﻿using System;
namespace SharedPacketLib.DataPackets
{
    /// <summary>
    /// Specifies packet IDs that trigger an action in the Brainwave Online game client.
    /// </summary>
    public enum ClientOpCode : int
    {
        // Common (block 1-9)
        Core_send_version = 1,
        Core_receive_version_ok = 2,
        Core_receive_version_failed = 3,
        Generic_Error = 9,

        Request_Ping = 10,
        Ping_Received = 11,

        Request_License = 15,
        Shutdown_server = 16,
        Request_online_count = 17,
        Start_Server = 18,
        Force_Shutdown_server = 19,
        Run_Query = 20,
    }
    /// <summary>
    /// Operation code keeper
    /// </summary>
    public static class ClientOpcodeCheck
    {
        /// <summary>
        /// Checks if an integer is an operation code
        /// </summary>
        /// <param name="code"></param>
        /// <returns></returns>
        public static bool isOpCode(int code)
        {
            return Enum.IsDefined(typeof(ClientOpCode), code);
        }
    }
}