﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SocketTest
{
    public class ButterflyServerDetails
    {
        private LicenseHolder licenseHolder;

        public string LicenseID { get { return this.licenseHolder.getLicenseID(); } }
        public string HotelName { get {return this.licenseHolder.getHotelName();} }
        public int UserCount { get; set; }
        public int GetMaxUserCount { get { return this.licenseHolder.getMaxOnline(); } }
        public bool QueryResult { get; set; }
        public bool ServerFull { get; set; }

        public event SameTypeEventDelegate OnServerDisconnect;
        public event UpdateDelegate OnServerDetailsChanged;
        

        public delegate void SameTypeEventDelegate(ButterflyServerDetails details);
        public delegate void UpdateDelegate(ButterflyServerDetails details, UpdateType type);
        
        public ButterflyServerDetails(LicenseHolder licenseHolder)
        {
            this.licenseHolder = licenseHolder;
        }

        internal void triggerDetailsChanged(UpdateType type)
        {
            if (this.OnServerDetailsChanged != null)
                this.OnServerDetailsChanged.Invoke(this, type);
        }

        internal void serverDisconnect()
        {
            if (this.OnServerDisconnect != null)
                this.OnServerDisconnect.Invoke(this);
        }


        
    }
    [Flags]
    public enum UpdateType
    {
        User_count_update,
        Query_result_status,
        Server_is_full,
    }

}
