﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ClientImplementation.ConnectionClasses;
using ConnectionManager;

namespace SocketTest
{
    public class LicenseRequester
    {
        private Dictionary<string, List<ConnectionHandeler>> liveConnections = new Dictionary<string, List<ConnectionHandeler>>();

        private Dictionary<string, ILicenseable> liveLicenses = new Dictionary<string, ILicenseable>();

        private SocketManager con;

        private Dictionary<string, LicenseHolder> activeList = new Dictionary<string, LicenseHolder>();

        public LicenseRequester(SocketManager ipcon)
        {
            this.con = ipcon;
            this.con.connectionEvent += newConnectionRequest;
        }

        private void newConnectionRequest(ConnectionManager.ConnectionInformation connection)
        {
            ConnectionHandeler handeler = new ConnectionHandeler(connection);
            handeler.Disconnection += serverDisconnected;
            AddConnection(handeler);
            handeler.Start();
        }

        private void serverDisconnected(ConnectionHandeler handeler)
        {
            RemoveConnection(handeler);
            handeler.Disconnection -= serverDisconnected;
        }

        private void AddConnection(ConnectionHandeler connection)
        {
            if (!liveConnections.ContainsKey(connection.getIp()))
            {
                liveConnections.Add(connection.getIp(), new List<ConnectionHandeler>());
            }
            liveConnections[connection.getIp()].Add(connection);
        }

        private void RemoveConnection(ConnectionHandeler connection)
        {
            if (liveConnections.ContainsKey(connection.getIp()))
            {
                liveConnections[connection.getIp()].Remove(connection);
                if (liveConnections[connection.getIp()].Count == 0)
                    liveConnections.Remove(connection.getIp());
            }
        }

        internal License GetLicense(string username,string license)
        {
            License l = LicenseLoader.getLicenseWithID(username, license);
            if (l == null)
            {
                throw new InvalidLicenseException();
            }
            return l;
        }

        internal bool AddActiveLicense(LicenseHolder licenseHolder)
        {
            try
            {
                activeList.Add(licenseHolder.getLicenseID(), licenseHolder);
                return true;
            }
            catch {
                return false;
            }
        }


        internal void RemoveActiveLicense(LicenseHolder licenseHolder)
        {
            activeList.Remove(licenseHolder.getLicenseID());
        }
    }
}
