﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ClientImplementation.ConnectionClasses;
using ConnectionManager;
using SharedPacketLib.DataPackets;
using Helpers;
using Database_Manager.Database;
using System.Runtime.InteropServices;

namespace SocketTest
{
    class AwsomeLicense
    {

        const int SWP_NOSIZE = 0x0001;
        [DllImport("kernel32.dll", ExactSpelling = true)]
        private static extern IntPtr GetConsoleWindow();

        private static IntPtr MyConsole = GetConsoleWindow();

        [DllImport("user32.dll", EntryPoint = "SetWindowPos")]
        public static extern IntPtr SetWindowPos(IntPtr hWnd, int hWndInsertAfter, int x, int Y, int cx, int cy, int wFlags);

        public static ConfigurationData Configuration { get; private set; }
        public static DatabaseManager manager;
        
        private static ClientConnectionManager ipcon;
        private static SocketManager conManager;

        public static LicenseRequester licenseRequester;
        static void Main()
        {
            InitializeLicenseSystem();
        }
        static void InitializeLicenseSystem()
        {
            SetWindowPos(MyConsole, 0, 100, 100, 0, 0, SWP_NOSIZE);

            Console.WindowHeight = Console.LargestWindowHeight - 20;
            Console.WindowWidth = Console.LargestWindowWidth - 20;
            Helpers.Out.startLogger();

            Configuration = new ConfigurationData(@"Settings/configuration.ini");

            conManager = new ConnectionManager.SocketManager();
            conManager.init(int.Parse(Configuration.data["con.socket"]), int.Parse(Configuration.data["con.max_servers"]), int.Parse(Configuration.data["con.con_per_ip"]), new GamePacketParser(), true);

            licenseRequester = new LicenseRequester(conManager);

            manager = new DatabaseManager(uint.Parse(Configuration.data["db.pool.maxsize"]), int.Parse(Configuration.data["db.pool.minsize"]));
            manager.setServerDetails(
                Configuration.data["db.hostname"],
                uint.Parse(Configuration.data["db.port"]),
                Configuration.data["db.username"],
                Configuration.data["db.password"],
                Configuration.data["db.name"]);
            manager.init();




            conManager.initializeConnectionRequests();
            while (Console.ReadLine() != "exit")
            {
                
            }
            Helpers.Out.stopLogger();
        }


       
    }
}
