﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Butterfly_Moderation_Tool.ServerSocket;
using System.Windows.Media.Animation;
using System.Threading;

namespace Butterfly_Moderation_Tool
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ServerConenction connection;


        public MainWindow()
        {
            InitializeComponent();
            graphs = new List<GraphPosition>();
            Application.Current.Exit += new ExitEventHandler(Current_Exit);
            Topmost = true;
            MouseLeftButtonDown += new MouseButtonEventHandler(title_MouseLeftButtonDown);
        }

        void Current_Exit(object sender, ExitEventArgs e)
        {
            if (connection != null)
                connection.CloseConnection();
        }
        private void title_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            DragMove();
        }


        private void button1_Click(object sender, RoutedEventArgs e)
        {
            int tier = RenderCapability.Tier;
            ComboBoxItem server = (ComboBoxItem)comboBox1.SelectedItem;

            string serverAdress = (string)server.Content;
            if (serverAdress == "bobbaitalia.net")
                serverAdress = "216.245.197.154";
            string password = textBox2.Text;
            connection = new ServerConenction(serverAdress, password, this);

            this.currentServer.Text = serverAdress;
            this.comboBox1.Visibility = System.Windows.Visibility.Hidden;
            //this.textBox1.Visibility = System.Windows.Visibility.Hidden;
            this.textBox2.Visibility = System.Windows.Visibility.Hidden;
            this.button1.Visibility = System.Windows.Visibility.Hidden;
            this.canvas1.Width = Application.Current.MainWindow.Width;
            
        }

        private List<GraphPosition> graphs;
        private int maxCount = 300;
        private int userPeak = 3516;

        private int tUserCount;
        private int tRoomCount;
        private int tDCRate;
        private int tQueryRate;
        private int minPing = 99099;
        private bool autoJitter = true; //0 = auto, 1 = disabled

        private void ShowNewRecord()
        {
            MessageBox.Show("New user record: " + userPeak, "", MessageBoxButton.OK, MessageBoxImage.Warning);
        }

        internal void UpdateGraph(int usercount, int roomcount, int dcrate, Canvas gfxRef, int ping, int queryRate, int qps)
        {
            Dispatcher.Invoke(
                 System.Windows.Threading.DispatcherPriority.Normal,
                 new Action(
                   delegate()
                   {

                       if (usercount > maxCount)
                           maxCount = usercount;
                       if (roomcount > maxCount)
                           maxCount = roomcount;
                       if (dcrate > maxCount)
                           maxCount = dcrate;
                       if (ping > maxCount)
                           maxCount = ping;
                       if (queryRate > maxCount)
                           maxCount = queryRate;
                       if (ping < minPing && autoJitter)
                           minPing = ping;

                       ping = ping - minPing;
                       if (ping < 0)
                           ping = 0;

                       if (usercount > userPeak)
                       {
                           userPeak = usercount;
                           Thread a = new Thread(new ThreadStart(ShowNewRecord));
                           a.Start();
                       }

                       usercounter.Text = "Users: " + usercount;
                       roomcounter.Text = "Rooms: " + roomcount;
                       //dccounter.Text = "DCs: " + dcrate;
                       this.ping.Text = "Ping: " + ping + "ms";
                       querycounter.Text = "TQT: " + queryRate + "ms";
                       qyeriespersec.Text = "QPS: " + qps;
                       
                       List<GraphPosition> toremove = new List<GraphPosition>();

                       foreach (GraphPosition pos in graphs)
                       {
                           if (pos.type != GraphType.Performance)
                                pos.Move(maxCount);
                           else
                               pos.Move(maxPerformance);
                           if (pos.pos > 200)
                               toremove.Add(pos);
                       }

                       foreach (GraphPosition pos in toremove)
                       {
                           graphs.Remove(pos);
                           pos.Dispose();
                       }

                       if (tRoomCount - roomcount != 0)
                       {
                           int differance = tRoomCount - roomcount;
                           if (differance > 0) //Increase
                           {
                               double b = GraphPosition.CalculatePosition(gfxRef, maxCount, differance);
                               graphs.Add(new GraphPosition(gfxRef, roomcount, maxCount, GraphType.Room, b + 2, ExceptionType.None, string.Empty, this));
                           }
                           else//Decrease
                           {
                               double b = GraphPosition.CalculatePosition(gfxRef, maxCount, -differance);
                               graphs.Add(new GraphPosition(gfxRef, tRoomCount, maxCount, GraphType.Room, b + 2, ExceptionType.None, string.Empty, this));
                           }
                       }
                       else
                       {
                           graphs.Add(new GraphPosition(gfxRef, roomcount, maxCount, GraphType.Room, 2, ExceptionType.None, string.Empty, this));
                       }

                       if (tUserCount - usercount != 0)
                       {
                           int differance = tUserCount - usercount;
                           if (differance > 0) //Increase
                           {
                               double b = GraphPosition.CalculatePosition(gfxRef, maxCount, differance);
                               graphs.Add(new GraphPosition(gfxRef, usercount, maxCount, GraphType.User, b + 2, ExceptionType.None, string.Empty, this));
                           }
                           else
                           {
                               double b = GraphPosition.CalculatePosition(gfxRef, maxCount, -differance);
                               graphs.Add(new GraphPosition(gfxRef, tUserCount, maxCount, GraphType.User, b + 2, ExceptionType.None, string.Empty, this));
                           }
                       }
                       else
                       {
                           graphs.Add(new GraphPosition(gfxRef, usercount, maxCount, GraphType.User, 2, ExceptionType.None, string.Empty, this));
                       }

                       if (tDCRate - dcrate != 0)
                       {
                           int differance = tDCRate - dcrate;
                           if (differance > 0) //Increase
                           {

                           }
                           else
                           {

                           }
                       }
                       else
                       {
                           //graphs.Add(new GraphPosition(gfxRef, dcrate, maxCount, GraphType.DC, 2));
                       }


                       if (tQueryRate - queryRate != 0)
                       {
                           int differance = tQueryRate - queryRate;
                           if (differance > 0) //Increase
                           {
                               double b = GraphPosition.CalculatePosition(gfxRef, maxCount, differance);
                               graphs.Add(new GraphPosition(gfxRef, queryRate, maxCount, GraphType.Query, b + 2, ExceptionType.None, string.Empty, this));
                           }
                           else
                           {
                               double b = GraphPosition.CalculatePosition(gfxRef, maxCount, -differance);
                               graphs.Add(new GraphPosition(gfxRef, tQueryRate, maxCount, GraphType.Query, b + 2, ExceptionType.None, string.Empty, this));
                           }

                       }
                       else
                       {
                           graphs.Add(new GraphPosition(gfxRef, queryRate, maxCount, GraphType.Query, 2, ExceptionType.None, string.Empty, this));
                       }

                       graphs.Add(new GraphPosition(gfxRef, 0, 1000, GraphType.Ping, GraphPosition.CalculatePosition(gfxRef, 1000, ping), ExceptionType.None, string.Empty, this));

                       tRoomCount = roomcount;
                       tUserCount = usercount;
                       tDCRate = dcrate;
                       tQueryRate = queryRate;
                   }
               ));
        }

        internal void AddExceptionToGraph(string message, Canvas gfxRef, string token)
        {
            Dispatcher.Invoke(
                 System.Windows.Threading.DispatcherPriority.Normal,
                 new Action(
                   delegate()
                   {
                       switch (message)
                       {
                           case "1":
                               {
                                   graphs.Add(new GraphPosition(gfxRef, 0, 0, GraphType.Room, 0, ExceptionType.StandardException, token, this));
                                   break;
                               }

                           case "2":
                               {
                                   graphs.Add(new GraphPosition(gfxRef, 0, 0, GraphType.Room, 0, ExceptionType.FatalException, token, this));
                                   break;
                               }

                           case "3":
                               {
                                   graphs.Add(new GraphPosition(gfxRef, 0, 0, GraphType.Room, 0, ExceptionType.SQLException, token, this));
                                   break;
                               }

                           case "4":
                               {
                                   graphs.Add(new GraphPosition(gfxRef, 0, 0, GraphType.Room, 0, ExceptionType.ThreadedException, token, this));
                                   break;
                               }

                           case "5":
                               {
                                   graphs.Add(new GraphPosition(gfxRef, 0, 0, GraphType.Room, 0, ExceptionType.UserException, token, this));
                                   break;
                               }

                           case "6":
                               {
                                   graphs.Add(new GraphPosition(gfxRef, 0, 0, GraphType.Room, 0, ExceptionType.DDOSException, token, this));
                                   break;
                               }
                       }


                   }
               ));
        }

        private int maxPerformance = 10;
        private int tPerformance = 0;

        internal void AddPerformanceStatToGraph(Canvas gfxRef, int performance)
        {
            Dispatcher.Invoke(
                 System.Windows.Threading.DispatcherPriority.Normal,
                 new Action(
                   delegate()
                   {
                       if (performance > maxPerformance)
                           maxPerformance = performance;
                       int b = 2;
                       if (performance > 10)
                       {
                           performance = 10;
                           b = 4;
                       }

                       if (tPerformance - performance != 0)
                       {
                           int differance = tPerformance - performance;
                           if (differance > 0) //Increase
                           {
                               //double b = 2; //GraphPosition.CalculatePosition(gfxRef, maxPerformance, differance);
                               graphs.Add(new GraphPosition(gfxRef, performance, maxPerformance, GraphType.Performance, b + 2, ExceptionType.None, string.Empty, this));
                           }
                           else
                           {
                               //double b = 2; //GraphPosition.CalculatePosition(gfxRef, maxPerformance, -differance);
                               graphs.Add(new GraphPosition(gfxRef, tPerformance, maxPerformance, GraphType.Performance, b + 2, ExceptionType.None, string.Empty, this));
                           }
                       }
                       else
                       {
                           graphs.Add(new GraphPosition(gfxRef, performance, maxPerformance, GraphType.Performance, 2, ExceptionType.None, string.Empty, this));
                       }
                       tPerformance = performance;
                       //graphs.Add(new GraphPosition(gfxRef, token, 10, GraphType.Performance, 2, ExceptionType.None, string.Empty, this));
                   }
               ));
        }

        internal void SetTokenValue(string value)
        {
            tokenContent.Text = value;
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            connection.CloseConnection();

            string serverAdress = connection.serverAdress;
            string password = connection.password;
            connection = new ServerConenction(serverAdress, password, this);
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            autoJitter = !autoJitter;
            if (autoJitter)
                button3.Content = "Disable jitter";
            else
                button3.Content = "Enable jitter";
        }
    
    }



    class GraphPosition
    {
        internal Canvas gfxRef;
        internal Rectangle gfxItem;
        internal double value;
        internal double pos;
        internal GraphType type;
        internal ExceptionType exceptionContent;
        private readonly string token;
        private readonly MainWindow UI;

        public GraphPosition(Canvas gfxRef, double value, int max, GraphType type, double height, ExceptionType exceptionType, string token, MainWindow window)
        {
            this.UI = window;
            this.gfxRef = gfxRef;
            this.value = value;
            this.type = type;
            this.exceptionContent = exceptionType;
            this.token = token;

            if (exceptionType == ExceptionType.None)
            {
                this.gfxItem = new Rectangle()
                {
                    Height = height,
                    Width = 4
                };
            }
            else
            {
                
                this.gfxItem = new Rectangle()
                {
                    Height = 30,
                    Width = 4
                };
                this.gfxItem.MouseEnter += new MouseEventHandler(gfxItem_MouseEnter);
            }

            switch (type)
            {
                case GraphType.User:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 34, 177, 76));
                        gfxItem.Fill = brush;
                        break;
                    }
                case GraphType.Room:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 0, 162, 232));
                        gfxItem.Fill = brush;
                        break;
                    }
                case GraphType.DC:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 237, 28, 36));
                        gfxItem.Fill = brush;
                        break;
                    }
                case GraphType.Ping:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 255, 157, 26));
                        gfxItem.Fill = brush;
                        break;
                    }
                case GraphType.Query:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 163, 73, 164));
                        gfxItem.Fill = brush;
                        break;
                    }
                case GraphType.Performance:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 183, 234, 255));
                        gfxItem.Fill = brush;
                        gfxItem.Width = 8;
                        break;
                    }
                default:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 0, 0, 0));
                        gfxItem.Fill = brush;
                        break;
                    }
            }

            switch (exceptionType)
            {
                case ExceptionType.DDOSException:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 237, 28, 36));
                        gfxItem.Fill = brush;
                        break;
                    }

                case ExceptionType.FatalException:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 163, 73, 164));
                        gfxItem.Fill = brush;
                        break;
                    }

                case ExceptionType.SQLException:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 255, 242, 0));
                        gfxItem.Fill = brush;
                        break;
                    }

                case ExceptionType.StandardException:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 34, 177, 76));
                        gfxItem.Fill = brush;
                        break;
                    }

                case ExceptionType.ThreadedException:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 255, 127, 39));
                        gfxItem.Fill = brush;
                        break;
                    }

                case ExceptionType.UserException:
                    {
                        SolidColorBrush brush = new SolidColorBrush(Color.FromArgb(255, 0, 162, 232));
                        gfxItem.Fill = brush;
                        break;
                    }
            }

            gfxRef.Children.Add(gfxItem);
            Canvas.SetLeft(gfxItem, 0);

            if (exceptionContent == ExceptionType.None)
                Canvas.SetBottom(gfxItem, CalculatePosition(gfxRef, max, value));
            else
                Canvas.SetBottom(gfxItem, -38);

            
            Storyboard storyboard = new Storyboard();
            DoubleAnimation doubleAnimation = new DoubleAnimation()
            {
                From = Canvas.GetLeft(gfxItem),
                To = gfxRef.Width,
                Duration = new Duration(TimeSpan.FromMilliseconds(250 * (gfxRef.Width / 2)))
            };
            Storyboard.SetTarget(doubleAnimation, gfxItem);
            Storyboard.SetTargetProperty(doubleAnimation, new PropertyPath("(Canvas.Left)"));
            storyboard.Children.Add(doubleAnimation);

            storyboard.Begin();
        }

        private void gfxItem_MouseEnter(object sender, MouseEventArgs e)
        {
            UI.SetTokenValue("Token: " + this.token);
        }

        internal void Move(int max)
        {
            pos = pos + 2;
            if (exceptionContent == ExceptionType.None)
                Canvas.SetBottom(gfxItem, CalculatePosition(gfxRef, max, value));
        }

        internal static double CalculatePosition(Canvas gfx, double maxValue, double value)
        {
            if (value <= 0)
                return 0;
            return gfx.Height * ((float)value / maxValue);
        }

        internal void Dispose()
        {
            gfxRef.Children.Remove(gfxItem);
        }
    }

    enum GraphType
    {
        User,
        Room,
        DC,
        Ping,
        Query,
        Performance
    }

    enum ExceptionType
    {
        None,
        UserException,
        SQLException,
        FatalException, //Normally caused by Dario
        ThreadedException,
        StandardException,
        DDOSException
    }

}
