
CREATE TABLE IF NOT EXISTS `achievements` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `group_name` varchar(64) NOT NULL DEFAULT 'ACH_',
  `category` varchar(255) NOT NULL DEFAULT 'identity',
  `level` int(11) NOT NULL DEFAULT '1',
  `reward_pixels` int(11) NOT NULL DEFAULT '100',
  `reward_points` int(11) DEFAULT '10',
  `progress_needed` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=26 ;

--
-- Volcado de datos para la tabla `achievements`
--

INSERT INTO `achievements` (`id`, `group_name`, `category`, `level`, `reward_pixels`, `reward_points`, `progress_needed`) VALUES
(1, 'ACH_AvatarTags', 'identity', 1, 5, 5, 5),
(2, 'ACH_AvatarLooks', 'identity', 1, 5, 5, 1),
(3, 'ACH_Motto', 'identity', 1, 10, 10, 1),
(4, 'ACH_EmailVerification', 'identity', 1, 20, 20, 1),
(5, 'ACH_RespectGiven', 'social', 1, 100, 100, 100),
(6, 'ACH_BasicClub', 'identity', 1, 25, 25, 1),
(7, 'ACH_VipClub', 'identity', 1, 50, 50, 1),
(8, 'ACH_BasicClub', 'identity', 2, 100, 100, 3),
(9, 'ACH_BasicClub', 'identity', 3, 250, 250, 6),
(10, 'ACH_BasicClub', 'identity', 4, 350, 350, 9),
(11, 'ACH_BasicClub', 'identity', 5, 500, 500, 12),
(12, 'ACH_VipClub', 'identity', 2, 200, 200, 3),
(13, 'ACH_VipClub', 'identity', 3, 500, 500, 6),
(14, 'ACH_VipClub', 'identity', 4, 700, 700, 9),
(15, 'ACH_VipClub', 'identity', 5, 1000, 1000, 12),
(16, 'ACH_RespectEarned', 'social', 1, 5, 5, 1),
(17, 'ACH_RespectEarned', 'social', 2, 20, 20, 10),
(18, 'ACH_RespectEarned', 'social', 3, 40, 40, 20),
(19, 'ACH_RespectEarned', 'social', 4, 100, 100, 50),
(20, 'ACH_RespectEarned', 'social', 5, 200, 200, 100),
(21, 'ACH_RespectEarned', 'social', 6, 500, 500, 250),
(22, 'ACH_RespectEarned', 'social', 7, 1000, 1000, 500),
(23, 'ACH_RespectEarned', 'social', 8, 1300, 1300, 750),
(24, 'ACH_RespectEarned', 'social', 9, 2000, 2000, 1000),
(25, 'ACH_RespectEarned', 'social', 10, 3000, 3000, 1500);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `bans`
--

CREATE TABLE IF NOT EXISTS `bans` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `bantype` enum('user','ip') NOT NULL DEFAULT 'user',
  `value` varchar(50) NOT NULL,
  `reason` text NOT NULL,
  `expire` double NOT NULL DEFAULT '0',
  `added_by` varchar(50) NOT NULL,
  `added_date` varchar(50) NOT NULL,
  `appeal_state` enum('0','1','2') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=7 ;

--
-- Volcado de datos para la tabla `bans`
--

INSERT INTO `bans` (`id`, `bantype`, `value`, `reason`, `expire`, `added_by`, `added_date`, `appeal_state`) VALUES
(1, 'user', 'neger', 'Innapropriate name', 1700894482, 'T09', 'Thursday, June 28, 2012', '1'),
(2, 'user', 'superneger', 'Innapropriate username', 1700894573, 'T09', 'Thursday, June 28, 2012', '1'),
(3, 'user', 'NLT09', 'Using a bastard command', 1341002662, 'T09', 'Friday, June 29, 2012', '1'),
(4, 'user', 'Mansan', 'Using a bastard command', 1341005244, 'T09', 'Friday, June 29, 2012', '1'),
(5, 'user', 'xPatatxSaus.', 'Using a bastard command', 1341060131, 'T09', 'Saturday, June 30, 2012', '1'),
(6, 'user', 'HabboLatino', 'trrwetb rt', 1343078188, 'Itachi', 'Sunday, July 22, 2012', '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `bans_appeals`
--

CREATE TABLE IF NOT EXISTS `bans_appeals` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ban_id` int(11) NOT NULL,
  `send_ip` varchar(50) NOT NULL,
  `send_date` varchar(120) NOT NULL,
  `mail` varchar(120) NOT NULL,
  `plea` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ban_id` (`ban_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `bots`
--

CREATE TABLE IF NOT EXISTS `bots` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `room_id` int(10) unsigned NOT NULL DEFAULT '0',
  `ai_type` enum('generic','guide','pet') NOT NULL DEFAULT 'generic',
  `name` varchar(100) NOT NULL,
  `motto` varchar(120) NOT NULL,
  `look` text NOT NULL,
  `x` int(11) NOT NULL DEFAULT '0',
  `y` int(11) NOT NULL DEFAULT '0',
  `z` int(11) NOT NULL DEFAULT '0',
  `rotation` int(11) NOT NULL DEFAULT '0',
  `walk_mode` enum('stand','freeroam','specified_range') NOT NULL DEFAULT 'stand',
  `min_x` int(11) NOT NULL DEFAULT '0',
  `min_y` int(11) NOT NULL DEFAULT '0',
  `max_x` int(11) NOT NULL DEFAULT '0',
  `max_y` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `room_id` (`room_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=70 ;

--
-- Volcado de datos para la tabla `bots`
--

INSERT INTO `bots` (`id`, `room_id`, `ai_type`, `name`, `motto`, `look`, `x`, `y`, `z`, `rotation`, `walk_mode`, `min_x`, `min_y`, `max_x`, `max_y`) VALUES
(54, 1, 'generic', 'Harry', 'Welcome to Habbo!', 'hd-180-7.sh-290-110.lg-270-91.ch-809-62.hr-828-45', 10, 6, 0, 2, 'stand', 8, 16, 9, 24),
(55, 0, 'guide', 'Jesus', 'Hail my Fauther, Martinmine!', 'hr-891-37.hd-190-7.fa-1205-67.lg-275-92.he-3181-85', 0, 0, 0, 0, 'freeroam', 0, 0, 0, 0),
(56, 81261, 'guide', 'Brother Various', 'Nigga, i''m his clone!', 'hd-180-8.ea-1406-62.ch-3059-1328.he-3149-1328.lg-3078-1328.hr-3043-1348.sh-3089-1328', 14, 2, 2, 4, 'freeroam', 0, 0, 0, 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `bots_responses`
--

CREATE TABLE IF NOT EXISTS `bots_responses` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `bot_id` int(10) unsigned NOT NULL,
  `keywords` text NOT NULL,
  `response_text` varchar(200) NOT NULL,
  `mode` enum('say','shout','whisper') NOT NULL DEFAULT 'say',
  `serve_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `bot_id` (`bot_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=21 ;

--
-- Volcado de datos para la tabla `bots_responses`
--

INSERT INTO `bots_responses` (`id`, `bot_id`, `keywords`, `response_text`, `mode`, `serve_id`) VALUES
(1, 54, 'hey;hello;hallo;hai;hoi;howdy;hi', 'Hello!', 'say', 0),
(2, 54, 'drink;cola;food;order;buy;ice', 'You can''t order anything here. Does this look like a bar to you?', 'say', 0),
(3, 54, 'harry', 'That''s me!', 'say', 0),
(4, 54, 'project bobba', 'Ah, Project Bobba. Those were the days..', 'say', 0),
(5, 54, 'love', 'Love is a strange thing..', 'say', 0),
(6, 54, 'dust;dusty;dirty;filthy;disgusting;eww', 'Are you calling my lobby dirty!??!', 'shout', 0),
(7, 54, 'whisper to me harry', 'Do you like being whispered to...?', 'whisper', 0),
(8, 54, 'yes;yep;definitely;yeah;uh-huh;no;nope;never;nay', 'Oh, well, if you say so...', 'say', 0),
(9, 55, 'dutch;italian;sweedish;french;spanish;polish;portugese;brazillian;inglaise;anglais;hola;bonjour;nederlands;engels;swedish;language;german;deutsch', 'This is an English hotel! Please speak English or face punishment!', 'shout', 0),
(10, 55, 'help;halp', 'I''m here to help! If theres anything I can''t answer, use the help tool to the left!', 'say', 0),
(11, 55, 'noob;n00b;nOob;no0b;n0ob;gtfo;noob;pl0x;troll', 'STFU AND GTFO MY HOUSE!', 'say', 0),
(12, 55, 'cred;credz;creds;credits;coins', 'Credits are given out at random intervals. Check the site for more details.', 'say', 0),
(13, 55, 'mod;admin;staff', 'Our dedicated staff are here to improve your retro experience!', 'say', 0),
(14, 55, 'martin;martinmine;martinimine', 'Hail Martinmine o/ ! Ask him for cookies!', 'shout', 0),
(15, 55, 'pixels', 'You get pixels for being online and getting achievements, you can then spend them in the catalogue!', 'say', 0),
(16, 59, '*Hands order*', '*Starts preparing and cooking meal*', 'say', 0),
(17, 63, 'drink;cola;food;order;buy;ice', 'Im sorry we are out of drinks at the moment.', 'say', 0),
(18, 63, 'Butler', 'Yes sir?', 'say', 0),
(19, 56, 'various,var,god', 'Shut the fuck up, My brother "Various" the overlord owner is busy nigger...', 'shout', 0),
(20, 56, 'fuck,bitch,cunt,shit,pussy,dick,penis,bitch,nigga,nigger', 'FUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU', 'shout', 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `bots_speech`
--

CREATE TABLE IF NOT EXISTS `bots_speech` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `bot_id` int(10) unsigned NOT NULL,
  `text` varchar(200) NOT NULL,
  `shout` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `bot_id` (`bot_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=31 ;

--
-- Volcado de datos para la tabla `bots_speech`
--

INSERT INTO `bots_speech` (`id`, `bot_id`, `text`, `shout`) VALUES
(1, 54, 'Welcome to Habbo. Can I help you?', '0'),
(2, 54, '*sneeze*', '1'),
(3, 54, 'Whats that you say? Alec is awesome?', '0'),
(4, 54, 'My feet hurt.. :(', '0'),
(5, 54, '*yawn*', '0'),
(6, 54, 'I miss Project Bobba.. people used to be nice there. *sigh*', '0'),
(7, 54, 'Why is it always so quiet here? I feel so lonely..', '0'),
(8, 54, 'Don''t even think about asking me for a drink .. this is not a bar.', '0'),
(9, 56, 'sigh..', '0'),
(10, 56, 'NIGGA I''M VARIOUS', '1'),
(11, 56, 'VARIOUS IS ALMIGHTY LLOOOOOOOOOOOLLL', '1'),
(12, 57, 'Can I be mod plz?', '0'),
(13, 57, '*writes on todo list*', '0'),
(14, 57, 'I love Skye <3', '0'),
(15, 57, 'Plz to has moar badges? :(', '0'),
(16, 58, '*jumps out of window*', '0'),
(17, 58, 'God, I do all the work around here...', '0'),
(18, 58, 'I deserve all the Project Bobba awards!', '0'),
(19, 58, ':invisible 1', '0'),
(20, 59, '*Cleans surfaces*', '0'),
(21, 59, '*Sweeps floor*', '0'),
(22, 59, '*Mops up spillage*', '0'),
(23, 0, '*Wipes over surfaces*', '0'),
(24, 59, '*Mops up spillage*', '0'),
(25, 59, '*Wipes over surfaces*', '0'),
(26, 63, 'I wish the boss paid me more....', '1'),
(27, 63, 'How are you sir?', '0'),
(28, 63, 'Welcome to Alec''s Room', '1'),
(29, 63, '*coughs*', '1'),
(30, 63, 'Nice weather we are haveing.', '0');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `catalog_items`
--

CREATE TABLE IF NOT EXISTS `catalog_items` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `page_id` int(11) NOT NULL,
  `item_ids` int(120) unsigned NOT NULL,
  `catalog_name` varchar(100) NOT NULL,
  `cost_credits` int(11) NOT NULL,
  `cost_pixels` int(11) NOT NULL,
  `amount` int(11) NOT NULL,
  `cost_crystal` int(11) NOT NULL,
  `cost_oude_belcredits` int(11) NOT NULL,
  `song_id` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3569018 ;

--
-- Volcado de datos para la tabla `catalog_items`
--

INSERT INTO `catalog_items` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`, `song_id`) VALUES
(1, 134, 19942, 'byesw_hand', 25, 0, 1, 0, 0, 0),
(2, 134, 19943, 'byesw_hotel', 25, 0, 1, 0, 0, 0),
(3568953, 15, 19926, 'landscape_single_3.4', 3, 0, 1, 0, 0, 0),
(3568952, 15, 19926, 'landscape_single_2.4', 3, 0, 1, 0, 0, 0),
(3568951, 15, 19926, 'landscape_single_1.4', 3, 0, 1, 0, 0, 0),
(3568950, 15, 19926, 'landscape_single_7.3', 3, 0, 1, 0, 0, 0),
(3568949, 15, 19926, 'landscape_single_6.3', 3, 0, 1, 0, 0, 0),
(3568948, 15, 19926, 'landscape_single_5.3', 3, 0, 1, 0, 0, 0),
(3568947, 15, 19926, 'landscape_single_4.3', 3, 0, 1, 0, 0, 0),
(3568946, 15, 19926, 'landscape_single_3.3', 3, 0, 1, 0, 0, 0),
(3568945, 15, 19926, 'landscape_single_2.3', 3, 0, 1, 0, 0, 0),
(3568944, 15, 19926, 'landscape_single_1.3', 3, 0, 1, 0, 0, 0),
(3568943, 15, 19926, 'landscape_single_1.2', 3, 0, 1, 0, 0, 0),
(3568942, 15, 19926, 'landscape_single_7.1', 3, 0, 1, 0, 0, 0),
(3568941, 15, 19926, 'landscape_single_6.1', 3, 0, 1, 0, 0, 0),
(3568940, 15, 19926, 'landscape_single_5.1', 3, 0, 1, 0, 0, 0),
(3568939, 15, 19926, 'landscape_single_4.1', 3, 0, 1, 0, 0, 0),
(3568938, 15, 19926, 'landscape_single_3.1', 3, 0, 1, 0, 0, 0),
(3568937, 15, 19926, 'landscape_single_2.1', 3, 0, 1, 0, 0, 0),
(3568936, 15, 19926, 'landscape_single_1.1', 3, 0, 1, 0, 0, 0),
(3568935, 15, 19894, 'floor_single_610', 3, 0, 1, 0, 0, 0),
(3568934, 15, 19894, 'floor_single_609', 3, 0, 1, 0, 0, 0),
(3568933, 15, 19894, 'floor_single_608', 3, 0, 1, 0, 0, 0),
(3568932, 15, 19894, 'floor_single_607', 3, 0, 1, 0, 0, 0),
(72, 55, 1, 'shelves_norja', 3, 0, 1, 0, 0, 0),
(71, 55, 6, 'table_norja_med', 4, 0, 1, 0, 0, 0),
(73, 55, 14, 'couch_norja', 4, 0, 1, 0, 0, 0),
(74, 55, 15, 'chair_norja', 3, 0, 1, 0, 0, 0),
(75, 55, 173, 'soft_sofachair_norja', 3, 0, 1, 0, 0, 0),
(76, 55, 174, 'soft_sofa_norja', 4, 0, 1, 0, 0, 0),
(101, 55, 501, 'shelves_norja*9', 3, 0, 1, 0, 0, 0),
(78, 55, 479, 'table_norja_med*2', 3, 0, 1, 0, 0, 0),
(79, 55, 480, 'table_norja_med*3', 3, 0, 1, 0, 0, 0),
(80, 55, 481, 'table_norja_med*4', 3, 0, 1, 0, 0, 0),
(81, 55, 482, 'table_norja_med*5', 3, 0, 1, 0, 0, 0),
(82, 55, 483, 'table_norja_med*6', 3, 0, 1, 0, 0, 0),
(83, 55, 484, 'table_norja_med*7', 3, 0, 1, 0, 0, 0),
(85, 55, 485, 'table_norja_med*8', 3, 0, 1, 0, 0, 0),
(86, 55, 486, 'table_norja_med*9', 3, 0, 1, 0, 0, 0),
(87, 55, 487, 'couch_norja*2', 4, 0, 1, 0, 0, 0),
(88, 55, 488, 'couch_norja*3', 4, 0, 1, 0, 0, 0),
(89, 55, 489, 'couch_norja*4', 4, 0, 1, 0, 0, 0),
(90, 1, 490, 'couch_norja*5', 4, 0, 1, 0, 0, 0),
(91, 55, 491, 'couch_norja*6', 4, 0, 1, 0, 0, 0),
(92, 55, 492, 'couch_norja*7', 4, 0, 1, 0, 0, 0),
(93, 55, 493, 'couch_norja*8', 4, 0, 1, 0, 0, 0),
(94, 55, 494, 'couch_norja*9', 4, 0, 1, 0, 0, 0),
(95, 55, 495, 'shelves_norja*2', 3, 0, 1, 0, 0, 0),
(96, 55, 496, 'shelves_norja*3', 3, 0, 1, 0, 0, 0),
(97, 55, 497, 'shelves_norja*5', 3, 0, 1, 0, 0, 0),
(98, 55, 498, 'shelves_norja*6', 3, 0, 1, 0, 0, 0),
(99, 55, 499, 'shelves_norja*7', 3, 0, 1, 0, 0, 0),
(100, 55, 500, 'shelves_norja*8', 3, 0, 1, 0, 0, 0),
(140, 30, 2, 'shelves_polyfon', 3, 0, 1, 0, 0, 0),
(103, 55, 502, 'chair_norja*2', 3, 0, 1, 0, 0, 0),
(104, 55, 503, 'chair_norja*3', 3, 0, 1, 0, 0, 0),
(105, 55, 504, 'chair_norja*4', 3, 0, 1, 0, 0, 0),
(106, 55, 505, 'chair_norja*5', 3, 0, 1, 0, 0, 0),
(107, 55, 506, 'chair_norja*6', 3, 0, 1, 0, 0, 0),
(108, 55, 507, 'chair_norja*7', 3, 0, 1, 0, 0, 0),
(109, 55, 508, 'chair_norja*8', 3, 0, 1, 0, 0, 0),
(110, 55, 509, 'chair_norja*9', 3, 0, 1, 0, 0, 0),
(111, 55, 518, 'soft_sofa_norja*2', 4, 0, 1, 0, 0, 0),
(112, 55, 519, 'soft_sofa_norja*3', 4, 0, 1, 0, 0, 0),
(113, 55, 520, 'soft_sofa_norja*4', 3, 0, 1, 0, 0, 0),
(114, 55, 521, 'soft_sofa_norja*5', 4, 0, 1, 0, 0, 0),
(115, 55, 522, 'soft_sofa_norja*6', 4, 0, 1, 0, 0, 0),
(116, 55, 523, 'soft_sofa_norja*7', 4, 0, 1, 0, 0, 0),
(391, 28, 1375, 'xmas08_icerug', 5, 0, 1, 0, 0, 0),
(118, 55, 524, 'soft_sofa_norja*8', 4, 0, 1, 0, 0, 0),
(387, 28, 1366, 'xmas08_trph1', 6, 0, 1, 0, 0, 0),
(386, 28, 1364, 'xmas08_snowpl', 3, 0, 1, 0, 0, 0),
(121, 55, 525, 'soft_sofa_norja*9', 4, 0, 1, 0, 0, 0),
(123, 55, 526, 'soft_sofachair_norja*2', 3, 0, 1, 0, 0, 0),
(124, 55, 527, 'soft_sofachair_norja*3', 3, 0, 1, 0, 0, 0),
(125, 55, 528, 'soft_sofachair_norja*3', 3, 0, 1, 0, 0, 0),
(126, 55, 530, 'soft_sofachair_norja*6', 3, 0, 1, 0, 0, 0),
(127, 55, 531, 'soft_sofachair_norja*7', 3, 0, 1, 0, 0, 0),
(128, 55, 529, 'soft_sofachair_norja*5', 3, 0, 1, 0, 0, 0),
(129, 55, 532, 'soft_sofachair_norja*8', 3, 0, 1, 0, 0, 0),
(130, 55, 533, 'soft_sofachair_norja*9', 3, 0, 1, 0, 0, 0),
(131, 55, 658, 'solarium_norja', 3, 0, 1, 0, 0, 0),
(132, 55, 659, 'solarium_norja*1', 3, 0, 1, 0, 0, 0),
(133, 55, 660, 'solarium_norja*2', 3, 0, 1, 0, 0, 0),
(134, 55, 661, 'solarium_norja*3', 3, 0, 1, 0, 0, 0),
(135, 55, 662, 'solarium_norja*5', 3, 0, 1, 0, 0, 0),
(136, 55, 663, 'solarium_norja*6', 3, 0, 1, 0, 0, 0),
(137, 55, 664, 'solarium_norja*7', 3, 0, 1, 0, 0, 0),
(138, 55, 665, 'solarium_norja*8', 3, 0, 1, 0, 0, 0),
(139, 55, 666, 'solarium_norja*9', 3, 0, 1, 0, 0, 0),
(141, 30, 4, 'table_polyfon_small', 2, 0, 1, 0, 0, 0),
(142, 30, 5, 'chair_polyfon', 3, 0, 1, 0, 0, 0),
(143, 30, 11, 'stand_polyfon_z', 1, 0, 1, 0, 0, 0),
(144, 30, 16, 'table_polyfon_med', 3, 0, 1, 0, 0, 0),
(145, 30, 19, 'sofachair_polyfon', 3, 0, 1, 0, 0, 0),
(146, 30, 20, 'sofa_polyfon', 4, 0, 1, 0, 0, 0),
(147, 30, 25, 'bed_polyfon', 4, 0, 1, 0, 0, 0),
(148, 30, 26, 'bed_polyfon_one', 3, 0, 1, 0, 0, 0),
(149, 30, 109, 'bar_polyfon', 3, 0, 1, 0, 0, 0),
(150, 30, 46, 'fireplace_polyfon', 5, 0, 1, 0, 0, 0),
(152, 30, 112, 'bardesk_polyfon', 3, 0, 1, 0, 0, 0),
(153, 30, 113, 'bardeskcorner_polyfon', 3, 0, 1, 0, 0, 0),
(154, 30, 133, 'table_polyfon', 4, 0, 1, 0, 0, 0),
(155, 30, 134, 'smooth_table_polyfon', 4, 0, 1, 0, 0, 0),
(156, 31, 135, 'sofachair_polyfon_girl', 3, 0, 1, 0, 0, 0),
(157, 31, 136, 'bed_polyfon_girl_one', 3, 0, 1, 0, 0, 0),
(158, 31, 137, 'bed_polyfon_girl', 4, 0, 1, 0, 0, 0),
(159, 31, 138, 'sofa_polyfon_girl', 4, 0, 1, 0, 0, 0),
(160, 31, 620, 'bardeskcorner_polyfon*5', 3, 0, 1, 0, 0, 0),
(161, 31, 612, 'bardesk_polyfon*5', 3, 0, 1, 0, 0, 0),
(162, 31, 628, 'divider_poly3*5', 6, 0, 1, 0, 0, 0),
(163, 30, 216, 'divider_poly3', 6, 0, 1, 0, 0, 0),
(260, 26, 1804, 'dimmer_fuse2', 6, 0, 1, 0, 0, 0),
(259, 26, 1803, 'dimmer_swtch', 3, 0, 1, 0, 0, 0),
(166, 30, 582, 'sofachair_polyfon*2', 3, 0, 1, 0, 0, 0),
(258, 26, 1802, 'dimmer_fuse6', 6, 0, 1, 0, 0, 0),
(168, 30, 583, 'sofachair_polyfon*3', 3, 0, 1, 0, 0, 0),
(383, 37, 1798, 'ktchn_wall', 20, 0, 5, 0, 0, 0),
(170, 30, 584, 'sofachair_polyfon*4', 3, 0, 1, 0, 0, 0),
(171, 30, 585, 'sofachair_polyfon*6', 3, 0, 1, 0, 0, 0),
(172, 30, 586, 'sofachair_polyfon*7', 3, 0, 1, 0, 0, 0),
(173, 30, 587, 'sofachair_polyfon*8', 3, 0, 1, 0, 0, 0),
(174, 30, 588, 'sofachair_polyfon*9', 3, 0, 1, 0, 0, 0),
(175, 30, 589, 'sofa_polyfon*2', 4, 0, 1, 0, 0, 0),
(176, 30, 590, 'sofa_polyfon*3', 4, 0, 1, 0, 0, 0),
(177, 30, 591, 'sofa_polyfon*3', 4, 0, 1, 0, 0, 0),
(178, 30, 592, 'sofa_polyfon*6', 3, 0, 1, 0, 0, 0),
(179, 30, 593, 'sofa_polyfon*7', 3, 0, 1, 0, 0, 0),
(180, 30, 594, 'sofa_polyfon*8', 4, 0, 1, 0, 0, 0),
(181, 30, 595, 'sofa_polyfon*9', 4, 0, 1, 0, 0, 0),
(182, 30, 596, 'bed_polyfon*3', 4, 0, 1, 0, 0, 0),
(183, 30, 597, 'bed_polyfon*4', 4, 0, 1, 0, 0, 0),
(184, 30, 598, 'bed_polyfon*6', 4, 0, 1, 0, 0, 0),
(185, 30, 599, 'bed_polyfon*7', 4, 0, 1, 0, 0, 0),
(186, 30, 600, 'bed_polyfon*8', 4, 0, 1, 0, 0, 0),
(187, 30, 601, 'bed_polyfon*9', 4, 0, 1, 0, 0, 0),
(188, 30, 602, 'bed_polyfon_one*2', 3, 0, 1, 0, 0, 0),
(189, 30, 603, 'bed_polyfon_one*3', 3, 0, 1, 0, 0, 0),
(190, 30, 604, 'bed_polyfon_one*4', 3, 0, 1, 0, 0, 0),
(191, 30, 605, 'bed_polyfon_one*6', 3, 0, 1, 0, 0, 0),
(192, 30, 606, 'bed_polyfon_one*7', 3, 0, 1, 0, 0, 0),
(193, 30, 607, 'bed_polyfon_one*8', 3, 0, 1, 0, 0, 0),
(194, 30, 608, 'bed_polyfon_one*9', 3, 0, 1, 0, 0, 0),
(195, 30, 609, 'bardesk_polyfon*2', 3, 0, 1, 0, 0, 0),
(196, 30, 610, 'bardesk_polyfon*3', 3, 0, 1, 0, 0, 0),
(197, 30, 611, 'bardesk_polyfon*4', 3, 0, 1, 0, 0, 0),
(198, 30, 604, 'bed_polyfon_one*4', 3, 0, 1, 0, 0, 0),
(199, 30, 613, 'bardesk_polyfon*6', 3, 0, 1, 0, 0, 0),
(200, 30, 614, 'bardesk_polyfon*7', 3, 0, 1, 0, 0, 0),
(201, 615, 615, 'bardesk_polyfon*8', 3, 0, 1, 0, 0, 0),
(202, 30, 616, 'bardesk_polyfon*9', 3, 0, 1, 0, 0, 0),
(203, 30, 616, 'bardesk_polyfon*9', 3, 0, 1, 0, 0, 0),
(204, 30, 617, 'bardeskcorner_polyfon*2', 3, 0, 1, 0, 0, 0),
(205, 30, 618, 'bardeskcorner_polyfon*3', 3, 0, 1, 0, 0, 0),
(206, 30, 619, 'bardeskcorner_polyfon*4', 3, 0, 1, 0, 0, 0),
(207, 30, 621, 'bardeskcorner_polyfon*6', 3, 0, 1, 0, 0, 0),
(208, 30, 622, 'bardeskcorner_polyfon*7', 3, 0, 1, 0, 0, 0),
(209, 30, 623, 'bardeskcorner_polyfon*8', 3, 0, 1, 0, 0, 0),
(210, 30, 624, 'bardeskcorner_polyfon*9', 3, 0, 1, 0, 0, 0),
(222, 35, 32, 'bed_armas_two', 4, 0, 1, 0, 0, 0),
(212, 30, 625, 'divider_poly3*2', 6, 0, 1, 0, 0, 0),
(213, 30, 626, 'divider_poly3*3', 6, 0, 1, 0, 0, 0),
(214, 30, 627, 'divider_poly3*4', 6, 0, 1, 0, 0, 0),
(215, 30, 629, 'divider_poly3*6', 6, 0, 1, 0, 0, 0),
(2138, 160, 329, 'toy1*3', 3, 0, 1, 0, 0, 0),
(2335, 129, 1502, 'bump_road', 0, 1250, 20, 0, 0, 0),
(218, 30, 632, 'divider_poly3*9', 6, 0, 1, 0, 0, 0),
(2118, 7, 20060, 'DEAL_HC_1', 100, 0, 1, 0, 0, 0),
(390, 28, 1373, 'xmas08_icetree', 4, 0, 1, 0, 0, 0),
(224, 35, 36, 'bench_armas', 3, 0, 1, 0, 0, 0),
(225, 35, 37, 'table_armas', 4, 0, 1, 0, 0, 0),
(226, 35, 38, 'small_table_armas', 3, 0, 1, 0, 0, 0),
(227, 35, 39, 'small_chair_armas', 1, 0, 1, 0, 0, 0),
(228, 35, 40, 'fireplace_armas', 5, 0, 1, 0, 0, 0),
(229, 35, 41, 'lamp_armas', 3, 0, 1, 0, 0, 0),
(230, 35, 42, 'bed_armas_one', 3, 0, 1, 0, 0, 0),
(231, 35, 44, 'carpet_armas', 3, 0, 1, 0, 0, 0),
(232, 35, 115, 'bar_armas', 4, 0, 1, 0, 0, 0),
(233, 35, 116, 'bartable_armas', 4, 0, 1, 0, 0, 0),
(234, 35, 117, 'bar_chair_armas', 1, 0, 1, 0, 0, 0),
(235, 35, 176, 'lamp2_armas', 3, 0, 1, 0, 0, 0),
(237, 24, 1693, 'window_single_default', 3, 0, 1, 0, 0, 0),
(238, 24, 1694, 'window_double_default', 4, 0, 1, 0, 0, 0),
(239, 24, 1695, 'noob_window_double', 4, 0, 1, 0, 0, 0),
(240, 24, 1696, 'window_triple', 5, 0, 1, 0, 0, 0),
(241, 24, 1697, 'window_square', 1, 0, 1, 0, 0, 0),
(242, 24, 1698, 'window_romantic_wide', 4, 0, 1, 0, 0, 0),
(243, 24, 1699, 'window_romantic_narrow', 3, 0, 1, 0, 0, 0),
(244, 24, 1700, 'window_grunge', 2, 0, 1, 0, 0, 0),
(245, 24, 1701, 'window_golden', 4, 0, 1, 0, 0, 0),
(246, 24, 1702, 'window_chinese_wide', 6, 0, 1, 0, 0, 0),
(264, 29, 178, 'door', 5, 0, 1, 0, 0, 0),
(248, 24, 1703, 'window_chinese_narrow', 5, 0, 1, 0, 0, 0),
(249, 24, 1704, 'window_basic', 3, 0, 1, 0, 0, 0),
(250, 24, 1705, 'window_70s_wide', 5, 0, 1, 0, 0, 0),
(251, 24, 1706, 'window_70s_narrow', 4, 0, 1, 0, 0, 0),
(261, 26, 1805, 'dimmer_buttn', 3, 0, 1, 0, 0, 0),
(257, 26, 1683, 'roomdimmer', 6, 0, 1, 0, 0, 0),
(254, 24, 1712, 'window_hole', 2, 0, 1, 0, 0, 0),
(255, 24, 1717, 'window_skyscraper', 18, 0, 5, 0, 0, 0),
(389, 28, 1369, 'xmas08_hottub', 5, 0, 1, 0, 0, 0),
(265, 29, 1100, 'teleport_door', 6, 0, 1, 0, 0, 0),
(757, 73, 1787, 'sf_window', 7, 0, 1, 0, 0, 0),
(756, 73, 1614, 'sf_roller', 7, 0, 1, 0, 0, 0),
(268, 73, 1613, 'sf_tele', 5, 0, 1, 0, 0, 0),
(269, 58, 1452, 'lostc_teleport', 5, 0, 1, 0, 0, 0),
(271, 33, 3, 'shelves_silo', 3, 0, 1, 0, 0, 0),
(272, 33, 7, 'table_silo_med', 3, 0, 1, 0, 0, 0),
(273, 33, 12, 'chair_silo', 3, 0, 1, 0, 0, 0),
(274, 33, 13, 'sofa_silo', 3, 0, 1, 0, 0, 0),
(275, 33, 21, 'sofachair_silo', 3, 0, 1, 0, 0, 0),
(276, 33, 29, 'bed_silo_one', 3, 0, 1, 0, 0, 0),
(277, 33, 30, 'bed_silo_two', 4, 0, 1, 0, 0, 0),
(278, 33, 31, 'table_silo_small', 2, 0, 1, 0, 0, 0),
(279, 33, 221, 'divider_silo1', 3, 0, 1, 0, 0, 0),
(280, 33, 223, 'divider_silo2', 3, 0, 1, 0, 0, 0),
(281, 33, 225, 'divider_silo3', 6, 0, 1, 0, 0, 0),
(282, 33, 461, 'barchair_silo', 3, 0, 1, 0, 0, 0),
(283, 33, 534, 'sofachair_silo*2', 3, 0, 1, 0, 0, 0),
(284, 33, 535, 'sofachair_silo*3', 3, 0, 1, 0, 0, 0),
(285, 33, 536, 'sofachair_silo*4', 3, 0, 1, 0, 0, 0),
(286, 33, 537, 'sofachair_silo*5', 3, 0, 1, 0, 0, 0),
(287, 33, 538, 'sofachair_silo*6', 3, 0, 1, 0, 0, 0),
(288, 33, 539, 'sofachair_silo*7', 3, 0, 1, 0, 0, 0),
(289, 33, 540, 'sofachair_silo*8', 3, 0, 1, 0, 0, 0),
(290, 33, 541, 'sofachair_silo*9', 3, 0, 1, 0, 0, 0),
(291, 33, 542, 'table_silo_small*2', 2, 0, 1, 0, 0, 0),
(292, 33, 543, 'table_silo_small*3', 2, 0, 1, 0, 0, 0),
(293, 33, 544, 'table_silo_small*4', 2, 0, 1, 0, 0, 0),
(294, 33, 545, 'table_silo_small*5', 2, 0, 1, 0, 0, 0),
(295, 33, 546, 'table_silo_small*6', 2, 0, 1, 0, 0, 0),
(296, 33, 547, 'table_silo_small*7', 2, 0, 1, 0, 0, 0),
(297, 33, 548, 'table_silo_small*8', 2, 0, 1, 0, 0, 0),
(298, 33, 549, 'table_silo_small*9', 3, 0, 1, 0, 0, 0),
(299, 33, 550, 'divider_silo1*2', 3, 0, 1, 0, 0, 0),
(300, 33, 551, 'divider_silo1*3', 3, 0, 1, 0, 0, 0),
(301, 33, 552, 'divider_silo1*4', 3, 0, 1, 0, 0, 0),
(302, 33, 553, 'divider_silo1*5', 3, 0, 1, 0, 0, 0),
(303, 33, 554, 'divider_silo1*6', 3, 0, 1, 0, 0, 0),
(304, 33, 555, 'divider_silo1*7', 3, 0, 1, 0, 0, 0),
(305, 33, 556, 'divider_silo1*8', 3, 0, 1, 0, 0, 0),
(306, 33, 557, 'divider_silo1*9', 3, 0, 1, 0, 0, 0),
(307, 33, 558, 'divider_silo3*2', 6, 0, 1, 0, 0, 0),
(308, 33, 559, 'divider_silo3*3', 6, 0, 1, 0, 0, 0),
(309, 33, 560, 'divider_silo3*4', 6, 0, 1, 0, 0, 0),
(310, 33, 561, 'divider_silo3*5', 6, 0, 1, 0, 0, 0),
(311, 33, 562, 'divider_silo3*6', 6, 0, 1, 0, 0, 0),
(312, 33, 563, 'divider_silo3*7', 6, 0, 1, 0, 0, 0),
(313, 33, 564, 'divider_silo3*8', 6, 0, 1, 0, 0, 0),
(314, 33, 565, 'divider_silo3*9', 6, 0, 1, 0, 0, 0),
(315, 33, 566, 'table_silo_med*2', 3, 0, 1, 0, 0, 0),
(316, 33, 567, 'table_silo_med*3', 3, 0, 1, 0, 0, 0),
(317, 33, 568, 'table_silo_med*4', 3, 0, 1, 0, 0, 0),
(318, 33, 569, 'table_silo_med*5', 3, 0, 1, 0, 0, 0),
(319, 33, 570, 'table_silo_med*6', 3, 0, 1, 0, 0, 0),
(320, 33, 571, 'table_silo_med*7', 3, 0, 1, 0, 0, 0),
(321, 33, 572, 'table_silo_med*8', 3, 0, 1, 0, 0, 0),
(322, 33, 573, 'table_silo_med*9', 3, 0, 1, 0, 0, 0),
(323, 33, 574, 'sofa_silo*2', 4, 0, 1, 0, 0, 0),
(324, 33, 575, 'sofa_silo*3', 4, 0, 1, 0, 0, 0),
(325, 33, 576, 'sofa_silo*4', 4, 0, 1, 0, 0, 0),
(326, 33, 577, 'sofa_silo*5', 4, 0, 1, 0, 0, 0),
(327, 33, 578, 'sofa_silo*6', 4, 0, 1, 0, 0, 0),
(328, 33, 579, 'sofa_silo*7', 4, 0, 1, 0, 0, 0),
(329, 33, 580, 'sofa_silo*8', 4, 0, 1, 0, 0, 0),
(330, 33, 581, 'sofa_silo*9', 4, 0, 1, 0, 0, 0),
(331, 33, 633, 'chair_silo*2', 3, 0, 1, 0, 0, 0),
(332, 33, 634, 'chair_silo*3', 3, 0, 1, 0, 0, 0),
(333, 33, 635, 'chair_silo*4', 3, 0, 1, 0, 0, 0),
(334, 33, 636, 'chair_silo*5', 3, 0, 1, 0, 0, 0),
(335, 33, 637, 'chair_silo*5', 3, 0, 1, 0, 0, 0),
(336, 33, 638, 'chair_silo*7', 3, 0, 1, 0, 0, 0),
(337, 33, 639, 'chair_silo*8', 3, 0, 1, 0, 0, 0),
(338, 33, 640, 'chair_silo*9', 3, 0, 1, 0, 0, 0),
(339, 33, 657, 'silo_studydesk', 10, 0, 1, 0, 0, 0),
(340, 33, 657, 'silo_studydesk', 10, 0, 1, 0, 0, 0),
(341, 33, 675, 'safe_silo', 3, 0, 1, 0, 0, 0),
(342, 33, 702, 'barchair_silo*2', 3, 0, 1, 0, 0, 0),
(343, 33, 703, 'barchair_silo*3', 3, 0, 1, 0, 0, 0),
(344, 33, 704, 'barchair_silo*4', 3, 0, 1, 0, 0, 0),
(345, 33, 705, 'barchair_silo*5', 3, 0, 1, 0, 0, 0),
(346, 33, 706, 'barchair_silo*6', 3, 0, 1, 0, 0, 0),
(347, 33, 707, 'barchair_silo*6', 3, 0, 1, 0, 0, 0),
(348, 33, 707, 'barchair_silo*7', 3, 0, 1, 0, 0, 0),
(349, 33, 708, 'barchair_silo*8', 3, 0, 1, 0, 0, 0),
(350, 33, 709, 'barchair_silo*9', 3, 0, 1, 0, 0, 0),
(351, 33, 710, 'safe_silo*2', 3, 0, 1, 0, 0, 0),
(352, 33, 711, 'safe_silo*3', 3, 0, 1, 0, 0, 0),
(353, 33, 712, 'safe_silo*4', 3, 0, 1, 0, 0, 0),
(354, 33, 713, 'safe_silo*5', 3, 0, 1, 0, 0, 0),
(355, 33, 714, 'safe_silo*6', 3, 0, 1, 0, 0, 0),
(356, 33, 715, 'safe_silo*7', 3, 0, 1, 0, 0, 0),
(358, 33, 716, 'safe_silo*8', 3, 0, 1, 0, 0, 0),
(359, 33, 717, 'safe_silo*9', 3, 0, 1, 0, 0, 0),
(360, 33, 1043, 'safe_silo_pb', 5, 0, 1, 0, 0, 0),
(364, 37, 1640, 'ktchn_light', 3, 0, 1, 0, 0, 0),
(363, 37, 1639, 'ktchn_stove', 4, 0, 1, 0, 0, 0),
(365, 37, 1641, 'ktchn_plates', 3, 0, 1, 0, 0, 0),
(366, 37, 1642, 'ktchn_countr_1', 3, 0, 1, 0, 0, 0),
(367, 37, 1643, 'ktchn_pots', 5, 0, 1, 0, 0, 0),
(368, 37, 1644, 'ktchn_cornr', 3, 0, 1, 0, 0, 0),
(369, 37, 1645, 'ktchn_desk', 3, 0, 1, 0, 0, 0),
(370, 37, 1646, 'ktchn_trash', 3, 0, 1, 0, 0, 0),
(371, 37, 1647, 'ktchn_countr_2', 4, 0, 1, 0, 0, 0),
(372, 37, 1648, 'ktchn_bBlock', 5, 0, 1, 0, 0, 0),
(373, 37, 1649, 'ktchn_dvdr', 3, 0, 1, 0, 0, 0),
(374, 37, 1650, 'ktchn_inspctr', 5, 0, 1, 0, 0, 0),
(375, 37, 1651, 'ktchn_fridge', 4, 0, 1, 0, 0, 0),
(376, 37, 1653, 'ktchn_sink', 4, 0, 1, 0, 0, 0),
(388, 28, 1368, 'xmas08_table', 3, 0, 1, 0, 0, 0),
(378, 37, 1654, 'ktchn_gate', 6, 0, 1, 0, 0, 0),
(379, 37, 1798, 'ktchn_wall', 8, 0, 1, 0, 0, 0),
(380, 37, 1800, 'ktchn_oven', 3, 0, 1, 0, 0, 0),
(381, 37, 1801, 'ktchn_knives', 3, 0, 1, 0, 0, 0),
(392, 28, 1387, 'xmas08_geysir', 4, 0, 1, 0, 0, 0),
(393, 28, 1391, 'xmas08_lantern', 3, 0, 1, 0, 0, 0),
(394, 28, 1392, 'xmas08_chair', 3, 0, 1, 0, 0, 0),
(395, 28, 1394, 'xmas08_telep', 6, 0, 1, 0, 0, 0),
(396, 28, 1395, 'xmas08_cubetree', 3, 0, 1, 0, 0, 0),
(397, 28, 1397, 'xmas08_dvdr1', 3, 0, 1, 0, 0, 0),
(398, 28, 1398, 'xmas08_hole', 2, 0, 1, 0, 0, 0),
(399, 28, 1401, 'xmas08_dvdr2', 3, 0, 1, 0, 0, 0),
(400, 28, 1413, 'xmas08_trph2', 6, 0, 1, 0, 0, 0),
(401, 28, 1738, 'xmas08_wallpaper', 3, 0, 1, 0, 0, 0),
(402, 28, 1739, 'xmas08_icewall', 3, 0, 1, 0, 0, 0),
(404, 39, 141, 'plant_pineapple', 3, 0, 1, 0, 0, 0),
(405, 39, 142, 'plant_fruittree', 3, 0, 1, 0, 0, 0),
(406, 39, 143, 'plant_small_cactus', 1, 0, 1, 0, 0, 0),
(407, 39, 144, 'plant_bonsai', 2, 0, 1, 0, 0, 0),
(408, 39, 145, 'plant_big_cactus', 3, 0, 1, 0, 0, 0),
(409, 39, 146, 'plant_yukka', 3, 0, 1, 0, 0, 0),
(410, 39, 152, 'plant_sunflower', 3, 0, 1, 0, 0, 0),
(411, 39, 153, 'plant_rose', 3, 0, 1, 0, 0, 0),
(412, 39, 816, 'plant_mazegate', 5, 0, 1, 0, 0, 0),
(413, 39, 817, 'plant_maze', 5, 0, 1, 0, 0, 0),
(414, 39, 818, 'plant_bulrush', 3, 0, 1, 0, 0, 0),
(417, 38, 155, 'bath', 6, 0, 1, 0, 0, 0),
(418, 38, 156, 'sink', 3, 0, 1, 0, 0, 0),
(419, 38, 159, 'tile', 3, 0, 1, 0, 0, 0),
(420, 38, 162, 'tile_red', 3, 0, 1, 0, 0, 0),
(421, 38, 163, 'tile_yell', 3, 0, 1, 0, 0, 0),
(422, 38, 157, 'toilet', 4, 0, 1, 0, 0, 0),
(423, 38, 160, 'toilet_red', 4, 0, 1, 0, 0, 0),
(424, 38, 161, 'toilet_yell', 4, 0, 1, 0, 0, 0),
(425, 38, 158, 'duck', 1, 0, 1, 0, 0, 0),
(426, 34, 1536, 'country_rain', 3, 0, 10, 0, 0, 0),
(427, 34, 1537, 'country_scarecrow', 3, 0, 10, 0, 0, 0),
(428, 34, 1539, 'country_soil', 50, 0, 10, 0, 0, 0),
(429, 34, 1540, 'country_grass', 500, 0, 100, 0, 0, 0),
(430, 34, 1543, 'country_trctr', 4, 0, 10, 0, 0, 0),
(431, 34, 1544, 'country_fnc2', 3, 0, 10, 0, 0, 0),
(432, 34, 1545, 'country_fnc1', 2, 0, 10, 0, 0, 0),
(433, 34, 1546, 'country_well', 3, 0, 10, 0, 0, 0),
(434, 34, 1548, 'country_rbw', 3, 0, 10, 0, 0, 0),
(435, 34, 1549, 'country_wheat', 50, 0, 10, 0, 0, 0),
(436, 34, 1550, 'country_gate', 6, 0, 10, 0, 0, 0),
(437, 34, 1552, 'country_stage', 4, 0, 10, 0, 0, 0),
(438, 34, 1557, 'country_log', 3, 0, 10, 0, 0, 0),
(439, 34, 1558, 'country_fnc3', 3, 0, 10, 0, 0, 0),
(440, 34, 1559, 'country_patio', 1, 0, 10, 0, 0, 0),
(441, 34, 1560, 'country_corner', 3, 0, 10, 0, 0, 0),
(442, 34, 1561, 'country_ditch', 3, 0, 10, 0, 0, 0),
(443, 34, 1777, 'country_forestwall', 4, 0, 10, 0, 0, 0),
(444, 34, 1778, 'country_fp', 4, 0, 10, 0, 0, 0),
(445, 34, 1779, 'country_wall', 3, 0, 10, 0, 0, 0),
(446, 34, 1780, 'country_lantern', 3, 0, 10, 0, 0, 0),
(448, 34, 1779, 'country_wall', 15, 0, 10, 0, 0, 0),
(449, 40, 43, 'carpet_standard', 3, 0, 1, 0, 0, 0),
(450, 40, 45, 'carpet_polar', 3, 0, 1, 0, 0, 0),
(451, 40, 52, 'carpet_standard*1', 3, 0, 1, 0, 0, 0),
(452, 40, 60, 'carpet_standard*2', 3, 0, 1, 0, 0, 0),
(453, 40, 66, 'carpet_standard*3', 3, 0, 1, 0, 0, 0),
(454, 40, 66, 'carpet_standard*3', 3, 0, 1, 0, 0, 0),
(455, 40, 73, 'carpet_standard*4', 3, 0, 1, 0, 0, 0),
(456, 40, 77, 'carpet_standard*5', 3, 0, 1, 0, 0, 0),
(457, 40, 102, 'carpet_standard*6', 3, 0, 1, 0, 0, 0),
(458, 40, 118, 'carpet_soft', 3, 0, 1, 0, 0, 0),
(459, 40, 119, 'carpet_soft*1', 3, 0, 1, 0, 0, 0),
(460, 40, 120, 'carpet_soft*2', 3, 0, 1, 0, 0, 0),
(461, 40, 121, 'carpet_soft*3', 3, 0, 1, 0, 0, 0),
(462, 40, 122, 'carpet_soft*4', 3, 0, 1, 0, 0, 0),
(463, 40, 123, 'carpet_soft*5', 3, 0, 1, 0, 0, 0),
(464, 40, 124, 'carpet_soft*6', 3, 0, 1, 0, 0, 0),
(465, 40, 127, 'carpet_polar*1', 3, 0, 1, 0, 0, 0),
(466, 40, 129, 'carpet_polar*2', 3, 0, 1, 0, 0, 0),
(467, 40, 130, 'carpet_polar*3', 3, 0, 1, 0, 0, 0),
(468, 40, 131, 'carpet_polar*4', 3, 0, 1, 0, 0, 0),
(469, 40, 147, 'carpet_standard*7', 3, 0, 1, 0, 0, 0),
(470, 40, 148, 'carpet_standard*8', 3, 0, 1, 0, 0, 0),
(471, 40, 149, 'carpet_standard*9', 3, 0, 1, 0, 0, 0),
(472, 40, 150, 'carpet_standard*10', 3, 0, 1, 0, 0, 0),
(473, 40, 151, 'carpet_standard*11', 3, 0, 1, 0, 0, 0),
(475, 41, 1781, 'flag_norway', 3, 0, 1, 0, 0, 0),
(476, 41, 1795, 'flag_belgium', 3, 0, 1, 0, 0, 0),
(477, 41, 1796, 'flag_portugal', 3, 0, 1, 0, 0, 0),
(481, 27, 190, 'xmasduck', 1, 0, 1, 0, 0, 0),
(482, 27, 263, 'rare_xmas_screen', 6, 0, 1, 0, 0, 0),
(483, 28, 1035, 'xmas_icelamp', 3, 0, 1, 0, 0, 0),
(485, 27, 1036, 'xmas_cstl_wall', 5, 0, 1, 0, 0, 0),
(486, 27, 1037, 'xmas_cstl_twr', 5, 0, 1, 0, 0, 0),
(487, 27, 1038, 'xmas_cstl_gate', 5, 0, 1, 0, 0, 0),
(488, 27, 1378, 'xmas_snow', 3, 0, 1, 0, 0, 0),
(489, 27, 1378, 'xmas_snow', 20, 0, 10, 0, 0, 0),
(490, 27, 1676, 'xmas_light', 3, 0, 1, 0, 0, 0),
(513, 27, 193, 'tree3', 3, 0, 1, 0, 0, 0),
(496, 27, 19973, 'xm09_table', 5, 0, 1, 0, 0, 0),
(493, 27, 19971, 'xm09_man_b', 3, 0, 1, 0, 0, 0),
(833, 57, 669, 'chair_china', 3, 0, 1, 0, 0, 0),
(495, 27, 19972, 'xm09_man_c', 3, 0, 1, 0, 0, 0),
(497, 27, 19974, 'xm09_bench', 5, 0, 1, 0, 0, 0),
(2120, 7, 20060, 'DEAL_HC_2', 250, 0, 3, 0, 0, 0),
(499, 27, 19977, 'xm09_forestwall', 3, 0, 1, 0, 0, 0),
(500, 27, 19978, 'xm09_lodgewall', 3, 0, 1, 0, 0, 0),
(501, 27, 19979, 'xm09_bauble_25', 3, 0, 1, 0, 0, 0),
(502, 27, 19976, 'xm09_firwall', 3, 0, 1, 0, 0, 0),
(503, 27, 19980, 'xm09_bauble_26', 3, 0, 1, 0, 0, 0),
(512, 27, 187, 'pudding', 3, 0, 1, 0, 0, 0),
(505, 27, 19982, 'xm09_bauble_27', 3, 0, 1, 0, 0, 0),
(506, 27, 19983, 'xm09_bauble_23', 3, 0, 1, 0, 0, 0),
(507, 27, 19984, 'xm09_bauble_24', 3, 0, 1, 0, 0, 0),
(508, 27, 19985, 'xm09_candyCane', 3, 0, 1, 0, 0, 0),
(509, 27, 19986, 'xm09_stocking', 3, 0, 1, 0, 0, 0),
(514, 27, 194, 'tree4', 3, 0, 1, 0, 0, 0),
(515, 27, 195, 'tree5', 3, 0, 1, 0, 0, 0),
(516, 27, 1039, 'tree7', 3, 0, 1, 0, 0, 0),
(517, 27, 1040, 'tree6', 3, 0, 1, 0, 0, 0),
(518, 27, 1046, 'christmas_sleigh', 6, 0, 1, 0, 0, 0),
(519, 27, 1047, 'christmas_reindeer', 5, 0, 1, 0, 0, 0),
(520, 27, 1048, 'christmas_poop', 1, 0, 1, 0, 0, 0),
(522, 27, 192, 'triplecandle', 3, 0, 1, 0, 0, 0),
(523, 27, 198, 'rcandleset', 3, 0, 1, 0, 0, 0),
(524, 27, 270, 'rcandle', 2, 0, 1, 0, 0, 0),
(555, 77, 1305, 'greek_corner', 3, 0, 1, 0, 0, 0),
(528, 27, 19989, 'xm09_man_a', 3, 0, 1, 0, 0, 0),
(1117, 43, 125, 'red_tv', 3, 0, 1, 0, 0, 0),
(531, 27, 19981, 'xm09_bauble_27', 3, 0, 1, 0, 0, 0),
(532, 28, 1374, 'campfire', 4, 0, 1, 0, 0, 0),
(533, 76, 200, 'valeduck', 1, 0, 1, 0, 0, 0),
(534, 76, 245, 'valentinescreen', 5, 0, 1, 0, 0, 0),
(556, 77, 1306, 'greek_gate', 6, 0, 1, 0, 0, 0),
(536, 76, 811, 'plant_valentinerose*3', 3, 0, 1, 0, 0, 0),
(537, 76, 812, 'plant_valentinerose*5', 3, 0, 1, 0, 0, 0),
(538, 76, 813, 'plant_valentinerose*2', 3, 0, 1, 0, 0, 0),
(539, 76, 814, 'plant_valentinerose*4', 3, 0, 1, 0, 0, 0),
(540, 76, 815, 'plant_valentinerose*1', 3, 0, 1, 0, 0, 0),
(541, 76, 820, 'carpet_valentine', 6, 0, 1, 0, 0, 0),
(542, 76, 1092, 'val_teddy*1', 3, 0, 1, 0, 0, 0),
(543, 76, 1093, 'val_teddy*2', 3, 0, 1, 0, 0, 0),
(544, 76, 1094, 'val_teddy*3', 3, 0, 1, 0, 0, 0),
(545, 76, 1095, 'val_teddy*4', 3, 0, 1, 0, 0, 0),
(546, 76, 1096, 'val_teddy*4', 3, 0, 1, 0, 0, 0),
(547, 76, 1097, 'val_teddy*6', 3, 0, 1, 0, 0, 0),
(548, 76, 1098, 'val_randomizer', 8, 0, 1, 0, 0, 0),
(549, 76, 1099, 'val_choco', 3, 0, 1, 0, 0, 0),
(550, 76, 1669, 'val_heart', 3, 0, 1, 0, 0, 0),
(551, 76, 1656, 'post.it.vd', 3, 0, 30, 0, 0, 0),
(552, 76, 199, 'statue', 4, 0, 1, 0, 0, 0),
(553, 76, 201, 'heartsofa', 3, 0, 1, 0, 0, 0),
(557, 77, 1307, 'greek_pillars', 3, 0, 1, 0, 0, 0),
(558, 77, 1308, 'greek_seat', 2, 0, 1, 0, 0, 0),
(564, 71, 1623, 'rela_candle1', 3, 0, 1, 0, 0, 0),
(560, 42, 1310, 'a0 greektrophy_s', 10, 0, 1, 0, 0, 0),
(561, 42, 1311, 'a0 greektrophy_b', 10, 0, 1, 0, 0, 0),
(562, 77, 1312, 'greek_block', 4, 0, 1, 0, 0, 0),
(563, 42, 1309, 'a0 greektrophy_g', 10, 0, 1, 0, 0, 0),
(2108, 42, 20051, 'ads_twi_trophy', 10, 0, 1, 0, 0, 0),
(566, 71, 1625, 'rela_candles2', 3, 0, 1, 0, 0, 0),
(766, 72, 796, 'romantique_pianochair*5', 2, 0, 1, 0, 0, 0),
(568, 71, 1627, 'rela_hchair', 5, 0, 1, 0, 0, 0),
(569, 71, 1628, 'rela_candle2', 3, 0, 1, 0, 0, 0),
(570, 71, 1632, 'rela_candle3', 3, 0, 1, 0, 0, 0),
(571, 71, 1634, 'rela_plant', 4, 0, 1, 0, 0, 0),
(572, 71, 1635, 'rela_candles1', 3, 0, 1, 0, 0, 0),
(573, 71, 1636, 'rela_candles3', 3, 0, 1, 0, 0, 0),
(574, 71, 1637, 'rela_orchid', 5, 0, 1, 0, 0, 0),
(575, 71, 1638, 'rela_rock', 4, 0, 1, 0, 0, 0),
(576, 71, 1794, 'rela_wall', 4, 0, 1, 0, 0, 0),
(578, 59, 209, 'basket', 3, 0, 1, 0, 0, 0),
(579, 59, 208, 'bunny', 3, 0, 1, 0, 0, 0),
(580, 59, 207, 'easterduck', 1, 0, 1, 0, 0, 0),
(581, 59, 210, 'birdie', 4, 0, 1, 0, 0, 0),
(584, 56, 1124, 'arabian_teamk', 4, 0, 1, 0, 0, 0),
(585, 56, 1125, 'arabian_snake', 3, 0, 1, 0, 0, 0),
(586, 56, 1126, 'arabian_rug', 6, 0, 1, 0, 0, 0),
(587, 56, 1127, 'arabian_pllw', 3, 0, 1, 0, 0, 0),
(588, 56, 1128, 'arabian_divdr', 3, 0, 1, 0, 0, 0),
(589, 56, 1129, 'arabian_chair', 3, 0, 1, 0, 0, 0),
(590, 56, 1130, 'arabian_bigtb', 6, 0, 1, 0, 0, 0),
(591, 56, 1131, 'arabian_tetbl', 3, 0, 1, 0, 0, 0),
(592, 56, 1132, 'arabian_tray1', 3, 0, 1, 0, 0, 0),
(600, 63, 451, 'sporttrack1*1', 3, 0, 1, 0, 0, 0),
(594, 56, 1134, 'arabian_tray3', 3, 0, 1, 0, 0, 0),
(595, 56, 1135, 'arabian_tray4', 3, 0, 1, 0, 0, 0),
(596, 56, 1688, 'arabian_swords', 4, 0, 1, 0, 0, 0),
(597, 56, 1689, 'arabian_wndw', 2, 0, 1, 0, 0, 0),
(598, 56, 1133, 'arabian_tray2', 3, 0, 1, 0, 0, 0),
(601, 63, 452, 'sporttrack1*3', 3, 0, 1, 0, 0, 0),
(602, 63, 453, 'sporttrack1*2', 3, 0, 1, 0, 0, 0),
(603, 63, 454, 'sporttrack2*1', 3, 0, 1, 0, 0, 0),
(604, 63, 455, 'sporttrack2*2', 3, 0, 1, 0, 0, 0),
(605, 63, 456, 'sporttrack2*3', 3, 0, 1, 0, 0, 0),
(606, 63, 457, 'sporttrack3*1', 3, 0, 1, 0, 0, 0),
(607, 63, 458, 'sporttrack3*2', 3, 0, 1, 0, 0, 0),
(608, 63, 459, 'sporttrack3*3', 3, 0, 1, 0, 0, 0),
(609, 63, 293, 'hockey_light', 4, 0, 1, 0, 0, 0),
(610, 63, 292, 'hockey_score', 5, 0, 1, 0, 0, 0),
(611, 63, 243, 'bench_lego', 3, 0, 1, 0, 0, 0),
(612, 63, 242, 'carpet_legocourt', 4, 0, 1, 0, 0, 0),
(613, 63, 244, 'legotrophy', 3, 0, 1, 0, 0, 0),
(615, 63, 460, 'footylamp', 3, 0, 1, 0, 0, 0),
(617, 64, 1017, 'grunge_chair', 3, 0, 1, 0, 0, 0),
(618, 64, 1018, 'grunge_mattress', 4, 0, 1, 0, 0, 0),
(619, 64, 1019, 'grunge_radiator', 3, 0, 1, 0, 0, 0),
(620, 64, 1020, 'grunge_shelf', 4, 0, 1, 0, 0, 0),
(621, 64, 1022, 'grunge_table', 4, 0, 1, 0, 0, 0),
(622, 64, 1021, 'grunge_sign', 3, 0, 1, 0, 0, 0),
(623, 64, 1110, 'grunge_candle', 2, 0, 1, 0, 0, 0),
(624, 64, 1111, 'grunge_bench', 4, 0, 1, 0, 0, 0),
(625, 64, 1112, 'grunge_barrel', 3, 0, 1, 0, 0, 0),
(626, 64, 1700, 'window_grunge', 2, 0, 1, 0, 0, 0),
(628, 67, 844, 'jp_tatami2', 4, 0, 1, 0, 0, 0),
(629, 67, 845, 'jp_tatami', 3, 0, 1, 0, 0, 0),
(630, 67, 847, 'jp_bamboo', 5, 0, 1, 0, 0, 0),
(631, 67, 848, 'jp_irori', 5, 0, 1, 0, 0, 0),
(632, 67, 849, 'jp_pillow', 2, 0, 1, 0, 0, 0),
(633, 67, 937, 'jp_lantern', 3, 0, 1, 0, 0, 0),
(634, 67, 965, 'jp_drawer', 3, 0, 1, 0, 0, 0),
(635, 67, 1118, 'jp_tray6', 3, 0, 1, 0, 0, 0),
(636, 67, 1119, 'jp_tray5', 3, 0, 1, 0, 0, 0),
(637, 67, 1120, 'jp_tray4', 3, 0, 1, 0, 0, 0),
(638, 67, 1121, 'jp_tray3', 3, 0, 1, 0, 0, 0),
(639, 67, 1122, 'jp_tray2', 3, 0, 1, 0, 0, 0),
(640, 67, 1123, 'jp_tray1', 3, 0, 1, 0, 0, 0),
(641, 67, 1150, 'jp_table', 5, 0, 1, 0, 0, 0),
(642, 67, 1151, 'jp_rare', 6, 0, 1, 0, 0, 0),
(643, 67, 1152, 'jp_katana3', 3, 0, 1, 0, 0, 0),
(644, 67, 1153, 'jp_katana2', 3, 0, 1, 0, 0, 0),
(645, 67, 1154, 'jp_katana1', 3, 0, 1, 0, 0, 0),
(646, 67, 1197, 'jp_teamaker', 4, 0, 1, 0, 0, 0),
(647, 67, 1671, 'jp_ninjastars', 4, 0, 1, 0, 0, 0),
(648, 67, 1685, 'jp_sheet3', 3, 0, 1, 0, 0, 0),
(649, 67, 1686, 'jp_sheet2', 3, 0, 1, 0, 0, 0),
(650, 67, 1687, 'jp_sheet1', 3, 0, 1, 0, 0, 0),
(651, 75, 969, 'summer_grill*1', 3, 0, 1, 0, 0, 0),
(652, 75, 970, 'summer_grill*2', 3, 0, 1, 0, 0, 0),
(653, 75, 971, 'summer_grill*3', 3, 0, 1, 0, 0, 0),
(654, 75, 972, 'summer_grill*4', 3, 0, 1, 0, 0, 0),
(655, 75, 973, 'summer_chair*1', 3, 0, 1, 0, 0, 0),
(656, 75, 974, 'summer_chair*2', 3, 0, 1, 0, 0, 0),
(657, 75, 975, 'summer_chair*3', 3, 0, 1, 0, 0, 0),
(658, 75, 976, 'summer_chair*4', 3, 0, 1, 0, 0, 0),
(659, 75, 977, 'summer_chair*5', 3, 0, 1, 0, 0, 0),
(660, 75, 978, 'summer_chair*6', 3, 0, 1, 0, 0, 0),
(661, 75, 979, 'summer_chair*7', 3, 0, 1, 0, 0, 0),
(662, 75, 980, 'summer_chair*8', 3, 0, 1, 0, 0, 0),
(663, 75, 981, 'summer_chair*9', 3, 0, 1, 0, 0, 0),
(664, 75, 1003, 'summer_pool*1', 5, 0, 1, 0, 0, 0),
(665, 75, 1004, 'summer_pool*2', 5, 0, 1, 0, 0, 0),
(666, 75, 1005, 'summer_pool*3', 5, 0, 1, 0, 0, 0),
(667, 75, 1006, 'summer_pool*4', 5, 0, 1, 0, 0, 0),
(668, 75, 1616, 'summer_raft1', 4, 0, 1, 0, 0, 0),
(669, 75, 1618, 'summer_raft2', 4, 0, 1, 0, 0, 0),
(670, 75, 1620, 'summer_icebox', 3, 0, 1, 0, 0, 0),
(671, 66, 19938, 'hween09_floor', 3, 0, 1, 0, 0, 0),
(672, 66, 19938, 'hween09_floor', 25, 0, 10, 0, 0, 0),
(673, 66, 19939, 'hween09_jar', 3, 0, 1, 0, 0, 0),
(674, 66, 19941, 'hween09_organ', 5, 0, 1, 0, 0, 0),
(675, 66, 19944, 'hween09_table', 6, 0, 1, 0, 0, 0),
(676, 66, 19945, 'hween09_chair', 3, 0, 1, 0, 0, 0),
(677, 66, 19946, 'hween09_mirror', 4, 0, 1, 0, 0, 0),
(678, 66, 19947, 'hween09_hatch', 6, 0, 1, 0, 0, 0),
(679, 66, 19948, 'hween09_ghost', 3, 0, 1, 0, 0, 0),
(680, 66, 19949, 'hween09_tv', 3, 0, 1, 0, 0, 0),
(681, 66, 19950, 'hween09_chandelier', 5, 0, 1, 0, 0, 0),
(682, 66, 19951, 'hween09_crnr1', 3, 0, 1, 0, 0, 0),
(683, 66, 19952, 'hween09_paint', 3, 0, 1, 0, 0, 0),
(684, 66, 19953, 'hween09_treewall', 3, 0, 1, 0, 0, 0),
(685, 66, 19954, 'hween09_wall1', 3, 0, 1, 0, 0, 0),
(686, 66, 19955, 'hween09_stonewall', 3, 0, 1, 0, 0, 0),
(687, 66, 19956, 'hween09_win', 4, 0, 1, 0, 0, 0),
(688, 66, 181, 'pumpkin', 3, 0, 1, 0, 0, 0),
(694, 66, 185, 'deadduck3', 1, 0, 1, 0, 0, 0),
(690, 66, 182, 'skullcandle', 3, 0, 1, 0, 0, 0),
(693, 66, 184, 'deadduck2', 1, 0, 1, 0, 0, 0),
(695, 66, 183, 'deadduck', 1, 0, 1, 0, 0, 0),
(697, 88, 1334, 'hween08_sink', 3, 0, 1, 0, 0, 0),
(698, 88, 1335, 'hween08_curtain', 5, 0, 1, 0, 0, 0),
(699, 88, 1336, 'hween08_bath', 6, 0, 1, 0, 0, 0),
(700, 88, 1337, 'hween08_defibs', 3, 0, 1, 0, 0, 0),
(701, 88, 1338, 'hween08_bbag', 5, 0, 1, 0, 0, 0),
(702, 88, 1339, 'hween08_curtain2', 5, 0, 1, 0, 0, 0),
(703, 88, 1340, 'hween08_defibs2', 3, 0, 1, 0, 0, 0),
(704, 88, 1341, 'hween08_bed', 4, 0, 1, 0, 0, 0),
(705, 88, 1342, 'hween08_sink2', 3, 0, 1, 0, 0, 0),
(706, 88, 1343, 'hween08_bed2', 4, 0, 1, 0, 0, 0),
(707, 88, 1344, 'hween08_bath2', 4, 0, 1, 0, 0, 0),
(708, 88, 1345, 'hween08_manhole', 3, 0, 1, 0, 0, 0),
(709, 88, 1346, 'hween08_trll', 3, 0, 1, 0, 0, 0),
(710, 88, 1721, 'hween08_rad', 3, 0, 1, 0, 0, 0),
(711, 88, 1722, 'hween08_wndwb', 3, 0, 1, 0, 0, 0),
(712, 88, 1723, 'hween08_wndw', 4, 0, 1, 0, 0, 0),
(713, 88, 1724, 'hween08_bio', 3, 0, 1, 0, 0, 0),
(714, 74, 1419, 'bolly_lotus_pool', 4, 0, 1, 0, 0, 0),
(715, 74, 1422, 'bolly_petals', 3, 0, 1, 0, 0, 0),
(716, 74, 1423, 'bolly_tree', 3, 0, 1, 0, 0, 0),
(717, 74, 1424, 'bolly_swing', 4, 0, 1, 0, 0, 0),
(718, 74, 1425, 'bolly_pillow', 3, 0, 1, 0, 0, 0),
(719, 74, 1426, 'bolly_corner', 3, 0, 1, 0, 0, 0),
(720, 74, 1427, 'bolly_phant', 5, 0, 1, 0, 0, 0),
(721, 74, 1428, 'bolly_monkey_lamp', 4, 0, 1, 0, 0, 0),
(722, 74, 1429, 'bolly_drapeb', 4, 0, 1, 0, 0, 0),
(723, 74, 1431, 'bolly_lamp', 3, 0, 1, 0, 0, 0),
(724, 74, 1432, 'bolly_desk', 3, 0, 1, 0, 0, 0),
(725, 74, 1433, 'bolly_vase', 3, 0, 1, 0, 0, 0),
(726, 74, 1434, 'bolly_tile2', 3, 0, 1, 0, 0, 0),
(727, 74, 1435, 'bolly_table', 4, 0, 1, 0, 0, 0),
(728, 74, 1436, 'bolly_drapec', 4, 0, 1, 0, 0, 0),
(729, 74, 1437, 'bolly_fountain', 5, 0, 1, 0, 0, 0),
(735, 73, 1593, 'SF_reactor', 5, 0, 1, 0, 0, 0),
(731, 74, 1439, 'bolly_tile1', 3, 0, 1, 0, 0, 0),
(732, 74, 1440, 'bolly_drapea', 4, 0, 1, 0, 0, 0),
(733, 74, 1749, 'bolly_wdw_wd', 4, 0, 1, 0, 0, 0),
(736, 73, 1594, 'SF_crate_2', 3, 0, 1, 0, 0, 0),
(737, 73, 1595, 'SF_chair_blue', 3, 0, 1, 0, 0, 0),
(738, 73, 1596, 'sf_pod', 4, 0, 1, 0, 0, 0),
(739, 73, 1597, 'SF_panel1', 3, 0, 1, 0, 0, 0),
(740, 73, 1598, 'SF_table', 3, 0, 1, 0, 0, 0),
(741, 73, 1602, 'SF_panel2', 3, 0, 1, 0, 0, 0),
(742, 73, 1603, 'sf_gate', 6, 0, 1, 0, 0, 0),
(743, 73, 1599, 'SF_chair_green', 3, 0, 1, 0, 0, 0),
(744, 73, 1600, 'SF_crate_1', 2, 0, 1, 0, 0, 0),
(745, 73, 1601, 'SF_alien', 4, 0, 1, 0, 0, 0),
(746, 73, 1605, 'SF_floor_2', 3, 0, 1, 0, 0, 0),
(747, 73, 1604, 'SF_panel3', 5, 0, 1, 0, 0, 0),
(748, 73, 1606, 'SF_lamp', 3, 0, 1, 0, 0, 0),
(749, 73, 1607, 'SF_chair_red', 3, 0, 1, 0, 0, 0),
(750, 73, 1608, 'sf_floor', 3, 0, 1, 0, 0, 0),
(751, 73, 1609, 'sf_roof', 5, 0, 1, 0, 0, 0),
(752, 73, 1610, 'sf_stick', 3, 0, 1, 0, 0, 0),
(753, 73, 1611, 'SF_floor_1', 3, 0, 1, 0, 0, 0),
(759, 73, 1791, 'sf_wall3', 6, 0, 1, 0, 0, 0),
(758, 73, 1788, 'sf_wall2', 6, 0, 1, 0, 0, 0),
(765, 72, 795, 'romantique_pianochair*3', 2, 0, 1, 0, 0, 0),
(767, 72, 797, 'romantique_pianochair*2', 2, 0, 1, 0, 0, 0),
(768, 72, 798, 'romantique_pianochair*4', 2, 0, 1, 0, 0, 0),
(769, 72, 799, 'romantique_pianochair*1', 2, 0, 1, 0, 0, 0),
(770, 72, 800, 'romantique_divan*3', 4, 0, 1, 0, 0, 0),
(771, 72, 801, 'romantique_divan*5', 4, 0, 1, 0, 0, 0),
(772, 72, 802, 'romantique_divan*2', 4, 0, 1, 0, 0, 0),
(773, 72, 803, 'romantique_divan*4', 4, 0, 1, 0, 0, 0),
(774, 72, 804, 'romantique_divan*1', 4, 0, 1, 0, 0, 0),
(775, 72, 805, 'romantique_chair*3', 3, 0, 1, 0, 0, 0),
(776, 72, 806, 'romantique_chair*5', 3, 0, 1, 0, 0, 0),
(777, 72, 807, 'romantique_chair*2', 3, 0, 1, 0, 0, 0),
(778, 72, 808, 'romantique_chair*4', 3, 0, 1, 0, 0, 0),
(779, 72, 809, 'romantique_chair*1', 3, 0, 1, 0, 0, 0),
(780, 72, 832, 'romantique_tray2', 3, 0, 1, 0, 0, 0),
(781, 72, 833, 'romantique_tray1', 3, 0, 1, 0, 0, 0),
(782, 72, 834, 'romantique_smalltabl*3', 2, 0, 1, 0, 0, 0),
(783, 72, 835, 'romantique_smalltabl*5', 2, 0, 1, 0, 0, 0),
(784, 72, 836, 'romantique_smalltabl*2', 2, 0, 1, 0, 0, 0),
(785, 72, 837, 'romantique_smalltabl*4', 2, 0, 1, 0, 0, 0),
(786, 72, 838, 'romantique_smalltabl*1', 2, 0, 1, 0, 0, 0),
(787, 72, 839, 'romantique_mirrortabl', 3, 0, 1, 0, 0, 0),
(788, 72, 840, 'romantique_divider*3', 3, 0, 1, 0, 0, 0),
(789, 72, 841, 'romantique_divider*2', 3, 0, 1, 0, 0, 0),
(790, 72, 842, 'romantique_divider*4', 3, 0, 1, 0, 0, 0),
(791, 72, 843, 'romantique_divider*1', 3, 0, 1, 0, 0, 0),
(792, 72, 891, 'romantique_clock', 5, 0, 1, 0, 0, 0),
(793, 69, 1347, 'party_table', 3, 0, 1, 0, 0, 0),
(794, 69, 1348, 'party_discol', 5, 0, 1, 0, 0, 0),
(795, 69, 1349, 'party_block2', 4, 0, 1, 0, 0, 0),
(796, 69, 1350, 'party_barcorn', 3, 0, 1, 0, 0, 0),
(797, 69, 1351, 'party_chair', 3, 0, 1, 0, 0, 0),
(798, 69, 1352, 'party_block', 2, 0, 1, 0, 0, 0),
(799, 69, 1353, 'party_ravel', 5, 0, 1, 0, 0, 0),
(800, 69, 1354, 'party_tube_lava', 4, 0, 1, 0, 0, 0),
(801, 69, 1355, 'party_tray', 3, 0, 1, 0, 0, 0),
(802, 69, 1356, 'party_djtable', 4, 0, 1, 0, 0, 0),
(803, 69, 1357, 'party_floor', 3, 0, 1, 0, 0, 0),
(804, 69, 1358, 'party_ball', 3, 0, 1, 0, 0, 0),
(805, 69, 1359, 'party_tube_bubble', 4, 0, 1, 0, 0, 0),
(806, 69, 1360, 'party_mic', 3, 0, 1, 0, 0, 0),
(807, 69, 1361, 'party_beamer', 5, 0, 1, 0, 0, 0),
(808, 69, 1362, 'party_bardesk', 3, 0, 1, 0, 0, 0),
(809, 69, 1363, 'party_seat', 3, 0, 1, 0, 0, 0),
(810, 69, 1729, 'party_wc_boy', 3, 0, 1, 0, 0, 0),
(811, 69, 1730, 'party_led', 4, 0, 1, 0, 0, 0),
(812, 69, 1731, 'party_neon5', 3, 0, 1, 0, 0, 0),
(813, 69, 1732, 'party_neon1', 3, 0, 1, 0, 0, 0),
(814, 69, 1733, 'party_neon2', 3, 0, 1, 0, 0, 0),
(815, 69, 1734, 'party_wc_girl', 3, 0, 1, 0, 0, 0),
(816, 69, 1735, 'party_neon3', 3, 0, 1, 0, 0, 0),
(817, 69, 1736, 'party_shelf', 4, 0, 1, 0, 0, 0),
(818, 69, 1737, 'party_neon4', 3, 0, 1, 0, 0, 0),
(822, 29, 179, 'doorB', 3, 0, 1, 0, 0, 0),
(821, 29, 180, 'doorC', 4, 0, 1, 0, 0, 0),
(824, 94, 227, 'spyro', 10, 0, 1, 0, 0, 0),
(825, 94, 202, 'throne', 10, 0, 1, 0, 0, 0),
(826, 94, 203, 'samovar', 10, 0, 1, 0, 0, 0),
(827, 94, 110, 'plant_cruddy', 10, 0, 1, 0, 0, 0),
(1118, 43, 126, 'wood_tv', 4, 0, 1, 0, 0, 0),
(830, 94, 273, 'djesko_turntable', 10, 0, 1, 0, 0, 0),
(834, 57, 670, 'china_table', 3, 0, 1, 0, 0, 0),
(835, 57, 682, 'china_shelve', 4, 0, 1, 0, 0, 0),
(836, 57, 700, 'wall_china', 4, 0, 1, 0, 0, 0),
(837, 57, 701, 'corner_china', 4, 0, 1, 0, 0, 0),
(838, 57, 1418, 'china_moongt', 5, 0, 1, 0, 0, 0),
(839, 57, 1420, 'china_ox', 3, 0, 1, 0, 0, 0),
(840, 57, 1746, 'china_pstr2', 3, 0, 1, 0, 0, 0),
(846, 60, 1000, 'exe_rug', 20, 0, 6, 0, 0, 0),
(842, 57, 1747, 'china_light', 3, 0, 1, 0, 0, 0),
(843, 57, 1748, 'china_pstr1', 3, 0, 1, 0, 0, 0),
(845, 60, 1000, 'exe_rug', 4, 0, 1, 0, 0, 0),
(847, 60, 1001, 'exe_s_table', 4, 0, 1, 0, 0, 0),
(848, 60, 1049, 'exe_bardesk', 2, 0, 1, 0, 0, 0),
(849, 60, 1050, 'exe_chair', 3, 0, 1, 0, 0, 0),
(850, 60, 1051, 'exe_chair2', 3, 0, 1, 0, 0, 0),
(851, 60, 1052, 'exe_corner', 2, 0, 1, 0, 0, 0),
(852, 60, 1053, 'exe_drinks', 3, 0, 1, 0, 0, 0),
(853, 60, 1054, 'exe_sofa', 3, 0, 1, 0, 0, 0),
(1758, 123, 1061, 'noob_table*1', 0, 100, 1, 0, 0, 0),
(855, 60, 1055, 'exe_table', 6, 0, 1, 0, 0, 0),
(856, 60, 1091, 'exe_plant', 3, 0, 1, 0, 0, 0),
(857, 60, 1510, 'exe_light', 3, 0, 1, 0, 0, 0),
(858, 60, 1517, 'exe_gate', 6, 0, 1, 0, 0, 0),
(859, 60, 1521, 'exe_cubelight', 3, 0, 1, 0, 0, 0),
(860, 60, 1523, 'exe_artlamp', 3, 0, 1, 0, 0, 0),
(861, 60, 1771, 'exe_map', 5, 0, 1, 0, 0, 0),
(862, 60, 1772, 'exe_wfall', 4, 0, 1, 0, 0, 0),
(863, 58, 1449, 'lc_tile1', 3, 0, 1, 0, 0, 0),
(865, 58, 1451, 'lc_crab2', 3, 0, 1, 0, 0, 0),
(866, 58, 1454, 'lc_coral_divider_hi', 4, 0, 1, 0, 0, 0),
(867, 58, 1456, 'lc_tubes_corners', 3, 0, 1, 0, 0, 0),
(868, 58, 1457, 'lc_table', 4, 0, 1, 0, 0, 0),
(869, 58, 1458, 'lc_tile2', 3, 0, 1, 0, 0, 0),
(870, 58, 1459, 'lc_anemone', 4, 0, 1, 0, 0, 0),
(871, 58, 1461, 'lc_glass_floor', 4, 0, 1, 0, 0, 0),
(872, 58, 1460, 'lc_coral_divider_low', 3, 0, 1, 0, 0, 0),
(874, 58, 1462, 'lc_medusa1', 4, 0, 1, 0, 0, 0),
(875, 58, 1463, 'lc_crab1', 4, 0, 1, 0, 0, 0),
(876, 58, 1466, 'lc_tubes_straight', 3, 0, 1, 0, 0, 0),
(877, 58, 1470, 'lc_corner', 3, 0, 1, 0, 0, 0),
(878, 58, 1471, 'lc_stool', 3, 0, 1, 0, 0, 0),
(879, 58, 1472, 'lc_chair', 3, 0, 1, 0, 0, 0),
(880, 58, 1473, 'lc_desk', 3, 0, 1, 0, 0, 0),
(881, 58, 1755, 'lc_wall1', 5, 0, 1, 0, 0, 0),
(882, 58, 1756, 'lc_window2', 5, 0, 1, 0, 0, 0),
(883, 58, 1757, 'lc_window1', 3, 0, 1, 0, 0, 0),
(884, 58, 1759, 'lc_wall2', 5, 0, 1, 0, 0, 0),
(890, 42, 296, 'a0 prizetrophy3_b', 10, 0, 1, 0, 0, 0),
(889, 42, 295, 'a0 prizetrophy2_b', 10, 0, 1, 0, 0, 0),
(891, 42, 297, 'a0 prizetrophy4_b', 10, 0, 1, 0, 0, 0),
(892, 42, 298, 'a0 prizetrophy5_b', 10, 0, 1, 0, 0, 0),
(893, 42, 299, 'a0 prizetrophy1_g', 10, 0, 1, 0, 0, 0),
(894, 42, 300, 'a0 prizetrophy2_g', 10, 0, 1, 0, 0, 0),
(895, 42, 301, 'a0 prizetrophy3_g', 10, 0, 1, 0, 0, 0),
(896, 42, 302, 'a0 prizetrophy4_g', 10, 0, 1, 0, 0, 0),
(897, 42, 303, 'a0 prizetrophy4_g', 10, 0, 1, 0, 0, 0),
(898, 42, 304, 'a0 prizetrophy6_g', 10, 0, 1, 0, 0, 0),
(899, 42, 305, 'a0 prizetrophy1_s', 10, 0, 1, 0, 0, 0),
(900, 42, 306, 'a0 prizetrophy2_s', 10, 0, 1, 0, 0, 0),
(901, 42, 307, 'a0 prizetrophy3_s', 10, 0, 1, 0, 0, 0),
(902, 42, 308, 'a0 prizetrophy4_s', 10, 0, 1, 0, 0, 0),
(903, 42, 309, 'a0 prizetrophy5_s', 10, 0, 1, 0, 0, 0),
(904, 42, 310, 'a0 prizetrophy6_s', 10, 0, 1, 0, 0, 0),
(905, 42, 311, 'a0 prizetrophy1_b', 10, 0, 1, 0, 0, 0),
(906, 93, 335, 'a0 prizetrophy7_b', 10, 0, 1, 0, 0, 0),
(1386, 8, 1313, 'hcc_table', 4, 0, 1, 0, 0, 0),
(908, 93, 336, 'a0 prizetrophy7_g', 10, 0, 1, 0, 0, 0),
(909, 93, 337, 'a0 prizetrophy7_s', 10, 0, 1, 0, 0, 0),
(910, 42, 1115, 'a0 prizetrophy5_g', 10, 0, 1, 0, 0, 0),
(911, 93, 1615, 'prizetrophy_hot', 10, 0, 1, 0, 0, 0),
(912, 93, 1617, 'prizetrophy_cool', 10, 0, 1, 0, 0, 0),
(913, 32, 171, 'bar_basic', 4, 0, 1, 0, 0, 0),
(914, 32, 172, 'shelves_basic', 3, 0, 1, 0, 0, 0),
(915, 32, 175, 'lamp_basic', 3, 0, 1, 0, 0, 0),
(916, 32, 177, 'fridge', 6, 0, 1, 0, 0, 0),
(987, 65, 890, 'rope_divider', 5, 0, 1, 0, 0, 0),
(918, 32, 893, 'pura_mdl5*2', 3, 0, 1, 0, 0, 0),
(919, 32, 894, 'pura_mdl5*3', 3, 0, 1, 0, 0, 0),
(920, 32, 895, 'pura_mdl5*4', 3, 0, 1, 0, 0, 0),
(921, 32, 896, 'pura_mdl5*5', 3, 0, 1, 0, 0, 0),
(922, 32, 897, 'pura_mdl5*6', 3, 0, 1, 0, 0, 0),
(923, 32, 898, 'pura_mdl5*7', 3, 0, 1, 0, 0, 0),
(924, 32, 899, 'pura_mdl5*8', 3, 0, 1, 0, 0, 0),
(925, 32, 900, 'pura_mdl5*9', 3, 0, 1, 0, 0, 0),
(926, 32, 901, 'pura_mdl4*1', 3, 0, 1, 0, 0, 0),
(927, 32, 902, 'pura_mdl4*2', 3, 0, 1, 0, 0, 0),
(928, 32, 903, 'pura_mdl4*3', 3, 0, 1, 0, 0, 0),
(929, 32, 904, 'pura_mdl4*4', 3, 0, 1, 0, 0, 0),
(930, 32, 905, 'pura_mdl4*5', 3, 0, 1, 0, 0, 0),
(931, 32, 906, 'pura_mdl4*6', 3, 0, 1, 0, 0, 0),
(932, 32, 907, 'pura_mdl4*7', 3, 0, 1, 0, 0, 0),
(933, 32, 908, 'pura_mdl4*8', 3, 0, 1, 0, 0, 0),
(934, 32, 909, 'pura_mdl4*9', 3, 0, 1, 0, 0, 0),
(935, 32, 910, 'pura_mdl3*1', 3, 0, 1, 0, 0, 0),
(936, 32, 911, 'pura_mdl3*2', 3, 0, 1, 0, 0, 0),
(937, 32, 912, 'pura_mdl3*3', 3, 0, 1, 0, 0, 0),
(938, 32, 913, 'pura_mdl3*4', 3, 0, 1, 0, 0, 0),
(939, 32, 914, 'pura_mdl3*5', 3, 0, 1, 0, 0, 0),
(940, 32, 915, 'pura_mdl3*6', 3, 0, 1, 0, 0, 0),
(941, 32, 916, 'pura_mdl3*7', 3, 0, 1, 0, 0, 0),
(942, 32, 917, 'pura_mdl3*8', 3, 0, 1, 0, 0, 0),
(943, 32, 918, 'pura_mdl3*9', 3, 0, 1, 0, 0, 0),
(944, 32, 919, 'pura_mdl2*1', 3, 0, 1, 0, 0, 0),
(945, 32, 920, 'pura_mdl2*2', 3, 0, 1, 0, 0, 0),
(947, 32, 921, 'pura_mdl2*3', 3, 0, 1, 0, 0, 0),
(948, 32, 922, 'pura_mdl2*4', 3, 0, 1, 0, 0, 0),
(949, 32, 923, 'pura_mdl2*5', 3, 0, 1, 0, 0, 0),
(950, 32, 924, 'pura_mdl2*6', 3, 0, 1, 0, 0, 0),
(951, 32, 925, 'pura_mdl2*7', 3, 0, 1, 0, 0, 0),
(952, 32, 926, 'pura_mdl2*8', 3, 0, 1, 0, 0, 0),
(953, 32, 927, 'pura_mdl2*9', 3, 0, 1, 0, 0, 0),
(954, 32, 928, 'pura_mdl1*1', 3, 0, 1, 0, 0, 0),
(955, 32, 929, 'pura_mdl1*2', 3, 0, 1, 0, 0, 0),
(956, 32, 930, 'pura_mdl1*3', 3, 0, 1, 0, 0, 0),
(957, 32, 931, 'pura_mdl1*4', 3, 0, 1, 0, 0, 0),
(958, 32, 932, 'pura_mdl1*5', 3, 0, 1, 0, 0, 0),
(959, 32, 933, 'pura_mdl1*6', 3, 0, 1, 0, 0, 0),
(960, 32, 934, 'pura_mdl1*7', 3, 0, 1, 0, 0, 0),
(961, 32, 935, 'pura_mdl1*8', 3, 0, 1, 0, 0, 0),
(962, 32, 936, 'pura_mdl1*9', 3, 0, 1, 0, 0, 0),
(963, 32, 939, 'chair_basic*2', 4, 0, 1, 0, 0, 0),
(964, 32, 940, 'chair_basic*3', 4, 0, 1, 0, 0, 0),
(965, 32, 941, 'chair_basic*4', 4, 0, 1, 0, 0, 0),
(966, 32, 942, 'chair_basic*5', 4, 0, 1, 0, 0, 0),
(967, 32, 943, 'chair_basic*6', 4, 0, 1, 0, 0, 0),
(968, 32, 944, 'chair_basic*7', 4, 0, 1, 0, 0, 0),
(969, 32, 946, 'chair_basic*9', 4, 0, 1, 0, 0, 0),
(970, 32, 948, 'bed_budget*2', 4, 0, 1, 0, 0, 0),
(971, 32, 949, 'bed_budget*3', 4, 0, 1, 0, 0, 0),
(972, 32, 950, 'bed_budget*4', 4, 0, 1, 0, 0, 0),
(973, 32, 951, 'bed_budget*5', 4, 0, 1, 0, 0, 0),
(974, 32, 952, 'bed_budget*6', 4, 0, 1, 0, 0, 0),
(975, 32, 953, 'bed_budget*7', 4, 0, 1, 0, 0, 0),
(976, 32, 954, 'bed_budget*8', 4, 0, 1, 0, 0, 0),
(977, 32, 955, 'bed_budget*9', 4, 0, 1, 0, 0, 0),
(978, 32, 957, 'bed_budget_one*2', 3, 0, 1, 0, 0, 0),
(979, 32, 958, 'bed_budget_one*3', 3, 0, 1, 0, 0, 0),
(980, 32, 959, 'bed_budget_one*4', 3, 0, 1, 0, 0, 0),
(981, 32, 960, 'bed_budget_one*5', 3, 0, 1, 0, 0, 0),
(982, 32, 961, 'bed_budget_one*6', 3, 0, 1, 0, 0, 0),
(983, 32, 962, 'bed_budget_one*7', 3, 0, 1, 0, 0, 0),
(984, 32, 963, 'bed_budget_one*8', 3, 0, 1, 0, 0, 0),
(985, 32, 964, 'bed_budget_one*9', 3, 0, 1, 0, 0, 0),
(988, 65, 846, 'habbowood_chair', 3, 0, 1, 0, 0, 0),
(989, 65, 860, 'spotlight', 5, 0, 1, 0, 0, 0),
(990, 65, 1672, 'habw_mirror', 3, 0, 1, 0, 0, 0),
(991, 65, 967, 'tile_marble', 1, 0, 1, 0, 0, 0),
(992, 65, 967, 'tile_marble', 40, 0, 50, 0, 0, 0),
(993, 65, 968, 'tile_brown', 1, 0, 1, 0, 0, 0),
(994, 65, 968, 'tile_brown', 40, 0, 50, 0, 0, 0),
(995, 65, 966, 'tile_stella', 2, 0, 1, 0, 0, 0),
(996, 65, 966, 'tile_stella', 30, 0, 50, 0, 0, 0),
(998, 102, 437, 'queue_tile1*3', 7, 0, 1, 0, 0, 0),
(999, 102, 437, 'queue_tile1*3', 18, 0, 3, 0, 0, 0),
(1000, 102, 437, 'queue_tile1*3', 30, 0, 5, 0, 0, 0),
(1001, 102, 438, 'queue_tile1*6', 7, 0, 1, 0, 0, 0),
(1002, 102, 438, 'queue_tile1*6', 18, 0, 3, 0, 0, 0),
(1003, 102, 438, 'queue_tile1*6', 30, 0, 5, 0, 0, 0),
(1004, 102, 439, 'queue_tile1*4', 7, 0, 1, 0, 0, 0),
(1005, 102, 439, 'queue_tile1*4', 18, 0, 3, 0, 0, 0),
(1006, 102, 439, 'queue_tile1*4', 30, 0, 5, 0, 0, 0),
(1007, 102, 440, 'queue_tile1*9', 7, 0, 1, 0, 0, 0),
(1008, 102, 440, 'queue_tile1*9', 18, 0, 3, 0, 0, 0),
(1009, 102, 440, 'queue_tile1*9', 30, 0, 5, 0, 0, 0),
(1010, 102, 441, 'queue_tile1*8', 7, 0, 1, 0, 0, 0),
(1011, 102, 441, 'queue_tile1*8', 18, 0, 3, 0, 0, 0),
(1012, 102, 441, 'queue_tile1*8', 30, 0, 5, 0, 0, 0),
(1013, 102, 442, 'queue_tile1*5', 7, 0, 1, 0, 0, 0),
(1014, 102, 442, 'queue_tile1*5', 18, 0, 3, 0, 0, 0),
(1015, 102, 442, 'queue_tile1*5', 30, 0, 5, 0, 0, 0),
(1016, 102, 443, 'queue_tile1*7', 7, 0, 1, 0, 0, 0),
(1017, 102, 443, 'queue_tile1*7', 18, 0, 3, 0, 0, 0),
(1018, 102, 443, 'queue_tile1*7', 30, 0, 5, 0, 0, 0),
(1019, 102, 444, 'queue_tile1*2', 7, 0, 1, 0, 0, 0),
(1020, 102, 444, 'queue_tile1*2', 18, 0, 3, 0, 0, 0),
(1021, 102, 444, 'queue_tile1*2', 30, 0, 5, 0, 0, 0),
(1022, 102, 445, 'queue_tile1*1', 7, 0, 1, 0, 0, 0),
(1023, 102, 445, 'queue_tile1*1', 18, 0, 3, 0, 0, 0),
(1024, 102, 445, 'queue_tile1*1', 30, 0, 5, 0, 0, 0),
(1025, 102, 446, 'queue_tile1*0', 7, 0, 1, 0, 0, 0),
(1026, 102, 446, 'queue_tile1*0', 18, 0, 3, 0, 0, 0),
(1027, 102, 446, 'queue_tile1*0', 30, 0, 5, 0, 0, 0),
(1030, 68, 1568, 'lt_stage2', 4, 0, 1, 0, 0, 0),
(1029, 68, 1567, 'LT_skull', 3, 0, 1, 0, 0, 0),
(1031, 68, 1569, 'lt_lavac', 3, 0, 1, 0, 0, 0),
(1032, 68, 1570, 'lt_gate', 6, 0, 1, 0, 0, 0),
(1033, 68, 1573, 'lt_statue', 3, 0, 1, 0, 0, 0),
(1034, 68, 1574, 'lt_spider', 3, 0, 1, 0, 0, 0),
(1035, 68, 1575, 'lt_stone2', 4, 0, 1, 0, 0, 0),
(1036, 68, 1576, 'LT_throne', 4, 0, 1, 0, 0, 0),
(1037, 68, 1578, 'lt_patch', 3, 0, 1, 0, 0, 0),
(1038, 68, 1579, 'lt_lava', 3, 0, 1, 0, 0, 0),
(1039, 68, 1580, 'LT_pillar2', 3, 0, 1, 0, 0, 0),
(1040, 68, 1581, 'lt_bughill', 5, 0, 1, 0, 0, 0),
(1041, 68, 1584, 'LT_pillar', 4, 0, 1, 0, 0, 0),
(1042, 68, 1588, 'lt_stone1', 4, 0, 1, 0, 0, 0),
(1043, 68, 1585, 'lt_stage1', 3, 0, 1, 0, 0, 0),
(1044, 68, 1785, 'lt_wall', 3, 0, 1, 0, 0, 0),
(1045, 68, 1783, 'lt_jngl_wall', 3, 0, 1, 0, 0, 0),
(1119, 43, 154, 'tv_luxus', 5, 0, 1, 0, 0, 0),
(1050, 61, 718, 'glass_shelf', 4, 0, 1, 0, 0, 0),
(1051, 61, 719, 'glass_chair', 3, 0, 1, 0, 0, 0),
(1052, 61, 720, 'glass_stool', 2, 0, 1, 0, 0, 0),
(1053, 61, 721, 'glass_sofa', 4, 0, 1, 0, 0, 0),
(1054, 61, 723, 'glass_table*2', 3, 0, 1, 0, 0, 0),
(2102, 60, 20046, 'exe_elevator', 5, 0, 1, 0, 0, 0),
(1056, 61, 724, 'glass_table*3', 3, 0, 1, 0, 0, 0),
(1057, 61, 722, 'glass_table', 3, 0, 1, 0, 0, 0),
(1058, 61, 725, 'glass_table*4', 3, 0, 1, 0, 0, 0),
(1059, 61, 726, 'glass_table*5', 3, 0, 1, 0, 0, 0),
(1060, 61, 727, 'glass_table*6', 3, 0, 1, 0, 0, 0),
(1061, 61, 728, 'glass_table*7', 3, 0, 1, 0, 0, 0),
(1062, 61, 729, 'glass_table*8', 3, 0, 1, 0, 0, 0),
(1063, 61, 730, 'glass_table*9', 3, 0, 1, 0, 0, 0),
(1064, 61, 731, 'glass_chair*2', 3, 0, 1, 0, 0, 0),
(1065, 61, 732, 'glass_chair*3', 3, 0, 1, 0, 0, 0),
(1066, 61, 733, 'glass_chair*4', 3, 0, 1, 0, 0, 0),
(1067, 61, 734, 'glass_chair*5', 3, 0, 1, 0, 0, 0),
(1068, 61, 735, 'glass_chair*6', 3, 0, 1, 0, 0, 0),
(1069, 61, 736, 'glass_chair*7', 3, 0, 1, 0, 0, 0),
(1070, 61, 737, 'glass_chair*8', 3, 0, 1, 0, 0, 0),
(1071, 61, 738, 'glass_chair*9', 3, 0, 1, 0, 0, 0),
(1072, 61, 739, 'glass_sofa*2', 4, 0, 1, 0, 0, 0),
(1073, 61, 740, 'glass_sofa*3', 4, 0, 1, 0, 0, 0),
(1074, 61, 741, 'glass_sofa*4', 4, 0, 1, 0, 0, 0),
(1075, 61, 742, 'glass_sofa*5', 4, 0, 1, 0, 0, 0),
(1076, 61, 743, 'glass_sofa*6', 4, 0, 1, 0, 0, 0),
(1077, 61, 744, 'glass_sofa*7', 4, 0, 1, 0, 0, 0),
(1078, 61, 745, 'glass_sofa*8', 4, 0, 1, 0, 0, 0),
(1079, 61, 746, 'glass_sofa*9', 4, 0, 1, 0, 0, 0),
(1080, 61, 747, 'glass_stool*2', 2, 0, 1, 0, 0, 0),
(1081, 61, 748, 'glass_stool*4', 2, 0, 1, 0, 0, 0),
(1082, 61, 749, 'glass_stool*5', 2, 0, 1, 0, 0, 0),
(1083, 61, 750, 'glass_stool*6', 2, 0, 1, 0, 0, 0),
(1084, 61, 751, 'glass_stool*7', 2, 0, 1, 0, 0, 0),
(1085, 61, 752, 'glass_stool*8', 2, 0, 1, 0, 0, 0),
(1086, 61, 753, 'glass_stool*3', 2, 0, 1, 0, 0, 0),
(1087, 61, 754, 'glass_stool*9', 2, 0, 1, 0, 0, 0),
(1088, 72, 829, 'grand_piano*4', 5, 0, 1, 0, 0, 0),
(1089, 72, 826, 'grand_piano*3', 5, 0, 1, 0, 0, 0),
(1090, 72, 827, 'grand_piano*5', 5, 0, 1, 0, 0, 0),
(1091, 72, 828, 'grand_piano*2', 5, 0, 1, 0, 0, 0),
(1092, 72, 830, 'grand_piano*1', 5, 0, 1, 0, 0, 0),
(1093, 94, 248, 'rare_beehive_bulb', 10, 0, 1, 0, 0, 0),
(1094, 94, 261, 'rare_beehive_bulb*1', 10, 0, 1, 0, 0, 0),
(1095, 94, 262, 'rare_beehive_bulb*2', 10, 0, 1, 0, 0, 0),
(1096, 94, 206, 'hologram', 10, 0, 1, 0, 0, 0),
(1097, 94, 228, 'redhologram', 10, 0, 1, 0, 0, 0),
(1098, 94, 255, 'rare_hammock', 10, 0, 1, 0, 0, 0),
(1099, 94, 251, 'rare_elephant_statue', 10, 0, 1, 0, 0, 0),
(1100, 94, 252, 'rare_fountain', 10, 0, 1, 0, 0, 0),
(1101, 94, 253, 'rare_stand', 10, 0, 1, 0, 0, 0),
(1102, 27, 254, 'rare_globe', 5, 0, 1, 0, 0, 0),
(1103, 94, 256, 'rare_elephant_statue*1', 10, 0, 1, 0, 0, 0),
(1104, 94, 257, 'rare_elephant_statue*2', 10, 0, 1, 0, 0, 0),
(1105, 94, 258, 'rare_fountain*1', 10, 0, 1, 0, 0, 0),
(1106, 94, 259, 'rare_fountain*2', 10, 0, 1, 0, 0, 0),
(1107, 94, 260, 'rare_fountain*3', 10, 0, 1, 0, 0, 0),
(1108, 94, 264, 'rare_parasol*1', 10, 0, 1, 0, 0, 0),
(1109, 94, 265, 'rare_parasol*2', 10, 0, 1, 0, 0, 0),
(1110, 94, 266, 'rare_parasol*3', 10, 0, 1, 0, 0, 0),
(1111, 94, 312, 'rare_parasol*0', 10, 0, 1, 0, 0, 0),
(1113, 94, 448, 'rare_snowrug', 10, 0, 1, 0, 0, 0),
(1114, 94, 668, 'rare_moonrug', 10, 0, 1, 0, 0, 0),
(1326, 94, 339, 'scifiport*9', 10, 0, 1, 0, 0, 0),
(1120, 43, 1655, 'post.it', 3, 0, 30, 0, 0, 0),
(1121, 41, 1677, 'hrella_poster_3', 3, 0, 1, 0, 0, 0),
(1122, 41, 1678, 'hrella_poster_2', 3, 0, 1, 0, 0, 0),
(1123, 41, 1679, 'hrella_poster_1', 3, 0, 1, 0, 0, 0),
(1124, 43, 104, 'pizza', 3, 0, 1, 0, 0, 0),
(1125, 43, 105, 'drinks', 3, 0, 1, 0, 0, 0),
(1133, 112, 19995, 'ads_twi_dvdr2', 3, 0, 1, 0, 0, 0),
(1127, 43, 111, 'bottle', 3, 0, 1, 0, 0, 0),
(1128, 43, 211, 'edice', 6, 0, 1, 0, 0, 0),
(1132, 112, 19994, 'ads_twi_fountn', 5, 0, 1, 0, 0, 0),
(1134, 112, 19996, 'ads_twi_roses', 4, 0, 1, 0, 0, 0),
(1135, 112, 19997, 'ads_twi_table', 4, 0, 1, 0, 0, 0),
(1136, 112, 19998, 'ads_twi_chair', 3, 0, 1, 0, 0, 0),
(1137, 112, 19999, 'ads_twi_dvdr1', 3, 0, 1, 0, 0, 0),
(1138, 112, 20000, 'ads_twi_piano', 4, 0, 1, 0, 0, 0),
(1139, 112, 20001, 'ads_twi_tower', 4, 0, 1, 0, 0, 0),
(1140, 112, 20002, 'ads_twi_toolbx', 3, 0, 1, 0, 0, 0),
(1141, 112, 20003, 'ads_twi_mist', 3, 0, 1, 0, 0, 0),
(1159, 62, 763, 'gothiccandelabra', 4, 0, 1, 0, 0, 0),
(1154, 62, 764, 'gothrailing', 3, 0, 1, 0, 0, 0),
(1152, 62, 777, 'gothic_sofa*1', 4, 0, 1, 0, 0, 0),
(1156, 62, 778, 'gothic_stool*1', 2, 0, 1, 0, 0, 0),
(1157, 62, 780, 'gothic_sofa*2', 4, 0, 1, 0, 0, 0),
(1173, 62, 790, 'gothic_stool*5', 2, 0, 1, 0, 0, 0),
(1160, 62, 762, 'gothgate', 6, 0, 1, 0, 0, 0),
(1161, 62, 765, 'goth_table', 5, 0, 1, 0, 0, 0),
(1162, 62, 776, 'gothic_chair*1', 3, 0, 1, 0, 0, 0),
(1163, 62, 779, 'gothic_chair*2', 3, 0, 1, 0, 0, 0);
INSERT INTO `catalog_items` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`, `song_id`) VALUES
(1164, 62, 781, 'gothic_stool*2', 2, 0, 1, 0, 0, 0),
(1165, 62, 782, 'gothic_chair*3', 3, 0, 1, 0, 0, 0),
(1166, 62, 783, 'gothic_sofa*3', 4, 0, 1, 0, 0, 0),
(1167, 62, 784, 'gothic_stool*3', 2, 0, 1, 0, 0, 0),
(1168, 62, 785, 'gothic_chair*4', 3, 0, 1, 0, 0, 0),
(1169, 62, 786, 'gothic_sofa*4', 4, 0, 1, 0, 0, 0),
(1170, 62, 787, 'gothic_stool*4', 2, 0, 1, 0, 0, 0),
(1171, 62, 788, 'gothic_chair*5', 4, 0, 1, 0, 0, 0),
(1172, 62, 789, 'gothic_sofa*5', 4, 0, 1, 0, 0, 0),
(1174, 62, 791, 'gothic_chair*6', 3, 0, 1, 0, 0, 0),
(1175, 62, 792, 'gothic_sofa*6', 4, 0, 1, 0, 0, 0),
(1176, 62, 793, 'gothic_stool*6', 2, 0, 1, 0, 0, 0),
(1177, 62, 821, 'gothic_carpet', 5, 0, 1, 0, 0, 0),
(1178, 62, 822, 'gothic_carpet2', 6, 0, 1, 0, 0, 0),
(1179, 62, 823, 'gothic_chair', 3, 0, 1, 0, 0, 0),
(1180, 62, 824, 'gothic_sofa', 4, 0, 1, 0, 0, 0),
(1181, 62, 825, 'gothic_stool', 2, 0, 1, 0, 0, 0),
(1182, 62, 1665, 'gothicfountain', 3, 0, 1, 0, 0, 0),
(1183, 62, 1668, 'torch', 3, 0, 1, 0, 0, 0),
(1184, 62, 1726, 'gothicfountain2', 3, 0, 1, 0, 0, 0),
(1186, 103, 1204, 'diner_tray_6', 3, 0, 1, 0, 0, 0),
(1187, 103, 1205, 'diner_tray_5', 3, 0, 1, 0, 0, 0),
(1188, 103, 1206, 'diner_tray_4', 3, 0, 1, 0, 0, 0),
(1191, 103, 1208, 'diner_tray_2', 3, 0, 1, 0, 0, 0),
(1294, 94, 398, 'pillar*1', 10, 0, 1, 0, 0, 0),
(1190, 103, 1207, 'diner_tray_3', 3, 0, 1, 0, 0, 0),
(1192, 103, 1209, 'diner_tray_1', 3, 0, 1, 0, 0, 0),
(1193, 103, 1203, 'diner_tray_7', 3, 0, 1, 0, 0, 0),
(1194, 103, 1210, 'diner_tray_0', 3, 0, 1, 0, 0, 0),
(1195, 103, 1211, 'diner_sofa_2*1', 4, 0, 1, 0, 0, 0),
(1196, 103, 1212, 'diner_sofa_2*2', 4, 0, 1, 0, 0, 0),
(1197, 103, 1213, 'diner_sofa_2*3', 4, 0, 1, 0, 0, 0),
(1198, 103, 1214, 'diner_sofa_2*4', 4, 0, 1, 0, 0, 0),
(1199, 103, 1215, 'diner_sofa_2*5', 4, 0, 1, 0, 0, 0),
(1200, 103, 1216, 'diner_sofa_2*6', 4, 0, 1, 0, 0, 0),
(1201, 103, 1217, 'diner_sofa_2*7', 4, 0, 1, 0, 0, 0),
(1202, 103, 1218, 'diner_sofa_2*8', 4, 0, 1, 0, 0, 0),
(1203, 103, 1219, 'diner_sofa_2*9', 4, 0, 1, 0, 0, 0),
(1204, 103, 1220, 'diner_shaker', 5, 0, 1, 0, 0, 0),
(1205, 103, 1221, 'diner_rug', 3, 0, 1, 0, 0, 0),
(1206, 103, 1221, 'diner_rug', 25, 0, 10, 0, 0, 0),
(1207, 103, 1222, 'diner_gumvendor*1', 3, 0, 1, 0, 0, 0),
(1208, 103, 1223, 'diner_gumvendor*2', 3, 0, 1, 0, 0, 0),
(1209, 103, 1224, 'diner_gumvendor*3', 3, 0, 1, 0, 0, 0),
(1210, 103, 1225, 'diner_gumvendor*4', 3, 0, 1, 0, 0, 0),
(1211, 103, 1226, 'diner_gumvendor*5', 3, 0, 1, 0, 0, 0),
(1212, 103, 1227, 'diner_gumvendor*6', 3, 0, 1, 0, 0, 0),
(1213, 103, 1228, 'diner_gumvendor*7', 3, 0, 1, 0, 0, 0),
(1214, 103, 1229, 'diner_gumvendor*8', 3, 0, 1, 0, 0, 0),
(1215, 103, 1230, 'diner_gumvendor*9', 3, 0, 1, 0, 0, 0),
(1216, 103, 1231, 'diner_cashreg*1', 3, 0, 1, 0, 0, 0),
(1217, 103, 1234, 'diner_cashreg*4', 3, 0, 1, 0, 0, 0),
(1218, 103, 1232, 'diner_cashreg*2', 3, 0, 1, 0, 0, 0),
(1219, 103, 1233, 'diner_cashreg*3', 3, 0, 1, 0, 0, 0),
(1220, 103, 1235, 'diner_cashreg*5', 3, 0, 1, 0, 0, 0),
(1221, 103, 1236, 'diner_cashreg*6', 3, 0, 1, 0, 0, 0),
(1222, 103, 1237, 'diner_cashreg*7', 3, 0, 1, 0, 0, 0),
(1223, 103, 1238, 'diner_cashreg*8', 3, 0, 1, 0, 0, 0),
(1224, 103, 1239, 'diner_cashreg*9', 3, 0, 1, 0, 0, 0),
(1225, 103, 1240, 'diner_table_2*1', 5, 0, 1, 0, 0, 0),
(1226, 103, 1241, 'diner_table_2*2', 5, 0, 1, 0, 0, 0),
(1227, 103, 1242, 'diner_table_2*3', 5, 0, 1, 0, 0, 0),
(1228, 103, 1243, 'diner_table_2*4', 5, 0, 1, 0, 0, 0),
(1229, 103, 1244, 'diner_table_2*5', 5, 0, 1, 0, 0, 0),
(1230, 103, 1245, 'diner_table_2*6', 5, 0, 1, 0, 0, 0),
(1231, 103, 1246, 'diner_table_2*7', 5, 0, 1, 0, 0, 0),
(1232, 103, 1247, 'diner_table_2*8', 5, 0, 1, 0, 0, 0),
(1233, 103, 1248, 'diner_table_2*9', 5, 0, 1, 0, 0, 0),
(1234, 103, 1249, 'diner_table_1*1', 3, 0, 1, 0, 0, 0),
(1235, 103, 1250, 'diner_table_1*2', 3, 0, 1, 0, 0, 0),
(1236, 103, 1251, 'diner_table_1*3', 3, 0, 1, 0, 0, 0),
(1237, 103, 1252, 'diner_table_1*4', 3, 0, 1, 0, 0, 0),
(1238, 103, 1253, 'diner_table_1*5', 3, 0, 1, 0, 0, 0),
(1239, 103, 1254, 'diner_table_1*6', 3, 0, 1, 0, 0, 0),
(1240, 103, 1255, 'diner_table_1*7', 3, 0, 1, 0, 0, 0),
(1241, 103, 1256, 'diner_table_1*8', 3, 0, 1, 0, 0, 0),
(1242, 103, 1257, 'diner_table_1*9', 3, 0, 1, 0, 0, 0),
(1243, 103, 1258, 'diner_sofa_1*1', 4, 0, 1, 0, 0, 0),
(1244, 103, 1259, 'diner_sofa_1*2', 4, 0, 1, 0, 0, 0),
(1245, 103, 1260, 'diner_sofa_1*3', 4, 0, 1, 0, 0, 0),
(1246, 103, 1261, 'diner_sofa_1*4', 4, 0, 1, 0, 0, 0),
(1247, 103, 1262, 'diner_sofa_1*5', 4, 0, 1, 0, 0, 0),
(1248, 103, 1263, 'diner_sofa_1*6', 4, 0, 1, 0, 0, 0),
(1251, 103, 1265, 'diner_sofa_1*8', 4, 0, 1, 0, 0, 0),
(1250, 103, 1264, 'diner_sofa_1*7', 4, 0, 1, 0, 0, 0),
(1252, 103, 1266, 'diner_sofa_1*9', 4, 0, 1, 0, 0, 0),
(1253, 103, 1267, 'diner_chair*1', 3, 0, 1, 0, 0, 0),
(1254, 103, 1268, 'diner_chair*2', 3, 0, 1, 0, 0, 0),
(1255, 103, 1269, 'diner_chair*3', 3, 0, 1, 0, 0, 0),
(1256, 103, 1270, 'diner_chair*4', 3, 0, 1, 0, 0, 0),
(1257, 103, 1271, 'diner_chair*5', 3, 0, 1, 0, 0, 0),
(1258, 103, 1272, 'diner_chair*6', 3, 0, 1, 0, 0, 0),
(1259, 103, 1273, 'diner_chair*7', 3, 0, 1, 0, 0, 0),
(1260, 103, 1274, 'diner_chair*8', 3, 0, 1, 0, 0, 0),
(1261, 103, 1275, 'diner_chair*9', 3, 0, 1, 0, 0, 0),
(1262, 103, 1276, 'diner_bardesk_gate*1', 6, 0, 1, 0, 0, 0),
(1263, 103, 1277, 'diner_bardesk_gate*2', 6, 0, 1, 0, 0, 0),
(1264, 103, 1278, 'diner_bardesk_gate*3', 6, 0, 1, 0, 0, 0),
(1265, 103, 1279, 'diner_bardesk_gate*4', 6, 0, 1, 0, 0, 0),
(1266, 103, 1280, 'diner_bardesk_gate*5', 6, 0, 1, 0, 0, 0),
(1267, 103, 1281, 'diner_bardesk_gate*6', 6, 0, 1, 0, 0, 0),
(2119, 7, 20060, 'DEAL_HC_3', 500, 0, 6, 0, 0, 0),
(1269, 103, 1282, 'diner_bardesk_gate*7', 6, 0, 1, 0, 0, 0),
(1270, 103, 1283, 'diner_bardesk_gate*8', 6, 0, 1, 0, 0, 0),
(1271, 103, 1284, 'diner_bardesk_gate*9', 6, 0, 1, 0, 0, 0),
(1272, 103, 1285, 'diner_bardesk_corner*1', 3, 0, 1, 0, 0, 0),
(1273, 103, 1286, 'diner_bardesk_corner*2', 3, 0, 1, 0, 0, 0),
(1274, 103, 1287, 'diner_bardesk_corner*3', 3, 0, 1, 0, 0, 0),
(1275, 103, 1288, 'diner_bardesk_corner*4', 3, 0, 1, 0, 0, 0),
(1276, 103, 1289, 'diner_bardesk_corner*6', 3, 0, 1, 0, 0, 0),
(1277, 103, 1290, 'diner_bardesk_corner*7', 3, 0, 1, 0, 0, 0),
(1278, 103, 1291, 'diner_bardesk_corner*8', 3, 0, 1, 0, 0, 0),
(1279, 103, 1292, 'diner_bardesk_corner*9', 3, 0, 1, 0, 0, 0),
(1280, 103, 1293, 'diner_bardesk*1', 3, 0, 1, 0, 0, 0),
(1281, 103, 1294, 'diner_bardesk*2', 3, 0, 1, 0, 0, 0),
(1282, 103, 1295, 'diner_bardesk*3', 3, 0, 1, 0, 0, 0),
(1283, 103, 1296, 'diner_bardesk*4', 3, 0, 1, 0, 0, 0),
(1284, 103, 1297, 'diner_bardesk*5', 3, 0, 1, 0, 0, 0),
(1285, 103, 1298, 'diner_bardesk*6', 3, 0, 1, 0, 0, 0),
(1286, 103, 1299, 'diner_bardesk*7', 3, 0, 1, 0, 0, 0),
(1287, 103, 1300, 'diner_bardesk*8', 3, 0, 1, 0, 0, 0),
(1288, 103, 1301, 'diner_bardesk*9', 3, 0, 1, 0, 0, 0),
(1289, 103, 1708, 'window_diner2', 3, 0, 1, 0, 0, 0),
(1290, 103, 1709, 'window_diner', 4, 0, 1, 0, 0, 0),
(1291, 103, 1710, 'diner_walltable', 2, 0, 1, 0, 0, 0),
(1292, 103, 1782, 'diner_poster', 3, 0, 1, 0, 0, 0),
(1295, 94, 399, 'pillar*9', 10, 0, 1, 0, 0, 0),
(1296, 94, 400, 'pillar*0', 10, 0, 1, 0, 0, 0),
(1297, 94, 401, 'pillar*8', 10, 0, 1, 0, 0, 0),
(1298, 94, 402, 'pillar*2', 10, 0, 1, 0, 0, 0),
(1299, 94, 403, 'pillar*5', 10, 0, 1, 0, 0, 0),
(1300, 94, 404, 'pillar*4', 10, 0, 1, 0, 0, 0),
(1301, 94, 405, 'pillar*7', 10, 0, 1, 0, 0, 0),
(1302, 94, 406, 'pillar*3', 10, 0, 1, 0, 0, 0),
(1303, 94, 388, 'wooden_screen*1', 10, 0, 1, 0, 0, 0),
(1304, 94, 389, 'wooden_screen*2', 10, 0, 1, 0, 0, 0),
(1305, 94, 390, 'wooden_screen*7', 10, 0, 1, 0, 0, 0),
(1306, 94, 391, 'wooden_screen*0', 10, 0, 1, 0, 0, 0),
(1307, 94, 392, 'wooden_screen*8', 10, 0, 1, 0, 0, 0),
(1308, 94, 393, 'wooden_screen*5', 10, 0, 1, 0, 0, 0),
(1309, 94, 394, 'wooden_screen*9', 10, 0, 1, 0, 0, 0),
(1310, 94, 395, 'wooden_screen*4', 10, 0, 1, 0, 0, 0),
(1311, 94, 396, 'wooden_screen*6', 10, 0, 1, 0, 0, 0),
(1312, 94, 397, 'wooden_screen*3', 10, 0, 1, 0, 0, 0),
(1313, 94, 417, 'rare_icecream*1', 10, 0, 1, 0, 0, 0),
(1314, 94, 418, 'rare_icecream*7', 10, 0, 1, 0, 0, 0),
(1315, 94, 419, 'rare_icecream*8', 10, 0, 1, 0, 0, 0),
(1316, 94, 420, 'rare_icecream*2', 10, 0, 1, 0, 0, 0),
(1317, 94, 421, 'rare_icecream*6', 10, 0, 1, 0, 0, 0),
(1318, 94, 422, 'rare_icecream*9', 10, 0, 1, 0, 0, 0),
(1319, 94, 423, 'rare_icecream*3', 10, 0, 1, 0, 0, 0),
(1320, 94, 424, 'rare_icecream*0', 10, 0, 1, 0, 0, 0),
(1321, 94, 425, 'rare_icecream*4', 10, 0, 1, 0, 0, 0),
(1322, 94, 426, 'rare_icecream*5', 10, 0, 1, 0, 0, 0),
(1323, 95, 892, 'rare_icecream_campaign', 10, 0, 1, 0, 0, 0),
(1324, 95, 1140, 'calippo', 10, 0, 1, 0, 0, 0),
(1325, 94, 338, 'scifiport*0', 10, 0, 1, 0, 0, 0),
(1327, 94, 340, 'scifiport*8', 10, 0, 1, 0, 0, 0),
(1328, 94, 341, 'scifiport*7', 10, 0, 1, 0, 0, 0),
(1329, 94, 342, 'scifiport*6', 10, 0, 1, 0, 0, 0),
(1330, 94, 343, 'scifiport*5', 10, 0, 1, 0, 0, 0),
(1331, 94, 344, 'scifiport*4', 10, 0, 1, 0, 0, 0),
(1332, 94, 345, 'scifiport*3', 10, 0, 1, 0, 0, 0),
(1333, 94, 346, 'scifiport*2', 10, 0, 1, 0, 0, 0),
(1334, 94, 347, 'scifiport*1', 10, 0, 1, 0, 0, 0),
(1335, 94, 348, 'scifirocket*9', 10, 0, 1, 0, 0, 0),
(1336, 94, 349, 'scifirocket*8', 10, 0, 1, 0, 0, 0),
(1337, 94, 350, 'scifirocket*7', 10, 0, 1, 0, 0, 0),
(1338, 94, 351, 'scifirocket*6', 10, 0, 1, 0, 0, 0),
(1339, 94, 352, 'scifirocket*5', 10, 0, 1, 0, 0, 0),
(1340, 94, 353, 'scifirocket*4', 10, 0, 1, 0, 0, 0),
(1341, 94, 354, 'scifirocket*3', 10, 0, 1, 0, 0, 0),
(1342, 94, 355, 'scifirocket*2', 10, 0, 1, 0, 0, 0),
(1343, 94, 356, 'scifirocket*1', 10, 0, 1, 0, 0, 0),
(1344, 94, 357, 'scifirocket*0', 10, 0, 1, 0, 0, 0),
(1345, 94, 358, 'scifidoor*10', 10, 0, 1, 0, 0, 0),
(1346, 94, 359, 'scifidoor*9', 10, 0, 1, 0, 0, 0),
(1347, 94, 360, 'scifidoor*8', 10, 0, 1, 0, 0, 0),
(1348, 94, 361, 'scifidoor*7', 10, 0, 1, 0, 0, 0),
(1349, 94, 362, 'scifidoor*6', 10, 0, 1, 0, 0, 0),
(1350, 94, 363, 'scifidoor*5', 10, 0, 1, 0, 0, 0),
(1351, 94, 364, 'scifidoor*4', 10, 0, 1, 0, 0, 0),
(1352, 94, 365, 'scifidoor*3', 10, 0, 1, 0, 0, 0),
(1353, 94, 367, 'scifidoor*2', 10, 0, 1, 0, 0, 0),
(1354, 94, 366, 'scifidoor*2', 10, 0, 1, 0, 0, 0),
(1355, 27, 186, 'menorah', 3, 0, 1, 0, 0, 0),
(1356, 43, 188, 'ham', 3, 0, 1, 0, 0, 0),
(1357, 27, 189, 'turkey', 3, 0, 1, 0, 0, 0),
(1358, 27, 191, 'house', 3, 0, 1, 0, 0, 0),
(1359, 43, 196, 'ham2', 2, 0, 1, 0, 0, 0),
(1360, 27, 197, 'wcandleset', 3, 0, 1, 0, 0, 0),
(1361, 43, 205, 'habbocake', 5, 0, 1, 0, 0, 0),
(1362, 39, 204, 'giftflowers', 4, 0, 1, 0, 0, 0),
(1365, 8, 239, 'chair_plasto*14', 3, 0, 1, 0, 0, 0),
(1364, 8, 212, 'club_sofa', 4, 0, 1, 0, 0, 0),
(1366, 8, 240, 'table_plasto_4leg*14', 4, 0, 1, 0, 0, 0),
(1367, 8, 246, 'edicehc', 5, 0, 1, 0, 0, 0),
(1368, 8, 249, 'hcsohva', 10, 0, 1, 0, 0, 0),
(1369, 8, 250, 'hcamme', 6, 0, 1, 0, 0, 0),
(1370, 8, 313, 'hc_lmp', 4, 0, 1, 0, 0, 0),
(1371, 8, 314, 'hc_tbl', 6, 0, 1, 0, 0, 0),
(1372, 8, 315, 'hc_chr', 5, 0, 1, 0, 0, 0),
(1373, 8, 316, 'hc_dsk', 5, 0, 1, 0, 0, 0),
(1374, 8, 760, 'hc_crpt', 4, 0, 1, 0, 0, 0),
(1375, 8, 761, 'hc_tv', 5, 0, 1, 0, 0, 0),
(1376, 8, 766, 'hc_bkshlf', 6, 0, 1, 0, 0, 0),
(1377, 8, 767, 'hc_btlr', 4, 0, 1, 0, 0, 0),
(1378, 8, 768, 'hc_crtn', 4, 0, 1, 0, 0, 0),
(1379, 8, 769, 'hc_djset', 5, 0, 1, 0, 0, 0),
(1380, 8, 770, 'hc_frplc', 6, 0, 1, 0, 0, 0),
(1381, 8, 771, 'hc_lmpst', 3, 0, 1, 0, 0, 0),
(1382, 8, 772, 'hc_machine', 5, 0, 1, 0, 0, 0),
(1383, 8, 773, 'hc_rllr', 7, 0, 1, 0, 0, 0),
(1384, 8, 774, 'hc_rntgn', 3, 0, 1, 0, 0, 0),
(1385, 8, 775, 'hc_trll', 3, 0, 1, 0, 0, 0),
(1387, 8, 1314, 'hcc_shelf', 3, 0, 1, 0, 0, 0),
(1388, 8, 1315, 'hcc_sofa', 3, 0, 1, 0, 0, 0),
(1389, 8, 1316, 'hcc_minibar', 5, 0, 1, 0, 0, 0),
(1390, 8, 1317, 'hcc_chair', 3, 0, 1, 0, 0, 0),
(1391, 8, 1321, 'hcc_stool', 2, 0, 1, 0, 0, 0),
(1392, 8, 1322, 'hcc_sofachair', 4, 0, 1, 0, 0, 0),
(1393, 8, 1323, 'hcc_crnr', 3, 0, 1, 0, 0, 0),
(1394, 8, 1324, 'hcc_dvdr', 3, 0, 1, 0, 0, 0),
(1398, 36, 8, 'table_plasto_4leg', 3, 0, 1, 0, 0, 0),
(1396, 8, 1666, 'hc_wall_lamp', 3, 0, 1, 0, 0, 0),
(1399, 36, 9, 'table_plasto_round', 3, 0, 1, 0, 0, 0),
(1400, 36, 10, 'table_plasto_bigsquare', 3, 0, 1, 0, 0, 0),
(1401, 36, 22, 'chair_plasty', 3, 0, 1, 0, 0, 0),
(1402, 36, 23, 'chair_plasto', 3, 0, 1, 0, 0, 0),
(1403, 36, 24, 'table_plasto_square', 3, 0, 1, 0, 0, 0),
(1404, 36, 47, 'table_plasto_4leg*1', 3, 0, 1, 0, 0, 0),
(1405, 36, 48, 'table_plasto_bigsquare*1', 3, 0, 1, 0, 0, 0),
(1406, 36, 49, 'table_plasto_round*1', 3, 0, 1, 0, 0, 0),
(1407, 36, 50, 'table_plasto_square*1', 3, 0, 1, 0, 0, 0),
(1408, 36, 51, 'chair_plasto*1', 3, 0, 1, 0, 0, 0),
(1409, 36, 54, 'table_plasto_4leg*2', 3, 0, 1, 0, 0, 0),
(1410, 36, 55, 'table_plasto_bigsquare*2', 3, 0, 1, 0, 0, 0),
(1411, 36, 56, 'table_plasto_round*2', 3, 0, 1, 0, 0, 0),
(1412, 36, 57, 'table_plasto_square*2', 3, 0, 1, 0, 0, 0),
(1413, 36, 58, 'chair_plasto*2', 3, 0, 1, 0, 0, 0),
(1414, 36, 61, 'table_plasto_4leg*3', 3, 0, 1, 0, 0, 0),
(1415, 36, 62, 'table_plasto_bigsquare*3', 3, 0, 1, 0, 0, 0),
(1416, 36, 63, 'table_plasto_round*3', 3, 0, 1, 0, 0, 0),
(1417, 36, 64, 'table_plasto_square*3', 3, 0, 1, 0, 0, 0),
(1418, 36, 65, 'chair_plasto*3', 3, 0, 1, 0, 0, 0),
(1419, 36, 68, 'table_plasto_4leg*4', 3, 0, 1, 0, 0, 0),
(1420, 36, 71, 'table_plasto_square*4', 3, 0, 1, 0, 0, 0),
(1421, 36, 72, 'chair_plasto*4', 3, 0, 1, 0, 0, 0),
(1422, 36, 78, 'table_plasto_4leg*5', 3, 0, 1, 0, 0, 0),
(1423, 36, 79, 'table_plasto_bigsquare*5', 3, 0, 1, 0, 0, 0),
(1424, 36, 80, 'table_plasto_round*5', 3, 0, 1, 0, 0, 0),
(1425, 36, 81, 'table_plasto_square*5', 3, 0, 1, 0, 0, 0),
(1426, 36, 82, 'chair_plasto*5', 3, 0, 1, 0, 0, 0),
(1427, 36, 83, 'table_plasto_4leg*6', 3, 0, 1, 0, 0, 0),
(1428, 36, 84, 'table_plasto_bigsquare*6', 3, 0, 1, 0, 0, 0),
(1429, 36, 85, 'table_plasto_round*6', 3, 0, 1, 0, 0, 0),
(1430, 36, 86, 'table_plasto_square*6', 3, 0, 1, 0, 0, 0),
(1431, 36, 87, 'chair_plasto*6', 3, 0, 1, 0, 0, 0),
(1432, 36, 88, 'table_plasto_4leg*7', 3, 0, 1, 0, 0, 0),
(1433, 36, 89, 'table_plasto_bigsquare*7', 3, 0, 1, 0, 0, 0),
(1434, 36, 90, 'table_plasto_round*7', 3, 0, 1, 0, 0, 0),
(1435, 36, 91, 'table_plasto_square*7', 3, 0, 1, 0, 0, 0),
(1436, 36, 92, 'chair_plasto*7', 3, 0, 1, 0, 0, 0),
(1437, 36, 93, 'table_plasto_4leg*8', 3, 0, 1, 0, 0, 0),
(1438, 36, 94, 'table_plasto_bigsquare*8', 3, 0, 1, 0, 0, 0),
(1439, 36, 95, 'table_plasto_round*8', 3, 0, 1, 0, 0, 0),
(1440, 36, 96, 'table_plasto_square*8', 3, 0, 1, 0, 0, 0),
(1441, 36, 97, 'chair_plasto*8', 3, 0, 1, 0, 0, 0),
(1442, 36, 98, 'table_plasto_4leg*9', 3, 0, 1, 0, 0, 0),
(1443, 36, 99, 'table_plasto_bigsquare*9', 3, 0, 1, 0, 0, 0),
(1444, 36, 100, 'table_plasto_round*9', 3, 0, 1, 0, 0, 0),
(1445, 36, 101, 'chair_plasto*9', 3, 0, 1, 0, 0, 0),
(1446, 36, 233, 'chair_plasto*10', 3, 0, 1, 0, 0, 0),
(1447, 36, 234, 'chair_plasto*11', 3, 0, 1, 0, 0, 0),
(1448, 36, 237, 'chair_plasto*12', 3, 0, 1, 0, 0, 0),
(1449, 36, 238, 'chair_plasto*13', 3, 0, 1, 0, 0, 0),
(1450, 36, 276, 'table_plasto_4leg*10', 3, 0, 1, 0, 0, 0),
(1451, 36, 277, 'table_plasto_4leg*15', 3, 0, 1, 0, 0, 0),
(1452, 36, 278, 'table_plasto_bigsquare*14', 3, 0, 1, 0, 0, 0),
(1453, 36, 279, 'table_plasto_bigsquare*15', 3, 0, 1, 0, 0, 0),
(1454, 36, 280, 'table_plasto_round*14', 3, 0, 1, 0, 0, 0),
(1455, 36, 281, 'table_plasto_round*15', 3, 0, 1, 0, 0, 0),
(1456, 36, 282, 'table_plasto_square*14', 3, 0, 1, 0, 0, 0),
(1457, 36, 283, 'table_plasto_square*15', 3, 0, 1, 0, 0, 0),
(1458, 36, 284, 'chair_plasto*15', 3, 0, 1, 0, 0, 0),
(1459, 36, 290, 'chair_plasto*16', 3, 0, 1, 0, 0, 0),
(1460, 36, 291, 'table_plasto_4leg*16', 3, 0, 1, 0, 0, 0),
(1462, 40, 17, 'doormat_love', 1, 0, 1, 0, 0, 0),
(1463, 40, 18, 'doormat_plain', 3, 0, 1, 0, 0, 0),
(1464, 40, 53, 'doormat_plain*1', 1, 0, 1, 0, 0, 0),
(1465, 40, 59, 'doormat_plain*2', 1, 0, 1, 0, 0, 0),
(1466, 40, 67, 'doormat_plain*3', 1, 0, 1, 0, 0, 0),
(1467, 40, 74, 'doormat_plain*4', 1, 0, 1, 0, 0, 0),
(1468, 40, 75, 'doormat_plain*6', 3, 0, 1, 0, 0, 0),
(1469, 40, 76, 'doormat_plain*5', 1, 0, 1, 0, 0, 0),
(1471, 95, 27, 'bed_trad_one', 10, 0, 1, 0, 0, 0),
(1472, 95, 28, 'bed_trad', 10, 0, 1, 0, 0, 0),
(1473, 35, 35, 'shelves_armas', 4, 0, 1, 0, 0, 0),
(1474, 32, 33, 'bed_budget_one', 3, 0, 1, 0, 0, 0),
(1475, 32, 34, 'bed_budget', 4, 0, 1, 0, 0, 0),
(1476, 32, 139, 'bed_budgetb_one', 3, 0, 1, 0, 0, 0),
(1477, 32, 140, 'bed_budgetb', 4, 0, 1, 0, 0, 0),
(1478, 32, 947, 'bed_budget*1', 4, 0, 1, 0, 0, 0),
(1479, 32, 956, 'bed_budget_one*1', 3, 0, 1, 0, 0, 0),
(1482, 36, 103, 'chair_plasty*1', 3, 0, 1, 0, 0, 0),
(1483, 36, 106, 'chair_plasty*2', 3, 0, 1, 0, 0, 0),
(1484, 36, 107, 'chair_plasty*3', 3, 0, 1, 0, 0, 0),
(1485, 36, 108, 'chair_plasty*4', 3, 0, 1, 0, 0, 0),
(1486, 36, 128, 'chair_plasty*5', 3, 0, 1, 0, 0, 0),
(1487, 36, 132, 'chair_plasty*6', 3, 0, 1, 0, 0, 0),
(1488, 36, 285, 'chair_plasty*7', 3, 0, 1, 0, 0, 0),
(1489, 36, 286, 'chair_plasty*8', 3, 0, 1, 0, 0, 0),
(1490, 36, 287, 'chair_plasty*9', 3, 0, 1, 0, 0, 0),
(1491, 36, 288, 'chair_plasty*10', 3, 0, 1, 0, 0, 0),
(1492, 36, 289, 'chair_plasty*11', 3, 0, 1, 0, 0, 0),
(1564, 94, 370, 'pillow*0', 10, 0, 1, 0, 0, 0),
(1496, 35, 217, 'divider_arm1', 3, 0, 1, 0, 0, 0),
(1497, 35, 218, 'divider_arm2', 3, 0, 1, 0, 0, 0),
(1498, 35, 219, 'divider_arm3', 6, 0, 1, 0, 0, 0),
(1499, 94, 213, 'a0 prize1', 10, 0, 1, 0, 0, 0),
(1500, 94, 214, 'a0 prize2', 10, 0, 1, 0, 0, 0),
(1501, 94, 215, 'a0 prize3', 10, 0, 1, 0, 0, 0),
(1502, 55, 220, 'divider_nor1', 3, 0, 1, 0, 0, 0),
(1503, 55, 222, 'divider_nor2', 3, 0, 1, 0, 0, 0),
(2099, 95, 20043, 'party_lights', 10, 0, 1, 0, 0, 0),
(1505, 55, 224, 'divider_nor3', 6, 0, 1, 0, 0, 0),
(1506, 55, 462, 'divider_nor4*4', 3, 0, 1, 0, 0, 0),
(1507, 55, 510, 'divider_nor1*2', 3, 0, 1, 0, 0, 0),
(1508, 55, 511, 'divider_nor1*3', 3, 0, 1, 0, 0, 0),
(1509, 55, 512, 'divider_nor1*4', 3, 0, 1, 0, 0, 0),
(1510, 55, 513, 'divider_nor1*5', 3, 0, 1, 0, 0, 0),
(1511, 55, 514, 'divider_nor1*6', 3, 0, 1, 0, 0, 0),
(1512, 55, 515, 'divider_nor1*7', 3, 0, 1, 0, 0, 0),
(1513, 55, 516, 'divider_nor1*8', 3, 0, 1, 0, 0, 0),
(1514, 55, 517, 'divider_nor1*8', 3, 0, 1, 0, 0, 0),
(1515, 55, 641, 'divider_nor3*2', 6, 0, 1, 0, 0, 0),
(1516, 55, 642, 'divider_nor3*3', 6, 0, 1, 0, 0, 0),
(1517, 55, 643, 'divider_nor3*4', 3, 0, 1, 0, 0, 0),
(1518, 55, 644, 'divider_nor3*5', 6, 0, 1, 0, 0, 0),
(1519, 55, 645, 'divider_nor3*6', 6, 0, 1, 0, 0, 0),
(1520, 55, 646, 'divider_nor3*7', 6, 0, 1, 0, 0, 0),
(1521, 55, 647, 'divider_nor3*8', 6, 0, 1, 0, 0, 0),
(1522, 55, 648, 'divider_nor3*9', 6, 0, 1, 0, 0, 0),
(1523, 55, 649, 'divider_nor2*2', 3, 0, 1, 0, 0, 0),
(1524, 55, 650, 'divider_nor2*3', 3, 0, 1, 0, 0, 0),
(1525, 55, 651, 'divider_nor2*4', 3, 0, 1, 0, 0, 0),
(1526, 55, 652, 'divider_nor2*5', 3, 0, 1, 0, 0, 0),
(1527, 55, 653, 'divider_nor2*6', 3, 0, 1, 0, 0, 0),
(1528, 55, 654, 'divider_nor2*7', 3, 0, 1, 0, 0, 0),
(1529, 55, 655, 'divider_nor2*8', 3, 0, 1, 0, 0, 0),
(1530, 55, 656, 'divider_nor2*9', 3, 0, 1, 0, 0, 0),
(1531, 55, 684, 'divider_nor4*2', 3, 0, 1, 0, 0, 0),
(1532, 55, 685, 'divider_nor4*3', 3, 0, 1, 0, 0, 0),
(1533, 55, 686, 'divider_nor4*5', 3, 0, 1, 0, 0, 0),
(1534, 55, 687, 'divider_nor4*6', 3, 0, 1, 0, 0, 0),
(1535, 55, 688, 'divider_nor4*7', 3, 0, 1, 0, 0, 0),
(1536, 55, 689, 'divider_nor4*8', 3, 0, 1, 0, 0, 0),
(1537, 55, 690, 'divider_nor4*9', 3, 0, 1, 0, 0, 0),
(1538, 55, 691, 'divider_nor5*2', 3, 0, 1, 0, 0, 0),
(1539, 55, 692, 'divider_nor5*3', 3, 0, 1, 0, 0, 0),
(1540, 55, 693, 'divider_nor5*4', 3, 0, 1, 0, 0, 0),
(1541, 55, 694, 'divider_nor5*5', 3, 0, 1, 0, 0, 0),
(1542, 55, 695, 'divider_nor5*7', 3, 0, 1, 0, 0, 0),
(1543, 55, 696, 'divider_nor5*8', 3, 0, 1, 0, 0, 0),
(1544, 55, 697, 'divider_nor5*9', 3, 0, 1, 0, 0, 0),
(1545, 55, 698, 'divider_nor5', 3, 0, 1, 0, 0, 0),
(1546, 55, 699, 'divider_nor4', 3, 0, 1, 0, 0, 0),
(1547, 94, 226, 'typingmachine', 10, 0, 1, 0, 0, 0),
(1548, 27, 230, 'joulutahti', 10, 0, 1, 0, 0, 0),
(1549, 94, 231, 'hyacinth1', 10, 0, 1, 0, 0, 0),
(1550, 94, 232, 'hyacinth2', 10, 0, 1, 0, 0, 0),
(1551, 30, 235, 'bardeskcorner_polyfon*12', 3, 0, 1, 0, 0, 0),
(1552, 20, 236, 'bardeskcorner_polyfon*13', 3, 0, 1, 0, 0, 0),
(1553, 8, 241, 'mocchamaster', 5, 0, 1, 0, 0, 0),
(1554, 94, 247, 'rare_daffodil_rug', 10000, 5000, 3, 0, 0, 0),
(1555, 27, 267, 'tree1', 3, 0, 1, 0, 0, 0),
(2101, 71, 20047, 'rela_stick', 3, 0, 1, 0, 0, 0),
(1557, 27, 269, 'wcandle', 3, 0, 1, 0, 0, 0),
(1558, 27, 272, 'house2', 3, 0, 1, 0, 0, 0),
(1559, 94, 275, 'md_limukaappi', 10, 0, 1, 0, 0, 0),
(1587, 94, 378, 'marquee*1', 10, 0, 1, 0, 0, 0),
(1561, 8, 294, 'doorD', 6, 0, 1, 0, 0, 0),
(1562, 94, 368, 'pillow*5', 10, 0, 1, 0, 0, 0),
(1563, 94, 369, 'pillow*8', 10, 0, 1, 0, 0, 0),
(1565, 94, 371, 'pillow*1', 10, 0, 1, 0, 0, 0),
(1566, 94, 372, 'pillow*2', 10, 0, 1, 0, 0, 0),
(1567, 94, 373, 'pillow*7', 10, 0, 1, 0, 0, 0),
(1568, 94, 374, 'pillow*9', 10, 0, 1, 0, 0, 0),
(1569, 94, 375, 'pillow*4', 10, 0, 1, 0, 0, 0),
(1570, 94, 376, 'pillow*6', 10, 0, 1, 0, 0, 0),
(1571, 94, 377, 'pillow*3', 10, 0, 1, 0, 0, 0),
(1572, 95, 1410, 'ads_ob_pillow', 10, 0, 1, 0, 0, 0),
(1573, 94, 379, 'marquee*2', 10, 0, 1, 0, 0, 0),
(1574, 94, 407, 'rare_dragonlamp*4', 10, 0, 1, 0, 0, 0),
(1575, 94, 408, 'rare_dragonlamp*0', 10, 0, 1, 0, 0, 0),
(1576, 94, 409, 'rare_dragonlamp*5', 10, 0, 1, 0, 0, 0),
(1577, 94, 410, 'rare_dragonlamp*2', 10, 0, 1, 0, 0, 0),
(1578, 94, 411, 'rare_dragonlamp*8', 10, 0, 1, 0, 0, 0),
(1579, 94, 412, 'rare_dragonlamp*9', 10, 0, 1, 0, 0, 0),
(1580, 94, 413, 'rare_dragonlamp*7', 10, 0, 1, 0, 0, 0),
(1581, 94, 414, 'rare_dragonlamp*6', 10, 0, 1, 0, 0, 0),
(1582, 94, 415, 'rare_dragonlamp*1', 10, 0, 1, 0, 0, 0),
(1583, 94, 416, 'rare_dragonlamp*3', 10, 0, 1, 0, 0, 0),
(1584, 94, 430, 'rare_fan*3', 10, 0, 1, 0, 0, 0),
(1585, 58, 1411, 'lostc_merdragon', 6, 0, 1, 0, 0, 0),
(1588, 94, 380, 'marquee*7', 10, 0, 1, 0, 0, 0),
(1589, 94, 382, 'marquee*8', 10, 0, 1, 0, 0, 0),
(1590, 94, 383, 'marquee*9', 10, 0, 1, 0, 0, 0),
(1591, 94, 384, 'marquee*5', 10, 0, 1, 0, 0, 0),
(1592, 94, 385, 'marquee*4', 10, 0, 1, 0, 0, 0),
(1593, 94, 386, 'marquee*6', 10, 0, 1, 0, 0, 0),
(1594, 94, 387, 'marquee*3', 10, 0, 1, 0, 0, 0),
(1595, 94, 381, 'marquee*10', 10, 0, 1, 0, 0, 0),
(1596, 94, 427, 'rare_fan*7', 10, 0, 1, 0, 0, 0),
(1598, 94, 428, 'rare_fan*6', 10, 0, 1, 0, 0, 0),
(1599, 94, 429, 'rare_fan*9', 10, 0, 1, 0, 0, 0),
(1600, 94, 430, 'rare_fan*3', 10, 0, 1, 0, 0, 0),
(1601, 94, 431, 'rare_fan*0', 10, 0, 1, 0, 0, 0),
(1602, 94, 432, 'rare_fan*4', 10, 0, 1, 0, 0, 0),
(1603, 94, 433, 'rare_fan*5', 10, 0, 1, 0, 0, 0),
(1604, 94, 434, 'rare_fan*1', 10, 0, 1, 0, 0, 0),
(1605, 94, 435, 'rare_fan*8', 10, 0, 1, 0, 0, 0),
(1606, 94, 436, 'rare_fan*2', 10, 0, 1, 0, 0, 0),
(1607, 95, 1589, 'ads_calip_fan', 10, 0, 1, 0, 0, 0),
(1608, 62, 1667, 'industrialfan', 4, 0, 1, 0, 0, 0),
(1609, 57, 449, 'cn_lamp', 5, 0, 1, 0, 0, 0),
(1610, 57, 450, 'cn_sofa', 4, 0, 1, 0, 0, 0),
(1611, 95, 1302, 'ads_dave_cns', 10, 0, 1, 0, 0, 0),
(1612, 94, 468, 'rubberchair*1', 10, 0, 1, 0, 0, 0),
(1613, 94, 469, 'rubberchair*2', 10, 0, 1, 0, 0, 0),
(1614, 94, 470, 'rubberchair*3', 10, 0, 1, 0, 0, 0),
(1615, 94, 471, 'rubberchair*4', 10, 0, 1, 0, 0, 0),
(1616, 94, 472, 'rubberchair*5', 10, 0, 1, 0, 0, 0),
(1617, 94, 473, 'rubberchair*6', 10, 0, 1, 0, 0, 0),
(1618, 94, 477, 'rubberchair*7', 10, 0, 1, 0, 0, 0),
(1619, 94, 478, 'rubberchair*8', 10, 0, 1, 0, 0, 0),
(1620, 94, 463, 'traffic_light*1', 10, 0, 1, 0, 0, 0),
(1621, 94, 464, 'traffic_light*2', 10, 0, 1, 0, 0, 0),
(1622, 94, 465, 'traffic_light*3', 10, 0, 1, 0, 0, 0),
(1623, 94, 466, 'traffic_light*4', 10, 0, 1, 0, 0, 0),
(1624, 94, 467, 'traffic_light*6', 10, 0, 1, 0, 0, 0),
(1625, 94, 683, 'traffic_light*5', 10, 0, 1, 0, 0, 0),
(1626, 94, 474, 'barrier*1', 10, 0, 1, 0, 0, 0),
(1627, 94, 475, 'barrier*2', 10, 0, 1, 0, 0, 0),
(1628, 94, 476, 'barrier*3', 10, 0, 1, 0, 0, 0),
(1629, 94, 667, 'sandrug', 10, 0, 1, 0, 0, 0),
(1630, 94, 671, 'sleepingbag*1', 10, 0, 1, 0, 0, 0),
(1631, 94, 672, 'sleepingbag*2', 10, 0, 1, 0, 0, 0),
(1632, 94, 673, 'sleepingbag*3', 10, 0, 1, 0, 0, 0),
(1633, 94, 674, 'sleepingbag*4', 10, 0, 1, 0, 0, 0),
(1634, 94, 676, 'sleepingbag*7', 10, 0, 1, 0, 0, 0),
(1635, 94, 677, 'sleepingbag*9', 10, 0, 1, 0, 0, 0),
(1636, 94, 678, 'sleepingbag*5', 10, 0, 1, 0, 0, 0),
(1637, 94, 679, 'sleepingbag*10', 10, 0, 1, 0, 0, 0),
(1638, 94, 680, 'sleepingbag*6', 10, 0, 1, 0, 0, 0),
(1639, 94, 681, 'sleepingbag*8', 10, 0, 1, 0, 0, 0),
(1640, 13, 755, 'CF_10_coin_gold', 10, 0, 1, 0, 0, 0),
(1641, 13, 756, 'CF_1_coin_bronze', 1, 0, 1, 0, 0, 0),
(1642, 13, 757, 'CF_20_moneybag', 20, 0, 1, 0, 0, 0),
(1643, 12, 758, 'CF_50_goldbar', 50, 0, 1, 0, 0, 0),
(1644, 13, 759, 'CF_5_coin_silver', 5, 0, 1, 0, 0, 0),
(1645, 65, 831, 'theatre_seat', 5, 0, 1, 0, 0, 0),
(1646, 32, 938, 'chair_basic*1', 3, 0, 1, 0, 0, 0),
(1647, 32, 945, 'chair_basic*8', 3, 0, 1, 0, 0, 0),
(1648, 40, 1009, 'carpet_soft_tut', 2, 0, 1, 0, 0, 0),
(1649, 66, 1025, 'hal_cauldron', 5, 0, 1, 0, 0, 0),
(1650, 66, 1026, 'hal_grave', 4, 0, 1, 0, 0, 0),
(1651, 66, 1318, 'det_divider', 3, 0, 1, 0, 0, 0),
(1652, 66, 1320, 'det_body', 5, 0, 1, 0, 0, 0),
(1653, 66, 1719, 'det_bhole', 2, 0, 1, 0, 0, 0),
(1654, 5, 1719, 'det_bhole', 5, 0, 3, 0, 0, 0),
(1655, 121, 794, 'sound_machine', 5, 0, 1, 0, 0, 0),
(1656, 121, 859, 'sound_machine*1', 5, 0, 1, 0, 0, 0),
(1657, 121, 861, 'sound_machine*2', 5, 0, 1, 0, 0, 0),
(1658, 121, 862, 'sound_machine*3', 5, 0, 1, 0, 0, 0),
(1659, 121, 863, 'sound_machine*4', 5, 0, 1, 0, 0, 0),
(1660, 121, 864, 'sound_machine*5', 5, 0, 1, 0, 0, 0),
(1661, 121, 865, 'sound_machine*6', 5, 0, 1, 0, 0, 0),
(1662, 121, 866, 'sound_machine*7', 5, 0, 1, 0, 0, 0),
(1663, 121, 990, 'sound_machine_pro', 5, 0, 1, 0, 0, 0),
(1664, 122, 850, 'sound_set_1', 3, 0, 1, 0, 0, 0),
(1665, 122, 851, 'sound_set_2', 3, 0, 1, 0, 0, 0),
(1666, 122, 852, 'sound_set_3', 3, 0, 1, 0, 0, 0),
(1667, 122, 853, 'sound_set_4', 3, 0, 1, 0, 0, 0),
(1668, 122, 854, 'sound_set_5', 3, 0, 1, 0, 0, 0),
(1669, 122, 855, 'sound_set_6', 3, 0, 1, 0, 0, 0),
(1670, 122, 856, 'sound_set_7', 3, 0, 1, 0, 0, 0),
(1671, 122, 857, 'sound_set_8', 3, 0, 1, 0, 0, 0),
(1672, 122, 858, 'sound_set_9', 3, 0, 1, 0, 0, 0),
(1673, 122, 872, 'sound_set_27', 3, 0, 1, 0, 0, 0),
(1674, 122, 873, 'sound_set_26', 3, 0, 1, 0, 0, 0),
(1675, 122, 871, 'sound_set_28', 3, 0, 1, 0, 0, 0),
(1676, 122, 874, 'sound_set_25', 3, 0, 1, 0, 0, 0),
(1677, 122, 875, 'sound_set_24', 3, 0, 1, 0, 0, 0),
(1678, 122, 876, 'sound_set_23', 3, 0, 1, 0, 0, 0),
(1679, 122, 878, 'sound_set_22', 3, 0, 1, 0, 0, 0),
(1680, 122, 877, 'sound_set_22', 3, 0, 1, 0, 0, 0),
(1681, 122, 879, 'sound_set_20', 3, 0, 1, 0, 0, 0),
(1682, 122, 880, 'sound_set_19', 3, 0, 1, 0, 0, 0),
(1683, 122, 881, 'sound_set_18', 3, 0, 1, 0, 0, 0),
(1684, 122, 882, 'sound_set_17', 3, 0, 1, 0, 0, 0),
(1685, 122, 883, 'sound_set_16', 3, 0, 1, 0, 0, 0),
(1686, 122, 884, 'sound_set_15', 3, 0, 1, 0, 0, 0),
(1687, 122, 885, 'sound_set_14', 3, 0, 1, 0, 0, 0),
(1688, 122, 886, 'sound_set_13', 3, 0, 1, 0, 0, 0),
(1689, 122, 887, 'sound_set_12', 3, 0, 1, 0, 0, 0),
(1690, 122, 888, 'sound_set_11', 3, 0, 1, 0, 0, 0),
(1691, 122, 889, 'sound_set_10', 3, 0, 1, 0, 0, 0),
(1692, 122, 982, 'sound_set_36', 3, 0, 1, 0, 0, 0),
(1693, 122, 983, 'sound_set_35', 3, 0, 1, 0, 0, 0),
(1694, 122, 984, 'sound_set_34', 3, 0, 1, 0, 0, 0),
(1695, 122, 985, 'sound_set_33', 3, 0, 1, 0, 0, 0),
(1696, 122, 986, 'sound_set_32', 3, 0, 1, 0, 0, 0),
(1697, 122, 987, 'sound_set_31', 3, 0, 1, 0, 0, 0),
(1698, 122, 988, 'sound_set_30', 3, 0, 1, 0, 0, 0),
(1699, 122, 989, 'sound_set_29', 3, 0, 1, 0, 0, 0),
(1700, 122, 1002, 'sound_set_37', 3, 0, 1, 0, 0, 0),
(1701, 122, 1010, 'sound_set_44', 3, 0, 1, 0, 0, 0),
(1702, 122, 1011, 'sound_set_43', 3, 0, 1, 0, 0, 0),
(2756, 137, 1, 'World Cup Soccer', 15, 0, 9, 0, 0, 0),
(1704, 122, 1013, 'sound_set_41', 3, 0, 1, 0, 0, 0),
(1705, 122, 1014, 'sound_set_40', 3, 0, 1, 0, 0, 0),
(1706, 122, 1015, 'sound_set_39', 3, 0, 1, 0, 0, 0),
(1707, 122, 1016, 'sound_set_38', 3, 0, 1, 0, 0, 0),
(1708, 122, 1027, 'sound_set_52', 3, 0, 1, 0, 0, 0),
(1709, 122, 1028, 'sound_set_51', 3, 0, 1, 0, 0, 0),
(1710, 122, 1029, 'sound_set_50', 3, 0, 1, 0, 0, 0),
(1711, 122, 1030, 'sound_set_49', 3, 0, 1, 0, 0, 0),
(1712, 122, 1031, 'sound_set_48', 3, 0, 1, 0, 0, 0),
(1713, 122, 1032, 'sound_set_47', 3, 0, 1, 0, 0, 0),
(1714, 122, 1033, 'sound_set_46', 3, 0, 1, 0, 0, 0),
(1715, 122, 1034, 'sound_set_45', 3, 0, 1, 0, 0, 0),
(1716, 122, 1041, 'sound_set_54', 3, 0, 1, 0, 0, 0),
(1717, 122, 1042, 'sound_set_53', 3, 0, 1, 0, 0, 0),
(1718, 122, 1056, 'sound_set_59', 3, 0, 1, 0, 0, 0),
(1719, 122, 1057, 'sound_set_58', 3, 0, 1, 0, 0, 0),
(1720, 122, 1058, 'sound_set_57', 3, 0, 1, 0, 0, 0),
(1721, 122, 1059, 'sound_set_56', 3, 0, 1, 0, 0, 0),
(1722, 122, 1060, 'sound_set_55', 3, 0, 1, 0, 0, 0),
(1723, 122, 1101, 'sound_set_61', 3, 0, 1, 0, 0, 0),
(1724, 122, 1102, 'sound_set_60', 3, 0, 1, 0, 0, 0),
(1725, 122, 1136, 'sound_set_64', 3, 0, 1, 0, 0, 0),
(1726, 122, 1137, 'sound_set_63', 3, 0, 1, 0, 0, 0),
(1727, 122, 1138, 'sound_set_62', 3, 0, 1, 0, 0, 0),
(1728, 122, 1173, 'sound_set_70', 3, 0, 1, 0, 0, 0),
(1729, 122, 1174, 'sound_set_69', 3, 0, 1, 0, 0, 0),
(1730, 122, 1175, 'sound_set_68', 3, 0, 1, 0, 0, 0),
(1731, 122, 1176, 'sound_set_67', 3, 0, 1, 0, 0, 0),
(1732, 122, 1177, 'sound_set_66', 3, 0, 1, 0, 0, 0),
(1733, 122, 1178, 'sound_set_65', 3, 0, 1, 0, 0, 0),
(1734, 122, 1382, 'sound_set_71', 3, 0, 1, 0, 0, 0),
(1735, 122, 1551, 'sound_set_72', 3, 0, 1, 0, 0, 0),
(1736, 95, 868, 'rclr_sofa', 10, 0, 1, 0, 0, 0),
(1737, 72, 867, 'rom_lamp', 3, 0, 1, 0, 0, 0),
(1738, 95, 869, 'rclr_garden', 10, 0, 1, 0, 0, 0),
(1739, 95, 870, 'rclr_chair', 10, 0, 1, 0, 0, 0),
(1740, 95, 991, 'rare_mnstr', 10, 0, 1, 0, 0, 0),
(1752, 121, 1008, 'jukebox*1', 5, 0, 1, 0, 0, 0),
(1742, 94, 993, 'one_way_door*3', 10, 0, 1, 0, 0, 0),
(1743, 94, 994, 'one_way_door*4', 10, 0, 1, 0, 0, 0),
(1744, 94, 995, 'one_way_door*5', 10, 0, 1, 0, 0, 0),
(1745, 94, 996, 'one_way_door*6', 10, 0, 1, 0, 0, 0),
(1746, 94, 997, 'one_way_door*7', 10, 0, 1, 0, 0, 0),
(1747, 94, 998, 'one_way_door*8', 10, 0, 1, 0, 0, 0),
(1748, 94, 999, 'one_way_door*9', 10, 0, 1, 0, 0, 0),
(1753, 66, 1023, 'habboween_crypt', 6, 0, 1, 0, 0, 0),
(1750, 94, 992, 'one_way_door*2', 10, 0, 1, 0, 0, 0),
(1754, 66, 1024, 'habboween_grass', 5, 0, 1, 0, 0, 0),
(1755, 39, 1044, 'plant_mazegate_snow', 3, 0, 1, 0, 0, 0),
(1756, 39, 1045, 'plant_maze_snow', 3, 0, 1, 0, 0, 0),
(1759, 123, 1062, 'noob_table*2', 0, 100, 1, 0, 0, 0),
(1760, 123, 1063, 'noob_table*3', 0, 100, 1, 0, 0, 0),
(1808, 75, 1107, 'sand_cstl_wall', 5, 0, 1, 0, 0, 0),
(1762, 123, 1064, 'noob_table*4', 0, 100, 1, 0, 0, 0),
(1763, 123, 1065, 'noob_table*5', 0, 100, 1, 0, 0, 0),
(1764, 123, 1066, 'noob_table*6', 0, 100, 1, 0, 0, 0),
(1765, 123, 1067, 'noob_stool*1', 0, 100, 1, 0, 0, 0),
(1766, 123, 1068, 'noob_stool*2', 0, 100, 1, 0, 0, 0),
(1767, 123, 1069, 'noob_stool*3', 0, 100, 1, 0, 0, 0),
(1768, 123, 1070, 'noob_stool*4', 0, 100, 1, 0, 0, 0),
(1769, 123, 1071, 'noob_stool*5', 0, 100, 1, 0, 0, 0),
(1770, 123, 1072, 'noob_stool*6', 0, 100, 1, 0, 0, 0),
(1771, 123, 1073, 'noob_rug*1', 0, 100, 1, 0, 0, 0),
(1772, 123, 1074, 'noob_rug*2', 0, 100, 1, 0, 0, 0),
(1773, 123, 1075, 'noob_rug*3', 0, 100, 1, 0, 0, 0),
(1774, 123, 1076, 'noob_rug*4', 0, 100, 1, 0, 0, 0),
(1775, 123, 1077, 'noob_rug*5', 0, 100, 1, 0, 0, 0),
(1776, 123, 1078, 'noob_rug*6', 0, 100, 1, 0, 0, 0),
(1777, 123, 1079, 'noob_lamp*1', 0, 100, 1, 0, 0, 0),
(1778, 123, 1080, 'noob_lamp*2', 0, 100, 1, 0, 0, 0),
(1779, 123, 1081, 'noob_lamp*3', 0, 100, 1, 0, 0, 0),
(1780, 123, 1082, 'noob_lamp*4', 0, 100, 1, 0, 0, 0),
(1781, 123, 1083, 'noob_lamp*5', 0, 100, 1, 0, 0, 0),
(1782, 123, 1084, 'noob_lamp*6', 0, 100, 1, 0, 0, 0),
(1783, 123, 1085, 'noob_chair*1', 0, 100, 1, 0, 0, 0),
(1784, 123, 1086, 'noob_chair*2', 0, 100, 1, 0, 0, 0),
(1785, 123, 1087, 'noob_chair*3', 0, 100, 1, 0, 0, 0),
(1786, 123, 1088, 'noob_chair*4', 0, 100, 1, 0, 0, 0),
(1787, 123, 1089, 'noob_chair*5', 0, 100, 1, 0, 0, 0),
(1788, 123, 1090, 'noob_chair*6', 0, 100, 1, 0, 0, 0),
(1826, 126, 1168, 'tiki_corner', 3, 0, 1, 0, 0, 0),
(1825, 126, 1167, 'tiki_junglerug', 45, 0, 10, 0, 0, 0),
(1824, 126, 1167, 'tiki_junglerug', 5, 0, 1, 0, 0, 0),
(1823, 126, 1166, 'tiki_parasol', 4, 0, 1, 0, 0, 0),
(1822, 126, 1165, 'tiki_sand', 45, 0, 10, 0, 0, 0),
(1821, 126, 1165, 'tiki_sand', 5, 0, 1, 0, 0, 0),
(1795, 123, 1185, 'noob_plant', 0, 100, 1, 0, 0, 0),
(1820, 126, 1164, 'tiki_statue', 5, 0, 1, 0, 0, 0),
(1819, 126, 1163, 'tiki_torch', 3, 0, 1, 0, 0, 0),
(1818, 126, 1162, 'tiki_toucan', 4, 0, 1, 0, 0, 0),
(1817, 126, 1161, 'tiki_tray0', 3, 0, 1, 0, 0, 0),
(1816, 126, 1159, 'tiki_tray2', 3, 0, 1, 0, 0, 0),
(1815, 126, 1160, 'tiki_tray1', 3, 0, 1, 0, 0, 0),
(1832, 76, 1103, 'fortune', 5, 0, 1, 0, 0, 0),
(1813, 126, 1158, 'tiki_tray3', 3, 0, 1, 0, 0, 0),
(1812, 126, 1157, 'tiki_tray4', 3, 0, 1, 0, 0, 0),
(1811, 126, 1156, 'tiki_waterfall', 5, 0, 1, 0, 0, 0),
(1809, 75, 1108, 'sand_cstl_twr', 5, 0, 1, 0, 0, 0),
(1810, 75, 1109, 'sand_cstl_gate', 5, 0, 1, 0, 0, 0),
(1827, 126, 1169, 'tiki_bflies', 3, 0, 1, 0, 0, 0),
(1828, 126, 1170, 'tiki_bench', 3, 0, 1, 0, 0, 0),
(1829, 126, 1171, 'tiki_bardesk', 3, 0, 1, 0, 0, 0),
(1830, 126, 1690, 'tiki_wallplnt', 4, 0, 1, 0, 0, 0),
(1831, 126, 1691, 'tiki_surfboard', 3, 0, 1, 0, 0, 0),
(1833, 95, 1104, 'sw_table', 10, 0, 1, 0, 0, 0),
(1834, 95, 1105, 'sw_raven', 10, 0, 1, 0, 0, 0),
(1836, 95, 1106, 'sw_chest', 10, 0, 1, 0, 0, 0),
(1838, 95, 1113, 'rclr_lamp', 10, 0, 1, 0, 0, 0),
(1839, 95, 1117, 'md_rug', 10, 0, 1, 0, 0, 0),
(1840, 95, 1116, 'nouvelle_trax', 10, 0, 1, 0, 0, 0),
(1841, 95, 1139, 'jukebox_ptv*1', 10, 0, 1, 0, 0, 0),
(1842, 121, 1141, 'traxsilver', 5, 0, 1, 0, 0, 0),
(1843, 121, 1142, 'traxgold', 5, 0, 1, 0, 0, 0),
(1844, 121, 1143, 'traxbronze', 5, 0, 1, 0, 0, 0),
(1845, 95, 1144, 'bench_puffet', 10, 0, 1, 0, 0, 0),
(1846, 13, 1145, 'CFC_500_goldbar', 500, 0, 1, 0, 0, 0),
(1847, 13, 1146, 'CFC_200_moneybag', 200, 0, 1, 0, 0, 0),
(1848, 13, 1148, 'CFC_100_coin_gold', 100, 0, 1, 0, 0, 0),
(1851, 128, 19940, 'urban_bench_plain', 4, 0, 1, 0, 0, 0),
(1850, 13, 1149, 'CFC_50_coin_silver', 50, 0, 1, 0, 0, 0),
(1852, 95, 1328, 'ads_igorswitch', 10, 0, 1, 0, 0, 0),
(1853, 95, 1329, 'ads_711*1', 10, 0, 1, 0, 0, 0),
(1854, 95, 1330, 'ads_711*2', 10, 0, 1, 0, 0, 0),
(1855, 95, 1331, 'ads_711*3', 10, 0, 1, 0, 0, 0),
(1856, 95, 1332, 'ads_711*4', 10, 0, 1, 0, 0, 0),
(1857, 95, 1333, 'ads_igorraygun', 10, 0, 1, 0, 0, 0),
(1858, 95, 1412, 'ads_cldesk', 10, 0, 1, 0, 0, 0),
(1859, 95, 1414, 'ads_cltele', 10, 0, 1, 0, 0, 0),
(1860, 95, 1415, 'ads_clfloor', 10, 0, 1, 0, 0, 0),
(1862, 95, 1327, 'ads_igorbrain', 10, 0, 1, 0, 0, 0),
(1863, 95, 1417, 'ads_mall_tele', 10, 0, 1, 0, 0, 0),
(1864, 95, 1441, 'ads_idol_floor1', 10, 0, 1, 0, 0, 0),
(1865, 95, 1442, 'ads_igor_dsk', 10, 0, 1, 0, 0, 0),
(1866, 95, 1443, 'ads_idol_desk', 10, 0, 1, 0, 0, 0),
(1867, 95, 1444, 'ads_idol_ch', 10, 0, 1, 0, 0, 0),
(1868, 95, 1445, 'ads_igor_flask', 10, 0, 1, 0, 0, 0),
(1869, 95, 1446, 'ads_idol_drape', 10, 0, 1, 0, 0, 0),
(1870, 95, 1447, 'ads_idol_floor2', 10, 0, 1, 0, 0, 0),
(1871, 95, 1453, 'ads_idol_piano', 10, 0, 1, 0, 0, 0),
(1872, 95, 1455, 'ads_711shelf', 10, 0, 1, 0, 0, 0),
(1873, 95, 1464, 'ads_idol_jukebox*1', 10, 0, 1, 0, 0, 0),
(1874, 95, 1465, 'ads_idol_pchair', 10, 0, 1, 0, 0, 0),
(1875, 95, 1467, 'ads_idol_audChr', 10, 0, 1, 0, 0, 0),
(1876, 95, 1468, 'ads_idol_trax', 10, 0, 1, 0, 0, 0),
(1877, 95, 1469, 'ads_idol_tele', 10, 0, 1, 0, 0, 0),
(1878, 95, 1474, 'ads_idol_mic', 10, 0, 1, 0, 0, 0),
(1879, 95, 1475, 'ads_idol_hotspot', 10, 0, 1, 0, 0, 0),
(1880, 95, 1476, 'ads_idol_clRack', 10, 0, 1, 0, 0, 0),
(1881, 95, 1477, 'ads_idol_voting_ch', 10, 0, 1, 0, 0, 0),
(1882, 95, 1491, 'ads_frankb', 10, 0, 1, 0, 0, 0),
(1883, 95, 1508, 'ads_grefusa_cactus', 10, 0, 1, 0, 0, 0),
(1884, 95, 1509, 'ads_idol_tube', 10, 0, 1, 0, 0, 0),
(1885, 95, 1511, 'ads_idol_cork', 10, 0, 1, 0, 0, 0),
(1886, 95, 1512, 'ads_cl_jukeb', 10, 0, 1, 0, 0, 0),
(1887, 95, 1518, 'ads_idol_newsDsk', 10, 0, 1, 0, 0, 0),
(1888, 95, 1524, 'ads_idol_ichair', 10, 0, 1, 0, 0, 0),
(1889, 95, 1526, 'ads_reebok_block2', 10, 0, 1, 0, 0, 0),
(1890, 95, 1527, 'ads_malaco_rug', 10, 0, 1, 0, 0, 0),
(1891, 95, 1530, 'ads_malaco_gu', 10, 0, 1, 0, 0, 0),
(1892, 95, 1531, 'ads_clcake', 10, 0, 1, 0, 0, 0),
(1893, 95, 1532, 'ads_cl_sofa', 10, 0, 1, 0, 0, 0),
(1894, 95, 1533, 'ads_idol_tblCloth', 10, 0, 1, 0, 0, 0),
(1895, 95, 1534, 'ads_idol_carpet', 10, 0, 1, 0, 0, 0),
(1896, 95, 1535, 'ads_idol_lamp', 10, 0, 1, 0, 0, 0),
(1897, 95, 1541, 'ads_goldtabl', 10, 0, 1, 0, 0, 0),
(1898, 95, 1553, 'ads_calip_cola*1', 10, 0, 1, 0, 0, 0),
(1899, 95, 1554, 'ads_calip_cola*2', 10, 0, 1, 0, 0, 0),
(1900, 95, 1555, 'ads_calip_cola*3', 10, 0, 1, 0, 0, 0),
(1901, 95, 1630, 'ads_711*6', 10, 0, 1, 0, 0, 0),
(1902, 95, 1556, 'ads_calip_cola*4', 10, 0, 1, 0, 0, 0),
(1903, 95, 1562, 'ads_calip_chair', 10, 0, 1, 0, 0, 0),
(1904, 95, 1563, 'ads_idol_trophy', 10, 0, 1, 0, 0, 0),
(1905, 95, 1565, 'ads_calip_pool', 10, 0, 1, 0, 0, 0),
(1906, 95, 1572, 'ads_calip_tele', 10, 0, 1, 0, 0, 0),
(2106, 94, 247, 'rare_daffodil_rug', 1, 0, 150, 0, 0, 0),
(1908, 95, 1587, 'ads_calip_lava', 10, 0, 1, 0, 0, 0),
(1909, 95, 1591, 'ads_mall_coffeem', 10, 0, 1, 0, 0, 0),
(1910, 95, 1612, 'ads_mall_kiosk', 10, 0, 1, 0, 0, 0),
(1911, 95, 1619, 'ads_elisa_gnome', 10, 0, 1, 0, 0, 0),
(1912, 95, 1621, 'ads_oc_soda', 10, 0, 1, 0, 0, 0),
(1913, 95, 1629, 'ads_711*5', 10, 0, 1, 0, 0, 0),
(1914, 95, 1631, 'ads_711*7', 10, 0, 1, 0, 0, 0),
(1915, 95, 1652, 'ads_1800tele', 10, 0, 1, 0, 0, 0),
(1916, 95, 1707, 'ads_sunnyd', 10, 0, 1, 0, 0, 0),
(1917, 95, 1711, 'ads_dave_wall', 10, 0, 1, 0, 0, 0),
(1918, 95, 1714, 'ads_nokia_logo', 10, 0, 1, 0, 0, 0),
(1919, 95, 1715, 'ads_nokia_phone', 10, 0, 1, 0, 0, 0),
(1920, 95, 1720, 'ads_campguitar', 10, 0, 1, 0, 0, 0),
(1921, 95, 1728, 'ads_cmusic', 10, 0, 1, 0, 0, 0),
(1922, 95, 1741, 'ads_clwall1', 10, 0, 1, 0, 0, 0),
(1923, 95, 1742, 'ads_clwall2', 10, 0, 1, 0, 0, 0),
(1924, 95, 1743, 'ads_clwall3', 10, 0, 1, 0, 0, 0),
(1925, 95, 1744, 'ads_ob_wall', 10, 0, 1, 0, 0, 0),
(1926, 95, 1745, 'ads_mall_window', 10, 0, 1, 0, 0, 0),
(1927, 42, 20022, 'a0 prizetrophy6_b', 8, 0, 1, 0, 0, 0),
(1928, 95, 1750, 'ads_igor_wall', 10, 0, 1, 0, 0, 0),
(1929, 95, 1751, 'ads_igorevilb', 10, 0, 1, 0, 0, 0),
(1930, 95, 1752, 'ads_idol_wall', 10, 0, 1, 0, 0, 0),
(1931, 95, 1753, 'ads_mall_winfur', 10, 0, 1, 0, 0, 0),
(1932, 95, 1754, 'ads_mall_winpet', 10, 0, 1, 0, 0, 0),
(1933, 95, 1758, 'ads_idol_tv', 10, 0, 1, 0, 0, 0),
(1934, 95, 1760, 'ads_idol_mirror', 10, 0, 1, 0, 0, 0),
(1935, 95, 1761, 'ads_mall_wincin', 10, 0, 1, 0, 0, 0),
(1936, 95, 1762, 'ads_mall_winmus', 10, 0, 1, 0, 0, 0),
(1937, 95, 1763, 'ads_mall_winbea', 10, 0, 1, 0, 0, 0),
(1938, 95, 1765, 'ads_mall_winchi', 10, 0, 1, 0, 0, 0),
(1939, 95, 1768, 'ads_mall_winice', 10, 0, 1, 0, 0, 0),
(1940, 95, 1769, 'ads_mall_winspo', 10, 0, 1, 0, 0, 0),
(1941, 95, 1770, 'ads_idol_logo', 10, 0, 1, 0, 0, 0),
(1942, 95, 1773, 'ads_lin_wh_c', 10, 0, 1, 0, 0, 0),
(1943, 95, 1774, 'ads_malaco_tv', 10, 0, 1, 0, 0, 0),
(1944, 95, 1775, 'ads_puffet_tv', 10, 0, 1, 0, 0, 0),
(1945, 95, 1776, 'ads_reebok_tv', 10, 0, 1, 0, 0, 0),
(1946, 95, 1784, 'ads_mirror', 10, 0, 1, 0, 0, 0),
(1947, 95, 1789, 'ads_wwe_poster', 10, 0, 1, 0, 0, 0),
(1948, 95, 1790, 'ads_mall_wintra', 10, 0, 1, 0, 0, 0),
(1949, 95, 1793, 'ads_veet', 10, 0, 1, 0, 0, 0),
(1950, 95, 1797, 'ads_mall_wingar', 10, 0, 1, 0, 0, 0),
(1951, 95, 1799, 'ads_mall_winclo', 10, 0, 1, 0, 0, 0),
(2011, 88, 1725, 'hw_08_xray', 5, 0, 1, 0, 0, 0),
(1954, 95, 20037, 'ads_calip_parasol', 10, 0, 1, 0, 0, 0),
(1956, 95, 1172, 'tampax_rug', 10, 0, 1, 0, 0, 0),
(1957, 95, 1692, 'tampax_wall', 10, 0, 1, 0, 0, 0),
(1958, 94, 20025, 'pillar*6', 10, 0, 1, 0, 0, 0),
(1959, 55, 20026, 'shelves_norja*4', 3, 0, 1, 0, 0, 0),
(1960, 30, 20027, 'bed_polyfon*2', 4, 0, 1, 0, 0, 0),
(1961, 55, 20028, 'divider_nor5*6', 3, 0, 1, 0, 0, 0),
(1962, 76, 20029, 'val_cauldron', 10, 0, 1, 0, 0, 0),
(1963, 32, 20030, 'pura_mdl5*1', 3, 0, 1, 0, 0, 0),
(1964, 94, 20031, 'one_way_door*1', 10, 0, 1, 0, 0, 0),
(1976, 128, 20006, 'urban_fence_corner', 3, 0, 1, 0, 0, 0),
(1966, 60, 20032, 'exe_globe', 5, 0, 1, 0, 0, 0),
(2097, 95, 20041, 'year2010', 10, 0, 1, 0, 0, 0),
(1968, 45, 20035, 'fx_bubble', 0, 250, 1, 0, 0, 0),
(1969, 129, 20036, 'bump_tottero', 0, 50, 1, 0, 0, 0),
(1970, 129, 1502, 'bump_road', 0, 75, 1, 0, 0, 0),
(1971, 129, 1497, 'bump_lights', 0, 50, 1, 0, 0, 0),
(1972, 129, 1496, 'bump_tires', 0, 50, 1, 0, 0, 0),
(1973, 129, 1492, 'bump_signs', 0, 50, 1, 0, 0, 0),
(1974, 103, 20034, 'diner_bardesk_corner*5', 3, 0, 1, 0, 0, 0),
(1977, 128, 20016, 'urban_lamp', 4, 0, 1, 0, 0, 0),
(1978, 128, 20018, 'urban_wall', 5, 0, 1, 0, 0, 0),
(1979, 128, 20011, 'urban_wpost', 3, 0, 1, 0, 0, 0),
(1980, 128, 20010, 'urban_sidewalk', 4, 0, 1, 0, 0, 0),
(1981, 128, 20008, 'urban_bench', 3, 0, 1, 0, 0, 0),
(1982, 128, 20007, 'urban_carsofa', 4, 0, 1, 0, 0, 0),
(1983, 128, 20014, 'urban_blocker', 2, 0, 1, 0, 0, 0),
(1984, 128, 20013, 'urban_bin', 3, 0, 1, 0, 0, 0),
(1985, 128, 20012, 'urban_fence', 3, 0, 1, 0, 0, 0),
(1986, 128, 20015, 'urban_bsktbll', 4, 0, 1, 0, 0, 0),
(1987, 125, 19877, 'avatar_effect9', 0, 100, 1, 0, 0, 0),
(1988, 125, 19878, 'avatar_effect6', 0, 100, 1, 0, 0, 0),
(1989, 125, 19879, 'avatar_effect16', 0, 100, 1, 0, 0, 0),
(1990, 125, 19880, 'avatar_effect2', 0, 100, 1, 0, 0, 0),
(1991, 125, 19881, 'avatar_effect14', 0, 100, 1, 0, 0, 0),
(1992, 125, 19882, 'avatar_effect15', 0, 100, 1, 0, 0, 0),
(1993, 125, 19883, 'avatar_effect3', 0, 100, 1, 0, 0, 0),
(1994, 125, 19884, 'avatar_effect17', 0, 100, 1, 0, 0, 0),
(1995, 125, 19885, 'avatar_effect18', 0, 100, 1, 0, 0, 0),
(1996, 125, 19886, 'avatar_effect1', 0, 100, 1, 0, 0, 0),
(1997, 125, 19887, 'avatar_effect4', 0, 100, 1, 0, 0, 0),
(1998, 125, 19888, 'avatar_effect5', 0, 100, 1, 0, 0, 0),
(1999, 125, 19889, 'avatar_effect7', 0, 100, 1, 0, 0, 0),
(2000, 125, 19890, 'avatar_effect8', 0, 100, 1, 0, 0, 0),
(2001, 125, 19891, 'avatar_effect10', 0, 100, 1, 0, 0, 0),
(2002, 125, 19892, 'avatar_effect12', 0, 100, 1, 0, 0, 0),
(2003, 125, 19893, 'avatar_effect13', 0, 100, 1, 0, 0, 0),
(2004, 129, 19957, 'avatar_effect22', 0, 100, 1, 0, 0, 0),
(2005, 129, 19958, 'avatar_effect19', 0, 100, 1, 0, 0, 0),
(2006, 129, 19959, 'avatar_effect20', 0, 100, 1, 0, 0, 0),
(2007, 129, 19960, 'avatar_effect21', 0, 100, 1, 0, 0, 0),
(2016, 95, 1681, 'sw_stone', 10, 0, 1, 0, 0, 0),
(2012, 95, 1718, 'netari_poster', 10, 0, 1, 0, 0, 0),
(2013, 95, 1713, 'easy_poster', 10, 0, 1, 0, 0, 0),
(2014, 95, 1684, 'md_logo_wall', 10, 0, 1, 0, 0, 0),
(2015, 95, 1682, 'sw_hole', 10, 0, 1, 0, 0, 0),
(2017, 95, 1680, 'sw_swords', 10, 0, 1, 0, 0, 0),
(2018, 41, 1675, 'guitar_v', 4, 0, 1, 0, 0, 0),
(2019, 41, 1674, 'guitar_skull', 4, 0, 1, 0, 0, 0),
(2020, 43, 1673, 'habbowheel', 5, 0, 1, 0, 0, 0),
(2021, 72, 1670, 'wallmirror', 3, 0, 1, 0, 0, 0),
(2022, 85, 1633, 'pix_asteroid', 0, 2000, 1, 0, 0, 0),
(2023, 71, 1626, 'rela_stone', 4, 0, 1, 0, 0, 0),
(2024, 94, 1622, 'marsrug', 10, 0, 1, 0, 0, 0),
(2025, 85, 1592, 'totem_planet', 0, 2000, 1, 0, 0, 0),
(2026, 95, 1590, 'voting_ch', 10, 0, 1, 0, 0, 0),
(2027, 73, 1586, 'transparent_floor', 5, 0, 1, 0, 0, 0),
(2028, 95, 1583, 'clrack', 10, 0, 1, 0, 0, 0),
(2029, 95, 1582, 'noticeboard', 10, 0, 1, 0, 0, 0),
(2030, 95, 1577, 'audChr', 10, 0, 1, 0, 0, 0),
(2031, 85, 1571, 'saturn', 0, 2000, 1, 0, 0, 0),
(2032, 95, 1566, 'laptopdesk', 10, 0, 1, 0, 0, 0),
(2033, 85, 1564, 'totem_head', 0, 2000, 1, 0, 0, 0),
(2034, 130, 1538, 'env_telep', 5, 0, 20, 0, 0, 0),
(2035, 95, 1529, 'tray_glasstower', 6, 0, 1, 0, 0, 0),
(2036, 95, 1528, 'tray_champagne', 5, 0, 1, 0, 0, 0),
(2037, 95, 1525, 'tray_cake', 4, 0, 1, 0, 0, 0),
(2038, 130, 1522, 'env_tree4', 5, 0, 20, 0, 0, 0),
(2039, 130, 1520, 'env_tree2', 3, 0, 20, 0, 0, 0),
(2040, 130, 1519, 'env_tree1', 3, 0, 20, 0, 0, 0),
(2044, 130, 1515, 'env_bushes', 5, 0, 20, 0, 0, 0),
(2043, 130, 1516, 'env_bushes_gate', 5, 0, 20, 0, 0, 0),
(2045, 130, 1514, 'env_tree3', 3, 0, 20, 0, 0, 0),
(2046, 130, 1513, 'env_grass', 5, 0, 20, 0, 0, 0),
(2047, 130, 1513, 'env_grass', 15, 5000, 200, 0, 0, 0),
(2048, 85, 1507, 'totem_leg', 0, 2000, 1, 0, 0, 0),
(2110, 112, 20052, 'ads_twi_crest', 6, 0, 1, 0, 0, 0),
(2050, 58, 1448, 'lostc_octopus', 6, 0, 1, 0, 0, 0),
(2052, 85, 1430, 'planet_of_love', 0, 2000, 1, 0, 0, 0),
(2054, 28, 1365, 'penguin_basic', 2, 0, 1, 0, 0, 0),
(2055, 28, 1367, 'penguin_musketeer', 2, 0, 1, 0, 0, 0),
(2056, 28, 1370, 'penguin_wrestler', 2, 0, 1, 0, 0, 0),
(2057, 28, 1372, 'penguin_robot', 2, 0, 1, 0, 0, 0),
(2058, 28, 1376, 'penguin_suit', 2, 0, 1, 0, 0, 0),
(2059, 28, 1379, 'penguin_icehockey', 2, 0, 1, 0, 0, 0),
(2060, 28, 1380, 'penguin_pilot', 2, 0, 1, 0, 0, 0),
(2061, 28, 1381, 'penguin_ballet', 2, 0, 1, 0, 0, 0),
(2062, 28, 1383, 'penguin_boxer', 2, 0, 1, 0, 0, 0),
(2063, 28, 1384, 'penguin_glow', 2, 0, 1, 0, 0, 0),
(2064, 28, 1385, 'penguin_swim', 2, 0, 1, 0, 0, 0),
(2065, 28, 1386, 'penguin_sumo', 2, 0, 1, 0, 0, 0),
(2066, 28, 1388, 'penguin_clown', 2, 0, 1, 0, 0, 0),
(2067, 28, 1389, 'penguin_infected', 2, 0, 1, 0, 0, 0),
(2068, 28, 1393, 'penguin_super', 2, 0, 1, 0, 0, 0),
(2069, 28, 1396, 'penguin_rock', 2, 0, 1, 0, 0, 0),
(2070, 28, 1399, 'penguin_ski', 2, 0, 1, 0, 0, 0),
(2071, 28, 1400, 'penguin_skater', 2, 0, 1, 0, 0, 0),
(2072, 28, 1402, 'penguin_elf', 2, 0, 1, 0, 0, 0),
(2073, 28, 1403, 'penguin_bunny', 2, 0, 1, 0, 0, 0),
(2074, 28, 1404, 'penguin_ninja', 2, 0, 1, 0, 0, 0),
(2075, 28, 1405, 'penguin_magician', 2, 0, 1, 0, 0, 0),
(2076, 28, 1406, 'penguin_hunchback', 2, 0, 1, 0, 0, 0),
(2077, 28, 1407, 'penguin_cowboy', 2, 0, 1, 0, 0, 0),
(2078, 28, 1408, 'penguin_punk', 2, 0, 1, 0, 0, 0),
(2079, 28, 1409, 'penguin_pirate', 2, 0, 1, 0, 0, 0),
(2080, 45, 1390, 'fx_flare', 0, 250, 1, 0, 0, 0),
(2081, 95, 1377, 'svnr_fi', 10, 0, 1, 0, 0, 0),
(2082, 45, 1371, 'fx_explosion', 0, 250, 1, 0, 0, 0),
(2084, 95, 1202, 'svnr_aus', 10, 0, 1, 0, 0, 0),
(2085, 95, 1201, 'svnr_de', 10, 0, 1, 0, 0, 0),
(2086, 95, 1200, 'svnr_it', 10, 0, 1, 0, 0, 0),
(2087, 95, 1199, 'svnr_nl', 10, 0, 1, 0, 0, 0),
(2088, 95, 1198, 'svnr_uk', 10, 0, 1, 0, 0, 0),
(2089, 36, 20024, 'table_plasto_square*9', 3, 0, 1, 0, 0, 0),
(2090, 76, 20021, 'heart', 5, 0, 1, 0, 0, 0),
(2091, 95, 1303, 'easy_carpet', 10, 0, 1, 0, 0, 0),
(2092, 95, 1304, 'easy_bowl2', 10, 0, 1, 0, 0, 0),
(2093, 95, 1319, 'netari_carpet', 10, 0, 1, 0, 0, 0),
(2094, 40, 1325, 'sob_carpet', 3, 0, 1, 0, 0, 0),
(2095, 95, 1326, 'igor_seat', 10, 0, 1, 0, 0, 0),
(2098, 95, 20042, 'party_lantern', 10, 0, 1, 0, 0, 0),
(2103, 56, 20045, 'arabian_tile', 5, 0, 1, 0, 0, 0),
(2105, 95, 20048, 'ads_mall_elevator', 10, 0, 1, 0, 0, 0),
(2112, 112, 20053, 'ads_twi_paint', 3, 0, 1, 0, 0, 0),
(2107, 95, 20050, 'xm09_infotv', 10, 0, 1, 0, 0, 0),
(2113, 112, 20054, 'ads_twi_windw', 3, 0, 1, 0, 0, 0),
(2114, 112, 20055, 'ads_twi_bwall2', 3, 0, 1, 0, 0, 0),
(2115, 112, 20056, 'ads_twi_dreamc', 3, 0, 1, 0, 0, 0),
(2116, 112, 20057, 'ads_twi_bwall1', 3, 0, 1, 0, 0, 0),
(2121, 56, 20059, 'arabian_wall', 4, 0, 1, 0, 0, 0),
(2123, 73, 20064, 'sf_mbar', 5, 0, 1, 0, 0, 0),
(2124, 27, 20063, 'xm09_cocoa', 6, 0, 1, 0, 0, 0),
(2126, 160, 317, 'nest', 3, 0, 1, 0, 0, 0),
(2127, 160, 318, 'petfood1', 3, 0, 1, 0, 0, 0),
(2128, 160, 319, 'petfood2', 3, 0, 1, 0, 0, 0),
(2129, 160, 320, 'petfood3', 3, 0, 1, 0, 0, 0),
(2130, 160, 321, 'waterbowl*4', 3, 0, 1, 0, 0, 0),
(2131, 160, 322, 'waterbowl*5', 3, 0, 1, 0, 0, 0),
(2132, 160, 326, 'toy1', 3, 0, 1, 0, 0, 0),
(2133, 160, 323, 'waterbowl*2', 3, 0, 1, 0, 0, 0),
(2134, 160, 324, 'waterbowl*1', 3, 0, 1, 0, 0, 0),
(2135, 160, 325, 'waterbowl*3', 3, 0, 1, 0, 0, 0),
(2136, 160, 327, 'toy1*1', 3, 0, 1, 0, 0, 0),
(2137, 160, 328, 'toy1*2', 3, 0, 1, 0, 0, 0),
(2139, 160, 330, 'toy1*4', 3, 0, 1, 0, 0, 0),
(2140, 160, 331, 'goodie1', 3, 0, 1, 0, 0, 0),
(2141, 160, 332, 'goodie1*1', 3, 0, 1, 0, 0, 0),
(2142, 160, 333, 'goodie1*2', 3, 0, 1, 0, 0, 0),
(2143, 160, 334, 'goodie2', 3, 0, 1, 0, 0, 0),
(2144, 160, 334, 'goodie2', 3, 0, 1, 0, 0, 0),
(2145, 134, 1478, 'ecotron_box', 3, 0, 1, 0, 0, 0),
(2146, 134, 1479, 'eco_light2', 3, 0, 1, 0, 0, 0),
(2147, 134, 1480, 'eco_chair3', 3, 0, 1, 0, 0, 0),
(2148, 134, 1481, 'eco_table3', 3, 0, 1, 0, 0, 0),
(2149, 134, 1482, 'eco_lamp2', 3, 0, 1, 0, 0, 0),
(2150, 134, 1483, 'eco_sofa3', 3, 0, 1, 0, 0, 0),
(2151, 134, 1484, 'eco_table2', 3, 0, 1, 0, 0, 0),
(2152, 134, 1485, 'eco_fruits2', 3, 0, 1, 0, 0, 0),
(2153, 134, 1486, 'eco_sofa1', 3, 0, 1, 0, 0, 0),
(2154, 134, 1487, 'eco_fruits3', 3, 0, 1, 0, 0, 0),
(2155, 134, 1488, 'eco_light1', 3, 0, 1, 0, 0, 0),
(2156, 134, 1489, 'eco_tree1', 3, 0, 1, 0, 0, 0),
(2157, 134, 1490, 'eco_cactus2', 3, 0, 1, 0, 0, 0),
(2158, 134, 1493, 'eco_cactus1', 3, 0, 1, 0, 0, 0),
(2159, 134, 1494, 'eco_chair2', 3, 0, 1, 0, 0, 0),
(2160, 134, 1495, 'eco_cactus3', 3, 0, 1, 0, 0, 0),
(2161, 134, 1498, 'eco_lamp3', 3, 0, 1, 0, 0, 0),
(2164, 30, 631, 'divider_poly3*8', 3, 0, 1, 0, 0, 0),
(2163, 160, 819, 'petfood4', 3, 0, 1, 0, 0, 0),
(2165, 134, 164, 'present_gen', 3, 0, 1, 0, 0, 0),
(2166, 134, 165, 'present_gen1', 3, 0, 1, 0, 0, 0),
(2167, 134, 166, 'present_gen2', 3, 0, 1, 0, 0, 0),
(2168, 134, 167, 'present_gen3', 3, 0, 1, 0, 0, 0),
(2169, 134, 168, 'present_gen4', 3, 0, 1, 0, 0, 0),
(2170, 134, 169, 'present_gen5', 3, 0, 1, 0, 0, 0),
(2171, 134, 170, 'present_gen6', 3, 0, 1, 0, 0, 0),
(2172, 134, 1450, 'lc_medusa2', 3, 0, 1, 0, 0, 0),
(2173, 134, 1007, 'song_disk', 3, 0, 1, 0, 0, 0),
(2174, 134, 1499, 'eco_table1', 3, 0, 1, 0, 0, 0),
(2175, 134, 1500, 'eco_chair1', 3, 0, 1, 0, 0, 0),
(2176, 134, 1501, 'eco_sofa2', 3, 0, 1, 0, 0, 0),
(2177, 134, 1503, 'eco_fruits1', 3, 0, 1, 0, 0, 0),
(2178, 134, 1504, 'eco_lamp1', 3, 0, 1, 0, 0, 0),
(2179, 134, 1505, 'eco_light3', 3, 0, 1, 0, 0, 0),
(2180, 134, 1506, 'eco_tree2', 3, 0, 1, 0, 0, 0),
(2181, 134, 1542, 'eco_mush1', 3, 0, 1, 0, 0, 0),
(2182, 134, 1547, 'eco_mush2', 3, 0, 1, 0, 0, 0),
(2183, 134, 1764, 'eco_curtains1', 3, 0, 1, 0, 0, 0),
(2184, 134, 1766, 'eco_curtains3', 3, 0, 1, 0, 0, 0),
(2185, 134, 1767, 'eco_curtains2', 3, 0, 1, 0, 0, 0),
(2195, 41, 20156, 'flag_dominicanrepublic', 3, 0, 1, 0, 0, 0),
(2194, 41, 20155, 'flag_ecuador', 3, 0, 1, 0, 0, 0),
(2193, 41, 20154, 'flag_chile', 3, 0, 1, 0, 0, 0),
(2190, 41, 20151, 'flag_singapore', 3, 0, 1, 0, 0, 0),
(2191, 41, 20153, 'flag_columbia', 3, 0, 1, 0, 0, 0),
(2196, 41, 20157, 'flag_newzealand', 3, 0, 1, 0, 0, 0),
(2197, 41, 20158, 'flag_malaysia', 3, 0, 1, 0, 0, 0),
(2198, 41, 20160, 'flag_venezl', 3, 0, 1, 0, 0, 0),
(2199, 41, 20161, 'flag_algeria', 3, 0, 1, 0, 0, 0),
(2200, 41, 20162, 'flag_tunisia', 3, 0, 1, 0, 0, 0),
(2201, 41, 20163, 'flag_panama', 3, 0, 1, 0, 0, 0),
(2202, 41, 20164, 'flag_mexico', 3, 0, 1, 0, 0, 0),
(2203, 41, 20165, 'flag_argentina', 3, 0, 1, 0, 0, 0),
(2204, 41, 20166, 'flag_philippines', 3, 0, 1, 0, 0, 0),
(2205, 41, 20167, 'flag_greece', 3, 0, 1, 0, 0, 0),
(2206, 41, 20168, 'flag_peru', 3, 0, 1, 0, 0, 0),
(2207, 41, 20169, 'flag_morocco', 3, 0, 1, 0, 0, 0),
(2208, 41, 20170, 'flag_turkey', 3, 0, 1, 0, 0, 0),
(2209, 136, 20117, 'bling_fridge', 5, 0, 1, 0, 0, 0),
(2210, 136, 20121, 'bling_chair_a', 3, 0, 1, 0, 0, 0),
(2211, 136, 20123, 'bling_pool', 3, 0, 1, 0, 0, 0),
(2212, 136, 20124, 'bling_toilet', 4, 0, 1, 0, 0, 0),
(2213, 136, 20126, 'bling_chair_c', 3, 0, 1, 0, 0, 0),
(2214, 136, 20127, 'bling_chair_b', 3, 0, 1, 0, 0, 0),
(2215, 136, 20128, 'bling_shwr', 5, 0, 1, 0, 0, 0),
(2216, 136, 20129, 'bling_bed', 3, 0, 1, 0, 0, 0),
(2217, 136, 20130, 'bling_sofa', 4, 0, 1, 0, 0, 0),
(2218, 136, 20144, 'bling_fridge_restricted', 3, 0, 1, 0, 0, 0),
(2219, 136, 20200, 'bling_sink', 3, 0, 1, 0, 0, 0),
(2220, 136, 20202, 'bling_cabinet', 3, 0, 1, 0, 0, 0),
(2223, 137, 20103, 'org_chairpnk', 3, 0, 1, 0, 0, 0),
(2224, 137, 20104, 'org_tblpnk', 3, 0, 1, 0, 0, 0);
INSERT INTO `catalog_items` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`, `song_id`) VALUES
(2225, 137, 20105, 'org_lampblk', 3, 0, 1, 0, 0, 0),
(2226, 137, 20106, 'org_lamppnk', 3, 0, 1, 0, 0, 0),
(2227, 137, 20107, 'org_table', 3, 0, 1, 0, 0, 0),
(2228, 137, 20111, 'org_chairblk', 3, 0, 1, 0, 0, 0),
(2229, 137, 20112, 'org_tblblk', 3, 0, 1, 0, 0, 0),
(2230, 137, 20113, 'org_chrblk', 3, 0, 1, 0, 0, 0),
(2231, 137, 20115, 'org_chrpnk', 3, 0, 1, 0, 0, 0),
(2232, 76, 20125, 'val09_floor', 3, 0, 1, 0, 0, 0),
(2233, 76, 20131, 'val09_floor2', 3, 0, 1, 0, 0, 0),
(2234, 76, 20198, 'val09_wdrobe_b', 5, 0, 1, 0, 0, 0),
(2235, 76, 20199, 'val09_wall2', 4, 0, 1, 0, 0, 0),
(2236, 76, 20201, 'val09_wall1', 4, 0, 1, 0, 0, 0),
(2237, 76, 20204, 'val09_wdrobe_g', 5, 0, 1, 0, 0, 0),
(2238, 76, 20134, 'val_hSeat*1', 3, 0, 1, 0, 0, 0),
(2239, 76, 20135, 'val_hSeat*2', 3, 0, 1, 0, 0, 0),
(2240, 76, 20136, 'val_hSeat*3', 3, 0, 1, 0, 0, 0),
(2241, 76, 20137, 'val_hSeat*4', 3, 0, 1, 0, 0, 0),
(2242, 76, 20138, 'val_hSeat*5', 3, 0, 1, 0, 0, 0),
(2243, 76, 20139, 'val_hSeat*6', 3, 0, 1, 0, 0, 0),
(2244, 76, 20140, 'val_hSeat*7', 3, 0, 1, 0, 0, 0),
(2245, 76, 20141, 'val_basket', 3, 0, 1, 0, 0, 0),
(2246, 76, 20190, 'val_table1', 4, 0, 1, 0, 0, 0),
(2248, 27, 20093, 'xm09_lrgBauble', 10, 0, 1, 0, 0, 0),
(2250, 42, 20109, 'xm09_trophy', 6, 0, 1, 0, 0, 0),
(2251, 27, 20171, 'xm09_bauble_12', 3, 0, 1, 0, 0, 0),
(2252, 27, 20172, 'xm09_bauble_16', 3, 0, 1, 0, 0, 0),
(2253, 27, 20173, 'xm09_bauble_17', 3, 0, 1, 0, 0, 0),
(2254, 27, 20174, 'xm09_bauble_15', 3, 0, 1, 0, 0, 0),
(2255, 27, 20175, 'xm09_bauble_10', 3, 0, 1, 0, 0, 0),
(2256, 27, 20176, 'xm09_bauble_9', 3, 0, 1, 0, 0, 0),
(2257, 27, 20177, 'xm09_bauble_18', 3, 0, 1, 0, 0, 0),
(2258, 27, 20178, 'xm09_bauble_13', 3, 0, 1, 0, 0, 0),
(2259, 27, 20179, 'xm09_bauble_2', 3, 0, 1, 0, 0, 0),
(2260, 27, 20180, 'xm09_bauble_1', 3, 0, 1, 0, 0, 0),
(2261, 27, 20181, 'xm09_bauble_22', 3, 0, 1, 0, 0, 0),
(2262, 27, 20182, 'xm09_bauble_3', 3, 0, 1, 0, 0, 0),
(2263, 27, 20183, 'xm09_bauble_21', 3, 0, 1, 0, 0, 0),
(2264, 27, 20184, 'xm09_bauble_8', 3, 0, 1, 0, 0, 0),
(2265, 27, 20185, 'xm09_bauble_4', 3, 0, 1, 0, 0, 0),
(2266, 27, 20186, 'xm09_bauble_5', 3, 0, 1, 0, 0, 0),
(2267, 27, 20187, 'xm09_bauble_11', 3, 0, 1, 0, 0, 0),
(2268, 27, 20188, 'xm09_bauble_20', 3, 0, 1, 0, 0, 0),
(2269, 27, 20191, 'xm09_bauble_14', 3, 0, 1, 0, 0, 0),
(2270, 27, 20192, 'xm09_bauble_7', 3, 0, 1, 0, 0, 0),
(2271, 27, 20193, 'xm09_bauble_6', 3, 0, 1, 0, 0, 0),
(2272, 27, 20194, 'xm09_bauble_19', 3, 0, 1, 0, 0, 0),
(2273, 76, 20132, 'teddy_basic', 4, 0, 1, 0, 0, 0),
(2274, 76, 20133, 'teddy_pendergrass', 5, 0, 1, 0, 0, 0),
(2275, 76, 20142, 'teddy_bear', 3, 0, 1, 0, 0, 0),
(2276, 76, 20143, 'teddy_pink', 4, 0, 1, 0, 0, 0),
(2277, 160, 20079, 'nest_plow_reg', 3, 0, 1, 0, 0, 0),
(2278, 160, 20080, 'nest_snug_yel', 4, 0, 1, 0, 0, 0),
(2279, 160, 20085, 'nest_snug_grn', 4, 0, 1, 0, 0, 0),
(2280, 160, 20086, 'nest_snug_red', 4, 0, 1, 0, 0, 0),
(2281, 160, 20087, 'nest_snug_grn', 4, 0, 1, 0, 0, 0),
(2282, 160, 20088, 'nest_plow_bro', 3, 0, 1, 0, 0, 0),
(2283, 160, 20089, 'nest_plow_red', 3, 0, 1, 0, 0, 0),
(2284, 160, 20090, 'nest_snug_blu', 4, 0, 1, 0, 0, 0),
(2285, 160, 20092, 'nest_plow_blu', 3, 0, 1, 0, 0, 0),
(2286, 160, 20094, 'nest_dirt', 2, 0, 1, 0, 0, 0),
(2287, 160, 20095, 'nest_snug_prp', 3, 0, 1, 0, 0, 0),
(2288, 160, 20096, 'nest_nest', 3, 0, 1, 0, 0, 0),
(2289, 160, 20097, 'nest_nails', 2, 0, 1, 0, 0, 0),
(2290, 160, 20098, 'nest_basket', 2, 0, 1, 0, 0, 0),
(2291, 160, 20099, 'nest_ice', 2, 0, 1, 0, 0, 0),
(2292, 160, 20100, 'nest_plow_skl', 3, 0, 1, 0, 0, 0),
(2293, 160, 20101, 'nest_snug_bla', 4, 0, 1, 0, 0, 0),
(2294, 95, 20071, 'ads_gsArcade_2', 10, 0, 1, 0, 0, 0),
(2295, 95, 20073, 'ads_idol_l_carpet', 10, 0, 1, 0, 0, 0),
(2296, 134, 20068, 'ads_cllava2', 10, 0, 1, 0, 0, 0),
(2297, 95, 20072, 'ads_gsArcade_1', 10, 0, 1, 0, 0, 0),
(2298, 95, 20074, 'ads_mtvtrophy_silver', 10, 0, 1, 0, 0, 0),
(2299, 94, 20075, 'ads_spang_sleep', 10, 0, 1, 0, 0, 0),
(2300, 95, 20076, 'ads_mtvtrophy_gold', 10, 0, 1, 0, 0, 0),
(2301, 94, 20102, 'ads_cl_moodi', 10, 0, 1, 0, 0, 0),
(2302, 95, 20116, 'ads_chups', 10, 0, 1, 0, 0, 0),
(2303, 95, 20119, 'ads_droetker_paula', 10, 0, 1, 0, 0, 0),
(2304, 95, 20145, 'ads_percyrock', 10, 0, 1, 0, 0, 0),
(2305, 95, 20147, 'ads_idol_l_logo', 10, 0, 1, 0, 0, 0),
(2306, 95, 20197, 'ads_percyw', 10, 0, 1, 0, 0, 0),
(2307, 95, 20150, 'ads_mtv_tv', 10, 0, 1, 0, 0, 0),
(2308, 95, 20196, 'ads_tv_jaapuisto', 10, 0, 1, 0, 0, 0),
(2310, 134, 20159, 'byesw_loadscreen', 10, 0, 1, 0, 0, 0),
(2312, 95, 20149, 'ads_mtv_bigtv', 10, 0, 1, 0, 0, 0),
(2313, 95, 20148, 'ads_idol_l_tv', 10, 0, 1, 0, 0, 0),
(2314, 27, 20066, 'tree2', 2, 0, 1, 0, 0, 0),
(2317, 30, 20067, 'divider_poly3*7', 6, 0, 1, 0, 0, 0),
(2318, 37, 20077, 'ktchn_hlthNut', 5, 0, 1, 0, 0, 0),
(2319, 160, 20078, 'petfood8', 10, 0, 1, 0, 0, 0),
(2320, 160, 20081, 'petfood9', 10, 0, 1, 0, 0, 0),
(2321, 160, 20082, 'petfood10', 10, 0, 1, 0, 0, 0),
(2322, 160, 20083, 'petfood7', 10, 0, 1, 0, 0, 0),
(2323, 160, 20084, 'petfood6', 10, 0, 1, 0, 0, 0),
(2324, 160, 20091, 'petfood5', 10, 0, 1, 0, 0, 0),
(2325, 160, 20118, 'petfood12', 10, 0, 1, 0, 0, 0),
(2326, 160, 20120, 'petfood11', 10, 0, 1, 0, 0, 0),
(2327, 160, 20122, 'petfood13', 10, 0, 1, 0, 0, 0),
(2329, 94, 20146, 'md_can', 10, 0, 1, 0, 0, 0),
(2330, 66, 20152, 'hween09_curt', 4, 0, 1, 0, 0, 0),
(2331, 57, 20108, 'china_tiger', 4, 0, 1, 0, 0, 0),
(2332, 57, 20110, 'china_plmTree', 3, 0, 1, 0, 0, 0),
(2333, 134, 20114, 'china_tigrSeat', 3, 0, 1, 0, 0, 0),
(2334, 57, 20195, 'china_pstr3', 3, 0, 1, 0, 0, 0),
(2336, 62, 20207, 'rare_ironmaiden name', 5, 0, 1, 0, 0, 0),
(2337, 95, 20208, 'rare_trex name', 10, 0, 1, 0, 0, 0),
(2338, 143, 20209, 'beanstalk', 6, 0, 10, 0, 0, 0),
(2339, 95, 20210, 'rare_vdoll name', 3, 0, 1, 0, 0, 0),
(2340, 95, 20211, 'rare_mmmth name', 10, 0, 1, 0, 0, 0),
(2341, 136, 20212, 'crystal_patch', 3, 0, 1, 0, 0, 0),
(2342, 95, 20213, 'ads_boost_surfb name', 10, 0, 1, 0, 0, 0),
(2343, 95, 20214, 'ads_tlc_wheel name', 10, 0, 1, 0, 0, 0),
(2346, 16, 247, 'rare_daffodil_rug', 100, 100, 4, 0, 0, 0),
(2348, 134, 180, 'doorC', 10, 0, 100, 0, 0, 0),
(2443, 146, 20321, 'a0 pet3', 20000, 7500, 1, 0, 0, 0),
(2350, 143, 20221, 'garden_lupin4', 4, 0, 10, 0, 0, 0),
(2351, 143, 20222, 'garden_mursu3', 5, 0, 10, 0, 0, 0),
(2352, 143, 20223, 'garden_lupin5', 4, 0, 10, 0, 0, 0),
(2353, 143, 20224, 'garden_seed', 3, 0, 10, 0, 0, 0),
(2354, 143, 20225, 'garden_flytrap', 6, 0, 10, 0, 0, 0),
(2355, 143, 20226, 'garden_flo3', 2, 0, 10, 0, 0, 0),
(2359, 143, 20229, 'garden_mursu2', 5, 0, 10, 0, 0, 0),
(2357, 143, 20227, 'garden_volcano', 5, 0, 10, 0, 0, 0),
(2358, 143, 20228, 'garden_flolamp', 8, 0, 10, 0, 0, 0),
(2360, 143, 20230, 'garden_jyrki', 4, 0, 10, 0, 0, 0),
(2361, 143, 20231, 'garden_mursu4', 4, 0, 10, 0, 0, 0),
(2362, 143, 20232, 'garden_leaves', 3, 0, 10, 0, 0, 0),
(2363, 143, 20233, 'garden_lupin2', 4, 0, 10, 0, 0, 0),
(2364, 143, 20234, 'garden_lupin3', 4, 0, 10, 0, 0, 0),
(2365, 143, 20235, 'garden_mursu', 4, 0, 10, 0, 0, 0),
(2366, 143, 20238, 'garden_orchtree', 6, 0, 10, 0, 0, 0),
(2367, 143, 20237, 'garden_flo2', 2, 0, 10, 0, 0, 0),
(2368, 143, 20239, 'garden_lupin1', 4, 0, 10, 0, 0, 0),
(2369, 143, 20240, 'garden_staringbush', 5, 0, 10, 0, 0, 0),
(2370, 143, 20242, 'garden_flo1', 2, 0, 10, 0, 0, 0),
(2371, 143, 20243, 'garden_jungle', 5, 0, 10, 0, 0, 0),
(2372, 143, 20286, 'garden_wall', 4, 0, 10, 0, 0, 0),
(2374, 144, 20247, 'runway_display', 5, 0, 1, 0, 0, 0),
(2375, 144, 20248, 'runway_bigchr_5', 4, 0, 1, 0, 0, 0),
(2376, 144, 20249, 'runway_bigchr_4', 4, 0, 1, 0, 0, 0),
(2377, 144, 20253, 'runway_stool', 4, 0, 1, 0, 0, 0),
(2378, 144, 20254, 'runway_dvdr', 3, 0, 1, 0, 0, 0),
(2379, 144, 20255, 'runway_block_2', 5, 0, 1, 0, 0, 0),
(2380, 144, 20256, 'runway_bigchr_1', 5, 0, 1, 0, 0, 0),
(2381, 144, 20260, 'runway_block_1', 5, 0, 1, 0, 0, 0),
(2382, 144, 20261, 'runway_bench', 4, 0, 1, 0, 0, 0),
(2383, 144, 20262, 'runway_chair_2', 3, 0, 1, 0, 0, 0),
(2384, 144, 20265, 'runway_bigchr_3', 4, 0, 1, 0, 0, 0),
(2385, 144, 20268, 'runway_bigchr_2', 4, 0, 1, 0, 0, 0),
(2386, 144, 20270, 'runway_table_2', 4, 0, 1, 0, 0, 0),
(2387, 144, 20271, 'runway_table_1', 5, 0, 1, 0, 0, 0),
(2388, 144, 20272, 'runway_manqn_1', 4, 0, 1, 0, 0, 0),
(2389, 144, 20276, 'runway_head', 4, 0, 1, 0, 0, 0),
(2390, 144, 20277, 'runway_manqn_2', 4, 0, 1, 0, 0, 0),
(2391, 144, 20285, 'runway_chair_1', 3, 0, 1, 0, 0, 0),
(2392, 144, 20289, 'runway_shelf', 3, 0, 1, 0, 0, 0),
(2393, 144, 20292, 'runway_fabric', 3, 0, 1, 0, 0, 0),
(2394, 8, 20245, 'hc2_frplc', 5, 0, 1, 0, 0, 0),
(2395, 8, 20246, 'hc2_barchair', 3, 0, 1, 0, 0, 0),
(2396, 8, 20250, 'hc3_dc', 4, 0, 1, 0, 0, 0),
(2397, 8, 20252, 'hc2_sofatbl', 4, 0, 1, 0, 0, 0),
(2398, 8, 20257, 'hc2_biglamp', 3, 0, 1, 0, 0, 0),
(2399, 8, 20258, 'hc2_sofa', 4, 0, 1, 0, 0, 0),
(2400, 8, 20259, 'hc2_carpet', 5, 0, 1, 0, 0, 0),
(2401, 8, 20264, 'hc3_table', 3, 0, 1, 0, 0, 0),
(2402, 8, 20266, 'hc3_stool', 3, 0, 1, 0, 0, 0),
(2403, 8, 20267, 'hc3_sofa', 4, 0, 1, 0, 0, 0),
(2404, 8, 20269, 'hc2_armchair', 3, 0, 1, 0, 0, 0),
(2405, 8, 20273, 'hc2_dvn', 4, 0, 1, 0, 0, 0),
(2406, 8, 20274, 'hc3_light', 3, 0, 1, 0, 0, 0),
(2407, 8, 20275, 'hc3_shelf', 5, 0, 1, 0, 0, 0),
(2408, 8, 20278, 'hc2_divider', 3, 0, 1, 0, 0, 0),
(2409, 8, 20279, 'hc2_coffee', 5, 0, 1, 0, 0, 0),
(2410, 8, 20280, 'hc2_cart', 3, 0, 1, 0, 0, 0),
(2411, 8, 20281, 'hc3_bard', 10, 0, 1, 0, 0, 0),
(2412, 8, 20282, 'hc3_hugelamp', 5, 0, 1, 0, 0, 0),
(2413, 8, 20283, 'hc3_divider', 3, 0, 1, 0, 0, 0),
(2414, 8, 20284, 'hc2_vase', 4, 0, 1, 0, 0, 0),
(2415, 8, 20288, 'hc3_walldeco', 10, 0, 1, 0, 0, 0),
(2416, 134, 20295, 'camera', 10, 0, 1, 0, 0, 0),
(2417, 134, 20045, 'arabian_tile', 10, 0, 100, 0, 0, 0),
(2418, 95, 20241, 'ads_grefusa_yum', 10, 0, 1, 0, 0, 0),
(2419, 95, 20244, 'merger_chesT', 10, 0, 1, 0, 0, 0),
(2420, 95, 20263, 'ads_cheetos name', 10, 0, 1, 0, 0, 0),
(2421, 95, 20287, 'ads_tv_yle name', 10, 0, 1, 0, 0, 0),
(2422, 95, 20290, 'ads_nokia_x6', 10, 0, 1, 0, 0, 0),
(2423, 95, 20291, 'ads_target_wall', 10, 0, 1, 0, 0, 0),
(2424, 95, 20293, 'ads_latrobe_flag', 10, 0, 1, 0, 0, 0),
(2425, 27, 20296, 'holly', 4, 0, 1, 0, 0, 0),
(2442, 141, 20319, 'a0 pet5', 20000, 7500, 1, 0, 0, 0),
(4964, 161, 20339, 'bw_water_1', 3, 0, 1, 0, 0, 0),
(4965, 161, 20338, 'bw_tele', 5, 0, 1, 0, 0, 0),
(4969, 161, 20339, 'bw_water_1', 60, 0, 100, 0, 0, 0),
(29910, 161, 29910, 'bw_water_2', 5, 0, 1, 0, 0, 0),
(57009, 161, 29904, 'bw_chair', 4, 0, 1, 0, 0, 0),
(57010, 161, 29903, 'bw_sboard', 2, 0, 1, 0, 0, 0),
(57011, 161, 29909, 'bw_fnc', 2, 0, 1, 0, 0, 0),
(57012, 161, 29901, 'bw_lgchair', 5, 0, 1, 0, 0, 0),
(57013, 161, 29908, 'bw_croc', 4, 0, 1, 0, 0, 0),
(57014, 161, 29907, 'bw_bball', 2, 0, 1, 0, 0, 0),
(57015, 161, 29906, 'bw_table', 3, 0, 1, 0, 0, 0),
(57016, 159, 29916, 'prison_crnr', 4, 0, 1, 0, 0, 0),
(57017, 159, 29913, 'prison_dvdr1', 5, 0, 1, 0, 0, 0),
(57018, 159, 29912, 'prison_gate', 4, 0, 1, 0, 0, 0),
(57019, 159, 29911, 'prison_dvdr2', 5, 0, 1, 0, 0, 0),
(57020, 159, 29914, 'prison_stone', 1, 0, 1, 0, 0, 0),
(57021, 159, 29915, 'prison_tower', 10, 0, 1, 0, 0, 0),
(57022, 159, 29913, 'prison_dvdr1', 20, 0, 10, 0, 0, 0),
(57023, 159, 29911, 'prison_dvdr2', 20, 0, 10, 0, 0, 0),
(2483, 171, 20354, 'fball_score_y', 15, 0, 1, 0, 0, 0),
(2482, 171, 20353, 'fball_score_r', 15, 0, 1, 0, 0, 0),
(2481, 171, 20352, 'fball_score_g', 15, 0, 1, 0, 0, 0),
(2480, 171, 20351, 'fball_score_b', 15, 0, 1, 0, 0, 0),
(2479, 171, 20350, 'fball_ptch8', 5, 0, 1, 0, 0, 0),
(2478, 171, 20349, 'fball_ptch7', 5, 0, 1, 0, 0, 0),
(2477, 171, 20348, 'fball_ptch6', 5, 0, 1, 0, 0, 0),
(2476, 171, 20347, 'fball_ptch5', 5, 0, 1, 0, 0, 0),
(2475, 171, 20346, 'fball_ptch4', 5, 0, 1, 0, 0, 0),
(2474, 171, 20345, 'fball_ptch3', 5, 0, 1, 0, 0, 0),
(2473, 171, 20344, 'fball_ptch2', 5, 0, 1, 0, 0, 0),
(2472, 171, 20343, 'fball_ptch1', 5, 0, 1, 0, 0, 0),
(2471, 171, 20342, 'fball_ptch0', 5, 0, 1, 0, 0, 0),
(2470, 171, 20341, 'fball_counter', 10, 0, 1, 0, 0, 0),
(2469, 171, 20340, 'fball_gate', 10, 0, 1, 0, 0, 0),
(2468, 171, 20355, 'fball_light', 10, 0, 1, 0, 0, 0),
(2467, 171, 20356, 'fball_goal_y', 15, 0, 1, 0, 0, 0),
(2466, 171, 20357, 'fball_goal_r', 15, 0, 1, 0, 0, 0),
(2465, 171, 20358, 'fball_goal_g', 15, 0, 1, 0, 0, 0),
(2464, 171, 20359, 'fball_goal_b', 15, 0, 1, 0, 0, 0),
(2463, 171, 20360, 'fball_fnc3', 10, 0, 1, 0, 0, 0),
(2462, 171, 20361, 'fball_fnc1', 10, 0, 1, 0, 0, 0),
(2461, 171, 20362, 'fball_crnr', 10, 0, 1, 0, 0, 0),
(2460, 171, 20363, 'fball_cote', 10, 0, 1, 0, 0, 0),
(2459, 171, 20364, 'fball_bench', 10, 0, 1, 0, 0, 0),
(2458, 171, 20365, 'fball_ball5', 20, 0, 1, 0, 0, 0),
(2457, 171, 20366, 'fball_ball4', 20, 0, 1, 0, 0, 0),
(2456, 171, 20367, 'fball_ball2', 20, 0, 1, 0, 0, 0),
(2455, 171, 20368, 'fball_ball', 20, 0, 1, 0, 0, 0),
(2454, 171, 20369, 'fball_audbench', 7, 0, 1, 0, 0, 0),
(2453, 171, 20370, 'fball_trophy', 35, 0, 1, 0, 0, 0),
(10289, 497, 10289, 'easel_0', 25, 0, 1, 0, 0, 0),
(10290, 497, 10290, 'easel_1', 25, 0, 1, 0, 0, 0),
(10291, 496, 10291, 'easel_2', 25, 0, 1, 0, 0, 0),
(10292, 497, 10292, 'easel_3', 25, 0, 1, 0, 0, 0),
(10293, 497, 10293, 'easel_4', 25, 0, 1, 0, 0, 0),
(10294, 497, 10294, 'easel_2', 25, 0, 1, 0, 0, 0),
(2713, 174, 20372, 'party_crate2_1', 6, 0, 1, 0, 0, 0),
(2714, 174, 20373, 'party_crate1_3', 6, 0, 1, 0, 0, 0),
(2715, 174, 20374, 'party_crate1_4', 15, 0, 1, 0, 0, 0),
(2716, 174, 20375, 'party_crate1_1', 15, 0, 1, 0, 0, 0),
(2717, 174, 20376, 'party_crate1_2', 5, 0, 1, 0, 0, 0),
(2718, 174, 20377, 'party_crate2_2', 5, 0, 1, 0, 0, 0),
(2719, 174, 20378, 'party_crate2_3', 5, 0, 1, 0, 0, 0),
(2720, 174, 20379, 'party_crate2_4', 5, 0, 1, 0, 0, 0),
(2721, 174, 20380, 'party_djset', 10, 0, 1, 0, 0, 0),
(41082, 165, 25355, 'bw_lgchair', 8, 0, 1, 0, 0, 0),
(41083, 165, 25359, 'bw_fin', 15, 0, 1, 0, 0, 0),
(41084, 165, 25360, 'bw_ccnuts', 3, 0, 1, 0, 0, 0),
(41085, 165, 25361, 'bw_shower', 6, 0, 1, 0, 0, 0),
(41086, 165, 25362, 'bw_water_2', 10, 0, 1, 0, 0, 0),
(41087, 165, 25363, 'bw_croc', 7, 0, 1, 0, 0, 0),
(41088, 165, 25364, 'bw_sboard', 6, 0, 1, 0, 0, 0),
(41089, 165, 25366, 'bw_table', 4, 0, 1, 0, 0, 0),
(41090, 165, 25367, 'bw_ball', 11, 0, 1, 0, 0, 0),
(41091, 165, 25368, 'bw_mttrss', 6, 0, 1, 0, 0, 0),
(41092, 165, 25369, 'bw_van', 25, 0, 1, 0, 0, 0),
(41094, 165, 25371, 'bw_fnc_crnr', 4, 0, 1, 0, 0, 0),
(41095, 165, 25372, 'bw_fnc', 3, 0, 1, 0, 0, 0),
(41097, 165, 25357, 'bw_sofa', 5, 0, 1, 0, 0, 0),
(41098, 165, 25354, 'bw_boat', 12, 0, 1, 0, 0, 0),
(41099, 165, 25365, 'bw_chair', 4, 0, 1, 0, 0, 0),
(77025, 165, 59939, 'bw_jaws', 5, 0, 1, 0, 0, 0),
(97308, 165, 95383, 'bw_pool_a3', 5, 0, 1, 0, 0, 0),
(97309, 165, 95382, 'bw_pool_a2', 5, 0, 1, 0, 0, 0),
(97310, 165, 95381, 'bw_pool_b2', 5, 0, 1, 0, 0, 0),
(97311, 165, 95380, 'bw_mttrss_g', 5, 0, 1, 0, 0, 0),
(97312, 165, 95379, 'bw_boat_p', 5, 0, 1, 0, 0, 0),
(97313, 165, 95378, 'bw_sofa_p', 5, 0, 1, 0, 0, 0),
(97314, 165, 95377, 'bw_fnc_crnr_g', 5, 0, 1, 0, 0, 0),
(97315, 165, 95376, 'bw_fnc_crnr_p', 5, 0, 1, 0, 0, 0),
(97318, 165, 95395, 'bw_fnc_g', 5, 0, 1, 0, 0, 0),
(600000, 165, 25362, 'bw_water_2', 10, 0, 50, 0, 0, 0),
(97319, 165, 95394, 'bw_sofa_p', 5, 0, 1, 0, 0, 0),
(97320, 165, 95393, 'bw_sofa_g', 5, 0, 1, 0, 0, 0),
(97321, 165, 95392, 'bw_van_g', 5, 0, 1, 0, 0, 0),
(97322, 165, 95391, 'bw_van_p', 5, 0, 1, 0, 0, 0),
(97323, 165, 95390, 'bw_table_p', 5, 0, 1, 0, 0, 0),
(97324, 165, 95389, 'bw_table_g', 5, 0, 1, 0, 0, 0),
(97326, 165, 95387, 'bw_surfb_g', 5, 0, 1, 0, 0, 0),
(97327, 165, 95386, 'bw_fnc_crnr_p', 5, 0, 1, 0, 0, 0),
(97328, 165, 95385, 'bw_pool_b1', 5, 0, 1, 0, 0, 0),
(97329, 165, 95384, 'bw_pool_a1', 5, 0, 1, 0, 0, 0),
(97317, 165, 95374, 'ads_grefusa_surfb', 5, 0, 1, 0, 0, 0),
(97316, 165, 95375, 'ads_pepsi0', 5, 0, 1, 0, 0, 0),
(10355, 502, 10355, 'african_tree2', 10, 0, 1, 0, 0, 0),
(10354, 502, 10354, 'african_tree1', 10, 0, 1, 0, 0, 0),
(10353, 502, 10353, 'african_stage', 5, 0, 1, 0, 0, 0),
(10352, 502, 10352, 'african_patch', 10, 0, 1, 0, 0, 0),
(10351, 502, 10351, 'african_fence', 5, 0, 1, 0, 0, 0),
(10350, 502, 10350, 'african_bones', 3, 0, 1, 0, 0, 0),
(10357, 503, 10357, 'ktchn10_cabnt', 5, 0, 1, 0, 0, 0),
(10358, 503, 10358, 'ktchn10_pot', 1, 0, 1, 0, 0, 0),
(10359, 503, 10359, 'ktchn10_sink', 10, 0, 1, 0, 0, 0),
(10360, 503, 10360, 'ktchn10_stove', 10, 0, 1, 0, 0, 0),
(10278, 496, 10278, 'hosptl_bbag name', 10, 0, 1, 0, 0, 0),
(10279, 496, 10279, 'hosptl_bed', 10, 0, 1, 0, 0, 0),
(10280, 496, 10280, 'hosptl_cab1', 5, 0, 1, 0, 0, 0),
(10281, 496, 10281, 'hosptl_cab2', 3, 0, 1, 0, 0, 0),
(10282, 496, 10282, 'hosptl_curtain', 3, 0, 1, 0, 0, 0),
(10283, 496, 10283, 'hosptl_defibs', 5, 0, 1, 0, 0, 0),
(10284, 496, 10284, 'hosptl_light', 15, 0, 1, 0, 0, 0),
(10285, 496, 10285, 'hosptl_seat', 5, 0, 1, 0, 0, 0),
(10286, 496, 10286, 'hosptl_skele', 1, 0, 1, 0, 0, 0),
(10287, 496, 10287, 'hosptl_xray', 10, 0, 1, 0, 0, 0),
(900000, 105, 416, 'rare_dragonlamp*3', 10000, 2500, 1, 0, 0, 0),
(89945, 200, 89945, 'cubie_rug_b', 3, 0, 1, 0, 0, 0),
(89946, 200, 89946, 'cubie_lamp_p', 3, 0, 1, 0, 0, 0),
(89947, 200, 89947, 'cubie_shelf_3_p', 3, 0, 1, 0, 0, 0),
(89948, 200, 89948, 'cubie_shelf_4_b', 3, 0, 1, 0, 0, 0),
(89949, 200, 89949, 'cubie_shelf_1_b', 3, 0, 1, 0, 0, 0),
(89950, 200, 89950, 'cubie_shelf_1_p', 3, 0, 1, 0, 0, 0),
(89951, 200, 89951, 'cubie_chair_p', 3, 0, 1, 0, 0, 0),
(89952, 200, 89952, 'cubie_shelf_4_p', 3, 0, 1, 0, 0, 0),
(89953, 200, 89953, 'cubie_bigtable_p', 3, 0, 1, 0, 0, 0),
(89954, 200, 89954, 'cubie_shelf_0_p', 3, 0, 1, 0, 0, 0),
(89955, 200, 89955, 'cubie_beanbag_b', 3, 0, 1, 0, 0, 0),
(89956, 200, 89956, 'cubie_chair_b', 3, 0, 1, 0, 0, 0),
(89957, 200, 89957, 'cubie_bed_b', 3, 0, 1, 0, 0, 0),
(89958, 200, 89958, 'cubie_bigtable_b', 3, 0, 1, 0, 0, 0),
(89959, 200, 89959, 'cubie_stool_b', 3, 0, 1, 0, 0, 0),
(89960, 200, 89960, 'cubie_beanbag_p', 3, 0, 1, 0, 0, 0),
(89961, 200, 89961, 'cubie_shelf_0_b', 3, 0, 1, 0, 0, 0),
(89962, 200, 89962, 'cubie_shelf_2_p', 3, 0, 1, 0, 0, 0),
(89963, 200, 89963, 'cubie_rug_p', 3, 0, 1, 0, 0, 0),
(89964, 200, 89964, 'cubie_sofaseat_b', 3, 0, 1, 0, 0, 0),
(89965, 200, 89965, 'cubie_table', 3, 0, 1, 0, 0, 0),
(89966, 200, 89966, 'cubie_sofaseat_p', 3, 0, 1, 0, 0, 0),
(89967, 200, 89967, 'cubie_bed_p', 3, 0, 1, 0, 0, 0),
(89968, 200, 89968, 'cubie_shelf_3_b', 3, 0, 1, 0, 0, 0),
(89969, 200, 89969, 'cubie_shelf_2_b', 3, 0, 1, 0, 0, 0),
(89970, 200, 89970, 'cubie_lamp_b', 3, 0, 1, 0, 0, 0),
(89971, 200, 89971, 'cubie_stool_p', 3, 0, 1, 0, 0, 0),
(89972, 200, 89972, 'cubie_wallshelf_b', 3, 0, 1, 0, 0, 0),
(89973, 200, 89973, 'cubie_decklight_p', 3, 0, 1, 0, 0, 0),
(89974, 200, 89974, 'cubie_wallshelf_p', 3, 0, 1, 0, 0, 0),
(89975, 200, 89975, 'cubie_decal_0', 3, 0, 1, 0, 0, 0),
(89976, 200, 89976, 'cubie_decal_3', 3, 0, 1, 0, 0, 0),
(89977, 200, 89977, 'cubie_decal_1_p', 3, 0, 1, 0, 0, 0),
(89978, 200, 89978, 'cubie_decklight_b', 3, 0, 1, 0, 0, 0),
(89979, 200, 89979, 'cubie_decal_1_b', 3, 0, 1, 0, 0, 0),
(89980, 200, 89980, 'cubie_decal_2_b', 3, 0, 1, 0, 0, 0),
(89981, 200, 89981, 'cubie_decal_3_p', 3, 0, 1, 0, 0, 0),
(89982, 200, 89982, 'cubie_decal_2_p', 3, 0, 1, 0, 0, 0),
(89983, 200, 89983, 'cubie_decal_3_b', 3, 0, 1, 0, 0, 0),
(89984, 175, 89984, 'newbie_present', 3, 0, 1, 0, 0, 0),
(89985, 175, 89985, 'tv_flat', 3, 0, 1, 0, 0, 0),
(89986, 175, 89986, 'waasa_table2', 3, 0, 1, 0, 0, 0),
(89987, 175, 89987, 'computer_flatscreen', 3, 0, 1, 0, 0, 0),
(89988, 175, 89988, 'waasa_chair', 3, 0, 1, 0, 0, 0),
(89989, 175, 89989, 'waasa_ship2', 3, 0, 1, 0, 0, 0),
(89990, 175, 89990, 'waasa_ship1', 3, 0, 1, 0, 0, 0),
(89991, 175, 89991, 'waasa_bunk_bed', 3, 0, 1, 0, 0, 0),
(89992, 175, 89992, 'computer_laptop', 3, 0, 1, 0, 0, 0),
(89993, 175, 89993, 'computer_old', 3, 0, 1, 0, 0, 0),
(89994, 175, 89994, 'waasa_table1', 3, 0, 1, 0, 0, 0),
(89995, 175, 89995, 'waasa_desk', 3, 0, 1, 0, 0, 0),
(89996, 175, 89996, 'waasa_wall_shelf2', 3, 0, 1, 0, 0, 0),
(89997, 175, 89997, 'waasa_wall_shelf1', 3, 0, 1, 0, 0, 0),
(89914, 169, 89914, 'nest_frog', 3, 0, 1, 0, 0, 0),
(89915, 169, 89915, 'pond', 3, 0, 1, 0, 0, 0),
(89916, 169, 89916, 'val11_present', 3, 0, 1, 0, 0, 0),
(89917, 169, 89917, 'prizetrophy_cine', 3, 0, 1, 0, 0, 0),
(89918, 169, 89918, 'cine_vipsign', 3, 0, 1, 0, 0, 0),
(89919, 169, 89919, 'limo_b_mid3', 3, 0, 1, 0, 0, 0),
(89920, 169, 89920, 'limo_b_mid2', 3, 0, 1, 0, 0, 0),
(89921, 169, 89921, 'limo_b_front', 3, 0, 1, 0, 0, 0),
(89922, 169, 89922, 'limo_b_mid', 3, 0, 1, 0, 0, 0),
(89923, 169, 89923, 'cine_star', 3, 0, 1, 0, 0, 0),
(89924, 169, 89924, 'limo_b_back', 3, 0, 1, 0, 0, 0),
(89925, 169, 89925, 'ads_bigtv_missmix', 3, 0, 1, 0, 0, 0),
(89926, 169, 89926, 'cine_curtain', 3, 0, 1, 0, 0, 0),
(89927, 169, 89927, 'cine_screen', 3, 0, 1, 0, 0, 0),
(89928, 169, 89928, 'theatre_seat_g', 3, 0, 1, 0, 0, 0),
(89929, 169, 89929, 'cine_tile', 3, 0, 1, 0, 0, 0),
(89930, 169, 89930, 'cine_bench_b', 3, 0, 1, 0, 0, 0),
(89931, 169, 89931, 'theatre_seat_b', 3, 0, 1, 0, 0, 0),
(89932, 169, 89932, 'cine_roof', 3, 0, 1, 0, 0, 0),
(89933, 169, 89933, 'cine_popcorn', 3, 0, 1, 0, 0, 0),
(89934, 169, 89934, 'cine_bench', 3, 0, 1, 0, 0, 0),
(89935, 169, 89935, 'cine_bench_b', 3, 0, 1, 0, 0, 0),
(89936, 169, 89936, 'cine_ticket_booth', 3, 0, 1, 0, 0, 0),
(89937, 169, 89937, 'cine_projector', 3, 0, 1, 0, 0, 0),
(89907, 201, 89907, 'gothic_st_glass', 3, 0, 1, 0, 0, 0),
(89908, 201, 89908, 'gothic_candles', 3, 0, 1, 0, 0, 0),
(89909, 201, 89909, 'gothic_bed', 3, 0, 1, 0, 0, 0),
(89910, 201, 89910, 'gothic_desk', 3, 0, 1, 0, 0, 0),
(89911, 201, 89911, 'gothic_bowl', 3, 0, 1, 0, 0, 0),
(89912, 201, 89912, 'ads_grefu_trophy', 3, 0, 1, 0, 0, 0),
(77701, 777, 77701, 'bling11_block', 3, 0, 1, 0, 0, 0),
(77702, 777, 77702, 'bling11_dvd', 3, 0, 1, 0, 0, 0),
(77703, 777, 77703, 'bling11_dvn', 3, 0, 1, 0, 0, 0),
(77704, 777, 77704, 'bling11_floor', 3, 0, 1, 0, 0, 0),
(77705, 777, 77705, 'bling11_pillar', 3, 0, 1, 0, 0, 0),
(77706, 777, 77706, 'bling11_plant', 3, 0, 1, 0, 0, 0),
(77707, 777, 77707, 'bling11_rug1', 3, 0, 1, 0, 0, 0),
(77708, 777, 77708, 'bling11_rug2', 3, 0, 1, 0, 0, 0),
(77709, 777, 77709, 'bling11_seat1', 3, 0, 1, 0, 0, 0),
(77710, 777, 77710, 'bling11_seat2', 3, 0, 1, 0, 0, 0),
(77711, 777, 77711, 'bling11_slot', 3, 0, 1, 0, 0, 0),
(77712, 777, 77712, 'bling11_sofa', 3, 0, 1, 0, 0, 0),
(77713, 777, 77713, 'bling11_statue1', 3, 0, 1, 0, 0, 0),
(77714, 777, 77714, 'bling11_statue2', 3, 0, 1, 0, 0, 0),
(77715, 777, 77715, 'bling11_tele', 3, 0, 1, 0, 0, 0),
(77716, 777, 77716, 'bling11_towels', 3, 0, 1, 0, 0, 0),
(77717, 777, 77717, 'bling11_val11_floor', 3, 0, 1, 0, 0, 0),
(77801, 778, 77801, 'china_rabbit', 5, 0, 1, 0, 0, 0),
(89900, 899, 89900, 'limo_w_front', 3, 0, 1, 0, 0, 0),
(89901, 899, 89901, 'limo_w_mid', 3, 0, 1, 0, 0, 0),
(89902, 899, 89902, 'limo_w_mid2', 3, 0, 1, 0, 0, 0),
(89903, 899, 89903, 'limo_w_back', 3, 0, 1, 0, 0, 0),
(89904, 160, 89904, 'petfood19', 3, 0, 1, 0, 0, 0),
(89905, 160, 89905, 'petfood18', 3, 0, 1, 0, 0, 0),
(89906, 160, 89906, 'petfood17', 3, 0, 1, 0, 0, 0),
(3000, 300, 30000, 'hween10_bat', 3, 0, 1, 0, 0, 0),
(3001, 300, 30001, 'hween10_card_1', 3, 0, 1, 0, 0, 0),
(3002, 300, 30002, 'hween10_card_2', 3, 0, 1, 0, 0, 0),
(3003, 300, 30003, 'hween10_card_3', 3, 0, 1, 0, 0, 0),
(3004, 300, 30004, 'hween10_card_4', 3, 0, 1, 0, 0, 0),
(3005, 300, 30005, 'hween10_card_5', 3, 0, 1, 0, 0, 0),
(3006, 300, 30006, 'hween10_card_6', 3, 0, 1, 0, 0, 0),
(3007, 300, 30007, 'hween10_chicken', 3, 0, 1, 0, 0, 0),
(3008, 300, 30008, 'hween10_ffly', 3, 0, 1, 0, 0, 0),
(3009, 300, 30009, 'hween10_fog', 3, 0, 1, 0, 0, 0),
(3010, 300, 30010, 'hween10_jar', 3, 0, 1, 0, 0, 0),
(3011, 300, 30011, 'hween10_logs', 3, 0, 1, 0, 0, 0),
(3012, 300, 30012, 'hween10_pond', 3, 0, 1, 0, 0, 0),
(3013, 300, 30013, 'hween10_portch', 3, 0, 1, 0, 0, 0),
(3014, 300, 30014, 'hween10_skullpost', 3, 0, 1, 0, 0, 0),
(3015, 300, 30015, 'hween10_swamp', 3, 0, 1, 0, 0, 0),
(3016, 300, 30016, 'hween10_tarot', 3, 0, 1, 0, 0, 0),
(3017, 300, 30017, 'hween10_tele', 3, 0, 1, 0, 0, 0),
(3018, 300, 30018, 'hween10_throne', 3, 0, 1, 0, 0, 0),
(3019, 300, 30019, 'hween10_tree', 3, 0, 1, 0, 0, 0),
(3020, 300, 30020, 'hween10_voodoo1', 3, 0, 1, 0, 0, 0),
(3021, 300, 30021, 'hween10_voodoo2', 3, 0, 1, 0, 0, 0),
(3022, 300, 30022, 'hween10_voodoo3', 3, 0, 1, 0, 0, 0),
(3023, 300, 30023, 'hween10_wallskull', 3, 0, 1, 0, 0, 0),
(99904, 600, 99904, 'year2011_waver_b', 25, 0, 1, 0, 0, 0),
(99905, 600, 99905, 'year2011_waver_g', 25, 0, 1, 0, 0, 0),
(99906, 600, 99906, 'year2011_waver_r', 25, 0, 1, 0, 0, 0),
(99907, 600, 99907, 'year2011_waver_y', 25, 0, 1, 0, 0, 0),
(99908, 600, 99908, 'prizetrophy_2011_y', 25, 0, 1, 0, 0, 0),
(99909, 600, 99909, 'prizetrophy_2011_b', 25, 0, 1, 0, 0, 0),
(99910, 600, 99910, 'prizetrophy_2011_r', 25, 0, 1, 0, 0, 0),
(99911, 600, 99911, 'prizetrophy_2011_p', 25, 0, 1, 0, 0, 0),
(99912, 600, 99912, 'prizetrophy_2011_g', 25, 0, 1, 0, 0, 0),
(99913, 600, 99913, 'prizetrophy_2011_w', 25, 0, 1, 0, 0, 0),
(99914, 600, 99914, 'year2011', 25, 0, 1, 0, 0, 0),
(99000, 500, 99000, 'qt_xm10_nest', 10, 0, 1, 0, 0, 0),
(99001, 500, 99001, 'qt_xm10_icedragon', 10, 0, 1, 0, 0, 0),
(99002, 500, 99002, 'qt_xm10_stone', 10, 0, 1, 0, 0, 0),
(99003, 500, 99003, 'qt_xm10_icetiger', 10, 0, 1, 0, 0, 0),
(99004, 500, 99004, 'qt_xm10_trex', 10, 0, 1, 0, 0, 0),
(99005, 500, 99005, 'qt_xm10_palm_tree', 10, 0, 1, 0, 0, 0),
(99006, 500, 99006, 'qt_xm10_bench', 10, 0, 1, 0, 0, 0),
(99007, 500, 99007, 'qt_xm10_icelupin', 10, 0, 1, 0, 0, 0),
(99008, 500, 99008, 'qt_xm10_xmduck', 10, 0, 1, 0, 0, 0),
(99009, 500, 99009, 'qt_xm10_iceduck', 10, 0, 1, 0, 0, 0),
(99010, 500, 99010, 'qt_xm10_bauble1', 10, 0, 1, 0, 0, 0),
(99011, 500, 99011, 'qt_xm10_bauble2', 10, 0, 1, 0, 0, 0),
(99012, 500, 99012, 'qt_xm10_bauble3', 10, 0, 1, 0, 0, 0),
(99013, 500, 99013, 'qt_xm10_iceplasto', 10, 0, 1, 0, 0, 0),
(99014, 500, 99014, 'qt_xm10_ice_fish', 10, 0, 1, 0, 0, 0),
(99015, 500, 99015, 'qt_xm10_gnome', 10, 0, 1, 0, 0, 0),
(99016, 500, 99016, 'qt_xm10_icesilotable', 10, 0, 1, 0, 0, 0),
(99017, 500, 99017, 'qt_xm10_iceteddy', 10, 0, 1, 0, 0, 0),
(99018, 500, 99018, 'qt_xm10_elephant', 10, 0, 1, 0, 0, 0),
(99019, 500, 99019, 'qt_xm10_iceclubsofa', 10, 0, 1, 0, 0, 0),
(99020, 500, 99020, 'es_skating_ice', 10, 0, 1, 0, 0, 0),
(99021, 500, 99021, 'es_sidewalk', 10, 0, 1, 0, 0, 0),
(99022, 500, 99022, 'es_wpost', 10, 0, 1, 0, 0, 0),
(99023, 500, 99023, 'es_tagging', 10, 0, 1, 0, 0, 0),
(99024, 500, 99024, 'es_santa', 10, 0, 1, 0, 0, 0),
(99025, 500, 99025, 'es_window', 10, 0, 1, 0, 0, 0),
(99026, 500, 99026, 'es_bench', 10, 0, 1, 0, 0, 0),
(99027, 500, 99027, 'es_fnc_1', 10, 0, 1, 0, 0, 0),
(99028, 500, 99028, 'es_fnc_2', 10, 0, 1, 0, 0, 0),
(99029, 500, 99029, 'es_fnc_crnr', 10, 0, 1, 0, 0, 0),
(99030, 500, 99030, 'es_epictree', 10, 0, 1, 0, 0, 0),
(99031, 500, 99031, 'es_icestar_g', 10, 0, 1, 0, 0, 0),
(99032, 500, 99032, 'es_icestar_r', 10, 0, 1, 0, 0, 0),
(99033, 500, 99033, 'es_icestar_y', 10, 0, 1, 0, 0, 0),
(99034, 500, 99034, 'es_icestar', 10, 0, 1, 0, 0, 0),
(99035, 500, 99035, 'es_puck', 10, 0, 1, 0, 0, 0),
(99036, 500, 99036, 'es_roaster', 10, 0, 1, 0, 0, 0),
(99037, 500, 99037, 'es_lmppst', 10, 0, 1, 0, 0, 0),
(99038, 500, 99038, 'es_statue', 10, 0, 1, 0, 0, 0),
(3568424, 60, 3568405, 'exe_sensor', 3, 0, 1, 0, 0, 0),
(3568425, 60, 3568404, 'exe_seccam', 3, 0, 1, 0, 0, 0),
(3568426, 60, 3568403, 'exe_wrkdesk', 5, 0, 1, 0, 0, 0),
(3568427, 60, 3568402, 'exe_glassdvdr', 5, 0, 1, 0, 0, 0),
(3568428, 60, 3568401, 'exe_copier', 5, 0, 1, 0, 0, 0),
(99060, 501, 99082, 'es_box', 10, 0, 1, 0, 0, 0),
(99061, 501, 99083, 'es_counter', 15, 0, 1, 0, 0, 0),
(99062, 501, 99084, 'es_exit', 5, 0, 1, 0, 0, 0),
(99063, 501, 99085, 'es_gate_b', 4, 0, 1, 0, 0, 0),
(99064, 501, 99086, 'es_gate_g', 4, 0, 1, 0, 0, 0),
(99065, 501, 99087, 'es_gate_r', 4, 0, 1, 0, 0, 0),
(99066, 501, 99088, 'es_gate_y', 4, 0, 1, 0, 0, 0),
(99067, 501, 99091, 'es_score_b', 3, 0, 1, 0, 0, 0),
(99068, 501, 99092, 'es_score_g', 3, 0, 1, 0, 0, 0),
(99069, 501, 99090, 'es_score_r', 3, 0, 1, 0, 0, 0),
(99070, 501, 99089, 'es_score_y', 3, 0, 1, 0, 0, 0),
(99071, 501, 99083, 'es_tile', 8, 0, 1, 0, 0, 0),
(89938, 173, 89938, 'wf_box', 3, 0, 1, 0, 0, 0),
(89939, 173, 89939, 'wf_maze', 3, 0, 1, 0, 0, 0),
(89940, 173, 89940, 'ads_rangocactus', 3, 0, 1, 0, 0, 0),
(89941, 173, 89941, 'cine_glass', 3, 0, 1, 0, 0, 0),
(89942, 173, 89942, 'wf_cnd_has_furni_on', 3, 0, 1, 0, 0, 0),
(89943, 173, 89943, 'cine_light2', 3, 0, 1, 0, 0, 0),
(89944, 173, 89944, 'cine_light1', 3, 0, 1, 0, 0, 0),
(2444, 147, 20320, 'a0 pet4', 20000, 7500, 1, 0, 0, 0),
(2445, 148, 20323, 'a0 pet1', 20000, 7500, 1, 0, 0, 0),
(2446, 149, 20324, 'a0 pet0', 20000, 7500, 1, 0, 0, 0),
(2447, 150, 20322, 'a0 pet2', 20000, 7500, 1, 0, 0, 0),
(2530, 157, 20411, 'a0 pet6', 20000, 7500, 1, 0, 0, 0),
(2531, 158, 20412, 'a0 pet7', 20000, 7500, 1, 0, 0, 0),
(3568432, 170, 3568412, 'a0 pet8', 20000, 7500, 1, 0, 0, 0),
(3568433, 176, 3568413, 'a0 pet11', 20000, 7500, 1, 0, 0, 0),
(3568442, 182, 3568422, 'a0 pet10', 20000, 7500, 1, 0, 0, 0),
(900001, 105, 20210, 'rare_vdoll', 8500, 4500, 1, 0, 0, 0),
(3568954, 15, 19926, 'landscape_single_4.4', 3, 0, 1, 0, 0, 0),
(3568931, 15, 19894, 'floor_single_606', 3, 0, 1, 0, 0, 0),
(3568930, 15, 19894, 'floor_single_605', 3, 0, 1, 0, 0, 0),
(3568929, 15, 19894, 'floor_single_604', 3, 0, 1, 0, 0, 0),
(3568928, 15, 19894, 'floor_single_603', 3, 0, 1, 0, 0, 0),
(3568927, 15, 19894, 'floor_single_602', 3, 0, 1, 0, 0, 0),
(3568926, 15, 19894, 'floor_single_601', 3, 0, 1, 0, 0, 0),
(3568925, 15, 19894, 'floor_single_507', 3, 0, 1, 0, 0, 0),
(3568924, 15, 19894, 'floor_single_506', 3, 0, 1, 0, 0, 0),
(3568923, 15, 19894, 'floor_single_505', 3, 0, 1, 0, 0, 0),
(3568922, 15, 19894, 'floor_single_504', 3, 0, 1, 0, 0, 0),
(3568921, 15, 19894, 'floor_single_503', 3, 0, 1, 0, 0, 0),
(3568920, 15, 19894, 'floor_single_502', 3, 0, 1, 0, 0, 0),
(3568919, 15, 19894, 'floor_single_501', 3, 0, 1, 0, 0, 0),
(3568918, 15, 19894, 'floor_single_410', 3, 0, 1, 0, 0, 0),
(3568917, 15, 19894, 'floor_single_409', 3, 0, 1, 0, 0, 0),
(3568916, 15, 19894, 'floor_single_408', 3, 0, 1, 0, 0, 0),
(3568915, 15, 19894, 'floor_single_407', 3, 0, 1, 0, 0, 0),
(3568914, 15, 19894, 'floor_single_406', 3, 0, 1, 0, 0, 0),
(3568913, 15, 19894, 'floor_single_405', 3, 0, 1, 0, 0, 0),
(3568912, 15, 19894, 'floor_single_404', 3, 0, 1, 0, 0, 0),
(3568911, 15, 19894, 'floor_single_403', 3, 0, 1, 0, 0, 0),
(3568910, 15, 19894, 'floor_single_402', 3, 0, 1, 0, 0, 0),
(3568909, 15, 19894, 'floor_single_401', 3, 0, 1, 0, 0, 0),
(3568908, 15, 19894, 'floor_single_307', 3, 0, 1, 0, 0, 0),
(3568907, 15, 19894, 'floor_single_306', 3, 0, 1, 0, 0, 0),
(3568906, 15, 19894, 'floor_single_305', 3, 0, 1, 0, 0, 0),
(3568905, 15, 19894, 'floor_single_304', 3, 0, 1, 0, 0, 0),
(3568904, 15, 19894, 'floor_single_303', 3, 0, 1, 0, 0, 0),
(3568903, 15, 19894, 'floor_single_302', 3, 0, 1, 0, 0, 0),
(3568902, 15, 19894, 'floor_single_301', 3, 0, 1, 0, 0, 0),
(3568901, 15, 19894, 'floor_single_212', 3, 0, 1, 0, 0, 0),
(3568900, 15, 19894, 'floor_single_211', 3, 0, 1, 0, 0, 0),
(3568899, 15, 19894, 'floor_single_210', 3, 0, 1, 0, 0, 0),
(3568898, 15, 19894, 'floor_single_209', 3, 0, 1, 0, 0, 0),
(3568897, 15, 19894, 'floor_single_208', 3, 0, 1, 0, 0, 0),
(3568896, 15, 19894, 'floor_single_207', 3, 0, 1, 0, 0, 0),
(3568895, 15, 19894, 'floor_single_206', 3, 0, 1, 0, 0, 0),
(3568894, 15, 19894, 'floor_single_205', 3, 0, 1, 0, 0, 0),
(3568893, 15, 19894, 'floor_single_204', 3, 0, 1, 0, 0, 0),
(3568892, 15, 19894, 'floor_single_203', 3, 0, 1, 0, 0, 0),
(3568891, 15, 19894, 'floor_single_202', 3, 0, 1, 0, 0, 0),
(3568890, 15, 19894, 'floor_single_201', 3, 0, 1, 0, 0, 0),
(3568889, 15, 19894, 'floor_single_111', 3, 0, 1, 0, 0, 0),
(3568888, 15, 19894, 'floor_single_110', 3, 0, 1, 0, 0, 0),
(3568887, 15, 19894, 'floor_single_109', 3, 0, 1, 0, 0, 0),
(3568886, 15, 19894, 'floor_single_108', 3, 0, 1, 0, 0, 0),
(3568885, 15, 19894, 'floor_single_107', 3, 0, 1, 0, 0, 0),
(3568884, 15, 19894, 'floor_single_106', 3, 0, 1, 0, 0, 0),
(3568883, 15, 19894, 'floor_single_105', 3, 0, 1, 0, 0, 0),
(3568882, 15, 19894, 'floor_single_104', 3, 0, 1, 0, 0, 0),
(3568881, 15, 19894, 'floor_single_103', 3, 0, 1, 0, 0, 0),
(3568880, 15, 19894, 'floor_single_102', 3, 0, 1, 0, 0, 0),
(3568879, 15, 19894, 'floor_single_101', 3, 0, 1, 0, 0, 0),
(3568878, 15, 19896, 'wallpaper_single_3106', 3, 0, 1, 0, 0, 0),
(3568877, 15, 19896, 'wallpaper_single_3105', 3, 0, 1, 0, 0, 0),
(3568876, 15, 19896, 'wallpaper_single_3104', 3, 0, 1, 0, 0, 0),
(3568875, 15, 19896, 'wallpaper_single_3103', 3, 0, 1, 0, 0, 0),
(3568874, 15, 19896, 'wallpaper_single_3101', 3, 0, 1, 0, 0, 0),
(3568873, 15, 19896, 'wallpaper_single_3101', 3, 0, 1, 0, 0, 0),
(3568872, 15, 19896, 'wallpaper_single_3004', 3, 0, 1, 0, 0, 0),
(3568871, 15, 19896, 'wallpaper_single_3003', 3, 0, 1, 0, 0, 0),
(3568870, 15, 19896, 'wallpaper_single_3002', 3, 0, 1, 0, 0, 0),
(3568869, 15, 19896, 'wallpaper_single_3001', 3, 0, 1, 0, 0, 0),
(3568868, 15, 19896, 'wallpaper_single_2904', 3, 0, 1, 0, 0, 0),
(3568867, 15, 19896, 'wallpaper_single_2903', 3, 0, 1, 0, 0, 0),
(3568866, 15, 19896, 'wallpaper_single_2902', 3, 0, 1, 0, 0, 0),
(3568865, 15, 19896, 'wallpaper_single_2901', 3, 0, 1, 0, 0, 0),
(3568864, 15, 19896, 'wallpaper_single_2804', 3, 0, 1, 0, 0, 0),
(3568863, 15, 19896, 'wallpaper_single_2803', 3, 0, 1, 0, 0, 0),
(3568862, 15, 19896, 'wallpaper_single_2802', 3, 0, 1, 0, 0, 0),
(3568861, 15, 19896, 'wallpaper_single_2801', 3, 0, 1, 0, 0, 0),
(3568860, 15, 19896, 'wallpaper_single_2704', 3, 0, 1, 0, 0, 0),
(3568859, 15, 19896, 'wallpaper_single_2703', 3, 0, 1, 0, 0, 0),
(3568858, 15, 19896, 'wallpaper_single_2702', 3, 0, 1, 0, 0, 0),
(3568857, 15, 19896, 'wallpaper_single_2701', 3, 0, 1, 0, 0, 0),
(3568856, 15, 19896, 'wallpaper_single_2604', 3, 0, 1, 0, 0, 0),
(3568855, 15, 19896, 'wallpaper_single_2603', 3, 0, 1, 0, 0, 0),
(3568854, 15, 19896, 'wallpaper_single_2602', 3, 0, 1, 0, 0, 0),
(3568853, 15, 19896, 'wallpaper_single_2601', 3, 0, 1, 0, 0, 0),
(3568852, 15, 19896, 'wallpaper_single_2504', 3, 0, 1, 0, 0, 0),
(3568851, 15, 19896, 'wallpaper_single_2503', 3, 0, 1, 0, 0, 0),
(3568850, 15, 19896, 'wallpaper_single_2502', 3, 0, 1, 0, 0, 0),
(3568849, 15, 19896, 'wallpaper_single_2501', 3, 0, 1, 0, 0, 0),
(3568848, 15, 19896, 'wallpaper_single_2403', 3, 0, 1, 0, 0, 0),
(3568847, 15, 19896, 'wallpaper_single_2402', 3, 0, 1, 0, 0, 0),
(3568846, 15, 19896, 'wallpaper_single_2401', 3, 0, 1, 0, 0, 0),
(3568845, 15, 19896, 'wallpaper_single_2304', 3, 0, 1, 0, 0, 0),
(3568844, 15, 19896, 'wallpaper_single_2303', 3, 0, 1, 0, 0, 0),
(3568843, 15, 19896, 'wallpaper_single_2302', 3, 0, 1, 0, 0, 0),
(3568842, 15, 19896, 'wallpaper_single_2301', 3, 0, 1, 0, 0, 0),
(3568841, 15, 19896, 'wallpaper_single_2206', 3, 0, 1, 0, 0, 0),
(3568840, 15, 19896, 'wallpaper_single_2205', 3, 0, 1, 0, 0, 0),
(3568839, 15, 19896, 'wallpaper_single_2204', 3, 0, 1, 0, 0, 0),
(3568838, 15, 19896, 'wallpaper_single_2203', 3, 0, 1, 0, 0, 0),
(3568837, 15, 19896, 'wallpaper_single_2202', 3, 0, 1, 0, 0, 0),
(3568836, 15, 19896, 'wallpaper_single_2201', 3, 0, 1, 0, 0, 0),
(3568835, 15, 19896, 'wallpaper_single_2103', 3, 0, 1, 0, 0, 0),
(3568834, 15, 19896, 'wallpaper_single_2102', 3, 0, 1, 0, 0, 0),
(3568833, 15, 19896, 'wallpaper_single_2101', 3, 0, 1, 0, 0, 0),
(3568832, 15, 19896, 'wallpaper_single_2003', 3, 0, 1, 0, 0, 0),
(3568831, 15, 19896, 'wallpaper_single_2002', 3, 0, 1, 0, 0, 0),
(3568830, 15, 19896, 'wallpaper_single_2001', 3, 0, 1, 0, 0, 0),
(3568829, 15, 19896, 'wallpaper_single_1902', 3, 0, 1, 0, 0, 0),
(3568828, 15, 19896, 'wallpaper_single_1901', 3, 0, 1, 0, 0, 0),
(3568827, 15, 19896, 'wallpaper_single_1801', 3, 0, 1, 0, 0, 0),
(3568826, 15, 19896, 'wallpaper_single_1701', 3, 0, 1, 0, 0, 0),
(3568825, 15, 19896, 'wallpaper_single_1601', 3, 0, 1, 0, 0, 0),
(3568824, 15, 19896, 'wallpaper_single_1501', 3, 0, 1, 0, 0, 0),
(3568823, 15, 19896, 'wallpaper_single_1401', 3, 0, 1, 0, 0, 0),
(3568822, 15, 19896, 'wallpaper_single_1301', 3, 0, 1, 0, 0, 0),
(3568821, 15, 19896, 'wallpaper_single_1201', 3, 0, 1, 0, 0, 0),
(3568820, 15, 19896, 'wallpaper_single_1101', 3, 0, 1, 0, 0, 0),
(3568819, 15, 19896, 'wallpaper_single_1007', 3, 0, 1, 0, 0, 0),
(3568818, 15, 19896, 'wallpaper_single_1006', 3, 0, 1, 0, 0, 0),
(3568817, 15, 19896, 'wallpaper_single_1005', 3, 0, 1, 0, 0, 0),
(3568816, 15, 19896, 'wallpaper_single_1004', 3, 0, 1, 0, 0, 0),
(3568815, 15, 19896, 'wallpaper_single_1003', 3, 0, 1, 0, 0, 0),
(3568814, 15, 19896, 'wallpaper_single_1002', 3, 0, 1, 0, 0, 0),
(3568813, 15, 19896, 'wallpaper_single_1001', 3, 0, 1, 0, 0, 0),
(3568812, 15, 19896, 'wallpaper_single_908', 3, 0, 1, 0, 0, 0),
(3568811, 15, 19896, 'wallpaper_single_907', 3, 0, 1, 0, 0, 0),
(3568810, 15, 19896, 'wallpaper_single_906', 3, 0, 1, 0, 0, 0),
(3568809, 15, 19896, 'wallpaper_single_905', 3, 0, 1, 0, 0, 0),
(3568808, 15, 19896, 'wallpaper_single_904', 3, 0, 1, 0, 0, 0),
(3568807, 15, 19896, 'wallpaper_single_903', 3, 0, 1, 0, 0, 0),
(3568806, 15, 19896, 'wallpaper_single_902', 3, 0, 1, 0, 0, 0),
(3568805, 15, 19896, 'wallpaper_single_901', 3, 0, 1, 0, 0, 0),
(3568804, 15, 19896, 'wallpaper_single_810', 3, 0, 1, 0, 0, 0),
(3568803, 15, 19896, 'wallpaper_single_809', 3, 0, 1, 0, 0, 0),
(3568802, 15, 19896, 'wallpaper_single_808', 3, 0, 1, 0, 0, 0),
(3568801, 15, 19896, 'wallpaper_single_807', 3, 0, 1, 0, 0, 0),
(3568800, 15, 19896, 'wallpaper_single_806', 3, 0, 1, 0, 0, 0),
(3568799, 15, 19896, 'wallpaper_single_805', 3, 0, 1, 0, 0, 0),
(3568798, 15, 19896, 'wallpaper_single_804', 3, 0, 1, 0, 0, 0),
(3568797, 15, 19896, 'wallpaper_single_803', 3, 0, 1, 0, 0, 0),
(3568796, 15, 19896, 'wallpaper_single_802', 3, 0, 1, 0, 0, 0),
(3568795, 15, 19896, 'wallpaper_single_801', 3, 0, 1, 0, 0, 0),
(3568794, 15, 19896, 'wallpaper_single_710', 3, 0, 1, 0, 0, 0),
(3568793, 15, 19896, 'wallpaper_single_709', 3, 0, 1, 0, 0, 0),
(3568792, 15, 19896, 'wallpaper_single_708', 3, 0, 1, 0, 0, 0),
(3568791, 15, 19896, 'wallpaper_single_707', 3, 0, 1, 0, 0, 0),
(3568790, 15, 19896, 'wallpaper_single_706', 3, 0, 1, 0, 0, 0),
(3568789, 15, 19896, 'wallpaper_single_705', 3, 0, 1, 0, 0, 0),
(3568788, 15, 19896, 'wallpaper_single_704', 3, 0, 1, 0, 0, 0),
(3568787, 15, 19896, 'wallpaper_single_703', 3, 0, 1, 0, 0, 0),
(3568786, 15, 19896, 'wallpaper_single_702', 3, 0, 1, 0, 0, 0),
(3568785, 15, 19896, 'wallpaper_single_701', 3, 0, 1, 0, 0, 0),
(3568784, 15, 19896, 'wallpaper_single_610', 3, 0, 1, 0, 0, 0),
(3568783, 15, 19896, 'wallpaper_single_609', 3, 0, 1, 0, 0, 0),
(3568782, 15, 19896, 'wallpaper_single_608', 3, 0, 1, 0, 0, 0),
(3568781, 15, 19896, 'wallpaper_single_607', 3, 0, 1, 0, 0, 0),
(3568780, 15, 19896, 'wallpaper_single_606', 3, 0, 1, 0, 0, 0),
(3568779, 15, 19896, 'wallpaper_single_605', 3, 0, 1, 0, 0, 0),
(3568778, 15, 19896, 'wallpaper_single_604', 3, 0, 1, 0, 0, 0),
(3568777, 15, 19896, 'wallpaper_single_603', 3, 0, 1, 0, 0, 0),
(3568776, 15, 19896, 'wallpaper_single_602', 3, 0, 1, 0, 0, 0),
(3568775, 15, 19896, 'wallpaper_single_601', 3, 0, 1, 0, 0, 0),
(3568774, 15, 19896, 'wallpaper_single_508', 3, 0, 1, 0, 0, 0),
(3568773, 15, 19896, 'wallpaper_single_507', 3, 0, 1, 0, 0, 0),
(3568772, 15, 19896, 'wallpaper_single_506', 3, 0, 1, 0, 0, 0),
(3568771, 15, 19896, 'wallpaper_single_505', 3, 0, 1, 0, 0, 0),
(3568770, 15, 19896, 'wallpaper_single_504', 3, 0, 1, 0, 0, 0),
(3568769, 15, 19896, 'wallpaper_single_503', 3, 0, 1, 0, 0, 0),
(3568768, 15, 19896, 'wallpaper_single_502', 3, 0, 1, 0, 0, 0),
(3568767, 15, 19896, 'wallpaper_single_501', 3, 0, 1, 0, 0, 0),
(3568766, 15, 19896, 'wallpaper_single_408', 3, 0, 1, 0, 0, 0),
(3568765, 15, 19896, 'wallpaper_single_407', 3, 0, 1, 0, 0, 0),
(3568764, 15, 19896, 'wallpaper_single_406', 3, 0, 1, 0, 0, 0),
(3568763, 15, 19896, 'wallpaper_single_405', 3, 0, 1, 0, 0, 0),
(3568762, 15, 19896, 'wallpaper_single_404', 3, 0, 1, 0, 0, 0),
(3568761, 15, 19896, 'wallpaper_single_403', 3, 0, 1, 0, 0, 0),
(3568760, 15, 19896, 'wallpaper_single_402', 3, 0, 1, 0, 0, 0),
(3568759, 15, 19896, 'wallpaper_single_401', 3, 0, 1, 0, 0, 0),
(3568758, 15, 19896, 'wallpaper_single_307', 3, 0, 1, 0, 0, 0),
(3568757, 15, 19896, 'wallpaper_single_306', 3, 0, 1, 0, 0, 0),
(3568756, 15, 19896, 'wallpaper_single_305', 3, 0, 1, 0, 0, 0),
(3568755, 15, 19896, 'wallpaper_single_304', 3, 0, 1, 0, 0, 0),
(3568754, 15, 19896, 'wallpaper_single_303', 3, 0, 1, 0, 0, 0),
(3568753, 15, 19896, 'wallpaper_single_302', 3, 0, 1, 0, 0, 0),
(3568752, 15, 19896, 'wallpaper_single_301', 3, 0, 1, 0, 0, 0),
(3568751, 15, 19896, 'wallpaper_single_218', 3, 0, 1, 0, 0, 0),
(3568750, 15, 19896, 'wallpaper_single_217', 3, 0, 1, 0, 0, 0),
(3568749, 15, 19896, 'wallpaper_single_216', 3, 0, 1, 0, 0, 0),
(3568748, 15, 19896, 'wallpaper_single_215', 3, 0, 1, 0, 0, 0),
(3568747, 15, 19896, 'wallpaper_single_214', 3, 0, 1, 0, 0, 0),
(3568746, 15, 19896, 'wallpaper_single_213', 3, 0, 1, 0, 0, 0),
(3568745, 15, 19896, 'wallpaper_single_212', 3, 0, 1, 0, 0, 0),
(3568744, 15, 19896, 'wallpaper_single_211', 3, 0, 1, 0, 0, 0),
(3568743, 15, 19896, 'wallpaper_single_210', 3, 0, 1, 0, 0, 0),
(3568742, 15, 19896, 'wallpaper_single_209', 3, 0, 1, 0, 0, 0),
(3568741, 15, 19896, 'wallpaper_single_208', 3, 0, 1, 0, 0, 0),
(3568740, 15, 19896, 'wallpaper_single_207', 3, 0, 1, 0, 0, 0),
(3568739, 15, 19896, 'wallpaper_single_206', 3, 0, 1, 0, 0, 0),
(3568738, 15, 19896, 'wallpaper_single_205', 3, 0, 1, 0, 0, 0),
(3568737, 15, 19896, 'wallpaper_single_204', 3, 0, 1, 0, 0, 0),
(3568736, 15, 19896, 'wallpaper_single_203', 3, 0, 1, 0, 0, 0),
(3568735, 15, 19896, 'wallpaper_single_202', 3, 0, 1, 0, 0, 0),
(3568734, 15, 19896, 'wallpaper_single_201', 3, 0, 1, 0, 0, 0),
(3568733, 15, 19896, 'wallpaper_single_115', 3, 0, 1, 0, 0, 0),
(3568732, 15, 19896, 'wallpaper_single_114', 3, 0, 1, 0, 0, 0),
(3568731, 15, 19896, 'wallpaper_single_113', 3, 0, 1, 0, 0, 0),
(3568730, 15, 19896, 'wallpaper_single_112', 3, 0, 1, 0, 0, 0),
(3568729, 15, 19896, 'wallpaper_single_111', 3, 0, 1, 0, 0, 0),
(3568728, 15, 19896, 'wallpaper_single_110', 3, 0, 1, 0, 0, 0),
(3568727, 15, 19896, 'wallpaper_single_109', 3, 0, 1, 0, 0, 0),
(3568726, 15, 19896, 'wallpaper_single_108', 3, 0, 1, 0, 0, 0),
(3568725, 15, 19896, 'wallpaper_single_107', 3, 0, 1, 0, 0, 0),
(3568724, 15, 19896, 'wallpaper_single_106', 3, 0, 1, 0, 0, 0),
(3568723, 15, 19896, 'wallpaper_single_105', 3, 0, 1, 0, 0, 0),
(3568722, 15, 19896, 'wallpaper_single_104', 3, 0, 1, 0, 0, 0),
(3568721, 15, 19896, 'wallpaper_single_103', 3, 0, 1, 0, 0, 0),
(3568720, 15, 19896, 'wallpaper_single_102', 3, 0, 1, 0, 0, 0),
(3568719, 15, 19896, 'wallpaper_single_101', 3, 0, 1, 0, 0, 0),
(3568955, 15, 19926, 'landscape_single_5.4', 3, 0, 1, 0, 0, 0),
(3568956, 15, 19926, 'landscape_single_6.4', 3, 0, 1, 0, 0, 0),
(3568957, 15, 19926, 'landscape_single_7.4', 3, 0, 1, 0, 0, 0),
(3568958, 15, 19926, 'landscape_single_1.5', 3, 0, 1, 0, 0, 0),
(3568959, 15, 19926, 'landscape_single_2.5', 3, 0, 1, 0, 0, 0),
(3568960, 15, 19926, 'landscape_single_3.5', 3, 0, 1, 0, 0, 0),
(3568961, 15, 19926, 'landscape_single_4.5', 3, 0, 1, 0, 0, 0),
(3568962, 15, 19926, 'landscape_single_5.5', 3, 0, 1, 0, 0, 0),
(3568963, 15, 19926, 'landscape_single_6.5', 3, 0, 1, 0, 0, 0),
(3568964, 15, 19926, 'landscape_single_7.5', 3, 0, 1, 0, 0, 0),
(3568965, 15, 19926, 'landscape_single_1.6', 3, 0, 1, 0, 0, 0),
(3568966, 15, 19926, 'landscape_single_2.6', 3, 0, 1, 0, 0, 0),
(3568967, 15, 19926, 'landscape_single_3.6', 3, 0, 1, 0, 0, 0),
(3568968, 15, 19926, 'landscape_single_4.6', 3, 0, 1, 0, 0, 0),
(3568969, 15, 19926, 'landscape_single_5.6', 3, 0, 1, 0, 0, 0),
(3568970, 15, 19926, 'landscape_single_6.6', 3, 0, 1, 0, 0, 0),
(3568971, 15, 19926, 'landscape_single_7.6', 3, 0, 1, 0, 0, 0),
(3568972, 15, 19926, 'landscape_single_1.7', 3, 0, 1, 0, 0, 0),
(3568973, 15, 19926, 'landscape_single_2.7', 3, 0, 1, 0, 0, 0),
(3568974, 15, 19926, 'landscape_single_3.7', 3, 0, 1, 0, 0, 0),
(3568975, 15, 19926, 'landscape_single_4.7', 3, 0, 1, 0, 0, 0),
(3568976, 15, 19926, 'landscape_single_5.7', 3, 0, 1, 0, 0, 0),
(3568977, 15, 19926, 'landscape_single_6.7', 3, 0, 1, 0, 0, 0),
(3568978, 15, 19926, 'landscape_single_7.7', 3, 0, 1, 0, 0, 0),
(3568979, 15, 19926, 'landscape_single_1.8', 3, 0, 1, 0, 0, 0),
(3568980, 15, 19926, 'landscape_single_1.9', 3, 0, 1, 0, 0, 0),
(3568981, 15, 19926, 'landscape_single_1.10', 3, 0, 1, 0, 0, 0),
(3568982, 15, 19926, 'landscape_single_1.11', 3, 0, 1, 0, 0, 0),
(3568983, 15, 19926, 'landscape_single_7.12', 3, 0, 1, 0, 0, 0),
(2763, 187, 9001, 'a0 pet12', 30, 0, 1, 0, 0, 0),
(600014, 120, 2785090, 'bb_knj1', 3, 0, 1, 0, 0, 0),
(600015, 120, 2785091, 'bb_gate_r', 1, 0, 1, 0, 0, 0),
(600016, 120, 2785092, 'bb_tddhnd', 3, 0, 1, 0, 0, 0),
(600017, 120, 2785093, 'bb_lightdiv', 4, 0, 1, 0, 0, 0),
(600018, 120, 2785094, 'bb_tddhead', 4, 0, 1, 0, 0, 0),
(600019, 120, 2785095, 'bb_pyramid', 3, 0, 1, 0, 0, 0),
(600020, 120, 2785096, 'bb_patch1', 5, 0, 1, 0, 0, 0),
(600021, 120, 2785097, 'bb_fnc3', 3, 0, 1, 0, 0, 0),
(600022, 120, 2785098, 'bb_gate_y', 2, 0, 1, 0, 0, 0),
(600023, 120, 2785099, 'bb_apparatus', 3, 0, 1, 0, 0, 0),
(600024, 120, 2785100, 'bb_caterbody', 2, 0, 1, 0, 0, 0),
(600025, 120, 2785101, 'bb_knj2', 3, 0, 1, 0, 0, 0),
(600026, 120, 2785102, 'bb_fnc1', 3, 0, 1, 0, 0, 0),
(600027, 120, 2785103, 'bb_puck', 3, 0, 1, 0, 0, 0),
(600028, 120, 2785104, 'bb_rnd_tele', 3, 0, 1, 0, 0, 0),
(600029, 120, 2785105, 'bb_gate_b', 3, 0, 1, 0, 0, 0),
(600030, 120, 2785106, 'bb_score_r', 3, 0, 1, 0, 0, 0),
(600031, 120, 2785107, 'bb_painimies1', 3, 0, 1, 0, 0, 0),
(600032, 120, 2785108, 'bb_painimies2', 5, 0, 1, 0, 0, 0),
(600035, 120, 2785096, 'bb_patch1', 5, 0, 100, 0, 0, 0),
(600002, 120, 2785078, 'bb_score_b', 3, 0, 1, 0, 0, 0),
(600003, 120, 2785079, 'bb_robo', 3, 0, 1, 0, 0, 0),
(600004, 120, 2785080, 'bb_dragon', 8, 0, 1, 0, 0, 0),
(600005, 120, 2785081, 'bb_ducklight', 3, 0, 1, 0, 0, 0),
(600006, 120, 2785082, 'bb_caterhead', 3, 0, 1, 0, 0, 0),
(600007, 120, 2785083, 'bb_cargobox', 4, 0, 1, 0, 0, 0),
(600008, 120, 2785084, 'bb_gate_g', 3, 0, 1, 0, 0, 0),
(600009, 120, 2785085, 'bb_crchair3', 4, 0, 1, 0, 0, 0),
(600010, 120, 2785086, 'bb_score_g', 3, 0, 1, 0, 0, 0),
(600011, 120, 2785087, 'bb_crchair', 3, 0, 1, 0, 0, 0),
(600012, 120, 2785088, 'bb_crchair2', 3, 0, 1, 0, 0, 0),
(600013, 120, 2785089, 'bb_score_y', 3, 0, 1, 0, 0, 0),
(600036, 120, 2785109, 'bb_counter', 20, 0, 1, 0, 0, 0),
(99039, 501, 99093, 'Freeze tile', 2, 0, 1, 0, 0, 0),
(3568984, 912, 4568423, 'SONG disco_extreme', 1, 0, 1, 0, 0, 0),
(3568985, 912, 4568423, 'SONG TeemuP1', 1, 0, 1, 0, 0, 0),
(3568986, 912, 4568423, 'SONG Haadolocknloll', 1, 0, 1, 0, 0, 0),
(3568987, 912, 4568423, 'SONG Weirdodo', 1, 0, 1, 0, 0, 0),
(3568988, 912, 4568423, 'SONG double_peks', 1, 0, 1, 0, 0, 0),
(3568989, 912, 4568423, 'SONG Trax_1', 1, 0, 1, 0, 0, 0),
(3568990, 912, 4568423, 'SONG klubhaus', 1, 0, 1, 0, 0, 0),
(3568991, 912, 4568423, 'SONG limbertake', 1, 0, 1, 0, 0, 0),
(3568992, 912, 4568423, 'SONG miamimiamor', 1, 0, 1, 0, 0, 0),
(3568993, 912, 4568423, 'SONG new_song', 1, 0, 1, 0, 0, 0),
(3568994, 912, 4568423, 'SONG park_adventure', 1, 0, 1, 0, 0, 0),
(3568995, 912, 4568423, 'SONG pianissimo', 1, 0, 1, 0, 0, 0),
(3568996, 912, 4568423, 'Frank''s Generic Hotel Sounds', 1, 0, 1, 0, 0, 0),
(3568997, 912, 4568423, 'SONG TeemuP2', 1, 0, 1, 0, 0, 0),
(3568998, 912, 4568423, 'SONG bossanova', 1, 0, 1, 0, 0, 0),
(3568999, 912, 4568423, 'SONG WhoDaresStacks', 1, 0, 1, 0, 0, 0),
(3568323, 177, 3568337, 'wf_trg_at_given_time', 3, 0, 1, 0, 0, 0),
(3568324, 177, 3568338, 'wf_trg_enter_room', 3, 0, 1, 0, 0, 0),
(3568325, 177, 3568339, 'wf_trg_game_ends', 3, 0, 1, 0, 0, 0),
(3568326, 177, 3568340, 'wf_trg_game_starts', 3, 0, 1, 0, 0, 0),
(3568327, 177, 3568341, 'wf_trg_periodically', 3, 0, 1, 0, 0, 0),
(3568328, 177, 3568342, 'wf_trg_says_something', 3, 0, 1, 0, 0, 0),
(3568329, 177, 3568343, 'wf_trg_score_achieved', 3, 0, 1, 0, 0, 0),
(3568330, 177, 3568344, 'wf_trg_state_changed', 3, 0, 1, 0, 0, 0),
(3568331, 177, 3568345, 'wf_trg_walks_off_furni', 3, 0, 1, 0, 0, 0),
(3568332, 177, 3568346, 'wf_trg_walks_on_furni', 3, 0, 1, 0, 0, 0),
(3568333, 178, 3568347, 'wf_act_give_score', 3, 0, 1, 0, 0, 0),
(3568334, 178, 3568348, 'wf_act_match_to_sshot', 3, 0, 1, 0, 0, 0),
(3568335, 178, 3568349, 'wf_act_move_rotate', 3, 0, 1, 0, 0, 0),
(3568336, 178, 3568350, 'wf_act_reset_timers', 3, 0, 1, 0, 0, 0),
(3568337, 178, 3568351, 'wf_act_show_message', 3, 0, 1, 0, 0, 0),
(3568338, 178, 3568352, 'wf_act_teleport_to', 3, 0, 1, 0, 0, 0),
(3568339, 178, 3568353, 'wf_act_toggle_state', 3, 0, 1, 0, 0, 0),
(3568340, 180, 3568354, 'wf_cnd_furnis_hv_avtrs', 3, 0, 1, 0, 0, 0),
(3568341, 180, 3568355, 'wf_cnd_match_snapshot', 3, 0, 1, 0, 0, 0),
(3568342, 180, 3568356, 'wf_cnd_time_less_than', 1, 0, 1, 0, 0, 0),
(3568343, 180, 3568357, 'wf_cnd_time_more_than', 3, 0, 1, 0, 0, 0),
(3568344, 180, 3568358, 'wf_cnd_trggrer_on_frn', 3, 0, 1, 0, 0, 0),
(3568345, 179, 3568359, 'wf_arrowplate', 3, 0, 1, 0, 0, 0),
(3568346, 179, 3568360, 'wf_pressureplate', 3, 0, 1, 0, 0, 0),
(3568347, 179, 3568361, 'wf_ringplate', 1, 0, 1, 0, 0, 0),
(3568348, 179, 3568362, 'wf_colortile', 3, 0, 1, 0, 0, 0),
(3568349, 179, 3568363, 'wf_colorwheel', 3, 0, 1, 0, 0, 0),
(3568350, 179, 3568364, 'wf_floor_switch1', 3, 0, 1, 0, 0, 0),
(3568351, 179, 3568365, 'wf_floor_switch2', 3, 0, 1, 0, 0, 0),
(3568352, 179, 3568366, 'wf_firegate', 3, 0, 1, 0, 0, 0),
(3568353, 179, 3568367, 'wf_glassdoor', 3, 0, 1, 0, 0, 0),
(3568354, 179, 3568368, 'wf_xtra_random', 3, 0, 1, 0, 0, 0),
(3568355, 179, 3568369, 'wf_xtra_unseen', 3, 0, 1, 0, 0, 0),
(3568356, 179, 3568374, 'wf_wire1', 1, 0, 1, 0, 0, 0),
(3568357, 179, 3568374, 'wf_wire1', 10, 0, 5, 0, 0, 0),
(3568358, 179, 3568375, 'wf_wire2', 1, 0, 1, 0, 0, 0),
(3568359, 179, 3568375, 'wf_wire2', 10, 0, 5, 0, 0, 0),
(3568360, 179, 3568376, 'wf_wire3', 1, 0, 1, 0, 0, 0),
(3568361, 179, 3568376, 'wf_wire3', 10, 0, 5, 0, 0, 0),
(3568362, 179, 3568377, 'wf_wire4', 1, 0, 1, 0, 0, 0),
(3568363, 179, 3568377, 'wf_wire4', 10, 0, 5, 0, 0, 0),
(3569001, 913, 4568424, 'qt_sum11_ictrolley', 0, 100, 1, 0, 0, 0),
(3569002, 913, 4568425, 'qt_sum11_platfrm', 8, 0, 1, 0, 0, 0),
(3569003, 913, 4568426, 'qt_sum11_shell3', 3, 0, 1, 0, 0, 0),
(3569004, 913, 4568427, 'qt_sum11_shell2', 3, 0, 1, 0, 0, 0),
(3569005, 913, 4568428, 'qt_sum11_chair', 4, 0, 1, 0, 0, 0),
(3569006, 913, 4568429, 'qt_sum11_shell4', 3, 0, 1, 0, 0, 0),
(3569007, 913, 4568430, 'qt_sum11_shell1', 3, 0, 1, 0, 0, 0),
(3569008, 913, 4568431, 'qt_sum11_shell5', 3, 0, 1, 0, 0, 0),
(3569009, 913, 4568432, 'qt_sum11_petfood', 2, 100, 1, 0, 0, 0),
(3569010, 914, 4568433, 'petfood25', 2, 0, 1, 0, 0, 0),
(3569011, 914, 4568434, 'lm_bananadrink', 20, 0, 1, 0, 0, 0),
(3569012, 914, 4568435, 'lm_crystal_skull', 5, 0, 1, 0, 0, 0),
(3569013, 914, 4568436, 'lm_jackbox', 5, 0, 1, 0, 0, 0),
(3569014, 915, 4568437, 'ads_durex_carpet', 5, 0, 1, 0, 0, 0),
(3569015, 915, 4568438, 'ads_durex_screen', 5, 0, 1, 0, 0, 0),
(3569016, 915, 4568439, 'ads_durex_vend', 5, 0, 1, 0, 0, 0),
(3569017, 94, 4568440, 'qt_sum11_dragon', 2500, 0, 0, 0, 0, 0),
(4000, 145, 4000, 'a0 pet14', 20000, 7500, 1, 0, 0, 0),
(6003, 46, 20700, 'a0 pet9', 20, 0, 1, 0, 0, 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `catalog_items_copy`
--

CREATE TABLE IF NOT EXISTS `catalog_items_copy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `page_id` int(11) NOT NULL,
  `item_ids` varchar(12000) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `catalog_name` varchar(100) NOT NULL,
  `cost_credits` int(11) NOT NULL,
  `cost_pixels` int(11) NOT NULL,
  `amount` int(11) NOT NULL,
  `cost_crystal` int(11) NOT NULL,
  `cost_oude_belcredits` int(11) NOT NULL,
  `song_id` int(11) unsigned NOT NULL,
  `limited_stack` int(255) NOT NULL DEFAULT '0',
  `limited_sells` int(255) NOT NULL DEFAULT '0',
  `offer_active` enum('0','1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3569043 ;

--
-- Volcado de datos para la tabla `catalog_items_copy`
--

INSERT INTO `catalog_items_copy` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`, `song_id`, `limited_stack`, `limited_sells`, `offer_active`) VALUES
(1, 134, '1642', 'byesw_hand', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(2, 134, '1643', 'byesw_hotel', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568953, 15, '1637', 'landscape_single_3.4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568952, 15, '1637', 'landscape_single_2.4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568951, 15, '1637', 'landscape_single_1.4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568950, 15, '1637', 'landscape_single_7.3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568949, 15, '1637', 'landscape_single_6.3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568948, 15, '1637', 'landscape_single_5.3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568947, 15, '1637', 'landscape_single_4.3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568946, 15, '1637', 'landscape_single_3.3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568945, 15, '1637', 'landscape_single_2.3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568944, 15, '1637', 'landscape_single_1.3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568943, 15, '1637', 'landscape_single_1.2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568942, 15, '1637', 'landscape_single_7.1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568941, 15, '1637', 'landscape_single_6.1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568940, 15, '1637', 'landscape_single_5.1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568939, 15, '1637', 'landscape_single_4.1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568938, 15, '1637', 'landscape_single_3.1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568937, 15, '1637', 'landscape_single_2.1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568936, 15, '1637', 'landscape_single_1.1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568935, 15, '1634', 'floor_single_610', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568934, 15, '1634', 'floor_single_609', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568933, 15, '1634', 'floor_single_608', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568932, 15, '1634', 'floor_single_607', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(72, 55, '1', 'shelves_norja', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(71, 55, '6', 'table_norja_med', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(73, 55, '14', 'couch_norja', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(74, 55, '15', 'chair_norja', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(75, 55, '170', 'soft_sofachair_norja', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(76, 55, '171', 'soft_sofa_norja', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(101, 55, '495', 'shelves_norja*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(78, 55, '473', 'table_norja_med*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(79, 55, '474', 'table_norja_med*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(80, 55, '475', 'table_norja_med*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(81, 55, '476', 'table_norja_med*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(82, 55, '477', 'table_norja_med*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(83, 55, '478', 'table_norja_med*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(85, 55, '479', 'table_norja_med*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(86, 55, '480', 'table_norja_med*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(87, 55, '481', 'couch_norja*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(88, 55, '482', 'couch_norja*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(89, 55, '483', 'couch_norja*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(90, 1, '484', 'couch_norja*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(91, 55, '485', 'couch_norja*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(92, 55, '486', 'couch_norja*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(93, 55, '487', 'couch_norja*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(94, 55, '488', 'couch_norja*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(95, 55, '489', 'shelves_norja*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(96, 55, '490', 'shelves_norja*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(97, 55, '491', 'shelves_norja*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(98, 55, '492', 'shelves_norja*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(99, 55, '493', 'shelves_norja*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(100, 55, '494', 'shelves_norja*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(140, 30, '2', 'shelves_polyfon', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(103, 55, '496', 'chair_norja*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(104, 55, '497', 'chair_norja*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(105, 55, '498', 'chair_norja*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(106, 55, '499', 'chair_norja*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(107, 55, '500', 'chair_norja*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(108, 55, '501', 'chair_norja*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(109, 55, '502', 'chair_norja*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(110, 55, '503', 'chair_norja*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(111, 55, '512', 'soft_sofa_norja*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(112, 55, '513', 'soft_sofa_norja*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(113, 55, '514', 'soft_sofa_norja*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(114, 55, '515', 'soft_sofa_norja*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(115, 55, '516', 'soft_sofa_norja*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(116, 55, '517', 'soft_sofa_norja*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(391, 28, '1198', 'xmas08_icerug', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(118, 55, '518', 'soft_sofa_norja*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(387, 28, '1189', 'xmas08_trph1', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(386, 28, '1187', 'xmas08_snowpl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(121, 55, '519', 'soft_sofa_norja*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(123, 55, '520', 'soft_sofachair_norja*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(124, 55, '521', 'soft_sofachair_norja*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(125, 55, '522', 'soft_sofachair_norja*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(126, 55, '524', 'soft_sofachair_norja*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(127, 55, '525', 'soft_sofachair_norja*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(128, 55, '523', 'soft_sofachair_norja*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(129, 55, '526', 'soft_sofachair_norja*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(130, 55, '527', 'soft_sofachair_norja*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(131, 55, '652', 'solarium_norja', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(132, 55, '653', 'solarium_norja*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(133, 55, '654', 'solarium_norja*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(134, 55, '655', 'solarium_norja*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(135, 55, '656', 'solarium_norja*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(136, 55, '657', 'solarium_norja*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(137, 55, '658', 'solarium_norja*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(138, 55, '659', 'solarium_norja*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(139, 55, '660', 'solarium_norja*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(141, 30, '4', 'table_polyfon_small', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(142, 30, '5', 'chair_polyfon', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(143, 30, '11', 'stand_polyfon_z', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(144, 30, '16', 'table_polyfon_med', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(145, 30, '19', 'sofachair_polyfon', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(146, 30, '20', 'sofa_polyfon', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(147, 30, '25', 'bed_polyfon', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(148, 30, '26', 'bed_polyfon_one', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(149, 30, '107', 'bar_polyfon', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(150, 30, '46', 'fireplace_polyfon', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(152, 30, '110', 'bardesk_polyfon', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(153, 30, '111', 'bardeskcorner_polyfon', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(154, 30, '130', 'table_polyfon', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(155, 30, '131', 'smooth_table_polyfon', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(156, 31, '132', 'sofachair_polyfon_girl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(157, 31, '133', 'bed_polyfon_girl_one', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(158, 31, '134', 'bed_polyfon_girl', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(159, 31, '135', 'sofa_polyfon_girl', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(160, 31, '614', 'bardeskcorner_polyfon*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(161, 31, '606', 'bardesk_polyfon*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(162, 31, '622', 'divider_poly3*5', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(163, 30, '213', 'divider_poly3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(260, 26, '1615', 'dimmer_fuse2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(259, 26, '1614', 'dimmer_swtch', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(166, 30, '576', 'sofachair_polyfon*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(258, 26, '1613', 'dimmer_fuse6', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(168, 30, '577', 'sofachair_polyfon*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(383, 37, '1609', 'ktchn_wall', 20, 0, 5, 0, 0, 0, 0, 0, '1'),
(170, 30, '578', 'sofachair_polyfon*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(171, 30, '579', 'sofachair_polyfon*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(172, 30, '580', 'sofachair_polyfon*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(173, 30, '581', 'sofachair_polyfon*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(174, 30, '582', 'sofachair_polyfon*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(175, 30, '583', 'sofa_polyfon*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(176, 30, '584', 'sofa_polyfon*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(177, 30, '585', 'sofa_polyfon*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(178, 30, '586', 'sofa_polyfon*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(179, 30, '587', 'sofa_polyfon*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(180, 30, '588', 'sofa_polyfon*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(181, 30, '589', 'sofa_polyfon*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(182, 30, '590', 'bed_polyfon*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(183, 30, '591', 'bed_polyfon*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(184, 30, '592', 'bed_polyfon*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(185, 30, '593', 'bed_polyfon*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(186, 30, '594', 'bed_polyfon*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(187, 30, '595', 'bed_polyfon*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(188, 30, '596', 'bed_polyfon_one*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(189, 30, '597', 'bed_polyfon_one*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(190, 30, '598', 'bed_polyfon_one*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(191, 30, '599', 'bed_polyfon_one*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(192, 30, '600', 'bed_polyfon_one*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(193, 30, '601', 'bed_polyfon_one*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(194, 30, '602', 'bed_polyfon_one*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(195, 30, '603', 'bardesk_polyfon*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(196, 30, '604', 'bardesk_polyfon*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(197, 30, '605', 'bardesk_polyfon*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(198, 30, '598', 'bed_polyfon_one*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(199, 30, '607', 'bardesk_polyfon*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(200, 30, '608', 'bardesk_polyfon*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(201, 615, '609', 'bardesk_polyfon*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(202, 30, '610', 'bardesk_polyfon*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(203, 30, '610', 'bardesk_polyfon*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(204, 30, '611', 'bardeskcorner_polyfon*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(205, 30, '612', 'bardeskcorner_polyfon*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(206, 30, '613', 'bardeskcorner_polyfon*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(207, 30, '615', 'bardeskcorner_polyfon*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(208, 30, '616', 'bardeskcorner_polyfon*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(209, 30, '617', 'bardeskcorner_polyfon*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(210, 30, '618', 'bardeskcorner_polyfon*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(222, 35, '32', 'bed_armas_two', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(212, 30, '619', 'divider_poly3*2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(213, 30, '620', 'divider_poly3*3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(214, 30, '621', 'divider_poly3*4', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(215, 30, '623', 'divider_poly3*6', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2138, 160, '323', 'toy1*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2335, 129, '1323', 'bump_road', 0, 1250, 20, 0, 0, 0, 0, 0, '1'),
(218, 30, '626', 'divider_poly3*9', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2118, 7, '1720', 'DEAL_HC_1', 100, 0, 1, 0, 0, 0, 0, 0, '1'),
(390, 28, '1196', 'xmas08_icetree', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(224, 35, '36', 'bench_armas', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(225, 35, '37', 'table_armas', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(226, 35, '38', 'small_table_armas', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(227, 35, '39', 'small_chair_armas', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(228, 35, '40', 'fireplace_armas', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(229, 35, '41', 'lamp_armas', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(230, 35, '42', 'bed_armas_one', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(231, 35, '44', 'carpet_armas', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(232, 35, '112', 'bar_armas', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(233, 35, '113', 'bartable_armas', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(234, 35, '114', 'bar_chair_armas', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(235, 35, '173', 'lamp2_armas', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(237, 24, '1508', 'window_single_default', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(238, 24, '1509', 'window_double_default', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(239, 24, '1510', 'noob_window_double', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(240, 24, '1511', 'window_triple', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(241, 24, '1512', 'window_square', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(242, 24, '1513', 'window_romantic_wide', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(243, 24, '1514', 'window_romantic_narrow', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(244, 24, '1515', 'window_grunge', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(245, 24, '1516', 'window_golden', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(246, 24, '1517', 'window_chinese_wide', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(264, 29, '175', 'door', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(248, 24, '1518', 'window_chinese_narrow', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(249, 24, '1519', 'window_basic', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(250, 24, '1520', 'window_70s_wide', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(251, 24, '1521', 'window_70s_narrow', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(261, 26, '1616', 'dimmer_buttn', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(257, 26, '1498', 'roomdimmer', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(254, 24, '1527', 'window_hole', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(255, 24, '1531', 'window_skyscraper', 18, 0, 5, 0, 0, 0, 0, 0, '1'),
(389, 28, '1192', 'xmas08_hottub', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(265, 29, '937', 'teleport_door', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(757, 73, '1599', 'sf_window', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(756, 73, '1435', 'sf_roller', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(268, 73, '1434', 'sf_tele', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(269, 58, '1273', 'lostc_teleport', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(271, 33, '3', 'shelves_silo', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(272, 33, '7', 'table_silo_med', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(273, 33, '12', 'chair_silo', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(274, 33, '13', 'sofa_silo', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(275, 33, '21', 'sofachair_silo', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(276, 33, '29', 'bed_silo_one', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(277, 33, '30', 'bed_silo_two', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(278, 33, '31', 'table_silo_small', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(279, 33, '218', 'divider_silo1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(280, 33, '220', 'divider_silo2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(281, 33, '222', 'divider_silo3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(282, 33, '455', 'barchair_silo', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(283, 33, '528', 'sofachair_silo*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(284, 33, '529', 'sofachair_silo*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(285, 33, '530', 'sofachair_silo*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(286, 33, '531', 'sofachair_silo*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(287, 33, '532', 'sofachair_silo*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(288, 33, '533', 'sofachair_silo*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(289, 33, '534', 'sofachair_silo*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(290, 33, '535', 'sofachair_silo*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(291, 33, '536', 'table_silo_small*2', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(292, 33, '537', 'table_silo_small*3', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(293, 33, '538', 'table_silo_small*4', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(294, 33, '539', 'table_silo_small*5', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(295, 33, '540', 'table_silo_small*6', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(296, 33, '541', 'table_silo_small*7', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(297, 33, '542', 'table_silo_small*8', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(298, 33, '543', 'table_silo_small*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(299, 33, '544', 'divider_silo1*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(300, 33, '545', 'divider_silo1*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(301, 33, '546', 'divider_silo1*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(302, 33, '547', 'divider_silo1*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(303, 33, '548', 'divider_silo1*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(304, 33, '549', 'divider_silo1*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(305, 33, '550', 'divider_silo1*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(306, 33, '551', 'divider_silo1*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(307, 33, '552', 'divider_silo3*2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(308, 33, '553', 'divider_silo3*3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(309, 33, '554', 'divider_silo3*4', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(310, 33, '555', 'divider_silo3*5', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(311, 33, '556', 'divider_silo3*6', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(312, 33, '557', 'divider_silo3*7', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(313, 33, '558', 'divider_silo3*8', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(314, 33, '559', 'divider_silo3*9', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(315, 33, '560', 'table_silo_med*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(316, 33, '561', 'table_silo_med*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(317, 33, '562', 'table_silo_med*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(318, 33, '563', 'table_silo_med*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(319, 33, '564', 'table_silo_med*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(320, 33, '565', 'table_silo_med*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(321, 33, '566', 'table_silo_med*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(322, 33, '567', 'table_silo_med*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(323, 33, '568', 'sofa_silo*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(324, 33, '569', 'sofa_silo*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(325, 33, '570', 'sofa_silo*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(326, 33, '571', 'sofa_silo*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(327, 33, '572', 'sofa_silo*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(328, 33, '573', 'sofa_silo*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(329, 33, '574', 'sofa_silo*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(330, 33, '575', 'sofa_silo*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(331, 33, '627', 'chair_silo*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(332, 33, '628', 'chair_silo*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(333, 33, '629', 'chair_silo*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(334, 33, '630', 'chair_silo*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(335, 33, '631', 'chair_silo*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(336, 33, '632', 'chair_silo*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(337, 33, '633', 'chair_silo*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(338, 33, '634', 'chair_silo*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(339, 33, '651', 'silo_studydesk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(340, 33, '651', 'silo_studydesk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(341, 33, '669', 'safe_silo', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(342, 33, '696', 'barchair_silo*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(343, 33, '697', 'barchair_silo*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(344, 33, '698', 'barchair_silo*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(345, 33, '699', 'barchair_silo*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(346, 33, '700', 'barchair_silo*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(347, 33, '701', 'barchair_silo*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(348, 33, '701', 'barchair_silo*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(349, 33, '702', 'barchair_silo*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(350, 33, '703', 'barchair_silo*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(351, 33, '704', 'safe_silo*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(352, 33, '705', 'safe_silo*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(353, 33, '706', 'safe_silo*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(354, 33, '707', 'safe_silo*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(355, 33, '708', 'safe_silo*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(356, 33, '709', 'safe_silo*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(358, 33, '710', 'safe_silo*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(359, 33, '711', 'safe_silo*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(360, 33, '880', 'safe_silo_pb', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(364, 37, '1461', 'ktchn_light', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(363, 37, '1460', 'ktchn_stove', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(365, 37, '1462', 'ktchn_plates', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(366, 37, '1463', 'ktchn_countr_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(367, 37, '1464', 'ktchn_pots', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(368, 37, '1465', 'ktchn_cornr', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(369, 37, '1466', 'ktchn_desk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(370, 37, '1467', 'ktchn_trash', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(371, 37, '1468', 'ktchn_countr_2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(372, 37, '1469', 'ktchn_bBlock', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(373, 37, '1470', 'ktchn_dvdr', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(374, 37, '1471', 'ktchn_inspctr', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(375, 37, '1472', 'ktchn_fridge', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(376, 37, '1474', 'ktchn_sink', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(388, 28, '1191', 'xmas08_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(378, 37, '1475', 'ktchn_gate', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(379, 37, '1609', 'ktchn_wall', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(380, 37, '1611', 'ktchn_oven', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(381, 37, '1612', 'ktchn_knives', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(392, 28, '1210', 'xmas08_geysir', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(393, 28, '1214', 'xmas08_lantern', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(394, 28, '1215', 'xmas08_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(395, 28, '1217', 'xmas08_telep', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(396, 28, '1218', 'xmas08_cubetree', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(397, 28, '1220', 'xmas08_dvdr1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(398, 28, '1221', 'xmas08_hole', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(399, 28, '1224', 'xmas08_dvdr2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(400, 28, '1236', 'xmas08_trph2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(401, 28, '1552', 'xmas08_wallpaper', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(402, 28, '1553', 'xmas08_icewall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(404, 39, '138', 'plant_pineapple', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(405, 39, '139', 'plant_fruittree', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(406, 39, '140', 'plant_small_cactus', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(407, 39, '141', 'plant_bonsai', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(408, 39, '142', 'plant_big_cactus', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(409, 39, '143', 'plant_yukka', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(410, 39, '149', 'plant_sunflower', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(411, 39, '150', 'plant_rose', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(412, 39, '809', 'plant_mazegate', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(413, 39, '810', 'plant_maze', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(414, 39, '811', 'plant_bulrush', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(417, 38, '152', 'bath', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(418, 38, '153', 'sink', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(419, 38, '156', 'tile', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(420, 38, '159', 'tile_red', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(421, 38, '160', 'tile_yell', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(422, 38, '154', 'toilet', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(423, 38, '157', 'toilet_red', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(424, 38, '158', 'toilet_yell', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(425, 38, '155', 'duck', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(426, 34, '1357', 'country_rain', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(427, 34, '1358', 'country_scarecrow', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(428, 34, '1360', 'country_soil', 50, 0, 10, 0, 0, 0, 0, 0, '1'),
(429, 34, '1361', 'country_grass', 500, 0, 100, 0, 0, 0, 0, 0, '1'),
(430, 34, '1364', 'country_trctr', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(431, 34, '1365', 'country_fnc2', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(432, 34, '1366', 'country_fnc1', 2, 0, 10, 0, 0, 0, 0, 0, '1'),
(433, 34, '1367', 'country_well', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(434, 34, '1369', 'country_rbw', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(435, 34, '1370', 'country_wheat', 50, 0, 10, 0, 0, 0, 0, 0, '1'),
(436, 34, '1371', 'country_gate', 6, 0, 10, 0, 0, 0, 0, 0, '1'),
(437, 34, '1373', 'country_stage', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(438, 34, '1378', 'country_log', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(439, 34, '1379', 'country_fnc3', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(440, 34, '1380', 'country_patio', 1, 0, 10, 0, 0, 0, 0, 0, '1'),
(441, 34, '1381', 'country_corner', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(442, 34, '1382', 'country_ditch', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(443, 34, '1590', 'country_forestwall', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(444, 34, '1591', 'country_fp', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(445, 34, '1592', 'country_wall', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(446, 34, '1593', 'country_lantern', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(448, 34, '1592', 'country_wall', 15, 0, 10, 0, 0, 0, 0, 0, '1'),
(449, 40, '43', 'carpet_standard', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(450, 40, '45', 'carpet_polar', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(451, 40, '52', 'carpet_standard*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(452, 40, '60', 'carpet_standard*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(453, 40, '66', 'carpet_standard*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(454, 40, '66', 'carpet_standard*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(455, 40, '71', 'carpet_standard*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(456, 40, '75', 'carpet_standard*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(457, 40, '100', 'carpet_standard*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(458, 40, '115', 'carpet_soft', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(459, 40, '116', 'carpet_soft*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(460, 40, '117', 'carpet_soft*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(461, 40, '118', 'carpet_soft*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(462, 40, '119', 'carpet_soft*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(463, 40, '120', 'carpet_soft*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(464, 40, '121', 'carpet_soft*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(465, 40, '124', 'carpet_polar*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(466, 40, '126', 'carpet_polar*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(467, 40, '127', 'carpet_polar*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(468, 40, '128', 'carpet_polar*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(469, 40, '144', 'carpet_standard*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(470, 40, '145', 'carpet_standard*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(471, 40, '146', 'carpet_standard*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(472, 40, '147', 'carpet_standard*10', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(473, 40, '148', 'carpet_standard*11', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(475, 41, '1594', 'flag_norway', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(476, 41, '1606', 'flag_belgium', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(477, 41, '1607', 'flag_portugal', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(481, 27, '187', 'xmasduck', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(482, 27, '259', 'rare_xmas_screen', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(483, 28, '872', 'xmas_icelamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(485, 27, '873', 'xmas_cstl_wall', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(486, 27, '874', 'xmas_cstl_twr', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(487, 27, '875', 'xmas_cstl_gate', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(488, 27, '1201', 'xmas_snow', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(489, 27, '1201', 'xmas_snow', 20, 0, 10, 0, 0, 0, 0, 0, '1'),
(490, 27, '1491', 'xmas_light', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(513, 27, '190', 'tree3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(496, 27, '1664', 'xm09_table', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(493, 27, '1662', 'xm09_man_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(833, 57, '663', 'chair_china', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(495, 27, '1663', 'xm09_man_c', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(497, 27, '1665', 'xm09_bench', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2120, 7, '1720', 'DEAL_HC_2', 250, 0, 3, 0, 0, 0, 0, 0, '1'),
(499, 27, '1667', 'xm09_forestwall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(500, 27, '1668', 'xm09_lodgewall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(501, 27, '1669', 'xm09_bauble_25', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(502, 27, '1666', 'xm09_firwall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(503, 27, '1670', 'xm09_bauble_26', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(512, 27, '184', 'pudding', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(505, 27, '1672', 'xm09_bauble_27', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(506, 27, '1673', 'xm09_bauble_23', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(507, 27, '1674', 'xm09_bauble_24', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(508, 27, '1675', 'xm09_candyCane', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(509, 27, '1676', 'xm09_stocking', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(514, 27, '191', 'tree4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(515, 27, '192', 'tree5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(516, 27, '876', 'tree7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(517, 27, '877', 'tree6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(518, 27, '883', 'christmas_sleigh', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(519, 27, '884', 'christmas_reindeer', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(520, 27, '885', 'christmas_poop', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(522, 27, '189', 'triplecandle', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(523, 27, '195', 'rcandleset', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(524, 27, '266', 'rcandle', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(555, 77, '1128', 'greek_corner', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(528, 27, '1661', 'xm09_man_a', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1117, 43, '122', 'red_tv', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(531, 27, '1671', 'xm09_bauble_27', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(532, 28, '1197', 'campfire', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(533, 76, '197', 'valeduck', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(534, 76, '241', 'valentinescreen', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(556, 77, '1129', 'greek_gate', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(536, 76, '804', 'plant_valentinerose*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(537, 76, '805', 'plant_valentinerose*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(538, 76, '806', 'plant_valentinerose*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(539, 76, '807', 'plant_valentinerose*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(540, 76, '808', 'plant_valentinerose*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(541, 76, '813', 'carpet_valentine', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(542, 76, '929', 'val_teddy*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(543, 76, '930', 'val_teddy*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(544, 76, '931', 'val_teddy*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(545, 76, '932', 'val_teddy*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(546, 76, '933', 'val_teddy*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(547, 76, '934', 'val_teddy*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(548, 76, '935', 'val_randomizer', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(549, 76, '936', 'val_choco', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(550, 76, '1484', 'val_heart', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(551, 76, '1477', 'post.it.vd', 3, 0, 30, 0, 0, 0, 0, 0, '1'),
(552, 76, '196', 'statue', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(553, 76, '198', 'heartsofa', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(557, 77, '1130', 'greek_pillars', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(558, 77, '1131', 'greek_seat', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(564, 71, '1444', 'rela_candle1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(560, 42, '1133', 'a0 greektrophy_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(561, 42, '1134', 'a0 greektrophy_b', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(562, 77, '1135', 'greek_block', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(563, 42, '1132', 'a0 greektrophy_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2108, 42, '1713', 'ads_twi_trophy', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(566, 71, '1446', 'rela_candles2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(766, 72, '790', 'romantique_pianochair*5', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(568, 71, '1448', 'rela_hchair', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(569, 71, '1449', 'rela_candle2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(570, 71, '1453', 'rela_candle3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(571, 71, '1455', 'rela_plant', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(572, 71, '1456', 'rela_candles1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(573, 71, '1457', 'rela_candles3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(574, 71, '1458', 'rela_orchid', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(575, 71, '1459', 'rela_rock', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(576, 71, '1605', 'rela_wall', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(578, 59, '206', 'basket', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(579, 59, '205', 'bunny', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(580, 59, '204', 'easterduck', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(581, 59, '207', 'birdie', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(584, 56, '960', 'arabian_teamk', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(585, 56, '961', 'arabian_snake', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(586, 56, '962', 'arabian_rug', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(587, 56, '963', 'arabian_pllw', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(588, 56, '964', 'arabian_divdr', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(589, 56, '965', 'arabian_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(590, 56, '966', 'arabian_bigtb', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(591, 56, '967', 'arabian_tetbl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(592, 56, '968', 'arabian_tray1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600, 63, '445', 'sporttrack1*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(594, 56, '970', 'arabian_tray3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(595, 56, '971', 'arabian_tray4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(596, 56, '1503', 'arabian_swords', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(597, 56, '1504', 'arabian_wndw', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(598, 56, '969', 'arabian_tray2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(601, 63, '446', 'sporttrack1*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(602, 63, '447', 'sporttrack1*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(603, 63, '448', 'sporttrack2*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(604, 63, '449', 'sporttrack2*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(605, 63, '450', 'sporttrack2*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(606, 63, '451', 'sporttrack3*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(607, 63, '452', 'sporttrack3*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(608, 63, '453', 'sporttrack3*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(609, 63, '287', 'hockey_light', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(610, 63, '286', 'hockey_score', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(611, 63, '239', 'bench_lego', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(612, 63, '238', 'carpet_legocourt', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(613, 63, '240', 'legotrophy', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(615, 63, '454', 'footylamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(617, 64, '854', 'grunge_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(618, 64, '855', 'grunge_mattress', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(619, 64, '856', 'grunge_radiator', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(620, 64, '857', 'grunge_shelf', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(621, 64, '859', 'grunge_table', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(622, 64, '858', 'grunge_sign', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(623, 64, '947', 'grunge_candle', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(624, 64, '948', 'grunge_bench', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(625, 64, '949', 'grunge_barrel', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(626, 64, '1515', 'window_grunge', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(628, 67, '837', 'jp_tatami2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(629, 67, '838', 'jp_tatami', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(630, 67, '840', 'jp_bamboo', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(631, 67, '841', 'jp_irori', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(632, 67, '842', 'jp_pillow', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(633, 67, '2020', 'jp_lantern', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(634, 67, '2048', 'jp_drawer', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(635, 67, '954', 'jp_tray6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(636, 67, '955', 'jp_tray5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(637, 67, '956', 'jp_tray4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(638, 67, '957', 'jp_tray3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(639, 67, '958', 'jp_tray2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(640, 67, '959', 'jp_tray1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(641, 67, '986', 'jp_table', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(642, 67, '987', 'jp_rare', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(643, 67, '988', 'jp_katana3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(644, 67, '989', 'jp_katana2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(645, 67, '990', 'jp_katana1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(646, 67, '1020', 'jp_teamaker', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(647, 67, '1486', 'jp_ninjastars', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(648, 67, '1500', 'jp_sheet3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(649, 67, '1501', 'jp_sheet2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(650, 67, '1502', 'jp_sheet1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(651, 75, '2052', 'summer_grill*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(652, 75, '2053', 'summer_grill*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(653, 75, '2054', 'summer_grill*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(654, 75, '2055', 'summer_grill*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(655, 75, '2056', 'summer_chair*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(656, 75, '2057', 'summer_chair*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(657, 75, '2058', 'summer_chair*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(658, 75, '2059', 'summer_chair*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(659, 75, '2060', 'summer_chair*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(660, 75, '2061', 'summer_chair*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(661, 75, '2062', 'summer_chair*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(662, 75, '2063', 'summer_chair*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(663, 75, '2064', 'summer_chair*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(664, 75, '2086', 'summer_pool*1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(665, 75, '2087', 'summer_pool*2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(666, 75, '2088', 'summer_pool*3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(667, 75, '2089', 'summer_pool*4', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(668, 75, '1437', 'summer_raft1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(669, 75, '1439', 'summer_raft2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(670, 75, '1441', 'summer_icebox', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(671, 66, '1638', 'hween09_floor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(672, 66, '1638', 'hween09_floor', 25, 0, 10, 0, 0, 0, 0, 0, '1'),
(673, 66, '1639', 'hween09_jar', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(674, 66, '1641', 'hween09_organ', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(675, 66, '1644', 'hween09_table', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(676, 66, '1645', 'hween09_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(677, 66, '1646', 'hween09_mirror', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(678, 66, '1647', 'hween09_hatch', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(679, 66, '1648', 'hween09_ghost', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(680, 66, '1649', 'hween09_tv', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(681, 66, '1650', 'hween09_chandelier', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(682, 66, '1651', 'hween09_crnr1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(683, 66, '1652', 'hween09_paint', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(684, 66, '1653', 'hween09_treewall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(685, 66, '1654', 'hween09_wall1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(686, 66, '1655', 'hween09_stonewall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(687, 66, '1656', 'hween09_win', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(688, 66, '178', 'pumpkin', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(694, 66, '182', 'deadduck3', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(690, 66, '179', 'skullcandle', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(693, 66, '181', 'deadduck2', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(695, 66, '180', 'deadduck', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(697, 88, '1157', 'hween08_sink', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(698, 88, '1158', 'hween08_curtain', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(699, 88, '1159', 'hween08_bath', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(700, 88, '1160', 'hween08_defibs', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(701, 88, '1161', 'hween08_bbag', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(702, 88, '1162', 'hween08_curtain2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(703, 88, '1163', 'hween08_defibs2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(704, 88, '1164', 'hween08_bed', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(705, 88, '1165', 'hween08_sink2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(706, 88, '1166', 'hween08_bed2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(707, 88, '1167', 'hween08_bath2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(708, 88, '1168', 'hween08_manhole', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(709, 88, '1169', 'hween08_trll', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(710, 88, '1535', 'hween08_rad', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(711, 88, '1536', 'hween08_wndwb', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(712, 88, '1537', 'hween08_wndw', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(713, 88, '1538', 'hween08_bio', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(714, 74, '1241', 'bolly_lotus_pool', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(715, 74, '1243', 'bolly_petals', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(716, 74, '1244', 'bolly_tree', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(717, 74, '1245', 'bolly_swing', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(718, 74, '1246', 'bolly_pillow', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(719, 74, '1247', 'bolly_corner', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(720, 74, '1248', 'bolly_phant', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(721, 74, '1249', 'bolly_monkey_lamp', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(722, 74, '1250', 'bolly_drapeb', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(723, 74, '1252', 'bolly_lamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(724, 74, '1253', 'bolly_desk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(725, 74, '1254', 'bolly_vase', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(726, 74, '1255', 'bolly_tile2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(727, 74, '1256', 'bolly_table', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(728, 74, '1257', 'bolly_drapec', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(729, 74, '1258', 'bolly_fountain', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(735, 73, '1414', 'SF_reactor', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(731, 74, '1260', 'bolly_tile1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(732, 74, '1261', 'bolly_drapea', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(733, 74, '1562', 'bolly_wdw_wd', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(736, 73, '1415', 'SF_crate_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(737, 73, '1416', 'SF_chair_blue', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(738, 73, '1417', 'sf_pod', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(739, 73, '1418', 'SF_panel1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(740, 73, '1419', 'SF_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(741, 73, '1423', 'SF_panel2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(742, 73, '1424', 'sf_gate', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(743, 73, '1420', 'SF_chair_green', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(744, 73, '1421', 'SF_crate_1', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(745, 73, '1422', 'SF_alien', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(746, 73, '1426', 'SF_floor_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(747, 73, '1425', 'SF_panel3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(748, 73, '1427', 'SF_lamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(749, 73, '1428', 'SF_chair_red', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(750, 73, '1429', 'sf_floor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(751, 73, '1430', 'sf_roof', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(752, 73, '1431', 'sf_stick', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(753, 73, '1432', 'SF_floor_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(759, 73, '1603', 'sf_wall3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(758, 73, '1600', 'sf_wall2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(765, 72, '789', 'romantique_pianochair*3', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(767, 72, '791', 'romantique_pianochair*2', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(768, 72, '792', 'romantique_pianochair*4', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(769, 72, '793', 'romantique_pianochair*1', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(770, 72, '794', 'romantique_divan*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(771, 72, '795', 'romantique_divan*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(772, 72, '796', 'romantique_divan*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(773, 72, '797', 'romantique_divan*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(774, 72, '798', 'romantique_divan*1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(775, 72, '799', 'romantique_chair*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(776, 72, '800', 'romantique_chair*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(777, 72, '801', 'romantique_chair*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(778, 72, '802', 'romantique_chair*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(779, 72, '803', 'romantique_chair*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(780, 72, '825', 'romantique_tray2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(781, 72, '826', 'romantique_tray1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(782, 72, '827', 'romantique_smalltabl*3', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(783, 72, '828', 'romantique_smalltabl*5', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(784, 72, '829', 'romantique_smalltabl*2', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(785, 72, '830', 'romantique_smalltabl*4', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(786, 72, '831', 'romantique_smalltabl*1', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(787, 72, '832', 'romantique_mirrortabl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(788, 72, '833', 'romantique_divider*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(789, 72, '834', 'romantique_divider*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(790, 72, '835', 'romantique_divider*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(791, 72, '836', 'romantique_divider*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(792, 72, '1974', 'romantique_clock', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(793, 69, '1170', 'party_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(794, 69, '1171', 'party_discol', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(795, 69, '1172', 'party_block2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(796, 69, '1173', 'party_barcorn', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(797, 69, '1174', 'party_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(798, 69, '1175', 'party_block', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(799, 69, '1176', 'party_ravel', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(800, 69, '1177', 'party_tube_lava', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(801, 69, '1178', 'party_tray', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(802, 69, '1179', 'party_djtable', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(803, 69, '1180', 'party_floor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(804, 69, '1181', 'party_ball', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(805, 69, '1182', 'party_tube_bubble', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(806, 69, '1183', 'party_mic', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(807, 69, '1184', 'party_beamer', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(808, 69, '1185', 'party_bardesk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(809, 69, '1186', 'party_seat', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(810, 69, '1543', 'party_wc_boy', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(811, 69, '1544', 'party_led', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(812, 69, '1545', 'party_neon5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(813, 69, '1546', 'party_neon1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(814, 69, '1547', 'party_neon2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(815, 69, '1548', 'party_wc_girl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(816, 69, '1549', 'party_neon3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(817, 69, '1550', 'party_shelf', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(818, 69, '1551', 'party_neon4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(822, 29, '176', 'doorB', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(821, 29, '177', 'doorC', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(824, 94, '224', 'spyro', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(825, 94, '199', 'throne', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(826, 94, '200', 'samovar', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(827, 94, '108', 'plant_cruddy', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1118, 43, '123', 'wood_tv', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(830, 94, '268', 'djesko_turntable', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(834, 57, '664', 'china_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(835, 57, '676', 'china_shelve', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(836, 57, '694', 'wall_china', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(837, 57, '695', 'corner_china', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(838, 57, '1240', 'china_moongt', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(839, 57, '1242', 'china_ox', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(840, 57, '1559', 'china_pstr2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(846, 60, '2083', 'exe_rug', 20, 0, 6, 0, 0, 0, 0, 0, '1'),
(842, 57, '1560', 'china_light', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(843, 57, '1561', 'china_pstr1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(845, 60, '2083', 'exe_rug', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(847, 60, '2084', 'exe_s_table', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(848, 60, '886', 'exe_bardesk', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(849, 60, '887', 'exe_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(850, 60, '888', 'exe_chair2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(851, 60, '889', 'exe_corner', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(852, 60, '890', 'exe_drinks', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(853, 60, '891', 'exe_sofa', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1758, 123, '898', 'noob_table*1', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(855, 60, '892', 'exe_table', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(856, 60, '928', 'exe_plant', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(857, 60, '1331', 'exe_light', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(858, 60, '1338', 'exe_gate', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(859, 60, '1342', 'exe_cubelight', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(860, 60, '1344', 'exe_artlamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(861, 60, '1584', 'exe_map', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(862, 60, '1585', 'exe_wfall', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(863, 58, '1270', 'lc_tile1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(865, 58, '1272', 'lc_crab2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(866, 58, '1275', 'lc_coral_divider_hi', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(867, 58, '1277', 'lc_tubes_corners', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(868, 58, '1278', 'lc_table', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(869, 58, '1279', 'lc_tile2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(870, 58, '1280', 'lc_anemone', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(871, 58, '1282', 'lc_glass_floor', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(872, 58, '1281', 'lc_coral_divider_low', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(874, 58, '1283', 'lc_medusa1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(875, 58, '1284', 'lc_crab1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(876, 58, '1287', 'lc_tubes_straight', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(877, 58, '1291', 'lc_corner', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(878, 58, '1292', 'lc_stool', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(879, 58, '1293', 'lc_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(880, 58, '1294', 'lc_desk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(881, 58, '1568', 'lc_wall1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(882, 58, '1569', 'lc_window2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(883, 58, '1570', 'lc_window1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(884, 58, '1572', 'lc_wall2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(890, 42, '290', 'a0 prizetrophy3_b', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(889, 42, '289', 'a0 prizetrophy2_b', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(891, 42, '291', 'a0 prizetrophy4_b', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(892, 42, '292', 'a0 prizetrophy5_b', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(893, 42, '293', 'a0 prizetrophy1_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(894, 42, '294', 'a0 prizetrophy2_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(895, 42, '295', 'a0 prizetrophy3_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(896, 42, '296', 'a0 prizetrophy4_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(897, 42, '297', 'a0 prizetrophy4_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(898, 42, '298', 'a0 prizetrophy6_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(899, 42, '299', 'a0 prizetrophy1_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(900, 42, '300', 'a0 prizetrophy2_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(901, 42, '301', 'a0 prizetrophy3_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(902, 42, '302', 'a0 prizetrophy4_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(903, 42, '303', 'a0 prizetrophy5_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(904, 42, '304', 'a0 prizetrophy6_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(905, 42, '305', 'a0 prizetrophy1_b', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(906, 93, '329', 'a0 prizetrophy7_b', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1386, 8, '1136', 'hcc_table', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(908, 93, '330', 'a0 prizetrophy7_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(909, 93, '331', 'a0 prizetrophy7_s', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(910, 42, '951', 'a0 prizetrophy5_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(911, 93, '1436', 'prizetrophy_hot', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(912, 93, '1438', 'prizetrophy_cool', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(913, 32, '168', 'bar_basic', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(914, 32, '169', 'shelves_basic', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(915, 32, '172', 'lamp_basic', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(916, 32, '174', 'fridge', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(987, 65, '1973', 'rope_divider', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(918, 32, '1976', 'pura_mdl5*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(919, 32, '1977', 'pura_mdl5*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(920, 32, '1978', 'pura_mdl5*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(921, 32, '1979', 'pura_mdl5*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(922, 32, '1980', 'pura_mdl5*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(923, 32, '1981', 'pura_mdl5*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(924, 32, '1982', 'pura_mdl5*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(925, 32, '1983', 'pura_mdl5*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(926, 32, '1984', 'pura_mdl4*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(927, 32, '1985', 'pura_mdl4*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(928, 32, '1986', 'pura_mdl4*3', 3, 0, 1, 0, 0, 0, 0, 0, '1');
INSERT INTO `catalog_items_copy` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`, `song_id`, `limited_stack`, `limited_sells`, `offer_active`) VALUES
(929, 32, '1987', 'pura_mdl4*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(930, 32, '1988', 'pura_mdl4*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(931, 32, '1989', 'pura_mdl4*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(932, 32, '1990', 'pura_mdl4*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(933, 32, '1991', 'pura_mdl4*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(934, 32, '1992', 'pura_mdl4*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(935, 32, '1993', 'pura_mdl3*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(936, 32, '1994', 'pura_mdl3*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(937, 32, '1995', 'pura_mdl3*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(938, 32, '1996', 'pura_mdl3*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(939, 32, '1997', 'pura_mdl3*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(940, 32, '1998', 'pura_mdl3*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(941, 32, '1999', 'pura_mdl3*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(942, 32, '2000', 'pura_mdl3*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(943, 32, '2001', 'pura_mdl3*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(944, 32, '2002', 'pura_mdl2*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(945, 32, '2003', 'pura_mdl2*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(947, 32, '2004', 'pura_mdl2*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(948, 32, '2005', 'pura_mdl2*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(949, 32, '2006', 'pura_mdl2*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(950, 32, '2007', 'pura_mdl2*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(951, 32, '2008', 'pura_mdl2*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(952, 32, '2009', 'pura_mdl2*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(953, 32, '2010', 'pura_mdl2*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(954, 32, '2011', 'pura_mdl1*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(955, 32, '2012', 'pura_mdl1*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(956, 32, '2013', 'pura_mdl1*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(957, 32, '2014', 'pura_mdl1*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(958, 32, '2015', 'pura_mdl1*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(959, 32, '2016', 'pura_mdl1*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(960, 32, '2017', 'pura_mdl1*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(961, 32, '2018', 'pura_mdl1*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(962, 32, '2019', 'pura_mdl1*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(963, 32, '2022', 'chair_basic*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(964, 32, '2023', 'chair_basic*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(965, 32, '2024', 'chair_basic*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(966, 32, '2025', 'chair_basic*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(967, 32, '2026', 'chair_basic*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(968, 32, '2027', 'chair_basic*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(969, 32, '2029', 'chair_basic*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(970, 32, '2031', 'bed_budget*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(971, 32, '2032', 'bed_budget*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(972, 32, '2033', 'bed_budget*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(973, 32, '2034', 'bed_budget*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(974, 32, '2035', 'bed_budget*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(975, 32, '2036', 'bed_budget*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(976, 32, '2037', 'bed_budget*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(977, 32, '2038', 'bed_budget*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(978, 32, '2040', 'bed_budget_one*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(979, 32, '2041', 'bed_budget_one*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(980, 32, '2042', 'bed_budget_one*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(981, 32, '2043', 'bed_budget_one*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(982, 32, '2044', 'bed_budget_one*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(983, 32, '2045', 'bed_budget_one*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(984, 32, '2046', 'bed_budget_one*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(985, 32, '2047', 'bed_budget_one*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(988, 65, '839', 'habbowood_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(989, 65, '1943', 'spotlight', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(990, 65, '1487', 'habw_mirror', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(991, 65, '2050', 'tile_marble', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(992, 65, '2050', 'tile_marble', 40, 0, 50, 0, 0, 0, 0, 0, '1'),
(993, 65, '2051', 'tile_brown', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(994, 65, '2051', 'tile_brown', 40, 0, 50, 0, 0, 0, 0, 0, '1'),
(995, 65, '2049', 'tile_stella', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(996, 65, '2049', 'tile_stella', 30, 0, 50, 0, 0, 0, 0, 0, '1'),
(998, 102, '431', 'queue_tile1*3', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(999, 102, '431', 'queue_tile1*3', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1000, 102, '431', 'queue_tile1*3', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1001, 102, '432', 'queue_tile1*6', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1002, 102, '432', 'queue_tile1*6', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1003, 102, '432', 'queue_tile1*6', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1004, 102, '433', 'queue_tile1*4', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1005, 102, '433', 'queue_tile1*4', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1006, 102, '433', 'queue_tile1*4', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1007, 102, '434', 'queue_tile1*9', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1008, 102, '434', 'queue_tile1*9', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1009, 102, '434', 'queue_tile1*9', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1010, 102, '435', 'queue_tile1*8', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1011, 102, '435', 'queue_tile1*8', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1012, 102, '435', 'queue_tile1*8', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1013, 102, '436', 'queue_tile1*5', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1014, 102, '436', 'queue_tile1*5', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1015, 102, '436', 'queue_tile1*5', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1016, 102, '437', 'queue_tile1*7', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1017, 102, '437', 'queue_tile1*7', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1018, 102, '437', 'queue_tile1*7', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1019, 102, '438', 'queue_tile1*2', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1020, 102, '438', 'queue_tile1*2', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1021, 102, '438', 'queue_tile1*2', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1022, 102, '439', 'queue_tile1*1', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1023, 102, '439', 'queue_tile1*1', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1024, 102, '439', 'queue_tile1*1', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1025, 102, '440', 'queue_tile1*0', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1026, 102, '440', 'queue_tile1*0', 18, 0, 3, 0, 0, 0, 0, 0, '1'),
(1027, 102, '440', 'queue_tile1*0', 30, 0, 5, 0, 0, 0, 0, 0, '1'),
(1030, 68, '1389', 'lt_stage2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1029, 68, '1388', 'LT_skull', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1031, 68, '1390', 'lt_lavac', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1032, 68, '1391', 'lt_gate', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1033, 68, '1394', 'lt_statue', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1034, 68, '1395', 'lt_spider', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1035, 68, '1396', 'lt_stone2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1036, 68, '1397', 'LT_throne', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1037, 68, '1399', 'lt_patch', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1038, 68, '1400', 'lt_lava', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1039, 68, '1401', 'LT_pillar2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1040, 68, '1402', 'lt_bughill', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1041, 68, '1405', 'LT_pillar', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1042, 68, '1409', 'lt_stone1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1043, 68, '1406', 'lt_stage1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1044, 68, '1598', 'lt_wall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1045, 68, '1596', 'lt_jngl_wall', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1119, 43, '151', 'tv_luxus', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1050, 61, '712', 'glass_shelf', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1051, 61, '713', 'glass_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1052, 61, '714', 'glass_stool', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1053, 61, '715', 'glass_sofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1054, 61, '717', 'glass_table*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2102, 60, '1259', 'exe_elevator', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1056, 61, '718', 'glass_table*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1057, 61, '716', 'glass_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1058, 61, '719', 'glass_table*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1059, 61, '720', 'glass_table*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1060, 61, '721', 'glass_table*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1061, 61, '722', 'glass_table*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1062, 61, '723', 'glass_table*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1063, 61, '724', 'glass_table*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1064, 61, '725', 'glass_chair*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1065, 61, '726', 'glass_chair*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1066, 61, '727', 'glass_chair*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1067, 61, '728', 'glass_chair*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1068, 61, '729', 'glass_chair*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1069, 61, '730', 'glass_chair*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1070, 61, '731', 'glass_chair*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1071, 61, '732', 'glass_chair*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1072, 61, '733', 'glass_sofa*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1073, 61, '734', 'glass_sofa*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1074, 61, '735', 'glass_sofa*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1075, 61, '736', 'glass_sofa*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1076, 61, '737', 'glass_sofa*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1077, 61, '738', 'glass_sofa*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1078, 61, '739', 'glass_sofa*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1079, 61, '740', 'glass_sofa*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1080, 61, '741', 'glass_stool*2', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1081, 61, '742', 'glass_stool*4', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1082, 61, '743', 'glass_stool*5', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1083, 61, '744', 'glass_stool*6', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1084, 61, '745', 'glass_stool*7', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1085, 61, '746', 'glass_stool*8', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1086, 61, '747', 'glass_stool*3', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1087, 61, '748', 'glass_stool*9', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1088, 72, '822', 'grand_piano*4', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1089, 72, '819', 'grand_piano*3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1090, 72, '820', 'grand_piano*5', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1091, 72, '821', 'grand_piano*2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1092, 72, '823', 'grand_piano*1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1093, 94, '244', 'rare_beehive_bulb', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1094, 94, '257', 'rare_beehive_bulb*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1095, 94, '258', 'rare_beehive_bulb*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1096, 94, '203', 'hologram', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1097, 94, '225', 'redhologram', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1098, 94, '251', 'rare_hammock', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1099, 94, '247', 'rare_elephant_statue', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1100, 94, '248', 'rare_fountain', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1101, 94, '249', 'rare_stand', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1102, 27, '250', 'rare_globe', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1103, 94, '252', 'rare_elephant_statue*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1104, 94, '253', 'rare_elephant_statue*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1105, 94, '254', 'rare_fountain*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1106, 94, '255', 'rare_fountain*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1107, 94, '256', 'rare_fountain*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1108, 94, '260', 'rare_parasol*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1109, 94, '261', 'rare_parasol*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1110, 94, '262', 'rare_parasol*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1111, 94, '306', 'rare_parasol*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1113, 94, '442', 'rare_snowrug', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1114, 94, '662', 'rare_moonrug', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1326, 94, '333', 'scifiport*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1120, 43, '1476', 'post.it', 3, 0, 30, 0, 0, 0, 0, 0, '1'),
(1121, 41, '1492', 'hrella_poster_3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1122, 41, '1493', 'hrella_poster_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1123, 41, '1494', 'hrella_poster_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1124, 43, '102', 'pizza', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1125, 43, '103', 'drinks', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1133, 112, '1678', 'ads_twi_dvdr2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1127, 43, '109', 'bottle', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1128, 43, '208', 'edice', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1132, 112, '1677', 'ads_twi_fountn', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1134, 112, '1679', 'ads_twi_roses', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1135, 112, '1680', 'ads_twi_table', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1136, 112, '1681', 'ads_twi_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1137, 112, '1682', 'ads_twi_dvdr1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1138, 112, '1683', 'ads_twi_piano', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1139, 112, '1684', 'ads_twi_tower', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1140, 112, '1685', 'ads_twi_toolbx', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1141, 112, '1686', 'ads_twi_mist', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1159, 62, '757', 'gothiccandelabra', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1154, 62, '758', 'gothrailing', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1152, 62, '771', 'gothic_sofa*1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1156, 62, '772', 'gothic_stool*1', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1157, 62, '774', 'gothic_sofa*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1173, 62, '784', 'gothic_stool*5', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1160, 62, '756', 'gothgate', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1161, 62, '759', 'goth_table', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1162, 62, '770', 'gothic_chair*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1163, 62, '773', 'gothic_chair*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1164, 62, '775', 'gothic_stool*2', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1165, 62, '776', 'gothic_chair*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1166, 62, '777', 'gothic_sofa*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1167, 62, '778', 'gothic_stool*3', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1168, 62, '779', 'gothic_chair*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1169, 62, '780', 'gothic_sofa*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1170, 62, '781', 'gothic_stool*4', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1171, 62, '782', 'gothic_chair*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1172, 62, '783', 'gothic_sofa*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1174, 62, '785', 'gothic_chair*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1175, 62, '786', 'gothic_sofa*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1176, 62, '787', 'gothic_stool*6', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1177, 62, '814', 'gothic_carpet', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1178, 62, '815', 'gothic_carpet2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1179, 62, '816', 'gothic_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1180, 62, '817', 'gothic_sofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1181, 62, '818', 'gothic_stool', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1182, 62, '1480', 'gothicfountain', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1183, 62, '1483', 'torch', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1184, 62, '1540', 'gothicfountain2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1186, 103, '1027', 'diner_tray_6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1187, 103, '1028', 'diner_tray_5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1188, 103, '1029', 'diner_tray_4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1191, 103, '1031', 'diner_tray_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1294, 94, '392', 'pillar*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1190, 103, '1030', 'diner_tray_3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1192, 103, '1032', 'diner_tray_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1193, 103, '1026', 'diner_tray_7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1194, 103, '1033', 'diner_tray_0', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1195, 103, '1034', 'diner_sofa_2*1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1196, 103, '1035', 'diner_sofa_2*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1197, 103, '1036', 'diner_sofa_2*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1198, 103, '1037', 'diner_sofa_2*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1199, 103, '1038', 'diner_sofa_2*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1200, 103, '1039', 'diner_sofa_2*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1201, 103, '1040', 'diner_sofa_2*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1202, 103, '1041', 'diner_sofa_2*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1203, 103, '1042', 'diner_sofa_2*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1204, 103, '1043', 'diner_shaker', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1205, 103, '1044', 'diner_rug', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1206, 103, '1044', 'diner_rug', 25, 0, 10, 0, 0, 0, 0, 0, '1'),
(1207, 103, '1045', 'diner_gumvendor*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1208, 103, '1046', 'diner_gumvendor*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1209, 103, '1047', 'diner_gumvendor*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1210, 103, '1048', 'diner_gumvendor*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1211, 103, '1049', 'diner_gumvendor*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1212, 103, '1050', 'diner_gumvendor*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1213, 103, '1051', 'diner_gumvendor*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1214, 103, '1052', 'diner_gumvendor*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1215, 103, '1053', 'diner_gumvendor*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1216, 103, '1054', 'diner_cashreg*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1217, 103, '1057', 'diner_cashreg*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1218, 103, '1055', 'diner_cashreg*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1219, 103, '1056', 'diner_cashreg*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1220, 103, '1058', 'diner_cashreg*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1221, 103, '1059', 'diner_cashreg*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1222, 103, '1060', 'diner_cashreg*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1223, 103, '1061', 'diner_cashreg*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1224, 103, '1062', 'diner_cashreg*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1225, 103, '1063', 'diner_table_2*1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1226, 103, '1064', 'diner_table_2*2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1227, 103, '1065', 'diner_table_2*3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1228, 103, '1066', 'diner_table_2*4', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1229, 103, '1067', 'diner_table_2*5', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1230, 103, '1068', 'diner_table_2*6', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1231, 103, '1069', 'diner_table_2*7', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1232, 103, '1070', 'diner_table_2*8', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1233, 103, '1071', 'diner_table_2*9', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1234, 103, '1072', 'diner_table_1*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1235, 103, '1073', 'diner_table_1*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1236, 103, '1074', 'diner_table_1*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1237, 103, '1075', 'diner_table_1*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1238, 103, '1076', 'diner_table_1*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1239, 103, '1077', 'diner_table_1*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1240, 103, '1078', 'diner_table_1*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1241, 103, '1079', 'diner_table_1*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1242, 103, '1080', 'diner_table_1*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1243, 103, '1081', 'diner_sofa_1*1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1244, 103, '1082', 'diner_sofa_1*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1245, 103, '1083', 'diner_sofa_1*3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1246, 103, '1084', 'diner_sofa_1*4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1247, 103, '1085', 'diner_sofa_1*5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1248, 103, '1086', 'diner_sofa_1*6', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1251, 103, '1088', 'diner_sofa_1*8', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1250, 103, '1087', 'diner_sofa_1*7', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1252, 103, '1089', 'diner_sofa_1*9', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1253, 103, '1090', 'diner_chair*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1254, 103, '1091', 'diner_chair*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1255, 103, '1092', 'diner_chair*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1256, 103, '1093', 'diner_chair*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1257, 103, '1094', 'diner_chair*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1258, 103, '1095', 'diner_chair*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1259, 103, '1096', 'diner_chair*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1260, 103, '1097', 'diner_chair*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1261, 103, '1098', 'diner_chair*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1262, 103, '1099', 'diner_bardesk_gate*1', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1263, 103, '1100', 'diner_bardesk_gate*2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1264, 103, '1101', 'diner_bardesk_gate*3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1265, 103, '1102', 'diner_bardesk_gate*4', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1266, 103, '1103', 'diner_bardesk_gate*5', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1267, 103, '1104', 'diner_bardesk_gate*6', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2119, 7, '1720', 'DEAL_HC_3', 500, 0, 6, 0, 0, 0, 0, 0, '1'),
(1269, 103, '1105', 'diner_bardesk_gate*7', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1270, 103, '1106', 'diner_bardesk_gate*8', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1271, 103, '1107', 'diner_bardesk_gate*9', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1272, 103, '1108', 'diner_bardesk_corner*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1273, 103, '1109', 'diner_bardesk_corner*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1274, 103, '1110', 'diner_bardesk_corner*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1275, 103, '1111', 'diner_bardesk_corner*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1276, 103, '1112', 'diner_bardesk_corner*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1277, 103, '1113', 'diner_bardesk_corner*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1278, 103, '1114', 'diner_bardesk_corner*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1279, 103, '1115', 'diner_bardesk_corner*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1280, 103, '1116', 'diner_bardesk*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1281, 103, '1117', 'diner_bardesk*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1282, 103, '1118', 'diner_bardesk*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1283, 103, '1119', 'diner_bardesk*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1284, 103, '1120', 'diner_bardesk*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1285, 103, '1121', 'diner_bardesk*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1286, 103, '1122', 'diner_bardesk*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1287, 103, '1123', 'diner_bardesk*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1288, 103, '1124', 'diner_bardesk*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1289, 103, '1523', 'window_diner2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1290, 103, '1524', 'window_diner', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1291, 103, '1525', 'diner_walltable', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1292, 103, '1595', 'diner_poster', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1295, 94, '393', 'pillar*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1296, 94, '394', 'pillar*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1297, 94, '395', 'pillar*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1298, 94, '396', 'pillar*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1299, 94, '397', 'pillar*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1300, 94, '398', 'pillar*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1301, 94, '399', 'pillar*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1302, 94, '400', 'pillar*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1303, 94, '382', 'wooden_screen*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1304, 94, '383', 'wooden_screen*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1305, 94, '384', 'wooden_screen*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1306, 94, '385', 'wooden_screen*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1307, 94, '386', 'wooden_screen*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1308, 94, '387', 'wooden_screen*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1309, 94, '388', 'wooden_screen*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1310, 94, '389', 'wooden_screen*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1311, 94, '390', 'wooden_screen*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1312, 94, '391', 'wooden_screen*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1313, 94, '411', 'rare_icecream*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1314, 94, '412', 'rare_icecream*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1315, 94, '413', 'rare_icecream*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1316, 94, '414', 'rare_icecream*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1317, 94, '415', 'rare_icecream*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1318, 94, '416', 'rare_icecream*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1319, 94, '417', 'rare_icecream*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1320, 94, '418', 'rare_icecream*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1321, 94, '419', 'rare_icecream*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1322, 94, '420', 'rare_icecream*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1323, 95, '1975', 'rare_icecream_campaign', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1324, 95, '976', 'calippo', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1325, 94, '332', 'scifiport*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1327, 94, '334', 'scifiport*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1328, 94, '335', 'scifiport*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1329, 94, '336', 'scifiport*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1330, 94, '337', 'scifiport*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1331, 94, '338', 'scifiport*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1332, 94, '339', 'scifiport*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1333, 94, '340', 'scifiport*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1334, 94, '341', 'scifiport*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1335, 94, '342', 'scifirocket*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1336, 94, '343', 'scifirocket*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1337, 94, '344', 'scifirocket*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1338, 94, '345', 'scifirocket*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1339, 94, '346', 'scifirocket*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1340, 94, '347', 'scifirocket*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1341, 94, '348', 'scifirocket*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1342, 94, '349', 'scifirocket*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1343, 94, '350', 'scifirocket*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1344, 94, '351', 'scifirocket*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1345, 94, '352', 'scifidoor*10', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1346, 94, '353', 'scifidoor*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1347, 94, '354', 'scifidoor*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1348, 94, '355', 'scifidoor*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1349, 94, '356', 'scifidoor*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1350, 94, '357', 'scifidoor*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1351, 94, '358', 'scifidoor*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1352, 94, '359', 'scifidoor*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1353, 94, '361', 'scifidoor*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1354, 94, '360', 'scifidoor*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1355, 27, '183', 'menorah', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1356, 43, '185', 'ham', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1357, 27, '186', 'turkey', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1358, 27, '188', 'house', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1359, 43, '193', 'ham2', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1360, 27, '194', 'wcandleset', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1361, 43, '202', 'habbocake', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1362, 39, '201', 'giftflowers', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1365, 8, '235', 'chair_plasto*14', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1364, 8, '209', 'club_sofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1366, 8, '236', 'table_plasto_4leg*14', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1367, 8, '242', 'edicehc', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1368, 8, '245', 'hcsohva', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1369, 8, '246', 'hcamme', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1370, 8, '307', 'hc_lmp', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1371, 8, '308', 'hc_tbl', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1372, 8, '309', 'hc_chr', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1373, 8, '310', 'hc_dsk', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1374, 8, '754', 'hc_crpt', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1375, 8, '755', 'hc_tv', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1376, 8, '760', 'hc_bkshlf', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1377, 8, '761', 'hc_btlr', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1378, 8, '762', 'hc_crtn', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1379, 8, '763', 'hc_djset', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1380, 8, '764', 'hc_frplc', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1381, 8, '765', 'hc_lmpst', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1382, 8, '766', 'hc_machine', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1383, 8, '767', 'hc_rllr', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(1384, 8, '768', 'hc_rntgn', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1385, 8, '769', 'hc_trll', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1387, 8, '1137', 'hcc_shelf', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1388, 8, '1138', 'hcc_sofa', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1389, 8, '1139', 'hcc_minibar', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1390, 8, '1140', 'hcc_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1391, 8, '1144', 'hcc_stool', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1392, 8, '1145', 'hcc_sofachair', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1393, 8, '1146', 'hcc_crnr', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1394, 8, '1147', 'hcc_dvdr', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1398, 36, '8', 'table_plasto_4leg', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1396, 8, '1481', 'hc_wall_lamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1399, 36, '9', 'table_plasto_round', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1400, 36, '10', 'table_plasto_bigsquare', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1401, 36, '22', 'chair_plasty', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1402, 36, '23', 'chair_plasto', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1403, 36, '24', 'table_plasto_square', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1404, 36, '47', 'table_plasto_4leg*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1405, 36, '48', 'table_plasto_bigsquare*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1406, 36, '49', 'table_plasto_round*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1407, 36, '50', 'table_plasto_square*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1408, 36, '51', 'chair_plasto*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1409, 36, '54', 'table_plasto_4leg*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1410, 36, '55', 'table_plasto_bigsquare*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1411, 36, '56', 'table_plasto_round*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1412, 36, '57', 'table_plasto_square*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1413, 36, '58', 'chair_plasto*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1414, 36, '61', 'table_plasto_4leg*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1415, 36, '62', 'table_plasto_bigsquare*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1416, 36, '63', 'table_plasto_round*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1417, 36, '64', 'table_plasto_square*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1418, 36, '65', 'chair_plasto*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1419, 36, '68', 'table_plasto_4leg*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1420, 36, '69', 'table_plasto_square*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1421, 36, '70', 'chair_plasto*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1422, 36, '76', 'table_plasto_4leg*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1423, 36, '77', 'table_plasto_bigsquare*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1424, 36, '78', 'table_plasto_round*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1425, 36, '79', 'table_plasto_square*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1426, 36, '80', 'chair_plasto*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1427, 36, '81', 'table_plasto_4leg*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1428, 36, '82', 'table_plasto_bigsquare*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1429, 36, '83', 'table_plasto_round*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1430, 36, '84', 'table_plasto_square*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1431, 36, '85', 'chair_plasto*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1432, 36, '86', 'table_plasto_4leg*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1433, 36, '87', 'table_plasto_bigsquare*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1434, 36, '88', 'table_plasto_round*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1435, 36, '89', 'table_plasto_square*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1436, 36, '90', 'chair_plasto*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1437, 36, '91', 'table_plasto_4leg*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1438, 36, '92', 'table_plasto_bigsquare*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1439, 36, '93', 'table_plasto_round*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1440, 36, '94', 'table_plasto_square*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1441, 36, '95', 'chair_plasto*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1442, 36, '96', 'table_plasto_4leg*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1443, 36, '97', 'table_plasto_bigsquare*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1444, 36, '98', 'table_plasto_round*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1445, 36, '99', 'chair_plasto*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1446, 36, '229', 'chair_plasto*10', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1447, 36, '230', 'chair_plasto*11', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1448, 36, '233', 'chair_plasto*12', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1449, 36, '234', 'chair_plasto*13', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1450, 36, '270', 'table_plasto_4leg*10', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1451, 36, '271', 'table_plasto_4leg*15', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1452, 36, '272', 'table_plasto_bigsquare*14', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1453, 36, '273', 'table_plasto_bigsquare*15', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1454, 36, '274', 'table_plasto_round*14', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1455, 36, '275', 'table_plasto_round*15', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1456, 36, '276', 'table_plasto_square*14', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1457, 36, '277', 'table_plasto_square*15', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1458, 36, '278', 'chair_plasto*15', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1459, 36, '284', 'chair_plasto*16', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1460, 36, '285', 'table_plasto_4leg*16', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1462, 40, '17', 'doormat_love', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(1463, 40, '18', 'doormat_plain', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1464, 40, '53', 'doormat_plain*1', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(1465, 40, '59', 'doormat_plain*2', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(1466, 40, '67', 'doormat_plain*3', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(1467, 40, '72', 'doormat_plain*4', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(1468, 40, '73', 'doormat_plain*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1469, 40, '74', 'doormat_plain*5', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(1471, 95, '27', 'bed_trad_one', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1472, 95, '28', 'bed_trad', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1473, 35, '35', 'shelves_armas', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1474, 32, '33', 'bed_budget_one', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1475, 32, '34', 'bed_budget', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1476, 32, '136', 'bed_budgetb_one', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1477, 32, '137', 'bed_budgetb', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1478, 32, '2030', 'bed_budget*1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1479, 32, '2039', 'bed_budget_one*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1482, 36, '101', 'chair_plasty*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1483, 36, '104', 'chair_plasty*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1484, 36, '105', 'chair_plasty*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1485, 36, '106', 'chair_plasty*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1486, 36, '125', 'chair_plasty*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1487, 36, '129', 'chair_plasty*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1488, 36, '279', 'chair_plasty*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1489, 36, '280', 'chair_plasty*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1490, 36, '281', 'chair_plasty*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1491, 36, '282', 'chair_plasty*10', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1492, 36, '283', 'chair_plasty*11', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1564, 94, '364', 'pillow*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1496, 35, '214', 'divider_arm1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1497, 35, '215', 'divider_arm2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1498, 35, '216', 'divider_arm3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1499, 94, '210', 'a0 prize1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1500, 94, '211', 'a0 prize2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1501, 94, '212', 'a0 prize3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1502, 55, '217', 'divider_nor1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1503, 55, '219', 'divider_nor2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2099, 95, '1709', 'party_lights', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1505, 55, '221', 'divider_nor3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1506, 55, '456', 'divider_nor4*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1507, 55, '504', 'divider_nor1*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1508, 55, '505', 'divider_nor1*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1509, 55, '506', 'divider_nor1*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1510, 55, '507', 'divider_nor1*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1511, 55, '508', 'divider_nor1*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1512, 55, '509', 'divider_nor1*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1513, 55, '510', 'divider_nor1*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1514, 55, '511', 'divider_nor1*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1515, 55, '635', 'divider_nor3*2', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1516, 55, '636', 'divider_nor3*3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1517, 55, '637', 'divider_nor3*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1518, 55, '638', 'divider_nor3*5', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1519, 55, '639', 'divider_nor3*6', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1520, 55, '640', 'divider_nor3*7', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1521, 55, '641', 'divider_nor3*8', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1522, 55, '642', 'divider_nor3*9', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1523, 55, '643', 'divider_nor2*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1524, 55, '644', 'divider_nor2*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1525, 55, '645', 'divider_nor2*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1526, 55, '646', 'divider_nor2*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1527, 55, '647', 'divider_nor2*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1528, 55, '648', 'divider_nor2*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1529, 55, '649', 'divider_nor2*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1530, 55, '650', 'divider_nor2*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1531, 55, '678', 'divider_nor4*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1532, 55, '679', 'divider_nor4*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1533, 55, '680', 'divider_nor4*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1534, 55, '681', 'divider_nor4*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1535, 55, '682', 'divider_nor4*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1536, 55, '683', 'divider_nor4*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1537, 55, '684', 'divider_nor4*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1538, 55, '685', 'divider_nor5*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1539, 55, '686', 'divider_nor5*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1540, 55, '687', 'divider_nor5*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1541, 55, '688', 'divider_nor5*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1542, 55, '689', 'divider_nor5*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1543, 55, '690', 'divider_nor5*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1544, 55, '691', 'divider_nor5*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1545, 55, '692', 'divider_nor5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1546, 55, '693', 'divider_nor4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1547, 94, '223', 'typingmachine', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1548, 27, '226', 'joulutahti', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1549, 94, '227', 'hyacinth1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1550, 94, '228', 'hyacinth2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1551, 30, '231', 'bardeskcorner_polyfon*12', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1552, 20, '232', 'bardeskcorner_polyfon*13', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1553, 8, '237', 'mocchamaster', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1554, 94, '243', 'rare_daffodil_rug', 10000, 5000, 3, 0, 0, 0, 0, 0, '1'),
(1555, 27, '263', 'tree1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2101, 71, '1710', 'rela_stick', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1557, 27, '265', 'wcandle', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1558, 27, '267', 'house2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1559, 94, '269', 'md_limukaappi', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1587, 94, '372', 'marquee*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1561, 8, '288', 'doorD', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1562, 94, '362', 'pillow*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1563, 94, '363', 'pillow*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1565, 94, '365', 'pillow*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1566, 94, '366', 'pillow*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1567, 94, '367', 'pillow*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1568, 94, '368', 'pillow*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1569, 94, '369', 'pillow*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1570, 94, '370', 'pillow*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1571, 94, '371', 'pillow*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1572, 95, '1233', 'ads_ob_pillow', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1573, 94, '373', 'marquee*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1574, 94, '401', 'rare_dragonlamp*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1575, 94, '402', 'rare_dragonlamp*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1576, 94, '403', 'rare_dragonlamp*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1577, 94, '404', 'rare_dragonlamp*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1578, 94, '405', 'rare_dragonlamp*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1579, 94, '406', 'rare_dragonlamp*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1580, 94, '407', 'rare_dragonlamp*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1581, 94, '408', 'rare_dragonlamp*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1582, 94, '409', 'rare_dragonlamp*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1583, 94, '410', 'rare_dragonlamp*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1584, 94, '424', 'rare_fan*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1585, 58, '1234', 'lostc_merdragon', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1588, 94, '374', 'marquee*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1589, 94, '376', 'marquee*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1590, 94, '377', 'marquee*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1591, 94, '378', 'marquee*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1592, 94, '379', 'marquee*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1593, 94, '380', 'marquee*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1594, 94, '381', 'marquee*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1595, 94, '375', 'marquee*10', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1596, 94, '421', 'rare_fan*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1598, 94, '422', 'rare_fan*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1599, 94, '423', 'rare_fan*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1600, 94, '424', 'rare_fan*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1601, 94, '425', 'rare_fan*0', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1602, 94, '426', 'rare_fan*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1603, 94, '427', 'rare_fan*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1604, 94, '428', 'rare_fan*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1605, 94, '429', 'rare_fan*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1606, 94, '430', 'rare_fan*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1607, 95, '1410', 'ads_calip_fan', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1608, 62, '1482', 'industrialfan', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1609, 57, '443', 'cn_lamp', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1610, 57, '444', 'cn_sofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1611, 95, '1125', 'ads_dave_cns', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1612, 94, '462', 'rubberchair*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1613, 94, '463', 'rubberchair*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1614, 94, '464', 'rubberchair*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1615, 94, '465', 'rubberchair*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1616, 94, '466', 'rubberchair*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1617, 94, '467', 'rubberchair*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1618, 94, '471', 'rubberchair*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1619, 94, '472', 'rubberchair*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1620, 94, '457', 'traffic_light*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1621, 94, '458', 'traffic_light*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1622, 94, '459', 'traffic_light*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1623, 94, '460', 'traffic_light*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1624, 94, '461', 'traffic_light*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1625, 94, '677', 'traffic_light*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1626, 94, '468', 'barrier*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1627, 94, '469', 'barrier*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1628, 94, '470', 'barrier*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1629, 94, '661', 'sandrug', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1630, 94, '665', 'sleepingbag*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1631, 94, '666', 'sleepingbag*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1632, 94, '667', 'sleepingbag*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1633, 94, '668', 'sleepingbag*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1634, 94, '670', 'sleepingbag*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1635, 94, '671', 'sleepingbag*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1636, 94, '672', 'sleepingbag*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1637, 94, '673', 'sleepingbag*10', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1638, 94, '674', 'sleepingbag*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1639, 94, '675', 'sleepingbag*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1640, 13, '749', 'CF_10_coin_gold', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1641, 13, '750', 'CF_1_coin_bronze', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(1642, 13, '751', 'CF_20_moneybag', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(1643, 12, '752', 'CF_50_goldbar', 50, 0, 1, 0, 0, 0, 0, 0, '1'),
(1644, 13, '753', 'CF_5_coin_silver', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1645, 65, '824', 'theatre_seat', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1646, 32, '2021', 'chair_basic*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1647, 32, '2028', 'chair_basic*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1648, 40, '846', 'carpet_soft_tut', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1649, 66, '862', 'hal_cauldron', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1650, 66, '863', 'hal_grave', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1651, 66, '1141', 'det_divider', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1652, 66, '1143', 'det_body', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1653, 66, '1533', 'det_bhole', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569039, 5, '0', 'deal_vip_1_year_and_badge', 100, 0, 1, 0, 0, 0, 0, 0, '1'),
(1655, 121, '788', 'sound_machine', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1656, 121, '1942', 'sound_machine*1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1657, 121, '1944', 'sound_machine*2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1658, 121, '1945', 'sound_machine*3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1659, 121, '1946', 'sound_machine*4', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1660, 121, '1947', 'sound_machine*5', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1661, 121, '1948', 'sound_machine*6', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1662, 121, '1949', 'sound_machine*7', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1663, 121, '2073', 'sound_machine_pro', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1664, 122, '843', 'sound_set_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1665, 122, '844', 'sound_set_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1666, 122, '1935', 'sound_set_3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1667, 122, '1936', 'sound_set_4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1668, 122, '1937', 'sound_set_5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1669, 122, '1938', 'sound_set_6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1670, 122, '1939', 'sound_set_7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1671, 122, '1940', 'sound_set_8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1672, 122, '1941', 'sound_set_9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1673, 122, '1955', 'sound_set_27', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1674, 122, '1956', 'sound_set_26', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1675, 122, '1954', 'sound_set_28', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1676, 122, '1957', 'sound_set_25', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1677, 122, '1958', 'sound_set_24', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1678, 122, '1959', 'sound_set_23', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1679, 122, '1961', 'sound_set_22', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1680, 122, '1960', 'sound_set_22', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1681, 122, '1962', 'sound_set_20', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1682, 122, '1963', 'sound_set_19', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1683, 122, '1964', 'sound_set_18', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1684, 122, '1965', 'sound_set_17', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1685, 122, '1966', 'sound_set_16', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1686, 122, '1967', 'sound_set_15', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1687, 122, '1968', 'sound_set_14', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1688, 122, '1969', 'sound_set_13', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1689, 122, '1970', 'sound_set_12', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1690, 122, '1971', 'sound_set_11', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1691, 122, '1972', 'sound_set_10', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1692, 122, '2065', 'sound_set_36', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1693, 122, '2066', 'sound_set_35', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1694, 122, '2067', 'sound_set_34', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1695, 122, '2068', 'sound_set_33', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1696, 122, '2069', 'sound_set_32', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1697, 122, '2070', 'sound_set_31', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1698, 122, '2071', 'sound_set_30', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1699, 122, '2072', 'sound_set_29', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1700, 122, '2085', 'sound_set_37', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1701, 122, '847', 'sound_set_44', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1702, 122, '848', 'sound_set_43', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2756, 137, '1', 'World Cup Soccer', 15, 0, 9, 0, 0, 0, 0, 0, '1'),
(1704, 122, '850', 'sound_set_41', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1705, 122, '851', 'sound_set_40', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1706, 122, '852', 'sound_set_39', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1707, 122, '853', 'sound_set_38', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1708, 122, '864', 'sound_set_52', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1709, 122, '865', 'sound_set_51', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1710, 122, '866', 'sound_set_50', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1711, 122, '867', 'sound_set_49', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1712, 122, '868', 'sound_set_48', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1713, 122, '869', 'sound_set_47', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1714, 122, '870', 'sound_set_46', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1715, 122, '871', 'sound_set_45', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1716, 122, '878', 'sound_set_54', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1717, 122, '879', 'sound_set_53', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1718, 122, '893', 'sound_set_59', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1719, 122, '894', 'sound_set_58', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1720, 122, '895', 'sound_set_57', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1721, 122, '896', 'sound_set_56', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1722, 122, '897', 'sound_set_55', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1723, 122, '938', 'sound_set_61', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1724, 122, '939', 'sound_set_60', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1725, 122, '972', 'sound_set_64', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1726, 122, '973', 'sound_set_63', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1727, 122, '974', 'sound_set_62', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1728, 122, '1008', 'sound_set_70', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1729, 122, '1009', 'sound_set_69', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1730, 122, '1010', 'sound_set_68', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1731, 122, '1011', 'sound_set_67', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1732, 122, '1012', 'sound_set_66', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1733, 122, '1013', 'sound_set_65', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1734, 122, '1205', 'sound_set_71', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1735, 122, '1372', 'sound_set_72', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1736, 95, '1951', 'rclr_sofa', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1737, 72, '1950', 'rom_lamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1738, 95, '1952', 'rclr_garden', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1739, 95, '1953', 'rclr_chair', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1740, 95, '2074', 'rare_mnstr', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1752, 121, '845', 'jukebox*1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1742, 94, '2076', 'one_way_door*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1743, 94, '2077', 'one_way_door*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1744, 94, '2078', 'one_way_door*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1745, 94, '2079', 'one_way_door*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1746, 94, '2080', 'one_way_door*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1747, 94, '2081', 'one_way_door*8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1748, 94, '2082', 'one_way_door*9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1753, 66, '860', 'habboween_crypt', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(1750, 94, '2075', 'one_way_door*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1754, 66, '861', 'habboween_grass', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1755, 39, '881', 'plant_mazegate_snow', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1756, 39, '882', 'plant_maze_snow', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1759, 123, '899', 'noob_table*2', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1760, 123, '900', 'noob_table*3', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1808, 75, '944', 'sand_cstl_wall', 5, 0, 1, 0, 0, 0, 0, 0, '1');
INSERT INTO `catalog_items_copy` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`, `song_id`, `limited_stack`, `limited_sells`, `offer_active`) VALUES
(1762, 123, '901', 'noob_table*4', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1763, 123, '902', 'noob_table*5', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1764, 123, '903', 'noob_table*6', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1765, 123, '904', 'noob_stool*1', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1766, 123, '905', 'noob_stool*2', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1767, 123, '906', 'noob_stool*3', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1768, 123, '907', 'noob_stool*4', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1769, 123, '908', 'noob_stool*5', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1770, 123, '909', 'noob_stool*6', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1771, 123, '910', 'noob_rug*1', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1772, 123, '911', 'noob_rug*2', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1773, 123, '912', 'noob_rug*3', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1774, 123, '913', 'noob_rug*4', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1775, 123, '914', 'noob_rug*5', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1776, 123, '915', 'noob_rug*6', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1777, 123, '916', 'noob_lamp*1', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1778, 123, '917', 'noob_lamp*2', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1779, 123, '918', 'noob_lamp*3', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1780, 123, '919', 'noob_lamp*4', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1781, 123, '920', 'noob_lamp*5', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1782, 123, '921', 'noob_lamp*6', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1783, 123, '922', 'noob_chair*1', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1784, 123, '923', 'noob_chair*2', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1785, 123, '924', 'noob_chair*3', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1786, 123, '925', 'noob_chair*4', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1787, 123, '926', 'noob_chair*5', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1788, 123, '927', 'noob_chair*6', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1826, 126, '1003', 'tiki_corner', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1825, 126, '1002', 'tiki_junglerug', 45, 0, 10, 0, 0, 0, 0, 0, '1'),
(1824, 126, '1002', 'tiki_junglerug', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1823, 126, '1001', 'tiki_parasol', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1822, 126, '1000', 'tiki_sand', 45, 0, 10, 0, 0, 0, 0, 0, '1'),
(1821, 126, '1000', 'tiki_sand', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1795, 123, '1017', 'noob_plant', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1820, 126, '999', 'tiki_statue', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1819, 126, '998', 'tiki_torch', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1818, 126, '997', 'tiki_toucan', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1817, 126, '996', 'tiki_tray0', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1816, 126, '994', 'tiki_tray2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1815, 126, '995', 'tiki_tray1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1832, 76, '940', 'fortune', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1813, 126, '993', 'tiki_tray3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1812, 126, '992', 'tiki_tray4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1811, 126, '991', 'tiki_waterfall', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1809, 75, '945', 'sand_cstl_twr', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1810, 75, '946', 'sand_cstl_gate', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1827, 126, '1004', 'tiki_bflies', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1828, 126, '1005', 'tiki_bench', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1829, 126, '1006', 'tiki_bardesk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1830, 126, '1505', 'tiki_wallplnt', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1831, 126, '1506', 'tiki_surfboard', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1833, 95, '941', 'sw_table', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1834, 95, '942', 'sw_raven', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1836, 95, '943', 'sw_chest', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1838, 95, '950', 'rclr_lamp', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1839, 95, '953', 'md_rug', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1840, 95, '952', 'nouvelle_trax', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1841, 95, '975', 'jukebox_ptv*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1842, 121, '977', 'traxsilver', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1843, 121, '978', 'traxgold', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1844, 121, '979', 'traxbronze', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1845, 95, '980', 'bench_puffet', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1846, 13, '981', 'CFC_500_goldbar', 500, 0, 1, 0, 0, 0, 0, 0, '1'),
(1847, 13, '982', 'CFC_200_moneybag', 200, 0, 1, 0, 0, 0, 0, 0, '1'),
(1848, 13, '984', 'CFC_100_coin_gold', 100, 0, 1, 0, 0, 0, 0, 0, '1'),
(1851, 128, '1640', 'urban_bench_plain', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1850, 13, '985', 'CFC_50_coin_silver', 50, 0, 1, 0, 0, 0, 0, 0, '1'),
(1852, 95, '1151', 'ads_igorswitch', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1853, 95, '1152', 'ads_711*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1854, 95, '1153', 'ads_711*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1855, 95, '1154', 'ads_711*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1856, 95, '1155', 'ads_711*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1857, 95, '1156', 'ads_igorraygun', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1858, 95, '1235', 'ads_cldesk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1859, 95, '1237', 'ads_cltele', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1860, 95, '1238', 'ads_clfloor', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1862, 95, '1150', 'ads_igorbrain', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1863, 95, '1239', 'ads_mall_tele', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1864, 95, '1262', 'ads_idol_floor1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1865, 95, '1263', 'ads_igor_dsk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1866, 95, '1264', 'ads_idol_desk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1867, 95, '1265', 'ads_idol_ch', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1868, 95, '1266', 'ads_igor_flask', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1869, 95, '1267', 'ads_idol_drape', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1870, 95, '1268', 'ads_idol_floor2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1871, 95, '1274', 'ads_idol_piano', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1872, 95, '1276', 'ads_711shelf', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1873, 95, '1285', 'ads_idol_jukebox*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1874, 95, '1286', 'ads_idol_pchair', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1875, 95, '1288', 'ads_idol_audChr', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1876, 95, '1289', 'ads_idol_trax', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1877, 95, '1290', 'ads_idol_tele', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1878, 95, '1295', 'ads_idol_mic', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1879, 95, '1296', 'ads_idol_hotspot', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1880, 95, '1297', 'ads_idol_clRack', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1881, 95, '1298', 'ads_idol_voting_ch', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1882, 95, '1312', 'ads_frankb', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1883, 95, '1329', 'ads_grefusa_cactus', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1884, 95, '1330', 'ads_idol_tube', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1885, 95, '1332', 'ads_idol_cork', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1886, 95, '1333', 'ads_cl_jukeb', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1887, 95, '1339', 'ads_idol_newsDsk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1888, 95, '1345', 'ads_idol_ichair', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1889, 95, '1347', 'ads_reebok_block2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1890, 95, '1348', 'ads_malaco_rug', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1891, 95, '1351', 'ads_malaco_gu', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1892, 95, '1352', 'ads_clcake', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1893, 95, '1353', 'ads_cl_sofa', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1894, 95, '1354', 'ads_idol_tblCloth', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1895, 95, '1355', 'ads_idol_carpet', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1896, 95, '1356', 'ads_idol_lamp', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1897, 95, '1362', 'ads_goldtabl', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1898, 95, '1374', 'ads_calip_cola*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1899, 95, '1375', 'ads_calip_cola*2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1900, 95, '1376', 'ads_calip_cola*3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1901, 95, '1451', 'ads_711*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1902, 95, '1377', 'ads_calip_cola*4', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1903, 95, '1383', 'ads_calip_chair', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1904, 95, '1384', 'ads_idol_trophy', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1905, 95, '1386', 'ads_calip_pool', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1906, 95, '1393', 'ads_calip_tele', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2106, 94, '243', 'rare_daffodil_rug', 1, 0, 150, 0, 0, 0, 0, 0, '1'),
(1908, 95, '1408', 'ads_calip_lava', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1909, 95, '1412', 'ads_mall_coffeem', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1910, 95, '1433', 'ads_mall_kiosk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1911, 95, '1440', 'ads_elisa_gnome', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1912, 95, '1442', 'ads_oc_soda', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1913, 95, '1450', 'ads_711*5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1914, 95, '1452', 'ads_711*7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1915, 95, '1473', 'ads_1800tele', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1916, 95, '1522', 'ads_sunnyd', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1917, 95, '1526', 'ads_dave_wall', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1918, 95, '1529', 'ads_nokia_logo', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1919, 95, '1530', 'ads_nokia_phone', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1920, 95, '1534', 'ads_campguitar', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1921, 95, '1542', 'ads_cmusic', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1922, 95, '1554', 'ads_clwall1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1923, 95, '1555', 'ads_clwall2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1924, 95, '1556', 'ads_clwall3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1925, 95, '1557', 'ads_ob_wall', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1926, 95, '1558', 'ads_mall_window', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1927, 42, '1019', 'a0 prizetrophy6_b', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(1928, 95, '1563', 'ads_igor_wall', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1929, 95, '1564', 'ads_igorevilb', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1930, 95, '1565', 'ads_idol_wall', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1931, 95, '1566', 'ads_mall_winfur', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1932, 95, '1567', 'ads_mall_winpet', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1933, 95, '1571', 'ads_idol_tv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1934, 95, '1573', 'ads_idol_mirror', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1935, 95, '1574', 'ads_mall_wincin', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1936, 95, '1575', 'ads_mall_winmus', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1937, 95, '1576', 'ads_mall_winbea', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1938, 95, '1578', 'ads_mall_winchi', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1939, 95, '1581', 'ads_mall_winice', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1940, 95, '1582', 'ads_mall_winspo', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1941, 95, '1583', 'ads_idol_logo', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1942, 95, '1586', 'ads_lin_wh_c', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1943, 95, '1587', 'ads_malaco_tv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1944, 95, '1588', 'ads_puffet_tv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1945, 95, '1589', 'ads_reebok_tv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1946, 95, '1597', 'ads_mirror', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1947, 95, '1601', 'ads_wwe_poster', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1948, 95, '1602', 'ads_mall_wintra', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1949, 95, '1604', 'ads_veet', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1950, 95, '1608', 'ads_mall_wingar', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1951, 95, '1610', 'ads_mall_winclo', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2011, 88, '1539', 'hw_08_xray', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1954, 95, '1706', 'ads_calip_parasol', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1956, 95, '1007', 'tampax_rug', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1957, 95, '1507', 'tampax_wall', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1958, 94, '1695', 'pillar*6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1959, 55, '1696', 'shelves_norja*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1960, 30, '1697', 'bed_polyfon*2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1961, 55, '1698', 'divider_nor5*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1962, 76, '1699', 'val_cauldron', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1963, 32, '1700', 'pura_mdl5*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1964, 94, '1701', 'one_way_door*1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1976, 128, '983', 'urban_fence_corner', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1966, 60, '1702', 'exe_globe', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2097, 95, '1707', 'year2010', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(1968, 45, '1704', 'fx_bubble', 0, 250, 1, 0, 0, 0, 0, 0, '1'),
(1969, 129, '1705', 'bump_tottero', 0, 50, 1, 0, 0, 0, 0, 0, '1'),
(1970, 129, '1323', 'bump_road', 0, 75, 1, 0, 0, 0, 0, 0, '1'),
(1971, 129, '1318', 'bump_lights', 0, 50, 1, 0, 0, 0, 0, 0, '1'),
(1972, 129, '1317', 'bump_tires', 0, 50, 1, 0, 0, 0, 0, 0, '1'),
(1973, 129, '1313', 'bump_signs', 0, 50, 1, 0, 0, 0, 0, 0, '1'),
(1974, 103, '1703', 'diner_bardesk_corner*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1977, 128, '1016', 'urban_lamp', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1978, 128, '1018', 'urban_wall', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(1979, 128, '1687', 'urban_wpost', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1980, 128, '1688', 'urban_sidewalk', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1981, 128, '1689', 'urban_bench', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1982, 128, '1690', 'urban_carsofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1983, 128, '1691', 'urban_blocker', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(1984, 128, '1692', 'urban_bin', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1985, 128, '1693', 'urban_fence', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(1986, 128, '1694', 'urban_bsktbll', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(1987, 125, '1617', 'avatar_effect9', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1988, 125, '1618', 'avatar_effect6', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1989, 125, '1619', 'avatar_effect16', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1990, 125, '1620', 'avatar_effect2', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1991, 125, '1621', 'avatar_effect14', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1992, 125, '1622', 'avatar_effect15', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1993, 125, '1623', 'avatar_effect3', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1994, 125, '1624', 'avatar_effect17', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1995, 125, '1625', 'avatar_effect18', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1996, 125, '1626', 'avatar_effect1', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1997, 125, '1627', 'avatar_effect4', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1998, 125, '1628', 'avatar_effect5', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(1999, 125, '1629', 'avatar_effect7', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2000, 125, '1630', 'avatar_effect8', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2001, 125, '1631', 'avatar_effect10', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2002, 125, '1632', 'avatar_effect12', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2003, 125, '1633', 'avatar_effect13', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2004, 129, '1657', 'avatar_effect22', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2005, 129, '1658', 'avatar_effect19', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2006, 129, '1659', 'avatar_effect20', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2007, 129, '1660', 'avatar_effect21', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(2016, 95, '1496', 'sw_stone', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2012, 95, '1532', 'netari_poster', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2013, 95, '1528', 'easy_poster', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2014, 95, '1499', 'md_logo_wall', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2015, 95, '1497', 'sw_hole', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2017, 95, '1495', 'sw_swords', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2018, 41, '1490', 'guitar_v', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2019, 41, '1489', 'guitar_skull', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2020, 43, '1488', 'habbowheel', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2021, 72, '1485', 'wallmirror', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2022, 85, '1454', 'pix_asteroid', 0, 2000, 1, 0, 0, 0, 0, 0, '1'),
(2023, 71, '1447', 'rela_stone', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2024, 94, '1443', 'marsrug', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2025, 85, '1413', 'totem_planet', 0, 2000, 1, 0, 0, 0, 0, 0, '1'),
(2026, 95, '1411', 'voting_ch', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2027, 73, '1407', 'transparent_floor', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2028, 95, '1404', 'clrack', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2029, 95, '1403', 'noticeboard', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2030, 95, '1398', 'audChr', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2031, 85, '1392', 'saturn', 0, 2000, 1, 0, 0, 0, 0, 0, '1'),
(2032, 95, '1387', 'laptopdesk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2033, 85, '1385', 'totem_head', 0, 2000, 1, 0, 0, 0, 0, 0, '1'),
(2034, 130, '1359', 'env_telep', 5, 0, 20, 0, 0, 0, 0, 0, '1'),
(2035, 95, '1350', 'tray_glasstower', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2036, 95, '1349', 'tray_champagne', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2037, 95, '1346', 'tray_cake', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2038, 130, '1343', 'env_tree4', 5, 0, 20, 0, 0, 0, 0, 0, '1'),
(2039, 130, '1341', 'env_tree2', 3, 0, 20, 0, 0, 0, 0, 0, '1'),
(2040, 130, '1340', 'env_tree1', 3, 0, 20, 0, 0, 0, 0, 0, '1'),
(2044, 130, '1336', 'env_bushes', 5, 0, 20, 0, 0, 0, 0, 0, '1'),
(2043, 130, '1337', 'env_bushes_gate', 5, 0, 20, 0, 0, 0, 0, 0, '1'),
(2045, 130, '1335', 'env_tree3', 3, 0, 20, 0, 0, 0, 0, 0, '1'),
(2046, 130, '1334', 'env_grass', 5, 0, 20, 0, 0, 0, 0, 0, '1'),
(2047, 130, '1334', 'env_grass', 15, 5000, 200, 0, 0, 0, 0, 0, '1'),
(2048, 85, '1328', 'totem_leg', 0, 2000, 1, 0, 0, 0, 0, 0, '1'),
(2110, 112, '1541', 'ads_twi_crest', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2050, 58, '1269', 'lostc_octopus', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2052, 85, '1251', 'planet_of_love', 0, 2000, 1, 0, 0, 0, 0, 0, '1'),
(2054, 28, '1188', 'penguin_basic', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2055, 28, '1190', 'penguin_musketeer', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2056, 28, '1193', 'penguin_wrestler', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2057, 28, '1195', 'penguin_robot', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2058, 28, '1199', 'penguin_suit', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2059, 28, '1202', 'penguin_icehockey', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2060, 28, '1203', 'penguin_pilot', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2061, 28, '1204', 'penguin_ballet', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2062, 28, '1206', 'penguin_boxer', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2063, 28, '1207', 'penguin_glow', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2064, 28, '1208', 'penguin_swim', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2065, 28, '1209', 'penguin_sumo', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2066, 28, '1211', 'penguin_clown', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2067, 28, '1212', 'penguin_infected', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2068, 28, '1216', 'penguin_super', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2069, 28, '1219', 'penguin_rock', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2070, 28, '1222', 'penguin_ski', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2071, 28, '1223', 'penguin_skater', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2072, 28, '1225', 'penguin_elf', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2073, 28, '1226', 'penguin_bunny', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2074, 28, '1227', 'penguin_ninja', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2075, 28, '1228', 'penguin_magician', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2076, 28, '1229', 'penguin_hunchback', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2077, 28, '1230', 'penguin_cowboy', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2078, 28, '1231', 'penguin_punk', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2079, 28, '1232', 'penguin_pirate', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2080, 45, '1213', 'fx_flare', 0, 250, 1, 0, 0, 0, 0, 0, '1'),
(2081, 95, '1200', 'svnr_fi', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2082, 45, '1194', 'fx_explosion', 0, 250, 1, 0, 0, 0, 0, 0, '1'),
(2084, 95, '1025', 'svnr_aus', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2085, 95, '1024', 'svnr_de', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2086, 95, '1023', 'svnr_it', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2087, 95, '1022', 'svnr_nl', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2088, 95, '1021', 'svnr_uk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2089, 36, '1014', 'table_plasto_square*9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2090, 76, '1015', 'heart', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2091, 95, '1126', 'easy_carpet', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2092, 95, '1127', 'easy_bowl2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2093, 95, '1142', 'netari_carpet', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2094, 40, '1148', 'sob_carpet', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2095, 95, '1149', 'igor_seat', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2098, 95, '1708', 'party_lantern', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2103, 56, '264', 'arabian_tile', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2105, 95, '1711', 'ads_mall_elevator', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2112, 112, '1714', 'ads_twi_paint', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2107, 95, '1712', 'xm09_infotv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2113, 112, '1715', 'ads_twi_windw', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2114, 112, '1716', 'ads_twi_bwall2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2115, 112, '1717', 'ads_twi_dreamc', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2116, 112, '1718', 'ads_twi_bwall1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2121, 56, '1719', 'arabian_wall', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2123, 73, '1723', 'sf_mbar', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2124, 27, '1722', 'xm09_cocoa', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2126, 160, '311', 'nest', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2127, 160, '312', 'petfood1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2128, 160, '313', 'petfood2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2129, 160, '314', 'petfood3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2130, 160, '315', 'waterbowl*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2131, 160, '316', 'waterbowl*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2132, 160, '320', 'toy1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2133, 160, '317', 'waterbowl*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2134, 160, '318', 'waterbowl*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2135, 160, '319', 'waterbowl*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2136, 160, '321', 'toy1*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2137, 160, '322', 'toy1*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2139, 160, '324', 'toy1*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2140, 160, '325', 'goodie1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2141, 160, '326', 'goodie1*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2142, 160, '327', 'goodie1*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2143, 160, '328', 'goodie2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2144, 160, '328', 'goodie2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2145, 134, '1299', 'ecotron_box', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2146, 134, '1300', 'eco_light2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2147, 134, '1301', 'eco_chair3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2148, 134, '1302', 'eco_table3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2149, 134, '1303', 'eco_lamp2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2150, 134, '1304', 'eco_sofa3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2151, 134, '1305', 'eco_table2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2152, 134, '1306', 'eco_fruits2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2153, 134, '1307', 'eco_sofa1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2154, 134, '1308', 'eco_fruits3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2155, 134, '1309', 'eco_light1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2156, 134, '1310', 'eco_tree1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2157, 134, '1311', 'eco_cactus2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2158, 134, '1314', 'eco_cactus1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2159, 134, '1315', 'eco_chair2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2160, 134, '1316', 'eco_cactus3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2161, 134, '1319', 'eco_lamp3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2164, 30, '625', 'divider_poly3*8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2163, 160, '812', 'petfood4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2165, 134, '161', 'present_gen', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2166, 134, '162', 'present_gen1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2167, 134, '163', 'present_gen2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2168, 134, '164', 'present_gen3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2169, 134, '165', 'present_gen4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2170, 134, '166', 'present_gen5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2171, 134, '167', 'present_gen6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2172, 134, '1271', 'lc_medusa2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2173, 134, '2090', 'song_disk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2174, 134, '1320', 'eco_table1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2175, 134, '1321', 'eco_chair1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2176, 134, '1322', 'eco_sofa2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2177, 134, '1324', 'eco_fruits1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2178, 134, '1325', 'eco_lamp1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2179, 134, '1326', 'eco_light3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2180, 134, '1327', 'eco_tree2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2181, 134, '1363', 'eco_mush1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2182, 134, '1368', 'eco_mush2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2183, 134, '1577', 'eco_curtains1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2184, 134, '1579', 'eco_curtains3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2185, 134, '1580', 'eco_curtains2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2195, 41, '1806', 'flag_dominicanrepublic', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2194, 41, '1805', 'flag_ecuador', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2193, 41, '1804', 'flag_chile', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2190, 41, '1801', 'flag_singapore', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2191, 41, '1803', 'flag_columbia', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2196, 41, '1807', 'flag_newzealand', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2197, 41, '1808', 'flag_malaysia', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2198, 41, '1810', 'flag_venezl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2199, 41, '1811', 'flag_algeria', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2200, 41, '1812', 'flag_tunisia', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2201, 41, '1813', 'flag_panama', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2202, 41, '1814', 'flag_mexico', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2203, 41, '1815', 'flag_argentina', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2204, 41, '1816', 'flag_philippines', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2205, 41, '1817', 'flag_greece', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2206, 41, '1818', 'flag_peru', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2207, 41, '1819', 'flag_morocco', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2208, 41, '1820', 'flag_turkey', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2209, 136, '1767', 'bling_fridge', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2210, 136, '1771', 'bling_chair_a', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2211, 136, '1773', 'bling_pool', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2212, 136, '1774', 'bling_toilet', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2213, 136, '1776', 'bling_chair_c', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2214, 136, '1777', 'bling_chair_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2215, 136, '1778', 'bling_shwr', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2216, 136, '1779', 'bling_bed', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2217, 136, '1780', 'bling_sofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2218, 136, '1794', 'bling_fridge_restricted', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2219, 136, '1849', 'bling_sink', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2220, 136, '1851', 'bling_cabinet', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2223, 137, '1753', 'org_chairpnk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2224, 137, '1754', 'org_tblpnk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2225, 137, '1755', 'org_lampblk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2226, 137, '1756', 'org_lamppnk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2227, 137, '1757', 'org_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2228, 137, '1761', 'org_chairblk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2229, 137, '1762', 'org_tblblk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2230, 137, '1763', 'org_chrblk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2231, 137, '1765', 'org_chrpnk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2232, 76, '1775', 'val09_floor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2233, 76, '1781', 'val09_floor2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2234, 76, '1847', 'val09_wdrobe_b', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2235, 76, '1848', 'val09_wall2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2236, 76, '1850', 'val09_wall1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2237, 76, '1852', 'val09_wdrobe_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2238, 76, '1784', 'val_hSeat*1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2239, 76, '1785', 'val_hSeat*2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2240, 76, '1786', 'val_hSeat*3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2241, 76, '1787', 'val_hSeat*4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2242, 76, '1788', 'val_hSeat*5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2243, 76, '1789', 'val_hSeat*6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2244, 76, '1790', 'val_hSeat*7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2245, 76, '1791', 'val_basket', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2246, 76, '1839', 'val_table1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2248, 27, '1743', 'xm09_lrgBauble', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2250, 42, '1759', 'xm09_trophy', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2251, 27, '1821', 'xm09_bauble_12', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2252, 27, '1822', 'xm09_bauble_16', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2253, 27, '1823', 'xm09_bauble_17', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2254, 27, '1824', 'xm09_bauble_15', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2255, 27, '1825', 'xm09_bauble_10', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2256, 27, '1826', 'xm09_bauble_9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2257, 27, '1827', 'xm09_bauble_18', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2258, 27, '1828', 'xm09_bauble_13', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2259, 27, '1829', 'xm09_bauble_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2260, 27, '1830', 'xm09_bauble_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2261, 27, '1831', 'xm09_bauble_22', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2262, 27, '1832', 'xm09_bauble_3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2263, 27, '1833', 'xm09_bauble_21', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2264, 27, '1834', 'xm09_bauble_8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2265, 27, '1835', 'xm09_bauble_4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2266, 27, '1836', 'xm09_bauble_5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2267, 27, '1837', 'xm09_bauble_11', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2268, 27, '1838', 'xm09_bauble_20', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2269, 27, '1840', 'xm09_bauble_14', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2270, 27, '1841', 'xm09_bauble_7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2271, 27, '1842', 'xm09_bauble_6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2272, 27, '1843', 'xm09_bauble_19', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2273, 76, '1782', 'teddy_basic', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2274, 76, '1783', 'teddy_pendergrass', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2275, 76, '1792', 'teddy_bear', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2276, 76, '1793', 'teddy_pink', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2277, 160, '1729', 'nest_plow_reg', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2278, 160, '1730', 'nest_snug_yel', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2279, 160, '1735', 'nest_snug_grn', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2280, 160, '1736', 'nest_snug_red', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2281, 160, '1737', 'nest_snug_grn', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2282, 160, '1738', 'nest_plow_bro', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2283, 160, '1739', 'nest_plow_red', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2284, 160, '1740', 'nest_snug_blu', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2285, 160, '1742', 'nest_plow_blu', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2286, 160, '1744', 'nest_dirt', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2287, 160, '1745', 'nest_snug_prp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2288, 160, '1746', 'nest_nest', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2289, 160, '1747', 'nest_nails', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2290, 160, '1748', 'nest_basket', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2291, 160, '1749', 'nest_ice', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2292, 160, '1750', 'nest_plow_skl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2293, 160, '1751', 'nest_snug_bla', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2294, 95, '441', 'ads_gsArcade_2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2295, 95, '624', 'ads_idol_l_carpet', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2296, 134, '1479', 'ads_cllava2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2297, 95, '1721', 'ads_gsArcade_1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2298, 95, '1724', 'ads_mtvtrophy_silver', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2299, 94, '1725', 'ads_spang_sleep', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2300, 95, '1726', 'ads_mtvtrophy_gold', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2301, 94, '1752', 'ads_cl_moodi', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2302, 95, '1766', 'ads_chups', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2303, 95, '1769', 'ads_droetker_paula', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2304, 95, '1795', 'ads_percyrock', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2305, 95, '1797', 'ads_idol_l_logo', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2306, 95, '1846', 'ads_percyw', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2307, 95, '1800', 'ads_mtv_tv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2308, 95, '1845', 'ads_tv_jaapuisto', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2310, 134, '1809', 'byesw_loadscreen', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2312, 95, '1799', 'ads_mtv_bigtv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2313, 95, '1798', 'ads_idol_l_tv', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2314, 27, '1445', 'tree2', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(2317, 30, '1478', 'divider_poly3*7', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2318, 37, '1727', 'ktchn_hlthNut', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2319, 160, '1728', 'petfood8', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2320, 160, '1731', 'petfood9', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2321, 160, '1732', 'petfood10', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2322, 160, '1733', 'petfood7', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2323, 160, '1734', 'petfood6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2324, 160, '1741', 'petfood5', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2325, 160, '1768', 'petfood12', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2326, 160, '1770', 'petfood11', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2327, 160, '1772', 'petfood13', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2329, 94, '1796', 'md_can', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2330, 66, '1802', 'hween09_curt', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2331, 57, '1758', 'china_tiger', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2332, 57, '1760', 'china_plmTree', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2333, 134, '1764', 'china_tigrSeat', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2334, 57, '1844', 'china_pstr3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2336, 62, '1853', 'rare_ironmaiden name', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2337, 95, '1854', 'rare_trex name', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2338, 143, '1855', 'beanstalk', 6, 0, 10, 0, 0, 0, 0, 0, '1'),
(2339, 95, '1856', 'rare_vdoll name', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2340, 95, '1857', 'rare_mmmth name', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2341, 136, '1858', 'crystal_patch', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2342, 95, '1859', 'ads_boost_surfb name', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2343, 95, '1860', 'ads_tlc_wheel name', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2346, 16, '243', 'rare_daffodil_rug', 100, 100, 4, 0, 0, 0, 0, 0, '1'),
(2348, 134, '177', 'doorC', 10, 0, 100, 0, 0, 0, 0, 0, '1'),
(2443, 146, '2429', 'a0 pet3', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(2350, 143, '1862', 'garden_lupin4', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2351, 143, '1863', 'garden_mursu3', 5, 0, 10, 0, 0, 0, 0, 0, '1'),
(2352, 143, '1864', 'garden_lupin5', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2353, 143, '1865', 'garden_seed', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(2354, 143, '1866', 'garden_flytrap', 6, 0, 10, 0, 0, 0, 0, 0, '1'),
(2355, 143, '1867', 'garden_flo3', 2, 0, 10, 0, 0, 0, 0, 0, '1'),
(2359, 143, '1870', 'garden_mursu2', 5, 0, 10, 0, 0, 0, 0, 0, '1'),
(2357, 143, '1868', 'garden_volcano', 5, 0, 10, 0, 0, 0, 0, 0, '1'),
(2358, 143, '1869', 'garden_flolamp', 8, 0, 10, 0, 0, 0, 0, 0, '1'),
(2360, 143, '1871', 'garden_jyrki', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2361, 143, '1872', 'garden_mursu4', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2362, 143, '1873', 'garden_leaves', 3, 0, 10, 0, 0, 0, 0, 0, '1'),
(2363, 143, '1874', 'garden_lupin2', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2364, 143, '1875', 'garden_lupin3', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2365, 143, '1876', 'garden_mursu', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2366, 143, '1877', 'garden_orchtree', 6, 0, 10, 0, 0, 0, 0, 0, '1'),
(2367, 143, '1878', 'garden_flo2', 2, 0, 10, 0, 0, 0, 0, 0, '1'),
(2368, 143, '1879', 'garden_lupin1', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2369, 143, '1880', 'garden_staringbush', 5, 0, 10, 0, 0, 0, 0, 0, '1'),
(2370, 143, '1882', 'garden_flo1', 2, 0, 10, 0, 0, 0, 0, 0, '1'),
(2371, 143, '1883', 'garden_jungle', 5, 0, 10, 0, 0, 0, 0, 0, '1'),
(2372, 143, '1925', 'garden_wall', 4, 0, 10, 0, 0, 0, 0, 0, '1'),
(2374, 144, '1887', 'runway_display', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2375, 144, '1888', 'runway_bigchr_5', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2376, 144, '1889', 'runway_bigchr_4', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2377, 144, '1892', 'runway_stool', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2378, 144, '1893', 'runway_dvdr', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2379, 144, '1894', 'runway_block_2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2380, 144, '1895', 'runway_bigchr_1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2381, 144, '1899', 'runway_block_1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2382, 144, '1900', 'runway_bench', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2383, 144, '1901', 'runway_chair_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2384, 144, '1904', 'runway_bigchr_3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2385, 144, '1907', 'runway_bigchr_2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2386, 144, '1909', 'runway_table_2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2387, 144, '1910', 'runway_table_1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2388, 144, '1911', 'runway_manqn_1', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2389, 144, '1915', 'runway_head', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2390, 144, '1916', 'runway_manqn_2', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2391, 144, '1924', 'runway_chair_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2392, 144, '1928', 'runway_shelf', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2393, 144, '1931', 'runway_fabric', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2394, 8, '1885', 'hc2_frplc', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2395, 8, '1886', 'hc2_barchair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2396, 8, '1890', 'hc3_dc', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2397, 8, '1891', 'hc2_sofatbl', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2398, 8, '1896', 'hc2_biglamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2399, 8, '1897', 'hc2_sofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2400, 8, '1898', 'hc2_carpet', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2401, 8, '1903', 'hc3_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2402, 8, '1905', 'hc3_stool', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2403, 8, '1906', 'hc3_sofa', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2404, 8, '1908', 'hc2_armchair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2405, 8, '1912', 'hc2_dvn', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2406, 8, '1913', 'hc3_light', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2407, 8, '1914', 'hc3_shelf', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2408, 8, '1917', 'hc2_divider', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2409, 8, '1918', 'hc2_coffee', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2410, 8, '1919', 'hc2_cart', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2411, 8, '1920', 'hc3_bard', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2412, 8, '1921', 'hc3_hugelamp', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2413, 8, '1922', 'hc3_divider', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2414, 8, '1923', 'hc2_vase', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2415, 8, '1927', 'hc3_walldeco', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2416, 134, '1933', 'camera', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2417, 134, '264', 'arabian_tile', 10, 0, 100, 0, 0, 0, 0, 0, '1'),
(2418, 95, '1881', 'ads_grefusa_yum', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2419, 95, '1884', 'merger_chesT', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2420, 95, '1902', 'ads_cheetos name', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2421, 95, '1926', 'ads_tv_yle name', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2422, 95, '1929', 'ads_nokia_x6', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2423, 95, '1930', 'ads_target_wall', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2424, 95, '1932', 'ads_latrobe_flag', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2425, 27, '1934', 'holly', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(2442, 141, '1861', 'a0 pet5', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(4964, 161, '2095', 'bw_water_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(4965, 161, '2094', 'bw_tele', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(4969, 161, '2095', 'bw_water_1', 60, 0, 100, 0, 0, 0, 0, 0, '1'),
(29910, 161, '2105', 'bw_water_2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(57009, 161, '2099', 'bw_chair', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(57010, 161, '2098', 'bw_sboard', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(57011, 161, '2104', 'bw_fnc', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(57012, 161, '2096', 'bw_lgchair', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(57013, 161, '2103', 'bw_croc', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(57014, 161, '2102', 'bw_bball', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(57015, 161, '2101', 'bw_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(57016, 159, '2111', 'prison_crnr', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(57017, 159, '2108', 'prison_dvdr1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(57018, 159, '2107', 'prison_gate', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(57019, 159, '2106', 'prison_dvdr2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(57020, 159, '2109', 'prison_stone', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(57021, 159, '2110', 'prison_tower', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(57022, 159, '2108', 'prison_dvdr1', 20, 0, 10, 0, 0, 0, 0, 0, '1'),
(57023, 159, '2106', 'prison_dvdr2', 20, 0, 10, 0, 0, 0, 0, 0, '1'),
(2483, 171, '2124', 'fball_score_y', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2482, 171, '2123', 'fball_score_r', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2481, 171, '2122', 'fball_score_g', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2480, 171, '2121', 'fball_score_b', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2479, 171, '2120', 'fball_ptch8', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2478, 171, '2119', 'fball_ptch7', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2477, 171, '2118', 'fball_ptch6', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2476, 171, '2117', 'fball_ptch5', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2475, 171, '2116', 'fball_ptch4', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2474, 171, '2115', 'fball_ptch3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2473, 171, '2114', 'fball_ptch2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2472, 171, '2113', 'fball_ptch1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2471, 171, '2112', 'fball_ptch0', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2470, 171, '2125', 'fball_counter', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2469, 171, '2126', 'fball_gate', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2468, 171, '2127', 'fball_light', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2467, 171, '2128', 'fball_goal_y', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2466, 171, '2129', 'fball_goal_r', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2465, 171, '2130', 'fball_goal_g', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2464, 171, '2131', 'fball_goal_b', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2463, 171, '2132', 'fball_fnc3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2462, 171, '2133', 'fball_fnc1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2461, 171, '2134', 'fball_crnr', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2460, 171, '2135', 'fball_cote', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2459, 171, '2136', 'fball_bench', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(2458, 171, '2137', 'fball_ball5', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(2457, 171, '2138', 'fball_ball4', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(2456, 171, '2139', 'fball_ball2', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(2455, 171, '2140', 'fball_ball', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(2454, 171, '2141', 'fball_audbench', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(2453, 171, '2142', 'fball_trophy', 35, 0, 1, 0, 0, 0, 0, 0, '1'),
(10289, 497, '2144', 'easel_0', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(10290, 497, '2145', 'easel_1', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(10291, 496, '2146', 'easel_2', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(10292, 497, '2147', 'easel_3', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(10293, 497, '2148', 'easel_4', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(10294, 497, '2149', 'easel_2', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(2713, 174, '2150', 'party_crate2_1', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2714, 174, '2151', 'party_crate1_3', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(2715, 174, '2152', 'party_crate1_4', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2716, 174, '2153', 'party_crate1_1', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(2717, 174, '2154', 'party_crate1_2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2718, 174, '2155', 'party_crate2_2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2719, 174, '2156', 'party_crate2_3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2720, 174, '2157', 'party_crate2_4', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(2721, 174, '2158', 'party_djset', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(41082, 165, '2160', 'bw_lgchair', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(41083, 165, '2162', 'bw_fin', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(41084, 165, '2163', 'bw_ccnuts', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(41085, 165, '2164', 'bw_shower', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(41086, 165, '2165', 'bw_water_2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(41087, 165, '2166', 'bw_croc', 7, 0, 1, 0, 0, 0, 0, 0, '1'),
(41088, 165, '2167', 'bw_sboard', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(41089, 165, '2169', 'bw_table', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(41090, 165, '2170', 'bw_ball', 11, 0, 1, 0, 0, 0, 0, 0, '1'),
(41091, 165, '2171', 'bw_mttrss', 6, 0, 1, 0, 0, 0, 0, 0, '1'),
(41092, 165, '2172', 'bw_van', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(41094, 165, '2173', 'bw_fnc_crnr', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(41095, 165, '2174', 'bw_fnc', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(41097, 165, '2161', 'bw_sofa', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(41098, 165, '2159', 'bw_boat', 12, 0, 1, 0, 0, 0, 0, 0, '1'),
(41099, 165, '2168', 'bw_chair', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(77025, 165, '2176', 'bw_jaws', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97308, 165, '2184', 'bw_pool_a3', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97309, 165, '2183', 'bw_pool_a2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97310, 165, '2182', 'bw_pool_b2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97311, 165, '2181', 'bw_mttrss_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97312, 165, '2180', 'bw_boat_p', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97313, 165, '2179', 'bw_sofa_p', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97314, 165, '2178', 'bw_fnc_crnr_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97315, 165, '2177', 'bw_fnc_crnr_p', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97318, 165, '2198', 'bw_fnc_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(600000, 165, '2165', 'bw_water_2', 10, 0, 50, 0, 0, 0, 0, 0, '1'),
(97319, 165, '2197', 'bw_sofa_p', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97320, 165, '2196', 'bw_sofa_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97321, 165, '2195', 'bw_van_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97322, 165, '2194', 'bw_van_p', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97323, 165, '2193', 'bw_table_p', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97324, 165, '2192', 'bw_table_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97326, 165, '2190', 'bw_surfb_g', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97327, 165, '2189', 'bw_fnc_crnr_p', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97328, 165, '2188', 'bw_pool_b1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97329, 165, '2185', 'bw_pool_a1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97317, 165, '2187', 'ads_grefusa_surfb', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(97316, 165, '2186', 'ads_pepsi0', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(10355, 502, '2200', 'african_tree2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(10354, 502, '2201', 'african_tree1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(10353, 502, '2202', 'african_stage', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(10352, 502, '2203', 'african_patch', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(10351, 502, '2204', 'african_fence', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(10350, 502, '2205', 'african_bones', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(10357, 503, '2206', 'ktchn10_cabnt', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(10358, 503, '2207', 'ktchn10_pot', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(10359, 503, '2208', 'ktchn10_sink', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(10360, 503, '2209', 'ktchn10_stove', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(10278, 496, '2210', 'hosptl_bbag name', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(10279, 496, '2211', 'hosptl_bed', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(10280, 496, '2212', 'hosptl_cab1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(10281, 496, '2213', 'hosptl_cab2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(10282, 496, '2214', 'hosptl_curtain', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(10283, 496, '2215', 'hosptl_defibs', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(10284, 496, '2216', 'hosptl_light', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(10285, 496, '2217', 'hosptl_seat', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(10286, 496, '2218', 'hosptl_skele', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(10287, 496, '2219', 'hosptl_xray', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(900000, 105, '410', 'rare_dragonlamp*3', 10000, 2500, 1, 0, 0, 0, 500, 36, '1'),
(89945, 200, '2220', 'cubie_rug_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89946, 200, '2221', 'cubie_lamp_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89947, 200, '2222', 'cubie_shelf_3_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89948, 200, '2223', 'cubie_shelf_4_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89949, 200, '2224', 'cubie_shelf_1_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89950, 200, '2225', 'cubie_shelf_1_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89951, 200, '2226', 'cubie_chair_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89952, 200, '2227', 'cubie_shelf_4_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89953, 200, '2228', 'cubie_bigtable_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89954, 200, '2229', 'cubie_shelf_0_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89955, 200, '2230', 'cubie_beanbag_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89956, 200, '2231', 'cubie_chair_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89957, 200, '2232', 'cubie_bed_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89958, 200, '2233', 'cubie_bigtable_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89959, 200, '2234', 'cubie_stool_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89960, 200, '2235', 'cubie_beanbag_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89961, 200, '2236', 'cubie_shelf_0_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89962, 200, '2237', 'cubie_shelf_2_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89963, 200, '2238', 'cubie_rug_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89964, 200, '2239', 'cubie_sofaseat_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89965, 200, '2240', 'cubie_table', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89966, 200, '2241', 'cubie_sofaseat_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89967, 200, '2242', 'cubie_bed_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89968, 200, '2243', 'cubie_shelf_3_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89969, 200, '2244', 'cubie_shelf_2_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89970, 200, '2245', 'cubie_lamp_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89971, 200, '2246', 'cubie_stool_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89972, 200, '2247', 'cubie_wallshelf_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89973, 200, '2248', 'cubie_decklight_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89974, 200, '2249', 'cubie_wallshelf_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89975, 200, '2250', 'cubie_decal_0', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89976, 200, '2251', 'cubie_decal_3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89977, 200, '2252', 'cubie_decal_1_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89978, 200, '2253', 'cubie_decklight_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89979, 200, '2254', 'cubie_decal_1_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89980, 200, '2255', 'cubie_decal_2_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89981, 200, '2256', 'cubie_decal_3_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89982, 200, '2257', 'cubie_decal_2_p', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89983, 200, '2258', 'cubie_decal_3_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89984, 175, '2259', 'newbie_present', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89985, 175, '2260', 'tv_flat', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89986, 175, '2261', 'waasa_table2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89987, 175, '2262', 'computer_flatscreen', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89988, 175, '2263', 'waasa_chair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89989, 175, '2264', 'waasa_ship2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89990, 175, '2265', 'waasa_ship1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89991, 175, '2266', 'waasa_bunk_bed', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89992, 175, '2267', 'computer_laptop', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89993, 175, '2268', 'computer_old', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89994, 175, '2269', 'waasa_table1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89995, 175, '2270', 'waasa_desk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89996, 175, '2271', 'waasa_wall_shelf2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89997, 175, '2272', 'waasa_wall_shelf1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89914, 169, '2273', 'nest_frog', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89915, 169, '2274', 'pond', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89916, 169, '2275', 'val11_present', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89917, 169, '2276', 'prizetrophy_cine', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89918, 169, '2277', 'cine_vipsign', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89919, 169, '2278', 'limo_b_mid3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89920, 169, '2279', 'limo_b_mid2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89921, 169, '2280', 'limo_b_front', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89922, 169, '2281', 'limo_b_mid', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89923, 169, '2282', 'cine_star', 3, 0, 1, 0, 0, 0, 0, 0, '1');
INSERT INTO `catalog_items_copy` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`, `song_id`, `limited_stack`, `limited_sells`, `offer_active`) VALUES
(89924, 169, '2283', 'limo_b_back', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89925, 169, '2284', 'ads_bigtv_missmix', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89926, 169, '2285', 'cine_curtain', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89927, 169, '2286', 'cine_screen', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89928, 169, '2287', 'theatre_seat_g', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89929, 169, '2288', 'cine_tile', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89930, 169, '2289', 'cine_bench_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89931, 169, '2290', 'theatre_seat_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89932, 169, '2291', 'cine_roof', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89933, 169, '2292', 'cine_popcorn', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89934, 169, '2293', 'cine_bench', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89935, 169, '2294', 'cine_bench_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89936, 169, '2295', 'cine_ticket_booth', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89937, 169, '2296', 'cine_projector', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89907, 201, '2297', 'gothic_st_glass', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89908, 201, '2298', 'gothic_candles', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89909, 201, '2299', 'gothic_bed', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89910, 201, '2300', 'gothic_desk', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89911, 201, '2301', 'gothic_bowl', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89912, 201, '2302', 'ads_grefu_trophy', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77701, 777, '2303', 'bling11_block', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77702, 777, '2304', 'bling11_dvd', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77703, 777, '2305', 'bling11_dvn', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77704, 777, '2306', 'bling11_floor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77705, 777, '2307', 'bling11_pillar', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77706, 777, '2308', 'bling11_plant', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77707, 777, '2309', 'bling11_rug1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77708, 777, '2310', 'bling11_rug2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77709, 777, '2311', 'bling11_seat1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77710, 777, '2312', 'bling11_seat2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77711, 777, '2313', 'bling11_slot', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77712, 777, '2314', 'bling11_sofa', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77713, 777, '2315', 'bling11_statue1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77714, 777, '2316', 'bling11_statue2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77715, 777, '2317', 'bling11_tele', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77716, 777, '2318', 'bling11_towels', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77717, 777, '2319', 'bling11_val11_floor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(77801, 778, '2320', 'china_rabbit', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(89900, 899, '2321', 'limo_w_front', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89901, 899, '2322', 'limo_w_mid', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89902, 899, '2323', 'limo_w_mid2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89903, 899, '2324', 'limo_w_back', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89904, 160, '2325', 'petfood19', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89905, 160, '2326', 'petfood18', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89906, 160, '2327', 'petfood17', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3000, 300, '2328', 'hween10_bat', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3001, 300, '2329', 'hween10_card_1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3002, 300, '2330', 'hween10_card_2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3003, 300, '2331', 'hween10_card_3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3004, 300, '2332', 'hween10_card_4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3005, 300, '2333', 'hween10_card_5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3006, 300, '2334', 'hween10_card_6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3007, 300, '2335', 'hween10_chicken', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3008, 300, '2336', 'hween10_ffly', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3009, 300, '2337', 'hween10_fog', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3010, 300, '2338', 'hween10_jar', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3011, 300, '2339', 'hween10_logs', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3012, 300, '2340', 'hween10_pond', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3013, 300, '2341', 'hween10_portch', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3014, 300, '2342', 'hween10_skullpost', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3015, 300, '2343', 'hween10_swamp', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3016, 300, '2344', 'hween10_tarot', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3017, 300, '2345', 'hween10_tele', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3018, 300, '2346', 'hween10_throne', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3019, 300, '2347', 'hween10_tree', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3020, 300, '2348', 'hween10_voodoo1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3021, 300, '2349', 'hween10_voodoo2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3022, 300, '2350', 'hween10_voodoo3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3023, 300, '2351', 'hween10_wallskull', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(99904, 600, '2352', 'year2011_waver_b', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99905, 600, '2353', 'year2011_waver_g', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99906, 600, '2354', 'year2011_waver_r', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99907, 600, '2355', 'year2011_waver_y', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99908, 600, '2356', 'prizetrophy_2011_y', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99909, 600, '2357', 'prizetrophy_2011_b', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99910, 600, '2358', 'prizetrophy_2011_r', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99911, 600, '2359', 'prizetrophy_2011_p', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99912, 600, '2360', 'prizetrophy_2011_g', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99913, 600, '2361', 'prizetrophy_2011_w', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99914, 600, '2362', 'year2011', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(99000, 500, '2363', 'qt_xm10_nest', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99001, 500, '2364', 'qt_xm10_icedragon', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99002, 500, '2365', 'qt_xm10_stone', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99003, 500, '2366', 'qt_xm10_icetiger', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99004, 500, '2367', 'qt_xm10_trex', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99005, 500, '2368', 'qt_xm10_palm_tree', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99006, 500, '2369', 'qt_xm10_bench', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99007, 500, '2370', 'qt_xm10_icelupin', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99008, 500, '2371', 'qt_xm10_xmduck', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99009, 500, '2372', 'qt_xm10_iceduck', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99010, 500, '2373', 'qt_xm10_bauble1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99011, 500, '2374', 'qt_xm10_bauble2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99012, 500, '2375', 'qt_xm10_bauble3', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99013, 500, '2376', 'qt_xm10_iceplasto', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99014, 500, '2377', 'qt_xm10_ice_fish', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99015, 500, '2378', 'qt_xm10_gnome', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99016, 500, '2379', 'qt_xm10_icesilotable', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99017, 500, '2380', 'qt_xm10_iceteddy', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99018, 500, '2381', 'qt_xm10_elephant', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99019, 500, '2382', 'qt_xm10_iceclubsofa', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99020, 500, '2383', 'es_skating_ice', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99021, 500, '2384', 'es_sidewalk', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99022, 500, '2385', 'es_wpost', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99023, 500, '2386', 'es_tagging', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99024, 500, '2387', 'es_santa', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99025, 500, '2388', 'es_window', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99026, 500, '2389', 'es_bench', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99027, 500, '2390', 'es_fnc_1', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99028, 500, '2391', 'es_fnc_2', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99029, 500, '2392', 'es_fnc_crnr', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99030, 500, '2393', 'es_epictree', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99031, 500, '2394', 'es_icestar_g', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99032, 500, '2395', 'es_icestar_r', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99033, 500, '2396', 'es_icestar_y', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99034, 500, '2397', 'es_icestar', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99035, 500, '2398', 'es_puck', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99036, 500, '2399', 'es_roaster', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99037, 500, '2400', 'es_lmppst', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99038, 500, '2401', 'es_statue', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568424, 60, '2406', 'exe_sensor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568425, 60, '2405', 'exe_seccam', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568426, 60, '2404', 'exe_wrkdesk', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568427, 60, '2403', 'exe_glassdvdr', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568428, 60, '2402', 'exe_copier', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(99060, 501, '2409', 'es_box', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(99061, 501, '2410', 'es_counter', 15, 0, 1, 0, 0, 0, 0, 0, '1'),
(99062, 501, '2411', 'es_exit', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(99063, 501, '2412', 'es_gate_b', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(99064, 501, '2413', 'es_gate_g', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(99065, 501, '2414', 'es_gate_r', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(99066, 501, '2415', 'es_gate_y', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(99067, 501, '2418', 'es_score_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(99068, 501, '2419', 'es_score_g', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(99069, 501, '2417', 'es_score_r', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(99070, 501, '2416', 'es_score_y', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(99071, 501, '2410', 'es_tile', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(89938, 173, '2421', 'wf_box', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89939, 173, '2422', 'wf_maze', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89940, 173, '2423', 'ads_rangocactus', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89941, 173, '2424', 'cine_glass', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89942, 173, '2425', 'wf_cnd_has_furni_on', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89943, 173, '2426', 'cine_light2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(89944, 173, '2427', 'cine_light1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2444, 147, '2428', 'a0 pet4', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(2445, 148, '2431', 'a0 pet1', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(2446, 149, '2432', 'a0 pet0', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(2447, 150, '2430', 'a0 pet2', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(2530, 157, '2433', 'a0 pet6', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(2531, 158, '2434', 'a0 pet7', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(3568432, 170, '2435', 'a0 pet8', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(3568433, 176, '2436', 'a0 pet11', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(3568442, 182, '2437', 'a0 pet10', 20000, 7500, 1, 0, 0, 0, 0, 0, '1'),
(900001, 105, '1856', 'rare_vdoll', 8500, 4500, 1, 0, 0, 0, 20, 20, '1'),
(3568954, 15, '1637', 'landscape_single_4.4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568931, 15, '1634', 'floor_single_606', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568930, 15, '1634', 'floor_single_605', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568929, 15, '1634', 'floor_single_604', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568928, 15, '1634', 'floor_single_603', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568927, 15, '1634', 'floor_single_602', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568926, 15, '1634', 'floor_single_601', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568925, 15, '1634', 'floor_single_507', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568924, 15, '1634', 'floor_single_506', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568923, 15, '1634', 'floor_single_505', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568922, 15, '1634', 'floor_single_504', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568921, 15, '1634', 'floor_single_503', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568920, 15, '1634', 'floor_single_502', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568919, 15, '1634', 'floor_single_501', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568918, 15, '1634', 'floor_single_410', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568917, 15, '1634', 'floor_single_409', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568916, 15, '1634', 'floor_single_408', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568915, 15, '1634', 'floor_single_407', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568914, 15, '1634', 'floor_single_406', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568913, 15, '1634', 'floor_single_405', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568912, 15, '1634', 'floor_single_404', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568911, 15, '1634', 'floor_single_403', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568910, 15, '1634', 'floor_single_402', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568909, 15, '1634', 'floor_single_401', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568908, 15, '1634', 'floor_single_307', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568907, 15, '1634', 'floor_single_306', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568906, 15, '1634', 'floor_single_305', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568905, 15, '1634', 'floor_single_304', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568904, 15, '1634', 'floor_single_303', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568903, 15, '1634', 'floor_single_302', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568902, 15, '1634', 'floor_single_301', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568901, 15, '1634', 'floor_single_212', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568900, 15, '1634', 'floor_single_211', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568899, 15, '1634', 'floor_single_210', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568898, 15, '1634', 'floor_single_209', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568897, 15, '1634', 'floor_single_208', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568896, 15, '1634', 'floor_single_207', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568895, 15, '1634', 'floor_single_206', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568894, 15, '1634', 'floor_single_205', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568893, 15, '1634', 'floor_single_204', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568892, 15, '1634', 'floor_single_203', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568891, 15, '1634', 'floor_single_202', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568890, 15, '1634', 'floor_single_201', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568889, 15, '1634', 'floor_single_111', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568888, 15, '1634', 'floor_single_110', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568887, 15, '1634', 'floor_single_109', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568886, 15, '1634', 'floor_single_108', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568885, 15, '1634', 'floor_single_107', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568884, 15, '1634', 'floor_single_106', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568883, 15, '1634', 'floor_single_105', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568882, 15, '1634', 'floor_single_104', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568881, 15, '1634', 'floor_single_103', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568880, 15, '1634', 'floor_single_102', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568879, 15, '1634', 'floor_single_101', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568878, 15, '1636', 'wallpaper_single_3106', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568877, 15, '1636', 'wallpaper_single_3105', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568876, 15, '1636', 'wallpaper_single_3104', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568875, 15, '1636', 'wallpaper_single_3103', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568874, 15, '1636', 'wallpaper_single_3101', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568873, 15, '1636', 'wallpaper_single_3101', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568872, 15, '1636', 'wallpaper_single_3004', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568871, 15, '1636', 'wallpaper_single_3003', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568870, 15, '1636', 'wallpaper_single_3002', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568869, 15, '1636', 'wallpaper_single_3001', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568868, 15, '1636', 'wallpaper_single_2904', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568867, 15, '1636', 'wallpaper_single_2903', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568866, 15, '1636', 'wallpaper_single_2902', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568865, 15, '1636', 'wallpaper_single_2901', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568864, 15, '1636', 'wallpaper_single_2804', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568863, 15, '1636', 'wallpaper_single_2803', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568862, 15, '1636', 'wallpaper_single_2802', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568861, 15, '1636', 'wallpaper_single_2801', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568860, 15, '1636', 'wallpaper_single_2704', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568859, 15, '1636', 'wallpaper_single_2703', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568858, 15, '1636', 'wallpaper_single_2702', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568857, 15, '1636', 'wallpaper_single_2701', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568856, 15, '1636', 'wallpaper_single_2604', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568855, 15, '1636', 'wallpaper_single_2603', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568854, 15, '1636', 'wallpaper_single_2602', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568853, 15, '1636', 'wallpaper_single_2601', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568852, 15, '1636', 'wallpaper_single_2504', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568851, 15, '1636', 'wallpaper_single_2503', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568850, 15, '1636', 'wallpaper_single_2502', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568849, 15, '1636', 'wallpaper_single_2501', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568848, 15, '1636', 'wallpaper_single_2403', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568847, 15, '1636', 'wallpaper_single_2402', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568846, 15, '1636', 'wallpaper_single_2401', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568845, 15, '1636', 'wallpaper_single_2304', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568844, 15, '1636', 'wallpaper_single_2303', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568843, 15, '1636', 'wallpaper_single_2302', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568842, 15, '1636', 'wallpaper_single_2301', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568841, 15, '1636', 'wallpaper_single_2206', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568840, 15, '1636', 'wallpaper_single_2205', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568839, 15, '1636', 'wallpaper_single_2204', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568838, 15, '1636', 'wallpaper_single_2203', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568837, 15, '1636', 'wallpaper_single_2202', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568836, 15, '1636', 'wallpaper_single_2201', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568835, 15, '1636', 'wallpaper_single_2103', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568834, 15, '1636', 'wallpaper_single_2102', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568833, 15, '1636', 'wallpaper_single_2101', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568832, 15, '1636', 'wallpaper_single_2003', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568831, 15, '1636', 'wallpaper_single_2002', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568830, 15, '1636', 'wallpaper_single_2001', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568829, 15, '1636', 'wallpaper_single_1902', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568828, 15, '1636', 'wallpaper_single_1901', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568827, 15, '1636', 'wallpaper_single_1801', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568826, 15, '1636', 'wallpaper_single_1701', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568825, 15, '1636', 'wallpaper_single_1601', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568824, 15, '1636', 'wallpaper_single_1501', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568823, 15, '1636', 'wallpaper_single_1401', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568822, 15, '1636', 'wallpaper_single_1301', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568821, 15, '1636', 'wallpaper_single_1201', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568820, 15, '1636', 'wallpaper_single_1101', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568819, 15, '1636', 'wallpaper_single_1007', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568818, 15, '1636', 'wallpaper_single_1006', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568817, 15, '1636', 'wallpaper_single_1005', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568816, 15, '1636', 'wallpaper_single_1004', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568815, 15, '1636', 'wallpaper_single_1003', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568814, 15, '1636', 'wallpaper_single_1002', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568813, 15, '1636', 'wallpaper_single_1001', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568812, 15, '1636', 'wallpaper_single_908', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568811, 15, '1636', 'wallpaper_single_907', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568810, 15, '1636', 'wallpaper_single_906', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568809, 15, '1636', 'wallpaper_single_905', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568808, 15, '1636', 'wallpaper_single_904', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568807, 15, '1636', 'wallpaper_single_903', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568806, 15, '1636', 'wallpaper_single_902', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568805, 15, '1636', 'wallpaper_single_901', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568804, 15, '1636', 'wallpaper_single_810', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568803, 15, '1636', 'wallpaper_single_809', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568802, 15, '1636', 'wallpaper_single_808', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568801, 15, '1636', 'wallpaper_single_807', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568800, 15, '1636', 'wallpaper_single_806', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568799, 15, '1636', 'wallpaper_single_805', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568798, 15, '1636', 'wallpaper_single_804', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568797, 15, '1636', 'wallpaper_single_803', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568796, 15, '1636', 'wallpaper_single_802', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568795, 15, '1636', 'wallpaper_single_801', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568794, 15, '1636', 'wallpaper_single_710', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568793, 15, '1636', 'wallpaper_single_709', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568792, 15, '1636', 'wallpaper_single_708', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568791, 15, '1636', 'wallpaper_single_707', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568790, 15, '1636', 'wallpaper_single_706', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568789, 15, '1636', 'wallpaper_single_705', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568788, 15, '1636', 'wallpaper_single_704', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568787, 15, '1636', 'wallpaper_single_703', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568786, 15, '1636', 'wallpaper_single_702', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568785, 15, '1636', 'wallpaper_single_701', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568784, 15, '1636', 'wallpaper_single_610', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568783, 15, '1636', 'wallpaper_single_609', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568782, 15, '1636', 'wallpaper_single_608', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568781, 15, '1636', 'wallpaper_single_607', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568780, 15, '1636', 'wallpaper_single_606', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568779, 15, '1636', 'wallpaper_single_605', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568778, 15, '1636', 'wallpaper_single_604', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568777, 15, '1636', 'wallpaper_single_603', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568776, 15, '1636', 'wallpaper_single_602', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568775, 15, '1636', 'wallpaper_single_601', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568774, 15, '1636', 'wallpaper_single_508', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568773, 15, '1636', 'wallpaper_single_507', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568772, 15, '1636', 'wallpaper_single_506', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568771, 15, '1636', 'wallpaper_single_505', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568770, 15, '1636', 'wallpaper_single_504', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568769, 15, '1636', 'wallpaper_single_503', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568768, 15, '1636', 'wallpaper_single_502', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568767, 15, '1636', 'wallpaper_single_501', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568766, 15, '1636', 'wallpaper_single_408', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568765, 15, '1636', 'wallpaper_single_407', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568764, 15, '1636', 'wallpaper_single_406', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568763, 15, '1636', 'wallpaper_single_405', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568762, 15, '1636', 'wallpaper_single_404', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568761, 15, '1636', 'wallpaper_single_403', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568760, 15, '1636', 'wallpaper_single_402', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568759, 15, '1636', 'wallpaper_single_401', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568758, 15, '1636', 'wallpaper_single_307', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568757, 15, '1636', 'wallpaper_single_306', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568756, 15, '1636', 'wallpaper_single_305', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568755, 15, '1636', 'wallpaper_single_304', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568754, 15, '1636', 'wallpaper_single_303', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568753, 15, '1636', 'wallpaper_single_302', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568752, 15, '1636', 'wallpaper_single_301', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568751, 15, '1636', 'wallpaper_single_218', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568750, 15, '1636', 'wallpaper_single_217', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568749, 15, '1636', 'wallpaper_single_216', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568748, 15, '1636', 'wallpaper_single_215', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568747, 15, '1636', 'wallpaper_single_214', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568746, 15, '1636', 'wallpaper_single_213', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568745, 15, '1636', 'wallpaper_single_212', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568744, 15, '1636', 'wallpaper_single_211', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568743, 15, '1636', 'wallpaper_single_210', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568742, 15, '1636', 'wallpaper_single_209', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568741, 15, '1636', 'wallpaper_single_208', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568740, 15, '1636', 'wallpaper_single_207', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568739, 15, '1636', 'wallpaper_single_206', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568738, 15, '1636', 'wallpaper_single_205', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568737, 15, '1636', 'wallpaper_single_204', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568736, 15, '1636', 'wallpaper_single_203', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568735, 15, '1636', 'wallpaper_single_202', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568734, 15, '1636', 'wallpaper_single_201', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568733, 15, '1636', 'wallpaper_single_115', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568732, 15, '1636', 'wallpaper_single_114', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568731, 15, '1636', 'wallpaper_single_113', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568730, 15, '1636', 'wallpaper_single_112', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568729, 15, '1636', 'wallpaper_single_111', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568728, 15, '1636', 'wallpaper_single_110', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568727, 15, '1636', 'wallpaper_single_109', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568726, 15, '1636', 'wallpaper_single_108', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568725, 15, '1636', 'wallpaper_single_107', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568724, 15, '1636', 'wallpaper_single_106', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568723, 15, '1636', 'wallpaper_single_105', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568722, 15, '1636', 'wallpaper_single_104', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568721, 15, '1636', 'wallpaper_single_103', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568720, 15, '1636', 'wallpaper_single_102', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568719, 15, '1636', 'wallpaper_single_101', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568955, 15, '1637', 'landscape_single_5.4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568956, 15, '1637', 'landscape_single_6.4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568957, 15, '1637', 'landscape_single_7.4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568958, 15, '1637', 'landscape_single_1.5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568959, 15, '1637', 'landscape_single_2.5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568960, 15, '1637', 'landscape_single_3.5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568961, 15, '1637', 'landscape_single_4.5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568962, 15, '1637', 'landscape_single_5.5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568963, 15, '1637', 'landscape_single_6.5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568964, 15, '1637', 'landscape_single_7.5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568965, 15, '1637', 'landscape_single_1.6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568966, 15, '1637', 'landscape_single_2.6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568967, 15, '1637', 'landscape_single_3.6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568968, 15, '1637', 'landscape_single_4.6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568969, 15, '1637', 'landscape_single_5.6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568970, 15, '1637', 'landscape_single_6.6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568971, 15, '1637', 'landscape_single_7.6', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568972, 15, '1637', 'landscape_single_1.7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568973, 15, '1637', 'landscape_single_2.7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568974, 15, '1637', 'landscape_single_3.7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568975, 15, '1637', 'landscape_single_4.7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568976, 15, '1637', 'landscape_single_5.7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568977, 15, '1637', 'landscape_single_6.7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568978, 15, '1637', 'landscape_single_7.7', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568979, 15, '1637', 'landscape_single_1.8', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568980, 15, '1637', 'landscape_single_1.9', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568981, 15, '1637', 'landscape_single_1.10', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568982, 15, '1637', 'landscape_single_1.11', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568983, 15, '1637', 'landscape_single_7.12', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(2763, 187, '2702', 'a0 pet12', 30, 0, 1, 0, 0, 0, 0, 0, '1'),
(600014, 120, '2716', 'bb_knj1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600015, 120, '2717', 'bb_gate_r', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(600016, 120, '2718', 'bb_tddhnd', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600017, 120, '2719', 'bb_lightdiv', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(600018, 120, '2720', 'bb_tddhead', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(600019, 120, '2721', 'bb_pyramid', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600020, 120, '2722', 'bb_patch1', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(600021, 120, '2723', 'bb_fnc3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600022, 120, '2724', 'bb_gate_y', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(600023, 120, '2725', 'bb_apparatus', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600024, 120, '2726', 'bb_caterbody', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(600025, 120, '2727', 'bb_knj2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600026, 120, '2728', 'bb_fnc1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600027, 120, '2729', 'bb_puck', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600028, 120, '2730', 'bb_rnd_tele', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600029, 120, '2731', 'bb_gate_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600030, 120, '2732', 'bb_score_r', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600031, 120, '2733', 'bb_painimies1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600032, 120, '2703', 'bb_painimies2', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(600035, 120, '2722', 'bb_patch1', 5, 0, 100, 0, 0, 0, 0, 0, '1'),
(600002, 120, '2704', 'bb_score_b', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600003, 120, '2705', 'bb_robo', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600004, 120, '2706', 'bb_dragon', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(600005, 120, '2707', 'bb_ducklight', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600006, 120, '2708', 'bb_caterhead', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600007, 120, '2709', 'bb_cargobox', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(600008, 120, '2710', 'bb_gate_g', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600009, 120, '2711', 'bb_crchair3', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(600010, 120, '2712', 'bb_score_g', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600011, 120, '2713', 'bb_crchair', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600012, 120, '2714', 'bb_crchair2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600013, 120, '2715', 'bb_score_y', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(600036, 120, '2735', 'bb_counter', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(99039, 501, '2420', 'Freeze tile', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568984, 912, '2736', 'SONG disco_extreme', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568985, 912, '2736', 'SONG TeemuP1', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568986, 912, '2736', 'SONG Haadolocknloll', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568987, 912, '2736', 'SONG Weirdodo', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568988, 912, '2736', 'SONG double_peks', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568989, 912, '2736', 'SONG Trax_1', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568990, 912, '2736', 'SONG klubhaus', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568991, 912, '2736', 'SONG limbertake', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568992, 912, '2736', 'SONG miamimiamor', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568993, 912, '2736', 'SONG new_song', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568994, 912, '2736', 'SONG park_adventure', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568995, 912, '2736', 'SONG pianissimo', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568996, 912, '2736', 'Frank''s Generic Hotel Sounds', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568997, 912, '2736', 'SONG TeemuP2', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568998, 912, '2736', 'SONG bossanova', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568999, 912, '2736', 'SONG WhoDaresStacks', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568323, 177, '2737', 'wf_trg_at_given_time', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568324, 177, '2738', 'wf_trg_enter_room', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568325, 177, '2739', 'wf_trg_game_ends', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568326, 177, '2740', 'wf_trg_game_starts', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568327, 177, '2741', 'wf_trg_periodically', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568328, 177, '2742', 'wf_trg_says_something', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568329, 177, '2743', 'wf_trg_score_achieved', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568330, 177, '2744', 'wf_trg_state_changed', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568331, 177, '2745', 'wf_trg_walks_off_furni', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568332, 177, '2746', 'wf_trg_walks_on_furni', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568333, 178, '2747', 'wf_act_give_score', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568334, 178, '2748', 'wf_act_match_to_sshot', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568335, 178, '2749', 'wf_act_move_rotate', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568336, 178, '2750', 'wf_act_reset_timers', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568337, 178, '2751', 'wf_act_show_message', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568338, 178, '2752', 'wf_act_teleport_to', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568339, 178, '2753', 'wf_act_toggle_state', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568340, 180, '2754', 'wf_cnd_furnis_hv_avtrs', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568341, 180, '2755', 'wf_cnd_match_snapshot', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568342, 180, '2756', 'wf_cnd_time_less_than', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568343, 180, '2757', 'wf_cnd_time_more_than', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568344, 180, '2758', 'wf_cnd_trggrer_on_frn', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568345, 179, '2759', 'wf_arrowplate', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568346, 179, '2760', 'wf_pressureplate', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568347, 179, '2761', 'wf_ringplate', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568348, 179, '2762', 'wf_colortile', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568349, 179, '2763', 'wf_colorwheel', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568350, 179, '2764', 'wf_floor_switch1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568351, 179, '2765', 'wf_floor_switch2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568352, 179, '2766', 'wf_firegate', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568353, 179, '2767', 'wf_glassdoor', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568354, 179, '2768', 'wf_xtra_random', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568355, 179, '2769', 'wf_xtra_unseen', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568356, 179, '2770', 'wf_wire1', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568357, 179, '2770', 'wf_wire1', 10, 0, 5, 0, 0, 0, 0, 0, '1'),
(3568358, 179, '2771', 'wf_wire2', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568359, 179, '2771', 'wf_wire2', 10, 0, 5, 0, 0, 0, 0, 0, '1'),
(3568360, 179, '2772', 'wf_wire3', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568361, 179, '2772', 'wf_wire3', 10, 0, 5, 0, 0, 0, 0, 0, '1'),
(3568362, 179, '2773', 'wf_wire4', 1, 0, 1, 0, 0, 0, 0, 0, '1'),
(3568363, 179, '2773', 'wf_wire4', 10, 0, 5, 0, 0, 0, 0, 0, '1'),
(3569001, 913, '2774', 'qt_sum11_ictrolley', 0, 100, 1, 0, 0, 0, 0, 0, '1'),
(3569002, 913, '2775', 'qt_sum11_platfrm', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569003, 913, '2776', 'qt_sum11_shell3', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569004, 913, '2777', 'qt_sum11_shell2', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569005, 913, '2778', 'qt_sum11_chair', 4, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569006, 913, '2779', 'qt_sum11_shell4', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569007, 913, '2780', 'qt_sum11_shell1', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569008, 913, '2781', 'qt_sum11_shell5', 3, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569009, 913, '2782', 'qt_sum11_petfood', 2, 100, 1, 0, 0, 0, 0, 0, '1'),
(3569010, 914, '2783', 'petfood25', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569011, 914, '2784', 'lm_bananadrink', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569012, 914, '2785', 'lm_crystal_skull', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569013, 914, '2786', 'lm_jackbox', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569014, 915, '2787', 'ads_durex_carpet', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569015, 915, '2788', 'ads_durex_screen', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569016, 915, '2789', 'ads_durex_vend', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569017, 94, '2790', 'qt_sum11_dragon', 2500, 0, 0, 0, 0, 0, 0, 0, '1'),
(4000, 145, '2791', 'a0 pet14', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(6003, 46, '2792', 'a0 pet9', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569018, 916, '2793', 'a0 pet15', 20, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569038, 5, '0', 'deal_vip_1_year_and_badge', 100, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569037, 5, '0', 'HABBO_CLUB_VIP_3_DAYS', 5, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569036, 5, '0', 'HABBO_CLUB_VIP_1_DAY', 2, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569033, 5, '0', 'HABBO_CLUB_VIP_1_MONTH', 25, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569034, 5, '0', 'HABBO_CLUB_VIP_7_DAYS', 10, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569035, 5, '0', 'HABBO_CLUB_VIP_3_MONTHS', 60, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569032, 5, '0', 'HABBO_CLUB_VIP_5_DAYS', 8, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569040, 5, '0', 'deal_vip_1_year_and_badge', 100, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569041, 5, '0', 'HABBO_CLUB_VIP_5_YEAR', 500, 0, 1, 0, 0, 0, 0, 0, '1'),
(3569042, 142, '2804', 'horse_saddle', 10, 0, 1, 0, 0, 0, 0, 0, '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `catalog_items_old`
--

CREATE TABLE IF NOT EXISTS `catalog_items_old` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `page_id` int(11) NOT NULL,
  `item_ids` int(120) unsigned NOT NULL,
  `catalog_name` varchar(100) NOT NULL,
  `cost_credits` int(11) NOT NULL,
  `cost_pixels` int(11) NOT NULL,
  `amount` int(11) NOT NULL,
  `cost_crystal` int(11) NOT NULL,
  `cost_oude_belcredits` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3568719 ;

--
-- Volcado de datos para la tabla `catalog_items_old`
--

INSERT INTO `catalog_items_old` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`) VALUES
(1, 134, 19942, 'byesw_hand', 25, 0, 1, 50, 0),
(2, 134, 19943, 'byesw_hotel', 25, 0, 1, 50, 0),
(71, 55, 6, 'table_norja_med', 4, 0, 1, 50, 0),
(72, 55, 1, 'shelves_norja', 3, 0, 1, 50, 0),
(73, 55, 14, 'couch_norja', 4, 0, 1, 50, 0),
(74, 55, 15, 'chair_norja', 3, 0, 1, 50, 0),
(75, 55, 173, 'soft_sofachair_norja', 3, 0, 1, 50, 0),
(76, 55, 174, 'soft_sofa_norja', 4, 0, 1, 50, 0),
(78, 55, 479, 'table_norja_med*2', 3, 0, 1, 50, 0),
(79, 55, 480, 'table_norja_med*3', 3, 0, 1, 50, 0),
(80, 55, 481, 'table_norja_med*4', 3, 0, 1, 50, 0),
(81, 55, 482, 'table_norja_med*5', 3, 0, 1, 50, 0),
(82, 55, 483, 'table_norja_med*6', 3, 0, 1, 50, 0),
(83, 55, 484, 'table_norja_med*7', 3, 0, 1, 50, 0),
(85, 55, 485, 'table_norja_med*8', 3, 0, 1, 50, 0),
(86, 55, 486, 'table_norja_med*9', 3, 0, 1, 50, 0),
(87, 55, 487, 'couch_norja*2', 4, 0, 1, 50, 0),
(88, 55, 488, 'couch_norja*3', 4, 0, 1, 50, 0),
(89, 55, 489, 'couch_norja*4', 4, 0, 1, 50, 0),
(90, 1, 490, 'couch_norja*5', 4, 0, 1, 50, 0),
(91, 55, 491, 'couch_norja*6', 4, 0, 1, 50, 0),
(92, 55, 492, 'couch_norja*7', 4, 0, 1, 50, 0),
(93, 55, 493, 'couch_norja*8', 4, 0, 1, 50, 0),
(94, 55, 494, 'couch_norja*9', 4, 0, 1, 50, 0),
(95, 55, 495, 'shelves_norja*2', 3, 0, 1, 50, 0),
(96, 55, 496, 'shelves_norja*3', 3, 0, 1, 50, 0),
(97, 55, 497, 'shelves_norja*5', 3, 0, 1, 50, 0),
(98, 55, 498, 'shelves_norja*6', 3, 0, 1, 50, 0),
(99, 55, 499, 'shelves_norja*7', 3, 0, 1, 50, 0),
(100, 55, 500, 'shelves_norja*8', 3, 0, 1, 50, 0),
(101, 55, 501, 'shelves_norja*9', 3, 0, 1, 50, 0),
(103, 55, 502, 'chair_norja*2', 3, 0, 1, 50, 0),
(104, 55, 503, 'chair_norja*3', 3, 0, 1, 50, 0),
(105, 55, 504, 'chair_norja*4', 3, 0, 1, 50, 0),
(106, 55, 505, 'chair_norja*5', 3, 0, 1, 50, 0),
(107, 55, 506, 'chair_norja*6', 3, 0, 1, 50, 0),
(108, 55, 507, 'chair_norja*7', 3, 0, 1, 50, 0),
(109, 55, 508, 'chair_norja*8', 3, 0, 1, 50, 0),
(110, 55, 509, 'chair_norja*9', 3, 0, 1, 50, 0),
(111, 55, 518, 'soft_sofa_norja*2', 4, 0, 1, 50, 0),
(112, 55, 519, 'soft_sofa_norja*3', 4, 0, 1, 50, 0),
(113, 55, 520, 'soft_sofa_norja*4', 3, 0, 1, 50, 0),
(114, 55, 521, 'soft_sofa_norja*5', 4, 0, 1, 50, 0),
(115, 55, 522, 'soft_sofa_norja*6', 4, 0, 1, 50, 0),
(116, 55, 523, 'soft_sofa_norja*7', 4, 0, 1, 50, 0),
(118, 55, 524, 'soft_sofa_norja*8', 4, 0, 1, 50, 0),
(121, 55, 525, 'soft_sofa_norja*9', 4, 0, 1, 50, 0),
(123, 55, 526, 'soft_sofachair_norja*2', 3, 0, 1, 50, 0),
(124, 55, 527, 'soft_sofachair_norja*3', 3, 0, 1, 50, 0),
(125, 55, 528, 'soft_sofachair_norja*3', 3, 0, 1, 50, 0),
(126, 55, 530, 'soft_sofachair_norja*6', 3, 0, 1, 50, 0),
(127, 55, 531, 'soft_sofachair_norja*7', 3, 0, 1, 50, 0),
(128, 55, 529, 'soft_sofachair_norja*5', 3, 0, 1, 50, 0),
(129, 55, 532, 'soft_sofachair_norja*8', 3, 0, 1, 50, 0),
(130, 55, 533, 'soft_sofachair_norja*9', 3, 0, 1, 50, 0),
(131, 55, 658, 'solarium_norja', 3, 0, 1, 50, 0),
(132, 55, 659, 'solarium_norja*1', 3, 0, 1, 50, 0),
(133, 55, 660, 'solarium_norja*2', 3, 0, 1, 50, 0),
(134, 55, 661, 'solarium_norja*3', 3, 0, 1, 50, 0),
(135, 55, 662, 'solarium_norja*5', 3, 0, 1, 50, 0),
(136, 55, 663, 'solarium_norja*6', 3, 0, 1, 50, 0),
(137, 55, 664, 'solarium_norja*7', 3, 0, 1, 50, 0),
(138, 55, 665, 'solarium_norja*8', 3, 0, 1, 50, 0),
(139, 55, 666, 'solarium_norja*9', 3, 0, 1, 50, 0),
(140, 30, 2, 'shelves_polyfon', 3, 0, 1, 50, 0),
(141, 30, 4, 'table_polyfon_small', 2, 0, 1, 50, 0),
(142, 30, 5, 'chair_polyfon', 3, 0, 1, 50, 0),
(143, 30, 11, 'stand_polyfon_z', 1, 0, 1, 50, 0),
(144, 30, 16, 'table_polyfon_med', 3, 0, 1, 50, 0),
(145, 30, 19, 'sofachair_polyfon', 3, 0, 1, 50, 0),
(146, 30, 20, 'sofa_polyfon', 4, 0, 1, 50, 0),
(147, 30, 25, 'bed_polyfon', 4, 0, 1, 50, 0),
(148, 30, 26, 'bed_polyfon_one', 3, 0, 1, 50, 0),
(149, 30, 109, 'bar_polyfon', 3, 0, 1, 50, 0),
(150, 30, 46, 'fireplace_polyfon', 5, 0, 1, 50, 0),
(152, 30, 112, 'bardesk_polyfon', 3, 0, 1, 50, 0),
(153, 30, 113, 'bardeskcorner_polyfon', 3, 0, 1, 50, 0),
(154, 30, 133, 'table_polyfon', 4, 0, 1, 50, 0),
(155, 30, 134, 'smooth_table_polyfon', 4, 0, 1, 50, 0),
(156, 31, 135, 'sofachair_polyfon_girl', 3, 0, 1, 50, 0),
(157, 31, 136, 'bed_polyfon_girl_one', 3, 0, 1, 50, 0),
(158, 31, 137, 'bed_polyfon_girl', 4, 0, 1, 50, 0),
(159, 31, 138, 'sofa_polyfon_girl', 4, 0, 1, 50, 0),
(160, 31, 620, 'bardeskcorner_polyfon*5', 3, 0, 1, 50, 0),
(161, 31, 612, 'bardesk_polyfon*5', 3, 0, 1, 50, 0),
(162, 31, 628, 'divider_poly3*5', 6, 0, 1, 50, 0),
(163, 30, 216, 'divider_poly3', 6, 0, 1, 50, 0),
(166, 30, 582, 'sofachair_polyfon*2', 3, 0, 1, 50, 0),
(168, 30, 583, 'sofachair_polyfon*3', 3, 0, 1, 50, 0),
(170, 30, 584, 'sofachair_polyfon*4', 3, 0, 1, 50, 0),
(171, 30, 585, 'sofachair_polyfon*6', 3, 0, 1, 50, 0),
(172, 30, 586, 'sofachair_polyfon*7', 3, 0, 1, 50, 0),
(173, 30, 587, 'sofachair_polyfon*8', 3, 0, 1, 50, 0),
(174, 30, 588, 'sofachair_polyfon*9', 3, 0, 1, 50, 0),
(175, 30, 589, 'sofa_polyfon*2', 4, 0, 1, 50, 0),
(176, 30, 590, 'sofa_polyfon*3', 4, 0, 1, 50, 0),
(177, 30, 591, 'sofa_polyfon*3', 4, 0, 1, 50, 0),
(178, 30, 592, 'sofa_polyfon*6', 3, 0, 1, 50, 0),
(179, 30, 593, 'sofa_polyfon*7', 3, 0, 1, 50, 0),
(180, 30, 594, 'sofa_polyfon*8', 4, 0, 1, 50, 0),
(181, 30, 595, 'sofa_polyfon*9', 4, 0, 1, 50, 0),
(182, 30, 596, 'bed_polyfon*3', 4, 0, 1, 50, 0),
(183, 30, 597, 'bed_polyfon*4', 4, 0, 1, 50, 0),
(184, 30, 598, 'bed_polyfon*6', 4, 0, 1, 50, 0),
(185, 30, 599, 'bed_polyfon*7', 4, 0, 1, 50, 0),
(186, 30, 600, 'bed_polyfon*8', 4, 0, 1, 50, 0),
(187, 30, 601, 'bed_polyfon*9', 4, 0, 1, 50, 0),
(188, 30, 602, 'bed_polyfon_one*2', 3, 0, 1, 50, 0),
(189, 30, 603, 'bed_polyfon_one*3', 3, 0, 1, 50, 0),
(190, 30, 604, 'bed_polyfon_one*4', 3, 0, 1, 50, 0),
(191, 30, 605, 'bed_polyfon_one*6', 3, 0, 1, 50, 0),
(192, 30, 606, 'bed_polyfon_one*7', 3, 0, 1, 50, 0),
(193, 30, 607, 'bed_polyfon_one*8', 3, 0, 1, 50, 0),
(194, 30, 608, 'bed_polyfon_one*9', 3, 0, 1, 50, 0),
(195, 30, 609, 'bardesk_polyfon*2', 3, 0, 1, 50, 0),
(196, 30, 610, 'bardesk_polyfon*3', 3, 0, 1, 50, 0),
(197, 30, 611, 'bardesk_polyfon*4', 3, 0, 1, 50, 0),
(198, 30, 604, 'bed_polyfon_one*4', 3, 0, 1, 50, 0),
(199, 30, 613, 'bardesk_polyfon*6', 3, 0, 1, 50, 0),
(200, 30, 614, 'bardesk_polyfon*7', 3, 0, 1, 50, 0),
(201, 615, 615, 'bardesk_polyfon*8', 3, 0, 1, 50, 0),
(202, 30, 616, 'bardesk_polyfon*9', 3, 0, 1, 50, 0),
(203, 30, 616, 'bardesk_polyfon*9', 3, 0, 1, 50, 0),
(204, 30, 617, 'bardeskcorner_polyfon*2', 3, 0, 1, 50, 0),
(205, 30, 618, 'bardeskcorner_polyfon*3', 3, 0, 1, 50, 0),
(206, 30, 619, 'bardeskcorner_polyfon*4', 3, 0, 1, 50, 0),
(207, 30, 621, 'bardeskcorner_polyfon*6', 3, 0, 1, 50, 0),
(208, 30, 622, 'bardeskcorner_polyfon*7', 3, 0, 1, 50, 0),
(209, 30, 623, 'bardeskcorner_polyfon*8', 3, 0, 1, 50, 0),
(210, 30, 624, 'bardeskcorner_polyfon*9', 3, 0, 1, 50, 0),
(212, 30, 625, 'divider_poly3*2', 6, 0, 1, 50, 0),
(213, 30, 626, 'divider_poly3*3', 6, 0, 1, 50, 0),
(214, 30, 627, 'divider_poly3*4', 6, 0, 1, 50, 0),
(215, 30, 629, 'divider_poly3*6', 6, 0, 1, 50, 0),
(218, 30, 632, 'divider_poly3*9', 6, 0, 1, 50, 0),
(222, 35, 32, 'bed_armas_two', 4, 0, 1, 50, 0),
(224, 35, 36, 'bench_armas', 3, 0, 1, 50, 0),
(225, 35, 37, 'table_armas', 4, 0, 1, 50, 0),
(226, 35, 38, 'small_table_armas', 3, 0, 1, 50, 0),
(227, 35, 39, 'small_chair_armas', 1, 0, 1, 50, 0),
(228, 35, 40, 'fireplace_armas', 5, 0, 1, 50, 0),
(229, 35, 41, 'lamp_armas', 3, 0, 1, 50, 0),
(230, 35, 42, 'bed_armas_one', 3, 0, 1, 50, 0),
(231, 35, 44, 'carpet_armas', 3, 0, 1, 50, 0),
(232, 35, 115, 'bar_armas', 4, 0, 1, 50, 0),
(233, 35, 116, 'bartable_armas', 4, 0, 1, 50, 0),
(234, 35, 117, 'bar_chair_armas', 1, 0, 1, 50, 0),
(235, 35, 176, 'lamp2_armas', 3, 0, 1, 50, 0),
(237, 24, 1693, 'window_single_default', 3, 0, 1, 50, 0),
(238, 24, 1694, 'window_double_default', 4, 0, 1, 50, 0),
(239, 24, 1695, 'noob_window_double', 4, 0, 1, 50, 0),
(240, 24, 1696, 'window_triple', 5, 0, 1, 50, 0),
(241, 24, 1697, 'window_square', 1, 0, 1, 50, 0),
(242, 24, 1698, 'window_romantic_wide', 4, 0, 1, 50, 0),
(243, 24, 1699, 'window_romantic_narrow', 3, 0, 1, 50, 0),
(244, 24, 1700, 'window_grunge', 2, 0, 1, 50, 0),
(245, 24, 1701, 'window_golden', 4, 0, 1, 50, 0),
(246, 24, 1702, 'window_chinese_wide', 6, 0, 1, 50, 0),
(248, 24, 1703, 'window_chinese_narrow', 5, 0, 1, 50, 0),
(249, 24, 1704, 'window_basic', 3, 0, 1, 50, 0),
(250, 24, 1705, 'window_70s_wide', 5, 0, 1, 50, 0),
(251, 24, 1706, 'window_70s_narrow', 4, 0, 1, 50, 0),
(254, 24, 1712, 'window_hole', 2, 0, 1, 50, 0),
(255, 24, 1717, 'window_skyscraper', 18, 0, 5, 50, 0),
(257, 26, 1683, 'roomdimmer', 6, 0, 1, 50, 0),
(258, 26, 1802, 'dimmer_fuse6', 6, 0, 1, 50, 0),
(259, 26, 1803, 'dimmer_swtch', 3, 0, 1, 50, 0),
(260, 26, 1804, 'dimmer_fuse2', 6, 0, 1, 50, 0),
(261, 26, 1805, 'dimmer_buttn', 3, 0, 1, 50, 0),
(264, 29, 178, 'door', 5, 0, 1, 50, 0),
(265, 29, 1100, 'teleport_door', 6, 0, 1, 50, 0),
(268, 73, 1613, 'sf_tele', 5, 0, 1, 50, 0),
(269, 58, 1452, 'lostc_teleport', 5, 0, 1, 50, 0),
(271, 33, 3, 'shelves_silo', 3, 0, 1, 50, 0),
(272, 33, 7, 'table_silo_med', 3, 0, 1, 50, 0),
(273, 33, 12, 'chair_silo', 3, 0, 1, 50, 0),
(274, 33, 13, 'sofa_silo', 3, 0, 1, 50, 0),
(275, 33, 21, 'sofachair_silo', 3, 0, 1, 50, 0),
(276, 33, 29, 'bed_silo_one', 3, 0, 1, 50, 0),
(277, 33, 30, 'bed_silo_two', 4, 0, 1, 50, 0),
(278, 33, 31, 'table_silo_small', 2, 0, 1, 50, 0),
(279, 33, 221, 'divider_silo1', 3, 0, 1, 50, 0),
(280, 33, 223, 'divider_silo2', 3, 0, 1, 50, 0),
(281, 33, 225, 'divider_silo3', 6, 0, 1, 50, 0),
(282, 33, 461, 'barchair_silo', 3, 0, 1, 50, 0),
(283, 33, 534, 'sofachair_silo*2', 3, 0, 1, 50, 0),
(284, 33, 535, 'sofachair_silo*3', 3, 0, 1, 50, 0),
(285, 33, 536, 'sofachair_silo*4', 3, 0, 1, 50, 0),
(286, 33, 537, 'sofachair_silo*5', 3, 0, 1, 50, 0),
(287, 33, 538, 'sofachair_silo*6', 3, 0, 1, 50, 0),
(288, 33, 539, 'sofachair_silo*7', 3, 0, 1, 50, 0),
(289, 33, 540, 'sofachair_silo*8', 3, 0, 1, 50, 0),
(290, 33, 541, 'sofachair_silo*9', 3, 0, 1, 50, 0),
(291, 33, 542, 'table_silo_small*2', 2, 0, 1, 50, 0),
(292, 33, 543, 'table_silo_small*3', 2, 0, 1, 50, 0),
(293, 33, 544, 'table_silo_small*4', 2, 0, 1, 50, 0),
(294, 33, 545, 'table_silo_small*5', 2, 0, 1, 50, 0),
(295, 33, 546, 'table_silo_small*6', 2, 0, 1, 50, 0),
(296, 33, 547, 'table_silo_small*7', 2, 0, 1, 50, 0),
(297, 33, 548, 'table_silo_small*8', 2, 0, 1, 50, 0),
(298, 33, 549, 'table_silo_small*9', 3, 0, 1, 50, 0),
(299, 33, 550, 'divider_silo1*2', 3, 0, 1, 50, 0),
(300, 33, 551, 'divider_silo1*3', 3, 0, 1, 50, 0),
(301, 33, 552, 'divider_silo1*4', 3, 0, 1, 50, 0),
(302, 33, 553, 'divider_silo1*5', 3, 0, 1, 50, 0),
(303, 33, 554, 'divider_silo1*6', 3, 0, 1, 50, 0),
(304, 33, 555, 'divider_silo1*7', 3, 0, 1, 50, 0),
(305, 33, 556, 'divider_silo1*8', 3, 0, 1, 50, 0),
(306, 33, 557, 'divider_silo1*9', 3, 0, 1, 50, 0),
(307, 33, 558, 'divider_silo3*2', 6, 0, 1, 50, 0),
(308, 33, 559, 'divider_silo3*3', 6, 0, 1, 50, 0),
(309, 33, 560, 'divider_silo3*4', 6, 0, 1, 50, 0),
(310, 33, 561, 'divider_silo3*5', 6, 0, 1, 50, 0),
(311, 33, 562, 'divider_silo3*6', 6, 0, 1, 50, 0),
(312, 33, 563, 'divider_silo3*7', 6, 0, 1, 50, 0),
(313, 33, 564, 'divider_silo3*8', 6, 0, 1, 50, 0),
(314, 33, 565, 'divider_silo3*9', 6, 0, 1, 50, 0),
(315, 33, 566, 'table_silo_med*2', 3, 0, 1, 50, 0),
(316, 33, 567, 'table_silo_med*3', 3, 0, 1, 50, 0),
(317, 33, 568, 'table_silo_med*4', 3, 0, 1, 50, 0),
(318, 33, 569, 'table_silo_med*5', 3, 0, 1, 50, 0),
(319, 33, 570, 'table_silo_med*6', 3, 0, 1, 50, 0),
(320, 33, 571, 'table_silo_med*7', 3, 0, 1, 50, 0),
(321, 33, 572, 'table_silo_med*8', 3, 0, 1, 50, 0),
(322, 33, 573, 'table_silo_med*9', 3, 0, 1, 50, 0),
(323, 33, 574, 'sofa_silo*2', 4, 0, 1, 50, 0),
(324, 33, 575, 'sofa_silo*3', 4, 0, 1, 50, 0),
(325, 33, 576, 'sofa_silo*4', 4, 0, 1, 50, 0),
(326, 33, 577, 'sofa_silo*5', 4, 0, 1, 50, 0),
(327, 33, 578, 'sofa_silo*6', 4, 0, 1, 50, 0),
(328, 33, 579, 'sofa_silo*7', 4, 0, 1, 50, 0),
(329, 33, 580, 'sofa_silo*8', 4, 0, 1, 50, 0),
(330, 33, 581, 'sofa_silo*9', 4, 0, 1, 50, 0),
(331, 33, 633, 'chair_silo*2', 3, 0, 1, 50, 0),
(332, 33, 634, 'chair_silo*3', 3, 0, 1, 50, 0),
(333, 33, 635, 'chair_silo*4', 3, 0, 1, 50, 0),
(334, 33, 636, 'chair_silo*5', 3, 0, 1, 50, 0),
(335, 33, 637, 'chair_silo*5', 3, 0, 1, 50, 0),
(336, 33, 638, 'chair_silo*7', 3, 0, 1, 50, 0),
(337, 33, 639, 'chair_silo*8', 3, 0, 1, 50, 0),
(338, 33, 640, 'chair_silo*9', 3, 0, 1, 50, 0),
(339, 33, 657, 'silo_studydesk', 10, 0, 1, 50, 0),
(340, 33, 657, 'silo_studydesk', 10, 0, 1, 50, 0),
(341, 33, 675, 'safe_silo', 3, 0, 1, 50, 0),
(342, 33, 702, 'barchair_silo*2', 3, 0, 1, 50, 0),
(343, 33, 703, 'barchair_silo*3', 3, 0, 1, 50, 0),
(344, 33, 704, 'barchair_silo*4', 3, 0, 1, 50, 0),
(345, 33, 705, 'barchair_silo*5', 3, 0, 1, 50, 0),
(346, 33, 706, 'barchair_silo*6', 3, 0, 1, 50, 0),
(347, 33, 707, 'barchair_silo*6', 3, 0, 1, 50, 0),
(348, 33, 707, 'barchair_silo*7', 3, 0, 1, 50, 0),
(349, 33, 708, 'barchair_silo*8', 3, 0, 1, 50, 0),
(350, 33, 709, 'barchair_silo*9', 3, 0, 1, 50, 0),
(351, 33, 710, 'safe_silo*2', 3, 0, 1, 50, 0),
(352, 33, 711, 'safe_silo*3', 3, 0, 1, 50, 0),
(353, 33, 712, 'safe_silo*4', 3, 0, 1, 50, 0),
(354, 33, 713, 'safe_silo*5', 3, 0, 1, 50, 0),
(355, 33, 714, 'safe_silo*6', 3, 0, 1, 50, 0),
(356, 33, 715, 'safe_silo*7', 3, 0, 1, 50, 0),
(358, 33, 716, 'safe_silo*8', 3, 0, 1, 50, 0),
(359, 33, 717, 'safe_silo*9', 3, 0, 1, 50, 0),
(360, 33, 1043, 'safe_silo_pb', 5, 0, 1, 50, 0),
(363, 37, 1639, 'ktchn_stove', 4, 0, 1, 50, 0),
(364, 37, 1640, 'ktchn_light', 3, 0, 1, 50, 0),
(365, 37, 1641, 'ktchn_plates', 3, 0, 1, 50, 0),
(366, 37, 1642, 'ktchn_countr_1', 3, 0, 1, 50, 0),
(367, 37, 1643, 'ktchn_pots', 5, 0, 1, 50, 0),
(368, 37, 1644, 'ktchn_cornr', 3, 0, 1, 50, 0),
(369, 37, 1645, 'ktchn_desk', 3, 0, 1, 50, 0),
(370, 37, 1646, 'ktchn_trash', 3, 0, 1, 50, 0),
(371, 37, 1647, 'ktchn_countr_2', 4, 0, 1, 50, 0),
(372, 37, 1648, 'ktchn_bBlock', 5, 0, 1, 50, 0),
(373, 37, 1649, 'ktchn_dvdr', 3, 0, 1, 50, 0),
(374, 37, 1650, 'ktchn_inspctr', 5, 0, 1, 50, 0),
(375, 37, 1651, 'ktchn_fridge', 4, 0, 1, 50, 0),
(376, 37, 1653, 'ktchn_sink', 4, 0, 1, 50, 0),
(378, 37, 1654, 'ktchn_gate', 6, 0, 1, 50, 0),
(379, 37, 1798, 'ktchn_wall', 8, 0, 1, 50, 0),
(380, 37, 1800, 'ktchn_oven', 3, 0, 1, 50, 0),
(381, 37, 1801, 'ktchn_knives', 3, 0, 1, 50, 0),
(383, 37, 1798, 'ktchn_wall', 20, 0, 5, 50, 0),
(386, 28, 1364, 'xmas08_snowpl', 3, 0, 1, 50, 0),
(387, 28, 1366, 'xmas08_trph1', 6, 0, 1, 50, 0),
(388, 28, 1368, 'xmas08_table', 3, 0, 1, 50, 0),
(389, 28, 1369, 'xmas08_hottub', 5, 0, 1, 50, 0),
(390, 28, 1373, 'xmas08_icetree', 4, 0, 1, 50, 0),
(391, 28, 1375, 'xmas08_icerug', 5, 0, 1, 50, 0),
(392, 28, 1387, 'xmas08_geysir', 4, 0, 1, 50, 0),
(393, 28, 1391, 'xmas08_lantern', 3, 0, 1, 50, 0),
(394, 28, 1392, 'xmas08_chair', 3, 0, 1, 50, 0),
(395, 28, 1394, 'xmas08_telep', 6, 0, 1, 50, 0),
(396, 28, 1395, 'xmas08_cubetree', 3, 0, 1, 50, 0),
(397, 28, 1397, 'xmas08_dvdr1', 3, 0, 1, 50, 0),
(398, 28, 1398, 'xmas08_hole', 2, 0, 1, 50, 0),
(399, 28, 1401, 'xmas08_dvdr2', 3, 0, 1, 50, 0),
(400, 28, 1413, 'xmas08_trph2', 6, 0, 1, 50, 0),
(401, 28, 1738, 'xmas08_wallpaper', 3, 0, 1, 50, 0),
(402, 28, 1739, 'xmas08_icewall', 3, 0, 1, 50, 0),
(404, 39, 141, 'plant_pineapple', 3, 0, 1, 50, 0),
(405, 39, 142, 'plant_fruittree', 3, 0, 1, 50, 0),
(406, 39, 143, 'plant_small_cactus', 1, 0, 1, 50, 0),
(407, 39, 144, 'plant_bonsai', 2, 0, 1, 50, 0),
(408, 39, 145, 'plant_big_cactus', 3, 0, 1, 50, 0),
(409, 39, 146, 'plant_yukka', 3, 0, 1, 50, 0),
(410, 39, 152, 'plant_sunflower', 3, 0, 1, 50, 0),
(411, 39, 153, 'plant_rose', 3, 0, 1, 50, 0),
(412, 39, 816, 'plant_mazegate', 5, 0, 1, 50, 0),
(413, 39, 817, 'plant_maze', 5, 0, 1, 50, 0),
(414, 39, 818, 'plant_bulrush', 3, 0, 1, 50, 0),
(417, 38, 155, 'bath', 6, 0, 1, 50, 0),
(418, 38, 156, 'sink', 3, 0, 1, 50, 0),
(419, 38, 159, 'tile', 3, 0, 1, 50, 0),
(420, 38, 162, 'tile_red', 3, 0, 1, 50, 0),
(421, 38, 163, 'tile_yell', 3, 0, 1, 50, 0),
(422, 38, 157, 'toilet', 4, 0, 1, 50, 0),
(423, 38, 160, 'toilet_red', 4, 0, 1, 50, 0),
(424, 38, 161, 'toilet_yell', 4, 0, 1, 50, 0),
(425, 38, 158, 'duck', 1, 0, 1, 50, 0),
(426, 34, 1536, 'country_rain', 3, 0, 10, 50, 0),
(427, 34, 1537, 'country_scarecrow', 3, 0, 10, 50, 0),
(428, 34, 1539, 'country_soil', 50, 0, 10, 50, 0),
(429, 34, 1540, 'country_grass', 500, 0, 100, 50, 0),
(430, 34, 1543, 'country_trctr', 4, 0, 10, 50, 0),
(431, 34, 1544, 'country_fnc2', 3, 0, 10, 50, 0),
(432, 34, 1545, 'country_fnc1', 2, 0, 10, 50, 0),
(433, 34, 1546, 'country_well', 3, 0, 10, 50, 0),
(434, 34, 1548, 'country_rbw', 3, 0, 10, 50, 0),
(435, 34, 1549, 'country_wheat', 50, 0, 10, 50, 0),
(436, 34, 1550, 'country_gate', 6, 0, 10, 50, 0),
(437, 34, 1552, 'country_stage', 4, 0, 10, 50, 0),
(438, 34, 1557, 'country_log', 3, 0, 10, 50, 0),
(439, 34, 1558, 'country_fnc3', 3, 0, 10, 50, 0),
(440, 34, 1559, 'country_patio', 1, 0, 10, 50, 0),
(441, 34, 1560, 'country_corner', 3, 0, 10, 50, 0),
(442, 34, 1561, 'country_ditch', 3, 0, 10, 50, 0),
(443, 34, 1777, 'country_forestwall', 4, 0, 10, 50, 0),
(444, 34, 1778, 'country_fp', 4, 0, 10, 50, 0),
(445, 34, 1779, 'country_wall', 3, 0, 10, 50, 0),
(446, 34, 1780, 'country_lantern', 3, 0, 10, 50, 0),
(448, 34, 1779, 'country_wall', 15, 0, 10, 50, 0),
(449, 40, 43, 'carpet_standard', 3, 0, 1, 50, 0),
(450, 40, 45, 'carpet_polar', 3, 0, 1, 50, 0),
(451, 40, 52, 'carpet_standard*1', 3, 0, 1, 50, 0),
(452, 40, 60, 'carpet_standard*2', 3, 0, 1, 50, 0),
(453, 40, 66, 'carpet_standard*3', 3, 0, 1, 50, 0),
(454, 40, 66, 'carpet_standard*3', 3, 0, 1, 50, 0),
(455, 40, 73, 'carpet_standard*4', 3, 0, 1, 50, 0),
(456, 40, 77, 'carpet_standard*5', 3, 0, 1, 50, 0),
(457, 40, 102, 'carpet_standard*6', 3, 0, 1, 50, 0),
(458, 40, 118, 'carpet_soft', 3, 0, 1, 50, 0),
(459, 40, 119, 'carpet_soft*1', 3, 0, 1, 50, 0),
(460, 40, 120, 'carpet_soft*2', 3, 0, 1, 50, 0),
(461, 40, 121, 'carpet_soft*3', 3, 0, 1, 50, 0),
(462, 40, 122, 'carpet_soft*4', 3, 0, 1, 50, 0),
(463, 40, 123, 'carpet_soft*5', 3, 0, 1, 50, 0),
(464, 40, 124, 'carpet_soft*6', 3, 0, 1, 50, 0),
(465, 40, 127, 'carpet_polar*1', 3, 0, 1, 50, 0),
(466, 40, 129, 'carpet_polar*2', 3, 0, 1, 50, 0),
(467, 40, 130, 'carpet_polar*3', 3, 0, 1, 50, 0),
(468, 40, 131, 'carpet_polar*4', 3, 0, 1, 50, 0),
(469, 40, 147, 'carpet_standard*7', 3, 0, 1, 50, 0),
(470, 40, 148, 'carpet_standard*8', 3, 0, 1, 50, 0),
(471, 40, 149, 'carpet_standard*9', 3, 0, 1, 50, 0),
(472, 40, 150, 'carpet_standard*10', 3, 0, 1, 50, 0),
(473, 40, 151, 'carpet_standard*11', 3, 0, 1, 50, 0),
(475, 41, 1781, 'flag_norway', 3, 0, 1, 50, 0),
(476, 41, 1795, 'flag_belgium', 3, 0, 1, 50, 0),
(477, 41, 1796, 'flag_portugal', 3, 0, 1, 50, 0),
(481, 27, 190, 'xmasduck', 1, 0, 1, 50, 0),
(482, 27, 263, 'rare_xmas_screen', 6, 0, 1, 50, 0),
(483, 28, 1035, 'xmas_icelamp', 3, 0, 1, 50, 0),
(485, 27, 1036, 'xmas_cstl_wall', 5, 0, 1, 50, 0),
(486, 27, 1037, 'xmas_cstl_twr', 5, 0, 1, 50, 0),
(487, 27, 1038, 'xmas_cstl_gate', 5, 0, 1, 50, 0),
(488, 27, 1378, 'xmas_snow', 3, 0, 1, 50, 0),
(489, 27, 1378, 'xmas_snow', 20, 0, 10, 50, 0),
(490, 27, 1676, 'xmas_light', 3, 0, 1, 50, 0),
(493, 27, 19971, 'xm09_man_b', 3, 0, 1, 50, 0),
(495, 27, 19972, 'xm09_man_c', 3, 0, 1, 50, 0),
(496, 27, 19973, 'xm09_table', 5, 0, 1, 50, 0),
(497, 27, 19974, 'xm09_bench', 5, 0, 1, 50, 0),
(499, 27, 19977, 'xm09_forestwall', 3, 0, 1, 50, 0),
(500, 27, 19978, 'xm09_lodgewall', 3, 0, 1, 50, 0),
(501, 27, 19979, 'xm09_bauble_25', 3, 0, 1, 50, 0),
(502, 27, 19976, 'xm09_firwall', 3, 0, 1, 50, 0),
(503, 27, 19980, 'xm09_bauble_26', 3, 0, 1, 50, 0),
(505, 27, 19982, 'xm09_bauble_27', 3, 0, 1, 50, 0),
(506, 27, 19983, 'xm09_bauble_23', 3, 0, 1, 50, 0),
(507, 27, 19984, 'xm09_bauble_24', 3, 0, 1, 50, 0),
(508, 27, 19985, 'xm09_candyCane', 3, 0, 1, 50, 0),
(509, 27, 19986, 'xm09_stocking', 3, 0, 1, 50, 0),
(512, 27, 187, 'pudding', 3, 0, 1, 50, 0),
(513, 27, 193, 'tree3', 3, 0, 1, 50, 0),
(514, 27, 194, 'tree4', 3, 0, 1, 50, 0),
(515, 27, 195, 'tree5', 3, 0, 1, 50, 0),
(516, 27, 1039, 'tree7', 3, 0, 1, 50, 0),
(517, 27, 1040, 'tree6', 3, 0, 1, 50, 0),
(518, 27, 1046, 'christmas_sleigh', 6, 0, 1, 50, 0),
(519, 27, 1047, 'christmas_reindeer', 5, 0, 1, 50, 0),
(520, 27, 1048, 'christmas_poop', 1, 0, 1, 50, 0),
(522, 27, 192, 'triplecandle', 3, 0, 1, 50, 0),
(523, 27, 198, 'rcandleset', 3, 0, 1, 50, 0),
(524, 27, 270, 'rcandle', 2, 0, 1, 50, 0),
(528, 27, 19989, 'xm09_man_a', 3, 0, 1, 50, 0),
(531, 27, 19981, 'xm09_bauble_27', 3, 0, 1, 50, 0),
(532, 28, 1374, 'campfire', 4, 0, 1, 50, 0),
(533, 76, 200, 'valeduck', 1, 0, 1, 50, 0),
(534, 76, 245, 'valentinescreen', 5, 0, 1, 50, 0),
(536, 76, 811, 'plant_valentinerose*3', 3, 0, 1, 50, 0),
(537, 76, 812, 'plant_valentinerose*5', 3, 0, 1, 50, 0),
(538, 76, 813, 'plant_valentinerose*2', 3, 0, 1, 50, 0),
(539, 76, 814, 'plant_valentinerose*4', 3, 0, 1, 50, 0),
(540, 76, 815, 'plant_valentinerose*1', 3, 0, 1, 50, 0),
(541, 76, 820, 'carpet_valentine', 6, 0, 1, 50, 0),
(542, 76, 1092, 'val_teddy*1', 3, 0, 1, 50, 0),
(543, 76, 1093, 'val_teddy*2', 3, 0, 1, 50, 0),
(544, 76, 1094, 'val_teddy*3', 3, 0, 1, 50, 0),
(545, 76, 1095, 'val_teddy*4', 3, 0, 1, 50, 0),
(546, 76, 1096, 'val_teddy*4', 3, 0, 1, 50, 0),
(547, 76, 1097, 'val_teddy*6', 3, 0, 1, 50, 0),
(548, 76, 1098, 'val_randomizer', 8, 0, 1, 50, 0),
(549, 76, 1099, 'val_choco', 3, 0, 1, 50, 0),
(550, 76, 1669, 'val_heart', 3, 0, 1, 50, 0),
(551, 76, 1656, 'post.it.vd', 3, 0, 30, 50, 0),
(552, 76, 199, 'statue', 4, 0, 1, 50, 0),
(553, 76, 201, 'heartsofa', 3, 0, 1, 50, 0),
(555, 77, 1305, 'greek_corner', 3, 0, 1, 50, 0),
(556, 77, 1306, 'greek_gate', 6, 0, 1, 50, 0),
(557, 77, 1307, 'greek_pillars', 3, 0, 1, 50, 0),
(558, 77, 1308, 'greek_seat', 2, 0, 1, 50, 0),
(560, 42, 1310, 'a0 greektrophy_s', 10, 0, 1, 50, 0),
(561, 42, 1311, 'a0 greektrophy_b', 10, 0, 1, 50, 0),
(562, 77, 1312, 'greek_block', 4, 0, 1, 50, 0),
(563, 42, 1309, 'a0 greektrophy_g', 10, 0, 1, 50, 0),
(564, 71, 1623, 'rela_candle1', 3, 0, 1, 50, 0),
(566, 71, 1625, 'rela_candles2', 3, 0, 1, 50, 0),
(568, 71, 1627, 'rela_hchair', 5, 0, 1, 50, 0),
(569, 71, 1628, 'rela_candle2', 3, 0, 1, 50, 0),
(570, 71, 1632, 'rela_candle3', 3, 0, 1, 50, 0),
(571, 71, 1634, 'rela_plant', 4, 0, 1, 50, 0),
(572, 71, 1635, 'rela_candles1', 3, 0, 1, 50, 0),
(573, 71, 1636, 'rela_candles3', 3, 0, 1, 50, 0),
(574, 71, 1637, 'rela_orchid', 5, 0, 1, 50, 0),
(575, 71, 1638, 'rela_rock', 4, 0, 1, 50, 0),
(576, 71, 1794, 'rela_wall', 4, 0, 1, 50, 0),
(578, 59, 209, 'basket', 3, 0, 1, 50, 0),
(579, 59, 208, 'bunny', 3, 0, 1, 50, 0),
(580, 59, 207, 'easterduck', 1, 0, 1, 50, 0),
(581, 59, 210, 'birdie', 4, 0, 1, 50, 0),
(584, 56, 1124, 'arabian_teamk', 4, 0, 1, 50, 0),
(585, 56, 1125, 'arabian_snake', 3, 0, 1, 50, 0),
(586, 56, 1126, 'arabian_rug', 6, 0, 1, 50, 0),
(587, 56, 1127, 'arabian_pllw', 3, 0, 1, 50, 0),
(588, 56, 1128, 'arabian_divdr', 3, 0, 1, 50, 0),
(589, 56, 1129, 'arabian_chair', 3, 0, 1, 50, 0),
(590, 56, 1130, 'arabian_bigtb', 6, 0, 1, 50, 0),
(591, 56, 1131, 'arabian_tetbl', 3, 0, 1, 50, 0),
(592, 56, 1132, 'arabian_tray1', 3, 0, 1, 50, 0),
(594, 56, 1134, 'arabian_tray3', 3, 0, 1, 50, 0),
(595, 56, 1135, 'arabian_tray4', 3, 0, 1, 50, 0),
(596, 56, 1688, 'arabian_swords', 4, 0, 1, 50, 0),
(597, 56, 1689, 'arabian_wndw', 2, 0, 1, 50, 0),
(598, 56, 1133, 'arabian_tray2', 3, 0, 1, 50, 0),
(600, 63, 451, 'sporttrack1*1', 3, 0, 1, 50, 0),
(601, 63, 452, 'sporttrack1*3', 3, 0, 1, 50, 0),
(602, 63, 453, 'sporttrack1*2', 3, 0, 1, 50, 0),
(603, 63, 454, 'sporttrack2*1', 3, 0, 1, 50, 0),
(604, 63, 455, 'sporttrack2*2', 3, 0, 1, 50, 0),
(605, 63, 456, 'sporttrack2*3', 3, 0, 1, 50, 0),
(606, 63, 457, 'sporttrack3*1', 3, 0, 1, 50, 0),
(607, 63, 458, 'sporttrack3*2', 3, 0, 1, 50, 0),
(608, 63, 459, 'sporttrack3*3', 3, 0, 1, 50, 0),
(609, 63, 293, 'hockey_light', 4, 0, 1, 50, 0),
(610, 63, 292, 'hockey_score', 5, 0, 1, 50, 0),
(611, 63, 243, 'bench_lego', 3, 0, 1, 50, 0),
(612, 63, 242, 'carpet_legocourt', 4, 0, 1, 50, 0),
(613, 63, 244, 'legotrophy', 3, 0, 1, 50, 0),
(615, 63, 460, 'footylamp', 3, 0, 1, 50, 0),
(617, 64, 1017, 'grunge_chair', 3, 0, 1, 50, 0),
(618, 64, 1018, 'grunge_mattress', 4, 0, 1, 50, 0),
(619, 64, 1019, 'grunge_radiator', 3, 0, 1, 50, 0),
(620, 64, 1020, 'grunge_shelf', 4, 0, 1, 50, 0),
(621, 64, 1022, 'grunge_table', 4, 0, 1, 50, 0),
(622, 64, 1021, 'grunge_sign', 3, 0, 1, 50, 0),
(623, 64, 1110, 'grunge_candle', 2, 0, 1, 50, 0),
(624, 64, 1111, 'grunge_bench', 4, 0, 1, 50, 0),
(625, 64, 1112, 'grunge_barrel', 3, 0, 1, 50, 0),
(626, 64, 1700, 'window_grunge', 2, 0, 1, 50, 0),
(628, 67, 844, 'jp_tatami2', 4, 0, 1, 50, 0),
(629, 67, 845, 'jp_tatami', 3, 0, 1, 50, 0),
(630, 67, 847, 'jp_bamboo', 5, 0, 1, 50, 0),
(631, 67, 848, 'jp_irori', 5, 0, 1, 50, 0),
(632, 67, 849, 'jp_pillow', 2, 0, 1, 50, 0),
(633, 67, 937, 'jp_lantern', 3, 0, 1, 50, 0),
(634, 67, 965, 'jp_drawer', 3, 0, 1, 50, 0),
(635, 67, 1118, 'jp_tray6', 3, 0, 1, 50, 0),
(636, 67, 1119, 'jp_tray5', 3, 0, 1, 50, 0),
(637, 67, 1120, 'jp_tray4', 3, 0, 1, 50, 0),
(638, 67, 1121, 'jp_tray3', 3, 0, 1, 50, 0),
(639, 67, 1122, 'jp_tray2', 3, 0, 1, 50, 0),
(640, 67, 1123, 'jp_tray1', 3, 0, 1, 50, 0),
(641, 67, 1150, 'jp_table', 5, 0, 1, 50, 0),
(642, 67, 1151, 'jp_rare', 6, 0, 1, 50, 0),
(643, 67, 1152, 'jp_katana3', 3, 0, 1, 50, 0),
(644, 67, 1153, 'jp_katana2', 3, 0, 1, 50, 0),
(645, 67, 1154, 'jp_katana1', 3, 0, 1, 50, 0),
(646, 67, 1197, 'jp_teamaker', 4, 0, 1, 50, 0),
(647, 67, 1671, 'jp_ninjastars', 4, 0, 1, 50, 0),
(648, 67, 1685, 'jp_sheet3', 3, 0, 1, 50, 0),
(649, 67, 1686, 'jp_sheet2', 3, 0, 1, 50, 0),
(650, 67, 1687, 'jp_sheet1', 3, 0, 1, 50, 0),
(651, 75, 969, 'summer_grill*1', 3, 0, 1, 50, 0),
(652, 75, 970, 'summer_grill*2', 3, 0, 1, 50, 0),
(653, 75, 971, 'summer_grill*3', 3, 0, 1, 50, 0),
(654, 75, 972, 'summer_grill*4', 3, 0, 1, 50, 0),
(655, 75, 973, 'summer_chair*1', 3, 0, 1, 50, 0),
(656, 75, 974, 'summer_chair*2', 3, 0, 1, 50, 0),
(657, 75, 975, 'summer_chair*3', 3, 0, 1, 50, 0),
(658, 75, 976, 'summer_chair*4', 3, 0, 1, 50, 0),
(659, 75, 977, 'summer_chair*5', 3, 0, 1, 50, 0),
(660, 75, 978, 'summer_chair*6', 3, 0, 1, 50, 0),
(661, 75, 979, 'summer_chair*7', 3, 0, 1, 50, 0),
(662, 75, 980, 'summer_chair*8', 3, 0, 1, 50, 0),
(663, 75, 981, 'summer_chair*9', 3, 0, 1, 50, 0),
(664, 75, 1003, 'summer_pool*1', 5, 0, 1, 50, 0),
(665, 75, 1004, 'summer_pool*2', 5, 0, 1, 50, 0),
(666, 75, 1005, 'summer_pool*3', 5, 0, 1, 50, 0),
(667, 75, 1006, 'summer_pool*4', 5, 0, 1, 50, 0),
(668, 75, 1616, 'summer_raft1', 4, 0, 1, 50, 0),
(669, 75, 1618, 'summer_raft2', 4, 0, 1, 50, 0),
(670, 75, 1620, 'summer_icebox', 3, 0, 1, 50, 0),
(671, 66, 19938, 'hween09_floor', 3, 0, 1, 50, 0),
(672, 66, 19938, 'hween09_floor', 25, 0, 10, 50, 0),
(673, 66, 19939, 'hween09_jar', 3, 0, 1, 50, 0),
(674, 66, 19941, 'hween09_organ', 5, 0, 1, 50, 0),
(675, 66, 19944, 'hween09_table', 6, 0, 1, 50, 0),
(676, 66, 19945, 'hween09_chair', 3, 0, 1, 50, 0),
(677, 66, 19946, 'hween09_mirror', 4, 0, 1, 50, 0),
(678, 66, 19947, 'hween09_hatch', 6, 0, 1, 50, 0),
(679, 66, 19948, 'hween09_ghost', 3, 0, 1, 50, 0),
(680, 66, 19949, 'hween09_tv', 3, 0, 1, 50, 0),
(681, 66, 19950, 'hween09_chandelier', 5, 0, 1, 50, 0),
(682, 66, 19951, 'hween09_crnr1', 3, 0, 1, 50, 0),
(683, 66, 19952, 'hween09_paint', 3, 0, 1, 50, 0),
(684, 66, 19953, 'hween09_treewall', 3, 0, 1, 50, 0),
(685, 66, 19954, 'hween09_wall1', 3, 0, 1, 50, 0),
(686, 66, 19955, 'hween09_stonewall', 3, 0, 1, 50, 0),
(687, 66, 19956, 'hween09_win', 4, 0, 1, 50, 0),
(688, 66, 181, 'pumpkin', 3, 0, 1, 50, 0),
(690, 66, 182, 'skullcandle', 3, 0, 1, 50, 0),
(693, 66, 184, 'deadduck2', 1, 0, 1, 50, 0),
(694, 66, 185, 'deadduck3', 1, 0, 1, 50, 0),
(695, 66, 183, 'deadduck', 1, 0, 1, 50, 0),
(697, 88, 1334, 'hween08_sink', 3, 0, 1, 50, 0),
(698, 88, 1335, 'hween08_curtain', 5, 0, 1, 50, 0),
(699, 88, 1336, 'hween08_bath', 6, 0, 1, 50, 0),
(700, 88, 1337, 'hween08_defibs', 3, 0, 1, 50, 0),
(701, 88, 1338, 'hween08_bbag', 5, 0, 1, 50, 0),
(702, 88, 1339, 'hween08_curtain2', 5, 0, 1, 50, 0),
(703, 88, 1340, 'hween08_defibs2', 3, 0, 1, 50, 0),
(704, 88, 1341, 'hween08_bed', 4, 0, 1, 50, 0),
(705, 88, 1342, 'hween08_sink2', 3, 0, 1, 50, 0),
(706, 88, 1343, 'hween08_bed2', 4, 0, 1, 50, 0),
(707, 88, 1344, 'hween08_bath2', 4, 0, 1, 50, 0),
(708, 88, 1345, 'hween08_manhole', 3, 0, 1, 50, 0),
(709, 88, 1346, 'hween08_trll', 3, 0, 1, 50, 0),
(710, 88, 1721, 'hween08_rad', 3, 0, 1, 50, 0),
(711, 88, 1722, 'hween08_wndwb', 3, 0, 1, 50, 0),
(712, 88, 1723, 'hween08_wndw', 4, 0, 1, 50, 0),
(713, 88, 1724, 'hween08_bio', 3, 0, 1, 50, 0),
(714, 74, 1419, 'bolly_lotus_pool', 4, 0, 1, 50, 0),
(715, 74, 1422, 'bolly_petals', 3, 0, 1, 50, 0),
(716, 74, 1423, 'bolly_tree', 3, 0, 1, 50, 0),
(717, 74, 1424, 'bolly_swing', 4, 0, 1, 50, 0),
(718, 74, 1425, 'bolly_pillow', 3, 0, 1, 50, 0),
(719, 74, 1426, 'bolly_corner', 3, 0, 1, 50, 0),
(720, 74, 1427, 'bolly_phant', 5, 0, 1, 50, 0),
(721, 74, 1428, 'bolly_monkey_lamp', 4, 0, 1, 50, 0),
(722, 74, 1429, 'bolly_drapeb', 4, 0, 1, 50, 0),
(723, 74, 1431, 'bolly_lamp', 3, 0, 1, 50, 0),
(724, 74, 1432, 'bolly_desk', 3, 0, 1, 50, 0),
(725, 74, 1433, 'bolly_vase', 3, 0, 1, 50, 0),
(726, 74, 1434, 'bolly_tile2', 3, 0, 1, 50, 0),
(727, 74, 1435, 'bolly_table', 4, 0, 1, 50, 0),
(728, 74, 1436, 'bolly_drapec', 4, 0, 1, 50, 0),
(729, 74, 1437, 'bolly_fountain', 5, 0, 1, 50, 0),
(731, 74, 1439, 'bolly_tile1', 3, 0, 1, 50, 0),
(732, 74, 1440, 'bolly_drapea', 4, 0, 1, 50, 0),
(733, 74, 1749, 'bolly_wdw_wd', 4, 0, 1, 50, 0),
(735, 73, 1593, 'SF_reactor', 5, 0, 1, 50, 0),
(736, 73, 1594, 'SF_crate_2', 3, 0, 1, 50, 0),
(737, 73, 1595, 'SF_chair_blue', 3, 0, 1, 50, 0),
(738, 73, 1596, 'sf_pod', 4, 0, 1, 50, 0),
(739, 73, 1597, 'SF_panel1', 3, 0, 1, 50, 0),
(740, 73, 1598, 'SF_table', 3, 0, 1, 50, 0),
(741, 73, 1602, 'SF_panel2', 3, 0, 1, 50, 0),
(742, 73, 1603, 'sf_gate', 6, 0, 1, 50, 0),
(743, 73, 1599, 'SF_chair_green', 3, 0, 1, 50, 0),
(744, 73, 1600, 'SF_crate_1', 2, 0, 1, 50, 0),
(745, 73, 1601, 'SF_alien', 4, 0, 1, 50, 0),
(746, 73, 1605, 'SF_floor_2', 3, 0, 1, 50, 0),
(747, 73, 1604, 'SF_panel3', 5, 0, 1, 50, 0),
(748, 73, 1606, 'SF_lamp', 3, 0, 1, 50, 0),
(749, 73, 1607, 'SF_chair_red', 3, 0, 1, 50, 0),
(750, 73, 1608, 'sf_floor', 3, 0, 1, 50, 0),
(751, 73, 1609, 'sf_roof', 5, 0, 1, 50, 0),
(752, 73, 1610, 'sf_stick', 3, 0, 1, 50, 0),
(753, 73, 1611, 'SF_floor_1', 3, 0, 1, 50, 0),
(756, 73, 1614, 'sf_roller', 7, 0, 1, 50, 0),
(757, 73, 1787, 'sf_window', 7, 0, 1, 50, 0),
(758, 73, 1788, 'sf_wall2', 6, 0, 1, 50, 0),
(759, 73, 1791, 'sf_wall3', 6, 0, 1, 50, 0),
(765, 72, 795, 'romantique_pianochair*3', 2, 0, 1, 50, 0),
(766, 72, 796, 'romantique_pianochair*5', 2, 0, 1, 50, 0),
(767, 72, 797, 'romantique_pianochair*2', 2, 0, 1, 50, 0),
(768, 72, 798, 'romantique_pianochair*4', 2, 0, 1, 50, 0),
(769, 72, 799, 'romantique_pianochair*1', 2, 0, 1, 50, 0),
(770, 72, 800, 'romantique_divan*3', 4, 0, 1, 50, 0),
(771, 72, 801, 'romantique_divan*5', 4, 0, 1, 50, 0),
(772, 72, 802, 'romantique_divan*2', 4, 0, 1, 50, 0),
(773, 72, 803, 'romantique_divan*4', 4, 0, 1, 50, 0),
(774, 72, 804, 'romantique_divan*1', 4, 0, 1, 50, 0),
(775, 72, 805, 'romantique_chair*3', 3, 0, 1, 50, 0),
(776, 72, 806, 'romantique_chair*5', 3, 0, 1, 50, 0),
(777, 72, 807, 'romantique_chair*2', 3, 0, 1, 50, 0),
(778, 72, 808, 'romantique_chair*4', 3, 0, 1, 50, 0),
(779, 72, 809, 'romantique_chair*1', 3, 0, 1, 50, 0),
(780, 72, 832, 'romantique_tray2', 3, 0, 1, 50, 0),
(781, 72, 833, 'romantique_tray1', 3, 0, 1, 50, 0),
(782, 72, 834, 'romantique_smalltabl*3', 2, 0, 1, 50, 0),
(783, 72, 835, 'romantique_smalltabl*5', 2, 0, 1, 50, 0),
(784, 72, 836, 'romantique_smalltabl*2', 2, 0, 1, 50, 0),
(785, 72, 837, 'romantique_smalltabl*4', 2, 0, 1, 50, 0),
(786, 72, 838, 'romantique_smalltabl*1', 2, 0, 1, 50, 0),
(787, 72, 839, 'romantique_mirrortabl', 3, 0, 1, 50, 0),
(788, 72, 840, 'romantique_divider*3', 3, 0, 1, 50, 0),
(789, 72, 841, 'romantique_divider*2', 3, 0, 1, 50, 0),
(790, 72, 842, 'romantique_divider*4', 3, 0, 1, 50, 0),
(791, 72, 843, 'romantique_divider*1', 3, 0, 1, 50, 0),
(792, 72, 891, 'romantique_clock', 5, 0, 1, 50, 0),
(793, 69, 1347, 'party_table', 3, 0, 1, 50, 0),
(794, 69, 1348, 'party_discol', 5, 0, 1, 50, 0),
(795, 69, 1349, 'party_block2', 4, 0, 1, 50, 0),
(796, 69, 1350, 'party_barcorn', 3, 0, 1, 50, 0),
(797, 69, 1351, 'party_chair', 3, 0, 1, 50, 0),
(798, 69, 1352, 'party_block', 2, 0, 1, 50, 0),
(799, 69, 1353, 'party_ravel', 5, 0, 1, 50, 0),
(800, 69, 1354, 'party_tube_lava', 4, 0, 1, 50, 0),
(801, 69, 1355, 'party_tray', 3, 0, 1, 50, 0),
(802, 69, 1356, 'party_djtable', 4, 0, 1, 50, 0),
(803, 69, 1357, 'party_floor', 3, 0, 1, 50, 0),
(804, 69, 1358, 'party_ball', 3, 0, 1, 50, 0),
(805, 69, 1359, 'party_tube_bubble', 4, 0, 1, 50, 0),
(806, 69, 1360, 'party_mic', 3, 0, 1, 50, 0),
(807, 69, 1361, 'party_beamer', 5, 0, 1, 50, 0),
(808, 69, 1362, 'party_bardesk', 3, 0, 1, 50, 0),
(809, 69, 1363, 'party_seat', 3, 0, 1, 50, 0),
(810, 69, 1729, 'party_wc_boy', 3, 0, 1, 50, 0),
(811, 69, 1730, 'party_led', 4, 0, 1, 50, 0),
(812, 69, 1731, 'party_neon5', 3, 0, 1, 50, 0),
(813, 69, 1732, 'party_neon1', 3, 0, 1, 50, 0),
(814, 69, 1733, 'party_neon2', 3, 0, 1, 50, 0),
(815, 69, 1734, 'party_wc_girl', 3, 0, 1, 50, 0),
(816, 69, 1735, 'party_neon3', 3, 0, 1, 50, 0),
(817, 69, 1736, 'party_shelf', 4, 0, 1, 50, 0),
(818, 69, 1737, 'party_neon4', 3, 0, 1, 50, 0),
(821, 29, 180, 'doorC', 4, 0, 1, 50, 0),
(822, 29, 179, 'doorB', 3, 0, 1, 50, 0),
(824, 94, 227, 'spyro', 10, 0, 1, 50, 0),
(825, 94, 202, 'throne', 10, 0, 1, 50, 0),
(826, 94, 203, 'samovar', 10, 0, 1, 50, 0),
(827, 94, 110, 'plant_cruddy', 10, 0, 1, 50, 0),
(830, 94, 273, 'djesko_turntable', 10, 0, 1, 50, 0),
(833, 57, 669, 'chair_china', 3, 0, 1, 50, 0),
(834, 57, 670, 'china_table', 3, 0, 1, 50, 0),
(835, 57, 682, 'china_shelve', 4, 0, 1, 50, 0),
(836, 57, 700, 'wall_china', 4, 0, 1, 50, 0),
(837, 57, 701, 'corner_china', 4, 0, 1, 50, 0),
(838, 57, 1418, 'china_moongt', 5, 0, 1, 50, 0),
(839, 57, 1420, 'china_ox', 3, 0, 1, 50, 0),
(840, 57, 1746, 'china_pstr2', 3, 0, 1, 50, 0),
(842, 57, 1747, 'china_light', 3, 0, 1, 50, 0),
(843, 57, 1748, 'china_pstr1', 3, 0, 1, 50, 0),
(845, 60, 1000, 'exe_rug', 4, 0, 1, 50, 0),
(846, 60, 1000, 'exe_rug', 20, 0, 6, 50, 0),
(847, 60, 1001, 'exe_s_table', 4, 0, 1, 50, 0),
(848, 60, 1049, 'exe_bardesk', 2, 0, 1, 50, 0),
(849, 60, 1050, 'exe_chair', 3, 0, 1, 50, 0),
(850, 60, 1051, 'exe_chair2', 3, 0, 1, 50, 0),
(851, 60, 1052, 'exe_corner', 2, 0, 1, 50, 0),
(852, 60, 1053, 'exe_drinks', 3, 0, 1, 50, 0),
(853, 60, 1054, 'exe_sofa', 3, 0, 1, 50, 0),
(855, 60, 1055, 'exe_table', 6, 0, 1, 50, 0),
(856, 60, 1091, 'exe_plant', 3, 0, 1, 50, 0),
(857, 60, 1510, 'exe_light', 3, 0, 1, 50, 0),
(858, 60, 1517, 'exe_gate', 6, 0, 1, 50, 0),
(859, 60, 1521, 'exe_cubelight', 3, 0, 1, 50, 0),
(860, 60, 1523, 'exe_artlamp', 3, 0, 1, 50, 0),
(861, 60, 1771, 'exe_map', 5, 0, 1, 50, 0),
(862, 60, 1772, 'exe_wfall', 4, 0, 1, 50, 0),
(863, 58, 1449, 'lc_tile1', 3, 0, 1, 50, 0),
(865, 58, 1451, 'lc_crab2', 3, 0, 1, 50, 0),
(866, 58, 1454, 'lc_coral_divider_hi', 4, 0, 1, 50, 0),
(867, 58, 1456, 'lc_tubes_corners', 3, 0, 1, 50, 0),
(868, 58, 1457, 'lc_table', 4, 0, 1, 50, 0),
(869, 58, 1458, 'lc_tile2', 3, 0, 1, 50, 0),
(870, 58, 1459, 'lc_anemone', 4, 0, 1, 50, 0),
(871, 58, 1461, 'lc_glass_floor', 4, 0, 1, 50, 0),
(872, 58, 1460, 'lc_coral_divider_low', 3, 0, 1, 50, 0),
(874, 58, 1462, 'lc_medusa1', 4, 0, 1, 50, 0),
(875, 58, 1463, 'lc_crab1', 4, 0, 1, 50, 0),
(876, 58, 1466, 'lc_tubes_straight', 3, 0, 1, 50, 0),
(877, 58, 1470, 'lc_corner', 3, 0, 1, 50, 0),
(878, 58, 1471, 'lc_stool', 3, 0, 1, 50, 0),
(879, 58, 1472, 'lc_chair', 3, 0, 1, 50, 0),
(880, 58, 1473, 'lc_desk', 3, 0, 1, 50, 0),
(881, 58, 1755, 'lc_wall1', 5, 0, 1, 50, 0),
(882, 58, 1756, 'lc_window2', 5, 0, 1, 50, 0),
(883, 58, 1757, 'lc_window1', 3, 0, 1, 50, 0),
(884, 58, 1759, 'lc_wall2', 5, 0, 1, 50, 0),
(889, 42, 295, 'a0 prizetrophy2_b', 10, 0, 1, 50, 0),
(890, 42, 296, 'a0 prizetrophy3_b', 10, 0, 1, 50, 0),
(891, 42, 297, 'a0 prizetrophy4_b', 10, 0, 1, 50, 0),
(892, 42, 298, 'a0 prizetrophy5_b', 10, 0, 1, 50, 0),
(893, 42, 299, 'a0 prizetrophy1_g', 10, 0, 1, 50, 0),
(894, 42, 300, 'a0 prizetrophy2_g', 10, 0, 1, 50, 0),
(895, 42, 301, 'a0 prizetrophy3_g', 10, 0, 1, 50, 0),
(896, 42, 302, 'a0 prizetrophy4_g', 10, 0, 1, 50, 0),
(897, 42, 303, 'a0 prizetrophy4_g', 10, 0, 1, 50, 0),
(898, 42, 304, 'a0 prizetrophy6_g', 10, 0, 1, 50, 0),
(899, 42, 305, 'a0 prizetrophy1_s', 10, 0, 1, 50, 0),
(900, 42, 306, 'a0 prizetrophy2_s', 10, 0, 1, 50, 0),
(901, 42, 307, 'a0 prizetrophy3_s', 10, 0, 1, 50, 0),
(902, 42, 308, 'a0 prizetrophy4_s', 10, 0, 1, 50, 0),
(903, 42, 309, 'a0 prizetrophy5_s', 10, 0, 1, 50, 0),
(904, 42, 310, 'a0 prizetrophy6_s', 10, 0, 1, 50, 0),
(905, 42, 311, 'a0 prizetrophy1_b', 10, 0, 1, 50, 0),
(906, 93, 335, 'a0 prizetrophy7_b', 10, 0, 1, 50, 0),
(908, 93, 336, 'a0 prizetrophy7_g', 10, 0, 1, 50, 0),
(909, 93, 337, 'a0 prizetrophy7_s', 10, 0, 1, 50, 0),
(910, 42, 1115, 'a0 prizetrophy5_g', 10, 0, 1, 50, 0),
(911, 93, 1615, 'prizetrophy_hot', 10, 0, 1, 50, 0),
(912, 93, 1617, 'prizetrophy_cool', 10, 0, 1, 50, 0),
(913, 32, 171, 'bar_basic', 4, 0, 1, 50, 0),
(914, 32, 172, 'shelves_basic', 3, 0, 1, 50, 0),
(915, 32, 175, 'lamp_basic', 3, 0, 1, 50, 0),
(916, 32, 177, 'fridge', 6, 0, 1, 50, 0),
(918, 32, 893, 'pura_mdl5*2', 3, 0, 1, 50, 0),
(919, 32, 894, 'pura_mdl5*3', 3, 0, 1, 50, 0),
(920, 32, 895, 'pura_mdl5*4', 3, 0, 1, 50, 0),
(921, 32, 896, 'pura_mdl5*5', 3, 0, 1, 50, 0),
(922, 32, 897, 'pura_mdl5*6', 3, 0, 1, 50, 0),
(923, 32, 898, 'pura_mdl5*7', 3, 0, 1, 50, 0),
(924, 32, 899, 'pura_mdl5*8', 3, 0, 1, 50, 0),
(925, 32, 900, 'pura_mdl5*9', 3, 0, 1, 50, 0),
(926, 32, 901, 'pura_mdl4*1', 3, 0, 1, 50, 0),
(927, 32, 902, 'pura_mdl4*2', 3, 0, 1, 50, 0),
(928, 32, 903, 'pura_mdl4*3', 3, 0, 1, 50, 0),
(929, 32, 904, 'pura_mdl4*4', 3, 0, 1, 50, 0),
(930, 32, 905, 'pura_mdl4*5', 3, 0, 1, 50, 0),
(931, 32, 906, 'pura_mdl4*6', 3, 0, 1, 50, 0),
(932, 32, 907, 'pura_mdl4*7', 3, 0, 1, 50, 0),
(933, 32, 908, 'pura_mdl4*8', 3, 0, 1, 50, 0),
(934, 32, 909, 'pura_mdl4*9', 3, 0, 1, 50, 0),
(935, 32, 910, 'pura_mdl3*1', 3, 0, 1, 50, 0),
(936, 32, 911, 'pura_mdl3*2', 3, 0, 1, 50, 0),
(937, 32, 912, 'pura_mdl3*3', 3, 0, 1, 50, 0),
(938, 32, 913, 'pura_mdl3*4', 3, 0, 1, 50, 0),
(939, 32, 914, 'pura_mdl3*5', 3, 0, 1, 50, 0),
(940, 32, 915, 'pura_mdl3*6', 3, 0, 1, 50, 0),
(941, 32, 916, 'pura_mdl3*7', 3, 0, 1, 50, 0),
(942, 32, 917, 'pura_mdl3*8', 3, 0, 1, 50, 0),
(943, 32, 918, 'pura_mdl3*9', 3, 0, 1, 50, 0),
(944, 32, 919, 'pura_mdl2*1', 3, 0, 1, 50, 0),
(945, 32, 920, 'pura_mdl2*2', 3, 0, 1, 50, 0),
(947, 32, 921, 'pura_mdl2*3', 3, 0, 1, 50, 0),
(948, 32, 922, 'pura_mdl2*4', 3, 0, 1, 50, 0),
(949, 32, 923, 'pura_mdl2*5', 3, 0, 1, 50, 0),
(950, 32, 924, 'pura_mdl2*6', 3, 0, 1, 50, 0),
(951, 32, 925, 'pura_mdl2*7', 3, 0, 1, 50, 0),
(952, 32, 926, 'pura_mdl2*8', 3, 0, 1, 50, 0),
(953, 32, 927, 'pura_mdl2*9', 3, 0, 1, 50, 0),
(954, 32, 928, 'pura_mdl1*1', 3, 0, 1, 50, 0),
(955, 32, 929, 'pura_mdl1*2', 3, 0, 1, 50, 0),
(956, 32, 930, 'pura_mdl1*3', 3, 0, 1, 50, 0),
(957, 32, 931, 'pura_mdl1*4', 3, 0, 1, 50, 0),
(958, 32, 932, 'pura_mdl1*5', 3, 0, 1, 50, 0),
(959, 32, 933, 'pura_mdl1*6', 3, 0, 1, 50, 0),
(960, 32, 934, 'pura_mdl1*7', 3, 0, 1, 50, 0),
(961, 32, 935, 'pura_mdl1*8', 3, 0, 1, 50, 0),
(962, 32, 936, 'pura_mdl1*9', 3, 0, 1, 50, 0),
(963, 32, 939, 'chair_basic*2', 4, 0, 1, 50, 0),
(964, 32, 940, 'chair_basic*3', 4, 0, 1, 50, 0),
(965, 32, 941, 'chair_basic*4', 4, 0, 1, 50, 0),
(966, 32, 942, 'chair_basic*5', 4, 0, 1, 50, 0),
(967, 32, 943, 'chair_basic*6', 4, 0, 1, 50, 0),
(968, 32, 944, 'chair_basic*7', 4, 0, 1, 50, 0),
(969, 32, 946, 'chair_basic*9', 4, 0, 1, 50, 0),
(970, 32, 948, 'bed_budget*2', 4, 0, 1, 50, 0),
(971, 32, 949, 'bed_budget*3', 4, 0, 1, 50, 0),
(972, 32, 950, 'bed_budget*4', 4, 0, 1, 50, 0),
(973, 32, 951, 'bed_budget*5', 4, 0, 1, 50, 0),
(974, 32, 952, 'bed_budget*6', 4, 0, 1, 50, 0),
(975, 32, 953, 'bed_budget*7', 4, 0, 1, 50, 0),
(976, 32, 954, 'bed_budget*8', 4, 0, 1, 50, 0),
(977, 32, 955, 'bed_budget*9', 4, 0, 1, 50, 0),
(978, 32, 957, 'bed_budget_one*2', 3, 0, 1, 50, 0),
(979, 32, 958, 'bed_budget_one*3', 3, 0, 1, 50, 0),
(980, 32, 959, 'bed_budget_one*4', 3, 0, 1, 50, 0),
(981, 32, 960, 'bed_budget_one*5', 3, 0, 1, 50, 0),
(982, 32, 961, 'bed_budget_one*6', 3, 0, 1, 50, 0),
(983, 32, 962, 'bed_budget_one*7', 3, 0, 1, 50, 0),
(984, 32, 963, 'bed_budget_one*8', 3, 0, 1, 50, 0),
(985, 32, 964, 'bed_budget_one*9', 3, 0, 1, 50, 0),
(987, 65, 890, 'rope_divider', 5, 0, 1, 50, 0),
(988, 65, 846, 'habbowood_chair', 3, 0, 1, 50, 0),
(989, 65, 860, 'spotlight', 5, 0, 1, 50, 0),
(990, 65, 1672, 'habw_mirror', 3, 0, 1, 50, 0),
(991, 65, 967, 'tile_marble', 1, 0, 1, 50, 0),
(992, 65, 967, 'tile_marble', 40, 0, 50, 50, 0),
(993, 65, 968, 'tile_brown', 1, 0, 1, 50, 0),
(994, 65, 968, 'tile_brown', 40, 0, 50, 50, 0),
(995, 65, 966, 'tile_stella', 2, 0, 1, 50, 0),
(996, 65, 966, 'tile_stella', 30, 0, 50, 50, 0),
(998, 102, 437, 'queue_tile1*3', 7, 0, 1, 50, 0),
(999, 102, 437, 'queue_tile1*3', 18, 0, 3, 50, 0),
(1000, 102, 437, 'queue_tile1*3', 30, 0, 5, 50, 0),
(1001, 102, 438, 'queue_tile1*6', 7, 0, 1, 50, 0),
(1002, 102, 438, 'queue_tile1*6', 18, 0, 3, 50, 0),
(1003, 102, 438, 'queue_tile1*6', 30, 0, 5, 50, 0),
(1004, 102, 439, 'queue_tile1*4', 7, 0, 1, 50, 0),
(1005, 102, 439, 'queue_tile1*4', 18, 0, 3, 50, 0),
(1006, 102, 439, 'queue_tile1*4', 30, 0, 5, 50, 0),
(1007, 102, 440, 'queue_tile1*9', 7, 0, 1, 50, 0),
(1008, 102, 440, 'queue_tile1*9', 18, 0, 3, 50, 0),
(1009, 102, 440, 'queue_tile1*9', 30, 0, 5, 50, 0),
(1010, 102, 441, 'queue_tile1*8', 7, 0, 1, 50, 0),
(1011, 102, 441, 'queue_tile1*8', 18, 0, 3, 50, 0),
(1012, 102, 441, 'queue_tile1*8', 30, 0, 5, 50, 0),
(1013, 102, 442, 'queue_tile1*5', 7, 0, 1, 50, 0),
(1014, 102, 442, 'queue_tile1*5', 18, 0, 3, 50, 0),
(1015, 102, 442, 'queue_tile1*5', 30, 0, 5, 50, 0),
(1016, 102, 443, 'queue_tile1*7', 7, 0, 1, 50, 0),
(1017, 102, 443, 'queue_tile1*7', 18, 0, 3, 50, 0),
(1018, 102, 443, 'queue_tile1*7', 30, 0, 5, 50, 0),
(1019, 102, 444, 'queue_tile1*2', 7, 0, 1, 50, 0),
(1020, 102, 444, 'queue_tile1*2', 18, 0, 3, 50, 0),
(1021, 102, 444, 'queue_tile1*2', 30, 0, 5, 50, 0),
(1022, 102, 445, 'queue_tile1*1', 7, 0, 1, 50, 0),
(1023, 102, 445, 'queue_tile1*1', 18, 0, 3, 50, 0),
(1024, 102, 445, 'queue_tile1*1', 30, 0, 5, 50, 0),
(1025, 102, 446, 'queue_tile1*0', 7, 0, 1, 50, 0),
(1026, 102, 446, 'queue_tile1*0', 18, 0, 3, 50, 0),
(1027, 102, 446, 'queue_tile1*0', 30, 0, 5, 50, 0),
(1029, 68, 1567, 'LT_skull', 3, 0, 1, 50, 0),
(1030, 68, 1568, 'lt_stage2', 4, 0, 1, 50, 0),
(1031, 68, 1569, 'lt_lavac', 3, 0, 1, 50, 0),
(1032, 68, 1570, 'lt_gate', 6, 0, 1, 50, 0),
(1033, 68, 1573, 'lt_statue', 3, 0, 1, 50, 0),
(1034, 68, 1574, 'lt_spider', 3, 0, 1, 50, 0),
(1035, 68, 1575, 'lt_stone2', 4, 0, 1, 50, 0),
(1036, 68, 1576, 'LT_throne', 4, 0, 1, 50, 0),
(1037, 68, 1578, 'lt_patch', 3, 0, 1, 50, 0),
(1038, 68, 1579, 'lt_lava', 3, 0, 1, 50, 0),
(1039, 68, 1580, 'LT_pillar2', 3, 0, 1, 50, 0),
(1040, 68, 1581, 'lt_bughill', 5, 0, 1, 50, 0),
(1041, 68, 1584, 'LT_pillar', 4, 0, 1, 50, 0),
(1042, 68, 1588, 'lt_stone1', 4, 0, 1, 50, 0),
(1043, 68, 1585, 'lt_stage1', 3, 0, 1, 50, 0),
(1044, 68, 1785, 'lt_wall', 3, 0, 1, 50, 0),
(1045, 68, 1783, 'lt_jngl_wall', 3, 0, 1, 50, 0),
(1050, 61, 718, 'glass_shelf', 4, 0, 1, 50, 0),
(1051, 61, 719, 'glass_chair', 3, 0, 1, 50, 0),
(1052, 61, 720, 'glass_stool', 2, 0, 1, 50, 0),
(1053, 61, 721, 'glass_sofa', 4, 0, 1, 50, 0),
(1054, 61, 723, 'glass_table*2', 3, 0, 1, 50, 0),
(1056, 61, 724, 'glass_table*3', 3, 0, 1, 50, 0),
(1057, 61, 722, 'glass_table', 3, 0, 1, 50, 0),
(1058, 61, 725, 'glass_table*4', 3, 0, 1, 50, 0),
(1059, 61, 726, 'glass_table*5', 3, 0, 1, 50, 0),
(1060, 61, 727, 'glass_table*6', 3, 0, 1, 50, 0),
(1061, 61, 728, 'glass_table*7', 3, 0, 1, 50, 0),
(1062, 61, 729, 'glass_table*8', 3, 0, 1, 50, 0),
(1063, 61, 730, 'glass_table*9', 3, 0, 1, 50, 0),
(1064, 61, 731, 'glass_chair*2', 3, 0, 1, 50, 0),
(1065, 61, 732, 'glass_chair*3', 3, 0, 1, 50, 0),
(1066, 61, 733, 'glass_chair*4', 3, 0, 1, 50, 0),
(1067, 61, 734, 'glass_chair*5', 3, 0, 1, 50, 0),
(1068, 61, 735, 'glass_chair*6', 3, 0, 1, 50, 0),
(1069, 61, 736, 'glass_chair*7', 3, 0, 1, 50, 0),
(1070, 61, 737, 'glass_chair*8', 3, 0, 1, 50, 0),
(1071, 61, 738, 'glass_chair*9', 3, 0, 1, 50, 0),
(1072, 61, 739, 'glass_sofa*2', 4, 0, 1, 50, 0),
(1073, 61, 740, 'glass_sofa*3', 4, 0, 1, 50, 0),
(1074, 61, 741, 'glass_sofa*4', 4, 0, 1, 50, 0),
(1075, 61, 742, 'glass_sofa*5', 4, 0, 1, 50, 0),
(1076, 61, 743, 'glass_sofa*6', 4, 0, 1, 50, 0),
(1077, 61, 744, 'glass_sofa*7', 4, 0, 1, 50, 0),
(1078, 61, 745, 'glass_sofa*8', 4, 0, 1, 50, 0),
(1079, 61, 746, 'glass_sofa*9', 4, 0, 1, 50, 0),
(1080, 61, 747, 'glass_stool*2', 2, 0, 1, 50, 0),
(1081, 61, 748, 'glass_stool*4', 2, 0, 1, 50, 0),
(1082, 61, 749, 'glass_stool*5', 2, 0, 1, 50, 0),
(1083, 61, 750, 'glass_stool*6', 2, 0, 1, 50, 0),
(1084, 61, 751, 'glass_stool*7', 2, 0, 1, 50, 0),
(1085, 61, 752, 'glass_stool*8', 2, 0, 1, 50, 0),
(1086, 61, 753, 'glass_stool*3', 2, 0, 1, 50, 0),
(1087, 61, 754, 'glass_stool*9', 2, 0, 1, 50, 0),
(1088, 72, 829, 'grand_piano*4', 5, 0, 1, 50, 0),
(1089, 72, 826, 'grand_piano*3', 5, 0, 1, 50, 0),
(1090, 72, 827, 'grand_piano*5', 5, 0, 1, 50, 0),
(1091, 72, 828, 'grand_piano*2', 5, 0, 1, 50, 0),
(1092, 72, 830, 'grand_piano*1', 5, 0, 1, 50, 0),
(1093, 94, 248, 'rare_beehive_bulb', 10, 0, 1, 50, 0),
(1094, 94, 261, 'rare_beehive_bulb*1', 10, 0, 1, 50, 0),
(1095, 94, 262, 'rare_beehive_bulb*2', 10, 0, 1, 50, 0),
(1096, 94, 206, 'hologram', 10, 0, 1, 50, 0),
(1097, 94, 228, 'redhologram', 10, 0, 1, 50, 0),
(1098, 94, 255, 'rare_hammock', 10, 0, 1, 50, 0),
(1099, 94, 251, 'rare_elephant_statue', 10, 0, 1, 50, 0),
(1100, 94, 252, 'rare_fountain', 10, 0, 1, 50, 0),
(1101, 94, 253, 'rare_stand', 10, 0, 1, 50, 0),
(1102, 27, 254, 'rare_globe', 5, 0, 1, 50, 0),
(1103, 94, 256, 'rare_elephant_statue*1', 10, 0, 1, 50, 0),
(1104, 94, 257, 'rare_elephant_statue*2', 10, 0, 1, 50, 0),
(1105, 94, 258, 'rare_fountain*1', 10, 0, 1, 50, 0),
(1106, 94, 259, 'rare_fountain*2', 10, 0, 1, 50, 0),
(1107, 94, 260, 'rare_fountain*3', 10, 0, 1, 50, 0),
(1108, 94, 264, 'rare_parasol*1', 10, 0, 1, 50, 0),
(1109, 94, 265, 'rare_parasol*2', 10, 0, 1, 50, 0),
(1110, 94, 266, 'rare_parasol*3', 10, 0, 1, 50, 0),
(1111, 94, 312, 'rare_parasol*0', 10, 0, 1, 50, 0),
(1113, 94, 448, 'rare_snowrug', 10, 0, 1, 50, 0),
(1114, 94, 668, 'rare_moonrug', 10, 0, 1, 50, 0),
(1117, 43, 125, 'red_tv', 3, 0, 1, 50, 0),
(1118, 43, 126, 'wood_tv', 4, 0, 1, 50, 0),
(1119, 43, 154, 'tv_luxus', 5, 0, 1, 50, 0),
(1120, 43, 1655, 'post.it', 3, 0, 30, 50, 0),
(1121, 41, 1677, 'hrella_poster_3', 3, 0, 1, 50, 0),
(1122, 41, 1678, 'hrella_poster_2', 3, 0, 1, 50, 0),
(1123, 41, 1679, 'hrella_poster_1', 3, 0, 1, 50, 0),
(1124, 43, 104, 'pizza', 3, 0, 1, 50, 0),
(1125, 43, 105, 'drinks', 3, 0, 1, 50, 0),
(1127, 43, 111, 'bottle', 3, 0, 1, 50, 0),
(1128, 43, 211, 'edice', 6, 0, 1, 50, 0),
(1132, 112, 19994, 'ads_twi_fountn', 5, 0, 1, 50, 0),
(1133, 112, 19995, 'ads_twi_dvdr2', 3, 0, 1, 50, 0),
(1134, 112, 19996, 'ads_twi_roses', 4, 0, 1, 50, 0),
(1135, 112, 19997, 'ads_twi_table', 4, 0, 1, 50, 0),
(1136, 112, 19998, 'ads_twi_chair', 3, 0, 1, 50, 0),
(1137, 112, 19999, 'ads_twi_dvdr1', 3, 0, 1, 50, 0),
(1138, 112, 20000, 'ads_twi_piano', 4, 0, 1, 50, 0),
(1139, 112, 20001, 'ads_twi_tower', 4, 0, 1, 50, 0),
(1140, 112, 20002, 'ads_twi_toolbx', 3, 0, 1, 50, 0),
(1141, 112, 20003, 'ads_twi_mist', 3, 0, 1, 50, 0),
(1152, 62, 777, 'gothic_sofa*1', 4, 0, 1, 50, 0),
(1154, 62, 764, 'gothrailing', 3, 0, 1, 50, 0),
(1156, 62, 778, 'gothic_stool*1', 2, 0, 1, 50, 0),
(1157, 62, 780, 'gothic_sofa*2', 4, 0, 1, 50, 0),
(1159, 62, 763, 'gothiccandelabra', 4, 0, 1, 50, 0),
(1160, 62, 762, 'gothgate', 6, 0, 1, 50, 0),
(1161, 62, 765, 'goth_table', 5, 0, 1, 50, 0),
(1162, 62, 776, 'gothic_chair*1', 3, 0, 1, 50, 0),
(1163, 62, 779, 'gothic_chair*2', 3, 0, 1, 50, 0),
(1164, 62, 781, 'gothic_stool*2', 2, 0, 1, 50, 0),
(1165, 62, 782, 'gothic_chair*3', 3, 0, 1, 50, 0),
(1166, 62, 783, 'gothic_sofa*3', 4, 0, 1, 50, 0),
(1167, 62, 784, 'gothic_stool*3', 2, 0, 1, 50, 0),
(1168, 62, 785, 'gothic_chair*4', 3, 0, 1, 50, 0),
(1169, 62, 786, 'gothic_sofa*4', 4, 0, 1, 50, 0),
(1170, 62, 787, 'gothic_stool*4', 2, 0, 1, 50, 0),
(1171, 62, 788, 'gothic_chair*5', 4, 0, 1, 50, 0),
(1172, 62, 789, 'gothic_sofa*5', 4, 0, 1, 50, 0),
(1173, 62, 790, 'gothic_stool*5', 2, 0, 1, 50, 0),
(1174, 62, 791, 'gothic_chair*6', 3, 0, 1, 50, 0),
(1175, 62, 792, 'gothic_sofa*6', 4, 0, 1, 50, 0),
(1176, 62, 793, 'gothic_stool*6', 2, 0, 1, 50, 0),
(1177, 62, 821, 'gothic_carpet', 5, 0, 1, 50, 0),
(1178, 62, 822, 'gothic_carpet2', 6, 0, 1, 50, 0),
(1179, 62, 823, 'gothic_chair', 3, 0, 1, 50, 0),
(1180, 62, 824, 'gothic_sofa', 4, 0, 1, 50, 0),
(1181, 62, 825, 'gothic_stool', 2, 0, 1, 50, 0),
(1182, 62, 1665, 'gothicfountain', 3, 0, 1, 50, 0),
(1183, 62, 1668, 'torch', 3, 0, 1, 50, 0),
(1184, 62, 1726, 'gothicfountain2', 3, 0, 1, 50, 0),
(1186, 103, 1204, 'diner_tray_6', 3, 0, 1, 50, 0),
(1187, 103, 1205, 'diner_tray_5', 3, 0, 1, 50, 0),
(1188, 103, 1206, 'diner_tray_4', 3, 0, 1, 50, 0),
(1190, 103, 1207, 'diner_tray_3', 3, 0, 1, 50, 0),
(1191, 103, 1208, 'diner_tray_2', 3, 0, 1, 50, 0),
(1192, 103, 1209, 'diner_tray_1', 3, 0, 1, 50, 0),
(1193, 103, 1203, 'diner_tray_7', 3, 0, 1, 50, 0),
(1194, 103, 1210, 'diner_tray_0', 3, 0, 1, 50, 0),
(1195, 103, 1211, 'diner_sofa_2*1', 4, 0, 1, 50, 0),
(1196, 103, 1212, 'diner_sofa_2*2', 4, 0, 1, 50, 0),
(1197, 103, 1213, 'diner_sofa_2*3', 4, 0, 1, 50, 0),
(1198, 103, 1214, 'diner_sofa_2*4', 4, 0, 1, 50, 0),
(1199, 103, 1215, 'diner_sofa_2*5', 4, 0, 1, 50, 0),
(1200, 103, 1216, 'diner_sofa_2*6', 4, 0, 1, 50, 0),
(1201, 103, 1217, 'diner_sofa_2*7', 4, 0, 1, 50, 0),
(1202, 103, 1218, 'diner_sofa_2*8', 4, 0, 1, 50, 0),
(1203, 103, 1219, 'diner_sofa_2*9', 4, 0, 1, 50, 0),
(1204, 103, 1220, 'diner_shaker', 5, 0, 1, 50, 0),
(1205, 103, 1221, 'diner_rug', 3, 0, 1, 50, 0),
(1206, 103, 1221, 'diner_rug', 25, 0, 10, 50, 0),
(1207, 103, 1222, 'diner_gumvendor*1', 3, 0, 1, 50, 0),
(1208, 103, 1223, 'diner_gumvendor*2', 3, 0, 1, 50, 0),
(1209, 103, 1224, 'diner_gumvendor*3', 3, 0, 1, 50, 0),
(1210, 103, 1225, 'diner_gumvendor*4', 3, 0, 1, 50, 0),
(1211, 103, 1226, 'diner_gumvendor*5', 3, 0, 1, 50, 0),
(1212, 103, 1227, 'diner_gumvendor*6', 3, 0, 1, 50, 0),
(1213, 103, 1228, 'diner_gumvendor*7', 3, 0, 1, 50, 0),
(1214, 103, 1229, 'diner_gumvendor*8', 3, 0, 1, 50, 0),
(1215, 103, 1230, 'diner_gumvendor*9', 3, 0, 1, 50, 0),
(1216, 103, 1231, 'diner_cashreg*1', 3, 0, 1, 50, 0),
(1217, 103, 1234, 'diner_cashreg*4', 3, 0, 1, 50, 0),
(1218, 103, 1232, 'diner_cashreg*2', 3, 0, 1, 50, 0),
(1219, 103, 1233, 'diner_cashreg*3', 3, 0, 1, 50, 0),
(1220, 103, 1235, 'diner_cashreg*5', 3, 0, 1, 50, 0),
(1221, 103, 1236, 'diner_cashreg*6', 3, 0, 1, 50, 0),
(1222, 103, 1237, 'diner_cashreg*7', 3, 0, 1, 50, 0),
(1223, 103, 1238, 'diner_cashreg*8', 3, 0, 1, 50, 0),
(1224, 103, 1239, 'diner_cashreg*9', 3, 0, 1, 50, 0),
(1225, 103, 1240, 'diner_table_2*1', 5, 0, 1, 50, 0),
(1226, 103, 1241, 'diner_table_2*2', 5, 0, 1, 50, 0),
(1227, 103, 1242, 'diner_table_2*3', 5, 0, 1, 50, 0),
(1228, 103, 1243, 'diner_table_2*4', 5, 0, 1, 50, 0),
(1229, 103, 1244, 'diner_table_2*5', 5, 0, 1, 50, 0),
(1230, 103, 1245, 'diner_table_2*6', 5, 0, 1, 50, 0),
(1231, 103, 1246, 'diner_table_2*7', 5, 0, 1, 50, 0),
(1232, 103, 1247, 'diner_table_2*8', 5, 0, 1, 50, 0),
(1233, 103, 1248, 'diner_table_2*9', 5, 0, 1, 50, 0),
(1234, 103, 1249, 'diner_table_1*1', 3, 0, 1, 50, 0),
(1235, 103, 1250, 'diner_table_1*2', 3, 0, 1, 50, 0),
(1236, 103, 1251, 'diner_table_1*3', 3, 0, 1, 50, 0),
(1237, 103, 1252, 'diner_table_1*4', 3, 0, 1, 50, 0),
(1238, 103, 1253, 'diner_table_1*5', 3, 0, 1, 50, 0),
(1239, 103, 1254, 'diner_table_1*6', 3, 0, 1, 50, 0),
(1240, 103, 1255, 'diner_table_1*7', 3, 0, 1, 50, 0);
INSERT INTO `catalog_items_old` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`) VALUES
(1241, 103, 1256, 'diner_table_1*8', 3, 0, 1, 50, 0),
(1242, 103, 1257, 'diner_table_1*9', 3, 0, 1, 50, 0),
(1243, 103, 1258, 'diner_sofa_1*1', 4, 0, 1, 50, 0),
(1244, 103, 1259, 'diner_sofa_1*2', 4, 0, 1, 50, 0),
(1245, 103, 1260, 'diner_sofa_1*3', 4, 0, 1, 50, 0),
(1246, 103, 1261, 'diner_sofa_1*4', 4, 0, 1, 50, 0),
(1247, 103, 1262, 'diner_sofa_1*5', 4, 0, 1, 50, 0),
(1248, 103, 1263, 'diner_sofa_1*6', 4, 0, 1, 50, 0),
(1250, 103, 1264, 'diner_sofa_1*7', 4, 0, 1, 50, 0),
(1251, 103, 1265, 'diner_sofa_1*8', 4, 0, 1, 50, 0),
(1252, 103, 1266, 'diner_sofa_1*9', 4, 0, 1, 50, 0),
(1253, 103, 1267, 'diner_chair*1', 3, 0, 1, 50, 0),
(1254, 103, 1268, 'diner_chair*2', 3, 0, 1, 50, 0),
(1255, 103, 1269, 'diner_chair*3', 3, 0, 1, 50, 0),
(1256, 103, 1270, 'diner_chair*4', 3, 0, 1, 50, 0),
(1257, 103, 1271, 'diner_chair*5', 3, 0, 1, 50, 0),
(1258, 103, 1272, 'diner_chair*6', 3, 0, 1, 50, 0),
(1259, 103, 1273, 'diner_chair*7', 3, 0, 1, 50, 0),
(1260, 103, 1274, 'diner_chair*8', 3, 0, 1, 50, 0),
(1261, 103, 1275, 'diner_chair*9', 3, 0, 1, 50, 0),
(1262, 103, 1276, 'diner_bardesk_gate*1', 6, 0, 1, 50, 0),
(1263, 103, 1277, 'diner_bardesk_gate*2', 6, 0, 1, 50, 0),
(1264, 103, 1278, 'diner_bardesk_gate*3', 6, 0, 1, 50, 0),
(1265, 103, 1279, 'diner_bardesk_gate*4', 6, 0, 1, 50, 0),
(1266, 103, 1280, 'diner_bardesk_gate*5', 6, 0, 1, 50, 0),
(1267, 103, 1281, 'diner_bardesk_gate*6', 6, 0, 1, 50, 0),
(1269, 103, 1282, 'diner_bardesk_gate*7', 6, 0, 1, 50, 0),
(1270, 103, 1283, 'diner_bardesk_gate*8', 6, 0, 1, 50, 0),
(1271, 103, 1284, 'diner_bardesk_gate*9', 6, 0, 1, 50, 0),
(1272, 103, 1285, 'diner_bardesk_corner*1', 3, 0, 1, 50, 0),
(1273, 103, 1286, 'diner_bardesk_corner*2', 3, 0, 1, 50, 0),
(1274, 103, 1287, 'diner_bardesk_corner*3', 3, 0, 1, 50, 0),
(1275, 103, 1288, 'diner_bardesk_corner*4', 3, 0, 1, 50, 0),
(1276, 103, 1289, 'diner_bardesk_corner*6', 3, 0, 1, 50, 0),
(1277, 103, 1290, 'diner_bardesk_corner*7', 3, 0, 1, 50, 0),
(1278, 103, 1291, 'diner_bardesk_corner*8', 3, 0, 1, 50, 0),
(1279, 103, 1292, 'diner_bardesk_corner*9', 3, 0, 1, 50, 0),
(1280, 103, 1293, 'diner_bardesk*1', 3, 0, 1, 50, 0),
(1281, 103, 1294, 'diner_bardesk*2', 3, 0, 1, 50, 0),
(1282, 103, 1295, 'diner_bardesk*3', 3, 0, 1, 50, 0),
(1283, 103, 1296, 'diner_bardesk*4', 3, 0, 1, 50, 0),
(1284, 103, 1297, 'diner_bardesk*5', 3, 0, 1, 50, 0),
(1285, 103, 1298, 'diner_bardesk*6', 3, 0, 1, 50, 0),
(1286, 103, 1299, 'diner_bardesk*7', 3, 0, 1, 50, 0),
(1287, 103, 1300, 'diner_bardesk*8', 3, 0, 1, 50, 0),
(1288, 103, 1301, 'diner_bardesk*9', 3, 0, 1, 50, 0),
(1289, 103, 1708, 'window_diner2', 3, 0, 1, 50, 0),
(1290, 103, 1709, 'window_diner', 4, 0, 1, 50, 0),
(1291, 103, 1710, 'diner_walltable', 2, 0, 1, 50, 0),
(1292, 103, 1782, 'diner_poster', 3, 0, 1, 50, 0),
(1294, 94, 398, 'pillar*1', 10, 0, 1, 50, 0),
(1295, 94, 399, 'pillar*9', 10, 0, 1, 50, 0),
(1296, 94, 400, 'pillar*0', 10, 0, 1, 50, 0),
(1297, 94, 401, 'pillar*8', 10, 0, 1, 50, 0),
(1298, 94, 402, 'pillar*2', 10, 0, 1, 50, 0),
(1299, 94, 403, 'pillar*5', 10, 0, 1, 50, 0),
(1300, 94, 404, 'pillar*4', 10, 0, 1, 50, 0),
(1301, 94, 405, 'pillar*7', 10, 0, 1, 50, 0),
(1302, 94, 406, 'pillar*3', 10, 0, 1, 50, 0),
(1303, 94, 388, 'wooden_screen*1', 10, 0, 1, 50, 0),
(1304, 94, 389, 'wooden_screen*2', 10, 0, 1, 50, 0),
(1305, 94, 390, 'wooden_screen*7', 10, 0, 1, 50, 0),
(1306, 94, 391, 'wooden_screen*0', 10, 0, 1, 50, 0),
(1307, 94, 392, 'wooden_screen*8', 10, 0, 1, 50, 0),
(1308, 94, 393, 'wooden_screen*5', 10, 0, 1, 50, 0),
(1309, 94, 394, 'wooden_screen*9', 10, 0, 1, 50, 0),
(1310, 94, 395, 'wooden_screen*4', 10, 0, 1, 50, 0),
(1311, 94, 396, 'wooden_screen*6', 10, 0, 1, 50, 0),
(1312, 94, 397, 'wooden_screen*3', 10, 0, 1, 50, 0),
(1313, 94, 417, 'rare_icecream*1', 10, 0, 1, 50, 0),
(1314, 94, 418, 'rare_icecream*7', 10, 0, 1, 50, 0),
(1315, 94, 419, 'rare_icecream*8', 10, 0, 1, 50, 0),
(1316, 94, 420, 'rare_icecream*2', 10, 0, 1, 50, 0),
(1317, 94, 421, 'rare_icecream*6', 10, 0, 1, 50, 0),
(1318, 94, 422, 'rare_icecream*9', 10, 0, 1, 50, 0),
(1319, 94, 423, 'rare_icecream*3', 10, 0, 1, 50, 0),
(1320, 94, 424, 'rare_icecream*0', 10, 0, 1, 50, 0),
(1321, 94, 425, 'rare_icecream*4', 10, 0, 1, 50, 0),
(1322, 94, 426, 'rare_icecream*5', 10, 0, 1, 50, 0),
(1323, 95, 892, 'rare_icecream_campaign', 10, 0, 1, 50, 0),
(1324, 95, 1140, 'calippo', 10, 0, 1, 50, 0),
(1325, 94, 338, 'scifiport*0', 10, 0, 1, 50, 0),
(1326, 94, 339, 'scifiport*9', 10, 0, 1, 50, 0),
(1327, 94, 340, 'scifiport*8', 10, 0, 1, 50, 0),
(1328, 94, 341, 'scifiport*7', 10, 0, 1, 50, 0),
(1329, 94, 342, 'scifiport*6', 10, 0, 1, 50, 0),
(1330, 94, 343, 'scifiport*5', 10, 0, 1, 50, 0),
(1331, 94, 344, 'scifiport*4', 10, 0, 1, 50, 0),
(1332, 94, 345, 'scifiport*3', 10, 0, 1, 50, 0),
(1333, 94, 346, 'scifiport*2', 10, 0, 1, 50, 0),
(1334, 94, 347, 'scifiport*1', 10, 0, 1, 50, 0),
(1335, 94, 348, 'scifirocket*9', 10, 0, 1, 50, 0),
(1336, 94, 349, 'scifirocket*8', 10, 0, 1, 50, 0),
(1337, 94, 350, 'scifirocket*7', 10, 0, 1, 50, 0),
(1338, 94, 351, 'scifirocket*6', 10, 0, 1, 50, 0),
(1339, 94, 352, 'scifirocket*5', 10, 0, 1, 50, 0),
(1340, 94, 353, 'scifirocket*4', 10, 0, 1, 50, 0),
(1341, 94, 354, 'scifirocket*3', 10, 0, 1, 50, 0),
(1342, 94, 355, 'scifirocket*2', 10, 0, 1, 50, 0),
(1343, 94, 356, 'scifirocket*1', 10, 0, 1, 50, 0),
(1344, 94, 357, 'scifirocket*0', 10, 0, 1, 50, 0),
(1345, 94, 358, 'scifidoor*10', 10, 0, 1, 50, 0),
(1346, 94, 359, 'scifidoor*9', 10, 0, 1, 50, 0),
(1347, 94, 360, 'scifidoor*8', 10, 0, 1, 50, 0),
(1348, 94, 361, 'scifidoor*7', 10, 0, 1, 50, 0),
(1349, 94, 362, 'scifidoor*6', 10, 0, 1, 50, 0),
(1350, 94, 363, 'scifidoor*5', 10, 0, 1, 50, 0),
(1351, 94, 364, 'scifidoor*4', 10, 0, 1, 50, 0),
(1352, 94, 365, 'scifidoor*3', 10, 0, 1, 50, 0),
(1353, 94, 367, 'scifidoor*2', 10, 0, 1, 50, 0),
(1354, 94, 366, 'scifidoor*2', 10, 0, 1, 50, 0),
(1355, 27, 186, 'menorah', 3, 0, 1, 50, 0),
(1356, 43, 188, 'ham', 3, 0, 1, 50, 0),
(1357, 27, 189, 'turkey', 3, 0, 1, 50, 0),
(1358, 27, 191, 'house', 3, 0, 1, 50, 0),
(1359, 43, 196, 'ham2', 2, 0, 1, 50, 0),
(1360, 27, 197, 'wcandleset', 3, 0, 1, 50, 0),
(1361, 43, 205, 'habbocake', 5, 0, 1, 50, 0),
(1362, 39, 204, 'giftflowers', 4, 0, 1, 50, 0),
(1364, 8, 212, 'club_sofa', 4, 0, 1, 50, 0),
(1365, 8, 239, 'chair_plasto*14', 3, 0, 1, 50, 0),
(1366, 8, 240, 'table_plasto_4leg*14', 4, 0, 1, 50, 0),
(1367, 8, 246, 'edicehc', 5, 0, 1, 50, 0),
(1368, 8, 249, 'hcsohva', 10, 0, 1, 50, 0),
(1369, 8, 250, 'hcamme', 6, 0, 1, 50, 0),
(1370, 8, 313, 'hc_lmp', 4, 0, 1, 50, 0),
(1371, 8, 314, 'hc_tbl', 6, 0, 1, 50, 0),
(1372, 8, 315, 'hc_chr', 5, 0, 1, 50, 0),
(1373, 8, 316, 'hc_dsk', 5, 0, 1, 50, 0),
(1374, 8, 760, 'hc_crpt', 4, 0, 1, 50, 0),
(1375, 8, 761, 'hc_tv', 5, 0, 1, 50, 0),
(1376, 8, 766, 'hc_bkshlf', 6, 0, 1, 50, 0),
(1377, 8, 767, 'hc_btlr', 4, 0, 1, 50, 0),
(1378, 8, 768, 'hc_crtn', 4, 0, 1, 50, 0),
(1379, 8, 769, 'hc_djset', 5, 0, 1, 50, 0),
(1380, 8, 770, 'hc_frplc', 6, 0, 1, 50, 0),
(1381, 8, 771, 'hc_lmpst', 3, 0, 1, 50, 0),
(1382, 8, 772, 'hc_machine', 5, 0, 1, 50, 0),
(1383, 8, 773, 'hc_rllr', 7, 0, 1, 50, 0),
(1384, 8, 774, 'hc_rntgn', 3, 0, 1, 50, 0),
(1385, 8, 775, 'hc_trll', 3, 0, 1, 50, 0),
(1386, 8, 1313, 'hcc_table', 4, 0, 1, 50, 0),
(1387, 8, 1314, 'hcc_shelf', 3, 0, 1, 50, 0),
(1388, 8, 1315, 'hcc_sofa', 3, 0, 1, 50, 0),
(1389, 8, 1316, 'hcc_minibar', 5, 0, 1, 50, 0),
(1390, 8, 1317, 'hcc_chair', 3, 0, 1, 50, 0),
(1391, 8, 1321, 'hcc_stool', 2, 0, 1, 50, 0),
(1392, 8, 1322, 'hcc_sofachair', 4, 0, 1, 50, 0),
(1393, 8, 1323, 'hcc_crnr', 3, 0, 1, 50, 0),
(1394, 8, 1324, 'hcc_dvdr', 3, 0, 1, 50, 0),
(1396, 8, 1666, 'hc_wall_lamp', 3, 0, 1, 50, 0),
(1398, 36, 8, 'table_plasto_4leg', 3, 0, 1, 50, 0),
(1399, 36, 9, 'table_plasto_round', 3, 0, 1, 50, 0),
(1400, 36, 10, 'table_plasto_bigsquare', 3, 0, 1, 50, 0),
(1401, 36, 22, 'chair_plasty', 3, 0, 1, 50, 0),
(1402, 36, 23, 'chair_plasto', 3, 0, 1, 50, 0),
(1403, 36, 24, 'table_plasto_square', 3, 0, 1, 50, 0),
(1404, 36, 47, 'table_plasto_4leg*1', 3, 0, 1, 50, 0),
(1405, 36, 48, 'table_plasto_bigsquare*1', 3, 0, 1, 50, 0),
(1406, 36, 49, 'table_plasto_round*1', 3, 0, 1, 50, 0),
(1407, 36, 50, 'table_plasto_square*1', 3, 0, 1, 50, 0),
(1408, 36, 51, 'chair_plasto*1', 3, 0, 1, 50, 0),
(1409, 36, 54, 'table_plasto_4leg*2', 3, 0, 1, 50, 0),
(1410, 36, 55, 'table_plasto_bigsquare*2', 3, 0, 1, 50, 0),
(1411, 36, 56, 'table_plasto_round*2', 3, 0, 1, 50, 0),
(1412, 36, 57, 'table_plasto_square*2', 3, 0, 1, 50, 0),
(1413, 36, 58, 'chair_plasto*2', 3, 0, 1, 50, 0),
(1414, 36, 61, 'table_plasto_4leg*3', 3, 0, 1, 50, 0),
(1415, 36, 62, 'table_plasto_bigsquare*3', 3, 0, 1, 50, 0),
(1416, 36, 63, 'table_plasto_round*3', 3, 0, 1, 50, 0),
(1417, 36, 64, 'table_plasto_square*3', 3, 0, 1, 50, 0),
(1418, 36, 65, 'chair_plasto*3', 3, 0, 1, 50, 0),
(1419, 36, 68, 'table_plasto_4leg*4', 3, 0, 1, 50, 0),
(1420, 36, 71, 'table_plasto_square*4', 3, 0, 1, 50, 0),
(1421, 36, 72, 'chair_plasto*4', 3, 0, 1, 50, 0),
(1422, 36, 78, 'table_plasto_4leg*5', 3, 0, 1, 50, 0),
(1423, 36, 79, 'table_plasto_bigsquare*5', 3, 0, 1, 50, 0),
(1424, 36, 80, 'table_plasto_round*5', 3, 0, 1, 50, 0),
(1425, 36, 81, 'table_plasto_square*5', 3, 0, 1, 50, 0),
(1426, 36, 82, 'chair_plasto*5', 3, 0, 1, 50, 0),
(1427, 36, 83, 'table_plasto_4leg*6', 3, 0, 1, 50, 0),
(1428, 36, 84, 'table_plasto_bigsquare*6', 3, 0, 1, 50, 0),
(1429, 36, 85, 'table_plasto_round*6', 3, 0, 1, 50, 0),
(1430, 36, 86, 'table_plasto_square*6', 3, 0, 1, 50, 0),
(1431, 36, 87, 'chair_plasto*6', 3, 0, 1, 50, 0),
(1432, 36, 88, 'table_plasto_4leg*7', 3, 0, 1, 50, 0),
(1433, 36, 89, 'table_plasto_bigsquare*7', 3, 0, 1, 50, 0),
(1434, 36, 90, 'table_plasto_round*7', 3, 0, 1, 50, 0),
(1435, 36, 91, 'table_plasto_square*7', 3, 0, 1, 50, 0),
(1436, 36, 92, 'chair_plasto*7', 3, 0, 1, 50, 0),
(1437, 36, 93, 'table_plasto_4leg*8', 3, 0, 1, 50, 0),
(1438, 36, 94, 'table_plasto_bigsquare*8', 3, 0, 1, 50, 0),
(1439, 36, 95, 'table_plasto_round*8', 3, 0, 1, 50, 0),
(1440, 36, 96, 'table_plasto_square*8', 3, 0, 1, 50, 0),
(1441, 36, 97, 'chair_plasto*8', 3, 0, 1, 50, 0),
(1442, 36, 98, 'table_plasto_4leg*9', 3, 0, 1, 50, 0),
(1443, 36, 99, 'table_plasto_bigsquare*9', 3, 0, 1, 50, 0),
(1444, 36, 100, 'table_plasto_round*9', 3, 0, 1, 50, 0),
(1445, 36, 101, 'chair_plasto*9', 3, 0, 1, 50, 0),
(1446, 36, 233, 'chair_plasto*10', 3, 0, 1, 50, 0),
(1447, 36, 234, 'chair_plasto*11', 3, 0, 1, 50, 0),
(1448, 36, 237, 'chair_plasto*12', 3, 0, 1, 50, 0),
(1449, 36, 238, 'chair_plasto*13', 3, 0, 1, 50, 0),
(1450, 36, 276, 'table_plasto_4leg*10', 3, 0, 1, 50, 0),
(1451, 36, 277, 'table_plasto_4leg*15', 3, 0, 1, 50, 0),
(1452, 36, 278, 'table_plasto_bigsquare*14', 3, 0, 1, 50, 0),
(1453, 36, 279, 'table_plasto_bigsquare*15', 3, 0, 1, 50, 0),
(1454, 36, 280, 'table_plasto_round*14', 3, 0, 1, 50, 0),
(1455, 36, 281, 'table_plasto_round*15', 3, 0, 1, 50, 0),
(1456, 36, 282, 'table_plasto_square*14', 3, 0, 1, 50, 0),
(1457, 36, 283, 'table_plasto_square*15', 3, 0, 1, 50, 0),
(1458, 36, 284, 'chair_plasto*15', 3, 0, 1, 50, 0),
(1459, 36, 290, 'chair_plasto*16', 3, 0, 1, 50, 0),
(1460, 36, 291, 'table_plasto_4leg*16', 3, 0, 1, 50, 0),
(1462, 40, 17, 'doormat_love', 1, 0, 1, 50, 0),
(1463, 40, 18, 'doormat_plain', 3, 0, 1, 50, 0),
(1464, 40, 53, 'doormat_plain*1', 1, 0, 1, 50, 0),
(1465, 40, 59, 'doormat_plain*2', 1, 0, 1, 50, 0),
(1466, 40, 67, 'doormat_plain*3', 1, 0, 1, 50, 0),
(1467, 40, 74, 'doormat_plain*4', 1, 0, 1, 50, 0),
(1468, 40, 75, 'doormat_plain*6', 3, 0, 1, 50, 0),
(1469, 40, 76, 'doormat_plain*5', 1, 0, 1, 50, 0),
(1471, 95, 27, 'bed_trad_one', 10, 0, 1, 50, 0),
(1472, 95, 28, 'bed_trad', 10, 0, 1, 50, 0),
(1473, 35, 35, 'shelves_armas', 4, 0, 1, 50, 0),
(1474, 32, 33, 'bed_budget_one', 3, 0, 1, 50, 0),
(1475, 32, 34, 'bed_budget', 4, 0, 1, 50, 0),
(1476, 32, 139, 'bed_budgetb_one', 3, 0, 1, 50, 0),
(1477, 32, 140, 'bed_budgetb', 4, 0, 1, 50, 0),
(1478, 32, 947, 'bed_budget*1', 4, 0, 1, 50, 0),
(1479, 32, 956, 'bed_budget_one*1', 3, 0, 1, 50, 0),
(1482, 36, 103, 'chair_plasty*1', 3, 0, 1, 50, 0),
(1483, 36, 106, 'chair_plasty*2', 3, 0, 1, 50, 0),
(1484, 36, 107, 'chair_plasty*3', 3, 0, 1, 50, 0),
(1485, 36, 108, 'chair_plasty*4', 3, 0, 1, 50, 0),
(1486, 36, 128, 'chair_plasty*5', 3, 0, 1, 50, 0),
(1487, 36, 132, 'chair_plasty*6', 3, 0, 1, 50, 0),
(1488, 36, 285, 'chair_plasty*7', 3, 0, 1, 50, 0),
(1489, 36, 286, 'chair_plasty*8', 3, 0, 1, 50, 0),
(1490, 36, 287, 'chair_plasty*9', 3, 0, 1, 50, 0),
(1491, 36, 288, 'chair_plasty*10', 3, 0, 1, 50, 0),
(1492, 36, 289, 'chair_plasty*11', 3, 0, 1, 50, 0),
(1496, 35, 217, 'divider_arm1', 3, 0, 1, 50, 0),
(1497, 35, 218, 'divider_arm2', 3, 0, 1, 50, 0),
(1498, 35, 219, 'divider_arm3', 6, 0, 1, 50, 0),
(1499, 94, 213, 'a0 prize1', 10, 0, 1, 50, 0),
(1500, 94, 214, 'a0 prize2', 10, 0, 1, 50, 0),
(1501, 94, 215, 'a0 prize3', 10, 0, 1, 50, 0),
(1502, 55, 220, 'divider_nor1', 3, 0, 1, 50, 0),
(1503, 55, 222, 'divider_nor2', 3, 0, 1, 50, 0),
(1505, 55, 224, 'divider_nor3', 6, 0, 1, 50, 0),
(1506, 55, 462, 'divider_nor4*4', 3, 0, 1, 50, 0),
(1507, 55, 510, 'divider_nor1*2', 3, 0, 1, 50, 0),
(1508, 55, 511, 'divider_nor1*3', 3, 0, 1, 50, 0),
(1509, 55, 512, 'divider_nor1*4', 3, 0, 1, 50, 0),
(1510, 55, 513, 'divider_nor1*5', 3, 0, 1, 50, 0),
(1511, 55, 514, 'divider_nor1*6', 3, 0, 1, 50, 0),
(1512, 55, 515, 'divider_nor1*7', 3, 0, 1, 50, 0),
(1513, 55, 516, 'divider_nor1*8', 3, 0, 1, 50, 0),
(1514, 55, 517, 'divider_nor1*8', 3, 0, 1, 50, 0),
(1515, 55, 641, 'divider_nor3*2', 6, 0, 1, 50, 0),
(1516, 55, 642, 'divider_nor3*3', 6, 0, 1, 50, 0),
(1517, 55, 643, 'divider_nor3*4', 3, 0, 1, 50, 0),
(1518, 55, 644, 'divider_nor3*5', 6, 0, 1, 50, 0),
(1519, 55, 645, 'divider_nor3*6', 6, 0, 1, 50, 0),
(1520, 55, 646, 'divider_nor3*7', 6, 0, 1, 50, 0),
(1521, 55, 647, 'divider_nor3*8', 6, 0, 1, 50, 0),
(1522, 55, 648, 'divider_nor3*9', 6, 0, 1, 50, 0),
(1523, 55, 649, 'divider_nor2*2', 3, 0, 1, 50, 0),
(1524, 55, 650, 'divider_nor2*3', 3, 0, 1, 50, 0),
(1525, 55, 651, 'divider_nor2*4', 3, 0, 1, 50, 0),
(1526, 55, 652, 'divider_nor2*5', 3, 0, 1, 50, 0),
(1527, 55, 653, 'divider_nor2*6', 3, 0, 1, 50, 0),
(1528, 55, 654, 'divider_nor2*7', 3, 0, 1, 50, 0),
(1529, 55, 655, 'divider_nor2*8', 3, 0, 1, 50, 0),
(1530, 55, 656, 'divider_nor2*9', 3, 0, 1, 50, 0),
(1531, 55, 684, 'divider_nor4*2', 3, 0, 1, 50, 0),
(1532, 55, 685, 'divider_nor4*3', 3, 0, 1, 50, 0),
(1533, 55, 686, 'divider_nor4*5', 3, 0, 1, 50, 0),
(1534, 55, 687, 'divider_nor4*6', 3, 0, 1, 50, 0),
(1535, 55, 688, 'divider_nor4*7', 3, 0, 1, 50, 0),
(1536, 55, 689, 'divider_nor4*8', 3, 0, 1, 50, 0),
(1537, 55, 690, 'divider_nor4*9', 3, 0, 1, 50, 0),
(1538, 55, 691, 'divider_nor5*2', 3, 0, 1, 50, 0),
(1539, 55, 692, 'divider_nor5*3', 3, 0, 1, 50, 0),
(1540, 55, 693, 'divider_nor5*4', 3, 0, 1, 50, 0),
(1541, 55, 694, 'divider_nor5*5', 3, 0, 1, 50, 0),
(1542, 55, 695, 'divider_nor5*7', 3, 0, 1, 50, 0),
(1543, 55, 696, 'divider_nor5*8', 3, 0, 1, 50, 0),
(1544, 55, 697, 'divider_nor5*9', 3, 0, 1, 50, 0),
(1545, 55, 698, 'divider_nor5', 3, 0, 1, 50, 0),
(1546, 55, 699, 'divider_nor4', 3, 0, 1, 50, 0),
(1547, 94, 226, 'typingmachine', 10, 0, 1, 50, 0),
(1548, 27, 230, 'joulutahti', 10, 0, 1, 50, 0),
(1549, 94, 231, 'hyacinth1', 10, 0, 1, 50, 0),
(1550, 94, 232, 'hyacinth2', 10, 0, 1, 50, 0),
(1551, 30, 235, 'bardeskcorner_polyfon*12', 3, 0, 1, 50, 0),
(1552, 20, 236, 'bardeskcorner_polyfon*13', 3, 0, 1, 50, 0),
(1553, 8, 241, 'mocchamaster', 5, 0, 1, 50, 0),
(1554, 94, 247, 'rare_daffodil_rug', 10000, 5000, 3, 50, 0),
(1555, 27, 267, 'tree1', 3, 0, 1, 50, 0),
(1557, 27, 269, 'wcandle', 3, 0, 1, 50, 0),
(1558, 27, 272, 'house2', 3, 0, 1, 50, 0),
(1559, 94, 275, 'md_limukaappi', 10, 0, 1, 50, 0),
(1561, 8, 294, 'doorD', 6, 0, 1, 50, 0),
(1562, 94, 368, 'pillow*5', 10, 0, 1, 50, 0),
(1563, 94, 369, 'pillow*8', 10, 0, 1, 50, 0),
(1564, 94, 370, 'pillow*0', 10, 0, 1, 50, 0),
(1565, 94, 371, 'pillow*1', 10, 0, 1, 50, 0),
(1566, 94, 372, 'pillow*2', 10, 0, 1, 50, 0),
(1567, 94, 373, 'pillow*7', 10, 0, 1, 50, 0),
(1568, 94, 374, 'pillow*9', 10, 0, 1, 50, 0),
(1569, 94, 375, 'pillow*4', 10, 0, 1, 50, 0),
(1570, 94, 376, 'pillow*6', 10, 0, 1, 50, 0),
(1571, 94, 377, 'pillow*3', 10, 0, 1, 50, 0),
(1572, 95, 1410, 'ads_ob_pillow', 10, 0, 1, 50, 0),
(1573, 94, 379, 'marquee*2', 10, 0, 1, 50, 0),
(1574, 94, 407, 'rare_dragonlamp*4', 10, 0, 1, 50, 0),
(1575, 94, 408, 'rare_dragonlamp*0', 10, 0, 1, 50, 0),
(1576, 94, 409, 'rare_dragonlamp*5', 10, 0, 1, 50, 0),
(1577, 94, 410, 'rare_dragonlamp*2', 10, 0, 1, 50, 0),
(1578, 94, 411, 'rare_dragonlamp*8', 10, 0, 1, 50, 0),
(1579, 94, 412, 'rare_dragonlamp*9', 10, 0, 1, 50, 0),
(1580, 94, 413, 'rare_dragonlamp*7', 10, 0, 1, 50, 0),
(1581, 94, 414, 'rare_dragonlamp*6', 10, 0, 1, 50, 0),
(1582, 94, 415, 'rare_dragonlamp*1', 10, 0, 1, 50, 0),
(1583, 94, 416, 'rare_dragonlamp*3', 10, 0, 1, 50, 0),
(1584, 94, 430, 'rare_fan*3', 10, 0, 1, 50, 0),
(1585, 58, 1411, 'lostc_merdragon', 6, 0, 1, 50, 0),
(1587, 94, 378, 'marquee*1', 10, 0, 1, 50, 0),
(1588, 94, 380, 'marquee*7', 10, 0, 1, 50, 0),
(1589, 94, 382, 'marquee*8', 10, 0, 1, 50, 0),
(1590, 94, 383, 'marquee*9', 10, 0, 1, 50, 0),
(1591, 94, 384, 'marquee*5', 10, 0, 1, 50, 0),
(1592, 94, 385, 'marquee*4', 10, 0, 1, 50, 0),
(1593, 94, 386, 'marquee*6', 10, 0, 1, 50, 0),
(1594, 94, 387, 'marquee*3', 10, 0, 1, 50, 0),
(1595, 94, 381, 'marquee*10', 10, 0, 1, 50, 0),
(1596, 94, 427, 'rare_fan*7', 10, 0, 1, 50, 0),
(1598, 94, 428, 'rare_fan*6', 10, 0, 1, 50, 0),
(1599, 94, 429, 'rare_fan*9', 10, 0, 1, 50, 0),
(1600, 94, 430, 'rare_fan*3', 10, 0, 1, 50, 0),
(1601, 94, 431, 'rare_fan*0', 10, 0, 1, 50, 0),
(1602, 94, 432, 'rare_fan*4', 10, 0, 1, 50, 0),
(1603, 94, 433, 'rare_fan*5', 10, 0, 1, 50, 0),
(1604, 94, 434, 'rare_fan*1', 10, 0, 1, 50, 0),
(1605, 94, 435, 'rare_fan*8', 10, 0, 1, 50, 0),
(1606, 94, 436, 'rare_fan*2', 10, 0, 1, 50, 0),
(1607, 95, 1589, 'ads_calip_fan', 10, 0, 1, 50, 0),
(1608, 62, 1667, 'industrialfan', 4, 0, 1, 50, 0),
(1609, 57, 449, 'cn_lamp', 5, 0, 1, 50, 0),
(1610, 57, 450, 'cn_sofa', 4, 0, 1, 50, 0),
(1611, 95, 1302, 'ads_dave_cns', 10, 0, 1, 50, 0),
(1612, 94, 468, 'rubberchair*1', 10, 0, 1, 50, 0),
(1613, 94, 469, 'rubberchair*2', 10, 0, 1, 50, 0),
(1614, 94, 470, 'rubberchair*3', 10, 0, 1, 50, 0),
(1615, 94, 471, 'rubberchair*4', 10, 0, 1, 50, 0),
(1616, 94, 472, 'rubberchair*5', 10, 0, 1, 50, 0),
(1617, 94, 473, 'rubberchair*6', 10, 0, 1, 50, 0),
(1618, 94, 477, 'rubberchair*7', 10, 0, 1, 50, 0),
(1619, 94, 478, 'rubberchair*8', 10, 0, 1, 50, 0),
(1620, 94, 463, 'traffic_light*1', 10, 0, 1, 50, 0),
(1621, 94, 464, 'traffic_light*2', 10, 0, 1, 50, 0),
(1622, 94, 465, 'traffic_light*3', 10, 0, 1, 50, 0),
(1623, 94, 466, 'traffic_light*4', 10, 0, 1, 50, 0),
(1624, 94, 467, 'traffic_light*6', 10, 0, 1, 50, 0),
(1625, 94, 683, 'traffic_light*5', 10, 0, 1, 50, 0),
(1626, 94, 474, 'barrier*1', 10, 0, 1, 50, 0),
(1627, 94, 475, 'barrier*2', 10, 0, 1, 50, 0),
(1628, 94, 476, 'barrier*3', 10, 0, 1, 50, 0),
(1629, 94, 667, 'sandrug', 10, 0, 1, 50, 0),
(1630, 94, 671, 'sleepingbag*1', 10, 0, 1, 50, 0),
(1631, 94, 672, 'sleepingbag*2', 10, 0, 1, 50, 0),
(1632, 94, 673, 'sleepingbag*3', 10, 0, 1, 50, 0),
(1633, 94, 674, 'sleepingbag*4', 10, 0, 1, 50, 0),
(1634, 94, 676, 'sleepingbag*7', 10, 0, 1, 50, 0),
(1635, 94, 677, 'sleepingbag*9', 10, 0, 1, 50, 0),
(1636, 94, 678, 'sleepingbag*5', 10, 0, 1, 50, 0),
(1637, 94, 679, 'sleepingbag*10', 10, 0, 1, 50, 0),
(1638, 94, 680, 'sleepingbag*6', 10, 0, 1, 50, 0),
(1639, 94, 681, 'sleepingbag*8', 10, 0, 1, 50, 0),
(1640, 13, 755, 'CF_10_coin_gold', 10, 0, 1, 50, 0),
(1641, 13, 756, 'CF_1_coin_bronze', 1, 0, 1, 50, 0),
(1642, 13, 757, 'CF_20_moneybag', 20, 0, 1, 50, 0),
(1643, 12, 758, 'CF_50_goldbar', 50, 0, 1, 50, 0),
(1644, 13, 759, 'CF_5_coin_silver', 5, 0, 1, 50, 0),
(1645, 65, 831, 'theatre_seat', 5, 0, 1, 50, 0),
(1646, 32, 938, 'chair_basic*1', 3, 0, 1, 50, 0),
(1647, 32, 945, 'chair_basic*8', 3, 0, 1, 50, 0),
(1648, 40, 1009, 'carpet_soft_tut', 2, 0, 1, 50, 0),
(1649, 66, 1025, 'hal_cauldron', 5, 0, 1, 50, 0),
(1650, 66, 1026, 'hal_grave', 4, 0, 1, 50, 0),
(1651, 66, 1318, 'det_divider', 3, 0, 1, 50, 0),
(1652, 66, 1320, 'det_body', 5, 0, 1, 50, 0),
(1653, 66, 1719, 'det_bhole', 2, 0, 1, 50, 0),
(1654, 5, 1719, 'det_bhole', 5, 0, 3, 50, 0),
(1655, 121, 794, 'sound_machine', 5, 0, 1, 50, 0),
(1656, 121, 859, 'sound_machine*1', 5, 0, 1, 50, 0),
(1657, 121, 861, 'sound_machine*2', 5, 0, 1, 50, 0),
(1658, 121, 862, 'sound_machine*3', 5, 0, 1, 50, 0),
(1659, 121, 863, 'sound_machine*4', 5, 0, 1, 50, 0),
(1660, 121, 864, 'sound_machine*5', 5, 0, 1, 50, 0),
(1661, 121, 865, 'sound_machine*6', 5, 0, 1, 50, 0),
(1662, 121, 866, 'sound_machine*7', 5, 0, 1, 50, 0),
(1663, 121, 990, 'sound_machine_pro', 5, 0, 1, 50, 0),
(1664, 122, 850, 'sound_set_1', 3, 0, 1, 50, 0),
(1665, 122, 851, 'sound_set_2', 3, 0, 1, 50, 0),
(1666, 122, 852, 'sound_set_3', 3, 0, 1, 50, 0),
(1667, 122, 853, 'sound_set_4', 3, 0, 1, 50, 0),
(1668, 122, 854, 'sound_set_5', 3, 0, 1, 50, 0),
(1669, 122, 855, 'sound_set_6', 3, 0, 1, 50, 0),
(1670, 122, 856, 'sound_set_7', 3, 0, 1, 50, 0),
(1671, 122, 857, 'sound_set_8', 3, 0, 1, 50, 0),
(1672, 122, 858, 'sound_set_9', 3, 0, 1, 50, 0),
(1673, 122, 872, 'sound_set_27', 3, 0, 1, 50, 0),
(1674, 122, 873, 'sound_set_26', 3, 0, 1, 50, 0),
(1675, 122, 871, 'sound_set_28', 3, 0, 1, 50, 0),
(1676, 122, 874, 'sound_set_25', 3, 0, 1, 50, 0),
(1677, 122, 875, 'sound_set_24', 3, 0, 1, 50, 0),
(1678, 122, 876, 'sound_set_23', 3, 0, 1, 50, 0),
(1679, 122, 878, 'sound_set_22', 3, 0, 1, 50, 0),
(1680, 122, 877, 'sound_set_22', 3, 0, 1, 50, 0),
(1681, 122, 879, 'sound_set_20', 3, 0, 1, 50, 0),
(1682, 122, 880, 'sound_set_19', 3, 0, 1, 50, 0),
(1683, 122, 881, 'sound_set_18', 3, 0, 1, 50, 0),
(1684, 122, 882, 'sound_set_17', 3, 0, 1, 50, 0),
(1685, 122, 883, 'sound_set_16', 3, 0, 1, 50, 0),
(1686, 122, 884, 'sound_set_15', 3, 0, 1, 50, 0),
(1687, 122, 885, 'sound_set_14', 3, 0, 1, 50, 0),
(1688, 122, 886, 'sound_set_13', 3, 0, 1, 50, 0),
(1689, 122, 887, 'sound_set_12', 3, 0, 1, 50, 0),
(1690, 122, 888, 'sound_set_11', 3, 0, 1, 50, 0),
(1691, 122, 889, 'sound_set_10', 3, 0, 1, 50, 0),
(1692, 122, 982, 'sound_set_36', 3, 0, 1, 50, 0),
(1693, 122, 983, 'sound_set_35', 3, 0, 1, 50, 0),
(1694, 122, 984, 'sound_set_34', 3, 0, 1, 50, 0),
(1695, 122, 985, 'sound_set_33', 3, 0, 1, 50, 0),
(1696, 122, 986, 'sound_set_32', 3, 0, 1, 50, 0),
(1697, 122, 987, 'sound_set_31', 3, 0, 1, 50, 0),
(1698, 122, 988, 'sound_set_30', 3, 0, 1, 50, 0),
(1699, 122, 989, 'sound_set_29', 3, 0, 1, 50, 0),
(1700, 122, 1002, 'sound_set_37', 3, 0, 1, 50, 0),
(1701, 122, 1010, 'sound_set_44', 3, 0, 1, 50, 0),
(1702, 122, 1011, 'sound_set_43', 3, 0, 1, 50, 0),
(1704, 122, 1013, 'sound_set_41', 3, 0, 1, 50, 0),
(1705, 122, 1014, 'sound_set_40', 3, 0, 1, 50, 0),
(1706, 122, 1015, 'sound_set_39', 3, 0, 1, 50, 0),
(1707, 122, 1016, 'sound_set_38', 3, 0, 1, 50, 0),
(1708, 122, 1027, 'sound_set_52', 3, 0, 1, 50, 0),
(1709, 122, 1028, 'sound_set_51', 3, 0, 1, 50, 0),
(1710, 122, 1029, 'sound_set_50', 3, 0, 1, 50, 0),
(1711, 122, 1030, 'sound_set_49', 3, 0, 1, 50, 0),
(1712, 122, 1031, 'sound_set_48', 3, 0, 1, 50, 0),
(1713, 122, 1032, 'sound_set_47', 3, 0, 1, 50, 0),
(1714, 122, 1033, 'sound_set_46', 3, 0, 1, 50, 0),
(1715, 122, 1034, 'sound_set_45', 3, 0, 1, 50, 0),
(1716, 122, 1041, 'sound_set_54', 3, 0, 1, 50, 0),
(1717, 122, 1042, 'sound_set_53', 3, 0, 1, 50, 0),
(1718, 122, 1056, 'sound_set_59', 3, 0, 1, 50, 0),
(1719, 122, 1057, 'sound_set_58', 3, 0, 1, 50, 0),
(1720, 122, 1058, 'sound_set_57', 3, 0, 1, 50, 0),
(1721, 122, 1059, 'sound_set_56', 3, 0, 1, 50, 0),
(1722, 122, 1060, 'sound_set_55', 3, 0, 1, 50, 0),
(1723, 122, 1101, 'sound_set_61', 3, 0, 1, 50, 0),
(1724, 122, 1102, 'sound_set_60', 3, 0, 1, 50, 0),
(1725, 122, 1136, 'sound_set_64', 3, 0, 1, 50, 0),
(1726, 122, 1137, 'sound_set_63', 3, 0, 1, 50, 0),
(1727, 122, 1138, 'sound_set_62', 3, 0, 1, 50, 0),
(1728, 122, 1173, 'sound_set_70', 3, 0, 1, 50, 0),
(1729, 122, 1174, 'sound_set_69', 3, 0, 1, 50, 0),
(1730, 122, 1175, 'sound_set_68', 3, 0, 1, 50, 0),
(1731, 122, 1176, 'sound_set_67', 3, 0, 1, 50, 0),
(1732, 122, 1177, 'sound_set_66', 3, 0, 1, 50, 0),
(1733, 122, 1178, 'sound_set_65', 3, 0, 1, 50, 0),
(1734, 122, 1382, 'sound_set_71', 3, 0, 1, 50, 0),
(1735, 122, 1551, 'sound_set_72', 3, 0, 1, 50, 0),
(1736, 95, 868, 'rclr_sofa', 10, 0, 1, 50, 0),
(1737, 72, 867, 'rom_lamp', 3, 0, 1, 50, 0),
(1738, 95, 869, 'rclr_garden', 10, 0, 1, 50, 0),
(1739, 95, 870, 'rclr_chair', 10, 0, 1, 50, 0),
(1740, 95, 991, 'rare_mnstr', 10, 0, 1, 50, 0),
(1742, 94, 993, 'one_way_door*3', 10, 0, 1, 50, 0),
(1743, 94, 994, 'one_way_door*4', 10, 0, 1, 50, 0),
(1744, 94, 995, 'one_way_door*5', 10, 0, 1, 50, 0),
(1745, 94, 996, 'one_way_door*6', 10, 0, 1, 50, 0),
(1746, 94, 997, 'one_way_door*7', 10, 0, 1, 50, 0),
(1747, 94, 998, 'one_way_door*8', 10, 0, 1, 50, 0),
(1748, 94, 999, 'one_way_door*9', 10, 0, 1, 50, 0),
(1750, 94, 992, 'one_way_door*2', 10, 0, 1, 50, 0),
(1752, 121, 1008, 'jukebox*1', 5, 0, 1, 50, 0),
(1753, 66, 1023, 'habboween_crypt', 6, 0, 1, 50, 0),
(1754, 66, 1024, 'habboween_grass', 5, 0, 1, 50, 0),
(1755, 39, 1044, 'plant_mazegate_snow', 3, 0, 1, 50, 0),
(1756, 39, 1045, 'plant_maze_snow', 3, 0, 1, 50, 0),
(1758, 123, 1061, 'noob_table*1', 0, 100, 1, 50, 0),
(1759, 123, 1062, 'noob_table*2', 0, 100, 1, 50, 0),
(1760, 123, 1063, 'noob_table*3', 0, 100, 1, 50, 0),
(1762, 123, 1064, 'noob_table*4', 0, 100, 1, 50, 0),
(1763, 123, 1065, 'noob_table*5', 0, 100, 1, 50, 0),
(1764, 123, 1066, 'noob_table*6', 0, 100, 1, 50, 0),
(1765, 123, 1067, 'noob_stool*1', 0, 100, 1, 50, 0),
(1766, 123, 1068, 'noob_stool*2', 0, 100, 1, 50, 0),
(1767, 123, 1069, 'noob_stool*3', 0, 100, 1, 50, 0),
(1768, 123, 1070, 'noob_stool*4', 0, 100, 1, 50, 0),
(1769, 123, 1071, 'noob_stool*5', 0, 100, 1, 50, 0),
(1770, 123, 1072, 'noob_stool*6', 0, 100, 1, 50, 0),
(1771, 123, 1073, 'noob_rug*1', 0, 100, 1, 50, 0),
(1772, 123, 1074, 'noob_rug*2', 0, 100, 1, 50, 0),
(1773, 123, 1075, 'noob_rug*3', 0, 100, 1, 50, 0),
(1774, 123, 1076, 'noob_rug*4', 0, 100, 1, 50, 0),
(1775, 123, 1077, 'noob_rug*5', 0, 100, 1, 50, 0),
(1776, 123, 1078, 'noob_rug*6', 0, 100, 1, 50, 0),
(1777, 123, 1079, 'noob_lamp*1', 0, 100, 1, 50, 0),
(1778, 123, 1080, 'noob_lamp*2', 0, 100, 1, 50, 0),
(1779, 123, 1081, 'noob_lamp*3', 0, 100, 1, 50, 0),
(1780, 123, 1082, 'noob_lamp*4', 0, 100, 1, 50, 0),
(1781, 123, 1083, 'noob_lamp*5', 0, 100, 1, 50, 0),
(1782, 123, 1084, 'noob_lamp*6', 0, 100, 1, 50, 0),
(1783, 123, 1085, 'noob_chair*1', 0, 100, 1, 50, 0),
(1784, 123, 1086, 'noob_chair*2', 0, 100, 1, 50, 0),
(1785, 123, 1087, 'noob_chair*3', 0, 100, 1, 50, 0),
(1786, 123, 1088, 'noob_chair*4', 0, 100, 1, 50, 0),
(1787, 123, 1089, 'noob_chair*5', 0, 100, 1, 50, 0),
(1788, 123, 1090, 'noob_chair*6', 0, 100, 1, 50, 0),
(1795, 123, 1185, 'noob_plant', 0, 100, 1, 50, 0),
(1808, 75, 1107, 'sand_cstl_wall', 5, 0, 1, 50, 0),
(1809, 75, 1108, 'sand_cstl_twr', 5, 0, 1, 50, 0),
(1810, 75, 1109, 'sand_cstl_gate', 5, 0, 1, 50, 0),
(1811, 126, 1156, 'tiki_waterfall', 5, 0, 1, 50, 0),
(1812, 126, 1157, 'tiki_tray4', 3, 0, 1, 50, 0),
(1813, 126, 1158, 'tiki_tray3', 3, 0, 1, 50, 0),
(1815, 126, 1160, 'tiki_tray1', 3, 0, 1, 50, 0),
(1816, 126, 1159, 'tiki_tray2', 3, 0, 1, 50, 0),
(1817, 126, 1161, 'tiki_tray0', 3, 0, 1, 50, 0),
(1818, 126, 1162, 'tiki_toucan', 4, 0, 1, 50, 0),
(1819, 126, 1163, 'tiki_torch', 3, 0, 1, 50, 0),
(1820, 126, 1164, 'tiki_statue', 5, 0, 1, 50, 0),
(1821, 126, 1165, 'tiki_sand', 5, 0, 1, 50, 0),
(1822, 126, 1165, 'tiki_sand', 45, 0, 10, 50, 0),
(1823, 126, 1166, 'tiki_parasol', 4, 0, 1, 50, 0),
(1824, 126, 1167, 'tiki_junglerug', 5, 0, 1, 50, 0),
(1825, 126, 1167, 'tiki_junglerug', 45, 0, 10, 50, 0),
(1826, 126, 1168, 'tiki_corner', 3, 0, 1, 50, 0),
(1827, 126, 1169, 'tiki_bflies', 3, 0, 1, 50, 0),
(1828, 126, 1170, 'tiki_bench', 3, 0, 1, 50, 0),
(1829, 126, 1171, 'tiki_bardesk', 3, 0, 1, 50, 0),
(1830, 126, 1690, 'tiki_wallplnt', 4, 0, 1, 50, 0),
(1831, 126, 1691, 'tiki_surfboard', 3, 0, 1, 50, 0),
(1832, 76, 1103, 'fortune', 5, 0, 1, 50, 0),
(1833, 95, 1104, 'sw_table', 10, 0, 1, 50, 0),
(1834, 95, 1105, 'sw_raven', 10, 0, 1, 50, 0),
(1836, 95, 1106, 'sw_chest', 10, 0, 1, 50, 0),
(1838, 95, 1113, 'rclr_lamp', 10, 0, 1, 50, 0),
(1839, 95, 1117, 'md_rug', 10, 0, 1, 50, 0),
(1840, 95, 1116, 'nouvelle_trax', 10, 0, 1, 50, 0),
(1841, 95, 1139, 'jukebox_ptv*1', 10, 0, 1, 50, 0),
(1842, 121, 1141, 'traxsilver', 5, 0, 1, 50, 0),
(1843, 121, 1142, 'traxgold', 5, 0, 1, 50, 0),
(1844, 121, 1143, 'traxbronze', 5, 0, 1, 50, 0),
(1845, 95, 1144, 'bench_puffet', 10, 0, 1, 50, 0),
(1846, 13, 1145, 'CFC_500_goldbar', 500, 0, 1, 50, 0),
(1847, 13, 1146, 'CFC_200_moneybag', 200, 0, 1, 50, 0),
(1848, 13, 1148, 'CFC_100_coin_gold', 100, 0, 1, 50, 0),
(1850, 13, 1149, 'CFC_50_coin_silver', 50, 0, 1, 50, 0),
(1851, 128, 19940, 'urban_bench_plain', 4, 0, 1, 50, 0),
(1852, 95, 1328, 'ads_igorswitch', 10, 0, 1, 50, 0),
(1853, 95, 1329, 'ads_711*1', 10, 0, 1, 50, 0),
(1854, 95, 1330, 'ads_711*2', 10, 0, 1, 50, 0),
(1855, 95, 1331, 'ads_711*3', 10, 0, 1, 50, 0),
(1856, 95, 1332, 'ads_711*4', 10, 0, 1, 50, 0),
(1857, 95, 1333, 'ads_igorraygun', 10, 0, 1, 50, 0),
(1858, 95, 1412, 'ads_cldesk', 10, 0, 1, 50, 0),
(1859, 95, 1414, 'ads_cltele', 10, 0, 1, 50, 0),
(1860, 95, 1415, 'ads_clfloor', 10, 0, 1, 50, 0),
(1862, 95, 1327, 'ads_igorbrain', 10, 0, 1, 50, 0),
(1863, 95, 1417, 'ads_mall_tele', 10, 0, 1, 50, 0),
(1864, 95, 1441, 'ads_idol_floor1', 10, 0, 1, 50, 0),
(1865, 95, 1442, 'ads_igor_dsk', 10, 0, 1, 50, 0),
(1866, 95, 1443, 'ads_idol_desk', 10, 0, 1, 50, 0),
(1867, 95, 1444, 'ads_idol_ch', 10, 0, 1, 50, 0),
(1868, 95, 1445, 'ads_igor_flask', 10, 0, 1, 50, 0),
(1869, 95, 1446, 'ads_idol_drape', 10, 0, 1, 50, 0),
(1870, 95, 1447, 'ads_idol_floor2', 10, 0, 1, 50, 0),
(1871, 95, 1453, 'ads_idol_piano', 10, 0, 1, 50, 0),
(1872, 95, 1455, 'ads_711shelf', 10, 0, 1, 50, 0),
(1873, 95, 1464, 'ads_idol_jukebox*1', 10, 0, 1, 50, 0),
(1874, 95, 1465, 'ads_idol_pchair', 10, 0, 1, 50, 0),
(1875, 95, 1467, 'ads_idol_audChr', 10, 0, 1, 50, 0),
(1876, 95, 1468, 'ads_idol_trax', 10, 0, 1, 50, 0),
(1877, 95, 1469, 'ads_idol_tele', 10, 0, 1, 50, 0),
(1878, 95, 1474, 'ads_idol_mic', 10, 0, 1, 50, 0),
(1879, 95, 1475, 'ads_idol_hotspot', 10, 0, 1, 50, 0),
(1880, 95, 1476, 'ads_idol_clRack', 10, 0, 1, 50, 0),
(1881, 95, 1477, 'ads_idol_voting_ch', 10, 0, 1, 50, 0),
(1882, 95, 1491, 'ads_frankb', 10, 0, 1, 50, 0),
(1883, 95, 1508, 'ads_grefusa_cactus', 10, 0, 1, 50, 0),
(1884, 95, 1509, 'ads_idol_tube', 10, 0, 1, 50, 0),
(1885, 95, 1511, 'ads_idol_cork', 10, 0, 1, 50, 0),
(1886, 95, 1512, 'ads_cl_jukeb', 10, 0, 1, 50, 0),
(1887, 95, 1518, 'ads_idol_newsDsk', 10, 0, 1, 50, 0),
(1888, 95, 1524, 'ads_idol_ichair', 10, 0, 1, 50, 0),
(1889, 95, 1526, 'ads_reebok_block2', 10, 0, 1, 50, 0),
(1890, 95, 1527, 'ads_malaco_rug', 10, 0, 1, 50, 0),
(1891, 95, 1530, 'ads_malaco_gu', 10, 0, 1, 50, 0),
(1892, 95, 1531, 'ads_clcake', 10, 0, 1, 50, 0),
(1893, 95, 1532, 'ads_cl_sofa', 10, 0, 1, 50, 0),
(1894, 95, 1533, 'ads_idol_tblCloth', 10, 0, 1, 50, 0),
(1895, 95, 1534, 'ads_idol_carpet', 10, 0, 1, 50, 0),
(1896, 95, 1535, 'ads_idol_lamp', 10, 0, 1, 50, 0),
(1897, 95, 1541, 'ads_goldtabl', 10, 0, 1, 50, 0),
(1898, 95, 1553, 'ads_calip_cola*1', 10, 0, 1, 50, 0),
(1899, 95, 1554, 'ads_calip_cola*2', 10, 0, 1, 50, 0),
(1900, 95, 1555, 'ads_calip_cola*3', 10, 0, 1, 50, 0),
(1901, 95, 1630, 'ads_711*6', 10, 0, 1, 50, 0),
(1902, 95, 1556, 'ads_calip_cola*4', 10, 0, 1, 50, 0),
(1903, 95, 1562, 'ads_calip_chair', 10, 0, 1, 50, 0),
(1904, 95, 1563, 'ads_idol_trophy', 10, 0, 1, 50, 0),
(1905, 95, 1565, 'ads_calip_pool', 10, 0, 1, 50, 0),
(1906, 95, 1572, 'ads_calip_tele', 10, 0, 1, 50, 0),
(1908, 95, 1587, 'ads_calip_lava', 10, 0, 1, 50, 0),
(1909, 95, 1591, 'ads_mall_coffeem', 10, 0, 1, 50, 0),
(1910, 95, 1612, 'ads_mall_kiosk', 10, 0, 1, 50, 0),
(1911, 95, 1619, 'ads_elisa_gnome', 10, 0, 1, 50, 0),
(1912, 95, 1621, 'ads_oc_soda', 10, 0, 1, 50, 0),
(1913, 95, 1629, 'ads_711*5', 10, 0, 1, 50, 0),
(1914, 95, 1631, 'ads_711*7', 10, 0, 1, 50, 0),
(1915, 95, 1652, 'ads_1800tele', 10, 0, 1, 50, 0),
(1916, 95, 1707, 'ads_sunnyd', 10, 0, 1, 50, 0),
(1917, 95, 1711, 'ads_dave_wall', 10, 0, 1, 50, 0),
(1918, 95, 1714, 'ads_nokia_logo', 10, 0, 1, 50, 0),
(1919, 95, 1715, 'ads_nokia_phone', 10, 0, 1, 50, 0),
(1920, 95, 1720, 'ads_campguitar', 10, 0, 1, 50, 0),
(1921, 95, 1728, 'ads_cmusic', 10, 0, 1, 50, 0),
(1922, 95, 1741, 'ads_clwall1', 10, 0, 1, 50, 0),
(1923, 95, 1742, 'ads_clwall2', 10, 0, 1, 50, 0),
(1924, 95, 1743, 'ads_clwall3', 10, 0, 1, 50, 0),
(1925, 95, 1744, 'ads_ob_wall', 10, 0, 1, 50, 0),
(1926, 95, 1745, 'ads_mall_window', 10, 0, 1, 50, 0),
(1927, 42, 20022, 'a0 prizetrophy6_b', 8, 0, 1, 50, 0),
(1928, 95, 1750, 'ads_igor_wall', 10, 0, 1, 50, 0),
(1929, 95, 1751, 'ads_igorevilb', 10, 0, 1, 50, 0),
(1930, 95, 1752, 'ads_idol_wall', 10, 0, 1, 50, 0),
(1931, 95, 1753, 'ads_mall_winfur', 10, 0, 1, 50, 0),
(1932, 95, 1754, 'ads_mall_winpet', 10, 0, 1, 50, 0),
(1933, 95, 1758, 'ads_idol_tv', 10, 0, 1, 50, 0),
(1934, 95, 1760, 'ads_idol_mirror', 10, 0, 1, 50, 0),
(1935, 95, 1761, 'ads_mall_wincin', 10, 0, 1, 50, 0),
(1936, 95, 1762, 'ads_mall_winmus', 10, 0, 1, 50, 0),
(1937, 95, 1763, 'ads_mall_winbea', 10, 0, 1, 50, 0),
(1938, 95, 1765, 'ads_mall_winchi', 10, 0, 1, 50, 0),
(1939, 95, 1768, 'ads_mall_winice', 10, 0, 1, 50, 0),
(1940, 95, 1769, 'ads_mall_winspo', 10, 0, 1, 50, 0),
(1941, 95, 1770, 'ads_idol_logo', 10, 0, 1, 50, 0),
(1942, 95, 1773, 'ads_lin_wh_c', 10, 0, 1, 50, 0),
(1943, 95, 1774, 'ads_malaco_tv', 10, 0, 1, 50, 0),
(1944, 95, 1775, 'ads_puffet_tv', 10, 0, 1, 50, 0),
(1945, 95, 1776, 'ads_reebok_tv', 10, 0, 1, 50, 0),
(1946, 95, 1784, 'ads_mirror', 10, 0, 1, 50, 0),
(1947, 95, 1789, 'ads_wwe_poster', 10, 0, 1, 50, 0),
(1948, 95, 1790, 'ads_mall_wintra', 10, 0, 1, 50, 0),
(1949, 95, 1793, 'ads_veet', 10, 0, 1, 50, 0),
(1950, 95, 1797, 'ads_mall_wingar', 10, 0, 1, 50, 0),
(1951, 95, 1799, 'ads_mall_winclo', 10, 0, 1, 50, 0),
(1954, 95, 20037, 'ads_calip_parasol', 10, 0, 1, 50, 0),
(1956, 95, 1172, 'tampax_rug', 10, 0, 1, 50, 0),
(1957, 95, 1692, 'tampax_wall', 10, 0, 1, 50, 0),
(1958, 94, 20025, 'pillar*6', 10, 0, 1, 50, 0),
(1959, 55, 20026, 'shelves_norja*4', 3, 0, 1, 50, 0),
(1960, 30, 20027, 'bed_polyfon*2', 4, 0, 1, 50, 0),
(1961, 55, 20028, 'divider_nor5*6', 3, 0, 1, 50, 0),
(1962, 76, 20029, 'val_cauldron', 10, 0, 1, 50, 0),
(1963, 32, 20030, 'pura_mdl5*1', 3, 0, 1, 50, 0),
(1964, 94, 20031, 'one_way_door*1', 10, 0, 1, 50, 0),
(1966, 60, 20032, 'exe_globe', 5, 0, 1, 50, 0),
(1968, 45, 20035, 'fx_bubble', 0, 250, 1, 50, 0),
(1969, 129, 20036, 'bump_tottero', 0, 50, 1, 50, 0),
(1970, 129, 1502, 'bump_road', 0, 75, 1, 50, 0),
(1971, 129, 1497, 'bump_lights', 0, 50, 1, 50, 0),
(1972, 129, 1496, 'bump_tires', 0, 50, 1, 50, 0),
(1973, 129, 1492, 'bump_signs', 0, 50, 1, 50, 0),
(1974, 103, 20034, 'diner_bardesk_corner*5', 3, 0, 1, 50, 0),
(1976, 128, 20006, 'urban_fence_corner', 3, 0, 1, 50, 0),
(1977, 128, 20016, 'urban_lamp', 4, 0, 1, 50, 0),
(1978, 128, 20018, 'urban_wall', 5, 0, 1, 50, 0),
(1979, 128, 20011, 'urban_wpost', 3, 0, 1, 50, 0),
(1980, 128, 20010, 'urban_sidewalk', 4, 0, 1, 50, 0),
(1981, 128, 20008, 'urban_bench', 3, 0, 1, 50, 0),
(1982, 128, 20007, 'urban_carsofa', 4, 0, 1, 50, 0),
(1983, 128, 20014, 'urban_blocker', 2, 0, 1, 50, 0),
(1984, 128, 20013, 'urban_bin', 3, 0, 1, 50, 0),
(1985, 128, 20012, 'urban_fence', 3, 0, 1, 50, 0),
(1986, 128, 20015, 'urban_bsktbll', 4, 0, 1, 50, 0),
(1987, 125, 19877, 'avatar_effect9', 0, 100, 1, 50, 0),
(1988, 125, 19878, 'avatar_effect6', 0, 100, 1, 50, 0),
(1989, 125, 19879, 'avatar_effect16', 0, 100, 1, 50, 0),
(1990, 125, 19880, 'avatar_effect2', 0, 100, 1, 50, 0),
(1991, 125, 19881, 'avatar_effect14', 0, 100, 1, 50, 0),
(1992, 125, 19882, 'avatar_effect15', 0, 100, 1, 50, 0),
(1993, 125, 19883, 'avatar_effect3', 0, 100, 1, 50, 0),
(1994, 125, 19884, 'avatar_effect17', 0, 100, 1, 50, 0),
(1995, 125, 19885, 'avatar_effect18', 0, 100, 1, 50, 0),
(1996, 125, 19886, 'avatar_effect1', 0, 100, 1, 50, 0),
(1997, 125, 19887, 'avatar_effect4', 0, 100, 1, 50, 0),
(1998, 125, 19888, 'avatar_effect5', 0, 100, 1, 50, 0),
(1999, 125, 19889, 'avatar_effect7', 0, 100, 1, 50, 0),
(2000, 125, 19890, 'avatar_effect8', 0, 100, 1, 50, 0),
(2001, 125, 19891, 'avatar_effect10', 0, 100, 1, 50, 0),
(2002, 125, 19892, 'avatar_effect12', 0, 100, 1, 50, 0),
(2003, 125, 19893, 'avatar_effect13', 0, 100, 1, 50, 0),
(2004, 129, 19957, 'avatar_effect22', 0, 100, 1, 50, 0),
(2005, 129, 19958, 'avatar_effect19', 0, 100, 1, 50, 0),
(2006, 129, 19959, 'avatar_effect20', 0, 100, 1, 50, 0),
(2007, 129, 19960, 'avatar_effect21', 0, 100, 1, 50, 0),
(2011, 88, 1725, 'hw_08_xray', 5, 0, 1, 50, 0),
(2012, 95, 1718, 'netari_poster', 10, 0, 1, 50, 0),
(2013, 95, 1713, 'easy_poster', 10, 0, 1, 50, 0),
(2014, 95, 1684, 'md_logo_wall', 10, 0, 1, 50, 0),
(2015, 95, 1682, 'sw_hole', 10, 0, 1, 50, 0),
(2016, 95, 1681, 'sw_stone', 10, 0, 1, 50, 0),
(2017, 95, 1680, 'sw_swords', 10, 0, 1, 50, 0),
(2018, 41, 1675, 'guitar_v', 4, 0, 1, 50, 0),
(2019, 41, 1674, 'guitar_skull', 4, 0, 1, 50, 0),
(2020, 43, 1673, 'habbowheel', 5, 0, 1, 50, 0),
(2021, 72, 1670, 'wallmirror', 3, 0, 1, 50, 0),
(2022, 85, 1633, 'pix_asteroid', 0, 2000, 1, 50, 0),
(2023, 71, 1626, 'rela_stone', 4, 0, 1, 50, 0),
(2024, 94, 1622, 'marsrug', 10, 0, 1, 50, 0),
(2025, 85, 1592, 'totem_planet', 0, 2000, 1, 50, 0),
(2026, 95, 1590, 'voting_ch', 10, 0, 1, 50, 0),
(2027, 73, 1586, 'transparent_floor', 5, 0, 1, 50, 0),
(2028, 95, 1583, 'clrack', 10, 0, 1, 50, 0),
(2029, 95, 1582, 'noticeboard', 10, 0, 1, 50, 0),
(2030, 95, 1577, 'audChr', 10, 0, 1, 50, 0),
(2031, 85, 1571, 'saturn', 0, 2000, 1, 50, 0),
(2032, 95, 1566, 'laptopdesk', 10, 0, 1, 50, 0),
(2033, 85, 1564, 'totem_head', 0, 2000, 1, 50, 0),
(2034, 130, 1538, 'env_telep', 5, 0, 20, 50, 0),
(2035, 95, 1529, 'tray_glasstower', 6, 0, 1, 50, 0),
(2036, 95, 1528, 'tray_champagne', 5, 0, 1, 50, 0),
(2037, 95, 1525, 'tray_cake', 4, 0, 1, 50, 0),
(2038, 130, 1522, 'env_tree4', 5, 0, 20, 50, 0),
(2039, 130, 1520, 'env_tree2', 3, 0, 20, 50, 0),
(2040, 130, 1519, 'env_tree1', 3, 0, 20, 50, 0),
(2043, 130, 1516, 'env_bushes_gate', 5, 0, 20, 50, 0),
(2044, 130, 1515, 'env_bushes', 5, 0, 20, 50, 0),
(2045, 130, 1514, 'env_tree3', 3, 0, 20, 50, 0),
(2046, 130, 1513, 'env_grass', 5, 0, 20, 50, 0),
(2047, 130, 1513, 'env_grass', 15, 5000, 200, 50, 0),
(2048, 85, 1507, 'totem_leg', 0, 2000, 1, 50, 0),
(2050, 58, 1448, 'lostc_octopus', 6, 0, 1, 50, 0),
(2052, 85, 1430, 'planet_of_love', 0, 2000, 1, 50, 0),
(2054, 28, 1365, 'penguin_basic', 2, 0, 1, 50, 0),
(2055, 28, 1367, 'penguin_musketeer', 2, 0, 1, 50, 0),
(2056, 28, 1370, 'penguin_wrestler', 2, 0, 1, 50, 0),
(2057, 28, 1372, 'penguin_robot', 2, 0, 1, 50, 0),
(2058, 28, 1376, 'penguin_suit', 2, 0, 1, 50, 0),
(2059, 28, 1379, 'penguin_icehockey', 2, 0, 1, 50, 0),
(2060, 28, 1380, 'penguin_pilot', 2, 0, 1, 50, 0),
(2061, 28, 1381, 'penguin_ballet', 2, 0, 1, 50, 0),
(2062, 28, 1383, 'penguin_boxer', 2, 0, 1, 50, 0),
(2063, 28, 1384, 'penguin_glow', 2, 0, 1, 50, 0),
(2064, 28, 1385, 'penguin_swim', 2, 0, 1, 50, 0),
(2065, 28, 1386, 'penguin_sumo', 2, 0, 1, 50, 0),
(2066, 28, 1388, 'penguin_clown', 2, 0, 1, 50, 0),
(2067, 28, 1389, 'penguin_infected', 2, 0, 1, 50, 0),
(2068, 28, 1393, 'penguin_super', 2, 0, 1, 50, 0),
(2069, 28, 1396, 'penguin_rock', 2, 0, 1, 50, 0),
(2070, 28, 1399, 'penguin_ski', 2, 0, 1, 50, 0),
(2071, 28, 1400, 'penguin_skater', 2, 0, 1, 50, 0),
(2072, 28, 1402, 'penguin_elf', 2, 0, 1, 50, 0),
(2073, 28, 1403, 'penguin_bunny', 2, 0, 1, 50, 0),
(2074, 28, 1404, 'penguin_ninja', 2, 0, 1, 50, 0),
(2075, 28, 1405, 'penguin_magician', 2, 0, 1, 50, 0),
(2076, 28, 1406, 'penguin_hunchback', 2, 0, 1, 50, 0),
(2077, 28, 1407, 'penguin_cowboy', 2, 0, 1, 50, 0),
(2078, 28, 1408, 'penguin_punk', 2, 0, 1, 50, 0),
(2079, 28, 1409, 'penguin_pirate', 2, 0, 1, 50, 0),
(2080, 45, 1390, 'fx_flare', 0, 250, 1, 50, 0),
(2081, 95, 1377, 'svnr_fi', 10, 0, 1, 50, 0),
(2082, 45, 1371, 'fx_explosion', 0, 250, 1, 50, 0),
(2084, 95, 1202, 'svnr_aus', 10, 0, 1, 50, 0),
(2085, 95, 1201, 'svnr_de', 10, 0, 1, 50, 0),
(2086, 95, 1200, 'svnr_it', 10, 0, 1, 50, 0),
(2087, 95, 1199, 'svnr_nl', 10, 0, 1, 50, 0),
(2088, 95, 1198, 'svnr_uk', 10, 0, 1, 50, 0),
(2089, 36, 20024, 'table_plasto_square*9', 3, 0, 1, 50, 0),
(2090, 76, 20021, 'heart', 5, 0, 1, 50, 0),
(2091, 95, 1303, 'easy_carpet', 10, 0, 1, 50, 0),
(2092, 95, 1304, 'easy_bowl2', 10, 0, 1, 50, 0),
(2093, 95, 1319, 'netari_carpet', 10, 0, 1, 50, 0),
(2094, 40, 1325, 'sob_carpet', 3, 0, 1, 50, 0),
(2095, 95, 1326, 'igor_seat', 10, 0, 1, 50, 0),
(2097, 95, 20041, 'year2010', 10, 0, 1, 50, 0),
(2098, 95, 20042, 'party_lantern', 10, 0, 1, 50, 0),
(2099, 95, 20043, 'party_lights', 10, 0, 1, 50, 0),
(2101, 71, 20047, 'rela_stick', 3, 0, 1, 50, 0),
(2102, 60, 20046, 'exe_elevator', 5, 0, 1, 50, 0),
(2103, 56, 20045, 'arabian_tile', 5, 0, 1, 50, 0),
(2105, 95, 20048, 'ads_mall_elevator', 10, 0, 1, 50, 0),
(2106, 94, 247, 'rare_daffodil_rug', 1, 0, 150, 50, 0),
(2107, 95, 20050, 'xm09_infotv', 10, 0, 1, 50, 0),
(2108, 42, 20051, 'ads_twi_trophy', 10, 0, 1, 50, 0),
(2110, 112, 20052, 'ads_twi_crest', 6, 0, 1, 50, 0),
(2112, 112, 20053, 'ads_twi_paint', 3, 0, 1, 50, 0),
(2113, 112, 20054, 'ads_twi_windw', 3, 0, 1, 50, 0),
(2114, 112, 20055, 'ads_twi_bwall2', 3, 0, 1, 50, 0),
(2115, 112, 20056, 'ads_twi_dreamc', 3, 0, 1, 50, 0),
(2116, 112, 20057, 'ads_twi_bwall1', 3, 0, 1, 50, 0),
(2118, 7, 20060, 'DEAL_HC_1', 100, 0, 1, 50, 0),
(2119, 7, 20060, 'DEAL_HC_3', 500, 0, 6, 50, 0),
(2120, 7, 20060, 'DEAL_HC_2', 250, 0, 3, 50, 0),
(2121, 56, 20059, 'arabian_wall', 4, 0, 1, 50, 0),
(2123, 73, 20064, 'sf_mbar', 5, 0, 1, 50, 0),
(2124, 27, 20063, 'xm09_cocoa', 6, 0, 1, 50, 0),
(2126, 160, 317, 'nest', 3, 0, 1, 50, 0),
(2127, 160, 318, 'petfood1', 3, 0, 1, 50, 0),
(2128, 160, 319, 'petfood2', 3, 0, 1, 50, 0),
(2129, 160, 320, 'petfood3', 3, 0, 1, 50, 0),
(2130, 160, 321, 'waterbowl*4', 3, 0, 1, 50, 0),
(2131, 160, 322, 'waterbowl*5', 3, 0, 1, 50, 0),
(2132, 160, 326, 'toy1', 3, 0, 1, 50, 0),
(2133, 160, 323, 'waterbowl*2', 3, 0, 1, 50, 0),
(2134, 160, 324, 'waterbowl*1', 3, 0, 1, 50, 0),
(2135, 160, 325, 'waterbowl*3', 3, 0, 1, 50, 0),
(2136, 160, 327, 'toy1*1', 3, 0, 1, 50, 0),
(2137, 160, 328, 'toy1*2', 3, 0, 1, 50, 0),
(2138, 160, 329, 'toy1*3', 3, 0, 1, 50, 0),
(2139, 160, 330, 'toy1*4', 3, 0, 1, 50, 0),
(2140, 160, 331, 'goodie1', 3, 0, 1, 50, 0),
(2141, 160, 332, 'goodie1*1', 3, 0, 1, 50, 0),
(2142, 160, 333, 'goodie1*2', 3, 0, 1, 50, 0),
(2143, 160, 334, 'goodie2', 3, 0, 1, 50, 0),
(2144, 160, 334, 'goodie2', 3, 0, 1, 50, 0),
(2145, 134, 1478, 'ecotron_box', 3, 0, 1, 50, 0),
(2146, 134, 1479, 'eco_light2', 3, 0, 1, 50, 0),
(2147, 134, 1480, 'eco_chair3', 3, 0, 1, 50, 0),
(2148, 134, 1481, 'eco_table3', 3, 0, 1, 50, 0),
(2149, 134, 1482, 'eco_lamp2', 3, 0, 1, 50, 0),
(2150, 134, 1483, 'eco_sofa3', 3, 0, 1, 50, 0),
(2151, 134, 1484, 'eco_table2', 3, 0, 1, 50, 0),
(2152, 134, 1485, 'eco_fruits2', 3, 0, 1, 50, 0),
(2153, 134, 1486, 'eco_sofa1', 3, 0, 1, 50, 0),
(2154, 134, 1487, 'eco_fruits3', 3, 0, 1, 50, 0),
(2155, 134, 1488, 'eco_light1', 3, 0, 1, 50, 0),
(2156, 134, 1489, 'eco_tree1', 3, 0, 1, 50, 0),
(2157, 134, 1490, 'eco_cactus2', 3, 0, 1, 50, 0),
(2158, 134, 1493, 'eco_cactus1', 3, 0, 1, 50, 0),
(2159, 134, 1494, 'eco_chair2', 3, 0, 1, 50, 0),
(2160, 134, 1495, 'eco_cactus3', 3, 0, 1, 50, 0),
(2161, 134, 1498, 'eco_lamp3', 3, 0, 1, 50, 0),
(2163, 160, 819, 'petfood4', 3, 0, 1, 50, 0),
(2164, 30, 631, 'divider_poly3*8', 3, 0, 1, 50, 0),
(2165, 134, 164, 'present_gen', 3, 0, 1, 50, 0),
(2166, 134, 165, 'present_gen1', 3, 0, 1, 50, 0),
(2167, 134, 166, 'present_gen2', 3, 0, 1, 50, 0),
(2168, 134, 167, 'present_gen3', 3, 0, 1, 50, 0),
(2169, 134, 168, 'present_gen4', 3, 0, 1, 50, 0),
(2170, 134, 169, 'present_gen5', 3, 0, 1, 50, 0),
(2171, 134, 170, 'present_gen6', 3, 0, 1, 50, 0),
(2172, 134, 1450, 'lc_medusa2', 3, 0, 1, 50, 0),
(2173, 134, 1007, 'song_disk', 3, 0, 1, 50, 0),
(2174, 134, 1499, 'eco_table1', 3, 0, 1, 50, 0),
(2175, 134, 1500, 'eco_chair1', 3, 0, 1, 50, 0),
(2176, 134, 1501, 'eco_sofa2', 3, 0, 1, 50, 0),
(2177, 134, 1503, 'eco_fruits1', 3, 0, 1, 50, 0),
(2178, 134, 1504, 'eco_lamp1', 3, 0, 1, 50, 0),
(2179, 134, 1505, 'eco_light3', 3, 0, 1, 50, 0),
(2180, 134, 1506, 'eco_tree2', 3, 0, 1, 50, 0),
(2181, 134, 1542, 'eco_mush1', 3, 0, 1, 50, 0),
(2182, 134, 1547, 'eco_mush2', 3, 0, 1, 50, 0),
(2183, 134, 1764, 'eco_curtains1', 3, 0, 1, 50, 0),
(2184, 134, 1766, 'eco_curtains3', 3, 0, 1, 50, 0),
(2185, 134, 1767, 'eco_curtains2', 3, 0, 1, 50, 0),
(2190, 41, 20151, 'flag_singapore', 3, 0, 1, 50, 0),
(2191, 41, 20153, 'flag_columbia', 3, 0, 1, 50, 0),
(2193, 41, 20154, 'flag_chile', 3, 0, 1, 50, 0),
(2194, 41, 20155, 'flag_ecuador', 3, 0, 1, 50, 0),
(2195, 41, 20156, 'flag_dominicanrepublic', 3, 0, 1, 50, 0),
(2196, 41, 20157, 'flag_newzealand', 3, 0, 1, 50, 0),
(2197, 41, 20158, 'flag_malaysia', 3, 0, 1, 50, 0),
(2198, 41, 20160, 'flag_venezl', 3, 0, 1, 50, 0),
(2199, 41, 20161, 'flag_algeria', 3, 0, 1, 50, 0),
(2200, 41, 20162, 'flag_tunisia', 3, 0, 1, 50, 0),
(2201, 41, 20163, 'flag_panama', 3, 0, 1, 50, 0),
(2202, 41, 20164, 'flag_mexico', 3, 0, 1, 50, 0),
(2203, 41, 20165, 'flag_argentina', 3, 0, 1, 50, 0),
(2204, 41, 20166, 'flag_philippines', 3, 0, 1, 50, 0),
(2205, 41, 20167, 'flag_greece', 3, 0, 1, 50, 0),
(2206, 41, 20168, 'flag_peru', 3, 0, 1, 50, 0),
(2207, 41, 20169, 'flag_morocco', 3, 0, 1, 50, 0),
(2208, 41, 20170, 'flag_turkey', 3, 0, 1, 50, 0),
(2209, 136, 20117, 'bling_fridge', 5, 0, 1, 50, 0),
(2210, 136, 20121, 'bling_chair_a', 3, 0, 1, 50, 0),
(2211, 136, 20123, 'bling_pool', 3, 0, 1, 50, 0),
(2212, 136, 20124, 'bling_toilet', 4, 0, 1, 50, 0),
(2213, 136, 20126, 'bling_chair_c', 3, 0, 1, 50, 0),
(2214, 136, 20127, 'bling_chair_b', 3, 0, 1, 50, 0),
(2215, 136, 20128, 'bling_shwr', 5, 0, 1, 50, 0),
(2216, 136, 20129, 'bling_bed', 3, 0, 1, 50, 0),
(2217, 136, 20130, 'bling_sofa', 4, 0, 1, 50, 0),
(2218, 136, 20144, 'bling_fridge_restricted', 3, 0, 1, 50, 0),
(2219, 136, 20200, 'bling_sink', 3, 0, 1, 50, 0),
(2220, 136, 20202, 'bling_cabinet', 3, 0, 1, 50, 0),
(2223, 137, 20103, 'org_chairpnk', 3, 0, 1, 50, 0),
(2224, 137, 20104, 'org_tblpnk', 3, 0, 1, 50, 0),
(2225, 137, 20105, 'org_lampblk', 3, 0, 1, 50, 0),
(2226, 137, 20106, 'org_lamppnk', 3, 0, 1, 50, 0),
(2227, 137, 20107, 'org_table', 3, 0, 1, 50, 0),
(2228, 137, 20111, 'org_chairblk', 3, 0, 1, 50, 0),
(2229, 137, 20112, 'org_tblblk', 3, 0, 1, 50, 0),
(2230, 137, 20113, 'org_chrblk', 3, 0, 1, 50, 0),
(2231, 137, 20115, 'org_chrpnk', 3, 0, 1, 50, 0),
(2232, 76, 20125, 'val09_floor', 3, 0, 1, 50, 0),
(2233, 76, 20131, 'val09_floor2', 3, 0, 1, 50, 0),
(2234, 76, 20198, 'val09_wdrobe_b', 5, 0, 1, 50, 0),
(2235, 76, 20199, 'val09_wall2', 4, 0, 1, 50, 0),
(2236, 76, 20201, 'val09_wall1', 4, 0, 1, 50, 0),
(2237, 76, 20204, 'val09_wdrobe_g', 5, 0, 1, 50, 0),
(2238, 76, 20134, 'val_hSeat*1', 3, 0, 1, 50, 0),
(2239, 76, 20135, 'val_hSeat*2', 3, 0, 1, 50, 0),
(2240, 76, 20136, 'val_hSeat*3', 3, 0, 1, 50, 0),
(2241, 76, 20137, 'val_hSeat*4', 3, 0, 1, 50, 0),
(2242, 76, 20138, 'val_hSeat*5', 3, 0, 1, 50, 0),
(2243, 76, 20139, 'val_hSeat*6', 3, 0, 1, 50, 0),
(2244, 76, 20140, 'val_hSeat*7', 3, 0, 1, 50, 0),
(2245, 76, 20141, 'val_basket', 3, 0, 1, 50, 0),
(2246, 76, 20190, 'val_table1', 4, 0, 1, 50, 0),
(2248, 27, 20093, 'xm09_lrgBauble', 10, 0, 1, 50, 0),
(2250, 42, 20109, 'xm09_trophy', 6, 0, 1, 50, 0),
(2251, 27, 20171, 'xm09_bauble_12', 3, 0, 1, 50, 0),
(2252, 27, 20172, 'xm09_bauble_16', 3, 0, 1, 50, 0),
(2253, 27, 20173, 'xm09_bauble_17', 3, 0, 1, 50, 0),
(2254, 27, 20174, 'xm09_bauble_15', 3, 0, 1, 50, 0),
(2255, 27, 20175, 'xm09_bauble_10', 3, 0, 1, 50, 0),
(2256, 27, 20176, 'xm09_bauble_9', 3, 0, 1, 50, 0),
(2257, 27, 20177, 'xm09_bauble_18', 3, 0, 1, 50, 0),
(2258, 27, 20178, 'xm09_bauble_13', 3, 0, 1, 50, 0),
(2259, 27, 20179, 'xm09_bauble_2', 3, 0, 1, 50, 0),
(2260, 27, 20180, 'xm09_bauble_1', 3, 0, 1, 50, 0),
(2261, 27, 20181, 'xm09_bauble_22', 3, 0, 1, 50, 0),
(2262, 27, 20182, 'xm09_bauble_3', 3, 0, 1, 50, 0),
(2263, 27, 20183, 'xm09_bauble_21', 3, 0, 1, 50, 0),
(2264, 27, 20184, 'xm09_bauble_8', 3, 0, 1, 50, 0),
(2265, 27, 20185, 'xm09_bauble_4', 3, 0, 1, 50, 0),
(2266, 27, 20186, 'xm09_bauble_5', 3, 0, 1, 50, 0),
(2267, 27, 20187, 'xm09_bauble_11', 3, 0, 1, 50, 0),
(2268, 27, 20188, 'xm09_bauble_20', 3, 0, 1, 50, 0),
(2269, 27, 20191, 'xm09_bauble_14', 3, 0, 1, 50, 0),
(2270, 27, 20192, 'xm09_bauble_7', 3, 0, 1, 50, 0),
(2271, 27, 20193, 'xm09_bauble_6', 3, 0, 1, 50, 0),
(2272, 27, 20194, 'xm09_bauble_19', 3, 0, 1, 50, 0),
(2273, 76, 20132, 'teddy_basic', 4, 0, 1, 50, 0),
(2274, 76, 20133, 'teddy_pendergrass', 5, 0, 1, 50, 0),
(2275, 76, 20142, 'teddy_bear', 3, 0, 1, 50, 0),
(2276, 76, 20143, 'teddy_pink', 4, 0, 1, 50, 0),
(2277, 160, 20079, 'nest_plow_reg', 3, 0, 1, 50, 0),
(2278, 160, 20080, 'nest_snug_yel', 4, 0, 1, 50, 0),
(2279, 160, 20085, 'nest_snug_grn', 4, 0, 1, 50, 0),
(2280, 160, 20086, 'nest_snug_red', 4, 0, 1, 50, 0),
(2281, 160, 20087, 'nest_snug_grn', 4, 0, 1, 50, 0),
(2282, 160, 20088, 'nest_plow_bro', 3, 0, 1, 50, 0),
(2283, 160, 20089, 'nest_plow_red', 3, 0, 1, 50, 0),
(2284, 160, 20090, 'nest_snug_blu', 4, 0, 1, 50, 0),
(2285, 160, 20092, 'nest_plow_blu', 3, 0, 1, 50, 0),
(2286, 160, 20094, 'nest_dirt', 2, 0, 1, 50, 0),
(2287, 160, 20095, 'nest_snug_prp', 3, 0, 1, 50, 0),
(2288, 160, 20096, 'nest_nest', 3, 0, 1, 50, 0),
(2289, 160, 20097, 'nest_nails', 2, 0, 1, 50, 0),
(2290, 160, 20098, 'nest_basket', 2, 0, 1, 50, 0),
(2291, 160, 20099, 'nest_ice', 2, 0, 1, 50, 0),
(2292, 160, 20100, 'nest_plow_skl', 3, 0, 1, 50, 0),
(2293, 160, 20101, 'nest_snug_bla', 4, 0, 1, 50, 0),
(2294, 95, 20071, 'ads_gsArcade_2', 10, 0, 1, 50, 0),
(2295, 95, 20073, 'ads_idol_l_carpet', 10, 0, 1, 50, 0),
(2296, 134, 20068, 'ads_cllava2', 10, 0, 1, 50, 0),
(2297, 95, 20072, 'ads_gsArcade_1', 10, 0, 1, 50, 0),
(2298, 95, 20074, 'ads_mtvtrophy_silver', 10, 0, 1, 50, 0),
(2299, 94, 20075, 'ads_spang_sleep', 10, 0, 1, 50, 0),
(2300, 95, 20076, 'ads_mtvtrophy_gold', 10, 0, 1, 50, 0),
(2301, 94, 20102, 'ads_cl_moodi', 10, 0, 1, 50, 0),
(2302, 95, 20116, 'ads_chups', 10, 0, 1, 50, 0),
(2303, 95, 20119, 'ads_droetker_paula', 10, 0, 1, 50, 0),
(2304, 95, 20145, 'ads_percyrock', 10, 0, 1, 50, 0),
(2305, 95, 20147, 'ads_idol_l_logo', 10, 0, 1, 50, 0),
(2306, 95, 20197, 'ads_percyw', 10, 0, 1, 50, 0),
(2307, 95, 20150, 'ads_mtv_tv', 10, 0, 1, 50, 0),
(2308, 95, 20196, 'ads_tv_jaapuisto', 10, 0, 1, 50, 0),
(2310, 134, 20159, 'byesw_loadscreen', 10, 0, 1, 50, 0),
(2312, 95, 20149, 'ads_mtv_bigtv', 10, 0, 1, 50, 0),
(2313, 95, 20148, 'ads_idol_l_tv', 10, 0, 1, 50, 0),
(2314, 27, 20066, 'tree2', 2, 0, 1, 50, 0),
(2317, 30, 20067, 'divider_poly3*7', 6, 0, 1, 50, 0),
(2318, 37, 20077, 'ktchn_hlthNut', 5, 0, 1, 50, 0),
(2319, 160, 20078, 'petfood8', 10, 0, 1, 50, 0),
(2320, 160, 20081, 'petfood9', 10, 0, 1, 50, 0),
(2321, 160, 20082, 'petfood10', 10, 0, 1, 50, 0),
(2322, 160, 20083, 'petfood7', 10, 0, 1, 50, 0),
(2323, 160, 20084, 'petfood6', 10, 0, 1, 50, 0),
(2324, 160, 20091, 'petfood5', 10, 0, 1, 50, 0),
(2325, 160, 20118, 'petfood12', 10, 0, 1, 50, 0),
(2326, 160, 20120, 'petfood11', 10, 0, 1, 50, 0),
(2327, 160, 20122, 'petfood13', 10, 0, 1, 50, 0),
(2329, 94, 20146, 'md_can', 10, 0, 1, 50, 0),
(2330, 66, 20152, 'hween09_curt', 4, 0, 1, 50, 0),
(2331, 57, 20108, 'china_tiger', 4, 0, 1, 50, 0),
(2332, 57, 20110, 'china_plmTree', 3, 0, 1, 50, 0),
(2333, 134, 20114, 'china_tigrSeat', 3, 0, 1, 50, 0),
(2334, 57, 20195, 'china_pstr3', 3, 0, 1, 50, 0),
(2335, 129, 1502, 'bump_road', 0, 1250, 20, 50, 0),
(2336, 62, 20207, 'rare_ironmaiden name', 5, 0, 1, 50, 0),
(2337, 95, 20208, 'rare_trex name', 10, 0, 1, 50, 0),
(2338, 143, 20209, 'beanstalk', 6, 0, 10, 50, 0),
(2339, 95, 20210, 'rare_vdoll name', 3, 0, 1, 50, 0);
INSERT INTO `catalog_items_old` (`id`, `page_id`, `item_ids`, `catalog_name`, `cost_credits`, `cost_pixels`, `amount`, `cost_crystal`, `cost_oude_belcredits`) VALUES
(2340, 95, 20211, 'rare_mmmth name', 10, 0, 1, 50, 0),
(2341, 136, 20212, 'crystal_patch', 3, 0, 1, 50, 0),
(2342, 95, 20213, 'ads_boost_surfb name', 10, 0, 1, 50, 0),
(2343, 95, 20214, 'ads_tlc_wheel name', 10, 0, 1, 50, 0),
(2346, 16, 247, 'rare_daffodil_rug', 100, 100, 4, 50, 0),
(2348, 134, 180, 'doorC', 10, 0, 100, 50, 0),
(2350, 143, 20221, 'garden_lupin4', 4, 0, 10, 50, 0),
(2351, 143, 20222, 'garden_mursu3', 5, 0, 10, 50, 0),
(2352, 143, 20223, 'garden_lupin5', 4, 0, 10, 50, 0),
(2353, 143, 20224, 'garden_seed', 3, 0, 10, 50, 0),
(2354, 143, 20225, 'garden_flytrap', 6, 0, 10, 50, 0),
(2355, 143, 20226, 'garden_flo3', 2, 0, 10, 50, 0),
(2357, 143, 20227, 'garden_volcano', 5, 0, 10, 50, 0),
(2358, 143, 20228, 'garden_flolamp', 8, 0, 10, 50, 0),
(2359, 143, 20229, 'garden_mursu2', 5, 0, 10, 50, 0),
(2360, 143, 20230, 'garden_jyrki', 4, 0, 10, 50, 0),
(2361, 143, 20231, 'garden_mursu4', 4, 0, 10, 50, 0),
(2362, 143, 20232, 'garden_leaves', 3, 0, 10, 50, 0),
(2363, 143, 20233, 'garden_lupin2', 4, 0, 10, 50, 0),
(2364, 143, 20234, 'garden_lupin3', 4, 0, 10, 50, 0),
(2365, 143, 20235, 'garden_mursu', 4, 0, 10, 50, 0),
(2366, 143, 20238, 'garden_orchtree', 6, 0, 10, 50, 0),
(2367, 143, 20237, 'garden_flo2', 2, 0, 10, 50, 0),
(2368, 143, 20239, 'garden_lupin1', 4, 0, 10, 50, 0),
(2369, 143, 20240, 'garden_staringbush', 5, 0, 10, 50, 0),
(2370, 143, 20242, 'garden_flo1', 2, 0, 10, 50, 0),
(2371, 143, 20243, 'garden_jungle', 5, 0, 10, 50, 0),
(2372, 143, 20286, 'garden_wall', 4, 0, 10, 50, 0),
(2374, 144, 20247, 'runway_display', 5, 0, 1, 50, 0),
(2375, 144, 20248, 'runway_bigchr_5', 4, 0, 1, 50, 0),
(2376, 144, 20249, 'runway_bigchr_4', 4, 0, 1, 50, 0),
(2377, 144, 20253, 'runway_stool', 4, 0, 1, 50, 0),
(2378, 144, 20254, 'runway_dvdr', 3, 0, 1, 50, 0),
(2379, 144, 20255, 'runway_block_2', 5, 0, 1, 50, 0),
(2380, 144, 20256, 'runway_bigchr_1', 5, 0, 1, 50, 0),
(2381, 144, 20260, 'runway_block_1', 5, 0, 1, 50, 0),
(2382, 144, 20261, 'runway_bench', 4, 0, 1, 50, 0),
(2383, 144, 20262, 'runway_chair_2', 3, 0, 1, 50, 0),
(2384, 144, 20265, 'runway_bigchr_3', 4, 0, 1, 50, 0),
(2385, 144, 20268, 'runway_bigchr_2', 4, 0, 1, 50, 0),
(2386, 144, 20270, 'runway_table_2', 4, 0, 1, 50, 0),
(2387, 144, 20271, 'runway_table_1', 5, 0, 1, 50, 0),
(2388, 144, 20272, 'runway_manqn_1', 4, 0, 1, 50, 0),
(2389, 144, 20276, 'runway_head', 4, 0, 1, 50, 0),
(2390, 144, 20277, 'runway_manqn_2', 4, 0, 1, 50, 0),
(2391, 144, 20285, 'runway_chair_1', 3, 0, 1, 50, 0),
(2392, 144, 20289, 'runway_shelf', 3, 0, 1, 50, 0),
(2393, 144, 20292, 'runway_fabric', 3, 0, 1, 50, 0),
(2394, 8, 20245, 'hc2_frplc', 5, 0, 1, 50, 0),
(2395, 8, 20246, 'hc2_barchair', 3, 0, 1, 50, 0),
(2396, 8, 20250, 'hc3_dc', 4, 0, 1, 50, 0),
(2397, 8, 20252, 'hc2_sofatbl', 4, 0, 1, 50, 0),
(2398, 8, 20257, 'hc2_biglamp', 3, 0, 1, 50, 0),
(2399, 8, 20258, 'hc2_sofa', 4, 0, 1, 50, 0),
(2400, 8, 20259, 'hc2_carpet', 5, 0, 1, 50, 0),
(2401, 8, 20264, 'hc3_table', 3, 0, 1, 50, 0),
(2402, 8, 20266, 'hc3_stool', 3, 0, 1, 50, 0),
(2403, 8, 20267, 'hc3_sofa', 4, 0, 1, 50, 0),
(2404, 8, 20269, 'hc2_armchair', 3, 0, 1, 50, 0),
(2405, 8, 20273, 'hc2_dvn', 4, 0, 1, 50, 0),
(2406, 8, 20274, 'hc3_light', 3, 0, 1, 50, 0),
(2407, 8, 20275, 'hc3_shelf', 5, 0, 1, 50, 0),
(2408, 8, 20278, 'hc2_divider', 3, 0, 1, 50, 0),
(2409, 8, 20279, 'hc2_coffee', 5, 0, 1, 50, 0),
(2410, 8, 20280, 'hc2_cart', 3, 0, 1, 50, 0),
(2411, 8, 20281, 'hc3_bard', 10, 0, 1, 50, 0),
(2412, 8, 20282, 'hc3_hugelamp', 5, 0, 1, 50, 0),
(2413, 8, 20283, 'hc3_divider', 3, 0, 1, 50, 0),
(2414, 8, 20284, 'hc2_vase', 4, 0, 1, 50, 0),
(2415, 8, 20288, 'hc3_walldeco', 10, 0, 1, 50, 0),
(2416, 134, 20295, 'camera', 10, 0, 1, 50, 0),
(2417, 134, 20045, 'arabian_tile', 10, 0, 100, 50, 0),
(2418, 95, 20241, 'ads_grefusa_yum', 10, 0, 1, 50, 0),
(2419, 95, 20244, 'merger_chesT', 10, 0, 1, 50, 0),
(2420, 95, 20263, 'ads_cheetos name', 10, 0, 1, 50, 0),
(2421, 95, 20287, 'ads_tv_yle name', 10, 0, 1, 50, 0),
(2422, 95, 20290, 'ads_nokia_x6', 10, 0, 1, 50, 0),
(2423, 95, 20291, 'ads_target_wall', 10, 0, 1, 50, 0),
(2424, 95, 20293, 'ads_latrobe_flag', 10, 0, 1, 50, 0),
(2425, 27, 20296, 'holly', 4, 0, 1, 50, 0),
(2442, 141, 20319, 'a0 pet5', 20000, 7500, 1, 50, 0),
(2443, 146, 20321, 'a0 pet3', 20000, 7500, 1, 50, 0),
(2444, 147, 20320, 'a0 pet4', 20000, 7500, 1, 50, 0),
(2445, 148, 20323, 'a0 pet1', 20000, 7500, 1, 50, 0),
(2446, 149, 20324, 'a0 pet0', 20000, 7500, 1, 50, 0),
(2447, 150, 20322, 'a0 pet2', 20000, 7500, 1, 50, 0),
(2453, 171, 20370, 'fball_trophy', 35, 0, 1, 50, 0),
(2454, 171, 20369, 'fball_audbench', 7, 0, 1, 50, 0),
(2455, 171, 20368, 'fball_ball', 20, 0, 1, 50, 0),
(2456, 171, 20367, 'fball_ball2', 20, 0, 1, 50, 0),
(2457, 171, 20366, 'fball_ball4', 20, 0, 1, 50, 0),
(2458, 171, 20365, 'fball_ball5', 20, 0, 1, 50, 0),
(2459, 171, 20364, 'fball_bench', 10, 0, 1, 50, 0),
(2460, 171, 20363, 'fball_cote', 10, 0, 1, 50, 0),
(2461, 171, 20362, 'fball_crnr', 10, 0, 1, 50, 0),
(2462, 171, 20361, 'fball_fnc1', 10, 0, 1, 50, 0),
(2463, 171, 20360, 'fball_fnc3', 10, 0, 1, 50, 0),
(2464, 171, 20359, 'fball_goal_b', 15, 0, 1, 50, 0),
(2465, 171, 20358, 'fball_goal_g', 15, 0, 1, 50, 0),
(2466, 171, 20357, 'fball_goal_r', 15, 0, 1, 50, 0),
(2467, 171, 20356, 'fball_goal_y', 15, 0, 1, 50, 0),
(2468, 171, 20355, 'fball_light', 10, 0, 1, 50, 0),
(2469, 171, 20340, 'fball_gate', 10, 0, 1, 50, 0),
(2470, 171, 20341, 'fball_counter', 10, 0, 1, 50, 0),
(2471, 171, 20342, 'fball_ptch0', 5, 0, 1, 50, 0),
(2472, 171, 20343, 'fball_ptch1', 5, 0, 1, 50, 0),
(2473, 171, 20344, 'fball_ptch2', 5, 0, 1, 50, 0),
(2474, 171, 20345, 'fball_ptch3', 5, 0, 1, 50, 0),
(2475, 171, 20346, 'fball_ptch4', 5, 0, 1, 50, 0),
(2476, 171, 20347, 'fball_ptch5', 5, 0, 1, 50, 0),
(2477, 171, 20348, 'fball_ptch6', 5, 0, 1, 50, 0),
(2478, 171, 20349, 'fball_ptch7', 5, 0, 1, 50, 0),
(2479, 171, 20350, 'fball_ptch8', 5, 0, 1, 50, 0),
(2480, 171, 20351, 'fball_score_b', 15, 0, 1, 50, 0),
(2481, 171, 20352, 'fball_score_g', 15, 0, 1, 50, 0),
(2482, 171, 20353, 'fball_score_r', 15, 0, 1, 50, 0),
(2483, 171, 20354, 'fball_score_y', 15, 0, 1, 50, 0),
(2530, 157, 20411, 'a0 pet6', 20000, 7500, 1, 50, 0),
(2531, 158, 20412, 'a0 pet7', 20000, 7500, 1, 50, 0),
(2713, 174, 20372, 'party_crate2_1', 6, 0, 1, 50, 0),
(2714, 174, 20373, 'party_crate1_3', 6, 0, 1, 50, 0),
(2715, 174, 20374, 'party_crate1_4', 15, 0, 1, 50, 0),
(2716, 174, 20375, 'party_crate1_1', 15, 0, 1, 50, 0),
(2717, 174, 20376, 'party_crate1_2', 5, 0, 1, 50, 0),
(2718, 174, 20377, 'party_crate2_2', 5, 0, 1, 50, 0),
(2719, 174, 20378, 'party_crate2_3', 5, 0, 1, 50, 0),
(2720, 174, 20379, 'party_crate2_4', 5, 0, 1, 50, 0),
(2721, 174, 20380, 'party_djset', 10, 0, 1, 50, 0),
(2756, 137, 1, 'World Cup Soccer', 15, 0, 9, 50, 0),
(3000, 300, 30000, 'hween10_bat', 3, 0, 1, 50, 0),
(3001, 300, 30001, 'hween10_card_1', 3, 0, 1, 50, 0),
(3002, 300, 30002, 'hween10_card_2', 3, 0, 1, 50, 0),
(3003, 300, 30003, 'hween10_card_3', 3, 0, 1, 50, 0),
(3004, 300, 30004, 'hween10_card_4', 3, 0, 1, 50, 0),
(3005, 300, 30005, 'hween10_card_5', 3, 0, 1, 50, 0),
(3006, 300, 30006, 'hween10_card_6', 3, 0, 1, 50, 0),
(3007, 300, 30007, 'hween10_chicken', 3, 0, 1, 50, 0),
(3008, 300, 30008, 'hween10_ffly', 3, 0, 1, 50, 0),
(3009, 300, 30009, 'hween10_fog', 3, 0, 1, 50, 0),
(3010, 300, 30010, 'hween10_jar', 3, 0, 1, 50, 0),
(3011, 300, 30011, 'hween10_logs', 3, 0, 1, 50, 0),
(3012, 300, 30012, 'hween10_pond', 3, 0, 1, 50, 0),
(3013, 300, 30013, 'hween10_portch', 3, 0, 1, 50, 0),
(3014, 300, 30014, 'hween10_skullpost', 3, 0, 1, 50, 0),
(3015, 300, 30015, 'hween10_swamp', 3, 0, 1, 50, 0),
(3016, 300, 30016, 'hween10_tarot', 3, 0, 1, 50, 0),
(3017, 300, 30017, 'hween10_tele', 3, 0, 1, 50, 0),
(3018, 300, 30018, 'hween10_throne', 3, 0, 1, 50, 0),
(3019, 300, 30019, 'hween10_tree', 3, 0, 1, 50, 0),
(3020, 300, 30020, 'hween10_voodoo1', 3, 0, 1, 50, 0),
(3021, 300, 30021, 'hween10_voodoo2', 3, 0, 1, 50, 0),
(3022, 300, 30022, 'hween10_voodoo3', 3, 0, 1, 50, 0),
(3023, 300, 30023, 'hween10_wallskull', 3, 0, 1, 50, 0),
(4964, 161, 20339, 'bw_water_1', 3, 0, 1, 50, 0),
(4965, 161, 20338, 'bw_tele', 5, 0, 1, 50, 0),
(4969, 161, 20339, 'bw_water_1', 60, 0, 100, 50, 0),
(10278, 496, 10278, 'hosptl_bbag name', 10, 0, 1, 50, 0),
(10279, 496, 10279, 'hosptl_bed', 10, 0, 1, 50, 0),
(10280, 496, 10280, 'hosptl_cab1', 5, 0, 1, 50, 0),
(10281, 496, 10281, 'hosptl_cab2', 3, 0, 1, 50, 0),
(10282, 496, 10282, 'hosptl_curtain', 3, 0, 1, 50, 0),
(10283, 496, 10283, 'hosptl_defibs', 5, 0, 1, 50, 0),
(10284, 496, 10284, 'hosptl_light', 15, 0, 1, 50, 0),
(10285, 496, 10285, 'hosptl_seat', 5, 0, 1, 50, 0),
(10286, 496, 10286, 'hosptl_skele', 1, 0, 1, 50, 0),
(10287, 496, 10287, 'hosptl_xray', 10, 0, 1, 50, 0),
(10289, 497, 10289, 'easel_0', 25, 0, 1, 50, 0),
(10290, 497, 10290, 'easel_1', 25, 0, 1, 50, 0),
(10291, 496, 10291, 'easel_2', 25, 0, 1, 50, 0),
(10292, 497, 10292, 'easel_3', 25, 0, 1, 50, 0),
(10293, 497, 10293, 'easel_4', 25, 0, 1, 50, 0),
(10294, 497, 10294, 'easel_2', 25, 0, 1, 50, 0),
(10350, 502, 10350, 'african_bones', 3, 0, 1, 50, 0),
(10351, 502, 10351, 'african_fence', 5, 0, 1, 50, 0),
(10352, 502, 10352, 'african_patch', 10, 0, 1, 50, 0),
(10353, 502, 10353, 'african_stage', 5, 0, 1, 50, 0),
(10354, 502, 10354, 'african_tree1', 10, 0, 1, 50, 0),
(10355, 502, 10355, 'african_tree2', 10, 0, 1, 50, 0),
(10357, 503, 10357, 'ktchn10_cabnt', 5, 0, 1, 50, 0),
(10358, 503, 10358, 'ktchn10_pot', 1, 0, 1, 50, 0),
(10359, 503, 10359, 'ktchn10_sink', 10, 0, 1, 50, 0),
(10360, 503, 10360, 'ktchn10_stove', 10, 0, 1, 50, 0),
(29910, 161, 29910, 'bw_water_2', 5, 0, 1, 50, 0),
(41082, 165, 25355, 'bw_lgchair', 8, 0, 1, 50, 0),
(41083, 165, 25359, 'bw_fin', 15, 0, 1, 50, 0),
(41084, 165, 25360, 'bw_ccnuts', 3, 0, 1, 50, 0),
(41085, 165, 25361, 'bw_shower', 6, 0, 1, 50, 0),
(41086, 165, 25362, 'bw_water_2', 10, 0, 1, 50, 0),
(41087, 165, 25363, 'bw_croc', 7, 0, 1, 50, 0),
(41088, 165, 25364, 'bw_sboard', 6, 0, 1, 50, 0),
(41089, 165, 25366, 'bw_table', 4, 0, 1, 50, 0),
(41090, 165, 25367, 'bw_ball', 11, 0, 1, 50, 0),
(41091, 165, 25368, 'bw_mttrss', 6, 0, 1, 50, 0),
(41092, 165, 25369, 'bw_van', 25, 0, 1, 50, 0),
(41094, 165, 25371, 'bw_fnc_crnr', 4, 0, 1, 50, 0),
(41095, 165, 25372, 'bw_fnc', 3, 0, 1, 50, 0),
(41097, 165, 25357, 'bw_sofa', 5, 0, 1, 50, 0),
(41098, 165, 25354, 'bw_boat', 12, 0, 1, 50, 0),
(41099, 165, 25365, 'bw_chair', 4, 0, 1, 50, 0),
(57009, 161, 29904, 'bw_chair', 4, 0, 1, 50, 0),
(57010, 161, 29903, 'bw_sboard', 2, 0, 1, 50, 0),
(57011, 161, 29909, 'bw_fnc', 2, 0, 1, 50, 0),
(57012, 161, 29901, 'bw_lgchair', 5, 0, 1, 50, 0),
(57013, 161, 29908, 'bw_croc', 4, 0, 1, 50, 0),
(57014, 161, 29907, 'bw_bball', 2, 0, 1, 50, 0),
(57015, 161, 29906, 'bw_table', 3, 0, 1, 50, 0),
(57016, 159, 29916, 'prison_crnr', 4, 0, 1, 50, 0),
(57017, 159, 29913, 'prison_dvdr1', 5, 0, 1, 50, 0),
(57018, 159, 29912, 'prison_gate', 4, 0, 1, 50, 0),
(57019, 159, 29911, 'prison_dvdr2', 5, 0, 1, 50, 0),
(57020, 159, 29914, 'prison_stone', 1, 0, 1, 50, 0),
(57021, 159, 29915, 'prison_tower', 10, 0, 1, 50, 0),
(57022, 159, 29913, 'prison_dvdr1', 20, 0, 10, 50, 0),
(57023, 159, 29911, 'prison_dvdr2', 20, 0, 10, 50, 0),
(77025, 165, 59939, 'bw_jaws', 5, 0, 1, 50, 0),
(77701, 777, 77701, 'bling11_block', 3, 0, 1, 50, 0),
(77702, 777, 77702, 'bling11_dvd', 3, 0, 1, 50, 0),
(77703, 777, 77703, 'bling11_dvn', 3, 0, 1, 50, 0),
(77704, 777, 77704, 'bling11_floor', 3, 0, 1, 50, 0),
(77705, 777, 77705, 'bling11_pillar', 3, 0, 1, 50, 0),
(77706, 777, 77706, 'bling11_plant', 3, 0, 1, 50, 0),
(77707, 777, 77707, 'bling11_rug1', 3, 0, 1, 50, 0),
(77708, 777, 77708, 'bling11_rug2', 3, 0, 1, 50, 0),
(77709, 777, 77709, 'bling11_seat1', 3, 0, 1, 50, 0),
(77710, 777, 77710, 'bling11_seat2', 3, 0, 1, 50, 0),
(77711, 777, 77711, 'bling11_slot', 3, 0, 1, 50, 0),
(77712, 777, 77712, 'bling11_sofa', 3, 0, 1, 50, 0),
(77713, 777, 77713, 'bling11_statue1', 3, 0, 1, 50, 0),
(77714, 777, 77714, 'bling11_statue2', 3, 0, 1, 50, 0),
(77715, 777, 77715, 'bling11_tele', 3, 0, 1, 50, 0),
(77716, 777, 77716, 'bling11_towels', 3, 0, 1, 50, 0),
(77717, 777, 77717, 'bling11_val11_floor', 3, 0, 1, 50, 0),
(77801, 778, 77801, 'china_rabbit', 5, 0, 1, 50, 0),
(89900, 899, 89900, 'limo_w_front', 3, 0, 1, 50, 0),
(89901, 899, 89901, 'limo_w_mid', 3, 0, 1, 50, 0),
(89902, 899, 89902, 'limo_w_mid2', 3, 0, 1, 50, 0),
(89903, 899, 89903, 'limo_w_back', 3, 0, 1, 50, 0),
(89904, 160, 89904, 'petfood19', 3, 0, 1, 50, 0),
(89905, 160, 89905, 'petfood18', 3, 0, 1, 50, 0),
(89906, 160, 89906, 'petfood17', 3, 0, 1, 50, 0),
(89907, 201, 89907, 'gothic_st_glass', 3, 0, 1, 50, 0),
(89908, 201, 89908, 'gothic_candles', 3, 0, 1, 50, 0),
(89909, 201, 89909, 'gothic_bed', 3, 0, 1, 50, 0),
(89910, 201, 89910, 'gothic_desk', 3, 0, 1, 50, 0),
(89911, 201, 89911, 'gothic_bowl', 3, 0, 1, 50, 0),
(89912, 201, 89912, 'ads_grefu_trophy', 3, 0, 1, 50, 0),
(89914, 169, 89914, 'nest_frog', 3, 0, 1, 50, 0),
(89915, 169, 89915, 'pond', 3, 0, 1, 50, 0),
(89916, 169, 89916, 'val11_present', 3, 0, 1, 50, 0),
(89917, 169, 89917, 'prizetrophy_cine', 3, 0, 1, 50, 0),
(89918, 169, 89918, 'cine_vipsign', 3, 0, 1, 50, 0),
(89919, 169, 89919, 'limo_b_mid3', 3, 0, 1, 50, 0),
(89920, 169, 89920, 'limo_b_mid2', 3, 0, 1, 50, 0),
(89921, 169, 89921, 'limo_b_front', 3, 0, 1, 50, 0),
(89922, 169, 89922, 'limo_b_mid', 3, 0, 1, 50, 0),
(89923, 169, 89923, 'cine_star', 3, 0, 1, 50, 0),
(89924, 169, 89924, 'limo_b_back', 3, 0, 1, 50, 0),
(89925, 169, 89925, 'ads_bigtv_missmix', 3, 0, 1, 50, 0),
(89926, 169, 89926, 'cine_curtain', 3, 0, 1, 50, 0),
(89927, 169, 89927, 'cine_screen', 3, 0, 1, 50, 0),
(89928, 169, 89928, 'theatre_seat_g', 3, 0, 1, 50, 0),
(89929, 169, 89929, 'cine_tile', 3, 0, 1, 50, 0),
(89930, 169, 89930, 'cine_bench_b', 3, 0, 1, 50, 0),
(89931, 169, 89931, 'theatre_seat_b', 3, 0, 1, 50, 0),
(89932, 169, 89932, 'cine_roof', 3, 0, 1, 50, 0),
(89933, 169, 89933, 'cine_popcorn', 3, 0, 1, 50, 0),
(89934, 169, 89934, 'cine_bench', 3, 0, 1, 50, 0),
(89935, 169, 89935, 'cine_bench_b', 3, 0, 1, 50, 0),
(89936, 169, 89936, 'cine_ticket_booth', 3, 0, 1, 50, 0),
(89937, 169, 89937, 'cine_projector', 3, 0, 1, 50, 0),
(89938, 173, 89938, 'wf_box', 3, 0, 1, 50, 0),
(89939, 173, 89939, 'wf_maze', 3, 0, 1, 50, 0),
(89940, 173, 89940, 'ads_rangocactus', 3, 0, 1, 50, 0),
(89941, 173, 89941, 'cine_glass', 3, 0, 1, 50, 0),
(89942, 173, 89942, 'wf_cnd_has_furni_on', 3, 0, 1, 50, 0),
(89943, 173, 89943, 'cine_light2', 3, 0, 1, 50, 0),
(89944, 173, 89944, 'cine_light1', 3, 0, 1, 50, 0),
(89945, 200, 89945, 'cubie_rug_b', 3, 0, 1, 50, 0),
(89946, 200, 89946, 'cubie_lamp_p', 3, 0, 1, 50, 0),
(89947, 200, 89947, 'cubie_shelf_3_p', 3, 0, 1, 50, 0),
(89948, 200, 89948, 'cubie_shelf_4_b', 3, 0, 1, 50, 0),
(89949, 200, 89949, 'cubie_shelf_1_b', 3, 0, 1, 50, 0),
(89950, 200, 89950, 'cubie_shelf_1_p', 3, 0, 1, 50, 0),
(89951, 200, 89951, 'cubie_chair_p', 3, 0, 1, 50, 0),
(89952, 200, 89952, 'cubie_shelf_4_p', 3, 0, 1, 50, 0),
(89953, 200, 89953, 'cubie_bigtable_p', 3, 0, 1, 50, 0),
(89954, 200, 89954, 'cubie_shelf_0_p', 3, 0, 1, 50, 0),
(89955, 200, 89955, 'cubie_beanbag_b', 3, 0, 1, 50, 0),
(89956, 200, 89956, 'cubie_chair_b', 3, 0, 1, 50, 0),
(89957, 200, 89957, 'cubie_bed_b', 3, 0, 1, 50, 0),
(89958, 200, 89958, 'cubie_bigtable_b', 3, 0, 1, 50, 0),
(89959, 200, 89959, 'cubie_stool_b', 3, 0, 1, 50, 0),
(89960, 200, 89960, 'cubie_beanbag_p', 3, 0, 1, 50, 0),
(89961, 200, 89961, 'cubie_shelf_0_b', 3, 0, 1, 50, 0),
(89962, 200, 89962, 'cubie_shelf_2_p', 3, 0, 1, 50, 0),
(89963, 200, 89963, 'cubie_rug_p', 3, 0, 1, 50, 0),
(89964, 200, 89964, 'cubie_sofaseat_b', 3, 0, 1, 50, 0),
(89965, 200, 89965, 'cubie_table', 3, 0, 1, 50, 0),
(89966, 200, 89966, 'cubie_sofaseat_p', 3, 0, 1, 50, 0),
(89967, 200, 89967, 'cubie_bed_p', 3, 0, 1, 50, 0),
(89968, 200, 89968, 'cubie_shelf_3_b', 3, 0, 1, 50, 0),
(89969, 200, 89969, 'cubie_shelf_2_b', 3, 0, 1, 50, 0),
(89970, 200, 89970, 'cubie_lamp_b', 3, 0, 1, 50, 0),
(89971, 200, 89971, 'cubie_stool_p', 3, 0, 1, 50, 0),
(89972, 200, 89972, 'cubie_wallshelf_b', 3, 0, 1, 50, 0),
(89973, 200, 89973, 'cubie_decklight_p', 3, 0, 1, 50, 0),
(89974, 200, 89974, 'cubie_wallshelf_p', 3, 0, 1, 50, 0),
(89975, 200, 89975, 'cubie_decal_0', 3, 0, 1, 50, 0),
(89976, 200, 89976, 'cubie_decal_3', 3, 0, 1, 50, 0),
(89977, 200, 89977, 'cubie_decal_1_p', 3, 0, 1, 50, 0),
(89978, 200, 89978, 'cubie_decklight_b', 3, 0, 1, 50, 0),
(89979, 200, 89979, 'cubie_decal_1_b', 3, 0, 1, 50, 0),
(89980, 200, 89980, 'cubie_decal_2_b', 3, 0, 1, 50, 0),
(89981, 200, 89981, 'cubie_decal_3_p', 3, 0, 1, 50, 0),
(89982, 200, 89982, 'cubie_decal_2_p', 3, 0, 1, 50, 0),
(89983, 200, 89983, 'cubie_decal_3_b', 3, 0, 1, 50, 0),
(89984, 175, 89984, 'newbie_present', 3, 0, 1, 50, 0),
(89985, 175, 89985, 'tv_flat', 3, 0, 1, 50, 0),
(89986, 175, 89986, 'waasa_table2', 3, 0, 1, 50, 0),
(89987, 175, 89987, 'computer_flatscreen', 3, 0, 1, 50, 0),
(89988, 175, 89988, 'waasa_chair', 3, 0, 1, 50, 0),
(89989, 175, 89989, 'waasa_ship2', 3, 0, 1, 50, 0),
(89990, 175, 89990, 'waasa_ship1', 3, 0, 1, 50, 0),
(89991, 175, 89991, 'waasa_bunk_bed', 3, 0, 1, 50, 0),
(89992, 175, 89992, 'computer_laptop', 3, 0, 1, 50, 0),
(89993, 175, 89993, 'computer_old', 3, 0, 1, 50, 0),
(89994, 175, 89994, 'waasa_table1', 3, 0, 1, 50, 0),
(89995, 175, 89995, 'waasa_desk', 3, 0, 1, 50, 0),
(89996, 175, 89996, 'waasa_wall_shelf2', 3, 0, 1, 50, 0),
(89997, 175, 89997, 'waasa_wall_shelf1', 3, 0, 1, 50, 0),
(97308, 165, 95383, 'bw_pool_a3', 5, 0, 1, 50, 0),
(97309, 165, 95382, 'bw_pool_a2', 5, 0, 1, 50, 0),
(97310, 165, 95381, 'bw_pool_b2', 5, 0, 1, 50, 0),
(97311, 165, 95380, 'bw_mttrss_g', 5, 0, 1, 50, 0),
(97312, 165, 95379, 'bw_boat_p', 5, 0, 1, 50, 0),
(97313, 165, 95378, 'bw_sofa_p', 5, 0, 1, 50, 0),
(97314, 165, 95377, 'bw_fnc_crnr_g', 5, 0, 1, 50, 0),
(97315, 165, 95376, 'bw_fnc_crnr_p', 5, 0, 1, 50, 0),
(97316, 165, 95375, 'ads_pepsi0', 5, 0, 1, 50, 0),
(97317, 165, 95374, 'ads_grefusa_surfb', 5, 0, 1, 50, 0),
(97318, 165, 95395, 'bw_fnc_g', 5, 0, 1, 50, 0),
(97319, 165, 95394, 'bw_sofa_p', 5, 0, 1, 50, 0),
(97320, 165, 95393, 'bw_sofa_g', 5, 0, 1, 50, 0),
(97321, 165, 95392, 'bw_van_g', 5, 0, 1, 50, 0),
(97322, 165, 95391, 'bw_van_p', 5, 0, 1, 50, 0),
(97323, 165, 95390, 'bw_table_p', 5, 0, 1, 50, 0),
(97324, 165, 95389, 'bw_table_g', 5, 0, 1, 50, 0),
(97326, 165, 95387, 'bw_surfb_g', 5, 0, 1, 50, 0),
(97327, 165, 95386, 'bw_fnc_crnr_p', 5, 0, 1, 50, 0),
(97328, 165, 95385, 'bw_pool_b1', 5, 0, 1, 50, 0),
(97329, 165, 95384, 'bw_pool_a1', 5, 0, 1, 50, 0),
(99000, 500, 99000, 'qt_xm10_nest', 10, 0, 1, 50, 0),
(99001, 500, 99001, 'qt_xm10_icedragon', 10, 0, 1, 50, 0),
(99002, 500, 99002, 'qt_xm10_stone', 10, 0, 1, 50, 0),
(99003, 500, 99003, 'qt_xm10_icetiger', 10, 0, 1, 50, 0),
(99004, 500, 99004, 'qt_xm10_trex', 10, 0, 1, 50, 0),
(99005, 500, 99005, 'qt_xm10_palm_tree', 10, 0, 1, 50, 0),
(99006, 500, 99006, 'qt_xm10_bench', 10, 0, 1, 50, 0),
(99007, 500, 99007, 'qt_xm10_icelupin', 10, 0, 1, 50, 0),
(99008, 500, 99008, 'qt_xm10_xmduck', 10, 0, 1, 50, 0),
(99009, 500, 99009, 'qt_xm10_iceduck', 10, 0, 1, 50, 0),
(99010, 500, 99010, 'qt_xm10_bauble1', 10, 0, 1, 50, 0),
(99011, 500, 99011, 'qt_xm10_bauble2', 10, 0, 1, 50, 0),
(99012, 500, 99012, 'qt_xm10_bauble3', 10, 0, 1, 50, 0),
(99013, 500, 99013, 'qt_xm10_iceplasto', 10, 0, 1, 50, 0),
(99014, 500, 99014, 'qt_xm10_ice_fish', 10, 0, 1, 50, 0),
(99015, 500, 99015, 'qt_xm10_gnome', 10, 0, 1, 50, 0),
(99016, 500, 99016, 'qt_xm10_icesilotable', 10, 0, 1, 50, 0),
(99017, 500, 99017, 'qt_xm10_iceteddy', 10, 0, 1, 50, 0),
(99018, 500, 99018, 'qt_xm10_elephant', 10, 0, 1, 50, 0),
(99019, 500, 99019, 'qt_xm10_iceclubsofa', 10, 0, 1, 50, 0),
(99020, 500, 99020, 'es_skating_ice', 10, 0, 1, 50, 0),
(99021, 500, 99021, 'es_sidewalk', 10, 0, 1, 50, 0),
(99022, 500, 99022, 'es_wpost', 10, 0, 1, 50, 0),
(99023, 500, 99023, 'es_tagging', 10, 0, 1, 50, 0),
(99024, 500, 99024, 'es_santa', 10, 0, 1, 50, 0),
(99025, 500, 99025, 'es_window', 10, 0, 1, 50, 0),
(99026, 500, 99026, 'es_bench', 10, 0, 1, 50, 0),
(99027, 500, 99027, 'es_fnc_1', 10, 0, 1, 50, 0),
(99028, 500, 99028, 'es_fnc_2', 10, 0, 1, 50, 0),
(99029, 500, 99029, 'es_fnc_crnr', 10, 0, 1, 50, 0),
(99030, 500, 99030, 'es_epictree', 10, 0, 1, 50, 0),
(99031, 500, 99031, 'es_icestar_g', 10, 0, 1, 50, 0),
(99032, 500, 99032, 'es_icestar_r', 10, 0, 1, 50, 0),
(99033, 500, 99033, 'es_icestar_y', 10, 0, 1, 50, 0),
(99034, 500, 99034, 'es_icestar', 10, 0, 1, 50, 0),
(99035, 500, 99035, 'es_puck', 10, 0, 1, 50, 0),
(99036, 500, 99036, 'es_roaster', 10, 0, 1, 50, 0),
(99037, 500, 99037, 'es_lmppst', 10, 0, 1, 50, 0),
(99038, 500, 99038, 'es_statue', 10, 0, 1, 50, 0),
(99060, 501, 99082, 'es_box', 10, 0, 1, 50, 0),
(99061, 501, 99083, 'es_counter', 15, 0, 1, 50, 0),
(99062, 501, 99084, 'es_exit', 5, 0, 1, 50, 0),
(99063, 501, 99085, 'es_gate_b', 4, 0, 1, 50, 0),
(99064, 501, 99086, 'es_gate_g', 4, 0, 1, 50, 0),
(99065, 501, 99087, 'es_gate_r', 4, 0, 1, 50, 0),
(99066, 501, 99088, 'es_gate_y', 4, 0, 1, 50, 0),
(99067, 501, 99091, 'es_score_b', 3, 0, 1, 50, 0),
(99068, 501, 99092, 'es_score_g', 3, 0, 1, 50, 0),
(99069, 501, 99090, 'es_score_r', 3, 0, 1, 50, 0),
(99070, 501, 99089, 'es_score_y', 3, 0, 1, 50, 0),
(99071, 501, 99083, 'es_tile', 8, 0, 1, 50, 0),
(99904, 600, 99904, 'year2011_waver_b', 25, 0, 1, 50, 0),
(99905, 600, 99905, 'year2011_waver_g', 25, 0, 1, 50, 0),
(99906, 600, 99906, 'year2011_waver_r', 25, 0, 1, 50, 0),
(99907, 600, 99907, 'year2011_waver_y', 25, 0, 1, 50, 0),
(99908, 600, 99908, 'prizetrophy_2011_y', 25, 0, 1, 50, 0),
(99909, 600, 99909, 'prizetrophy_2011_b', 25, 0, 1, 50, 0),
(99910, 600, 99910, 'prizetrophy_2011_r', 25, 0, 1, 50, 0),
(99911, 600, 99911, 'prizetrophy_2011_p', 25, 0, 1, 50, 0),
(99912, 600, 99912, 'prizetrophy_2011_g', 25, 0, 1, 50, 0),
(99913, 600, 99913, 'prizetrophy_2011_w', 25, 0, 1, 50, 0),
(99914, 600, 99914, 'year2011', 25, 0, 1, 50, 0),
(600000, 165, 25362, 'bw_water_2', 10, 0, 50, 50, 0),
(900000, 105, 416, 'rare_dragonlamp*3', 10000, 2500, 1, 50, 0),
(900001, 105, 20210, 'rare_vdoll', 8500, 4500, 1, 50, 0),
(3568424, 60, 3568405, 'exe_sensor', 3, 0, 1, 50, 0),
(3568425, 60, 3568404, 'exe_seccam', 3, 0, 1, 50, 0),
(3568426, 60, 3568403, 'exe_wrkdesk', 5, 0, 1, 50, 0),
(3568427, 60, 3568402, 'exe_glassdvdr', 5, 0, 1, 50, 0),
(3568428, 60, 3568401, 'exe_copier', 5, 0, 1, 50, 0),
(3568432, 170, 3568412, 'a0 pet8', 20000, 7500, 1, 50, 0),
(3568433, 176, 3568413, 'a0 pet11', 20000, 7500, 1, 50, 0),
(3568442, 182, 3568422, 'a0 pet10', 20000, 7500, 1, 50, 0),
(3568455, 15, 19896, 'wallpaper_single_101', 3, 0, 1, 50, 0),
(3568456, 15, 19896, 'wallpaper_single_102', 3, 0, 1, 50, 0),
(3568457, 15, 19896, 'wallpaper_single_103', 3, 0, 1, 50, 0),
(3568458, 15, 19896, 'wallpaper_single_104', 3, 0, 1, 50, 0),
(3568459, 15, 19896, 'wallpaper_single_105', 3, 0, 1, 50, 0),
(3568460, 15, 19896, 'wallpaper_single_106', 3, 0, 1, 50, 0),
(3568461, 15, 19896, 'wallpaper_single_107', 3, 0, 1, 50, 0),
(3568462, 15, 19896, 'wallpaper_single_108', 3, 0, 1, 50, 0),
(3568463, 15, 19896, 'wallpaper_single_109', 3, 0, 1, 50, 0),
(3568464, 15, 19896, 'wallpaper_single_110', 3, 0, 1, 50, 0),
(3568465, 15, 19896, 'wallpaper_single_111', 3, 0, 1, 50, 0),
(3568466, 15, 19896, 'wallpaper_single_112', 3, 0, 1, 50, 0),
(3568467, 15, 19896, 'wallpaper_single_113', 3, 0, 1, 50, 0),
(3568468, 15, 19896, 'wallpaper_single_114', 3, 0, 1, 50, 0),
(3568469, 15, 19896, 'wallpaper_single_115', 3, 0, 1, 50, 0),
(3568470, 15, 19896, 'wallpaper_single_201', 3, 0, 1, 50, 0),
(3568471, 15, 19896, 'wallpaper_single_202', 3, 0, 1, 50, 0),
(3568472, 15, 19896, 'wallpaper_single_203', 3, 0, 1, 50, 0),
(3568473, 15, 19896, 'wallpaper_single_204', 3, 0, 1, 50, 0),
(3568474, 15, 19896, 'wallpaper_single_205', 3, 0, 1, 50, 0),
(3568475, 15, 19896, 'wallpaper_single_206', 3, 0, 1, 50, 0),
(3568476, 15, 19896, 'wallpaper_single_207', 3, 0, 1, 50, 0),
(3568477, 15, 19896, 'wallpaper_single_208', 3, 0, 1, 50, 0),
(3568478, 15, 19896, 'wallpaper_single_209', 3, 0, 1, 50, 0),
(3568479, 15, 19896, 'wallpaper_single_210', 3, 0, 1, 50, 0),
(3568480, 15, 19896, 'wallpaper_single_211', 3, 0, 1, 50, 0),
(3568481, 15, 19896, 'wallpaper_single_212', 3, 0, 1, 50, 0),
(3568482, 15, 19896, 'wallpaper_single_213', 3, 0, 1, 50, 0),
(3568483, 15, 19896, 'wallpaper_single_214', 3, 0, 1, 50, 0),
(3568484, 15, 19896, 'wallpaper_single_215', 3, 0, 1, 50, 0),
(3568485, 15, 19896, 'wallpaper_single_216', 3, 0, 1, 50, 0),
(3568486, 15, 19896, 'wallpaper_single_217', 3, 0, 1, 50, 0),
(3568487, 15, 19896, 'wallpaper_single_218', 3, 0, 1, 50, 0),
(3568488, 15, 19896, 'wallpaper_single_301', 3, 0, 1, 50, 0),
(3568489, 15, 19896, 'wallpaper_single_302', 3, 0, 1, 50, 0),
(3568490, 15, 19896, 'wallpaper_single_303', 3, 0, 1, 50, 0),
(3568491, 15, 19896, 'wallpaper_single_304', 3, 0, 1, 50, 0),
(3568492, 15, 19896, 'wallpaper_single_305', 3, 0, 1, 50, 0),
(3568493, 15, 19896, 'wallpaper_single_306', 3, 0, 1, 50, 0),
(3568494, 15, 19896, 'wallpaper_single_307', 3, 0, 1, 50, 0),
(3568495, 15, 19896, 'wallpaper_single_401', 3, 0, 1, 50, 0),
(3568496, 15, 19896, 'wallpaper_single_402', 3, 0, 1, 50, 0),
(3568497, 15, 19896, 'wallpaper_single_403', 3, 0, 1, 50, 0),
(3568498, 15, 19896, 'wallpaper_single_404', 3, 0, 1, 50, 0),
(3568499, 15, 19896, 'wallpaper_single_405', 3, 0, 1, 50, 0),
(3568500, 15, 19896, 'wallpaper_single_406', 3, 0, 1, 50, 0),
(3568501, 15, 19896, 'wallpaper_single_407', 3, 0, 1, 50, 0),
(3568502, 15, 19896, 'wallpaper_single_408', 3, 0, 1, 50, 0),
(3568503, 15, 19896, 'wallpaper_single_501', 3, 0, 1, 50, 0),
(3568504, 15, 19896, 'wallpaper_single_502', 3, 0, 1, 50, 0),
(3568505, 15, 19896, 'wallpaper_single_503', 3, 0, 1, 50, 0),
(3568506, 15, 19896, 'wallpaper_single_504', 3, 0, 1, 50, 0),
(3568507, 15, 19896, 'wallpaper_single_505', 3, 0, 1, 50, 0),
(3568508, 15, 19896, 'wallpaper_single_506', 3, 0, 1, 50, 0),
(3568509, 15, 19896, 'wallpaper_single_507', 3, 0, 1, 50, 0),
(3568510, 15, 19896, 'wallpaper_single_508', 3, 0, 1, 50, 0),
(3568511, 15, 19896, 'wallpaper_single_601', 3, 0, 1, 50, 0),
(3568512, 15, 19896, 'wallpaper_single_602', 3, 0, 1, 50, 0),
(3568513, 15, 19896, 'wallpaper_single_603', 3, 0, 1, 50, 0),
(3568514, 15, 19896, 'wallpaper_single_604', 3, 0, 1, 50, 0),
(3568515, 15, 19896, 'wallpaper_single_605', 3, 0, 1, 50, 0),
(3568516, 15, 19896, 'wallpaper_single_606', 3, 0, 1, 50, 0),
(3568517, 15, 19896, 'wallpaper_single_607', 3, 0, 1, 50, 0),
(3568518, 15, 19896, 'wallpaper_single_608', 3, 0, 1, 50, 0),
(3568519, 15, 19896, 'wallpaper_single_609', 3, 0, 1, 50, 0),
(3568520, 15, 19896, 'wallpaper_single_610', 3, 0, 1, 50, 0),
(3568521, 15, 19896, 'wallpaper_single_701', 3, 0, 1, 50, 0),
(3568522, 15, 19896, 'wallpaper_single_702', 3, 0, 1, 50, 0),
(3568523, 15, 19896, 'wallpaper_single_703', 3, 0, 1, 50, 0),
(3568524, 15, 19896, 'wallpaper_single_704', 3, 0, 1, 50, 0),
(3568525, 15, 19896, 'wallpaper_single_705', 3, 0, 1, 50, 0),
(3568526, 15, 19896, 'wallpaper_single_706', 3, 0, 1, 50, 0),
(3568527, 15, 19896, 'wallpaper_single_707', 3, 0, 1, 50, 0),
(3568528, 15, 19896, 'wallpaper_single_708', 3, 0, 1, 50, 0),
(3568529, 15, 19896, 'wallpaper_single_709', 3, 0, 1, 50, 0),
(3568530, 15, 19896, 'wallpaper_single_710', 3, 0, 1, 50, 0),
(3568531, 15, 19896, 'wallpaper_single_801', 3, 0, 1, 50, 0),
(3568532, 15, 19896, 'wallpaper_single_802', 3, 0, 1, 50, 0),
(3568533, 15, 19896, 'wallpaper_single_803', 3, 0, 1, 50, 0),
(3568534, 15, 19896, 'wallpaper_single_804', 3, 0, 1, 50, 0),
(3568535, 15, 19896, 'wallpaper_single_805', 3, 0, 1, 50, 0),
(3568536, 15, 19896, 'wallpaper_single_806', 3, 0, 1, 50, 0),
(3568537, 15, 19896, 'wallpaper_single_807', 3, 0, 1, 50, 0),
(3568538, 15, 19896, 'wallpaper_single_808', 3, 0, 1, 50, 0),
(3568539, 15, 19896, 'wallpaper_single_809', 3, 0, 1, 50, 0),
(3568540, 15, 19896, 'wallpaper_single_810', 3, 0, 1, 50, 0),
(3568541, 15, 19896, 'wallpaper_single_901', 3, 0, 1, 50, 0),
(3568542, 15, 19896, 'wallpaper_single_902', 3, 0, 1, 50, 0),
(3568543, 15, 19896, 'wallpaper_single_903', 3, 0, 1, 50, 0),
(3568544, 15, 19896, 'wallpaper_single_904', 3, 0, 1, 50, 0),
(3568545, 15, 19896, 'wallpaper_single_905', 3, 0, 1, 50, 0),
(3568546, 15, 19896, 'wallpaper_single_906', 3, 0, 1, 50, 0),
(3568547, 15, 19896, 'wallpaper_single_907', 3, 0, 1, 50, 0),
(3568548, 15, 19896, 'wallpaper_single_908', 3, 0, 1, 50, 0),
(3568549, 15, 19896, 'wallpaper_single_1001', 3, 0, 1, 50, 0),
(3568550, 15, 19896, 'wallpaper_single_1002', 3, 0, 1, 50, 0),
(3568551, 15, 19896, 'wallpaper_single_1003', 3, 0, 1, 50, 0),
(3568552, 15, 19896, 'wallpaper_single_1004', 3, 0, 1, 50, 0),
(3568553, 15, 19896, 'wallpaper_single_1005', 3, 0, 1, 50, 0),
(3568554, 15, 19896, 'wallpaper_single_1006', 3, 0, 1, 50, 0),
(3568555, 15, 19896, 'wallpaper_single_1007', 3, 0, 1, 50, 0),
(3568556, 15, 19896, 'wallpaper_single_1101', 3, 0, 1, 50, 0),
(3568557, 15, 19896, 'wallpaper_single_1201', 3, 0, 1, 50, 0),
(3568558, 15, 19896, 'wallpaper_single_1301', 3, 0, 1, 50, 0),
(3568559, 15, 19896, 'wallpaper_single_1401', 3, 0, 1, 50, 0),
(3568560, 15, 19896, 'wallpaper_single_1501', 3, 0, 1, 50, 0),
(3568561, 15, 19896, 'wallpaper_single_1601', 3, 0, 1, 50, 0),
(3568562, 15, 19896, 'wallpaper_single_1701', 3, 0, 1, 50, 0),
(3568563, 15, 19896, 'wallpaper_single_1801', 3, 0, 1, 50, 0),
(3568564, 15, 19896, 'wallpaper_single_1901', 3, 0, 1, 50, 0),
(3568565, 15, 19896, 'wallpaper_single_1902', 3, 0, 1, 50, 0),
(3568566, 15, 19896, 'wallpaper_single_2001', 3, 0, 1, 50, 0),
(3568567, 15, 19896, 'wallpaper_single_2002', 3, 0, 1, 50, 0),
(3568568, 15, 19896, 'wallpaper_single_2003', 3, 0, 1, 50, 0),
(3568569, 15, 19896, 'wallpaper_single_2101', 3, 0, 1, 50, 0),
(3568570, 15, 19896, 'wallpaper_single_2102', 3, 0, 1, 50, 0),
(3568571, 15, 19896, 'wallpaper_single_2103', 3, 0, 1, 50, 0),
(3568572, 15, 19896, 'wallpaper_single_2201', 3, 0, 1, 50, 0),
(3568573, 15, 19896, 'wallpaper_single_2202', 3, 0, 1, 50, 0),
(3568574, 15, 19896, 'wallpaper_single_2203', 3, 0, 1, 50, 0),
(3568575, 15, 19896, 'wallpaper_single_2204', 3, 0, 1, 50, 0),
(3568576, 15, 19896, 'wallpaper_single_2205', 3, 0, 1, 50, 0),
(3568577, 15, 19896, 'wallpaper_single_2206', 3, 0, 1, 50, 0),
(3568578, 15, 19896, 'wallpaper_single_2301', 3, 0, 1, 50, 0),
(3568579, 15, 19896, 'wallpaper_single_2302', 3, 0, 1, 50, 0),
(3568580, 15, 19896, 'wallpaper_single_2303', 3, 0, 1, 50, 0),
(3568581, 15, 19896, 'wallpaper_single_2304', 3, 0, 1, 50, 0),
(3568582, 15, 19896, 'wallpaper_single_2401', 3, 0, 1, 50, 0),
(3568583, 15, 19896, 'wallpaper_single_2402', 3, 0, 1, 50, 0),
(3568584, 15, 19896, 'wallpaper_single_2403', 3, 0, 1, 50, 0),
(3568585, 15, 19896, 'wallpaper_single_2501', 3, 0, 1, 50, 0),
(3568586, 15, 19896, 'wallpaper_single_2502', 3, 0, 1, 50, 0),
(3568587, 15, 19896, 'wallpaper_single_2503', 3, 0, 1, 50, 0),
(3568588, 15, 19896, 'wallpaper_single_2504', 3, 0, 1, 50, 0),
(3568589, 15, 19896, 'wallpaper_single_2601', 3, 0, 1, 50, 0),
(3568590, 15, 19896, 'wallpaper_single_2602', 3, 0, 1, 50, 0),
(3568591, 15, 19896, 'wallpaper_single_2603', 3, 0, 1, 50, 0),
(3568592, 15, 19896, 'wallpaper_single_2604', 3, 0, 1, 50, 0),
(3568593, 15, 19896, 'wallpaper_single_2701', 3, 0, 1, 50, 0),
(3568594, 15, 19896, 'wallpaper_single_2702', 3, 0, 1, 50, 0),
(3568595, 15, 19896, 'wallpaper_single_2703', 3, 0, 1, 50, 0),
(3568596, 15, 19896, 'wallpaper_single_2704', 3, 0, 1, 50, 0),
(3568597, 15, 19896, 'wallpaper_single_2801', 3, 0, 1, 50, 0),
(3568598, 15, 19896, 'wallpaper_single_2802', 3, 0, 1, 50, 0),
(3568599, 15, 19896, 'wallpaper_single_2803', 3, 0, 1, 50, 0),
(3568600, 15, 19896, 'wallpaper_single_2804', 3, 0, 1, 50, 0),
(3568601, 15, 19896, 'wallpaper_single_2901', 3, 0, 1, 50, 0),
(3568602, 15, 19896, 'wallpaper_single_2902', 3, 0, 1, 50, 0),
(3568603, 15, 19896, 'wallpaper_single_2903', 3, 0, 1, 50, 0),
(3568604, 15, 19896, 'wallpaper_single_2904', 3, 0, 1, 50, 0),
(3568605, 15, 19896, 'wallpaper_single_3001', 3, 0, 1, 50, 0),
(3568606, 15, 19896, 'wallpaper_single_3002', 3, 0, 1, 50, 0),
(3568607, 15, 19896, 'wallpaper_single_3003', 3, 0, 1, 50, 0),
(3568608, 15, 19896, 'wallpaper_single_3004', 3, 0, 1, 50, 0),
(3568609, 15, 19896, 'wallpaper_single_3101', 3, 0, 1, 50, 0),
(3568610, 15, 19896, 'wallpaper_single_3102', 3, 0, 1, 50, 0),
(3568611, 15, 19896, 'wallpaper_single_3103', 3, 0, 1, 50, 0),
(3568612, 15, 19896, 'wallpaper_single_3104', 3, 0, 1, 50, 0),
(3568613, 15, 19896, 'wallpaper_single_3105', 3, 0, 1, 50, 0),
(3568614, 15, 19896, 'wallpaper_single_3106', 3, 0, 1, 50, 0),
(3568615, 15, 19894, 'floor_single_101', 4, 0, 1, 50, 0),
(3568616, 15, 19894, 'floor_single_102', 4, 0, 1, 50, 0),
(3568617, 15, 19894, 'floor_single_103', 4, 0, 1, 50, 0),
(3568618, 15, 19894, 'floor_single_104', 4, 0, 1, 50, 0),
(3568619, 15, 19894, 'floor_single_105', 4, 0, 1, 50, 0),
(3568620, 15, 19894, 'floor_single_106', 4, 0, 1, 50, 0),
(3568621, 15, 19894, 'floor_single_107', 4, 0, 1, 50, 0),
(3568622, 15, 19894, 'floor_single_108', 4, 0, 1, 50, 0),
(3568623, 15, 19894, 'floor_single_109', 4, 0, 1, 50, 0),
(3568624, 15, 19894, 'floor_single_110', 4, 0, 1, 50, 0),
(3568625, 15, 19894, 'floor_single_111', 4, 0, 1, 50, 0),
(3568626, 15, 19894, 'floor_single_201', 4, 0, 1, 50, 0),
(3568627, 15, 19894, 'floor_single_202', 4, 0, 1, 50, 0),
(3568628, 15, 19894, 'floor_single_203', 4, 0, 1, 50, 0),
(3568629, 15, 19894, 'floor_single_204', 4, 0, 1, 50, 0),
(3568630, 15, 19894, 'floor_single_205', 4, 0, 1, 50, 0),
(3568631, 15, 19894, 'floor_single_206', 4, 0, 1, 50, 0),
(3568632, 15, 19894, 'floor_single_207', 4, 0, 1, 50, 0),
(3568633, 15, 19894, 'floor_single_208', 4, 0, 1, 50, 0),
(3568634, 15, 19894, 'floor_single_209', 4, 0, 1, 50, 0),
(3568635, 15, 19894, 'floor_single_210', 4, 0, 1, 50, 0),
(3568636, 15, 19894, 'floor_single_211', 4, 0, 1, 50, 0),
(3568637, 15, 19894, 'floor_single_212', 4, 0, 1, 50, 0),
(3568638, 15, 19894, 'floor_single_301', 4, 0, 1, 50, 0),
(3568639, 15, 19894, 'floor_single_302', 4, 0, 1, 50, 0),
(3568640, 15, 19894, 'floor_single_303', 4, 0, 1, 50, 0),
(3568641, 15, 19894, 'floor_single_304', 4, 0, 1, 50, 0),
(3568642, 15, 19894, 'floor_single_305', 4, 0, 1, 50, 0),
(3568643, 15, 19894, 'floor_single_306', 4, 0, 1, 50, 0),
(3568644, 15, 19894, 'floor_single_307', 4, 0, 1, 50, 0),
(3568645, 15, 19894, 'floor_single_401', 4, 0, 1, 50, 0),
(3568646, 15, 19894, 'floor_single_402', 4, 0, 1, 50, 0),
(3568647, 15, 19894, 'floor_single_403', 4, 0, 1, 50, 0),
(3568648, 15, 19894, 'floor_single_404', 4, 0, 1, 50, 0),
(3568649, 15, 19894, 'floor_single_405', 4, 0, 1, 50, 0),
(3568650, 15, 19894, 'floor_single_406', 4, 0, 1, 50, 0),
(3568651, 15, 19894, 'floor_single_407', 4, 0, 1, 50, 0),
(3568652, 15, 19894, 'floor_single_408', 4, 0, 1, 50, 0),
(3568653, 15, 19894, 'floor_single_409', 4, 0, 1, 50, 0),
(3568654, 15, 19894, 'floor_single_501', 4, 0, 1, 50, 0),
(3568655, 15, 19894, 'floor_single_502', 4, 0, 1, 50, 0),
(3568656, 15, 19894, 'floor_single_503', 4, 0, 1, 50, 0),
(3568657, 15, 19894, 'floor_single_504', 4, 0, 1, 50, 0),
(3568658, 15, 19894, 'floor_single_505', 4, 0, 1, 50, 0),
(3568659, 15, 19894, 'floor_single_506', 4, 0, 1, 50, 0),
(3568660, 15, 19894, 'floor_single_507', 4, 0, 1, 50, 0),
(3568661, 15, 19894, 'floor_single_601', 4, 0, 1, 50, 0),
(3568662, 15, 19894, 'floor_single_602', 4, 0, 1, 50, 0),
(3568663, 15, 19894, 'floor_single_603', 4, 0, 1, 50, 0),
(3568664, 15, 19894, 'floor_single_604', 4, 0, 1, 50, 0),
(3568665, 15, 19894, 'floor_single_605', 4, 0, 1, 50, 0),
(3568666, 15, 19894, 'floor_single_606', 4, 0, 1, 50, 0),
(3568667, 15, 19894, 'floor_single_607', 4, 0, 1, 50, 0),
(3568668, 15, 19894, 'floor_single_608', 4, 0, 1, 50, 0),
(3568669, 15, 19894, 'floor_single_609', 4, 0, 1, 50, 0),
(3568670, 15, 19894, 'floor_single_610', 4, 0, 1, 50, 0),
(3568671, 15, 19926, 'landscape_single_1.1', 10, 0, 1, 50, 0),
(3568672, 15, 19926, 'landscape_single_1.2', 10, 0, 1, 50, 0),
(3568673, 15, 19926, 'landscape_single_1.3', 10, 0, 1, 50, 0),
(3568674, 15, 19926, 'landscape_single_1.4', 10, 0, 1, 50, 0),
(3568675, 15, 19926, 'landscape_single_1.5', 10, 0, 1, 50, 0),
(3568676, 15, 19926, 'landscape_single_1.6', 10, 0, 1, 50, 0),
(3568677, 15, 19926, 'landscape_single_1.7', 10, 0, 1, 50, 0),
(3568678, 15, 19926, 'landscape_single_1.8', 10, 0, 1, 50, 0),
(3568679, 15, 19926, 'landscape_single_1.9', 10, 0, 1, 50, 0),
(3568680, 15, 19926, 'landscape_single_1.10', 10, 0, 1, 50, 0),
(3568681, 15, 19926, 'landscape_single_1.11', 10, 0, 1, 50, 0),
(3568682, 15, 19926, 'landscape_single_2.1', 10, 0, 1, 50, 0),
(3568683, 15, 19926, 'landscape_single_2.3', 10, 0, 1, 50, 0),
(3568684, 15, 19926, 'landscape_single_2.4', 10, 0, 1, 50, 0),
(3568685, 15, 19926, 'landscape_single_2.5', 10, 0, 1, 50, 0),
(3568686, 15, 19926, 'landscape_single_2.6', 10, 0, 1, 50, 0),
(3568687, 15, 19926, 'landscape_single_2.7', 10, 0, 1, 50, 0),
(3568688, 15, 19926, 'landscape_single_3.1', 10, 0, 1, 50, 0),
(3568689, 15, 19926, 'landscape_single_3.3', 10, 0, 1, 50, 0),
(3568690, 15, 19926, 'landscape_single_3.4', 10, 0, 1, 50, 0),
(3568691, 15, 19926, 'landscape_single_3.5', 10, 0, 1, 50, 0),
(3568692, 15, 19926, 'landscape_single_3.6', 10, 0, 1, 50, 0),
(3568693, 15, 19926, 'landscape_single_3.7', 10, 0, 1, 50, 0),
(3568694, 15, 19926, 'landscape_single_4.1', 10, 0, 1, 50, 0),
(3568695, 15, 19926, 'landscape_single_4.3', 10, 0, 1, 50, 0),
(3568696, 15, 19926, 'landscape_single_4.4', 10, 0, 1, 50, 0),
(3568697, 15, 19926, 'landscape_single_4.5', 10, 0, 1, 50, 0),
(3568698, 15, 19926, 'landscape_single_4.6', 10, 0, 1, 50, 0),
(3568699, 15, 19926, 'landscape_single_4.7', 10, 0, 1, 50, 0),
(3568700, 15, 19926, 'landscape_single_5.1', 10, 0, 1, 50, 0),
(3568701, 15, 19926, 'landscape_single_5.3', 10, 0, 1, 50, 0),
(3568702, 15, 19926, 'landscape_single_5.4', 10, 0, 1, 50, 0),
(3568703, 15, 19926, 'landscape_single_5.5', 10, 0, 1, 50, 0),
(3568704, 15, 19926, 'landscape_single_5.6', 10, 0, 1, 50, 0),
(3568705, 15, 19926, 'landscape_single_5.7', 10, 0, 1, 50, 0),
(3568706, 15, 19926, 'landscape_single_6.1', 10, 0, 1, 50, 0),
(3568707, 15, 19926, 'landscape_single_6.3', 10, 0, 1, 50, 0),
(3568708, 15, 19926, 'landscape_single_6.4', 10, 0, 1, 50, 0),
(3568709, 15, 19926, 'landscape_single_6.5', 10, 0, 1, 50, 0),
(3568710, 15, 19926, 'landscape_single_6.6', 10, 0, 1, 50, 0),
(3568711, 15, 19926, 'landscape_single_6.7', 10, 0, 1, 50, 0),
(3568712, 15, 19926, 'landscape_single_7.1', 10, 0, 1, 50, 0),
(3568713, 15, 19926, 'landscape_single_7.3', 10, 0, 1, 50, 0),
(3568714, 15, 19926, 'landscape_single_7.4', 10, 0, 1, 50, 0),
(3568715, 15, 19926, 'landscape_single_7.5', 10, 0, 1, 50, 0),
(3568716, 15, 19926, 'landscape_single_7.6', 10, 0, 1, 50, 0),
(3568717, 15, 19926, 'landscape_single_7.7', 10, 0, 1, 50, 0),
(3568718, 15, 19926, 'landscape_single_7.12', 10, 0, 1, 50, 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `catalog_marketplace_offers`
--

CREATE TABLE IF NOT EXISTS `catalog_marketplace_offers` (
  `offer_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `item_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `asking_price` int(11) NOT NULL,
  `total_price` int(11) NOT NULL DEFAULT '0',
  `public_name` text NOT NULL,
  `sprite_id` int(11) NOT NULL,
  `item_type` enum('1','2') NOT NULL DEFAULT '1',
  `timestamp` double NOT NULL,
  `state` enum('1','2') NOT NULL DEFAULT '1',
  `extra_data` text NOT NULL,
  PRIMARY KEY (`offer_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `catalog_pages`
--

CREATE TABLE IF NOT EXISTS `catalog_pages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT '-1',
  `caption` varchar(100) NOT NULL,
  `icon_color` int(11) NOT NULL DEFAULT '1',
  `icon_image` int(11) NOT NULL DEFAULT '1',
  `visible` enum('0','1') NOT NULL DEFAULT '1',
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  `min_rank` int(10) unsigned NOT NULL DEFAULT '1',
  `club_only` enum('0','1') NOT NULL DEFAULT '0',
  `coming_soon` enum('0','1') NOT NULL DEFAULT '0',
  `order_num` int(11) NOT NULL,
  `page_layout` enum('default_3x3','club_buy','frontpage','spaces','recycler','recycler_info','recycler_prizes','trophies','plasto','marketplace','marketplace_own_items','pets','pets2','spaces_new','soundmachine') NOT NULL DEFAULT 'default_3x3',
  `page_headline` text NOT NULL,
  `page_teaser` text NOT NULL,
  `page_special` text NOT NULL,
  `page_text1` text NOT NULL,
  `page_text2` text NOT NULL,
  `page_text_details` text NOT NULL,
  `page_text_teaser` text NOT NULL,
  `text3` text NOT NULL,
  `link` text NOT NULL,
  `mobile_frntpg` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=917 ;

--
-- Volcado de datos para la tabla `catalog_pages`
--

INSERT INTO `catalog_pages` (`id`, `parent_id`, `caption`, `icon_color`, `icon_image`, `visible`, `enabled`, `min_rank`, `club_only`, `coming_soon`, `order_num`, `page_layout`, `page_headline`, `page_teaser`, `page_special`, `page_text1`, `page_text2`, `page_text_details`, `page_text_teaser`, `text3`, `link`, `mobile_frntpg`) VALUES
(1, -1, 'Startpagina', 6, 1, '1', '1', 1, '0', '0', -1, 'frontpage', 'catalog_frontpage_headline2_en', '', '', 'Habbo.vg Catalouge!', 'Welkom in de catalogue van Nablo Hotel. Hier vind je alle meubels voor je Kamer!', 'Voucher Codes released by a staff can be redeemed under here:', '', '', '', ''),
(3, -1, 'Furni Shop', 3, 2, '1', '0', 1, '0', '0', -1, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(4, -1, 'Pixel Shop', 5, 5, '1', '0', 1, '0', '0', -1, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(5, -1, 'Habbo Club', 7, 75, '1', '1', 1, '0', '0', -1, 'club_buy', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(6, -1, 'Trax Shop', 4, 4, '0', '0', 1, '0', '1', -1, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(8, 5, 'Club Furniture', 1, 75, '1', '1', 1, '1', '0', 5, 'default_3x3', 'catalog_club_headline1', 'catalog_hc_teaser', '', 'We''ve got all that exclusive club furniture available for you right here .. but for an exclusive price.', '', '', '', '', '', ''),
(9, -1, 'Ecotron', 3, 7, '1', '0', 1, '0', '0', -1, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(10, 9, 'Ecotron', 1, 7, '1', '1', 1, '0', '0', 9, 'recycler', 'catalog_recycler_headline3', 'ctlg_ecotron_image', '', 'Become an Eco-warrior!', 'Recycle your worthless stuff and be rewarded with a random prize. Check out the prizes and the instructions for recycling.', 'Drag 5 items to the boxes below and click recycle!', '', '', '', ''),
(11, 9, 'Rewards', 1, 26, '1', '1', 1, '0', '0', 9, 'recycler_prizes', 'catalog_recycler_headline3', '', '', 'What are the prizes? Ecotron box may contain one of these:', '', '', '', '', '', ''),
(12, 9, 'Instructions', 1, 42, '1', '1', 1, '0', '0', 9, 'recycler_info', 'catalog_recycler_headline3', 'ctlg_ecotron_box', '', 'The Ecotron is a furni recycler. Get rid of old furni... what will you get in return? It''s a surprise! Become a Habbo eco-warrior. No refunds!', 'How to use the Ecotron?', '1. Just drag 5 items from your hand to the Ecotron. One item / square. Recyclable items are marked in your inventory with an image. When you have 5 items in the boxes, click the "Recycle" button. You can now find the Ecotron prize box from your hand.\r\n\r\n2. Click the box to see its tag. Open the box, or trade it unopened. The timer shows you how long you have to wait before you can recycle more items. Check the prizes before you recycle- don''t be surprised by the surprise!', '', '', '', ''),
(13, -1, 'Habbo Exchange', 11, 6, '1', '1', 1, '0', '0', 45, 'default_3x3', 'catalog_bank_headline1', 'catalog_bank_teaser', 'catalog_special_txtbg1', 'You can exchange your Habbo credits here for Exchange furniture, which you can use in a trade or simply exchange for actual credits.', '', 'Click on an item to see more details.', 'Gold! Glorious Gold!', '', '', ''),
(14, -1, 'Pets Shop', 2, 8, '1', '1', 1, '0', '0', -1, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '0', '', ''),
(15, 3, 'Spaces', 1, 55, '1', '1', 1, '0', '0', 1, 'spaces_new', 'catalog_spaces_headline1', '', '', 'Floors, wallpapers and landscapes - get a groovy combination for your room! Use our sample room below to try before you buy! Select your favourite designs and colours and simply click Buy!', '', '', '', '', '', ''),
(24, 3, 'Windows', 0, 63, '1', '1', 1, '0', '0', 1, 'default_3x3', 'ctlg_windows_headline1_en', 'ctlg_windows_teaser1_en', 'catalog_special_txtbg2', 'Let some light in! Our windows come in many unique styles to give an exciting look to your room. Buy landscapes to go with your windows from the ''Spaces'' page!', '', 'Click on an item for more information.', 'Ooh, new view!', '', '', ''),
(26, 3, 'Moodlights', 0, 40, '1', '1', 1, '0', '0', 46, 'default_3x3', 'catalog_dimmers_header_en', 'dimmers_teaser', '', 'Our range of moodlights allow you to control the atmosphere and transform your room in just a click. What will your room look like? Click the switch and find out now!', '', 'Click on an item for more information.', '', '', '', ''),
(27, 3, 'Christmas', 1, 64, '1', '1', 1, '0', '0', 16, 'default_3x3', 'catalog_xmas_headline1', 'xmas2009_catalogue', 'catalog_special_txtbg2', 'Get yourself into the Christmas spirit with our selection of festive furni! From baubles to Reindeer poo, we''ve got it all!', '', 'Click on an item for more information.', '''tis the season!', '', '', ''),
(28, 3, 'Artic', 0, 13, '1', '1', 1, '0', '0', 6, 'default_3x3', 'catalog_arc_header1_en', 'catalog_arc_teaser1_en', '', 'Stay cool (or warm with out campfire!) with and create your own Winter Wonderland or Humble Homeland for your Penguins.', '', 'Click on an item for more information.', '', '', '', ''),
(29, 3, 'Teleporters', 0, 58, '1', '1', 1, '0', '0', 4, 'default_3x3', 'catalog_doors_headline1', 'catalog_door_a', 'catalog_special_txtbg1', 'Take your room to a whole new level with our range of space age teleporters! Just buy a pair, put one in each room and voila! You''ll have two linked rooms!', '', 'Click on an item for more information.', 'Take your room to the next level!', '', '', ''),
(30, 3, 'Mode', 0, 39, '1', '1', 1, '0', '0', 45, 'default_3x3', 'catalog_mode_headline1', 'catalog_mode_teaser1', 'catalog_special_txtbg2', 'Steely, grey industrial standard metal with a sleek design. The perfect range for a streetwise city dweller.', '', 'Click on an item for more information.', 'So shiny and new..', '', '', ''),
(31, 3, 'Candy', 0, 19, '1', '1', 1, '0', '0', 14, 'default_3x3', 'catalog_candy_headline1', 'catalog_candy_teaser1', 'catalog_special_txtbg2', 'A bit more feminine than ''Mode'', this will add a bit of glamour and glitz to your rooms. Lacking a few items? Head on over to the ''Mode'' catagory!', '', 'Click on an item for more information.', 'Look its a pink bear! ', '', '', ''),
(32, 3, 'Pura', 0, 48, '1', '1', 1, '0', '0', 57, 'default_3x3', 'catalog_pura_headline1', 'catalog_pura_teaser1', 'catalog_special_txtbg2', 'The clenest, freshest range. You can almost hear it breath cool and tranquility within your room. Use it to create a haven away from the hetic lifestyle of HabboHotel.', '', 'Click on an item for more information.', 'So many colors!', '', '', ''),
(33, 3, 'Area', 0, 14, '1', '1', 1, '0', '0', 5, 'default_3x3', 'catalog_area_headline1', 'catalog_area_teaser1', 'catalog_special_txtbg2', 'A chunky and sofisticated line for the down-to-earth, studious Habbo. It''s simplicty is beautful and will add a welcoming charm to every room.', '', 'Click on an item for more information.', 'Beautiful in it''s simplicity! ', '', '', ''),
(34, 3, 'Country', 0, 21, '1', '1', 1, '0', '0', 18, 'default_3x3', 'country_header1_en_001', 'country_teaser1', 'catalog_special_txtbg2', 'Lets leave the busy city streets and head over to the wide abyss of golden whear, emerald fields and home grown, organic vegetables. Everything you need to create a farm!', '', 'Click on an item for more information.', 'Who''d be a crow, eh?', '', '', ''),
(35, 3, 'Lodge', 0, 37, '1', '1', 1, '0', '0', 40, 'default_3x3', 'catalog_lodge_headline1', 'catalog_lodge_teaser1', 'catalog_special_txtbg2', 'For that splendid ski-lodge effect with an open fire and whisky on the sidebar. This range is for those who appreicate the true beauty of solid wood.', '', 'Click on an item for more information.', 'I like wood!', '', '', ''),
(36, 3, 'Plastic', 0, 46, '1', '1', 1, '0', '0', 55, 'plasto', 'catalog_plasto_headline1', '', '', 'Throw on an afro and grab a disco ball! Feel that retro, 1970s vibe? You soon will with this colourful, plastic range! Choose a colour to suit your mood and off you go!', '', 'Click on an item for more information.', '', '', '', ''),
(37, 3, 'Kitchen', 0, 43, '1', '1', 1, '0', '0', 38, 'default_3x3', 'kitchen_header_en', 'kitchen_teaser_en', 'catalog_special_txtbg2', 'Hygiene, hygiene, hygiene! With this new range you can keep your meat chilled and vegetables stored correctly! Just watch out for that dreaded Health Inspector...', '', 'Click on an item for more information.', 'Choccy mouse you say?', '', '', ''),
(38, 3, 'Bathroom', 0, 17, '1', '1', 1, '0', '0', 9, 'default_3x3', 'catalog_bath_headline1', 'catalog_bath_teaser1', 'catalog_special_txtbg2', 'Lets face it.. you can''t live without your bathroom. Give yours guests somewhere to freshen up with our cheeful bathroom collection!', '', 'Click on an item for more information.', 'Every Habbo needs one!', '', '', ''),
(39, 3, 'Plants', 0, 45, '1', '1', 1, '0', '0', 54, 'default_3x3', 'catalog_plants_headline1', 'catalog_plants_teaser1', 'catalog_special_txtbg2', 'Every room needs some greenery, dear! Not only do they enhance the air quality, they cheer up a room to make it simply splendid! And what better gift for a friend than an elegant rose..', '', 'Click on an item for more information.', 'I''m a tree!', '', '', ''),
(40, 3, 'Rugs', 0, 52, '1', '1', 1, '0', '0', 61, 'default_3x3', 'catalog_rugs_headline1', 'catalog_rugs_teaser1', 'catalog_special_txtbg2', 'Rugs for all occasions, white for weddings, black for funerals and everything in between! All rugs and non-slip and machine washable. Take your pick!', '', 'Click on an item for more information.', 'This''ll be perfect in my room!', '', '', ''),
(41, 3, 'Gallery', 0, 47, '1', '1', 1, '0', '0', 26, 'default_3x3', 'catalog_gallery_headline1', 'catalog_posters_teaser1', 'catalog_special_txtbg2', 'Adorn your walls with posters, art, plaques and wall hangings. This gallery is bursting with items to suit all tastes, traditional and modern!', '', 'Click on an item for more information.', 'Brighten up your walls!', '', '', ''),
(42, 3, 'Trophies', 0, 60, '1', '1', 1, '0', '0', 73, 'trophies', 'catalog_trophies_headline1', '', '', 'Everyone a winner with Habbo trophies! Now you can reward all your friends with our pre-polished array of trohpies. In bronze, silver and gold. \r\nFirst choose your trophy model, then the metal and carefully type your inscription. Don''t worry, we''ll engrave it all with your name and the date.', '', 'Click on an item for more information.', '', '', '', ''),
(43, 3, 'Accessories', 0, 11, '1', '1', 1, '0', '0', 5, 'default_3x3', 'catalog_extra_headline1', 'catalog_extra_teaser1', 'catalog_special_txtbg2', 'However you like to place your essentials, its the finishing touches that really make a room and express your true personality. Don''t forget, like anything else, you can move them all about to suit your mood!', '', 'Click on an item for more information.', 'I love my rabbit...', '', '', ''),
(45, 4, 'Rentals', 0, 44, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_pixelrent_headline1_en', 'catalog_pxl_teaser3_en', '', 'Hire some cool effects to add an explosive touch to your room. From bubbles to firestarters, you can enhance your room dramatically!', '', 'Click on an item for more information.', '', '', '', ''),
(58, 3, 'Lost City', 0, 18, '1', '1', 1, '0', '0', 41, 'default_3x3', 'catalog_lc_headline2_en', '', '', 'Under the seaaaaaaaaa, oh, Under the seaaaaaa! What will your underwater world look like? We have it all here, crabs, HIV and genital warts!', '', 'Click on an item for more information.', '', '', '', ''),
(59, 3, 'Easter', 0, 25, '1', '1', 1, '0', '0', 21, 'default_3x3', 'catalog_easter_headline1', 'catalog_easter_teaser1', '', 'Little birdies hatching from their eggs, pretty, dainty flowers blooming and cute rabbits bouncy in Spring meadows. Some Chicks are also in the Pet Section! ;)', '', 'Click on an item for more information.', '', '', '', ''),
(60, 3, 'Executive', 0, 27, '1', '1', 1, '0', '0', 23, 'default_3x3', 'catalog_exe_headline1_en', 'catalog_exe_teaser1_no', '', 'For the ultimate business man, the Executive range with its leather seats and Italian coffee is a dream! How about you try the easy lifestyle?', '', 'Click on an item for more information.', '', '', '', ''),
(61, 3, 'Glass', 0, 29, '1', '1', 1, '0', '0', 27, 'default_3x3', 'catalog_glass_headline1', 'ctlg_glass_teaser1_fr', '', 'You can really open up a space with this stylish glass furniture, just don''t walk into it!', '', 'Click on an item for more information.', '', '', '', ''),
(62, 3, 'Gothic', 0, 30, '1', '1', 1, '0', '0', 28, 'default_3x3', 'catalog_gothic_headline1', 'catalog_gothic_teaser1', '', 'As the church bells ring out midnight, you walk through your cobbled hall lit by candles, throw yourself into your medieval throne and paint your nails black. This is what we imagined when we ordered this range!', '', 'Click on an item for more information.', '', '', '', ''),
(63, 3, 'Sport', 0, 56, '1', '1', 1, '0', '0', 68, 'default_3x3', 'catalog_sports_headline1', 'catalog_sports_teaser1', '', 'Sport contains all those vital Olympic pieces from running tracks to basketball courts! 3 2 1 GO!', '', 'Click on an item for more information.', '', '', '', ''),
(64, 3, 'Grunge', 0, 32, '1', '1', 1, '0', '0', 30, 'default_3x3', 'catalog_grunge_headline1', 'catalog_grunge_teaser', '', 'Sleeping rough? Make the streets a bit more bearable with our collection of homeless furni, Grunge!', '', 'Click on an item for more information.', '', '', '', ''),
(56, 3, 'Alhambra', 0, 12, '1', '1', 1, '0', '0', 4, 'default_3x3', 'catalog_alh_headline2_en', 'catalog_alh_teaser2_no', '', 'For the cold Arabian nights and hot Arabian days, you''ll need a palace.. and we have just what you need! Green blossom print should cover it just fine!', '', 'Click on an item for more information.', '', '', '', ''),
(57, 3, 'Asian', 0, 15, '1', '1', 1, '0', '0', 7, 'default_3x3', 'catalog_asian_headline1', 'catalog_asian_teaser1', '', 'Ting tong! Ching chong? Ting chong ting, ping ping! I mean uh.. with our authentic Chinese furniture, you can make a beautiful oriental room!', '', 'Click on an item for more information.', '', '', '', ''),
(55, 3, 'Iced', 0, 13, '1', '1', 1, '0', '0', 36, 'default_3x3', 'catalog_iced_headline1', 'catalog_iced_teaser1', '', 'The Iced range, squishy, soft and most definitely cool. Whatever your needs, this stylish range should  cover it!', '', 'Click on an item for more information.', '', '', '', ''),
(65, 3, 'Habbowood', 0, 33, '1', '1', 1, '0', '0', 31, 'default_3x3', 'ctlg_habbowood_headline1_sv', '', '', 'No flash photography, darling! This range is only for the VIP Hollywood actors!', '', 'Click on an item for more information.', '', '', '', ''),
(66, 3, 'Halloween', 0, 34, '1', '1', 1, '0', '0', 33, 'default_3x3', 'catalog_halloween_headline1', 'catalog_halloween_teaser', '', 'WooOOOOoooOOoo! Spooky! Don''t wanna be left with this range at night.. who knows what would happen!', '', 'Click on an item for more information.', '', '', '', ''),
(67, 3, 'Japanese', 0, 36, '1', '1', 1, '0', '0', 37, 'default_3x3', 'japan_3', '', '', 'We have sushi, tatami and katana''s! I have no idea what the difference is, but I sure know its Japanese! Fulfil your fantasies and buy some today!', '', 'Click on an item for more information.', '', '', '', ''),
(68, 3, 'Lost Tribe', 0, 38, '1', '1', 1, '0', '0', 42, 'default_3x3', 'catalog_frontpage_headline2_en', 'LT_teaser_en', '', 'Start your own tribal village with our ancient furniture, all carved from hard wearing stone. NOTE: Lava is hot, get an adult to help you.', '', 'Click on an item for more information.', '', '', '', ''),
(69, 3, 'Neon', 0, 41, '1', '1', 1, '0', '0', 47, 'default_3x3', 'catalog_neon_header1_en', 'catalog_neon_teaser1_en', '', 'New years eve, birthdays and every other day of the year, there''s always an exscuse for a party! So, why don''t you buy some Neon furni!?', '', 'Click on an item for more information.', '', '', '', ''),
(71, 3, 'Relax', 0, 49, '1', '1', 1, '0', '0', 58, 'default_3x3', 'rela_header_en', '', '', 'Relax after a busy day in the Welcome Lounge. Light a few candles, and chill out with a good read in a wicker chair. We understand the needs of an Habbo with a hectic lifestyle!', '', 'Click on an item for more information.', '', '', '', ''),
(72, 3, 'Romantique', 0, 50, '1', '1', 1, '0', '0', 60, 'default_3x3', 'catalog_romantique_headline1', 'catalog_romantique_teaser1', '', 'Found in a French barn, this sweet but sexily romantic range caters to every ladies needs. Just going to powder my nose!', '', 'Click on an item for more information.', '', '', '', ''),
(73, 3, 'Sci Fi', 0, 53, '1', '1', 1, '0', '0', 63, 'default_3x3', 'sf_header_en', '', '', 'Blip blop blip blip blip.. Oooh.. what''s this button do?.. You can find out exactly what it does with our new Scifi range, batteries included!', '', 'Click on an item for more information.', '', '', '', ''),
(74, 3, 'Shalimar', 0, 54, '1', '1', 1, '0', '0', 64, 'default_3x3', 'catalog_shal_header1_en', 'catalog_shal_teaser_it', '', 'Everyone loves Bollywood! Want some free credits? Tell Oscar you successfully read the Shalimar page! Tell no one else you found this Easter egg. Watch out for rose petals!', '', 'Click on an item for more information.', '', '', '', ''),
(75, 3, 'Summer', 0, 57, '1', '1', 1, '0', '0', 70, 'default_3x3', 'catalog_frontpage_headline2_en', 'catalog_sum_teaser1', '', 'Phwoar! Start up the barbie! This range has everything you need for the perfect summer garden!', '', 'Click on an item for more information.', '', '', '', ''),
(76, 3, 'Love', 0, 62, '1', '1', 1, '0', '0', 43, 'default_3x3', 'catalog_love_headline1', 'catalog_love_teaser1', '', 'Love is in the air once again! Buy your sweetheart a rose or whisper sweet nothings in their ear on a love sofa. Can you feel it? <3', '', 'Click on an item for more information.', '', '', '', ''),
(77, 3, 'Greek', 0, 31, '1', '1', 1, '0', '0', 29, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Be transported back to ancient Greece with a couple of thousand pounds and British Airways. Until then, build your own panthenon with our realist Greek range!', '', 'Click on an item for more information.', '', '', '', ''),
(88, 3, 'Virus', 0, 42, '1', '1', 1, '0', '0', 76, 'default_3x3', 'catalog_vir_header1_en', 'catalog_vir_teaser_nl', '', 'All of Habbo''s emergency pandemic supplies are kept here! They need a bit of a clean after the exploding puss disease but.. they''ll do fine!', '', 'Click on an item for more information.', '', '', '', ''),
(91, -1, 'Staff Pages', 6, 28, '1', '1', 7, '0', '0', 48, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Staff are not allowed to give out these Rares for no reason. Only give as a Prize of a Event, Competition or for building a Event Room (If needed).', '', '', '', '', '', ''),
(93, 91, 'Trophies', 1, 60, '1', '1', 7, '0', '0', 7, 'trophies', 'catalog_trophies_headline1', '', '', 'This page contains special trophies available for staff to give as prizes. STAFF CAUGHT GIVING OUT THESE WITH NO REASON WILL BE DEMOTED.', '', 'Click in this grey box and type your inscription *carefully* - it''s permanent!', '', '', '', ''),
(94, 91, 'Rares', 1, 10, '1', '1', 7, '0', '0', 0, 'default_3x3', 'catalog_rares_headline1', 'catalog_limited_teaser_en', '', 'This page contains special rares available for staff. STAFF CAUGHT GIVING OUT THESE WITH NO REASON WILL BE DEMOTED.', '', 'Click on an item for more information.', '', '', '', ''),
(95, 91, 'Promotional', 1, 11, '1', '1', 7, '0', '0', 0, 'default_3x3', 'catalog_rares_headline1', 'catalog_limited_teaser_en', '', 'This page contains special promotional items available for staff. STAFF CAUGHT GIVING OUT THESE WITH NO REASON WILL BE DEMOTED.', '', 'Click on an item for more information.', '', '', '', ''),
(105, -1, 'Raros Limitados', 0, 10, '1', '1', 1, '0', '0', 47, 'default_3x3', 'catalog_rares_headline1', 'catalog_limited_teaser_en', '', 'On this page, we have some lovely rares for you! We''ve kept a few behind for competition and event prizes!', '', 'Click on an item for more information.', '', '', '', ''),
(102, 3, 'Rollers', 0, 16, '1', '1', 1, '0', '0', 3, 'default_3x3', 'catalog_roller_headline1', 'catalog_teaser_rollers_en', '', 'Zoooooooom, Zooooooooooooooooooooooooooom! Was it a plane? Was it a bird!? No, it was Roy on a roller! You can use rollers in games, events or even just to  move a queue along.', '', 'Click on an item for more information.', '', '', '', ''),
(103, 3, 'Diner', 0, 51, '1', '1', 1, '0', '0', 20, 'default_3x3', 'catalog_frontpage_headline2_en', 'catalog_diner_teaser_en', '', 'Originally from the 50''s this furni has been refurbished and put right into the catalogue! Use this with the Kitchen range for ultimate diner experience!', '', 'Click on an item for more information.', '', '', '', ''),
(112, 3, 'Twilight', 0, 64, '1', '1', 1, '0', '0', 74, 'default_3x3', 'catalog_twilight_header_en', '', '', 'I''ve never read the book, all I know is it has vampires playing basket ball and some heart throb called Edward Cullen, but the furni looks good!', '', 'Click on an item for more information.', '', '', '', ''),
(121, 91, 'Trax Machines', 0, 4, '1', '1', 7, '0', '0', 8, 'default_3x3', 'catalog_frontpage_headline2_en', 'catalog_limited_teaser_en', '', 'Buy your Trax machines here, ready to load with all your wonderful, musical creations! Check the Sound Sets page for all the discs you could use!', '', 'Click on an item for more information.', '', '', '', ''),
(116, -1, 'Marketplace', 6, 69, '1', '0', 1, '0', '0', 44, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(117, 116, 'Offers', 1, 70, '1', '1', 1, '0', '0', 0, 'marketplace', 'catalog_marketplace_header_en', '', '', '', '', '', '', '', '', ''),
(118, 116, 'My Sales', 1, 71, '1', '1', 1, '0', '0', 0, 'marketplace_own_items', 'catalog_marketplace_header_en', '', '', '', '', '', '', '', '', ''),
(119, 116, 'Instructions', 1, 42, '1', '1', 1, '0', '0', 0, 'recycler_info', 'catalog_marketplace_header_en', '', '', 'Habbo Marketplace is a convenient and safe way to buy and sell items in Habbo.', 'How does the Habbo Marketplace work?', 'Selling items:\r\nYou can sell any item which is tradable by selecting the item in your inventory and clicking on ''Sell in Marketplace''. You are able to post 5 items for sale at the cost of 1 credit. You cannot use items currently in the Catalogue.\r\n\r\nBuying items:\r\nBrowse for the item you want to buy on the Marketplace Offers page and click Buy. We guarantee you''ll get the item at the cheapest price available at the moment of purchase.', '', '', '', ''),
(122, 3, 'Sound Sets', 0, 4, '1', '1', 1, '0', '0', 66, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'We have every sound you could ever want right here! From sound effects and ambient tunes to rock and roll and heavy metal!', '', 'Click on an item for more information.', '', '', '', ''),
(123, 4, 'Hello Furni', 0, 35, '1', '1', 1, '0', '0', 34, 'default_3x3', 'catalog_hello_header1_en', 'catalog_hello_teaser1_en', '', 'Hello Furni is available with Pixels and is perfect if you are decorating your room for the very first time. The Furni is yours to keep and therefore cannot be traded.', '', 'Click on an item for more information.', '', '', '', ''),
(125, 4, 'Special Effects', 0, 61, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_pixeleffects_headline1_en', 'catalog_pxl_teaser1_en', '', 'Tune your character with cool effects that fit the occasion. Ride the hoverboard and spit on the mic. Effects can be activated from the menu, by clicking on your avatar.', '', 'Click on an item for more information.', '', '', '', ''),
(126, 3, 'Tiki', 0, 59, '1', '1', 1, '0', '0', 72, 'default_3x3', 'catalog_tiki_header1_en', 'tiki_teaser', '', 'Imagine in the scene.. lost on a desert island when you stumble across a small local tribe.. now you can with our Tiki range!', '', 'Click on an item for more information.', '', '', '', ''),
(128, 3, 'Urban', 0, 26, '1', '1', 1, '0', '0', 75, 'default_3x3', 'urban_header_en', 'urban_teaser_en', '', 'New York City styled furni range, Urban is perfect for any street, alleyway or road. Rubbish bins, street lights and benches, all the Urban furniture you need!', '', 'Click on an item for more information.', '', '', '', ''),
(129, 4, 'Automobile', 0, 16, '1', '1', 1, '0', '0', 8, 'default_3x3', 'catalog_automobile_header1_en', 'catalog_automobile_teaser1_en', '', 'Every Habbo needs a car effect! Not only do they bring a bit of the outside inside, they also enhance the air quality! And what better gift for a friend than a beautiful traffic sign or elegant pile of tires...', '', 'Click on an item for more information.', '', '', '', ''),
(130, 3, 'Environment', 0, 21, '1', '1', 1, '0', '0', 22, 'default_3x3', '', '', '', 'Go green with our environmentally friendly Environment range! This selection of furni is perfect for a beautiful, relaxing garden.', '', 'Click on an item for more information.', '', '', '', ''),
(134, 91, 'System', 0, 1, '', '', 7, '0', '0', 3, 'default_3x3', 'catalog_frontpage_headline2_en', 'catalog_limited_teaser_en', '', '', '', 'Click on an item for more information.', '', '', '', ''),
(137, 3, 'Orgie', 51, 1, '1', '1', 1, '0', '0', 51, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'The latest range from Ann Summers, the Orgie line. Made of soft, wipe clean plastic, its perfect for any three, four or fivesome!', '', 'Click on an item for more information.', '', '', '', ''),
(136, 3, 'Bling', 0, 42, '1', '1', 1, '0', '0', 12, 'default_3x3', 'catalog_header_bling_en', '', '', 'Bling, Bling! Flash, Flash! Want to have that real celebrity lifestyle? Well, go somewhere else, all we have here is a tacky range of furni.', '', 'Click on an item for more information.', '', '', '', ''),
(160, 14, 'Accessories', 0, 43, '1', '1', 1, '0', '0', 5, 'default_3x3', 'catalog_pet_headline1', 'ctlg_pet_teaser1', 'catalog_special_txtbg2', 'This page has everything you need to give your pet the happy life it deserves. We''ve got a huge selection!', '', 'Click on an item for more information.', 'Keep ''em happy!', '', '', ''),
(143, 3, 'Flower Power', 0, 73, '1', '1', 1, '0', '0', 24, 'default_3x3', 'flowerpower_header_en', '', '', 'Woah! Far out man... let the petals take control. Lets collaborate on a hippy hideout and plant some seeds! Lucy in the sky with diamonds style eyy?!', '', 'Click on an item for more information.', '', '', '', ''),
(144, 3, 'Runway', 0, 74, '1', '1', 1, '0', '0', 62, 'default_3x3', 'runway_header_en', 'runway_teaser_en', '', 'Spice up your salon, hair parlour or boutique with our stylish yet practical range! From sewing machines to comfy seating, we''ve got the perfect option for you.', '', 'Click on an item for more information.', '', '', '', ''),
(161, 3, 'Beach', 1, 57, '1', '1', 1, '0', '0', 10, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Just sit down on your blanket, and enjoy the sun!', '', '', '', '', '', ''),
(159, 3, 'Prison', 2, 14, '1', '1', 1, '0', '0', 56, 'default_3x3', 'catalog_extra_headline1', 'catalog_extra_teaser1', 'catalog_special_txtbg2', 'You wont get out of these hard steel cells! Mwuahaha!', '', 'Click on an item for more information.', '', '', '', ''),
(171, 3, 'Soccer 2010', 0, 56, '1', '1', 1, '0', '0', 65, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Play ball!', '', '', '', '', '', ''),
(497, 3, 'Stray Pixels', 28, 1, '1', '1', 1, '0', '0', 69, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Stray Pixel', '', '', '', '', '', ''),
(174, 3, 'Party', 2, 4, '1', '1', 1, '0', '0', 53, 'default_3x3', 'catalog_neon_header1_en', 'catalog_neon_teaser1_en', '', 'Neon furni.. perfect to design your party room and party rock!', '', 'Click an item for more information.', '', '', '', ''),
(165, 3, 'Beach', 1, 84, '1', '1', 1, '0', '0', 11, 'default_3x3', 'catalog_frontpage_headline2_en', 'beach_teaser', 'catalog_special_txtbg1_en', 'The new Habbo Beach furniture range is here!', '', '', 'Beach furni 2010!', '', '', ''),
(502, 3, 'African', 1, 30, '1', '1', 1, '0', '0', 5, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'The new African furniture range is here!', '', '', '', '', '', ''),
(503, 3, 'New Kitchen ', 1, 43, '1', '1', 1, '0', '0', 49, 'default_3x3', 'kitchen_header_en', 'kitchen_teaser_en', '', 'The new kitchen furniture range is here!', '', '', '', '', '', ''),
(496, 3, 'Hospital', 10, 1, '1', '1', 1, '0', '0', 35, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'The new hospital furniture range is here! Buy it now and create your own Hospital!', '', '', '', '', '', ''),
(200, 3, 'Cubie', 1, 100, '1', '1', 1, '0', '0', 19, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'They are smaller then a cubie?', '', '', '', '', '', ''),
(175, 3, 'Waasa', 1, 102, '1', '1', 1, '0', '0', 78, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Pick some perfect furniture for your office or your college room!', '', '', '', 'Click here >>', '', ''),
(169, 3, 'Habbowood 2011', 1, 1, '1', '1', 1, '0', '0', 32, 'default_3x3', 'ctlg_habbowood_headline1_sv', '', '', 'Film Ready, but still Commercial''s coming. Buy the new Theather Furni!', '', '', '', '', '', ''),
(201, 3, 'New Gothic', 1, 30, '1', '1', 1, '0', '0', 48, 'default_3x3', 'catalog_gothic_headline1', 'catalog_gothic_teaser1', '', 'Is''nt this furniture a little bit scary?', '', '', '', '', '', ''),
(777, 3, 'Bling 2011', 1, 1, '1', '1', 1, '0', '0', 13, 'default_3x3', 'catalog_header_bling_en', 'catalog_teaser_bling11', '', 'It''s the dawg''s Bling Bling. All from Hollywood!', '', '', '', '', '', ''),
(778, 3, 'Chinese New Year', 1, 1, '1', '1', 1, '0', '0', 15, 'default_3x3', 'japan_3', '', '', 'Xinnian kuaile!', '', '', '', '', '', ''),
(899, 3, 'Limousine', 1, 1, '1', '1', 1, '0', '0', 39, 'default_3x3', '', '', '', 'Is''nt it cool to be in the Spotlight with your Limousine?', '', '', '', '', '', ''),
(300, 3, 'Voodoo', 1, 79, '1', '1', 1, '0', '0', 77, 'default_3x3', 'catalog_voodoo_header_en', 'catalog_voodoo_teaser', '', 'The creepy Survival Forest furni...', '', '', '', '', '', ''),
(600, 3, 'New Year 2011', 1, 91, '1', '1', 1, '0', '0', 50, 'default_3x3', 'catalog_limited_headline1_en', 'catalog_limited_teaser_en', '', 'Different furni from New Year 2011.', '', 'Click on an item for more information.', '', '', '', ''),
(500, 3, 'Christmas 2010', 1, 3, '1', '1', 1, '0', '0', 17, 'default_3x3', 'catalog_snowflake_en', 'ctlg_pic_snowflake_pilot', '', 'Christmas Furni 2010! I bet you wished this for Christmas? ;)', '', 'Click on an item for more information.', '', '', '', ''),
(501, 3, 'Freeze', 0, 87, '1', '1', 1, '0', '0', 25, 'default_3x3', 'catalog_freeze_en', 'catalog_cltbs_tease r_es', '', 'FREEZE! No, its not the Police but a new game!', '', '', '', '', '', ''),
(173, 3, 'Other Furnis', 1, 53, '1', '1', 1, '0', '0', 52, 'default_3x3', '', '', '', 'Furni from a uncategorized Section.', '', '', '', '', '', ''),
(139, 14, 'Pets Info', 0, 42, '1', '1', 1, '0', '0', 8, 'pets2', 'catalog_pet_headline1', 'ctlg_pet_note', '', 'Pets are inhabitants of uberHotel too, so each pet owner needs to know a bit about them. Look after your pet by looking through our key points below.', '', '', '- You cannot trade or give away pets. Once you purchase them, they will be yours forever.\r\n- You can own as many as you want, but you can have no more than 5 pets per room.\r\n- You can take pets with you to other rooms, should the room owner allow you to do so.\r\n- Your pet needs to be trained before it''ll listen to your commands.', '0', '', ''),
(142, 14, 'Pet Accessories', 0, 43, '1', '1', 1, '0', '0', 7, 'default_3x3', 'catalog_pet_headline1', 'ctlg_pet_teaser1', 'catalog_special_txtbg2', 'This page has everything you need to give your pet the happy life it deserves. We''ve got a huge selection!', '', 'Click on an item for more information.', 'Keep ''em happy!', '0', '', ''),
(141, 14, 'Pigs', 0, 67, '1', '1', 1, '0', '0', 1, 'pets', 'catalog_pet_headline1', '', '', 'These little scamps were destined for the dining table until we struck a deal with a local farmer to rescue their cute pigtails! Adopt your little piglet today, all you need now is a name.', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(146, 14, 'Terriers', 0, 66, '1', '1', 1, '0', '0', 2, 'pets', 'catalog_pet_headline1', '', '', 'Good things come in small packages and Habbo''s Terriers are no exception', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(147, 14, 'Bears', 0, 68, '1', '1', 1, '0', '0', 12, 'pets', 'catalog_pet_headline1', '', '', 'A large, heavy, mammal that walks on the soles of its feet, with thick fur and a very short tail. Fall in love with our adorable range of Bears that include the Grizzly and Polar varieties!', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(148, 14, 'Cats', 0, 20, '1', '1', 1, '0', '0', 4, 'pets', 'catalog_pet_headline1', '', '', 'Fluff, whiskers, meows and purrs! You''re about to enter the world of Habbo Cats. These cute little critters make great playmates and will keep you company if you look after them well. Find a new friend from our ever-changing selection.', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(149, 14, 'Dogs', 0, 24, '1', '1', 1, '0', '0', 5, 'pets', 'catalog_pet_headline1', '', '', 'Wet noses, paws, yaps and woofs! You''re about to enter the world of Habbo Dogs. An adorable and faithful servant awaits you with a wagging tail everytime they see you. Find a new friend from our ever-changing selection.', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(150, 14, 'Crocodiles', 0, 22, '1', '1', 1, '0', '0', 6, 'pets', 'catalog_pet_headline1', '', '', 'Scaly skin, growls and snaps! You''re about to enter the world of Habbo Crocs. Security for your room or to scare your friends a trustworthy and surprisingly loving companion can be yours. Find a new friend from our ever-changing selection', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(157, 14, 'Lion', 1, 76, '1', '1', 1, '0', '0', 0, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(158, 14, 'Rhino', 1, 77, '1', '1', 1, '0', '0', 0, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(170, 14, 'Spiders', 0, 95, '1', '1', 1, '0', '0', 7, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(176, 14, 'Frogs', 1, 97, '1', '1', 1, '0', '0', 8, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(182, 14, 'Chicken', 0, 0, '1', '1', 1, '0', '0', 2, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(187, 14, 'Dragon', 1, 109, '1', '1', 1, '0', '0', 0, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(120, 3, 'Battle Banzai', 1, 78, '1', '1', 1, '0', '0', 1, 'default_3x3', 'Los nuevos furnis de Battle Banzai por fin en catalogo', '', '', 'Los nuevos furnis de Battle Ball por fin en catalogo', '', '', '', '', '', ''),
(912, 3, 'Music Discs', 3, 5, '1', '1', 1, '0', '0', 0, 'soundmachine', 'catalog_djshop_headline1', 'catalog_djshop_teaser1', '', '', '', '', '', '', '', ''),
(177, 903, 'Triggers', 1, 81, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_wired_header2_es', 'ctlg_pic_wired_triggers', '', '¿Qué provoca que usted puede determinar lo que debe suceder a la función está activada? Disparo programable mediante la colocación en el piso y la sala haciendo doble clic en el disparador. Ajuste la función en el botón del obturador, para que trabajen juntos.', '', '', '', '', '', ''),
(178, 903, 'Effects', 1, 82, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_wired_header3_es', 'ctlg_pic_wired_effects', '', 'Esta función determina lo que sucede cuando el obturador se activa. función programable mediante la colocación en el piso y la sala haciendo doble clic en la materia. Ajuste la función en el botón del obturador, para que trabajen juntos.', '', '', '', '', '', ''),
(179, 903, 'Utillity', 1, 85, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_wired_header5_es', 'ctlg_pic_wired_support_furniture', '', 'Estos productos, que puede sintonizar con cable de su habitación! Los productos son artículos de primera necesidad, que puede agregar funcionalidad adicional mediante la combinación de los factores desencadenantes, las funciones y condiciones.', '', '', '', '', '', ''),
(180, 903, 'Conditions', 1, 83, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_wired_header4_es', 'ctlg_pic_wired_effects', '', '', '', '', '', '', '', ''),
(903, -1, 'Wired', 1, 80, '1', '1', 1, '0', '0', 0, 'default_3x3', 'head_shop', '', '', '', '', '', '', '', '', ''),
(913, 3, 'Beach Shop', 1, 59, '1', '1', 1, '0', '0', 0, 'default_3x3', '', 'Welcome to the Beach Shop! Buy here some things, that come in handy when you are making a beach club, or something else. Don', '', '', '', '', '', '', '', ''),
(914, 3, 'Bananas', 1, 128, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_banana_header', '', 'Furni Banana, consiguelos antes que un mono se los robe xD', '', 'Clic para mas información de los furnis', '', '', '', '', ''),
(915, 3, 'Durex', 1, 115, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_limited_teaser1', '', 'Maxima duracion, placer y proteccion total con Durex', '', 'Clic para mas información de los furnis', '', '', '', '', ''),
(145, 14, 'Monkey', 0, 136, '1', '1', 1, '0', '0', 302, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(46, 14, 'Turtle', 0, 136, '1', '1', 1, '0', '0', 15, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(916, 14, 'Horse', 0, 136, '1', '1', 1, '0', '0', 14, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `catalog_pages_old`
--

CREATE TABLE IF NOT EXISTS `catalog_pages_old` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT '-1',
  `caption` varchar(100) NOT NULL,
  `icon_color` int(11) NOT NULL DEFAULT '1',
  `icon_image` int(11) NOT NULL DEFAULT '1',
  `visible` enum('0','1') NOT NULL DEFAULT '1',
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  `min_rank` int(10) unsigned NOT NULL DEFAULT '1',
  `club_only` enum('0','1') NOT NULL DEFAULT '0',
  `coming_soon` enum('0','1') NOT NULL DEFAULT '0',
  `order_num` int(11) NOT NULL,
  `page_layout` enum('default_3x3','frontpage','spaces','recycler','recycler_info','recycler_prizes','trophies','plasto','marketplace','marketplace_own_items','pets','pets2','spaces_new') NOT NULL DEFAULT 'default_3x3',
  `page_headline` text NOT NULL,
  `page_teaser` text NOT NULL,
  `page_special` text NOT NULL,
  `page_text1` text NOT NULL,
  `page_text2` text NOT NULL,
  `page_text_details` text NOT NULL,
  `page_text_teaser` text NOT NULL,
  `text3` text NOT NULL,
  `link` text NOT NULL,
  `mobile_frntpg` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=900 ;

--
-- Volcado de datos para la tabla `catalog_pages_old`
--

INSERT INTO `catalog_pages_old` (`id`, `parent_id`, `caption`, `icon_color`, `icon_image`, `visible`, `enabled`, `min_rank`, `club_only`, `coming_soon`, `order_num`, `page_layout`, `page_headline`, `page_teaser`, `page_special`, `page_text1`, `page_text2`, `page_text_details`, `page_text_teaser`, `text3`, `link`, `mobile_frntpg`) VALUES
(1, -1, 'Frontpage', 6, 1, '1', '1', 1, '0', '0', 1, 'frontpage', 'catalog_frontpage_headline2_en', '', '', 'Oh rawr, monthly rares by Various will be updated every month!\r\n\r\nThis month''s rare: Orange Inflatable Chair!', 'How do I get Credits?Habbo credits are completely free! Your credits will be refilled and topped up to a total of 3000 credits every 3 hours, if you fall below this amount. This ensures credits are distributed fairly. You do not need to be logged in for your credits to be refilled.\r\n\r\nCheck out the credits page on the website for more information.', 'Voucher Codes released by a staff can be redeemed under here:', 'NO YOU!', '', '', ''),
(3, -1, 'Furni Shop', 3, 2, '1', '0', 1, '0', '0', 2, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(4, -1, 'Pixel Shop', 5, 5, '1', '0', 1, '0', '0', 4, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(5, -1, 'Habbo Club', 7, 75, '1', '0', 1, '0', '0', 8, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(6, -1, 'Trax Shop', 4, 4, '0', '0', 1, '0', '1', 6, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(7, 5, 'Buy Habbo Club', 1, 75, '1', '1', 1, '0', '0', 1, 'default_3x3', 'catalog_club_headline1', 'catalog_hc_teaser', '', 'Habbo Club is our VIP members-only club - absolutely no riff-raff admitted! Members enjoy a wide range of benefits, including exclusive clothes, free gifts and an extended friends list.', '', '', '', '', '', ''),
(8, 5, 'Club Furniture', 1, 75, '1', '1', 1, '1', '0', 2, 'default_3x3', 'catalog_club_headline1', 'catalog_hc_teaser', '', 'We''ve got all that exclusive club furniture available for you right here .. but for an exclusive price.', '', '', '', '', '', ''),
(9, -1, 'Ecotron', 3, 7, '1', '0', 1, '0', '0', 9, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(10, 9, 'Ecotron', 1, 7, '1', '1', 1, '0', '0', 1, 'recycler', 'catalog_recycler_headline3', 'ctlg_ecotron_image', '', 'Become an Eco-warrior', 'Recycle your worthless stuff and be rewarded with a random prize. Check out the prizes and the instructions for recycling.', 'Drag 5 items to the boxes below and click recycle!', '', '', '', ''),
(11, 9, 'Rewards', 1, 26, '1', '1', 1, '0', '0', 2, 'recycler_prizes', 'catalog_recycler_headline3', '', '', 'What are the prizes? Ecotron box may contain one of these:', '', '', '', '', '', ''),
(12, 9, 'Instructions', 1, 42, '1', '1', 1, '0', '0', 3, 'recycler_info', 'catalog_recycler_headline3', 'ctlg_ecotron_box', '', 'The Ecotron is a furni recycler. Get rid of old furni... what will you get in return? It''s a surprise! Become a Habbo eco-warrior. No refunds!', 'How to use the Ecotron?', '1. Just drag 5 items from your hand to the Ecotron. One item / square. Recyclable items are marked in your inventory with an image. When you have 5 items in the boxes, click the "Recycle" button. You can now find the Ecotron prize box from your hand.\r\n\r\n2. Click the box to see its tag. Open the box, or trade it unopened. The timer shows you how long you have to wait before you can recycle more items. Check the prizes before you recycle- don''t be surprised by the surprise!', '', '', '', ''),
(13, -1, 'Habbo Exchange', 11, 6, '1', '1', 1, '0', '0', 7, 'default_3x3', 'catalog_bank_headline1', 'catalog_bank_teaser', 'catalog_special_txtbg1', 'You can exchange your Habbo credits here for Exchange furniture, which you can use in a trade or simply exchange for actual credits.', '', 'Click on an item to see more details.', 'Gold! Glorious Gold!', '', '', ''),
(14, -1, 'Pets Shop', 2, 8, '1', '1', 1, '0', '0', 8, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '0', '', ''),
(15, 3, 'Spaces', 1, 55, '1', '1', 1, '0', '0', 2, 'spaces_new', 'catalog_spaces_headline1', '', '', 'Floors, wallpapers and landscapes - get a groovy combination for your room! Use our sample room below to try before you buy! Select your favourite designs and colours and simply click Buy!', '', '', '', '', '', ''),
(16, 3, 'Limited Edition', 1, 26, '1', '1', 1, '0', '1', 1, 'default_3x3', 'catalog_limited_headline1', '', 'catalog_special_txtbg1', 'This weeks limited edition rare (updated every Sunday) is the petal patch!', '', 'Click on an item for more information.', 'Get ''em before they''re gone!', '', '', ''),
(24, 3, 'Windows', 0, 63, '1', '1', 1, '0', '0', 3, 'default_3x3', 'ctlg_windows_headline1_en', 'ctlg_windows_teaser1_en', 'catalog_special_txtbg2', 'Let some light in! Our windows come in many unique styles to give an exciting look to your room. Buy landscapes to go with your windows from the ''Spaces'' page!', '', 'Click on an item for more information.', 'Ooh, new view!', '', '', ''),
(26, 3, 'Moodlights', 0, 40, '1', '1', 1, '0', '0', 4, 'default_3x3', 'catalog_dimmers_header_en', 'dimmers_teaser', '', 'Our range of moodlights allow you to control the atmosphere and transform your room in just a click. What will your room look like? Click the switch and find out now!', '', 'Click on an item for more information.', '', '', '', ''),
(27, 3, 'Christmas', 1, 64, '1', '1', 1, '0', '0', 47, 'default_3x3', 'catalog_xmas_headline1', 'xmas2009_catalogue', 'catalog_special_txtbg2', 'Get yourself into the Christmas spirit with our selection of festive furni! From baubles to Reindeer poo, we''ve got it all!', '', 'Click on an item for more information.', '''tis the season!', '', '', ''),
(28, 3, 'Artic', 0, 13, '1', '1', 1, '0', '0', 35, 'default_3x3', 'catalog_arc_header1_en', 'catalog_arc_teaser1_en', '', 'Stay cool (or warm with out campfire!) with and create your own Winter Wonderland or Humble Homeland for your Penguins.', '', 'Click on an item for more information.', '', '', '', ''),
(29, 3, 'Teleporters', 0, 58, '1', '1', 1, '0', '0', 12, 'default_3x3', 'catalog_doors_headline1', 'catalog_door_a', 'catalog_special_txtbg1', 'Take your room to a whole new level with our range of space age teleporters! Just buy a pair, put one in each room and voila! You''ll have two linked rooms!', '', 'Click on an item for more information.', 'Take your room to the next level!', '', '', ''),
(30, 3, 'Mode', 0, 39, '1', '1', 1, '0', '0', 5, 'default_3x3', 'catalog_mode_headline1', 'catalog_mode_teaser1', 'catalog_special_txtbg2', 'Steely, grey industrial standard metal with a sleek design. The perfect range for a streetwise city dweller.', '', 'Click on an item for more information.', 'So shiny and new..', '', '', ''),
(31, 3, 'Candy', 0, 19, '1', '1', 1, '0', '0', 6, 'default_3x3', 'catalog_candy_headline1', 'catalog_candy_teaser1', 'catalog_special_txtbg2', 'A bit more feminine than ''Mode'', this will add a bit of glamour and glitz to your rooms. Lacking a few items? Head on over to the ''Mode'' catagory!', '', 'Click on an item for more information.', 'lol I killed a pink bear for this rug!', '', '', ''),
(32, 3, 'Pura', 0, 48, '1', '1', 1, '0', '0', 9, 'default_3x3', 'catalog_pura_headline1', 'catalog_pura_teaser1', 'catalog_special_txtbg2', 'The clenest, freshest range. You can almost hear it breath cool and tranquility within your room. Use it to create a haven away from the hetic lifestyle of HabboHotel.', '', 'Click on an item for more information.', 'So many colors!', '', '', ''),
(33, 3, 'Area', 0, 14, '1', '1', 1, '0', '0', 8, 'default_3x3', 'catalog_area_headline1', 'catalog_area_teaser1', 'catalog_special_txtbg2', 'A chunky and sofisticated line for the down-to-earth, studious Habbo. It''s simplicty is beautful and will add a welcoming charm to every room.', '', 'Click on an item for more information.', 'Beautiful in it''s simplicity! ', '', '', ''),
(34, 3, 'Country', 0, 21, '1', '1', 1, '0', '0', 31, 'default_3x3', 'country_header1_en_001', 'country_teaser1', 'catalog_special_txtbg2', 'Lets leave the busy city streets and head over to the wide abyss of golden whear, emerald fields and home grown, organic vegetables. Everything you need to create a farm!', '', 'Click on an item for more information.', 'Who''d be a crow, eh?', '', '', ''),
(35, 3, 'Lodge', 0, 37, '1', '1', 1, '0', '0', 7, 'default_3x3', 'catalog_lodge_headline1', 'catalog_lodge_teaser1', 'catalog_special_txtbg2', 'For that splendid ski-lodge effect with an open fire and whisky on the sidebar. This range is for those who appreicate the true beauty of solid wood.', '', 'Click on an item for more information.', 'I like wood!', '', '', ''),
(36, 3, 'Plastic', 0, 46, '1', '1', 1, '0', '0', 11, 'plasto', 'catalog_plasto_headline1', '', '', 'Throw on an afro and grab a disco ball! Feel that retro, 1970s vibe? You soon will with this colourful, plastic range! Choose a colour to suit your mood and off you go!', '', 'Click on an item for more information.', '', '', '', ''),
(37, 3, 'Kitchen', 0, 43, '1', '1', 1, '0', '0', 29, 'default_3x3', 'kitchen_header_en', 'kitchen_teaser_en', 'catalog_special_txtbg2', 'Hygiene, hygiene, hygiene! With this new range you can keep your meat chilled and vegetables stored correctly! Just watch out for that dreaded Health Inspector...', '', 'Click on an item for more information.', 'Choccy mouse you say?', '', '', ''),
(38, 3, 'Bathroom', 0, 17, '1', '1', 1, '0', '0', 14, 'default_3x3', 'catalog_bath_headline1', 'catalog_bath_teaser1', 'catalog_special_txtbg2', 'Lets face it.. you can''t live without your bathroom. Give yours guests somewhere to freshen up with our cheeful bathroom collection!', '', 'Click on an item for more information.', 'Every Habbo needs one!', '', '', ''),
(39, 3, 'Plants', 0, 45, '1', '1', 1, '0', '0', 15, 'default_3x3', 'catalog_plants_headline1', 'catalog_plants_teaser1', 'catalog_special_txtbg2', 'Every room needs some greenery, dear! Not only do they enhance the air quality, they cheer up a room to make it simply splendid! And what better gift for a friend than an elegant rose..', '', 'Click on an item for more information.', 'I''m a tree!', '', '', ''),
(40, 3, 'Rugs', 0, 52, '1', '1', 1, '0', '0', 16, 'default_3x3', 'catalog_rugs_headline1', 'catalog_posters_teaser1', 'catalog_special_txtbg2', 'Rugs for all occasions, white for weddings, black for funerals and everything in between! All rugs and non-slip and machine washable. Take your pick!', '', 'Click on an item for more information.', 'This''ll be perfect in my room!', '', '', ''),
(41, 3, 'Gallery', 0, 47, '1', '1', 1, '0', '0', 17, 'default_3x3', 'catalog_gallery_headline1', 'catalog_posters_teaser1', 'catalog_special_txtbg2', 'Adorn your walls with posters, art, plaques and wall hangings. This gallery is bursting with items to suit all tastes, traditional and modern!', '', 'Click on an item for more information.', 'Brighten up your walls!', '', '', ''),
(42, 3, 'Trophies', 0, 60, '1', '1', 1, '0', '0', 20, 'trophies', 'catalog_trophies_headline1', '', '', 'Everyone a winner with Habbo trophies! Now you can reward all your friends with our pre-polished array of trohpies. In bronze, silver and gold. \r\nFirst choose your trophy model, then the metal and carefully type your inscription. Don''t worry, we''ll engrave it all with your name and the date.', '', 'Click on an item for more information.', '', '', '', ''),
(43, 3, 'Accessories', 0, 11, '1', '1', 1, '0', '0', 19, 'default_3x3', 'catalog_extra_headline1', 'catalog_extra_teaser1', 'catalog_special_txtbg2', 'However you like to place your essentials, its the finishing touches that really make a room and express your true personality. Don''t forget, like anything else, you can move them all about to suit your mood!', '', 'Click on an item for more information.', 'I love my rabbit...', '', '', ''),
(45, 4, 'Rentals', 0, 44, '1', '1', 1, '0', '0', 23, 'default_3x3', 'catalog_pixelrent_headline1_en', 'catalog_pxl_teaser3_en', '', 'Hire some cool effects to add an explosive touch to your room. From bubbles to firestarters, you can enhance your room dramatically!', '', 'Click on an item for more information.', '', '', '', ''),
(55, 3, 'Iced', 0, 13, '1', '1', 1, '0', '0', 10, 'default_3x3', 'catalog_iced_headline1', '', '', 'The Iced range, squishy, soft and most definitely cool. Whatever your needs, this stylish range should  cover it!', '', 'Click on an item for more information.', '', '', '', ''),
(56, 3, 'Alhambra', 0, 12, '1', '1', 1, '0', '0', 22, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'For the cold Arabian nights and hot Arabian days, you''ll need a palace.. and we have just what you need! Green blossom print should cover it just fine!', '', 'Click on an item for more information.', '', '', '', ''),
(57, 3, 'Asian', 0, 15, '1', '1', 1, '0', '0', 23, 'default_3x3', 'catalog_asian_headline1', '', '', 'Ting tong! Ching chong? Ting chong ting, ping ping! I mean uh.. with our authentic Chinese furniture, you can make a beautiful oriental room!', '', 'Click on an item for more information.', '', '', '', ''),
(58, 3, 'Lost City', 0, 18, '1', '1', 1, '0', '0', 26, 'default_3x3', 'catalog_lc_headline2_en', '', '', 'Under the seaaaaaaaaa, oh, Under the seaaaaaa! What will your underwater world look like? We have it all here, crabs, HIV and genital warts!', '', 'Click on an item for more information.', '', '', '', ''),
(59, 3, 'Easter', 0, 25, '1', '1', 1, '0', '0', 48, 'default_3x3', 'catalog_easter_headline1', '', '', 'Little birdies hatching from their eggs, pretty, dainty flowers blooming and cute rabbits bouncy in Spring meadows.. FUCK IT ALL! LETS BUY FURNI!', '', 'Click on an item for more information.', '', '', '', ''),
(60, 3, 'Executive', 0, 27, '1', '1', 1, '0', '0', 38, 'default_3x3', 'catalog_exe_headline1_en', '', '', 'For the ultimate business man, the Executive range with its leather seats and Italian coffee is a dream! How about you try the easy lifestyle?', '', 'Click on an item for more information.', '', '', '', ''),
(61, 3, 'Glass', 0, 29, '1', '1', 1, '0', '0', 40, 'default_3x3', 'catalog_glass_headline1', '', '', 'You can really open up a space with this stylish glass furniture, just don''t walk into it!', '', 'Click on an item for more information.', '', '', '', ''),
(62, 3, 'Gothic', 0, 30, '1', '1', 1, '0', '0', 37, 'default_3x3', 'catalog_gothic_headline1', '', '', 'As the church bells ring out midnight, you walk through your cobbled hall lit by candles, throw yourself into your medieval throne and paint your nails black. This is what we imagined when we ordered this range!', '', 'Click on an item for more information.', '', '', '', ''),
(63, 3, 'Sport', 0, 56, '1', '1', 1, '0', '0', 43, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Sport contains all those vital Olympic pieces from running tracks to basketball courts! 3 2 1 GO!', '', 'Click on an item for more information.', '', '', '', ''),
(64, 3, 'Grunge', 0, 32, '1', '1', 1, '0', '0', 28, 'default_3x3', 'catalog_grunge_headline1', '', '', 'Sleeping rough? Make the streets a bit more bearable with our collection of homeless furni, Grunge!', '', 'Click on an item for more information.', '', '', '', ''),
(65, 3, 'Habbowood', 0, 33, '1', '1', 1, '0', '0', 39, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'No flash photography, darling! This range is only for the VIP Hollywood actors!', '', 'Click on an item for more information.', '', '', '', ''),
(66, 3, 'Halloween', 0, 34, '1', '1', 1, '0', '0', 50, 'default_3x3', 'catalog_halloween_headline1', '', '', 'WooOOOOoooOOoo! Spooky! Don''t wanna be left with this range at night.. who knows what would happen!', '', 'Click on an item for more information.', '', '', '', ''),
(67, 3, 'Japanese', 0, 36, '1', '1', 1, '0', '0', 24, 'default_3x3', 'catalog_jap_headline2_en', '', '', 'We have sushi, tatami and katana''s! I have no idea what the difference is, but I sure know its Japanese! Fulfil your fantasies and buy some today!', '', 'Click on an item for more information.', '', '', '', ''),
(68, 3, 'Lost Tribe', 0, 38, '1', '1', 1, '0', '0', 27, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Start your own tribal village with our ancient furniture, all carved from hard wearing stone. NOTE: Lava is hot, get an adult to help you.', '', 'Click on an item for more information.', '', '', '', ''),
(69, 3, 'Neon', 0, 41, '1', '1', 1, '0', '0', 42, 'default_3x3', 'catalog_neon_header1_en', '', '', 'New years eve, birthdays and every other day of the year, there''s always an exscuse for a party! So, why don''t you buy some Neon furni!?', '', 'Click on an item for more information.', '', '', '', ''),
(71, 3, 'Relax', 0, 49, '1', '1', 1, '0', '0', 41, 'default_3x3', 'rela_header_en', '', '', 'Relax after a busy day in the Welcome Lounge. Light a few candles, and chill out with a good read in a wicker chair. We understand the needs of an Habbo with a hectic lifestyle!', '', 'Click on an item for more information.', '', '', '', ''),
(72, 3, 'Romantique', 0, 50, '1', '1', 1, '0', '0', 45, 'default_3x3', 'catalog_romantique_headline1', '', '', 'Found in a French barn, this sweet but sexily romantic range caters to every ladies needs. Just going to powder my nose!', '', 'Click on an item for more information.', '', '', '', ''),
(73, 3, 'Sci Fi', 0, 53, '1', '1', 1, '0', '0', 28, 'default_3x3', 'sf_header_en', '', '', 'Blipblop blip blip blip.. Oooh.. what''s this button do?.. You can find out exactly what it does with our new Scifi range, batteries included!', '', 'Click on an item for more information.', '', '', '', ''),
(74, 3, 'Shalimar', 0, 54, '1', '1', 1, '0', '0', 44, 'default_3x3', 'catalog_shal_header1_en', '', '', 'Everyone loves Bollywood! Want some free credits? Tell Oscar you successfully read the Shalimar page! Tell no one else you found this Easter egg. Watch out for rose petals!', '', 'Click on an item for more information.', '', '', '', ''),
(75, 3, 'Summer', 0, 57, '1', '1', 1, '0', '0', 32, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Phwoar! Start up the barbie! This range has everything you need for the perfect summer garden!', '', 'Click on an item for more information.', '', '', '', ''),
(76, 3, 'Love', 0, 62, '1', '1', 1, '0', '0', 46, 'default_3x3', 'catalog_love_headline1', '', '', 'Love is in the air once again! Buy your sweetheart a rose or whisper sweet nothings in their ear on a love sofa. Can you feel it? <3', '', 'Click on an item for more information.', '', '', '', ''),
(77, 3, 'Greek', 0, 31, '1', '1', 1, '0', '0', 25, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Be transported back to ancient Greece with a couple of thousand pounds and British Airways. Until then, build your own panthenon with our realist Greek range!', '', 'Click on an item for more information.', '', '', '', ''),
(85, 4, 'Collectables', 0, 71, '1', '1', 1, '0', '1', 1, 'default_3x3', 'catalog_pixeldeals_headline1_en', 'catalog_pxl_teaser2_en', '', 'The Pixel Collectables are the ultimate collectors items, requiring a mammoth 2000 pixels and credits to buy! If you collect all the pieces and manage to put them together in certain ways, you''ll receive a special effect!', '', 'Click on an item for more information.', '', '', '', ''),
(88, 3, 'Virus', 0, 42, '1', '1', 1, '0', '0', 36, 'default_3x3', 'catalog_vir_header1_en', '', '', 'All of Habbo''s emergency pandemic supplies are kept here! They need a bit of a clean after the exploding puss disease but.. they''ll do fine!', '', 'Click on an item for more information.', '', '', '', ''),
(91, -1, 'Staff Pages', 6, 28, '1', '1', 6, '0', '0', 10, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(93, 91, 'Trophies', 1, 60, '1', '1', 6, '0', '0', 1, 'trophies', 'catalog_trophies_headline1', '', '', 'This page contains special trophies available for staff to give as prizes. STAFF CAUGHT GIVING OUT THESE WITH NO REASON WILL BE DEMOTED.', '', 'Click in this grey box and type your inscription *carefully* - it''s permanent!', '', '', '', ''),
(94, 91, 'Rares', 1, 10, '1', '1', 6, '0', '0', 2, 'default_3x3', 'catalog_rares_headline1', '', '', 'This page contains special rares available for staff. STAFF CAUGHT GIVING OUT THESE WITH NO REASON WILL BE DEMOTED.', '', 'Click on an item for more information.', '', '', '', ''),
(95, 91, 'Promotional', 1, 11, '1', '1', 7, '0', '0', 3, 'default_3x3', 'catalog_rares_headline1', '', '', 'This page contains special promotional items available for staff. STAFF CAUGHT GIVING OUT THESE WITH NO REASON WILL BE DEMOTED.', '', 'Click on an item for more information.', '', '', '', ''),
(102, 3, 'Rollers', 0, 16, '1', '1', 1, '0', '0', 13, 'default_3x3', 'catalog_roller_headline1', '', '', 'Zoooooooom, Zooooooooooooooooooooooooooom! Was it a plane? Was it a bird!? No, it was Roy on a roller! You can use rollers in games, events or even just to  move a queue along.', '', 'Click on an item for more information.', '', '', '', ''),
(103, 3, 'Diner', 0, 51, '1', '1', 1, '0', '0', 30, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Originally from the 50''s this furni has been refurbished and put right into the catalogue! Use this with the Kitchen range for ultimate diner experience!', '', 'Click on an item for more information.', '', '', '', ''),
(105, -1, 'Monthly Epic Rares', 0, 10, '1', '1', 1, '0', '0', 50, 'default_3x3', 'catalog_rares_headline1', '', '', 'On this page, we have some lovely rares for you! We''ve kept a few behind for competition and event prizes!', '', 'Click on an item for more information.', '', '', '', ''),
(112, 3, 'Twilight', 0, 64, '1', '1', 1, '0', '0', 51, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'I''ve never read the book, all I know is it has vampires playing basket ball and some heart throb called Edward Cullen, but the furni looks good!', '', 'Click on an item for more information.', '', '', '', ''),
(116, -1, 'Marketplace', 6, 69, '1', '0', 1, '0', '0', 5, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', '', '', '', '', ''),
(117, 116, 'Offers', 1, 70, '1', '1', 1, '0', '0', 1, 'marketplace', 'catalog_marketplace_header_en', '', '', '', '', '', '', '', '', ''),
(118, 116, 'My Sales', 1, 71, '1', '1', 1, '0', '0', 2, 'marketplace_own_items', 'catalog_marketplace_header_en', '', '', '', '', '', '', '', '', ''),
(119, 116, 'Instructions', 1, 42, '1', '1', 1, '0', '0', 3, 'recycler_info', 'catalog_marketplace_header_en', '', '', 'Habbo Marketplace is a convenient and safe way to buy and sell items in Habbo.', 'How does the Habbo Marketplace work?', 'Selling items:\r\nYou can sell any item which is tradable by selecting the item in your inventory and clicking on ''Sell in Marketplace''. You are able to post 5 items for sale at the cost of 1 credit. You cannot use items currently in the Catalogue.\r\n\r\nBuying items:\r\nBrowse for the item you want to buy on the Marketplace Offers page and click Buy. We guarantee you''ll get the item at the cheapest price available at the moment of purchase.', '', '', '', ''),
(121, 91, 'Trax Machines', 0, 4, '1', '1', 7, '0', '0', 52, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Buy your Trax machines here, ready to load with all your wonderful, musical creations! Check the Sound Sets page for all the discs you could use!', '', 'Click on an item for more information.', '', '', '', ''),
(122, 6, 'Sound Sets', 0, 4, '1', '1', 1, '0', '0', 53, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'We have every sound you could ever want right here! From sound effects and ambient tunes to rock and roll and heavy metal!', '', 'Click on an item for more information.', '', '', '', ''),
(123, 4, 'Hello Furni', 0, 35, '1', '1', 1, '0', '0', 24, 'default_3x3', 'catalog_hello_header1_en', 'catalog_hello_teaser1_en', '', 'Hello Furni is available with Pixels and is perfect if you are decorating your room for the very first time. The Furni is yours to keep and therefore cannot be traded.', '', 'Click on an item for more information.', '', '', '', ''),
(125, 4, 'Special Effects', 0, 61, '1', '1', 1, '0', '0', 25, 'default_3x3', 'catalog_pixeleffects_headline1_en', 'catalog_pxl_teaser1_en', '', 'Tune your character with cool effects that fit the occasion. Ride the hoverboard and spit on the mic. Effects can be activated from the menu, by clicking on your avatar.', '', 'Click on an item for more information.', '', '', '', ''),
(126, 3, 'Tiki', 0, 59, '1', '1', 1, '0', '0', 33, 'default_3x3', 'catalog_tiki_header1_en', '', '', 'Imagine in the scene.. lost on a desert island when you stumble across a small local tribe.. now you can with our Tiki range!', '', 'Click on an item for more information.', '', '', '', ''),
(128, 3, 'Urban', 0, 26, '1', '1', 1, '0', '0', 21, 'default_3x3', 'urban_header_en', '', '', 'New York City styled furni range, Urban is perfect for any street, alleyway or road. Rubbish bins, street lights and benches, all the Urban furniture you need!', '', 'Click on an item for more information.', '', '', '', ''),
(129, 4, 'Automobile', 0, 16, '1', '1', 1, '0', '0', 26, 'default_3x3', 'catalog_automobile_header1_en', 'catalog_automobile_teaser1_en', '', 'Every Habbo needs a car effect! Not only do they bring a bit of the outside inside, they also enhance the air quality! And what better gift for a friend than a beautiful traffic sign or elegant pile of tires...', '', 'Click on an item for more information.', '', '', '', ''),
(130, 3, 'Environment', 0, 21, '1', '1', 1, '0', '0', 34, 'default_3x3', '', '', '', 'Go green with our environmentally friendly Environment range! This selection of furni is perfect for a beautiful, relaxing garden.', '', 'Click on an item for more information.', '', '', '', ''),
(134, 91, 'System', 0, 1, '1', '1', 7, '0', '0', 4, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', '', '', 'Click on an item for more information.', '', '', '', ''),
(136, 3, 'Bling', 0, 42, '1', '1', 1, '0', '0', 52, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'Bling, Bling! Flash, Flash! Want to have that real celebrity lifestyle? Well, go somewhere else, all we have here is a tacky range of furni.', '', 'Click on an item for more information.', '', '', '', ''),
(137, 3, 'Orgie', 51, 1, '1', '1', 1, '0', '0', 55, 'default_3x3', 'catalog_frontpage_headline2_en', '', '', 'The latest range from Ann Summers, the Orgie line. Made of soft, wipe clean plastic, its perfect for any three, four or fivesome!', '', 'Click on an item for more information.', '', '', '', ''),
(139, 14, 'Pets Info', 0, 42, '1', '1', 1, '0', '0', 8, 'pets2', 'catalog_pet_headline1', 'ctlg_pet_note', '', 'Pets are inhabitants of uberHotel too, so each pet owner needs to know a bit about them. Look after your pet by looking through our key points below.', '', '', '- You cannot trade or give away pets. Once you purchase them, they will be yours forever.\r\n- You can own as many as you want, but you can have no more than 5 pets per room.\r\n- You can take pets with you to other rooms, should the room owner allow you to do so.\r\n- Your pet needs to be trained before it''ll listen to your commands. By training your pets, you can gain some awesome achievements as well.', '0', '', ''),
(141, 14, 'Pigs', 0, 67, '1', '1', 1, '0', '0', 1, 'pets', 'catalog_pet_headline1', '', '', 'These little scamps were destined for the dining table until we struck a deal with a local farmer to rescue their cute pigtails! Adopt your little piglet today, all you need now is a name.', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(142, 14, 'Pet Accessories', 0, 43, '1', '1', 1, '0', '0', 7, 'default_3x3', 'catalog_pet_headline1', 'ctlg_pet_teaser1', 'catalog_special_txtbg2', 'This page has everything you need to give your pet the happy life it deserves. We''ve got a huge selection!', '', 'Click on an item for more information.', 'Keep ''em happy!', '0', '', ''),
(143, 3, 'Flower Power', 0, 73, '1', '1', 1, '0', '0', 53, 'default_3x3', 'flowerpower_header_en', '', '', 'Woah! Far out man... let the petals take control. Lets collaborate on a hippy hideout and plant some seeds! Lucy in the sky with diamonds style eyy?!', '', 'Click on an item for more information.', '', '', '', ''),
(144, 3, 'Runway', 0, 74, '1', '1', 1, '0', '0', 54, 'default_3x3', 'runway_header_en', '', '', 'Spice up your salon, hair parlour or boutique with our stylish yet practical range! From sewing machines to comfy seating, we''ve got the perfect option for you.', '', 'Click on an item for more information.', '', '', '', ''),
(146, 14, 'Terriers', 0, 66, '1', '1', 1, '0', '0', 2, 'pets', 'catalog_pet_headline1', '', '', 'Good things come in small packages and Habbo''s Terriers are no exception', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(147, 14, 'Bears', 0, 68, '1', '1', 1, '0', '0', 3, 'pets', 'catalog_pet_headline1', '', '', 'A large, heavy, mammal that walks on the soles of its feet, with thick fur and a very short tail. Fall in love with our adorable range of Bears that include the Grizzly and Polar varieties!', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(148, 14, 'Cats', 0, 20, '1', '1', 1, '0', '0', 4, 'pets', 'catalog_pet_headline1', '', '', 'Fluff, whiskers, meows and purrs! You''re about to enter the world of Habbo Cats. These cute little critters make great playmates and will keep you company if you look after them well. Find a new friend from our ever-changing selection.', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(149, 14, 'Dogs', 0, 24, '1', '1', 1, '0', '0', 5, 'pets', 'catalog_pet_headline1', '', '', 'Wet noses, paws, yaps and woofs! You''re about to enter the world of Habbo Dogs. An adorable and faithful servant awaits you with a wagging tail everytime they see you. Find a new friend from our ever-changing selection.', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(150, 14, 'Crocodiles', 0, 22, '1', '1', 1, '0', '0', 6, 'pets', 'catalog_pet_headline1', '', '', 'Scaly skin, growls and snaps! You''re about to enter the world of Habbo Crocs. Security for your room or to scare your friends a trustworthy and surprisingly loving companion can be yours. Find a new friend from our ever-changing selection', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(157, 14, 'Lion', 1, 76, '1', '1', 1, '0', '0', 0, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(158, 14, 'Rhino', 1, 77, '1', '1', 1, '0', '0', 0, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:Pick a color:Pick a race:', '', '', '', ''),
(159, 3, 'Prison', 2, 14, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_extra_headline1', 'catalog_extra_teaser1', 'catalog_special_txtbg2', 'Ennenjulkaisemattomat kamat!', '', 'Klikkaa tuotteen kuvaa niin n?et lis?tiedot', '', '', '', ''),
(160, 14, 'Accessories', 0, 43, '1', '1', 1, '0', '0', 2, 'default_3x3', 'catalog_pet_headline1', 'ctlg_pet_teaser1', 'catalog_special_txtbg2', 'This page has everything you need to give your pet the happy life it deserves. We''ve got a huge selection!', '', 'Click on an item for more information.', 'Keep ''em happy!', '', '', ''),
(161, 3, 'Beach', 1, 57, '1', '1', 1, '0', '0', 0, 'default_3x3', 'catalog_sports_headline1', 'ctlg_pet_teaser1', '', 'Ennenjulkaisemattomia tavaroita!', '', '', '', '', '', ''),
(165, 3, 'Beach', 1, 84, '1', '1', 1, '0', '0', 5, 'default_3x3', 'verano2', 'beach_teaser', 'catalog_special_txtbg1_en', 'Al parecer, la playa ha llegado al hotel. Ya que estamos en verano, no es imposible dejar de comer helado o estar bronceandonos. Ahora, ?estamos en Playa! Y es hora de echarnos bloqueador solar.', '', '', '?S?lo en este Verano 2010!', '', '', ''),
(169, 3, 'New Furnis', 1, 1, '1', '1', 1, '0', '0', 5, 'default_3x3', '', '', '', '', '', '', '', '', '', ''),
(170, 14, 'Spiders', 0, 95, '1', '1', 1, '0', '0', 7, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:', '', '', '', ''),
(171, 3, 'Soccer 2010', 0, 56, '1', '1', 1, '0', '0', 3, 'default_3x3', 'catalog_rares_headline1', '', '', '', '', '', '', '', '', ''),
(173, 3, 'Other Furnis', 1, 53, '1', '1', 1, '0', '0', 1, 'default_3x3', '', '', '', '', '', '', '', '', '', ''),
(174, 3, 'Party', 2, 4, '1', '1', 1, '0', '0', 1, 'default_3x3', 'catalogue_head_party', '', '', '?Neon? ya es epoca pasada... ?Fiesta? !Aqu?! con estos nuevos furni Fiesta... Arma tu propia fiesta.', '', 'Click en un item, para m?s informaci?n.', '', '', '', ''),
(175, 3, 'Waasa + Other', 1, 102, '1', '1', 1, '0', '0', 5, 'default_3x3', '', '', '', '', '', '', '', 'Klik hier >>', '', ''),
(176, 14, 'Frogs', 1, 97, '1', '1', 1, '0', '0', 8, 'pets', 'catalog_pet_headline1', '', '', '', '', 'Give a name:', '', '', '', ''),
(182, 14, 'Chicken', 0, 0, '1', '1', 1, '0', '0', 2, 'pets', 'catalog_pet_headline1', '', '', 'Good things come in small packages and Habbo''s Chicken are no exception!', '', 'Give a name:', '', '', '', ''),
(200, 3, 'Cubie', 1, 100, '1', '1', 1, '0', '0', 5, 'default_3x3', '', '', '', '', '', '', '', '', '', ''),
(201, 3, 'New Gothic', 1, 30, '1', '1', 1, '0', '0', 7, 'default_3x3', '', '', '', '', '', '', '', '', '', ''),
(300, 3, 'Voodoo', 1, 79, '1', '1', 1, '0', '0', 1, 'default_3x3', '', '', '', '', '', '', '', '', '', ''),
(496, 3, 'Hospital', 10, 1, '1', '1', 1, '0', '0', 5, 'default_3x3', 'The new hospital furniture range is here! Buy it now and create your own Hospital!', '', '', 'The new hospital furniture range is here! Buy it now and create your own Hospital!', '', '', '', '', '', ''),
(497, 3, 'Stray Pixels', 28, 1, '1', '1', 1, '0', '0', 7, 'default_3x3', 'Stray Pixel', '', '', 'Stray Pixel', '', '', '', '', '', ''),
(500, 3, 'Navidad 2010', 1, 3, '1', '1', 1, '0', '0', 10, 'default_3x3', 'catalog_snowflake_en', 'ctlg_pic_snowflake_pilot', '', 'En esta navidad yo te voy a regalar...! La navidad de apodero de Habbo Hotel. Disfruta de tan esperada fecha con todos los nuevos furni.', '', 'Click en un ITEM para ver m', '', '', '', ''),
(501, 3, 'Freeze', 0, 87, '1', '1', 1, '0', '0', 1, 'default_3x3', 'catalog_cltbs_heade r1_es', 'catalog_cltbs_tease r_es', '', 'Bienvenido a Freeze! un nuevo juego en el que tendr?s que ser audaz para atrapar y congelar a tu oponente', '', '', '', '', '', ''),
(502, 3, 'African', 1, 30, '1', '1', 1, '0', '0', 1, 'default_3x3', 'The new African furniture range is here!', '', '', 'The new African furniture range is here!', '', '', '', '', '', ''),
(503, 3, 'New Kitchen ', 1, 43, '1', '1', 1, '0', '0', 5, 'default_3x3', 'The new kitchen furniture range is here!\r\nBuy it before it''s too late!!! :o', '', '', 'The new kitchen furniture range is here!\r\nBuy it before it''s too late!!! :o', '', '', '', '', '', ''),
(600, 3, '?A?o 2011!', 1, 91, '1', '1', 1, '0', '0', 5, 'default_3x3', 'catalog_limited_headline1_en', 'catalog_limited_teaser_en', '', '?Festeja el A?o nuevo con los nuevos Furni!', '', 'Click en un ITEM para m?s informaci?n.', '', '', '', ''),
(777, 3, 'Bling 2011', 1, 1, '1', '1', 1, '0', '0', 3, 'default_3x3', '', '', '', '', '', '', '', '', '', ''),
(778, 3, 'Chinese New Year', 1, 1, '1', '1', 1, '0', '0', 3, 'default_3x3', '', '', '', '', '', '', '', '', '', ''),
(899, -1, 'Limousine', 1, 1, '1', '1', 1, '0', '0', 5, 'default_3x3', '', '', '', '', '', '', '', '', '', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `chatlogs`
--

CREATE TABLE IF NOT EXISTS `chatlogs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `room_id` int(10) unsigned NOT NULL,
  `hour` int(11) NOT NULL,
  `minute` int(11) NOT NULL,
  `full_date` varchar(120) NOT NULL,
  `timestamp` double NOT NULL,
  `message` text NOT NULL,
  `user_name` varchar(100) NOT NULL DEFAULT 'Unknown User',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`,`room_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `cms_contents`
--

CREATE TABLE IF NOT EXISTS `cms_contents` (
  `add_footer` text NOT NULL,
  `add_side` text NOT NULL,
  `googleanalytics` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `cms_contents`
--

INSERT INTO `cms_contents` (`add_footer`, `add_side`, `googleanalytics`) VALUES
('<center> <script type="text/javascript"><!--\r\ngoogle_ad_client = "ca-pub-0642720761789572";\r\n/* Peacock */\r\ngoogle_ad_slot = "9052278378";\r\ngoogle_ad_width = 468;\r\ngoogle_ad_height = 60;\r\n//-->\r\n</script>\r\n<script type="text/javascript"\r\nsrc="http://pagead2.googlesyndication.com/pagead/show_ads.js">\r\n</script> </center>', '', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `connection_test_table`
--

CREATE TABLE IF NOT EXISTS `connection_test_table` (
  `a` char(1) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `country_banned`
--

CREATE TABLE IF NOT EXISTS `country_banned` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `country` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `country` (`country`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `country_sites`
--

CREATE TABLE IF NOT EXISTS `country_sites` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `credit_vouchers`
--

CREATE TABLE IF NOT EXISTS `credit_vouchers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(50) NOT NULL,
  `value` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `code` (`code`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=106 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `ecotron_rewards`
--

CREATE TABLE IF NOT EXISTS `ecotron_rewards` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `display_id` int(10) unsigned NOT NULL,
  `item_id` int(10) unsigned NOT NULL,
  `reward_level` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=27 ;

--
-- Volcado de datos para la tabla `ecotron_rewards`
--

INSERT INTO `ecotron_rewards` (`id`, `display_id`, `item_id`, `reward_level`) VALUES
(1, 2857, 1542, 5),
(2, 2862, 1547, 4),
(3, 2799, 1485, 3),
(4, 2802, 1487, 3),
(5, 2818, 1503, 3),
(6, 2797, 1483, 2),
(7, 2800, 1486, 2),
(8, 2816, 1501, 2),
(9, 2805, 1490, 1),
(10, 2808, 1493, 1),
(11, 2810, 1495, 1),
(12, 2796, 1482, 1),
(13, 2813, 1498, 1),
(14, 2819, 1504, 1),
(15, 2794, 1480, 2),
(16, 2809, 1494, 2),
(17, 2815, 1500, 2),
(18, 2793, 1479, 2),
(19, 2803, 1488, 2),
(20, 2820, 1505, 2),
(21, 4102, 1764, 2),
(22, 4104, 1766, 2),
(23, 4105, 1767, 2),
(24, 2795, 1481, 2),
(25, 2798, 1484, 2),
(26, 2814, 1499, 2);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `external_texts`
--

CREATE TABLE IF NOT EXISTS `external_texts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `skey` text NOT NULL,
  `sval` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=266 ;

--
-- Volcado de datos para la tabla `external_texts`
--

INSERT INTO `external_texts` (`id`, `skey`, `sval`) VALUES
(1, 'badge_desc_MDMWW', 'I won the Habbo Home Exhibition competition!'),
(213, 'badge_desc_adm', 'I''m a staff member here at Habbo!'),
(3, 'badge_name_MDMWW', 'Home Exhibition'),
(212, 'badge_name_adm', 'Habbo Staff'),
(5, 'badge_name_CAA', 'Trial Moderator'),
(6, 'badge_desc_CAA', 'I am a new Moderator being trialed at Habbo.'),
(7, 'badge_name_WHY', '...'),
(8, 'badge_desc_WHY', 'What?'),
(9, 'badge_name_Z63', 'BETA Lab Rat'),
(10, 'badge_desc_Z63', 'Beta tester'),
(11, 'badge_name_BOT', 'Habbo Bot'),
(12, 'badge_desc_BOT', 'I''m an automated worker at HabboHotel.'),
(13, 'navigator.roomsettings.deleteroom.confirm.message', 'Are you sure you want to delete %room_name%? YOU WILL LOSE ALL YOUR FURNITURE!'),
(14, 'badge_name_HUG', 'Hug me'),
(15, 'badge_desc_HUG', 'Give me a hug'),
(16, 'badge_name_HC1', 'Habbo Club Member'),
(17, 'badge_desc_HC1', 'HC Club'),
(18, 'badge_name_VIP', 'V.I.P'),
(19, 'badge_desc_VIP', 'I''m a Very Important Person.'),
(20, 'badge_name_PRE', 'The Press'),
(21, 'badge_desc_PRE', 'I''m a press member of any crews on habbo hotel'),
(22, 'badge_name_Z31', 'Pixel Artist'),
(23, 'badge_desc_Z31', 'I work on Pixel Art.'),
(24, 'badge_name_UK072', 'Throne Trophy'),
(25, 'badge_desc_UK072', 'I was awarded a Throne!'),
(26, 'badge_desc_AP1', 'I''m part of the events team, treat me with respect ª'),
(27, 'badge_name_AP1', 'Events Team'),
(28, 'badge_name_MD1', 'Eddie Murphy'),
(29, 'badge_desc_MD1', 'Eddie Murphy Rocks!'),
(30, 'badge_name_UK020', 'KRAKEN'),
(31, 'badge_desc_UK020', 'Well I would just like to share a picture of your mother with the rest of this hotel|'),
(32, 'badge_name_UK2', 'Tampons |'),
(33, 'badge_desc_UK2', 'I''m the guy that makes sure all you ladies have tampons ª'),
(200, 'badge_name_http://217.23.10.67/c_images/album1584/VA2.gif', ''),
(36, 'badge_name_BBBH1', 'Old Habbo'),
(37, 'badge_desc_BBBH1', 'We miss OLD HABBO!'),
(38, 'badge_name_DE016', 'Room of week'),
(39, 'badge_desc_DE016', 'I won the room of week competition!'),
(40, 'badge_name_DEQ', 'Habbo Awards'),
(41, 'badge_desc_DEQ', 'Winner of the habbo awards!'),
(42, 'badge_name_UK037', 'Britney Spears'),
(43, 'badge_desc_UK037', 'I''m a Britney Spears fan!'),
(44, 'badge_name_UKFB1', 'Facebook'),
(45, 'badge_desc_UKFB1', 'FACEBOOK Badge!'),
(46, 'badge_name_SE009', 'Room Designer'),
(47, 'badge_desc_SE009', 'I design some awesome rooms on uber.'),
(48, 'badge_name_HW1', 'Celebrity'),
(49, 'badge_desc_HW1', 'I''m a hotel celebrity!'),
(50, 'badge_name_US09', 'Habbo Trial Moderator'),
(51, 'badge_desc_US09', 'I''m a trial moderator for Habbo.VG'),
(52, 'badge_name_HBA', 'Gold Hobba'),
(53, 'badge_desc_HBA', 'The Gold Hobba badge is given out to players who are very helpful! These players are volunteer Moderators.'),
(54, 'badge_name_NWB', 'Silver Hobba (Trainee)'),
(55, 'badge_desc_NWB', 'The Silver Hobba badge is given to those Hobbas still in training!'),
(56, 'badge_name_BR080', 'Brazil Follower Badge'),
(57, 'badge_desc_BR080', 'I''m a proud follower of the Brazil team for the World Cup 2010!'),
(58, 'badge_name_FBLL5', 'Goooooal!'),
(59, 'badge_desc_FBLL5', 'I predicted a World Cup 2010 game winner!'),
(60, 'badge_name_FBLL0', 'Fifa World Cup 2010'),
(61, 'badge_desc_FBLL0', 'I predicted which country would win the Fifa World Cup 2010!'),
(62, 'badge_name_TLB', 'Habbo Technician'),
(63, 'badge_desc_TLB', 'This badge is given to the Technicians of Habbo.'),
(64, 'badge_name_ES005', 'Go Argentina!'),
(65, 'badge_desc_ES005', 'I voted for Argentina to win the 2010 World Cup!'),
(66, 'badge_name_ES009', 'Go Netherlands!'),
(67, 'badge_desc_ES009', 'I voted for the Netherlands to win the 2010 World Cup!'),
(68, 'badge_name_ES012', 'Go Spain!'),
(69, 'badge_desc_ES012', 'I voted for Spain to win the 2010 World Cup!'),
(70, 'badge_name_ES017', 'Go Paraguay!'),
(71, 'badge_desc_ES017', 'I voted for Paraguay to win the 2010 World Cup!'),
(72, 'badge_name_ES019', 'Go Uruguay!'),
(73, 'badge_desc_ES019', 'I voted for Uruguay to win the 2010 World Cup!'),
(74, 'badge_name_DE5', 'Go Germany!'),
(75, 'badge_desc_DE5', 'I voted for Germany to win the 2010 World Cup!'),
(76, 'badge_desc_NLB', 'I''m a Official Habbo.GG DJ'),
(77, 'badge_name_NLB', 'Habbo.GG'),
(78, 'badge_name_US0K', ''),
(79, 'badge_desc_US0K', ''),
(80, 'badge_name_FRL', 'Pixel Hotel'),
(81, 'badge_desc_FRL', 'I did Pixel Art on this Hotel!'),
(82, 'badge_name_ES076', 'Cheetos'),
(83, 'badge_desc_ES076', 'Cause i love Cheetos!'),
(84, 'badge_name_DE036', 'Weener'),
(85, 'badge_desc_DE036', 'Every Staff needs to have a Weener!'),
(86, 'badge_name_Z39', 'Sparky'),
(87, 'badge_desc_Z39', 'Woof, im Sparky!'),
(88, 'badge_name_Z35', 'Speedy'),
(89, 'badge_desc_Z35', 'Woof, im Speedy!'),
(90, 'badge_name_UK065', 'News Expert'),
(91, 'badge_desc_UK065', 'Only for the real News Experts.'),
(92, 'badge_desc_SE2(2)', 'Only for Martin, call me if you need help. ;)'),
(95, 'badge_name_SE5', 'Laurent''s Cellphone'),
(96, 'badge_desc_SE5', 'Only for Laurent, call me if you need help. ;)'),
(99, 'badge_name_SE2(2)', 'Martin''s Cellphone'),
(100, 'badge_name_FR007', 'FireFox'),
(101, 'badge_desc_FR007', 'OK!'),
(102, 'badge_name_MS3', 'Kirby Angry!'),
(103, 'badge_desc_MS3', 'DAMN, I GOT NO CHEETOS!'),
(104, 'badge_name_DEG', 'Horny'),
(105, 'badge_desc_DEG', 'This badge just makes me Horny!'),
(106, 'badge_name_FBLL3', 'I know my soccer!'),
(107, 'badge_desc_FBLL3', 'This badge was given to those who got a question right at the 2010 World Cup Trivia!'),
(108, 'badge_name_ES027', 'I love soccer!'),
(109, 'badge_desc_ES027', 'I showed how smart I was by answering the hardest question at the World Cup trivia!'),
(110, 'badge_name_WD4', 'July Fourth!'),
(111, 'badge_desc_WD4', 'I partied with hotel staff in the party room on July Fourth, 2010!'),
(112, 'badge_name_RUN05', 'Fashion'),
(113, 'badge_desc_RUN05', 'Style is my name, and fashion is my game. Fashion finalist in July 2010.'),
(114, 'badge_name_RUN04', 'Fashion Winner!'),
(115, 'badge_desc_RUN04', 'I was the winner in a Fashion competition in July 2010.'),
(116, 'badge_name_US0K', 'Vrooooom!'),
(117, 'badge_desc_US0K', 'I was one of the fastest Habbo''s at the racing event, July 2010!'),
(118, 'badge_name_HS1', 'Super Hobba'),
(119, 'badge_desc_HS1', 'This badge is given to a Super Hobba. There is only one Super Hobba in the hotel.'),
(122, 'badge_name_HOP01', 'Habbo Events 2010 Gold'),
(123, 'badge_desc_HOP01', 'I placed first place in one of the July Habbo events!'),
(124, 'badge_name_HOP02', 'Habbo Events 2010 Silver'),
(125, 'badge_desc_HOP02', 'I placed second place in one of the July Habbo events!'),
(126, 'badge_name_HOP03', 'Habbo Events 2010 Bronze'),
(127, 'badge_desc_HOP03', 'I placed third place in one of the July Habbo events!'),
(128, 'badge_name_IT038', 'FOOTBALL Fever!'),
(129, 'badge_desc_IT038', 'I was in the 2010 Fifa World Cup™ room, and watched the entire game!'),
(130, 'badge_name_FBLL4', 'FOOTBALL Fever!'),
(131, 'badge_desc_FBLL4', 'I voted right on the last game for Spain before the final Fifa 2010 World Cup™!'),
(132, 'badge_name_FBLL7', '2010 Fifa World Cup Badge'),
(133, 'badge_desc_FBLL7', 'I was there to represent my team at a Fifa World Cup staff room.'),
(134, 'badge_name_EXH', 'Ex-Hobba Badge'),
(135, 'badge_desc_EXH', 'This unique badge was to the past Hobbas. Habbo.vg no longer has Hobbas. Thanks for your dedication and support!'),
(136, 'badge_name_US0W', 'I know music!'),
(137, 'badge_desc_US0W', 'This badge was given to the habbos who guessed the right song in the 2010 July Event!'),
(138, 'badge_name_EC2', 'Tree Solver badge'),
(139, 'badge_desc_EC2', 'Given to the Habbos who submitted the correct clue in the Habboville Forest competition!'),
(140, 'badge_name_PX0', 'Straypixels x1'),
(141, 'badge_desc_PX0', 'I submitted a unique pixel photo and won!'),
(142, 'badge_name_EC3', 'Tree Solver badge'),
(143, 'badge_desc_EC3', 'Given to the Habbos who submitted the correct clue in the second Habboville Forest competition!'),
(146, 'badge_name_BGWV7', 'D&B Show Badge'),
(147, 'badge_desc_BGWV7', 'This badge is awarded to those who have participated in a D&B event. Summer 2010'),
(148, 'badge_name_RM0', 'Room of the Week Winner'),
(149, 'badge_desc_RM0', 'This badge is award to those who have won Room of the Week!'),
(150, 'badge_name_UST', 'Room of the Week Winner'),
(151, 'badge_desc_UST', 'This badge is award to those who have won Room of the Week!'),
(152, 'badge_name_US0B', 'Competition Winner!'),
(153, 'badge_desc_US0B', 'I won a competition at Habbo!'),
(154, 'badge_desc_FR005', 'I submitted ideas to Habbo.vg Staff!'),
(155, 'badge_name_FR005', 'Ideas Badge'),
(156, 'badge_desc_HC2', ''),
(157, 'badge_name_HC2', ''),
(158, 'badge_name_SB1', 'POOLS CLOSED!'),
(159, 'badge_desc_SB1', 'Pools closed due to aids!'),
(160, 'badge_name_FI001', ''),
(161, 'badge_desc_FI001', ''),
(175, 'badge_desc_UK076', ''),
(174, 'badge_name_UK076', ''),
(164, 'badge_name_MTV02', ''),
(165, 'badge_desc_MTV02', ''),
(166, 'badge_name_DSX', ''),
(167, 'badge_desc_DSX', ''),
(168, 'badge_name_DS6', ''),
(169, 'badge_desc_DS6', ''),
(170, 'badge_name_DS5', ''),
(171, 'badge_desc_DS5', ''),
(172, 'badge_name_US08', ''),
(173, 'badge_desc_US08', ''),
(176, 'badge_name_UK077', ''),
(177, 'badge_desc_UK077', ''),
(178, 'badge_name_UK078', ''),
(179, 'badge_desc_UK078', ''),
(183, 'badge_desc_UK105', ''),
(182, 'badge_name_UK105', ''),
(184, 'badge_name_UK079', ''),
(185, 'badge_desc_UK079', ''),
(186, 'badge_name_DS0', ''),
(187, 'badge_desc_DS0', ''),
(188, 'badge_name_DS3', ''),
(189, 'badge_desc_DS3', ''),
(190, 'badge_name_DS4', ''),
(191, 'badge_desc_DS4', ''),
(194, 'badge_name_ORA', 'Orange'),
(195, 'badge_desc_ORA', 'Im the fucking only Orange in this hotel ^^'),
(235, 'badge_desc_CAK', 'Happy Canada Day 2011!'),
(201, 'badge_desc_http://217.23.10.67/c_images/album1584/VA2.gif', ''),
(204, 'badge_name_UK025', 'Friday 13'),
(205, 'badge_desc_UK025', 'It''s Friday the 13th!'),
(206, 'badge_name_UK6', 'Dev-Studios.NET'),
(207, 'badge_desc_UK6', 'I registered on Dev-Studios.NET and got this badge!'),
(208, 'badge_name_UK6', 'Dev-Studios.NET'),
(209, 'badge_desc_UK6', 'I registered on Dev-Studios.NET and got this badge!'),
(210, 'badge_name_CH010', 'Dev-Studios.NET'),
(211, 'badge_desc_CH010', 'I registered on Dev-Studios.NET and got this badge!'),
(216, 'badge_name_MRG03', 'Habbo VG/GG'),
(217, 'badge_desc_MRG03', 'I came to Habbo.GG from Habbo.VG!'),
(221, 'badge_desc_ADM1337', 'It 0wns!'),
(220, 'badge_name_ADM1337', 'Habbo.GG Owner'),
(222, 'badge_name_ADMRed', 'Habbo.GG Senior Admin'),
(223, 'badge_desc_ADMRed', 'I''m a Senior Admin at Habbo.GG'),
(224, 'badge_name_ADMBlue', 'Habbo.GG Admin'),
(225, 'badge_desc_ADMBlue', 'I''m a Admin at Habbo.GG'),
(226, 'badge_name_ADMGreen', 'Habbo.GG Senior Mod'),
(227, 'badge_desc_ADMGreen', 'I''m a Senior Mod at Habbo.GG'),
(228, 'badge_name_AM4', 'Tetsuda'),
(229, 'badge_desc_AM4', 'The secret organization for Habbo.gg.'),
(230, 'badge_name_https://mail.google.com/mail/?ui=2&ik=b25c019c12&view=att&th=130dba7f65b87d07&attid=0.1&disp=thd&zw', ''),
(231, 'badge_desc_https://mail.google.com/mail/?ui=2&ik=b25c019c12&view=att&th=130dba7f65b87d07&attid=0.1&disp=thd&zw', ''),
(234, 'badge_name_CAK', 'Canada Day'),
(248, 'badge_name_TC3', 'In Charge Of All Event Staff'),
(247, 'badge_desc_TC1', 'Event Staff        (I Work For Baris)'),
(246, 'badge_name_TC1', 'Event Staff'),
(244, 'badge_name_TC2', 'Event Staff'),
(245, 'badge_desc_TC2', 'Head Event Staff   (I Work For Baris)'),
(250, 'badge_name_LEE', 'Lees badge'),
(249, 'badge_desc_TC3', 'In Charge Of All Event Staff'),
(251, 'badge_desc_LEE', 'Lee is da beast.'),
(252, 'badge_name_Au1', 'Black Bobbas'),
(253, 'badge_desc_Au1', 'I joined The black bobbas'),
(257, 'badge_desc_50S', 'I am a fan of 1337''s music'),
(256, 'badge_name_50S', 'Music fan'),
(258, 'badge_name_JPB', 'I Smile'),
(259, 'badge_desc_JPB', 'I love gg <3'),
(260, 'badge_name_http://bl153w.blu153.mail.live.com/att/GetAttachment.aspx?tnail=0&messageId=38c2d146-cfde-11e0-8cac-001e0bcbb1e8&Aux=54|0|8CE32021E064770||0|0|0|0||&maxwidth=220&maxheight=160&size=Att', 'Big Brother'),
(261, 'badge_desc_http://bl153w.blu153.mail.live.com/att/GetAttachment.aspx?tnail=0&messageId=38c2d146-cfde-11e0-8cac-001e0bcbb1e8&Aux=54|0|8CE32021E064770||0|0|0|0||&maxwidth=220&maxheight=160&size=Att', '<3'),
(262, 'badge_name_Fan', 'Hannah <3'),
(263, 'badge_desc_Fan', 'H is for Hannah <3'),
(264, 'badge_name_UK010', 'Memorial Badge'),
(265, 'badge_desc_UK010', 'Respect for Lei');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `external_variables`
--

CREATE TABLE IF NOT EXISTS `external_variables` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `skey` text NOT NULL,
  `sval` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `faq`
--

CREATE TABLE IF NOT EXISTS `faq` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `question` text NOT NULL,
  `answer` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`) USING BTREE
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=11 ;

--
-- Volcado de datos para la tabla `faq`
--

INSERT INTO `faq` (`id`, `question`, `answer`) VALUES
(1, 'How can I be staff?', 'Wait for sollicitations'),
(2, 'Can I have more credits?', 'You get 3000 new credits each day when you log in'),
(3, 'Can I have a rare?', 'No'),
(4, 'Can I have more pixels?', 'No, pixels are given out as long as you are online'),
(5, 'When will pets get released?', 'They are allready in the catalog.'),
(7, 'Can staff come and advertise my room?', 'No'),
(9, 'Can I be friend with staff?', 'No'),
(10, 'Can i have a Badge?', 'No');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `furniture`
--

CREATE TABLE IF NOT EXISTS `furniture` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `public_name` text NOT NULL COMMENT 'temp only',
  `item_name` varchar(100) NOT NULL,
  `type` enum('s','i','e','h') NOT NULL DEFAULT 's',
  `width` int(11) NOT NULL DEFAULT '1',
  `length` int(11) NOT NULL DEFAULT '1',
  `stack_height` double NOT NULL DEFAULT '1',
  `can_stack` enum('0','1') NOT NULL DEFAULT '1',
  `can_sit` enum('0','1') NOT NULL DEFAULT '0',
  `is_walkable` enum('0','1') NOT NULL DEFAULT '0',
  `sprite_id` int(11) NOT NULL,
  `allow_recycle` enum('0','1') NOT NULL DEFAULT '1',
  `allow_trade` enum('0','1') NOT NULL DEFAULT '1',
  `allow_marketplace_sell` enum('0','1') NOT NULL DEFAULT '1',
  `allow_gift` enum('0','1') NOT NULL DEFAULT '1',
  `allow_inventory_stack` enum('0','1') NOT NULL DEFAULT '1',
  `interaction_type` enum('default','gate','postit','roomeffect','dimmer','trophy','bed','scoreboard','vendingmachine','alert','onewaygate','loveshuffler','habbowheel','dice','bottle','teleport','rentals','pet','pool','roller','fbgate','lowpool','haloweenpool','normalskates','iceskates','pet0','pet1','pet2','pet3','pet4','pet5','pet6','pet7','pet8','pet9','pet10','pet11','pet12','football','footballgoalred','footballgoalblue','footballgoalyellow','footballgoalgreen','footballcountered','footballcountergreen','footballcounterblue','footballcounteryellow','banzaigateblue','banzaigatered','banzaigateyellow','banzaigategreen','banzaifloor','banzaiscoreblue','banzaiscorered','banzaiscoreyellow','banzaiscoregreen','banzaicounter','banzaitele','banzaipuck','banzaipyramid','freezetimer','freezeexit','freezeredcounter','freezebluecounter','freezeyellowcounter','freezegreencounter','freezeyellowgate','freezeredgate','freezegreengate','freezebluegate','freezetileblock','freezetile','musicdisc','triggertimer','triggerroomenter','triggergameend','triggergamestart','triggerrepeater','triggeronusersay','triggerscoreachieved','triggerstatechanged','triggerwalkonfurni','triggerwalkofffurni','actiongivescore','actionposreset','actionmoverotate','actionresettimer','actionshowmessage','actionteleportto','actiontogglestate','conditionfurnishaveusers','conditionstatepos','conditiontimelessthan','conditiontimemorethan','conditiontriggeronfurni','arrowplate','preassureplate','ringplate','colortile','colorwheel','floorswitch1','floorswitch2','firegate','glassfoor','specialrandom','specialunseen','wire','wireCenter','wireCorner','wireSplitter','wireStandard','pet13','pet14') NOT NULL DEFAULT 'default',
  `interaction_modes_count` int(11) NOT NULL DEFAULT '1',
  `vending_ids` varchar(100) NOT NULL DEFAULT '0',
  `foot_figure` char(2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4568441 ;

--
-- Volcado de datos para la tabla `furniture`
--

INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1, 'Bookcase', 'shelves_norja', 's', 1, 1, 1, '0', '0', '0', 13, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(2, 'Bookcase', 'shelves_polyfon', 's', 2, 1, 1, '0', '0', '0', 14, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(3, 'Bookcase', 'shelves_silo', 's', 2, 1, 1, '0', '0', '0', 15, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4, 'Small Coffee Table', 'table_polyfon_small', 's', 2, 2, 1, '0', '0', '0', 17, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(5, 'Dining Chair', 'chair_polyfon', 's', 1, 1, 1, '0', '1', '0', 18, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(6, 'Coffee Table', 'table_norja_med', 's', 2, 2, 1, '1', '0', '0', 20, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(7, 'Coffee Table', 'table_silo_med', 's', 2, 2, 1, '1', '0', '0', 21, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(8, 'Occasional Table', 'table_plasto_4leg', 's', 2, 2, 1, '1', '0', '0', 22, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(9, 'Round Dining Table', 'table_plasto_round', 's', 2, 2, 1, '1', '0', '0', 23, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(10, 'Square Dining Table', 'table_plasto_bigsquare', 's', 2, 2, 1, '1', '0', '0', 24, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(11, 'Shelf', 'stand_polyfon_z', 's', 1, 1, 0.5, '1', '0', '0', 25, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(12, 'Dining Chair', 'chair_silo', 's', 1, 1, 1.1, '0', '1', '0', 26, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(13, 'Cushioned', 'sofa_silo', 's', 2, 1, 1.1, '0', '1', '0', 28, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(14, 'Bench', 'couch_norja', 's', 2, 1, 1, '0', '1', '0', 29, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(15, 'Chair', 'chair_norja', 's', 1, 1, 1, '0', '1', '0', 30, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(16, 'Large Coffee Table', 'table_polyfon_med', 's', 2, 2, 1, '1', '0', '0', 31, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(17, 'Doormat', 'doormat_love', 's', 1, 1, 0.1, '0', '0', '1', 32, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(18, 'Doormat', 'doormat_plain', 's', 1, 1, 0.1, '0', '0', '1', 33, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19, 'Armchair', 'sofachair_polyfon', 's', 1, 1, 1.1, '0', '1', '0', 34, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20, 'Two-seater Sofa', 'sofa_polyfon', 's', 2, 1, 1.1, '0', '1', '0', 35, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(21, 'Large', 'sofachair_silo', 's', 1, 1, 1.1, '0', '1', '0', 36, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(22, 'Plastic Pod Chair', 'chair_plasty', 's', 1, 1, 1, '0', '1', '0', 38, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(23, 'Chair', 'chair_plasto', 's', 1, 1, 1, '0', '1', '0', 39, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(24, 'Occasional Table', 'table_plasto_square', 's', 1, 1, 1, '1', '0', '0', 40, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25, 'Double Bed', 'bed_polyfon', 's', 2, 3, 1.8, '0', '0', '0', 41, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(26, 'Single Bed', 'bed_polyfon_one', 's', 1, 3, 1.8, '0', '0', '0', 42, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(27, 'Plain Single Bed', 'bed_trad_one', 's', 2, 3, 1, '0', '0', '0', 43, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(28, 'Plain Double Bed', 'bed_trad', 's', 2, 3, 1, '0', '0', '0', 44, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(29, 'Single Bed', 'bed_silo_one', 's', 1, 3, 1.8, '0', '0', '0', 45, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(30, 'Double Bed', 'bed_silo_two', 's', 2, 3, 1.8, '0', '0', '0', 46, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(31, 'Occasional Table', 'table_silo_small', 's', 1, 1, 1, '1', '0', '0', 47, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(32, 'Double Bed', 'bed_armas_two', 's', 2, 3, 1.8, '0', '0', '0', 48, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(33, 'bed_budget_one', 'bed_budget_one', 's', 1, 3, 1.9, '0', '0', '0', 49, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(34, 'Comfortable', 'bed_budget', 's', 2, 3, 1.9, '0', '0', '0', 50, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(35, 'Bookcase', 'shelves_armas', 's', 2, 1, 1, '0', '0', '0', 51, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(36, 'Bench', 'bench_armas', 's', 2, 1, 1.1, '0', '1', '0', 52, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(37, 'Dining Table', 'table_armas', 's', 2, 2, 1, '1', '0', '0', 53, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(38, 'Occasional Table', 'small_table_armas', 's', 1, 1, 1, '1', '0', '0', 54, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(39, 'Stool', 'small_chair_armas', 's', 1, 1, 1, '0', '1', '0', 55, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(40, 'Authentic', 'fireplace_armas', 's', 2, 1, 1, '0', '0', '0', 56, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(41, 'Table Lamp', 'lamp_armas', 's', 1, 1, 1, '0', '0', '0', 57, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(42, 'Single Bed', 'bed_armas_one', 's', 1, 3, 1.8, '0', '0', '0', 58, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(43, 'Floor rug', 'carpet_standard', 's', 3, 5, 0, '1', '0', '1', 59, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(44, 'Hand-Woven Rug', 'carpet_armas', 's', 2, 4, 0, '1', '0', '1', 60, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(45, 'Faux-Fur Bear Rug', 'carpet_polar', 's', 2, 3, 0, '1', '0', '1', 61, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(46, 'Fireplace', 'fireplace_polyfon', 's', 2, 1, 1, '0', '0', '0', 62, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(47, 'Square Dining Table', 'table_plasto_4leg*1', 's', 2, 2, 1, '1', '0', '0', 63, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(48, 'Square Dining Table', 'table_plasto_bigsquare*1', 's', 2, 2, 1, '1', '0', '0', 64, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(49, 'Round Dining Table', 'table_plasto_round*1', 's', 2, 2, 1, '1', '0', '0', 65, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(50, 'Occasional Table', 'table_plasto_square*1', 's', 1, 1, 1, '1', '0', '0', 66, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(51, 'Chair', 'chair_plasto*1', 's', 1, 1, 1, '0', '1', '0', 67, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(52, 'Floor Rug', 'carpet_standard*1', 's', 3, 5, 0, '1', '0', '1', 68, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(53, 'Doormat', 'doormat_plain*1', 's', 1, 1, 0.1, '0', '0', '1', 69, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(54, 'Occasional Table', 'table_plasto_4leg*2', 's', 2, 2, 1, '1', '0', '0', 70, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(55, 'Square Dining Table', 'table_plasto_bigsquare*2', 's', 2, 2, 1, '1', '0', '0', 71, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(56, 'Round Dining Table', 'table_plasto_round*2', 's', 2, 2, 1, '1', '0', '0', 72, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(57, 'Round Dining Table', 'table_plasto_square*2', 's', 1, 1, 1, '1', '0', '0', 73, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(58, 'Chair', 'chair_plasto*2', 's', 1, 1, 1, '0', '1', '0', 74, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(59, 'Doormat', 'doormat_plain*2', 's', 1, 1, 0.1, '0', '0', '1', 75, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(60, 'Floor Rug', 'carpet_standard*2', 's', 3, 5, 0, '1', '0', '1', 76, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(61, 'Round Dining Table', 'table_plasto_4leg*3', 's', 2, 2, 1, '1', '0', '0', 77, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(62, 'Square Dining Table', 'table_plasto_bigsquare*3', 's', 2, 2, 1, '1', '0', '0', 78, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(63, 'Round Dining Table', 'table_plasto_round*3', 's', 2, 2, 1, '1', '0', '0', 79, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(64, 'Square Dining Table', 'table_plasto_square*3', 's', 1, 1, 1, '1', '0', '0', 80, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(65, 'Chair', 'chair_plasto*3', 's', 1, 1, 1, '0', '1', '0', 81, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(66, 'Floor Rug', 'carpet_standard*3', 's', 3, 5, 0, '1', '0', '1', 82, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(67, 'Doormat', 'doormat_plain*3', 's', 1, 1, 0.1, '0', '0', '1', 83, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(68, 'Square Dining Table', 'table_plasto_4leg*4', 's', 2, 2, 1, '1', '0', '0', 84, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(71, 'Square Dining Table', 'table_plasto_square*4', 's', 1, 1, 1, '1', '0', '0', 87, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(72, 'Chair', 'chair_plasto*4', 's', 1, 1, 1, '0', '1', '0', 88, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(73, 'Floor Rug', 'carpet_standard*4', 's', 3, 5, 0, '1', '0', '1', 89, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(74, 'Doormat', 'doormat_plain*4', 's', 1, 1, 0.1, '0', '0', '1', 90, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(75, 'Doormat', 'doormat_plain*6', 's', 1, 1, 0.1, '0', '0', '1', 91, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(76, 'Doormat', 'doormat_plain*5', 's', 1, 1, 0.1, '0', '0', '1', 93, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77, 'Floor Rug', 'carpet_standard*5', 's', 3, 5, 0, '1', '0', '1', 94, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(78, 'Occasional Table', 'table_plasto_4leg*5', 's', 2, 2, 1, '1', '0', '0', 95, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(79, 'Square Dining Table', 'table_plasto_bigsquare*5', 's', 2, 2, 1, '1', '0', '0', 96, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(80, 'Round Dining Table', 'table_plasto_round*5', 's', 2, 2, 1, '1', '0', '0', 97, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(81, 'Square Dining Table', 'table_plasto_square*5', 's', 1, 1, 1, '1', '0', '0', 98, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(82, 'Chair', 'chair_plasto*5', 's', 1, 1, 1, '0', '1', '0', 99, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(83, 'Occasional table Table', 'table_plasto_4leg*6', 's', 2, 2, 1, '1', '0', '0', 100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(84, 'Square Dining Table', 'table_plasto_bigsquare*6', 's', 2, 2, 1, '1', '0', '0', 101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(85, 'Round Dining Table', 'table_plasto_round*6', 's', 2, 2, 1, '1', '0', '0', 102, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(86, 'Square Dining Table', 'table_plasto_square*6', 's', 1, 1, 1, '1', '0', '0', 103, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(87, 'Chair', 'chair_plasto*6', 's', 1, 1, 1, '0', '1', '0', 104, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(88, 'Occasional table', 'table_plasto_4leg*7', 's', 2, 2, 1, '1', '0', '0', 105, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89, 'Square Dining Table', 'table_plasto_bigsquare*7', 's', 2, 2, 1, '1', '0', '0', 106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(90, 'Round Dining Table', 'table_plasto_round*7', 's', 2, 2, 1, '1', '0', '0', 107, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(91, 'Square Dining Table', 'table_plasto_square*7', 's', 1, 1, 1, '1', '0', '0', 108, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(92, 'Chair', 'chair_plasto*7', 's', 1, 1, 1, '0', '1', '0', 109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(93, 'Occasional Table', 'table_plasto_4leg*8', 's', 2, 2, 1, '1', '0', '0', 110, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(94, 'Square Dining Table', 'table_plasto_bigsquare*8', 's', 2, 2, 1, '1', '0', '0', 111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95, 'Round Dining Table', 'table_plasto_round*8', 's', 2, 2, 1, '1', '0', '0', 112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(96, 'Square Dining Table', 'table_plasto_square*8', 's', 1, 1, 1, '1', '0', '0', 113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(97, 'Chair', 'chair_plasto*8', 's', 1, 1, 1, '0', '1', '0', 114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(98, 'Occasional Table', 'table_plasto_4leg*9', 's', 2, 2, 1, '1', '0', '0', 115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99, 'Square Dining Table', 'table_plasto_bigsquare*9', 's', 2, 2, 1, '1', '0', '0', 116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(100, 'Square Dining Table', 'table_plasto_round*9', 's', 2, 2, 1, '1', '0', '0', 117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(101, 'Chair', 'chair_plasto*9', 's', 1, 1, 1, '0', '1', '0', 119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(102, 'Floor Rug', 'carpet_standard*6', 's', 3, 5, 0, '1', '0', '1', 120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(103, 'Plastic Pod Chair', 'chair_plasty*1', 's', 1, 1, 1, '0', '1', '0', 121, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(104, 'Pizza Box', 'pizza', 's', 1, 1, 1, '0', '0', '0', 122, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(105, 'Empty Cans', 'drinks', 's', 1, 1, 1, '0', '0', '0', 123, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(106, 'Plastic Pod Chair', 'chair_plasty*2', 's', 1, 1, 1, '0', '1', '0', 124, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(107, 'Plastic Pod Chair', 'chair_plasty*3', 's', 1, 1, 1, '0', '1', '0', 125, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(108, 'Plastic Pod Chair', 'chair_plasty*4', 's', 1, 1, 1, '0', '1', '0', 126, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(109, 'Mini-Bar', 'bar_polyfon', 's', 1, 1, 1, '0', '0', '0', 127, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,5,2,1', ''),
(110, 'Aloe Vera', 'plant_cruddy', 's', 1, 1, 1, '0', '0', '0', 128, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(111, 'Empty Spinning Bottle', 'bottle', 's', 1, 1, 1, '0', '0', '0', 129, '1', '1', '1', '1', '1', 'bottle', 0, '0', ''),
(112, 'Bar/desk', 'bardesk_polyfon', 's', 2, 1, 1, '1', '0', '0', 130, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(113, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon', 's', 1, 1, 1, '1', '0', '0', 131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(115, 'Barrel Minibar', 'bar_armas', 's', 1, 1, 1, '0', '0', '0', 133, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,2,1', ''),
(116, 'Bardesk', 'bartable_armas', 's', 1, 3, 1.2, '1', '0', '0', 134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(117, 'Barrel Stool', 'bar_chair_armas', 's', 1, 1, 1.2, '0', '1', '0', 135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(118, 'Soft Wool Rug', 'carpet_soft', 's', 2, 4, 0, '1', '0', '1', 136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(119, 'Soft Wool Rug', 'carpet_soft*1', 's', 2, 4, 0, '1', '0', '1', 137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(120, 'Soft Wool Rug', 'carpet_soft*2', 's', 2, 4, 0, '1', '0', '1', 138, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(121, 'Soft Wool Rug', 'carpet_soft*3', 's', 2, 4, 0, '1', '0', '1', 139, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(122, 'Soft Wool Rug', 'carpet_soft*4', 's', 2, 4, 0, '1', '0', '1', 140, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(123, 'Soft Wool Rug', 'carpet_soft*5', 's', 2, 4, 0, '1', '0', '1', 141, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(124, 'Soft Wool Rug', 'carpet_soft*6', 's', 2, 4, 0, '1', '0', '1', 143, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(125, 'Portable TV', 'red_tv', 's', 1, 1, 1, '0', '0', '0', 144, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(126, 'Large TV', 'wood_tv', 's', 1, 2, 1, '0', '0', '0', 145, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(127, 'Pink Faux-Fur Bear Rug', 'carpet_polar*1', 's', 2, 3, 0, '1', '0', '1', 146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(128, 'Plastic Pod Chair', 'chair_plasty*5', 's', 1, 1, 1, '0', '1', '0', 147, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(129, 'Blue Bear Rug', 'carpet_polar*2', 's', 2, 3, 0, '1', '0', '1', 148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(130, 'Yellow Bear Rug', 'carpet_polar*3', 's', 2, 3, 0, '1', '0', '1', 149, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(131, 'Green Bear Rug', 'carpet_polar*4', 's', 2, 3, 0, '1', '0', '1', 150, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(132, 'Plastic Pod Chair', 'chair_plasty*6', 's', 1, 1, 1, '0', '1', '0', 151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(133, 'Large Coffee Table', 'table_polyfon', 's', 2, 2, 1, '1', '0', '0', 152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(134, 'Large Dining Table', 'smooth_table_polyfon', 's', 2, 2, 1, '1', '0', '0', 153, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(135, 'Armchair', 'sofachair_polyfon_girl', 's', 1, 1, 1.1, '0', '1', '0', 154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(136, 'Single Bed', 'bed_polyfon_girl_one', 's', 1, 3, 1.8, '0', '0', '0', 155, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(137, 'Double Bed', 'bed_polyfon_girl', 's', 2, 3, 1.8, '0', '0', '0', 156, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(138, 'Two-seater Sofa', 'sofa_polyfon_girl', 's', 2, 1, 1.1, '0', '1', '0', 157, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(139, 'Plain Single Bed', 'bed_budgetb_one', 's', 1, 3, 1.9, '0', '0', '0', 158, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(140, 'Plain Double Bed', 'bed_budgetb', 's', 2, 3, 1.9, '0', '0', '0', 159, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(141, 'Pineapple Plant', 'plant_pineapple', 's', 1, 1, 1, '0', '0', '0', 160, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(142, 'Fruit Tree', 'plant_fruittree', 's', 1, 1, 1, '0', '0', '0', 161, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(143, 'Small Cactus', 'plant_small_cactus', 's', 1, 1, 1, '0', '0', '0', 162, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(144, 'Bonsai Tree', 'plant_bonsai', 's', 1, 1, 1, '0', '0', '0', 163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(145, 'Mature Cactus', 'plant_big_cactus', 's', 1, 1, 1, '0', '0', '0', 164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(146, 'Yukka Plant', 'plant_yukka', 's', 1, 1, 1, '0', '0', '0', 165, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(147, 'Floor Rug', 'carpet_standard*7', 's', 3, 5, 0, '1', '0', '1', 166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(148, 'Floor Rug', 'carpet_standard*8', 's', 3, 5, 0, '1', '0', '1', 167, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(149, 'Floor Rug', 'carpet_standard*9', 's', 3, 5, 0, '1', '0', '1', 168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(150, 'Floor Rug', 'carpet_standard*10', 's', 3, 5, 0, '1', '0', '1', 169, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(151, 'Floor Rug', 'carpet_standard*11', 's', 3, 5, 0, '1', '0', '1', 170, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(152, 'Cut Sunflower', 'plant_sunflower', 's', 1, 1, 1, '0', '0', '0', 171, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(153, 'Cut Roses', 'plant_rose', 's', 1, 1, 1, '0', '0', '0', 172, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(154, 'Digital TV', 'tv_luxus', 's', 1, 3, 1, '0', '0', '0', 173, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(155, 'Bubble Bath', 'bath', 's', 1, 2, 1, '0', '1', '0', 174, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(156, 'Sink', 'sink', 's', 1, 1, 1, '0', '0', '0', 177, '1', '1', '1', '1', '1', 'vendingmachine', 0, '100', ''),
(157, 'Loo Seat', 'toilet', 's', 1, 1, 1.2, '0', '1', '0', 178, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(158, 'Rubber Duck', 'duck', 's', 1, 1, 1, '0', '0', '0', 179, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(159, 'Floor Tiles', 'tile', 's', 4, 4, 0, '1', '0', '1', 180, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(160, 'Loo Seat', 'toilet_red', 's', 1, 1, 1.2, '0', '1', '0', 181, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(161, 'Loo Seat', 'toilet_yell', 's', 1, 1, 1.2, '0', '1', '0', 182, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(162, 'Floor Tiles', 'tile_red', 's', 4, 4, 0, '1', '0', '1', 183, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(163, 'Floor Tiles', 'tile_yell', 's', 4, 4, 0, '1', '0', '1', 184, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(164, 'Gift', 'present_gen', 's', 1, 1, 1, '1', '0', '0', 187, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(165, 'Gift', 'present_gen1', 's', 1, 1, 1, '1', '0', '0', 188, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(166, 'Gift', 'present_gen2', 's', 1, 1, 1, '1', '0', '0', 189, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(167, 'Gift', 'present_gen3', 's', 1, 1, 1, '1', '0', '0', 190, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(168, 'Gift', 'present_gen4', 's', 1, 1, 1, '1', '0', '0', 191, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(169, 'Gift', 'present_gen5', 's', 1, 1, 1, '1', '0', '0', 192, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(170, 'Gift', 'present_gen6', 's', 1, 1, 1, '1', '0', '0', 193, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(171, 'A Pura Minibar', 'bar_basic', 's', 1, 1, 1, '0', '0', '0', 195, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,2,5,1', ''),
(172, 'Pura Shelves', 'shelves_basic', 's', 2, 1, 1, '0', '0', '0', 196, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(173, 'iced sofachair', 'soft_sofachair_norja', 's', 1, 1, 1, '0', '1', '0', 197, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(174, 'iced sofa', 'soft_sofa_norja', 's', 2, 1, 1, '0', '1', '0', 198, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(175, 'Pura Lamp', 'lamp_basic', 's', 1, 1, 1, '0', '0', '0', 199, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(176, 'Lodge Candle', 'lamp2_armas', 's', 1, 1, 1, '0', '0', '0', 200, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(177, 'Pura Refridgerator', 'fridge', 's', 1, 1, 1, '0', '0', '0', 201, '1', '1', '1', '1', '1', 'vendingmachine', 0, '3,5,6,2', ''),
(178, 'Telephone Box', 'door', 's', 1, 1, 0.001, '0', '0', '0', 202, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(179, 'Wardrobe', 'doorB', 's', 1, 1, 0.001, '0', '0', '0', 204, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(180, 'Portaloo', 'doorC', 's', 1, 1, 0.001, '0', '0', '0', 205, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(181, 'Pumpkin Lamp', 'pumpkin', 's', 1, 1, 1, '1', '0', '0', 206, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(182, 'Skull Candle Holder', 'skullcandle', 's', 1, 1, 1, '0', '0', '0', 207, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(183, 'Blood', 'deadduck', 's', 1, 1, 1, '0', '0', '0', 208, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(184, 'Dead Duck 2', 'deadduck2', 's', 1, 1, 1, '0', '0', '0', 209, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(185, 'Dead Duck 3', 'deadduck3', 's', 1, 1, 1, '0', '0', '0', 210, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(186, 'Menorah', 'menorah', 's', 1, 1, 1, '0', '0', '0', 211, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(187, 'Christmas Pudding', 'pudding', 's', 1, 1, 1, '1', '0', '0', 212, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(188, 'Joint of Ham', 'ham', 's', 1, 1, 1, '0', '0', '0', 213, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(189, 'Roast Turkey', 'turkey', 's', 1, 1, 1, '0', '0', '0', 214, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(190, 'Christmas Rubber Duck', 'xmasduck', 's', 1, 1, 1, '1', '0', '0', 215, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(191, 'Gingerbread House', 'house', 's', 1, 1, 1, '0', '0', '0', 216, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(192, 'Electric Candles', 'triplecandle', 's', 1, 1, 1, '0', '0', '0', 217, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(193, 'Christmas Tree 1', 'tree3', 's', 1, 1, 1, '0', '0', '0', 218, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(194, 'Christmas Tree 2', 'tree4', 's', 1, 1, 1, '0', '0', '0', 219, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(195, 'Christmas Tree 3', 'tree5', 's', 1, 1, 1, '0', '0', '0', 220, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(196, 'Eaten Ham', 'ham2', 's', 1, 1, 1, '0', '0', '0', 223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(197, 'White Candle Plate', 'wcandleset', 's', 1, 1, 1, '0', '0', '0', 224, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(198, 'Red Candle Plate', 'rcandleset', 's', 1, 1, 1, '0', '0', '0', 225, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(199, 'Giant Heart', 'statue', 's', 1, 1, 1, '0', '0', '0', 226, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(200, 'Valentine''s Duck', 'valeduck', 's', 1, 1, 1, '0', '0', '0', 228, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(201, 'Heart Sofa', 'heartsofa', 's', 2, 1, 1, '0', '1', '0', 229, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(202, 'Throne', 'throne', 's', 1, 1, 1, '0', '1', '0', 230, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(203, 'Russian Samovar', 'samovar', 's', 1, 1, 1, '0', '0', '0', 231, '0', '1', '1', '1', '1', 'vendingmachine', 0, '1', ''),
(204, 'Vase of Flowers', 'giftflowers', 's', 1, 1, 1, '0', '0', '0', 232, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(205, 'Cake', 'habbocake', 's', 1, 1, 1, '0', '0', '0', 233, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(206, 'Holopod', 'hologram', 's', 1, 1, 1, '0', '0', '0', 234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(207, 'Wannabe bunny', 'easterduck', 's', 1, 1, 1, '0', '0', '0', 235, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(208, 'Squidgy Bunny', 'bunny', 's', 1, 1, 1, '0', '0', '0', 236, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(209, 'Basket Of Eggs', 'basket', 's', 1, 1, 1, '0', '0', '0', 237, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(210, 'Pop-up Egg', 'birdie', 's', 1, 1, 1, '0', '0', '0', 238, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(211, 'Holo-dice', 'edice', 's', 1, 1, 1, '0', '0', '0', 239, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(212, 'Club sofa', 'club_sofa', 's', 2, 1, 1, '0', '1', '0', 267, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(213, 'Gold Trophy', 'a0 prize1', 's', 1, 1, 1, '0', '0', '0', 241, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(214, 'Silver Trophy', 'a0 prize2', 's', 1, 1, 1, '0', '0', '0', 242, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(215, 'Bronze Trophy', 'a0 prize3', 's', 1, 1, 1, '0', '0', '0', 243, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(216, 'Hatch (Lockable)', 'divider_poly3', 's', 1, 1, 0.001, '0', '0', '0', 244, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(217, 'Corner plinth', 'divider_arm1', 's', 1, 1, 1.4, '1', '0', '0', 245, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(218, 'Room divider', 'divider_arm2', 's', 2, 1, 1, '0', '0', '0', 246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(219, 'Knock', 'divider_arm3', 's', 1, 1, 0.001, '0', '0', '0', 247, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(220, 'Looks squishy', 'divider_nor1', 's', 1, 1, 1, '0', '0', '0', 248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(221, 'Corner Shelf', 'divider_silo1', 's', 1, 1, 1, '0', '0', '0', 249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(222, 'Strong', 'divider_nor2', 's', 2, 1, 1, '0', '0', '0', 250, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(223, 'Screen', 'divider_silo2', 's', 2, 1, 1, '0', '0', '0', 251, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(224, 'Door (Lockable)', 'divider_nor3', 's', 1, 1, 0.001, '0', '0', '0', 252, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(225, 'Gate (lockable)', 'divider_silo3', 's', 1, 1, 0.001, '0', '0', '0', 253, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(226, 'Typewriter', 'typingmachine', 's', 1, 1, 1, '0', '0', '0', 254, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(227, 'Dragon Egg', 'spyro', 's', 1, 1, 1, '0', '0', '0', 260, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(228, 'Holo-girl', 'redhologram', 's', 1, 1, 1, '0', '0', '0', 261, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(230, 'Poinsetta', 'joulutahti', 's', 1, 1, 1, '0', '0', '0', 264, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(231, 'Pink Hyacinth', 'hyacinth1', 's', 1, 1, 1, '0', '0', '0', 265, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(232, 'Blue Hyacinth', 'hyacinth2', 's', 1, 1, 1, '0', '0', '0', 266, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(233, 'Chair', 'chair_plasto*10', 's', 1, 1, 1, '0', '1', '0', 268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(234, 'Chair', 'chair_plasto*11', 's', 1, 1, 1, '0', '1', '0', 269, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(235, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*12', 's', 1, 1, 1, '1', '0', '0', 270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(236, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*13', 's', 1, 1, 1, '1', '0', '0', 271, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(237, 'Chair', 'chair_plasto*12', 's', 1, 1, 1, '0', '1', '0', 273, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(238, 'Chair', 'chair_plasto*13', 's', 1, 1, 1, '0', '1', '0', 274, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(239, 'HC chair', 'chair_plasto*14', 's', 1, 1, 1, '0', '1', '0', 275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(240, 'HC table', 'table_plasto_4leg*14', 's', 2, 2, 1, '1', '0', '0', 276, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(241, 'Mochamaster', 'mocchamaster', 's', 1, 1, 1, '1', '0', '0', 277, '1', '1', '1', '1', '1', 'vendingmachine', 0, '9,8,14,15,6,10,11,12,17,13', ''),
(242, 'Basketball Court', 'carpet_legocourt', 's', 3, 3, 0, '1', '0', '1', 278, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(243, 'Team Bench', 'bench_lego', 's', 4, 1, 1, '0', '1', '0', 279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(244, 'Basketball Trophy', 'legotrophy', 's', 1, 1, 1, '0', '0', '0', 280, '1', '1', '1', '1', '0', 'trophy', 2, '0', ''),
(245, 'Holiday Romance', 'valentinescreen', 's', 2, 1, 0.1, '0', '0', '1', 283, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(246, 'Dicemaster', 'edicehc', 's', 1, 1, 1, '0', '0', '0', 284, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(247, 'Petal Patch', 'rare_daffodil_rug', 's', 2, 2, 0, '1', '0', '1', 285, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(248, 'Blue Amber Lamp', 'rare_beehive_bulb', 's', 1, 1, 1, '0', '0', '0', 286, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(249, 'Throne Sofa', 'hcsohva', 's', 2, 1, 1, '0', '1', '0', 287, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(250, 'Tubmaster', 'hcamme', 's', 1, 2, 0.6, '0', '1', '0', 288, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(251, 'Golden Elephant', 'rare_elephant_statue', 's', 1, 1, 1, '0', '0', '0', 290, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(252, 'Bird Bath (red)', 'rare_fountain', 's', 1, 1, 1, '0', '0', '0', 291, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(253, 'Speaker''s Corner', 'rare_stand', 's', 1, 1, 1.7, '0', '1', '0', 292, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(254, 'Snow Globe', 'rare_globe', 's', 1, 1, 1, '0', '0', '0', 293, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(255, 'Hammock', 'rare_hammock', 's', 1, 3, 1.57, '0', '0', '0', 294, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(256, 'Silver Elephant', 'rare_elephant_statue*1', 's', 1, 1, 1, '0', '0', '0', 295, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(257, 'Bronze Elephant', 'rare_elephant_statue*2', 's', 1, 1, 1, '0', '0', '0', 296, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(258, 'Bird Bath (grey)', 'rare_fountain*1', 's', 1, 1, 1, '0', '0', '0', 297, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(259, 'Bird Bath (green)', 'rare_fountain*2', 's', 1, 1, 1, '0', '0', '0', 298, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(260, 'Bird Bath (blue)', 'rare_fountain*3', 's', 1, 1, 1, '0', '0', '0', 299, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(261, 'Red Amber Lamp', 'rare_beehive_bulb*1', 's', 1, 1, 1, '0', '0', '0', 300, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(262, 'Yellow Amber Lamp', 'rare_beehive_bulb*2', 's', 1, 1, 1, '0', '0', '0', 301, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(263, 'Lappland Greetings', 'rare_xmas_screen', 's', 2, 1, 0, '0', '0', '1', 302, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(264, 'Yellow Parasol', 'rare_parasol*1', 's', 1, 1, 1, '0', '0', '0', 303, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(265, 'Orange Parasol', 'rare_parasol*2', 's', 1, 1, 1, '0', '0', '0', 304, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(266, 'Violet Parasol', 'rare_parasol*3', 's', 1, 1, 1, '0', '0', '0', 305, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(267, 'Dead tree', 'tree1', 's', 1, 1, 1, '0', '0', '0', 1758, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20045, 'arabian_tile', 'arabian_tile', 's', 2, 2, 0, '1', '0', '1', 3312, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(269, 'White Candle', 'wcandle', 's', 1, 1, 1, '0', '0', '0', 2102, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(270, 'Red Candle', 'rcandle', 's', 1, 1, 1, '0', '0', '0', 2121, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(272, 'Gingerbread House', 'house2', 's', 1, 1, 1, '0', '0', '0', 428, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(273, 'Habbo Turntable', 'djesko_turntable', 's', 1, 1, 1, '0', '0', '0', 449, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(275, 'Habbo Cola Machine', 'md_limukaappi', 's', 1, 1, 1, '0', '0', '0', 457, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(276, 'Occasional Table', 'table_plasto_4leg*10', 's', 2, 2, 1, '1', '0', '0', 1484, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(277, 'Occasional Table', 'table_plasto_4leg*15', 's', 2, 2, 1, '1', '0', '0', 1486, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(278, 'Occasional Table', 'table_plasto_bigsquare*14', 's', 2, 2, 1, '1', '0', '0', 1487, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(279, 'Occasional Table', 'table_plasto_bigsquare*15', 's', 2, 2, 1, '1', '0', '0', 1488, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(280, 'Occasional Table', 'table_plasto_round*14', 's', 2, 2, 1, '1', '0', '0', 1489, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(281, 'Occasional Table', 'table_plasto_round*15', 's', 2, 2, 1, '1', '0', '0', 1490, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(282, 'Occasional Table', 'table_plasto_square*14', 's', 1, 1, 1, '1', '0', '0', 1491, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(283, 'Occasional Table', 'table_plasto_square*15', 's', 1, 1, 1, '1', '0', '0', 1492, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(284, 'Chair', 'chair_plasto*15', 's', 1, 1, 1, '0', '1', '0', 1495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(285, 'Plastic Pod Chair', 'chair_plasty*7', 's', 1, 1, 1, '0', '1', '0', 1496, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(286, 'Plastic Pod Chair', 'chair_plasty*8', 's', 1, 1, 1, '0', '1', '0', 1497, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(287, 'Plastic Pod Chair', 'chair_plasty*9', 's', 1, 1, 1, '0', '1', '0', 1498, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(288, 'Plastic Pod Chair', 'chair_plasty*10', 's', 1, 1, 1, '0', '1', '0', 1499, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(289, 'Plastic Pod Chair', 'chair_plasty*11', 's', 1, 1, 1, '0', '1', '0', 1500, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(290, 'Chair', 'chair_plasto*16', 's', 1, 1, 1, '0', '1', '0', 1501, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(291, 'Occasional Table', 'table_plasto_4leg*16', 's', 2, 2, 1, '1', '0', '0', 1502, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(292, 'Scoreboard', 'hockey_score', 's', 1, 1, 1, '0', '0', '0', 1503, '1', '1', '1', '1', '1', 'scoreboard', 100, '0', ''),
(293, 'Lert', 'hockey_light', 's', 1, 1, 1, '0', '0', '0', 1504, '1', '1', '1', '1', '1', 'alert', 2, '0', ''),
(294, 'Imperial Teleport', 'doorD', 's', 1, 1, 0.001, '0', '0', '0', 1505, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(295, 'Duck trophy', 'a0 prizetrophy2_b', 's', 1, 1, 1, '0', '0', '0', 1506, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(296, 'Globe trophy', 'a0 prizetrophy3_b', 's', 1, 1, 1, '0', '0', '0', 1507, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(297, 'Fish trophy', 'a0 prizetrophy4_b', 's', 1, 1, 1, '0', '0', '0', 1508, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(298, 'Champion trophy', 'a0 prizetrophy5_b', 's', 1, 1, 1, '0', '0', '0', 1509, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(299, 'Classic trophy', 'prizetrophy*1', 's', 1, 1, 1, '0', '0', '0', 1512, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(300, 'Duck trophy', 'a0 prizetrophy2_g', 's', 1, 1, 1, '0', '0', '0', 1512, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(301, 'Globe trophy', 'a0 prizetrophy3_g', 's', 1, 1, 1, '0', '0', '0', 1513, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(302, 'Fish trophy', 'a0 prizetrophy4_g', 's', 1, 1, 1, '0', '0', '0', 1514, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(303, 'Duo trophy', 'a0 prizetrophy5_g', 's', 1, 1, 1, '0', '0', '0', 1515, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(304, 'Champion trophy', 'a0 prizetrophy6_g', 's', 1, 1, 1, '0', '0', '0', 1516, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(305, 'Classic trophy', 'prizetrophy*2', 's', 1, 1, 1, '0', '0', '0', 1519, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(306, 'Duck trophy', 'a0 prizetrophy2_s', 's', 1, 1, 1, '0', '0', '0', 1518, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(307, 'Globe trophy', 'a0 prizetrophy3_s', 's', 1, 1, 1, '0', '0', '0', 1519, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(308, 'Fish trophy', 'a0 prizetrophy4_s', 's', 1, 1, 1, '0', '0', '0', 1520, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(309, 'Duo trophy', 'a0 prizetrophy5_s', 's', 1, 1, 1, '0', '0', '0', 1521, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(310, 'Champion trophy', 'a0 prizetrophy6_s', 's', 1, 1, 1, '0', '0', '0', 1522, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(311, 'Classic trophy', 'prizetrophy*3', 's', 1, 1, 1, '0', '0', '0', 1526, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(312, 'Green Parasol', 'rare_parasol*0', 's', 1, 1, 1, '0', '0', '0', 289, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(313, 'Oil Lamp', 'hc_lmp', 's', 1, 1, 1, '0', '0', '0', 1529, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(314, 'Nordic Table', 'hc_tbl', 's', 1, 3, 1, '1', '0', '0', 1528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(315, 'Majestic Chair', 'hc_chr', 's', 1, 1, 1, '0', '1', '0', 1527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(316, 'Study Desk', 'hc_dsk', 's', 1, 2, 1, '0', '0', '0', 1530, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(317, 'Night', 'nest', 's', 1, 1, 1, '1', '0', '0', 1531, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(318, 'Bones Mega Multipack', 'petfood1', 's', 1, 1, 1, '1', '0', '0', 1532, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(319, 'Sardines Mega Multipack', 'petfood2', 's', 1, 1, 1, '1', '0', '0', 1533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(320, 'Cabbage Mega Multipack', 'petfood3', 's', 1, 1, 1, '1', '0', '0', 1534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(321, 'Blue Water Bowl', 'waterbowl*4', 's', 1, 1, 1, '1', '0', '0', 1535, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(322, 'Brown Water Bowl', 'waterbowl*5', 's', 1, 1, 1, '1', '0', '0', 1536, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(323, 'Green Water Bowl', 'waterbowl*2', 's', 1, 1, 1, '1', '0', '0', 1537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(324, 'Red Water Bowl', 'waterbowl*1', 's', 1, 1, 1, '1', '0', '0', 1538, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(325, 'Yellow Water Bowl', 'waterbowl*3', 's', 1, 1, 1, '1', '0', '0', 1539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(326, 'Rubber Ball', 'toy1', 's', 1, 1, 1, '1', '0', '0', 1540, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(327, 'Rubber Ball', 'toy1*1', 's', 1, 1, 1, '1', '0', '0', 1541, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(328, 'Rubber Ball', 'toy1*2', 's', 1, 1, 1, '1', '0', '0', 1542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(329, 'Rubber Ball', 'toy1*3', 's', 1, 1, 1, '1', '0', '0', 1543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(330, 'Rubber Ball', 'toy1*4', 's', 1, 1, 1, '1', '0', '0', 1544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(331, 'Marzipan Man', 'goodie1', 's', 1, 1, 1, '1', '0', '0', 1545, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(332, 'Marzipan Man', 'goodie1*1', 's', 1, 1, 1, '1', '0', '0', 1546, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(333, 'Marzipan Man', 'goodie1*2', 's', 1, 1, 1, '1', '0', '0', 1547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(334, 'Chocolate Mouse', 'goodie2', 's', 1, 1, 1, '1', '0', '0', 1548, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(335, 'Bronze Habbo trophy', 'a0 prizetrophy7_b', 's', 1, 1, 1, '0', '0', '0', 1547, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(336, 'Gold Habbo trophy', 'a0 prizetrophy7_g', 's', 1, 1, 1, '0', '0', '0', 1548, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(337, 'Silver Habbo trophy', 'a0 prizetrophy7_s', 's', 1, 1, 1, '0', '0', '0', 1549, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(338, 'Red Laser Door', 'scifiport*0', 's', 1, 1, 0.001, '0', '0', '0', 1549, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(339, 'Violet Sci-Fi Port', 'scifiport*9', 's', 1, 1, 0.001, '0', '0', '0', 1550, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(340, 'Purple Sci-Fi Port', 'scifiport*8', 's', 1, 1, 0.001, '0', '0', '0', 1551, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(341, 'Aqua Laser Gate', 'scifiport*7', 's', 1, 1, 0.001, '0', '0', '0', 1552, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(342, 'White Sci-Fi Port', 'scifiport*6', 's', 1, 1, 0.001, '0', '0', '0', 1553, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(343, 'Security Fence', 'scifiport*5', 's', 1, 1, 0.001, '0', '0', '0', 1554, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(344, 'Pink Sci-Fi Port', 'scifiport*4', 's', 1, 1, 0.001, '0', '0', '0', 1555, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(345, 'Jade Sci-Fi Port', 'scifiport*3', 's', 1, 1, 0.001, '0', '0', '0', 1556, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(346, 'Blue Laser Gate', 'scifiport*2', 's', 1, 1, 0.001, '0', '0', '0', 1557, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(347, 'Gold Laser Gate', 'scifiport*1', 's', 1, 1, 0.001, '0', '0', '0', 1558, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(348, 'Neptune Smoke Machine', 'scifirocket*9', 's', 1, 1, 1, '0', '0', '0', 1559, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(349, 'From a space far', 'scifirocket*8', 's', 1, 1, 1, '0', '0', '0', 1560, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(350, 'Jupiter Smoke Machine', 'scifirocket*7', 's', 1, 1, 1, '0', '0', '0', 1561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(351, 'Mercury Smoke Machine', 'scifirocket*6', 's', 1, 1, 1, '0', '0', '0', 1562, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(352, 'Uranus Smoke Machine', 'scifirocket*5', 's', 1, 1, 1, '0', '0', '0', 1563, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(353, 'Venus Smoke Machine', 'scifirocket*4', 's', 1, 1, 1, '0', '0', '0', 1564, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(354, 'Endor Smoke Machine', 'scifirocket*3', 's', 1, 1, 1, '0', '0', '0', 1565, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(355, 'Earth Smoke Machine', 'scifirocket*2', 's', 1, 1, 1, '0', '0', '0', 1566, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(356, 'Saturn Smoke Machine', 'scifirocket*1', 's', 1, 1, 1, '0', '0', '0', 1567, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(357, 'Mars Smoke Machine', 'scifirocket*0', 's', 1, 1, 1, '0', '0', '0', 1568, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(358, 'Violet Starship Door', 'scifidoor*10', 's', 1, 1, 0.001, '0', '0', '0', 1569, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(359, 'It''s blue', 'scifidoor*9', 's', 1, 1, 0.001, '0', '0', '0', 1570, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(360, 'Purple Spaceship Door', 'scifidoor*8', 's', 1, 1, 0.001, '0', '0', '0', 1571, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(361, 'Aqua Spaceship Door', 'scifidoor*7', 's', 1, 1, 0.001, '0', '0', '0', 1572, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(362, 'Black Monolith', 'scifidoor*6', 's', 1, 1, 0.001, '0', '0', '0', 1573, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(363, 'White Spaceship Door', 'scifidoor*5', 's', 1, 1, 0.001, '0', '0', '0', 1574, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(364, 'Emerald Spaceship Door', 'scifidoor*4', 's', 1, 1, 0.001, '0', '0', '0', 1575, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(365, 'Lightblue Spaceship Door', 'scifidoor*3', 's', 1, 1, 0.001, '0', '0', '0', 1576, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(366, 'Yellow Spaceship Door', 'scifidoor*2', 's', 1, 1, 0.001, '0', '0', '0', 1577, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(367, 'Pink Spaceship Door', 'scifidoor*1', 's', 1, 1, 0.001, '0', '0', '0', 1578, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(368, 'Puffy', 'pillow*5', 's', 1, 1, 1, '0', '1', '0', 1579, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(369, 'Puffy', 'pillow*8', 's', 1, 1, 1, '0', '1', '0', 1580, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(370, 'White Lace Pillow', 'pillow*0', 's', 1, 1, 1, '0', '1', '0', 1581, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(371, 'Puffy', 'pillow*1', 's', 1, 1, 1, '0', '1', '0', 1582, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(372, 'Puffy', 'pillow*2', 's', 1, 1, 1, '0', '1', '0', 1583, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(373, 'Purple Velvet Pillow', 'pillow*7', 's', 1, 1, 1, '0', '1', '0', 1584, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(374, 'Puffy', 'pillow*9', 's', 1, 1, 1, '0', '1', '0', 1585, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(375, 'Puffy', 'pillow*4', 's', 1, 1, 1, '0', '1', '0', 1586, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(376, 'Puffy', 'pillow*6', 's', 1, 1, 1, '0', '1', '0', 1587, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(377, 'Puffy', 'pillow*3', 's', 1, 1, 1, '0', '1', '0', 1588, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(378, 'Pink marquee', 'marquee*1', 's', 1, 1, 0.001, '0', '0', '0', 1589, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(379, 'Red Dragon Marquee', 'marquee*2', 's', 1, 1, 0.001, '0', '0', '0', 1590, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(380, 'Purple Marquee', 'marquee*7', 's', 1, 1, 0.001, '0', '0', '0', 1591, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(381, 'White Marquee', 'marquee*10', 's', 1, 1, 0.001, '0', '0', '0', 1592, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(382, 'Ultramarine Marquee', 'marquee*8', 's', 1, 1, 0.001, '0', '0', '0', 1593, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(383, 'Green Marquee', 'marquee*9', 's', 1, 1, 0.001, '0', '0', '0', 1594, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(384, 'Graphite Marquee', 'marquee*5', 's', 1, 1, 0.001, '0', '0', '0', 1595, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(385, 'Yellow Marquee', 'marquee*4', 's', 1, 1, 0.001, '0', '0', '0', 1596, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(386, 'Blue Marquee', 'marquee*6', 's', 1, 1, 0.001, '0', '0', '0', 1597, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(387, 'Aqua Marquee', 'marquee*3', 's', 1, 1, 0.001, '0', '0', '0', 1598, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(388, 'Pink Oriental screen', 'wooden_screen*1', 's', 1, 2, 1, '0', '0', '0', 1599, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(389, 'RosewoodScreen', 'wooden_screen*2', 's', 1, 2, 1, '0', '0', '0', 1600, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(390, 'Purple Oriental Screen', 'wooden_screen*7', 's', 1, 2, 1, '0', '0', '0', 1601, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(391, 'White Oriental Screen', 'wooden_screen*0', 's', 1, 2, 1, '0', '0', '0', 1602, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(392, 'Night Blue Oriental Screen', 'wooden_screen*8', 's', 1, 2, 1, '0', '0', '0', 1603, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(393, 'Gray Oriental Screen', 'wooden_screen*5', 's', 1, 2, 1, '0', '0', '0', 1604, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(394, 'Green Oriental Screen', 'wooden_screen*9', 's', 1, 2, 1, '0', '0', '0', 1605, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(395, 'Golden Oriental Screen', 'wooden_screen*4', 's', 1, 2, 1, '0', '0', '0', 1606, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(396, 'Blue Oriental Screen', 'wooden_screen*6', 's', 1, 2, 1, '0', '0', '0', 1607, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(397, 'Terracotta Pillar', 'wooden_screen*3', 's', 1, 2, 1, '0', '0', '0', 1608, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(398, 'Pink Marble Pillar', 'pillar*1', 's', 1, 1, 1, '0', '0', '0', 1610, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(399, 'Rock Pillar', 'pillar*9', 's', 1, 1, 1, '0', '0', '0', 1611, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(400, 'Classy architect', 'pillar*0', 's', 1, 1, 1, '0', '0', '0', 1612, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(401, 'Roman Pillar', 'pillar*8', 's', 1, 1, 1, '0', '0', '0', 1613, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(402, 'Nordic Pillar', 'pillar*2', 's', 1, 1, 1, '0', '0', '0', 1614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(403, 'Pagan Pillar', 'pillar*5', 's', 1, 1, 1, '0', '0', '0', 1615, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(404, 'Dark Ages Pillar', 'pillar*4', 's', 1, 1, 1, '0', '0', '0', 1616, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(405, 'Atlantean Pillar', 'pillar*7', 's', 1, 1, 1, '0', '0', '0', 1617, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(406, 'blue pillar', 'pillar*3', 's', 1, 1, 1, '0', '0', '0', 1618, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(407, 'Serpent of Doom', 'rare_dragonlamp*4', 's', 1, 1, 1, '0', '0', '0', 1619, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(408, 'Fire Dragon Lamp', 'rare_dragonlamp*0', 's', 1, 1, 1, '0', '0', '0', 1620, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(409, 'Elf Green Dragon Lamp', 'rare_dragonlamp*5', 's', 1, 1, 1, '0', '0', '0', 1621, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(410, 'Jade Dragon Lamp', 'rare_dragonlamp*2', 's', 1, 1, 1, '0', '0', '0', 1622, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(411, 'Bronze Dragon Lamp', 'rare_dragonlamp*8', 's', 1, 1, 1, '0', '0', '0', 1623, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(412, 'Purple Dragon Lamp', 'rare_dragonlamp*9', 's', 1, 1, 1, '0', '0', '0', 1624, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(413, 'Sky Dragon Lamp', 'rare_dragonlamp*7', 's', 1, 1, 1, '0', '0', '0', 1625, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(414, 'Gold Dragon Lamp', 'rare_dragonlamp*6', 's', 1, 1, 1, '0', '0', '0', 1626, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(415, 'Sea Dragon Lamp', 'rare_dragonlamp*1', 's', 1, 1, 1, '0', '0', '0', 1627, '1', '1', '1', '1', '1', 'default', 2, '0', '');
INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(416, 'Silver Dragon Lamp', 'rare_dragonlamp*3', 's', 1, 1, 1, '0', '0', '0', 1628, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(417, 'Blueberry Ice Cream Machine', 'rare_icecream*1', 's', 1, 1, 1, '0', '0', '0', 1629, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(418, 'Chocolate Ice Cream Machine', 'rare_icecream*7', 's', 1, 1, 1, '0', '0', '0', 1630, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(419, 'Peppermint Ice Cream Machine', 'rare_icecream*8', 's', 1, 1, 1, '0', '0', '0', 1631, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(420, 'Pistachio Ice Cream Machine', 'rare_icecream*2', 's', 1, 1, 1, '0', '0', '0', 1632, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(421, 'Toffee Ice Cream Machine', 'rare_icecream*6', 's', 1, 1, 1, '0', '0', '0', 1633, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(422, 'Bubblegum Ice Cream Machine', 'rare_icecream*9', 's', 1, 1, 1, '0', '0', '0', 1634, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(423, 'Blackcurrant Ice Cream Machine', 'rare_icecream*3', 's', 1, 1, 1, '0', '0', '0', 1635, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(424, 'Cherry Ice Cream Machine', 'rare_icecream*0', 's', 1, 1, 1, '0', '0', '0', 1636, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(425, 'Strawberry Ice Cream Machine', 'rare_icecream*4', 's', 1, 1, 1, '0', '0', '0', 1637, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(426, 'Vanilla Ice Cream Machine', 'rare_icecream*5', 's', 1, 1, 1, '0', '0', '0', 1638, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(427, 'Brown Powered Fan', 'rare_fan*7', 's', 1, 1, 1, '0', '0', '0', 1639, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(428, 'Ochre Powered Fan', 'rare_fan*6', 's', 1, 1, 1, '0', '0', '0', 1640, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(429, 'Fucsia Powered Fan', 'rare_fan*9', 's', 1, 1, 1, '0', '0', '0', 1641, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(430, 'Purple Dragon Skin Fan', 'rare_fan*3', 's', 1, 1, 1, '0', '0', '0', 1642, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(431, 'Festive Fan', 'rare_fan*0', 's', 1, 1, 1, '0', '0', '0', 1643, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(432, 'SUPERLOVE Fan', 'rare_fan*4', 's', 1, 1, 1, '0', '0', '0', 1644, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(433, 'Yellow Powered Fan', 'rare_fan*5', 's', 1, 1, 1, '0', '0', '0', 1645, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(434, 'Birthday Fan', 'rare_fan*1', 's', 1, 1, 1, '0', '0', '0', 1646, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(435, 'Stylish', 'rare_fan*8', 's', 1, 1, 1, '0', '0', '0', 1647, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(436, 'Green Powered Fan', 'rare_fan*2', 's', 1, 1, 1, '0', '0', '0', 1648, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(437, 'Ice Habbo Roller', 'queue_tile1*3', 's', 1, 1, 0.5, '1', '0', '1', 1649, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(438, 'Blue Habbo Roller', 'queue_tile1*6', 's', 1, 1, 0.5, '1', '0', '1', 1650, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(439, 'Gold Habbo Roller', 'queue_tile1*4', 's', 1, 1, 0.5, '1', '0', '1', 1651, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(440, 'Green Habbo Roller', 'queue_tile1*9', 's', 1, 1, 0.5, '1', '0', '1', 1652, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(441, 'Navy Habbo Roller', 'queue_tile1*8', 's', 1, 1, 0.5, '1', '0', '1', 1653, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(442, 'Knight Roller', 'queue_tile1*5', 's', 1, 1, 0.5, '1', '0', '1', 1654, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(443, 'Purple Habbo Roller', 'queue_tile1*7', 's', 1, 1, 0.5, '1', '0', '1', 1655, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(444, 'Red Habbo Roller', 'queue_tile1*2', 's', 1, 1, 0.5, '1', '0', '1', 1656, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(445, 'Pink Habbo Roller', 'queue_tile1*1', 's', 1, 1, 0.5, '1', '0', '1', 1657, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(446, 'White Quest Roller', 'queue_tile1*0', 's', 1, 1, 0.5, '1', '0', '1', 1658, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(20071, 'ads_gsArcade_2 name', 'ads_gsArcade_2', 's', 1, 1, 1, '1', '0', '0', 3278, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(448, 'Snow Rug', 'rare_snowrug', 's', 2, 2, 0, '1', '0', '1', 1738, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(449, 'Lantern', 'cn_lamp', 's', 1, 1, 1, '0', '0', '0', 1741, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(450, 'Chinese Sofa', 'cn_sofa', 's', 3, 1, 1, '0', '1', '0', 1742, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(451, 'Sport track straight', 'sporttrack1*1', 's', 2, 2, 0, '1', '0', '1', 1745, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(452, 'Sport track straight grass', 'sporttrack1*3', 's', 2, 2, 0, '1', '0', '1', 1747, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(453, 'Sport track straight asphalt', 'sporttrack1*2', 's', 2, 2, 0, '1', '0', '1', 1748, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(454, 'Sport corner tartan', 'sporttrack2*1', 's', 2, 2, 0, '1', '0', '1', 1750, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(455, 'Sport corner asphalt', 'sporttrack2*2', 's', 2, 2, 0, '1', '0', '1', 1751, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(456, 'Sport corner grass', 'sporttrack2*3', 's', 2, 2, 0, '1', '0', '1', 1752, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(457, 'Sport goal tartan', 'sporttrack3*1', 's', 2, 2, 0, '1', '0', '1', 1754, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(458, 'Sport goal asphalt', 'sporttrack3*2', 's', 2, 2, 0, '1', '0', '1', 1755, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(459, 'Sport goal grass', 'sporttrack3*3', 's', 2, 2, 0, '1', '0', '1', 1756, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(460, 'Football Lamp', 'footylamp', 's', 1, 1, 1, '0', '0', '0', 1757, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(461, 'Bar Stool', 'barchair_silo', 's', 1, 1, 1.2, '0', '1', '0', 1759, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(462, 'Habbos', 'divider_nor4*4', 's', 2, 1, 1, '0', '0', '0', 1760, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(463, 'Classic Traffic Light', 'traffic_light*1', 's', 1, 1, 1, '0', '0', '0', 1761, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(464, 'Blue Traffic Light', 'traffic_light*2', 's', 1, 1, 1, '0', '0', '0', 1762, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(465, 'Purple Traffic Light', 'traffic_light*3', 's', 1, 1, 1, '0', '0', '0', 1763, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(466, 'Yellow Traffic Light', 'traffic_light*4', 's', 1, 1, 1, '0', '0', '0', 1764, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(467, 'Red Traffic Light', 'traffic_light*6', 's', 1, 1, 1, '0', '0', '0', 1765, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(468, 'Blue Inflatable Chair', 'rubberchair*1', 's', 1, 1, 1, '0', '1', '0', 1766, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(469, 'Pink Inflatable Chair', 'rubberchair*2', 's', 1, 1, 1, '0', '1', '0', 1767, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(470, 'Orange Inflatable Chair', 'rubberchair*3', 's', 1, 1, 1, '0', '1', '0', 1768, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(471, 'Ocean Inflatable Chair', 'rubberchair*4', 's', 1, 1, 1, '0', '1', '0', 1769, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(472, 'Lime Inflatable Chair', 'rubberchair*5', 's', 1, 1, 1, '0', '1', '0', 1770, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(473, 'Violet Inflatable Chair', 'rubberchair*6', 's', 1, 1, 1, '0', '1', '0', 1771, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(474, 'Yellow Maze Barrier', 'barrier*1', 's', 1, 2, 1, '0', '0', '0', 1772, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(475, 'No trespassing', 'barrier*2', 's', 1, 2, 1, '0', '0', '0', 1773, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(476, 'No trespassing', 'barrier*3', 's', 1, 2, 1, '0', '0', '0', 1774, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(477, 'White Inflatable Chair', 'rubberchair*7', 's', 1, 1, 1, '0', '1', '0', 1775, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(478, 'Black Inflatable Chair', 'rubberchair*8', 's', 1, 1, 1, '0', '1', '0', 1776, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(479, 'Black Iced Table', 'table_norja_med*2', 's', 2, 2, 1, '1', '0', '0', 1777, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(480, 'White Iced Table', 'table_norja_med*3', 's', 2, 2, 1, '1', '0', '0', 1778, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(481, 'Urban Iced Coffee Table', 'table_norja_med*4', 's', 2, 2, 1, '1', '0', '0', 1779, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(482, 'Large Coffee Table Pink', 'table_norja_med*5', 's', 2, 2, 1, '1', '0', '0', 1780, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(483, 'Large Coffee Table Blue', 'table_norja_med*6', 's', 2, 2, 1, '1', '0', '0', 1781, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(484, 'Rural Iced Coffee Table', 'table_norja_med*7', 's', 2, 2, 1, '1', '0', '0', 1782, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(485, 'Large Coffee Table Yellow', 'table_norja_med*8', 's', 2, 2, 1, '1', '0', '0', 1783, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(486, 'Large Coffee Table Red', 'table_norja_med*9', 's', 2, 2, 1, '1', '0', '0', 1784, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(487, 'Black Iced Bench', 'couch_norja*2', 's', 2, 1, 1, '0', '1', '0', 1785, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(488, 'White Iced Bench', 'couch_norja*3', 's', 2, 1, 1, '0', '1', '0', 1786, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(489, 'Urban Iced Bench', 'couch_norja*4', 's', 2, 1, 1, '0', '1', '0', 1787, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(490, 'Pink Bench', 'couch_norja*5', 's', 2, 1, 1, '0', '1', '0', 1788, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(491, 'Blue Bench', 'couch_norja*6', 's', 2, 1, 1, '0', '1', '0', 1789, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(492, 'Rural Iced Bench', 'couch_norja*7', 's', 2, 1, 1, '0', '1', '0', 1790, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(493, 'Yellow Bench', 'couch_norja*8', 's', 2, 1, 1, '0', '1', '0', 1791, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(494, 'Red Bench', 'couch_norja*9', 's', 2, 1, 1, '0', '1', '0', 1792, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(495, 'Black Iced Bookcase', 'shelves_norja*2', 's', 1, 1, 1, '0', '0', '0', 1793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(496, 'Urban Iced Bookcase', 'shelves_norja*3', 's', 1, 1, 1, '0', '0', '0', 1794, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(497, 'Pink Bookcase', 'shelves_norja*5', 's', 1, 1, 1, '0', '0', '0', 1796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(498, 'Blue Bookcase', 'shelves_norja*6', 's', 1, 1, 1, '0', '0', '0', 1797, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(499, 'Rural Iced Bookcase', 'shelves_norja*7', 's', 1, 1, 1, '0', '0', '0', 1798, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(500, 'Yellow Bookcase', 'shelves_norja*8', 's', 1, 1, 1, '0', '0', '0', 1799, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(501, 'Red Bookcase', 'shelves_norja*9', 's', 1, 1, 1, '0', '0', '0', 1800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(502, 'Black Iced Chair', 'chair_norja*2', 's', 1, 1, 1, '0', '1', '0', 1801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(503, 'White Iced Chair', 'chair_norja*3', 's', 1, 1, 1, '0', '1', '0', 1802, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(504, 'Urban Iced Chair', 'chair_norja*4', 's', 1, 1, 1, '0', '1', '0', 1803, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(505, 'Pink Chair', 'chair_norja*5', 's', 1, 1, 1, '0', '1', '0', 1804, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(506, 'Blue Chair', 'chair_norja*6', 's', 1, 1, 1, '0', '1', '0', 1805, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(507, 'Rural Chair', 'chair_norja*7', 's', 1, 1, 1, '0', '1', '0', 1806, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(508, 'Yellow Chair', 'chair_norja*8', 's', 1, 1, 1, '0', '1', '0', 1807, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(509, 'Red Chair', 'chair_norja*9', 's', 1, 1, 1, '0', '1', '0', 1808, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(510, 'Black Iced Corner', 'divider_nor1*2', 's', 1, 1, 1, '0', '0', '0', 1809, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(511, 'Looks squishy', 'divider_nor1*3', 's', 1, 1, 1, '0', '0', '0', 1810, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(512, 'Urban Iced Corner', 'divider_nor1*4', 's', 1, 1, 1, '0', '0', '0', 1811, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(513, 'Pink Ice corner', 'divider_nor1*5', 's', 1, 1, 1, '0', '0', '0', 1812, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(514, 'Blue Ice corner', 'divider_nor1*6', 's', 1, 1, 1, '0', '0', '0', 1813, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(515, 'Rural Iced Corner', 'divider_nor1*7', 's', 1, 1, 1, '0', '0', '0', 1814, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(516, 'Yellow Ice corner', 'divider_nor1*8', 's', 1, 1, 1, '0', '0', '0', 1815, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(517, 'Red Ice corner', 'divider_nor1*9', 's', 1, 1, 1, '0', '0', '0', 1816, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(518, 'Black Iced Sofa', 'soft_sofa_norja*2', 's', 2, 1, 1, '0', '1', '0', 1817, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(519, 'Pristine white', 'soft_sofa_norja*3', 's', 2, 1, 1, '0', '1', '0', 1818, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(520, 'Urban Iced Sofa', 'soft_sofa_norja*4', 's', 2, 1, 1, '0', '1', '0', 1819, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(521, 'Pink Iced Sofa', 'soft_sofa_norja*5', 's', 2, 1, 1, '0', '1', '0', 1820, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(522, 'Blue Iced Sofa', 'soft_sofa_norja*6', 's', 2, 1, 1, '0', '1', '0', 1821, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(523, 'Rural Iced Sofa', 'soft_sofa_norja*7', 's', 2, 1, 1, '0', '1', '0', 1822, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(524, 'Yellow Iced Sofa', 'soft_sofa_norja*8', 's', 2, 1, 1, '0', '1', '0', 1823, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(525, 'Red Iced Sofa', 'soft_sofa_norja*9', 's', 2, 1, 1, '0', '1', '0', 1824, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(526, 'Black Iced Sofachair', 'soft_sofachair_norja*2', 's', 1, 1, 1, '0', '1', '0', 1825, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(527, 'White Iced Sofachair', 'soft_sofachair_norja*3', 's', 1, 1, 1, '0', '1', '0', 1826, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(528, 'Urban Iced Sofachair', 'soft_sofachair_norja*4', 's', 1, 1, 1, '0', '1', '0', 1827, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(529, 'Pink Iced Sofachair', 'soft_sofachair_norja*5', 's', 1, 1, 1, '0', '1', '0', 1828, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(530, 'Blue Iced Sofachair', 'soft_sofachair_norja*6', 's', 1, 1, 1, '0', '1', '0', 1829, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(531, 'Rural Iced Sofachair', 'soft_sofachair_norja*7', 's', 1, 1, 1, '0', '1', '0', 1830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(532, 'Yellow Iced Sofachair', 'soft_sofachair_norja*8', 's', 1, 1, 1, '0', '1', '0', 1831, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(533, 'Red Iced Sofachair', 'soft_sofachair_norja*9', 's', 1, 1, 1, '0', '1', '0', 1832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(534, 'Large', 'sofachair_silo*2', 's', 1, 1, 1.1, '0', '1', '0', 1833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(535, 'Large', 'sofachair_silo*3', 's', 1, 1, 1.1, '0', '1', '0', 1834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(536, 'Beige Area Armchair', 'sofachair_silo*4', 's', 1, 1, 1.1, '0', '1', '0', 1835, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(537, 'Pink Area Armchair', 'sofachair_silo*5', 's', 1, 1, 1.1, '0', '1', '0', 1836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(538, 'Blue Area Armchair', 'sofachair_silo*6', 's', 1, 1, 1.1, '0', '1', '0', 1837, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(539, 'Green Area Armchair', 'sofachair_silo*7', 's', 1, 1, 1.1, '0', '1', '0', 1838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(540, 'Large', 'sofachair_silo*8', 's', 1, 1, 1.1, '0', '1', '0', 1839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(541, 'Red Area Armchair', 'sofachair_silo*9', 's', 1, 1, 1.1, '0', '1', '0', 1840, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(542, 'Black Occasional Table', 'table_silo_small*2', 's', 1, 1, 1, '1', '0', '0', 1841, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(543, 'White Occasional Table', 'table_silo_small*3', 's', 1, 1, 1, '1', '0', '0', 1842, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(544, 'Beige Area Occasional Table', 'table_silo_small*4', 's', 1, 1, 1, '1', '0', '0', 1843, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(545, 'Pink Area Occasional Table', 'table_silo_small*5', 's', 1, 1, 1, '1', '0', '0', 1844, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(546, 'Blue Area Occasional Table', 'table_silo_small*6', 's', 1, 1, 1, '1', '0', '0', 1845, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(547, 'Green Area Occasional Table', 'table_silo_small*7', 's', 1, 1, 1, '1', '0', '0', 1846, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(548, 'Yellow Occasional Table', 'table_silo_small*8', 's', 1, 1, 1, '1', '0', '0', 1847, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(549, 'Red Area Occasional Table', 'table_silo_small*9', 's', 1, 1, 1, '1', '0', '0', 1848, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(550, 'Black Corner Shelf', 'divider_silo1*2', 's', 1, 1, 1, '0', '0', '0', 1849, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(551, 'White Corner Shelf', 'divider_silo1*3', 's', 1, 1, 1, '0', '0', '0', 1850, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(552, 'Beige Area Corner Shelf', 'divider_silo1*4', 's', 1, 1, 1, '0', '0', '0', 1851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(553, 'Pink Area Corner Shelf', 'divider_silo1*5', 's', 1, 1, 1, '0', '0', '0', 1852, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(554, 'Blue Area Corner Shelf', 'divider_silo1*6', 's', 1, 1, 1, '0', '0', '0', 1853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(555, 'Green Area Corner Shelf', 'divider_silo1*7', 's', 1, 1, 1, '0', '0', '0', 1854, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(556, 'Yellow Corner Shelf', 'divider_silo1*8', 's', 1, 1, 1, '0', '0', '0', 1855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(557, 'Red Area Corner Shelf', 'divider_silo1*9', 's', 1, 1, 1, '0', '0', '0', 1856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(558, 'Black Area Gate', 'divider_silo3*2', 's', 1, 1, 0.001, '0', '0', '0', 1857, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(559, 'White Area Gate', 'divider_silo3*3', 's', 1, 1, 0.001, '0', '0', '0', 1858, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(560, 'Beige Area Gate', 'divider_silo3*4', 's', 1, 1, 0.001, '0', '0', '0', 1859, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(561, 'Pink Area Gate', 'divider_silo3*5', 's', 1, 1, 0.001, '0', '0', '0', 1860, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(562, 'Blue Area Gate', 'divider_silo3*6', 's', 1, 1, 0.001, '0', '0', '0', 1861, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(563, 'Green Area Gate', 'divider_silo3*7', 's', 1, 1, 0.001, '0', '0', '0', 1862, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(564, 'Yellow Area Gate', 'divider_silo3*8', 's', 1, 1, 0.001, '0', '0', '0', 1863, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(565, 'Red Area Gate', 'divider_silo3*9', 's', 1, 1, 0.001, '0', '0', '0', 1864, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(566, 'Black Coffee Table', 'table_silo_med*2', 's', 2, 2, 1, '1', '0', '0', 1865, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(567, 'White Coffee Table', 'table_silo_med*3', 's', 2, 2, 1, '1', '0', '0', 1866, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(568, 'Beige Area Coffee Table', 'table_silo_med*4', 's', 2, 2, 1, '1', '0', '0', 1867, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(569, 'Pink Area Coffee Table', 'table_silo_med*5', 's', 2, 2, 1, '1', '0', '0', 1868, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(570, 'Blue Area Coffee Table', 'table_silo_med*6', 's', 2, 2, 1, '1', '0', '0', 1869, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(571, 'Green Area Coffee Table', 'table_silo_med*7', 's', 2, 2, 1, '1', '0', '0', 1870, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(572, 'Yellow Coffee Table', 'table_silo_med*8', 's', 2, 2, 1, '1', '0', '0', 1871, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(573, 'Red Area Coffee Table', 'table_silo_med*9', 's', 2, 2, 1, '1', '0', '0', 1872, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(574, 'Cushioned', 'sofa_silo*2', 's', 2, 1, 1.1, '0', '1', '0', 1873, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(575, 'Cushioned', 'sofa_silo*3', 's', 2, 1, 1.1, '0', '1', '0', 1874, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(576, 'Beige Area Sofa', 'sofa_silo*4', 's', 2, 1, 1.1, '0', '1', '0', 1875, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(577, 'Pink Area Sofa', 'sofa_silo*5', 's', 2, 1, 1.1, '0', '1', '0', 1876, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(578, 'Blue Area Sofa', 'sofa_silo*6', 's', 2, 1, 1.1, '0', '1', '0', 1877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(579, 'Green Area Sofa', 'sofa_silo*7', 's', 2, 1, 1.1, '0', '1', '0', 1878, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(580, 'Cushioned', 'sofa_silo*8', 's', 2, 1, 1.1, '0', '1', '0', 1879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(581, 'Red Area Sofa', 'sofa_silo*9', 's', 2, 1, 1.1, '0', '1', '0', 1880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(582, 'Black Mode Armchair', 'sofachair_polyfon*2', 's', 1, 1, 1.1, '0', '1', '0', 1881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(583, 'White Armchair', 'sofachair_polyfon*3', 's', 1, 1, 1.1, '0', '1', '0', 1882, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(584, 'Beige Mode Armchair', 'sofachair_polyfon*4', 's', 1, 1, 1.1, '0', '1', '0', 1883, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(585, 'Blue Mode Armchair', 'sofachair_polyfon*6', 's', 1, 1, 1.1, '0', '1', '0', 1884, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(586, 'Green Armchair', 'sofachair_polyfon*7', 's', 1, 1, 1.1, '0', '1', '0', 1885, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(587, 'Yellow Mode Armchair', 'sofachair_polyfon*8', 's', 1, 1, 1.1, '0', '1', '0', 1886, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(588, 'Red Armchair', 'sofachair_polyfon*9', 's', 1, 1, 1.1, '0', '1', '0', 1887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(589, 'Black Mode Sofa', 'sofa_polyfon*2', 's', 2, 1, 1.1, '0', '1', '0', 1888, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(590, 'White Two-seater Sofa', 'sofa_polyfon*3', 's', 2, 1, 1.1, '0', '1', '0', 1889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(591, 'Beige Mode Sofa', 'sofa_polyfon*4', 's', 2, 1, 1.1, '0', '1', '0', 1890, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(592, 'Blue Mode Sofa', 'sofa_polyfon*6', 's', 2, 1, 1.1, '0', '1', '0', 1891, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(593, 'Green Two-seater Sofa', 'sofa_polyfon*7', 's', 2, 1, 1.1, '0', '1', '0', 1892, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(594, 'Yellow Mode Sofa', 'sofa_polyfon*8', 's', 2, 1, 1.1, '0', '1', '0', 1893, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(595, 'Black Mode Double Bed', 'sofa_polyfon*9', 's', 2, 1, 1.1, '0', '1', '0', 1894, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(596, 'White Double Bed', 'bed_polyfon*3', 's', 2, 3, 1.8, '0', '0', '0', 1896, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(597, 'Beige Mode Double Bed', 'bed_polyfon*4', 's', 2, 3, 1.8, '0', '0', '0', 1897, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(598, 'Blue Mode Double Bed', 'bed_polyfon*6', 's', 2, 3, 1.8, '0', '0', '0', 1898, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(599, 'Green Double Bed', 'bed_polyfon*7', 's', 2, 3, 1.8, '0', '0', '0', 1899, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(600, 'Yellow Mode Double Bed', 'bed_polyfon*8', 's', 2, 3, 1.8, '0', '0', '0', 1900, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(601, 'Red Double Bed', 'bed_polyfon*9', 's', 2, 3, 1.8, '0', '0', '0', 1901, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(602, 'Black Mode Single Bed', 'bed_polyfon_one*2', 's', 1, 3, 1.8, '0', '0', '0', 1902, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(603, 'White Single Bed', 'bed_polyfon_one*3', 's', 1, 3, 1.8, '0', '0', '0', 1903, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(604, 'Beige Mode Single Bed', 'bed_polyfon_one*4', 's', 1, 3, 1.8, '0', '0', '0', 1904, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(605, 'Blue Mode Single Bed', 'bed_polyfon_one*6', 's', 1, 3, 1.8, '0', '0', '0', 1905, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(606, 'Green Single Bed', 'bed_polyfon_one*7', 's', 1, 3, 1.8, '0', '0', '0', 1906, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(607, 'Yellow Mode Single Bed', 'bed_polyfon_one*8', 's', 1, 3, 1.8, '0', '0', '0', 1907, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(608, 'Red Single Bed', 'bed_polyfon_one*9', 's', 1, 3, 1.8, '0', '0', '0', 1908, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(609, 'Black Mode Bardesk', 'bardesk_polyfon*2', 's', 2, 1, 1, '1', '0', '0', 1909, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(610, 'White Bardesk', 'bardesk_polyfon*3', 's', 2, 1, 1, '1', '0', '0', 1910, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(611, 'Beige Mode Bardesk', 'bardesk_polyfon*4', 's', 2, 1, 1, '1', '0', '0', 1911, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(612, 'Candy Bar', 'bardesk_polyfon*5', 's', 2, 1, 1, '1', '0', '0', 1912, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(613, 'Blue Mode Bardesk', 'bardesk_polyfon*6', 's', 2, 1, 1, '1', '0', '0', 1913, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(614, 'Green Bardesk', 'bardesk_polyfon*7', 's', 2, 1, 1, '1', '0', '0', 1914, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(615, 'Yellow Mode Bardesk', 'bardesk_polyfon*8', 's', 2, 1, 1, '1', '0', '0', 1915, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(616, 'Red Bardesk', 'bardesk_polyfon*9', 's', 2, 1, 1, '1', '0', '0', 1916, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(617, 'Black Mode Bardesk Corner', 'bardeskcorner_polyfon*2', 's', 1, 1, 1, '1', '0', '0', 1917, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(618, 'White Corner Desk', 'bardeskcorner_polyfon*3', 's', 1, 1, 1, '1', '0', '0', 1918, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(619, 'Beige Mode Bardesk Corner', 'bardeskcorner_polyfon*4', 's', 1, 1, 1, '1', '0', '0', 1919, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(620, 'Candy Corner', 'bardeskcorner_polyfon*5', 's', 1, 1, 1, '1', '0', '0', 1920, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(621, 'Blue Mode Bardesk Corner', 'bardeskcorner_polyfon*6', 's', 1, 1, 1, '1', '0', '0', 1921, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(622, 'Green Corner Desk', 'bardeskcorner_polyfon*7', 's', 1, 1, 1, '1', '0', '0', 1922, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(623, 'Yellow Mode Bardesk Corner', 'bardeskcorner_polyfon*8', 's', 1, 1, 1, '1', '0', '0', 1923, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(624, 'Red Corner Desk', 'bardeskcorner_polyfon*9', 's', 1, 1, 1, '1', '0', '0', 1924, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(625, 'Black Mode Bardesk Gate', 'divider_poly3*2', 's', 1, 1, 0.001, '0', '0', '0', 1925, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(626, 'White Hatch', 'divider_poly3*3', 's', 1, 1, 0.001, '0', '0', '0', 1926, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(627, 'Beige Mode Bardesk Gate', 'divider_poly3*4', 's', 1, 1, 0.001, '0', '0', '0', 1927, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(628, 'Candy Hatch (Lockable)', 'divider_poly3*5', 's', 1, 1, 0.001, '0', '0', '0', 1928, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(629, 'Blue Mode Bardesk Gate', 'divider_poly3*6', 's', 1, 1, 0.001, '0', '0', '0', 1929, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(20073, 'ads_idol_l_carpet name', 'ads_idol_l_carpet', 's', 2, 7, 0, '1', '0', '0', 3276, '1', '1', '1', '1', '1', '', 1, '0', ''),
(631, 'Yellow Mode Bardesk Gate', 'divider_poly3*8', 's', 1, 1, 0.001, '0', '0', '0', 1931, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(632, 'Red Hatch', 'divider_poly3*9', 's', 1, 1, 0.001, '0', '0', '0', 1932, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(633, 'Black Dining Chair', 'chair_silo*2', 's', 1, 1, 1.1, '0', '1', '0', 1933, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(634, 'White Dining Chair', 'chair_silo*3', 's', 1, 1, 1.1, '0', '1', '0', 1934, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(635, 'Beige Silo Dining Chair', 'chair_silo*4', 's', 1, 1, 1.1, '0', '1', '0', 1935, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(636, 'Pink Silo Dining Chair', 'chair_silo*5', 's', 1, 1, 1.1, '0', '1', '0', 1936, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(637, 'Blue Area Dining Chair', 'chair_silo*6', 's', 1, 1, 1.1, '0', '1', '0', 1937, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(638, 'Green Area Dining Chair', 'chair_silo*7', 's', 1, 1, 1.1, '0', '1', '0', 1938, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(639, 'Yellow Dining Chair', 'chair_silo*8', 's', 1, 1, 1.1, '0', '1', '0', 1939, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(640, 'Red Area Dining Chair', 'chair_silo*9', 's', 1, 1, 1.1, '0', '1', '0', 1940, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(641, 'No way through', 'divider_nor3*2', 's', 1, 1, 1, '0', '0', '0', 1941, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(642, 'White Iced Gate', 'divider_nor3*3', 's', 1, 1, 0.001, '0', '0', '0', 1942, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(643, 'Urban Iced Gate', 'divider_nor3*4', 's', 1, 1, 0.001, '0', '0', '0', 1943, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(644, 'Pink Iced gate', 'divider_nor3*5', 's', 1, 1, 0.001, '0', '0', '0', 1944, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(645, 'Blue Iced gate', 'divider_nor3*6', 's', 1, 1, 0.001, '0', '0', '0', 1945, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(646, 'Rural Iced gate', 'divider_nor3*7', 's', 1, 1, 0.001, '0', '0', '0', 1946, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(647, 'Yellow Iced gate', 'divider_nor3*8', 's', 1, 1, 0.001, '0', '0', '0', 1947, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(648, 'Red Iced gate', 'divider_nor3*9', 's', 1, 1, 0.001, '0', '0', '0', 1948, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(649, 'Black Iced Bar-Desk', 'divider_nor2*2', 's', 2, 1, 1, '0', '0', '0', 1949, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(650, 'Strong', 'divider_nor2*3', 's', 2, 1, 1, '0', '0', '0', 1950, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(651, 'Urban Iced Bar', 'divider_nor2*4', 's', 2, 1, 1, '0', '0', '0', 1951, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(652, 'Pink Iced bar desk', 'divider_nor2*5', 's', 2, 1, 1, '0', '0', '0', 1952, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(653, 'Blue Iced  bar desk', 'divider_nor2*6', 's', 2, 1, 1, '0', '0', '0', 1953, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(654, 'Rural Iced Bar', 'divider_nor2*7', 's', 2, 1, 1, '0', '0', '0', 1954, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(655, 'Yellow Iced  bar desk', 'divider_nor2*8', 's', 2, 1, 1, '0', '0', '0', 1955, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(656, 'Red Iced  bar desk', 'divider_nor2*9', 's', 2, 1, 1, '0', '0', '0', 1956, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(657, 'Area Quest Desk', 'silo_studydesk', 's', 2, 1, 1, '1', '0', '0', 1957, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(658, 'White Solarium', 'solarium_norja', 's', 1, 1, 1, '0', '0', '0', 1958, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(659, 'Black Solarium', 'solarium_norja*1', 's', 1, 1, 1, '0', '0', '0', 1959, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(660, 'Beige Solarium', 'solarium_norja*2', 's', 1, 1, 1, '0', '0', '0', 1960, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(661, 'Urban Solarium', 'solarium_norja*3', 's', 1, 1, 1, '0', '0', '0', 1961, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(662, 'Pink Solarium', 'solarium_norja*5', 's', 1, 1, 1, '0', '0', '0', 1962, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(663, 'Blue Solarium', 'solarium_norja*6', 's', 1, 1, 1, '0', '0', '0', 1963, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(664, 'Rural Solarium', 'solarium_norja*7', 's', 1, 1, 1, '0', '0', '0', 1964, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(665, 'Yellow Solarium', 'solarium_norja*8', 's', 1, 1, 1, '0', '0', '0', 1965, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(666, 'Red Solarium', 'solarium_norja*9', 's', 1, 1, 1, '0', '0', '0', 1966, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(667, 'Tropical Beach Rug', 'sandrug', 's', 2, 2, 0, '1', '0', '1', 1967, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(668, 'Moon Patch', 'rare_moonrug', 's', 2, 2, 0, '1', '0', '1', 1968, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(669, 'Chinese Lacquer Chair', 'chair_china', 's', 1, 1, 1, '0', '1', '0', 1969, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(670, 'Chinese Lacquer Table', 'china_table', 's', 1, 1, 1, '1', '0', '0', 1970, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(671, 'Red Sleeping Bag', 'sleepingbag*1', 's', 1, 3, 0.8, '0', '0', '0', 1971, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(672, 'Lime Sleeping Bag', 'sleepingbag*2', 's', 1, 3, 0.8, '0', '0', '0', 1972, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(673, 'Ocean Sleeping Bag', 'sleepingbag*3', 's', 1, 3, 0.8, '0', '0', '0', 1973, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(674, 'Safety Sleeping Bag', 'sleepingbag*4', 's', 1, 3, 0.8, '0', '0', '0', 1974, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(675, 'Safe Minibar', 'safe_silo', 's', 1, 1, 1.3, '1', '0', '0', 1975, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(676, 'Orange Sleeping Bag', 'sleepingbag*7', 's', 1, 3, 0.8, '0', '0', '0', 1976, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(677, 'eXceptional Sleeping Bag', 'sleepingbag*9', 's', 1, 3, 0.8, '0', '0', '0', 1977, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(678, 'Graphite Sleeping Bag', 'sleepingbag*5', 's', 1, 3, 0.8, '0', '0', '0', 1978, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(679, 'Khaki Sleeping Bag', 'sleepingbag*10', 's', 1, 3, 0.8, '0', '0', '0', 1979, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(680, 'Purple Sleeping Bag', 'sleepingbag*6', 's', 1, 3, 0.8, '0', '0', '0', 1980, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(681, 'Golden Sleeping Bag', 'sleepingbag*8', 's', 1, 3, 0.8, '0', '0', '0', 1981, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(682, 'Chinese Bookshelf', 'china_shelve', 's', 2, 1, 1, '0', '0', '0', 1982, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(683, 'White Traffic Light', 'traffic_light*5', 's', 1, 1, 1, '0', '0', '0', 1983, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(684, 'Habbos', 'divider_nor4*2', 's', 2, 1, 1, '0', '0', '0', 1984, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(685, 'Habbos', 'divider_nor4*3', 's', 2, 1, 1, '0', '0', '0', 1985, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(686, 'Habbos', 'divider_nor4*5', 's', 2, 1, 1, '0', '0', '0', 1986, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(687, 'Habbos', 'divider_nor4*6', 's', 2, 1, 1, '0', '0', '0', 1987, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(688, 'Habbos', 'divider_nor4*7', 's', 2, 1, 1, '0', '0', '0', 1988, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(689, 'Habbos', 'divider_nor4*8', 's', 2, 1, 1, '0', '0', '0', 1989, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(690, 'Habbos', 'divider_nor4*9', 's', 2, 1, 1, '0', '0', '0', 1990, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(691, 'Black Iced Angle', 'divider_nor5*2', 's', 1, 1, 1, '0', '0', '0', 1991, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(692, 'White Iced Angle', 'divider_nor5*3', 's', 1, 1, 1, '0', '0', '0', 1992, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(693, 'Urban Iced Angle', 'divider_nor5*4', 's', 1, 1, 1, '0', '0', '0', 1993, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(694, 'Blue Iced Angle', 'divider_nor5*5', 's', 1, 1, 1, '0', '0', '0', 1994, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(695, 'Rural Iced Angle', 'divider_nor5*7', 's', 1, 1, 1, '0', '0', '0', 1996, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(696, 'Yellow Iced Angle', 'divider_nor5*8', 's', 1, 1, 1, '0', '0', '0', 1997, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(697, 'Red Iced Angle', 'divider_nor5*9', 's', 1, 1, 1, '0', '0', '0', 1998, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(698, 'Plain Iced Angle', 'divider_nor5', 's', 1, 1, 1, '0', '0', '0', 1999, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(699, 'Habbos', 'divider_nor4', 's', 2, 1, 1, '0', '0', '0', 2000, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(700, 'Dragon Screen', 'wall_china', 's', 1, 1, 1, '0', '0', '0', 2001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(701, 'Firm', 'corner_china', 's', 1, 1, 1, '0', '0', '0', 2002, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(702, 'Black Bar Stool', 'barchair_silo*2', 's', 1, 1, 1.2, '0', '1', '0', 2003, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(703, 'White Bar Stool', 'barchair_silo*3', 's', 1, 1, 1.2, '0', '1', '0', 2004, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(704, 'Beige Bar Stool', 'barchair_silo*4', 's', 1, 1, 1.2, '0', '1', '0', 2005, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(705, 'Pink Bar Stool', 'barchair_silo*5', 's', 1, 1, 1.2, '0', '1', '0', 2006, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(706, 'Blue Bar Stool', 'barchair_silo*6', 's', 1, 1, 1.2, '0', '1', '0', 2007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(707, 'Green Bar Stool', 'barchair_silo*7', 's', 1, 1, 1.2, '0', '1', '0', 2008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(708, 'Yellow Bar Stool', 'barchair_silo*8', 's', 1, 1, 1.2, '0', '1', '0', 2009, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(709, 'Red Bar Stool', 'barchair_silo*9', 's', 1, 1, 1.2, '0', '1', '0', 2010, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(710, 'Black Safe Minibar', 'safe_silo*2', 's', 1, 1, 1.3, '1', '0', '0', 2011, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(711, 'White Safe Minibar', 'safe_silo*3', 's', 1, 1, 1.3, '1', '0', '0', 2012, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(712, 'Beige Safe Minibar', 'safe_silo*4', 's', 1, 1, 1.3, '1', '0', '0', 2013, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(713, 'Pink Safe Minibar', 'safe_silo*5', 's', 1, 1, 1.3, '1', '0', '0', 2014, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(714, 'Blue Safe Minibar', 'safe_silo*6', 's', 1, 1, 1.3, '1', '0', '0', 2015, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(715, 'Green Safe Minibar', 'safe_silo*7', 's', 1, 1, 1.3, '1', '0', '0', 2016, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(716, 'Yellow Safe Minibar', 'safe_silo*8', 's', 1, 1, 1.3, '1', '0', '0', 2017, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(717, 'Red Safe Minibar', 'safe_silo*9', 's', 1, 1, 1.3, '1', '0', '0', 2018, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(718, 'Glass shelf', 'glass_shelf', 's', 2, 1, 1, '0', '0', '0', 2019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(719, 'Glass chair', 'glass_chair', 's', 1, 1, 1, '0', '1', '0', 2020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(720, 'Glass stool', 'glass_stool', 's', 1, 1, 1, '0', '1', '0', 2021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(721, 'Glass sofa', 'glass_sofa', 's', 2, 1, 1, '0', '1', '0', 2022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(722, 'Glass table', 'glass_table', 's', 2, 2, 1, '1', '0', '0', 2023, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(723, 'Glass table', 'glass_table*2', 's', 2, 2, 1, '1', '0', '0', 2024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(724, 'White Glass Table', 'glass_table*3', 's', 2, 2, 1, '1', '0', '0', 2025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(725, 'Glass table', 'glass_table*4', 's', 2, 2, 1, '1', '0', '0', 2026, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(726, 'Candy Glass Table', 'glass_table*5', 's', 2, 2, 1, '1', '0', '0', 2027, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(727, 'Blue Glass Table', 'glass_table*6', 's', 2, 2, 1, '1', '0', '0', 2028, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(728, 'Green Glass Table', 'glass_table*7', 's', 2, 2, 1, '1', '0', '0', 2029, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(729, 'Yellow Glass Table', 'glass_table*8', 's', 2, 2, 1, '1', '0', '0', 2030, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(730, 'Glass table', 'glass_table*9', 's', 2, 2, 1, '1', '0', '0', 2031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(731, 'Glass chair', 'glass_chair*2', 's', 1, 1, 1, '0', '1', '0', 2032, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(732, 'Glass chair', 'glass_chair*3', 's', 1, 1, 1, '0', '1', '0', 2033, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(733, 'Glass chair', 'glass_chair*4', 's', 1, 1, 1, '0', '1', '0', 2034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(734, 'Candy Glass Chair', 'glass_chair*5', 's', 1, 1, 1, '0', '1', '0', 2035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(735, 'Blue Glass Chair', 'glass_chair*6', 's', 1, 1, 1, '0', '1', '0', 2036, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(736, 'Green Glass Chair', 'glass_chair*7', 's', 1, 1, 1, '0', '1', '0', 2037, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(737, 'Yellow Glass Chair', 'glass_chair*8', 's', 1, 1, 1, '0', '1', '0', 2038, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(738, 'Glass chair', 'glass_chair*9', 's', 1, 1, 1, '0', '1', '0', 2039, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(739, 'Glass sofa', 'glass_sofa*2', 's', 2, 1, 1, '0', '1', '0', 2040, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(740, 'White Glass Sofa', 'glass_sofa*3', 's', 2, 1, 1, '0', '1', '0', 2041, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(741, 'Glass sofa', 'glass_sofa*4', 's', 2, 1, 1, '0', '1', '0', 2042, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(742, 'Candy Glass Sofa', 'glass_sofa*5', 's', 2, 1, 1, '0', '1', '0', 2043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(743, 'Blue Glass Sofa', 'glass_sofa*6', 's', 2, 1, 1, '0', '1', '0', 2044, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(744, 'Green Glass Sofa', 'glass_sofa*7', 's', 2, 1, 1, '0', '1', '0', 2045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(745, 'Yellow Glass Sofa', 'glass_sofa*8', 's', 2, 1, 1, '0', '1', '0', 2046, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(746, 'Glass sofa', 'glass_sofa*9', 's', 2, 1, 1, '0', '1', '0', 2047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(747, 'Glass stool', 'glass_stool*2', 's', 1, 1, 1, '0', '1', '0', 2048, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(748, 'Glass stool', 'glass_stool*4', 's', 1, 1, 1, '0', '1', '0', 2050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(749, 'Candy Glass Stool', 'glass_stool*5', 's', 1, 1, 1, '0', '1', '0', 2051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(750, 'Blue Glass Stool', 'glass_stool*6', 's', 1, 1, 1, '0', '1', '0', 2052, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(751, 'Green Glass Stool', 'glass_stool*7', 's', 1, 1, 1, '0', '1', '0', 2053, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(752, 'Yellow Glass Stool', 'glass_stool*8', 's', 1, 1, 1, '0', '1', '0', 2054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(753, 'White Glass Stool', 'glass_stool*3', 's', 1, 1, 1, '0', '1', '0', 2056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(754, 'Glass stool', 'glass_stool*9', 's', 1, 1, 1, '0', '1', '0', 2057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(755, 'Gold Coin', 'CF_10_coin_gold', 's', 1, 1, 0.2, '1', '0', '0', 2063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(756, 'Bronze Coin', 'CF_1_coin_bronze', 's', 1, 1, 0.2, '1', '0', '0', 2064, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(757, 'Sack of Credits', 'CF_20_moneybag', 's', 1, 1, 1, '1', '0', '0', 2065, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(758, 'Gold Bar', 'CF_50_goldbar', 's', 1, 1, 0.2, '1', '0', '0', 2066, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(759, 'Silver Coin', 'CF_5_coin_silver', 's', 1, 1, 0.2, '1', '0', '0', 2067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(760, 'Persian Carpet', 'hc_crpt', 's', 3, 5, 0, '1', '0', '1', 2068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(761, 'Forget plasma', 'hc_tv', 's', 2, 1, 1.4, '0', '1', '0', 2069, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(762, 'Gothic Portcullis', 'gothgate', 's', 2, 1, 0.001, '0', '0', '0', 2070, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(763, 'Gothic Candelabra', 'gothiccandelabra', 's', 1, 1, 1, '0', '0', '0', 2071, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(764, 'Gothic Railing', 'gothrailing', 's', 2, 1, 1, '0', '0', '0', 2072, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(765, 'Gothic table', 'goth_table', 's', 1, 5, 1.7, '0', '0', '0', 2073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(766, 'Medieval Bookcase', 'hc_bkshlf', 's', 1, 4, 1, '0', '0', '0', 2074, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(767, 'Electric Butler', 'hc_btlr', 's', 1, 1, 1, '0', '0', '0', 2075, '1', '1', '1', '1', '1', 'vendingmachine', 0, '24', ''),
(768, 'Antique Drapery', 'hc_crtn', 's', 2, 1, 0.001, '0', '0', '0', 2076, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(769, 'The Grammophon', 'hc_djset', 's', 3, 1, 1, '0', '0', '0', 2077, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(770, 'Heavy Duty Fireplace', 'hc_frplc', 's', 1, 3, 1, '0', '0', '0', 2078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(771, 'Victorian Street Light', 'hc_lmpst', 's', 1, 1, 1, '0', '0', '0', 2079, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(772, 'Weird Science Machine', 'hc_machine', 's', 1, 3, 1, '0', '0', '0', 2080, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(773, 'HC Rollers Set', 'hc_rllr', 's', 1, 1, 0.5, '0', '0', '1', 2081, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(774, 'X-Ray Divider', 'hc_rntgn', 's', 2, 1, 1, '0', '0', '0', 2082, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(775, 'Drinks Trolley', 'hc_trll', 's', 1, 2, 1, '0', '0', '0', 2083, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(776, 'Gothic Chair Pink', 'gothic_chair*1', 's', 1, 1, 1, '0', '1', '0', 2084, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(777, 'Gothic Sofa Pink', 'gothic_sofa*1', 's', 2, 1, 1, '0', '1', '0', 2085, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(778, 'Gothic Stool Pink', 'gothic_stool*1', 's', 1, 1, 1, '0', '1', '0', 2086, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(779, 'Golden Gothic Chair', 'gothic_chair*2', 's', 1, 1, 1, '0', '1', '0', 2087, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(780, 'Golden Gothic Sofa', 'gothic_sofa*2', 's', 2, 1, 1, '0', '1', '0', 2088, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(781, 'Golden Gothic Stool', 'gothic_stool*2', 's', 1, 1, 1, '0', '1', '0', 2089, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(782, 'Red Gothic Chair', 'gothic_chair*3', 's', 1, 1, 1, '0', '1', '0', 2090, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(783, 'Red Gothic Sofa', 'gothic_sofa*3', 's', 2, 1, 1, '0', '1', '0', 2091, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(784, 'Red Gothic Stool', 'gothic_stool*3', 's', 1, 1, 1, '0', '1', '0', 2092, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(785, 'Black Gothic Chair', 'gothic_chair*4', 's', 1, 1, 1, '0', '1', '0', 2093, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(786, 'Black Gothic Sofa', 'gothic_sofa*4', 's', 2, 1, 1, '0', '1', '0', 2094, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(787, 'Black Gothic Stool', 'gothic_stool*4', 's', 1, 1, 1, '0', '1', '0', 2095, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(788, 'Green Gothic Chair', 'gothic_chair*5', 's', 1, 1, 1, '0', '1', '0', 2096, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(789, 'Green Gothic Sofa', 'gothic_sofa*5', 's', 2, 1, 1, '0', '1', '0', 2097, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(790, 'Green Gothic Stool', 'gothic_stool*5', 's', 1, 1, 1, '0', '1', '0', 2098, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(791, 'Gothic Chair Blue', 'gothic_chair*6', 's', 1, 1, 1, '0', '1', '0', 2099, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(792, 'Gothic Sofa Blue', 'gothic_sofa*6', 's', 2, 1, 1, '0', '1', '0', 2100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(793, 'Valentine''s Cauldron', 'gothic_stool*6', 's', 1, 1, 1, '0', '1', '0', 2101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(794, 'Sound Machine', 'sound_machine', 's', 1, 1, 1, '0', '0', '0', 2105, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(795, 'Turquoise Romantique Piano Chair', 'romantique_pianochair*3', 's', 1, 1, 1, '0', '1', '0', 2106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(796, 'Onyx Piano Stool', 'romantique_pianochair*5', 's', 1, 1, 1, '0', '1', '0', 2107, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(797, 'Lime Romantique Piano Chair', 'romantique_pianochair*2', 's', 1, 1, 1, '0', '1', '0', 2108, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(798, 'Amber Piano Stool', 'romantique_pianochair*4', 's', 1, 1, 1, '0', '1', '0', 2109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(799, 'Rose Quartz Piano Stool', 'romantique_pianochair*1', 's', 1, 1, 1, '0', '1', '0', 2110, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(800, 'Turquoise Romantique Divan', 'romantique_divan*3', 's', 2, 1, 1, '0', '1', '0', 2111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(801, 'Onyx Chaise-Longue', 'romantique_divan*5', 's', 2, 1, 1, '0', '1', '0', 2112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(802, 'Emerald Chaise-Longue', 'romantique_divan*2', 's', 2, 1, 1, '0', '1', '0', 2113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(803, 'Amber Chaise-Longue', 'romantique_divan*4', 's', 2, 1, 1, '0', '1', '0', 2114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(804, 'Rose Quartz Chaise-Longue', 'romantique_divan*1', 's', 2, 1, 1, '0', '1', '0', 2115, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(805, 'Turquoise Romantique Chair', 'romantique_chair*3', 's', 1, 1, 1, '0', '1', '0', 2116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(806, 'Onyx Chair', 'romantique_chair*5', 's', 1, 1, 1, '0', '1', '0', 2117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(807, 'Lime Romantique Chair', 'romantique_chair*2', 's', 1, 1, 1, '0', '1', '0', 2118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(808, 'Amber Chair', 'romantique_chair*4', 's', 1, 1, 1, '0', '1', '0', 2119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(809, 'Rose Quartz Chair', 'romantique_chair*1', 's', 1, 1, 1, '0', '1', '0', 2120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(811, 'Yellow Valentine Rose', 'plant_valentinerose*3', 's', 1, 1, 1, '0', '0', '0', 2123, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(812, 'Purple Valentine''s Rose', 'plant_valentinerose*5', 's', 1, 1, 1, '0', '0', '0', 2124, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(813, 'White Valentine''s Rose', 'plant_valentinerose*2', 's', 1, 1, 1, '0', '0', '0', 2125, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(814, 'Pink Valentine''s Rose', 'plant_valentinerose*4', 's', 1, 1, 1, '0', '0', '0', 2126, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(815, 'Red Valentine''s Rose', 'plant_valentinerose*1', 's', 1, 1, 1, '0', '0', '0', 2127, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(816, 'Maze Shrubbery Gate', 'plant_mazegate', 's', 2, 1, 0.001, '0', '0', '0', 2128, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(817, 'Maze Shrubbery', 'plant_maze', 's', 2, 1, 1, '0', '0', '0', 2129, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(818, 'Bulrush', 'plant_bulrush', 's', 1, 1, 1, '0', '0', '0', 2130, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(819, 'T-Bones Mega Multipack', 'petfood4', 's', 1, 1, 1, '1', '0', '0', 2131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(820, 'Red carpet', 'carpet_valentine', 's', 2, 7, 0, '1', '0', '1', 2132, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(821, 'Cobbled Path', 'gothic_carpet', 's', 2, 4, 0, '1', '0', '1', 2133, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(822, 'Dungeon Floor', 'gothic_carpet2', 's', 2, 4, 0, '1', '0', '1', 2134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(823, '', 'gothic_chair', 's', 1, 1, 1, '0', '1', '0', 2135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(824, '', 'gothic_sofa', 's', 2, 1, 1, '0', '1', '0', 2136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(825, '', 'gothic_stool', 's', 1, 1, 1, '0', '1', '0', 2137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(826, 'Pink Grand Piano', 'grand_piano*3', 's', 2, 2, 1, '0', '0', '0', 2138, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(827, 'Onyx Grand Piano', 'grand_piano*5', 's', 2, 2, 1, '0', '0', '0', 2139, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(828, 'Black Grand Piano', 'grand_piano*2', 's', 2, 2, 1, '0', '0', '0', 2140, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(829, 'Amber Grand Piano', 'grand_piano*4', 's', 2, 2, 1, '0', '0', '0', 2141, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(830, 'Turquoise Grand Piano', 'grand_piano*1', 's', 2, 2, 1, '0', '0', '0', 2142, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(831, 'Deluxe Theatre Chair', 'theatre_seat', 's', 1, 1, 1.2, '0', '1', '0', 2143, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(832, 'Treats Tray', 'romantique_tray2', 's', 1, 1, 1, '0', '0', '0', 2144, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(833, 'Breakfast Tray', 'romantique_tray1', 's', 1, 1, 1, '0', '0', '0', 2145, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(834, 'Turquoise Tray Table', 'romantique_smalltabl*3', 's', 1, 1, 1, '1', '0', '0', 2146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(835, 'Onyx Tray Table', 'romantique_smalltabl*5', 's', 1, 1, 1, '1', '0', '0', 2147, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(836, 'Lime Tray Table', 'romantique_smalltabl*2', 's', 1, 1, 1, '1', '0', '0', 2148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(837, 'Amber Tray Table', 'romantique_smalltabl*4', 's', 1, 1, 1, '1', '0', '0', 2149, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(838, 'Rose Quartz Tray Table', 'romantique_smalltabl*1', 's', 1, 1, 1, '1', '0', '0', 2150, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(839, 'Dressing Table', 'romantique_mirrortabl', 's', 1, 1, 1, '1', '0', '0', 2151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(840, 'Turquoise Screen', 'romantique_divider*3', 's', 2, 1, 1, '0', '0', '0', 2152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(841, 'Green Screen', 'romantique_divider*2', 's', 2, 1, 1, '1', '0', '0', 2153, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(842, 'Amber Screen', 'romantique_divider*4', 's', 2, 1, 1, '1', '0', '0', 2154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(843, 'Rose Quartz Screen', 'romantique_divider*1', 's', 2, 1, 1, '1', '0', '0', 2155, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(844, 'Large Tatami Mat', 'jp_tatami2', 's', 2, 4, 0, '1', '0', '1', 2156, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(845, 'Small Tatami Mat', 'jp_tatami', 's', 2, 2, 1, '0', '0', '1', 2157, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(846, 'Director''s Chair', 'habbowood_chair', 's', 1, 1, 1.2, '0', '1', '0', 2158, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(847, 'Bamboo Forest', 'jp_bamboo', 's', 2, 2, 0, '1', '0', '1', 2159, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(848, 'Irori', 'jp_irori', 's', 2, 2, 1, '0', '0', '0', 2160, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(849, 'Pillow Chair', 'jp_pillow', 's', 1, 1, 0.8, '0', '1', '0', 2161, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(850, 'Habbo Sounds 1', 'sound_set_1', 's', 1, 1, 0.2, '1', '0', '0', 2162, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(851, 'Habbo Sounds 3', 'sound_set_2', 's', 1, 1, 0.2, '1', '0', '0', 2163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1008, 'Jukebox', 'jukebox*1', 's', 1, 1, 1, '1', '0', '0', 2608, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1009, 'Welcome', 'carpet_soft_tut', 's', 1, 1, 0, '1', '0', '1', 2609, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1010, 'Graveyard Portal', 'sound_set_44', 's', 1, 1, 0.2, '1', '0', '0', 2610, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1011, 'SFX 1', 'sound_set_43', 's', 1, 1, 0.2, '1', '0', '0', 2614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1012, 'Haunted Mansion', 'sound_set_42', 's', 1, 1, 0.2, '1', '0', '0', 2624, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1013, 'Rock 8', 'sound_set_41', 's', 1, 1, 0.2, '1', '0', '0', 2612, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1014, 'Rock 4', 'sound_set_40', 's', 1, 1, 0.2, '1', '0', '0', 2615, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1015, 'Rock 7', 'sound_set_39', 's', 1, 1, 0.2, '1', '0', '0', 2622, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1016, 'Rock 6', 'sound_set_38', 's', 1, 1, 0.2, '1', '0', '0', 2616, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1017, 'Grunge Chair', 'grunge_chair', 's', 1, 1, 1, '0', '1', '0', 2617, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1018, 'Grunge Mattress', 'grunge_mattress', 's', 3, 1, 1, '0', '1', '0', 2618, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1019, 'Radiator', 'grunge_radiator', 's', 1, 1, 1, '0', '0', '0', 2621, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1020, 'Grunge Bookshelf', 'grunge_shelf', 's', 3, 1, 1, '0', '0', '0', 2619, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1021, 'Road Sign', 'grunge_sign', 's', 1, 1, 1, '0', '0', '0', 2613, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1022, 'Grunge Table', 'grunge_table', 's', 2, 2, 1, '1', '0', '0', 2623, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1023, 'Creepy Crypt', 'habboween_crypt', 's', 1, 3, 1.1, '0', '0', '0', 2611, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(1024, 'Unholy Ground', 'habboween_grass', 's', 2, 2, 0, '0', '0', '1', 2626, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1025, 'Habboween Cauldron', 'hal_cauldron', 's', 1, 1, 1, '0', '0', '0', 2625, '1', '1', '1', '1', '1', 'vendingmachine', 0, '30', ''),
(1026, 'Haunted Grave', 'hal_grave', 's', 1, 1, 1, '0', '0', '0', 2620, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1027, 'Christmas Party', 'sound_set_52', 's', 1, 1, 0.2, '1', '0', '0', 2633, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1028, 'Club 6', 'sound_set_51', 's', 1, 1, 0.2, '1', '0', '0', 2631, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1029, 'Club 5', 'sound_set_50', 's', 1, 1, 0.2, '1', '0', '0', 2632, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1030, 'Club 4', 'sound_set_49', 's', 1, 1, 0.2, '1', '0', '0', 2634, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1031, 'Club 3', 'sound_set_48', 's', 1, 1, 0.2, '1', '0', '0', 2629, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1032, 'Club 2', 'sound_set_47', 's', 1, 1, 0.2, '1', '0', '0', 2627, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1033, 'Club 1', 'sound_set_46', 's', 1, 1, 0.2, '1', '0', '0', 2630, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1034, 'Lost_Beatness', 'sound_set_45', 's', 1, 1, 0.2, '1', '0', '0', 2628, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1035, 'Lantern Bundle 2', 'xmas_icelamp', 's', 1, 1, 1, '1', '0', '0', 2641, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1036, 'Ice Castle Wall', 'xmas_cstl_wall', 's', 2, 1, 1, '0', '0', '0', 2646, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1037, 'Ice Castle Tower', 'xmas_cstl_twr', 's', 1, 1, 1, '0', '0', '0', 2651, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1038, 'Ice Castle Gate', 'xmas_cstl_gate', 's', 2, 1, 0.001, '0', '0', '0', 2636, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1039, 'Snowy Christmas Tree', 'tree7', 's', 1, 1, 1, '0', '0', '0', 2653, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1040, 'Flashy Christmas Tree', 'tree6', 's', 1, 1, 1, '0', '0', '0', 2638, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1041, 'Oh Blinging Tree', 'sound_set_54', 's', 1, 1, 0.2, '1', '0', '0', 2649, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1042, 'Snowy Surprise', 'sound_set_53', 's', 1, 1, 0.2, '1', '0', '0', 2652, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1043, 'postbank Safe', 'safe_silo_pb', 's', 1, 1, 1.3, '1', '0', '0', 2642, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(1044, 'Snowy Maze Gate', 'plant_mazegate_snow', 's', 2, 1, 0.001, '0', '0', '1', 2640, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1045, 'Snowy Maze Bundle 2', 'plant_maze_snow', 's', 2, 1, 1, '0', '0', '1', 2635, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1046, 'Winter Sleigh', 'christmas_sleigh', 's', 2, 2, 1, '0', '0', '0', 2648, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1047, 'Reindeer', 'christmas_reindeer', 's', 1, 2, 1, '0', '0', '0', 2637, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1048, 'Reindeer Droppings', 'christmas_poop', 's', 1, 1, 1, '0', '0', '0', 2654, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1049, 'Executive Bar Desk', 'exe_bardesk', 's', 1, 1, 1, '1', '0', '0', 2643, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1050, 'Executive Sofa Chair', 'exe_chair', 's', 1, 1, 1, '0', '1', '0', 2647, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1051, 'Executive Boss Chair', 'exe_chair2', 's', 1, 1, 1, '0', '1', '0', 2650, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1052, 'Executive Corner Desk', 'exe_corner', 's', 1, 1, 1, '1', '0', '0', 2655, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1053, 'Executive Drinks Tray', 'exe_drinks', 's', 1, 1, 1, '0', '0', '0', 2645, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1054, '3-Seater Sofa', 'exe_sofa', 's', 3, 1, 1, '0', '1', '0', 2639, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1055, 'Take a memo', 'exe_table', 's', 3, 2, 1.1, '0', '0', '0', 2644, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1056, 'RnB Grooves 5', 'sound_set_59', 's', 1, 1, 0.2, '1', '0', '0', 2670, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1057, 'RnB Grooves 4', 'sound_set_58', 's', 1, 1, 0.2, '1', '0', '0', 2656, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1058, 'RnB Grooves 3', 'sound_set_57', 's', 1, 1, 0.2, '1', '0', '0', 2673, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1059, 'RnB Grooves 2', 'sound_set_56', 's', 1, 1, 0.2, '1', '0', '0', 2669, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1060, 'RnB Grooves 1', 'sound_set_55', 's', 1, 1, 0.2, '1', '0', '0', 2671, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1061, 'Lightweight', 'noob_table*1', 's', 2, 2, 1, '1', '0', '0', 2687, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1062, 'Lightweight', 'noob_table*2', 's', 2, 2, 1, '1', '0', '0', 2688, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1063, 'Lightweight', 'noob_table*3', 's', 2, 2, 1, '1', '0', '0', 2689, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1064, 'Lightweight', 'noob_table*4', 's', 2, 2, 1, '1', '0', '0', 2690, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1065, 'Lightweight', 'noob_table*5', 's', 2, 2, 1, '1', '0', '0', 2691, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1066, 'Lightweight', 'noob_table*6', 's', 2, 2, 1, '1', '0', '0', 2692, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1067, 'My first Habbo stool', 'noob_stool*1', 's', 1, 1, 1, '0', '1', '0', 2657, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1068, 'My first Habbo stool', 'noob_stool*2', 's', 1, 1, 1, '0', '1', '0', 2658, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1069, 'My first Habbo stool', 'noob_stool*3', 's', 1, 1, 1, '0', '1', '0', 2659, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1070, 'My first Habbo stool', 'noob_stool*4', 's', 1, 1, 1, '0', '1', '0', 2660, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1071, 'My first Habbo stool', 'noob_stool*5', 's', 1, 1, 1, '0', '1', '0', 2661, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1072, 'My first Habbo stool', 'noob_stool*6', 's', 1, 1, 1, '0', '1', '0', 2662, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1073, 'My first Habbo rug', 'noob_rug*1', 's', 2, 3, 0, '1', '0', '1', 2681, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1074, 'My first Habbo rug', 'noob_rug*2', 's', 2, 3, 0, '1', '0', '1', 2682, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1075, 'My first Habbo rug', 'noob_rug*3', 's', 2, 3, 0, '1', '0', '1', 2683, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1076, 'My first Habbo rug', 'noob_rug*4', 's', 2, 3, 0, '1', '0', '1', 2684, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1077, 'My first Habbo rug', 'noob_rug*5', 's', 2, 3, 0, '1', '0', '1', 2685, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1078, 'My first Habbo rug', 'noob_rug*6', 's', 2, 3, 0, '1', '0', '1', 2686, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1079, 'My first Habbo lamp', 'noob_lamp*1', 's', 1, 1, 1, '0', '0', '0', 2663, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1080, 'My first Habbo lamp', 'noob_lamp*2', 's', 1, 1, 1, '0', '0', '0', 2664, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1081, 'My first Habbo lamp', 'noob_lamp*3', 's', 1, 1, 1, '0', '0', '0', 2665, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1082, 'My first Habbo lamp', 'noob_lamp*4', 's', 1, 1, 1, '0', '0', '0', 2666, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1083, 'My first Habbo lamp', 'noob_lamp*5', 's', 1, 1, 1, '0', '0', '0', 2667, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1084, 'My first Habbo lamp', 'noob_lamp*6', 's', 1, 1, 1, '0', '0', '0', 2668, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1085, 'Lightweight', 'noob_chair*1', 's', 1, 1, 1, '0', '1', '0', 2675, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1086, ' practical', 'noob_chair*2', 's', 1, 1, 1, '0', '1', '0', 2676, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1087, ' practical', 'noob_chair*3', 's', 1, 1, 1, '0', '1', '0', 2677, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1088, ' practical', 'noob_chair*4', 's', 1, 1, 1, '0', '1', '0', 2678, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1089, ' practical', 'noob_chair*5', 's', 1, 1, 1, '0', '1', '0', 2679, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1090, 'Power Globe', 'noob_chair*6', 's', 1, 1, 1, '0', '1', '0', 2680, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1091, 'Executive Plant', 'exe_plant', 's', 1, 1, 1, '0', '0', '0', 2674, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1092, 'Grey Share Bear', 'val_teddy*1', 's', 1, 1, 1, '0', '1', '0', 2699, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1093, 'Pink Share Bear', 'val_teddy*2', 's', 1, 1, 1, '0', '1', '0', 2700, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1094, 'Green Share Bear', 'val_teddy*3', 's', 1, 1, 1, '0', '1', '0', 2701, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1095, 'Brown Share Bear', 'val_teddy*4', 's', 1, 1, 1, '0', '1', '0', 2702, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1096, 'Yellow Share Bear', 'val_teddy*5', 's', 1, 1, 1, '0', '1', '0', 2703, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1097, 'Blue Share Bear', 'val_teddy*6', 's', 1, 1, 1, '0', '1', '0', 2704, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1098, 'Love Randomiser', 'val_randomizer', 's', 4, 1, 1.4, '0', '1', '0', 2696, '1', '1', '1', '1', '1', 'loveshuffler', 1, '0', ''),
(1099, 'Heart Shaped Chocs', 'val_choco', 's', 1, 1, 1, '0', '0', '0', 2697, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1100, 'Teleport Door', 'teleport_door', 's', 1, 1, 0.001, '0', '0', '1', 2693, '1', '1', '0', '1', '1', 'teleport', 2, '0', ''),
(1101, 'Latin Love 3', 'sound_set_61', 's', 1, 1, 0.2, '1', '0', '0', 2698, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1102, 'Latin Love 2', 'sound_set_60', 's', 1, 1, 0.2, '1', '0', '0', 2695, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1103, 'Crystal Ball', 'fortune', 's', 1, 1, 1, '0', '0', '0', 2694, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(1104, 'Adventure Desk', 'sw_table', 's', 1, 2, 1, '0', '0', '0', 2713, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1105, 'Raven', 'sw_raven', 's', 1, 1, 1, '0', '0', '0', 2711, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1106, 'Ye Olde Chest', 'sw_chest', 's', 1, 2, 1, '0', '0', '0', 2709, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1107, 'Sand Castle Wall', 'sand_cstl_wall', 's', 2, 1, 1, '0', '0', '0', 2710, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1108, 'Sand Castle Tower', 'sand_cstl_twr', 's', 1, 1, 1, '0', '0', '0', 2705, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1109, 'Sand Castle Gate', 'sand_cstl_gate', 's', 2, 1, 0.001, '0', '0', '0', 2712, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1110, 'Candle Box', 'grunge_candle', 's', 1, 1, 1, '0', '0', '0', 2708, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1111, 'Bench', 'grunge_bench', 's', 3, 1, 1, '0', '1', '0', 2707, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1112, 'Flaming Barrel', 'grunge_barrel', 's', 1, 1, 1, '0', '0', '0', 2706, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1113, 'Moon Lamp', 'rclr_lamp', 's', 1, 1, 1, '0', '0', '0', 2733, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1115, 'Bubble trophy', 'a0 prizetrophy8_g', 's', 1, 1, 1, '0', '0', '0', 2426, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1116, 'nouvelle_trax', 'nouvelle_trax', 's', 1, 1, 1, '0', '0', '0', 2736, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1117, 'Bubble Juice Floor', 'md_rug', 's', 4, 4, 0, '1', '0', '1', 2727, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1118, 'Sushi Kohada', 'jp_tray6', 's', 1, 1, 1, '0', '0', '0', 2720, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1119, 'Sushi Tamago', 'jp_tray5', 's', 1, 1, 1, '0', '0', '0', 2717, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1120, 'Sushi Uni', 'jp_tray4', 's', 1, 1, 1, '0', '0', '0', 2725, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1121, 'Sushi Ikura', 'jp_tray3', 's', 1, 1, 1, '0', '0', '0', 2726, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1122, 'Sushi Ika', 'jp_tray2', 's', 1, 1, 1, '0', '0', '0', 2724, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1123, 'Sushi Maguro', 'jp_tray1', 's', 1, 1, 1, '0', '0', '0', 2715, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1124, 'Tea Maker', 'arabian_teamk', 's', 1, 1, 1, '0', '0', '0', 2716, '1', '1', '1', '1', '1', 'vendingmachine', 0, '1', ''),
(1125, 'Ornamental Urn', 'arabian_snake', 's', 1, 1, 1, '0', '0', '0', 2732, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1126, 'Berber Kilim Rug', 'arabian_rug', 's', 3, 5, 0, '1', '0', '1', 2719, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1127, 'Green Blossom Pillow', 'arabian_pllw', 's', 1, 1, 0.8, '0', '1', '0', 2722, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1128, 'Soft wooden screen', 'arabian_divdr', 's', 1, 2, 1, '0', '0', '0', 2730, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1129, 'Exotic', 'arabian_chair', 's', 1, 1, 1.2, '0', '1', '0', 2721, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1130, 'Amanjena Table', 'arabian_bigtb', 's', 3, 2, 0.8, '1', '0', '0', 2731, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1131, 'Hexagonal Tea Table', 'arabian_tetbl', 's', 1, 1, 1, '1', '0', '0', 2714, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1132, 'Mint Tea Tray', 'arabian_tray1', 's', 1, 1, 1, '0', '0', '0', 2734, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1133, 'Candle Tray', 'arabian_tray2', 's', 1, 1, 1, '0', '0', '0', 2735, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1134, 'Sweets Tray', 'arabian_tray3', 's', 1, 1, 1, '0', '0', '0', 2723, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1135, 'Sweet', 'arabian_tray4', 's', 1, 1, 1, '0', '0', '0', 2728, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1136, 'Alhambra Trax 3', 'sound_set_64', 's', 1, 1, 0.2, '1', '0', '0', 2738, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1137, 'Alhambra Trax 2', 'sound_set_63', 's', 1, 1, 0.2, '1', '0', '0', 2740, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1138, 'Alhambra Trax 1', 'sound_set_62', 's', 1, 1, 0.2, '1', '0', '0', 2741, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1139, 'Jukebox Pacha TV', 'jukebox_ptv*1', 's', 1, 1, 1, '0', '0', '0', 2739, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1140, 'Calippo icecream machine', 'calippo', 's', 1, 1, 1, '0', '0', '0', 2737, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(1141, 'traxsilver', 'traxsilver', 's', 1, 1, 1, '1', '0', '0', 2744, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1142, 'traxgold', 'traxgold', 's', 1, 1, 1, '1', '0', '0', 2742, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1143, 'traxbronze', 'traxbronze', 's', 1, 1, 1, '1', '0', '0', 2743, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1144, 'bench_puffet', 'bench_puffet', 's', 2, 1, 1, '0', '1', '0', 2745, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1145, 'Gold Bar (China)', 'CFC_500_goldbar', 's', 1, 1, 0.4, '1', '0', '0', 2764, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1146, 'Sack of Credits (China)', 'CFC_200_moneybag', 's', 1, 1, 1, '1', '0', '0', 2770, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20006, 'Mesh Corner', 'urban_fence_corner', 's', 1, 1, 1, '1', '0', '0', 3275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1148, 'Gold Coin (China)', 'CFC_100_coin_gold', 's', 1, 1, 0.2, '1', '0', '0', 2796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1149, 'Silver Coin (China)', 'CFC_50_coin_silver', 's', 1, 1, 0.2, '1', '0', '0', 2772, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1150, 'Chabu Dai', 'jp_table', 's', 2, 2, 1, '0', '0', '0', 2749, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1151, 'Shishi Odishi', 'jp_rare', 's', 2, 2, 1, '0', '0', '0', 2750, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1152, 'Katana Green', 'jp_katana3', 's', 1, 1, 1, '0', '0', '0', 2748, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1153, 'Katana Blue', 'jp_katana2', 's', 1, 1, 1, '0', '0', '0', 2747, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1154, 'HC Katana Red', 'jp_katana1', 's', 1, 1, 1, '0', '0', '0', 2751, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1156, 'Tiki Waterfall', 'tiki_waterfall', 's', 3, 2, 1, '0', '0', '0', 2757, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1157, 'Tiki Pig Tray', 'tiki_tray4', 's', 1, 1, 1, '0', '0', '0', 2765, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1158, 'Tiki Fish Tray', 'tiki_tray3', 's', 1, 1, 1, '0', '0', '0', 2753, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1159, 'Tiki Pineapple Plate', 'tiki_tray2', 's', 1, 1, 1, '0', '0', '0', 2768, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1160, 'Tiki Fruit Tray', 'tiki_tray1', 's', 1, 1, 1, '0', '0', '0', 2755, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1161, 'Empty Tray', 'tiki_tray0', 's', 1, 1, 1, '0', '0', '0', 2792, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1162, 'Toucan', 'tiki_toucan', 's', 1, 1, 1, '0', '0', '0', 2756, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1163, 'Beach Torch', 'tiki_torch', 's', 1, 1, 1, '0', '0', '0', 2773, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1164, 'Tribal Statue', 'tiki_statue', 's', 1, 1, 1, '0', '0', '0', 2782, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1165, 'Island Sand Patch', 'tiki_sand', 's', 2, 2, 0, '1', '0', '1', 2798, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1166, 'Tiki Parasol', 'tiki_parasol', 's', 1, 1, 1, '0', '0', '0', 2769, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1167, 'Jungle Patch', 'tiki_junglerug', 's', 2, 2, 0, '1', '0', '1', 2781, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1168, 'Tiki Bar Corner', 'tiki_corner', 's', 1, 1, 1, '1', '0', '0', 2794, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1169, 'Butterflies', 'tiki_bflies', 's', 1, 1, 1, '0', '0', '0', 2785, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1170, 'Tiki Bar Stool', 'tiki_bench', 's', 1, 1, 1.3, '0', '1', '0', 2784, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1171, 'Tiki Bar Desk', 'tiki_bardesk', 's', 1, 1, 1, '1', '0', '0', 2795, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1172, 'tampax_rug', 'tampax_rug', 's', 3, 4, 0, '1', '0', '1', 2754, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1173, 'Sound set 70', 'sound_set_70', 's', 1, 1, 0.2, '1', '0', '0', 2767, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1174, 'Sound set 69', 'sound_set_69', 's', 1, 1, 0.2, '1', '0', '0', 2799, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1175, 'Sound set 68', 'sound_set_68', 's', 1, 1, 0.2, '1', '0', '0', 2793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1176, 'Sound set 67', 'sound_set_67', 's', 1, 1, 0.2, '1', '0', '0', 2771, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1177, 'Sound set 66', 'sound_set_66', 's', 1, 1, 0.2, '1', '0', '0', 2752, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1178, 'Sound set 65', 'sound_set_65', 's', 1, 1, 0.2, '1', '0', '0', 2766, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20024, 'Square Dining Table', 'table_plasto_square*9', 's', 1, 1, 1, '1', '0', '0', 118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20021, 'Giant Heart', 'heart', 's', 1, 1, 1, '0', '0', '0', 227, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20016, 'Street Lamp', 'urban_lamp', 's', 1, 1, 1, '1', '0', '0', 3265, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1185, 'Lucky Bamboo', 'noob_plant', 's', 1, 1, 1, '0', '0', '0', 2783, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(20018, 'Street Wall', 'urban_wall', 'i', 0, 0, 1, '1', '0', '0', 4244, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20022, 'Champion trophy', 'a0 prizetrophy6_b', 's', 1, 1, 1, '0', '0', '0', 1510, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1197, 'Japanese Teamaker', 'jp_teamaker', 's', 1, 1, 1, '0', '0', '0', 2774, '1', '1', '1', '1', '1', 'vendingmachine', 0, '28', ''),
(1198, 'September 2008', 'svnr_uk', 's', 1, 1, 1, '0', '0', '0', 2838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1199, 'August 2008', 'svnr_nl', 's', 1, 2, 1, '0', '1', '0', 2825, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1200, 'July 2008', 'svnr_it', 's', 2, 1, 1, '0', '1', '0', 2813, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1201, 'October 2008', 'svnr_de', 's', 1, 1, 1, '0', '0', '0', 2801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1202, 'November 2008', 'svnr_aus', 's', 1, 1, 1, '0', '0', '0', 2836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1203, 'Accompaniments', 'diner_tray_7', 's', 1, 1, 1, '0', '0', '0', 2840, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1204, 'Vanilla', 'diner_tray_6', 's', 1, 1, 1, '0', '0', '0', 2826, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1205, 'Bacon and Eggs', 'diner_tray_5', 's', 1, 1, 1, '0', '0', '0', 2815, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1206, 'Pancakes', 'diner_tray_4', 's', 1, 1, 1, '0', '0', '0', 2800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1207, 'Spaghetti Meatballs', 'diner_tray_3', 's', 1, 1, 1, '0', '0', '0', 2841, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1208, 'Steak and Mash', 'diner_tray_2', 's', 1, 1, 1, '0', '0', '0', 2802, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1209, 'Burger and Chips', 'diner_tray_1', 's', 1, 1, 1, '0', '0', '0', 2839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1210, 'Had your fill', 'diner_tray_0', 's', 1, 1, 0.1, '1', '0', '0', 2837, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1211, 'Aqua Diner Sofa 2', 'diner_sofa_2*1', 's', 1, 1, 1, '0', '1', '0', 2804, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1212, 'Pink Diner Sofa 2', 'diner_sofa_2*2', 's', 1, 1, 1, '0', '1', '0', 2805, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1213, 'Black Diner Sofa 2', 'diner_sofa_2*3', 's', 1, 1, 1, '0', '1', '0', 2806, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1214, 'White Diner Sofa 2', 'diner_sofa_2*4', 's', 1, 1, 1, '0', '1', '0', 2807, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1215, 'Latte Diner Sofa 2', 'diner_sofa_2*5', 's', 1, 1, 1, '0', '1', '0', 2808, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1216, 'Blue Diner Sofa 2', 'diner_sofa_2*6', 's', 1, 1, 1, '0', '1', '0', 2809, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1217, 'Green Diner Sofa 2', 'diner_sofa_2*7', 's', 1, 1, 1, '0', '1', '0', 2810, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1218, 'Yellow Diner Sofa 2', 'diner_sofa_2*8', 's', 1, 1, 1, '0', '1', '0', 2811, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1219, 'Red Diner Sofa 2', 'diner_sofa_2*9', 's', 1, 1, 1, '0', '1', '0', 2812, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1220, 'Diner Shaker', 'diner_shaker', 's', 1, 1, 1, '0', '0', '0', 2814, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1221, 'Diner Floor', 'diner_rug', 's', 2, 2, 0, '1', '0', '1', 2803, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1222, 'Aqua Gumball Machine', 'diner_gumvendor*1', 's', 1, 1, 1, '0', '0', '0', 2827, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1223, 'Pink Gumball Machine', 'diner_gumvendor*2', 's', 1, 1, 1, '0', '0', '0', 2828, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1224, 'Black Gumball Machine', 'diner_gumvendor*3', 's', 1, 1, 1, '0', '0', '0', 2829, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1225, 'White Gumball Machine', 'diner_gumvendor*4', 's', 1, 1, 1, '0', '0', '0', 2830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1226, 'Latte Gumball Machine', 'diner_gumvendor*5', 's', 1, 1, 1, '0', '0', '0', 2831, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1227, 'Blue Gumball Machine', 'diner_gumvendor*6', 's', 1, 1, 1, '0', '0', '0', 2832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1228, 'Green Gumball Machine', 'diner_gumvendor*7', 's', 1, 1, 1, '0', '0', '0', 2833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1229, 'Yellow Gumball Machine', 'diner_gumvendor*8', 's', 1, 1, 1, '0', '0', '0', 2834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1230, 'Red Gumball Machine', 'diner_gumvendor*9', 's', 1, 1, 1, '0', '0', '0', 2835, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1231, 'Aqua Diner Till', 'diner_cashreg*1', 's', 1, 1, 1, '0', '0', '0', 2816, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1232, 'Pink Diner Till', 'diner_cashreg*2', 's', 1, 1, 1, '0', '0', '0', 2817, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1233, 'Black Diner Till', 'diner_cashreg*3', 's', 1, 1, 1, '0', '0', '0', 2818, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1234, 'White Diner Till', 'diner_cashreg*4', 's', 1, 1, 1, '0', '0', '0', 2819, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1235, 'Latte Diner Till', 'diner_cashreg*5', 's', 1, 1, 1, '0', '0', '0', 2820, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1236, 'Blue Diner Till', 'diner_cashreg*6', 's', 1, 1, 1, '0', '0', '0', 2821, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1237, 'Green Diner Till', 'diner_cashreg*7', 's', 1, 1, 1, '0', '0', '0', 2822, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1238, 'Yellow Diner Till', 'diner_cashreg*8', 's', 1, 1, 1, '0', '0', '0', 2823, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1239, 'Red Diner Till', 'diner_cashreg*9', 's', 1, 1, 1, '0', '0', '0', 2824, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1240, 'Aqua Diner Table', 'diner_table_2*1', 's', 3, 2, 1, '1', '0', '0', 2879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1241, 'Pink Diner Table', 'diner_table_2*2', 's', 3, 2, 1, '1', '0', '0', 2880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1242, 'Black Diner Table', 'diner_table_2*3', 's', 3, 2, 1, '1', '0', '0', 2881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1243, 'White Diner Table', 'diner_table_2*4', 's', 3, 2, 1, '1', '0', '0', 2882, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1244, 'Latte Diner Table', 'diner_table_2*5', 's', 3, 2, 1, '1', '0', '0', 2883, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1245, 'Blue Diner Table', 'diner_table_2*6', 's', 3, 2, 1, '1', '0', '0', 2884, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1246, 'Green Diner Table', 'diner_table_2*7', 's', 3, 2, 1, '1', '0', '0', 2885, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1247, 'Yellow Diner Table', 'diner_table_2*8', 's', 3, 2, 1, '1', '0', '0', 2886, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1248, 'Red Diner Table', 'diner_table_2*9', 's', 3, 2, 1, '1', '0', '0', 2887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1249, 'Aqua Diner Booth Table', 'diner_table_1*1', 's', 2, 2, 1, '1', '0', '0', 2897, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1250, 'Pink Diner Booth Table', 'diner_table_1*2', 's', 2, 2, 1, '1', '0', '0', 2898, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1251, 'Black Diner Booth Table', 'diner_table_1*3', 's', 2, 2, 1, '1', '0', '0', 2899, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1252, 'White Diner Booth Table', 'diner_table_1*4', 's', 2, 2, 1, '1', '0', '0', 2900, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1253, 'Latte Diner Booth Table', 'diner_table_1*5', 's', 2, 2, 1, '1', '0', '0', 2901, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1254, 'Blue Diner Booth Table', 'diner_table_1*6', 's', 2, 2, 1, '1', '0', '0', 2902, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1255, 'Green Diner Booth Table', 'diner_table_1*7', 's', 2, 2, 1, '1', '0', '0', 2903, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1256, 'Yellow Diner Booth Table', 'diner_table_1*8', 's', 2, 2, 1, '1', '0', '0', 2904, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1257, 'Red Diner Booth Table', 'diner_table_1*9', 's', 2, 2, 1, '1', '0', '0', 2905, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1258, 'Aqua Diner Sofa 1', 'diner_sofa_1*1', 's', 1, 1, 1, '0', '1', '0', 2888, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1259, 'Pink Diner Sofa 1', 'diner_sofa_1*2', 's', 1, 1, 1, '0', '1', '0', 2889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1260, 'Black Diner Sofa 1', 'diner_sofa_1*3', 's', 1, 1, 1, '0', '1', '0', 2890, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1261, 'White Diner Sofa 1', 'diner_sofa_1*4', 's', 1, 1, 1, '0', '1', '0', 2891, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1262, 'Latte Diner Sofa 1', 'diner_sofa_1*5', 's', 1, 1, 1, '0', '1', '0', 2892, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1263, 'Blue Diner Sofa 1', 'diner_sofa_1*6', 's', 1, 1, 1, '0', '1', '0', 2893, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1264, 'Green Diner Sofa 1', 'diner_sofa_1*7', 's', 1, 1, 1, '0', '1', '0', 2894, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1265, 'Yellow Diner Sofa 1', 'diner_sofa_1*8', 's', 1, 1, 1, '0', '1', '0', 2895, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1266, 'Red Diner Sofa 1', 'diner_sofa_1*9', 's', 1, 1, 1, '0', '1', '0', 2896, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1267, 'Aqua Diner Stool', 'diner_chair*1', 's', 1, 1, 1.4, '0', '1', '0', 2861, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1268, 'Pink Diner Stool', 'diner_chair*2', 's', 1, 1, 1.4, '0', '1', '0', 2862, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1269, 'Black Diner Stool', 'diner_chair*3', 's', 1, 1, 1.4, '0', '1', '0', 2863, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1270, 'White Diner Stool', 'diner_chair*4', 's', 1, 1, 1.4, '0', '1', '0', 2864, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1271, 'Latte Diner Stool', 'diner_chair*5', 's', 1, 1, 1.4, '0', '1', '0', 2865, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1272, 'Blue Diner Stool', 'diner_chair*6', 's', 1, 1, 1.4, '0', '1', '0', 2866, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1273, 'Green Diner Stool', 'diner_chair*7', 's', 1, 1, 1.4, '0', '1', '0', 2867, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1274, 'Yellow Diner Stool', 'diner_chair*8', 's', 1, 1, 1.4, '0', '1', '0', 2868, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1275, 'Red Diner Stool', 'diner_chair*9', 's', 1, 1, 1.4, '0', '1', '0', 2869, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1276, 'Aqua Diner Gate', 'diner_bardesk_gate*1', 's', 1, 1, 0.001, '0', '0', '0', 2842, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1277, 'Pink Diner Gate', 'diner_bardesk_gate*2', 's', 1, 1, 0.001, '0', '0', '0', 2843, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1278, 'Black Diner Gate', 'diner_bardesk_gate*3', 's', 1, 1, 0.001, '0', '0', '0', 2844, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1279, 'White Diner Gate', 'diner_bardesk_gate*4', 's', 1, 1, 0.001, '0', '0', '0', 2845, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1280, 'Latte Diner Gate', 'diner_bardesk_gate*5', 's', 1, 1, 0.001, '0', '0', '0', 2846, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1281, 'Blue Diner Gate', 'diner_bardesk_gate*6', 's', 1, 1, 0.001, '0', '0', '0', 2847, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1282, 'Green Diner Gate', 'diner_bardesk_gate*7', 's', 1, 1, 0.001, '0', '0', '0', 2848, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1283, 'Yellow Diner Gate', 'diner_bardesk_gate*8', 's', 1, 1, 0.001, '0', '0', '0', 2849, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1284, 'Red Diner Gate', 'diner_bardesk_gate*9', 's', 1, 1, 0.001, '0', '0', '0', 2850, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1285, 'Aqua Diner Corner', 'diner_bardesk_corner*1', 's', 1, 1, 1, '1', '0', '0', 2870, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1286, 'Pink Diner Corner', 'diner_bardesk_corner*2', 's', 1, 1, 1, '1', '0', '0', 2871, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1287, 'Black Diner Corner', 'diner_bardesk_corner*3', 's', 1, 1, 1, '1', '0', '0', 2872, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1288, 'Latte Diner Corner', 'diner_bardesk_corner*4', 's', 1, 1, 1, '1', '0', '0', 2873, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1289, 'Blue Diner Corner', 'diner_bardesk_corner*6', 's', 1, 1, 1, '1', '0', '0', 2875, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1290, 'Green Diner Corner', 'diner_bardesk_corner*7', 's', 1, 1, 1, '1', '0', '0', 2876, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1291, 'Yellow Diner Corner', 'diner_bardesk_corner*8', 's', 1, 1, 1, '1', '0', '0', 2877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1292, 'Red Diner Corner', 'diner_bardesk_corner*9', 's', 1, 1, 1, '1', '0', '0', 2878, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1293, 'Aqua Diner Bar', 'diner_bardesk*1', 's', 1, 1, 1, '1', '0', '0', 2851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1294, 'Pink Diner Bar', 'diner_bardesk*2', 's', 1, 1, 1, '1', '0', '0', 2852, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1295, 'Black Diner Bar', 'diner_bardesk*3', 's', 1, 1, 1, '1', '0', '0', 2853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1296, 'White Diner Bar', 'diner_bardesk*4', 's', 1, 1, 1, '1', '0', '0', 2854, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1297, 'Latte Diner Bar', 'diner_bardesk*5', 's', 1, 1, 1, '1', '0', '0', 2855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1298, 'Blue Diner Bar', 'diner_bardesk*6', 's', 1, 1, 1, '1', '0', '0', 2856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1299, 'Green Diner Bar', 'diner_bardesk*7', 's', 1, 1, 1, '1', '0', '0', 2857, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1300, 'Yellow Diner Bar', 'diner_bardesk*8', 's', 1, 1, 1, '1', '0', '0', 2858, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1301, 'Red Diner Bar', 'diner_bardesk*9', 's', 1, 1, 1, '1', '0', '0', 2859, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1302, 'ads_dave_cns', 'ads_dave_cns', 's', 1, 1, 1, '0', '0', '0', 2860, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1303, 'easy_carpet name', 'easy_carpet', 's', 4, 4, 0, '1', '0', '1', 2911, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1304, 'easy_bowl2', 'easy_bowl2', 's', 1, 1, 1, '1', '0', '0', 2907, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1305, 'Greek Corner', 'greek_corner', 's', 1, 1, 1, '0', '0', '0', 2910, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1306, 'Enter mortal', 'greek_gate', 's', 2, 1, 0.001, '0', '0', '0', 2908, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1307, 'Greek Pillars', 'greek_pillars', 's', 2, 1, 1, '0', '0', '0', 2909, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1308, 'Greek Seat', 'greek_seat', 's', 1, 1, 0.5, '0', '1', '0', 2906, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1309, 'Greek trophy', 'a0 greektrophy_g', 's', 1, 1, 1, '0', '0', '0', 2622, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1310, 'Greek trophy', 'a0 greektrophy_s', 's', 1, 1, 1, '0', '0', '0', 2623, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1311, 'Greek trophy', 'a0 greektrophy_b', 's', 1, 1, 1, '0', '0', '0', 2624, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1312, 'greek_block', 'greek_block', 's', 2, 1, 0.8, '0', '1', '0', 2915, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1313, 'Glass Table', 'hcc_table', 's', 1, 2, 1, '0', '0', '0', 2923, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1314, 'Bookshelf', 'hcc_shelf', 's', 1, 2, 1, '0', '0', '0', 2917, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1315, 'Low Back Sofa', 'hcc_sofa', 's', 2, 1, 1.2, '0', '1', '0', 2921, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1316, 'Cool look', 'hcc_minibar', 's', 1, 1, 1, '0', '0', '0', 2924, '1', '1', '1', '1', '1', 'vendingmachine', 0, '24', ''),
(1317, 'Trendy Stool', 'hcc_chair', 's', 1, 1, 1, '0', '1', '0', 2919, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1318, 'Crime scene', 'det_divider', 's', 2, 1, 1, '0', '0', '0', 2918, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1319, 'netari_carpet', 'netari_carpet', 's', 3, 5, 0, '1', '0', '1', 2916, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1320, 'Chalk Outline', 'det_body', 's', 2, 3, 0, '0', '0', '1', 2922, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1321, 'Antique Stool', 'hcc_stool', 's', 1, 1, 1.2, '0', '1', '0', 2920, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1322, 'Reclining Chair', 'hcc_sofachair', 's', 1, 1, 1.2, '0', '1', '0', 2925, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1323, 'Glass Corner', 'hcc_crnr', 's', 1, 1, 1, '0', '0', '0', 2926, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1324, 'Glass Divider', 'hcc_dvdr', 's', 2, 1, 1, '0', '0', '0', 2927, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1325, 'sob_carpet', 'sob_carpet', 's', 3, 5, 0, '1', '0', '1', 2928, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1326, 'My Hump', 'igor_seat', 's', 1, 1, 1, '0', '1', '0', 2929, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1327, 'The Brain', 'ads_igorbrain', 's', 1, 1, 1, '0', '0', '0', 2936, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1328, 'Igor Switch', 'ads_igorswitch', 's', 1, 1, 1, '0', '0', '0', 2934, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1329, 'ads_711', 'ads_711*1', 's', 1, 1, 1, '0', '0', '0', 2930, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1330, 'ads_711', 'ads_711*2', 's', 1, 1, 1, '0', '0', '0', 2931, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1331, 'ads_711', 'ads_711*3', 's', 1, 1, 1, '0', '0', '0', 2932, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1332, 'ads_711', 'ads_711*4', 's', 1, 1, 1, '0', '0', '0', 2933, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1333, 'Igor Ray Gun', 'ads_igorraygun', 's', 1, 2, 1, '0', '0', '0', 2935, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1334, 'Blood Sink', 'hween08_sink', 's', 1, 1, 1, '0', '0', '0', 2944, '1', '1', '1', '1', '1', 'vendingmachine', 0, '29', ''),
(1335, 'Hospital Curtain (blood)', 'hween08_curtain', 's', 3, 1, 1, '0', '0', '0', 2942, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1336, 'Blood Bath', 'hween08_bath', 's', 1, 2, 1, '0', '1', '0', 2948, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1337, 'Life Support (blood)', 'hween08_defibs', 's', 1, 1, 1, '0', '0', '0', 2938, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1338, 'Body Bag', 'hween08_bbag', 's', 1, 3, 1.3, '0', '0', '0', 2943, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1339, 'Hospital Curtain (ooze)', 'hween08_curtain2', 's', 3, 1, 1, '0', '0', '0', 2949, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1340, 'Life Support (ooze)', 'hween08_defibs2', 's', 1, 1, 1, '0', '0', '0', 2939, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1341, 'Hospital Bed (blood)', 'hween08_bed', 's', 1, 3, 2, '0', '0', '0', 2945, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1342, 'Ooze Sink', 'hween08_sink2', 's', 1, 1, 1, '0', '0', '0', 2940, '1', '1', '1', '1', '1', 'vendingmachine', 0, '30', ''),
(1343, 'Hospital Bed (ooze)', 'hween08_bed2', 's', 1, 3, 1, '0', '0', '0', 2937, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1344, 'Ooze Bath', 'hween08_bath2', 's', 1, 2, 1, '0', '1', '0', 2947, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1345, 'Manhole', 'hween08_manhole', 's', 1, 1, 1, '0', '0', '0', 2946, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1346, ' poke', 'hween08_trll', 's', 1, 1, 1, '0', '0', '0', 2941, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1347, 'Glass High Bar Table', 'party_table', 's', 1, 1, 1, '1', '0', '0', 2956, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1348, 'Spotlight', 'party_discol', 's', 1, 1, 1, '0', '0', '0', 2963, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1349, 'Stage Block Large', 'party_block2', 's', 2, 2, 0.7, '1', '0', '1', 2950, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1350, 'Bar Corner', 'party_barcorn', 's', 1, 1, 1, '1', '0', '0', 2957, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1351, 'High Class Bar Stool', 'party_chair', 's', 1, 1, 1.3, '0', '1', '0', 2960, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1352, 'Small Stage', 'party_block', 's', 1, 1, 0.9, '1', '0', '1', 2959, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1353, 'Dance Floor Laser', 'party_ravel', 's', 1, 1, 1, '0', '0', '0', 2965, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1354, 'Despite being made a lava', 'party_tube_lava', 's', 1, 1, 1, '0', '0', '0', 2966, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1355, 'Club Tray', 'party_tray', 's', 1, 1, 1, '0', '0', '0', 2955, '1', '1', '1', '1', '1', 'vendingmachine', 0, '31', ''),
(1356, 'Scratch it', 'party_djtable', 's', 1, 2, 1, '0', '0', '0', 2954, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1357, 'Disco Floor', 'party_floor', 's', 2, 2, 0, '1', '0', '1', 2958, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1358, 'Glitter Ball', 'party_ball', 's', 1, 1, 0, '0', '0', '1', 2964, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1359, 'Bubbles Machine', 'party_tube_bubble', 's', 1, 1, 1, '0', '0', '0', 2951, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1360, ' MC', 'party_mic', 's', 1, 1, 1, '0', '0', '0', 2953, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1361, 'Dance Floor Beamer', 'party_beamer', 's', 1, 1, 1, '0', '0', '0', 2961, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(1362, 'Bar Centre', 'party_bardesk', 's', 1, 1, 1, '1', '0', '0', 2962, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1363, 'Club seat', 'party_seat', 's', 1, 1, 1.1, '0', '1', '0', 2952, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1364, 'Snow Seat', 'xmas08_snowpl', 's', 1, 1, 1, '0', '1', '1', 3005, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1365, 'Emperor Penguin', 'penguin_basic', 's', 1, 1, 1, '0', '0', '0', 2977, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1366, 'Arctic Penguin Trophy', 'xmas08_trph1', 's', 1, 1, 1, '0', '0', '0', 2972, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1367, 'Musketeer Penguin', 'penguin_musketeer', 's', 1, 1, 1, '0', '0', '0', 2995, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1368, 'Icy table', 'xmas08_table', 's', 2, 2, 1, '1', '0', '0', 3009, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1369, 'Hot Tub', 'xmas08_hottub', 's', 2, 2, 1, '0', '0', '0', 2986, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1370, 'Luchador Penguin', 'penguin_wrestler', 's', 1, 1, 1, '0', '0', '0', 2990, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1371, 'Blow it up', 'fx_explosion', 's', 1, 1, 1, '0', '0', '0', 3011, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(1372, 'Robot Penguin', 'penguin_robot', 's', 1, 1, 1, '0', '0', '0', 2969, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1373, 'Icy Christmas Tree', 'xmas08_icetree', 's', 1, 1, 1, '0', '0', '0', 2967, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1374, 'Camp fire', 'campfire', 's', 1, 1, 1, '1', '0', '0', 2974, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1375, 'Ice', 'xmas08_icerug', 's', 2, 2, 0, '1', '0', '1', 3002, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1376, 'Executive Penguin', 'penguin_suit', 's', 1, 1, 1, '0', '0', '0', 3008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1377, 'December 2008', 'svnr_fi', 's', 1, 1, 1, '0', '0', '0', 2991, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1378, 'Snow Storm', 'xmas_snow', 's', 2, 2, 0, '1', '0', '1', 2982, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1379, 'Hockey Penguin', 'penguin_icehockey', 's', 1, 1, 1, '0', '0', '0', 2988, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1380, 'Pilot Penguin', 'penguin_pilot', 's', 1, 1, 1, '0', '0', '0', 3007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1381, 'Ballerina Penguin', 'penguin_ballet', 's', 1, 1, 1, '0', '0', '0', 2996, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1382, 'Arctic SFX', 'sound_set_71', 's', 1, 1, 0.2, '1', '0', '0', 3000, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1383, 'Boxer Penguin', 'penguin_boxer', 's', 1, 1, 1, '0', '0', '0', 2979, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1384, 'Fluorescent Penguin', 'penguin_glow', 's', 1, 1, 1, '0', '0', '0', 2993, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1385, 'Summer Penguin', 'penguin_swim', 's', 1, 1, 1, '0', '0', '0', 2984, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1386, 'Sumo Penguin', 'penguin_sumo', 's', 1, 1, 1, '0', '0', '0', 2994, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1387, 'Bubbles', 'xmas08_geysir', 's', 2, 2, 1, '0', '0', '0', 2985, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1388, 'Clown Penguin', 'penguin_clown', 's', 1, 1, 1, '0', '0', '0', 2989, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1389, 'Infected Penguin', 'penguin_infected', 's', 1, 1, 1, '0', '0', '0', 2983, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1390, 'Firestarter', 'fx_flare', 's', 1, 1, 1, '1', '0', '0', 3013, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(1391, 'Snowball Lantern Pile', 'xmas08_lantern', 's', 1, 1, 1, '0', '0', '0', 2968, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1392, 'Ice chair', 'xmas08_chair', 's', 1, 1, 1, '0', '1', '0', 3001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1393, 'Superhero Penguin', 'penguin_super', 's', 1, 1, 1, '0', '0', '0', 2998, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1394, 'Icy Teleport', 'xmas08_telep', 's', 1, 1, 0.001, '0', '0', '0', 2978, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1395, 'Cube Tree', 'xmas08_cubetree', 's', 1, 1, 1, '0', '0', '0', 3006, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1396, 'Disco Penguin', 'penguin_rock', 's', 1, 1, 1, '0', '0', '0', 3010, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1397, 'Ice divider', 'xmas08_dvdr1', 's', 2, 1, 1, '0', '0', '0', 2992, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1398, 'Ice Fish Hole', 'xmas08_hole', 's', 1, 1, 1, '0', '0', '0', 2980, '1', '1', '1', '1', '1', 'vendingmachine', 0, '34', ''),
(1399, 'XC Penguin', 'penguin_ski', 's', 1, 1, 1, '0', '0', '0', 2981, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1400, 'Skater Penguin', 'penguin_skater', 's', 1, 1, 1, '0', '0', '0', 2973, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1401, 'Icy Divider Corner', 'xmas08_dvdr2', 's', 1, 1, 1, '0', '0', '0', 2970, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1402, 'Christmas Penguin', 'penguin_elf', 's', 1, 1, 1, '0', '0', '0', 2971, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1403, 'Bunny Penguin', 'penguin_bunny', 's', 1, 1, 1, '0', '0', '0', 2975, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1404, 'Ninja Penguin', 'penguin_ninja', 's', 1, 1, 1, '0', '0', '0', 2976, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1405, 'Magic Penguin', 'penguin_magician', 's', 1, 1, 1, '0', '0', '0', 2997, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1406, 'Beautiful Penguin', 'penguin_hunchback', 's', 1, 1, 1, '0', '0', '0', 3003, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1407, 'Cowboy Penguin', 'penguin_cowboy', 's', 1, 1, 1, '0', '0', '0', 2987, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1408, 'Punk Penguin', 'penguin_punk', 's', 1, 1, 1, '0', '0', '0', 3004, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1409, 'Pirate Penguin', 'penguin_pirate', 's', 1, 1, 1, '0', '0', '0', 2999, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1410, 'ads_ob_pillow name', 'ads_ob_pillow', 's', 1, 1, 1, '0', '1', '0', 3018, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1411, 'Leviathon', 'lostc_merdragon', 's', 1, 3, 1, '0', '0', '0', 3016, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1412, 'Idea Agency Desk', 'ads_cldesk', 's', 2, 2, 1, '0', '0', '0', 3017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1413, 'Eco Friendly Penguin', 'xmas08_trph2', 's', 1, 1, 1, '0', '0', '0', 3015, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1414, 'Whatever your Idea', 'ads_cltele', 's', 1, 1, 0.001, '0', '0', '0', 3014, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1415, 'Childline Rug', 'ads_clfloor', 's', 3, 5, 0, '1', '0', '1', 3019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1417, 'Mall tele-door', 'ads_mall_tele', 's', 1, 1, 0.001, '1', '0', '1', 3020, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1418, 'Moongate', 'china_moongt', 's', 1, 3, 0.001, '0', '0', '1', 3024, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1419, 'Lotus Pool', 'bolly_lotus_pool', 's', 2, 2, 0, '0', '0', '0', 3022, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1420, 'Ox Statue', 'china_ox', 's', 1, 1, 1, '0', '0', '0', 3025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1422, 'Petal Flurry', 'bolly_petals', 's', 2, 2, 0, '1', '0', '1', 3026, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1423, 'Palm Tree', 'bolly_tree', 's', 1, 1, 1, '0', '0', '0', 3042, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1424, 'Swing low', 'bolly_swing', 's', 2, 1, 1.5, '0', '1', '0', 3037, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1425, 'Star Pillow', 'bolly_pillow', 's', 1, 1, 0.8, '0', '1', '0', 3030, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1426, 'Bollywood Corner', 'bolly_corner', 's', 1, 1, 1, '1', '0', '0', 3031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1427, 'Elephant MiniBar', 'bolly_phant', 's', 1, 1, 1, '0', '0', '0', 3033, '1', '1', '1', '1', '1', 'vendingmachine', 0, '35', ''),
(1428, 'Monkey Lamp', 'bolly_monkey_lamp', 's', 1, 1, 1, '0', '0', '0', 3036, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1429, 'Green Curtain', 'bolly_drapeb', 's', 3, 1, 0.001, '0', '0', '0', 3040, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1430, 'Planet of Love', 'planet_of_love', 's', 1, 1, 1, '1', '0', '0', 3044, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1431, 'Chandelier', 'bolly_lamp', 's', 1, 1, 1, '0', '0', '0', 3041, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1432, 'Bollywood Desk', 'bolly_desk', 's', 2, 1, 1, '1', '0', '0', 3034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1433, 'Vase of Flowers', 'bolly_vase', 's', 1, 1, 1, '0', '0', '0', 3043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1434, 'Standard Tile', 'bolly_tile2', 's', 2, 2, 0, '1', '0', '1', 3027, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1435, 'Large Ornamental Table', 'bolly_table', 's', 2, 2, 1, '1', '0', '0', 3035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1436, 'Yellow Curtain', 'bolly_drapec', 's', 3, 1, 0.001, '0', '0', '0', 3032, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1437, 'Extravagant Fountain', 'bolly_fountain', 's', 2, 2, 1, '0', '0', '0', 3029, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20046, 'Executive Teleport', 'exe_elevator', 's', 1, 1, 0.001, '0', '0', '0', 3305, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1439, 'Ornamental Tile', 'bolly_tile1', 's', 2, 2, 0, '1', '0', '1', 3028, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1440, 'Pink Curtain', 'bolly_drapea', 's', 3, 1, 0.001, '0', '0', '0', 3038, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1441, 'ads_idol_floor1 name', 'ads_idol_floor1', 's', 2, 2, 0, '1', '0', '1', 3045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1442, 'Inventor''s Desk', 'ads_igor_dsk', 's', 2, 1, 1, '0', '0', '0', 3049, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1443, 'ads_idol_desk', 'ads_idol_desk', 's', 1, 4, 1, '0', '0', '0', 3050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1444, 'ads_idol_ch', 'ads_idol_ch', 's', 1, 1, 1.2, '0', '1', '0', 3051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1445, 'Glass Flask', 'ads_igor_flask', 's', 1, 1, 1, '0', '0', '0', 3046, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1446, 'ads_idol_drape name', 'ads_idol_drape', 's', 3, 1, 0.001, '0', '0', '0', 3048, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1447, 'ads_idol_floor2 name', 'ads_idol_floor2', 's', 2, 2, 0, '1', '0', '1', 3047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1448, 'Kraken', 'lostc_octopus', 's', 1, 2, 1, '0', '0', '0', 3052, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1449, 'Marble Floor Tile', 'lc_tile1', 's', 2, 2, 0, '1', '0', '1', 3076, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1450, 'Small Jellyfish Lamp', 'lc_medusa2', 's', 1, 1, 1, '0', '0', '0', 3073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1451, 'Sally Lightfoot', 'lc_crab2', 's', 1, 1, 1, '0', '0', '0', 3068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1452, 'March Collectable 2009', 'lostc_teleport', 's', 1, 1, 0.001, '0', '0', '1', 3071, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1453, 'ads_idol_piano name', 'ads_idol_piano', 's', 2, 2, 1, '0', '0', '0', 3058, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1454, 'Large Coral Divider', 'lc_coral_divider_hi', 's', 2, 1, 1, '0', '0', '0', 3078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1455, 'ads_711shelf name', 'ads_711shelf', 's', 1, 2, 1, '0', '0', '0', 3066, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1456, 'Water Tube Corner', 'lc_tubes_corners', 's', 1, 1, 1, '0', '0', '0', 3072, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1457, 'Captain''s Table', 'lc_table', 's', 2, 2, 1, '1', '0', '0', 3067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1458, 'Cobbled Stones', 'lc_tile2', 's', 2, 2, 0, '1', '0', '1', 3069, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1459, 'Anemone', 'lc_anemone', 's', 1, 1, 1, '0', '0', '0', 3074, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1460, 'Small Coral Divider', 'lc_coral_divider_low', 's', 2, 1, 1, '0', '0', '0', 3077, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1461, 'Ocean Window Rug', 'lc_glass_floor', 's', 2, 3, 0, '1', '0', '1', 3060, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1462, 'Large Jellyfish Lamp', 'lc_medusa1', 's', 1, 1, 1, '0', '0', '0', 3064, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1463, 'Crab Patch', 'lc_crab1', 's', 2, 2, 1, '0', '0', '0', 3062, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1464, 'ads_idol_jukebox name', 'ads_idol_jukebox*1', 's', 1, 1, 1, '0', '0', '0', 3059, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1465, 'ads_idol_pchair name', 'ads_idol_pchair', 's', 1, 1, 1, '0', '1', '0', 3056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1466, 'Water Tube Straight', 'lc_tubes_straight', 's', 1, 1, 1, '0', '0', '0', 3065, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1467, 'ads_idol_audChr name', 'ads_idol_audChr', 's', 1, 1, 1, '0', '1', '0', 3057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1468, 'ads_idol_trax name', 'ads_idol_trax', 's', 1, 1, 1, '0', '0', '0', 3055, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1469, 'ads_idol_tele', 'ads_idol_tele', 's', 1, 1, 0.001, '0', '0', '1', 3053, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1470, 'Wooden Corner', 'lc_corner', 's', 1, 1, 1, '1', '0', '0', 3075, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1471, 'Wooden Stool', 'lc_stool', 's', 1, 1, 1, '0', '1', '0', 3063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1472, 'No rusty nails', 'lc_chair', 's', 1, 1, 1, '0', '1', '0', 3061, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1473, 'Wooden Bar Desk', 'lc_desk', 's', 2, 1, 1, '1', '0', '0', 3070, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1474, 'ads_idol_mic name', 'ads_idol_mic', 's', 1, 1, 1, '0', '0', '0', 3054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1475, 'ads_idol_hotspot name', 'ads_idol_hotspot', 's', 1, 1, 0.2, '0', '0', '1', 3080, '1', '1', '1', '1', '1', 'default', 103, '0', ''),
(1476, 'ads_idol_clRack name', 'ads_idol_clRack', 's', 3, 1, 1, '0', '0', '0', 3079, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1477, 'ads_idol_voting_ch name', 'ads_idol_voting_ch', 's', 1, 1, 1.2, '0', '1', '0', 3081, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1478, 'Ecotron prize', 'ecotron_box', 's', 1, 1, 1, '1', '0', '0', 3095, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1479, 'Eco Light 2', 'eco_light2', 's', 1, 1, 1, '1', '0', '0', 3082, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1480, 'Eco Stool 3', 'eco_chair3', 's', 1, 1, 1, '0', '1', '0', 3094, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1481, 'Eco Coffee Table 3', 'eco_table3', 's', 2, 2, 1, '1', '0', '0', 3086, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1482, 'Eco Lamp 2', 'eco_lamp2', 's', 1, 1, 1, '1', '0', '0', 3092, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1483, 'Eco Armchair 3', 'eco_sofa3', 's', 1, 1, 1, '0', '1', '0', 3088, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1484, 'Eco Coffee Table 2', 'eco_table2', 's', 2, 2, 1, '1', '0', '0', 3089, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1485, 'Fruit Bowl 2', 'eco_fruits2', 's', 1, 1, 1, '1', '0', '0', 3102, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1486, 'Eco Armchair 1', 'eco_sofa1', 's', 1, 1, 1, '0', '1', '0', 3096, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1487, 'Fruit Bowl 3', 'eco_fruits3', 's', 1, 1, 1, '1', '0', '0', 3104, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1488, 'Eco Light 1', 'eco_light1', 's', 1, 1, 1, '1', '0', '0', 3098, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1489, 'Actually', 'eco_tree1', 's', 1, 1, 1, '0', '0', '0', 3093, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1490, 'Potted Cactus 2', 'eco_cactus2', 's', 1, 1, 1, '1', '0', '0', 3105, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1491, 'Talk To FRANK Brain Lamp', 'ads_frankb', 's', 1, 1, 1, '0', '0', '0', 3111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1492, 'Road Signs', 'bump_signs', 's', 1, 1, 1, '0', '0', '0', 3090, '1', '1', '1', '0', '1', 'default', 7, '0', ''),
(1493, 'Potted Cactus 1', 'eco_cactus1', 's', 1, 1, 1, '1', '0', '0', 3083, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1494, 'Eco Stool 2', 'eco_chair2', 's', 1, 1, 1, '0', '1', '0', 3106, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1495, 'Potted Cactus 3', 'eco_cactus3', 's', 1, 1, 1, '1', '0', '0', 3085, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1496, 'Bumper Tyres', 'bump_tires', 's', 1, 1, 0.8, '1', '0', '0', 3101, '1', '1', '1', '0', '1', 'default', 3, '0', ''),
(1497, 'Traffic Lights', 'bump_lights', 's', 1, 1, 1, '0', '0', '0', 3103, '1', '1', '1', '0', '1', 'default', 3, '0', ''),
(1498, 'Eco Lamp 3', 'eco_lamp3', 's', 1, 1, 1, '1', '0', '0', 3091, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1499, 'Eco Coffee Table 1', 'eco_table1', 's', 2, 2, 1, '1', '0', '0', 3099, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1500, 'Eco Stool 1', 'eco_chair1', 's', 1, 1, 1, '0', '1', '0', 3084, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1501, 'Eco Armchair 2', 'eco_sofa2', 's', 1, 1, 1, '0', '1', '0', 3100, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1502, 'Road', 'bump_road', 's', 2, 2, 0, '1', '0', '1', 3110, '1', '1', '1', '0', '1', 'default', 4, '0', ''),
(1503, 'Fruit Bowl 1', 'eco_fruits1', 's', 1, 1, 1, '1', '0', '0', 3107, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1504, 'Eco Lamp 1', 'eco_lamp1', 's', 1, 1, 1, '1', '0', '0', 3097, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1505, 'Eco Light 3', 'eco_light3', 's', 1, 1, 1, '1', '0', '0', 3108, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1506, 'Pear Tree', 'eco_tree2', 's', 1, 1, 1, '0', '0', '0', 3109, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1507, 'Totem Leg', 'totem_leg', 's', 1, 1, 1.2, '1', '0', '0', 3113, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(1508, 'ads_grefusa_cactus name', 'ads_grefusa_cactus', 's', 1, 1, 1, '0', '0', '0', 3112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1509, 'ads_idol_tube name', 'ads_idol_tube', 's', 1, 1, 1, '0', '0', '0', 3126, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1510, 'Executive Light', 'exe_light', 's', 1, 1, 0, '1', '0', '1', 3122, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1511, 'ads_idol_cork name', 'ads_idol_cork', 's', 3, 1, 1, '0', '0', '0', 3120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1512, 'Idea Agency Jukebox', 'ads_cl_jukeb', 's', 1, 1, 1, '0', '0', '0', 3127, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1513, 'Grass patch', 'env_grass', 's', 2, 2, 0, '1', '0', '1', 3129, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1514, 'Forest Trunk Seat', 'env_tree3', 's', 1, 1, 1, '0', '0', '0', 3125, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1515, 'Eco Hedgerow', 'env_bushes', 's', 1, 2, 1, '0', '0', '0', 3115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1516, 'Eco Hedgerows Gate', 'env_bushes_gate', 's', 1, 2, 0.001, '0', '0', '0', 3128, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1517, 'Executive Gate', 'exe_gate', 's', 1, 1, 0.001, '0', '0', '0', 3119, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1518, 'ads_idol_newsDsk name', 'ads_idol_newsDsk', 's', 2, 2, 1, '0', '0', '0', 3116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1519, 'Forest Tree Chair', 'env_tree1', 's', 1, 1, 1, '0', '1', '0', 3117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1520, 'Forest Tree Americana', 'env_tree2', 's', 1, 1, 1, '0', '1', '0', 3123, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1521, 'Cubist Light', 'exe_cubelight', 's', 1, 1, 1, '0', '0', '0', 3121, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1522, 'The Four Seasons Tree', 'env_tree4', 's', 2, 2, 1, '0', '0', '0', 3118, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1523, 'Sphere Lamp', 'exe_artlamp', 's', 1, 1, 1, '0', '0', '0', 3114, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1524, 'ads_idol_ichair name', 'ads_idol_ichair', 's', 1, 1, 1.4, '0', '1', '0', 3124, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1525, 'Wedding Cake', 'tray_cake', 's', 1, 1, 1, '0', '0', '0', 3133, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1526, 'ads_reebok_block2', 'ads_reebok_block2', 's', 2, 2, 0.8, '1', '0', '1', 3132, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1527, 'ads_malaco_rug_name', 'ads_malaco_rug', 's', 3, 3, 0, '1', '0', '1', 3135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1528, 'Champagne Bucket', 'tray_champagne', 's', 1, 1, 1, '0', '0', '0', 3134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1529, 'Champagne Tower', 'tray_glasstower', 's', 1, 1, 1, '0', '0', '0', 3130, '1', '1', '1', '1', '1', 'vendingmachine', 0, '40', ''),
(1530, 'ads_malaco_gu', 'ads_malaco_gu', 's', 1, 1, 1, '0', '0', '0', 3131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1531, 'Idea Agency Super Cake', 'ads_clcake', 's', 1, 1, 1, '0', '0', '0', 3139, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1532, 'Idea Agency Sofa', 'ads_cl_sofa', 's', 2, 1, 1, '0', '1', '0', 3137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1533, 'Function Table', 'ads_idol_tblCloth', 's', 2, 2, 1, '1', '0', '0', 3136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1534, 'ads_idol_carpet name', 'ads_idol_carpet', 's', 2, 7, 0, '0', '0', '1', 3140, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1535, 'Function Lamp', 'ads_idol_lamp', 's', 1, 1, 0, '1', '0', '1', 3138, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1536, 'Rain Shower', 'country_rain', 's', 1, 1, 0, '1', '0', '1', 3153, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1537, 'Scarecrow', 'country_scarecrow', 's', 1, 1, 1, '0', '0', '0', 3160, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1538, 'Porta-House', 'env_telep', 's', 1, 1, 0.001, '0', '0', '0', 3161, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1539, 'Crop Field', 'country_soil', 's', 2, 2, 0, '1', '0', '1', 3145, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1540, 'Field Grass', 'country_grass', 's', 2, 2, 0, '1', '0', '1', 3162, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1541, 'The Golden Tablet', 'ads_goldtabl', 's', 1, 1, 1, '0', '0', '0', 3151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1542, 'Witch Mushroom', 'eco_mush1', 's', 1, 1, 1, '1', '0', '0', 3142, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1543, 'Tractor', 'country_trctr', 's', 2, 2, 1, '0', '0', '0', 3147, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1544, 'Stone Wall', 'country_fnc2', 's', 2, 1, 1, '0', '0', '0', 3141, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1545, 'Stick Fence', 'country_fnc1', 's', 2, 1, 1, '0', '0', '0', 3154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1546, 'Wishing Well', 'country_well', 's', 1, 1, 1, '0', '0', '0', 3149, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1547, 'Fairy Mushroom', 'eco_mush2', 's', 1, 1, 1, '1', '0', '0', 3155, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1548, 'Rainbow', 'country_rbw', 's', 1, 1, 1, '0', '0', '0', 3143, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1549, 'Golden Wheat', 'country_wheat', 's', 2, 2, 1, '0', '0', '0', 3163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1550, 'Farm Gate', 'country_gate', 's', 2, 1, 0.001, '0', '0', '0', 3150, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1551, 'Country Trax', 'sound_set_72', 's', 1, 1, 0.2, '1', '0', '0', 3144, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1552, 'Wooden Stage', 'country_stage', 's', 2, 2, 1, '1', '0', '1', 3148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1553, 'ads_calip_cola_1 name', 'ads_calip_cola*1', 's', 1, 1, 1, '0', '0', '0', 3156, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1554, 'ads_calip_cola_2 name', 'ads_calip_cola*2', 's', 1, 1, 1, '0', '0', '0', 3157, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1555, 'ads_calip_cola_3 name', 'ads_calip_cola*3', 's', 1, 1, 1, '0', '0', '0', 3158, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1556, 'ads_calip_cola_4 name', 'ads_calip_cola*4', 's', 1, 1, 1, '0', '0', '0', 3159, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1557, 'Log Bench', 'country_log', 's', 2, 1, 1, '0', '1', '0', 3146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1558, 'Stone Pile', 'country_fnc3', 's', 1, 1, 1, '0', '0', '0', 3152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1559, 'Wooden Patio Tile', 'country_patio', 's', 1, 1, 1, '0', '0', '0', 3166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1560, 'Country Ditch Corner', 'country_corner', 's', 1, 1, 1, '0', '0', '0', 3164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1561, 'Country Ditch', 'country_ditch', 's', 1, 2, 0.001, '0', '0', '0', 3165, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1562, 'ads_calip_chair name', 'ads_calip_chair', 's', 1, 1, 1, '0', '1', '0', 3168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1563, 'ads_idol_trophy name', 'ads_idol_trophy', 's', 1, 1, 1, '0', '0', '0', 3169, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1564, 'Totem Spirit Head', 'totem_head', 's', 1, 1, 1.7, '1', '0', '0', 3167, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1565, 'ads_calip_pool name', 'ads_calip_pool', 's', 2, 2, 0, '0', '0', '1', 3182, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1566, 'laptopdesk name', 'laptopdesk', 's', 2, 2, 1, '0', '0', '0', 3173, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1567, 'Skull', 'LT_skull', 's', 1, 1, 1, '0', '0', '0', 3189, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1568, 'Large Tribal Block', 'lt_stage2', 's', 2, 2, 0.9, '0', '0', '1', 3175, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1569, 'Lava Corner', 'lt_lavac', 's', 1, 1, 1, '0', '0', '0', 3180, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1570, 'Tribal Gate', 'lt_gate', 's', 2, 1, 0.001, '0', '0', '0', 3172, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1571, 'Planet of Eternity', 'saturn', 's', 1, 1, 1, '1', '0', '0', 3181, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1572, 'ads_calip_tele name', 'ads_calip_tele', 's', 1, 1, 0.001, '0', '0', '0', 3190, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1573, 'Stone Statue', 'lt_statue', 's', 1, 1, 1, '0', '0', '0', 3185, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1574, 'Tarantula', 'lt_spider', 's', 1, 1, 1, '0', '0', '0', 3178, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1575, 'Tribal Stone Wall', 'lt_stone2', 's', 2, 1, 1, '1', '0', '0', 3177, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1576, 'Tribal Seat', 'LT_throne', 's', 1, 1, 1.5, '0', '1', '0', 3171, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1577, 'audChr name', 'audChr', 's', 1, 1, 1, '0', '1', '0', 3179, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1578, 'Moss Patch', 'lt_patch', 's', 2, 2, 0, '1', '0', '1', 3188, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1579, 'Lava Ditch', 'lt_lava', 's', 1, 2, 1, '0', '0', '0', 3176, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1580, 'Small Tribal Torch', 'LT_pillar2', 's', 1, 1, 1, '0', '0', '0', 3170, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1581, 'Ant Hill', 'lt_bughill', 's', 1, 1, 1, '0', '0', '0', 3174, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1582, 'noticeboard name', 'noticeboard', 's', 3, 1, 1, '0', '0', '0', 3186, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1583, 'clrack name', 'clrack', 's', 3, 1, 0, '1', '0', '0', 3184, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1584, 'Large Tribal Torch', 'LT_pillar', 's', 1, 1, 1, '0', '0', '0', 3187, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1585, 'ads_calip_parasol name', 'lt_stage1', 's', 1, 1, 0.9, '0', '0', '1', 3183, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1586, 'transparent_floor name', 'transparent_floor', 's', 2, 2, 0, '1', '0', '1', 3199, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1587, 'ads_calip_lava name', 'ads_calip_lava', 's', 1, 1, 1, '0', '0', '0', 3197, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1588, 'Tribal Stone Corner', 'lt_stone1', 's', 1, 1, 1, '1', '0', '0', 3196, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1589, 'ads_calip_fan', 'ads_calip_fan', 's', 1, 1, 1, '0', '0', '0', 3198, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1590, 'voting_ch name', 'voting_ch', 's', 1, 1, 1.3, '0', '1', '0', 3201, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1591, 'Quick Coffee Stop', 'ads_mall_coffeem', 's', 1, 1, 1, '0', '0', '0', 3202, '1', '1', '1', '1', '1', 'vendingmachine', 0, '41', ''),
(1592, 'Totem Planet', 'totem_planet', 's', 1, 1, 1, '0', '0', '0', 3200, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1593, 'Don''t worry', 'SF_reactor', 's', 1, 1, 1, '1', '0', '0', 3212, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1594, 'Pack all you want', 'SF_crate_2', 's', 2, 1, 1, '1', '0', '0', 3204, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1595, 'Space Crew Chair', 'SF_chair_blue', 's', 1, 1, 1.2, '0', '1', '0', 3207, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1596, 'Cryogenic Bed', 'sf_pod', 's', 1, 3, 1.36, '0', '0', '0', 3219, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(1597, 'Command Console', 'SF_panel1', 's', 1, 1, 1, '0', '0', '0', 3217, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1598, 'Starship Table', 'SF_table', 's', 2, 2, 1, '1', '0', '0', 3220, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1599, 'Welcome aboard', 'SF_chair_green', 's', 1, 1, 1.2, '0', '1', '0', 3215, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1600, 'Small Crate', 'SF_crate_1', 's', 1, 1, 1, '1', '0', '0', 3205, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1601, 'Alien Lifeform', 'SF_alien', 's', 1, 1, 1, '0', '0', '0', 3210, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1602, 'Engineering Console', 'SF_panel2', 's', 2, 1, 1, '0', '0', '0', 3218, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1603, 'Display Gate', 'sf_gate', 's', 2, 1, 0.001, '0', '0', '0', 3221, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1604, 'Navigation Panel', 'SF_panel3', 's', 1, 1, 1, '0', '0', '0', 3208, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1605, 'Starship Floor 2', 'SF_floor_2', 's', 2, 2, 0, '1', '0', '1', 3211, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1606, 'Sci Fi Lamp', 'SF_lamp', 's', 1, 1, 1, '0', '0', '0', 3224, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1607, 'Captain''s Chair', 'SF_chair_red', 's', 1, 1, 1.2, '0', '1', '0', 3223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1608, 'Transparent Floor', 'sf_floor', 's', 2, 4, 0, '1', '0', '1', 3213, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1609, 'Starship Roof', 'sf_roof', 's', 2, 4, 0, '1', '0', '1', 3203, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1610, 'Light Pole', 'sf_stick', 's', 1, 1, 1, '0', '0', '0', 3206, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1611, 'Starship Floor 1', 'SF_floor_1', 's', 2, 2, 0, '1', '0', '1', 3222, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1612, ' sweets', 'ads_mall_kiosk', 's', 1, 2, 1, '0', '0', '0', 3216, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1613, 'Futuristic Teleport', 'sf_tele', 's', 1, 1, 0.001, '0', '0', '0', 3214, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1614, 'Sci Fi Roller', 'sf_roller', 's', 1, 1, 0.5, '1', '0', '1', 3209, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(1615, 'Hot Trophy', 'prizetrophy_hot', 's', 1, 1, 1, '0', '0', '0', 3229, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1616, 'Pink Inflatable Raft', 'summer_raft1', 's', 1, 1, 1, '0', '1', '0', 3228, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1617, 'Cool Trophy', 'prizetrophy_cool', 's', 1, 1, 1, '0', '0', '0', 3225, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1618, 'Blue Inflatable Raft', 'summer_raft2', 's', 1, 1, 1, '0', '1', '0', 3227, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1619, 'ads_elisa_gnome name', 'ads_elisa_gnome', 's', 1, 1, 1, '0', '0', '0', 3226, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1620, 'Summer Cool Box', 'summer_icebox', 's', 1, 1, 1, '0', '0', '0', 3231, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1621, 'ads_oc_soda', 'ads_oc_soda', 's', 1, 1, 1, '0', '0', '0', 3230, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1622, 'Mars Patch', 'marsrug', 's', 2, 2, 0, '1', '0', '1', 3232, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1623, 'White Candle', 'rela_candle1', 's', 1, 1, 1, '0', '0', '0', 3238, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20066, 'Dead Tree', 'tree2', 's', 1, 1, 1, '0', '0', '0', 2104, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1625, 'Red Candles', 'rela_candles2', 's', 1, 1, 1, '0', '0', '0', 3245, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1626, 'Stones', 'rela_stone', 's', 1, 1, 0.5, '0', '0', '1', 3233, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1627, 'Wicker Chair', 'rela_hchair', 's', 1, 1, 1.3, '0', '1', '0', 3247, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1628, 'Red Candle', 'rela_candle2', 's', 1, 1, 1, '0', '0', '0', 3244, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1629, 'ads_711', 'ads_711*5', 's', 1, 1, 1, '0', '0', '0', 3241, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1630, 'ads_711', 'ads_711*6', 's', 1, 1, 1, '0', '0', '0', 3242, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1631, 'ads_711', 'ads_711*7', 's', 1, 1, 1, '0', '0', '0', 3243, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1632, 'Purple Candle', 'rela_candle3', 's', 1, 1, 1, '0', '0', '0', 3235, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1633, 'Asteroid', 'pix_asteroid', 's', 1, 1, 1, '1', '0', '0', 3237, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1634, 'Bushy Houseplant', 'rela_plant', 's', 1, 1, 1, '0', '0', '0', 3246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1635, 'White Candles', 'rela_candles1', 's', 1, 1, 1, '0', '0', '0', 3234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1636, 'Purple Candles', 'rela_candles3', 's', 1, 1, 1, '0', '0', '0', 3236, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1637, 'Orchid', 'rela_orchid', 's', 1, 1, 1, '0', '0', '0', 3239, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1638, 'Rocks', 'rela_rock', 's', 1, 1, 0.8, '0', '1', '0', 3248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1639, 'ktchn_stove name', 'ktchn_stove', 's', 2, 1, 1, '0', '0', '0', 3256, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1640, 'ktchn_light name', 'ktchn_light', 's', 2, 1, 0, '1', '0', '1', 3258, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1641, 'ktchn_plates name', 'ktchn_plates', 's', 1, 1, 1, '0', '0', '0', 3263, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1642, 'ktchn_countr_1 name', 'ktchn_countr_1', 's', 1, 1, 1, '1', '0', '0', 3261, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1643, 'ktchn_pots name', 'ktchn_pots', 's', 2, 1, 0, '1', '0', '1', 3252, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1644, 'ktchn_cornr name', 'ktchn_cornr', 's', 1, 1, 1, '0', '0', '0', 3257, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1645, 'ktchn_desk name', 'ktchn_desk', 's', 2, 1, 1, '1', '0', '0', 3260, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1646, 'ktchn_trash name', 'ktchn_trash', 's', 1, 1, 1, '0', '0', '0', 3264, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1647, 'ktchn_countr_2 name', 'ktchn_countr_2', 's', 2, 1, 1, '1', '0', '0', 3253, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1648, 'ktchn_bBlock name', 'ktchn_bBlock', 's', 1, 1, 1, '0', '0', '0', 3255, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1649, 'ktchn_dvdr name', 'ktchn_dvdr', 's', 2, 1, 1, '0', '0', '0', 3259, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1650, 'ktchn_inspctr name', 'ktchn_inspctr', 's', 1, 1, 1, '1', '0', '0', 3250, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1651, 'ktchn_fridge name', 'ktchn_fridge', 's', 1, 1, 1, '1', '0', '0', 3249, '1', '1', '1', '1', '1', 'vendingmachine', 0, '3,36,37,38', ''),
(1652, 'ads_1800tele', 'ads_1800tele', 's', 1, 1, 0.001, '0', '0', '0', 3251, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1653, 'ktchn_sink name', 'ktchn_sink', 's', 2, 1, 1, '0', '0', '0', 3262, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1654, 'ktchn_gate name', 'ktchn_gate', 's', 2, 1, 0.001, '0', '0', '0', 3254, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1655, 'Pad of stickies', 'post.it', 'i', 0, 0, 1, '0', '0', '0', 1, '0', '0', '1', '0', '1', 'postit', 1, '0', ''),
(1656, 'Heart Stickies', 'post.it.vd', 'i', 0, 0, 1, '0', '0', '0', 2, '0', '0', '1', '0', '1', 'postit', 1, '0', ''),
(20067, 'Green Hatch', 'divider_poly3*7', 's', 1, 1, 0.001, '0', '0', '0', 1930, '1', '1', '1', '1', '1', 'gate', 1, '0', ''),
(20068, 'Idea Agency Lava Lamp', 'ads_cllava2', 's', 1, 1, 1, '0', '0', '0', 3021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1665, 'Gothic Ectoplasm Fountain', 'gothicfountain', 'i', 0, 0, 1, '0', '0', '0', 4002, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1666, 'Retro Wall Lamp', 'hc_wall_lamp', 'i', 0, 0, 1, '0', '0', '0', 4003, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1667, 'Industrial Turbine', 'industrialfan', 'i', 0, 0, 1, '0', '0', '0', 4004, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1668, 'Gothic Torch', 'torch', 'i', 0, 0, 1, '0', '0', '0', 4005, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1669, 'Heart Light', 'val_heart', 'i', 0, 0, 1, '0', '0', '0', 4006, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1670, 'Mirror', 'wallmirror', 'i', 0, 0, 1, '0', '0', '0', 4007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1671, 'Ninja Stars', 'jp_ninjastars', 'i', 0, 0, 1, '0', '0', '0', 4008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1672, 'Habbowood Mirror', 'habw_mirror', 'i', 0, 0, 1, '0', '0', '0', 4009, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1673, 'So you gotta ask yourself', 'habbowheel', 'i', 0, 0, 1, '0', '0', '0', 4010, '1', '1', '1', '1', '1', 'habbowheel', 1, '0', ''),
(1674, 'Skull Guitar', 'guitar_skull', 'i', 0, 0, 1, '0', '0', '0', 4011, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1675, 'V Guitar', 'guitar_v', 'i', 0, 0, 1, '0', '0', '0', 4012, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1676, 'Christmas Lights', 'xmas_light', 'i', 0, 0, 1, '0', '0', '0', 4015, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1677, 'Anchor', 'hrella_poster_3', 'i', 0, 0, 1, '0', '0', '0', 4016, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1678, 'Life Buoy', 'hrella_poster_2', 'i', 0, 0, 1, '0', '0', '0', 4013, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1679, 'Porthole', 'hrella_poster_1', 'i', 0, 0, 1, '0', '0', '0', 4014, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1680, 'Swords', 'sw_swords', 'i', 0, 0, 1, '0', '0', '0', 4017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1681, 'Mysterious Necklace', 'sw_stone', 'i', 0, 0, 1, '0', '0', '0', 4018, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1682, 'Ventilation Duct', 'sw_hole', 'i', 0, 0, 1, '0', '0', '0', 4019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1683, 'Mood Light', 'roomdimmer', 'i', 0, 0, 1, '0', '0', '0', 4027, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1684, 'Bubble Juice Can', 'md_logo_wall', 'i', 0, 0, 1, '0', '0', '0', 4023, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1685, 'Kakejiku Hokusai', 'jp_sheet3', 'i', 0, 0, 1, '0', '0', '0', 4021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1686, 'Kakejiku Ninjya', 'jp_sheet2', 'i', 0, 0, 1, '0', '0', '0', 4026, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1687, 'Kakejiku Ziritsu', 'jp_sheet1', 'i', 0, 0, 1, '0', '0', '0', 4024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1688, 'Ancestral Scimitars', 'arabian_swords', 'i', 0, 0, 1, '0', '0', '0', 4020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1689, 'Arabian Window Frame', 'arabian_wndw', 'i', 0, 0, 1, '0', '0', '0', 4022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1690, 'Jungle Wallplant', 'tiki_wallplnt', 'i', 0, 0, 1, '0', '0', '0', 4030, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(1691, 'Surfboard', 'tiki_surfboard', 'i', 0, 0, 1, '0', '0', '0', 4028, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(1692, 'tampax_wall', 'tampax_wall', 'i', 0, 0, 1, '0', '0', '0', 4029, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1693, 'Single Window', 'window_single_default', 'i', 0, 0, 1, '0', '0', '0', 4031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1694, 'Double Window', 'window_double_default', 'i', 0, 0, 1, '0', '0', '0', 4032, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1695, 'Window', 'noob_window_double', 'i', 0, 0, 1, '0', '0', '0', 4033, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1696, 'Bay Window', 'window_triple', 'i', 0, 0, 1, '0', '0', '0', 4045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1697, 'Glass Square Window', 'window_square', 'i', 0, 0, 1, '0', '0', '0', 4036, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1698, 'Large Romantic Window', 'window_romantic_wide', 'i', 0, 0, 1, '0', '0', '0', 4041, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1699, 'Small Romantic Window', 'window_romantic_narrow', 'i', 0, 0, 1, '0', '0', '0', 4037, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1700, 'Grunge Window', 'window_grunge', 'i', 0, 0, 1, '0', '0', '0', 4044, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1701, 'Golden Window', 'window_golden', 'i', 0, 0, 1, '0', '0', '0', 4035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1702, 'Large Oriental Window', 'window_chinese_wide', 'i', 0, 0, 1, '0', '0', '0', 4034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1703, 'Small Oriental Window', 'window_chinese_narrow', 'i', 0, 0, 1, '0', '0', '0', 4038, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1704, 'Basic Window', 'window_basic', 'i', 0, 0, 1, '0', '0', '0', 4042, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1705, 'Large 70s Window', 'window_70s_wide', 'i', 0, 0, 1, '0', '0', '0', 4039, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1706, 'Small 70s Window', 'window_70s_narrow', 'i', 0, 0, 1, '0', '0', '0', 4040, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1707, 'Sunny Delight', 'ads_sunnyd', 'i', 0, 0, 1, '0', '0', '0', 4043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1708, 'Good grub', 'window_diner2', 'i', 0, 0, 1, '0', '0', '0', 4046, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1709, 'Large Diner Window', 'window_diner', 'i', 0, 0, 1, '0', '0', '0', 4049, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1710, 'Diner Side Table', 'diner_walltable', 'i', 0, 0, 1, '0', '0', '0', 4048, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1711, 'ads_dave_wall', 'ads_dave_wall', 'i', 0, 0, 1, '0', '0', '0', 4047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1712, 'Window', 'window_hole', 'i', 0, 0, 1, '0', '0', '0', 4052, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1713, 'easy_poster', 'easy_poster', 'i', 0, 0, 1, '0', '0', '0', 4051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1714, 'ads_nokia_logo name', 'ads_nokia_logo', 'i', 0, 0, 1, '0', '0', '0', 4050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1715, 'ads_nokia_phone name', 'ads_nokia_phone', 'i', 0, 0, 1, '0', '0', '0', 4053, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1717, 'Skyscraper Window', 'window_skyscraper', 'i', 0, 0, 1, '0', '0', '0', 4054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1718, 'netari_poster', 'netari_poster', 'i', 0, 0, 1, '0', '0', '0', 4057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1719, 'Bullet Hole', 'det_bhole', 'i', 0, 0, 1, '0', '0', '0', 4056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1720, 'Red V Guitar', 'ads_campguitar', 'i', 0, 0, 1, '0', '0', '0', 4058, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1721, 'Nuclear Radiation Sign', 'hween08_rad', 'i', 0, 0, 1, '0', '0', '0', 4059, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1722, 'Broken Window (small)', 'hween08_wndwb', 'i', 0, 0, 1, '0', '0', '0', 4061, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1723, 'Broken Window (large)', 'hween08_wndw', 'i', 0, 0, 1, '0', '0', '0', 4062, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1724, 'Biohazard Sign', 'hween08_bio', 'i', 0, 0, 1, '0', '0', '0', 4063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1725, 'X-Ray Light Box', 'hw_08_xray', 'i', 0, 0, 1, '0', '0', '0', 4060, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1726, 'Red Gothic Fountain', 'gothicfountain2', 'i', 0, 0, 1, '0', '0', '0', 4065, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20052, 'Volturi Crest', 'ads_twi_crest', 'i', 0, 0, 1, '1', '0', '0', 4275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1728, 'TBD Central Musical TV', 'ads_cmusic', 'i', 0, 0, 1, '0', '0', '0', 4067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1729, 'Stand up or sitting down', 'party_wc_boy', 'i', 0, 0, 1, '0', '0', '0', 4070, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1730, 'Big Wall Lights', 'party_led', 'i', 0, 0, 1, '0', '0', '0', 4066, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1731, 'Neon Heart Light', 'party_neon5', 'i', 0, 0, 1, '0', '0', '0', 4074, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1732, 'Neon Right Arrows', 'party_neon1', 'i', 0, 0, 1, '0', '0', '0', 4069, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1733, 'Neon Left Arrows', 'party_neon2', 'i', 0, 0, 1, '0', '0', '0', 4073, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1734, 'Girls Toilets', 'party_wc_girl', 'i', 0, 0, 1, '0', '0', '0', 4068, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1735, 'Neon Pink Flamingo', 'party_neon3', 'i', 0, 0, 1, '0', '0', '0', 4075, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1736, 'Bar Shelf', 'party_shelf', 'i', 0, 0, 1, '0', '0', '0', 4071, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1737, 'Neon Skull Light', 'party_neon4', 'i', 0, 0, 1, '0', '0', '0', 4072, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1738, 'Snowy Posters', 'xmas08_wallpaper', 'i', 0, 0, 1, '0', '0', '0', 4077, '0', '0', '1', '1', '1', 'roomeffect', 1, '0', ''),
(1739, 'Icy Wall', 'xmas08_icewall', 'i', 0, 0, 1, '0', '0', '0', 4076, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1741, 'Idea Agency Plasma 1', 'ads_clwall1', 'i', 0, 0, 1, '0', '0', '0', 4082, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1742, 'Idea Agency Plasma 2', 'ads_clwall2', 'i', 0, 0, 1, '0', '0', '0', 4078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1743, 'Idea Agency Plasma 3', 'ads_clwall3', 'i', 0, 0, 1, '0', '0', '0', 4079, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1744, 'ads_ob_wall', 'ads_ob_wall', 'i', 0, 0, 1, '0', '0', '0', 4081, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1745, 'Mall Window', 'ads_mall_window', 'i', 0, 0, 1, '0', '0', '0', 4083, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1746, 'Dragon Poster', 'china_pstr2', 'i', 0, 0, 1, '0', '0', '0', 4085, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1747, 'Chinese Wall Lamp', 'china_light', 'i', 0, 0, 1, '0', '0', '0', 4086, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1748, 'Ox Poster', 'china_pstr1', 'i', 0, 0, 1, '0', '0', '0', 4084, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1749, 'Bolly Window', 'bolly_wdw_wd', 'i', 0, 0, 1, '0', '0', '0', 4087, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1750, 'Monster Plan Poster', 'ads_igor_wall', 'i', 0, 0, 1, '0', '0', '0', 4090, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1751, 'Evil Bone', 'ads_igorevilb', 'i', 0, 0, 1, '0', '0', '0', 4089, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1752, 'ads_idol_wall name', 'ads_idol_wall', 'i', 0, 0, 1, '0', '0', '0', 4088, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1753, 'Mall Furni Showroom', 'ads_mall_winfur', 'i', 0, 0, 1, '0', '0', '0', 4092, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1754, 'Mall Pet Shop Window', 'ads_mall_winpet', 'i', 0, 0, 1, '0', '0', '0', 4091, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1755, 'Rock Wall', 'lc_wall1', 'i', 0, 0, 1, '0', '0', '0', 4095, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1756, 'Aquarium Window', 'lc_window2', 'i', 0, 0, 1, '0', '0', '0', 4096, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1757, 'Wooden Window', 'lc_window1', 'i', 0, 0, 1, '0', '0', '0', 4094, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1758, 'American Idol TV', 'ads_idol_tv', 'i', 0, 0, 1, '0', '0', '0', 4093, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1759, 'Coral Wall', 'lc_wall2', 'i', 0, 0, 1, '0', '0', '0', 4097, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1760, 'ads_idol_mirror name', 'ads_idol_mirror', 'i', 0, 0, 1, '0', '0', '0', 4099, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1761, 'Mall Cinema Window', 'ads_mall_wincin', 'i', 0, 0, 1, '0', '0', '0', 4098, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1762, 'Strum', 'ads_mall_winmus', 'i', 0, 0, 1, '0', '0', '0', 4101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1763, 'Mall Beauty Salon', 'ads_mall_winbea', 'i', 0, 0, 1, '0', '0', '0', 4100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1764, 'Eco Curtain 1', 'eco_curtains1', 'i', 0, 0, 1, '0', '0', '0', 4105, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1765, 'Mall Idea Agency Window', 'ads_mall_winchi', 'i', 0, 0, 1, '0', '0', '0', 4103, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1766, 'Eco Curtain 3', 'eco_curtains3', 'i', 0, 0, 1, '0', '0', '0', 4104, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1767, 'Eco Curtain 2', 'eco_curtains2', 'i', 0, 0, 1, '0', '0', '0', 4102, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1768, 'Mall Ice Cream Parlour Window', 'ads_mall_winice', 'i', 0, 0, 1, '0', '0', '0', 4109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1769, 'Whatever your sporting dibble', 'ads_mall_winspo', 'i', 0, 0, 1, '0', '0', '0', 4106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1770, 'ads_idol_logo name', 'ads_idol_logo', 'i', 0, 0, 1, '0', '0', '0', 4108, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1771, 'World Map', 'exe_map', 'i', 0, 0, 1, '0', '0', '0', 4110, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1772, 'Wall Fall', 'exe_wfall', 'i', 0, 0, 1, '0', '0', '0', 4107, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1773, 'ads_lin_wh_c name', 'ads_lin_wh_c', 'i', 0, 0, 1, '0', '0', '0', 4115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1774, 'ads_malaco_tv name', 'ads_malaco_tv', 'i', 0, 0, 1, '0', '0', '0', 4113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1775, 'ads_puffet_tv name', 'ads_puffet_tv', 'i', 0, 0, 1, '0', '0', '0', 4111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1776, 'ads_reebok_tv name', 'ads_reebok_tv', 'i', 0, 0, 1, '0', '0', '0', 4112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1777, 'Forest Wall Poster', 'country_forestwall', 'i', 0, 0, 1, '0', '0', '0', 4114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1778, 'Marble Fireplace', 'country_fp', 'i', 0, 0, 1, '0', '0', '0', 4117, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1779, 'Farmhouse Wall', 'country_wall', 'i', 0, 0, 1, '0', '0', '0', 4118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1780, 'Ye Olde Lantern', 'country_lantern', 'i', 0, 0, 1, '0', '0', '0', 4116, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1781, 'Norwegian Flag', 'flag_norway', 'i', 0, 0, 1, '0', '0', '0', 4119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1782, 'Diner Poster', 'diner_poster', 'i', 0, 0, 1, '0', '0', '0', 4120, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1783, '', 'lt_jngl_wall', 'i', 0, 0, 1, '0', '0', '0', 4121, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1784, 'ads_mirror name', 'ads_mirror', 'i', 0, 0, 1, '0', '0', '0', 4122, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1785, 'lt_wall', 'lt_wall', 'i', 0, 0, 1, '0', '0', '0', 4123, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1787, 'Starship Window', 'sf_window', 'i', 0, 0, 1, '0', '0', '0', 4224, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1788, 'Starship Wall', 'sf_wall2', 'i', 0, 0, 1, '0', '0', '0', 4228, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1789, 'ads_wwe_poster name', 'ads_wwe_poster', 'i', 0, 0, 1, '0', '0', '0', 4226, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1790, 'Fly me to the moon', 'ads_mall_wintra', 'i', 0, 0, 1, '0', '0', '0', 4225, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1791, 'Starship Corner', 'sf_wall3', 'i', 0, 0, 1, '0', '0', '0', 4223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1793, 'ads_veet name', 'ads_veet', 'i', 0, 0, 1, '0', '0', '0', 4222, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1794, 'Wall Tiles', 'rela_wall', 'i', 0, 0, 1, '0', '0', '0', 4232, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(1795, 'flag_belgium', 'flag_belgium', 'i', 0, 0, 1, '0', '0', '0', 4229, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1796, 'Porko Flag', 'Porko Flag', 'i', 0, 0, 1, '0', '0', '0', 4249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1797, 'ads_mall_wingar', 'ads_mall_wingar', 'i', 0, 0, 1, '0', '0', '0', 4230, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1798, 'ktchn_wall name', 'ktchn_wall', 'i', 0, 0, 1, '0', '0', '0', 4235, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1799, 'ads_mall_winclo', 'ads_mall_winclo', 'i', 0, 0, 1, '0', '0', '0', 4236, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1800, 'ktchn_oven name', 'ktchn_oven', 'i', 0, 0, 1, '0', '0', '0', 4234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1801, 'ktchn_knives name', 'ktchn_knives', 'i', 0, 0, 1, '0', '0', '0', 4233, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1802, 'Mood Controller (Large)', 'dimmer_fuse6', 'i', 0, 0, 1, '0', '0', '0', 4240, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1803, 'Mood Switch (Large)', 'dimmer_swtch', 'i', 0, 0, 1, '0', '0', '0', 4237, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1804, 'Mood Controller (Small)', 'dimmer_fuse2', 'i', 0, 0, 1, '0', '0', '0', 4239, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1805, 'Mood Switch (Small)', 'dimmer_buttn', 'i', 0, 0, 1, '0', '0', '0', 4238, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(19877, '', 'avatar_effect9', 'e', 1, 1, 1, '0', '0', '0', 9, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19878, '', 'avatar_effect6', 'e', 1, 1, 1, '0', '0', '0', 6, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19879, '', 'avatar_effect16', 'e', 1, 1, 1, '0', '0', '0', 16, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19880, '', 'avatar_effect2', 'e', 1, 1, 1, '0', '0', '0', 2, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19881, '', 'avatar_effect14', 'e', 1, 1, 1, '0', '0', '0', 14, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19882, '', 'avatar_effect15', 'e', 1, 1, 1, '0', '0', '0', 15, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19883, '', 'avatar_effect3', 'e', 1, 1, 1, '0', '0', '0', 3, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19884, '', 'avatar_effect17', 'e', 1, 1, 1, '0', '0', '0', 17, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19885, '', 'avatar_effect18', 'e', 1, 1, 1, '0', '0', '0', 18, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19886, '', 'avatar_effect1', 'e', 1, 1, 1, '0', '0', '0', 1, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19887, '', 'avatar_effect4', 'e', 1, 1, 1, '0', '0', '0', 4, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19888, '', 'avatar_effect5', 'e', 1, 1, 1, '0', '0', '0', 5, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19889, '', 'avatar_effect7', 'e', 1, 1, 1, '0', '0', '0', 7, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19890, '', 'avatar_effect8', 'e', 1, 1, 1, '0', '0', '0', 8, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19891, '', 'avatar_effect10', 'e', 1, 1, 1, '0', '0', '0', 10, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19892, '', 'avatar_effect12', 'e', 1, 1, 1, '0', '0', '0', 12, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19893, '', 'avatar_effect13', 'e', 1, 1, 1, '0', '0', '0', 13, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19894, '', 'a2 l', 'i', 1, 1, 1, '0', '0', '0', 3002, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19895, '', 'a2 t', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19896, '', 'wallpaper 1', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19926, '', 'landscape 1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19938, '', 'hween09_floor', 's', 2, 2, 0, '1', '0', '1', 3288, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(19939, '', 'hween09_jar', 's', 1, 1, 1, '0', '0', '0', 3287, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19940, 'City Bench (Clean)', 'urban_bench_plain', 's', 2, 1, 1, '0', '1', '0', 3284, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19941, '', 'hween09_organ', 's', 2, 1, 1, '0', '0', '0', 3282, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19942, '', 'byesw_hand', 's', 1, 1, 1.35, '0', '0', '0', 3291, '0', '1', '1', '1', '1', '', 1, '0', ''),
(19943, '', 'byesw_hotel', 's', 1, 1, 1, '0', '0', '0', 3289, '0', '1', '1', '1', '1', 'default', 6, '0', ''),
(19944, '', 'hween09_table', 's', 1, 3, 1, '0', '0', '0', 3286, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19945, '', 'hween09_chair', 's', 1, 1, 1, '0', '1', '0', 3295, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(19946, '', 'hween09_mirror', 's', 1, 1, 1, '0', '1', '0', 3293, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19947, 'Trap Door', 'hween09_hatch', 's', 2, 2, 0.001, '0', '0', '1', 3285, '0', '0', '1', '1', '1', 'gate', 2, '0', ''),
(19948, '', 'hween09_ghost', 's', 1, 1, 1, '0', '0', '0', 3290, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19949, '', 'hween09_tv', 's', 2, 1, 1, '0', '0', '0', 3292, '0', '0', '1', '1', '1', 'default', 3, '0', ''),
(19950, '', 'hween09_chandelier', 's', 1, 1, 1, '0', '0', '1', 3294, '0', '0', '1', '1', '1', 'default', 3, '0', ''),
(19951, '', 'hween09_crnr1', 'i', 0, 0, 1, '0', '0', '0', 4247, '0', '0', '1', '1', '1', 'default', 4, '0', ''),
(19952, '', 'hween09_paint', 'i', 0, 0, 1, '0', '0', '0', 4263, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19953, '', 'hween09_treewall', 'i', 0, 0, 1, '0', '0', '0', 4269, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19954, '', 'hween09_wall1', 'i', 0, 0, 1, '0', '0', '0', 4257, '0', '0', '1', '1', '1', 'default', 4, '0', ''),
(19955, '', 'hween09_stonewall', 'i', 0, 0, 1, '0', '0', '0', 4259, '0', '0', '1', '1', '1', 'default', 5, '0', ''),
(19956, '', 'hween09_win', 'i', 0, 0, 1, '0', '0', '0', 4271, '0', '0', '1', '1', '1', 'default', 10, '0', ''),
(19957, '', 'avatar_effect22', 'e', 1, 1, 1, '0', '0', '0', 22, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19958, '', 'avatar_effect19', 'e', 1, 1, 1, '0', '0', '0', 19, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19959, '', 'avatar_effect20', 'e', 1, 1, 1, '0', '0', '0', 20, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19960, '', 'avatar_effect21', 'e', 1, 1, 1, '0', '0', '0', 21, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19989, 'Snowman Base', 'xm09_man_a', 's', 1, 1, 1, '1', '0', '0', 3330, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(19971, 'Snowman Middle', 'xm09_man_b', 's', 1, 1, 0.8, '1', '0', '0', 3328, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(19972, 'Snowman Head', 'xm09_man_c', 's', 1, 1, 1, '0', '0', '0', 3329, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(19973, 'Christmas Table', 'xm09_table', 's', 2, 6, 1, '1', '0', '0', 3335, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19974, '6-Seater Bench', 'xm09_bench', 's', 6, 1, 1, '0', '1', '0', 3340, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19976, 'Snowy Fir Trees', 'xm09_firwall', 'i', 0, 0, 1, '0', '0', '0', 4307, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19977, 'Snowy Forest', 'xm09_forestwall', 'i', 0, 0, 1, '0', '0', '0', 4308, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19978, 'Lodge Wall', 'xm09_lodgewall', 'i', 0, 0, 1, '1', '0', '0', 4311, '0', '1', '1', '1', '1', 'default', 8, '0', ''),
(19979, 'Gold Heart Bauble', 'xm09_bauble_25', 'i', 0, 0, 1, '1', '0', '0', 4286, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19980, 'Silver Heart Bauble', 'xm09_bauble_26', 'i', 0, 0, 1, '1', '0', '0', 4306, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19981, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1, '1', '0', '0', 4279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19982, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1, '1', '0', '0', 4279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19983, 'Blue Heart Bauble', 'xm09_bauble_23', 'i', 0, 0, 1, '1', '0', '0', 4292, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19984, 'Green Heart Bauble', 'xm09_bauble_24', 'i', 0, 0, 1, '1', '0', '0', 4278, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19985, 'Candy Cane', 'xm09_candyCane', 's', 1, 1, 1, '0', '0', '0', 3314, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(19986, 'Big Stocking', 'xm09_stocking', 'i', 0, 0, 1, '1', '0', '0', 4280, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19994, 'Fountain', 'ads_twi_fountn', 's', 2, 2, 1, '0', '0', '0', 3301, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19995, 'Clock Tower wall', 'ads_twi_dvdr2', 's', 2, 1, 1, '0', '0', '0', 3302, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19996, 'Standing Rose Bouquet', 'ads_twi_roses', 's', 1, 1, 1, '0', '0', '0', 3304, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19997, 'Cake on Table with Presents', 'ads_twi_table', 's', 2, 2, 1, '0', '0', '0', 3297, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19998, 'Volturi Royal Chair', 'ads_twi_chair', 's', 1, 1, 1, '0', '1', '0', 3300, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19999, 'Half wall', 'ads_twi_dvdr1', 's', 2, 1, 1, '0', '0', '0', 3303, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20000, 'Broken Piano', 'ads_twi_piano', 's', 2, 2, 1, '0', '0', '0', 3299, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20001, 'ads_twi_tower name', 'ads_twi_tower', 's', 1, 1, 1, '0', '0', '0', 3298, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20002, 'Toolbox', 'ads_twi_toolbx', 's', 1, 1, 1, '0', '0', '0', 3296, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20003, 'Mist', 'ads_twi_mist', 's', 1, 1, 0, '1', '0', '1', 3308, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20011, 'Water Hydrant', 'urban_wpost', 's', 1, 1, 1, '0', '0', '0', 3272, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20010, 'Pavement Slab', 'urban_sidewalk', 's', 2, 2, 0.2, '1', '0', '1', 3274, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(20008, 'City Bench (Dirty)', 'urban_bench', 's', 2, 1, 1, '0', '1', '0', 3269, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20007, 'Taxi Sofa', 'urban_carsofa', 's', 2, 1, 1, '0', '1', '0', 3268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20014, 'Concrete Block', 'urban_blocker', 's', 1, 1, 1, '0', '0', '0', 3270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20013, 'Garbage Bin', 'urban_bin', 's', 1, 1, 1, '0', '0', '0', 3266, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20012, 'Mesh Fencing', 'urban_fence', 's', 1, 2, 1, '0', '0', '0', 3267, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20015, 'Basketball Pole', 'urban_bsktbll', 's', 1, 1, 1, '0', '0', '0', 3271, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20025, 'Terracotta Pillar', 'pillar*6', 's', 1, 1, 1, '0', '0', '0', 1609, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20026, 'Urban Iced Bookcase', 'shelves_norja*4', 's', 1, 1, 1, '0', '0', '0', 1795, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20027, 'Black Mode Double Bed', 'bed_polyfon*2', 's', 2, 3, 1.8, '0', '0', '0', 1895, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20028, 'Blue Iced Angle', 'divider_nor5*6', 's', 1, 1, 1, '0', '0', '0', 1995, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20029, 'Valentine''s Cauldron', 'val_cauldron', 's', 1, 1, 1, '0', '0', '0', 2103, '1', '1', '1', '1', '1', 'vendingmachine', 0, '25', ''),
(20030, 'Aqua Pura Module 5', 'pura_mdl5*1', 's', 1, 1, 1, '0', '1', '0', 2509, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20031, 'Aqua One Way Gate', 'one_way_door*1', 's', 1, 1, 0.001, '0', '0', '0', 2597, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(20032, 'Power Globe', 'exe_globe', 's', 1, 1, 1, '0', '0', '0', 2672, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20034, 'Latte Diner Corner', 'diner_bardesk_corner*5', 's', 1, 1, 1, '1', '0', '0', 2874, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20035, 'Bubbles', 'fx_bubble', 's', 1, 1, 1, '1', '0', '0', 3012, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(20036, 'Safety Cone', 'bump_tottero', 's', 1, 1, 1, '0', '0', '0', 3087, '1', '1', '1', '0', '1', 'default', 1, '0', ''),
(20037, 'ads_calip_parasol name', 'ads_calip_parasol', 's', 1, 1, 1, '0', '0', '0', 3195, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20041, '2010 Poster', 'year2010', 'i', 0, 0, 1, '1', '0', '0', 4313, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20042, 'Party Lantern', 'party_lantern', 's', 1, 1, 0, '1', '0', '1', 3327, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20043, 'Party Lights', 'party_lights', 'i', 0, 0, 1, '0', '0', '0', 4310, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20047, 'Soothing Stick', 'rela_stick', 's', 1, 1, 1, '0', '0', '0', 3240, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20048, 'Mall Lift', 'ads_mall_elevator', 's', 1, 1, 0.001, '0', '0', '0', 3306, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(20050, 'Flatscreen TV', 'xm09_infotv', 'i', 0, 0, 1, '1', '0', '0', 4309, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20051, 'Twilight Trophy', 'ads_twi_trophy', 's', 1, 1, 1, '1', '0', '0', 3311, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(20053, 'Painting', 'ads_twi_paint', 'i', 0, 0, 1, '1', '0', '0', 4272, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20054, 'Window with Candles', 'ads_twi_windw', 'i', 0, 0, 1, '1', '0', '0', 4277, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20055, 'Truck and Motorcycles', 'ads_twi_bwall2', 'i', 0, 0, 1, '1', '0', '0', 4276, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20056, 'Dream Catcher', 'ads_twi_dreamc', 'i', 0, 0, 1, '1', '0', '0', 4273, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20057, 'Barn Wall', 'ads_twi_bwall1', 'i', 0, 0, 1, '1', '0', '0', 4274, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20059, 'Arabian Wall', 'arabian_wall', 'i', 0, 0, 1, '1', '0', '0', 4287, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20060, 'DEAL_HC_1', 'DEAL_HC_1', 'h', 0, 0, 0, '0', '0', '0', 0, '0', '0', '1', '0', '0', 'default', 0, '0', ''),
(20072, 'ads_gsArcade_1 name', 'ads_gsArcade_1', 's', 1, 1, 1, '1', '0', '0', 3277, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20063, 'Hot Choc Machine', 'xm09_cocoa', 's', 1, 1, 1, '1', '0', '0', 3337, '1', '1', '1', '1', '1', 'vendingmachine', 0, '10', ''),
(20064, 'Astro-Bar', 'sf_mbar', 's', 1, 1, 1, '1', '0', '0', 3273, '1', '1', '1', '1', '1', 'vendingmachine', 0, '44', ''),
(20074, 'Silver MTV EMA Trophy', 'ads_mtvtrophy_silver', 's', 1, 1, 1, '0', '0', '0', 3281, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20075, 'ads_spang_sleep', 'ads_spang_sleep', 's', 1, 3, 0.8, '1', '0', '0', 3280, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20076, 'Gold MTV EMA Trophy', 'ads_mtvtrophy_gold', 's', 1, 1, 1, '0', '0', '0', 3279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20077, 'ktchn_hlthNut name', 'ktchn_hlthNut', 's', 1, 1, 1, '1', '0', '0', 3307, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20078, 'Chicken', 'petfood8', 's', 1, 1, 1, '1', '0', '0', 3325, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20079, 'nest_plow_reg', 'nest_plow_reg', 's', 1, 1, 1, '1', '0', '0', 3318, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20080, 'Yellow Pet Snuggle', 'nest_snug_yel', 's', 1, 1, 1, '1', '0', '0', 3319, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20081, 'Salmon', 'petfood9', 's', 1, 1, 1, '1', '0', '0', 3322, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20082, 'Leveling Cake', 'petfood10', 's', 1, 1, 1, '1', '0', '0', 3326, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20083, 'Ice Apples', 'petfood7', 's', 1, 1, 1, '1', '0', '0', 3321, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20084, 'Red Apples', 'petfood6', 's', 1, 1, 1, '1', '0', '0', 3323, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20085, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1, '1', '0', '0', 3310, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20086, 'nest_snug_red', 'nest_snug_red', 's', 1, 1, 1, '1', '0', '0', 3317, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20087, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1, '1', '0', '0', 3310, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20088, 'nest_plow_bro', 'nest_plow_bro', 's', 1, 1, 1, '1', '0', '0', 3309, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20089, 'Red Pet Pillow', 'nest_plow_red', 's', 1, 1, 1, '1', '0', '0', 3320, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20090, 'nest_snug_blu', 'nest_snug_blu', 's', 1, 1, 1, '1', '0', '0', 3315, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20091, 'Green Apples', 'petfood5', 's', 1, 1, 1, '1', '0', '0', 3324, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20092, 'Blue Pet Pillow', 'nest_plow_blu', 's', 1, 1, 1, '1', '0', '0', 3316, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20093, 'Giant Bauble', 'xm09_lrgBauble', 's', 1, 1, 1, '1', '0', '0', 3313, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20094, 'nest_dirt', 'nest_dirt', 's', 1, 1, 1, '1', '0', '0', 3331, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20095, 'nest_snug_prp', 'nest_snug_prp', 's', 1, 1, 1, '1', '0', '0', 3332, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20096, 'nest_nest', 'nest_nest', 's', 1, 1, 1, '1', '0', '0', 3334, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20097, 'nest_nails', 'nest_nails', 's', 1, 1, 1, '1', '0', '0', 3336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20098, 'nest_basket', 'nest_basket', 's', 1, 1, 1, '1', '0', '0', 3333, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20099, 'Polar Bear Nest', 'nest_ice', 's', 1, 1, 1, '1', '0', '0', 3339, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20100, 'nest_plow_skl', 'nest_plow_skl', 's', 1, 1, 1, '1', '0', '0', 3341, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20101, 'nest_snug_bla', 'nest_snug_bla', 's', 1, 1, 1, '1', '0', '0', 3338, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20102, 'The Moodi Machine', 'ads_cl_moodi', 's', 1, 1, 1, '1', '0', '0', 3342, '1', '1', '1', '1', '1', 'vendingmachine', 1, '46,47,45', ''),
(20103, 'org_chairpnk', 'org_chairpnk', 's', 1, 1, 1.2, '0', '1', '0', 3354, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20104, 'org_tblpnk', 'org_tblpnk', 's', 1, 1, 1, '1', '0', '0', 3352, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20105, 'org_lampblk', 'org_lampblk', 's', 1, 1, 1.2, '0', '0', '0', 3353, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20106, 'org_lamppnk', 'org_lamppnk', 's', 1, 1, 1.2, '0', '0', '0', 3348, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20107, 'org_table', 'org_table', 's', 2, 2, 1, '1', '0', '0', 3356, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20108, 'china_tiger', 'china_tiger', 's', 1, 1, 1, '1', '0', '0', 3344, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20109, 'xm09_trophy name', 'xm09_trophy', 's', 1, 1, 1, '1', '0', '0', 3351, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20110, 'china_plmTree name', 'china_plmTree', 's', 1, 1, 1, '1', '0', '0', 3355, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20111, 'org_chairblk', 'org_chairblk', 's', 1, 1, 1.2, '0', '1', '0', 3349, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20112, 'org_tblblk', 'org_tblblk', 's', 1, 1, 1, '1', '0', '0', 3347, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20113, 'org_chrblk', 'org_chrblk', 's', 1, 1, 1.2, '0', '1', '0', 3345, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20114, 'china_tigrSeat name', 'china_tigrSeat', 's', 1, 2, 1, '1', '0', '0', 3346, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20115, 'org_chrpnk', 'org_chrpnk', 's', 1, 1, 1.2, '0', '1', '0', 3350, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20116, 'ads_chups name', 'ads_chups', 's', 1, 1, 1, '1', '0', '0', 3367, '1', '1', '1', '1', '1', 'vendingmachine', 1, '48', ''),
(20117, 'bling_fridge', 'bling_fridge', 's', 1, 1, 1, '0', '0', '0', 3366, '1', '1', '1', '1', '1', 'vendingmachine', 0, '50', ''),
(20118, 'petfood12 name', 'petfood12', 's', 1, 1, 1, '1', '0', '0', 3370, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20119, 'ads_droetker_paula name', 'ads_droetker_paula', 's', 1, 1, 1, '1', '0', '0', 3365, '1', '1', '1', '1', '1', 'vendingmachine', 1, '49', ''),
(20120, 'petfood11 name', 'petfood11', 's', 1, 1, 1, '1', '0', '0', 3358, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20121, 'bling_chair_a', 'bling_chair_a', 's', 1, 1, 1, '0', '1', '0', 3368, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20122, 'petfood13 name', 'petfood13', 's', 1, 1, 1, '1', '0', '0', 3359, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20123, 'bling_pool', 'bling_pool', 's', 3, 1, 0.01, '0', '1', '0', 3369, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20124, 'bling_toilet', 'bling_toilet', 's', 1, 1, 1.2, '0', '1', '0', 3362, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20125, 'val09_floor', 'val09_floor', 's', 2, 2, 0, '1', '0', '1', 3363, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20126, 'bling_chair_c', 'bling_chair_c', 's', 1, 1, 1, '0', '1', '0', 3361, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20127, 'bling_chair_b', 'bling_chair_b', 's', 1, 1, 1, '0', '1', '0', 3360, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20128, 'bling_shwr name', 'bling_shwr', 's', 1, 1, 0, '1', '0', '1', 3396, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20129, 'bling_bed name', 'bling_bed', 's', 2, 3, 1.6, '0', '1', '0', 3364, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20130, 'bling_sofa', 'bling_sofa', 's', 2, 1, 1.5, '0', '1', '0', 3371, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20131, 'val09_floor2', 'val09_floor2', 's', 2, 2, 0, '1', '0', '1', 3357, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20132, 'teddy_basic', 'teddy_basic', 's', 1, 1, 1, '1', '0', '0', 3393, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20133, 'teddy_pendergrass', 'teddy_pendergrass', 's', 1, 1, 1, '1', '0', '0', 3384, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20134, 'val_hSeat_1 name', 'val_hSeat*1', 's', 1, 1, 1, '0', '1', '0', 3386, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20135, 'val_hSeat_2 name', 'val_hSeat*2', 's', 1, 1, 1, '0', '1', '0', 3387, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20136, 'val_hSeat_3 name', 'val_hSeat*3', 's', 1, 1, 1, '0', '1', '0', 3388, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20137, 'val_hSeat_4 name', 'val_hSeat*4', 's', 1, 1, 1, '0', '1', '0', 3389, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20138, 'val_hSeat_5 name', 'val_hSeat*5', 's', 1, 1, 1, '0', '1', '0', 3390, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20139, 'val_hSeat_6 name', 'val_hSeat*6', 's', 1, 1, 1, '0', '1', '0', 3391, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20140, 'val_hSeat_7 name', 'val_hSeat*7', 's', 1, 1, 1, '0', '1', '0', 3392, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20141, 'Valentines gift basket', 'val_basket', 's', 1, 1, 1, '1', '0', '0', 3382, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20142, 'teddy_bear', 'teddy_bear', 's', 1, 1, 1, '1', '0', '0', 3385, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20143, 'teddy_pink', 'teddy_pink', 's', 1, 1, 1, '1', '0', '0', 3383, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20144, 'bling_fridge_restricted name', 'bling_fridge_restricted', 's', 1, 1, 1, '0', '0', '0', 3394, '1', '1', '1', '1', '1', 'vendingmachine', 0, '50', ''),
(20145, 'ads_percyrock name', 'ads_percyrock', 's', 2, 2, 1, '1', '0', '0', 3395, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20146, 'Bubble Juice Can', 'md_can', 'i', 0, 0, 1, '1', '0', '0', 4025, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20147, 'ads_idol_l_logo name', 'ads_idol_l_logo', 'i', 0, 0, 1, '1', '0', '0', 4243, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20148, 'Latin American Idol TV', 'ads_idol_l_tv', 'i', 0, 0, 1, '1', '0', '0', 4245, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20149, 'Big MTV', 'ads_mtv_bigtv', 'i', 0, 0, 1, '1', '0', '0', 4241, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20150, 'Small MTV', 'ads_mtv_tv', 'i', 0, 0, 1, '1', '0', '0', 4242, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20151, 'flag_singapore', 'flag_singapore', 'i', 0, 0, 1, '1', '0', '0', 4249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20152, 'Old Curtain', 'hween09_curt', 'i', 0, 0, 1, '1', '0', '0', 4266, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20153, 'flag_columbia', 'flag_columbia', 'i', 0, 0, 1, '1', '0', '0', 4258, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20154, 'flag_chile', 'flag_chile', 'i', 0, 0, 1, '1', '0', '0', 4256, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20155, 'flag_ecuador', 'flag_ecuador', 'i', 0, 0, 1, '1', '0', '0', 4268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20156, 'flag_dominicanrepublic', 'flag_dominicanrepublic', 'i', 0, 0, 1, '1', '0', '0', 4265, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20157, 'flag_newzealand', 'flag_newzealand', 'i', 0, 0, 1, '1', '0', '0', 4260, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20158, 'flag_malaysia', 'flag_malaysia', 'i', 0, 0, 1, '1', '0', '0', 4252, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20159, 'Loading Poster', 'byesw_loadscreen', 'i', 0, 0, 1, '1', '0', '0', 4267, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20160, 'flag_venezl', 'flag_venezl', 'i', 0, 0, 1, '1', '0', '0', 4254, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20161, 'flag_algeria', 'flag_algeria', 'i', 0, 0, 1, '1', '0', '0', 4270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20162, 'flag_tunisia', 'flag_tunisia', 'i', 0, 0, 1, '1', '0', '0', 4248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20163, 'flag_panama', 'flag_panama', 'i', 0, 0, 1, '1', '0', '0', 4262, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20164, 'flag_mexico', 'flag_mexico', 'i', 0, 0, 1, '1', '0', '0', 4250, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20165, 'flag_argentina', 'flag_argentina', 'i', 0, 0, 1, '1', '0', '0', 4261, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20166, 'flag_philippines', 'flag_philippines', 'i', 0, 0, 1, '1', '0', '0', 4251, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20167, 'flag_greece', 'flag_greece', 'i', 0, 0, 1, '1', '0', '0', 4253, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20168, 'flag_peru', 'flag_peru', 'i', 0, 0, 1, '1', '0', '0', 4246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20169, 'flag_morocco', 'flag_morocco', 'i', 0, 0, 1, '1', '0', '0', 4264, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20170, 'flag_turkey', 'flag_turkey', 'i', 0, 0, 1, '1', '0', '0', 4255, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20171, 'Blue Long Bauble', 'xm09_bauble_12', 'i', 0, 0, 1, '1', '0', '0', 4304, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20172, 'Purple Long Bauble', 'xm09_bauble_16', 'i', 0, 0, 1, '1', '0', '0', 4303, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20173, 'Red Long Bauble', 'xm09_bauble_17', 'i', 0, 0, 1, '1', '0', '0', 4281, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20174, 'Silver Long Bauble', 'xm09_bauble_15', 'i', 0, 0, 1, '1', '0', '0', 4301, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20175, 'Silver Round Bauble', 'xm09_bauble_10', 'i', 0, 0, 1, '1', '0', '0', 4293, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20176, 'Gold Round Bauble', 'xm09_bauble_9', 'i', 0, 0, 1, '1', '0', '0', 4294, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20177, 'Green Long Bauble', 'xm09_bauble_18', 'i', 0, 0, 1, '1', '0', '0', 4298, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20178, 'Green Long Bauble', 'xm09_bauble_13', 'i', 0, 0, 1, '1', '0', '0', 4299, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20179, 'Blue Round Bauble', 'xm09_bauble_2', 'i', 0, 0, 1, '1', '0', '0', 4297, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20180, 'Red Round Bauble', 'xm09_bauble_1', 'i', 0, 0, 1, '1', '0', '0', 4300, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20181, 'Red Heart Bauble', 'xm09_bauble_22', 'i', 0, 0, 1, '1', '0', '0', 4302, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20182, 'Green Round Bauble', 'xm09_bauble_3', 'i', 0, 0, 1, '1', '0', '0', 4285, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20183, 'Silver Long Bauble', 'xm09_bauble_21', 'i', 0, 0, 1, '1', '0', '0', 4305, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20184, 'Green Round Bauble', 'xm09_bauble_8', 'i', 0, 0, 1, '1', '0', '0', 4295, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20185, 'Gold Round Bauble', 'xm09_bauble_4', 'i', 0, 0, 1, '1', '0', '0', 4282, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20186, 'Silver Round Bauble', 'xm09_bauble_5', 'i', 0, 0, 1, '1', '0', '0', 4288, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20187, 'Red Long Bauble', 'xm09_bauble_11', 'i', 0, 0, 1, '1', '0', '0', 4289, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20188, 'Gold Long Bauble', 'xm09_bauble_20', 'i', 0, 0, 1, '1', '0', '0', 4296, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20190, 'val_table1 name', 'val_table1', 's', 1, 1, 1, '0', '0', '0', 3397, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20191, 'Gold Long Bauble', 'xm09_bauble_14', 'i', 0, 0, 1, '1', '0', '0', 4290, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20192, 'Blue Round Bauble', 'xm09_bauble_7', 'i', 0, 0, 1, '1', '0', '0', 4291, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20193, 'Red Round Bauble', 'xm09_bauble_6', 'i', 0, 0, 1, '1', '0', '0', 4284, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20194, 'Blue Long Bauble', 'xm09_bauble_19', 'i', 0, 0, 1, '1', '0', '0', 4283, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20195, 'china_pstr3 name', 'china_pstr3', 'i', 0, 0, 1, '1', '0', '0', 4314, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20196, 'ads_tv_jaapuisto name', 'ads_tv_jaapuisto', 'i', 0, 0, 1, '1', '0', '0', 4315, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20197, 'Empire State Building Clock', 'ads_percyw', 'i', 0, 0, 1, '1', '0', '0', 4322, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20198, 'val09_wdrobe_b', 'val09_wdrobe_b', 'i', 0, 0, 1, '1', '0', '0', 4320, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20199, 'val09_wall2', 'val09_wall2', 'i', 0, 0, 1, '1', '0', '0', 4316, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20200, 'bling_sink', 'bling_sink', 'i', 0, 0, 1, '1', '0', '0', 4319, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20201, 'val09_wall1', 'val09_wall1', 'i', 0, 0, 1, '1', '0', '0', 4318, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20202, 'bling_cabinet', 'bling_cabinet', 'i', 0, 0, 1, '1', '0', '0', 4321, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20204, 'val09_wdrobe_g', 'val09_wdrobe_g', 'i', 0, 0, 1, '1', '0', '0', 4317, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20207, 'rare_ironmaiden name', 'rare_ironmaiden', 's', 1, 1, 0.001, '0', '0', '0', 3399, '1', '1', '0', '1', '1', 'teleport', 2, '0', ''),
(20208, 'rare_trex name', 'rare_trex', 's', 3, 7, 1, '0', '0', '0', 3398, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20209, 'beanstalk', 'beanstalk', 's', 1, 1, 1, '1', '0', '0', 3401, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20210, 'Rare Voodoo Doll', 'rare_vdoll', 's', 1, 1, 1, '0', '0', '0', 3403, '1', '1', '1', '1', '1', '', 10, '0', ''),
(20211, 'rare_mmmth name', 'rare_mmmth', 's', 2, 1, 1, '0', '1', '0', 3402, '1', '1', '1', '1', '1', '', 0, '0', ''),
(20212, 'crystal_patch', 'crystal_patch', 's', 3, 3, 0, '0', '0', '1', 3400, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20213, 'ads_boost_surfb name', 'ads_boost_surfb', 'i', 0, 0, 1, '1', '0', '0', 4323, '1', '1', '1', '1', '1', '', 0, '0', ''),
(20214, 'ads_tlc_wheel name', 'ads_tlc_wheel', 'i', 0, 0, 1, '1', '0', '0', 4324, '1', '1', '1', '1', '1', 'habbowheel', 1, '0', ''),
(20319, 'a0 pet5', 'a0 pet5', 's', 1, 1, 0, '0', '0', '0', 2442, '1', '0', '0', '0', '0', 'pet5', 1, '0', ''),
(20221, 'White moon lupine', 'garden_lupin4', 's', 1, 1, 0.000000001, '0', '0', '0', 3419, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20222, 'Gold rush', 'garden_mursu3', 's', 1, 1, 1, '0', '0', '0', 3408, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20223, 'Purple Lupine', 'garden_lupin5', 's', 1, 1, 1, '0', '0', '0', 3411, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20224, 'Violet Blossom', 'garden_seed', 's', 1, 1, 1, '0', '0', '0', 3406, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20225, 'Snapping teleporter', 'garden_flytrap', 's', 1, 1, 0.001, '0', '0', '0', 3420, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(20226, 'Pink pandemic', 'garden_flo3', 's', 1, 1, 0.000000000000001, '1', '0', '1', 3426, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20227, 'Belching pod', 'garden_volcano', 's', 2, 2, 1, '0', '0', '0', 3424, '1', '1', '1', '1', '1', 'alert', 2, '0', ''),
(20228, 'Wonder lamp', 'garden_flolamp', 's', 1, 1, 1, '0', '0', '0', 3415, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20229, 'Red rush', 'garden_mursu2', 's', 1, 1, 1, '0', '0', '0', 3412, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20230, 'Star flower', 'garden_jyrki', 's', 1, 1, 1, '0', '0', '0', 3405, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(20231, 'White rush', 'garden_mursu4', 's', 1, 1, 1, '0', '0', '0', 3414, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20232, 'Garden leaves', 'garden_leaves', 's', 1, 1, 1, '0', '0', '0', 3425, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20233, 'Sky blue lupine', 'garden_lupin2', 's', 1, 1, 1, '0', '0', '0', 3416, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20234, 'Red lupine', 'garden_lupin3', 's', 1, 1, 1, '0', '0', '0', 3407, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20235, 'Pink rush', 'garden_mursu', 's', 1, 1, 1, '0', '0', '0', 3404, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20238, 'Bauhinia orchid tree', 'garden_orchtree', 's', 1, 1, 1, '0', '0', '0', 3413, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20237, 'Yellow happiness', 'garden_flo2', 's', 1, 1, 0, '1', '0', '1', 3409, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20239, 'Orange lupine', 'garden_lupin1', 's', 1, 1, 1, '0', '0', '0', 3421, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20240, 'Weird staring bush', 'garden_staringbush', 's', 1, 3, 1, '0', '0', '0', 3417, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20241, 'ads_grefusa_yum name', 'ads_grefusa_yum', 's', 1, 1, 1, '1', '0', '0', 3423, '1', '1', '1', '1', '1', 'vendingmachine', 1, '51, 52', ''),
(20242, 'Blue passion', 'garden_flo1', 's', 1, 1, 0.00000001, '1', '0', '1', 3418, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20243, 'Duck grass', 'garden_jungle', 's', 1, 1, 1, '1', '0', '0', 3422, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20244, 'merger_chest name', 'merger_chest', 's', 2, 1, 1, '0', '0', '0', 3455, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20245, 'Suave Fireplace', 'hc2_frplc', 's', 1, 2, 1, '0', '0', '0', 3458, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20246, 'Leather Bar Stool', 'hc2_barchair', 's', 1, 1, 1.7, '0', '1', '0', 3439, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20247, 'runway_display name', 'runway_display', 's', 1, 1, 1, '0', '0', '0', 3457, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20248, 'runway_bigchr_5 name', 'runway_bigchr_5', 's', 1, 1, 0.8, '1', '0', '0', 3463, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20249, 'runway_bigchr_4 name', 'runway_bigchr_4', 's', 1, 1, 0.8, '1', '0', '0', 3435, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20250, 'VIP Duvan', 'hc3_dc', 's', 1, 3, 1, '0', '0', '0', 3461, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20252, 'Glass Table', 'hc2_sofatbl', 's', 2, 2, 0.5, '1', '0', '0', 3434, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20253, 'runway_stool name', 'runway_stool', 's', 1, 1, 1.2, '0', '1', '0', 3442, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20254, 'runway_dvdr name', 'runway_dvdr', 's', 2, 1, 1, '0', '0', '0', 3456, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20255, 'runway_block_2 name', 'runway_block_2', 's', 2, 2, 0.8, '1', '0', '1', 3443, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20256, 'runway_bigchr_1 name', 'runway_bigchr_1', 's', 1, 1, 0.8, '0', '1', '0', 3462, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20257, 'Black Lamp', 'hc2_biglamp', 's', 1, 1, 1, '0', '0', '0', 3446, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20258, 'Leather Sofa', 'hc2_sofa', 's', 2, 1, 1, '0', '1', '0', 3452, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20259, 'Trendy Rug', 'hc2_carpet', 's', 3, 5, 0, '1', '0', '1', 3440, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20260, 'runway_block_1 name', 'runway_block_1', 's', 2, 2, 0.8, '1', '0', '1', 3433, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20261, 'runway_bench name', 'runway_bench', 's', 2, 1, 1.4, '0', '1', '0', 3464, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20262, 'runway_chair_2 name', 'runway_chair_2', 's', 1, 1, 1.4, '0', '1', '0', 3429, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20263, 'ads_cheetos name', 'ads_cheetos', 's', 1, 1, 1, '0', '0', '0', 3453, '1', '1', '1', '1', '1', 'vendingmachine', 1, '51, 52', ''),
(20264, 'VIP Coffee Table', 'hc3_table', 's', 2, 2, 0.5, '1', '0', '0', 3466, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20265, 'runway_bigchr_3 name', 'runway_bigchr_3', 's', 1, 1, 0.8, '1', '0', '0', 3454, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20266, 'VIP Stool', 'hc3_stool', 's', 1, 1, 1.7, '0', '1', '0', 3448, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20267, 'VIP Sofa', 'hc3_sofa', 's', 2, 1, 1, '0', '1', '0', 3441, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20268, 'runway_bigchr_2 name', 'runway_bigchr_2', 's', 1, 1, 0.8, '1', '0', '0', 3427, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20269, 'Leather Armchair', 'hc2_armchair', 's', 1, 1, 1, '1', '1', '0', 3436, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20270, 'runway_table_2 name', 'runway_table_2', 's', 2, 1, 1, '0', '0', '0', 3444, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20271, 'runway_table_1 name', 'runway_table_1', 's', 3, 2, 1, '1', '0', '0', 3460, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20272, 'runway_manqn_1 name', 'runway_manqn_1', 's', 1, 1, 1, '0', '0', '0', 3437, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20273, 'Leather Duvan', 'hc2_dvn', 's', 1, 3, 1, '0', '0', '0', 3459, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20274, 'VIP Light', 'hc3_light', 's', 2, 1, 0, '1', '0', '1', 3465, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20275, 'VIP Shelves', 'hc3_shelf', 's', 3, 1, 1.75, '1', '0', '0', 3438, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20276, 'runway_head name', 'runway_head', 's', 1, 1, 1, '1', '0', '0', 3432, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(20277, 'runway_manqn_2 name', 'runway_manqn_2', 's', 1, 1, 1, '0', '0', '0', 3467, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20278, 'Black Divider', 'hc2_divider', 's', 1, 3, 1, '0', '0', '0', 3449, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20279, 'Espresso Machine', 'hc2_coffee', 's', 1, 1, 1, '0', '0', '0', 3450, '1', '1', '1', '1', '1', 'vendingmachine', 0, '9,8,14,15,6,10,11,12,17,13', ''),
(20280, 'Service Trolley', 'hc2_cart', 's', 1, 1, 1, '0', '0', '0', 3430, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20281, 'VIP Bar Desk', 'hc3_bard', 's', 2, 1, 1.05, '1', '0', '0', 3445, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20282, 'VIP Lamp', 'hc3_hugelamp', 's', 1, 1, 0, '1', '0', '1', 3447, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20283, 'VIP Divider', 'hc3_divider', 's', 1, 3, 1, '0', '0', '0', 3431, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20284, 'Black Vase', 'hc2_vase', 's', 1, 1, 1, '0', '0', '0', 3428, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20285, 'runway_chair_1 name', 'runway_chair_1', 's', 1, 1, 1.4, '0', '1', '0', 3451, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20286, 'Green been vines', 'garden_wall', 'i', 0, 0, 1, '1', '0', '0', 4325, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20287, 'ads_tv_yle name', 'ads_tv_yle', 'i', 0, 0, 1, '1', '0', '0', 4326, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20288, 'VIP Wall Art', 'hc3_walldeco', 'i', 0, 0, 1, '1', '0', '0', 4329, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20289, 'runway_shelf name', 'runway_shelf', 'i', 0, 0, 1, '1', '0', '0', 4327, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(20290, 'ads_nokia_x6 name', 'ads_nokia_x6', 'i', 0, 0, 1, '1', '0', '0', 4330, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20291, 'ads_target_wall name', 'ads_target_wall', 'i', 0, 0, 1, '1', '0', '0', 4332, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20292, 'runway_fabric name', 'runway_fabric', 'i', 0, 0, 1, '1', '0', '0', 4331, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(20293, 'ads_latrobe_flag name', 'ads_latrobe_flag', 'i', 0, 0, 1, '1', '0', '0', 4328, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20295, 'Camera', 'camera', 's', 1, 1, 1, '0', '0', '0', 263, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20296, 'Holly', 'holly', 'i', 0, 0, 0, '1', '0', '0', 4001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(852, 'Electronic 1', 'sound_set_3', 's', 1, 1, 0.2, '1', '0', '0', 2164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(853, 'Ambient 1', 'sound_set_4', 's', 1, 1, 0.2, '1', '0', '0', 2165, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(854, 'Ambient 4', 'sound_set_5', 's', 1, 1, 0.2, '1', '0', '0', 2166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(855, 'Ambient 3', 'sound_set_6', 's', 1, 1, 0.2, '1', '0', '0', 2167, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(856, 'SFX 5', 'sound_set_7', 's', 1, 1, 0.2, '1', '0', '0', 2168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(857, 'Ambient 2', 'sound_set_8', 's', 1, 1, 0.2, '1', '0', '0', 2169, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(858, 'Electronic 2', 'sound_set_9', 's', 1, 1, 0.2, '1', '0', '0', 2170, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(859, 'Traxmachine', 'sound_machine*1', 's', 1, 1, 1, '0', '0', '0', 2171, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(860, 'Habbowood Spotlight', 'spotlight', 's', 1, 1, 1, '0', '0', '0', 2519, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(861, 'Ocean Traxmachine', 'sound_machine*2', 's', 1, 1, 1, '0', '0', '0', 2543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(862, 'Green Traxmachine', 'sound_machine*3', 's', 1, 1, 1, '0', '0', '0', 2544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(863, 'For Funky', 'sound_machine*4', 's', 1, 1, 1, '0', '0', '0', 2545, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(864, 'Brown Traxmachine', 'sound_machine*5', 's', 1, 1, 1, '0', '0', '0', 2546, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(865, 'Purple Traxmachine', 'sound_machine*6', 's', 1, 1, 1, '0', '0', '0', 2547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(866, 'Red Traxmachine', 'sound_machine*7', 's', 1, 1, 1, '0', '0', '0', 2548, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(867, 'Crystal Lamp', 'rom_lamp', 's', 1, 1, 1, '0', '0', '0', 2551, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(868, 'Polar Sofa', 'rclr_sofa', 's', 2, 1, 1, '0', '1', '0', 2459, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(869, 'Water Garden', 'rclr_garden', 's', 1, 3, 1, '0', '0', '0', 2458, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(870, 'Palm Chair', 'rclr_chair', 's', 1, 1, 1, '0', '1', '0', 2562, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(871, 'Rock 2', 'sound_set_28', 's', 1, 1, 0.2, '1', '0', '0', 2496, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(872, 'Groove 2', 'sound_set_27', 's', 1, 1, 0.2, '1', '0', '0', 2549, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(873, 'Groove 1', 'sound_set_26', 's', 1, 1, 0.2, '1', '0', '0', 2508, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(874, 'Actually', 'sound_set_25', 's', 1, 1, 0.2, '1', '0', '0', 2470, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(875, 'It''s all about the Pentiums', 'sound_set_24', 's', 1, 1, 0.2, '1', '0', '0', 2492, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(876, 'SFX 4', 'sound_set_23', 's', 1, 1, 0.2, '1', '0', '0', 2457, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(877, 'With a hamper full of sounds', 'sound_set_22', 's', 1, 1, 0.2, '1', '0', '0', 2521, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(878, 'Rock 1', 'sound_set_21', 's', 1, 1, 0.2, '1', '0', '0', 2494, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(879, 'SFX 2', 'sound_set_20', 's', 1, 1, 0.2, '1', '0', '0', 2524, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(880, 'Hip Hop Beats 4', 'sound_set_19', 's', 1, 1, 0.2, '1', '0', '0', 2469, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(881, 'Groove 4', 'sound_set_18', 's', 1, 1, 0.2, '1', '0', '0', 2497, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(882, 'Groove 3', 'sound_set_17', 's', 1, 1, 0.2, '1', '0', '0', 2550, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(883, 'Ferry', 'sound_set_16', 's', 1, 1, 0.2, '1', '0', '0', 2561, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(884, 'RnB Grooves 6', 'sound_set_15', 's', 1, 1, 0.2, '1', '0', '0', 2495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(885, 'Hip Hop Beats 2', 'sound_set_14', 's', 1, 1, 0.2, '1', '0', '0', 2482, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(886, 'Dance 5', 'sound_set_13', 's', 1, 1, 0.2, '1', '0', '0', 2523, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(887, 'Habbo Sounds 2', 'sound_set_12', 's', 1, 1, 0.2, '1', '0', '0', 2493, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(888, 'Dance 4', 'sound_set_11', 's', 1, 1, 0.2, '1', '0', '0', 2563, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(889, 'Hip Hop Beats 1', 'sound_set_10', 's', 1, 1, 0.2, '1', '0', '0', 2481, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(890, 'Rope Divider', 'rope_divider', 's', 2, 1, 0.001, '0', '0', '0', 2518, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(891, 'romantique_clock', 'romantique_clock', 's', 1, 1, 1, '0', '0', '0', 2520, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(892, 'Aqua Pura Module 5', 'rare_icecream_campaign', 's', 1, 1, 1, '0', '0', '0', 2507, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(893, 'Pink Pura Module 5', 'pura_mdl5*2', 's', 1, 1, 1, '0', '1', '0', 2510, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(894, 'Black Pura Module 5', 'pura_mdl5*3', 's', 1, 1, 1, '0', '1', '0', 2511, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(895, 'White Pura Module 5', 'pura_mdl5*4', 's', 1, 1, 1, '0', '1', '0', 2512, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(896, 'beige pura module 5', 'pura_mdl5*5', 's', 1, 1, 1, '0', '1', '0', 2513, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(897, 'Blue Pura Module 5', 'pura_mdl5*6', 's', 1, 1, 1, '0', '1', '0', 2514, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(898, 'Green Pura Module 5', 'pura_mdl5*7', 's', 1, 1, 1, '0', '1', '0', 2515, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(899, 'Yellow Pura Module 5', 'pura_mdl5*8', 's', 1, 1, 1, '0', '1', '0', 2516, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(900, 'Red Pura Module 5', 'pura_mdl5*9', 's', 1, 1, 1, '0', '1', '0', 2517, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(901, 'Aqua Pura Module 4', 'pura_mdl4*1', 's', 1, 1, 1, '0', '1', '0', 2472, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(902, 'Pink Pura Module 4', 'pura_mdl4*2', 's', 1, 1, 1, '0', '1', '0', 2473, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(903, 'Black Pura Module 4', 'pura_mdl4*3', 's', 1, 1, 1, '0', '1', '0', 2474, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(904, 'White Pura Module 4', 'pura_mdl4*4', 's', 1, 1, 1, '0', '1', '0', 2475, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(905, 'beige pura module 4', 'pura_mdl4*5', 's', 1, 1, 1, '0', '1', '0', 2476, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(906, 'Blue Pura Module 4', 'pura_mdl4*6', 's', 1, 1, 1, '0', '1', '0', 2477, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(907, 'Green Pura Module 4', 'pura_mdl4*7', 's', 1, 1, 1, '0', '1', '0', 2478, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(908, 'yellow pura module 4', 'pura_mdl4*8', 's', 1, 1, 1, '0', '1', '0', 2479, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(909, 'Red Pura Module 4', 'pura_mdl4*9', 's', 1, 1, 1, '0', '1', '0', 2480, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(910, 'Aqua Pura Module 3', 'pura_mdl3*1', 's', 1, 1, 1, '0', '1', '0', 2534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(911, 'Pink Pura Module 3', 'pura_mdl3*2', 's', 1, 1, 1, '0', '1', '0', 2535, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(912, 'Black Pura Module 3', 'pura_mdl3*3', 's', 1, 1, 1, '0', '1', '0', 2536, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(913, 'White Pura Module 3', 'pura_mdl3*4', 's', 1, 1, 1, '0', '1', '0', 2537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(914, 'beige pura module 3', 'pura_mdl3*5', 's', 1, 1, 1, '0', '1', '0', 2538, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(915, 'Blue Pura Module 3', 'pura_mdl3*6', 's', 1, 1, 1, '0', '1', '0', 2539, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(916, 'Green Pura Module 3', 'pura_mdl3*7', 's', 1, 1, 1, '0', '1', '0', 2540, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(917, 'yellow pura module 3', 'pura_mdl3*8', 's', 1, 1, 1, '0', '1', '0', 2541, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(918, 'Red Pura Module 3', 'pura_mdl3*9', 's', 1, 1, 1, '0', '1', '0', 2542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(919, 'Aqua Pura Module 2', 'pura_mdl2*1', 's', 1, 1, 1, '0', '1', '0', 2483, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(920, 'Pink Pura Module 2', 'pura_mdl2*2', 's', 1, 1, 1, '0', '1', '0', 2484, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(921, 'Black Pura Module 2', 'pura_mdl2*3', 's', 1, 1, 1, '0', '1', '0', 2485, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(922, 'White Pura Module 2', 'pura_mdl2*4', 's', 1, 1, 1, '0', '1', '0', 2486, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(923, 'beige pura module 2', 'pura_mdl2*5', 's', 1, 1, 1, '0', '1', '0', 2487, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(924, 'Blue Pura Module 2', 'pura_mdl2*6', 's', 1, 1, 1, '0', '1', '0', 2488, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(925, 'Green Pura Module 2', 'pura_mdl2*7', 's', 1, 1, 1, '0', '1', '0', 2489, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(926, 'yellow pura module 2', 'pura_mdl2*8', 's', 1, 1, 1, '0', '1', '0', 2490, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(927, 'Red Pura Module 2', 'pura_mdl2*9', 's', 1, 1, 1, '0', '1', '0', 2491, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(928, 'Aqua Pura Module 1', 'pura_mdl1*1', 's', 1, 1, 1, '0', '1', '0', 2460, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(929, 'Pink Pura Module 1', 'pura_mdl1*2', 's', 1, 1, 1, '0', '1', '0', 2461, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(930, 'Black Pura Module 1', 'pura_mdl1*3', 's', 1, 1, 1, '0', '1', '0', 2462, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(931, 'White Pura Module 1', 'pura_mdl1*4', 's', 1, 1, 1, '0', '1', '0', 2463, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(932, 'beige pura module 1', 'pura_mdl1*5', 's', 1, 1, 1, '0', '1', '0', 2464, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(933, 'Blue Pura Module 1', 'pura_mdl1*6', 's', 1, 1, 1, '0', '1', '0', 2465, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(934, 'Green Pura Module 1', 'pura_mdl1*7', 's', 1, 1, 1, '0', '1', '0', 2466, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(935, 'yellow pura module 1', 'pura_mdl1*8', 's', 1, 1, 1, '0', '1', '0', 2467, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(936, 'Red Pura Module 1', 'pura_mdl1*9', 's', 1, 1, 1, '0', '1', '0', 2468, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(937, 'Japanese Lantern', 'jp_lantern', 's', 1, 1, 1, '0', '0', '0', 2471, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(938, 'chair_basic', 'chair_basic*1', 's', 1, 1, 1.1, '0', '1', '0', 2525, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(939, 'Pink Pura Egg Chair', 'chair_basic*2', 's', 1, 1, 1.1, '0', '1', '0', 2526, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(940, 'Black Pura Egg Chair', 'chair_basic*3', 's', 1, 1, 1.1, '0', '1', '0', 2527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(941, 'White Pura Egg Chair', 'chair_basic*4', 's', 1, 1, 1.1, '0', '1', '0', 2528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(942, 'Beige Pura Egg Chair', 'chair_basic*5', 's', 1, 1, 1.1, '0', '1', '0', 2529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(943, 'Blue Pura Egg Chair', 'chair_basic*6', 's', 1, 1, 1.1, '0', '1', '0', 2530, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(944, 'Green Pura Egg Chair', 'chair_basic*7', 's', 1, 1, 1.1, '0', '1', '0', 2531, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(945, 'chair_basic', 'chair_basic*8', 's', 1, 1, 1.1, '0', '1', '0', 2532, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(946, 'Red Pura Egg Chair', 'chair_basic*9', 's', 1, 1, 1.1, '0', '1', '0', 2533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(947, '', 'bed_budget*1', 's', 2, 3, 1.9, '0', '0', '0', 2552, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(948, 'Pink Pura Double Bed', 'bed_budget*2', 's', 2, 3, 1.9, '0', '0', '0', 2553, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(949, 'Black Pura Double Bed', 'bed_budget*3', 's', 2, 3, 1.9, '0', '0', '0', 2554, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(950, 'White Pura Double Bed', 'bed_budget*4', 's', 2, 3, 1.9, '0', '0', '0', 2555, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(951, 'Beige Pura Double Bed', 'bed_budget*5', 's', 2, 3, 1.9, '0', '0', '0', 2556, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(952, 'Blue Pura Double Bed', 'bed_budget*6', 's', 2, 3, 1.9, '0', '0', '0', 2557, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(953, 'Green Pura Double Bed', 'bed_budget*7', 's', 2, 3, 1.9, '0', '0', '0', 2558, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(954, 'Yellow Pura Double Bed', 'bed_budget*8', 's', 2, 3, 1.9, '0', '0', '0', 2559, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(955, 'Red Pura Double Bed', 'bed_budget*9', 's', 2, 3, 1.9, '0', '0', '0', 2560, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(956, '', 'bed_budget_one*1', 's', 1, 3, 1.9, '0', '0', '0', 2498, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(957, 'Pink Pura Bed', 'bed_budget_one*2', 's', 1, 3, 1.9, '0', '0', '0', 2499, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(958, 'Black Pura Bed', 'bed_budget_one*3', 's', 1, 3, 1.9, '0', '0', '0', 2500, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(959, 'White Pura Bed', 'bed_budget_one*4', 's', 1, 3, 1.9, '0', '0', '0', 2501, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(960, 'Beige Pura Bed', 'bed_budget_one*5', 's', 1, 3, 1.9, '0', '0', '0', 2502, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(961, 'Blue Pura Bed', 'bed_budget_one*6', 's', 1, 3, 1.9, '0', '0', '0', 2503, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(962, 'Green Pura Bed', 'bed_budget_one*7', 's', 1, 3, 1.9, '0', '0', '0', 2504, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(963, 'Yellow Pura Bed', 'bed_budget_one*8', 's', 1, 3, 1.9, '0', '0', '0', 2505, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(964, 'Red Pura Bed', 'bed_budget_one*9', 's', 1, 3, 1.9, '0', '0', '0', 2506, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(965, 'Japanese Drawer', 'jp_drawer', 's', 1, 1, 1, '1', '0', '0', 2522, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(966, 'Star Tile', 'tile_stella', 's', 1, 1, 0.05, '1', '0', '1', 2568, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(967, 'Marble Tile', 'tile_marble', 's', 1, 1, 0.1, '1', '0', '1', 2566, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(968, 'Red Tile', 'tile_brown', 's', 1, 1, 0.05, '1', '0', '1', 2582, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(969, 'Blue Barbeque Grill', 'summer_grill*1', 's', 2, 1, 1, '0', '0', '0', 2587, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(970, 'Red Barbeque Grill', 'summer_grill*2', 's', 2, 1, 1, '0', '0', '0', 2588, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(971, 'Green Barbeque Grill', 'summer_grill*3', 's', 2, 1, 1, '0', '0', '0', 2589, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(972, 'Green Barbeque Grill', 'summer_grill*4', 's', 2, 1, 1, '0', '0', '0', 2590, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(973, 'Aqua Deck Chair', 'summer_chair*1', 's', 1, 1, 1, '0', '1', '0', 2571, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(974, 'Pink Deck Chair', 'summer_chair*2', 's', 1, 1, 1, '0', '1', '0', 2572, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(975, 'Black Deck Chair', 'summer_chair*3', 's', 1, 1, 1, '0', '1', '0', 2573, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(976, 'White Deck Chair', 'summer_chair*4', 's', 1, 1, 1, '0', '1', '0', 2574, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(977, 'Deck Chair', 'summer_chair*5', 's', 1, 1, 1, '0', '1', '0', 2575, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(978, 'Deck Chair', 'summer_chair*6', 's', 1, 1, 1, '0', '1', '0', 2576, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(979, 'Green Deck Chair', 'summer_chair*7', 's', 1, 1, 1, '0', '1', '0', 2577, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(980, 'Yellow Deck Chair', 'summer_chair*8', 's', 1, 1, 1, '0', '1', '0', 2578, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(981, 'Red Deck Chair', 'summer_chair*9', 's', 1, 1, 1, '0', '1', '0', 2579, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(982, 'Latin Love 1', 'sound_set_36', 's', 1, 1, 0.2, '1', '0', '0', 2583, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(983, 'Dance 6', 'sound_set_35', 's', 1, 1, 0.2, '1', '0', '0', 2595, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(984, 'Rock 5', 'sound_set_34', 's', 1, 1, 0.2, '1', '0', '0', 2570, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(985, 'Rock 3', 'sound_set_33', 's', 1, 1, 0.2, '1', '0', '0', 2564, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(986, 'Instrumental 2', 'sound_set_32', 's', 1, 1, 0.2, '1', '0', '0', 2569, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(987, 'Dance 3', 'sound_set_31', 's', 1, 1, 0.2, '1', '0', '0', 2596, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(988, 'Instrumental 1', 'sound_set_30', 's', 1, 1, 0.2, '1', '0', '0', 2585, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(989, 'Dance 2', 'sound_set_29', 's', 1, 1, 0.2, '1', '0', '0', 2580, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(990, 'Sound Machine Pro', 'sound_machine_pro', 's', 1, 1, 1, '0', '0', '0', 2606, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(991, 'Aqua One Way Gate', 'rare_mnstr', 's', 1, 1, 0.001, '0', '0', '0', 2584, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(992, 'Black HC Gate', 'one_way_door*2', 's', 1, 1, 0.001, '0', '0', '0', 2598, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(993, 'White HC Gate', 'one_way_door*3', 's', 1, 1, 0.001, '0', '0', '0', 2599, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(994, 'Beige One Way Gate', 'one_way_door*4', 's', 1, 1, 0.001, '0', '0', '0', 2600, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(995, 'Pink One Way Gate', 'one_way_door*5', 's', 1, 1, 0.001, '0', '0', '0', 2601, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(996, 'Blue HC Gate', 'one_way_door*6', 's', 1, 1, 0.001, '0', '0', '0', 2602, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(997, 'Green One Way Gate', 'one_way_door*7', 's', 1, 1, 0.001, '0', '0', '0', 2603, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(998, 'Yellow One Way Gate', 'one_way_door*8', 's', 1, 1, 0.001, '0', '0', '0', 2604, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(999, 'Red One Way Gate', 'one_way_door*9', 's', 1, 1, 0.001, '0', '0', '0', 2605, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(1000, 'Executive Rug', 'exe_rug', 's', 3, 3, 0, '1', '0', '1', 2567, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1001, 'Executive Glass Table', 'exe_s_table', 's', 2, 2, 1, '1', '0', '0', 2581, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1002, 'Sound set 37', 'sound_set_37', 's', 1, 1, 0.2, '1', '0', '0', 2565, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1003, 'Blue Summer Pool', 'summer_pool*1', 's', 2, 2, 0, '0', '0', '1', 2591, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1004, 'Red Summer Pool', 'summer_pool*2', 's', 2, 2, 0, '0', '0', '1', 2592, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1005, 'Green Summer Pool', 'summer_pool*3', 's', 2, 2, 0, '0', '0', '1', 2593, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1006, 'Yellow Summer Pool', 'summer_pool*4', 's', 2, 2, 0, '0', '0', '1', 2594, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1007, 'Burn', 'song_disk', 's', 1, 1, 0.1, '1', '0', '0', 2607, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20335, 'bw_boat name', 'bw_boat', 's', 2, 2, 1, '1', '1', '0', 3527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20336, 'bw_jaws', 'bw_jaws', 'i', 1, 1, 1, '1', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20337, 'bw_shower', 'bw_shower', 's', 1, 1, 0, '0', '0', '1', 3540, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20338, 'bw_tele', 'bw_tele', 's', 1, 1, 0, '0', '0', '1', 3550, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(20339, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0, '0', '0', '1', 3541, '1', '1', '1', '1', '1', 'pool', 1, '0', ''),
(29901, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3, '0', '1', '1', 3529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29902, 'bw_sofa', 'bw_sofa', 's', 1, 2, 1, '0', '0', '1', 3533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29903, 'bw_sboard', 'bw_sboard', 's', 1, 2, 1, '1', '0', '1', 3543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29904, 'bw_chair', 'bw_chair', 's', 1, 1, 1, '1', '1', '1', 3544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29905, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1, '0', '0', '0', 3539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29906, 'bw_table', 'bw_table', 's', 2, 2, 1, '1', '0', '0', 3545, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(29907, 'bw_bball', 'bw_bball', 's', 1, 1, 1, '1', '0', '0', 3547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29908, 'bw_croc', 'bw_croc', 's', 1, 1, 1, '1', '1', '0', 3542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29909, 'bw_fnc', 'bw_fnc', 's', 1, 1, 1, '1', '0', '0', 3552, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29910, 'bw_water_1', 'bw_water_1', 's', 2, 2, 0, '0', '0', '1', 3530, '1', '1', '1', '1', '1', 'lowpool', 1, '0', ''),
(29911, 'prison_dvdr2', 'prison_dvdr2', 's', 2, 1, 3, '1', '0', '0', 3532, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(29912, 'prison_gate', 'prison_gate', 's', 1, 1, 0.001, '0', '0', '0', 3526, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(29913, 'prison_dvdr1', 'prison_dvdr1', 's', 1, 1, 3, '1', '0', '0', 3534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29914, 'prison_stone', 'prison_stone', 's', 1, 1, 1, '0', '0', '0', 3537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29915, 'prison_tower', 'prison_tower', 's', 1, 1, 3, '1', '0', '1', 3531, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(29916, 'prison_crnr', 'prison_crnr', 's', 1, 1, 1, '1', '0', '0', 3528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20342, 'fball_ptch0', 'fball_ptch0', 's', 3, 3, 0, '1', '0', '1', 3520, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20343, 'fball_ptch1', 'fball_ptch1', 's', 3, 3, 0, '1', '0', '1', 3524, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20344, 'fball_ptch2 name', 'fball_ptch2', 's', 3, 3, 0, '1', '0', '1', 3511, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20345, 'fball_ptch3 name', 'fball_ptch3', 's', 3, 3, 0, '1', '0', '1', 3513, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20346, 'fball_ptch4 name', 'fball_ptch4', 's', 3, 3, 0, '1', '0', '1', 3504, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20347, 'fball_ptch5 name', 'fball_ptch5', 's', 3, 3, 0, '1', '0', '1', 3498, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20348, 'fball_ptch6 name', 'fball_ptch6', 's', 3, 3, 0, '1', '0', '1', 3517, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20349, 'fball_ptch7 name', 'fball_ptch7', 's', 3, 3, 0, '1', '0', '1', 3509, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20350, 'fball_ptch8 name', 'fball_ptch8', 's', 3, 3, 0, '1', '0', '1', 3502, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20351, 'fball_score_b', 'fball_score_b', 's', 1, 1, 1, '0', '0', '0', 3496, '1', '1', '1', '1', '1', 'footballcounterblue', 1, '0', ''),
(20352, 'fball_score_g', 'fball_score_g', 's', 1, 1, 1, '0', '0', '0', 3512, '1', '1', '1', '1', '1', 'footballcountergreen', 1, '0', ''),
(20353, 'fball_score_r', 'fball_score_r', 's', 1, 1, 1, '0', '0', '0', 3522, '1', '1', '1', '1', '1', 'footballcountered', 1, '0', ''),
(20354, 'fball_score_y', 'fball_score_y', 's', 1, 1, 1, '0', '0', '0', 3506, '1', '1', '1', '1', '1', 'footballcounteryellow', 1, '0', ''),
(20341, 'fball_counter name', 'fball_counter', 's', 2, 1, 1, '0', '0', '0', 3525, '1', '1', '1', '1', '1', 'scoreboard', 2, '0', ''),
(20340, 'fball_gate name', 'fball_gate', 's', 1, 0, 0.001, '0', '0', '1', 3516, '1', '1', '1', '1', '1', 'fbgate', 1, '0', ''),
(20355, 'fball_light name', 'fball_light', 's', 1, 0, 1, '0', '0', '0', 3499, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20356, 'fball_goal_y name', 'fball_goal_y', 's', 3, 0, 0, '1', '0', '1', 3523, '1', '1', '1', '1', '1', 'footballgoalyellow', 1, '0', ''),
(20357, 'fball_goal_r name', 'fball_goal_r', 's', 3, 0, 0, '1', '0', '1', 3514, '1', '1', '1', '1', '1', 'footballgoalred', 1, '0', ''),
(20358, 'fball_goal_g', 'fball_goal_g', 's', 3, 0, 0, '1', '0', '1', 3519, '1', '1', '1', '1', '1', 'footballgoalgreen', 1, '0', ''),
(20359, 'fball_goal_b name', 'fball_goal_b', 's', 3, 0, 0, '1', '0', '1', 3515, '1', '1', '1', '1', '1', 'footballgoalblue', 1, '0', ''),
(20360, 'fball_fnc3 name', 'fball_fnc3', 's', 1, 3, 1, '1', '0', '0', 3495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20361, 'fball_fnc1 name', 'fball_fnc1', 's', 1, 0, 1, '1', '0', '0', 3501, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20362, 'fball_crnr name', 'fball_crnr', 's', 1, 0, 1, '1', '0', '0', 3503, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20363, 'fball_cote name', 'fball_cote', 's', 3, 1, 1, '0', '0', '0', 3507, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20364, 'fball_bench name', 'fball_bench', 's', 3, 0, 1, '0', '1', '0', 3494, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20365, 'fball_ball5 name', 'fball_ball5', 's', 1, 0, 1, '0', '0', '1', 3518, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20366, 'fball_ball4 name', 'fball_ball4', 's', 1, 0, 1, '0', '0', '1', 3521, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20367, 'fball_ball3 name', 'fball_ball3', 's', 1, 0, 1, '0', '0', '1', 3497, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20368, 'fball_ball2 name', 'fball_ball2', 's', 1, 0, 1, '0', '0', '1', 3510, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20369, 'fball_ball name', 'fball_ball', 's', 1, 0, 1, '1', '0', '1', 3508, '1', '1', '1', '1', '1', 'football', 2, '0', ''),
(20370, 'fball_audbench name', 'fball_audbench', 's', 4, 1, 1, '0', '1', '0', 3500, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20371, 'fball_trophy name', 'fball_trophy', 's', 1, 1, 1, '0', '0', '0', 3505, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(10289, 'easel_0', 'easel_0', 's', 1, 1, 1, '0', '0', '0', 3582, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10290, 'easel_1', 'easel_1', 's', 1, 1, 1, '0', '0', '0', 3594, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10291, 'easel_2', 'easel_2', 's', 1, 1, 1, '0', '0', '0', 3603, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10292, 'easel_3', 'easel_3', 's', 1, 1, 1, '1', '0', '0', 3596, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(10293, 'easel_4', 'easel_4', 's', 1, 1, 1, '0', '0', '0', 3600, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(10294, 'easel_2', 'easel_2', 's', 1, 1, 1, '0', '0', '0', 3603, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20372, 'party_crate2_1', 'party_crate2_1', 's', 2, 1, 1, '1', '0', '0', 3480, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20373, 'party_crate1_3', 'party_crate1_3', 's', 1, 1, 1, '1', '0', '0', 3481, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20374, 'party_crate1_4', 'party_crate1_4', 's', 1, 1, 1, '1', '0', '0', 3485, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20375, 'party_crate1_1', 'party_crate1_1', 's', 1, 1, 1, '1', '0', '0', 3487, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20376, 'party_crate1_2', 'party_crate1_2', 's', 1, 1, 1, '1', '0', '0', 3489, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20377, 'party_crate2_2', 'party_crate2_2', 's', 2, 1, 1, '1', '0', '0', 3490, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20378, 'party_crate2_3', 'party_crate2_3', 's', 2, 1, 1, '1', '0', '0', 3491, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20379, 'party_crate2_4', 'party_crate2_4', 's', 2, 1, 1, '1', '0', '0', 3492, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20380, 'party_djset', 'pary_djset', 's', 1, 3, 3, '0', '0', '0', 3199, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25354, 'bw_boat', 'bw_boat', 's', 2, 2, 1, '1', '1', '0', 3527, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25355, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3, '0', '1', '0', 3529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25357, 'bw_sofa', 'bw_sofa', 's', 2, 1, 1, '1', '1', '0', 3533, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(25359, 'bw_fin', 'bw_fin', 's', 1, 1, 1, '1', '0', '0', 3538, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25360, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1, '0', '0', '0', 3539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25361, 'bw_shower', 'bw_shower', 's', 1, 1, 2, '1', '0', '0', 3540, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25362, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0, '0', '0', '0', 3541, '1', '1', '1', '1', '1', 'pool', 1, '0', ''),
(25363, 'bw_croc', 'bw_croc', 's', 1, 3, 1, '1', '1', '0', 3542, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25364, 'bw_sboard', 'bw_sboard', 's', 2, 1, 0, '0', '0', '0', 3543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25365, 'bw_chair', 'bw_chair', 's', 1, 1, 0.8, '1', '1', '1', 3544, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(25366, 'bw_table', 'bw_table', 's', 2, 2, 1, '1', '0', '0', 3545, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25367, 'bw_ball', 'bw_ball', 's', 1, 1, 1, '0', '0', '0', 3547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25368, 'bw_mttrss', 'bw_mttrss', 's', 1, 3, 0.8, '1', '1', '0', 3548, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25369, 'bw_van', 'bw_van', 's', 2, 2, 1, '0', '1', '0', 3549, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25371, 'bw_fnc_crnr', 'bw_fnc crnr', 's', 1, 2, 1, '1', '0', '0', 3551, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25372, 'bw_fnc', 'bw_fnc', 's', 2, 1, 1, '1', '0', '0', 3552, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(59919, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0, '0', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(59939, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0, '0', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95376, 'bw_fnc_p', 'bw_fnc_p', 's', 2, 1, 1, '1', '0', '0', 3569, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95377, 'bw_fnc_crnr_g', 'bw_fnc_crnr_g', 's', 1, 2, 1, '1', '0', '0', 3563, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95378, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1, '1', '1', '1', 3561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95379, 'bw_boat_g', 'bw_boat_g', 's', 2, 2, 0.8, '1', '1', '0', 3568, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95380, 'bw_mttrss_g', 'bw_mttrss_g', 's', 1, 3, 0.8, '1', '0', '0', 3558, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95381, 'bw_pool_b2', 'bw_pool_b2', 's', 2, 1, 1, '1', '0', '0', 3565, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95382, 'bw_pool_a2', 'bw_pool_a2', 's', 2, 1, 1, '1', '0', '0', 3564, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95383, 'bw_pool_a3', 'bw_pool_a3', 's', 1, 1, 0, '1', '0', '0', 3556, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95384, 'bw_pool_a1', 'bw_pool_a1', 's', 1, 1, 1, '1', '1', '0', 3577, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95375, 'ads_pepsi0', 'ads_pepsi0', 's', 1, 1, 3, '0', '0', '0', 3554, '1', '1', '1', '1', '1', 'vendingmachine', 1, '55', ''),
(95374, 'ads_grefusa_surfb', 'ads_grefusa_surfb', 'i', 0, 0, 0, '0', '0', '0', 4337, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95385, 'bw_pool_b1', 'bw_pool_b1', 's', 1, 1, 1, '1', '0', '0', 3560, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95386, 'bw_fnc_crnr_p', 'bw_fnc_crnr_p', 's', 1, 2, 1, '0', '0', '0', 3576, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95387, 'bw_sboard_g', 'bw_sboard_g', 's', 2, 1, 0, '0', '0', '0', 3562, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95388, 'bw_sboard_p', 'bw_sboard_p', 's', 2, 1, 0, '0', '0', '0', 3571, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95389, 'bw_table_g', 'bw_table_g', 's', 2, 2, 1, '1', '0', '0', 3566, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95390, 'bw_table_p', 'bw_table_p', 's', 2, 1, 0, '1', '0', '0', 3578, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95391, 'bw_van_p', 'bw_van_p', 's', 2, 2, 1, '0', '1', '0', 3570, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95392, 'bw_van_g', 'bw_van_g', 's', 2, 2, 1, '0', '1', '0', 3574, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95393, 'bw_sofa_g', 'bw_sofa_g', 's', 2, 1, 1, '1', '1', '0', 3575, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95394, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1, '1', '1', '0', 3561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95395, 'bw_fnc_g name', 'bw_fnc_g', 's', 2, 1, 1, '1', '0', '0', 3557, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95397, 'bw_tele', 'bw_tele', 's', 1, 1, 3, '0', '0', '0', 3550, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(10355, 'african_tree2', 'african_tree2', 's', 1, 1, 1, '0', '0', '0', 3605, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10354, 'african_tree1', 'african_tree1', 's', 1, 1, 1, '0', '0', '0', 3584, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10353, 'african_stage', 'african_stage', 's', 2, 2, 1, '1', '0', '1', 3607, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10352, 'african_patch', 'african_patch', 's', 2, 2, 1, '0', '0', '1', 3602, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10351, 'african_fence', 'african_fence', 's', 1, 2, 1, '0', '0', '0', 3579, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10350, 'african_bones', 'african_bones', 's', 1, 1, 1, '0', '0', '0', 3609, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10357, 'ktchn10_cabnt', 'ktchn10_cabnt', 'i', 0, 0, 0, '0', '0', '0', 4338, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10358, 'ktchn10_pot', 'ktchn10_pot', 's', 1, 1, 1, '0', '0', '0', 3580, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10359, 'ktchn10_sink', 'ktchn10_sink', 's', 2, 1, 1, '0', '0', '0', 3612, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10360, 'ktchn10_stove', 'ktchn10_stove', 's', 2, 1, 1, '0', '0', '0', 3581, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10278, 'hosptl_bbag name', 'hosptl_bbag', 's', 1, 3, 1, '0', '0', '0', 3591, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(10279, 'hosptl_bed', 'hosptl_bed', 's', 1, 3, 1, '0', '0', '0', 3590, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(10280, 'hosptl_cab1', 'hosptl_cab1', 's', 1, 1, 1, '0', '0', '0', 3586, '1', '1', '1', '1', '1', 'vendingmachine', 2, '35', ''),
(10281, 'hosptl_cab2', 'hosptl_cab2', 's', 2, 1, 1, '0', '0', '0', 3608, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10282, 'hosptl_curtain', 'hosptl_curtain', 's', 3, 1, 1, '0', '0', '0', 3588, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(10283, 'hosptl_defibs', 'hosptl_defibs', 's', 1, 1, 1, '0', '0', '0', 3606, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10284, 'hosptl_light', 'hosptl_light', 's', 1, 1, 1, '0', '0', '0', 3610, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10285, 'hosptl_seat', 'hosptl_seat', 's', 1, 2, 1, '0', '1', '0', 3611, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10286, 'hosptl_skele', 'hosptl_skele', 's', 1, 1, 1, '0', '0', '0', 3604, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10287, 'hosptl_xray', 'hosptl_xray', 'i', 0, 0, 0, '0', '0', '0', 4339, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89945, 'cubie_rug_b', 'cubie_rug_b', 's', 2, 3, 0.1, '1', '0', '1', 3860, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89946, 'cubie_lamp_p', 'cubie_lamp_p', 's', 1, 1, 1, '0', '0', '0', 3863, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89947, 'cubie_shelf_3_p', 'cubie_shelf_3_p', 's', 2, 1, 1, '1', '0', '0', 3873, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(89948, 'cubie_shelf_4_b', 'cubie_shelf_4_b', 's', 3, 1, 1, '1', '0', '0', 3882, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89949, 'cubie_shelf_1_b', 'cubie_shelf_1_b', 's', 1, 1, 1, '0', '0', '0', 3875, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89950, 'cubie_shelf_1_p', 'cubie_shelf_1_p', 's', 1, 1, 1, '0', '0', '0', 3874, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89951, 'cubie_chair_p', 'cubie_chair_p', 's', 1, 1, 1.2, '0', '1', '0', 3879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89952, 'cubie_shelf_4_p', 'cubie_shelf_4_p', 's', 3, 1, 1, '0', '0', '0', 3866, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89953, 'cubie_bigtable_p', 'cubie_bigtable_p', 's', 2, 2, 0.5, '1', '0', '1', 3876, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89954, 'cubie_shelf_0_p', 'cubie_shelf_0_p', 's', 1, 1, 0.5, '1', '0', '0', 3884, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89955, 'cubie_beanbag_b', 'cubie_beanbag_b', 's', 1, 1, 1, '0', '1', '0', 3877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89956, 'cubie_chair_b', 'cubie_chair_b', 's', 1, 1, 1.2, '0', '1', '0', 3859, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89957, 'cubie_bed_b', 'cubie_bed_b', 's', 1, 3, 1.8, '0', '0', '0', 3871, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(89958, 'cubie_bigtable_b', 'cubie_bigtable_b', 's', 2, 2, 0.5, '1', '0', '1', 3861, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89959, 'cubie_stool_b', 'cubie_stool_b', 's', 1, 1, 1.2, '0', '1', '0', 3869, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89960, 'cubie_beanbag_p', 'cubie_beanbag_p', 's', 1, 1, 1, '0', '1', '0', 3862, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89961, 'cubie_shelf_0_b', 'cubie_shelf_0_b', 's', 1, 1, 0.5, '1', '0', '0', 3865, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89962, 'cubie_shelf_2_p', 'cubie_shelf_2_p', 's', 2, 1, 1, '1', '0', '0', 3867, '1', '1', '1', '1', '1', 'default', 17, '0', ''),
(89963, 'cubie_rug_p', 'cubie_rug_p', 's', 2, 3, 0.1, '1', '0', '1', 3870, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89964, 'cubie_sofaseat_b', 'cubie_sofaseat_b', 's', 1, 1, 1, '0', '1', '0', 3881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89965, 'cubie_table', 'cubie_table', 's', 1, 2, 1, '1', '0', '0', 3880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89966, 'cubie_sofaseat_p', 'cubie_sofaseat_p', 's', 1, 1, 1, '0', '1', '0', 3864, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89967, 'cubie_bed_p', 'cubie_bed_p', 's', 1, 3, 1.8, '0', '0', '0', 3868, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(89968, 'cubie_shelf_3_b', 'cubie_shelf_3_b', 's', 2, 1, 1, '1', '0', '0', 3872, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(89969, 'cubie_shelf_2_b', 'cubie_shelf_2_b', 's', 2, 1, 1, '1', '0', '0', 3883, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89970, 'cubie_lamp_b', 'cubie_lamp_b', 's', 1, 1, 1, '0', '0', '0', 3858, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89971, 'cubie_stool_p', 'cubie_stool_p', 's', 1, 1, 1.2, '0', '1', '0', 3878, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89972, 'cubie_wallshelf_b', 'cubie_wallshelf_b', 'i', 1, 1, 1, '1', '0', '0', 4389, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89973, 'cubie_decklight_p', 'cubie_decklight_p', 'i', 1, 1, 1, '1', '0', '0', 4385, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89974, 'cubie_wallshelf_p', 'cubie_wallshelf_p', 'i', 1, 1, 1, '1', '0', '0', 4392, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89975, 'cubie_decal_0', 'cubie_decal_0', 'i', 1, 1, 1, '1', '0', '0', 4395, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89976, 'cubie_decal_3', 'cubie_decal_3', 'i', 1, 1, 1, '1', '0', '0', 4391, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89977, 'cubie_decal_1_p', 'cubie_decal_1_p', 'i', 1, 1, 1, '1', '0', '0', 4390, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89978, 'cubie_decklight_b', 'cubie_decklight_b', 'i', 1, 1, 1, '1', '0', '0', 4394, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89979, 'cubie_decal_1_b', 'cubie_decal_1_b', 'i', 1, 1, 1, '1', '0', '0', 4386, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89980, 'cubie_decal_2_b', 'cubie_decal_2_b', 'i', 1, 1, 1, '1', '0', '0', 4387, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89981, 'cubie_decal_3_p', 'cubie_decal_3_p', 'i', 1, 1, 1, '1', '0', '0', 4388, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89982, 'cubie_decal_2_p', 'cubie_decal_2_p', 'i', 1, 1, 1, '1', '0', '0', 4393, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89983, 'cubie_decal_3_b', 'cubie_decal_3_b', 'i', 1, 1, 1, '1', '0', '0', 4384, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89984, 'newbie_present', 'newbie_present', 's', 1, 1, 1, '1', '0', '0', 3885, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89985, 'tv_flat', 'tv_flat', 's', 2, 1, 1, '0', '0', '0', 3886, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89986, 'waasa_table2', 'waasa_table2', 's', 2, 1, 1, '1', '0', '0', 3887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89987, 'computer_flatscreen', 'computer_flatscreen', 's', 1, 1, 1, '0', '0', '0', 3888, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89988, 'waasa_chair', 'waasa_chair', 's', 1, 1, 1.2, '0', '1', '0', 3889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89989, 'waasa_ship2', 'waasa_ship2', 's', 2, 1, 1, '0', '0', '0', 3890, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89990, 'waasa_ship1', 'waasa_ship1', 's', 1, 1, 1, '0', '0', '0', 3891, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89991, 'waasa_bunk_bed', 'waasa_bunk_bed', 's', 3, 1, 1, '1', '0', '0', 3892, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89992, 'computer_laptop', 'computer_laptop', 's', 1, 1, 1, '0', '0', '0', 3893, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89993, 'computer_old', 'computer_old', 's', 1, 1, 1, '0', '0', '0', 3894, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89994, 'waasa_table1', 'waasa_table1', 's', 1, 1, 1, '1', '0', '0', 3895, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89995, 'waasa_desk', 'waasa_desk', 's', 2, 1, 1, '1', '0', '0', 3896, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89996, 'waasa_wall_shelf2', 'waasa_wall_shelf2', 'i', 1, 1, 1, '1', '0', '0', 4396, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89997, 'waasa_wall_shelf1', 'waasa_wall_shelf1', 'i', 1, 1, 1, '1', '0', '0', 4397, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89914, 'nest_frog', 'nest_frog', 's', 1, 1, 0.1, '0', '0', '1', 3830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89915, 'pond', 'pond', 's', 1, 1, 0.01, '0', '0', '1', 3831, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89916, 'val11_present', 'val11_present', 's', 1, 1, 1.2, '1', '0', '0', 3832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89917, 'prizetrophy_cine', 'prizetrophy_cine', 's', 1, 1, 1, '0', '0', '0', 3833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89918, 'cine_vipsign', 'cine_vipsign', 's', 1, 1, 1, '0', '0', '0', 3834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89919, 'limo_b_mid3', 'limo_b_mid3', 's', 2, 1, 1, '0', '0', '0', 3835, '1', '1', '1', '1', '1', 'vendingmachine', 1, '50', ''),
(89920, 'limo_b_mid2', 'limo_b_mid2', 's', 2, 1, 0.3, '0', '0', '1', 3836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89921, 'limo_b_front', 'limo_b_front', 's', 2, 1, 1, '0', '0', '0', 3837, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89922, 'limo_b_mid', 'limo_b_mid', 's', 2, 1, 1.2, '0', '1', '0', 3838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89923, 'cine_star', 'cine_star', 's', 1, 1, 0.1, '1', '0', '1', 3839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89924, 'limo_b_back', 'limo_b_back', 's', 2, 1, 1.2, '0', '1', '0', 3840, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89925, 'ads_bigtv_missmix', 'ads_bigtv_missmix', 'i', 1, 1, 1, '0', '0', '0', 4381, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89926, 'cine_curtain', 'cine_curtain', 's', 8, 1, 0.001, '0', '0', '0', 3841, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(89927, 'cine_screen', 'cine_screen', 's', 8, 1, 1, '0', '0', '0', 3842, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89928, 'theatre_seat_g', 'theatre_seat_g', 's', 1, 1, 1, '0', '1', '0', 3843, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89929, 'cine_tile', 'cine_tile', 's', 1, 1, 0.1, '0', '0', '1', 3844, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89930, 'cine_bench_b', 'cine_bench_b', 's', 3, 1, 1.1, '0', '1', '0', 3845, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89931, 'theatre_seat_b', 'theatre_seat_b', 's', 1, 1, 1, '0', '1', '0', 3846, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89932, 'cine_roof', 'cine_roof', 's', 3, 3, 0.1, '0', '0', '1', 3847, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89933, 'cine_popcorn', 'cine_popcorn', 's', 1, 1, 1, '0', '0', '0', 3848, '1', '1', '1', '1', '1', 'vendingmachine', 1, '62', ''),
(89934, 'cine_bench', 'cine_bench', 's', 3, 1, 1.1, '0', '1', '0', 3849, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89935, 'cine_bench_g', 'cine_bench_g', 's', 3, 1, 1.1, '0', '1', '0', 3850, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89936, 'cine_ticket_booth', 'cine_ticket_booth', 's', 1, 1, 1, '0', '0', '0', 3851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89937, 'cine_projector', 'cine_projector', 's', 1, 1, 1, '0', '0', '0', 3852, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89907, 'gothic_st_glass', 'gothic_st_glass', 'i', 1, 1, 1, '0', '0', '0', 4380, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89908, 'gothic_candles', 'gothic_candles', 's', 1, 1, 1, '0', '0', '0', 3825, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89909, 'gothic_bed', 'gothic_bed', 's', 2, 3, 1, '0', '1', '0', 3824, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89910, 'gothic_bowl', 'gothic_bowl', 's', 1, 1, 1, '0', '0', '0', 3828, '1', '1', '1', '1', '1', 'vendingmachine', 1, '62', ''),
(89911, 'gothic_desk', 'gothic_desk', 's', 1, 2, 1, '0', '0', '0', 3826, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89912, 'ads_grefu_trophy', 'ads_grefu_trophy', 's', 1, 1, 1, '0', '0', '0', 3827, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(77701, 'bling11_block', 'bling11_block', 's', 1, 1, 2, '1', '0', '0', 3801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77702, 'bling11_dvd', 'bling11_dvd', 's', 1, 2, 1.6, '1', '0', '0', 3793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77703, 'bling11_dvn', 'bling11_dnv', 's', 1, 3, 1.2, '0', '0', '0', 3798, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(77704, 'bling11_floor', 'bling11_floor', 's', 1, 1, 0.1, '1', '0', '0', 3794, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(77705, 'bling11_pillar', 'bling11_pillar', 's', 1, 1, 3.3, '1', '0', '0', 3802, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77706, 'bling11_plant', 'bling11_plant', 's', 1, 1, 1, '0', '0', '0', 3795, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77707, 'bling11_rug1', 'bling11_rug1', 's', 2, 2, 0.1, '1', '0', '1', 3788, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77708, 'bling11_rug2', 'bling11_rug2', 's', 3, 3, 0.2, '1', '0', '1', 3797, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77709, 'bling11_seat1', 'bling11_seat1', 's', 1, 1, 1, '0', '1', '0', 3800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77710, 'bling11_seat2', 'bling11_seat2', 's', 1, 1, 1.2, '0', '1', '0', 3799, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(77711, 'bling11_slot', 'bling11_slot', 's', 1, 1, 1, '0', '0', '0', 3786, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77712, 'bling11_sofa', 'bling11_sofa', 's', 3, 1, 0.4, '0', '1', '0', 3790, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77713, 'bling11_statue1', 'bling11_statue1', 's', 1, 1, 1, '0', '0', '0', 3791, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77714, 'bling11_statue2', 'bling11_statue2', 's', 2, 2, 1, '0', '0', '0', 3785, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77715, 'bling11_tele', 'bling11_tele', 's', 1, 1, 0.1, '0', '0', '0', 3789, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(77716, 'bling11_towels', 'bling11_towels', 's', 1, 1, 1, '0', '0', '0', 3787, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77717, 'val11_floor', 'val11_floor', 's', 2, 2, 0.1, '1', '0', '1', 3792, '1', '1', '1', '1', '1', 'normalskates', 1, '0', ''),
(77801, 'china_rabbit', 'china_rabbit', 's', 1, 1, 1, '0', '0', '0', 3796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89900, 'limo_w_front', 'limo_w_front', 's', 2, 1, 1, '0', '0', '0', 3823, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89901, 'limo_w_mid', 'limo_w_mid', 's', 2, 1, 1, '0', '1', '0', 3819, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89902, 'limo_w_mid2', 'limo_w_mid2', 's', 2, 1, 0.3, '0', '0', '1', 3820, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89903, 'limo_w_back', 'limo_w_back', 's', 2, 1, 1, '0', '1', '0', 3822, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89904, 'petfood19', 'petfood19', 's', 1, 1, 0.001, '0', '0', '1', 3821, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89905, 'petfood18', 'petfood18', 's', 1, 1, 0.001, '0', '0', '1', 3816, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89906, 'petfood17', 'petfood17', 's', 1, 1, 0.001, '0', '0', '1', 3817, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(30000, 'hween10_bat', 'hween10_bat', 's', 1, 1, 1, '0', '0', '0', 3662, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30001, 'hween10_card_1', 'hween10_card_1', 'i', 1, 1, 1, '1', '0', '0', 4346, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30002, 'hween10_card_2', 'hween10_card_2', 'i', 1, 1, 1, '1', '0', '0', 4350, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30003, 'hween10_card_3', 'hween10_card_3', 'i', 1, 1, 1, '1', '0', '0', 4345, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30004, 'hween10_card_4', 'hween10_card_4', 'i', 1, 1, 1, '1', '0', '0', 4347, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30005, 'hween10_card_5', 'hween10_card_5', 'i', 1, 1, 1, '1', '0', '0', 4351, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30006, 'hween10_card_6', 'hween10_card_6', 'i', 1, 1, 1, '1', '0', '0', 4348, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30007, 'hween10_chicken', 'hween10_chicken', 's', 2, 1, 1, '1', '0', '0', 3658, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30008, 'hween10_ffly', 'hween10_ffly', 's', 1, 1, 1, '1', '0', '0', 3657, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30009, 'hween10_fog', 'hween10_fog', 's', 2, 2, 0.0001, '1', '0', '1', 3652, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30010, 'hween10_jar', 'hween10_jar', 's', 1, 1, 1, '1', '0', '0', 3651, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30011, 'hween10_logs', 'hween10_logs', 's', 1, 1, 0.3, '0', '0', '1', 3656, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30012, 'hween10_pond', 'hween10_pond', 's', 2, 2, 0.01, '1', '0', '1', 3650, '1', '1', '1', '1', '1', 'haloweenpool', 1, '0', ''),
(30013, 'hween10_portch', 'hween10_portch', 's', 1, 1, 1, '0', '0', '1', 3661, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(30014, 'hween10_skullpost', 'hween10_skullpost', 's', 1, 1, 1, '1', '0', '0', 3654, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30015, 'hween10_swamp', 'hween10_swamp', 's', 2, 2, 0.01, '1', '0', '0', 3649, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30016, 'hween10_tarot', 'hween10_tarot', 's', 1, 1, 1, '1', '0', '0', 3646, '1', '1', '1', '1', '1', 'dice', 7, '0', ''),
(30017, 'hween10_tele', 'hween10_tele', 's', 1, 1, 0.1, '1', '0', '0', 3659, '1', '1', '1', '1', '1', 'teleport', 2, '0', ''),
(30018, 'hween10_throne', 'hween10_throne', 's', 1, 1, 1.2, '0', '1', '0', 3660, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30019, 'hween10_tree', 'hween10_tree', 's', 1, 1, 1, '1', '0', '0', 3648, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30020, 'hween10_voodoo1', 'hween10_voodoo1', 's', 1, 1, 1, '1', '0', '0', 3647, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30021, 'hween10_voodoo2', 'hween10_voodoo2', 's', 1, 1, 1, '1', '0', '0', 3653, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30022, 'hween10_voodoo3', 'hween10_voodoo3', 's', 1, 1, 1, '1', '0', '0', 3655, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30023, 'hween10_wallskull', 'hween10_wallskull', 'i', 1, 1, 1, '1', '0', '0', 4349, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99904, 'year2011_waver_b', 'year2011_waver_b', 's', 1, 1, 3, '0', '0', '0', 3781, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99905, 'year2011_waver_g', 'year2011_waver_g', 's', 1, 1, 3, '0', '0', '0', 3780, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99906, 'year2011_waver_r', 'year2011_waver_r', 's', 1, 1, 3, '0', '0', '0', 3777, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99907, 'year2011_waver_y', 'year2011_waver_y', 's', 1, 1, 3, '0', '0', '0', 3768, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99908, 'prizetrophy_2011_y', 'prizetrophy_2011_y', 's', 1, 1, 3, '0', '0', '0', 3771, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99909, 'prizetrophy_2011_b', 'prizetrophy_2011_b', 's', 1, 1, 3, '0', '0', '0', 3773, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99910, 'prizetrophy_2011_r', 'prizetrophy_2011_r', 's', 1, 1, 3, '0', '0', '0', 3770, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99911, 'prizetrophy_2011_p', 'prizetrophy_2011_p', 's', 1, 1, 3, '0', '0', '0', 3775, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99912, 'prizetrophy_2011_g', 'prizetrophy_2011_g', 's', 1, 1, 3, '0', '0', '0', 3778, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99913, 'prizetrophy_2011_w', 'prizetrophy_2011_w', 's', 1, 1, 3, '0', '0', '0', 3769, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99914, 'year2011', 'year2011', 'i', 1, 1, 1, '0', '0', '0', 4373, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99000, 'qt_xm10_nest', 'qt_xm10_nest', 's', 1, 1, 1, '0', '0', '0', 3742, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99001, 'qt_xm10_icedragon', 'qt_xm10_icedragon', 's', 1, 1, 1, '0', '0', '0', 3746, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99002, 'qt_xm10_stone', 'qt_xm10_stone', 's', 2, 1, 1, '0', '0', '0', 3747, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99003, 'qt_xm10_icetiger', 'qt_xm10_icetiger', 's', 1, 1, 1, '0', '0', '0', 3728, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99004, 'qt_xm10_trex', 'qt_xm10_trex', 's', 3, 7, 1, '0', '0', '0', 3722, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99005, 'qt_xm10_palm_tree', 'qt_xm10_palm_tree', 's', 1, 1, 3, '0', '0', '0', 3720, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99006, 'qt_xm10_bench', 'qt_xm10_bench', 's', 2, 1, 1, '0', '0', '0', 3750, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99007, 'qt_xm10_icelupin', 'qt_xm10_icelupin', 's', 1, 1, 1, '0', '0', '0', 3732, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99008, 'qt_xm10_xmduck', 'qt_xm10_xmduck', 's', 1, 1, 1, '0', '0', '0', 3719, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99009, 'qt_xm10_iceduck', 'qt_xm10_iceduck', 's', 1, 1, 1, '0', '0', '0', 3727, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99010, 'qt_xm10_bauble1', 'qt_xm10_bauble1', 'i', 1, 1, 1, '0', '0', '0', 4365, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99011, 'qt_xm10_bauble2', 'qt_xm10_bauble2', 'i', 1, 1, 1, '0', '0', '0', 4361, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99012, 'qt_xm10_bauble3', 'qt_xm10_bauble3', 'i', 1, 1, 1, '0', '0', '0', 4368, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99013, 'qt_xm10_iceplasto', 'qt_xm10_iceplasto', 's', 1, 1, 1, '0', '1', '0', 3730, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99014, 'qt_xm10_ice_fish', 'qt_xm10_ice_fish', 's', 1, 2, 3, '0', '0', '0', 3748, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99015, 'qt_xm10_gnome', 'qt_xm10_gnome', 's', 1, 2, 1, '0', '0', '0', 3726, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99016, 'qt_xm10_icesilotable', 'qt_xm10_icesilotable', 's', 1, 1, 1, '0', '0', '0', 3743, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99017, 'qt_xm10_iceteddy', 'qt_xm10_iceteddy', 's', 1, 1, 1, '0', '0', '0', 3734, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99018, 'qt_xm10_elephant', 'qt_xm10_elephant', 's', 1, 1, 1, '0', '0', '0', 3724, '1', '1', '1', '1', '1', 'vendingmachine', 2, '0', ''),
(99019, 'qt_xm10_iceclubsofa', 'qt_xm10_iceclubsofa', 's', 2, 1, 1, '0', '1', '0', 3718, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99020, 'es_skating_ice', 'es_skating_ice', 's', 2, 2, 0.01, '0', '0', '1', 3736, '1', '1', '1', '1', '1', 'iceskates', 2, '0', ''),
(99021, 'es_sidewalk', 'es_sidewalk', 's', 2, 2, 0.2, '0', '0', '1', 3716, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99022, 'es_wpost', 'es_wpost', 's', 1, 1, 1, '0', '0', '0', 3725, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99023, 'es_tagging', 'es_tagging', 's', 1, 1, 3, '0', '0', '0', 3741, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99024, 'es_santa', 'es_santa', 's', 1, 1, 1, '0', '0', '0', 3740, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99025, 'es_window', 'es_window', 'i', 1, 1, 1, '0', '0', '0', 4367, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99026, 'es_bench', 'es_bench', 's', 2, 1, 1, '0', '1', '0', 3712, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99027, 'es_fnc_1', 'es_fnc_1', 's', 1, 1, 1, '0', '0', '0', 3729, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99028, 'es_fnc_2', 'es_fnc_2', 's', 1, 1, 1, '0', '0', '0', 3714, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99029, 'es_fnc_crnr', 'es_fnc_crnr', 's', 1, 1, 1, '0', '0', '0', 3721, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99030, 'es_epictree', 'es_epictree', 's', 2, 2, 4, '0', '0', '0', 3723, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99031, 'es_icestar_g', 'es_icestar_g', 's', 1, 1, 6, '0', '0', '0', 3731, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99032, 'es_icestar_r', 'es_icestar_r', 's', 1, 1, 6, '0', '0', '0', 3745, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99033, 'es_icestar_y', 'es_icestar_y', 's', 1, 1, 6, '0', '0', '0', 3749, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99034, 'es_icestar', 'es_icestar', 's', 1, 1, 6, '0', '0', '0', 3713, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99035, 'es_puck', 'es_puck', 's', 1, 1, 1, '0', '0', '0', 3739, '1', '1', '1', '1', '1', '', 2, '0', ''),
(99036, 'es_roaster', 'es_roaster', 's', 1, 1, 2, '0', '0', '0', 3738, '1', '1', '1', '1', '1', 'default', 2, '0', '');
INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(99037, 'es_lmppst', 'es_lmppst', 's', 1, 1, 4, '0', '0', '0', 3735, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99038, 'es_statue', 'es_statue', 's', 1, 1, 1, '0', '0', '0', 3717, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568401, 'exe_copier', 'exe_copier', 's', 1, 1, 1, '0', '0', '0', 3704, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568402, 'exe_glassdvdr', 'exe_glassdvdr', 's', 1, 1, 1, '0', '0', '0', 3706, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568403, 'exe_wrkdesk', 'exe_wrkdesk', 's', 1, 1, 1, '0', '0', '0', 3705, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568404, 'exe_seccam', 'exe_seccam', 's', 1, 1, 1, '0', '0', '1', 3707, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568405, 'exe_sensor', 'exe_sensor', 'i', 1, 1, 1, '0', '0', '0', 4356, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99080, 'es_big3', 'es_big3', 'i', 1, 1, 0.5, '1', '0', '1', 4371, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99081, 'es_big2', 'es_big2', 'i', 1, 1, 0.5, '1', '0', '1', 4372, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99082, 'Freeze Ice Block', 'es_box', 's', 1, 1, 0.5, '1', '0', '0', 3758, '1', '1', '1', '1', '1', 'freezetileblock', 1, '0', ''),
(99083, 'Freese Counter', 'es_counter', 's', 1, 3, 1, '0', '0', '0', 3764, '1', '1', '1', '1', '1', 'freezetimer', 1, '0', ''),
(99084, 'Exit Tile', 'es_exit', 's', 1, 1, 0.1, '1', '0', '1', 3759, '1', '1', '1', '1', '1', 'freezeexit', 1, '0', ''),
(99085, 'Blue Freeze Gate', 'es_gate_b', 's', 1, 1, 1, '0', '0', '1', 3762, '1', '1', '1', '1', '1', 'freezebluegate', 1, '0', ''),
(99086, 'Green Freeze Gate', 'es_gate_g', 's', 1, 1, 0, '0', '0', '1', 3761, '1', '1', '1', '1', '1', 'freezegreengate', 1, '0', ''),
(99087, 'Red Freeze Gate', 'es_gate_r', 's', 1, 1, 0, '0', '0', '1', 3760, '1', '1', '1', '1', '1', 'freezeredgate', 1, '0', ''),
(99088, 'Yellow Freeze Gate', 'es_gate_y', 's', 1, 1, 0, '0', '0', '1', 3763, '1', '1', '1', '1', '1', 'freezeyellowgate', 1, '0', ''),
(99089, 'Yellow Freeze Scoreboard', 'es_score_y', 's', 1, 1, 0, '0', '0', '0', 3767, '1', '1', '1', '1', '1', 'freezeyellowcounter', 1, '0', ''),
(99090, 'Red Freeze Scoreboard', 'es_score_r', 's', 1, 1, 0, '0', '0', '0', 3765, '1', '1', '1', '1', '1', 'freezeredcounter', 1, '0', ''),
(99091, 'Blue Freeze Scoreboard', 'es_score_b', 's', 1, 1, 0, '0', '0', '0', 3756, '1', '1', '1', '1', '1', 'freezebluecounter', 1, '0', ''),
(99092, 'Green Freeze Scoreboard', 'es_score_g', 's', 1, 1, 0, '0', '0', '0', 3766, '1', '1', '1', '1', '1', 'freezegreencounter', 1, '0', ''),
(99093, 'Freeze Tile', 'es_tile', 's', 1, 1, 0, '1', '0', '1', 3757, '1', '1', '1', '1', '1', 'freezetile', 1, '0', ''),
(89938, 'wf_box', 'wf_box', 's', 1, 1, 1.2, '1', '0', '0', 3853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89939, 'wf_maze', 'wf_maze', 's', 1, 1, 1, '0', '0', '0', 3854, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89940, 'ads_rangocactus', 'ads_rangocactus', 's', 1, 1, 1, '0', '0', '0', 3855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89941, 'cine_glass', 'cine_glass', 's', 1, 1, 0.01, '1', '0', '0', 3856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89942, 'wf_cnd_has_furni_on', 'wf_cnd_has_furni_on', 's', 1, 1, 0.6, '1', '0', '0', 3857, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89943, 'cine_light2', 'cine_light2', 'i', 1, 1, 1, '1', '0', '0', 4382, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89944, 'cine_light1', 'cine_light1', 'i', 1, 1, 1, '1', '0', '0', 4383, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20320, 'a0 pet4', 'a0 pet4', 's', 1, 1, 0, '0', '0', '0', 2431, '0', '0', '0', '0', '0', 'pet4', 1, '0', ''),
(20321, 'a0 pet3', 'a0 pet3', 's', 1, 1, 0, '0', '0', '0', 2430, '0', '0', '0', '0', '0', 'pet3', 1, '0', ''),
(20322, 'a0 pet2', 'a0 pet2', 's', 1, 1, 0, '0', '0', '0', 2434, '0', '0', '0', '0', '0', 'pet2', 1, '0', ''),
(20323, 'a0 pet1', 'a0 pet1', 's', 1, 1, 0, '0', '0', '0', 2432, '0', '0', '0', '0', '0', 'pet1', 1, '0', ''),
(20324, 'a0 pet0', 'a0 pet0', 's', 1, 1, 0, '0', '0', '0', 2433, '0', '0', '0', '0', '0', 'pet0', 1, '0', ''),
(20411, 'a0 pet6', 'a0 pet6', 's', 1, 1, 0, '0', '0', '0', 7457, '0', '0', '0', '0', '0', 'pet6', 0, '0', ''),
(20412, 'a0 pet7', 'a0 pet7', 's', 1, 1, 0, '0', '0', '0', 5354, '0', '0', '0', '0', '0', 'pet7', 0, '0', ''),
(3568412, 'a0 pet8', 'a0 pet8', 's', 1, 1, 1, '1', '0', '0', 6489, '1', '1', '1', '1', '1', 'pet8', 1, '0', ''),
(3568413, 'a0 pet11', 'a0 pet11', 's', 1, 1, 1, '1', '0', '0', 6490, '1', '1', '1', '1', '1', 'pet11', 1, '0', ''),
(3568422, 'a0 pet10', 'a0 pet10', 's', 0, 0, 0, '0', '0', '0', 1532, '1', '1', '1', '1', '1', 'pet10', 1, '0', ''),
(3568406, 'wallpaper_single_101', 'wallpaper_single_101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568407, 'wallpaper_single_102', 'wallpaper_single_102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568408, 'wallpaper_single_103', 'wallpaper_single_103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568409, 'wallpaper_single_104', 'wallpaper_single_104', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568410, 'wallpaper_single_105', 'wallpaper_single_105', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568411, 'wallpaper_single_106', 'wallpaper_single_106', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568412, 'wallpaper_single_107', 'wallpaper_single_107', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568413, 'wallpaper_single_108', 'wallpaper_single_108', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568414, 'wallpaper_single_109', 'wallpaper_single_109', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568415, 'wallpaper_single_110', 'wallpaper_single_110', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568416, 'wallpaper_single_111', 'wallpaper_single_111', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568417, 'wallpaper_single_112', 'wallpaper_single_112', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568418, 'wallpaper_single_113', 'wallpaper_single_113', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568419, 'wallpaper_single_114', 'wallpaper_single_114', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568420, 'wallpaper_single_115', 'wallpaper_single_115', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568421, 'wallpaper_single_201', 'wallpaper_single_201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568422, 'wallpaper_single_202', 'wallpaper_single_202', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568423, 'wallpaper_single_203', 'wallpaper_single_203', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568424, 'wallpaper_single_204', 'wallpaper_single_204', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568425, 'wallpaper_single_205', 'wallpaper_single_205', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568426, 'wallpaper_single_206', 'wallpaper_single_206', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568427, 'wallpaper_single_207', 'wallpaper_single_207', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568428, 'wallpaper_single_208', 'wallpaper_single_208', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568429, 'wallpaper_single_209', 'wallpaper_single_209', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568430, 'wallpaper_single_210', 'wallpaper_single_210', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568431, 'wallpaper_single_211', 'wallpaper_single_211', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568432, 'wallpaper_single_212', 'wallpaper_single_212', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568433, 'wallpaper_single_213', 'wallpaper_single_213', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568434, 'wallpaper_single_214', 'wallpaper_single_214', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568435, 'wallpaper_single_215', 'wallpaper_single_215', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568436, 'wallpaper_single_216', 'wallpaper_single_216', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568437, 'wallpaper_single_217', 'wallpaper_single_217', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568438, 'wallpaper_single_218', 'wallpaper_single_218', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568439, 'wallpaper_single_301', 'wallpaper_single_301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568440, 'wallpaper_single_302', 'wallpaper_single_302', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568441, 'wallpaper_single_303', 'wallpaper_single_303', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568442, 'wallpaper_single_304', 'wallpaper_single_304', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568443, 'wallpaper_single_305', 'wallpaper_single_305', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568444, 'wallpaper_single_306', 'wallpaper_single_306', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568445, 'wallpaper_single_307', 'wallpaper_single_307', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568446, 'wallpaper_single_401', 'wallpaper_single_401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568447, 'wallpaper_single_402', 'wallpaper_single_402', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568448, 'wallpaper_single_403', 'wallpaper_single_403', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568449, 'wallpaper_single_404', 'wallpaper_single_404', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568450, 'wallpaper_single_405', 'wallpaper_single_405', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568451, 'wallpaper_single_406', 'wallpaper_single_406', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568452, 'wallpaper_single_407', 'wallpaper_single_407', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568453, 'wallpaper_single_408', 'wallpaper_single_408', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568454, 'wallpaper_single_501', 'wallpaper_single_501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568455, 'wallpaper_single_502', 'wallpaper_single_502', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568456, 'wallpaper_single_503', 'wallpaper_single_503', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568457, 'wallpaper_single_504', 'wallpaper_single_504', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568458, 'wallpaper_single_505', 'wallpaper_single_505', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568459, 'wallpaper_single_506', 'wallpaper_single_506', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568460, 'wallpaper_single_507', 'wallpaper_single_507', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568461, 'wallpaper_single_508', 'wallpaper_single_508', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568462, 'wallpaper_single_601', 'wallpaper_single_601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568463, 'wallpaper_single_602', 'wallpaper_single_602', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568464, 'wallpaper_single_603', 'wallpaper_single_603', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568465, 'wallpaper_single_604', 'wallpaper_single_604', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568466, 'wallpaper_single_605', 'wallpaper_single_605', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568467, 'wallpaper_single_606', 'wallpaper_single_606', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568468, 'wallpaper_single_607', 'wallpaper_single_607', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568469, 'wallpaper_single_608', 'wallpaper_single_608', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568470, 'wallpaper_single_609', 'wallpaper_single_609', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568471, 'wallpaper_single_610', 'wallpaper_single_610', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568472, 'wallpaper_single_701', 'wallpaper_single_701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568473, 'wallpaper_single_702', 'wallpaper_single_702', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568474, 'wallpaper_single_703', 'wallpaper_single_703', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568475, 'wallpaper_single_704', 'wallpaper_single_704', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568476, 'wallpaper_single_705', 'wallpaper_single_705', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568477, 'wallpaper_single_706', 'wallpaper_single_706', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568478, 'wallpaper_single_707', 'wallpaper_single_707', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568479, 'wallpaper_single_708', 'wallpaper_single_708', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568480, 'wallpaper_single_709', 'wallpaper_single_709', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568481, 'wallpaper_single_710', 'wallpaper_single_710', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568482, 'wallpaper_single_801', 'wallpaper_single_801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568483, 'wallpaper_single_802', 'wallpaper_single_802', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568484, 'wallpaper_single_803', 'wallpaper_single_803', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568485, 'wallpaper_single_804', 'wallpaper_single_804', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568486, 'wallpaper_single_805', 'wallpaper_single_805', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568487, 'wallpaper_single_806', 'wallpaper_single_806', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568488, 'wallpaper_single_807', 'wallpaper_single_807', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568489, 'wallpaper_single_808', 'wallpaper_single_808', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568490, 'wallpaper_single_809', 'wallpaper_single_809', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568491, 'wallpaper_single_810', 'wallpaper_single_810', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568492, 'wallpaper_single_901', 'wallpaper_single_901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568493, 'wallpaper_single_902', 'wallpaper_single_902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568494, 'wallpaper_single_903', 'wallpaper_single_903', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568495, 'wallpaper_single_904', 'wallpaper_single_904', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568496, 'wallpaper_single_905', 'wallpaper_single_905', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568497, 'wallpaper_single_906', 'wallpaper_single_906', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568498, 'wallpaper_single_907', 'wallpaper_single_907', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568499, 'wallpaper_single_908', 'wallpaper_single_908', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568500, 'wallpaper_single_1001', 'wallpaper_single_1001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568501, 'wallpaper_single_1002', 'wallpaper_single_1002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568502, 'wallpaper_single_1003', 'wallpaper_single_1003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568503, 'wallpaper_single_1004', 'wallpaper_single_1004', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568504, 'wallpaper_single_1005', 'wallpaper_single_1005', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568505, 'wallpaper_single_1006', 'wallpaper_single_1006', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568506, 'wallpaper_single_1007', 'wallpaper_single_1007', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568507, 'wallpaper_single_1101', 'wallpaper_single_1101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568508, 'wallpaper_single_1201', 'wallpaper_single_1201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568509, 'wallpaper_single_1301', 'wallpaper_single_1301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568510, 'wallpaper_single_1401', 'wallpaper_single_1401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568511, 'wallpaper_single_1501', 'wallpaper_single_1501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568512, 'wallpaper_single_1601', 'wallpaper_single_1601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568513, 'wallpaper_single_1701', 'wallpaper_single_1701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568514, 'wallpaper_single_1801', 'wallpaper_single_1801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568515, 'wallpaper_single_1901', 'wallpaper_single_1901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568516, 'wallpaper_single_1902', 'wallpaper_single_1902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568517, 'wallpaper_single_2001', 'wallpaper_single_2001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568518, 'wallpaper_single_2002', 'wallpaper_single_2002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568519, 'wallpaper_single_2003', 'wallpaper_single_2003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568520, 'wallpaper_single_2101', 'wallpaper_single_2101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568521, 'wallpaper_single_2102', 'wallpaper_single_2102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568522, 'wallpaper_single_2103', 'wallpaper_single_2103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568523, 'wallpaper_single_2201', 'wallpaper_single_2201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568524, 'wallpaper_single_2202', 'wallpaper_single_2202', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568525, 'wallpaper_single_2203', 'wallpaper_single_2203', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568526, 'wallpaper_single_2204', 'wallpaper_single_2204', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568527, 'wallpaper_single_2205', 'wallpaper_single_2205', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568528, 'wallpaper_single_2206', 'wallpaper_single_2206', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568529, 'wallpaper_single_2301', 'wallpaper_single_2301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568530, 'wallpaper_single_2302', 'wallpaper_single_2302', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568531, 'wallpaper_single_2303', 'wallpaper_single_2303', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568532, 'wallpaper_single_2304', 'wallpaper_single_2304', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568533, 'wallpaper_single_2401', 'wallpaper_single_2401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568534, 'wallpaper_single_2402', 'wallpaper_single_2402', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568535, 'wallpaper_single_2403', 'wallpaper_single_2403', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568536, 'wallpaper_single_2501', 'wallpaper_single_2501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568537, 'wallpaper_single_2502', 'wallpaper_single_2502', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568538, 'wallpaper_single_2503', 'wallpaper_single_2503', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568539, 'wallpaper_single_2504', 'wallpaper_single_2504', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568540, 'wallpaper_single_2601', 'wallpaper_single_2601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568541, 'wallpaper_single_2602', 'wallpaper_single_2602', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568542, 'wallpaper_single_2603', 'wallpaper_single_2603', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568543, 'wallpaper_single_2604', 'wallpaper_single_2604', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568544, 'wallpaper_single_2701', 'wallpaper_single_2701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568545, 'wallpaper_single_2702', 'wallpaper_single_2702', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568546, 'wallpaper_single_2703', 'wallpaper_single_2703', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568547, 'wallpaper_single_2704', 'wallpaper_single_2704', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568548, 'wallpaper_single_2801', 'wallpaper_single_2801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568549, 'wallpaper_single_2802', 'wallpaper_single_2802', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568550, 'wallpaper_single_2803', 'wallpaper_single_2803', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568551, 'wallpaper_single_2804', 'wallpaper_single_2804', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568552, 'wallpaper_single_2901', 'wallpaper_single_2901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568553, 'wallpaper_single_2902', 'wallpaper_single_2902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568554, 'wallpaper_single_2903', 'wallpaper_single_2903', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568555, 'wallpaper_single_2904', 'wallpaper_single_2904', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568556, 'wallpaper_single_3001', 'wallpaper_single_3001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568557, 'wallpaper_single_3002', 'wallpaper_single_3002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568558, 'wallpaper_single_3003', 'wallpaper_single_3003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568559, 'wallpaper_single_3004', 'wallpaper_single_3004', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568560, 'wallpaper_single_3101', 'wallpaper_single_3101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568561, 'wallpaper_single_3102', 'wallpaper_single_3102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568562, 'wallpaper_single_3103', 'wallpaper_single_3103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568563, 'wallpaper_single_3104', 'wallpaper_single_3104', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568564, 'wallpaper_single_3105', 'wallpaper_single_3105', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568565, 'wallpaper_single_3106', 'wallpaper_single_3106', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568566, 'floor_single_101', 'floor_single_101', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568567, 'floor_single_102', 'floor_single_102', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568568, 'floor_single_103', 'floor_single_103', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568569, 'floor_single_104', 'floor_single_104', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568570, 'floor_single_105', 'floor_single_105', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568571, 'floor_single_106', 'floor_single_106', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568572, 'floor_single_107', 'floor_single_107', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568573, 'floor_single_108', 'floor_single_108', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568574, 'floor_single_109', 'floor_single_109', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568575, 'floor_single_110', 'floor_single_110', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568576, 'floor_single_111', 'floor_single_111', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568577, 'floor_single_201', 'floor_single_201', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568578, 'floor_single_202', 'floor_single_202', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568579, 'floor_single_203', 'floor_single_203', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568580, 'floor_single_204', 'floor_single_204', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568581, 'floor_single_205', 'floor_single_205', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568582, 'floor_single_206', 'floor_single_206', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568583, 'floor_single_207', 'floor_single_207', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568584, 'floor_single_208', 'floor_single_208', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568585, 'floor_single_209', 'floor_single_209', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568586, 'floor_single_210', 'floor_single_210', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568587, 'floor_single_211', 'floor_single_211', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568588, 'floor_single_212', 'floor_single_212', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568589, 'floor_single_301', 'floor_single_301', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568590, 'floor_single_302', 'floor_single_302', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568591, 'floor_single_303', 'floor_single_303', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568592, 'floor_single_304', 'floor_single_304', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568593, 'floor_single_305', 'floor_single_305', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568594, 'floor_single_306', 'floor_single_306', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568595, 'floor_single_307', 'floor_single_307', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568596, 'floor_single_401', 'floor_single_401', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568597, 'floor_single_402', 'floor_single_402', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568598, 'floor_single_403', 'floor_single_403', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568599, 'floor_single_404', 'floor_single_404', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568600, 'floor_single_405', 'floor_single_405', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568601, 'floor_single_406', 'floor_single_406', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568602, 'floor_single_407', 'floor_single_407', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568603, 'floor_single_408', 'floor_single_408', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568604, 'floor_single_409', 'floor_single_409', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568605, 'floor_single_501', 'floor_single_501', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568606, 'floor_single_502', 'floor_single_502', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568607, 'floor_single_503', 'floor_single_503', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568608, 'floor_single_504', 'floor_single_504', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568609, 'floor_single_505', 'floor_single_505', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568610, 'floor_single_506', 'floor_single_506', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568611, 'floor_single_507', 'floor_single_507', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568612, 'floor_single_601', 'floor_single_601', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568613, 'floor_single_602', 'floor_single_602', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568614, 'floor_single_603', 'floor_single_603', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568615, 'floor_single_604', 'floor_single_604', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568616, 'floor_single_605', 'floor_single_605', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568617, 'floor_single_606', 'floor_single_606', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568618, 'floor_single_607', 'floor_single_607', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568619, 'floor_single_608', 'floor_single_608', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568620, 'floor_single_609', 'floor_single_609', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568621, 'floor_single_610', 'floor_single_610', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568622, 'landscape_single_1.1', 'landscape_single_1.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568623, 'landscape_single_1.2', 'landscape_single_1.2', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568624, 'landscape_single_1.3', 'landscape_single_1.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568625, 'landscape_single_1.4', 'landscape_single_1.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568626, 'landscape_single_1.5', 'landscape_single_1.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568627, 'landscape_single_1.6', 'landscape_single_1.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568628, 'landscape_single_1.7', 'landscape_single_1.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568629, 'landscape_single_1.8', 'landscape_single_1.8', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568630, 'landscape_single_1.9', 'landscape_single_1.9', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568631, 'landscape_single_1.10', 'landscape_single_1.10', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568632, 'landscape_single_1.11', 'landscape_single_1.11', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568633, 'landscape_single_2.1', 'landscape_single_2.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568634, 'landscape_single_2.3', 'landscape_single_2.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568635, 'landscape_single_2.4', 'landscape_single_2.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568636, 'landscape_single_2.5', 'landscape_single_2.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568637, 'landscape_single_2.6', 'landscape_single_2.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568638, 'landscape_single_2.7', 'landscape_single_2.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568639, 'landscape_single_3.1', 'landscape_single_3.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568640, 'landscape_single_3.3', 'landscape_single_3.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568641, 'landscape_single_3.4', 'landscape_single_3.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568642, 'landscape_single_3.5', 'landscape_single_3.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568643, 'landscape_single_3.6', 'landscape_single_3.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568644, 'landscape_single_3.7', 'landscape_single_3.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568645, 'landscape_single_4.1', 'landscape_single_4.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568646, 'landscape_single_4.3', 'landscape_single_4.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568647, 'landscape_single_4.4', 'landscape_single_4.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568648, 'landscape_single_4.5', 'landscape_single_4.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568649, 'landscape_single_4.6', 'landscape_single_4.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568650, 'landscape_single_4.7', 'landscape_single_4.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568651, 'landscape_single_5.1', 'landscape_single_5.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568652, 'landscape_single_5.3', 'landscape_single_5.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568653, 'landscape_single_5.4', 'landscape_single_5.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568654, 'landscape_single_5.5', 'landscape_single_5.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568655, 'landscape_single_5.6', 'landscape_single_5.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568656, 'landscape_single_5.7', 'landscape_single_5.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568657, 'landscape_single_6.1', 'landscape_single_6.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568658, 'landscape_single_6.3', 'landscape_single_6.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568659, 'landscape_single_6.4', 'landscape_single_6.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568660, 'landscape_single_6.5', 'landscape_single_6.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568661, 'landscape_single_6.6', 'landscape_single_6.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568662, 'landscape_single_6.7', 'landscape_single_6.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568663, 'landscape_single_7.1', 'landscape_single_7.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568664, 'landscape_single_7.3', 'landscape_single_7.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568665, 'landscape_single_7.4', 'landscape_single_7.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568666, 'landscape_single_7.5', 'landscape_single_7.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568667, 'landscape_single_7.6', 'landscape_single_7.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568668, 'landscape_single_7.7', 'landscape_single_7.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568669, 'landscape_single_7.12', 'landscape_single_7.12', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(9001, 'a0 pet12', 'a0 pet12', 's', 1, 1, 1, '1', '0', '0', 6491, '1', '1', '1', '1', '1', 'pet12', 1, '0', ''),
(2785108, 'bb_painimies2', 'bb_painimies2', 'i', 1, 1, 1, '0', '0', '1', 4342, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785078, 'bb_score_b', 'bb_score_b', 's', 1, 1, 1, '0', '1', '0', 3615, '1', '1', '1', '1', '1', 'banzaiscoreblue', 2, '0', ''),
(2785079, 'bb_robo', 'bb_robo', 's', 2, 2, 2, '0', '0', '0', 3616, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785080, 'bb_dragon', 'bb_dragon', 's', 3, 1, 2.5, '0', '0', '0', 3617, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785081, 'bb_ducklight', 'bb_ducklight', 's', 1, 1, 3, '0', '0', '0', 3618, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(2785082, 'bb_caterhead', 'bb_caterhead', 's', 1, 1, 1, '0', '0', '0', 3619, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785083, 'bb_cargobox', 'bb_cargobox', 's', 2, 1, 1, '0', '0', '0', 3620, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785084, 'bb_gate_g', 'bb_gate_g', 's', 1, 1, 0, '0', '0', '1', 3621, '1', '1', '1', '1', '1', 'banzaigategreen', 2, '0', ''),
(2785085, 'bb_crchair3', 'bb_crchair3', 's', 1, 1, 1, '0', '1', '0', 3622, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785086, 'bb_score_g', 'bb_score_g', 's', 1, 1, 1, '0', '1', '0', 3623, '1', '1', '1', '1', '1', 'banzaiscoregreen', 1, '0', ''),
(2785087, 'bb_crchair', 'bb_crchair', 's', 1, 1, 1, '0', '1', '0', 3624, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785088, 'bb_crchair2', 'bb_crchair2', 's', 1, 1, 1, '0', '1', '0', 3625, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785089, 'bb_score_y', 'bb_score_y', 's', 1, 1, 1, '1', '0', '0', 3626, '1', '1', '1', '1', '1', 'banzaiscoreyellow', 2, '0', ''),
(2785090, 'bb_knj1', 'bb_knj1', 's', 2, 1, 1, '0', '0', '0', 3627, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785091, 'bb_gate_r', 'bb_gate_r', 's', 1, 1, 0, '0', '0', '1', 3628, '1', '1', '1', '1', '1', 'banzaigatered', 2, '0', ''),
(2785092, 'bb_tddhnd', 'bb_tddhnd', 's', 1, 1, 1, '1', '0', '0', 3629, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(2785093, 'bb_lightdiv', 'bb_lightdiv', 's', 1, 1, 1, '1', '0', '0', 3630, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(2785094, 'bb_tddhead', 'bb_tddhead', 's', 2, 2, 2, '0', '0', '0', 3631, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785095, 'bb_pyramid', 'bb_pyramid', 's', 1, 1, 0, '1', '0', '0', 3632, '1', '1', '1', '1', '1', 'banzaipyramid', 3, '0', ''),
(2785096, 'bb_patch1', 'bb_patch1', 's', 1, 1, 0.1, '1', '0', '1', 3633, '1', '1', '1', '1', '1', 'banzaifloor', 4, '0', ''),
(2785097, 'bb_fnc3', 'bb_fnc3', 's', 1, 3, 1, '0', '0', '0', 3634, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(2785098, 'bb_gate_y', 'bb_gate_y', 's', 1, 1, 0, '0', '0', '1', 3635, '1', '1', '1', '1', '1', 'banzaigateyellow', 1, '0', ''),
(2785099, 'bb_apparatus', 'bb_apparatus', 's', 2, 2, 0, '1', '0', '1', 3637, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(2785100, 'bb_caterbody', 'bb_caterbody', 's', 1, 1, 1.7, '1', '1', '0', 3638, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785101, 'bb_knj2', 'bb_knj2', 's', 1, 1, 2, '1', '0', '0', 3639, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(2785102, 'bb_fnc1', 'bb_fnc1', 's', 1, 1, 1, '0', '0', '0', 3640, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(2785103, 'bb_puck', 'bb_puck', 's', 1, 1, 0.6, '1', '0', '0', 3641, '1', '1', '1', '1', '1', 'banzaipuck', 3, '0', ''),
(2785104, 'bb_rnd_tele', 'bb_rnd_tele', 's', 1, 1, 0.3, '0', '0', '1', 3642, '1', '1', '1', '1', '1', 'banzaitele', 1, '0', ''),
(2785105, 'bb_gate_b', 'bb_gate_b', 's', 1, 1, 0, '0', '0', '1', 3643, '1', '1', '1', '1', '1', 'banzaigateblue', 1, '0', ''),
(2785106, 'bb_score_r', 'bb_score_r', 's', 1, 1, 1, '0', '1', '0', 3644, '1', '1', '1', '1', '1', 'banzaiscorered', 2, '0', ''),
(2785107, 'bb_painimies1', 'bb_painimies1', 'i', 1, 1, 1, '0', '0', '1', 4341, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785077, 'bb_crnr', 'bb_crnr', 's', 1, 1, 1, '0', '0', '0', 3614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(2785109, 'bb_counter', 'bb_counter', 's', 1, 4, 0.1, '0', '0', '0', 3645, '1', '1', '0', '1', '1', 'banzaicounter', 1, '0', '0'),
(4568423, 'song_disk', 'song_disk', 's', 1, 1, 1, '1', '0', '0', 2607, '1', '1', '1', '1', '1', 'musicdisc', 1, '0', ''),
(3568337, 'wf_trg_at_given_time', 'wf_trg_at_given_time', 's', 1, 1, 0.5, '1', '0', '0', 3679, '1', '1', '1', '1', '1', 'triggertimer', 4, '0', ''),
(3568338, 'wf_trg_enter_room', 'wf_trg_enter_room', 's', 1, 1, 0.5, '1', '0', '0', 3683, '1', '1', '1', '1', '1', 'triggerroomenter', 4, '0', ''),
(3568339, 'wf_trg_game_ends', 'wf_trg_game_ends', 's', 1, 1, 0.5, '1', '0', '0', 3680, '1', '1', '1', '1', '1', 'triggergameend', 5, '0', ''),
(3568340, 'wf_trg_game_starts', 'wf_trg_game_starts', 's', 1, 1, 0.5, '1', '0', '0', 3702, '1', '1', '1', '1', '1', 'triggergamestart', 5, '0', ''),
(3568341, 'wf_trg_periodically', 'wf_trg_periodically', 's', 1, 1, 0.5, '1', '0', '0', 3671, '1', '1', '1', '1', '1', 'triggerrepeater', 4, '0', ''),
(3568342, 'wf_trg_says_something', 'wf_trg_says_something', 's', 1, 1, 0.5, '1', '0', '0', 3675, '1', '1', '1', '1', '1', 'triggeronusersay', 4, '0', ''),
(3568343, 'wf_trg_score_achieved', 'wf_trg_score_achieved', 's', 1, 1, 0.5, '1', '0', '0', 3673, '1', '1', '1', '1', '1', 'triggerscoreachieved', 4, '0', ''),
(3568344, 'wf_trg_state_changed', 'wf_trg_state_changed', 's', 1, 1, 0.5, '1', '0', '0', 3668, '1', '1', '1', '1', '1', 'triggerstatechanged', 4, '0', ''),
(3568345, 'wf_trg_walks_off_furni', 'wf_trg_walks_off_furni', 's', 1, 1, 0.5, '1', '0', '0', 3678, '1', '1', '1', '1', '1', 'triggerwalkofffurni', 4, '0', ''),
(3568346, 'wf_trg_walks_on_furni', 'wf_trg_walks_on_furni', 's', 1, 1, 0.5, '1', '0', '0', 3703, '1', '1', '1', '1', '1', 'triggerwalkonfurni', 4, '0', ''),
(3568347, 'wf_act_give_score', 'wf_act_give_score', 's', 1, 1, 0.5, '1', '0', '0', 3697, '1', '1', '1', '1', '1', 'actiongivescore', 5, '0', ''),
(3568348, 'wf_act_match_to_sshot', 'wf_act_match_to_sshot', 's', 1, 1, 0.5, '1', '0', '0', 3700, '1', '1', '1', '1', '1', 'actionposreset', 4, '0', ''),
(3568349, 'wf_act_move_rotate', 'wf_act_move_rotate', 's', 1, 1, 0.5, '1', '0', '0', 3663, '1', '1', '1', '1', '1', 'actionmoverotate', 4, '0', ''),
(3568350, 'wf_act_reset_timers', 'wf_act_reset_timers', 's', 1, 1, 0.5, '1', '0', '0', 3691, '1', '1', '1', '1', '1', 'actionresettimer', 4, '0', ''),
(3568351, 'wf_act_show_message', 'wf_act_show_message', 's', 1, 1, 0.5, '1', '0', '0', 3681, '1', '1', '1', '1', '1', 'actionshowmessage', 4, '0', ''),
(3568352, 'wf_act_teleport_to', 'wf_act_teleport_to', 's', 1, 1, 0.5, '1', '0', '0', 3674, '1', '1', '1', '1', '1', 'actionteleportto', 1, '0', ''),
(3568353, 'wf_act_toggle_state', 'wf_act_toggle_state', 's', 1, 1, 0.5, '1', '0', '0', 3685, '1', '1', '1', '1', '1', 'actiontogglestate', 4, '0', ''),
(3568354, 'wf_cnd_furnis_hv_avtrs', 'wf_cnd_furnis_hv_avtrs', 's', 1, 1, 0.5, '1', '0', '0', 3692, '1', '1', '1', '1', '1', 'conditionfurnishaveusers', 4, '0', ''),
(3568355, 'wf_cnd_match_snapshot', 'wf_cnd_match_snapshot', 's', 1, 1, 0.5, '1', '0', '0', 3695, '1', '1', '1', '1', '1', 'conditionstatepos', 4, '0', ''),
(3568356, 'wf_cnd_time_less_than', 'wf_cnd_time_less_than', 's', 1, 1, 0.5, '1', '0', '0', 3682, '1', '1', '1', '1', '1', 'conditiontimelessthan', 4, '0', ''),
(3568357, 'wf_cnd_time_more_than', 'wf_cnd_time_more_than', 's', 1, 1, 0.5, '1', '0', '0', 3665, '1', '1', '1', '1', '1', 'conditiontimemorethan', 4, '0', ''),
(3568358, 'wf_cnd_trggrer_on_frn', 'wf_cnd_trggrer_on_frn', 's', 1, 1, 0.5, '1', '0', '0', 3694, '1', '1', '1', '1', '1', 'conditiontriggeronfurni', 4, '0', ''),
(3568359, 'wf_arrowplate', 'wf_arrowplate', 's', 1, 1, 0, '1', '0', '1', 3693, '1', '1', '1', '1', '1', 'arrowplate', 4, '0', ''),
(3568360, 'wf_pressureplate', 'wf_pressureplate', 's', 1, 1, 0, '1', '0', '1', 3688, '1', '1', '1', '1', '1', 'preassureplate', 2, '0', ''),
(3568361, 'wf_ringplate', 'wf_ringplate', 's', 1, 1, 0, '1', '0', '1', 3687, '1', '1', '1', '1', '1', 'ringplate', 2, '0', ''),
(3568362, 'wf_colortile', 'wf_colortile', 's', 1, 1, 0, '1', '0', '1', 3666, '1', '1', '1', '1', '1', 'colortile', 10, '0', ''),
(3568363, 'wf_colorwheel', 'wf_colorwheel', 's', 1, 1, 1, '1', '0', '0', 3676, '1', '1', '1', '1', '1', 'colorwheel', 10, '0', ''),
(3568364, 'wf_floor_switch1', 'wf_floor_switch1', 's', 1, 1, 1, '1', '0', '0', 3701, '1', '1', '1', '1', '1', 'floorswitch1', 2, '0', '');
INSERT INTO `furniture` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(3568365, 'wf_floor_switch2', 'wf_floor_switch2', 's', 1, 1, 1, '1', '0', '0', 3667, '1', '1', '1', '1', '1', 'floorswitch2', 5, '0', ''),
(3568366, 'wf_firegate', 'wf_firegate', 's', 1, 1, 0, '1', '0', '1', 3686, '1', '1', '1', '1', '1', 'firegate', 2, '0', ''),
(3568367, 'wf_glassdoor', 'wf_glassdoor', 's', 1, 1, 0.1, '1', '0', '0', 3699, '1', '1', '1', '1', '1', 'gate', 1, '0', ''),
(3568368, 'wf_xtra_random', 'wf_xtra_random', 's', 1, 1, 0.5, '1', '0', '1', 3669, '1', '1', '1', '1', '1', 'specialrandom', 4, '0', ''),
(3568369, 'wf_xtra_unseen', 'wf_xtra_unseen', 's', 1, 1, 0.5, '1', '0', '1', 3670, '1', '1', '1', '1', '1', 'specialunseen', 4, '0', ''),
(3568374, 'wf_wire1', 'wf_wire1', 's', 1, 1, 0.1, '1', '0', '1', 3696, '1', '1', '1', '1', '1', 'wireStandard', 2, '0', ''),
(3568375, 'wf_wire2', 'wf_wire2', 's', 1, 1, 0.1, '1', '0', '1', 3664, '1', '1', '1', '1', '1', 'wireCenter', 2, '0', ''),
(3568376, 'wf_wire3', 'wf_wire3', 's', 1, 1, 0.1, '1', '0', '1', 3698, '1', '1', '1', '1', '1', 'wireCorner', 2, '0', ''),
(3568377, 'wf_wire4', 'wf_wire4', 's', 1, 1, 0.1, '1', '0', '1', 3677, '1', '1', '1', '1', '1', 'wireSplitter', 2, '0', ''),
(4568424, 'qt_sum11_ictrolley', 'qt_sum11_ictrolley', 's', 1, 1, 1, '0', '0', '0', 4018, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568425, 'qt_sum11_platfrm', 'qt_sum11_platfrm', 's', 2, 2, 1, '1', '0', '0', 4022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568426, 'qt_sum11_shell3', 'qt_sum11_shell3', 's', 1, 1, 1, '0', '0', '0', 4021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568427, 'qt_sum11_shell2', 'qt_sum11_shell2', 's', 1, 1, 1, '0', '0', '0', 4023, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568428, 'qt_sum11_chair', 'qt_sum11_chair', 's', 1, 1, 1, '0', '1', '0', 4025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568429, 'qt_sum11_shell4', 'qt_sum11_shell4', 's', 1, 1, 1, '1', '0', '0', 4020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568430, 'qt_sum11_shell1', 'qt_sum11_shell1', 's', 1, 1, 1, '0', '0', '0', 4017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568431, 'qt_sum11_shell5', 'qt_sum11_shell5', 's', 1, 1, 1, '0', '0', '0', 4024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568432, 'qt_sum11_petfood', 'qt_sum11_petfood', 's', 1, 1, 1, '0', '0', '0', 4019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568433, 'petfood25', 'petfood25', 's', 1, 1, 0.2, '0', '0', '0', 4070, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568434, 'lm_bananadrink', 'lm_bananadrink', 's', 1, 1, 3, '0', '0', '0', 4068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568435, 'lm_crystal_skull', 'lm_crystal_skull', 's', 1, 1, 0.2, '0', '0', '0', 4067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568436, 'lm_jackbox', 'lm_jackbox', 's', 1, 1, 1, '0', '0', '0', 4073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568437, 'ads_durex_carpet', 'ads_durex_carpet', 's', 2, 3, 0.1, '1', '0', '1', 4075, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568438, 'ads_durex_screen', 'ads_durex_screen', 'i', 1, 1, 1, '0', '0', '0', 4410, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568439, 'ads_durex_vend', 'ads_durex_vend', 's', 1, 1, 3, '0', '0', '0', 4074, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568440, 'Sand Dragon', 'qt_sum11_dragon', 's', 1, 1, 0.001, '0', '0', '0', 2124013, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4000, 'HabMoon Aapje', 'a0 pet14', 's', 1, 1, 1, '0', '0', '0', 14, '0', '0', '0', '0', '1', 'pet14', 1, '0', ''),
(20700, 'Turtels', 'a0 pet9', 's', 1, 1, 1, '0', '0', '0', 14, '0', '0', '0', '0', '1', 'pet9', 1, '0', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `furniture_copy`
--

CREATE TABLE IF NOT EXISTS `furniture_copy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `public_name` text NOT NULL COMMENT 'temp only',
  `item_name` varchar(100) NOT NULL,
  `type` enum('s','i','e','h') NOT NULL DEFAULT 's',
  `width` int(11) NOT NULL DEFAULT '1',
  `length` int(11) NOT NULL DEFAULT '1',
  `stack_height` double NOT NULL DEFAULT '1',
  `can_stack` enum('0','1') NOT NULL DEFAULT '1',
  `can_sit` enum('0','1') NOT NULL DEFAULT '0',
  `is_walkable` enum('0','1') NOT NULL DEFAULT '0',
  `sprite_id` int(11) NOT NULL,
  `allow_recycle` enum('0','1') NOT NULL DEFAULT '1',
  `allow_trade` enum('0','1') NOT NULL DEFAULT '1',
  `allow_marketplace_sell` enum('0','1') NOT NULL DEFAULT '1',
  `allow_gift` enum('0','1') NOT NULL DEFAULT '1',
  `allow_inventory_stack` enum('0','1') NOT NULL DEFAULT '1',
  `interaction_type` enum('default','gate','postit','roomeffect','dimmer','trophy','bed','scoreboard','vendingmachine','alert','onewaygate','loveshuffler','habbowheel','dice','bottle','teleport','rentals','pet','pool','roller','fbgate','lowpool','haloweenpool','normalskates','iceskates','pet0','pet1','pet2','pet3','pet4','pet5','pet6','pet7','pet8','pet9','pet10','pet11','pet12','football','footballgoalred','footballgoalblue','footballgoalyellow','footballgoalgreen','footballcountered','footballcountergreen','footballcounterblue','footballcounteryellow','banzaigateblue','banzaigatered','banzaigateyellow','banzaigategreen','banzaifloor','banzaiscoreblue','banzaiscorered','banzaiscoreyellow','banzaiscoregreen','banzaicounter','banzaitele','banzaipuck','banzaipyramid','freezetimer','freezeexit','freezeredcounter','freezebluecounter','freezeyellowcounter','freezegreencounter','freezeyellowgate','freezeredgate','freezegreengate','freezebluegate','freezetileblock','freezetile','musicdisc','triggertimer','triggerroomenter','triggergameend','triggergamestart','triggerrepeater','triggeronusersay','triggerscoreachieved','triggerstatechanged','triggerwalkonfurni','triggerwalkofffurni','actiongivescore','actionposreset','actionmoverotate','actionresettimer','actionshowmessage','actionteleportto','actiontogglestate','conditionfurnishaveusers','conditionstatepos','conditiontimelessthan','conditiontimemorethan','conditiontriggeronfurni','arrowplate','preassureplate','ringplate','colortile','colorwheel','floorswitch1','floorswitch2','firegate','glassfoor','specialrandom','specialunseen','wire','wireCenter','wireCorner','wireSplitter','wireStandard','pet13','pet14','pet15') NOT NULL DEFAULT 'default',
  `interaction_modes_count` int(11) NOT NULL DEFAULT '1',
  `vending_ids` varchar(100) NOT NULL DEFAULT '0',
  `foot_figure` char(2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4568441 ;

--
-- Volcado de datos para la tabla `furniture_copy`
--

INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1, 'Bookcase', 'shelves_norja', 's', 1, 1, 1, '0', '0', '0', 13, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(2, 'Bookcase', 'shelves_polyfon', 's', 2, 1, 1, '0', '0', '0', 14, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(3, 'Bookcase', 'shelves_silo', 's', 2, 1, 1, '0', '0', '0', 15, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4, 'Small Coffee Table', 'table_polyfon_small', 's', 2, 2, 1, '0', '0', '0', 17, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(5, 'Dining Chair', 'chair_polyfon', 's', 1, 1, 1, '0', '1', '0', 18, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(6, 'Coffee Table', 'table_norja_med', 's', 2, 2, 1, '1', '0', '0', 20, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(7, 'Coffee Table', 'table_silo_med', 's', 2, 2, 1, '1', '0', '0', 21, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(8, 'Occasional Table', 'table_plasto_4leg', 's', 2, 2, 1, '1', '0', '0', 22, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(9, 'Round Dining Table', 'table_plasto_round', 's', 2, 2, 1, '1', '0', '0', 23, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(10, 'Square Dining Table', 'table_plasto_bigsquare', 's', 2, 2, 1, '1', '0', '0', 24, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(11, 'Shelf', 'stand_polyfon_z', 's', 1, 1, 0.5, '1', '0', '0', 25, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(12, 'Dining Chair', 'chair_silo', 's', 1, 1, 1.1, '0', '1', '0', 26, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(13, 'Cushioned', 'sofa_silo', 's', 2, 1, 1.1, '0', '1', '0', 28, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(14, 'Bench', 'couch_norja', 's', 2, 1, 1, '0', '1', '0', 29, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(15, 'Chair', 'chair_norja', 's', 1, 1, 1, '0', '1', '0', 30, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(16, 'Large Coffee Table', 'table_polyfon_med', 's', 2, 2, 1, '1', '0', '0', 31, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(17, 'Doormat', 'doormat_love', 's', 1, 1, 0.1, '0', '0', '1', 32, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(18, 'Doormat', 'doormat_plain', 's', 1, 1, 0.1, '0', '0', '1', 33, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19, 'Armchair', 'sofachair_polyfon', 's', 1, 1, 1.1, '0', '1', '0', 34, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20, 'Two-seater Sofa', 'sofa_polyfon', 's', 2, 1, 1.1, '0', '1', '0', 35, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(21, 'Large', 'sofachair_silo', 's', 1, 1, 1.1, '0', '1', '0', 36, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(22, 'Plastic Pod Chair', 'chair_plasty', 's', 1, 1, 1, '0', '1', '0', 38, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(23, 'Chair', 'chair_plasto', 's', 1, 1, 1, '0', '1', '0', 39, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(24, 'Occasional Table', 'table_plasto_square', 's', 1, 1, 1, '1', '0', '0', 40, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25, 'Double Bed', 'bed_polyfon', 's', 2, 3, 1.8, '0', '0', '0', 41, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(26, 'Single Bed', 'bed_polyfon_one', 's', 1, 3, 1.8, '0', '0', '0', 42, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(27, 'Plain Single Bed', 'bed_trad_one', 's', 2, 3, 1, '0', '0', '0', 43, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(28, 'Plain Double Bed', 'bed_trad', 's', 2, 3, 1, '0', '0', '0', 44, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(29, 'Single Bed', 'bed_silo_one', 's', 1, 3, 1.8, '0', '0', '0', 45, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(30, 'Double Bed', 'bed_silo_two', 's', 2, 3, 1.8, '0', '0', '0', 46, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(31, 'Occasional Table', 'table_silo_small', 's', 1, 1, 1, '1', '0', '0', 47, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(32, 'Double Bed', 'bed_armas_two', 's', 2, 3, 1.8, '0', '0', '0', 48, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(33, 'bed_budget_one', 'bed_budget_one', 's', 1, 3, 1.9, '0', '0', '0', 49, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(34, 'Comfortable', 'bed_budget', 's', 2, 3, 1.9, '0', '0', '0', 50, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(35, 'Bookcase', 'shelves_armas', 's', 2, 1, 1, '0', '0', '0', 51, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(36, 'Bench', 'bench_armas', 's', 2, 1, 1.1, '0', '1', '0', 52, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(37, 'Dining Table', 'table_armas', 's', 2, 2, 1, '1', '0', '0', 53, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(38, 'Occasional Table', 'small_table_armas', 's', 1, 1, 1, '1', '0', '0', 54, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(39, 'Stool', 'small_chair_armas', 's', 1, 1, 1, '0', '1', '0', 55, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(40, 'Authentic', 'fireplace_armas', 's', 2, 1, 1, '0', '0', '0', 56, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(41, 'Table Lamp', 'lamp_armas', 's', 1, 1, 1, '0', '0', '0', 57, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(42, 'Single Bed', 'bed_armas_one', 's', 1, 3, 1.8, '0', '0', '0', 58, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(43, 'Floor rug', 'carpet_standard', 's', 3, 5, 0, '1', '0', '1', 59, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(44, 'Hand-Woven Rug', 'carpet_armas', 's', 2, 4, 0, '1', '0', '1', 60, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(45, 'Faux-Fur Bear Rug', 'carpet_polar', 's', 2, 3, 0, '1', '0', '1', 61, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(46, 'Fireplace', 'fireplace_polyfon', 's', 2, 1, 1, '0', '0', '0', 62, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(47, 'Square Dining Table', 'table_plasto_4leg*1', 's', 2, 2, 1, '1', '0', '0', 63, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(48, 'Square Dining Table', 'table_plasto_bigsquare*1', 's', 2, 2, 1, '1', '0', '0', 64, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(49, 'Round Dining Table', 'table_plasto_round*1', 's', 2, 2, 1, '1', '0', '0', 65, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(50, 'Occasional Table', 'table_plasto_square*1', 's', 1, 1, 1, '1', '0', '0', 66, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(51, 'Chair', 'chair_plasto*1', 's', 1, 1, 1, '0', '1', '0', 67, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(52, 'Floor Rug', 'carpet_standard*1', 's', 3, 5, 0, '1', '0', '1', 68, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(53, 'Doormat', 'doormat_plain*1', 's', 1, 1, 0.1, '0', '0', '1', 69, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(54, 'Occasional Table', 'table_plasto_4leg*2', 's', 2, 2, 1, '1', '0', '0', 70, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(55, 'Square Dining Table', 'table_plasto_bigsquare*2', 's', 2, 2, 1, '1', '0', '0', 71, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(56, 'Round Dining Table', 'table_plasto_round*2', 's', 2, 2, 1, '1', '0', '0', 72, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(57, 'Round Dining Table', 'table_plasto_square*2', 's', 1, 1, 1, '1', '0', '0', 73, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(58, 'Chair', 'chair_plasto*2', 's', 1, 1, 1, '0', '1', '0', 74, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(59, 'Doormat', 'doormat_plain*2', 's', 1, 1, 0.1, '0', '0', '1', 75, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(60, 'Floor Rug', 'carpet_standard*2', 's', 3, 5, 0, '1', '0', '1', 76, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(61, 'Round Dining Table', 'table_plasto_4leg*3', 's', 2, 2, 1, '1', '0', '0', 77, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(62, 'Square Dining Table', 'table_plasto_bigsquare*3', 's', 2, 2, 1, '1', '0', '0', 78, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(63, 'Round Dining Table', 'table_plasto_round*3', 's', 2, 2, 1, '1', '0', '0', 79, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(64, 'Square Dining Table', 'table_plasto_square*3', 's', 1, 1, 1, '1', '0', '0', 80, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(65, 'Chair', 'chair_plasto*3', 's', 1, 1, 1, '0', '1', '0', 81, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(66, 'Floor Rug', 'carpet_standard*3', 's', 3, 5, 0, '1', '0', '1', 82, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(67, 'Doormat', 'doormat_plain*3', 's', 1, 1, 0.1, '0', '0', '1', 83, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(68, 'Square Dining Table', 'table_plasto_4leg*4', 's', 2, 2, 1, '1', '0', '0', 84, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(71, 'Square Dining Table', 'table_plasto_square*4', 's', 1, 1, 1, '1', '0', '0', 87, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(72, 'Chair', 'chair_plasto*4', 's', 1, 1, 1, '0', '1', '0', 88, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(73, 'Floor Rug', 'carpet_standard*4', 's', 3, 5, 0, '1', '0', '1', 89, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(74, 'Doormat', 'doormat_plain*4', 's', 1, 1, 0.1, '0', '0', '1', 90, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(75, 'Doormat', 'doormat_plain*6', 's', 1, 1, 0.1, '0', '0', '1', 91, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(76, 'Doormat', 'doormat_plain*5', 's', 1, 1, 0.1, '0', '0', '1', 93, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77, 'Floor Rug', 'carpet_standard*5', 's', 3, 5, 0, '1', '0', '1', 94, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(78, 'Occasional Table', 'table_plasto_4leg*5', 's', 2, 2, 1, '1', '0', '0', 95, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(79, 'Square Dining Table', 'table_plasto_bigsquare*5', 's', 2, 2, 1, '1', '0', '0', 96, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(80, 'Round Dining Table', 'table_plasto_round*5', 's', 2, 2, 1, '1', '0', '0', 97, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(81, 'Square Dining Table', 'table_plasto_square*5', 's', 1, 1, 1, '1', '0', '0', 98, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(82, 'Chair', 'chair_plasto*5', 's', 1, 1, 1, '0', '1', '0', 99, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(83, 'Occasional table Table', 'table_plasto_4leg*6', 's', 2, 2, 1, '1', '0', '0', 100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(84, 'Square Dining Table', 'table_plasto_bigsquare*6', 's', 2, 2, 1, '1', '0', '0', 101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(85, 'Round Dining Table', 'table_plasto_round*6', 's', 2, 2, 1, '1', '0', '0', 102, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(86, 'Square Dining Table', 'table_plasto_square*6', 's', 1, 1, 1, '1', '0', '0', 103, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(87, 'Chair', 'chair_plasto*6', 's', 1, 1, 1, '0', '1', '0', 104, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(88, 'Occasional table', 'table_plasto_4leg*7', 's', 2, 2, 1, '1', '0', '0', 105, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89, 'Square Dining Table', 'table_plasto_bigsquare*7', 's', 2, 2, 1, '1', '0', '0', 106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(90, 'Round Dining Table', 'table_plasto_round*7', 's', 2, 2, 1, '1', '0', '0', 107, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(91, 'Square Dining Table', 'table_plasto_square*7', 's', 1, 1, 1, '1', '0', '0', 108, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(92, 'Chair', 'chair_plasto*7', 's', 1, 1, 1, '0', '1', '0', 109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(93, 'Occasional Table', 'table_plasto_4leg*8', 's', 2, 2, 1, '1', '0', '0', 110, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(94, 'Square Dining Table', 'table_plasto_bigsquare*8', 's', 2, 2, 1, '1', '0', '0', 111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95, 'Round Dining Table', 'table_plasto_round*8', 's', 2, 2, 1, '1', '0', '0', 112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(96, 'Square Dining Table', 'table_plasto_square*8', 's', 1, 1, 1, '1', '0', '0', 113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(97, 'Chair', 'chair_plasto*8', 's', 1, 1, 1, '0', '1', '0', 114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(98, 'Occasional Table', 'table_plasto_4leg*9', 's', 2, 2, 1, '1', '0', '0', 115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99, 'Square Dining Table', 'table_plasto_bigsquare*9', 's', 2, 2, 1, '1', '0', '0', 116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(100, 'Square Dining Table', 'table_plasto_round*9', 's', 2, 2, 1, '1', '0', '0', 117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(101, 'Chair', 'chair_plasto*9', 's', 1, 1, 1, '0', '1', '0', 119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(102, 'Floor Rug', 'carpet_standard*6', 's', 3, 5, 0, '1', '0', '1', 120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(103, 'Plastic Pod Chair', 'chair_plasty*1', 's', 1, 1, 1, '0', '1', '0', 121, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(104, 'Pizza Box', 'pizza', 's', 1, 1, 1, '0', '0', '0', 122, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(105, 'Empty Cans', 'drinks', 's', 1, 1, 1, '0', '0', '0', 123, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(106, 'Plastic Pod Chair', 'chair_plasty*2', 's', 1, 1, 1, '0', '1', '0', 124, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(107, 'Plastic Pod Chair', 'chair_plasty*3', 's', 1, 1, 1, '0', '1', '0', 125, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(108, 'Plastic Pod Chair', 'chair_plasty*4', 's', 1, 1, 1, '0', '1', '0', 126, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(109, 'Mini-Bar', 'bar_polyfon', 's', 1, 1, 1, '0', '0', '0', 127, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,5,2,1', ''),
(110, 'Aloe Vera', 'plant_cruddy', 's', 1, 1, 1, '0', '0', '0', 128, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(111, 'Empty Spinning Bottle', 'bottle', 's', 1, 1, 1, '0', '0', '0', 129, '1', '1', '1', '1', '1', 'bottle', 0, '0', ''),
(112, 'Bar/desk', 'bardesk_polyfon', 's', 2, 1, 1, '1', '0', '0', 130, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(113, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon', 's', 1, 1, 1, '1', '0', '0', 131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(115, 'Barrel Minibar', 'bar_armas', 's', 1, 1, 1, '0', '0', '0', 133, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,2,1', ''),
(116, 'Bardesk', 'bartable_armas', 's', 1, 3, 1.2, '1', '0', '0', 134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(117, 'Barrel Stool', 'bar_chair_armas', 's', 1, 1, 1.2, '0', '1', '0', 135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(118, 'Soft Wool Rug', 'carpet_soft', 's', 2, 4, 0, '1', '0', '1', 136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(119, 'Soft Wool Rug', 'carpet_soft*1', 's', 2, 4, 0, '1', '0', '1', 137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(120, 'Soft Wool Rug', 'carpet_soft*2', 's', 2, 4, 0, '1', '0', '1', 138, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(121, 'Soft Wool Rug', 'carpet_soft*3', 's', 2, 4, 0, '1', '0', '1', 139, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(122, 'Soft Wool Rug', 'carpet_soft*4', 's', 2, 4, 0, '1', '0', '1', 140, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(123, 'Soft Wool Rug', 'carpet_soft*5', 's', 2, 4, 0, '1', '0', '1', 141, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(124, 'Soft Wool Rug', 'carpet_soft*6', 's', 2, 4, 0, '1', '0', '1', 143, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(125, 'Portable TV', 'red_tv', 's', 1, 1, 1, '0', '0', '0', 144, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(126, 'Large TV', 'wood_tv', 's', 1, 2, 1, '0', '0', '0', 145, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(127, 'Pink Faux-Fur Bear Rug', 'carpet_polar*1', 's', 2, 3, 0, '1', '0', '1', 146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(128, 'Plastic Pod Chair', 'chair_plasty*5', 's', 1, 1, 1, '0', '1', '0', 147, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(129, 'Blue Bear Rug', 'carpet_polar*2', 's', 2, 3, 0, '1', '0', '1', 148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(130, 'Yellow Bear Rug', 'carpet_polar*3', 's', 2, 3, 0, '1', '0', '1', 149, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(131, 'Green Bear Rug', 'carpet_polar*4', 's', 2, 3, 0, '1', '0', '1', 150, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(132, 'Plastic Pod Chair', 'chair_plasty*6', 's', 1, 1, 1, '0', '1', '0', 151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(133, 'Large Coffee Table', 'table_polyfon', 's', 2, 2, 1, '1', '0', '0', 152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(134, 'Large Dining Table', 'smooth_table_polyfon', 's', 2, 2, 1, '1', '0', '0', 153, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(135, 'Armchair', 'sofachair_polyfon_girl', 's', 1, 1, 1.1, '0', '1', '0', 154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(136, 'Single Bed', 'bed_polyfon_girl_one', 's', 1, 3, 1.8, '0', '0', '0', 155, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(137, 'Double Bed', 'bed_polyfon_girl', 's', 2, 3, 1.8, '0', '0', '0', 156, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(138, 'Two-seater Sofa', 'sofa_polyfon_girl', 's', 2, 1, 1.1, '0', '1', '0', 157, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(139, 'Plain Single Bed', 'bed_budgetb_one', 's', 1, 3, 1.9, '0', '0', '0', 158, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(140, 'Plain Double Bed', 'bed_budgetb', 's', 2, 3, 1.9, '0', '0', '0', 159, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(141, 'Pineapple Plant', 'plant_pineapple', 's', 1, 1, 1, '0', '0', '0', 160, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(142, 'Fruit Tree', 'plant_fruittree', 's', 1, 1, 1, '0', '0', '0', 161, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(143, 'Small Cactus', 'plant_small_cactus', 's', 1, 1, 1, '0', '0', '0', 162, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(144, 'Bonsai Tree', 'plant_bonsai', 's', 1, 1, 1, '0', '0', '0', 163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(145, 'Mature Cactus', 'plant_big_cactus', 's', 1, 1, 1, '0', '0', '0', 164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(146, 'Yukka Plant', 'plant_yukka', 's', 1, 1, 1, '0', '0', '0', 165, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(147, 'Floor Rug', 'carpet_standard*7', 's', 3, 5, 0, '1', '0', '1', 166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(148, 'Floor Rug', 'carpet_standard*8', 's', 3, 5, 0, '1', '0', '1', 167, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(149, 'Floor Rug', 'carpet_standard*9', 's', 3, 5, 0, '1', '0', '1', 168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(150, 'Floor Rug', 'carpet_standard*10', 's', 3, 5, 0, '1', '0', '1', 169, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(151, 'Floor Rug', 'carpet_standard*11', 's', 3, 5, 0, '1', '0', '1', 170, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(152, 'Cut Sunflower', 'plant_sunflower', 's', 1, 1, 1, '0', '0', '0', 171, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(153, 'Cut Roses', 'plant_rose', 's', 1, 1, 1, '0', '0', '0', 172, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(154, 'Digital TV', 'tv_luxus', 's', 1, 3, 1, '0', '0', '0', 173, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(155, 'Bubble Bath', 'bath', 's', 1, 2, 1, '0', '1', '0', 174, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(156, 'Sink', 'sink', 's', 1, 1, 1, '0', '0', '0', 177, '1', '1', '1', '1', '1', 'vendingmachine', 0, '100', ''),
(157, 'Loo Seat', 'toilet', 's', 1, 1, 1.2, '0', '1', '0', 178, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(158, 'Rubber Duck', 'duck', 's', 1, 1, 1, '0', '0', '0', 179, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(159, 'Floor Tiles', 'tile', 's', 4, 4, 0, '1', '0', '1', 180, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(160, 'Loo Seat', 'toilet_red', 's', 1, 1, 1.2, '0', '1', '0', 181, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(161, 'Loo Seat', 'toilet_yell', 's', 1, 1, 1.2, '0', '1', '0', 182, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(162, 'Floor Tiles', 'tile_red', 's', 4, 4, 0, '1', '0', '1', 183, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(163, 'Floor Tiles', 'tile_yell', 's', 4, 4, 0, '1', '0', '1', 184, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(164, 'Gift', 'present_gen', 's', 1, 1, 1, '1', '0', '0', 187, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(165, 'Gift', 'present_gen1', 's', 1, 1, 1, '1', '0', '0', 188, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(166, 'Gift', 'present_gen2', 's', 1, 1, 1, '1', '0', '0', 189, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(167, 'Gift', 'present_gen3', 's', 1, 1, 1, '1', '0', '0', 190, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(168, 'Gift', 'present_gen4', 's', 1, 1, 1, '1', '0', '0', 191, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(169, 'Gift', 'present_gen5', 's', 1, 1, 1, '1', '0', '0', 192, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(170, 'Gift', 'present_gen6', 's', 1, 1, 1, '1', '0', '0', 193, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(171, 'A Pura Minibar', 'bar_basic', 's', 1, 1, 1, '0', '0', '0', 195, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,2,5,1', ''),
(172, 'Pura Shelves', 'shelves_basic', 's', 2, 1, 1, '0', '0', '0', 196, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(173, 'iced sofachair', 'soft_sofachair_norja', 's', 1, 1, 1, '0', '1', '0', 197, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(174, 'iced sofa', 'soft_sofa_norja', 's', 2, 1, 1, '0', '1', '0', 198, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(175, 'Pura Lamp', 'lamp_basic', 's', 1, 1, 1, '0', '0', '0', 199, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(176, 'Lodge Candle', 'lamp2_armas', 's', 1, 1, 1, '0', '0', '0', 200, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(177, 'Pura Refridgerator', 'fridge', 's', 1, 1, 1, '0', '0', '0', 201, '1', '1', '1', '1', '1', 'vendingmachine', 0, '3,5,6,2', ''),
(178, 'Telephone Box', 'door', 's', 1, 1, 0.001, '0', '0', '0', 202, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(179, 'Wardrobe', 'doorB', 's', 1, 1, 0.001, '0', '0', '0', 204, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(180, 'Portaloo', 'doorC', 's', 1, 1, 0.001, '0', '0', '0', 205, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(181, 'Pumpkin Lamp', 'pumpkin', 's', 1, 1, 1, '1', '0', '0', 206, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(182, 'Skull Candle Holder', 'skullcandle', 's', 1, 1, 1, '0', '0', '0', 207, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(183, 'Blood', 'deadduck', 's', 1, 1, 1, '0', '0', '0', 208, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(184, 'Dead Duck 2', 'deadduck2', 's', 1, 1, 1, '0', '0', '0', 209, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(185, 'Dead Duck 3', 'deadduck3', 's', 1, 1, 1, '0', '0', '0', 210, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(186, 'Menorah', 'menorah', 's', 1, 1, 1, '0', '0', '0', 211, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(187, 'Christmas Pudding', 'pudding', 's', 1, 1, 1, '1', '0', '0', 212, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(188, 'Joint of Ham', 'ham', 's', 1, 1, 1, '0', '0', '0', 213, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(189, 'Roast Turkey', 'turkey', 's', 1, 1, 1, '0', '0', '0', 214, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(190, 'Christmas Rubber Duck', 'xmasduck', 's', 1, 1, 1, '1', '0', '0', 215, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(191, 'Gingerbread House', 'house', 's', 1, 1, 1, '0', '0', '0', 216, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(192, 'Electric Candles', 'triplecandle', 's', 1, 1, 1, '0', '0', '0', 217, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(193, 'Christmas Tree 1', 'tree3', 's', 1, 1, 1, '0', '0', '0', 218, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(194, 'Christmas Tree 2', 'tree4', 's', 1, 1, 1, '0', '0', '0', 219, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(195, 'Christmas Tree 3', 'tree5', 's', 1, 1, 1, '0', '0', '0', 220, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(196, 'Eaten Ham', 'ham2', 's', 1, 1, 1, '0', '0', '0', 223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(197, 'White Candle Plate', 'wcandleset', 's', 1, 1, 1, '0', '0', '0', 224, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(198, 'Red Candle Plate', 'rcandleset', 's', 1, 1, 1, '0', '0', '0', 225, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(199, 'Giant Heart', 'statue', 's', 1, 1, 1, '0', '0', '0', 226, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(200, 'Valentine''s Duck', 'valeduck', 's', 1, 1, 1, '0', '0', '0', 228, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(201, 'Heart Sofa', 'heartsofa', 's', 2, 1, 1, '0', '1', '0', 229, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(202, 'Throne', 'throne', 's', 1, 1, 1, '0', '1', '0', 230, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(203, 'Russian Samovar', 'samovar', 's', 1, 1, 1, '0', '0', '0', 231, '0', '1', '1', '1', '1', 'vendingmachine', 0, '1', ''),
(204, 'Vase of Flowers', 'giftflowers', 's', 1, 1, 1, '0', '0', '0', 232, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(205, 'Cake', 'habbocake', 's', 1, 1, 1, '0', '0', '0', 233, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(206, 'Holopod', 'hologram', 's', 1, 1, 1, '0', '0', '0', 234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(207, 'Wannabe bunny', 'easterduck', 's', 1, 1, 1, '0', '0', '0', 235, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(208, 'Squidgy Bunny', 'bunny', 's', 1, 1, 1, '0', '0', '0', 236, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(209, 'Basket Of Eggs', 'basket', 's', 1, 1, 1, '0', '0', '0', 237, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(210, 'Pop-up Egg', 'birdie', 's', 1, 1, 1, '0', '0', '0', 238, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(211, 'Holo-dice', 'edice', 's', 1, 1, 1, '0', '0', '0', 239, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(212, 'Club sofa', 'club_sofa', 's', 2, 1, 1, '0', '1', '0', 267, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(213, 'Gold Trophy', 'a0 prize1', 's', 1, 1, 1, '0', '0', '0', 241, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(214, 'Silver Trophy', 'a0 prize2', 's', 1, 1, 1, '0', '0', '0', 242, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(215, 'Bronze Trophy', 'a0 prize3', 's', 1, 1, 1, '0', '0', '0', 243, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(216, 'Hatch (Lockable)', 'divider_poly3', 's', 1, 1, 0.001, '0', '0', '0', 244, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(217, 'Corner plinth', 'divider_arm1', 's', 1, 1, 1.4, '1', '0', '0', 245, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(218, 'Room divider', 'divider_arm2', 's', 2, 1, 1, '0', '0', '0', 246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(219, 'Knock', 'divider_arm3', 's', 1, 1, 0.001, '0', '0', '0', 247, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(220, 'Looks squishy', 'divider_nor1', 's', 1, 1, 1, '0', '0', '0', 248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(221, 'Corner Shelf', 'divider_silo1', 's', 1, 1, 1, '0', '0', '0', 249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(222, 'Strong', 'divider_nor2', 's', 2, 1, 1, '0', '0', '0', 250, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(223, 'Screen', 'divider_silo2', 's', 2, 1, 1, '0', '0', '0', 251, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(224, 'Door (Lockable)', 'divider_nor3', 's', 1, 1, 0.001, '0', '0', '0', 252, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(225, 'Gate (lockable)', 'divider_silo3', 's', 1, 1, 0.001, '0', '0', '0', 253, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(226, 'Typewriter', 'typingmachine', 's', 1, 1, 1, '0', '0', '0', 254, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(227, 'Dragon Egg', 'spyro', 's', 1, 1, 1, '0', '0', '0', 260, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(228, 'Holo-girl', 'redhologram', 's', 1, 1, 1, '0', '0', '0', 261, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(230, 'Poinsetta', 'joulutahti', 's', 1, 1, 1, '0', '0', '0', 264, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(231, 'Pink Hyacinth', 'hyacinth1', 's', 1, 1, 1, '0', '0', '0', 265, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(232, 'Blue Hyacinth', 'hyacinth2', 's', 1, 1, 1, '0', '0', '0', 266, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(233, 'Chair', 'chair_plasto*10', 's', 1, 1, 1, '0', '1', '0', 268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(234, 'Chair', 'chair_plasto*11', 's', 1, 1, 1, '0', '1', '0', 269, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(235, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*12', 's', 1, 1, 1, '1', '0', '0', 270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(236, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*13', 's', 1, 1, 1, '1', '0', '0', 271, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(237, 'Chair', 'chair_plasto*12', 's', 1, 1, 1, '0', '1', '0', 273, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(238, 'Chair', 'chair_plasto*13', 's', 1, 1, 1, '0', '1', '0', 274, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(239, 'HC chair', 'chair_plasto*14', 's', 1, 1, 1, '0', '1', '0', 275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(240, 'HC table', 'table_plasto_4leg*14', 's', 2, 2, 1, '1', '0', '0', 276, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(241, 'Mochamaster', 'mocchamaster', 's', 1, 1, 1, '1', '0', '0', 277, '1', '1', '1', '1', '1', 'vendingmachine', 0, '9,8,14,15,6,10,11,12,17,13', ''),
(242, 'Basketball Court', 'carpet_legocourt', 's', 3, 3, 0, '1', '0', '1', 278, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(243, 'Team Bench', 'bench_lego', 's', 4, 1, 1, '0', '1', '0', 279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(244, 'Basketball Trophy', 'legotrophy', 's', 1, 1, 1, '0', '0', '0', 280, '1', '1', '1', '1', '0', 'trophy', 2, '0', ''),
(245, 'Holiday Romance', 'valentinescreen', 's', 2, 1, 0.1, '0', '0', '1', 283, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(246, 'Dicemaster', 'edicehc', 's', 1, 1, 1, '0', '0', '0', 284, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(247, 'Petal Patch', 'rare_daffodil_rug', 's', 2, 2, 0, '1', '0', '1', 285, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(248, 'Blue Amber Lamp', 'rare_beehive_bulb', 's', 1, 1, 1, '0', '0', '0', 286, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(249, 'Throne Sofa', 'hcsohva', 's', 2, 1, 1, '0', '1', '0', 287, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(250, 'Tubmaster', 'hcamme', 's', 1, 2, 0.6, '0', '1', '0', 288, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(251, 'Golden Elephant', 'rare_elephant_statue', 's', 1, 1, 1, '0', '0', '0', 290, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(252, 'Bird Bath (red)', 'rare_fountain', 's', 1, 1, 1, '0', '0', '0', 291, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(253, 'Speaker''s Corner', 'rare_stand', 's', 1, 1, 1.7, '0', '1', '0', 292, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(254, 'Snow Globe', 'rare_globe', 's', 1, 1, 1, '0', '0', '0', 293, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(255, 'Hammock', 'rare_hammock', 's', 1, 3, 1.57, '0', '0', '0', 294, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(256, 'Silver Elephant', 'rare_elephant_statue*1', 's', 1, 1, 1, '0', '0', '0', 295, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(257, 'Bronze Elephant', 'rare_elephant_statue*2', 's', 1, 1, 1, '0', '0', '0', 296, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(258, 'Bird Bath (grey)', 'rare_fountain*1', 's', 1, 1, 1, '0', '0', '0', 297, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(259, 'Bird Bath (green)', 'rare_fountain*2', 's', 1, 1, 1, '0', '0', '0', 298, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(260, 'Bird Bath (blue)', 'rare_fountain*3', 's', 1, 1, 1, '0', '0', '0', 299, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(261, 'Red Amber Lamp', 'rare_beehive_bulb*1', 's', 1, 1, 1, '0', '0', '0', 300, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(262, 'Yellow Amber Lamp', 'rare_beehive_bulb*2', 's', 1, 1, 1, '0', '0', '0', 301, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(263, 'Lappland Greetings', 'rare_xmas_screen', 's', 2, 1, 0, '0', '0', '1', 302, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(264, 'Yellow Parasol', 'rare_parasol*1', 's', 1, 1, 1, '0', '0', '0', 303, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(265, 'Orange Parasol', 'rare_parasol*2', 's', 1, 1, 1, '0', '0', '0', 304, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(266, 'Violet Parasol', 'rare_parasol*3', 's', 1, 1, 1, '0', '0', '0', 305, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(267, 'Dead tree', 'tree1', 's', 1, 1, 1, '0', '0', '0', 1758, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20045, 'arabian_tile', 'arabian_tile', 's', 2, 2, 0, '1', '0', '1', 3312, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(269, 'White Candle', 'wcandle', 's', 1, 1, 1, '0', '0', '0', 2102, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(270, 'Red Candle', 'rcandle', 's', 1, 1, 1, '0', '0', '0', 2121, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(272, 'Gingerbread House', 'house2', 's', 1, 1, 1, '0', '0', '0', 428, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(273, 'Habbo Turntable', 'djesko_turntable', 's', 1, 1, 1, '0', '0', '0', 449, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(275, 'Habbo Cola Machine', 'md_limukaappi', 's', 1, 1, 1, '0', '0', '0', 457, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(276, 'Occasional Table', 'table_plasto_4leg*10', 's', 2, 2, 1, '1', '0', '0', 1484, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(277, 'Occasional Table', 'table_plasto_4leg*15', 's', 2, 2, 1, '1', '0', '0', 1486, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(278, 'Occasional Table', 'table_plasto_bigsquare*14', 's', 2, 2, 1, '1', '0', '0', 1487, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(279, 'Occasional Table', 'table_plasto_bigsquare*15', 's', 2, 2, 1, '1', '0', '0', 1488, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(280, 'Occasional Table', 'table_plasto_round*14', 's', 2, 2, 1, '1', '0', '0', 1489, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(281, 'Occasional Table', 'table_plasto_round*15', 's', 2, 2, 1, '1', '0', '0', 1490, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(282, 'Occasional Table', 'table_plasto_square*14', 's', 1, 1, 1, '1', '0', '0', 1491, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(283, 'Occasional Table', 'table_plasto_square*15', 's', 1, 1, 1, '1', '0', '0', 1492, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(284, 'Chair', 'chair_plasto*15', 's', 1, 1, 1, '0', '1', '0', 1495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(285, 'Plastic Pod Chair', 'chair_plasty*7', 's', 1, 1, 1, '0', '1', '0', 1496, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(286, 'Plastic Pod Chair', 'chair_plasty*8', 's', 1, 1, 1, '0', '1', '0', 1497, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(287, 'Plastic Pod Chair', 'chair_plasty*9', 's', 1, 1, 1, '0', '1', '0', 1498, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(288, 'Plastic Pod Chair', 'chair_plasty*10', 's', 1, 1, 1, '0', '1', '0', 1499, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(289, 'Plastic Pod Chair', 'chair_plasty*11', 's', 1, 1, 1, '0', '1', '0', 1500, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(290, 'Chair', 'chair_plasto*16', 's', 1, 1, 1, '0', '1', '0', 1501, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(291, 'Occasional Table', 'table_plasto_4leg*16', 's', 2, 2, 1, '1', '0', '0', 1502, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(292, 'Scoreboard', 'hockey_score', 's', 1, 1, 1, '0', '0', '0', 1503, '1', '1', '1', '1', '1', 'scoreboard', 100, '0', ''),
(293, 'Lert', 'hockey_light', 's', 1, 1, 1, '0', '0', '0', 1504, '1', '1', '1', '1', '1', 'alert', 2, '0', ''),
(294, 'Imperial Teleport', 'doorD', 's', 1, 1, 0.001, '0', '0', '0', 1505, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(295, 'Duck trophy', 'a0 prizetrophy2_b', 's', 1, 1, 1, '0', '0', '0', 1506, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(296, 'Globe trophy', 'a0 prizetrophy3_b', 's', 1, 1, 1, '0', '0', '0', 1507, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(297, 'Fish trophy', 'a0 prizetrophy4_b', 's', 1, 1, 1, '0', '0', '0', 1508, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(298, 'Champion trophy', 'a0 prizetrophy5_b', 's', 1, 1, 1, '0', '0', '0', 1509, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(299, 'Classic trophy', 'prizetrophy*1', 's', 1, 1, 1, '0', '0', '0', 1512, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(300, 'Duck trophy', 'a0 prizetrophy2_g', 's', 1, 1, 1, '0', '0', '0', 1512, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(301, 'Globe trophy', 'a0 prizetrophy3_g', 's', 1, 1, 1, '0', '0', '0', 1513, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(302, 'Fish trophy', 'a0 prizetrophy4_g', 's', 1, 1, 1, '0', '0', '0', 1514, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(303, 'Duo trophy', 'a0 prizetrophy5_g', 's', 1, 1, 1, '0', '0', '0', 1515, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(304, 'Champion trophy', 'a0 prizetrophy6_g', 's', 1, 1, 1, '0', '0', '0', 1516, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(305, 'Classic trophy', 'prizetrophy*2', 's', 1, 1, 1, '0', '0', '0', 1519, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(306, 'Duck trophy', 'a0 prizetrophy2_s', 's', 1, 1, 1, '0', '0', '0', 1518, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(307, 'Globe trophy', 'a0 prizetrophy3_s', 's', 1, 1, 1, '0', '0', '0', 1519, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(308, 'Fish trophy', 'a0 prizetrophy4_s', 's', 1, 1, 1, '0', '0', '0', 1520, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(309, 'Duo trophy', 'a0 prizetrophy5_s', 's', 1, 1, 1, '0', '0', '0', 1521, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(310, 'Champion trophy', 'a0 prizetrophy6_s', 's', 1, 1, 1, '0', '0', '0', 1522, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(311, 'Classic trophy', 'prizetrophy*3', 's', 1, 1, 1, '0', '0', '0', 1526, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(312, 'Green Parasol', 'rare_parasol*0', 's', 1, 1, 1, '0', '0', '0', 289, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(313, 'Oil Lamp', 'hc_lmp', 's', 1, 1, 1, '0', '0', '0', 1529, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(314, 'Nordic Table', 'hc_tbl', 's', 1, 3, 1, '1', '0', '0', 1528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(315, 'Majestic Chair', 'hc_chr', 's', 1, 1, 1, '0', '1', '0', 1527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(316, 'Study Desk', 'hc_dsk', 's', 1, 2, 1, '0', '0', '0', 1530, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(317, 'Night', 'nest', 's', 1, 1, 1, '1', '0', '0', 1531, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(318, 'Bones Mega Multipack', 'petfood1', 's', 1, 1, 1, '1', '0', '0', 1532, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(319, 'Sardines Mega Multipack', 'petfood2', 's', 1, 1, 1, '1', '0', '0', 1533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(320, 'Cabbage Mega Multipack', 'petfood3', 's', 1, 1, 1, '1', '0', '0', 1534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(321, 'Blue Water Bowl', 'waterbowl*4', 's', 1, 1, 1, '1', '0', '0', 1535, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(322, 'Brown Water Bowl', 'waterbowl*5', 's', 1, 1, 1, '1', '0', '0', 1536, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(323, 'Green Water Bowl', 'waterbowl*2', 's', 1, 1, 1, '1', '0', '0', 1537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(324, 'Red Water Bowl', 'waterbowl*1', 's', 1, 1, 1, '1', '0', '0', 1538, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(325, 'Yellow Water Bowl', 'waterbowl*3', 's', 1, 1, 1, '1', '0', '0', 1539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(326, 'Rubber Ball', 'toy1', 's', 1, 1, 1, '1', '0', '0', 1540, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(327, 'Rubber Ball', 'toy1*1', 's', 1, 1, 1, '1', '0', '0', 1541, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(328, 'Rubber Ball', 'toy1*2', 's', 1, 1, 1, '1', '0', '0', 1542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(329, 'Rubber Ball', 'toy1*3', 's', 1, 1, 1, '1', '0', '0', 1543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(330, 'Rubber Ball', 'toy1*4', 's', 1, 1, 1, '1', '0', '0', 1544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(331, 'Marzipan Man', 'goodie1', 's', 1, 1, 1, '1', '0', '0', 1545, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(332, 'Marzipan Man', 'goodie1*1', 's', 1, 1, 1, '1', '0', '0', 1546, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(333, 'Marzipan Man', 'goodie1*2', 's', 1, 1, 1, '1', '0', '0', 1547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(334, 'Chocolate Mouse', 'goodie2', 's', 1, 1, 1, '1', '0', '0', 1548, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(335, 'Bronze Habbo trophy', 'a0 prizetrophy7_b', 's', 1, 1, 1, '0', '0', '0', 1547, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(336, 'Gold Habbo trophy', 'a0 prizetrophy7_g', 's', 1, 1, 1, '0', '0', '0', 1548, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(337, 'Silver Habbo trophy', 'a0 prizetrophy7_s', 's', 1, 1, 1, '0', '0', '0', 1549, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(338, 'Red Laser Door', 'scifiport*0', 's', 1, 1, 0.001, '0', '0', '0', 1549, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(339, 'Violet Sci-Fi Port', 'scifiport*9', 's', 1, 1, 0.001, '0', '0', '0', 1550, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(340, 'Purple Sci-Fi Port', 'scifiport*8', 's', 1, 1, 0.001, '0', '0', '0', 1551, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(341, 'Aqua Laser Gate', 'scifiport*7', 's', 1, 1, 0.001, '0', '0', '0', 1552, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(342, 'White Sci-Fi Port', 'scifiport*6', 's', 1, 1, 0.001, '0', '0', '0', 1553, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(343, 'Security Fence', 'scifiport*5', 's', 1, 1, 0.001, '0', '0', '0', 1554, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(344, 'Pink Sci-Fi Port', 'scifiport*4', 's', 1, 1, 0.001, '0', '0', '0', 1555, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(345, 'Jade Sci-Fi Port', 'scifiport*3', 's', 1, 1, 0.001, '0', '0', '0', 1556, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(346, 'Blue Laser Gate', 'scifiport*2', 's', 1, 1, 0.001, '0', '0', '0', 1557, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(347, 'Gold Laser Gate', 'scifiport*1', 's', 1, 1, 0.001, '0', '0', '0', 1558, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(348, 'Neptune Smoke Machine', 'scifirocket*9', 's', 1, 1, 1, '0', '0', '0', 1559, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(349, 'From a space far', 'scifirocket*8', 's', 1, 1, 1, '0', '0', '0', 1560, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(350, 'Jupiter Smoke Machine', 'scifirocket*7', 's', 1, 1, 1, '0', '0', '0', 1561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(351, 'Mercury Smoke Machine', 'scifirocket*6', 's', 1, 1, 1, '0', '0', '0', 1562, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(352, 'Uranus Smoke Machine', 'scifirocket*5', 's', 1, 1, 1, '0', '0', '0', 1563, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(353, 'Venus Smoke Machine', 'scifirocket*4', 's', 1, 1, 1, '0', '0', '0', 1564, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(354, 'Endor Smoke Machine', 'scifirocket*3', 's', 1, 1, 1, '0', '0', '0', 1565, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(355, 'Earth Smoke Machine', 'scifirocket*2', 's', 1, 1, 1, '0', '0', '0', 1566, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(356, 'Saturn Smoke Machine', 'scifirocket*1', 's', 1, 1, 1, '0', '0', '0', 1567, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(357, 'Mars Smoke Machine', 'scifirocket*0', 's', 1, 1, 1, '0', '0', '0', 1568, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(358, 'Violet Starship Door', 'scifidoor*10', 's', 1, 1, 0.001, '0', '0', '0', 1569, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(359, 'It''s blue', 'scifidoor*9', 's', 1, 1, 0.001, '0', '0', '0', 1570, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(360, 'Purple Spaceship Door', 'scifidoor*8', 's', 1, 1, 0.001, '0', '0', '0', 1571, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(361, 'Aqua Spaceship Door', 'scifidoor*7', 's', 1, 1, 0.001, '0', '0', '0', 1572, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(362, 'Black Monolith', 'scifidoor*6', 's', 1, 1, 0.001, '0', '0', '0', 1573, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(363, 'White Spaceship Door', 'scifidoor*5', 's', 1, 1, 0.001, '0', '0', '0', 1574, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(364, 'Emerald Spaceship Door', 'scifidoor*4', 's', 1, 1, 0.001, '0', '0', '0', 1575, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(365, 'Lightblue Spaceship Door', 'scifidoor*3', 's', 1, 1, 0.001, '0', '0', '0', 1576, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(366, 'Yellow Spaceship Door', 'scifidoor*2', 's', 1, 1, 0.001, '0', '0', '0', 1577, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(367, 'Pink Spaceship Door', 'scifidoor*1', 's', 1, 1, 0.001, '0', '0', '0', 1578, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(368, 'Puffy', 'pillow*5', 's', 1, 1, 1, '0', '1', '0', 1579, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(369, 'Puffy', 'pillow*8', 's', 1, 1, 1, '0', '1', '0', 1580, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(370, 'White Lace Pillow', 'pillow*0', 's', 1, 1, 1, '0', '1', '0', 1581, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(371, 'Puffy', 'pillow*1', 's', 1, 1, 1, '0', '1', '0', 1582, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(372, 'Puffy', 'pillow*2', 's', 1, 1, 1, '0', '1', '0', 1583, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(373, 'Purple Velvet Pillow', 'pillow*7', 's', 1, 1, 1, '0', '1', '0', 1584, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(374, 'Puffy', 'pillow*9', 's', 1, 1, 1, '0', '1', '0', 1585, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(375, 'Puffy', 'pillow*4', 's', 1, 1, 1, '0', '1', '0', 1586, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(376, 'Puffy', 'pillow*6', 's', 1, 1, 1, '0', '1', '0', 1587, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(377, 'Puffy', 'pillow*3', 's', 1, 1, 1, '0', '1', '0', 1588, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(378, 'Pink marquee', 'marquee*1', 's', 1, 1, 0.001, '0', '0', '0', 1589, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(379, 'Red Dragon Marquee', 'marquee*2', 's', 1, 1, 0.001, '0', '0', '0', 1590, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(380, 'Purple Marquee', 'marquee*7', 's', 1, 1, 0.001, '0', '0', '0', 1591, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(381, 'White Marquee', 'marquee*10', 's', 1, 1, 0.001, '0', '0', '0', 1592, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(382, 'Ultramarine Marquee', 'marquee*8', 's', 1, 1, 0.001, '0', '0', '0', 1593, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(383, 'Green Marquee', 'marquee*9', 's', 1, 1, 0.001, '0', '0', '0', 1594, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(384, 'Graphite Marquee', 'marquee*5', 's', 1, 1, 0.001, '0', '0', '0', 1595, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(385, 'Yellow Marquee', 'marquee*4', 's', 1, 1, 0.001, '0', '0', '0', 1596, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(386, 'Blue Marquee', 'marquee*6', 's', 1, 1, 0.001, '0', '0', '0', 1597, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(387, 'Aqua Marquee', 'marquee*3', 's', 1, 1, 0.001, '0', '0', '0', 1598, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(388, 'Pink Oriental screen', 'wooden_screen*1', 's', 1, 2, 1, '0', '0', '0', 1599, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(389, 'RosewoodScreen', 'wooden_screen*2', 's', 1, 2, 1, '0', '0', '0', 1600, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(390, 'Purple Oriental Screen', 'wooden_screen*7', 's', 1, 2, 1, '0', '0', '0', 1601, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(391, 'White Oriental Screen', 'wooden_screen*0', 's', 1, 2, 1, '0', '0', '0', 1602, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(392, 'Night Blue Oriental Screen', 'wooden_screen*8', 's', 1, 2, 1, '0', '0', '0', 1603, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(393, 'Gray Oriental Screen', 'wooden_screen*5', 's', 1, 2, 1, '0', '0', '0', 1604, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(394, 'Green Oriental Screen', 'wooden_screen*9', 's', 1, 2, 1, '0', '0', '0', 1605, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(395, 'Golden Oriental Screen', 'wooden_screen*4', 's', 1, 2, 1, '0', '0', '0', 1606, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(396, 'Blue Oriental Screen', 'wooden_screen*6', 's', 1, 2, 1, '0', '0', '0', 1607, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(397, 'Terracotta Pillar', 'wooden_screen*3', 's', 1, 2, 1, '0', '0', '0', 1608, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(398, 'Pink Marble Pillar', 'pillar*1', 's', 1, 1, 1, '0', '0', '0', 1610, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(399, 'Rock Pillar', 'pillar*9', 's', 1, 1, 1, '0', '0', '0', 1611, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(400, 'Classy architect', 'pillar*0', 's', 1, 1, 1, '0', '0', '0', 1612, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(401, 'Roman Pillar', 'pillar*8', 's', 1, 1, 1, '0', '0', '0', 1613, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(402, 'Nordic Pillar', 'pillar*2', 's', 1, 1, 1, '0', '0', '0', 1614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(403, 'Pagan Pillar', 'pillar*5', 's', 1, 1, 1, '0', '0', '0', 1615, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(404, 'Dark Ages Pillar', 'pillar*4', 's', 1, 1, 1, '0', '0', '0', 1616, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(405, 'Atlantean Pillar', 'pillar*7', 's', 1, 1, 1, '0', '0', '0', 1617, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(406, 'blue pillar', 'pillar*3', 's', 1, 1, 1, '0', '0', '0', 1618, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(407, 'Serpent of Doom', 'rare_dragonlamp*4', 's', 1, 1, 1, '0', '0', '0', 1619, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(408, 'Fire Dragon Lamp', 'rare_dragonlamp*0', 's', 1, 1, 1, '0', '0', '0', 1620, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(409, 'Elf Green Dragon Lamp', 'rare_dragonlamp*5', 's', 1, 1, 1, '0', '0', '0', 1621, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(410, 'Jade Dragon Lamp', 'rare_dragonlamp*2', 's', 1, 1, 1, '0', '0', '0', 1622, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(411, 'Bronze Dragon Lamp', 'rare_dragonlamp*8', 's', 1, 1, 1, '0', '0', '0', 1623, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(412, 'Purple Dragon Lamp', 'rare_dragonlamp*9', 's', 1, 1, 1, '0', '0', '0', 1624, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(413, 'Sky Dragon Lamp', 'rare_dragonlamp*7', 's', 1, 1, 1, '0', '0', '0', 1625, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(414, 'Gold Dragon Lamp', 'rare_dragonlamp*6', 's', 1, 1, 1, '0', '0', '0', 1626, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(415, 'Sea Dragon Lamp', 'rare_dragonlamp*1', 's', 1, 1, 1, '0', '0', '0', 1627, '1', '1', '1', '1', '1', 'default', 2, '0', '');
INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(416, 'Silver Dragon Lamp', 'rare_dragonlamp*3', 's', 1, 1, 1, '0', '0', '0', 1628, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(417, 'Blueberry Ice Cream Machine', 'rare_icecream*1', 's', 1, 1, 1, '0', '0', '0', 1629, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(418, 'Chocolate Ice Cream Machine', 'rare_icecream*7', 's', 1, 1, 1, '0', '0', '0', 1630, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(419, 'Peppermint Ice Cream Machine', 'rare_icecream*8', 's', 1, 1, 1, '0', '0', '0', 1631, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(420, 'Pistachio Ice Cream Machine', 'rare_icecream*2', 's', 1, 1, 1, '0', '0', '0', 1632, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(421, 'Toffee Ice Cream Machine', 'rare_icecream*6', 's', 1, 1, 1, '0', '0', '0', 1633, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(422, 'Bubblegum Ice Cream Machine', 'rare_icecream*9', 's', 1, 1, 1, '0', '0', '0', 1634, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(423, 'Blackcurrant Ice Cream Machine', 'rare_icecream*3', 's', 1, 1, 1, '0', '0', '0', 1635, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(424, 'Cherry Ice Cream Machine', 'rare_icecream*0', 's', 1, 1, 1, '0', '0', '0', 1636, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(425, 'Strawberry Ice Cream Machine', 'rare_icecream*4', 's', 1, 1, 1, '0', '0', '0', 1637, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(426, 'Vanilla Ice Cream Machine', 'rare_icecream*5', 's', 1, 1, 1, '0', '0', '0', 1638, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(427, 'Brown Powered Fan', 'rare_fan*7', 's', 1, 1, 1, '0', '0', '0', 1639, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(428, 'Ochre Powered Fan', 'rare_fan*6', 's', 1, 1, 1, '0', '0', '0', 1640, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(429, 'Fucsia Powered Fan', 'rare_fan*9', 's', 1, 1, 1, '0', '0', '0', 1641, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(430, 'Purple Dragon Skin Fan', 'rare_fan*3', 's', 1, 1, 1, '0', '0', '0', 1642, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(431, 'Festive Fan', 'rare_fan*0', 's', 1, 1, 1, '0', '0', '0', 1643, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(432, 'SUPERLOVE Fan', 'rare_fan*4', 's', 1, 1, 1, '0', '0', '0', 1644, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(433, 'Yellow Powered Fan', 'rare_fan*5', 's', 1, 1, 1, '0', '0', '0', 1645, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(434, 'Birthday Fan', 'rare_fan*1', 's', 1, 1, 1, '0', '0', '0', 1646, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(435, 'Stylish', 'rare_fan*8', 's', 1, 1, 1, '0', '0', '0', 1647, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(436, 'Green Powered Fan', 'rare_fan*2', 's', 1, 1, 1, '0', '0', '0', 1648, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(437, 'Ice Habbo Roller', 'queue_tile1*3', 's', 1, 1, 0.5, '1', '0', '1', 1649, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(438, 'Blue Habbo Roller', 'queue_tile1*6', 's', 1, 1, 0.5, '1', '0', '1', 1650, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(439, 'Gold Habbo Roller', 'queue_tile1*4', 's', 1, 1, 0.5, '1', '0', '1', 1651, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(440, 'Green Habbo Roller', 'queue_tile1*9', 's', 1, 1, 0.5, '1', '0', '1', 1652, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(441, 'Navy Habbo Roller', 'queue_tile1*8', 's', 1, 1, 0.5, '1', '0', '1', 1653, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(442, 'Knight Roller', 'queue_tile1*5', 's', 1, 1, 0.5, '1', '0', '1', 1654, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(443, 'Purple Habbo Roller', 'queue_tile1*7', 's', 1, 1, 0.5, '1', '0', '1', 1655, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(444, 'Red Habbo Roller', 'queue_tile1*2', 's', 1, 1, 0.5, '1', '0', '1', 1656, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(445, 'Pink Habbo Roller', 'queue_tile1*1', 's', 1, 1, 0.5, '1', '0', '1', 1657, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(446, 'White Quest Roller', 'queue_tile1*0', 's', 1, 1, 0.5, '1', '0', '1', 1658, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(20071, 'ads_gsArcade_2 name', 'ads_gsArcade_2', 's', 1, 1, 1, '1', '0', '0', 3278, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(448, 'Snow Rug', 'rare_snowrug', 's', 2, 2, 0, '1', '0', '1', 1738, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(449, 'Lantern', 'cn_lamp', 's', 1, 1, 1, '0', '0', '0', 1741, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(450, 'Chinese Sofa', 'cn_sofa', 's', 3, 1, 1, '0', '1', '0', 1742, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(451, 'Sport track straight', 'sporttrack1*1', 's', 2, 2, 0, '1', '0', '1', 1745, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(452, 'Sport track straight grass', 'sporttrack1*3', 's', 2, 2, 0, '1', '0', '1', 1747, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(453, 'Sport track straight asphalt', 'sporttrack1*2', 's', 2, 2, 0, '1', '0', '1', 1748, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(454, 'Sport corner tartan', 'sporttrack2*1', 's', 2, 2, 0, '1', '0', '1', 1750, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(455, 'Sport corner asphalt', 'sporttrack2*2', 's', 2, 2, 0, '1', '0', '1', 1751, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(456, 'Sport corner grass', 'sporttrack2*3', 's', 2, 2, 0, '1', '0', '1', 1752, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(457, 'Sport goal tartan', 'sporttrack3*1', 's', 2, 2, 0, '1', '0', '1', 1754, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(458, 'Sport goal asphalt', 'sporttrack3*2', 's', 2, 2, 0, '1', '0', '1', 1755, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(459, 'Sport goal grass', 'sporttrack3*3', 's', 2, 2, 0, '1', '0', '1', 1756, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(460, 'Football Lamp', 'footylamp', 's', 1, 1, 1, '0', '0', '0', 1757, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(461, 'Bar Stool', 'barchair_silo', 's', 1, 1, 1.2, '0', '1', '0', 1759, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(462, 'Habbos', 'divider_nor4*4', 's', 2, 1, 1, '0', '0', '0', 1760, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(463, 'Classic Traffic Light', 'traffic_light*1', 's', 1, 1, 1, '0', '0', '0', 1761, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(464, 'Blue Traffic Light', 'traffic_light*2', 's', 1, 1, 1, '0', '0', '0', 1762, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(465, 'Purple Traffic Light', 'traffic_light*3', 's', 1, 1, 1, '0', '0', '0', 1763, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(466, 'Yellow Traffic Light', 'traffic_light*4', 's', 1, 1, 1, '0', '0', '0', 1764, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(467, 'Red Traffic Light', 'traffic_light*6', 's', 1, 1, 1, '0', '0', '0', 1765, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(468, 'Blue Inflatable Chair', 'rubberchair*1', 's', 1, 1, 1, '0', '1', '0', 1766, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(469, 'Pink Inflatable Chair', 'rubberchair*2', 's', 1, 1, 1, '0', '1', '0', 1767, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(470, 'Orange Inflatable Chair', 'rubberchair*3', 's', 1, 1, 1, '0', '1', '0', 1768, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(471, 'Ocean Inflatable Chair', 'rubberchair*4', 's', 1, 1, 1, '0', '1', '0', 1769, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(472, 'Lime Inflatable Chair', 'rubberchair*5', 's', 1, 1, 1, '0', '1', '0', 1770, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(473, 'Violet Inflatable Chair', 'rubberchair*6', 's', 1, 1, 1, '0', '1', '0', 1771, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(474, 'Yellow Maze Barrier', 'barrier*1', 's', 1, 2, 1, '0', '0', '0', 1772, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(475, 'No trespassing', 'barrier*2', 's', 1, 2, 1, '0', '0', '0', 1773, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(476, 'No trespassing', 'barrier*3', 's', 1, 2, 1, '0', '0', '0', 1774, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(477, 'White Inflatable Chair', 'rubberchair*7', 's', 1, 1, 1, '0', '1', '0', 1775, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(478, 'Black Inflatable Chair', 'rubberchair*8', 's', 1, 1, 1, '0', '1', '0', 1776, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(479, 'Black Iced Table', 'table_norja_med*2', 's', 2, 2, 1, '1', '0', '0', 1777, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(480, 'White Iced Table', 'table_norja_med*3', 's', 2, 2, 1, '1', '0', '0', 1778, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(481, 'Urban Iced Coffee Table', 'table_norja_med*4', 's', 2, 2, 1, '1', '0', '0', 1779, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(482, 'Large Coffee Table Pink', 'table_norja_med*5', 's', 2, 2, 1, '1', '0', '0', 1780, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(483, 'Large Coffee Table Blue', 'table_norja_med*6', 's', 2, 2, 1, '1', '0', '0', 1781, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(484, 'Rural Iced Coffee Table', 'table_norja_med*7', 's', 2, 2, 1, '1', '0', '0', 1782, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(485, 'Large Coffee Table Yellow', 'table_norja_med*8', 's', 2, 2, 1, '1', '0', '0', 1783, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(486, 'Large Coffee Table Red', 'table_norja_med*9', 's', 2, 2, 1, '1', '0', '0', 1784, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(487, 'Black Iced Bench', 'couch_norja*2', 's', 2, 1, 1, '0', '1', '0', 1785, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(488, 'White Iced Bench', 'couch_norja*3', 's', 2, 1, 1, '0', '1', '0', 1786, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(489, 'Urban Iced Bench', 'couch_norja*4', 's', 2, 1, 1, '0', '1', '0', 1787, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(490, 'Pink Bench', 'couch_norja*5', 's', 2, 1, 1, '0', '1', '0', 1788, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(491, 'Blue Bench', 'couch_norja*6', 's', 2, 1, 1, '0', '1', '0', 1789, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(492, 'Rural Iced Bench', 'couch_norja*7', 's', 2, 1, 1, '0', '1', '0', 1790, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(493, 'Yellow Bench', 'couch_norja*8', 's', 2, 1, 1, '0', '1', '0', 1791, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(494, 'Red Bench', 'couch_norja*9', 's', 2, 1, 1, '0', '1', '0', 1792, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(495, 'Black Iced Bookcase', 'shelves_norja*2', 's', 1, 1, 1, '0', '0', '0', 1793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(496, 'Urban Iced Bookcase', 'shelves_norja*3', 's', 1, 1, 1, '0', '0', '0', 1794, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(497, 'Pink Bookcase', 'shelves_norja*5', 's', 1, 1, 1, '0', '0', '0', 1796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(498, 'Blue Bookcase', 'shelves_norja*6', 's', 1, 1, 1, '0', '0', '0', 1797, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(499, 'Rural Iced Bookcase', 'shelves_norja*7', 's', 1, 1, 1, '0', '0', '0', 1798, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(500, 'Yellow Bookcase', 'shelves_norja*8', 's', 1, 1, 1, '0', '0', '0', 1799, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(501, 'Red Bookcase', 'shelves_norja*9', 's', 1, 1, 1, '0', '0', '0', 1800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(502, 'Black Iced Chair', 'chair_norja*2', 's', 1, 1, 1, '0', '1', '0', 1801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(503, 'White Iced Chair', 'chair_norja*3', 's', 1, 1, 1, '0', '1', '0', 1802, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(504, 'Urban Iced Chair', 'chair_norja*4', 's', 1, 1, 1, '0', '1', '0', 1803, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(505, 'Pink Chair', 'chair_norja*5', 's', 1, 1, 1, '0', '1', '0', 1804, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(506, 'Blue Chair', 'chair_norja*6', 's', 1, 1, 1, '0', '1', '0', 1805, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(507, 'Rural Chair', 'chair_norja*7', 's', 1, 1, 1, '0', '1', '0', 1806, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(508, 'Yellow Chair', 'chair_norja*8', 's', 1, 1, 1, '0', '1', '0', 1807, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(509, 'Red Chair', 'chair_norja*9', 's', 1, 1, 1, '0', '1', '0', 1808, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(510, 'Black Iced Corner', 'divider_nor1*2', 's', 1, 1, 1, '0', '0', '0', 1809, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(511, 'Looks squishy', 'divider_nor1*3', 's', 1, 1, 1, '0', '0', '0', 1810, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(512, 'Urban Iced Corner', 'divider_nor1*4', 's', 1, 1, 1, '0', '0', '0', 1811, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(513, 'Pink Ice corner', 'divider_nor1*5', 's', 1, 1, 1, '0', '0', '0', 1812, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(514, 'Blue Ice corner', 'divider_nor1*6', 's', 1, 1, 1, '0', '0', '0', 1813, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(515, 'Rural Iced Corner', 'divider_nor1*7', 's', 1, 1, 1, '0', '0', '0', 1814, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(516, 'Yellow Ice corner', 'divider_nor1*8', 's', 1, 1, 1, '0', '0', '0', 1815, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(517, 'Red Ice corner', 'divider_nor1*9', 's', 1, 1, 1, '0', '0', '0', 1816, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(518, 'Black Iced Sofa', 'soft_sofa_norja*2', 's', 2, 1, 1, '0', '1', '0', 1817, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(519, 'Pristine white', 'soft_sofa_norja*3', 's', 2, 1, 1, '0', '1', '0', 1818, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(520, 'Urban Iced Sofa', 'soft_sofa_norja*4', 's', 2, 1, 1, '0', '1', '0', 1819, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(521, 'Pink Iced Sofa', 'soft_sofa_norja*5', 's', 2, 1, 1, '0', '1', '0', 1820, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(522, 'Blue Iced Sofa', 'soft_sofa_norja*6', 's', 2, 1, 1, '0', '1', '0', 1821, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(523, 'Rural Iced Sofa', 'soft_sofa_norja*7', 's', 2, 1, 1, '0', '1', '0', 1822, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(524, 'Yellow Iced Sofa', 'soft_sofa_norja*8', 's', 2, 1, 1, '0', '1', '0', 1823, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(525, 'Red Iced Sofa', 'soft_sofa_norja*9', 's', 2, 1, 1, '0', '1', '0', 1824, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(526, 'Black Iced Sofachair', 'soft_sofachair_norja*2', 's', 1, 1, 1, '0', '1', '0', 1825, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(527, 'White Iced Sofachair', 'soft_sofachair_norja*3', 's', 1, 1, 1, '0', '1', '0', 1826, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(528, 'Urban Iced Sofachair', 'soft_sofachair_norja*4', 's', 1, 1, 1, '0', '1', '0', 1827, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(529, 'Pink Iced Sofachair', 'soft_sofachair_norja*5', 's', 1, 1, 1, '0', '1', '0', 1828, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(530, 'Blue Iced Sofachair', 'soft_sofachair_norja*6', 's', 1, 1, 1, '0', '1', '0', 1829, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(531, 'Rural Iced Sofachair', 'soft_sofachair_norja*7', 's', 1, 1, 1, '0', '1', '0', 1830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(532, 'Yellow Iced Sofachair', 'soft_sofachair_norja*8', 's', 1, 1, 1, '0', '1', '0', 1831, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(533, 'Red Iced Sofachair', 'soft_sofachair_norja*9', 's', 1, 1, 1, '0', '1', '0', 1832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(534, 'Large', 'sofachair_silo*2', 's', 1, 1, 1.1, '0', '1', '0', 1833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(535, 'Large', 'sofachair_silo*3', 's', 1, 1, 1.1, '0', '1', '0', 1834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(536, 'Beige Area Armchair', 'sofachair_silo*4', 's', 1, 1, 1.1, '0', '1', '0', 1835, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(537, 'Pink Area Armchair', 'sofachair_silo*5', 's', 1, 1, 1.1, '0', '1', '0', 1836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(538, 'Blue Area Armchair', 'sofachair_silo*6', 's', 1, 1, 1.1, '0', '1', '0', 1837, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(539, 'Green Area Armchair', 'sofachair_silo*7', 's', 1, 1, 1.1, '0', '1', '0', 1838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(540, 'Large', 'sofachair_silo*8', 's', 1, 1, 1.1, '0', '1', '0', 1839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(541, 'Red Area Armchair', 'sofachair_silo*9', 's', 1, 1, 1.1, '0', '1', '0', 1840, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(542, 'Black Occasional Table', 'table_silo_small*2', 's', 1, 1, 1, '1', '0', '0', 1841, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(543, 'White Occasional Table', 'table_silo_small*3', 's', 1, 1, 1, '1', '0', '0', 1842, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(544, 'Beige Area Occasional Table', 'table_silo_small*4', 's', 1, 1, 1, '1', '0', '0', 1843, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(545, 'Pink Area Occasional Table', 'table_silo_small*5', 's', 1, 1, 1, '1', '0', '0', 1844, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(546, 'Blue Area Occasional Table', 'table_silo_small*6', 's', 1, 1, 1, '1', '0', '0', 1845, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(547, 'Green Area Occasional Table', 'table_silo_small*7', 's', 1, 1, 1, '1', '0', '0', 1846, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(548, 'Yellow Occasional Table', 'table_silo_small*8', 's', 1, 1, 1, '1', '0', '0', 1847, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(549, 'Red Area Occasional Table', 'table_silo_small*9', 's', 1, 1, 1, '1', '0', '0', 1848, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(550, 'Black Corner Shelf', 'divider_silo1*2', 's', 1, 1, 1, '0', '0', '0', 1849, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(551, 'White Corner Shelf', 'divider_silo1*3', 's', 1, 1, 1, '0', '0', '0', 1850, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(552, 'Beige Area Corner Shelf', 'divider_silo1*4', 's', 1, 1, 1, '0', '0', '0', 1851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(553, 'Pink Area Corner Shelf', 'divider_silo1*5', 's', 1, 1, 1, '0', '0', '0', 1852, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(554, 'Blue Area Corner Shelf', 'divider_silo1*6', 's', 1, 1, 1, '0', '0', '0', 1853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(555, 'Green Area Corner Shelf', 'divider_silo1*7', 's', 1, 1, 1, '0', '0', '0', 1854, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(556, 'Yellow Corner Shelf', 'divider_silo1*8', 's', 1, 1, 1, '0', '0', '0', 1855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(557, 'Red Area Corner Shelf', 'divider_silo1*9', 's', 1, 1, 1, '0', '0', '0', 1856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(558, 'Black Area Gate', 'divider_silo3*2', 's', 1, 1, 0.001, '0', '0', '0', 1857, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(559, 'White Area Gate', 'divider_silo3*3', 's', 1, 1, 0.001, '0', '0', '0', 1858, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(560, 'Beige Area Gate', 'divider_silo3*4', 's', 1, 1, 0.001, '0', '0', '0', 1859, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(561, 'Pink Area Gate', 'divider_silo3*5', 's', 1, 1, 0.001, '0', '0', '0', 1860, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(562, 'Blue Area Gate', 'divider_silo3*6', 's', 1, 1, 0.001, '0', '0', '0', 1861, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(563, 'Green Area Gate', 'divider_silo3*7', 's', 1, 1, 0.001, '0', '0', '0', 1862, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(564, 'Yellow Area Gate', 'divider_silo3*8', 's', 1, 1, 0.001, '0', '0', '0', 1863, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(565, 'Red Area Gate', 'divider_silo3*9', 's', 1, 1, 0.001, '0', '0', '0', 1864, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(566, 'Black Coffee Table', 'table_silo_med*2', 's', 2, 2, 1, '1', '0', '0', 1865, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(567, 'White Coffee Table', 'table_silo_med*3', 's', 2, 2, 1, '1', '0', '0', 1866, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(568, 'Beige Area Coffee Table', 'table_silo_med*4', 's', 2, 2, 1, '1', '0', '0', 1867, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(569, 'Pink Area Coffee Table', 'table_silo_med*5', 's', 2, 2, 1, '1', '0', '0', 1868, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(570, 'Blue Area Coffee Table', 'table_silo_med*6', 's', 2, 2, 1, '1', '0', '0', 1869, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(571, 'Green Area Coffee Table', 'table_silo_med*7', 's', 2, 2, 1, '1', '0', '0', 1870, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(572, 'Yellow Coffee Table', 'table_silo_med*8', 's', 2, 2, 1, '1', '0', '0', 1871, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(573, 'Red Area Coffee Table', 'table_silo_med*9', 's', 2, 2, 1, '1', '0', '0', 1872, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(574, 'Cushioned', 'sofa_silo*2', 's', 2, 1, 1.1, '0', '1', '0', 1873, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(575, 'Cushioned', 'sofa_silo*3', 's', 2, 1, 1.1, '0', '1', '0', 1874, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(576, 'Beige Area Sofa', 'sofa_silo*4', 's', 2, 1, 1.1, '0', '1', '0', 1875, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(577, 'Pink Area Sofa', 'sofa_silo*5', 's', 2, 1, 1.1, '0', '1', '0', 1876, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(578, 'Blue Area Sofa', 'sofa_silo*6', 's', 2, 1, 1.1, '0', '1', '0', 1877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(579, 'Green Area Sofa', 'sofa_silo*7', 's', 2, 1, 1.1, '0', '1', '0', 1878, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(580, 'Cushioned', 'sofa_silo*8', 's', 2, 1, 1.1, '0', '1', '0', 1879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(581, 'Red Area Sofa', 'sofa_silo*9', 's', 2, 1, 1.1, '0', '1', '0', 1880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(582, 'Black Mode Armchair', 'sofachair_polyfon*2', 's', 1, 1, 1.1, '0', '1', '0', 1881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(583, 'White Armchair', 'sofachair_polyfon*3', 's', 1, 1, 1.1, '0', '1', '0', 1882, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(584, 'Beige Mode Armchair', 'sofachair_polyfon*4', 's', 1, 1, 1.1, '0', '1', '0', 1883, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(585, 'Blue Mode Armchair', 'sofachair_polyfon*6', 's', 1, 1, 1.1, '0', '1', '0', 1884, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(586, 'Green Armchair', 'sofachair_polyfon*7', 's', 1, 1, 1.1, '0', '1', '0', 1885, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(587, 'Yellow Mode Armchair', 'sofachair_polyfon*8', 's', 1, 1, 1.1, '0', '1', '0', 1886, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(588, 'Red Armchair', 'sofachair_polyfon*9', 's', 1, 1, 1.1, '0', '1', '0', 1887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(589, 'Black Mode Sofa', 'sofa_polyfon*2', 's', 2, 1, 1.1, '0', '1', '0', 1888, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(590, 'White Two-seater Sofa', 'sofa_polyfon*3', 's', 2, 1, 1.1, '0', '1', '0', 1889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(591, 'Beige Mode Sofa', 'sofa_polyfon*4', 's', 2, 1, 1.1, '0', '1', '0', 1890, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(592, 'Blue Mode Sofa', 'sofa_polyfon*6', 's', 2, 1, 1.1, '0', '1', '0', 1891, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(593, 'Green Two-seater Sofa', 'sofa_polyfon*7', 's', 2, 1, 1.1, '0', '1', '0', 1892, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(594, 'Yellow Mode Sofa', 'sofa_polyfon*8', 's', 2, 1, 1.1, '0', '1', '0', 1893, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(595, 'Black Mode Double Bed', 'sofa_polyfon*9', 's', 2, 1, 1.1, '0', '1', '0', 1894, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(596, 'White Double Bed', 'bed_polyfon*3', 's', 2, 3, 1.8, '0', '0', '0', 1896, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(597, 'Beige Mode Double Bed', 'bed_polyfon*4', 's', 2, 3, 1.8, '0', '0', '0', 1897, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(598, 'Blue Mode Double Bed', 'bed_polyfon*6', 's', 2, 3, 1.8, '0', '0', '0', 1898, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(599, 'Green Double Bed', 'bed_polyfon*7', 's', 2, 3, 1.8, '0', '0', '0', 1899, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(600, 'Yellow Mode Double Bed', 'bed_polyfon*8', 's', 2, 3, 1.8, '0', '0', '0', 1900, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(601, 'Red Double Bed', 'bed_polyfon*9', 's', 2, 3, 1.8, '0', '0', '0', 1901, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(602, 'Black Mode Single Bed', 'bed_polyfon_one*2', 's', 1, 3, 1.8, '0', '0', '0', 1902, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(603, 'White Single Bed', 'bed_polyfon_one*3', 's', 1, 3, 1.8, '0', '0', '0', 1903, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(604, 'Beige Mode Single Bed', 'bed_polyfon_one*4', 's', 1, 3, 1.8, '0', '0', '0', 1904, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(605, 'Blue Mode Single Bed', 'bed_polyfon_one*6', 's', 1, 3, 1.8, '0', '0', '0', 1905, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(606, 'Green Single Bed', 'bed_polyfon_one*7', 's', 1, 3, 1.8, '0', '0', '0', 1906, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(607, 'Yellow Mode Single Bed', 'bed_polyfon_one*8', 's', 1, 3, 1.8, '0', '0', '0', 1907, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(608, 'Red Single Bed', 'bed_polyfon_one*9', 's', 1, 3, 1.8, '0', '0', '0', 1908, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(609, 'Black Mode Bardesk', 'bardesk_polyfon*2', 's', 2, 1, 1, '1', '0', '0', 1909, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(610, 'White Bardesk', 'bardesk_polyfon*3', 's', 2, 1, 1, '1', '0', '0', 1910, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(611, 'Beige Mode Bardesk', 'bardesk_polyfon*4', 's', 2, 1, 1, '1', '0', '0', 1911, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(612, 'Candy Bar', 'bardesk_polyfon*5', 's', 2, 1, 1, '1', '0', '0', 1912, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(613, 'Blue Mode Bardesk', 'bardesk_polyfon*6', 's', 2, 1, 1, '1', '0', '0', 1913, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(614, 'Green Bardesk', 'bardesk_polyfon*7', 's', 2, 1, 1, '1', '0', '0', 1914, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(615, 'Yellow Mode Bardesk', 'bardesk_polyfon*8', 's', 2, 1, 1, '1', '0', '0', 1915, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(616, 'Red Bardesk', 'bardesk_polyfon*9', 's', 2, 1, 1, '1', '0', '0', 1916, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(617, 'Black Mode Bardesk Corner', 'bardeskcorner_polyfon*2', 's', 1, 1, 1, '1', '0', '0', 1917, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(618, 'White Corner Desk', 'bardeskcorner_polyfon*3', 's', 1, 1, 1, '1', '0', '0', 1918, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(619, 'Beige Mode Bardesk Corner', 'bardeskcorner_polyfon*4', 's', 1, 1, 1, '1', '0', '0', 1919, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(620, 'Candy Corner', 'bardeskcorner_polyfon*5', 's', 1, 1, 1, '1', '0', '0', 1920, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(621, 'Blue Mode Bardesk Corner', 'bardeskcorner_polyfon*6', 's', 1, 1, 1, '1', '0', '0', 1921, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(622, 'Green Corner Desk', 'bardeskcorner_polyfon*7', 's', 1, 1, 1, '1', '0', '0', 1922, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(623, 'Yellow Mode Bardesk Corner', 'bardeskcorner_polyfon*8', 's', 1, 1, 1, '1', '0', '0', 1923, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(624, 'Red Corner Desk', 'bardeskcorner_polyfon*9', 's', 1, 1, 1, '1', '0', '0', 1924, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(625, 'Black Mode Bardesk Gate', 'divider_poly3*2', 's', 1, 1, 0.001, '0', '0', '0', 1925, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(626, 'White Hatch', 'divider_poly3*3', 's', 1, 1, 0.001, '0', '0', '0', 1926, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(627, 'Beige Mode Bardesk Gate', 'divider_poly3*4', 's', 1, 1, 0.001, '0', '0', '0', 1927, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(628, 'Candy Hatch (Lockable)', 'divider_poly3*5', 's', 1, 1, 0.001, '0', '0', '0', 1928, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(629, 'Blue Mode Bardesk Gate', 'divider_poly3*6', 's', 1, 1, 0.001, '0', '0', '0', 1929, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(20073, 'ads_idol_l_carpet name', 'ads_idol_l_carpet', 's', 2, 7, 0, '1', '0', '0', 3276, '1', '1', '1', '1', '1', '', 1, '0', ''),
(631, 'Yellow Mode Bardesk Gate', 'divider_poly3*8', 's', 1, 1, 0.001, '0', '0', '0', 1931, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(632, 'Red Hatch', 'divider_poly3*9', 's', 1, 1, 0.001, '0', '0', '0', 1932, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(633, 'Black Dining Chair', 'chair_silo*2', 's', 1, 1, 1.1, '0', '1', '0', 1933, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(634, 'White Dining Chair', 'chair_silo*3', 's', 1, 1, 1.1, '0', '1', '0', 1934, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(635, 'Beige Silo Dining Chair', 'chair_silo*4', 's', 1, 1, 1.1, '0', '1', '0', 1935, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(636, 'Pink Silo Dining Chair', 'chair_silo*5', 's', 1, 1, 1.1, '0', '1', '0', 1936, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(637, 'Blue Area Dining Chair', 'chair_silo*6', 's', 1, 1, 1.1, '0', '1', '0', 1937, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(638, 'Green Area Dining Chair', 'chair_silo*7', 's', 1, 1, 1.1, '0', '1', '0', 1938, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(639, 'Yellow Dining Chair', 'chair_silo*8', 's', 1, 1, 1.1, '0', '1', '0', 1939, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(640, 'Red Area Dining Chair', 'chair_silo*9', 's', 1, 1, 1.1, '0', '1', '0', 1940, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(641, 'No way through', 'divider_nor3*2', 's', 1, 1, 1, '0', '0', '0', 1941, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(642, 'White Iced Gate', 'divider_nor3*3', 's', 1, 1, 0.001, '0', '0', '0', 1942, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(643, 'Urban Iced Gate', 'divider_nor3*4', 's', 1, 1, 0.001, '0', '0', '0', 1943, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(644, 'Pink Iced gate', 'divider_nor3*5', 's', 1, 1, 0.001, '0', '0', '0', 1944, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(645, 'Blue Iced gate', 'divider_nor3*6', 's', 1, 1, 0.001, '0', '0', '0', 1945, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(646, 'Rural Iced gate', 'divider_nor3*7', 's', 1, 1, 0.001, '0', '0', '0', 1946, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(647, 'Yellow Iced gate', 'divider_nor3*8', 's', 1, 1, 0.001, '0', '0', '0', 1947, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(648, 'Red Iced gate', 'divider_nor3*9', 's', 1, 1, 0.001, '0', '0', '0', 1948, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(649, 'Black Iced Bar-Desk', 'divider_nor2*2', 's', 2, 1, 1, '0', '0', '0', 1949, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(650, 'Strong', 'divider_nor2*3', 's', 2, 1, 1, '0', '0', '0', 1950, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(651, 'Urban Iced Bar', 'divider_nor2*4', 's', 2, 1, 1, '0', '0', '0', 1951, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(652, 'Pink Iced bar desk', 'divider_nor2*5', 's', 2, 1, 1, '0', '0', '0', 1952, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(653, 'Blue Iced  bar desk', 'divider_nor2*6', 's', 2, 1, 1, '0', '0', '0', 1953, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(654, 'Rural Iced Bar', 'divider_nor2*7', 's', 2, 1, 1, '0', '0', '0', 1954, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(655, 'Yellow Iced  bar desk', 'divider_nor2*8', 's', 2, 1, 1, '0', '0', '0', 1955, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(656, 'Red Iced  bar desk', 'divider_nor2*9', 's', 2, 1, 1, '0', '0', '0', 1956, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(657, 'Area Quest Desk', 'silo_studydesk', 's', 2, 1, 1, '1', '0', '0', 1957, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(658, 'White Solarium', 'solarium_norja', 's', 1, 1, 1, '0', '0', '0', 1958, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(659, 'Black Solarium', 'solarium_norja*1', 's', 1, 1, 1, '0', '0', '0', 1959, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(660, 'Beige Solarium', 'solarium_norja*2', 's', 1, 1, 1, '0', '0', '0', 1960, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(661, 'Urban Solarium', 'solarium_norja*3', 's', 1, 1, 1, '0', '0', '0', 1961, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(662, 'Pink Solarium', 'solarium_norja*5', 's', 1, 1, 1, '0', '0', '0', 1962, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(663, 'Blue Solarium', 'solarium_norja*6', 's', 1, 1, 1, '0', '0', '0', 1963, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(664, 'Rural Solarium', 'solarium_norja*7', 's', 1, 1, 1, '0', '0', '0', 1964, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(665, 'Yellow Solarium', 'solarium_norja*8', 's', 1, 1, 1, '0', '0', '0', 1965, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(666, 'Red Solarium', 'solarium_norja*9', 's', 1, 1, 1, '0', '0', '0', 1966, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(667, 'Tropical Beach Rug', 'sandrug', 's', 2, 2, 0, '1', '0', '1', 1967, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(668, 'Moon Patch', 'rare_moonrug', 's', 2, 2, 0, '1', '0', '1', 1968, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(669, 'Chinese Lacquer Chair', 'chair_china', 's', 1, 1, 1, '0', '1', '0', 1969, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(670, 'Chinese Lacquer Table', 'china_table', 's', 1, 1, 1, '1', '0', '0', 1970, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(671, 'Red Sleeping Bag', 'sleepingbag*1', 's', 1, 3, 0.8, '0', '0', '0', 1971, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(672, 'Lime Sleeping Bag', 'sleepingbag*2', 's', 1, 3, 0.8, '0', '0', '0', 1972, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(673, 'Ocean Sleeping Bag', 'sleepingbag*3', 's', 1, 3, 0.8, '0', '0', '0', 1973, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(674, 'Safety Sleeping Bag', 'sleepingbag*4', 's', 1, 3, 0.8, '0', '0', '0', 1974, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(675, 'Safe Minibar', 'safe_silo', 's', 1, 1, 1.3, '1', '0', '0', 1975, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(676, 'Orange Sleeping Bag', 'sleepingbag*7', 's', 1, 3, 0.8, '0', '0', '0', 1976, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(677, 'eXceptional Sleeping Bag', 'sleepingbag*9', 's', 1, 3, 0.8, '0', '0', '0', 1977, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(678, 'Graphite Sleeping Bag', 'sleepingbag*5', 's', 1, 3, 0.8, '0', '0', '0', 1978, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(679, 'Khaki Sleeping Bag', 'sleepingbag*10', 's', 1, 3, 0.8, '0', '0', '0', 1979, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(680, 'Purple Sleeping Bag', 'sleepingbag*6', 's', 1, 3, 0.8, '0', '0', '0', 1980, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(681, 'Golden Sleeping Bag', 'sleepingbag*8', 's', 1, 3, 0.8, '0', '0', '0', 1981, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(682, 'Chinese Bookshelf', 'china_shelve', 's', 2, 1, 1, '0', '0', '0', 1982, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(683, 'White Traffic Light', 'traffic_light*5', 's', 1, 1, 1, '0', '0', '0', 1983, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(684, 'Habbos', 'divider_nor4*2', 's', 2, 1, 1, '0', '0', '0', 1984, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(685, 'Habbos', 'divider_nor4*3', 's', 2, 1, 1, '0', '0', '0', 1985, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(686, 'Habbos', 'divider_nor4*5', 's', 2, 1, 1, '0', '0', '0', 1986, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(687, 'Habbos', 'divider_nor4*6', 's', 2, 1, 1, '0', '0', '0', 1987, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(688, 'Habbos', 'divider_nor4*7', 's', 2, 1, 1, '0', '0', '0', 1988, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(689, 'Habbos', 'divider_nor4*8', 's', 2, 1, 1, '0', '0', '0', 1989, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(690, 'Habbos', 'divider_nor4*9', 's', 2, 1, 1, '0', '0', '0', 1990, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(691, 'Black Iced Angle', 'divider_nor5*2', 's', 1, 1, 1, '0', '0', '0', 1991, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(692, 'White Iced Angle', 'divider_nor5*3', 's', 1, 1, 1, '0', '0', '0', 1992, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(693, 'Urban Iced Angle', 'divider_nor5*4', 's', 1, 1, 1, '0', '0', '0', 1993, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(694, 'Blue Iced Angle', 'divider_nor5*5', 's', 1, 1, 1, '0', '0', '0', 1994, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(695, 'Rural Iced Angle', 'divider_nor5*7', 's', 1, 1, 1, '0', '0', '0', 1996, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(696, 'Yellow Iced Angle', 'divider_nor5*8', 's', 1, 1, 1, '0', '0', '0', 1997, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(697, 'Red Iced Angle', 'divider_nor5*9', 's', 1, 1, 1, '0', '0', '0', 1998, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(698, 'Plain Iced Angle', 'divider_nor5', 's', 1, 1, 1, '0', '0', '0', 1999, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(699, 'Habbos', 'divider_nor4', 's', 2, 1, 1, '0', '0', '0', 2000, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(700, 'Dragon Screen', 'wall_china', 's', 1, 1, 1, '0', '0', '0', 2001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(701, 'Firm', 'corner_china', 's', 1, 1, 1, '0', '0', '0', 2002, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(702, 'Black Bar Stool', 'barchair_silo*2', 's', 1, 1, 1.2, '0', '1', '0', 2003, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(703, 'White Bar Stool', 'barchair_silo*3', 's', 1, 1, 1.2, '0', '1', '0', 2004, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(704, 'Beige Bar Stool', 'barchair_silo*4', 's', 1, 1, 1.2, '0', '1', '0', 2005, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(705, 'Pink Bar Stool', 'barchair_silo*5', 's', 1, 1, 1.2, '0', '1', '0', 2006, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(706, 'Blue Bar Stool', 'barchair_silo*6', 's', 1, 1, 1.2, '0', '1', '0', 2007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(707, 'Green Bar Stool', 'barchair_silo*7', 's', 1, 1, 1.2, '0', '1', '0', 2008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(708, 'Yellow Bar Stool', 'barchair_silo*8', 's', 1, 1, 1.2, '0', '1', '0', 2009, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(709, 'Red Bar Stool', 'barchair_silo*9', 's', 1, 1, 1.2, '0', '1', '0', 2010, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(710, 'Black Safe Minibar', 'safe_silo*2', 's', 1, 1, 1.3, '1', '0', '0', 2011, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(711, 'White Safe Minibar', 'safe_silo*3', 's', 1, 1, 1.3, '1', '0', '0', 2012, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(712, 'Beige Safe Minibar', 'safe_silo*4', 's', 1, 1, 1.3, '1', '0', '0', 2013, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(713, 'Pink Safe Minibar', 'safe_silo*5', 's', 1, 1, 1.3, '1', '0', '0', 2014, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(714, 'Blue Safe Minibar', 'safe_silo*6', 's', 1, 1, 1.3, '1', '0', '0', 2015, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(715, 'Green Safe Minibar', 'safe_silo*7', 's', 1, 1, 1.3, '1', '0', '0', 2016, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(716, 'Yellow Safe Minibar', 'safe_silo*8', 's', 1, 1, 1.3, '1', '0', '0', 2017, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(717, 'Red Safe Minibar', 'safe_silo*9', 's', 1, 1, 1.3, '1', '0', '0', 2018, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(718, 'Glass shelf', 'glass_shelf', 's', 2, 1, 1, '0', '0', '0', 2019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(719, 'Glass chair', 'glass_chair', 's', 1, 1, 1, '0', '1', '0', 2020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(720, 'Glass stool', 'glass_stool', 's', 1, 1, 1, '0', '1', '0', 2021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(721, 'Glass sofa', 'glass_sofa', 's', 2, 1, 1, '0', '1', '0', 2022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(722, 'Glass table', 'glass_table', 's', 2, 2, 1, '1', '0', '0', 2023, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(723, 'Glass table', 'glass_table*2', 's', 2, 2, 1, '1', '0', '0', 2024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(724, 'White Glass Table', 'glass_table*3', 's', 2, 2, 1, '1', '0', '0', 2025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(725, 'Glass table', 'glass_table*4', 's', 2, 2, 1, '1', '0', '0', 2026, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(726, 'Candy Glass Table', 'glass_table*5', 's', 2, 2, 1, '1', '0', '0', 2027, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(727, 'Blue Glass Table', 'glass_table*6', 's', 2, 2, 1, '1', '0', '0', 2028, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(728, 'Green Glass Table', 'glass_table*7', 's', 2, 2, 1, '1', '0', '0', 2029, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(729, 'Yellow Glass Table', 'glass_table*8', 's', 2, 2, 1, '1', '0', '0', 2030, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(730, 'Glass table', 'glass_table*9', 's', 2, 2, 1, '1', '0', '0', 2031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(731, 'Glass chair', 'glass_chair*2', 's', 1, 1, 1, '0', '1', '0', 2032, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(732, 'Glass chair', 'glass_chair*3', 's', 1, 1, 1, '0', '1', '0', 2033, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(733, 'Glass chair', 'glass_chair*4', 's', 1, 1, 1, '0', '1', '0', 2034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(734, 'Candy Glass Chair', 'glass_chair*5', 's', 1, 1, 1, '0', '1', '0', 2035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(735, 'Blue Glass Chair', 'glass_chair*6', 's', 1, 1, 1, '0', '1', '0', 2036, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(736, 'Green Glass Chair', 'glass_chair*7', 's', 1, 1, 1, '0', '1', '0', 2037, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(737, 'Yellow Glass Chair', 'glass_chair*8', 's', 1, 1, 1, '0', '1', '0', 2038, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(738, 'Glass chair', 'glass_chair*9', 's', 1, 1, 1, '0', '1', '0', 2039, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(739, 'Glass sofa', 'glass_sofa*2', 's', 2, 1, 1, '0', '1', '0', 2040, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(740, 'White Glass Sofa', 'glass_sofa*3', 's', 2, 1, 1, '0', '1', '0', 2041, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(741, 'Glass sofa', 'glass_sofa*4', 's', 2, 1, 1, '0', '1', '0', 2042, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(742, 'Candy Glass Sofa', 'glass_sofa*5', 's', 2, 1, 1, '0', '1', '0', 2043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(743, 'Blue Glass Sofa', 'glass_sofa*6', 's', 2, 1, 1, '0', '1', '0', 2044, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(744, 'Green Glass Sofa', 'glass_sofa*7', 's', 2, 1, 1, '0', '1', '0', 2045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(745, 'Yellow Glass Sofa', 'glass_sofa*8', 's', 2, 1, 1, '0', '1', '0', 2046, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(746, 'Glass sofa', 'glass_sofa*9', 's', 2, 1, 1, '0', '1', '0', 2047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(747, 'Glass stool', 'glass_stool*2', 's', 1, 1, 1, '0', '1', '0', 2048, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(748, 'Glass stool', 'glass_stool*4', 's', 1, 1, 1, '0', '1', '0', 2050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(749, 'Candy Glass Stool', 'glass_stool*5', 's', 1, 1, 1, '0', '1', '0', 2051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(750, 'Blue Glass Stool', 'glass_stool*6', 's', 1, 1, 1, '0', '1', '0', 2052, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(751, 'Green Glass Stool', 'glass_stool*7', 's', 1, 1, 1, '0', '1', '0', 2053, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(752, 'Yellow Glass Stool', 'glass_stool*8', 's', 1, 1, 1, '0', '1', '0', 2054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(753, 'White Glass Stool', 'glass_stool*3', 's', 1, 1, 1, '0', '1', '0', 2056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(754, 'Glass stool', 'glass_stool*9', 's', 1, 1, 1, '0', '1', '0', 2057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(755, 'Gold Coin', 'CF_10_coin_gold', 's', 1, 1, 0.2, '1', '0', '0', 2063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(756, 'Bronze Coin', 'CF_1_coin_bronze', 's', 1, 1, 0.2, '1', '0', '0', 2064, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(757, 'Sack of Credits', 'CF_20_moneybag', 's', 1, 1, 1, '1', '0', '0', 2065, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(758, 'Gold Bar', 'CF_50_goldbar', 's', 1, 1, 0.2, '1', '0', '0', 2066, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(759, 'Silver Coin', 'CF_5_coin_silver', 's', 1, 1, 0.2, '1', '0', '0', 2067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(760, 'Persian Carpet', 'hc_crpt', 's', 3, 5, 0, '1', '0', '1', 2068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(761, 'Forget plasma', 'hc_tv', 's', 2, 1, 1.4, '0', '1', '0', 2069, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(762, 'Gothic Portcullis', 'gothgate', 's', 2, 1, 0.001, '0', '0', '0', 2070, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(763, 'Gothic Candelabra', 'gothiccandelabra', 's', 1, 1, 1, '0', '0', '0', 2071, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(764, 'Gothic Railing', 'gothrailing', 's', 2, 1, 1, '0', '0', '0', 2072, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(765, 'Gothic table', 'goth_table', 's', 1, 5, 1.7, '0', '0', '0', 2073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(766, 'Medieval Bookcase', 'hc_bkshlf', 's', 1, 4, 1, '0', '0', '0', 2074, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(767, 'Electric Butler', 'hc_btlr', 's', 1, 1, 1, '0', '0', '0', 2075, '1', '1', '1', '1', '1', 'vendingmachine', 0, '24', ''),
(768, 'Antique Drapery', 'hc_crtn', 's', 2, 1, 0.001, '0', '0', '0', 2076, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(769, 'The Grammophon', 'hc_djset', 's', 3, 1, 1, '0', '0', '0', 2077, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(770, 'Heavy Duty Fireplace', 'hc_frplc', 's', 1, 3, 1, '0', '0', '0', 2078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(771, 'Victorian Street Light', 'hc_lmpst', 's', 1, 1, 1, '0', '0', '0', 2079, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(772, 'Weird Science Machine', 'hc_machine', 's', 1, 3, 1, '0', '0', '0', 2080, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(773, 'HC Rollers Set', 'hc_rllr', 's', 1, 1, 0.5, '0', '0', '1', 2081, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(774, 'X-Ray Divider', 'hc_rntgn', 's', 2, 1, 1, '0', '0', '0', 2082, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(775, 'Drinks Trolley', 'hc_trll', 's', 1, 2, 1, '0', '0', '0', 2083, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(776, 'Gothic Chair Pink', 'gothic_chair*1', 's', 1, 1, 1, '0', '1', '0', 2084, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(777, 'Gothic Sofa Pink', 'gothic_sofa*1', 's', 2, 1, 1, '0', '1', '0', 2085, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(778, 'Gothic Stool Pink', 'gothic_stool*1', 's', 1, 1, 1, '0', '1', '0', 2086, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(779, 'Golden Gothic Chair', 'gothic_chair*2', 's', 1, 1, 1, '0', '1', '0', 2087, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(780, 'Golden Gothic Sofa', 'gothic_sofa*2', 's', 2, 1, 1, '0', '1', '0', 2088, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(781, 'Golden Gothic Stool', 'gothic_stool*2', 's', 1, 1, 1, '0', '1', '0', 2089, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(782, 'Red Gothic Chair', 'gothic_chair*3', 's', 1, 1, 1, '0', '1', '0', 2090, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(783, 'Red Gothic Sofa', 'gothic_sofa*3', 's', 2, 1, 1, '0', '1', '0', 2091, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(784, 'Red Gothic Stool', 'gothic_stool*3', 's', 1, 1, 1, '0', '1', '0', 2092, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(785, 'Black Gothic Chair', 'gothic_chair*4', 's', 1, 1, 1, '0', '1', '0', 2093, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(786, 'Black Gothic Sofa', 'gothic_sofa*4', 's', 2, 1, 1, '0', '1', '0', 2094, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(787, 'Black Gothic Stool', 'gothic_stool*4', 's', 1, 1, 1, '0', '1', '0', 2095, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(788, 'Green Gothic Chair', 'gothic_chair*5', 's', 1, 1, 1, '0', '1', '0', 2096, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(789, 'Green Gothic Sofa', 'gothic_sofa*5', 's', 2, 1, 1, '0', '1', '0', 2097, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(790, 'Green Gothic Stool', 'gothic_stool*5', 's', 1, 1, 1, '0', '1', '0', 2098, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(791, 'Gothic Chair Blue', 'gothic_chair*6', 's', 1, 1, 1, '0', '1', '0', 2099, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(792, 'Gothic Sofa Blue', 'gothic_sofa*6', 's', 2, 1, 1, '0', '1', '0', 2100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(793, 'Valentine''s Cauldron', 'gothic_stool*6', 's', 1, 1, 1, '0', '1', '0', 2101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(794, 'Sound Machine', 'sound_machine', 's', 1, 1, 1, '0', '0', '0', 2105, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(795, 'Turquoise Romantique Piano Chair', 'romantique_pianochair*3', 's', 1, 1, 1, '0', '1', '0', 2106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(796, 'Onyx Piano Stool', 'romantique_pianochair*5', 's', 1, 1, 1, '0', '1', '0', 2107, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(797, 'Lime Romantique Piano Chair', 'romantique_pianochair*2', 's', 1, 1, 1, '0', '1', '0', 2108, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(798, 'Amber Piano Stool', 'romantique_pianochair*4', 's', 1, 1, 1, '0', '1', '0', 2109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(799, 'Rose Quartz Piano Stool', 'romantique_pianochair*1', 's', 1, 1, 1, '0', '1', '0', 2110, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(800, 'Turquoise Romantique Divan', 'romantique_divan*3', 's', 2, 1, 1, '0', '1', '0', 2111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(801, 'Onyx Chaise-Longue', 'romantique_divan*5', 's', 2, 1, 1, '0', '1', '0', 2112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(802, 'Emerald Chaise-Longue', 'romantique_divan*2', 's', 2, 1, 1, '0', '1', '0', 2113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(803, 'Amber Chaise-Longue', 'romantique_divan*4', 's', 2, 1, 1, '0', '1', '0', 2114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(804, 'Rose Quartz Chaise-Longue', 'romantique_divan*1', 's', 2, 1, 1, '0', '1', '0', 2115, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(805, 'Turquoise Romantique Chair', 'romantique_chair*3', 's', 1, 1, 1, '0', '1', '0', 2116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(806, 'Onyx Chair', 'romantique_chair*5', 's', 1, 1, 1, '0', '1', '0', 2117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(807, 'Lime Romantique Chair', 'romantique_chair*2', 's', 1, 1, 1, '0', '1', '0', 2118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(808, 'Amber Chair', 'romantique_chair*4', 's', 1, 1, 1, '0', '1', '0', 2119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(809, 'Rose Quartz Chair', 'romantique_chair*1', 's', 1, 1, 1, '0', '1', '0', 2120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(811, 'Yellow Valentine Rose', 'plant_valentinerose*3', 's', 1, 1, 1, '0', '0', '0', 2123, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(812, 'Purple Valentine''s Rose', 'plant_valentinerose*5', 's', 1, 1, 1, '0', '0', '0', 2124, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(813, 'White Valentine''s Rose', 'plant_valentinerose*2', 's', 1, 1, 1, '0', '0', '0', 2125, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(814, 'Pink Valentine''s Rose', 'plant_valentinerose*4', 's', 1, 1, 1, '0', '0', '0', 2126, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(815, 'Red Valentine''s Rose', 'plant_valentinerose*1', 's', 1, 1, 1, '0', '0', '0', 2127, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(816, 'Maze Shrubbery Gate', 'plant_mazegate', 's', 2, 1, 0.001, '0', '0', '0', 2128, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(817, 'Maze Shrubbery', 'plant_maze', 's', 2, 1, 1, '0', '0', '0', 2129, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(818, 'Bulrush', 'plant_bulrush', 's', 1, 1, 1, '0', '0', '0', 2130, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(819, 'T-Bones Mega Multipack', 'petfood4', 's', 1, 1, 1, '1', '0', '0', 2131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(820, 'Red carpet', 'carpet_valentine', 's', 2, 7, 0, '1', '0', '1', 2132, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(821, 'Cobbled Path', 'gothic_carpet', 's', 2, 4, 0, '1', '0', '1', 2133, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(822, 'Dungeon Floor', 'gothic_carpet2', 's', 2, 4, 0, '1', '0', '1', 2134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(823, '', 'gothic_chair', 's', 1, 1, 1, '0', '1', '0', 2135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(824, '', 'gothic_sofa', 's', 2, 1, 1, '0', '1', '0', 2136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(825, '', 'gothic_stool', 's', 1, 1, 1, '0', '1', '0', 2137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(826, 'Pink Grand Piano', 'grand_piano*3', 's', 2, 2, 1, '0', '0', '0', 2138, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(827, 'Onyx Grand Piano', 'grand_piano*5', 's', 2, 2, 1, '0', '0', '0', 2139, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(828, 'Black Grand Piano', 'grand_piano*2', 's', 2, 2, 1, '0', '0', '0', 2140, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(829, 'Amber Grand Piano', 'grand_piano*4', 's', 2, 2, 1, '0', '0', '0', 2141, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(830, 'Turquoise Grand Piano', 'grand_piano*1', 's', 2, 2, 1, '0', '0', '0', 2142, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(831, 'Deluxe Theatre Chair', 'theatre_seat', 's', 1, 1, 1.2, '0', '1', '0', 2143, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(832, 'Treats Tray', 'romantique_tray2', 's', 1, 1, 1, '0', '0', '0', 2144, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(833, 'Breakfast Tray', 'romantique_tray1', 's', 1, 1, 1, '0', '0', '0', 2145, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(834, 'Turquoise Tray Table', 'romantique_smalltabl*3', 's', 1, 1, 1, '1', '0', '0', 2146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(835, 'Onyx Tray Table', 'romantique_smalltabl*5', 's', 1, 1, 1, '1', '0', '0', 2147, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(836, 'Lime Tray Table', 'romantique_smalltabl*2', 's', 1, 1, 1, '1', '0', '0', 2148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(837, 'Amber Tray Table', 'romantique_smalltabl*4', 's', 1, 1, 1, '1', '0', '0', 2149, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(838, 'Rose Quartz Tray Table', 'romantique_smalltabl*1', 's', 1, 1, 1, '1', '0', '0', 2150, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(839, 'Dressing Table', 'romantique_mirrortabl', 's', 1, 1, 1, '1', '0', '0', 2151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(840, 'Turquoise Screen', 'romantique_divider*3', 's', 2, 1, 1, '0', '0', '0', 2152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(841, 'Green Screen', 'romantique_divider*2', 's', 2, 1, 1, '1', '0', '0', 2153, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(842, 'Amber Screen', 'romantique_divider*4', 's', 2, 1, 1, '1', '0', '0', 2154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(843, 'Rose Quartz Screen', 'romantique_divider*1', 's', 2, 1, 1, '1', '0', '0', 2155, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(844, 'Large Tatami Mat', 'jp_tatami2', 's', 2, 4, 0, '1', '0', '1', 2156, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(845, 'Small Tatami Mat', 'jp_tatami', 's', 2, 2, 1, '0', '0', '1', 2157, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(846, 'Director''s Chair', 'habbowood_chair', 's', 1, 1, 1.2, '0', '1', '0', 2158, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(847, 'Bamboo Forest', 'jp_bamboo', 's', 2, 2, 0, '1', '0', '1', 2159, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(848, 'Irori', 'jp_irori', 's', 2, 2, 1, '0', '0', '0', 2160, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(849, 'Pillow Chair', 'jp_pillow', 's', 1, 1, 0.8, '0', '1', '0', 2161, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(850, 'Habbo Sounds 1', 'sound_set_1', 's', 1, 1, 0.2, '1', '0', '0', 2162, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(851, 'Habbo Sounds 3', 'sound_set_2', 's', 1, 1, 0.2, '1', '0', '0', 2163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1008, 'Jukebox', 'jukebox*1', 's', 1, 1, 1, '1', '0', '0', 2608, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1009, 'Welcome', 'carpet_soft_tut', 's', 1, 1, 0, '1', '0', '1', 2609, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1010, 'Graveyard Portal', 'sound_set_44', 's', 1, 1, 0.2, '1', '0', '0', 2610, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1011, 'SFX 1', 'sound_set_43', 's', 1, 1, 0.2, '1', '0', '0', 2614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1012, 'Haunted Mansion', 'sound_set_42', 's', 1, 1, 0.2, '1', '0', '0', 2624, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1013, 'Rock 8', 'sound_set_41', 's', 1, 1, 0.2, '1', '0', '0', 2612, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1014, 'Rock 4', 'sound_set_40', 's', 1, 1, 0.2, '1', '0', '0', 2615, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1015, 'Rock 7', 'sound_set_39', 's', 1, 1, 0.2, '1', '0', '0', 2622, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1016, 'Rock 6', 'sound_set_38', 's', 1, 1, 0.2, '1', '0', '0', 2616, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1017, 'Grunge Chair', 'grunge_chair', 's', 1, 1, 1, '0', '1', '0', 2617, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1018, 'Grunge Mattress', 'grunge_mattress', 's', 3, 1, 1, '0', '1', '0', 2618, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1019, 'Radiator', 'grunge_radiator', 's', 1, 1, 1, '0', '0', '0', 2621, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1020, 'Grunge Bookshelf', 'grunge_shelf', 's', 3, 1, 1, '0', '0', '0', 2619, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1021, 'Road Sign', 'grunge_sign', 's', 1, 1, 1, '0', '0', '0', 2613, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1022, 'Grunge Table', 'grunge_table', 's', 2, 2, 1, '1', '0', '0', 2623, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1023, 'Creepy Crypt', 'habboween_crypt', 's', 1, 3, 1.1, '0', '0', '0', 2611, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(1024, 'Unholy Ground', 'habboween_grass', 's', 2, 2, 0, '0', '0', '1', 2626, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1025, 'Habboween Cauldron', 'hal_cauldron', 's', 1, 1, 1, '0', '0', '0', 2625, '1', '1', '1', '1', '1', 'vendingmachine', 0, '30', ''),
(1026, 'Haunted Grave', 'hal_grave', 's', 1, 1, 1, '0', '0', '0', 2620, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1027, 'Christmas Party', 'sound_set_52', 's', 1, 1, 0.2, '1', '0', '0', 2633, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1028, 'Club 6', 'sound_set_51', 's', 1, 1, 0.2, '1', '0', '0', 2631, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1029, 'Club 5', 'sound_set_50', 's', 1, 1, 0.2, '1', '0', '0', 2632, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1030, 'Club 4', 'sound_set_49', 's', 1, 1, 0.2, '1', '0', '0', 2634, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1031, 'Club 3', 'sound_set_48', 's', 1, 1, 0.2, '1', '0', '0', 2629, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1032, 'Club 2', 'sound_set_47', 's', 1, 1, 0.2, '1', '0', '0', 2627, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1033, 'Club 1', 'sound_set_46', 's', 1, 1, 0.2, '1', '0', '0', 2630, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1034, 'Lost_Beatness', 'sound_set_45', 's', 1, 1, 0.2, '1', '0', '0', 2628, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1035, 'Lantern Bundle 2', 'xmas_icelamp', 's', 1, 1, 1, '1', '0', '0', 2641, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1036, 'Ice Castle Wall', 'xmas_cstl_wall', 's', 2, 1, 1, '0', '0', '0', 2646, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1037, 'Ice Castle Tower', 'xmas_cstl_twr', 's', 1, 1, 1, '0', '0', '0', 2651, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1038, 'Ice Castle Gate', 'xmas_cstl_gate', 's', 2, 1, 0.001, '0', '0', '0', 2636, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1039, 'Snowy Christmas Tree', 'tree7', 's', 1, 1, 1, '0', '0', '0', 2653, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1040, 'Flashy Christmas Tree', 'tree6', 's', 1, 1, 1, '0', '0', '0', 2638, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1041, 'Oh Blinging Tree', 'sound_set_54', 's', 1, 1, 0.2, '1', '0', '0', 2649, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1042, 'Snowy Surprise', 'sound_set_53', 's', 1, 1, 0.2, '1', '0', '0', 2652, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1043, 'postbank Safe', 'safe_silo_pb', 's', 1, 1, 1.3, '1', '0', '0', 2642, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(1044, 'Snowy Maze Gate', 'plant_mazegate_snow', 's', 2, 1, 0.001, '0', '0', '1', 2640, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1045, 'Snowy Maze Bundle 2', 'plant_maze_snow', 's', 2, 1, 1, '0', '0', '1', 2635, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1046, 'Winter Sleigh', 'christmas_sleigh', 's', 2, 2, 1, '0', '0', '0', 2648, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1047, 'Reindeer', 'christmas_reindeer', 's', 1, 2, 1, '0', '0', '0', 2637, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1048, 'Reindeer Droppings', 'christmas_poop', 's', 1, 1, 1, '0', '0', '0', 2654, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1049, 'Executive Bar Desk', 'exe_bardesk', 's', 1, 1, 1, '1', '0', '0', 2643, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1050, 'Executive Sofa Chair', 'exe_chair', 's', 1, 1, 1, '0', '1', '0', 2647, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1051, 'Executive Boss Chair', 'exe_chair2', 's', 1, 1, 1, '0', '1', '0', 2650, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1052, 'Executive Corner Desk', 'exe_corner', 's', 1, 1, 1, '1', '0', '0', 2655, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1053, 'Executive Drinks Tray', 'exe_drinks', 's', 1, 1, 1, '0', '0', '0', 2645, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1054, '3-Seater Sofa', 'exe_sofa', 's', 3, 1, 1, '0', '1', '0', 2639, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1055, 'Take a memo', 'exe_table', 's', 3, 2, 1.1, '0', '0', '0', 2644, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1056, 'RnB Grooves 5', 'sound_set_59', 's', 1, 1, 0.2, '1', '0', '0', 2670, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1057, 'RnB Grooves 4', 'sound_set_58', 's', 1, 1, 0.2, '1', '0', '0', 2656, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1058, 'RnB Grooves 3', 'sound_set_57', 's', 1, 1, 0.2, '1', '0', '0', 2673, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1059, 'RnB Grooves 2', 'sound_set_56', 's', 1, 1, 0.2, '1', '0', '0', 2669, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1060, 'RnB Grooves 1', 'sound_set_55', 's', 1, 1, 0.2, '1', '0', '0', 2671, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1061, 'Lightweight', 'noob_table*1', 's', 2, 2, 1, '1', '0', '0', 2687, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1062, 'Lightweight', 'noob_table*2', 's', 2, 2, 1, '1', '0', '0', 2688, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1063, 'Lightweight', 'noob_table*3', 's', 2, 2, 1, '1', '0', '0', 2689, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1064, 'Lightweight', 'noob_table*4', 's', 2, 2, 1, '1', '0', '0', 2690, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1065, 'Lightweight', 'noob_table*5', 's', 2, 2, 1, '1', '0', '0', 2691, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1066, 'Lightweight', 'noob_table*6', 's', 2, 2, 1, '1', '0', '0', 2692, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1067, 'My first Habbo stool', 'noob_stool*1', 's', 1, 1, 1, '0', '1', '0', 2657, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1068, 'My first Habbo stool', 'noob_stool*2', 's', 1, 1, 1, '0', '1', '0', 2658, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1069, 'My first Habbo stool', 'noob_stool*3', 's', 1, 1, 1, '0', '1', '0', 2659, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1070, 'My first Habbo stool', 'noob_stool*4', 's', 1, 1, 1, '0', '1', '0', 2660, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1071, 'My first Habbo stool', 'noob_stool*5', 's', 1, 1, 1, '0', '1', '0', 2661, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1072, 'My first Habbo stool', 'noob_stool*6', 's', 1, 1, 1, '0', '1', '0', 2662, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1073, 'My first Habbo rug', 'noob_rug*1', 's', 2, 3, 0, '1', '0', '1', 2681, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1074, 'My first Habbo rug', 'noob_rug*2', 's', 2, 3, 0, '1', '0', '1', 2682, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1075, 'My first Habbo rug', 'noob_rug*3', 's', 2, 3, 0, '1', '0', '1', 2683, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1076, 'My first Habbo rug', 'noob_rug*4', 's', 2, 3, 0, '1', '0', '1', 2684, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1077, 'My first Habbo rug', 'noob_rug*5', 's', 2, 3, 0, '1', '0', '1', 2685, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1078, 'My first Habbo rug', 'noob_rug*6', 's', 2, 3, 0, '1', '0', '1', 2686, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1079, 'My first Habbo lamp', 'noob_lamp*1', 's', 1, 1, 1, '0', '0', '0', 2663, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1080, 'My first Habbo lamp', 'noob_lamp*2', 's', 1, 1, 1, '0', '0', '0', 2664, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1081, 'My first Habbo lamp', 'noob_lamp*3', 's', 1, 1, 1, '0', '0', '0', 2665, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1082, 'My first Habbo lamp', 'noob_lamp*4', 's', 1, 1, 1, '0', '0', '0', 2666, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1083, 'My first Habbo lamp', 'noob_lamp*5', 's', 1, 1, 1, '0', '0', '0', 2667, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1084, 'My first Habbo lamp', 'noob_lamp*6', 's', 1, 1, 1, '0', '0', '0', 2668, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1085, 'Lightweight', 'noob_chair*1', 's', 1, 1, 1, '0', '1', '0', 2675, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1086, ' practical', 'noob_chair*2', 's', 1, 1, 1, '0', '1', '0', 2676, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1087, ' practical', 'noob_chair*3', 's', 1, 1, 1, '0', '1', '0', 2677, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1088, ' practical', 'noob_chair*4', 's', 1, 1, 1, '0', '1', '0', 2678, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1089, ' practical', 'noob_chair*5', 's', 1, 1, 1, '0', '1', '0', 2679, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1090, 'Power Globe', 'noob_chair*6', 's', 1, 1, 1, '0', '1', '0', 2680, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1091, 'Executive Plant', 'exe_plant', 's', 1, 1, 1, '0', '0', '0', 2674, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1092, 'Grey Share Bear', 'val_teddy*1', 's', 1, 1, 1, '0', '1', '0', 2699, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1093, 'Pink Share Bear', 'val_teddy*2', 's', 1, 1, 1, '0', '1', '0', 2700, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1094, 'Green Share Bear', 'val_teddy*3', 's', 1, 1, 1, '0', '1', '0', 2701, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1095, 'Brown Share Bear', 'val_teddy*4', 's', 1, 1, 1, '0', '1', '0', 2702, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1096, 'Yellow Share Bear', 'val_teddy*5', 's', 1, 1, 1, '0', '1', '0', 2703, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1097, 'Blue Share Bear', 'val_teddy*6', 's', 1, 1, 1, '0', '1', '0', 2704, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1098, 'Love Randomiser', 'val_randomizer', 's', 4, 1, 1.4, '0', '1', '0', 2696, '1', '1', '1', '1', '1', 'loveshuffler', 1, '0', ''),
(1099, 'Heart Shaped Chocs', 'val_choco', 's', 1, 1, 1, '0', '0', '0', 2697, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1100, 'Teleport Door', 'teleport_door', 's', 1, 1, 0.001, '0', '0', '1', 2693, '1', '1', '0', '1', '1', 'teleport', 2, '0', ''),
(1101, 'Latin Love 3', 'sound_set_61', 's', 1, 1, 0.2, '1', '0', '0', 2698, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1102, 'Latin Love 2', 'sound_set_60', 's', 1, 1, 0.2, '1', '0', '0', 2695, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1103, 'Crystal Ball', 'fortune', 's', 1, 1, 1, '0', '0', '0', 2694, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(1104, 'Adventure Desk', 'sw_table', 's', 1, 2, 1, '0', '0', '0', 2713, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1105, 'Raven', 'sw_raven', 's', 1, 1, 1, '0', '0', '0', 2711, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1106, 'Ye Olde Chest', 'sw_chest', 's', 1, 2, 1, '0', '0', '0', 2709, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1107, 'Sand Castle Wall', 'sand_cstl_wall', 's', 2, 1, 1, '0', '0', '0', 2710, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1108, 'Sand Castle Tower', 'sand_cstl_twr', 's', 1, 1, 1, '0', '0', '0', 2705, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1109, 'Sand Castle Gate', 'sand_cstl_gate', 's', 2, 1, 0.001, '0', '0', '0', 2712, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1110, 'Candle Box', 'grunge_candle', 's', 1, 1, 1, '0', '0', '0', 2708, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1111, 'Bench', 'grunge_bench', 's', 3, 1, 1, '0', '1', '0', 2707, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1112, 'Flaming Barrel', 'grunge_barrel', 's', 1, 1, 1, '0', '0', '0', 2706, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1113, 'Moon Lamp', 'rclr_lamp', 's', 1, 1, 1, '0', '0', '0', 2733, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1115, 'Bubble trophy', 'a0 prizetrophy8_g', 's', 1, 1, 1, '0', '0', '0', 2426, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1116, 'nouvelle_trax', 'nouvelle_trax', 's', 1, 1, 1, '0', '0', '0', 2736, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1117, 'Bubble Juice Floor', 'md_rug', 's', 4, 4, 0, '1', '0', '1', 2727, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1118, 'Sushi Kohada', 'jp_tray6', 's', 1, 1, 1, '0', '0', '0', 2720, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1119, 'Sushi Tamago', 'jp_tray5', 's', 1, 1, 1, '0', '0', '0', 2717, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1120, 'Sushi Uni', 'jp_tray4', 's', 1, 1, 1, '0', '0', '0', 2725, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1121, 'Sushi Ikura', 'jp_tray3', 's', 1, 1, 1, '0', '0', '0', 2726, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1122, 'Sushi Ika', 'jp_tray2', 's', 1, 1, 1, '0', '0', '0', 2724, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1123, 'Sushi Maguro', 'jp_tray1', 's', 1, 1, 1, '0', '0', '0', 2715, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1124, 'Tea Maker', 'arabian_teamk', 's', 1, 1, 1, '0', '0', '0', 2716, '1', '1', '1', '1', '1', 'vendingmachine', 0, '1', ''),
(1125, 'Ornamental Urn', 'arabian_snake', 's', 1, 1, 1, '0', '0', '0', 2732, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1126, 'Berber Kilim Rug', 'arabian_rug', 's', 3, 5, 0, '1', '0', '1', 2719, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1127, 'Green Blossom Pillow', 'arabian_pllw', 's', 1, 1, 0.8, '0', '1', '0', 2722, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1128, 'Soft wooden screen', 'arabian_divdr', 's', 1, 2, 1, '0', '0', '0', 2730, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1129, 'Exotic', 'arabian_chair', 's', 1, 1, 1.2, '0', '1', '0', 2721, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1130, 'Amanjena Table', 'arabian_bigtb', 's', 3, 2, 0.8, '1', '0', '0', 2731, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1131, 'Hexagonal Tea Table', 'arabian_tetbl', 's', 1, 1, 1, '1', '0', '0', 2714, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1132, 'Mint Tea Tray', 'arabian_tray1', 's', 1, 1, 1, '0', '0', '0', 2734, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1133, 'Candle Tray', 'arabian_tray2', 's', 1, 1, 1, '0', '0', '0', 2735, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1134, 'Sweets Tray', 'arabian_tray3', 's', 1, 1, 1, '0', '0', '0', 2723, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1135, 'Sweet', 'arabian_tray4', 's', 1, 1, 1, '0', '0', '0', 2728, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1136, 'Alhambra Trax 3', 'sound_set_64', 's', 1, 1, 0.2, '1', '0', '0', 2738, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1137, 'Alhambra Trax 2', 'sound_set_63', 's', 1, 1, 0.2, '1', '0', '0', 2740, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1138, 'Alhambra Trax 1', 'sound_set_62', 's', 1, 1, 0.2, '1', '0', '0', 2741, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1139, 'Jukebox Pacha TV', 'jukebox_ptv*1', 's', 1, 1, 1, '0', '0', '0', 2739, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1140, 'Calippo icecream machine', 'calippo', 's', 1, 1, 1, '0', '0', '0', 2737, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(1141, 'traxsilver', 'traxsilver', 's', 1, 1, 1, '1', '0', '0', 2744, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1142, 'traxgold', 'traxgold', 's', 1, 1, 1, '1', '0', '0', 2742, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1143, 'traxbronze', 'traxbronze', 's', 1, 1, 1, '1', '0', '0', 2743, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1144, 'bench_puffet', 'bench_puffet', 's', 2, 1, 1, '0', '1', '0', 2745, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1145, 'Gold Bar (China)', 'CFC_500_goldbar', 's', 1, 1, 0.4, '1', '0', '0', 2764, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1146, 'Sack of Credits (China)', 'CFC_200_moneybag', 's', 1, 1, 1, '1', '0', '0', 2770, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20006, 'Mesh Corner', 'urban_fence_corner', 's', 1, 1, 1, '1', '0', '0', 3275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1148, 'Gold Coin (China)', 'CFC_100_coin_gold', 's', 1, 1, 0.2, '1', '0', '0', 2796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1149, 'Silver Coin (China)', 'CFC_50_coin_silver', 's', 1, 1, 0.2, '1', '0', '0', 2772, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1150, 'Chabu Dai', 'jp_table', 's', 2, 2, 1, '0', '0', '0', 2749, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1151, 'Shishi Odishi', 'jp_rare', 's', 2, 2, 1, '0', '0', '0', 2750, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1152, 'Katana Green', 'jp_katana3', 's', 1, 1, 1, '0', '0', '0', 2748, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1153, 'Katana Blue', 'jp_katana2', 's', 1, 1, 1, '0', '0', '0', 2747, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1154, 'HC Katana Red', 'jp_katana1', 's', 1, 1, 1, '0', '0', '0', 2751, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1156, 'Tiki Waterfall', 'tiki_waterfall', 's', 3, 2, 1, '0', '0', '0', 2757, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1157, 'Tiki Pig Tray', 'tiki_tray4', 's', 1, 1, 1, '0', '0', '0', 2765, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1158, 'Tiki Fish Tray', 'tiki_tray3', 's', 1, 1, 1, '0', '0', '0', 2753, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1159, 'Tiki Pineapple Plate', 'tiki_tray2', 's', 1, 1, 1, '0', '0', '0', 2768, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1160, 'Tiki Fruit Tray', 'tiki_tray1', 's', 1, 1, 1, '0', '0', '0', 2755, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1161, 'Empty Tray', 'tiki_tray0', 's', 1, 1, 1, '0', '0', '0', 2792, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1162, 'Toucan', 'tiki_toucan', 's', 1, 1, 1, '0', '0', '0', 2756, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1163, 'Beach Torch', 'tiki_torch', 's', 1, 1, 1, '0', '0', '0', 2773, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1164, 'Tribal Statue', 'tiki_statue', 's', 1, 1, 1, '0', '0', '0', 2782, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1165, 'Island Sand Patch', 'tiki_sand', 's', 2, 2, 0, '1', '0', '1', 2798, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1166, 'Tiki Parasol', 'tiki_parasol', 's', 1, 1, 1, '0', '0', '0', 2769, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1167, 'Jungle Patch', 'tiki_junglerug', 's', 2, 2, 0, '1', '0', '1', 2781, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1168, 'Tiki Bar Corner', 'tiki_corner', 's', 1, 1, 1, '1', '0', '0', 2794, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1169, 'Butterflies', 'tiki_bflies', 's', 1, 1, 1, '0', '0', '0', 2785, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1170, 'Tiki Bar Stool', 'tiki_bench', 's', 1, 1, 1.3, '0', '1', '0', 2784, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1171, 'Tiki Bar Desk', 'tiki_bardesk', 's', 1, 1, 1, '1', '0', '0', 2795, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1172, 'tampax_rug', 'tampax_rug', 's', 3, 4, 0, '1', '0', '1', 2754, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1173, 'Sound set 70', 'sound_set_70', 's', 1, 1, 0.2, '1', '0', '0', 2767, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1174, 'Sound set 69', 'sound_set_69', 's', 1, 1, 0.2, '1', '0', '0', 2799, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1175, 'Sound set 68', 'sound_set_68', 's', 1, 1, 0.2, '1', '0', '0', 2793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1176, 'Sound set 67', 'sound_set_67', 's', 1, 1, 0.2, '1', '0', '0', 2771, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1177, 'Sound set 66', 'sound_set_66', 's', 1, 1, 0.2, '1', '0', '0', 2752, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1178, 'Sound set 65', 'sound_set_65', 's', 1, 1, 0.2, '1', '0', '0', 2766, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20024, 'Square Dining Table', 'table_plasto_square*9', 's', 1, 1, 1, '1', '0', '0', 118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20021, 'Giant Heart', 'heart', 's', 1, 1, 1, '0', '0', '0', 227, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20016, 'Street Lamp', 'urban_lamp', 's', 1, 1, 1, '1', '0', '0', 3265, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1185, 'Lucky Bamboo', 'noob_plant', 's', 1, 1, 1, '0', '0', '0', 2783, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(20018, 'Street Wall', 'urban_wall', 'i', 0, 0, 1, '1', '0', '0', 4244, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20022, 'Champion trophy', 'a0 prizetrophy6_b', 's', 1, 1, 1, '0', '0', '0', 1510, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1197, 'Japanese Teamaker', 'jp_teamaker', 's', 1, 1, 1, '0', '0', '0', 2774, '1', '1', '1', '1', '1', 'vendingmachine', 0, '28', ''),
(1198, 'September 2008', 'svnr_uk', 's', 1, 1, 1, '0', '0', '0', 2838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1199, 'August 2008', 'svnr_nl', 's', 1, 2, 1, '0', '1', '0', 2825, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1200, 'July 2008', 'svnr_it', 's', 2, 1, 1, '0', '1', '0', 2813, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1201, 'October 2008', 'svnr_de', 's', 1, 1, 1, '0', '0', '0', 2801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1202, 'November 2008', 'svnr_aus', 's', 1, 1, 1, '0', '0', '0', 2836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1203, 'Accompaniments', 'diner_tray_7', 's', 1, 1, 1, '0', '0', '0', 2840, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1204, 'Vanilla', 'diner_tray_6', 's', 1, 1, 1, '0', '0', '0', 2826, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1205, 'Bacon and Eggs', 'diner_tray_5', 's', 1, 1, 1, '0', '0', '0', 2815, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1206, 'Pancakes', 'diner_tray_4', 's', 1, 1, 1, '0', '0', '0', 2800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1207, 'Spaghetti Meatballs', 'diner_tray_3', 's', 1, 1, 1, '0', '0', '0', 2841, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1208, 'Steak and Mash', 'diner_tray_2', 's', 1, 1, 1, '0', '0', '0', 2802, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1209, 'Burger and Chips', 'diner_tray_1', 's', 1, 1, 1, '0', '0', '0', 2839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1210, 'Had your fill', 'diner_tray_0', 's', 1, 1, 0.1, '1', '0', '0', 2837, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1211, 'Aqua Diner Sofa 2', 'diner_sofa_2*1', 's', 1, 1, 1, '0', '1', '0', 2804, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1212, 'Pink Diner Sofa 2', 'diner_sofa_2*2', 's', 1, 1, 1, '0', '1', '0', 2805, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1213, 'Black Diner Sofa 2', 'diner_sofa_2*3', 's', 1, 1, 1, '0', '1', '0', 2806, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1214, 'White Diner Sofa 2', 'diner_sofa_2*4', 's', 1, 1, 1, '0', '1', '0', 2807, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1215, 'Latte Diner Sofa 2', 'diner_sofa_2*5', 's', 1, 1, 1, '0', '1', '0', 2808, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1216, 'Blue Diner Sofa 2', 'diner_sofa_2*6', 's', 1, 1, 1, '0', '1', '0', 2809, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1217, 'Green Diner Sofa 2', 'diner_sofa_2*7', 's', 1, 1, 1, '0', '1', '0', 2810, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1218, 'Yellow Diner Sofa 2', 'diner_sofa_2*8', 's', 1, 1, 1, '0', '1', '0', 2811, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1219, 'Red Diner Sofa 2', 'diner_sofa_2*9', 's', 1, 1, 1, '0', '1', '0', 2812, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1220, 'Diner Shaker', 'diner_shaker', 's', 1, 1, 1, '0', '0', '0', 2814, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1221, 'Diner Floor', 'diner_rug', 's', 2, 2, 0, '1', '0', '1', 2803, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1222, 'Aqua Gumball Machine', 'diner_gumvendor*1', 's', 1, 1, 1, '0', '0', '0', 2827, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1223, 'Pink Gumball Machine', 'diner_gumvendor*2', 's', 1, 1, 1, '0', '0', '0', 2828, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1224, 'Black Gumball Machine', 'diner_gumvendor*3', 's', 1, 1, 1, '0', '0', '0', 2829, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1225, 'White Gumball Machine', 'diner_gumvendor*4', 's', 1, 1, 1, '0', '0', '0', 2830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1226, 'Latte Gumball Machine', 'diner_gumvendor*5', 's', 1, 1, 1, '0', '0', '0', 2831, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1227, 'Blue Gumball Machine', 'diner_gumvendor*6', 's', 1, 1, 1, '0', '0', '0', 2832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1228, 'Green Gumball Machine', 'diner_gumvendor*7', 's', 1, 1, 1, '0', '0', '0', 2833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1229, 'Yellow Gumball Machine', 'diner_gumvendor*8', 's', 1, 1, 1, '0', '0', '0', 2834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1230, 'Red Gumball Machine', 'diner_gumvendor*9', 's', 1, 1, 1, '0', '0', '0', 2835, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1231, 'Aqua Diner Till', 'diner_cashreg*1', 's', 1, 1, 1, '0', '0', '0', 2816, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1232, 'Pink Diner Till', 'diner_cashreg*2', 's', 1, 1, 1, '0', '0', '0', 2817, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1233, 'Black Diner Till', 'diner_cashreg*3', 's', 1, 1, 1, '0', '0', '0', 2818, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1234, 'White Diner Till', 'diner_cashreg*4', 's', 1, 1, 1, '0', '0', '0', 2819, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1235, 'Latte Diner Till', 'diner_cashreg*5', 's', 1, 1, 1, '0', '0', '0', 2820, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1236, 'Blue Diner Till', 'diner_cashreg*6', 's', 1, 1, 1, '0', '0', '0', 2821, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1237, 'Green Diner Till', 'diner_cashreg*7', 's', 1, 1, 1, '0', '0', '0', 2822, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1238, 'Yellow Diner Till', 'diner_cashreg*8', 's', 1, 1, 1, '0', '0', '0', 2823, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1239, 'Red Diner Till', 'diner_cashreg*9', 's', 1, 1, 1, '0', '0', '0', 2824, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1240, 'Aqua Diner Table', 'diner_table_2*1', 's', 3, 2, 1, '1', '0', '0', 2879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1241, 'Pink Diner Table', 'diner_table_2*2', 's', 3, 2, 1, '1', '0', '0', 2880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1242, 'Black Diner Table', 'diner_table_2*3', 's', 3, 2, 1, '1', '0', '0', 2881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1243, 'White Diner Table', 'diner_table_2*4', 's', 3, 2, 1, '1', '0', '0', 2882, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1244, 'Latte Diner Table', 'diner_table_2*5', 's', 3, 2, 1, '1', '0', '0', 2883, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1245, 'Blue Diner Table', 'diner_table_2*6', 's', 3, 2, 1, '1', '0', '0', 2884, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1246, 'Green Diner Table', 'diner_table_2*7', 's', 3, 2, 1, '1', '0', '0', 2885, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1247, 'Yellow Diner Table', 'diner_table_2*8', 's', 3, 2, 1, '1', '0', '0', 2886, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1248, 'Red Diner Table', 'diner_table_2*9', 's', 3, 2, 1, '1', '0', '0', 2887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1249, 'Aqua Diner Booth Table', 'diner_table_1*1', 's', 2, 2, 1, '1', '0', '0', 2897, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1250, 'Pink Diner Booth Table', 'diner_table_1*2', 's', 2, 2, 1, '1', '0', '0', 2898, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1251, 'Black Diner Booth Table', 'diner_table_1*3', 's', 2, 2, 1, '1', '0', '0', 2899, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1252, 'White Diner Booth Table', 'diner_table_1*4', 's', 2, 2, 1, '1', '0', '0', 2900, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1253, 'Latte Diner Booth Table', 'diner_table_1*5', 's', 2, 2, 1, '1', '0', '0', 2901, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1254, 'Blue Diner Booth Table', 'diner_table_1*6', 's', 2, 2, 1, '1', '0', '0', 2902, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1255, 'Green Diner Booth Table', 'diner_table_1*7', 's', 2, 2, 1, '1', '0', '0', 2903, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1256, 'Yellow Diner Booth Table', 'diner_table_1*8', 's', 2, 2, 1, '1', '0', '0', 2904, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1257, 'Red Diner Booth Table', 'diner_table_1*9', 's', 2, 2, 1, '1', '0', '0', 2905, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1258, 'Aqua Diner Sofa 1', 'diner_sofa_1*1', 's', 1, 1, 1, '0', '1', '0', 2888, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1259, 'Pink Diner Sofa 1', 'diner_sofa_1*2', 's', 1, 1, 1, '0', '1', '0', 2889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1260, 'Black Diner Sofa 1', 'diner_sofa_1*3', 's', 1, 1, 1, '0', '1', '0', 2890, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1261, 'White Diner Sofa 1', 'diner_sofa_1*4', 's', 1, 1, 1, '0', '1', '0', 2891, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1262, 'Latte Diner Sofa 1', 'diner_sofa_1*5', 's', 1, 1, 1, '0', '1', '0', 2892, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1263, 'Blue Diner Sofa 1', 'diner_sofa_1*6', 's', 1, 1, 1, '0', '1', '0', 2893, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1264, 'Green Diner Sofa 1', 'diner_sofa_1*7', 's', 1, 1, 1, '0', '1', '0', 2894, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1265, 'Yellow Diner Sofa 1', 'diner_sofa_1*8', 's', 1, 1, 1, '0', '1', '0', 2895, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1266, 'Red Diner Sofa 1', 'diner_sofa_1*9', 's', 1, 1, 1, '0', '1', '0', 2896, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1267, 'Aqua Diner Stool', 'diner_chair*1', 's', 1, 1, 1.4, '0', '1', '0', 2861, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1268, 'Pink Diner Stool', 'diner_chair*2', 's', 1, 1, 1.4, '0', '1', '0', 2862, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1269, 'Black Diner Stool', 'diner_chair*3', 's', 1, 1, 1.4, '0', '1', '0', 2863, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1270, 'White Diner Stool', 'diner_chair*4', 's', 1, 1, 1.4, '0', '1', '0', 2864, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1271, 'Latte Diner Stool', 'diner_chair*5', 's', 1, 1, 1.4, '0', '1', '0', 2865, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1272, 'Blue Diner Stool', 'diner_chair*6', 's', 1, 1, 1.4, '0', '1', '0', 2866, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1273, 'Green Diner Stool', 'diner_chair*7', 's', 1, 1, 1.4, '0', '1', '0', 2867, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1274, 'Yellow Diner Stool', 'diner_chair*8', 's', 1, 1, 1.4, '0', '1', '0', 2868, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1275, 'Red Diner Stool', 'diner_chair*9', 's', 1, 1, 1.4, '0', '1', '0', 2869, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1276, 'Aqua Diner Gate', 'diner_bardesk_gate*1', 's', 1, 1, 0.001, '0', '0', '0', 2842, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1277, 'Pink Diner Gate', 'diner_bardesk_gate*2', 's', 1, 1, 0.001, '0', '0', '0', 2843, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1278, 'Black Diner Gate', 'diner_bardesk_gate*3', 's', 1, 1, 0.001, '0', '0', '0', 2844, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1279, 'White Diner Gate', 'diner_bardesk_gate*4', 's', 1, 1, 0.001, '0', '0', '0', 2845, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1280, 'Latte Diner Gate', 'diner_bardesk_gate*5', 's', 1, 1, 0.001, '0', '0', '0', 2846, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1281, 'Blue Diner Gate', 'diner_bardesk_gate*6', 's', 1, 1, 0.001, '0', '0', '0', 2847, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1282, 'Green Diner Gate', 'diner_bardesk_gate*7', 's', 1, 1, 0.001, '0', '0', '0', 2848, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1283, 'Yellow Diner Gate', 'diner_bardesk_gate*8', 's', 1, 1, 0.001, '0', '0', '0', 2849, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1284, 'Red Diner Gate', 'diner_bardesk_gate*9', 's', 1, 1, 0.001, '0', '0', '0', 2850, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1285, 'Aqua Diner Corner', 'diner_bardesk_corner*1', 's', 1, 1, 1, '1', '0', '0', 2870, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1286, 'Pink Diner Corner', 'diner_bardesk_corner*2', 's', 1, 1, 1, '1', '0', '0', 2871, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1287, 'Black Diner Corner', 'diner_bardesk_corner*3', 's', 1, 1, 1, '1', '0', '0', 2872, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1288, 'Latte Diner Corner', 'diner_bardesk_corner*4', 's', 1, 1, 1, '1', '0', '0', 2873, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1289, 'Blue Diner Corner', 'diner_bardesk_corner*6', 's', 1, 1, 1, '1', '0', '0', 2875, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1290, 'Green Diner Corner', 'diner_bardesk_corner*7', 's', 1, 1, 1, '1', '0', '0', 2876, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1291, 'Yellow Diner Corner', 'diner_bardesk_corner*8', 's', 1, 1, 1, '1', '0', '0', 2877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1292, 'Red Diner Corner', 'diner_bardesk_corner*9', 's', 1, 1, 1, '1', '0', '0', 2878, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1293, 'Aqua Diner Bar', 'diner_bardesk*1', 's', 1, 1, 1, '1', '0', '0', 2851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1294, 'Pink Diner Bar', 'diner_bardesk*2', 's', 1, 1, 1, '1', '0', '0', 2852, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1295, 'Black Diner Bar', 'diner_bardesk*3', 's', 1, 1, 1, '1', '0', '0', 2853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1296, 'White Diner Bar', 'diner_bardesk*4', 's', 1, 1, 1, '1', '0', '0', 2854, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1297, 'Latte Diner Bar', 'diner_bardesk*5', 's', 1, 1, 1, '1', '0', '0', 2855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1298, 'Blue Diner Bar', 'diner_bardesk*6', 's', 1, 1, 1, '1', '0', '0', 2856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1299, 'Green Diner Bar', 'diner_bardesk*7', 's', 1, 1, 1, '1', '0', '0', 2857, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1300, 'Yellow Diner Bar', 'diner_bardesk*8', 's', 1, 1, 1, '1', '0', '0', 2858, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1301, 'Red Diner Bar', 'diner_bardesk*9', 's', 1, 1, 1, '1', '0', '0', 2859, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1302, 'ads_dave_cns', 'ads_dave_cns', 's', 1, 1, 1, '0', '0', '0', 2860, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1303, 'easy_carpet name', 'easy_carpet', 's', 4, 4, 0, '1', '0', '1', 2911, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1304, 'easy_bowl2', 'easy_bowl2', 's', 1, 1, 1, '1', '0', '0', 2907, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1305, 'Greek Corner', 'greek_corner', 's', 1, 1, 1, '0', '0', '0', 2910, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1306, 'Enter mortal', 'greek_gate', 's', 2, 1, 0.001, '0', '0', '0', 2908, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1307, 'Greek Pillars', 'greek_pillars', 's', 2, 1, 1, '0', '0', '0', 2909, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1308, 'Greek Seat', 'greek_seat', 's', 1, 1, 0.5, '0', '1', '0', 2906, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1309, 'Greek trophy', 'a0 greektrophy_g', 's', 1, 1, 1, '0', '0', '0', 2622, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1310, 'Greek trophy', 'a0 greektrophy_s', 's', 1, 1, 1, '0', '0', '0', 2623, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1311, 'Greek trophy', 'a0 greektrophy_b', 's', 1, 1, 1, '0', '0', '0', 2624, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1312, 'greek_block', 'greek_block', 's', 2, 1, 0.8, '0', '1', '0', 2915, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1313, 'Glass Table', 'hcc_table', 's', 1, 2, 1, '0', '0', '0', 2923, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1314, 'Bookshelf', 'hcc_shelf', 's', 1, 2, 1, '0', '0', '0', 2917, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1315, 'Low Back Sofa', 'hcc_sofa', 's', 2, 1, 1.2, '0', '1', '0', 2921, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1316, 'Cool look', 'hcc_minibar', 's', 1, 1, 1, '0', '0', '0', 2924, '1', '1', '1', '1', '1', 'vendingmachine', 0, '24', ''),
(1317, 'Trendy Stool', 'hcc_chair', 's', 1, 1, 1, '0', '1', '0', 2919, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1318, 'Crime scene', 'det_divider', 's', 2, 1, 1, '0', '0', '0', 2918, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1319, 'netari_carpet', 'netari_carpet', 's', 3, 5, 0, '1', '0', '1', 2916, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1320, 'Chalk Outline', 'det_body', 's', 2, 3, 0, '0', '0', '1', 2922, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1321, 'Antique Stool', 'hcc_stool', 's', 1, 1, 1.2, '0', '1', '0', 2920, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1322, 'Reclining Chair', 'hcc_sofachair', 's', 1, 1, 1.2, '0', '1', '0', 2925, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1323, 'Glass Corner', 'hcc_crnr', 's', 1, 1, 1, '0', '0', '0', 2926, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1324, 'Glass Divider', 'hcc_dvdr', 's', 2, 1, 1, '0', '0', '0', 2927, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1325, 'sob_carpet', 'sob_carpet', 's', 3, 5, 0, '1', '0', '1', 2928, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1326, 'My Hump', 'igor_seat', 's', 1, 1, 1, '0', '1', '0', 2929, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1327, 'The Brain', 'ads_igorbrain', 's', 1, 1, 1, '0', '0', '0', 2936, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1328, 'Igor Switch', 'ads_igorswitch', 's', 1, 1, 1, '0', '0', '0', 2934, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1329, 'ads_711', 'ads_711*1', 's', 1, 1, 1, '0', '0', '0', 2930, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1330, 'ads_711', 'ads_711*2', 's', 1, 1, 1, '0', '0', '0', 2931, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1331, 'ads_711', 'ads_711*3', 's', 1, 1, 1, '0', '0', '0', 2932, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1332, 'ads_711', 'ads_711*4', 's', 1, 1, 1, '0', '0', '0', 2933, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1333, 'Igor Ray Gun', 'ads_igorraygun', 's', 1, 2, 1, '0', '0', '0', 2935, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1334, 'Blood Sink', 'hween08_sink', 's', 1, 1, 1, '0', '0', '0', 2944, '1', '1', '1', '1', '1', 'vendingmachine', 0, '29', ''),
(1335, 'Hospital Curtain (blood)', 'hween08_curtain', 's', 3, 1, 1, '0', '0', '0', 2942, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1336, 'Blood Bath', 'hween08_bath', 's', 1, 2, 1, '0', '1', '0', 2948, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1337, 'Life Support (blood)', 'hween08_defibs', 's', 1, 1, 1, '0', '0', '0', 2938, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1338, 'Body Bag', 'hween08_bbag', 's', 1, 3, 1.3, '0', '0', '0', 2943, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1339, 'Hospital Curtain (ooze)', 'hween08_curtain2', 's', 3, 1, 1, '0', '0', '0', 2949, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1340, 'Life Support (ooze)', 'hween08_defibs2', 's', 1, 1, 1, '0', '0', '0', 2939, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1341, 'Hospital Bed (blood)', 'hween08_bed', 's', 1, 3, 2, '0', '0', '0', 2945, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1342, 'Ooze Sink', 'hween08_sink2', 's', 1, 1, 1, '0', '0', '0', 2940, '1', '1', '1', '1', '1', 'vendingmachine', 0, '30', ''),
(1343, 'Hospital Bed (ooze)', 'hween08_bed2', 's', 1, 3, 1, '0', '0', '0', 2937, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1344, 'Ooze Bath', 'hween08_bath2', 's', 1, 2, 1, '0', '1', '0', 2947, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1345, 'Manhole', 'hween08_manhole', 's', 1, 1, 1, '0', '0', '0', 2946, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1346, ' poke', 'hween08_trll', 's', 1, 1, 1, '0', '0', '0', 2941, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1347, 'Glass High Bar Table', 'party_table', 's', 1, 1, 1, '1', '0', '0', 2956, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1348, 'Spotlight', 'party_discol', 's', 1, 1, 1, '0', '0', '0', 2963, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1349, 'Stage Block Large', 'party_block2', 's', 2, 2, 0.7, '1', '0', '1', 2950, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1350, 'Bar Corner', 'party_barcorn', 's', 1, 1, 1, '1', '0', '0', 2957, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1351, 'High Class Bar Stool', 'party_chair', 's', 1, 1, 1.3, '0', '1', '0', 2960, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1352, 'Small Stage', 'party_block', 's', 1, 1, 0.9, '1', '0', '1', 2959, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1353, 'Dance Floor Laser', 'party_ravel', 's', 1, 1, 1, '0', '0', '0', 2965, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1354, 'Despite being made a lava', 'party_tube_lava', 's', 1, 1, 1, '0', '0', '0', 2966, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1355, 'Club Tray', 'party_tray', 's', 1, 1, 1, '0', '0', '0', 2955, '1', '1', '1', '1', '1', 'vendingmachine', 0, '31', ''),
(1356, 'Scratch it', 'party_djtable', 's', 1, 2, 1, '0', '0', '0', 2954, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1357, 'Disco Floor', 'party_floor', 's', 2, 2, 0, '1', '0', '1', 2958, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1358, 'Glitter Ball', 'party_ball', 's', 1, 1, 0, '0', '0', '1', 2964, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1359, 'Bubbles Machine', 'party_tube_bubble', 's', 1, 1, 1, '0', '0', '0', 2951, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1360, ' MC', 'party_mic', 's', 1, 1, 1, '0', '0', '0', 2953, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1361, 'Dance Floor Beamer', 'party_beamer', 's', 1, 1, 1, '0', '0', '0', 2961, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(1362, 'Bar Centre', 'party_bardesk', 's', 1, 1, 1, '1', '0', '0', 2962, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1363, 'Club seat', 'party_seat', 's', 1, 1, 1.1, '0', '1', '0', 2952, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1364, 'Snow Seat', 'xmas08_snowpl', 's', 1, 1, 1, '0', '1', '1', 3005, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1365, 'Emperor Penguin', 'penguin_basic', 's', 1, 1, 1, '0', '0', '0', 2977, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1366, 'Arctic Penguin Trophy', 'xmas08_trph1', 's', 1, 1, 1, '0', '0', '0', 2972, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1367, 'Musketeer Penguin', 'penguin_musketeer', 's', 1, 1, 1, '0', '0', '0', 2995, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1368, 'Icy table', 'xmas08_table', 's', 2, 2, 1, '1', '0', '0', 3009, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1369, 'Hot Tub', 'xmas08_hottub', 's', 2, 2, 1, '0', '0', '0', 2986, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1370, 'Luchador Penguin', 'penguin_wrestler', 's', 1, 1, 1, '0', '0', '0', 2990, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1371, 'Blow it up', 'fx_explosion', 's', 1, 1, 1, '0', '0', '0', 3011, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(1372, 'Robot Penguin', 'penguin_robot', 's', 1, 1, 1, '0', '0', '0', 2969, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1373, 'Icy Christmas Tree', 'xmas08_icetree', 's', 1, 1, 1, '0', '0', '0', 2967, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1374, 'Camp fire', 'campfire', 's', 1, 1, 1, '1', '0', '0', 2974, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1375, 'Ice', 'xmas08_icerug', 's', 2, 2, 0, '1', '0', '1', 3002, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1376, 'Executive Penguin', 'penguin_suit', 's', 1, 1, 1, '0', '0', '0', 3008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1377, 'December 2008', 'svnr_fi', 's', 1, 1, 1, '0', '0', '0', 2991, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1378, 'Snow Storm', 'xmas_snow', 's', 2, 2, 0, '1', '0', '1', 2982, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1379, 'Hockey Penguin', 'penguin_icehockey', 's', 1, 1, 1, '0', '0', '0', 2988, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1380, 'Pilot Penguin', 'penguin_pilot', 's', 1, 1, 1, '0', '0', '0', 3007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1381, 'Ballerina Penguin', 'penguin_ballet', 's', 1, 1, 1, '0', '0', '0', 2996, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1382, 'Arctic SFX', 'sound_set_71', 's', 1, 1, 0.2, '1', '0', '0', 3000, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1383, 'Boxer Penguin', 'penguin_boxer', 's', 1, 1, 1, '0', '0', '0', 2979, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1384, 'Fluorescent Penguin', 'penguin_glow', 's', 1, 1, 1, '0', '0', '0', 2993, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1385, 'Summer Penguin', 'penguin_swim', 's', 1, 1, 1, '0', '0', '0', 2984, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1386, 'Sumo Penguin', 'penguin_sumo', 's', 1, 1, 1, '0', '0', '0', 2994, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1387, 'Bubbles', 'xmas08_geysir', 's', 2, 2, 1, '0', '0', '0', 2985, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1388, 'Clown Penguin', 'penguin_clown', 's', 1, 1, 1, '0', '0', '0', 2989, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1389, 'Infected Penguin', 'penguin_infected', 's', 1, 1, 1, '0', '0', '0', 2983, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1390, 'Firestarter', 'fx_flare', 's', 1, 1, 1, '1', '0', '0', 3013, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(1391, 'Snowball Lantern Pile', 'xmas08_lantern', 's', 1, 1, 1, '0', '0', '0', 2968, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1392, 'Ice chair', 'xmas08_chair', 's', 1, 1, 1, '0', '1', '0', 3001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1393, 'Superhero Penguin', 'penguin_super', 's', 1, 1, 1, '0', '0', '0', 2998, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1394, 'Icy Teleport', 'xmas08_telep', 's', 1, 1, 0.001, '0', '0', '0', 2978, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1395, 'Cube Tree', 'xmas08_cubetree', 's', 1, 1, 1, '0', '0', '0', 3006, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1396, 'Disco Penguin', 'penguin_rock', 's', 1, 1, 1, '0', '0', '0', 3010, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1397, 'Ice divider', 'xmas08_dvdr1', 's', 2, 1, 1, '0', '0', '0', 2992, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1398, 'Ice Fish Hole', 'xmas08_hole', 's', 1, 1, 1, '0', '0', '0', 2980, '1', '1', '1', '1', '1', 'vendingmachine', 0, '34', ''),
(1399, 'XC Penguin', 'penguin_ski', 's', 1, 1, 1, '0', '0', '0', 2981, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1400, 'Skater Penguin', 'penguin_skater', 's', 1, 1, 1, '0', '0', '0', 2973, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1401, 'Icy Divider Corner', 'xmas08_dvdr2', 's', 1, 1, 1, '0', '0', '0', 2970, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1402, 'Christmas Penguin', 'penguin_elf', 's', 1, 1, 1, '0', '0', '0', 2971, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1403, 'Bunny Penguin', 'penguin_bunny', 's', 1, 1, 1, '0', '0', '0', 2975, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1404, 'Ninja Penguin', 'penguin_ninja', 's', 1, 1, 1, '0', '0', '0', 2976, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1405, 'Magic Penguin', 'penguin_magician', 's', 1, 1, 1, '0', '0', '0', 2997, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1406, 'Beautiful Penguin', 'penguin_hunchback', 's', 1, 1, 1, '0', '0', '0', 3003, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1407, 'Cowboy Penguin', 'penguin_cowboy', 's', 1, 1, 1, '0', '0', '0', 2987, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1408, 'Punk Penguin', 'penguin_punk', 's', 1, 1, 1, '0', '0', '0', 3004, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1409, 'Pirate Penguin', 'penguin_pirate', 's', 1, 1, 1, '0', '0', '0', 2999, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1410, 'ads_ob_pillow name', 'ads_ob_pillow', 's', 1, 1, 1, '0', '1', '0', 3018, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1411, 'Leviathon', 'lostc_merdragon', 's', 1, 3, 1, '0', '0', '0', 3016, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1412, 'Idea Agency Desk', 'ads_cldesk', 's', 2, 2, 1, '0', '0', '0', 3017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1413, 'Eco Friendly Penguin', 'xmas08_trph2', 's', 1, 1, 1, '0', '0', '0', 3015, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1414, 'Whatever your Idea', 'ads_cltele', 's', 1, 1, 0.001, '0', '0', '0', 3014, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1415, 'Childline Rug', 'ads_clfloor', 's', 3, 5, 0, '1', '0', '1', 3019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1417, 'Mall tele-door', 'ads_mall_tele', 's', 1, 1, 0.001, '1', '0', '1', 3020, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1418, 'Moongate', 'china_moongt', 's', 1, 3, 0.001, '0', '0', '1', 3024, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1419, 'Lotus Pool', 'bolly_lotus_pool', 's', 2, 2, 0, '0', '0', '0', 3022, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1420, 'Ox Statue', 'china_ox', 's', 1, 1, 1, '0', '0', '0', 3025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1422, 'Petal Flurry', 'bolly_petals', 's', 2, 2, 0, '1', '0', '1', 3026, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1423, 'Palm Tree', 'bolly_tree', 's', 1, 1, 1, '0', '0', '0', 3042, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1424, 'Swing low', 'bolly_swing', 's', 2, 1, 1.5, '0', '1', '0', 3037, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1425, 'Star Pillow', 'bolly_pillow', 's', 1, 1, 0.8, '0', '1', '0', 3030, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1426, 'Bollywood Corner', 'bolly_corner', 's', 1, 1, 1, '1', '0', '0', 3031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1427, 'Elephant MiniBar', 'bolly_phant', 's', 1, 1, 1, '0', '0', '0', 3033, '1', '1', '1', '1', '1', 'vendingmachine', 0, '35', ''),
(1428, 'Monkey Lamp', 'bolly_monkey_lamp', 's', 1, 1, 1, '0', '0', '0', 3036, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1429, 'Green Curtain', 'bolly_drapeb', 's', 3, 1, 0.001, '0', '0', '0', 3040, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1430, 'Planet of Love', 'planet_of_love', 's', 1, 1, 1, '1', '0', '0', 3044, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1431, 'Chandelier', 'bolly_lamp', 's', 1, 1, 1, '0', '0', '0', 3041, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1432, 'Bollywood Desk', 'bolly_desk', 's', 2, 1, 1, '1', '0', '0', 3034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1433, 'Vase of Flowers', 'bolly_vase', 's', 1, 1, 1, '0', '0', '0', 3043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1434, 'Standard Tile', 'bolly_tile2', 's', 2, 2, 0, '1', '0', '1', 3027, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1435, 'Large Ornamental Table', 'bolly_table', 's', 2, 2, 1, '1', '0', '0', 3035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1436, 'Yellow Curtain', 'bolly_drapec', 's', 3, 1, 0.001, '0', '0', '0', 3032, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1437, 'Extravagant Fountain', 'bolly_fountain', 's', 2, 2, 1, '0', '0', '0', 3029, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20046, 'Executive Teleport', 'exe_elevator', 's', 1, 1, 0.001, '0', '0', '0', 3305, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1439, 'Ornamental Tile', 'bolly_tile1', 's', 2, 2, 0, '1', '0', '1', 3028, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1440, 'Pink Curtain', 'bolly_drapea', 's', 3, 1, 0.001, '0', '0', '0', 3038, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1441, 'ads_idol_floor1 name', 'ads_idol_floor1', 's', 2, 2, 0, '1', '0', '1', 3045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1442, 'Inventor''s Desk', 'ads_igor_dsk', 's', 2, 1, 1, '0', '0', '0', 3049, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1443, 'ads_idol_desk', 'ads_idol_desk', 's', 1, 4, 1, '0', '0', '0', 3050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1444, 'ads_idol_ch', 'ads_idol_ch', 's', 1, 1, 1.2, '0', '1', '0', 3051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1445, 'Glass Flask', 'ads_igor_flask', 's', 1, 1, 1, '0', '0', '0', 3046, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1446, 'ads_idol_drape name', 'ads_idol_drape', 's', 3, 1, 0.001, '0', '0', '0', 3048, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1447, 'ads_idol_floor2 name', 'ads_idol_floor2', 's', 2, 2, 0, '1', '0', '1', 3047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1448, 'Kraken', 'lostc_octopus', 's', 1, 2, 1, '0', '0', '0', 3052, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1449, 'Marble Floor Tile', 'lc_tile1', 's', 2, 2, 0, '1', '0', '1', 3076, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1450, 'Small Jellyfish Lamp', 'lc_medusa2', 's', 1, 1, 1, '0', '0', '0', 3073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1451, 'Sally Lightfoot', 'lc_crab2', 's', 1, 1, 1, '0', '0', '0', 3068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1452, 'March Collectable 2009', 'lostc_teleport', 's', 1, 1, 0.001, '0', '0', '1', 3071, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1453, 'ads_idol_piano name', 'ads_idol_piano', 's', 2, 2, 1, '0', '0', '0', 3058, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1454, 'Large Coral Divider', 'lc_coral_divider_hi', 's', 2, 1, 1, '0', '0', '0', 3078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1455, 'ads_711shelf name', 'ads_711shelf', 's', 1, 2, 1, '0', '0', '0', 3066, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1456, 'Water Tube Corner', 'lc_tubes_corners', 's', 1, 1, 1, '0', '0', '0', 3072, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1457, 'Captain''s Table', 'lc_table', 's', 2, 2, 1, '1', '0', '0', 3067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1458, 'Cobbled Stones', 'lc_tile2', 's', 2, 2, 0, '1', '0', '1', 3069, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1459, 'Anemone', 'lc_anemone', 's', 1, 1, 1, '0', '0', '0', 3074, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1460, 'Small Coral Divider', 'lc_coral_divider_low', 's', 2, 1, 1, '0', '0', '0', 3077, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1461, 'Ocean Window Rug', 'lc_glass_floor', 's', 2, 3, 0, '1', '0', '1', 3060, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1462, 'Large Jellyfish Lamp', 'lc_medusa1', 's', 1, 1, 1, '0', '0', '0', 3064, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1463, 'Crab Patch', 'lc_crab1', 's', 2, 2, 1, '0', '0', '0', 3062, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1464, 'ads_idol_jukebox name', 'ads_idol_jukebox*1', 's', 1, 1, 1, '0', '0', '0', 3059, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1465, 'ads_idol_pchair name', 'ads_idol_pchair', 's', 1, 1, 1, '0', '1', '0', 3056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1466, 'Water Tube Straight', 'lc_tubes_straight', 's', 1, 1, 1, '0', '0', '0', 3065, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1467, 'ads_idol_audChr name', 'ads_idol_audChr', 's', 1, 1, 1, '0', '1', '0', 3057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1468, 'ads_idol_trax name', 'ads_idol_trax', 's', 1, 1, 1, '0', '0', '0', 3055, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1469, 'ads_idol_tele', 'ads_idol_tele', 's', 1, 1, 0.001, '0', '0', '1', 3053, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1470, 'Wooden Corner', 'lc_corner', 's', 1, 1, 1, '1', '0', '0', 3075, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1471, 'Wooden Stool', 'lc_stool', 's', 1, 1, 1, '0', '1', '0', 3063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1472, 'No rusty nails', 'lc_chair', 's', 1, 1, 1, '0', '1', '0', 3061, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1473, 'Wooden Bar Desk', 'lc_desk', 's', 2, 1, 1, '1', '0', '0', 3070, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1474, 'ads_idol_mic name', 'ads_idol_mic', 's', 1, 1, 1, '0', '0', '0', 3054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1475, 'ads_idol_hotspot name', 'ads_idol_hotspot', 's', 1, 1, 0.2, '0', '0', '1', 3080, '1', '1', '1', '1', '1', 'default', 103, '0', ''),
(1476, 'ads_idol_clRack name', 'ads_idol_clRack', 's', 3, 1, 1, '0', '0', '0', 3079, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1477, 'ads_idol_voting_ch name', 'ads_idol_voting_ch', 's', 1, 1, 1.2, '0', '1', '0', 3081, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1478, 'Ecotron prize', 'ecotron_box', 's', 1, 1, 1, '1', '0', '0', 3095, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1479, 'Eco Light 2', 'eco_light2', 's', 1, 1, 1, '1', '0', '0', 3082, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1480, 'Eco Stool 3', 'eco_chair3', 's', 1, 1, 1, '0', '1', '0', 3094, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1481, 'Eco Coffee Table 3', 'eco_table3', 's', 2, 2, 1, '1', '0', '0', 3086, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1482, 'Eco Lamp 2', 'eco_lamp2', 's', 1, 1, 1, '1', '0', '0', 3092, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1483, 'Eco Armchair 3', 'eco_sofa3', 's', 1, 1, 1, '0', '1', '0', 3088, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1484, 'Eco Coffee Table 2', 'eco_table2', 's', 2, 2, 1, '1', '0', '0', 3089, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1485, 'Fruit Bowl 2', 'eco_fruits2', 's', 1, 1, 1, '1', '0', '0', 3102, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1486, 'Eco Armchair 1', 'eco_sofa1', 's', 1, 1, 1, '0', '1', '0', 3096, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1487, 'Fruit Bowl 3', 'eco_fruits3', 's', 1, 1, 1, '1', '0', '0', 3104, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1488, 'Eco Light 1', 'eco_light1', 's', 1, 1, 1, '1', '0', '0', 3098, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1489, 'Actually', 'eco_tree1', 's', 1, 1, 1, '0', '0', '0', 3093, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1490, 'Potted Cactus 2', 'eco_cactus2', 's', 1, 1, 1, '1', '0', '0', 3105, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1491, 'Talk To FRANK Brain Lamp', 'ads_frankb', 's', 1, 1, 1, '0', '0', '0', 3111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1492, 'Road Signs', 'bump_signs', 's', 1, 1, 1, '0', '0', '0', 3090, '1', '1', '1', '0', '1', 'default', 7, '0', ''),
(1493, 'Potted Cactus 1', 'eco_cactus1', 's', 1, 1, 1, '1', '0', '0', 3083, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1494, 'Eco Stool 2', 'eco_chair2', 's', 1, 1, 1, '0', '1', '0', 3106, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1495, 'Potted Cactus 3', 'eco_cactus3', 's', 1, 1, 1, '1', '0', '0', 3085, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1496, 'Bumper Tyres', 'bump_tires', 's', 1, 1, 0.8, '1', '0', '0', 3101, '1', '1', '1', '0', '1', 'default', 3, '0', ''),
(1497, 'Traffic Lights', 'bump_lights', 's', 1, 1, 1, '0', '0', '0', 3103, '1', '1', '1', '0', '1', 'default', 3, '0', ''),
(1498, 'Eco Lamp 3', 'eco_lamp3', 's', 1, 1, 1, '1', '0', '0', 3091, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1499, 'Eco Coffee Table 1', 'eco_table1', 's', 2, 2, 1, '1', '0', '0', 3099, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1500, 'Eco Stool 1', 'eco_chair1', 's', 1, 1, 1, '0', '1', '0', 3084, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1501, 'Eco Armchair 2', 'eco_sofa2', 's', 1, 1, 1, '0', '1', '0', 3100, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1502, 'Road', 'bump_road', 's', 2, 2, 0, '1', '0', '1', 3110, '1', '1', '1', '0', '1', 'default', 4, '0', ''),
(1503, 'Fruit Bowl 1', 'eco_fruits1', 's', 1, 1, 1, '1', '0', '0', 3107, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1504, 'Eco Lamp 1', 'eco_lamp1', 's', 1, 1, 1, '1', '0', '0', 3097, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1505, 'Eco Light 3', 'eco_light3', 's', 1, 1, 1, '1', '0', '0', 3108, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1506, 'Pear Tree', 'eco_tree2', 's', 1, 1, 1, '0', '0', '0', 3109, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1507, 'Totem Leg', 'totem_leg', 's', 1, 1, 1.2, '1', '0', '0', 3113, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(1508, 'ads_grefusa_cactus name', 'ads_grefusa_cactus', 's', 1, 1, 1, '0', '0', '0', 3112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1509, 'ads_idol_tube name', 'ads_idol_tube', 's', 1, 1, 1, '0', '0', '0', 3126, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1510, 'Executive Light', 'exe_light', 's', 1, 1, 0, '1', '0', '1', 3122, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1511, 'ads_idol_cork name', 'ads_idol_cork', 's', 3, 1, 1, '0', '0', '0', 3120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1512, 'Idea Agency Jukebox', 'ads_cl_jukeb', 's', 1, 1, 1, '0', '0', '0', 3127, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1513, 'Grass patch', 'env_grass', 's', 2, 2, 0, '1', '0', '1', 3129, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1514, 'Forest Trunk Seat', 'env_tree3', 's', 1, 1, 1, '0', '0', '0', 3125, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1515, 'Eco Hedgerow', 'env_bushes', 's', 1, 2, 1, '0', '0', '0', 3115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1516, 'Eco Hedgerows Gate', 'env_bushes_gate', 's', 1, 2, 0.001, '0', '0', '0', 3128, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1517, 'Executive Gate', 'exe_gate', 's', 1, 1, 0.001, '0', '0', '0', 3119, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1518, 'ads_idol_newsDsk name', 'ads_idol_newsDsk', 's', 2, 2, 1, '0', '0', '0', 3116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1519, 'Forest Tree Chair', 'env_tree1', 's', 1, 1, 1, '0', '1', '0', 3117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1520, 'Forest Tree Americana', 'env_tree2', 's', 1, 1, 1, '0', '1', '0', 3123, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1521, 'Cubist Light', 'exe_cubelight', 's', 1, 1, 1, '0', '0', '0', 3121, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1522, 'The Four Seasons Tree', 'env_tree4', 's', 2, 2, 1, '0', '0', '0', 3118, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1523, 'Sphere Lamp', 'exe_artlamp', 's', 1, 1, 1, '0', '0', '0', 3114, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1524, 'ads_idol_ichair name', 'ads_idol_ichair', 's', 1, 1, 1.4, '0', '1', '0', 3124, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1525, 'Wedding Cake', 'tray_cake', 's', 1, 1, 1, '0', '0', '0', 3133, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1526, 'ads_reebok_block2', 'ads_reebok_block2', 's', 2, 2, 0.8, '1', '0', '1', 3132, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1527, 'ads_malaco_rug_name', 'ads_malaco_rug', 's', 3, 3, 0, '1', '0', '1', 3135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1528, 'Champagne Bucket', 'tray_champagne', 's', 1, 1, 1, '0', '0', '0', 3134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1529, 'Champagne Tower', 'tray_glasstower', 's', 1, 1, 1, '0', '0', '0', 3130, '1', '1', '1', '1', '1', 'vendingmachine', 0, '40', ''),
(1530, 'ads_malaco_gu', 'ads_malaco_gu', 's', 1, 1, 1, '0', '0', '0', 3131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1531, 'Idea Agency Super Cake', 'ads_clcake', 's', 1, 1, 1, '0', '0', '0', 3139, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1532, 'Idea Agency Sofa', 'ads_cl_sofa', 's', 2, 1, 1, '0', '1', '0', 3137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1533, 'Function Table', 'ads_idol_tblCloth', 's', 2, 2, 1, '1', '0', '0', 3136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1534, 'ads_idol_carpet name', 'ads_idol_carpet', 's', 2, 7, 0, '0', '0', '1', 3140, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1535, 'Function Lamp', 'ads_idol_lamp', 's', 1, 1, 0, '1', '0', '1', 3138, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1536, 'Rain Shower', 'country_rain', 's', 1, 1, 0, '1', '0', '1', 3153, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1537, 'Scarecrow', 'country_scarecrow', 's', 1, 1, 1, '0', '0', '0', 3160, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1538, 'Porta-House', 'env_telep', 's', 1, 1, 0.001, '0', '0', '0', 3161, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1539, 'Crop Field', 'country_soil', 's', 2, 2, 0, '1', '0', '1', 3145, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1540, 'Field Grass', 'country_grass', 's', 2, 2, 0, '1', '0', '1', 3162, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1541, 'The Golden Tablet', 'ads_goldtabl', 's', 1, 1, 1, '0', '0', '0', 3151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1542, 'Witch Mushroom', 'eco_mush1', 's', 1, 1, 1, '1', '0', '0', 3142, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1543, 'Tractor', 'country_trctr', 's', 2, 2, 1, '0', '0', '0', 3147, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1544, 'Stone Wall', 'country_fnc2', 's', 2, 1, 1, '0', '0', '0', 3141, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1545, 'Stick Fence', 'country_fnc1', 's', 2, 1, 1, '0', '0', '0', 3154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1546, 'Wishing Well', 'country_well', 's', 1, 1, 1, '0', '0', '0', 3149, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1547, 'Fairy Mushroom', 'eco_mush2', 's', 1, 1, 1, '1', '0', '0', 3155, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1548, 'Rainbow', 'country_rbw', 's', 1, 1, 1, '0', '0', '0', 3143, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1549, 'Golden Wheat', 'country_wheat', 's', 2, 2, 1, '0', '0', '0', 3163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1550, 'Farm Gate', 'country_gate', 's', 2, 1, 0.001, '0', '0', '0', 3150, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1551, 'Country Trax', 'sound_set_72', 's', 1, 1, 0.2, '1', '0', '0', 3144, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1552, 'Wooden Stage', 'country_stage', 's', 2, 2, 1, '1', '0', '1', 3148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1553, 'ads_calip_cola_1 name', 'ads_calip_cola*1', 's', 1, 1, 1, '0', '0', '0', 3156, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1554, 'ads_calip_cola_2 name', 'ads_calip_cola*2', 's', 1, 1, 1, '0', '0', '0', 3157, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1555, 'ads_calip_cola_3 name', 'ads_calip_cola*3', 's', 1, 1, 1, '0', '0', '0', 3158, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1556, 'ads_calip_cola_4 name', 'ads_calip_cola*4', 's', 1, 1, 1, '0', '0', '0', 3159, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1557, 'Log Bench', 'country_log', 's', 2, 1, 1, '0', '1', '0', 3146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1558, 'Stone Pile', 'country_fnc3', 's', 1, 1, 1, '0', '0', '0', 3152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1559, 'Wooden Patio Tile', 'country_patio', 's', 1, 1, 1, '0', '0', '0', 3166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1560, 'Country Ditch Corner', 'country_corner', 's', 1, 1, 1, '0', '0', '0', 3164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1561, 'Country Ditch', 'country_ditch', 's', 1, 2, 0.001, '0', '0', '0', 3165, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1562, 'ads_calip_chair name', 'ads_calip_chair', 's', 1, 1, 1, '0', '1', '0', 3168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1563, 'ads_idol_trophy name', 'ads_idol_trophy', 's', 1, 1, 1, '0', '0', '0', 3169, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1564, 'Totem Spirit Head', 'totem_head', 's', 1, 1, 1.7, '1', '0', '0', 3167, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1565, 'ads_calip_pool name', 'ads_calip_pool', 's', 2, 2, 0, '0', '0', '1', 3182, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1566, 'laptopdesk name', 'laptopdesk', 's', 2, 2, 1, '0', '0', '0', 3173, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1567, 'Skull', 'LT_skull', 's', 1, 1, 1, '0', '0', '0', 3189, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1568, 'Large Tribal Block', 'lt_stage2', 's', 2, 2, 0.9, '0', '0', '1', 3175, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1569, 'Lava Corner', 'lt_lavac', 's', 1, 1, 1, '0', '0', '0', 3180, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1570, 'Tribal Gate', 'lt_gate', 's', 2, 1, 0.001, '0', '0', '0', 3172, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1571, 'Planet of Eternity', 'saturn', 's', 1, 1, 1, '1', '0', '0', 3181, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1572, 'ads_calip_tele name', 'ads_calip_tele', 's', 1, 1, 0.001, '0', '0', '0', 3190, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1573, 'Stone Statue', 'lt_statue', 's', 1, 1, 1, '0', '0', '0', 3185, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1574, 'Tarantula', 'lt_spider', 's', 1, 1, 1, '0', '0', '0', 3178, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1575, 'Tribal Stone Wall', 'lt_stone2', 's', 2, 1, 1, '1', '0', '0', 3177, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1576, 'Tribal Seat', 'LT_throne', 's', 1, 1, 1.5, '0', '1', '0', 3171, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1577, 'audChr name', 'audChr', 's', 1, 1, 1, '0', '1', '0', 3179, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1578, 'Moss Patch', 'lt_patch', 's', 2, 2, 0, '1', '0', '1', 3188, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1579, 'Lava Ditch', 'lt_lava', 's', 1, 2, 1, '0', '0', '0', 3176, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1580, 'Small Tribal Torch', 'LT_pillar2', 's', 1, 1, 1, '0', '0', '0', 3170, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1581, 'Ant Hill', 'lt_bughill', 's', 1, 1, 1, '0', '0', '0', 3174, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1582, 'noticeboard name', 'noticeboard', 's', 3, 1, 1, '0', '0', '0', 3186, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1583, 'clrack name', 'clrack', 's', 3, 1, 0, '1', '0', '0', 3184, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1584, 'Large Tribal Torch', 'LT_pillar', 's', 1, 1, 1, '0', '0', '0', 3187, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1585, 'ads_calip_parasol name', 'lt_stage1', 's', 1, 1, 0.9, '0', '0', '1', 3183, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1586, 'transparent_floor name', 'transparent_floor', 's', 2, 2, 0, '1', '0', '1', 3199, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1587, 'ads_calip_lava name', 'ads_calip_lava', 's', 1, 1, 1, '0', '0', '0', 3197, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1588, 'Tribal Stone Corner', 'lt_stone1', 's', 1, 1, 1, '1', '0', '0', 3196, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1589, 'ads_calip_fan', 'ads_calip_fan', 's', 1, 1, 1, '0', '0', '0', 3198, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1590, 'voting_ch name', 'voting_ch', 's', 1, 1, 1.3, '0', '1', '0', 3201, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1591, 'Quick Coffee Stop', 'ads_mall_coffeem', 's', 1, 1, 1, '0', '0', '0', 3202, '1', '1', '1', '1', '1', 'vendingmachine', 0, '41', ''),
(1592, 'Totem Planet', 'totem_planet', 's', 1, 1, 1, '0', '0', '0', 3200, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1593, 'Don''t worry', 'SF_reactor', 's', 1, 1, 1, '1', '0', '0', 3212, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1594, 'Pack all you want', 'SF_crate_2', 's', 2, 1, 1, '1', '0', '0', 3204, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1595, 'Space Crew Chair', 'SF_chair_blue', 's', 1, 1, 1.2, '0', '1', '0', 3207, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1596, 'Cryogenic Bed', 'sf_pod', 's', 1, 3, 1.36, '0', '0', '0', 3219, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(1597, 'Command Console', 'SF_panel1', 's', 1, 1, 1, '0', '0', '0', 3217, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1598, 'Starship Table', 'SF_table', 's', 2, 2, 1, '1', '0', '0', 3220, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1599, 'Welcome aboard', 'SF_chair_green', 's', 1, 1, 1.2, '0', '1', '0', 3215, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1600, 'Small Crate', 'SF_crate_1', 's', 1, 1, 1, '1', '0', '0', 3205, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1601, 'Alien Lifeform', 'SF_alien', 's', 1, 1, 1, '0', '0', '0', 3210, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1602, 'Engineering Console', 'SF_panel2', 's', 2, 1, 1, '0', '0', '0', 3218, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1603, 'Display Gate', 'sf_gate', 's', 2, 1, 0.001, '0', '0', '0', 3221, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1604, 'Navigation Panel', 'SF_panel3', 's', 1, 1, 1, '0', '0', '0', 3208, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1605, 'Starship Floor 2', 'SF_floor_2', 's', 2, 2, 0, '1', '0', '1', 3211, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1606, 'Sci Fi Lamp', 'SF_lamp', 's', 1, 1, 1, '0', '0', '0', 3224, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1607, 'Captain''s Chair', 'SF_chair_red', 's', 1, 1, 1.2, '0', '1', '0', 3223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1608, 'Transparent Floor', 'sf_floor', 's', 2, 4, 0, '1', '0', '1', 3213, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1609, 'Starship Roof', 'sf_roof', 's', 2, 4, 0, '1', '0', '1', 3203, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1610, 'Light Pole', 'sf_stick', 's', 1, 1, 1, '0', '0', '0', 3206, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1611, 'Starship Floor 1', 'SF_floor_1', 's', 2, 2, 0, '1', '0', '1', 3222, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1612, ' sweets', 'ads_mall_kiosk', 's', 1, 2, 1, '0', '0', '0', 3216, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1613, 'Futuristic Teleport', 'sf_tele', 's', 1, 1, 0.001, '0', '0', '0', 3214, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1614, 'Sci Fi Roller', 'sf_roller', 's', 1, 1, 0.5, '1', '0', '1', 3209, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(1615, 'Hot Trophy', 'prizetrophy_hot', 's', 1, 1, 1, '0', '0', '0', 3229, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1616, 'Pink Inflatable Raft', 'summer_raft1', 's', 1, 1, 1, '0', '1', '0', 3228, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1617, 'Cool Trophy', 'prizetrophy_cool', 's', 1, 1, 1, '0', '0', '0', 3225, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1618, 'Blue Inflatable Raft', 'summer_raft2', 's', 1, 1, 1, '0', '1', '0', 3227, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1619, 'ads_elisa_gnome name', 'ads_elisa_gnome', 's', 1, 1, 1, '0', '0', '0', 3226, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1620, 'Summer Cool Box', 'summer_icebox', 's', 1, 1, 1, '0', '0', '0', 3231, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1621, 'ads_oc_soda', 'ads_oc_soda', 's', 1, 1, 1, '0', '0', '0', 3230, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1622, 'Mars Patch', 'marsrug', 's', 2, 2, 0, '1', '0', '1', 3232, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1623, 'White Candle', 'rela_candle1', 's', 1, 1, 1, '0', '0', '0', 3238, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20066, 'Dead Tree', 'tree2', 's', 1, 1, 1, '0', '0', '0', 2104, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1625, 'Red Candles', 'rela_candles2', 's', 1, 1, 1, '0', '0', '0', 3245, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1626, 'Stones', 'rela_stone', 's', 1, 1, 0.5, '0', '0', '1', 3233, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1627, 'Wicker Chair', 'rela_hchair', 's', 1, 1, 1.3, '0', '1', '0', 3247, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1628, 'Red Candle', 'rela_candle2', 's', 1, 1, 1, '0', '0', '0', 3244, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1629, 'ads_711', 'ads_711*5', 's', 1, 1, 1, '0', '0', '0', 3241, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1630, 'ads_711', 'ads_711*6', 's', 1, 1, 1, '0', '0', '0', 3242, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1631, 'ads_711', 'ads_711*7', 's', 1, 1, 1, '0', '0', '0', 3243, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1632, 'Purple Candle', 'rela_candle3', 's', 1, 1, 1, '0', '0', '0', 3235, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1633, 'Asteroid', 'pix_asteroid', 's', 1, 1, 1, '1', '0', '0', 3237, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1634, 'Bushy Houseplant', 'rela_plant', 's', 1, 1, 1, '0', '0', '0', 3246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1635, 'White Candles', 'rela_candles1', 's', 1, 1, 1, '0', '0', '0', 3234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1636, 'Purple Candles', 'rela_candles3', 's', 1, 1, 1, '0', '0', '0', 3236, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1637, 'Orchid', 'rela_orchid', 's', 1, 1, 1, '0', '0', '0', 3239, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1638, 'Rocks', 'rela_rock', 's', 1, 1, 0.8, '0', '1', '0', 3248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1639, 'ktchn_stove name', 'ktchn_stove', 's', 2, 1, 1, '0', '0', '0', 3256, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1640, 'ktchn_light name', 'ktchn_light', 's', 2, 1, 0, '1', '0', '1', 3258, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1641, 'ktchn_plates name', 'ktchn_plates', 's', 1, 1, 1, '0', '0', '0', 3263, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1642, 'ktchn_countr_1 name', 'ktchn_countr_1', 's', 1, 1, 1, '1', '0', '0', 3261, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1643, 'ktchn_pots name', 'ktchn_pots', 's', 2, 1, 0, '1', '0', '1', 3252, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1644, 'ktchn_cornr name', 'ktchn_cornr', 's', 1, 1, 1, '0', '0', '0', 3257, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1645, 'ktchn_desk name', 'ktchn_desk', 's', 2, 1, 1, '1', '0', '0', 3260, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1646, 'ktchn_trash name', 'ktchn_trash', 's', 1, 1, 1, '0', '0', '0', 3264, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1647, 'ktchn_countr_2 name', 'ktchn_countr_2', 's', 2, 1, 1, '1', '0', '0', 3253, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1648, 'ktchn_bBlock name', 'ktchn_bBlock', 's', 1, 1, 1, '0', '0', '0', 3255, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1649, 'ktchn_dvdr name', 'ktchn_dvdr', 's', 2, 1, 1, '0', '0', '0', 3259, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1650, 'ktchn_inspctr name', 'ktchn_inspctr', 's', 1, 1, 1, '1', '0', '0', 3250, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1651, 'ktchn_fridge name', 'ktchn_fridge', 's', 1, 1, 1, '1', '0', '0', 3249, '1', '1', '1', '1', '1', 'vendingmachine', 0, '3,36,37,38', ''),
(1652, 'ads_1800tele', 'ads_1800tele', 's', 1, 1, 0.001, '0', '0', '0', 3251, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1653, 'ktchn_sink name', 'ktchn_sink', 's', 2, 1, 1, '0', '0', '0', 3262, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1654, 'ktchn_gate name', 'ktchn_gate', 's', 2, 1, 0.001, '0', '0', '0', 3254, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1655, 'Pad of stickies', 'post.it', 'i', 0, 0, 1, '0', '0', '0', 1, '0', '0', '1', '0', '1', 'postit', 1, '0', ''),
(1656, 'Heart Stickies', 'post.it.vd', 'i', 0, 0, 1, '0', '0', '0', 2, '0', '0', '1', '0', '1', 'postit', 1, '0', ''),
(20067, 'Green Hatch', 'divider_poly3*7', 's', 1, 1, 0.001, '0', '0', '0', 1930, '1', '1', '1', '1', '1', 'gate', 1, '0', ''),
(20068, 'Idea Agency Lava Lamp', 'ads_cllava2', 's', 1, 1, 1, '0', '0', '0', 3021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1665, 'Gothic Ectoplasm Fountain', 'gothicfountain', 'i', 0, 0, 1, '0', '0', '0', 4002, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1666, 'Retro Wall Lamp', 'hc_wall_lamp', 'i', 0, 0, 1, '0', '0', '0', 4003, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1667, 'Industrial Turbine', 'industrialfan', 'i', 0, 0, 1, '0', '0', '0', 4004, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1668, 'Gothic Torch', 'torch', 'i', 0, 0, 1, '0', '0', '0', 4005, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1669, 'Heart Light', 'val_heart', 'i', 0, 0, 1, '0', '0', '0', 4006, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1670, 'Mirror', 'wallmirror', 'i', 0, 0, 1, '0', '0', '0', 4007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1671, 'Ninja Stars', 'jp_ninjastars', 'i', 0, 0, 1, '0', '0', '0', 4008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1672, 'Habbowood Mirror', 'habw_mirror', 'i', 0, 0, 1, '0', '0', '0', 4009, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1673, 'So you gotta ask yourself', 'habbowheel', 'i', 0, 0, 1, '0', '0', '0', 4010, '1', '1', '1', '1', '1', 'habbowheel', 1, '0', ''),
(1674, 'Skull Guitar', 'guitar_skull', 'i', 0, 0, 1, '0', '0', '0', 4011, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1675, 'V Guitar', 'guitar_v', 'i', 0, 0, 1, '0', '0', '0', 4012, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1676, 'Christmas Lights', 'xmas_light', 'i', 0, 0, 1, '0', '0', '0', 4015, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1677, 'Anchor', 'hrella_poster_3', 'i', 0, 0, 1, '0', '0', '0', 4016, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1678, 'Life Buoy', 'hrella_poster_2', 'i', 0, 0, 1, '0', '0', '0', 4013, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1679, 'Porthole', 'hrella_poster_1', 'i', 0, 0, 1, '0', '0', '0', 4014, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1680, 'Swords', 'sw_swords', 'i', 0, 0, 1, '0', '0', '0', 4017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1681, 'Mysterious Necklace', 'sw_stone', 'i', 0, 0, 1, '0', '0', '0', 4018, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1682, 'Ventilation Duct', 'sw_hole', 'i', 0, 0, 1, '0', '0', '0', 4019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1683, 'Mood Light', 'roomdimmer', 'i', 0, 0, 1, '0', '0', '0', 4027, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1684, 'Bubble Juice Can', 'md_logo_wall', 'i', 0, 0, 1, '0', '0', '0', 4023, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1685, 'Kakejiku Hokusai', 'jp_sheet3', 'i', 0, 0, 1, '0', '0', '0', 4021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1686, 'Kakejiku Ninjya', 'jp_sheet2', 'i', 0, 0, 1, '0', '0', '0', 4026, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1687, 'Kakejiku Ziritsu', 'jp_sheet1', 'i', 0, 0, 1, '0', '0', '0', 4024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1688, 'Ancestral Scimitars', 'arabian_swords', 'i', 0, 0, 1, '0', '0', '0', 4020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1689, 'Arabian Window Frame', 'arabian_wndw', 'i', 0, 0, 1, '0', '0', '0', 4022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1690, 'Jungle Wallplant', 'tiki_wallplnt', 'i', 0, 0, 1, '0', '0', '0', 4030, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(1691, 'Surfboard', 'tiki_surfboard', 'i', 0, 0, 1, '0', '0', '0', 4028, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(1692, 'tampax_wall', 'tampax_wall', 'i', 0, 0, 1, '0', '0', '0', 4029, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1693, 'Single Window', 'window_single_default', 'i', 0, 0, 1, '0', '0', '0', 4031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1694, 'Double Window', 'window_double_default', 'i', 0, 0, 1, '0', '0', '0', 4032, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1695, 'Window', 'noob_window_double', 'i', 0, 0, 1, '0', '0', '0', 4033, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1696, 'Bay Window', 'window_triple', 'i', 0, 0, 1, '0', '0', '0', 4045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1697, 'Glass Square Window', 'window_square', 'i', 0, 0, 1, '0', '0', '0', 4036, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1698, 'Large Romantic Window', 'window_romantic_wide', 'i', 0, 0, 1, '0', '0', '0', 4041, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1699, 'Small Romantic Window', 'window_romantic_narrow', 'i', 0, 0, 1, '0', '0', '0', 4037, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1700, 'Grunge Window', 'window_grunge', 'i', 0, 0, 1, '0', '0', '0', 4044, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1701, 'Golden Window', 'window_golden', 'i', 0, 0, 1, '0', '0', '0', 4035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1702, 'Large Oriental Window', 'window_chinese_wide', 'i', 0, 0, 1, '0', '0', '0', 4034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1703, 'Small Oriental Window', 'window_chinese_narrow', 'i', 0, 0, 1, '0', '0', '0', 4038, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1704, 'Basic Window', 'window_basic', 'i', 0, 0, 1, '0', '0', '0', 4042, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1705, 'Large 70s Window', 'window_70s_wide', 'i', 0, 0, 1, '0', '0', '0', 4039, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1706, 'Small 70s Window', 'window_70s_narrow', 'i', 0, 0, 1, '0', '0', '0', 4040, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1707, 'Sunny Delight', 'ads_sunnyd', 'i', 0, 0, 1, '0', '0', '0', 4043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1708, 'Good grub', 'window_diner2', 'i', 0, 0, 1, '0', '0', '0', 4046, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1709, 'Large Diner Window', 'window_diner', 'i', 0, 0, 1, '0', '0', '0', 4049, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1710, 'Diner Side Table', 'diner_walltable', 'i', 0, 0, 1, '0', '0', '0', 4048, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1711, 'ads_dave_wall', 'ads_dave_wall', 'i', 0, 0, 1, '0', '0', '0', 4047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1712, 'Window', 'window_hole', 'i', 0, 0, 1, '0', '0', '0', 4052, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1713, 'easy_poster', 'easy_poster', 'i', 0, 0, 1, '0', '0', '0', 4051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1714, 'ads_nokia_logo name', 'ads_nokia_logo', 'i', 0, 0, 1, '0', '0', '0', 4050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1715, 'ads_nokia_phone name', 'ads_nokia_phone', 'i', 0, 0, 1, '0', '0', '0', 4053, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1717, 'Skyscraper Window', 'window_skyscraper', 'i', 0, 0, 1, '0', '0', '0', 4054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1718, 'netari_poster', 'netari_poster', 'i', 0, 0, 1, '0', '0', '0', 4057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1719, 'Bullet Hole', 'det_bhole', 'i', 0, 0, 1, '0', '0', '0', 4056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1720, 'Red V Guitar', 'ads_campguitar', 'i', 0, 0, 1, '0', '0', '0', 4058, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1721, 'Nuclear Radiation Sign', 'hween08_rad', 'i', 0, 0, 1, '0', '0', '0', 4059, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1722, 'Broken Window (small)', 'hween08_wndwb', 'i', 0, 0, 1, '0', '0', '0', 4061, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1723, 'Broken Window (large)', 'hween08_wndw', 'i', 0, 0, 1, '0', '0', '0', 4062, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1724, 'Biohazard Sign', 'hween08_bio', 'i', 0, 0, 1, '0', '0', '0', 4063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1725, 'X-Ray Light Box', 'hw_08_xray', 'i', 0, 0, 1, '0', '0', '0', 4060, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1726, 'Red Gothic Fountain', 'gothicfountain2', 'i', 0, 0, 1, '0', '0', '0', 4065, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20052, 'Volturi Crest', 'ads_twi_crest', 'i', 0, 0, 1, '1', '0', '0', 4275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1728, 'TBD Central Musical TV', 'ads_cmusic', 'i', 0, 0, 1, '0', '0', '0', 4067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1729, 'Stand up or sitting down', 'party_wc_boy', 'i', 0, 0, 1, '0', '0', '0', 4070, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1730, 'Big Wall Lights', 'party_led', 'i', 0, 0, 1, '0', '0', '0', 4066, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1731, 'Neon Heart Light', 'party_neon5', 'i', 0, 0, 1, '0', '0', '0', 4074, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1732, 'Neon Right Arrows', 'party_neon1', 'i', 0, 0, 1, '0', '0', '0', 4069, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1733, 'Neon Left Arrows', 'party_neon2', 'i', 0, 0, 1, '0', '0', '0', 4073, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1734, 'Girls Toilets', 'party_wc_girl', 'i', 0, 0, 1, '0', '0', '0', 4068, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1735, 'Neon Pink Flamingo', 'party_neon3', 'i', 0, 0, 1, '0', '0', '0', 4075, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1736, 'Bar Shelf', 'party_shelf', 'i', 0, 0, 1, '0', '0', '0', 4071, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1737, 'Neon Skull Light', 'party_neon4', 'i', 0, 0, 1, '0', '0', '0', 4072, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1738, 'Snowy Posters', 'xmas08_wallpaper', 'i', 0, 0, 1, '0', '0', '0', 4077, '0', '0', '1', '1', '1', 'roomeffect', 1, '0', ''),
(1739, 'Icy Wall', 'xmas08_icewall', 'i', 0, 0, 1, '0', '0', '0', 4076, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1741, 'Idea Agency Plasma 1', 'ads_clwall1', 'i', 0, 0, 1, '0', '0', '0', 4082, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1742, 'Idea Agency Plasma 2', 'ads_clwall2', 'i', 0, 0, 1, '0', '0', '0', 4078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1743, 'Idea Agency Plasma 3', 'ads_clwall3', 'i', 0, 0, 1, '0', '0', '0', 4079, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1744, 'ads_ob_wall', 'ads_ob_wall', 'i', 0, 0, 1, '0', '0', '0', 4081, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1745, 'Mall Window', 'ads_mall_window', 'i', 0, 0, 1, '0', '0', '0', 4083, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1746, 'Dragon Poster', 'china_pstr2', 'i', 0, 0, 1, '0', '0', '0', 4085, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1747, 'Chinese Wall Lamp', 'china_light', 'i', 0, 0, 1, '0', '0', '0', 4086, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1748, 'Ox Poster', 'china_pstr1', 'i', 0, 0, 1, '0', '0', '0', 4084, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1749, 'Bolly Window', 'bolly_wdw_wd', 'i', 0, 0, 1, '0', '0', '0', 4087, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1750, 'Monster Plan Poster', 'ads_igor_wall', 'i', 0, 0, 1, '0', '0', '0', 4090, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1751, 'Evil Bone', 'ads_igorevilb', 'i', 0, 0, 1, '0', '0', '0', 4089, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1752, 'ads_idol_wall name', 'ads_idol_wall', 'i', 0, 0, 1, '0', '0', '0', 4088, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1753, 'Mall Furni Showroom', 'ads_mall_winfur', 'i', 0, 0, 1, '0', '0', '0', 4092, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1754, 'Mall Pet Shop Window', 'ads_mall_winpet', 'i', 0, 0, 1, '0', '0', '0', 4091, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1755, 'Rock Wall', 'lc_wall1', 'i', 0, 0, 1, '0', '0', '0', 4095, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1756, 'Aquarium Window', 'lc_window2', 'i', 0, 0, 1, '0', '0', '0', 4096, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1757, 'Wooden Window', 'lc_window1', 'i', 0, 0, 1, '0', '0', '0', 4094, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1758, 'American Idol TV', 'ads_idol_tv', 'i', 0, 0, 1, '0', '0', '0', 4093, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1759, 'Coral Wall', 'lc_wall2', 'i', 0, 0, 1, '0', '0', '0', 4097, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1760, 'ads_idol_mirror name', 'ads_idol_mirror', 'i', 0, 0, 1, '0', '0', '0', 4099, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1761, 'Mall Cinema Window', 'ads_mall_wincin', 'i', 0, 0, 1, '0', '0', '0', 4098, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1762, 'Strum', 'ads_mall_winmus', 'i', 0, 0, 1, '0', '0', '0', 4101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1763, 'Mall Beauty Salon', 'ads_mall_winbea', 'i', 0, 0, 1, '0', '0', '0', 4100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1764, 'Eco Curtain 1', 'eco_curtains1', 'i', 0, 0, 1, '0', '0', '0', 4105, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1765, 'Mall Idea Agency Window', 'ads_mall_winchi', 'i', 0, 0, 1, '0', '0', '0', 4103, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1766, 'Eco Curtain 3', 'eco_curtains3', 'i', 0, 0, 1, '0', '0', '0', 4104, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1767, 'Eco Curtain 2', 'eco_curtains2', 'i', 0, 0, 1, '0', '0', '0', 4102, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1768, 'Mall Ice Cream Parlour Window', 'ads_mall_winice', 'i', 0, 0, 1, '0', '0', '0', 4109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1769, 'Whatever your sporting dibble', 'ads_mall_winspo', 'i', 0, 0, 1, '0', '0', '0', 4106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1770, 'ads_idol_logo name', 'ads_idol_logo', 'i', 0, 0, 1, '0', '0', '0', 4108, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1771, 'World Map', 'exe_map', 'i', 0, 0, 1, '0', '0', '0', 4110, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1772, 'Wall Fall', 'exe_wfall', 'i', 0, 0, 1, '0', '0', '0', 4107, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1773, 'ads_lin_wh_c name', 'ads_lin_wh_c', 'i', 0, 0, 1, '0', '0', '0', 4115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1774, 'ads_malaco_tv name', 'ads_malaco_tv', 'i', 0, 0, 1, '0', '0', '0', 4113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1775, 'ads_puffet_tv name', 'ads_puffet_tv', 'i', 0, 0, 1, '0', '0', '0', 4111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1776, 'ads_reebok_tv name', 'ads_reebok_tv', 'i', 0, 0, 1, '0', '0', '0', 4112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1777, 'Forest Wall Poster', 'country_forestwall', 'i', 0, 0, 1, '0', '0', '0', 4114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1778, 'Marble Fireplace', 'country_fp', 'i', 0, 0, 1, '0', '0', '0', 4117, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1779, 'Farmhouse Wall', 'country_wall', 'i', 0, 0, 1, '0', '0', '0', 4118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1780, 'Ye Olde Lantern', 'country_lantern', 'i', 0, 0, 1, '0', '0', '0', 4116, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1781, 'Norwegian Flag', 'flag_norway', 'i', 0, 0, 1, '0', '0', '0', 4119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1782, 'Diner Poster', 'diner_poster', 'i', 0, 0, 1, '0', '0', '0', 4120, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1783, '', 'lt_jngl_wall', 'i', 0, 0, 1, '0', '0', '0', 4121, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1784, 'ads_mirror name', 'ads_mirror', 'i', 0, 0, 1, '0', '0', '0', 4122, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1785, 'lt_wall', 'lt_wall', 'i', 0, 0, 1, '0', '0', '0', 4123, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1787, 'Starship Window', 'sf_window', 'i', 0, 0, 1, '0', '0', '0', 4224, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1788, 'Starship Wall', 'sf_wall2', 'i', 0, 0, 1, '0', '0', '0', 4228, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1789, 'ads_wwe_poster name', 'ads_wwe_poster', 'i', 0, 0, 1, '0', '0', '0', 4226, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1790, 'Fly me to the moon', 'ads_mall_wintra', 'i', 0, 0, 1, '0', '0', '0', 4225, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1791, 'Starship Corner', 'sf_wall3', 'i', 0, 0, 1, '0', '0', '0', 4223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1793, 'ads_veet name', 'ads_veet', 'i', 0, 0, 1, '0', '0', '0', 4222, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1794, 'Wall Tiles', 'rela_wall', 'i', 0, 0, 1, '0', '0', '0', 4232, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(1795, 'flag_belgium', 'flag_belgium', 'i', 0, 0, 1, '0', '0', '0', 4229, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1796, 'Porko Flag', 'Porko Flag', 'i', 0, 0, 1, '0', '0', '0', 4249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1797, 'ads_mall_wingar', 'ads_mall_wingar', 'i', 0, 0, 1, '0', '0', '0', 4230, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1798, 'ktchn_wall name', 'ktchn_wall', 'i', 0, 0, 1, '0', '0', '0', 4235, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1799, 'ads_mall_winclo', 'ads_mall_winclo', 'i', 0, 0, 1, '0', '0', '0', 4236, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1800, 'ktchn_oven name', 'ktchn_oven', 'i', 0, 0, 1, '0', '0', '0', 4234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1801, 'ktchn_knives name', 'ktchn_knives', 'i', 0, 0, 1, '0', '0', '0', 4233, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1802, 'Mood Controller (Large)', 'dimmer_fuse6', 'i', 0, 0, 1, '0', '0', '0', 4240, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1803, 'Mood Switch (Large)', 'dimmer_swtch', 'i', 0, 0, 1, '0', '0', '0', 4237, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1804, 'Mood Controller (Small)', 'dimmer_fuse2', 'i', 0, 0, 1, '0', '0', '0', 4239, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1805, 'Mood Switch (Small)', 'dimmer_buttn', 'i', 0, 0, 1, '0', '0', '0', 4238, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(19877, '', 'avatar_effect9', 'e', 1, 1, 1, '0', '0', '0', 9, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19878, '', 'avatar_effect6', 'e', 1, 1, 1, '0', '0', '0', 6, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19879, '', 'avatar_effect16', 'e', 1, 1, 1, '0', '0', '0', 16, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19880, '', 'avatar_effect2', 'e', 1, 1, 1, '0', '0', '0', 2, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19881, '', 'avatar_effect14', 'e', 1, 1, 1, '0', '0', '0', 14, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19882, '', 'avatar_effect15', 'e', 1, 1, 1, '0', '0', '0', 15, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19883, '', 'avatar_effect3', 'e', 1, 1, 1, '0', '0', '0', 3, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19884, '', 'avatar_effect17', 'e', 1, 1, 1, '0', '0', '0', 17, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19885, '', 'avatar_effect18', 'e', 1, 1, 1, '0', '0', '0', 18, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19886, '', 'avatar_effect1', 'e', 1, 1, 1, '0', '0', '0', 1, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19887, '', 'avatar_effect4', 'e', 1, 1, 1, '0', '0', '0', 4, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19888, '', 'avatar_effect5', 'e', 1, 1, 1, '0', '0', '0', 5, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19889, '', 'avatar_effect7', 'e', 1, 1, 1, '0', '0', '0', 7, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19890, '', 'avatar_effect8', 'e', 1, 1, 1, '0', '0', '0', 8, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19891, '', 'avatar_effect10', 'e', 1, 1, 1, '0', '0', '0', 10, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19892, '', 'avatar_effect12', 'e', 1, 1, 1, '0', '0', '0', 12, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19893, '', 'avatar_effect13', 'e', 1, 1, 1, '0', '0', '0', 13, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19894, '', 'a2 l', 'i', 1, 1, 1, '0', '0', '0', 3002, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19895, '', 'a2 t', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19896, '', 'wallpaper 1', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19926, '', 'landscape 1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19938, '', 'hween09_floor', 's', 2, 2, 0, '1', '0', '1', 3288, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(19939, '', 'hween09_jar', 's', 1, 1, 1, '0', '0', '0', 3287, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19940, 'City Bench (Clean)', 'urban_bench_plain', 's', 2, 1, 1, '0', '1', '0', 3284, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19941, '', 'hween09_organ', 's', 2, 1, 1, '0', '0', '0', 3282, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19942, '', 'byesw_hand', 's', 1, 1, 1.35, '0', '0', '0', 3291, '0', '1', '1', '1', '1', '', 1, '0', ''),
(19943, '', 'byesw_hotel', 's', 1, 1, 1, '0', '0', '0', 3289, '0', '1', '1', '1', '1', 'default', 6, '0', ''),
(19944, '', 'hween09_table', 's', 1, 3, 1, '0', '0', '0', 3286, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19945, '', 'hween09_chair', 's', 1, 1, 1, '0', '1', '0', 3295, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(19946, '', 'hween09_mirror', 's', 1, 1, 1, '0', '1', '0', 3293, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19947, 'Trap Door', 'hween09_hatch', 's', 2, 2, 0.001, '0', '0', '1', 3285, '0', '0', '1', '1', '1', 'gate', 2, '0', ''),
(19948, '', 'hween09_ghost', 's', 1, 1, 1, '0', '0', '0', 3290, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19949, '', 'hween09_tv', 's', 2, 1, 1, '0', '0', '0', 3292, '0', '0', '1', '1', '1', 'default', 3, '0', ''),
(19950, '', 'hween09_chandelier', 's', 1, 1, 1, '0', '0', '1', 3294, '0', '0', '1', '1', '1', 'default', 3, '0', ''),
(19951, '', 'hween09_crnr1', 'i', 0, 0, 1, '0', '0', '0', 4247, '0', '0', '1', '1', '1', 'default', 4, '0', ''),
(19952, '', 'hween09_paint', 'i', 0, 0, 1, '0', '0', '0', 4263, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19953, '', 'hween09_treewall', 'i', 0, 0, 1, '0', '0', '0', 4269, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19954, '', 'hween09_wall1', 'i', 0, 0, 1, '0', '0', '0', 4257, '0', '0', '1', '1', '1', 'default', 4, '0', ''),
(19955, '', 'hween09_stonewall', 'i', 0, 0, 1, '0', '0', '0', 4259, '0', '0', '1', '1', '1', 'default', 5, '0', ''),
(19956, '', 'hween09_win', 'i', 0, 0, 1, '0', '0', '0', 4271, '0', '0', '1', '1', '1', 'default', 10, '0', ''),
(19957, '', 'avatar_effect22', 'e', 1, 1, 1, '0', '0', '0', 22, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19958, '', 'avatar_effect19', 'e', 1, 1, 1, '0', '0', '0', 19, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19959, '', 'avatar_effect20', 'e', 1, 1, 1, '0', '0', '0', 20, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19960, '', 'avatar_effect21', 'e', 1, 1, 1, '0', '0', '0', 21, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19989, 'Snowman Base', 'xm09_man_a', 's', 1, 1, 1, '1', '0', '0', 3330, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(19971, 'Snowman Middle', 'xm09_man_b', 's', 1, 1, 0.8, '1', '0', '0', 3328, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(19972, 'Snowman Head', 'xm09_man_c', 's', 1, 1, 1, '0', '0', '0', 3329, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(19973, 'Christmas Table', 'xm09_table', 's', 2, 6, 1, '1', '0', '0', 3335, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19974, '6-Seater Bench', 'xm09_bench', 's', 6, 1, 1, '0', '1', '0', 3340, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19976, 'Snowy Fir Trees', 'xm09_firwall', 'i', 0, 0, 1, '0', '0', '0', 4307, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19977, 'Snowy Forest', 'xm09_forestwall', 'i', 0, 0, 1, '0', '0', '0', 4308, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19978, 'Lodge Wall', 'xm09_lodgewall', 'i', 0, 0, 1, '1', '0', '0', 4311, '0', '1', '1', '1', '1', 'default', 8, '0', ''),
(19979, 'Gold Heart Bauble', 'xm09_bauble_25', 'i', 0, 0, 1, '1', '0', '0', 4286, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19980, 'Silver Heart Bauble', 'xm09_bauble_26', 'i', 0, 0, 1, '1', '0', '0', 4306, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19981, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1, '1', '0', '0', 4279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19982, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1, '1', '0', '0', 4279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19983, 'Blue Heart Bauble', 'xm09_bauble_23', 'i', 0, 0, 1, '1', '0', '0', 4292, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19984, 'Green Heart Bauble', 'xm09_bauble_24', 'i', 0, 0, 1, '1', '0', '0', 4278, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19985, 'Candy Cane', 'xm09_candyCane', 's', 1, 1, 1, '0', '0', '0', 3314, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(19986, 'Big Stocking', 'xm09_stocking', 'i', 0, 0, 1, '1', '0', '0', 4280, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19994, 'Fountain', 'ads_twi_fountn', 's', 2, 2, 1, '0', '0', '0', 3301, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19995, 'Clock Tower wall', 'ads_twi_dvdr2', 's', 2, 1, 1, '0', '0', '0', 3302, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19996, 'Standing Rose Bouquet', 'ads_twi_roses', 's', 1, 1, 1, '0', '0', '0', 3304, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19997, 'Cake on Table with Presents', 'ads_twi_table', 's', 2, 2, 1, '0', '0', '0', 3297, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19998, 'Volturi Royal Chair', 'ads_twi_chair', 's', 1, 1, 1, '0', '1', '0', 3300, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19999, 'Half wall', 'ads_twi_dvdr1', 's', 2, 1, 1, '0', '0', '0', 3303, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20000, 'Broken Piano', 'ads_twi_piano', 's', 2, 2, 1, '0', '0', '0', 3299, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20001, 'ads_twi_tower name', 'ads_twi_tower', 's', 1, 1, 1, '0', '0', '0', 3298, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20002, 'Toolbox', 'ads_twi_toolbx', 's', 1, 1, 1, '0', '0', '0', 3296, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20003, 'Mist', 'ads_twi_mist', 's', 1, 1, 0, '1', '0', '1', 3308, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20011, 'Water Hydrant', 'urban_wpost', 's', 1, 1, 1, '0', '0', '0', 3272, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20010, 'Pavement Slab', 'urban_sidewalk', 's', 2, 2, 0.2, '1', '0', '1', 3274, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(20008, 'City Bench (Dirty)', 'urban_bench', 's', 2, 1, 1, '0', '1', '0', 3269, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20007, 'Taxi Sofa', 'urban_carsofa', 's', 2, 1, 1, '0', '1', '0', 3268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20014, 'Concrete Block', 'urban_blocker', 's', 1, 1, 1, '0', '0', '0', 3270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20013, 'Garbage Bin', 'urban_bin', 's', 1, 1, 1, '0', '0', '0', 3266, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20012, 'Mesh Fencing', 'urban_fence', 's', 1, 2, 1, '0', '0', '0', 3267, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20015, 'Basketball Pole', 'urban_bsktbll', 's', 1, 1, 1, '0', '0', '0', 3271, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20025, 'Terracotta Pillar', 'pillar*6', 's', 1, 1, 1, '0', '0', '0', 1609, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20026, 'Urban Iced Bookcase', 'shelves_norja*4', 's', 1, 1, 1, '0', '0', '0', 1795, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20027, 'Black Mode Double Bed', 'bed_polyfon*2', 's', 2, 3, 1.8, '0', '0', '0', 1895, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20028, 'Blue Iced Angle', 'divider_nor5*6', 's', 1, 1, 1, '0', '0', '0', 1995, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20029, 'Valentine''s Cauldron', 'val_cauldron', 's', 1, 1, 1, '0', '0', '0', 2103, '1', '1', '1', '1', '1', 'vendingmachine', 0, '25', ''),
(20030, 'Aqua Pura Module 5', 'pura_mdl5*1', 's', 1, 1, 1, '0', '1', '0', 2509, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20031, 'Aqua One Way Gate', 'one_way_door*1', 's', 1, 1, 0.001, '0', '0', '0', 2597, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(20032, 'Power Globe', 'exe_globe', 's', 1, 1, 1, '0', '0', '0', 2672, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20034, 'Latte Diner Corner', 'diner_bardesk_corner*5', 's', 1, 1, 1, '1', '0', '0', 2874, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20035, 'Bubbles', 'fx_bubble', 's', 1, 1, 1, '1', '0', '0', 3012, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(20036, 'Safety Cone', 'bump_tottero', 's', 1, 1, 1, '0', '0', '0', 3087, '1', '1', '1', '0', '1', 'default', 1, '0', ''),
(20037, 'ads_calip_parasol name', 'ads_calip_parasol', 's', 1, 1, 1, '0', '0', '0', 3195, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20041, '2010 Poster', 'year2010', 'i', 0, 0, 1, '1', '0', '0', 4313, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20042, 'Party Lantern', 'party_lantern', 's', 1, 1, 0, '1', '0', '1', 3327, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20043, 'Party Lights', 'party_lights', 'i', 0, 0, 1, '0', '0', '0', 4310, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20047, 'Soothing Stick', 'rela_stick', 's', 1, 1, 1, '0', '0', '0', 3240, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20048, 'Mall Lift', 'ads_mall_elevator', 's', 1, 1, 0.001, '0', '0', '0', 3306, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(20050, 'Flatscreen TV', 'xm09_infotv', 'i', 0, 0, 1, '1', '0', '0', 4309, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20051, 'Twilight Trophy', 'ads_twi_trophy', 's', 1, 1, 1, '1', '0', '0', 3311, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(20053, 'Painting', 'ads_twi_paint', 'i', 0, 0, 1, '1', '0', '0', 4272, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20054, 'Window with Candles', 'ads_twi_windw', 'i', 0, 0, 1, '1', '0', '0', 4277, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20055, 'Truck and Motorcycles', 'ads_twi_bwall2', 'i', 0, 0, 1, '1', '0', '0', 4276, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20056, 'Dream Catcher', 'ads_twi_dreamc', 'i', 0, 0, 1, '1', '0', '0', 4273, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20057, 'Barn Wall', 'ads_twi_bwall1', 'i', 0, 0, 1, '1', '0', '0', 4274, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20059, 'Arabian Wall', 'arabian_wall', 'i', 0, 0, 1, '1', '0', '0', 4287, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20060, 'DEAL_HC_1', 'DEAL_HC_1', 'h', 0, 0, 0, '0', '0', '0', 0, '0', '0', '1', '0', '0', 'default', 0, '0', ''),
(20072, 'ads_gsArcade_1 name', 'ads_gsArcade_1', 's', 1, 1, 1, '1', '0', '0', 3277, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20063, 'Hot Choc Machine', 'xm09_cocoa', 's', 1, 1, 1, '1', '0', '0', 3337, '1', '1', '1', '1', '1', 'vendingmachine', 0, '10', ''),
(20064, 'Astro-Bar', 'sf_mbar', 's', 1, 1, 1, '1', '0', '0', 3273, '1', '1', '1', '1', '1', 'vendingmachine', 0, '44', ''),
(20074, 'Silver MTV EMA Trophy', 'ads_mtvtrophy_silver', 's', 1, 1, 1, '0', '0', '0', 3281, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20075, 'ads_spang_sleep', 'ads_spang_sleep', 's', 1, 3, 0.8, '1', '0', '0', 3280, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20076, 'Gold MTV EMA Trophy', 'ads_mtvtrophy_gold', 's', 1, 1, 1, '0', '0', '0', 3279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20077, 'ktchn_hlthNut name', 'ktchn_hlthNut', 's', 1, 1, 1, '1', '0', '0', 3307, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20078, 'Chicken', 'petfood8', 's', 1, 1, 1, '1', '0', '0', 3325, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20079, 'nest_plow_reg', 'nest_plow_reg', 's', 1, 1, 1, '1', '0', '0', 3318, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20080, 'Yellow Pet Snuggle', 'nest_snug_yel', 's', 1, 1, 1, '1', '0', '0', 3319, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20081, 'Salmon', 'petfood9', 's', 1, 1, 1, '1', '0', '0', 3322, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20082, 'Leveling Cake', 'petfood10', 's', 1, 1, 1, '1', '0', '0', 3326, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20083, 'Ice Apples', 'petfood7', 's', 1, 1, 1, '1', '0', '0', 3321, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20084, 'Red Apples', 'petfood6', 's', 1, 1, 1, '1', '0', '0', 3323, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20085, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1, '1', '0', '0', 3310, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20086, 'nest_snug_red', 'nest_snug_red', 's', 1, 1, 1, '1', '0', '0', 3317, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20087, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1, '1', '0', '0', 3310, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20088, 'nest_plow_bro', 'nest_plow_bro', 's', 1, 1, 1, '1', '0', '0', 3309, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20089, 'Red Pet Pillow', 'nest_plow_red', 's', 1, 1, 1, '1', '0', '0', 3320, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20090, 'nest_snug_blu', 'nest_snug_blu', 's', 1, 1, 1, '1', '0', '0', 3315, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20091, 'Green Apples', 'petfood5', 's', 1, 1, 1, '1', '0', '0', 3324, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20092, 'Blue Pet Pillow', 'nest_plow_blu', 's', 1, 1, 1, '1', '0', '0', 3316, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20093, 'Giant Bauble', 'xm09_lrgBauble', 's', 1, 1, 1, '1', '0', '0', 3313, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20094, 'nest_dirt', 'nest_dirt', 's', 1, 1, 1, '1', '0', '0', 3331, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20095, 'nest_snug_prp', 'nest_snug_prp', 's', 1, 1, 1, '1', '0', '0', 3332, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20096, 'nest_nest', 'nest_nest', 's', 1, 1, 1, '1', '0', '0', 3334, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20097, 'nest_nails', 'nest_nails', 's', 1, 1, 1, '1', '0', '0', 3336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20098, 'nest_basket', 'nest_basket', 's', 1, 1, 1, '1', '0', '0', 3333, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20099, 'Polar Bear Nest', 'nest_ice', 's', 1, 1, 1, '1', '0', '0', 3339, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20100, 'nest_plow_skl', 'nest_plow_skl', 's', 1, 1, 1, '1', '0', '0', 3341, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20101, 'nest_snug_bla', 'nest_snug_bla', 's', 1, 1, 1, '1', '0', '0', 3338, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20102, 'The Moodi Machine', 'ads_cl_moodi', 's', 1, 1, 1, '1', '0', '0', 3342, '1', '1', '1', '1', '1', 'vendingmachine', 1, '46,47,45', ''),
(20103, 'org_chairpnk', 'org_chairpnk', 's', 1, 1, 1.2, '0', '1', '0', 3354, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20104, 'org_tblpnk', 'org_tblpnk', 's', 1, 1, 1, '1', '0', '0', 3352, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20105, 'org_lampblk', 'org_lampblk', 's', 1, 1, 1.2, '0', '0', '0', 3353, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20106, 'org_lamppnk', 'org_lamppnk', 's', 1, 1, 1.2, '0', '0', '0', 3348, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20107, 'org_table', 'org_table', 's', 2, 2, 1, '1', '0', '0', 3356, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20108, 'china_tiger', 'china_tiger', 's', 1, 1, 1, '1', '0', '0', 3344, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20109, 'xm09_trophy name', 'xm09_trophy', 's', 1, 1, 1, '1', '0', '0', 3351, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20110, 'china_plmTree name', 'china_plmTree', 's', 1, 1, 1, '1', '0', '0', 3355, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20111, 'org_chairblk', 'org_chairblk', 's', 1, 1, 1.2, '0', '1', '0', 3349, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20112, 'org_tblblk', 'org_tblblk', 's', 1, 1, 1, '1', '0', '0', 3347, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20113, 'org_chrblk', 'org_chrblk', 's', 1, 1, 1.2, '0', '1', '0', 3345, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20114, 'china_tigrSeat name', 'china_tigrSeat', 's', 1, 2, 1, '1', '0', '0', 3346, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20115, 'org_chrpnk', 'org_chrpnk', 's', 1, 1, 1.2, '0', '1', '0', 3350, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20116, 'ads_chups name', 'ads_chups', 's', 1, 1, 1, '1', '0', '0', 3367, '1', '1', '1', '1', '1', 'vendingmachine', 1, '48', ''),
(20117, 'bling_fridge', 'bling_fridge', 's', 1, 1, 1, '0', '0', '0', 3366, '1', '1', '1', '1', '1', 'vendingmachine', 0, '50', ''),
(20118, 'petfood12 name', 'petfood12', 's', 1, 1, 1, '1', '0', '0', 3370, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20119, 'ads_droetker_paula name', 'ads_droetker_paula', 's', 1, 1, 1, '1', '0', '0', 3365, '1', '1', '1', '1', '1', 'vendingmachine', 1, '49', ''),
(20120, 'petfood11 name', 'petfood11', 's', 1, 1, 1, '1', '0', '0', 3358, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20121, 'bling_chair_a', 'bling_chair_a', 's', 1, 1, 1, '0', '1', '0', 3368, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20122, 'petfood13 name', 'petfood13', 's', 1, 1, 1, '1', '0', '0', 3359, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20123, 'bling_pool', 'bling_pool', 's', 3, 1, 0.01, '0', '1', '0', 3369, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20124, 'bling_toilet', 'bling_toilet', 's', 1, 1, 1.2, '0', '1', '0', 3362, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20125, 'val09_floor', 'val09_floor', 's', 2, 2, 0, '1', '0', '1', 3363, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20126, 'bling_chair_c', 'bling_chair_c', 's', 1, 1, 1, '0', '1', '0', 3361, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20127, 'bling_chair_b', 'bling_chair_b', 's', 1, 1, 1, '0', '1', '0', 3360, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20128, 'bling_shwr name', 'bling_shwr', 's', 1, 1, 0, '1', '0', '1', 3396, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20129, 'bling_bed name', 'bling_bed', 's', 2, 3, 1.6, '0', '1', '0', 3364, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20130, 'bling_sofa', 'bling_sofa', 's', 2, 1, 1.5, '0', '1', '0', 3371, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20131, 'val09_floor2', 'val09_floor2', 's', 2, 2, 0, '1', '0', '1', 3357, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20132, 'teddy_basic', 'teddy_basic', 's', 1, 1, 1, '1', '0', '0', 3393, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20133, 'teddy_pendergrass', 'teddy_pendergrass', 's', 1, 1, 1, '1', '0', '0', 3384, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20134, 'val_hSeat_1 name', 'val_hSeat*1', 's', 1, 1, 1, '0', '1', '0', 3386, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20135, 'val_hSeat_2 name', 'val_hSeat*2', 's', 1, 1, 1, '0', '1', '0', 3387, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20136, 'val_hSeat_3 name', 'val_hSeat*3', 's', 1, 1, 1, '0', '1', '0', 3388, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20137, 'val_hSeat_4 name', 'val_hSeat*4', 's', 1, 1, 1, '0', '1', '0', 3389, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20138, 'val_hSeat_5 name', 'val_hSeat*5', 's', 1, 1, 1, '0', '1', '0', 3390, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20139, 'val_hSeat_6 name', 'val_hSeat*6', 's', 1, 1, 1, '0', '1', '0', 3391, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20140, 'val_hSeat_7 name', 'val_hSeat*7', 's', 1, 1, 1, '0', '1', '0', 3392, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20141, 'Valentines gift basket', 'val_basket', 's', 1, 1, 1, '1', '0', '0', 3382, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20142, 'teddy_bear', 'teddy_bear', 's', 1, 1, 1, '1', '0', '0', 3385, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20143, 'teddy_pink', 'teddy_pink', 's', 1, 1, 1, '1', '0', '0', 3383, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20144, 'bling_fridge_restricted name', 'bling_fridge_restricted', 's', 1, 1, 1, '0', '0', '0', 3394, '1', '1', '1', '1', '1', 'vendingmachine', 0, '50', ''),
(20145, 'ads_percyrock name', 'ads_percyrock', 's', 2, 2, 1, '1', '0', '0', 3395, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20146, 'Bubble Juice Can', 'md_can', 'i', 0, 0, 1, '1', '0', '0', 4025, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20147, 'ads_idol_l_logo name', 'ads_idol_l_logo', 'i', 0, 0, 1, '1', '0', '0', 4243, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20148, 'Latin American Idol TV', 'ads_idol_l_tv', 'i', 0, 0, 1, '1', '0', '0', 4245, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20149, 'Big MTV', 'ads_mtv_bigtv', 'i', 0, 0, 1, '1', '0', '0', 4241, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20150, 'Small MTV', 'ads_mtv_tv', 'i', 0, 0, 1, '1', '0', '0', 4242, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20151, 'flag_singapore', 'flag_singapore', 'i', 0, 0, 1, '1', '0', '0', 4249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20152, 'Old Curtain', 'hween09_curt', 'i', 0, 0, 1, '1', '0', '0', 4266, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20153, 'flag_columbia', 'flag_columbia', 'i', 0, 0, 1, '1', '0', '0', 4258, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20154, 'flag_chile', 'flag_chile', 'i', 0, 0, 1, '1', '0', '0', 4256, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20155, 'flag_ecuador', 'flag_ecuador', 'i', 0, 0, 1, '1', '0', '0', 4268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20156, 'flag_dominicanrepublic', 'flag_dominicanrepublic', 'i', 0, 0, 1, '1', '0', '0', 4265, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20157, 'flag_newzealand', 'flag_newzealand', 'i', 0, 0, 1, '1', '0', '0', 4260, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20158, 'flag_malaysia', 'flag_malaysia', 'i', 0, 0, 1, '1', '0', '0', 4252, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20159, 'Loading Poster', 'byesw_loadscreen', 'i', 0, 0, 1, '1', '0', '0', 4267, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20160, 'flag_venezl', 'flag_venezl', 'i', 0, 0, 1, '1', '0', '0', 4254, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20161, 'flag_algeria', 'flag_algeria', 'i', 0, 0, 1, '1', '0', '0', 4270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20162, 'flag_tunisia', 'flag_tunisia', 'i', 0, 0, 1, '1', '0', '0', 4248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20163, 'flag_panama', 'flag_panama', 'i', 0, 0, 1, '1', '0', '0', 4262, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20164, 'flag_mexico', 'flag_mexico', 'i', 0, 0, 1, '1', '0', '0', 4250, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20165, 'flag_argentina', 'flag_argentina', 'i', 0, 0, 1, '1', '0', '0', 4261, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20166, 'flag_philippines', 'flag_philippines', 'i', 0, 0, 1, '1', '0', '0', 4251, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20167, 'flag_greece', 'flag_greece', 'i', 0, 0, 1, '1', '0', '0', 4253, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20168, 'flag_peru', 'flag_peru', 'i', 0, 0, 1, '1', '0', '0', 4246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20169, 'flag_morocco', 'flag_morocco', 'i', 0, 0, 1, '1', '0', '0', 4264, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20170, 'flag_turkey', 'flag_turkey', 'i', 0, 0, 1, '1', '0', '0', 4255, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20171, 'Blue Long Bauble', 'xm09_bauble_12', 'i', 0, 0, 1, '1', '0', '0', 4304, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20172, 'Purple Long Bauble', 'xm09_bauble_16', 'i', 0, 0, 1, '1', '0', '0', 4303, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20173, 'Red Long Bauble', 'xm09_bauble_17', 'i', 0, 0, 1, '1', '0', '0', 4281, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20174, 'Silver Long Bauble', 'xm09_bauble_15', 'i', 0, 0, 1, '1', '0', '0', 4301, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20175, 'Silver Round Bauble', 'xm09_bauble_10', 'i', 0, 0, 1, '1', '0', '0', 4293, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20176, 'Gold Round Bauble', 'xm09_bauble_9', 'i', 0, 0, 1, '1', '0', '0', 4294, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20177, 'Green Long Bauble', 'xm09_bauble_18', 'i', 0, 0, 1, '1', '0', '0', 4298, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20178, 'Green Long Bauble', 'xm09_bauble_13', 'i', 0, 0, 1, '1', '0', '0', 4299, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20179, 'Blue Round Bauble', 'xm09_bauble_2', 'i', 0, 0, 1, '1', '0', '0', 4297, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20180, 'Red Round Bauble', 'xm09_bauble_1', 'i', 0, 0, 1, '1', '0', '0', 4300, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20181, 'Red Heart Bauble', 'xm09_bauble_22', 'i', 0, 0, 1, '1', '0', '0', 4302, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20182, 'Green Round Bauble', 'xm09_bauble_3', 'i', 0, 0, 1, '1', '0', '0', 4285, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20183, 'Silver Long Bauble', 'xm09_bauble_21', 'i', 0, 0, 1, '1', '0', '0', 4305, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20184, 'Green Round Bauble', 'xm09_bauble_8', 'i', 0, 0, 1, '1', '0', '0', 4295, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20185, 'Gold Round Bauble', 'xm09_bauble_4', 'i', 0, 0, 1, '1', '0', '0', 4282, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20186, 'Silver Round Bauble', 'xm09_bauble_5', 'i', 0, 0, 1, '1', '0', '0', 4288, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20187, 'Red Long Bauble', 'xm09_bauble_11', 'i', 0, 0, 1, '1', '0', '0', 4289, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20188, 'Gold Long Bauble', 'xm09_bauble_20', 'i', 0, 0, 1, '1', '0', '0', 4296, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20190, 'val_table1 name', 'val_table1', 's', 1, 1, 1, '0', '0', '0', 3397, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20191, 'Gold Long Bauble', 'xm09_bauble_14', 'i', 0, 0, 1, '1', '0', '0', 4290, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20192, 'Blue Round Bauble', 'xm09_bauble_7', 'i', 0, 0, 1, '1', '0', '0', 4291, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20193, 'Red Round Bauble', 'xm09_bauble_6', 'i', 0, 0, 1, '1', '0', '0', 4284, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20194, 'Blue Long Bauble', 'xm09_bauble_19', 'i', 0, 0, 1, '1', '0', '0', 4283, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20195, 'china_pstr3 name', 'china_pstr3', 'i', 0, 0, 1, '1', '0', '0', 4314, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20196, 'ads_tv_jaapuisto name', 'ads_tv_jaapuisto', 'i', 0, 0, 1, '1', '0', '0', 4315, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20197, 'Empire State Building Clock', 'ads_percyw', 'i', 0, 0, 1, '1', '0', '0', 4322, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20198, 'val09_wdrobe_b', 'val09_wdrobe_b', 'i', 0, 0, 1, '1', '0', '0', 4320, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20199, 'val09_wall2', 'val09_wall2', 'i', 0, 0, 1, '1', '0', '0', 4316, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20200, 'bling_sink', 'bling_sink', 'i', 0, 0, 1, '1', '0', '0', 4319, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20201, 'val09_wall1', 'val09_wall1', 'i', 0, 0, 1, '1', '0', '0', 4318, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20202, 'bling_cabinet', 'bling_cabinet', 'i', 0, 0, 1, '1', '0', '0', 4321, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20204, 'val09_wdrobe_g', 'val09_wdrobe_g', 'i', 0, 0, 1, '1', '0', '0', 4317, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20207, 'rare_ironmaiden name', 'rare_ironmaiden', 's', 1, 1, 0.001, '0', '0', '0', 3399, '1', '1', '0', '1', '1', 'teleport', 2, '0', ''),
(20208, 'rare_trex name', 'rare_trex', 's', 3, 7, 1, '0', '0', '0', 3398, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20209, 'beanstalk', 'beanstalk', 's', 1, 1, 1, '1', '0', '0', 3401, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20210, 'Rare Voodoo Doll', 'rare_vdoll', 's', 1, 1, 1, '0', '0', '0', 3403, '1', '1', '1', '1', '1', '', 10, '0', ''),
(20211, 'rare_mmmth name', 'rare_mmmth', 's', 2, 1, 1, '0', '1', '0', 3402, '1', '1', '1', '1', '1', '', 0, '0', ''),
(20212, 'crystal_patch', 'crystal_patch', 's', 3, 3, 0, '0', '0', '1', 3400, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20213, 'ads_boost_surfb name', 'ads_boost_surfb', 'i', 0, 0, 1, '1', '0', '0', 4323, '1', '1', '1', '1', '1', '', 0, '0', ''),
(20214, 'ads_tlc_wheel name', 'ads_tlc_wheel', 'i', 0, 0, 1, '1', '0', '0', 4324, '1', '1', '1', '1', '1', 'habbowheel', 1, '0', ''),
(20319, 'a0 pet5', 'a0 pet5', 's', 1, 1, 0, '0', '0', '0', 2442, '1', '0', '0', '0', '0', 'pet5', 1, '0', ''),
(20221, 'White moon lupine', 'garden_lupin4', 's', 1, 1, 0.000000001, '0', '0', '0', 3419, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20222, 'Gold rush', 'garden_mursu3', 's', 1, 1, 1, '0', '0', '0', 3408, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20223, 'Purple Lupine', 'garden_lupin5', 's', 1, 1, 1, '0', '0', '0', 3411, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20224, 'Violet Blossom', 'garden_seed', 's', 1, 1, 1, '0', '0', '0', 3406, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20225, 'Snapping teleporter', 'garden_flytrap', 's', 1, 1, 0.001, '0', '0', '0', 3420, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(20226, 'Pink pandemic', 'garden_flo3', 's', 1, 1, 0.000000000000001, '1', '0', '1', 3426, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20227, 'Belching pod', 'garden_volcano', 's', 2, 2, 1, '0', '0', '0', 3424, '1', '1', '1', '1', '1', 'alert', 2, '0', ''),
(20228, 'Wonder lamp', 'garden_flolamp', 's', 1, 1, 1, '0', '0', '0', 3415, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20229, 'Red rush', 'garden_mursu2', 's', 1, 1, 1, '0', '0', '0', 3412, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20230, 'Star flower', 'garden_jyrki', 's', 1, 1, 1, '0', '0', '0', 3405, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(20231, 'White rush', 'garden_mursu4', 's', 1, 1, 1, '0', '0', '0', 3414, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20232, 'Garden leaves', 'garden_leaves', 's', 1, 1, 1, '0', '0', '0', 3425, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20233, 'Sky blue lupine', 'garden_lupin2', 's', 1, 1, 1, '0', '0', '0', 3416, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20234, 'Red lupine', 'garden_lupin3', 's', 1, 1, 1, '0', '0', '0', 3407, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20235, 'Pink rush', 'garden_mursu', 's', 1, 1, 1, '0', '0', '0', 3404, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20238, 'Bauhinia orchid tree', 'garden_orchtree', 's', 1, 1, 1, '0', '0', '0', 3413, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20237, 'Yellow happiness', 'garden_flo2', 's', 1, 1, 0, '1', '0', '1', 3409, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20239, 'Orange lupine', 'garden_lupin1', 's', 1, 1, 1, '0', '0', '0', 3421, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20240, 'Weird staring bush', 'garden_staringbush', 's', 1, 3, 1, '0', '0', '0', 3417, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20241, 'ads_grefusa_yum name', 'ads_grefusa_yum', 's', 1, 1, 1, '1', '0', '0', 3423, '1', '1', '1', '1', '1', 'vendingmachine', 1, '51, 52', ''),
(20242, 'Blue passion', 'garden_flo1', 's', 1, 1, 0.00000001, '1', '0', '1', 3418, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20243, 'Duck grass', 'garden_jungle', 's', 1, 1, 1, '1', '0', '0', 3422, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20244, 'merger_chest name', 'merger_chest', 's', 2, 1, 1, '0', '0', '0', 3455, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20245, 'Suave Fireplace', 'hc2_frplc', 's', 1, 2, 1, '0', '0', '0', 3458, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20246, 'Leather Bar Stool', 'hc2_barchair', 's', 1, 1, 1.7, '0', '1', '0', 3439, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20247, 'runway_display name', 'runway_display', 's', 1, 1, 1, '0', '0', '0', 3457, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20248, 'runway_bigchr_5 name', 'runway_bigchr_5', 's', 1, 1, 0.8, '1', '0', '0', 3463, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20249, 'runway_bigchr_4 name', 'runway_bigchr_4', 's', 1, 1, 0.8, '1', '0', '0', 3435, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20250, 'VIP Duvan', 'hc3_dc', 's', 1, 3, 1, '0', '0', '0', 3461, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20252, 'Glass Table', 'hc2_sofatbl', 's', 2, 2, 0.5, '1', '0', '0', 3434, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20253, 'runway_stool name', 'runway_stool', 's', 1, 1, 1.2, '0', '1', '0', 3442, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20254, 'runway_dvdr name', 'runway_dvdr', 's', 2, 1, 1, '0', '0', '0', 3456, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20255, 'runway_block_2 name', 'runway_block_2', 's', 2, 2, 0.8, '1', '0', '1', 3443, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20256, 'runway_bigchr_1 name', 'runway_bigchr_1', 's', 1, 1, 0.8, '0', '1', '0', 3462, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20257, 'Black Lamp', 'hc2_biglamp', 's', 1, 1, 1, '0', '0', '0', 3446, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20258, 'Leather Sofa', 'hc2_sofa', 's', 2, 1, 1, '0', '1', '0', 3452, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20259, 'Trendy Rug', 'hc2_carpet', 's', 3, 5, 0, '1', '0', '1', 3440, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20260, 'runway_block_1 name', 'runway_block_1', 's', 2, 2, 0.8, '1', '0', '1', 3433, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20261, 'runway_bench name', 'runway_bench', 's', 2, 1, 1.4, '0', '1', '0', 3464, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20262, 'runway_chair_2 name', 'runway_chair_2', 's', 1, 1, 1.4, '0', '1', '0', 3429, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20263, 'ads_cheetos name', 'ads_cheetos', 's', 1, 1, 1, '0', '0', '0', 3453, '1', '1', '1', '1', '1', 'vendingmachine', 1, '51, 52', ''),
(20264, 'VIP Coffee Table', 'hc3_table', 's', 2, 2, 0.5, '1', '0', '0', 3466, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20265, 'runway_bigchr_3 name', 'runway_bigchr_3', 's', 1, 1, 0.8, '1', '0', '0', 3454, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20266, 'VIP Stool', 'hc3_stool', 's', 1, 1, 1.7, '0', '1', '0', 3448, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20267, 'VIP Sofa', 'hc3_sofa', 's', 2, 1, 1, '0', '1', '0', 3441, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20268, 'runway_bigchr_2 name', 'runway_bigchr_2', 's', 1, 1, 0.8, '1', '0', '0', 3427, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20269, 'Leather Armchair', 'hc2_armchair', 's', 1, 1, 1, '1', '1', '0', 3436, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20270, 'runway_table_2 name', 'runway_table_2', 's', 2, 1, 1, '0', '0', '0', 3444, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20271, 'runway_table_1 name', 'runway_table_1', 's', 3, 2, 1, '1', '0', '0', 3460, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20272, 'runway_manqn_1 name', 'runway_manqn_1', 's', 1, 1, 1, '0', '0', '0', 3437, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20273, 'Leather Duvan', 'hc2_dvn', 's', 1, 3, 1, '0', '0', '0', 3459, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20274, 'VIP Light', 'hc3_light', 's', 2, 1, 0, '1', '0', '1', 3465, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20275, 'VIP Shelves', 'hc3_shelf', 's', 3, 1, 1.75, '1', '0', '0', 3438, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20276, 'runway_head name', 'runway_head', 's', 1, 1, 1, '1', '0', '0', 3432, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(20277, 'runway_manqn_2 name', 'runway_manqn_2', 's', 1, 1, 1, '0', '0', '0', 3467, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20278, 'Black Divider', 'hc2_divider', 's', 1, 3, 1, '0', '0', '0', 3449, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20279, 'Espresso Machine', 'hc2_coffee', 's', 1, 1, 1, '0', '0', '0', 3450, '1', '1', '1', '1', '1', 'vendingmachine', 0, '9,8,14,15,6,10,11,12,17,13', ''),
(20280, 'Service Trolley', 'hc2_cart', 's', 1, 1, 1, '0', '0', '0', 3430, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20281, 'VIP Bar Desk', 'hc3_bard', 's', 2, 1, 1.05, '1', '0', '0', 3445, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20282, 'VIP Lamp', 'hc3_hugelamp', 's', 1, 1, 0, '1', '0', '1', 3447, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20283, 'VIP Divider', 'hc3_divider', 's', 1, 3, 1, '0', '0', '0', 3431, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20284, 'Black Vase', 'hc2_vase', 's', 1, 1, 1, '0', '0', '0', 3428, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20285, 'runway_chair_1 name', 'runway_chair_1', 's', 1, 1, 1.4, '0', '1', '0', 3451, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20286, 'Green been vines', 'garden_wall', 'i', 0, 0, 1, '1', '0', '0', 4325, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20287, 'ads_tv_yle name', 'ads_tv_yle', 'i', 0, 0, 1, '1', '0', '0', 4326, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20288, 'VIP Wall Art', 'hc3_walldeco', 'i', 0, 0, 1, '1', '0', '0', 4329, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20289, 'runway_shelf name', 'runway_shelf', 'i', 0, 0, 1, '1', '0', '0', 4327, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(20290, 'ads_nokia_x6 name', 'ads_nokia_x6', 'i', 0, 0, 1, '1', '0', '0', 4330, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20291, 'ads_target_wall name', 'ads_target_wall', 'i', 0, 0, 1, '1', '0', '0', 4332, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20292, 'runway_fabric name', 'runway_fabric', 'i', 0, 0, 1, '1', '0', '0', 4331, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(20293, 'ads_latrobe_flag name', 'ads_latrobe_flag', 'i', 0, 0, 1, '1', '0', '0', 4328, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20295, 'Camera', 'camera', 's', 1, 1, 1, '0', '0', '0', 263, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20296, 'Holly', 'holly', 'i', 0, 0, 0, '1', '0', '0', 4001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(852, 'Electronic 1', 'sound_set_3', 's', 1, 1, 0.2, '1', '0', '0', 2164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(853, 'Ambient 1', 'sound_set_4', 's', 1, 1, 0.2, '1', '0', '0', 2165, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(854, 'Ambient 4', 'sound_set_5', 's', 1, 1, 0.2, '1', '0', '0', 2166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(855, 'Ambient 3', 'sound_set_6', 's', 1, 1, 0.2, '1', '0', '0', 2167, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(856, 'SFX 5', 'sound_set_7', 's', 1, 1, 0.2, '1', '0', '0', 2168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(857, 'Ambient 2', 'sound_set_8', 's', 1, 1, 0.2, '1', '0', '0', 2169, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(858, 'Electronic 2', 'sound_set_9', 's', 1, 1, 0.2, '1', '0', '0', 2170, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(859, 'Traxmachine', 'sound_machine*1', 's', 1, 1, 1, '0', '0', '0', 2171, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(860, 'Habbowood Spotlight', 'spotlight', 's', 1, 1, 1, '0', '0', '0', 2519, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(861, 'Ocean Traxmachine', 'sound_machine*2', 's', 1, 1, 1, '0', '0', '0', 2543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(862, 'Green Traxmachine', 'sound_machine*3', 's', 1, 1, 1, '0', '0', '0', 2544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(863, 'For Funky', 'sound_machine*4', 's', 1, 1, 1, '0', '0', '0', 2545, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(864, 'Brown Traxmachine', 'sound_machine*5', 's', 1, 1, 1, '0', '0', '0', 2546, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(865, 'Purple Traxmachine', 'sound_machine*6', 's', 1, 1, 1, '0', '0', '0', 2547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(866, 'Red Traxmachine', 'sound_machine*7', 's', 1, 1, 1, '0', '0', '0', 2548, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(867, 'Crystal Lamp', 'rom_lamp', 's', 1, 1, 1, '0', '0', '0', 2551, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(868, 'Polar Sofa', 'rclr_sofa', 's', 2, 1, 1, '0', '1', '0', 2459, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(869, 'Water Garden', 'rclr_garden', 's', 1, 3, 1, '0', '0', '0', 2458, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(870, 'Palm Chair', 'rclr_chair', 's', 1, 1, 1, '0', '1', '0', 2562, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(871, 'Rock 2', 'sound_set_28', 's', 1, 1, 0.2, '1', '0', '0', 2496, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(872, 'Groove 2', 'sound_set_27', 's', 1, 1, 0.2, '1', '0', '0', 2549, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(873, 'Groove 1', 'sound_set_26', 's', 1, 1, 0.2, '1', '0', '0', 2508, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(874, 'Actually', 'sound_set_25', 's', 1, 1, 0.2, '1', '0', '0', 2470, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(875, 'It''s all about the Pentiums', 'sound_set_24', 's', 1, 1, 0.2, '1', '0', '0', 2492, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(876, 'SFX 4', 'sound_set_23', 's', 1, 1, 0.2, '1', '0', '0', 2457, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(877, 'With a hamper full of sounds', 'sound_set_22', 's', 1, 1, 0.2, '1', '0', '0', 2521, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(878, 'Rock 1', 'sound_set_21', 's', 1, 1, 0.2, '1', '0', '0', 2494, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(879, 'SFX 2', 'sound_set_20', 's', 1, 1, 0.2, '1', '0', '0', 2524, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(880, 'Hip Hop Beats 4', 'sound_set_19', 's', 1, 1, 0.2, '1', '0', '0', 2469, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(881, 'Groove 4', 'sound_set_18', 's', 1, 1, 0.2, '1', '0', '0', 2497, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(882, 'Groove 3', 'sound_set_17', 's', 1, 1, 0.2, '1', '0', '0', 2550, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(883, 'Ferry', 'sound_set_16', 's', 1, 1, 0.2, '1', '0', '0', 2561, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(884, 'RnB Grooves 6', 'sound_set_15', 's', 1, 1, 0.2, '1', '0', '0', 2495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(885, 'Hip Hop Beats 2', 'sound_set_14', 's', 1, 1, 0.2, '1', '0', '0', 2482, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(886, 'Dance 5', 'sound_set_13', 's', 1, 1, 0.2, '1', '0', '0', 2523, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(887, 'Habbo Sounds 2', 'sound_set_12', 's', 1, 1, 0.2, '1', '0', '0', 2493, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(888, 'Dance 4', 'sound_set_11', 's', 1, 1, 0.2, '1', '0', '0', 2563, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(889, 'Hip Hop Beats 1', 'sound_set_10', 's', 1, 1, 0.2, '1', '0', '0', 2481, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(890, 'Rope Divider', 'rope_divider', 's', 2, 1, 0.001, '0', '0', '0', 2518, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(891, 'romantique_clock', 'romantique_clock', 's', 1, 1, 1, '0', '0', '0', 2520, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(892, 'Aqua Pura Module 5', 'rare_icecream_campaign', 's', 1, 1, 1, '0', '0', '0', 2507, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(893, 'Pink Pura Module 5', 'pura_mdl5*2', 's', 1, 1, 1, '0', '1', '0', 2510, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(894, 'Black Pura Module 5', 'pura_mdl5*3', 's', 1, 1, 1, '0', '1', '0', 2511, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(895, 'White Pura Module 5', 'pura_mdl5*4', 's', 1, 1, 1, '0', '1', '0', 2512, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(896, 'beige pura module 5', 'pura_mdl5*5', 's', 1, 1, 1, '0', '1', '0', 2513, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(897, 'Blue Pura Module 5', 'pura_mdl5*6', 's', 1, 1, 1, '0', '1', '0', 2514, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(898, 'Green Pura Module 5', 'pura_mdl5*7', 's', 1, 1, 1, '0', '1', '0', 2515, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(899, 'Yellow Pura Module 5', 'pura_mdl5*8', 's', 1, 1, 1, '0', '1', '0', 2516, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(900, 'Red Pura Module 5', 'pura_mdl5*9', 's', 1, 1, 1, '0', '1', '0', 2517, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(901, 'Aqua Pura Module 4', 'pura_mdl4*1', 's', 1, 1, 1, '0', '1', '0', 2472, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(902, 'Pink Pura Module 4', 'pura_mdl4*2', 's', 1, 1, 1, '0', '1', '0', 2473, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(903, 'Black Pura Module 4', 'pura_mdl4*3', 's', 1, 1, 1, '0', '1', '0', 2474, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(904, 'White Pura Module 4', 'pura_mdl4*4', 's', 1, 1, 1, '0', '1', '0', 2475, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(905, 'beige pura module 4', 'pura_mdl4*5', 's', 1, 1, 1, '0', '1', '0', 2476, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(906, 'Blue Pura Module 4', 'pura_mdl4*6', 's', 1, 1, 1, '0', '1', '0', 2477, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(907, 'Green Pura Module 4', 'pura_mdl4*7', 's', 1, 1, 1, '0', '1', '0', 2478, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(908, 'yellow pura module 4', 'pura_mdl4*8', 's', 1, 1, 1, '0', '1', '0', 2479, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(909, 'Red Pura Module 4', 'pura_mdl4*9', 's', 1, 1, 1, '0', '1', '0', 2480, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(910, 'Aqua Pura Module 3', 'pura_mdl3*1', 's', 1, 1, 1, '0', '1', '0', 2534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(911, 'Pink Pura Module 3', 'pura_mdl3*2', 's', 1, 1, 1, '0', '1', '0', 2535, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(912, 'Black Pura Module 3', 'pura_mdl3*3', 's', 1, 1, 1, '0', '1', '0', 2536, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(913, 'White Pura Module 3', 'pura_mdl3*4', 's', 1, 1, 1, '0', '1', '0', 2537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(914, 'beige pura module 3', 'pura_mdl3*5', 's', 1, 1, 1, '0', '1', '0', 2538, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(915, 'Blue Pura Module 3', 'pura_mdl3*6', 's', 1, 1, 1, '0', '1', '0', 2539, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(916, 'Green Pura Module 3', 'pura_mdl3*7', 's', 1, 1, 1, '0', '1', '0', 2540, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(917, 'yellow pura module 3', 'pura_mdl3*8', 's', 1, 1, 1, '0', '1', '0', 2541, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(918, 'Red Pura Module 3', 'pura_mdl3*9', 's', 1, 1, 1, '0', '1', '0', 2542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(919, 'Aqua Pura Module 2', 'pura_mdl2*1', 's', 1, 1, 1, '0', '1', '0', 2483, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(920, 'Pink Pura Module 2', 'pura_mdl2*2', 's', 1, 1, 1, '0', '1', '0', 2484, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(921, 'Black Pura Module 2', 'pura_mdl2*3', 's', 1, 1, 1, '0', '1', '0', 2485, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(922, 'White Pura Module 2', 'pura_mdl2*4', 's', 1, 1, 1, '0', '1', '0', 2486, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(923, 'beige pura module 2', 'pura_mdl2*5', 's', 1, 1, 1, '0', '1', '0', 2487, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(924, 'Blue Pura Module 2', 'pura_mdl2*6', 's', 1, 1, 1, '0', '1', '0', 2488, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(925, 'Green Pura Module 2', 'pura_mdl2*7', 's', 1, 1, 1, '0', '1', '0', 2489, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(926, 'yellow pura module 2', 'pura_mdl2*8', 's', 1, 1, 1, '0', '1', '0', 2490, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(927, 'Red Pura Module 2', 'pura_mdl2*9', 's', 1, 1, 1, '0', '1', '0', 2491, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(928, 'Aqua Pura Module 1', 'pura_mdl1*1', 's', 1, 1, 1, '0', '1', '0', 2460, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(929, 'Pink Pura Module 1', 'pura_mdl1*2', 's', 1, 1, 1, '0', '1', '0', 2461, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(930, 'Black Pura Module 1', 'pura_mdl1*3', 's', 1, 1, 1, '0', '1', '0', 2462, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(931, 'White Pura Module 1', 'pura_mdl1*4', 's', 1, 1, 1, '0', '1', '0', 2463, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(932, 'beige pura module 1', 'pura_mdl1*5', 's', 1, 1, 1, '0', '1', '0', 2464, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(933, 'Blue Pura Module 1', 'pura_mdl1*6', 's', 1, 1, 1, '0', '1', '0', 2465, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(934, 'Green Pura Module 1', 'pura_mdl1*7', 's', 1, 1, 1, '0', '1', '0', 2466, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(935, 'yellow pura module 1', 'pura_mdl1*8', 's', 1, 1, 1, '0', '1', '0', 2467, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(936, 'Red Pura Module 1', 'pura_mdl1*9', 's', 1, 1, 1, '0', '1', '0', 2468, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(937, 'Japanese Lantern', 'jp_lantern', 's', 1, 1, 1, '0', '0', '0', 2471, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(938, 'chair_basic', 'chair_basic*1', 's', 1, 1, 1.1, '0', '1', '0', 2525, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(939, 'Pink Pura Egg Chair', 'chair_basic*2', 's', 1, 1, 1.1, '0', '1', '0', 2526, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(940, 'Black Pura Egg Chair', 'chair_basic*3', 's', 1, 1, 1.1, '0', '1', '0', 2527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(941, 'White Pura Egg Chair', 'chair_basic*4', 's', 1, 1, 1.1, '0', '1', '0', 2528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(942, 'Beige Pura Egg Chair', 'chair_basic*5', 's', 1, 1, 1.1, '0', '1', '0', 2529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(943, 'Blue Pura Egg Chair', 'chair_basic*6', 's', 1, 1, 1.1, '0', '1', '0', 2530, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(944, 'Green Pura Egg Chair', 'chair_basic*7', 's', 1, 1, 1.1, '0', '1', '0', 2531, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(945, 'chair_basic', 'chair_basic*8', 's', 1, 1, 1.1, '0', '1', '0', 2532, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(946, 'Red Pura Egg Chair', 'chair_basic*9', 's', 1, 1, 1.1, '0', '1', '0', 2533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(947, '', 'bed_budget*1', 's', 2, 3, 1.9, '0', '0', '0', 2552, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(948, 'Pink Pura Double Bed', 'bed_budget*2', 's', 2, 3, 1.9, '0', '0', '0', 2553, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(949, 'Black Pura Double Bed', 'bed_budget*3', 's', 2, 3, 1.9, '0', '0', '0', 2554, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(950, 'White Pura Double Bed', 'bed_budget*4', 's', 2, 3, 1.9, '0', '0', '0', 2555, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(951, 'Beige Pura Double Bed', 'bed_budget*5', 's', 2, 3, 1.9, '0', '0', '0', 2556, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(952, 'Blue Pura Double Bed', 'bed_budget*6', 's', 2, 3, 1.9, '0', '0', '0', 2557, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(953, 'Green Pura Double Bed', 'bed_budget*7', 's', 2, 3, 1.9, '0', '0', '0', 2558, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(954, 'Yellow Pura Double Bed', 'bed_budget*8', 's', 2, 3, 1.9, '0', '0', '0', 2559, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(955, 'Red Pura Double Bed', 'bed_budget*9', 's', 2, 3, 1.9, '0', '0', '0', 2560, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(956, '', 'bed_budget_one*1', 's', 1, 3, 1.9, '0', '0', '0', 2498, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(957, 'Pink Pura Bed', 'bed_budget_one*2', 's', 1, 3, 1.9, '0', '0', '0', 2499, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(958, 'Black Pura Bed', 'bed_budget_one*3', 's', 1, 3, 1.9, '0', '0', '0', 2500, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(959, 'White Pura Bed', 'bed_budget_one*4', 's', 1, 3, 1.9, '0', '0', '0', 2501, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(960, 'Beige Pura Bed', 'bed_budget_one*5', 's', 1, 3, 1.9, '0', '0', '0', 2502, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(961, 'Blue Pura Bed', 'bed_budget_one*6', 's', 1, 3, 1.9, '0', '0', '0', 2503, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(962, 'Green Pura Bed', 'bed_budget_one*7', 's', 1, 3, 1.9, '0', '0', '0', 2504, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(963, 'Yellow Pura Bed', 'bed_budget_one*8', 's', 1, 3, 1.9, '0', '0', '0', 2505, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(964, 'Red Pura Bed', 'bed_budget_one*9', 's', 1, 3, 1.9, '0', '0', '0', 2506, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(965, 'Japanese Drawer', 'jp_drawer', 's', 1, 1, 1, '1', '0', '0', 2522, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(966, 'Star Tile', 'tile_stella', 's', 1, 1, 0.05, '1', '0', '1', 2568, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(967, 'Marble Tile', 'tile_marble', 's', 1, 1, 0.1, '1', '0', '1', 2566, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(968, 'Red Tile', 'tile_brown', 's', 1, 1, 0.05, '1', '0', '1', 2582, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(969, 'Blue Barbeque Grill', 'summer_grill*1', 's', 2, 1, 1, '0', '0', '0', 2587, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(970, 'Red Barbeque Grill', 'summer_grill*2', 's', 2, 1, 1, '0', '0', '0', 2588, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(971, 'Green Barbeque Grill', 'summer_grill*3', 's', 2, 1, 1, '0', '0', '0', 2589, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(972, 'Green Barbeque Grill', 'summer_grill*4', 's', 2, 1, 1, '0', '0', '0', 2590, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(973, 'Aqua Deck Chair', 'summer_chair*1', 's', 1, 1, 1, '0', '1', '0', 2571, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(974, 'Pink Deck Chair', 'summer_chair*2', 's', 1, 1, 1, '0', '1', '0', 2572, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(975, 'Black Deck Chair', 'summer_chair*3', 's', 1, 1, 1, '0', '1', '0', 2573, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(976, 'White Deck Chair', 'summer_chair*4', 's', 1, 1, 1, '0', '1', '0', 2574, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(977, 'Deck Chair', 'summer_chair*5', 's', 1, 1, 1, '0', '1', '0', 2575, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(978, 'Deck Chair', 'summer_chair*6', 's', 1, 1, 1, '0', '1', '0', 2576, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(979, 'Green Deck Chair', 'summer_chair*7', 's', 1, 1, 1, '0', '1', '0', 2577, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(980, 'Yellow Deck Chair', 'summer_chair*8', 's', 1, 1, 1, '0', '1', '0', 2578, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(981, 'Red Deck Chair', 'summer_chair*9', 's', 1, 1, 1, '0', '1', '0', 2579, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(982, 'Latin Love 1', 'sound_set_36', 's', 1, 1, 0.2, '1', '0', '0', 2583, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(983, 'Dance 6', 'sound_set_35', 's', 1, 1, 0.2, '1', '0', '0', 2595, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(984, 'Rock 5', 'sound_set_34', 's', 1, 1, 0.2, '1', '0', '0', 2570, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(985, 'Rock 3', 'sound_set_33', 's', 1, 1, 0.2, '1', '0', '0', 2564, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(986, 'Instrumental 2', 'sound_set_32', 's', 1, 1, 0.2, '1', '0', '0', 2569, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(987, 'Dance 3', 'sound_set_31', 's', 1, 1, 0.2, '1', '0', '0', 2596, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(988, 'Instrumental 1', 'sound_set_30', 's', 1, 1, 0.2, '1', '0', '0', 2585, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(989, 'Dance 2', 'sound_set_29', 's', 1, 1, 0.2, '1', '0', '0', 2580, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(990, 'Sound Machine Pro', 'sound_machine_pro', 's', 1, 1, 1, '0', '0', '0', 2606, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(991, 'Aqua One Way Gate', 'rare_mnstr', 's', 1, 1, 0.001, '0', '0', '0', 2584, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(992, 'Black HC Gate', 'one_way_door*2', 's', 1, 1, 0.001, '0', '0', '0', 2598, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(993, 'White HC Gate', 'one_way_door*3', 's', 1, 1, 0.001, '0', '0', '0', 2599, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(994, 'Beige One Way Gate', 'one_way_door*4', 's', 1, 1, 0.001, '0', '0', '0', 2600, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(995, 'Pink One Way Gate', 'one_way_door*5', 's', 1, 1, 0.001, '0', '0', '0', 2601, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(996, 'Blue HC Gate', 'one_way_door*6', 's', 1, 1, 0.001, '0', '0', '0', 2602, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(997, 'Green One Way Gate', 'one_way_door*7', 's', 1, 1, 0.001, '0', '0', '0', 2603, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(998, 'Yellow One Way Gate', 'one_way_door*8', 's', 1, 1, 0.001, '0', '0', '0', 2604, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(999, 'Red One Way Gate', 'one_way_door*9', 's', 1, 1, 0.001, '0', '0', '0', 2605, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(1000, 'Executive Rug', 'exe_rug', 's', 3, 3, 0, '1', '0', '1', 2567, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1001, 'Executive Glass Table', 'exe_s_table', 's', 2, 2, 1, '1', '0', '0', 2581, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1002, 'Sound set 37', 'sound_set_37', 's', 1, 1, 0.2, '1', '0', '0', 2565, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1003, 'Blue Summer Pool', 'summer_pool*1', 's', 2, 2, 0, '0', '0', '1', 2591, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1004, 'Red Summer Pool', 'summer_pool*2', 's', 2, 2, 0, '0', '0', '1', 2592, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1005, 'Green Summer Pool', 'summer_pool*3', 's', 2, 2, 0, '0', '0', '1', 2593, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1006, 'Yellow Summer Pool', 'summer_pool*4', 's', 2, 2, 0, '0', '0', '1', 2594, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1007, 'Burn', 'song_disk', 's', 1, 1, 0.1, '1', '0', '0', 2607, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20335, 'bw_boat name', 'bw_boat', 's', 2, 2, 1, '1', '1', '0', 3527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20336, 'bw_jaws', 'bw_jaws', 'i', 1, 1, 1, '1', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20337, 'bw_shower', 'bw_shower', 's', 1, 1, 0, '0', '0', '1', 3540, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20338, 'bw_tele', 'bw_tele', 's', 1, 1, 0, '0', '0', '1', 3550, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(20339, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0, '1', '0', '1', 3541, '1', '1', '1', '1', '1', 'pool', 1, '0', ''),
(29901, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3, '0', '1', '1', 3529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29902, 'bw_sofa', 'bw_sofa', 's', 1, 2, 1, '0', '0', '1', 3533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29903, 'bw_sboard', 'bw_sboard', 's', 1, 2, 1, '1', '0', '1', 3543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29904, 'bw_chair', 'bw_chair', 's', 1, 1, 1, '1', '1', '1', 3544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29905, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1, '0', '0', '0', 3539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29906, 'bw_table', 'bw_table', 's', 2, 2, 1, '1', '0', '0', 3545, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(29907, 'bw_bball', 'bw_bball', 's', 1, 1, 1, '1', '0', '0', 3547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29908, 'bw_croc', 'bw_croc', 's', 1, 1, 1, '1', '1', '0', 3542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29909, 'bw_fnc', 'bw_fnc', 's', 1, 1, 1, '1', '0', '0', 3552, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29910, 'bw_water_1', 'bw_water_1', 's', 2, 2, 0, '1', '0', '1', 3530, '1', '1', '1', '1', '1', 'lowpool', 1, '0', ''),
(29911, 'prison_dvdr2', 'prison_dvdr2', 's', 2, 1, 3, '1', '0', '0', 3532, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(29912, 'prison_gate', 'prison_gate', 's', 1, 1, 0.001, '0', '0', '0', 3526, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(29913, 'prison_dvdr1', 'prison_dvdr1', 's', 1, 1, 3, '1', '0', '0', 3534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29914, 'prison_stone', 'prison_stone', 's', 1, 1, 1, '0', '0', '0', 3537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29915, 'prison_tower', 'prison_tower', 's', 1, 1, 3, '1', '0', '1', 3531, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(29916, 'prison_crnr', 'prison_crnr', 's', 1, 1, 1, '1', '0', '0', 3528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20342, 'fball_ptch0', 'fball_ptch0', 's', 3, 3, 0, '1', '0', '1', 3520, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20343, 'fball_ptch1', 'fball_ptch1', 's', 3, 3, 0, '1', '0', '1', 3524, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20344, 'fball_ptch2 name', 'fball_ptch2', 's', 3, 3, 0, '1', '0', '1', 3511, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20345, 'fball_ptch3 name', 'fball_ptch3', 's', 3, 3, 0, '1', '0', '1', 3513, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20346, 'fball_ptch4 name', 'fball_ptch4', 's', 3, 3, 0, '1', '0', '1', 3504, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20347, 'fball_ptch5 name', 'fball_ptch5', 's', 3, 3, 0, '1', '0', '1', 3498, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20348, 'fball_ptch6 name', 'fball_ptch6', 's', 3, 3, 0, '1', '0', '1', 3517, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20349, 'fball_ptch7 name', 'fball_ptch7', 's', 3, 3, 0, '1', '0', '1', 3509, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20350, 'fball_ptch8 name', 'fball_ptch8', 's', 3, 3, 0, '1', '0', '1', 3502, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20351, 'fball_score_b', 'fball_score_b', 's', 1, 1, 1, '0', '0', '0', 3496, '1', '1', '1', '1', '1', 'footballcounterblue', 1, '0', ''),
(20352, 'fball_score_g', 'fball_score_g', 's', 1, 1, 1, '0', '0', '0', 3512, '1', '1', '1', '1', '1', 'footballcountergreen', 1, '0', ''),
(20353, 'fball_score_r', 'fball_score_r', 's', 1, 1, 1, '0', '0', '0', 3522, '1', '1', '1', '1', '1', 'footballcountered', 1, '0', ''),
(20354, 'fball_score_y', 'fball_score_y', 's', 1, 1, 1, '0', '0', '0', 3506, '1', '1', '1', '1', '1', 'footballcounteryellow', 1, '0', ''),
(20341, 'fball_counter name', 'fball_counter', 's', 2, 1, 1, '0', '0', '0', 3525, '1', '1', '1', '1', '1', 'scoreboard', 2, '0', ''),
(20340, 'fball_gate name', 'fball_gate', 's', 1, 0, 0.001, '0', '0', '1', 3516, '1', '1', '1', '1', '1', 'fbgate', 1, '0', ''),
(20355, 'fball_light name', 'fball_light', 's', 1, 0, 1, '0', '0', '0', 3499, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20356, 'fball_goal_y name', 'fball_goal_y', 's', 3, 0, 0, '1', '0', '1', 3523, '1', '1', '1', '1', '1', 'footballgoalyellow', 1, '0', ''),
(20357, 'fball_goal_r name', 'fball_goal_r', 's', 3, 0, 0, '1', '0', '1', 3514, '1', '1', '1', '1', '1', 'footballgoalred', 1, '0', ''),
(20358, 'fball_goal_g', 'fball_goal_g', 's', 3, 0, 0, '1', '0', '1', 3519, '1', '1', '1', '1', '1', 'footballgoalgreen', 1, '0', ''),
(20359, 'fball_goal_b name', 'fball_goal_b', 's', 3, 0, 0, '1', '0', '1', 3515, '1', '1', '1', '1', '1', 'footballgoalblue', 1, '0', ''),
(20360, 'fball_fnc3 name', 'fball_fnc3', 's', 1, 3, 1, '1', '0', '0', 3495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20361, 'fball_fnc1 name', 'fball_fnc1', 's', 1, 0, 1, '1', '0', '0', 3501, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20362, 'fball_crnr name', 'fball_crnr', 's', 1, 0, 1, '1', '0', '0', 3503, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20363, 'fball_cote name', 'fball_cote', 's', 3, 1, 1, '0', '0', '0', 3507, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20364, 'fball_bench name', 'fball_bench', 's', 3, 0, 1, '0', '1', '0', 3494, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20365, 'fball_ball5 name', 'fball_ball5', 's', 1, 0, 1, '0', '0', '1', 3518, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20366, 'fball_ball4 name', 'fball_ball4', 's', 1, 0, 1, '0', '0', '1', 3521, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20367, 'fball_ball3 name', 'fball_ball3', 's', 1, 0, 1, '0', '0', '1', 3497, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20368, 'fball_ball2 name', 'fball_ball2', 's', 1, 0, 1, '0', '0', '1', 3510, '1', '1', '1', '1', '1', 'football', 1, '0', ''),
(20369, 'fball_ball name', 'fball_ball', 's', 1, 0, 1, '1', '0', '1', 3508, '1', '1', '1', '1', '1', 'football', 2, '0', ''),
(20370, 'fball_audbench name', 'fball_audbench', 's', 4, 1, 1, '0', '1', '0', 3500, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20371, 'fball_trophy name', 'fball_trophy', 's', 1, 1, 1, '0', '0', '0', 3505, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(10289, 'easel_0', 'easel_0', 's', 1, 1, 1, '0', '0', '0', 3582, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10290, 'easel_1', 'easel_1', 's', 1, 1, 1, '0', '0', '0', 3594, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10291, 'easel_2', 'easel_2', 's', 1, 1, 1, '0', '0', '0', 3603, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10292, 'easel_3', 'easel_3', 's', 1, 1, 1, '1', '0', '0', 3596, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(10293, 'easel_4', 'easel_4', 's', 1, 1, 1, '0', '0', '0', 3600, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(10294, 'easel_2', 'easel_2', 's', 1, 1, 1, '0', '0', '0', 3603, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20372, 'party_crate2_1', 'party_crate2_1', 's', 2, 1, 1, '1', '0', '0', 3480, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20373, 'party_crate1_3', 'party_crate1_3', 's', 1, 1, 1, '1', '0', '0', 3481, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20374, 'party_crate1_4', 'party_crate1_4', 's', 1, 1, 1, '1', '0', '0', 3485, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20375, 'party_crate1_1', 'party_crate1_1', 's', 1, 1, 1, '1', '0', '0', 3487, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20376, 'party_crate1_2', 'party_crate1_2', 's', 1, 1, 1, '1', '0', '0', 3489, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20377, 'party_crate2_2', 'party_crate2_2', 's', 2, 1, 1, '1', '0', '0', 3490, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20378, 'party_crate2_3', 'party_crate2_3', 's', 2, 1, 1, '1', '0', '0', 3491, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20379, 'party_crate2_4', 'party_crate2_4', 's', 2, 1, 1, '1', '0', '0', 3492, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20380, 'party_djset', 'pary_djset', 's', 1, 3, 3, '0', '0', '0', 3199, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25354, 'bw_boat', 'bw_boat', 's', 2, 2, 1, '1', '1', '0', 3527, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25355, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3, '0', '1', '0', 3529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25357, 'bw_sofa', 'bw_sofa', 's', 2, 1, 1, '1', '1', '0', 3533, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(25359, 'bw_fin', 'bw_fin', 's', 1, 1, 1, '1', '0', '0', 3538, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25360, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1, '0', '0', '0', 3539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25361, 'bw_shower', 'bw_shower', 's', 1, 1, 2, '1', '0', '0', 3540, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25362, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0, '1', '0', '0', 3541, '1', '1', '1', '1', '1', 'pool', 1, '0', ''),
(25363, 'bw_croc', 'bw_croc', 's', 1, 3, 1, '1', '1', '0', 3542, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25364, 'bw_sboard', 'bw_sboard', 's', 2, 1, 0, '0', '0', '0', 3543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25365, 'bw_chair', 'bw_chair', 's', 1, 1, 0.8, '1', '1', '1', 3544, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(25366, 'bw_table', 'bw_table', 's', 2, 2, 1, '1', '0', '0', 3545, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25367, 'bw_ball', 'bw_ball', 's', 1, 1, 1, '0', '0', '0', 3547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25368, 'bw_mttrss', 'bw_mttrss', 's', 1, 3, 0.8, '1', '1', '0', 3548, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25369, 'bw_van', 'bw_van', 's', 2, 2, 1, '0', '1', '0', 3549, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25371, 'bw_fnc_crnr', 'bw_fnc crnr', 's', 1, 2, 1, '1', '0', '0', 3551, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25372, 'bw_fnc', 'bw_fnc', 's', 2, 1, 1, '1', '0', '0', 3552, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(59919, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0, '0', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(59939, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0, '0', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95376, 'bw_fnc_p', 'bw_fnc_p', 's', 2, 1, 1, '1', '0', '0', 3569, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95377, 'bw_fnc_crnr_g', 'bw_fnc_crnr_g', 's', 1, 2, 1, '1', '0', '0', 3563, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95378, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1, '1', '1', '1', 3561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95379, 'bw_boat_g', 'bw_boat_g', 's', 2, 2, 0.8, '1', '1', '0', 3568, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95380, 'bw_mttrss_g', 'bw_mttrss_g', 's', 1, 3, 0.8, '1', '0', '0', 3558, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95381, 'bw_pool_b2', 'bw_pool_b2', 's', 2, 1, 1, '1', '0', '0', 3565, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95382, 'bw_pool_a2', 'bw_pool_a2', 's', 2, 1, 1, '1', '0', '0', 3564, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95383, 'bw_pool_a3', 'bw_pool_a3', 's', 1, 1, 0, '1', '0', '0', 3556, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95384, 'bw_pool_a1', 'bw_pool_a1', 's', 1, 1, 1, '1', '1', '0', 3577, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95375, 'ads_pepsi0', 'ads_pepsi0', 's', 1, 1, 3, '0', '0', '0', 3554, '1', '1', '1', '1', '1', 'vendingmachine', 1, '55', ''),
(95374, 'ads_grefusa_surfb', 'ads_grefusa_surfb', 'i', 0, 0, 0, '0', '0', '0', 4337, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95385, 'bw_pool_b1', 'bw_pool_b1', 's', 1, 1, 1, '1', '0', '0', 3560, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95386, 'bw_fnc_crnr_p', 'bw_fnc_crnr_p', 's', 1, 2, 1, '0', '0', '0', 3576, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95387, 'bw_sboard_g', 'bw_sboard_g', 's', 2, 1, 0, '0', '0', '0', 3562, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95388, 'bw_sboard_p', 'bw_sboard_p', 's', 2, 1, 0, '0', '0', '0', 3571, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95389, 'bw_table_g', 'bw_table_g', 's', 2, 2, 1, '1', '0', '0', 3566, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95390, 'bw_table_p', 'bw_table_p', 's', 2, 1, 0, '1', '0', '0', 3578, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95391, 'bw_van_p', 'bw_van_p', 's', 2, 2, 1, '0', '1', '0', 3570, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95392, 'bw_van_g', 'bw_van_g', 's', 2, 2, 1, '0', '1', '0', 3574, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95393, 'bw_sofa_g', 'bw_sofa_g', 's', 2, 1, 1, '1', '1', '0', 3575, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95394, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1, '1', '1', '0', 3561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95395, 'bw_fnc_g name', 'bw_fnc_g', 's', 2, 1, 1, '1', '0', '0', 3557, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95397, 'bw_tele', 'bw_tele', 's', 1, 1, 3, '0', '0', '0', 3550, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(10355, 'african_tree2', 'african_tree2', 's', 1, 1, 1, '0', '0', '0', 3605, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10354, 'african_tree1', 'african_tree1', 's', 1, 1, 1, '0', '0', '0', 3584, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10353, 'african_stage', 'african_stage', 's', 2, 2, 1, '1', '0', '1', 3607, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10352, 'african_patch', 'african_patch', 's', 2, 2, 1, '0', '0', '1', 3602, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10351, 'african_fence', 'african_fence', 's', 1, 2, 1, '0', '0', '0', 3579, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10350, 'african_bones', 'african_bones', 's', 1, 1, 1, '0', '0', '0', 3609, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10357, 'ktchn10_cabnt', 'ktchn10_cabnt', 'i', 0, 0, 0, '0', '0', '0', 4338, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10358, 'ktchn10_pot', 'ktchn10_pot', 's', 1, 1, 1, '0', '0', '0', 3580, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10359, 'ktchn10_sink', 'ktchn10_sink', 's', 2, 1, 1, '0', '0', '0', 3612, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10360, 'ktchn10_stove', 'ktchn10_stove', 's', 2, 1, 1, '0', '0', '0', 3581, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10278, 'hosptl_bbag name', 'hosptl_bbag', 's', 1, 3, 1, '0', '0', '0', 3591, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(10279, 'hosptl_bed', 'hosptl_bed', 's', 1, 3, 1, '0', '0', '0', 3590, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(10280, 'hosptl_cab1', 'hosptl_cab1', 's', 1, 1, 1, '0', '0', '0', 3586, '1', '1', '1', '1', '1', 'vendingmachine', 2, '35', ''),
(10281, 'hosptl_cab2', 'hosptl_cab2', 's', 2, 1, 1, '0', '0', '0', 3608, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10282, 'hosptl_curtain', 'hosptl_curtain', 's', 3, 1, 1, '0', '0', '0', 3588, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(10283, 'hosptl_defibs', 'hosptl_defibs', 's', 1, 1, 1, '0', '0', '0', 3606, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10284, 'hosptl_light', 'hosptl_light', 's', 1, 1, 1, '0', '0', '0', 3610, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10285, 'hosptl_seat', 'hosptl_seat', 's', 1, 2, 1, '0', '1', '0', 3611, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10286, 'hosptl_skele', 'hosptl_skele', 's', 1, 1, 1, '0', '0', '0', 3604, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10287, 'hosptl_xray', 'hosptl_xray', 'i', 0, 0, 0, '0', '0', '0', 4339, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89945, 'cubie_rug_b', 'cubie_rug_b', 's', 2, 3, 0.1, '1', '0', '1', 3860, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89946, 'cubie_lamp_p', 'cubie_lamp_p', 's', 1, 1, 1, '0', '0', '0', 3863, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89947, 'cubie_shelf_3_p', 'cubie_shelf_3_p', 's', 2, 1, 1, '1', '0', '0', 3873, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(89948, 'cubie_shelf_4_b', 'cubie_shelf_4_b', 's', 3, 1, 1, '1', '0', '0', 3882, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89949, 'cubie_shelf_1_b', 'cubie_shelf_1_b', 's', 1, 1, 1, '0', '0', '0', 3875, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89950, 'cubie_shelf_1_p', 'cubie_shelf_1_p', 's', 1, 1, 1, '0', '0', '0', 3874, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89951, 'cubie_chair_p', 'cubie_chair_p', 's', 1, 1, 1.2, '0', '1', '0', 3879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89952, 'cubie_shelf_4_p', 'cubie_shelf_4_p', 's', 3, 1, 1, '0', '0', '0', 3866, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89953, 'cubie_bigtable_p', 'cubie_bigtable_p', 's', 2, 2, 0.5, '1', '0', '1', 3876, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89954, 'cubie_shelf_0_p', 'cubie_shelf_0_p', 's', 1, 1, 0.5, '1', '0', '0', 3884, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89955, 'cubie_beanbag_b', 'cubie_beanbag_b', 's', 1, 1, 1, '0', '1', '0', 3877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89956, 'cubie_chair_b', 'cubie_chair_b', 's', 1, 1, 1.2, '0', '1', '0', 3859, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89957, 'cubie_bed_b', 'cubie_bed_b', 's', 1, 3, 1.8, '0', '0', '0', 3871, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(89958, 'cubie_bigtable_b', 'cubie_bigtable_b', 's', 2, 2, 0.5, '1', '0', '1', 3861, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89959, 'cubie_stool_b', 'cubie_stool_b', 's', 1, 1, 1.2, '0', '1', '0', 3869, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89960, 'cubie_beanbag_p', 'cubie_beanbag_p', 's', 1, 1, 1, '0', '1', '0', 3862, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89961, 'cubie_shelf_0_b', 'cubie_shelf_0_b', 's', 1, 1, 0.5, '1', '0', '0', 3865, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89962, 'cubie_shelf_2_p', 'cubie_shelf_2_p', 's', 2, 1, 1, '1', '0', '0', 3867, '1', '1', '1', '1', '1', 'default', 17, '0', ''),
(89963, 'cubie_rug_p', 'cubie_rug_p', 's', 2, 3, 0.1, '1', '0', '1', 3870, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89964, 'cubie_sofaseat_b', 'cubie_sofaseat_b', 's', 1, 1, 1, '0', '1', '0', 3881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89965, 'cubie_table', 'cubie_table', 's', 1, 2, 1, '1', '0', '0', 3880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89966, 'cubie_sofaseat_p', 'cubie_sofaseat_p', 's', 1, 1, 1, '0', '1', '0', 3864, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89967, 'cubie_bed_p', 'cubie_bed_p', 's', 1, 3, 1.8, '0', '0', '0', 3868, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(89968, 'cubie_shelf_3_b', 'cubie_shelf_3_b', 's', 2, 1, 1, '1', '0', '0', 3872, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(89969, 'cubie_shelf_2_b', 'cubie_shelf_2_b', 's', 2, 1, 1, '1', '0', '0', 3883, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89970, 'cubie_lamp_b', 'cubie_lamp_b', 's', 1, 1, 1, '0', '0', '0', 3858, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89971, 'cubie_stool_p', 'cubie_stool_p', 's', 1, 1, 1.2, '0', '1', '0', 3878, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89972, 'cubie_wallshelf_b', 'cubie_wallshelf_b', 'i', 1, 1, 1, '1', '0', '0', 4389, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89973, 'cubie_decklight_p', 'cubie_decklight_p', 'i', 1, 1, 1, '1', '0', '0', 4385, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89974, 'cubie_wallshelf_p', 'cubie_wallshelf_p', 'i', 1, 1, 1, '1', '0', '0', 4392, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89975, 'cubie_decal_0', 'cubie_decal_0', 'i', 1, 1, 1, '1', '0', '0', 4395, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89976, 'cubie_decal_3', 'cubie_decal_3', 'i', 1, 1, 1, '1', '0', '0', 4391, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89977, 'cubie_decal_1_p', 'cubie_decal_1_p', 'i', 1, 1, 1, '1', '0', '0', 4390, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89978, 'cubie_decklight_b', 'cubie_decklight_b', 'i', 1, 1, 1, '1', '0', '0', 4394, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89979, 'cubie_decal_1_b', 'cubie_decal_1_b', 'i', 1, 1, 1, '1', '0', '0', 4386, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89980, 'cubie_decal_2_b', 'cubie_decal_2_b', 'i', 1, 1, 1, '1', '0', '0', 4387, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89981, 'cubie_decal_3_p', 'cubie_decal_3_p', 'i', 1, 1, 1, '1', '0', '0', 4388, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89982, 'cubie_decal_2_p', 'cubie_decal_2_p', 'i', 1, 1, 1, '1', '0', '0', 4393, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89983, 'cubie_decal_3_b', 'cubie_decal_3_b', 'i', 1, 1, 1, '1', '0', '0', 4384, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89984, 'newbie_present', 'newbie_present', 's', 1, 1, 1, '1', '0', '0', 3885, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89985, 'tv_flat', 'tv_flat', 's', 2, 1, 1, '0', '0', '0', 3886, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89986, 'waasa_table2', 'waasa_table2', 's', 2, 1, 1, '1', '0', '0', 3887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89987, 'computer_flatscreen', 'computer_flatscreen', 's', 1, 1, 1, '0', '0', '0', 3888, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89988, 'waasa_chair', 'waasa_chair', 's', 1, 1, 1.2, '0', '1', '0', 3889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89989, 'waasa_ship2', 'waasa_ship2', 's', 2, 1, 1, '0', '0', '0', 3890, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89990, 'waasa_ship1', 'waasa_ship1', 's', 1, 1, 1, '0', '0', '0', 3891, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89991, 'waasa_bunk_bed', 'waasa_bunk_bed', 's', 3, 1, 1, '1', '0', '0', 3892, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89992, 'computer_laptop', 'computer_laptop', 's', 1, 1, 1, '0', '0', '0', 3893, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89993, 'computer_old', 'computer_old', 's', 1, 1, 1, '0', '0', '0', 3894, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89994, 'waasa_table1', 'waasa_table1', 's', 1, 1, 1, '1', '0', '0', 3895, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89995, 'waasa_desk', 'waasa_desk', 's', 2, 1, 1, '1', '0', '0', 3896, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89996, 'waasa_wall_shelf2', 'waasa_wall_shelf2', 'i', 1, 1, 1, '1', '0', '0', 4396, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89997, 'waasa_wall_shelf1', 'waasa_wall_shelf1', 'i', 1, 1, 1, '1', '0', '0', 4397, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89914, 'nest_frog', 'nest_frog', 's', 1, 1, 0.1, '0', '0', '1', 3830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89915, 'pond', 'pond', 's', 1, 1, 0.01, '0', '0', '1', 3831, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89916, 'val11_present', 'val11_present', 's', 1, 1, 1.2, '1', '0', '0', 3832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89917, 'prizetrophy_cine', 'prizetrophy_cine', 's', 1, 1, 1, '0', '0', '0', 3833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89918, 'cine_vipsign', 'cine_vipsign', 's', 1, 1, 1, '0', '0', '0', 3834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89919, 'limo_b_mid3', 'limo_b_mid3', 's', 2, 1, 1, '0', '0', '0', 3835, '1', '1', '1', '1', '1', 'vendingmachine', 1, '50', ''),
(89920, 'limo_b_mid2', 'limo_b_mid2', 's', 2, 1, 0.3, '0', '0', '1', 3836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89921, 'limo_b_front', 'limo_b_front', 's', 2, 1, 1, '0', '0', '0', 3837, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89922, 'limo_b_mid', 'limo_b_mid', 's', 2, 1, 1.2, '0', '1', '0', 3838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89923, 'cine_star', 'cine_star', 's', 1, 1, 0.1, '1', '0', '1', 3839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89924, 'limo_b_back', 'limo_b_back', 's', 2, 1, 1.2, '0', '1', '0', 3840, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89925, 'ads_bigtv_missmix', 'ads_bigtv_missmix', 'i', 1, 1, 1, '0', '0', '0', 4381, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89926, 'cine_curtain', 'cine_curtain', 's', 8, 1, 0.001, '0', '0', '0', 3841, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(89927, 'cine_screen', 'cine_screen', 's', 8, 1, 1, '0', '0', '0', 3842, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89928, 'theatre_seat_g', 'theatre_seat_g', 's', 1, 1, 1, '0', '1', '0', 3843, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89929, 'cine_tile', 'cine_tile', 's', 1, 1, 0.1, '0', '0', '1', 3844, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89930, 'cine_bench_b', 'cine_bench_b', 's', 3, 1, 1.1, '0', '1', '0', 3845, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89931, 'theatre_seat_b', 'theatre_seat_b', 's', 1, 1, 1, '0', '1', '0', 3846, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89932, 'cine_roof', 'cine_roof', 's', 3, 3, 0.1, '0', '0', '1', 3847, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89933, 'cine_popcorn', 'cine_popcorn', 's', 1, 1, 1, '0', '0', '0', 3848, '1', '1', '1', '1', '1', 'vendingmachine', 1, '62', ''),
(89934, 'cine_bench', 'cine_bench', 's', 3, 1, 1.1, '0', '1', '0', 3849, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89935, 'cine_bench_g', 'cine_bench_g', 's', 3, 1, 1.1, '0', '1', '0', 3850, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89936, 'cine_ticket_booth', 'cine_ticket_booth', 's', 1, 1, 1, '0', '0', '0', 3851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89937, 'cine_projector', 'cine_projector', 's', 1, 1, 1, '0', '0', '0', 3852, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89907, 'gothic_st_glass', 'gothic_st_glass', 'i', 1, 1, 1, '0', '0', '0', 4380, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89908, 'gothic_candles', 'gothic_candles', 's', 1, 1, 1, '0', '0', '0', 3825, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89909, 'gothic_bed', 'gothic_bed', 's', 2, 3, 1, '0', '1', '0', 3824, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89910, 'gothic_bowl', 'gothic_bowl', 's', 1, 1, 1, '0', '0', '0', 3828, '1', '1', '1', '1', '1', 'vendingmachine', 1, '62', ''),
(89911, 'gothic_desk', 'gothic_desk', 's', 1, 2, 1, '0', '0', '0', 3826, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89912, 'ads_grefu_trophy', 'ads_grefu_trophy', 's', 1, 1, 1, '0', '0', '0', 3827, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(77701, 'bling11_block', 'bling11_block', 's', 1, 1, 2, '1', '0', '0', 3801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77702, 'bling11_dvd', 'bling11_dvd', 's', 1, 2, 1.6, '1', '0', '0', 3793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77703, 'bling11_dvn', 'bling11_dnv', 's', 1, 3, 1.2, '0', '0', '0', 3798, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(77704, 'bling11_floor', 'bling11_floor', 's', 1, 1, 0.1, '1', '0', '0', 3794, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(77705, 'bling11_pillar', 'bling11_pillar', 's', 1, 1, 3.3, '1', '0', '0', 3802, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77706, 'bling11_plant', 'bling11_plant', 's', 1, 1, 1, '0', '0', '0', 3795, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77707, 'bling11_rug1', 'bling11_rug1', 's', 2, 2, 0.1, '1', '0', '1', 3788, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77708, 'bling11_rug2', 'bling11_rug2', 's', 3, 3, 0.2, '1', '0', '1', 3797, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77709, 'bling11_seat1', 'bling11_seat1', 's', 1, 1, 1, '0', '1', '0', 3800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77710, 'bling11_seat2', 'bling11_seat2', 's', 1, 1, 1.2, '0', '1', '0', 3799, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(77711, 'bling11_slot', 'bling11_slot', 's', 1, 1, 1, '0', '0', '0', 3786, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77712, 'bling11_sofa', 'bling11_sofa', 's', 3, 1, 0.4, '0', '1', '0', 3790, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77713, 'bling11_statue1', 'bling11_statue1', 's', 1, 1, 1, '0', '0', '0', 3791, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77714, 'bling11_statue2', 'bling11_statue2', 's', 2, 2, 1, '0', '0', '0', 3785, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77715, 'bling11_tele', 'bling11_tele', 's', 1, 1, 0.1, '0', '0', '0', 3789, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(77716, 'bling11_towels', 'bling11_towels', 's', 1, 1, 1, '0', '0', '0', 3787, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77717, 'val11_floor', 'val11_floor', 's', 2, 2, 0.1, '1', '0', '1', 3792, '1', '1', '1', '1', '1', 'normalskates', 1, '0', ''),
(77801, 'china_rabbit', 'china_rabbit', 's', 1, 1, 1, '0', '0', '0', 3796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89900, 'limo_w_front', 'limo_w_front', 's', 2, 1, 1, '0', '0', '0', 3823, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89901, 'limo_w_mid', 'limo_w_mid', 's', 2, 1, 1, '0', '1', '0', 3819, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89902, 'limo_w_mid2', 'limo_w_mid2', 's', 2, 1, 0.3, '0', '0', '1', 3820, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89903, 'limo_w_back', 'limo_w_back', 's', 2, 1, 1, '0', '1', '0', 3822, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89904, 'petfood19', 'petfood19', 's', 1, 1, 0.001, '0', '0', '1', 3821, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89905, 'petfood18', 'petfood18', 's', 1, 1, 0.001, '0', '0', '1', 3816, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89906, 'petfood17', 'petfood17', 's', 1, 1, 0.001, '0', '0', '1', 3817, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(30000, 'hween10_bat', 'hween10_bat', 's', 1, 1, 1, '0', '0', '0', 3662, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30001, 'hween10_card_1', 'hween10_card_1', 'i', 1, 1, 1, '1', '0', '0', 4346, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30002, 'hween10_card_2', 'hween10_card_2', 'i', 1, 1, 1, '1', '0', '0', 4350, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30003, 'hween10_card_3', 'hween10_card_3', 'i', 1, 1, 1, '1', '0', '0', 4345, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30004, 'hween10_card_4', 'hween10_card_4', 'i', 1, 1, 1, '1', '0', '0', 4347, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30005, 'hween10_card_5', 'hween10_card_5', 'i', 1, 1, 1, '1', '0', '0', 4351, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30006, 'hween10_card_6', 'hween10_card_6', 'i', 1, 1, 1, '1', '0', '0', 4348, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30007, 'hween10_chicken', 'hween10_chicken', 's', 2, 1, 1, '1', '0', '0', 3658, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30008, 'hween10_ffly', 'hween10_ffly', 's', 1, 1, 1, '1', '0', '0', 3657, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30009, 'hween10_fog', 'hween10_fog', 's', 2, 2, 0.0001, '1', '0', '1', 3652, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30010, 'hween10_jar', 'hween10_jar', 's', 1, 1, 1, '1', '0', '0', 3651, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30011, 'hween10_logs', 'hween10_logs', 's', 1, 1, 0.3, '0', '0', '1', 3656, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30012, 'hween10_pond', 'hween10_pond', 's', 2, 2, 0.01, '1', '0', '1', 3650, '1', '1', '1', '1', '1', 'haloweenpool', 1, '0', ''),
(30013, 'hween10_portch', 'hween10_portch', 's', 1, 1, 1, '0', '0', '1', 3661, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(30014, 'hween10_skullpost', 'hween10_skullpost', 's', 1, 1, 1, '1', '0', '0', 3654, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30015, 'hween10_swamp', 'hween10_swamp', 's', 2, 2, 0.01, '1', '0', '0', 3649, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30016, 'hween10_tarot', 'hween10_tarot', 's', 1, 1, 1, '1', '0', '0', 3646, '1', '1', '1', '1', '1', 'dice', 7, '0', ''),
(30017, 'hween10_tele', 'hween10_tele', 's', 1, 1, 0.1, '1', '0', '0', 3659, '1', '1', '1', '1', '1', 'teleport', 2, '0', ''),
(30018, 'hween10_throne', 'hween10_throne', 's', 1, 1, 1.2, '0', '1', '0', 3660, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30019, 'hween10_tree', 'hween10_tree', 's', 1, 1, 1, '1', '0', '0', 3648, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30020, 'hween10_voodoo1', 'hween10_voodoo1', 's', 1, 1, 1, '1', '0', '0', 3647, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30021, 'hween10_voodoo2', 'hween10_voodoo2', 's', 1, 1, 1, '1', '0', '0', 3653, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30022, 'hween10_voodoo3', 'hween10_voodoo3', 's', 1, 1, 1, '1', '0', '0', 3655, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30023, 'hween10_wallskull', 'hween10_wallskull', 'i', 1, 1, 1, '1', '0', '0', 4349, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99904, 'year2011_waver_b', 'year2011_waver_b', 's', 1, 1, 3, '0', '0', '0', 3781, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99905, 'year2011_waver_g', 'year2011_waver_g', 's', 1, 1, 3, '0', '0', '0', 3780, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99906, 'year2011_waver_r', 'year2011_waver_r', 's', 1, 1, 3, '0', '0', '0', 3777, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99907, 'year2011_waver_y', 'year2011_waver_y', 's', 1, 1, 3, '0', '0', '0', 3768, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99908, 'prizetrophy_2011_y', 'prizetrophy_2011_y', 's', 1, 1, 3, '0', '0', '0', 3771, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99909, 'prizetrophy_2011_b', 'prizetrophy_2011_b', 's', 1, 1, 3, '0', '0', '0', 3773, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99910, 'prizetrophy_2011_r', 'prizetrophy_2011_r', 's', 1, 1, 3, '0', '0', '0', 3770, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99911, 'prizetrophy_2011_p', 'prizetrophy_2011_p', 's', 1, 1, 3, '0', '0', '0', 3775, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99912, 'prizetrophy_2011_g', 'prizetrophy_2011_g', 's', 1, 1, 3, '0', '0', '0', 3778, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99913, 'prizetrophy_2011_w', 'prizetrophy_2011_w', 's', 1, 1, 3, '0', '0', '0', 3769, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99914, 'year2011', 'year2011', 'i', 1, 1, 1, '0', '0', '0', 4373, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99000, 'qt_xm10_nest', 'qt_xm10_nest', 's', 1, 1, 1, '0', '0', '0', 3742, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99001, 'qt_xm10_icedragon', 'qt_xm10_icedragon', 's', 1, 1, 1, '0', '0', '0', 3746, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99002, 'qt_xm10_stone', 'qt_xm10_stone', 's', 2, 1, 1, '0', '0', '0', 3747, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99003, 'qt_xm10_icetiger', 'qt_xm10_icetiger', 's', 1, 1, 1, '0', '0', '0', 3728, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99004, 'qt_xm10_trex', 'qt_xm10_trex', 's', 3, 7, 1, '0', '0', '0', 3722, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99005, 'qt_xm10_palm_tree', 'qt_xm10_palm_tree', 's', 1, 1, 3, '0', '0', '0', 3720, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99006, 'qt_xm10_bench', 'qt_xm10_bench', 's', 2, 1, 1, '0', '0', '0', 3750, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99007, 'qt_xm10_icelupin', 'qt_xm10_icelupin', 's', 1, 1, 1, '0', '0', '0', 3732, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99008, 'qt_xm10_xmduck', 'qt_xm10_xmduck', 's', 1, 1, 1, '0', '0', '0', 3719, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99009, 'qt_xm10_iceduck', 'qt_xm10_iceduck', 's', 1, 1, 1, '0', '0', '0', 3727, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99010, 'qt_xm10_bauble1', 'qt_xm10_bauble1', 'i', 1, 1, 1, '0', '0', '0', 4365, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99011, 'qt_xm10_bauble2', 'qt_xm10_bauble2', 'i', 1, 1, 1, '0', '0', '0', 4361, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99012, 'qt_xm10_bauble3', 'qt_xm10_bauble3', 'i', 1, 1, 1, '0', '0', '0', 4368, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99013, 'qt_xm10_iceplasto', 'qt_xm10_iceplasto', 's', 1, 1, 1, '0', '1', '0', 3730, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99014, 'qt_xm10_ice_fish', 'qt_xm10_ice_fish', 's', 1, 2, 3, '0', '0', '0', 3748, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99015, 'qt_xm10_gnome', 'qt_xm10_gnome', 's', 1, 2, 1, '0', '0', '0', 3726, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99016, 'qt_xm10_icesilotable', 'qt_xm10_icesilotable', 's', 1, 1, 1, '0', '0', '0', 3743, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99017, 'qt_xm10_iceteddy', 'qt_xm10_iceteddy', 's', 1, 1, 1, '0', '0', '0', 3734, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99018, 'qt_xm10_elephant', 'qt_xm10_elephant', 's', 1, 1, 1, '0', '0', '0', 3724, '1', '1', '1', '1', '1', 'vendingmachine', 2, '0', ''),
(99019, 'qt_xm10_iceclubsofa', 'qt_xm10_iceclubsofa', 's', 2, 1, 1, '0', '1', '0', 3718, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99020, 'es_skating_ice', 'es_skating_ice', 's', 2, 2, 0.01, '0', '0', '1', 3736, '1', '1', '1', '1', '1', 'iceskates', 2, '0', ''),
(99021, 'es_sidewalk', 'es_sidewalk', 's', 2, 2, 0.2, '0', '0', '1', 3716, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99022, 'es_wpost', 'es_wpost', 's', 1, 1, 1, '0', '0', '0', 3725, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99023, 'es_tagging', 'es_tagging', 's', 1, 1, 3, '0', '0', '0', 3741, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99024, 'es_santa', 'es_santa', 's', 1, 1, 1, '0', '0', '0', 3740, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99025, 'es_window', 'es_window', 'i', 1, 1, 1, '0', '0', '0', 4367, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99026, 'es_bench', 'es_bench', 's', 2, 1, 1, '0', '1', '0', 3712, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99027, 'es_fnc_1', 'es_fnc_1', 's', 1, 1, 1, '0', '0', '0', 3729, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99028, 'es_fnc_2', 'es_fnc_2', 's', 1, 1, 1, '0', '0', '0', 3714, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99029, 'es_fnc_crnr', 'es_fnc_crnr', 's', 1, 1, 1, '0', '0', '0', 3721, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99030, 'es_epictree', 'es_epictree', 's', 2, 2, 4, '0', '0', '0', 3723, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99031, 'es_icestar_g', 'es_icestar_g', 's', 1, 1, 6, '0', '0', '0', 3731, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99032, 'es_icestar_r', 'es_icestar_r', 's', 1, 1, 6, '0', '0', '0', 3745, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99033, 'es_icestar_y', 'es_icestar_y', 's', 1, 1, 6, '0', '0', '0', 3749, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99034, 'es_icestar', 'es_icestar', 's', 1, 1, 6, '0', '0', '0', 3713, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99035, 'es_puck', 'es_puck', 's', 1, 1, 1, '0', '0', '0', 3739, '1', '1', '1', '1', '1', '', 2, '0', ''),
(99036, 'es_roaster', 'es_roaster', 's', 1, 1, 2, '0', '0', '0', 3738, '1', '1', '1', '1', '1', 'default', 2, '0', '');
INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(99037, 'es_lmppst', 'es_lmppst', 's', 1, 1, 4, '0', '0', '0', 3735, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99038, 'es_statue', 'es_statue', 's', 1, 1, 1, '0', '0', '0', 3717, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568401, 'exe_copier', 'exe_copier', 's', 1, 1, 1, '0', '0', '0', 3704, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568402, 'exe_glassdvdr', 'exe_glassdvdr', 's', 1, 1, 1, '0', '0', '0', 3706, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568403, 'exe_wrkdesk', 'exe_wrkdesk', 's', 1, 1, 1, '0', '0', '0', 3705, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568404, 'exe_seccam', 'exe_seccam', 's', 1, 1, 1, '0', '0', '1', 3707, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568405, 'exe_sensor', 'exe_sensor', 'i', 1, 1, 1, '0', '0', '0', 4356, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99080, 'es_big3', 'es_big3', 'i', 1, 1, 0.5, '1', '0', '1', 4371, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99081, 'es_big2', 'es_big2', 'i', 1, 1, 0.5, '1', '0', '1', 4372, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99082, 'Freeze Ice Block', 'es_box', 's', 1, 1, 0.5, '1', '0', '0', 3758, '1', '1', '1', '1', '1', 'freezetileblock', 1, '0', ''),
(99083, 'Freese Counter', 'es_counter', 's', 1, 3, 1, '0', '0', '0', 3764, '1', '1', '1', '1', '1', 'freezetimer', 1, '0', ''),
(99084, 'Exit Tile', 'es_exit', 's', 1, 1, 0.1, '1', '0', '1', 3759, '1', '1', '1', '1', '1', 'freezeexit', 1, '0', ''),
(99085, 'Blue Freeze Gate', 'es_gate_b', 's', 1, 1, 1, '0', '0', '1', 3762, '1', '1', '1', '1', '1', 'freezebluegate', 1, '0', ''),
(99086, 'Green Freeze Gate', 'es_gate_g', 's', 1, 1, 0, '0', '0', '1', 3761, '1', '1', '1', '1', '1', 'freezegreengate', 1, '0', ''),
(99087, 'Red Freeze Gate', 'es_gate_r', 's', 1, 1, 0, '0', '0', '1', 3760, '1', '1', '1', '1', '1', 'freezeredgate', 1, '0', ''),
(99088, 'Yellow Freeze Gate', 'es_gate_y', 's', 1, 1, 0, '0', '0', '1', 3763, '1', '1', '1', '1', '1', 'freezeyellowgate', 1, '0', ''),
(99089, 'Yellow Freeze Scoreboard', 'es_score_y', 's', 1, 1, 0, '0', '0', '0', 3767, '1', '1', '1', '1', '1', 'freezeyellowcounter', 1, '0', ''),
(99090, 'Red Freeze Scoreboard', 'es_score_r', 's', 1, 1, 0, '0', '0', '0', 3765, '1', '1', '1', '1', '1', 'freezeredcounter', 1, '0', ''),
(99091, 'Blue Freeze Scoreboard', 'es_score_b', 's', 1, 1, 0, '0', '0', '0', 3756, '1', '1', '1', '1', '1', 'freezebluecounter', 1, '0', ''),
(99092, 'Green Freeze Scoreboard', 'es_score_g', 's', 1, 1, 0, '0', '0', '0', 3766, '1', '1', '1', '1', '1', 'freezegreencounter', 1, '0', ''),
(99093, 'Freeze Tile', 'es_tile', 's', 1, 1, 0, '1', '0', '1', 3757, '1', '1', '1', '1', '1', 'freezetile', 1, '0', ''),
(89938, 'wf_box', 'wf_box', 's', 1, 1, 1.2, '1', '0', '0', 3853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89939, 'wf_maze', 'wf_maze', 's', 1, 1, 1, '0', '0', '0', 3854, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89940, 'ads_rangocactus', 'ads_rangocactus', 's', 1, 1, 1, '0', '0', '0', 3855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89941, 'cine_glass', 'cine_glass', 's', 1, 1, 0.01, '1', '0', '0', 3856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89942, 'wf_cnd_has_furni_on', 'wf_cnd_has_furni_on', 's', 1, 1, 0.6, '1', '0', '0', 3857, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89943, 'cine_light2', 'cine_light2', 'i', 1, 1, 1, '1', '0', '0', 4382, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89944, 'cine_light1', 'cine_light1', 'i', 1, 1, 1, '1', '0', '0', 4383, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20320, 'a0 pet4', 'a0 pet4', 's', 1, 1, 0, '0', '0', '0', 2431, '0', '0', '0', '0', '0', 'pet4', 1, '0', ''),
(20321, 'a0 pet3', 'a0 pet3', 's', 1, 1, 0, '0', '0', '0', 2430, '0', '0', '0', '0', '0', 'pet3', 1, '0', ''),
(20322, 'a0 pet2', 'a0 pet2', 's', 1, 1, 0, '0', '0', '0', 2434, '0', '0', '0', '0', '0', 'pet2', 1, '0', ''),
(20323, 'a0 pet1', 'a0 pet1', 's', 1, 1, 0, '0', '0', '0', 2432, '0', '0', '0', '0', '0', 'pet1', 1, '0', ''),
(20324, 'a0 pet0', 'a0 pet0', 's', 1, 1, 0, '0', '0', '0', 2433, '0', '0', '0', '0', '0', 'pet0', 1, '0', ''),
(20411, 'a0 pet6', 'a0 pet6', 's', 1, 1, 0, '0', '0', '0', 7457, '0', '0', '0', '0', '0', 'pet6', 0, '0', ''),
(20412, 'a0 pet7', 'a0 pet7', 's', 1, 1, 0, '0', '0', '0', 5354, '0', '0', '0', '0', '0', 'pet7', 0, '0', ''),
(3568412, 'a0 pet8', 'a0 pet8', 's', 1, 1, 1, '1', '0', '0', 6489, '1', '1', '1', '1', '1', 'pet8', 1, '0', ''),
(3568413, 'a0 pet11', 'a0 pet11', 's', 1, 1, 1, '1', '0', '0', 6490, '1', '1', '1', '1', '1', 'pet11', 1, '0', ''),
(3568422, 'a0 pet10', 'a0 pet10', 's', 0, 0, 0, '0', '0', '0', 1532, '1', '1', '1', '1', '1', 'pet10', 1, '0', ''),
(3568406, 'wallpaper_single_101', 'wallpaper_single_101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568407, 'wallpaper_single_102', 'wallpaper_single_102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568408, 'wallpaper_single_103', 'wallpaper_single_103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568409, 'wallpaper_single_104', 'wallpaper_single_104', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568410, 'wallpaper_single_105', 'wallpaper_single_105', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568411, 'wallpaper_single_106', 'wallpaper_single_106', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568412, 'wallpaper_single_107', 'wallpaper_single_107', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568413, 'wallpaper_single_108', 'wallpaper_single_108', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568414, 'wallpaper_single_109', 'wallpaper_single_109', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568415, 'wallpaper_single_110', 'wallpaper_single_110', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568416, 'wallpaper_single_111', 'wallpaper_single_111', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568417, 'wallpaper_single_112', 'wallpaper_single_112', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568418, 'wallpaper_single_113', 'wallpaper_single_113', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568419, 'wallpaper_single_114', 'wallpaper_single_114', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568420, 'wallpaper_single_115', 'wallpaper_single_115', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568421, 'wallpaper_single_201', 'wallpaper_single_201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568422, 'wallpaper_single_202', 'wallpaper_single_202', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568423, 'wallpaper_single_203', 'wallpaper_single_203', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568424, 'wallpaper_single_204', 'wallpaper_single_204', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568425, 'wallpaper_single_205', 'wallpaper_single_205', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568426, 'wallpaper_single_206', 'wallpaper_single_206', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568427, 'wallpaper_single_207', 'wallpaper_single_207', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568428, 'wallpaper_single_208', 'wallpaper_single_208', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568429, 'wallpaper_single_209', 'wallpaper_single_209', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568430, 'wallpaper_single_210', 'wallpaper_single_210', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568431, 'wallpaper_single_211', 'wallpaper_single_211', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568432, 'wallpaper_single_212', 'wallpaper_single_212', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568433, 'wallpaper_single_213', 'wallpaper_single_213', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568434, 'wallpaper_single_214', 'wallpaper_single_214', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568435, 'wallpaper_single_215', 'wallpaper_single_215', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568436, 'wallpaper_single_216', 'wallpaper_single_216', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568437, 'wallpaper_single_217', 'wallpaper_single_217', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568438, 'wallpaper_single_218', 'wallpaper_single_218', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568439, 'wallpaper_single_301', 'wallpaper_single_301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568440, 'wallpaper_single_302', 'wallpaper_single_302', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568441, 'wallpaper_single_303', 'wallpaper_single_303', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568442, 'wallpaper_single_304', 'wallpaper_single_304', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568443, 'wallpaper_single_305', 'wallpaper_single_305', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568444, 'wallpaper_single_306', 'wallpaper_single_306', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568445, 'wallpaper_single_307', 'wallpaper_single_307', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568446, 'wallpaper_single_401', 'wallpaper_single_401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568447, 'wallpaper_single_402', 'wallpaper_single_402', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568448, 'wallpaper_single_403', 'wallpaper_single_403', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568449, 'wallpaper_single_404', 'wallpaper_single_404', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568450, 'wallpaper_single_405', 'wallpaper_single_405', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568451, 'wallpaper_single_406', 'wallpaper_single_406', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568452, 'wallpaper_single_407', 'wallpaper_single_407', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568453, 'wallpaper_single_408', 'wallpaper_single_408', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568454, 'wallpaper_single_501', 'wallpaper_single_501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568455, 'wallpaper_single_502', 'wallpaper_single_502', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568456, 'wallpaper_single_503', 'wallpaper_single_503', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568457, 'wallpaper_single_504', 'wallpaper_single_504', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568458, 'wallpaper_single_505', 'wallpaper_single_505', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568459, 'wallpaper_single_506', 'wallpaper_single_506', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568460, 'wallpaper_single_507', 'wallpaper_single_507', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568461, 'wallpaper_single_508', 'wallpaper_single_508', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568462, 'wallpaper_single_601', 'wallpaper_single_601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568463, 'wallpaper_single_602', 'wallpaper_single_602', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568464, 'wallpaper_single_603', 'wallpaper_single_603', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568465, 'wallpaper_single_604', 'wallpaper_single_604', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568466, 'wallpaper_single_605', 'wallpaper_single_605', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568467, 'wallpaper_single_606', 'wallpaper_single_606', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568468, 'wallpaper_single_607', 'wallpaper_single_607', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568469, 'wallpaper_single_608', 'wallpaper_single_608', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568470, 'wallpaper_single_609', 'wallpaper_single_609', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568471, 'wallpaper_single_610', 'wallpaper_single_610', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568472, 'wallpaper_single_701', 'wallpaper_single_701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568473, 'wallpaper_single_702', 'wallpaper_single_702', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568474, 'wallpaper_single_703', 'wallpaper_single_703', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568475, 'wallpaper_single_704', 'wallpaper_single_704', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568476, 'wallpaper_single_705', 'wallpaper_single_705', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568477, 'wallpaper_single_706', 'wallpaper_single_706', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568478, 'wallpaper_single_707', 'wallpaper_single_707', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568479, 'wallpaper_single_708', 'wallpaper_single_708', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568480, 'wallpaper_single_709', 'wallpaper_single_709', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568481, 'wallpaper_single_710', 'wallpaper_single_710', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568482, 'wallpaper_single_801', 'wallpaper_single_801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568483, 'wallpaper_single_802', 'wallpaper_single_802', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568484, 'wallpaper_single_803', 'wallpaper_single_803', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568485, 'wallpaper_single_804', 'wallpaper_single_804', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568486, 'wallpaper_single_805', 'wallpaper_single_805', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568487, 'wallpaper_single_806', 'wallpaper_single_806', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568488, 'wallpaper_single_807', 'wallpaper_single_807', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568489, 'wallpaper_single_808', 'wallpaper_single_808', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568490, 'wallpaper_single_809', 'wallpaper_single_809', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568491, 'wallpaper_single_810', 'wallpaper_single_810', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568492, 'wallpaper_single_901', 'wallpaper_single_901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568493, 'wallpaper_single_902', 'wallpaper_single_902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568494, 'wallpaper_single_903', 'wallpaper_single_903', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568495, 'wallpaper_single_904', 'wallpaper_single_904', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568496, 'wallpaper_single_905', 'wallpaper_single_905', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568497, 'wallpaper_single_906', 'wallpaper_single_906', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568498, 'wallpaper_single_907', 'wallpaper_single_907', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568499, 'wallpaper_single_908', 'wallpaper_single_908', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568500, 'wallpaper_single_1001', 'wallpaper_single_1001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568501, 'wallpaper_single_1002', 'wallpaper_single_1002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568502, 'wallpaper_single_1003', 'wallpaper_single_1003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568503, 'wallpaper_single_1004', 'wallpaper_single_1004', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568504, 'wallpaper_single_1005', 'wallpaper_single_1005', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568505, 'wallpaper_single_1006', 'wallpaper_single_1006', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568506, 'wallpaper_single_1007', 'wallpaper_single_1007', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568507, 'wallpaper_single_1101', 'wallpaper_single_1101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568508, 'wallpaper_single_1201', 'wallpaper_single_1201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568509, 'wallpaper_single_1301', 'wallpaper_single_1301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568510, 'wallpaper_single_1401', 'wallpaper_single_1401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568511, 'wallpaper_single_1501', 'wallpaper_single_1501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568512, 'wallpaper_single_1601', 'wallpaper_single_1601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568513, 'wallpaper_single_1701', 'wallpaper_single_1701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568514, 'wallpaper_single_1801', 'wallpaper_single_1801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568515, 'wallpaper_single_1901', 'wallpaper_single_1901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568516, 'wallpaper_single_1902', 'wallpaper_single_1902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568517, 'wallpaper_single_2001', 'wallpaper_single_2001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568518, 'wallpaper_single_2002', 'wallpaper_single_2002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568519, 'wallpaper_single_2003', 'wallpaper_single_2003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568520, 'wallpaper_single_2101', 'wallpaper_single_2101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568521, 'wallpaper_single_2102', 'wallpaper_single_2102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568522, 'wallpaper_single_2103', 'wallpaper_single_2103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568523, 'wallpaper_single_2201', 'wallpaper_single_2201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568524, 'wallpaper_single_2202', 'wallpaper_single_2202', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568525, 'wallpaper_single_2203', 'wallpaper_single_2203', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568526, 'wallpaper_single_2204', 'wallpaper_single_2204', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568527, 'wallpaper_single_2205', 'wallpaper_single_2205', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568528, 'wallpaper_single_2206', 'wallpaper_single_2206', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568529, 'wallpaper_single_2301', 'wallpaper_single_2301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568530, 'wallpaper_single_2302', 'wallpaper_single_2302', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568531, 'wallpaper_single_2303', 'wallpaper_single_2303', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568532, 'wallpaper_single_2304', 'wallpaper_single_2304', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568533, 'wallpaper_single_2401', 'wallpaper_single_2401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568534, 'wallpaper_single_2402', 'wallpaper_single_2402', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568535, 'wallpaper_single_2403', 'wallpaper_single_2403', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568536, 'wallpaper_single_2501', 'wallpaper_single_2501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568537, 'wallpaper_single_2502', 'wallpaper_single_2502', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568538, 'wallpaper_single_2503', 'wallpaper_single_2503', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568539, 'wallpaper_single_2504', 'wallpaper_single_2504', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568540, 'wallpaper_single_2601', 'wallpaper_single_2601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568541, 'wallpaper_single_2602', 'wallpaper_single_2602', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568542, 'wallpaper_single_2603', 'wallpaper_single_2603', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568543, 'wallpaper_single_2604', 'wallpaper_single_2604', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568544, 'wallpaper_single_2701', 'wallpaper_single_2701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568545, 'wallpaper_single_2702', 'wallpaper_single_2702', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568546, 'wallpaper_single_2703', 'wallpaper_single_2703', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568547, 'wallpaper_single_2704', 'wallpaper_single_2704', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568548, 'wallpaper_single_2801', 'wallpaper_single_2801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568549, 'wallpaper_single_2802', 'wallpaper_single_2802', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568550, 'wallpaper_single_2803', 'wallpaper_single_2803', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568551, 'wallpaper_single_2804', 'wallpaper_single_2804', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568552, 'wallpaper_single_2901', 'wallpaper_single_2901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568553, 'wallpaper_single_2902', 'wallpaper_single_2902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568554, 'wallpaper_single_2903', 'wallpaper_single_2903', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568555, 'wallpaper_single_2904', 'wallpaper_single_2904', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568556, 'wallpaper_single_3001', 'wallpaper_single_3001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568557, 'wallpaper_single_3002', 'wallpaper_single_3002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568558, 'wallpaper_single_3003', 'wallpaper_single_3003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568559, 'wallpaper_single_3004', 'wallpaper_single_3004', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568560, 'wallpaper_single_3101', 'wallpaper_single_3101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568561, 'wallpaper_single_3102', 'wallpaper_single_3102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568562, 'wallpaper_single_3103', 'wallpaper_single_3103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568563, 'wallpaper_single_3104', 'wallpaper_single_3104', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568564, 'wallpaper_single_3105', 'wallpaper_single_3105', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568565, 'wallpaper_single_3106', 'wallpaper_single_3106', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568566, 'floor_single_101', 'floor_single_101', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568567, 'floor_single_102', 'floor_single_102', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568568, 'floor_single_103', 'floor_single_103', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568569, 'floor_single_104', 'floor_single_104', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568570, 'floor_single_105', 'floor_single_105', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568571, 'floor_single_106', 'floor_single_106', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568572, 'floor_single_107', 'floor_single_107', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568573, 'floor_single_108', 'floor_single_108', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568574, 'floor_single_109', 'floor_single_109', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568575, 'floor_single_110', 'floor_single_110', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568576, 'floor_single_111', 'floor_single_111', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568577, 'floor_single_201', 'floor_single_201', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568578, 'floor_single_202', 'floor_single_202', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568579, 'floor_single_203', 'floor_single_203', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568580, 'floor_single_204', 'floor_single_204', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568581, 'floor_single_205', 'floor_single_205', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568582, 'floor_single_206', 'floor_single_206', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568583, 'floor_single_207', 'floor_single_207', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568584, 'floor_single_208', 'floor_single_208', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568585, 'floor_single_209', 'floor_single_209', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568586, 'floor_single_210', 'floor_single_210', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568587, 'floor_single_211', 'floor_single_211', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568588, 'floor_single_212', 'floor_single_212', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568589, 'floor_single_301', 'floor_single_301', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568590, 'floor_single_302', 'floor_single_302', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568591, 'floor_single_303', 'floor_single_303', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568592, 'floor_single_304', 'floor_single_304', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568593, 'floor_single_305', 'floor_single_305', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568594, 'floor_single_306', 'floor_single_306', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568595, 'floor_single_307', 'floor_single_307', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568596, 'floor_single_401', 'floor_single_401', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568597, 'floor_single_402', 'floor_single_402', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568598, 'floor_single_403', 'floor_single_403', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568599, 'floor_single_404', 'floor_single_404', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568600, 'floor_single_405', 'floor_single_405', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568601, 'floor_single_406', 'floor_single_406', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568602, 'floor_single_407', 'floor_single_407', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568603, 'floor_single_408', 'floor_single_408', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568604, 'floor_single_409', 'floor_single_409', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568605, 'floor_single_501', 'floor_single_501', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568606, 'floor_single_502', 'floor_single_502', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568607, 'floor_single_503', 'floor_single_503', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568608, 'floor_single_504', 'floor_single_504', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568609, 'floor_single_505', 'floor_single_505', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568610, 'floor_single_506', 'floor_single_506', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568611, 'floor_single_507', 'floor_single_507', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568612, 'floor_single_601', 'floor_single_601', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568613, 'floor_single_602', 'floor_single_602', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568614, 'floor_single_603', 'floor_single_603', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568615, 'floor_single_604', 'floor_single_604', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568616, 'floor_single_605', 'floor_single_605', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568617, 'floor_single_606', 'floor_single_606', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568618, 'floor_single_607', 'floor_single_607', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568619, 'floor_single_608', 'floor_single_608', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568620, 'floor_single_609', 'floor_single_609', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568621, 'floor_single_610', 'floor_single_610', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568622, 'landscape_single_1.1', 'landscape_single_1.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568623, 'landscape_single_1.2', 'landscape_single_1.2', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568624, 'landscape_single_1.3', 'landscape_single_1.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568625, 'landscape_single_1.4', 'landscape_single_1.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568626, 'landscape_single_1.5', 'landscape_single_1.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568627, 'landscape_single_1.6', 'landscape_single_1.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568628, 'landscape_single_1.7', 'landscape_single_1.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568629, 'landscape_single_1.8', 'landscape_single_1.8', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568630, 'landscape_single_1.9', 'landscape_single_1.9', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568631, 'landscape_single_1.10', 'landscape_single_1.10', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568632, 'landscape_single_1.11', 'landscape_single_1.11', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568633, 'landscape_single_2.1', 'landscape_single_2.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568634, 'landscape_single_2.3', 'landscape_single_2.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568635, 'landscape_single_2.4', 'landscape_single_2.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568636, 'landscape_single_2.5', 'landscape_single_2.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568637, 'landscape_single_2.6', 'landscape_single_2.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568638, 'landscape_single_2.7', 'landscape_single_2.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568639, 'landscape_single_3.1', 'landscape_single_3.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568640, 'landscape_single_3.3', 'landscape_single_3.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568641, 'landscape_single_3.4', 'landscape_single_3.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568642, 'landscape_single_3.5', 'landscape_single_3.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568643, 'landscape_single_3.6', 'landscape_single_3.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568644, 'landscape_single_3.7', 'landscape_single_3.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568645, 'landscape_single_4.1', 'landscape_single_4.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568646, 'landscape_single_4.3', 'landscape_single_4.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568647, 'landscape_single_4.4', 'landscape_single_4.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568648, 'landscape_single_4.5', 'landscape_single_4.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568649, 'landscape_single_4.6', 'landscape_single_4.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568650, 'landscape_single_4.7', 'landscape_single_4.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568651, 'landscape_single_5.1', 'landscape_single_5.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568652, 'landscape_single_5.3', 'landscape_single_5.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568653, 'landscape_single_5.4', 'landscape_single_5.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568654, 'landscape_single_5.5', 'landscape_single_5.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568655, 'landscape_single_5.6', 'landscape_single_5.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568656, 'landscape_single_5.7', 'landscape_single_5.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568657, 'landscape_single_6.1', 'landscape_single_6.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568658, 'landscape_single_6.3', 'landscape_single_6.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568659, 'landscape_single_6.4', 'landscape_single_6.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568660, 'landscape_single_6.5', 'landscape_single_6.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568661, 'landscape_single_6.6', 'landscape_single_6.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568662, 'landscape_single_6.7', 'landscape_single_6.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568663, 'landscape_single_7.1', 'landscape_single_7.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568664, 'landscape_single_7.3', 'landscape_single_7.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568665, 'landscape_single_7.4', 'landscape_single_7.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568666, 'landscape_single_7.5', 'landscape_single_7.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568667, 'landscape_single_7.6', 'landscape_single_7.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568668, 'landscape_single_7.7', 'landscape_single_7.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568669, 'landscape_single_7.12', 'landscape_single_7.12', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(9001, 'a0 pet12', 'a0 pet12', 's', 1, 1, 1, '1', '0', '0', 6491, '1', '1', '1', '1', '1', 'pet12', 1, '0', ''),
(2785108, 'bb_painimies2', 'bb_painimies2', 'i', 1, 1, 1, '0', '0', '1', 4342, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785078, 'bb_score_b', 'bb_score_b', 's', 1, 1, 1, '0', '1', '0', 3615, '1', '1', '1', '1', '1', 'banzaiscoreblue', 2, '0', ''),
(2785079, 'bb_robo', 'bb_robo', 's', 2, 2, 2, '0', '0', '0', 3616, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785080, 'bb_dragon', 'bb_dragon', 's', 3, 1, 2.5, '0', '0', '0', 3617, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785081, 'bb_ducklight', 'bb_ducklight', 's', 1, 1, 3, '0', '0', '0', 3618, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(2785082, 'bb_caterhead', 'bb_caterhead', 's', 1, 1, 1, '0', '0', '0', 3619, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785083, 'bb_cargobox', 'bb_cargobox', 's', 2, 1, 1, '0', '0', '0', 3620, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785084, 'bb_gate_g', 'bb_gate_g', 's', 1, 1, 0, '0', '0', '1', 3621, '1', '1', '1', '1', '1', 'banzaigategreen', 2, '0', ''),
(2785085, 'bb_crchair3', 'bb_crchair3', 's', 1, 1, 1, '0', '1', '0', 3622, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785086, 'bb_score_g', 'bb_score_g', 's', 1, 1, 1, '0', '1', '0', 3623, '1', '1', '1', '1', '1', 'banzaiscoregreen', 1, '0', ''),
(2785087, 'bb_crchair', 'bb_crchair', 's', 1, 1, 1, '0', '1', '0', 3624, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785088, 'bb_crchair2', 'bb_crchair2', 's', 1, 1, 1, '0', '1', '0', 3625, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785089, 'bb_score_y', 'bb_score_y', 's', 1, 1, 1, '1', '0', '0', 3626, '1', '1', '1', '1', '1', 'banzaiscoreyellow', 2, '0', ''),
(2785090, 'bb_knj1', 'bb_knj1', 's', 2, 1, 1, '0', '0', '0', 3627, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785091, 'bb_gate_r', 'bb_gate_r', 's', 1, 1, 0, '0', '0', '1', 3628, '1', '1', '1', '1', '1', 'banzaigatered', 2, '0', ''),
(2785092, 'bb_tddhnd', 'bb_tddhnd', 's', 1, 1, 1, '1', '0', '0', 3629, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(2785093, 'bb_lightdiv', 'bb_lightdiv', 's', 1, 1, 1, '1', '0', '0', 3630, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(2785094, 'bb_tddhead', 'bb_tddhead', 's', 2, 2, 2, '0', '0', '0', 3631, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785095, 'bb_pyramid', 'bb_pyramid', 's', 1, 1, 0, '1', '0', '0', 3632, '1', '1', '1', '1', '1', 'banzaipyramid', 3, '0', ''),
(2785096, 'bb_patch1', 'bb_patch1', 's', 1, 1, 0.1, '1', '0', '1', 3633, '1', '1', '1', '1', '1', 'banzaifloor', 4, '0', ''),
(2785097, 'bb_fnc3', 'bb_fnc3', 's', 1, 3, 1, '0', '0', '0', 3634, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(2785098, 'bb_gate_y', 'bb_gate_y', 's', 1, 1, 0, '0', '0', '1', 3635, '1', '1', '1', '1', '1', 'banzaigateyellow', 1, '0', ''),
(2785099, 'bb_apparatus', 'bb_apparatus', 's', 2, 2, 0, '1', '0', '1', 3637, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(2785100, 'bb_caterbody', 'bb_caterbody', 's', 1, 1, 1.7, '1', '1', '0', 3638, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785101, 'bb_knj2', 'bb_knj2', 's', 1, 1, 2, '1', '0', '0', 3639, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(2785102, 'bb_fnc1', 'bb_fnc1', 's', 1, 1, 1, '0', '0', '0', 3640, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(2785103, 'bb_puck', 'bb_puck', 's', 1, 1, 0.6, '1', '0', '0', 3641, '1', '1', '1', '1', '1', 'banzaipuck', 3, '0', ''),
(2785104, 'bb_rnd_tele', 'bb_rnd_tele', 's', 1, 1, 0.3, '0', '0', '1', 3642, '1', '1', '1', '1', '1', 'banzaitele', 1, '0', ''),
(2785105, 'bb_gate_b', 'bb_gate_b', 's', 1, 1, 0, '0', '0', '1', 3643, '1', '1', '1', '1', '1', 'banzaigateblue', 1, '0', ''),
(2785106, 'bb_score_r', 'bb_score_r', 's', 1, 1, 1, '0', '1', '0', 3644, '1', '1', '1', '1', '1', 'banzaiscorered', 2, '0', ''),
(2785107, 'bb_painimies1', 'bb_painimies1', 'i', 1, 1, 1, '0', '0', '1', 4341, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(2785077, 'bb_crnr', 'bb_crnr', 's', 1, 1, 1, '0', '0', '0', 3614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(2785109, 'bb_counter', 'bb_counter', 's', 1, 4, 0.1, '0', '0', '0', 3645, '1', '1', '0', '1', '1', 'banzaicounter', 1, '0', '0'),
(4568423, 'song_disk', 'song_disk', 's', 1, 1, 1, '1', '0', '0', 2607, '1', '1', '1', '1', '1', 'musicdisc', 1, '0', ''),
(3568337, 'wf_trg_at_given_time', 'wf_trg_at_given_time', 's', 1, 1, 0.5, '1', '0', '0', 3679, '1', '1', '1', '1', '1', 'triggertimer', 4, '0', ''),
(3568338, 'wf_trg_enter_room', 'wf_trg_enter_room', 's', 1, 1, 0.5, '1', '0', '0', 3683, '1', '1', '1', '1', '1', 'triggerroomenter', 4, '0', ''),
(3568339, 'wf_trg_game_ends', 'wf_trg_game_ends', 's', 1, 1, 0.5, '1', '0', '0', 3680, '1', '1', '1', '1', '1', 'triggergameend', 5, '0', ''),
(3568340, 'wf_trg_game_starts', 'wf_trg_game_starts', 's', 1, 1, 0.5, '1', '0', '0', 3702, '1', '1', '1', '1', '1', 'triggergamestart', 5, '0', ''),
(3568341, 'wf_trg_periodically', 'wf_trg_periodically', 's', 1, 1, 0.5, '1', '0', '0', 3671, '1', '1', '1', '1', '1', 'triggerrepeater', 4, '0', ''),
(3568342, 'wf_trg_says_something', 'wf_trg_says_something', 's', 1, 1, 0.5, '1', '0', '0', 3675, '1', '1', '1', '1', '1', 'triggeronusersay', 4, '0', ''),
(3568343, 'wf_trg_score_achieved', 'wf_trg_score_achieved', 's', 1, 1, 0.5, '1', '0', '0', 3673, '1', '1', '1', '1', '1', 'triggerscoreachieved', 4, '0', ''),
(3568344, 'wf_trg_state_changed', 'wf_trg_state_changed', 's', 1, 1, 0.5, '1', '0', '0', 3668, '1', '1', '1', '1', '1', 'triggerstatechanged', 4, '0', ''),
(3568345, 'wf_trg_walks_off_furni', 'wf_trg_walks_off_furni', 's', 1, 1, 0.5, '1', '0', '0', 3678, '1', '1', '1', '1', '1', 'triggerwalkofffurni', 4, '0', ''),
(3568346, 'wf_trg_walks_on_furni', 'wf_trg_walks_on_furni', 's', 1, 1, 0.5, '1', '0', '0', 3703, '1', '1', '1', '1', '1', 'triggerwalkonfurni', 4, '0', ''),
(3568347, 'wf_act_give_score', 'wf_act_give_score', 's', 1, 1, 0.5, '1', '0', '0', 3697, '1', '1', '1', '1', '1', 'actiongivescore', 5, '0', ''),
(3568348, 'wf_act_match_to_sshot', 'wf_act_match_to_sshot', 's', 1, 1, 0.5, '1', '0', '0', 3700, '1', '1', '1', '1', '1', 'actionposreset', 4, '0', ''),
(3568349, 'wf_act_move_rotate', 'wf_act_move_rotate', 's', 1, 1, 0.5, '1', '0', '0', 3663, '1', '1', '1', '1', '1', 'actionmoverotate', 4, '0', ''),
(3568350, 'wf_act_reset_timers', 'wf_act_reset_timers', 's', 1, 1, 0.5, '1', '0', '0', 3691, '1', '1', '1', '1', '1', 'actionresettimer', 4, '0', ''),
(3568351, 'wf_act_show_message', 'wf_act_show_message', 's', 1, 1, 0.5, '1', '0', '0', 3681, '1', '1', '1', '1', '1', 'actionshowmessage', 4, '0', ''),
(3568352, 'wf_act_teleport_to', 'wf_act_teleport_to', 's', 1, 1, 0.5, '1', '0', '0', 3674, '1', '1', '1', '1', '1', 'actionteleportto', 1, '0', ''),
(3568353, 'wf_act_toggle_state', 'wf_act_toggle_state', 's', 1, 1, 0.5, '1', '0', '0', 3685, '1', '1', '1', '1', '1', 'actiontogglestate', 4, '0', ''),
(3568354, 'wf_cnd_furnis_hv_avtrs', 'wf_cnd_furnis_hv_avtrs', 's', 1, 1, 0.5, '1', '0', '0', 3692, '1', '1', '1', '1', '1', 'conditionfurnishaveusers', 4, '0', ''),
(3568355, 'wf_cnd_match_snapshot', 'wf_cnd_match_snapshot', 's', 1, 1, 0.5, '1', '0', '0', 3695, '1', '1', '1', '1', '1', 'conditionstatepos', 4, '0', ''),
(3568356, 'wf_cnd_time_less_than', 'wf_cnd_time_less_than', 's', 1, 1, 0.5, '1', '0', '0', 3682, '1', '1', '1', '1', '1', 'conditiontimelessthan', 4, '0', ''),
(3568357, 'wf_cnd_time_more_than', 'wf_cnd_time_more_than', 's', 1, 1, 0.5, '1', '0', '0', 3665, '1', '1', '1', '1', '1', 'conditiontimemorethan', 4, '0', ''),
(3568358, 'wf_cnd_trggrer_on_frn', 'wf_cnd_trggrer_on_frn', 's', 1, 1, 0.5, '1', '0', '0', 3694, '1', '1', '1', '1', '1', 'conditiontriggeronfurni', 4, '0', ''),
(3568359, 'wf_arrowplate', 'wf_arrowplate', 's', 1, 1, 0, '1', '0', '1', 3693, '1', '1', '1', '1', '1', 'arrowplate', 4, '0', ''),
(3568360, 'wf_pressureplate', 'wf_pressureplate', 's', 1, 1, 0, '1', '0', '1', 3688, '1', '1', '1', '1', '1', 'preassureplate', 2, '0', ''),
(3568361, 'wf_ringplate', 'wf_ringplate', 's', 1, 1, 0, '1', '0', '1', 3687, '1', '1', '1', '1', '1', 'ringplate', 2, '0', ''),
(3568362, 'wf_colortile', 'wf_colortile', 's', 1, 1, 0, '1', '0', '1', 3666, '1', '1', '1', '1', '1', 'colortile', 10, '0', ''),
(3568363, 'wf_colorwheel', 'wf_colorwheel', 's', 1, 1, 1, '1', '0', '0', 3676, '1', '1', '1', '1', '1', 'colorwheel', 10, '0', ''),
(3568364, 'wf_floor_switch1', 'wf_floor_switch1', 's', 1, 1, 1, '1', '0', '0', 3701, '1', '1', '1', '1', '1', 'floorswitch1', 2, '0', '');
INSERT INTO `furniture_copy` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(3568365, 'wf_floor_switch2', 'wf_floor_switch2', 's', 1, 1, 1, '1', '0', '0', 3667, '1', '1', '1', '1', '1', 'floorswitch2', 5, '0', ''),
(3568366, 'wf_firegate', 'wf_firegate', 's', 1, 1, 0, '1', '0', '1', 3686, '1', '1', '1', '1', '1', 'firegate', 2, '0', ''),
(3568367, 'wf_glassdoor', 'wf_glassdoor', 's', 1, 1, 0.1, '1', '0', '0', 3699, '1', '1', '1', '1', '1', 'gate', 1, '0', ''),
(3568368, 'wf_xtra_random', 'wf_xtra_random', 's', 1, 1, 0.5, '1', '0', '1', 3669, '1', '1', '1', '1', '1', 'specialrandom', 4, '0', ''),
(3568369, 'wf_xtra_unseen', 'wf_xtra_unseen', 's', 1, 1, 0.5, '1', '0', '1', 3670, '1', '1', '1', '1', '1', 'specialunseen', 4, '0', ''),
(3568374, 'wf_wire1', 'wf_wire1', 's', 1, 1, 0.1, '1', '0', '1', 3696, '1', '1', '1', '1', '1', 'wireStandard', 2, '0', ''),
(3568375, 'wf_wire2', 'wf_wire2', 's', 1, 1, 0.1, '1', '0', '1', 3664, '1', '1', '1', '1', '1', 'wireCenter', 2, '0', ''),
(3568376, 'wf_wire3', 'wf_wire3', 's', 1, 1, 0.1, '1', '0', '1', 3698, '1', '1', '1', '1', '1', 'wireCorner', 2, '0', ''),
(3568377, 'wf_wire4', 'wf_wire4', 's', 1, 1, 0.1, '1', '0', '1', 3677, '1', '1', '1', '1', '1', 'wireSplitter', 2, '0', ''),
(4568424, 'qt_sum11_ictrolley', 'qt_sum11_ictrolley', 's', 1, 1, 1, '0', '0', '0', 4018, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568425, 'qt_sum11_platfrm', 'qt_sum11_platfrm', 's', 2, 2, 1, '1', '0', '0', 4022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568426, 'qt_sum11_shell3', 'qt_sum11_shell3', 's', 1, 1, 1, '0', '0', '0', 4021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568427, 'qt_sum11_shell2', 'qt_sum11_shell2', 's', 1, 1, 1, '0', '0', '0', 4023, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568428, 'qt_sum11_chair', 'qt_sum11_chair', 's', 1, 1, 1, '0', '1', '0', 4025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568429, 'qt_sum11_shell4', 'qt_sum11_shell4', 's', 1, 1, 1, '1', '0', '0', 4020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568430, 'qt_sum11_shell1', 'qt_sum11_shell1', 's', 1, 1, 1, '0', '0', '0', 4017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568431, 'qt_sum11_shell5', 'qt_sum11_shell5', 's', 1, 1, 1, '0', '0', '0', 4024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568432, 'qt_sum11_petfood', 'qt_sum11_petfood', 's', 1, 1, 1, '0', '0', '0', 4019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568433, 'petfood25', 'petfood25', 's', 1, 1, 0.2, '0', '0', '0', 4070, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568434, 'lm_bananadrink', 'lm_bananadrink', 's', 1, 1, 3, '0', '0', '0', 4068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568435, 'lm_crystal_skull', 'lm_crystal_skull', 's', 1, 1, 0.2, '0', '0', '0', 4067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568436, 'lm_jackbox', 'lm_jackbox', 's', 1, 1, 1, '0', '0', '0', 4073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568437, 'ads_durex_carpet', 'ads_durex_carpet', 's', 2, 3, 0.1, '1', '0', '1', 4075, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568438, 'ads_durex_screen', 'ads_durex_screen', 'i', 1, 1, 1, '0', '0', '0', 4410, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568439, 'ads_durex_vend', 'ads_durex_vend', 's', 1, 1, 3, '0', '0', '0', 4074, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4568440, 'Sand Dragon', 'qt_sum11_dragon', 's', 1, 1, 0.001, '0', '0', '0', 2124013, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4000, 'HabMoon Aapje', 'a0 pet14', 's', 1, 1, 1, '0', '0', '0', 14, '0', '0', '0', '0', '1', 'pet14', 1, '0', ''),
(20700, 'Turtels', 'a0 pet9', 's', 1, 1, 1, '0', '0', '0', 14, '0', '0', '0', '0', '1', 'pet9', 1, '0', ''),
(80000, 'Horse', 'a0 pet15', 's', 1, 1, 1, '0', '0', '0', 14, '0', '0', '0', '0', '1', 'pet15', 1, '0', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `furniture_old`
--

CREATE TABLE IF NOT EXISTS `furniture_old` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `public_name` text NOT NULL COMMENT 'temp only',
  `item_name` varchar(100) NOT NULL,
  `type` enum('s','i','e','h') NOT NULL DEFAULT 's',
  `width` int(11) NOT NULL DEFAULT '1',
  `length` int(11) NOT NULL DEFAULT '1',
  `stack_height` double NOT NULL DEFAULT '1',
  `can_stack` enum('0','1') NOT NULL DEFAULT '1',
  `can_sit` enum('0','1') NOT NULL DEFAULT '0',
  `is_walkable` enum('0','1') NOT NULL DEFAULT '0',
  `sprite_id` int(11) NOT NULL,
  `allow_recycle` enum('0','1') NOT NULL DEFAULT '1',
  `allow_trade` enum('0','1') NOT NULL DEFAULT '1',
  `allow_marketplace_sell` enum('0','1') NOT NULL DEFAULT '1',
  `allow_gift` enum('0','1') NOT NULL DEFAULT '1',
  `allow_inventory_stack` enum('0','1') NOT NULL DEFAULT '1',
  `interaction_type` enum('default','gate','postit','roomeffect','dimmer','trophy','bed','scoreboard','vendingmachine','alert','onewaygate','loveshuffler','habbowheel','dice','bottle','teleport','rentals','pet','pool','roller','fbgate','lowpool','haloweenpool','normalskates','iceskates','pet0','pet1','pet2','pet3','pet4','pet5','pet6','pet7','pet8','pet9','pet10','pet11') NOT NULL DEFAULT 'default',
  `interaction_modes_count` int(11) NOT NULL DEFAULT '1',
  `vending_ids` varchar(100) NOT NULL DEFAULT '0',
  `foot_figure` char(2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4568423 ;

--
-- Volcado de datos para la tabla `furniture_old`
--

INSERT INTO `furniture_old` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1, 'Bookcase', 'shelves_norja', 's', 1, 1, 1, '0', '0', '0', 13, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(2, 'Bookcase', 'shelves_polyfon', 's', 2, 1, 1, '0', '0', '0', 14, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(3, 'Bookcase', 'shelves_silo', 's', 2, 1, 1, '0', '0', '0', 15, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(4, 'Small Coffee Table', 'table_polyfon_small', 's', 2, 2, 1, '0', '0', '0', 17, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(5, 'Dining Chair', 'chair_polyfon', 's', 1, 1, 1, '0', '1', '0', 18, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(6, 'Coffee Table', 'table_norja_med', 's', 2, 2, 1, '1', '0', '0', 20, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(7, 'Coffee Table', 'table_silo_med', 's', 2, 2, 1, '1', '0', '0', 21, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(8, 'Occasional Table', 'table_plasto_4leg', 's', 2, 2, 1, '1', '0', '0', 22, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(9, 'Round Dining Table', 'table_plasto_round', 's', 2, 2, 1, '1', '0', '0', 23, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(10, 'Square Dining Table', 'table_plasto_bigsquare', 's', 2, 2, 1, '1', '0', '0', 24, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(11, 'Shelf', 'stand_polyfon_z', 's', 1, 1, 0.5, '1', '0', '0', 25, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(12, 'Dining Chair', 'chair_silo', 's', 1, 1, 1.1, '0', '1', '0', 26, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(13, 'Cushioned', 'sofa_silo', 's', 2, 1, 1.1, '0', '1', '0', 28, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(14, 'Bench', 'couch_norja', 's', 2, 1, 1, '0', '1', '0', 29, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(15, 'Chair', 'chair_norja', 's', 1, 1, 1, '0', '1', '0', 30, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(16, 'Large Coffee Table', 'table_polyfon_med', 's', 2, 2, 1, '1', '0', '0', 31, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(17, 'Doormat', 'doormat_love', 's', 1, 1, 0.1, '0', '0', '1', 32, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(18, 'Doormat', 'doormat_plain', 's', 1, 1, 0.1, '0', '0', '1', 33, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19, 'Armchair', 'sofachair_polyfon', 's', 1, 1, 1.1, '0', '1', '0', 34, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20, 'Two-seater Sofa', 'sofa_polyfon', 's', 2, 1, 1.1, '0', '1', '0', 35, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(21, 'Large', 'sofachair_silo', 's', 1, 1, 1.1, '0', '1', '0', 36, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(22, 'Plastic Pod Chair', 'chair_plasty', 's', 1, 1, 1, '0', '1', '0', 38, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(23, 'Chair', 'chair_plasto', 's', 1, 1, 1, '0', '1', '0', 39, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(24, 'Occasional Table', 'table_plasto_square', 's', 1, 1, 1, '1', '0', '0', 40, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25, 'Double Bed', 'bed_polyfon', 's', 2, 3, 1.8, '0', '0', '0', 41, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(26, 'Single Bed', 'bed_polyfon_one', 's', 1, 3, 1.8, '0', '0', '0', 42, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(27, 'Plain Single Bed', 'bed_trad_one', 's', 2, 3, 1, '0', '0', '0', 43, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(28, 'Plain Double Bed', 'bed_trad', 's', 2, 3, 1, '0', '0', '0', 44, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(29, 'Single Bed', 'bed_silo_one', 's', 1, 3, 1.8, '0', '0', '0', 45, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(30, 'Double Bed', 'bed_silo_two', 's', 2, 3, 1.8, '0', '0', '0', 46, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(31, 'Occasional Table', 'table_silo_small', 's', 1, 1, 1, '1', '0', '0', 47, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(32, 'Double Bed', 'bed_armas_two', 's', 2, 3, 1.8, '0', '0', '0', 48, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(33, 'bed_budget_one', 'bed_budget_one', 's', 1, 3, 1.9, '0', '0', '0', 49, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(34, 'Comfortable', 'bed_budget', 's', 2, 3, 1.9, '0', '0', '0', 50, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(35, 'Bookcase', 'shelves_armas', 's', 2, 1, 1, '0', '0', '0', 51, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(36, 'Bench', 'bench_armas', 's', 2, 1, 1.1, '0', '1', '0', 52, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(37, 'Dining Table', 'table_armas', 's', 2, 2, 1, '1', '0', '0', 53, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(38, 'Occasional Table', 'small_table_armas', 's', 1, 1, 1, '1', '0', '0', 54, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(39, 'Stool', 'small_chair_armas', 's', 1, 1, 1, '0', '1', '0', 55, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(40, 'Authentic', 'fireplace_armas', 's', 2, 1, 1, '0', '0', '0', 56, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(41, 'Table Lamp', 'lamp_armas', 's', 1, 1, 1, '0', '0', '0', 57, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(42, 'Single Bed', 'bed_armas_one', 's', 1, 3, 1.8, '0', '0', '0', 58, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(43, 'Floor rug', 'carpet_standard', 's', 3, 5, 0, '1', '0', '1', 59, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(44, 'Hand-Woven Rug', 'carpet_armas', 's', 2, 4, 0, '1', '0', '1', 60, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(45, 'Faux-Fur Bear Rug', 'carpet_polar', 's', 2, 3, 0, '1', '0', '1', 61, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(46, 'Fireplace', 'fireplace_polyfon', 's', 2, 1, 1, '0', '0', '0', 62, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(47, 'Square Dining Table', 'table_plasto_4leg*1', 's', 2, 2, 1, '1', '0', '0', 63, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(48, 'Square Dining Table', 'table_plasto_bigsquare*1', 's', 2, 2, 1, '1', '0', '0', 64, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(49, 'Round Dining Table', 'table_plasto_round*1', 's', 2, 2, 1, '1', '0', '0', 65, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(50, 'Occasional Table', 'table_plasto_square*1', 's', 1, 1, 1, '1', '0', '0', 66, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(51, 'Chair', 'chair_plasto*1', 's', 1, 1, 1, '0', '1', '0', 67, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(52, 'Floor Rug', 'carpet_standard*1', 's', 3, 5, 0, '1', '0', '1', 68, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(53, 'Doormat', 'doormat_plain*1', 's', 1, 1, 0.1, '0', '0', '1', 69, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(54, 'Occasional Table', 'table_plasto_4leg*2', 's', 2, 2, 1, '1', '0', '0', 70, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(55, 'Square Dining Table', 'table_plasto_bigsquare*2', 's', 2, 2, 1, '1', '0', '0', 71, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(56, 'Round Dining Table', 'table_plasto_round*2', 's', 2, 2, 1, '1', '0', '0', 72, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(57, 'Round Dining Table', 'table_plasto_square*2', 's', 1, 1, 1, '1', '0', '0', 73, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(58, 'Chair', 'chair_plasto*2', 's', 1, 1, 1, '0', '1', '0', 74, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(59, 'Doormat', 'doormat_plain*2', 's', 1, 1, 0.1, '0', '0', '1', 75, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(60, 'Floor Rug', 'carpet_standard*2', 's', 3, 5, 0, '1', '0', '1', 76, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(61, 'Round Dining Table', 'table_plasto_4leg*3', 's', 2, 2, 1, '1', '0', '0', 77, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(62, 'Square Dining Table', 'table_plasto_bigsquare*3', 's', 2, 2, 1, '1', '0', '0', 78, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(63, 'Round Dining Table', 'table_plasto_round*3', 's', 2, 2, 1, '1', '0', '0', 79, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(64, 'Square Dining Table', 'table_plasto_square*3', 's', 1, 1, 1, '1', '0', '0', 80, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(65, 'Chair', 'chair_plasto*3', 's', 1, 1, 1, '0', '1', '0', 81, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(66, 'Floor Rug', 'carpet_standard*3', 's', 3, 5, 0, '1', '0', '1', 82, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(67, 'Doormat', 'doormat_plain*3', 's', 1, 1, 0.1, '0', '0', '1', 83, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(68, 'Square Dining Table', 'table_plasto_4leg*4', 's', 2, 2, 1, '1', '0', '0', 84, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(71, 'Square Dining Table', 'table_plasto_square*4', 's', 1, 1, 1, '1', '0', '0', 87, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(72, 'Chair', 'chair_plasto*4', 's', 1, 1, 1, '0', '1', '0', 88, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(73, 'Floor Rug', 'carpet_standard*4', 's', 3, 5, 0, '1', '0', '1', 89, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(74, 'Doormat', 'doormat_plain*4', 's', 1, 1, 0.1, '0', '0', '1', 90, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(75, 'Doormat', 'doormat_plain*6', 's', 1, 1, 0.1, '0', '0', '1', 91, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(76, 'Doormat', 'doormat_plain*5', 's', 1, 1, 0.1, '0', '0', '1', 93, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77, 'Floor Rug', 'carpet_standard*5', 's', 3, 5, 0, '1', '0', '1', 94, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(78, 'Occasional Table', 'table_plasto_4leg*5', 's', 2, 2, 1, '1', '0', '0', 95, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(79, 'Square Dining Table', 'table_plasto_bigsquare*5', 's', 2, 2, 1, '1', '0', '0', 96, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(80, 'Round Dining Table', 'table_plasto_round*5', 's', 2, 2, 1, '1', '0', '0', 97, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(81, 'Square Dining Table', 'table_plasto_square*5', 's', 1, 1, 1, '1', '0', '0', 98, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(82, 'Chair', 'chair_plasto*5', 's', 1, 1, 1, '0', '1', '0', 99, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(83, 'Occasional table Table', 'table_plasto_4leg*6', 's', 2, 2, 1, '1', '0', '0', 100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(84, 'Square Dining Table', 'table_plasto_bigsquare*6', 's', 2, 2, 1, '1', '0', '0', 101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(85, 'Round Dining Table', 'table_plasto_round*6', 's', 2, 2, 1, '1', '0', '0', 102, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(86, 'Square Dining Table', 'table_plasto_square*6', 's', 1, 1, 1, '1', '0', '0', 103, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(87, 'Chair', 'chair_plasto*6', 's', 1, 1, 1, '0', '1', '0', 104, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(88, 'Occasional table', 'table_plasto_4leg*7', 's', 2, 2, 1, '1', '0', '0', 105, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89, 'Square Dining Table', 'table_plasto_bigsquare*7', 's', 2, 2, 1, '1', '0', '0', 106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(90, 'Round Dining Table', 'table_plasto_round*7', 's', 2, 2, 1, '1', '0', '0', 107, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(91, 'Square Dining Table', 'table_plasto_square*7', 's', 1, 1, 1, '1', '0', '0', 108, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(92, 'Chair', 'chair_plasto*7', 's', 1, 1, 1, '0', '1', '0', 109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(93, 'Occasional Table', 'table_plasto_4leg*8', 's', 2, 2, 1, '1', '0', '0', 110, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(94, 'Square Dining Table', 'table_plasto_bigsquare*8', 's', 2, 2, 1, '1', '0', '0', 111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95, 'Round Dining Table', 'table_plasto_round*8', 's', 2, 2, 1, '1', '0', '0', 112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(96, 'Square Dining Table', 'table_plasto_square*8', 's', 1, 1, 1, '1', '0', '0', 113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(97, 'Chair', 'chair_plasto*8', 's', 1, 1, 1, '0', '1', '0', 114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(98, 'Occasional Table', 'table_plasto_4leg*9', 's', 2, 2, 1, '1', '0', '0', 115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99, 'Square Dining Table', 'table_plasto_bigsquare*9', 's', 2, 2, 1, '1', '0', '0', 116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(100, 'Square Dining Table', 'table_plasto_round*9', 's', 2, 2, 1, '1', '0', '0', 117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(101, 'Chair', 'chair_plasto*9', 's', 1, 1, 1, '0', '1', '0', 119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(102, 'Floor Rug', 'carpet_standard*6', 's', 3, 5, 0, '1', '0', '1', 120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(103, 'Plastic Pod Chair', 'chair_plasty*1', 's', 1, 1, 1, '0', '1', '0', 121, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(104, 'Pizza Box', 'pizza', 's', 1, 1, 1, '0', '0', '0', 122, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(105, 'Empty Cans', 'drinks', 's', 1, 1, 1, '0', '0', '0', 123, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(106, 'Plastic Pod Chair', 'chair_plasty*2', 's', 1, 1, 1, '0', '1', '0', 124, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(107, 'Plastic Pod Chair', 'chair_plasty*3', 's', 1, 1, 1, '0', '1', '0', 125, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(108, 'Plastic Pod Chair', 'chair_plasty*4', 's', 1, 1, 1, '0', '1', '0', 126, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(109, 'Mini-Bar', 'bar_polyfon', 's', 1, 1, 1, '0', '0', '0', 127, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,5,2,1', ''),
(110, 'Aloe Vera', 'plant_cruddy', 's', 1, 1, 1, '0', '0', '0', 128, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(111, 'Empty Spinning Bottle', 'bottle', 's', 1, 1, 1, '0', '0', '0', 129, '1', '1', '1', '1', '1', 'bottle', 0, '0', ''),
(112, 'Bar/desk', 'bardesk_polyfon', 's', 2, 1, 1, '1', '0', '0', 130, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(113, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon', 's', 1, 1, 1, '1', '0', '0', 131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(115, 'Barrel Minibar', 'bar_armas', 's', 1, 1, 1, '0', '0', '0', 133, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,2,1', ''),
(116, 'Bardesk', 'bartable_armas', 's', 1, 3, 1.2, '1', '0', '0', 134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(117, 'Barrel Stool', 'bar_chair_armas', 's', 1, 1, 1.2, '0', '1', '0', 135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(118, 'Soft Wool Rug', 'carpet_soft', 's', 2, 4, 0, '1', '0', '1', 136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(119, 'Soft Wool Rug', 'carpet_soft*1', 's', 2, 4, 0, '1', '0', '1', 137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(120, 'Soft Wool Rug', 'carpet_soft*2', 's', 2, 4, 0, '1', '0', '1', 138, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(121, 'Soft Wool Rug', 'carpet_soft*3', 's', 2, 4, 0, '1', '0', '1', 139, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(122, 'Soft Wool Rug', 'carpet_soft*4', 's', 2, 4, 0, '1', '0', '1', 140, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(123, 'Soft Wool Rug', 'carpet_soft*5', 's', 2, 4, 0, '1', '0', '1', 141, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(124, 'Soft Wool Rug', 'carpet_soft*6', 's', 2, 4, 0, '1', '0', '1', 143, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(125, 'Portable TV', 'red_tv', 's', 1, 1, 1, '0', '0', '0', 144, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(126, 'Large TV', 'wood_tv', 's', 1, 2, 1, '0', '0', '0', 145, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(127, 'Pink Faux-Fur Bear Rug', 'carpet_polar*1', 's', 2, 3, 0, '1', '0', '1', 146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(128, 'Plastic Pod Chair', 'chair_plasty*5', 's', 1, 1, 1, '0', '1', '0', 147, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(129, 'Blue Bear Rug', 'carpet_polar*2', 's', 2, 3, 0, '1', '0', '1', 148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(130, 'Yellow Bear Rug', 'carpet_polar*3', 's', 2, 3, 0, '1', '0', '1', 149, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(131, 'Green Bear Rug', 'carpet_polar*4', 's', 2, 3, 0, '1', '0', '1', 150, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(132, 'Plastic Pod Chair', 'chair_plasty*6', 's', 1, 1, 1, '0', '1', '0', 151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(133, 'Large Coffee Table', 'table_polyfon', 's', 2, 2, 1, '1', '0', '0', 152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(134, 'Large Dining Table', 'smooth_table_polyfon', 's', 2, 2, 1, '1', '0', '0', 153, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(135, 'Armchair', 'sofachair_polyfon_girl', 's', 1, 1, 1.1, '0', '1', '0', 154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(136, 'Single Bed', 'bed_polyfon_girl_one', 's', 1, 3, 1.8, '0', '0', '0', 155, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(137, 'Double Bed', 'bed_polyfon_girl', 's', 2, 3, 1.8, '0', '0', '0', 156, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(138, 'Two-seater Sofa', 'sofa_polyfon_girl', 's', 2, 1, 1.1, '0', '1', '0', 157, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(139, 'Plain Single Bed', 'bed_budgetb_one', 's', 1, 3, 1.9, '0', '0', '0', 158, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(140, 'Plain Double Bed', 'bed_budgetb', 's', 2, 3, 1.9, '0', '0', '0', 159, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(141, 'Pineapple Plant', 'plant_pineapple', 's', 1, 1, 1, '0', '0', '0', 160, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(142, 'Fruit Tree', 'plant_fruittree', 's', 1, 1, 1, '0', '0', '0', 161, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(143, 'Small Cactus', 'plant_small_cactus', 's', 1, 1, 1, '0', '0', '0', 162, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(144, 'Bonsai Tree', 'plant_bonsai', 's', 1, 1, 1, '0', '0', '0', 163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(145, 'Mature Cactus', 'plant_big_cactus', 's', 1, 1, 1, '0', '0', '0', 164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(146, 'Yukka Plant', 'plant_yukka', 's', 1, 1, 1, '0', '0', '0', 165, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(147, 'Floor Rug', 'carpet_standard*7', 's', 3, 5, 0, '1', '0', '1', 166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(148, 'Floor Rug', 'carpet_standard*8', 's', 3, 5, 0, '1', '0', '1', 167, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(149, 'Floor Rug', 'carpet_standard*9', 's', 3, 5, 0, '1', '0', '1', 168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(150, 'Floor Rug', 'carpet_standard*10', 's', 3, 5, 0, '1', '0', '1', 169, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(151, 'Floor Rug', 'carpet_standard*11', 's', 3, 5, 0, '1', '0', '1', 170, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(152, 'Cut Sunflower', 'plant_sunflower', 's', 1, 1, 1, '0', '0', '0', 171, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(153, 'Cut Roses', 'plant_rose', 's', 1, 1, 1, '0', '0', '0', 172, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(154, 'Digital TV', 'tv_luxus', 's', 1, 3, 1, '0', '0', '0', 173, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(155, 'Bubble Bath', 'bath', 's', 1, 2, 1, '0', '1', '0', 174, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(156, 'Sink', 'sink', 's', 1, 1, 1, '0', '0', '0', 177, '1', '1', '1', '1', '1', 'vendingmachine', 0, '100', ''),
(157, 'Loo Seat', 'toilet', 's', 1, 1, 1.2, '0', '1', '0', 178, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(158, 'Rubber Duck', 'duck', 's', 1, 1, 1, '0', '0', '0', 179, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(159, 'Floor Tiles', 'tile', 's', 4, 4, 0, '1', '0', '1', 180, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(160, 'Loo Seat', 'toilet_red', 's', 1, 1, 1.2, '0', '1', '0', 181, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(161, 'Loo Seat', 'toilet_yell', 's', 1, 1, 1.2, '0', '1', '0', 182, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(162, 'Floor Tiles', 'tile_red', 's', 4, 4, 0, '1', '0', '1', 183, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(163, 'Floor Tiles', 'tile_yell', 's', 4, 4, 0, '1', '0', '1', 184, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(164, 'Gift', 'present_gen', 's', 1, 1, 1, '1', '0', '0', 187, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(165, 'Gift', 'present_gen1', 's', 1, 1, 1, '1', '0', '0', 188, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(166, 'Gift', 'present_gen2', 's', 1, 1, 1, '1', '0', '0', 189, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(167, 'Gift', 'present_gen3', 's', 1, 1, 1, '1', '0', '0', 190, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(168, 'Gift', 'present_gen4', 's', 1, 1, 1, '1', '0', '0', 191, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(169, 'Gift', 'present_gen5', 's', 1, 1, 1, '1', '0', '0', 192, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(170, 'Gift', 'present_gen6', 's', 1, 1, 1, '1', '0', '0', 193, '1', '0', '1', '1', '1', 'default', 1, '0', ''),
(171, 'A Pura Minibar', 'bar_basic', 's', 1, 1, 1, '0', '0', '0', 195, '1', '1', '1', '1', '1', 'vendingmachine', 0, '6,2,5,1', ''),
(172, 'Pura Shelves', 'shelves_basic', 's', 2, 1, 1, '0', '0', '0', 196, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(173, 'iced sofachair', 'soft_sofachair_norja', 's', 1, 1, 1, '0', '1', '0', 197, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(174, 'iced sofa', 'soft_sofa_norja', 's', 2, 1, 1, '0', '1', '0', 198, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(175, 'Pura Lamp', 'lamp_basic', 's', 1, 1, 1, '0', '0', '0', 199, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(176, 'Lodge Candle', 'lamp2_armas', 's', 1, 1, 1, '0', '0', '0', 200, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(177, 'Pura Refridgerator', 'fridge', 's', 1, 1, 1, '0', '0', '0', 201, '1', '1', '1', '1', '1', 'vendingmachine', 0, '3,5,6,2', ''),
(178, 'Telephone Box', 'door', 's', 1, 1, 0.001, '0', '0', '0', 202, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(179, 'Wardrobe', 'doorB', 's', 1, 1, 0.001, '0', '0', '0', 204, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(180, 'Portaloo', 'doorC', 's', 1, 1, 0.001, '0', '0', '0', 205, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(181, 'Pumpkin Lamp', 'pumpkin', 's', 1, 1, 1, '1', '0', '0', 206, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(182, 'Skull Candle Holder', 'skullcandle', 's', 1, 1, 1, '0', '0', '0', 207, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(183, 'Blood', 'deadduck', 's', 1, 1, 1, '0', '0', '0', 208, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(184, 'Dead Duck 2', 'deadduck2', 's', 1, 1, 1, '0', '0', '0', 209, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(185, 'Dead Duck 3', 'deadduck3', 's', 1, 1, 1, '0', '0', '0', 210, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(186, 'Menorah', 'menorah', 's', 1, 1, 1, '0', '0', '0', 211, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(187, 'Christmas Pudding', 'pudding', 's', 1, 1, 1, '1', '0', '0', 212, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(188, 'Joint of Ham', 'ham', 's', 1, 1, 1, '0', '0', '0', 213, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(189, 'Roast Turkey', 'turkey', 's', 1, 1, 1, '0', '0', '0', 214, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(190, 'Christmas Rubber Duck', 'xmasduck', 's', 1, 1, 1, '1', '0', '0', 215, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(191, 'Gingerbread House', 'house', 's', 1, 1, 1, '0', '0', '0', 216, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(192, 'Electric Candles', 'triplecandle', 's', 1, 1, 1, '0', '0', '0', 217, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(193, 'Christmas Tree 1', 'tree3', 's', 1, 1, 1, '0', '0', '0', 218, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(194, 'Christmas Tree 2', 'tree4', 's', 1, 1, 1, '0', '0', '0', 219, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(195, 'Christmas Tree 3', 'tree5', 's', 1, 1, 1, '0', '0', '0', 220, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(196, 'Eaten Ham', 'ham2', 's', 1, 1, 1, '0', '0', '0', 223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(197, 'White Candle Plate', 'wcandleset', 's', 1, 1, 1, '0', '0', '0', 224, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(198, 'Red Candle Plate', 'rcandleset', 's', 1, 1, 1, '0', '0', '0', 225, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(199, 'Giant Heart', 'statue', 's', 1, 1, 1, '0', '0', '0', 226, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(200, 'Valentine''s Duck', 'valeduck', 's', 1, 1, 1, '0', '0', '0', 228, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(201, 'Heart Sofa', 'heartsofa', 's', 2, 1, 1, '0', '1', '0', 229, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(202, 'Throne', 'throne', 's', 1, 1, 1, '0', '1', '0', 230, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(203, 'Russian Samovar', 'samovar', 's', 1, 1, 1, '0', '0', '0', 231, '0', '1', '1', '1', '1', 'vendingmachine', 0, '1', ''),
(204, 'Vase of Flowers', 'giftflowers', 's', 1, 1, 1, '0', '0', '0', 232, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(205, 'Cake', 'habbocake', 's', 1, 1, 1, '0', '0', '0', 233, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(206, 'Holopod', 'hologram', 's', 1, 1, 1, '0', '0', '0', 234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(207, 'Wannabe bunny', 'easterduck', 's', 1, 1, 1, '0', '0', '0', 235, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(208, 'Squidgy Bunny', 'bunny', 's', 1, 1, 1, '0', '0', '0', 236, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(209, 'Basket Of Eggs', 'basket', 's', 1, 1, 1, '0', '0', '0', 237, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(210, 'Pop-up Egg', 'birdie', 's', 1, 1, 1, '0', '0', '0', 238, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(211, 'Holo-dice', 'edice', 's', 1, 1, 1, '0', '0', '0', 239, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(212, 'Club sofa', 'club_sofa', 's', 2, 1, 1, '0', '1', '0', 267, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(213, 'Gold Trophy', 'a0 prize1', 's', 1, 1, 1, '0', '0', '0', 241, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(214, 'Silver Trophy', 'a0 prize2', 's', 1, 1, 1, '0', '0', '0', 242, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(215, 'Bronze Trophy', 'a0 prize3', 's', 1, 1, 1, '0', '0', '0', 243, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(216, 'Hatch (Lockable)', 'divider_poly3', 's', 1, 1, 0.001, '0', '0', '0', 244, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(217, 'Corner plinth', 'divider_arm1', 's', 1, 1, 1.4, '1', '0', '0', 245, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(218, 'Room divider', 'divider_arm2', 's', 2, 1, 1, '0', '0', '0', 246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(219, 'Knock', 'divider_arm3', 's', 1, 1, 0.001, '0', '0', '0', 247, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(220, 'Looks squishy', 'divider_nor1', 's', 1, 1, 1, '0', '0', '0', 248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(221, 'Corner Shelf', 'divider_silo1', 's', 1, 1, 1, '0', '0', '0', 249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(222, 'Strong', 'divider_nor2', 's', 2, 1, 1, '0', '0', '0', 250, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(223, 'Screen', 'divider_silo2', 's', 2, 1, 1, '0', '0', '0', 251, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(224, 'Door (Lockable)', 'divider_nor3', 's', 1, 1, 0.001, '0', '0', '0', 252, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(225, 'Gate (lockable)', 'divider_silo3', 's', 1, 1, 0.001, '0', '0', '0', 253, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(226, 'Typewriter', 'typingmachine', 's', 1, 1, 1, '0', '0', '0', 254, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(227, 'Dragon Egg', 'spyro', 's', 1, 1, 1, '0', '0', '0', 260, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(228, 'Holo-girl', 'redhologram', 's', 1, 1, 1, '0', '0', '0', 261, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(230, 'Poinsetta', 'joulutahti', 's', 1, 1, 1, '0', '0', '0', 264, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(231, 'Pink Hyacinth', 'hyacinth1', 's', 1, 1, 1, '0', '0', '0', 265, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(232, 'Blue Hyacinth', 'hyacinth2', 's', 1, 1, 1, '0', '0', '0', 266, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(233, 'Chair', 'chair_plasto*10', 's', 1, 1, 1, '0', '1', '0', 268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(234, 'Chair', 'chair_plasto*11', 's', 1, 1, 1, '0', '1', '0', 269, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(235, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*12', 's', 1, 1, 1, '1', '0', '0', 270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(236, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*13', 's', 1, 1, 1, '1', '0', '0', 271, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(237, 'Chair', 'chair_plasto*12', 's', 1, 1, 1, '0', '1', '0', 273, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(238, 'Chair', 'chair_plasto*13', 's', 1, 1, 1, '0', '1', '0', 274, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(239, 'HC chair', 'chair_plasto*14', 's', 1, 1, 1, '0', '1', '0', 275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(240, 'HC table', 'table_plasto_4leg*14', 's', 2, 2, 1, '1', '0', '0', 276, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(241, 'Mochamaster', 'mocchamaster', 's', 1, 1, 1, '1', '0', '0', 277, '1', '1', '1', '1', '1', 'vendingmachine', 0, '9,8,14,15,6,10,11,12,17,13', ''),
(242, 'Basketball Court', 'carpet_legocourt', 's', 3, 3, 0, '1', '0', '1', 278, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(243, 'Team Bench', 'bench_lego', 's', 4, 1, 1, '0', '1', '0', 279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(244, 'Basketball Trophy', 'legotrophy', 's', 1, 1, 1, '0', '0', '0', 280, '1', '1', '1', '1', '0', 'trophy', 2, '0', ''),
(245, 'Holiday Romance', 'valentinescreen', 's', 2, 1, 0.1, '0', '0', '1', 283, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(246, 'Dicemaster', 'edicehc', 's', 1, 1, 1, '0', '0', '0', 284, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(247, 'Petal Patch', 'rare_daffodil_rug', 's', 2, 2, 0, '1', '0', '1', 285, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(248, 'Blue Amber Lamp', 'rare_beehive_bulb', 's', 1, 1, 1, '0', '0', '0', 286, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(249, 'Throne Sofa', 'hcsohva', 's', 2, 1, 1, '0', '1', '0', 287, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(250, 'Tubmaster', 'hcamme', 's', 1, 2, 0.6, '0', '1', '0', 288, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(251, 'Golden Elephant', 'rare_elephant_statue', 's', 1, 1, 1, '0', '0', '0', 290, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(252, 'Bird Bath (red)', 'rare_fountain', 's', 1, 1, 1, '0', '0', '0', 291, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(253, 'Speaker''s Corner', 'rare_stand', 's', 1, 1, 1.7, '0', '1', '0', 292, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(254, 'Snow Globe', 'rare_globe', 's', 1, 1, 1, '0', '0', '0', 293, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(255, 'Hammock', 'rare_hammock', 's', 1, 3, 1.57, '0', '0', '0', 294, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(256, 'Silver Elephant', 'rare_elephant_statue*1', 's', 1, 1, 1, '0', '0', '0', 295, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(257, 'Bronze Elephant', 'rare_elephant_statue*2', 's', 1, 1, 1, '0', '0', '0', 296, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(258, 'Bird Bath (grey)', 'rare_fountain*1', 's', 1, 1, 1, '0', '0', '0', 297, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(259, 'Bird Bath (green)', 'rare_fountain*2', 's', 1, 1, 1, '0', '0', '0', 298, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(260, 'Bird Bath (blue)', 'rare_fountain*3', 's', 1, 1, 1, '0', '0', '0', 299, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(261, 'Red Amber Lamp', 'rare_beehive_bulb*1', 's', 1, 1, 1, '0', '0', '0', 300, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(262, 'Yellow Amber Lamp', 'rare_beehive_bulb*2', 's', 1, 1, 1, '0', '0', '0', 301, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(263, 'Lappland Greetings', 'rare_xmas_screen', 's', 2, 1, 0, '0', '0', '1', 302, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(264, 'Yellow Parasol', 'rare_parasol*1', 's', 1, 1, 1, '0', '0', '0', 303, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(265, 'Orange Parasol', 'rare_parasol*2', 's', 1, 1, 1, '0', '0', '0', 304, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(266, 'Violet Parasol', 'rare_parasol*3', 's', 1, 1, 1, '0', '0', '0', 305, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(267, 'Dead tree', 'tree1', 's', 1, 1, 1, '0', '0', '0', 1758, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(269, 'White Candle', 'wcandle', 's', 1, 1, 1, '0', '0', '0', 2102, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(270, 'Red Candle', 'rcandle', 's', 1, 1, 1, '0', '0', '0', 2121, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(272, 'Gingerbread House', 'house2', 's', 1, 1, 1, '0', '0', '0', 428, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(273, 'Habbo Turntable', 'djesko_turntable', 's', 1, 1, 1, '0', '0', '0', 449, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(275, 'Habbo Cola Machine', 'md_limukaappi', 's', 1, 1, 1, '0', '0', '0', 457, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(276, 'Occasional Table', 'table_plasto_4leg*10', 's', 2, 2, 1, '1', '0', '0', 1484, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(277, 'Occasional Table', 'table_plasto_4leg*15', 's', 2, 2, 1, '1', '0', '0', 1486, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(278, 'Occasional Table', 'table_plasto_bigsquare*14', 's', 2, 2, 1, '1', '0', '0', 1487, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(279, 'Occasional Table', 'table_plasto_bigsquare*15', 's', 2, 2, 1, '1', '0', '0', 1488, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(280, 'Occasional Table', 'table_plasto_round*14', 's', 2, 2, 1, '1', '0', '0', 1489, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(281, 'Occasional Table', 'table_plasto_round*15', 's', 2, 2, 1, '1', '0', '0', 1490, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(282, 'Occasional Table', 'table_plasto_square*14', 's', 1, 1, 1, '1', '0', '0', 1491, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(283, 'Occasional Table', 'table_plasto_square*15', 's', 1, 1, 1, '1', '0', '0', 1492, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(284, 'Chair', 'chair_plasto*15', 's', 1, 1, 1, '0', '1', '0', 1495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(285, 'Plastic Pod Chair', 'chair_plasty*7', 's', 1, 1, 1, '0', '1', '0', 1496, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(286, 'Plastic Pod Chair', 'chair_plasty*8', 's', 1, 1, 1, '0', '1', '0', 1497, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(287, 'Plastic Pod Chair', 'chair_plasty*9', 's', 1, 1, 1, '0', '1', '0', 1498, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(288, 'Plastic Pod Chair', 'chair_plasty*10', 's', 1, 1, 1, '0', '1', '0', 1499, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(289, 'Plastic Pod Chair', 'chair_plasty*11', 's', 1, 1, 1, '0', '1', '0', 1500, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(290, 'Chair', 'chair_plasto*16', 's', 1, 1, 1, '0', '1', '0', 1501, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(291, 'Occasional Table', 'table_plasto_4leg*16', 's', 2, 2, 1, '1', '0', '0', 1502, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(292, 'Scoreboard', 'hockey_score', 's', 1, 1, 1, '0', '0', '0', 1503, '1', '1', '1', '1', '1', 'scoreboard', 100, '0', ''),
(293, 'Lert', 'hockey_light', 's', 1, 1, 1, '0', '0', '0', 1504, '1', '1', '1', '1', '1', 'alert', 2, '0', ''),
(294, 'Imperial Teleport', 'doorD', 's', 1, 1, 0.001, '0', '0', '0', 1505, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(295, 'Duck trophy', 'a0 prizetrophy2_b', 's', 1, 1, 1, '0', '0', '0', 1506, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(296, 'Globe trophy', 'a0 prizetrophy3_b', 's', 1, 1, 1, '0', '0', '0', 1507, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(297, 'Fish trophy', 'a0 prizetrophy4_b', 's', 1, 1, 1, '0', '0', '0', 1508, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(298, 'Champion trophy', 'a0 prizetrophy5_b', 's', 1, 1, 1, '0', '0', '0', 1509, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(299, 'Classic trophy', 'prizetrophy*1', 's', 1, 1, 1, '0', '0', '0', 1512, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(300, 'Duck trophy', 'a0 prizetrophy2_g', 's', 1, 1, 1, '0', '0', '0', 1512, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(301, 'Globe trophy', 'a0 prizetrophy3_g', 's', 1, 1, 1, '0', '0', '0', 1513, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(302, 'Fish trophy', 'a0 prizetrophy4_g', 's', 1, 1, 1, '0', '0', '0', 1514, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(303, 'Duo trophy', 'a0 prizetrophy5_g', 's', 1, 1, 1, '0', '0', '0', 1515, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(304, 'Champion trophy', 'a0 prizetrophy6_g', 's', 1, 1, 1, '0', '0', '0', 1516, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(305, 'Classic trophy', 'prizetrophy*2', 's', 1, 1, 1, '0', '0', '0', 1519, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(306, 'Duck trophy', 'a0 prizetrophy2_s', 's', 1, 1, 1, '0', '0', '0', 1518, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(307, 'Globe trophy', 'a0 prizetrophy3_s', 's', 1, 1, 1, '0', '0', '0', 1519, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(308, 'Fish trophy', 'a0 prizetrophy4_s', 's', 1, 1, 1, '0', '0', '0', 1520, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(309, 'Duo trophy', 'a0 prizetrophy5_s', 's', 1, 1, 1, '0', '0', '0', 1521, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(310, 'Champion trophy', 'a0 prizetrophy6_s', 's', 1, 1, 1, '0', '0', '0', 1522, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(311, 'Classic trophy', 'prizetrophy*3', 's', 1, 1, 1, '0', '0', '0', 1526, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(312, 'Green Parasol', 'rare_parasol*0', 's', 1, 1, 1, '0', '0', '0', 289, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(313, 'Oil Lamp', 'hc_lmp', 's', 1, 1, 1, '0', '0', '0', 1529, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(314, 'Nordic Table', 'hc_tbl', 's', 1, 3, 1, '1', '0', '0', 1528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(315, 'Majestic Chair', 'hc_chr', 's', 1, 1, 1, '0', '1', '0', 1527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(316, 'Study Desk', 'hc_dsk', 's', 1, 2, 1, '0', '0', '0', 1530, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(317, 'Night', 'nest', 's', 1, 1, 1, '1', '0', '0', 1531, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(318, 'Bones Mega Multipack', 'petfood1', 's', 1, 1, 1, '1', '0', '0', 1532, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(319, 'Sardines Mega Multipack', 'petfood2', 's', 1, 1, 1, '1', '0', '0', 1533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(320, 'Cabbage Mega Multipack', 'petfood3', 's', 1, 1, 1, '1', '0', '0', 1534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(321, 'Blue Water Bowl', 'waterbowl*4', 's', 1, 1, 1, '1', '0', '0', 1535, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(322, 'Brown Water Bowl', 'waterbowl*5', 's', 1, 1, 1, '1', '0', '0', 1536, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(323, 'Green Water Bowl', 'waterbowl*2', 's', 1, 1, 1, '1', '0', '0', 1537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(324, 'Red Water Bowl', 'waterbowl*1', 's', 1, 1, 1, '1', '0', '0', 1538, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(325, 'Yellow Water Bowl', 'waterbowl*3', 's', 1, 1, 1, '1', '0', '0', 1539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(326, 'Rubber Ball', 'toy1', 's', 1, 1, 1, '1', '0', '0', 1540, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(327, 'Rubber Ball', 'toy1*1', 's', 1, 1, 1, '1', '0', '0', 1541, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(328, 'Rubber Ball', 'toy1*2', 's', 1, 1, 1, '1', '0', '0', 1542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(329, 'Rubber Ball', 'toy1*3', 's', 1, 1, 1, '1', '0', '0', 1543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(330, 'Rubber Ball', 'toy1*4', 's', 1, 1, 1, '1', '0', '0', 1544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(331, 'Marzipan Man', 'goodie1', 's', 1, 1, 1, '1', '0', '0', 1545, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(332, 'Marzipan Man', 'goodie1*1', 's', 1, 1, 1, '1', '0', '0', 1546, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(333, 'Marzipan Man', 'goodie1*2', 's', 1, 1, 1, '1', '0', '0', 1547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(334, 'Chocolate Mouse', 'goodie2', 's', 1, 1, 1, '1', '0', '0', 1548, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(335, 'Bronze Habbo trophy', 'a0 prizetrophy7_b', 's', 1, 1, 1, '0', '0', '0', 1547, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(336, 'Gold Habbo trophy', 'a0 prizetrophy7_g', 's', 1, 1, 1, '0', '0', '0', 1548, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(337, 'Silver Habbo trophy', 'a0 prizetrophy7_s', 's', 1, 1, 1, '0', '0', '0', 1549, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(338, 'Red Laser Door', 'scifiport*0', 's', 1, 1, 0.001, '0', '0', '0', 1549, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(339, 'Violet Sci-Fi Port', 'scifiport*9', 's', 1, 1, 0.001, '0', '0', '0', 1550, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(340, 'Purple Sci-Fi Port', 'scifiport*8', 's', 1, 1, 0.001, '0', '0', '0', 1551, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(341, 'Aqua Laser Gate', 'scifiport*7', 's', 1, 1, 0.001, '0', '0', '0', 1552, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(342, 'White Sci-Fi Port', 'scifiport*6', 's', 1, 1, 0.001, '0', '0', '0', 1553, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(343, 'Security Fence', 'scifiport*5', 's', 1, 1, 0.001, '0', '0', '0', 1554, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(344, 'Pink Sci-Fi Port', 'scifiport*4', 's', 1, 1, 0.001, '0', '0', '0', 1555, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(345, 'Jade Sci-Fi Port', 'scifiport*3', 's', 1, 1, 0.001, '0', '0', '0', 1556, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(346, 'Blue Laser Gate', 'scifiport*2', 's', 1, 1, 0.001, '0', '0', '0', 1557, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(347, 'Gold Laser Gate', 'scifiport*1', 's', 1, 1, 0.001, '0', '0', '0', 1558, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(348, 'Neptune Smoke Machine', 'scifirocket*9', 's', 1, 1, 1, '0', '0', '0', 1559, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(349, 'From a space far', 'scifirocket*8', 's', 1, 1, 1, '0', '0', '0', 1560, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(350, 'Jupiter Smoke Machine', 'scifirocket*7', 's', 1, 1, 1, '0', '0', '0', 1561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(351, 'Mercury Smoke Machine', 'scifirocket*6', 's', 1, 1, 1, '0', '0', '0', 1562, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(352, 'Uranus Smoke Machine', 'scifirocket*5', 's', 1, 1, 1, '0', '0', '0', 1563, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(353, 'Venus Smoke Machine', 'scifirocket*4', 's', 1, 1, 1, '0', '0', '0', 1564, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(354, 'Endor Smoke Machine', 'scifirocket*3', 's', 1, 1, 1, '0', '0', '0', 1565, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(355, 'Earth Smoke Machine', 'scifirocket*2', 's', 1, 1, 1, '0', '0', '0', 1566, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(356, 'Saturn Smoke Machine', 'scifirocket*1', 's', 1, 1, 1, '0', '0', '0', 1567, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(357, 'Mars Smoke Machine', 'scifirocket*0', 's', 1, 1, 1, '0', '0', '0', 1568, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(358, 'Violet Starship Door', 'scifidoor*10', 's', 1, 1, 0.001, '0', '0', '0', 1569, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(359, 'It''s blue', 'scifidoor*9', 's', 1, 1, 0.001, '0', '0', '0', 1570, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(360, 'Purple Spaceship Door', 'scifidoor*8', 's', 1, 1, 0.001, '0', '0', '0', 1571, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(361, 'Aqua Spaceship Door', 'scifidoor*7', 's', 1, 1, 0.001, '0', '0', '0', 1572, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(362, 'Black Monolith', 'scifidoor*6', 's', 1, 1, 0.001, '0', '0', '0', 1573, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(363, 'White Spaceship Door', 'scifidoor*5', 's', 1, 1, 0.001, '0', '0', '0', 1574, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(364, 'Emerald Spaceship Door', 'scifidoor*4', 's', 1, 1, 0.001, '0', '0', '0', 1575, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(365, 'Lightblue Spaceship Door', 'scifidoor*3', 's', 1, 1, 0.001, '0', '0', '0', 1576, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(366, 'Yellow Spaceship Door', 'scifidoor*2', 's', 1, 1, 0.001, '0', '0', '0', 1577, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(367, 'Pink Spaceship Door', 'scifidoor*1', 's', 1, 1, 0.001, '0', '0', '0', 1578, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(368, 'Puffy', 'pillow*5', 's', 1, 1, 1, '0', '1', '0', 1579, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(369, 'Puffy', 'pillow*8', 's', 1, 1, 1, '0', '1', '0', 1580, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(370, 'White Lace Pillow', 'pillow*0', 's', 1, 1, 1, '0', '1', '0', 1581, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(371, 'Puffy', 'pillow*1', 's', 1, 1, 1, '0', '1', '0', 1582, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(372, 'Puffy', 'pillow*2', 's', 1, 1, 1, '0', '1', '0', 1583, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(373, 'Purple Velvet Pillow', 'pillow*7', 's', 1, 1, 1, '0', '1', '0', 1584, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(374, 'Puffy', 'pillow*9', 's', 1, 1, 1, '0', '1', '0', 1585, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(375, 'Puffy', 'pillow*4', 's', 1, 1, 1, '0', '1', '0', 1586, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(376, 'Puffy', 'pillow*6', 's', 1, 1, 1, '0', '1', '0', 1587, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(377, 'Puffy', 'pillow*3', 's', 1, 1, 1, '0', '1', '0', 1588, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(378, 'Pink marquee', 'marquee*1', 's', 1, 1, 0.001, '0', '0', '0', 1589, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(379, 'Red Dragon Marquee', 'marquee*2', 's', 1, 1, 0.001, '0', '0', '0', 1590, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(380, 'Purple Marquee', 'marquee*7', 's', 1, 1, 0.001, '0', '0', '0', 1591, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(381, 'White Marquee', 'marquee*10', 's', 1, 1, 0.001, '0', '0', '0', 1592, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(382, 'Ultramarine Marquee', 'marquee*8', 's', 1, 1, 0.001, '0', '0', '0', 1593, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(383, 'Green Marquee', 'marquee*9', 's', 1, 1, 0.001, '0', '0', '0', 1594, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(384, 'Graphite Marquee', 'marquee*5', 's', 1, 1, 0.001, '0', '0', '0', 1595, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(385, 'Yellow Marquee', 'marquee*4', 's', 1, 1, 0.001, '0', '0', '0', 1596, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(386, 'Blue Marquee', 'marquee*6', 's', 1, 1, 0.001, '0', '0', '0', 1597, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(387, 'Aqua Marquee', 'marquee*3', 's', 1, 1, 0.001, '0', '0', '0', 1598, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(388, 'Pink Oriental screen', 'wooden_screen*1', 's', 1, 2, 1, '0', '0', '0', 1599, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(389, 'RosewoodScreen', 'wooden_screen*2', 's', 1, 2, 1, '0', '0', '0', 1600, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(390, 'Purple Oriental Screen', 'wooden_screen*7', 's', 1, 2, 1, '0', '0', '0', 1601, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(391, 'White Oriental Screen', 'wooden_screen*0', 's', 1, 2, 1, '0', '0', '0', 1602, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(392, 'Night Blue Oriental Screen', 'wooden_screen*8', 's', 1, 2, 1, '0', '0', '0', 1603, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(393, 'Gray Oriental Screen', 'wooden_screen*5', 's', 1, 2, 1, '0', '0', '0', 1604, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(394, 'Green Oriental Screen', 'wooden_screen*9', 's', 1, 2, 1, '0', '0', '0', 1605, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(395, 'Golden Oriental Screen', 'wooden_screen*4', 's', 1, 2, 1, '0', '0', '0', 1606, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(396, 'Blue Oriental Screen', 'wooden_screen*6', 's', 1, 2, 1, '0', '0', '0', 1607, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(397, 'Terracotta Pillar', 'wooden_screen*3', 's', 1, 2, 1, '0', '0', '0', 1608, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(398, 'Pink Marble Pillar', 'pillar*1', 's', 1, 1, 1, '0', '0', '0', 1610, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(399, 'Rock Pillar', 'pillar*9', 's', 1, 1, 1, '0', '0', '0', 1611, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(400, 'Classy architect', 'pillar*0', 's', 1, 1, 1, '0', '0', '0', 1612, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(401, 'Roman Pillar', 'pillar*8', 's', 1, 1, 1, '0', '0', '0', 1613, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(402, 'Nordic Pillar', 'pillar*2', 's', 1, 1, 1, '0', '0', '0', 1614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(403, 'Pagan Pillar', 'pillar*5', 's', 1, 1, 1, '0', '0', '0', 1615, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(404, 'Dark Ages Pillar', 'pillar*4', 's', 1, 1, 1, '0', '0', '0', 1616, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(405, 'Atlantean Pillar', 'pillar*7', 's', 1, 1, 1, '0', '0', '0', 1617, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(406, 'blue pillar', 'pillar*3', 's', 1, 1, 1, '0', '0', '0', 1618, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(407, 'Serpent of Doom', 'rare_dragonlamp*4', 's', 1, 1, 1, '0', '0', '0', 1619, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(408, 'Fire Dragon Lamp', 'rare_dragonlamp*0', 's', 1, 1, 1, '0', '0', '0', 1620, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(409, 'Elf Green Dragon Lamp', 'rare_dragonlamp*5', 's', 1, 1, 1, '0', '0', '0', 1621, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(410, 'Jade Dragon Lamp', 'rare_dragonlamp*2', 's', 1, 1, 1, '0', '0', '0', 1622, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(411, 'Bronze Dragon Lamp', 'rare_dragonlamp*8', 's', 1, 1, 1, '0', '0', '0', 1623, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(412, 'Purple Dragon Lamp', 'rare_dragonlamp*9', 's', 1, 1, 1, '0', '0', '0', 1624, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(413, 'Sky Dragon Lamp', 'rare_dragonlamp*7', 's', 1, 1, 1, '0', '0', '0', 1625, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(414, 'Gold Dragon Lamp', 'rare_dragonlamp*6', 's', 1, 1, 1, '0', '0', '0', 1626, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(415, 'Sea Dragon Lamp', 'rare_dragonlamp*1', 's', 1, 1, 1, '0', '0', '0', 1627, '1', '1', '1', '1', '1', 'default', 2, '0', '');
INSERT INTO `furniture_old` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(416, 'Silver Dragon Lamp', 'rare_dragonlamp*3', 's', 1, 1, 1, '0', '0', '0', 1628, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(417, 'Blueberry Ice Cream Machine', 'rare_icecream*1', 's', 1, 1, 1, '0', '0', '0', 1629, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(418, 'Chocolate Ice Cream Machine', 'rare_icecream*7', 's', 1, 1, 1, '0', '0', '0', 1630, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(419, 'Peppermint Ice Cream Machine', 'rare_icecream*8', 's', 1, 1, 1, '0', '0', '0', 1631, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(420, 'Pistachio Ice Cream Machine', 'rare_icecream*2', 's', 1, 1, 1, '0', '0', '0', 1632, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(421, 'Toffee Ice Cream Machine', 'rare_icecream*6', 's', 1, 1, 1, '0', '0', '0', 1633, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(422, 'Bubblegum Ice Cream Machine', 'rare_icecream*9', 's', 1, 1, 1, '0', '0', '0', 1634, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(423, 'Blackcurrant Ice Cream Machine', 'rare_icecream*3', 's', 1, 1, 1, '0', '0', '0', 1635, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(424, 'Cherry Ice Cream Machine', 'rare_icecream*0', 's', 1, 1, 1, '0', '0', '0', 1636, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(425, 'Strawberry Ice Cream Machine', 'rare_icecream*4', 's', 1, 1, 1, '0', '0', '0', 1637, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(426, 'Vanilla Ice Cream Machine', 'rare_icecream*5', 's', 1, 1, 1, '0', '0', '0', 1638, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(427, 'Brown Powered Fan', 'rare_fan*7', 's', 1, 1, 1, '0', '0', '0', 1639, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(428, 'Ochre Powered Fan', 'rare_fan*6', 's', 1, 1, 1, '0', '0', '0', 1640, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(429, 'Fucsia Powered Fan', 'rare_fan*9', 's', 1, 1, 1, '0', '0', '0', 1641, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(430, 'Purple Dragon Skin Fan', 'rare_fan*3', 's', 1, 1, 1, '0', '0', '0', 1642, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(431, 'Festive Fan', 'rare_fan*0', 's', 1, 1, 1, '0', '0', '0', 1643, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(432, 'SUPERLOVE Fan', 'rare_fan*4', 's', 1, 1, 1, '0', '0', '0', 1644, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(433, 'Yellow Powered Fan', 'rare_fan*5', 's', 1, 1, 1, '0', '0', '0', 1645, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(434, 'Birthday Fan', 'rare_fan*1', 's', 1, 1, 1, '0', '0', '0', 1646, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(435, 'Stylish', 'rare_fan*8', 's', 1, 1, 1, '0', '0', '0', 1647, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(436, 'Green Powered Fan', 'rare_fan*2', 's', 1, 1, 1, '0', '0', '0', 1648, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(437, 'Ice Habbo Roller', 'queue_tile1*3', 's', 1, 1, 0.5, '1', '0', '1', 1649, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(438, 'Blue Habbo Roller', 'queue_tile1*6', 's', 1, 1, 0.5, '1', '0', '1', 1650, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(439, 'Gold Habbo Roller', 'queue_tile1*4', 's', 1, 1, 0.5, '1', '0', '1', 1651, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(440, 'Green Habbo Roller', 'queue_tile1*9', 's', 1, 1, 0.5, '1', '0', '1', 1652, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(441, 'Navy Habbo Roller', 'queue_tile1*8', 's', 1, 1, 0.5, '1', '0', '1', 1653, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(442, 'Knight Roller', 'queue_tile1*5', 's', 1, 1, 0.5, '1', '0', '1', 1654, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(443, 'Purple Habbo Roller', 'queue_tile1*7', 's', 1, 1, 0.5, '1', '0', '1', 1655, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(444, 'Red Habbo Roller', 'queue_tile1*2', 's', 1, 1, 0.5, '1', '0', '1', 1656, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(445, 'Pink Habbo Roller', 'queue_tile1*1', 's', 1, 1, 0.5, '1', '0', '1', 1657, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(446, 'White Quest Roller', 'queue_tile1*0', 's', 1, 1, 0.5, '1', '0', '1', 1658, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(448, 'Snow Rug', 'rare_snowrug', 's', 2, 2, 0, '1', '0', '1', 1738, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(449, 'Lantern', 'cn_lamp', 's', 1, 1, 1, '0', '0', '0', 1741, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(450, 'Chinese Sofa', 'cn_sofa', 's', 3, 1, 1, '0', '1', '0', 1742, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(451, 'Sport track straight', 'sporttrack1*1', 's', 2, 2, 0, '1', '0', '1', 1745, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(452, 'Sport track straight grass', 'sporttrack1*3', 's', 2, 2, 0, '1', '0', '1', 1747, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(453, 'Sport track straight asphalt', 'sporttrack1*2', 's', 2, 2, 0, '1', '0', '1', 1748, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(454, 'Sport corner tartan', 'sporttrack2*1', 's', 2, 2, 0, '1', '0', '1', 1750, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(455, 'Sport corner asphalt', 'sporttrack2*2', 's', 2, 2, 0, '1', '0', '1', 1751, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(456, 'Sport corner grass', 'sporttrack2*3', 's', 2, 2, 0, '1', '0', '1', 1752, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(457, 'Sport goal tartan', 'sporttrack3*1', 's', 2, 2, 0, '1', '0', '1', 1754, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(458, 'Sport goal asphalt', 'sporttrack3*2', 's', 2, 2, 0, '1', '0', '1', 1755, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(459, 'Sport goal grass', 'sporttrack3*3', 's', 2, 2, 0, '1', '0', '1', 1756, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(460, 'Football Lamp', 'footylamp', 's', 1, 1, 1, '0', '0', '0', 1757, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(461, 'Bar Stool', 'barchair_silo', 's', 1, 1, 1.2, '0', '1', '0', 1759, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(462, 'Habbos', 'divider_nor4*4', 's', 2, 1, 1, '0', '0', '0', 1760, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(463, 'Classic Traffic Light', 'traffic_light*1', 's', 1, 1, 1, '0', '0', '0', 1761, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(464, 'Blue Traffic Light', 'traffic_light*2', 's', 1, 1, 1, '0', '0', '0', 1762, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(465, 'Purple Traffic Light', 'traffic_light*3', 's', 1, 1, 1, '0', '0', '0', 1763, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(466, 'Yellow Traffic Light', 'traffic_light*4', 's', 1, 1, 1, '0', '0', '0', 1764, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(467, 'Red Traffic Light', 'traffic_light*6', 's', 1, 1, 1, '0', '0', '0', 1765, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(468, 'Blue Inflatable Chair', 'rubberchair*1', 's', 1, 1, 1, '0', '1', '0', 1766, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(469, 'Pink Inflatable Chair', 'rubberchair*2', 's', 1, 1, 1, '0', '1', '0', 1767, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(470, 'Orange Inflatable Chair', 'rubberchair*3', 's', 1, 1, 1, '0', '1', '0', 1768, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(471, 'Ocean Inflatable Chair', 'rubberchair*4', 's', 1, 1, 1, '0', '1', '0', 1769, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(472, 'Lime Inflatable Chair', 'rubberchair*5', 's', 1, 1, 1, '0', '1', '0', 1770, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(473, 'Violet Inflatable Chair', 'rubberchair*6', 's', 1, 1, 1, '0', '1', '0', 1771, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(474, 'Yellow Maze Barrier', 'barrier*1', 's', 1, 2, 1, '0', '0', '0', 1772, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(475, 'No trespassing', 'barrier*2', 's', 1, 2, 1, '0', '0', '0', 1773, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(476, 'No trespassing', 'barrier*3', 's', 1, 2, 1, '0', '0', '0', 1774, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(477, 'White Inflatable Chair', 'rubberchair*7', 's', 1, 1, 1, '0', '1', '0', 1775, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(478, 'Black Inflatable Chair', 'rubberchair*8', 's', 1, 1, 1, '0', '1', '0', 1776, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(479, 'Black Iced Table', 'table_norja_med*2', 's', 2, 2, 1, '1', '0', '0', 1777, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(480, 'White Iced Table', 'table_norja_med*3', 's', 2, 2, 1, '1', '0', '0', 1778, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(481, 'Urban Iced Coffee Table', 'table_norja_med*4', 's', 2, 2, 1, '1', '0', '0', 1779, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(482, 'Large Coffee Table Pink', 'table_norja_med*5', 's', 2, 2, 1, '1', '0', '0', 1780, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(483, 'Large Coffee Table Blue', 'table_norja_med*6', 's', 2, 2, 1, '1', '0', '0', 1781, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(484, 'Rural Iced Coffee Table', 'table_norja_med*7', 's', 2, 2, 1, '1', '0', '0', 1782, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(485, 'Large Coffee Table Yellow', 'table_norja_med*8', 's', 2, 2, 1, '1', '0', '0', 1783, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(486, 'Large Coffee Table Red', 'table_norja_med*9', 's', 2, 2, 1, '1', '0', '0', 1784, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(487, 'Black Iced Bench', 'couch_norja*2', 's', 2, 1, 1, '0', '1', '0', 1785, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(488, 'White Iced Bench', 'couch_norja*3', 's', 2, 1, 1, '0', '1', '0', 1786, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(489, 'Urban Iced Bench', 'couch_norja*4', 's', 2, 1, 1, '0', '1', '0', 1787, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(490, 'Pink Bench', 'couch_norja*5', 's', 2, 1, 1, '0', '1', '0', 1788, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(491, 'Blue Bench', 'couch_norja*6', 's', 2, 1, 1, '0', '1', '0', 1789, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(492, 'Rural Iced Bench', 'couch_norja*7', 's', 2, 1, 1, '0', '1', '0', 1790, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(493, 'Yellow Bench', 'couch_norja*8', 's', 2, 1, 1, '0', '1', '0', 1791, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(494, 'Red Bench', 'couch_norja*9', 's', 2, 1, 1, '0', '1', '0', 1792, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(495, 'Black Iced Bookcase', 'shelves_norja*2', 's', 1, 1, 1, '0', '0', '0', 1793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(496, 'Urban Iced Bookcase', 'shelves_norja*3', 's', 1, 1, 1, '0', '0', '0', 1794, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(497, 'Pink Bookcase', 'shelves_norja*5', 's', 1, 1, 1, '0', '0', '0', 1796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(498, 'Blue Bookcase', 'shelves_norja*6', 's', 1, 1, 1, '0', '0', '0', 1797, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(499, 'Rural Iced Bookcase', 'shelves_norja*7', 's', 1, 1, 1, '0', '0', '0', 1798, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(500, 'Yellow Bookcase', 'shelves_norja*8', 's', 1, 1, 1, '0', '0', '0', 1799, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(501, 'Red Bookcase', 'shelves_norja*9', 's', 1, 1, 1, '0', '0', '0', 1800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(502, 'Black Iced Chair', 'chair_norja*2', 's', 1, 1, 1, '0', '1', '0', 1801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(503, 'White Iced Chair', 'chair_norja*3', 's', 1, 1, 1, '0', '1', '0', 1802, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(504, 'Urban Iced Chair', 'chair_norja*4', 's', 1, 1, 1, '0', '1', '0', 1803, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(505, 'Pink Chair', 'chair_norja*5', 's', 1, 1, 1, '0', '1', '0', 1804, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(506, 'Blue Chair', 'chair_norja*6', 's', 1, 1, 1, '0', '1', '0', 1805, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(507, 'Rural Chair', 'chair_norja*7', 's', 1, 1, 1, '0', '1', '0', 1806, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(508, 'Yellow Chair', 'chair_norja*8', 's', 1, 1, 1, '0', '1', '0', 1807, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(509, 'Red Chair', 'chair_norja*9', 's', 1, 1, 1, '0', '1', '0', 1808, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(510, 'Black Iced Corner', 'divider_nor1*2', 's', 1, 1, 1, '0', '0', '0', 1809, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(511, 'Looks squishy', 'divider_nor1*3', 's', 1, 1, 1, '0', '0', '0', 1810, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(512, 'Urban Iced Corner', 'divider_nor1*4', 's', 1, 1, 1, '0', '0', '0', 1811, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(513, 'Pink Ice corner', 'divider_nor1*5', 's', 1, 1, 1, '0', '0', '0', 1812, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(514, 'Blue Ice corner', 'divider_nor1*6', 's', 1, 1, 1, '0', '0', '0', 1813, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(515, 'Rural Iced Corner', 'divider_nor1*7', 's', 1, 1, 1, '0', '0', '0', 1814, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(516, 'Yellow Ice corner', 'divider_nor1*8', 's', 1, 1, 1, '0', '0', '0', 1815, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(517, 'Red Ice corner', 'divider_nor1*9', 's', 1, 1, 1, '0', '0', '0', 1816, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(518, 'Black Iced Sofa', 'soft_sofa_norja*2', 's', 2, 1, 1, '0', '1', '0', 1817, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(519, 'Pristine white', 'soft_sofa_norja*3', 's', 2, 1, 1, '0', '1', '0', 1818, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(520, 'Urban Iced Sofa', 'soft_sofa_norja*4', 's', 2, 1, 1, '0', '1', '0', 1819, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(521, 'Pink Iced Sofa', 'soft_sofa_norja*5', 's', 2, 1, 1, '0', '1', '0', 1820, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(522, 'Blue Iced Sofa', 'soft_sofa_norja*6', 's', 2, 1, 1, '0', '1', '0', 1821, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(523, 'Rural Iced Sofa', 'soft_sofa_norja*7', 's', 2, 1, 1, '0', '1', '0', 1822, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(524, 'Yellow Iced Sofa', 'soft_sofa_norja*8', 's', 2, 1, 1, '0', '1', '0', 1823, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(525, 'Red Iced Sofa', 'soft_sofa_norja*9', 's', 2, 1, 1, '0', '1', '0', 1824, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(526, 'Black Iced Sofachair', 'soft_sofachair_norja*2', 's', 1, 1, 1, '0', '1', '0', 1825, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(527, 'White Iced Sofachair', 'soft_sofachair_norja*3', 's', 1, 1, 1, '0', '1', '0', 1826, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(528, 'Urban Iced Sofachair', 'soft_sofachair_norja*4', 's', 1, 1, 1, '0', '1', '0', 1827, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(529, 'Pink Iced Sofachair', 'soft_sofachair_norja*5', 's', 1, 1, 1, '0', '1', '0', 1828, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(530, 'Blue Iced Sofachair', 'soft_sofachair_norja*6', 's', 1, 1, 1, '0', '1', '0', 1829, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(531, 'Rural Iced Sofachair', 'soft_sofachair_norja*7', 's', 1, 1, 1, '0', '1', '0', 1830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(532, 'Yellow Iced Sofachair', 'soft_sofachair_norja*8', 's', 1, 1, 1, '0', '1', '0', 1831, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(533, 'Red Iced Sofachair', 'soft_sofachair_norja*9', 's', 1, 1, 1, '0', '1', '0', 1832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(534, 'Large', 'sofachair_silo*2', 's', 1, 1, 1.1, '0', '1', '0', 1833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(535, 'Large', 'sofachair_silo*3', 's', 1, 1, 1.1, '0', '1', '0', 1834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(536, 'Beige Area Armchair', 'sofachair_silo*4', 's', 1, 1, 1.1, '0', '1', '0', 1835, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(537, 'Pink Area Armchair', 'sofachair_silo*5', 's', 1, 1, 1.1, '0', '1', '0', 1836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(538, 'Blue Area Armchair', 'sofachair_silo*6', 's', 1, 1, 1.1, '0', '1', '0', 1837, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(539, 'Green Area Armchair', 'sofachair_silo*7', 's', 1, 1, 1.1, '0', '1', '0', 1838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(540, 'Large', 'sofachair_silo*8', 's', 1, 1, 1.1, '0', '1', '0', 1839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(541, 'Red Area Armchair', 'sofachair_silo*9', 's', 1, 1, 1.1, '0', '1', '0', 1840, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(542, 'Black Occasional Table', 'table_silo_small*2', 's', 1, 1, 1, '1', '0', '0', 1841, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(543, 'White Occasional Table', 'table_silo_small*3', 's', 1, 1, 1, '1', '0', '0', 1842, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(544, 'Beige Area Occasional Table', 'table_silo_small*4', 's', 1, 1, 1, '1', '0', '0', 1843, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(545, 'Pink Area Occasional Table', 'table_silo_small*5', 's', 1, 1, 1, '1', '0', '0', 1844, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(546, 'Blue Area Occasional Table', 'table_silo_small*6', 's', 1, 1, 1, '1', '0', '0', 1845, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(547, 'Green Area Occasional Table', 'table_silo_small*7', 's', 1, 1, 1, '1', '0', '0', 1846, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(548, 'Yellow Occasional Table', 'table_silo_small*8', 's', 1, 1, 1, '1', '0', '0', 1847, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(549, 'Red Area Occasional Table', 'table_silo_small*9', 's', 1, 1, 1, '1', '0', '0', 1848, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(550, 'Black Corner Shelf', 'divider_silo1*2', 's', 1, 1, 1, '0', '0', '0', 1849, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(551, 'White Corner Shelf', 'divider_silo1*3', 's', 1, 1, 1, '0', '0', '0', 1850, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(552, 'Beige Area Corner Shelf', 'divider_silo1*4', 's', 1, 1, 1, '0', '0', '0', 1851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(553, 'Pink Area Corner Shelf', 'divider_silo1*5', 's', 1, 1, 1, '0', '0', '0', 1852, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(554, 'Blue Area Corner Shelf', 'divider_silo1*6', 's', 1, 1, 1, '0', '0', '0', 1853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(555, 'Green Area Corner Shelf', 'divider_silo1*7', 's', 1, 1, 1, '0', '0', '0', 1854, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(556, 'Yellow Corner Shelf', 'divider_silo1*8', 's', 1, 1, 1, '0', '0', '0', 1855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(557, 'Red Area Corner Shelf', 'divider_silo1*9', 's', 1, 1, 1, '0', '0', '0', 1856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(558, 'Black Area Gate', 'divider_silo3*2', 's', 1, 1, 0.001, '0', '0', '0', 1857, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(559, 'White Area Gate', 'divider_silo3*3', 's', 1, 1, 0.001, '0', '0', '0', 1858, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(560, 'Beige Area Gate', 'divider_silo3*4', 's', 1, 1, 0.001, '0', '0', '0', 1859, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(561, 'Pink Area Gate', 'divider_silo3*5', 's', 1, 1, 0.001, '0', '0', '0', 1860, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(562, 'Blue Area Gate', 'divider_silo3*6', 's', 1, 1, 0.001, '0', '0', '0', 1861, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(563, 'Green Area Gate', 'divider_silo3*7', 's', 1, 1, 0.001, '0', '0', '0', 1862, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(564, 'Yellow Area Gate', 'divider_silo3*8', 's', 1, 1, 0.001, '0', '0', '0', 1863, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(565, 'Red Area Gate', 'divider_silo3*9', 's', 1, 1, 0.001, '0', '0', '0', 1864, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(566, 'Black Coffee Table', 'table_silo_med*2', 's', 2, 2, 1, '1', '0', '0', 1865, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(567, 'White Coffee Table', 'table_silo_med*3', 's', 2, 2, 1, '1', '0', '0', 1866, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(568, 'Beige Area Coffee Table', 'table_silo_med*4', 's', 2, 2, 1, '1', '0', '0', 1867, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(569, 'Pink Area Coffee Table', 'table_silo_med*5', 's', 2, 2, 1, '1', '0', '0', 1868, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(570, 'Blue Area Coffee Table', 'table_silo_med*6', 's', 2, 2, 1, '1', '0', '0', 1869, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(571, 'Green Area Coffee Table', 'table_silo_med*7', 's', 2, 2, 1, '1', '0', '0', 1870, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(572, 'Yellow Coffee Table', 'table_silo_med*8', 's', 2, 2, 1, '1', '0', '0', 1871, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(573, 'Red Area Coffee Table', 'table_silo_med*9', 's', 2, 2, 1, '1', '0', '0', 1872, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(574, 'Cushioned', 'sofa_silo*2', 's', 2, 1, 1.1, '0', '1', '0', 1873, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(575, 'Cushioned', 'sofa_silo*3', 's', 2, 1, 1.1, '0', '1', '0', 1874, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(576, 'Beige Area Sofa', 'sofa_silo*4', 's', 2, 1, 1.1, '0', '1', '0', 1875, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(577, 'Pink Area Sofa', 'sofa_silo*5', 's', 2, 1, 1.1, '0', '1', '0', 1876, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(578, 'Blue Area Sofa', 'sofa_silo*6', 's', 2, 1, 1.1, '0', '1', '0', 1877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(579, 'Green Area Sofa', 'sofa_silo*7', 's', 2, 1, 1.1, '0', '1', '0', 1878, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(580, 'Cushioned', 'sofa_silo*8', 's', 2, 1, 1.1, '0', '1', '0', 1879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(581, 'Red Area Sofa', 'sofa_silo*9', 's', 2, 1, 1.1, '0', '1', '0', 1880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(582, 'Black Mode Armchair', 'sofachair_polyfon*2', 's', 1, 1, 1.1, '0', '1', '0', 1881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(583, 'White Armchair', 'sofachair_polyfon*3', 's', 1, 1, 1.1, '0', '1', '0', 1882, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(584, 'Beige Mode Armchair', 'sofachair_polyfon*4', 's', 1, 1, 1.1, '0', '1', '0', 1883, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(585, 'Blue Mode Armchair', 'sofachair_polyfon*6', 's', 1, 1, 1.1, '0', '1', '0', 1884, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(586, 'Green Armchair', 'sofachair_polyfon*7', 's', 1, 1, 1.1, '0', '1', '0', 1885, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(587, 'Yellow Mode Armchair', 'sofachair_polyfon*8', 's', 1, 1, 1.1, '0', '1', '0', 1886, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(588, 'Red Armchair', 'sofachair_polyfon*9', 's', 1, 1, 1.1, '0', '1', '0', 1887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(589, 'Black Mode Sofa', 'sofa_polyfon*2', 's', 2, 1, 1.1, '0', '1', '0', 1888, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(590, 'White Two-seater Sofa', 'sofa_polyfon*3', 's', 2, 1, 1.1, '0', '1', '0', 1889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(591, 'Beige Mode Sofa', 'sofa_polyfon*4', 's', 2, 1, 1.1, '0', '1', '0', 1890, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(592, 'Blue Mode Sofa', 'sofa_polyfon*6', 's', 2, 1, 1.1, '0', '1', '0', 1891, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(593, 'Green Two-seater Sofa', 'sofa_polyfon*7', 's', 2, 1, 1.1, '0', '1', '0', 1892, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(594, 'Yellow Mode Sofa', 'sofa_polyfon*8', 's', 2, 1, 1.1, '0', '1', '0', 1893, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(595, 'Black Mode Double Bed', 'sofa_polyfon*9', 's', 2, 1, 1.1, '0', '1', '0', 1894, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(596, 'White Double Bed', 'bed_polyfon*3', 's', 2, 3, 1.8, '0', '0', '0', 1896, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(597, 'Beige Mode Double Bed', 'bed_polyfon*4', 's', 2, 3, 1.8, '0', '0', '0', 1897, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(598, 'Blue Mode Double Bed', 'bed_polyfon*6', 's', 2, 3, 1.8, '0', '0', '0', 1898, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(599, 'Green Double Bed', 'bed_polyfon*7', 's', 2, 3, 1.8, '0', '0', '0', 1899, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(600, 'Yellow Mode Double Bed', 'bed_polyfon*8', 's', 2, 3, 1.8, '0', '0', '0', 1900, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(601, 'Red Double Bed', 'bed_polyfon*9', 's', 2, 3, 1.8, '0', '0', '0', 1901, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(602, 'Black Mode Single Bed', 'bed_polyfon_one*2', 's', 1, 3, 1.8, '0', '0', '0', 1902, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(603, 'White Single Bed', 'bed_polyfon_one*3', 's', 1, 3, 1.8, '0', '0', '0', 1903, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(604, 'Beige Mode Single Bed', 'bed_polyfon_one*4', 's', 1, 3, 1.8, '0', '0', '0', 1904, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(605, 'Blue Mode Single Bed', 'bed_polyfon_one*6', 's', 1, 3, 1.8, '0', '0', '0', 1905, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(606, 'Green Single Bed', 'bed_polyfon_one*7', 's', 1, 3, 1.8, '0', '0', '0', 1906, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(607, 'Yellow Mode Single Bed', 'bed_polyfon_one*8', 's', 1, 3, 1.8, '0', '0', '0', 1907, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(608, 'Red Single Bed', 'bed_polyfon_one*9', 's', 1, 3, 1.8, '0', '0', '0', 1908, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(609, 'Black Mode Bardesk', 'bardesk_polyfon*2', 's', 2, 1, 1, '1', '0', '0', 1909, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(610, 'White Bardesk', 'bardesk_polyfon*3', 's', 2, 1, 1, '1', '0', '0', 1910, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(611, 'Beige Mode Bardesk', 'bardesk_polyfon*4', 's', 2, 1, 1, '1', '0', '0', 1911, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(612, 'Candy Bar', 'bardesk_polyfon*5', 's', 2, 1, 1, '1', '0', '0', 1912, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(613, 'Blue Mode Bardesk', 'bardesk_polyfon*6', 's', 2, 1, 1, '1', '0', '0', 1913, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(614, 'Green Bardesk', 'bardesk_polyfon*7', 's', 2, 1, 1, '1', '0', '0', 1914, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(615, 'Yellow Mode Bardesk', 'bardesk_polyfon*8', 's', 2, 1, 1, '1', '0', '0', 1915, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(616, 'Red Bardesk', 'bardesk_polyfon*9', 's', 2, 1, 1, '1', '0', '0', 1916, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(617, 'Black Mode Bardesk Corner', 'bardeskcorner_polyfon*2', 's', 1, 1, 1, '1', '0', '0', 1917, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(618, 'White Corner Desk', 'bardeskcorner_polyfon*3', 's', 1, 1, 1, '1', '0', '0', 1918, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(619, 'Beige Mode Bardesk Corner', 'bardeskcorner_polyfon*4', 's', 1, 1, 1, '1', '0', '0', 1919, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(620, 'Candy Corner', 'bardeskcorner_polyfon*5', 's', 1, 1, 1, '1', '0', '0', 1920, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(621, 'Blue Mode Bardesk Corner', 'bardeskcorner_polyfon*6', 's', 1, 1, 1, '1', '0', '0', 1921, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(622, 'Green Corner Desk', 'bardeskcorner_polyfon*7', 's', 1, 1, 1, '1', '0', '0', 1922, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(623, 'Yellow Mode Bardesk Corner', 'bardeskcorner_polyfon*8', 's', 1, 1, 1, '1', '0', '0', 1923, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(624, 'Red Corner Desk', 'bardeskcorner_polyfon*9', 's', 1, 1, 1, '1', '0', '0', 1924, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(625, 'Black Mode Bardesk Gate', 'divider_poly3*2', 's', 1, 1, 0.001, '0', '0', '0', 1925, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(626, 'White Hatch', 'divider_poly3*3', 's', 1, 1, 0.001, '0', '0', '0', 1926, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(627, 'Beige Mode Bardesk Gate', 'divider_poly3*4', 's', 1, 1, 0.001, '0', '0', '0', 1927, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(628, 'Candy Hatch (Lockable)', 'divider_poly3*5', 's', 1, 1, 0.001, '0', '0', '0', 1928, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(629, 'Blue Mode Bardesk Gate', 'divider_poly3*6', 's', 1, 1, 0.001, '0', '0', '0', 1929, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(631, 'Yellow Mode Bardesk Gate', 'divider_poly3*8', 's', 1, 1, 0.001, '0', '0', '0', 1931, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(632, 'Red Hatch', 'divider_poly3*9', 's', 1, 1, 0.001, '0', '0', '0', 1932, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(633, 'Black Dining Chair', 'chair_silo*2', 's', 1, 1, 1.1, '0', '1', '0', 1933, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(634, 'White Dining Chair', 'chair_silo*3', 's', 1, 1, 1.1, '0', '1', '0', 1934, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(635, 'Beige Silo Dining Chair', 'chair_silo*4', 's', 1, 1, 1.1, '0', '1', '0', 1935, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(636, 'Pink Silo Dining Chair', 'chair_silo*5', 's', 1, 1, 1.1, '0', '1', '0', 1936, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(637, 'Blue Area Dining Chair', 'chair_silo*6', 's', 1, 1, 1.1, '0', '1', '0', 1937, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(638, 'Green Area Dining Chair', 'chair_silo*7', 's', 1, 1, 1.1, '0', '1', '0', 1938, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(639, 'Yellow Dining Chair', 'chair_silo*8', 's', 1, 1, 1.1, '0', '1', '0', 1939, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(640, 'Red Area Dining Chair', 'chair_silo*9', 's', 1, 1, 1.1, '0', '1', '0', 1940, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(641, 'No way through', 'divider_nor3*2', 's', 1, 1, 1, '0', '0', '0', 1941, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(642, 'White Iced Gate', 'divider_nor3*3', 's', 1, 1, 0.001, '0', '0', '0', 1942, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(643, 'Urban Iced Gate', 'divider_nor3*4', 's', 1, 1, 0.001, '0', '0', '0', 1943, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(644, 'Pink Iced gate', 'divider_nor3*5', 's', 1, 1, 0.001, '0', '0', '0', 1944, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(645, 'Blue Iced gate', 'divider_nor3*6', 's', 1, 1, 0.001, '0', '0', '0', 1945, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(646, 'Rural Iced gate', 'divider_nor3*7', 's', 1, 1, 0.001, '0', '0', '0', 1946, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(647, 'Yellow Iced gate', 'divider_nor3*8', 's', 1, 1, 0.001, '0', '0', '0', 1947, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(648, 'Red Iced gate', 'divider_nor3*9', 's', 1, 1, 0.001, '0', '0', '0', 1948, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(649, 'Black Iced Bar-Desk', 'divider_nor2*2', 's', 2, 1, 1, '0', '0', '0', 1949, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(650, 'Strong', 'divider_nor2*3', 's', 2, 1, 1, '0', '0', '0', 1950, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(651, 'Urban Iced Bar', 'divider_nor2*4', 's', 2, 1, 1, '0', '0', '0', 1951, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(652, 'Pink Iced bar desk', 'divider_nor2*5', 's', 2, 1, 1, '0', '0', '0', 1952, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(653, 'Blue Iced  bar desk', 'divider_nor2*6', 's', 2, 1, 1, '0', '0', '0', 1953, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(654, 'Rural Iced Bar', 'divider_nor2*7', 's', 2, 1, 1, '0', '0', '0', 1954, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(655, 'Yellow Iced  bar desk', 'divider_nor2*8', 's', 2, 1, 1, '0', '0', '0', 1955, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(656, 'Red Iced  bar desk', 'divider_nor2*9', 's', 2, 1, 1, '0', '0', '0', 1956, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(657, 'Area Quest Desk', 'silo_studydesk', 's', 2, 1, 1, '1', '0', '0', 1957, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(658, 'White Solarium', 'solarium_norja', 's', 1, 1, 1, '0', '0', '0', 1958, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(659, 'Black Solarium', 'solarium_norja*1', 's', 1, 1, 1, '0', '0', '0', 1959, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(660, 'Beige Solarium', 'solarium_norja*2', 's', 1, 1, 1, '0', '0', '0', 1960, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(661, 'Urban Solarium', 'solarium_norja*3', 's', 1, 1, 1, '0', '0', '0', 1961, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(662, 'Pink Solarium', 'solarium_norja*5', 's', 1, 1, 1, '0', '0', '0', 1962, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(663, 'Blue Solarium', 'solarium_norja*6', 's', 1, 1, 1, '0', '0', '0', 1963, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(664, 'Rural Solarium', 'solarium_norja*7', 's', 1, 1, 1, '0', '0', '0', 1964, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(665, 'Yellow Solarium', 'solarium_norja*8', 's', 1, 1, 1, '0', '0', '0', 1965, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(666, 'Red Solarium', 'solarium_norja*9', 's', 1, 1, 1, '0', '0', '0', 1966, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(667, 'Tropical Beach Rug', 'sandrug', 's', 2, 2, 0, '1', '0', '1', 1967, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(668, 'Moon Patch', 'rare_moonrug', 's', 2, 2, 0, '1', '0', '1', 1968, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(669, 'Chinese Lacquer Chair', 'chair_china', 's', 1, 1, 1, '0', '1', '0', 1969, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(670, 'Chinese Lacquer Table', 'china_table', 's', 1, 1, 1, '1', '0', '0', 1970, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(671, 'Red Sleeping Bag', 'sleepingbag*1', 's', 1, 3, 0.8, '0', '0', '0', 1971, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(672, 'Lime Sleeping Bag', 'sleepingbag*2', 's', 1, 3, 0.8, '0', '0', '0', 1972, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(673, 'Ocean Sleeping Bag', 'sleepingbag*3', 's', 1, 3, 0.8, '0', '0', '0', 1973, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(674, 'Safety Sleeping Bag', 'sleepingbag*4', 's', 1, 3, 0.8, '0', '0', '0', 1974, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(675, 'Safe Minibar', 'safe_silo', 's', 1, 1, 1.3, '1', '0', '0', 1975, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(676, 'Orange Sleeping Bag', 'sleepingbag*7', 's', 1, 3, 0.8, '0', '0', '0', 1976, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(677, 'eXceptional Sleeping Bag', 'sleepingbag*9', 's', 1, 3, 0.8, '0', '0', '0', 1977, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(678, 'Graphite Sleeping Bag', 'sleepingbag*5', 's', 1, 3, 0.8, '0', '0', '0', 1978, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(679, 'Khaki Sleeping Bag', 'sleepingbag*10', 's', 1, 3, 0.8, '0', '0', '0', 1979, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(680, 'Purple Sleeping Bag', 'sleepingbag*6', 's', 1, 3, 0.8, '0', '0', '0', 1980, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(681, 'Golden Sleeping Bag', 'sleepingbag*8', 's', 1, 3, 0.8, '0', '0', '0', 1981, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(682, 'Chinese Bookshelf', 'china_shelve', 's', 2, 1, 1, '0', '0', '0', 1982, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(683, 'White Traffic Light', 'traffic_light*5', 's', 1, 1, 1, '0', '0', '0', 1983, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(684, 'Habbos', 'divider_nor4*2', 's', 2, 1, 1, '0', '0', '0', 1984, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(685, 'Habbos', 'divider_nor4*3', 's', 2, 1, 1, '0', '0', '0', 1985, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(686, 'Habbos', 'divider_nor4*5', 's', 2, 1, 1, '0', '0', '0', 1986, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(687, 'Habbos', 'divider_nor4*6', 's', 2, 1, 1, '0', '0', '0', 1987, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(688, 'Habbos', 'divider_nor4*7', 's', 2, 1, 1, '0', '0', '0', 1988, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(689, 'Habbos', 'divider_nor4*8', 's', 2, 1, 1, '0', '0', '0', 1989, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(690, 'Habbos', 'divider_nor4*9', 's', 2, 1, 1, '0', '0', '0', 1990, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(691, 'Black Iced Angle', 'divider_nor5*2', 's', 1, 1, 1, '0', '0', '0', 1991, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(692, 'White Iced Angle', 'divider_nor5*3', 's', 1, 1, 1, '0', '0', '0', 1992, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(693, 'Urban Iced Angle', 'divider_nor5*4', 's', 1, 1, 1, '0', '0', '0', 1993, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(694, 'Blue Iced Angle', 'divider_nor5*5', 's', 1, 1, 1, '0', '0', '0', 1994, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(695, 'Rural Iced Angle', 'divider_nor5*7', 's', 1, 1, 1, '0', '0', '0', 1996, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(696, 'Yellow Iced Angle', 'divider_nor5*8', 's', 1, 1, 1, '0', '0', '0', 1997, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(697, 'Red Iced Angle', 'divider_nor5*9', 's', 1, 1, 1, '0', '0', '0', 1998, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(698, 'Plain Iced Angle', 'divider_nor5', 's', 1, 1, 1, '0', '0', '0', 1999, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(699, 'Habbos', 'divider_nor4', 's', 2, 1, 1, '0', '0', '0', 2000, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(700, 'Dragon Screen', 'wall_china', 's', 1, 1, 1, '0', '0', '0', 2001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(701, 'Firm', 'corner_china', 's', 1, 1, 1, '0', '0', '0', 2002, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(702, 'Black Bar Stool', 'barchair_silo*2', 's', 1, 1, 1.2, '0', '1', '0', 2003, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(703, 'White Bar Stool', 'barchair_silo*3', 's', 1, 1, 1.2, '0', '1', '0', 2004, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(704, 'Beige Bar Stool', 'barchair_silo*4', 's', 1, 1, 1.2, '0', '1', '0', 2005, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(705, 'Pink Bar Stool', 'barchair_silo*5', 's', 1, 1, 1.2, '0', '1', '0', 2006, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(706, 'Blue Bar Stool', 'barchair_silo*6', 's', 1, 1, 1.2, '0', '1', '0', 2007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(707, 'Green Bar Stool', 'barchair_silo*7', 's', 1, 1, 1.2, '0', '1', '0', 2008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(708, 'Yellow Bar Stool', 'barchair_silo*8', 's', 1, 1, 1.2, '0', '1', '0', 2009, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(709, 'Red Bar Stool', 'barchair_silo*9', 's', 1, 1, 1.2, '0', '1', '0', 2010, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(710, 'Black Safe Minibar', 'safe_silo*2', 's', 1, 1, 1.3, '1', '0', '0', 2011, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(711, 'White Safe Minibar', 'safe_silo*3', 's', 1, 1, 1.3, '1', '0', '0', 2012, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(712, 'Beige Safe Minibar', 'safe_silo*4', 's', 1, 1, 1.3, '1', '0', '0', 2013, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(713, 'Pink Safe Minibar', 'safe_silo*5', 's', 1, 1, 1.3, '1', '0', '0', 2014, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(714, 'Blue Safe Minibar', 'safe_silo*6', 's', 1, 1, 1.3, '1', '0', '0', 2015, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(715, 'Green Safe Minibar', 'safe_silo*7', 's', 1, 1, 1.3, '1', '0', '0', 2016, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(716, 'Yellow Safe Minibar', 'safe_silo*8', 's', 1, 1, 1.3, '1', '0', '0', 2017, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(717, 'Red Safe Minibar', 'safe_silo*9', 's', 1, 1, 1.3, '1', '0', '0', 2018, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(718, 'Glass shelf', 'glass_shelf', 's', 2, 1, 1, '0', '0', '0', 2019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(719, 'Glass chair', 'glass_chair', 's', 1, 1, 1, '0', '1', '0', 2020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(720, 'Glass stool', 'glass_stool', 's', 1, 1, 1, '0', '1', '0', 2021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(721, 'Glass sofa', 'glass_sofa', 's', 2, 1, 1, '0', '1', '0', 2022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(722, 'Glass table', 'glass_table', 's', 2, 2, 1, '1', '0', '0', 2023, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(723, 'Glass table', 'glass_table*2', 's', 2, 2, 1, '1', '0', '0', 2024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(724, 'White Glass Table', 'glass_table*3', 's', 2, 2, 1, '1', '0', '0', 2025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(725, 'Glass table', 'glass_table*4', 's', 2, 2, 1, '1', '0', '0', 2026, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(726, 'Candy Glass Table', 'glass_table*5', 's', 2, 2, 1, '1', '0', '0', 2027, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(727, 'Blue Glass Table', 'glass_table*6', 's', 2, 2, 1, '1', '0', '0', 2028, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(728, 'Green Glass Table', 'glass_table*7', 's', 2, 2, 1, '1', '0', '0', 2029, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(729, 'Yellow Glass Table', 'glass_table*8', 's', 2, 2, 1, '1', '0', '0', 2030, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(730, 'Glass table', 'glass_table*9', 's', 2, 2, 1, '1', '0', '0', 2031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(731, 'Glass chair', 'glass_chair*2', 's', 1, 1, 1, '0', '1', '0', 2032, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(732, 'Glass chair', 'glass_chair*3', 's', 1, 1, 1, '0', '1', '0', 2033, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(733, 'Glass chair', 'glass_chair*4', 's', 1, 1, 1, '0', '1', '0', 2034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(734, 'Candy Glass Chair', 'glass_chair*5', 's', 1, 1, 1, '0', '1', '0', 2035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(735, 'Blue Glass Chair', 'glass_chair*6', 's', 1, 1, 1, '0', '1', '0', 2036, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(736, 'Green Glass Chair', 'glass_chair*7', 's', 1, 1, 1, '0', '1', '0', 2037, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(737, 'Yellow Glass Chair', 'glass_chair*8', 's', 1, 1, 1, '0', '1', '0', 2038, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(738, 'Glass chair', 'glass_chair*9', 's', 1, 1, 1, '0', '1', '0', 2039, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(739, 'Glass sofa', 'glass_sofa*2', 's', 2, 1, 1, '0', '1', '0', 2040, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(740, 'White Glass Sofa', 'glass_sofa*3', 's', 2, 1, 1, '0', '1', '0', 2041, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(741, 'Glass sofa', 'glass_sofa*4', 's', 2, 1, 1, '0', '1', '0', 2042, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(742, 'Candy Glass Sofa', 'glass_sofa*5', 's', 2, 1, 1, '0', '1', '0', 2043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(743, 'Blue Glass Sofa', 'glass_sofa*6', 's', 2, 1, 1, '0', '1', '0', 2044, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(744, 'Green Glass Sofa', 'glass_sofa*7', 's', 2, 1, 1, '0', '1', '0', 2045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(745, 'Yellow Glass Sofa', 'glass_sofa*8', 's', 2, 1, 1, '0', '1', '0', 2046, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(746, 'Glass sofa', 'glass_sofa*9', 's', 2, 1, 1, '0', '1', '0', 2047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(747, 'Glass stool', 'glass_stool*2', 's', 1, 1, 1, '0', '1', '0', 2048, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(748, 'Glass stool', 'glass_stool*4', 's', 1, 1, 1, '0', '1', '0', 2050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(749, 'Candy Glass Stool', 'glass_stool*5', 's', 1, 1, 1, '0', '1', '0', 2051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(750, 'Blue Glass Stool', 'glass_stool*6', 's', 1, 1, 1, '0', '1', '0', 2052, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(751, 'Green Glass Stool', 'glass_stool*7', 's', 1, 1, 1, '0', '1', '0', 2053, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(752, 'Yellow Glass Stool', 'glass_stool*8', 's', 1, 1, 1, '0', '1', '0', 2054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(753, 'White Glass Stool', 'glass_stool*3', 's', 1, 1, 1, '0', '1', '0', 2056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(754, 'Glass stool', 'glass_stool*9', 's', 1, 1, 1, '0', '1', '0', 2057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(755, 'Gold Coin', 'CF_10_coin_gold', 's', 1, 1, 0.2, '1', '0', '0', 2063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(756, 'Bronze Coin', 'CF_1_coin_bronze', 's', 1, 1, 0.2, '1', '0', '0', 2064, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(757, 'Sack of Credits', 'CF_20_moneybag', 's', 1, 1, 1, '1', '0', '0', 2065, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(758, 'Gold Bar', 'CF_50_goldbar', 's', 1, 1, 0.2, '1', '0', '0', 2066, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(759, 'Silver Coin', 'CF_5_coin_silver', 's', 1, 1, 0.2, '1', '0', '0', 2067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(760, 'Persian Carpet', 'hc_crpt', 's', 3, 5, 0, '1', '0', '1', 2068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(761, 'Forget plasma', 'hc_tv', 's', 2, 1, 1.4, '0', '1', '0', 2069, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(762, 'Gothic Portcullis', 'gothgate', 's', 2, 1, 0.001, '0', '0', '0', 2070, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(763, 'Gothic Candelabra', 'gothiccandelabra', 's', 1, 1, 1, '0', '0', '0', 2071, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(764, 'Gothic Railing', 'gothrailing', 's', 2, 1, 1, '0', '0', '0', 2072, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(765, 'Gothic table', 'goth_table', 's', 1, 5, 1.7, '0', '0', '0', 2073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(766, 'Medieval Bookcase', 'hc_bkshlf', 's', 1, 4, 1, '0', '0', '0', 2074, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(767, 'Electric Butler', 'hc_btlr', 's', 1, 1, 1, '0', '0', '0', 2075, '1', '1', '1', '1', '1', 'vendingmachine', 0, '24', ''),
(768, 'Antique Drapery', 'hc_crtn', 's', 2, 1, 0.001, '0', '0', '0', 2076, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(769, 'The Grammophon', 'hc_djset', 's', 3, 1, 1, '0', '0', '0', 2077, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(770, 'Heavy Duty Fireplace', 'hc_frplc', 's', 1, 3, 1, '0', '0', '0', 2078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(771, 'Victorian Street Light', 'hc_lmpst', 's', 1, 1, 1, '0', '0', '0', 2079, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(772, 'Weird Science Machine', 'hc_machine', 's', 1, 3, 1, '0', '0', '0', 2080, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(773, 'HC Rollers Set', 'hc_rllr', 's', 1, 1, 0.5, '0', '0', '1', 2081, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(774, 'X-Ray Divider', 'hc_rntgn', 's', 2, 1, 1, '0', '0', '0', 2082, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(775, 'Drinks Trolley', 'hc_trll', 's', 1, 2, 1, '0', '0', '0', 2083, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(776, 'Gothic Chair Pink', 'gothic_chair*1', 's', 1, 1, 1, '0', '1', '0', 2084, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(777, 'Gothic Sofa Pink', 'gothic_sofa*1', 's', 2, 1, 1, '0', '1', '0', 2085, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(778, 'Gothic Stool Pink', 'gothic_stool*1', 's', 1, 1, 1, '0', '1', '0', 2086, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(779, 'Golden Gothic Chair', 'gothic_chair*2', 's', 1, 1, 1, '0', '1', '0', 2087, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(780, 'Golden Gothic Sofa', 'gothic_sofa*2', 's', 2, 1, 1, '0', '1', '0', 2088, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(781, 'Golden Gothic Stool', 'gothic_stool*2', 's', 1, 1, 1, '0', '1', '0', 2089, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(782, 'Red Gothic Chair', 'gothic_chair*3', 's', 1, 1, 1, '0', '1', '0', 2090, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(783, 'Red Gothic Sofa', 'gothic_sofa*3', 's', 2, 1, 1, '0', '1', '0', 2091, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(784, 'Red Gothic Stool', 'gothic_stool*3', 's', 1, 1, 1, '0', '1', '0', 2092, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(785, 'Black Gothic Chair', 'gothic_chair*4', 's', 1, 1, 1, '0', '1', '0', 2093, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(786, 'Black Gothic Sofa', 'gothic_sofa*4', 's', 2, 1, 1, '0', '1', '0', 2094, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(787, 'Black Gothic Stool', 'gothic_stool*4', 's', 1, 1, 1, '0', '1', '0', 2095, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(788, 'Green Gothic Chair', 'gothic_chair*5', 's', 1, 1, 1, '0', '1', '0', 2096, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(789, 'Green Gothic Sofa', 'gothic_sofa*5', 's', 2, 1, 1, '0', '1', '0', 2097, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(790, 'Green Gothic Stool', 'gothic_stool*5', 's', 1, 1, 1, '0', '1', '0', 2098, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(791, 'Gothic Chair Blue', 'gothic_chair*6', 's', 1, 1, 1, '0', '1', '0', 2099, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(792, 'Gothic Sofa Blue', 'gothic_sofa*6', 's', 2, 1, 1, '0', '1', '0', 2100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(793, 'Valentine''s Cauldron', 'gothic_stool*6', 's', 1, 1, 1, '0', '1', '0', 2101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(794, 'Sound Machine', 'sound_machine', 's', 1, 1, 1, '0', '0', '0', 2105, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(795, 'Turquoise Romantique Piano Chair', 'romantique_pianochair*3', 's', 1, 1, 1, '0', '1', '0', 2106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(796, 'Onyx Piano Stool', 'romantique_pianochair*5', 's', 1, 1, 1, '0', '1', '0', 2107, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(797, 'Lime Romantique Piano Chair', 'romantique_pianochair*2', 's', 1, 1, 1, '0', '1', '0', 2108, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(798, 'Amber Piano Stool', 'romantique_pianochair*4', 's', 1, 1, 1, '0', '1', '0', 2109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(799, 'Rose Quartz Piano Stool', 'romantique_pianochair*1', 's', 1, 1, 1, '0', '1', '0', 2110, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(800, 'Turquoise Romantique Divan', 'romantique_divan*3', 's', 2, 1, 1, '0', '1', '0', 2111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(801, 'Onyx Chaise-Longue', 'romantique_divan*5', 's', 2, 1, 1, '0', '1', '0', 2112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(802, 'Emerald Chaise-Longue', 'romantique_divan*2', 's', 2, 1, 1, '0', '1', '0', 2113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(803, 'Amber Chaise-Longue', 'romantique_divan*4', 's', 2, 1, 1, '0', '1', '0', 2114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(804, 'Rose Quartz Chaise-Longue', 'romantique_divan*1', 's', 2, 1, 1, '0', '1', '0', 2115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(805, 'Turquoise Romantique Chair', 'romantique_chair*3', 's', 1, 1, 1, '0', '1', '0', 2116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(806, 'Onyx Chair', 'romantique_chair*5', 's', 1, 1, 1, '0', '1', '0', 2117, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture_old` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(807, 'Lime Romantique Chair', 'romantique_chair*2', 's', 1, 1, 1, '0', '1', '0', 2118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(808, 'Amber Chair', 'romantique_chair*4', 's', 1, 1, 1, '0', '1', '0', 2119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(809, 'Rose Quartz Chair', 'romantique_chair*1', 's', 1, 1, 1, '0', '1', '0', 2120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(811, 'Yellow Valentine Rose', 'plant_valentinerose*3', 's', 1, 1, 1, '0', '0', '0', 2123, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(812, 'Purple Valentine''s Rose', 'plant_valentinerose*5', 's', 1, 1, 1, '0', '0', '0', 2124, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(813, 'White Valentine''s Rose', 'plant_valentinerose*2', 's', 1, 1, 1, '0', '0', '0', 2125, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(814, 'Pink Valentine''s Rose', 'plant_valentinerose*4', 's', 1, 1, 1, '0', '0', '0', 2126, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(815, 'Red Valentine''s Rose', 'plant_valentinerose*1', 's', 1, 1, 1, '0', '0', '0', 2127, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(816, 'Maze Shrubbery Gate', 'plant_mazegate', 's', 2, 1, 0.001, '0', '0', '0', 2128, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(817, 'Maze Shrubbery', 'plant_maze', 's', 2, 1, 1, '0', '0', '0', 2129, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(818, 'Bulrush', 'plant_bulrush', 's', 1, 1, 1, '0', '0', '0', 2130, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(819, 'T-Bones Mega Multipack', 'petfood4', 's', 1, 1, 1, '1', '0', '0', 2131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(820, 'Red carpet', 'carpet_valentine', 's', 2, 7, 0, '1', '0', '1', 2132, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(821, 'Cobbled Path', 'gothic_carpet', 's', 2, 4, 0, '1', '0', '1', 2133, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(822, 'Dungeon Floor', 'gothic_carpet2', 's', 2, 4, 0, '1', '0', '1', 2134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(823, '', 'gothic_chair', 's', 1, 1, 1, '0', '1', '0', 2135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(824, '', 'gothic_sofa', 's', 2, 1, 1, '0', '1', '0', 2136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(825, '', 'gothic_stool', 's', 1, 1, 1, '0', '1', '0', 2137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(826, 'Pink Grand Piano', 'grand_piano*3', 's', 2, 2, 1, '0', '0', '0', 2138, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(827, 'Onyx Grand Piano', 'grand_piano*5', 's', 2, 2, 1, '0', '0', '0', 2139, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(828, 'Black Grand Piano', 'grand_piano*2', 's', 2, 2, 1, '0', '0', '0', 2140, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(829, 'Amber Grand Piano', 'grand_piano*4', 's', 2, 2, 1, '0', '0', '0', 2141, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(830, 'Turquoise Grand Piano', 'grand_piano*1', 's', 2, 2, 1, '0', '0', '0', 2142, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(831, 'Deluxe Theatre Chair', 'theatre_seat', 's', 1, 1, 1.2, '0', '1', '0', 2143, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(832, 'Treats Tray', 'romantique_tray2', 's', 1, 1, 1, '0', '0', '0', 2144, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(833, 'Breakfast Tray', 'romantique_tray1', 's', 1, 1, 1, '0', '0', '0', 2145, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(834, 'Turquoise Tray Table', 'romantique_smalltabl*3', 's', 1, 1, 1, '1', '0', '0', 2146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(835, 'Onyx Tray Table', 'romantique_smalltabl*5', 's', 1, 1, 1, '1', '0', '0', 2147, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(836, 'Lime Tray Table', 'romantique_smalltabl*2', 's', 1, 1, 1, '1', '0', '0', 2148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(837, 'Amber Tray Table', 'romantique_smalltabl*4', 's', 1, 1, 1, '1', '0', '0', 2149, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(838, 'Rose Quartz Tray Table', 'romantique_smalltabl*1', 's', 1, 1, 1, '1', '0', '0', 2150, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(839, 'Dressing Table', 'romantique_mirrortabl', 's', 1, 1, 1, '1', '0', '0', 2151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(840, 'Turquoise Screen', 'romantique_divider*3', 's', 2, 1, 1, '0', '0', '0', 2152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(841, 'Green Screen', 'romantique_divider*2', 's', 2, 1, 1, '1', '0', '0', 2153, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(842, 'Amber Screen', 'romantique_divider*4', 's', 2, 1, 1, '1', '0', '0', 2154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(843, 'Rose Quartz Screen', 'romantique_divider*1', 's', 2, 1, 1, '1', '0', '0', 2155, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(844, 'Large Tatami Mat', 'jp_tatami2', 's', 2, 4, 0, '1', '0', '1', 2156, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(845, 'Small Tatami Mat', 'jp_tatami', 's', 2, 2, 1, '0', '0', '1', 2157, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(846, 'Director''s Chair', 'habbowood_chair', 's', 1, 1, 1.2, '0', '1', '0', 2158, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(847, 'Bamboo Forest', 'jp_bamboo', 's', 2, 2, 0, '1', '0', '1', 2159, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(848, 'Irori', 'jp_irori', 's', 2, 2, 1, '0', '0', '0', 2160, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(849, 'Pillow Chair', 'jp_pillow', 's', 1, 1, 0.8, '0', '1', '0', 2161, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(850, 'Habbo Sounds 1', 'sound_set_1', 's', 1, 1, 0.2, '1', '0', '0', 2162, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(851, 'Habbo Sounds 3', 'sound_set_2', 's', 1, 1, 0.2, '1', '0', '0', 2163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(852, 'Electronic 1', 'sound_set_3', 's', 1, 1, 0.2, '1', '0', '0', 2164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(853, 'Ambient 1', 'sound_set_4', 's', 1, 1, 0.2, '1', '0', '0', 2165, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(854, 'Ambient 4', 'sound_set_5', 's', 1, 1, 0.2, '1', '0', '0', 2166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(855, 'Ambient 3', 'sound_set_6', 's', 1, 1, 0.2, '1', '0', '0', 2167, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(856, 'SFX 5', 'sound_set_7', 's', 1, 1, 0.2, '1', '0', '0', 2168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(857, 'Ambient 2', 'sound_set_8', 's', 1, 1, 0.2, '1', '0', '0', 2169, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(858, 'Electronic 2', 'sound_set_9', 's', 1, 1, 0.2, '1', '0', '0', 2170, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(859, 'Traxmachine', 'sound_machine*1', 's', 1, 1, 1, '0', '0', '0', 2171, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(860, 'Habbowood Spotlight', 'spotlight', 's', 1, 1, 1, '0', '0', '0', 2519, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(861, 'Ocean Traxmachine', 'sound_machine*2', 's', 1, 1, 1, '0', '0', '0', 2543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(862, 'Green Traxmachine', 'sound_machine*3', 's', 1, 1, 1, '0', '0', '0', 2544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(863, 'For Funky', 'sound_machine*4', 's', 1, 1, 1, '0', '0', '0', 2545, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(864, 'Brown Traxmachine', 'sound_machine*5', 's', 1, 1, 1, '0', '0', '0', 2546, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(865, 'Purple Traxmachine', 'sound_machine*6', 's', 1, 1, 1, '0', '0', '0', 2547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(866, 'Red Traxmachine', 'sound_machine*7', 's', 1, 1, 1, '0', '0', '0', 2548, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(867, 'Crystal Lamp', 'rom_lamp', 's', 1, 1, 1, '0', '0', '0', 2551, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(868, 'Polar Sofa', 'rclr_sofa', 's', 2, 1, 1, '0', '1', '0', 2459, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(869, 'Water Garden', 'rclr_garden', 's', 1, 3, 1, '0', '0', '0', 2458, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(870, 'Palm Chair', 'rclr_chair', 's', 1, 1, 1, '0', '1', '0', 2562, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(871, 'Rock 2', 'sound_set_28', 's', 1, 1, 0.2, '1', '0', '0', 2496, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(872, 'Groove 2', 'sound_set_27', 's', 1, 1, 0.2, '1', '0', '0', 2549, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(873, 'Groove 1', 'sound_set_26', 's', 1, 1, 0.2, '1', '0', '0', 2508, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(874, 'Actually', 'sound_set_25', 's', 1, 1, 0.2, '1', '0', '0', 2470, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(875, 'It''s all about the Pentiums', 'sound_set_24', 's', 1, 1, 0.2, '1', '0', '0', 2492, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(876, 'SFX 4', 'sound_set_23', 's', 1, 1, 0.2, '1', '0', '0', 2457, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(877, 'With a hamper full of sounds', 'sound_set_22', 's', 1, 1, 0.2, '1', '0', '0', 2521, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(878, 'Rock 1', 'sound_set_21', 's', 1, 1, 0.2, '1', '0', '0', 2494, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(879, 'SFX 2', 'sound_set_20', 's', 1, 1, 0.2, '1', '0', '0', 2524, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(880, 'Hip Hop Beats 4', 'sound_set_19', 's', 1, 1, 0.2, '1', '0', '0', 2469, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(881, 'Groove 4', 'sound_set_18', 's', 1, 1, 0.2, '1', '0', '0', 2497, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(882, 'Groove 3', 'sound_set_17', 's', 1, 1, 0.2, '1', '0', '0', 2550, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(883, 'Ferry', 'sound_set_16', 's', 1, 1, 0.2, '1', '0', '0', 2561, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(884, 'RnB Grooves 6', 'sound_set_15', 's', 1, 1, 0.2, '1', '0', '0', 2495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(885, 'Hip Hop Beats 2', 'sound_set_14', 's', 1, 1, 0.2, '1', '0', '0', 2482, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(886, 'Dance 5', 'sound_set_13', 's', 1, 1, 0.2, '1', '0', '0', 2523, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(887, 'Habbo Sounds 2', 'sound_set_12', 's', 1, 1, 0.2, '1', '0', '0', 2493, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(888, 'Dance 4', 'sound_set_11', 's', 1, 1, 0.2, '1', '0', '0', 2563, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(889, 'Hip Hop Beats 1', 'sound_set_10', 's', 1, 1, 0.2, '1', '0', '0', 2481, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(890, 'Rope Divider', 'rope_divider', 's', 2, 1, 0.001, '0', '0', '0', 2518, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(891, 'romantique_clock', 'romantique_clock', 's', 1, 1, 1, '0', '0', '0', 2520, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(892, 'Aqua Pura Module 5', 'rare_icecream_campaign', 's', 1, 1, 1, '0', '0', '0', 2507, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(893, 'Pink Pura Module 5', 'pura_mdl5*2', 's', 1, 1, 1, '0', '1', '0', 2510, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(894, 'Black Pura Module 5', 'pura_mdl5*3', 's', 1, 1, 1, '0', '1', '0', 2511, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(895, 'White Pura Module 5', 'pura_mdl5*4', 's', 1, 1, 1, '0', '1', '0', 2512, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(896, 'beige pura module 5', 'pura_mdl5*5', 's', 1, 1, 1, '0', '1', '0', 2513, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(897, 'Blue Pura Module 5', 'pura_mdl5*6', 's', 1, 1, 1, '0', '1', '0', 2514, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(898, 'Green Pura Module 5', 'pura_mdl5*7', 's', 1, 1, 1, '0', '1', '0', 2515, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(899, 'Yellow Pura Module 5', 'pura_mdl5*8', 's', 1, 1, 1, '0', '1', '0', 2516, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(900, 'Red Pura Module 5', 'pura_mdl5*9', 's', 1, 1, 1, '0', '1', '0', 2517, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(901, 'Aqua Pura Module 4', 'pura_mdl4*1', 's', 1, 1, 1, '0', '1', '0', 2472, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(902, 'Pink Pura Module 4', 'pura_mdl4*2', 's', 1, 1, 1, '0', '1', '0', 2473, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(903, 'Black Pura Module 4', 'pura_mdl4*3', 's', 1, 1, 1, '0', '1', '0', 2474, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(904, 'White Pura Module 4', 'pura_mdl4*4', 's', 1, 1, 1, '0', '1', '0', 2475, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(905, 'beige pura module 4', 'pura_mdl4*5', 's', 1, 1, 1, '0', '1', '0', 2476, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(906, 'Blue Pura Module 4', 'pura_mdl4*6', 's', 1, 1, 1, '0', '1', '0', 2477, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(907, 'Green Pura Module 4', 'pura_mdl4*7', 's', 1, 1, 1, '0', '1', '0', 2478, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(908, 'yellow pura module 4', 'pura_mdl4*8', 's', 1, 1, 1, '0', '1', '0', 2479, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(909, 'Red Pura Module 4', 'pura_mdl4*9', 's', 1, 1, 1, '0', '1', '0', 2480, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(910, 'Aqua Pura Module 3', 'pura_mdl3*1', 's', 1, 1, 1, '0', '1', '0', 2534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(911, 'Pink Pura Module 3', 'pura_mdl3*2', 's', 1, 1, 1, '0', '1', '0', 2535, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(912, 'Black Pura Module 3', 'pura_mdl3*3', 's', 1, 1, 1, '0', '1', '0', 2536, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(913, 'White Pura Module 3', 'pura_mdl3*4', 's', 1, 1, 1, '0', '1', '0', 2537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(914, 'beige pura module 3', 'pura_mdl3*5', 's', 1, 1, 1, '0', '1', '0', 2538, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(915, 'Blue Pura Module 3', 'pura_mdl3*6', 's', 1, 1, 1, '0', '1', '0', 2539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(916, 'Green Pura Module 3', 'pura_mdl3*7', 's', 1, 1, 1, '0', '1', '0', 2540, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(917, 'yellow pura module 3', 'pura_mdl3*8', 's', 1, 1, 1, '0', '1', '0', 2541, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(918, 'Red Pura Module 3', 'pura_mdl3*9', 's', 1, 1, 1, '0', '1', '0', 2542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(919, 'Aqua Pura Module 2', 'pura_mdl2*1', 's', 1, 1, 1, '0', '1', '0', 2483, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(920, 'Pink Pura Module 2', 'pura_mdl2*2', 's', 1, 1, 1, '0', '1', '0', 2484, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(921, 'Black Pura Module 2', 'pura_mdl2*3', 's', 1, 1, 1, '0', '1', '0', 2485, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(922, 'White Pura Module 2', 'pura_mdl2*4', 's', 1, 1, 1, '0', '1', '0', 2486, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(923, 'beige pura module 2', 'pura_mdl2*5', 's', 1, 1, 1, '0', '1', '0', 2487, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(924, 'Blue Pura Module 2', 'pura_mdl2*6', 's', 1, 1, 1, '0', '1', '0', 2488, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(925, 'Green Pura Module 2', 'pura_mdl2*7', 's', 1, 1, 1, '0', '1', '0', 2489, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(926, 'yellow pura module 2', 'pura_mdl2*8', 's', 1, 1, 1, '0', '1', '0', 2490, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(927, 'Red Pura Module 2', 'pura_mdl2*9', 's', 1, 1, 1, '0', '1', '0', 2491, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(928, 'Aqua Pura Module 1', 'pura_mdl1*1', 's', 1, 1, 1, '0', '1', '0', 2460, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(929, 'Pink Pura Module 1', 'pura_mdl1*2', 's', 1, 1, 1, '0', '1', '0', 2461, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(930, 'Black Pura Module 1', 'pura_mdl1*3', 's', 1, 1, 1, '0', '1', '0', 2462, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(931, 'White Pura Module 1', 'pura_mdl1*4', 's', 1, 1, 1, '0', '1', '0', 2463, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(932, 'beige pura module 1', 'pura_mdl1*5', 's', 1, 1, 1, '0', '1', '0', 2464, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(933, 'Blue Pura Module 1', 'pura_mdl1*6', 's', 1, 1, 1, '0', '1', '0', 2465, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(934, 'Green Pura Module 1', 'pura_mdl1*7', 's', 1, 1, 1, '0', '1', '0', 2466, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(935, 'yellow pura module 1', 'pura_mdl1*8', 's', 1, 1, 1, '0', '1', '0', 2467, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(936, 'Red Pura Module 1', 'pura_mdl1*9', 's', 1, 1, 1, '0', '1', '0', 2468, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(937, 'Japanese Lantern', 'jp_lantern', 's', 1, 1, 1, '0', '0', '0', 2471, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(938, 'chair_basic', 'chair_basic*1', 's', 1, 1, 1.1, '0', '1', '0', 2525, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(939, 'Pink Pura Egg Chair', 'chair_basic*2', 's', 1, 1, 1.1, '0', '1', '0', 2526, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(940, 'Black Pura Egg Chair', 'chair_basic*3', 's', 1, 1, 1.1, '0', '1', '0', 2527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(941, 'White Pura Egg Chair', 'chair_basic*4', 's', 1, 1, 1.1, '0', '1', '0', 2528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(942, 'Beige Pura Egg Chair', 'chair_basic*5', 's', 1, 1, 1.1, '0', '1', '0', 2529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(943, 'Blue Pura Egg Chair', 'chair_basic*6', 's', 1, 1, 1.1, '0', '1', '0', 2530, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(944, 'Green Pura Egg Chair', 'chair_basic*7', 's', 1, 1, 1.1, '0', '1', '0', 2531, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(945, 'chair_basic', 'chair_basic*8', 's', 1, 1, 1.1, '0', '1', '0', 2532, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(946, 'Red Pura Egg Chair', 'chair_basic*9', 's', 1, 1, 1.1, '0', '1', '0', 2533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(947, '', 'bed_budget*1', 's', 2, 3, 1.9, '0', '0', '0', 2552, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(948, 'Pink Pura Double Bed', 'bed_budget*2', 's', 2, 3, 1.9, '0', '0', '0', 2553, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(949, 'Black Pura Double Bed', 'bed_budget*3', 's', 2, 3, 1.9, '0', '0', '0', 2554, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(950, 'White Pura Double Bed', 'bed_budget*4', 's', 2, 3, 1.9, '0', '0', '0', 2555, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(951, 'Beige Pura Double Bed', 'bed_budget*5', 's', 2, 3, 1.9, '0', '0', '0', 2556, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(952, 'Blue Pura Double Bed', 'bed_budget*6', 's', 2, 3, 1.9, '0', '0', '0', 2557, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(953, 'Green Pura Double Bed', 'bed_budget*7', 's', 2, 3, 1.9, '0', '0', '0', 2558, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(954, 'Yellow Pura Double Bed', 'bed_budget*8', 's', 2, 3, 1.9, '0', '0', '0', 2559, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(955, 'Red Pura Double Bed', 'bed_budget*9', 's', 2, 3, 1.9, '0', '0', '0', 2560, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(956, '', 'bed_budget_one*1', 's', 1, 3, 1.9, '0', '0', '0', 2498, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(957, 'Pink Pura Bed', 'bed_budget_one*2', 's', 1, 3, 1.9, '0', '0', '0', 2499, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(958, 'Black Pura Bed', 'bed_budget_one*3', 's', 1, 3, 1.9, '0', '0', '0', 2500, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(959, 'White Pura Bed', 'bed_budget_one*4', 's', 1, 3, 1.9, '0', '0', '0', 2501, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(960, 'Beige Pura Bed', 'bed_budget_one*5', 's', 1, 3, 1.9, '0', '0', '0', 2502, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(961, 'Blue Pura Bed', 'bed_budget_one*6', 's', 1, 3, 1.9, '0', '0', '0', 2503, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(962, 'Green Pura Bed', 'bed_budget_one*7', 's', 1, 3, 1.9, '0', '0', '0', 2504, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(963, 'Yellow Pura Bed', 'bed_budget_one*8', 's', 1, 3, 1.9, '0', '0', '0', 2505, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(964, 'Red Pura Bed', 'bed_budget_one*9', 's', 1, 3, 1.9, '0', '0', '0', 2506, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(965, 'Japanese Drawer', 'jp_drawer', 's', 1, 1, 1, '1', '0', '0', 2522, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(966, 'Star Tile', 'tile_stella', 's', 1, 1, 0.05, '1', '0', '1', 2568, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(967, 'Marble Tile', 'tile_marble', 's', 1, 1, 0.1, '1', '0', '1', 2566, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(968, 'Red Tile', 'tile_brown', 's', 1, 1, 0.05, '1', '0', '1', 2582, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(969, 'Blue Barbeque Grill', 'summer_grill*1', 's', 2, 1, 1, '0', '0', '0', 2587, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(970, 'Red Barbeque Grill', 'summer_grill*2', 's', 2, 1, 1, '0', '0', '0', 2588, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(971, 'Green Barbeque Grill', 'summer_grill*3', 's', 2, 1, 1, '0', '0', '0', 2589, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(972, 'Green Barbeque Grill', 'summer_grill*4', 's', 2, 1, 1, '0', '0', '0', 2590, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(973, 'Aqua Deck Chair', 'summer_chair*1', 's', 1, 1, 1, '0', '1', '0', 2571, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(974, 'Pink Deck Chair', 'summer_chair*2', 's', 1, 1, 1, '0', '1', '0', 2572, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(975, 'Black Deck Chair', 'summer_chair*3', 's', 1, 1, 1, '0', '1', '0', 2573, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(976, 'White Deck Chair', 'summer_chair*4', 's', 1, 1, 1, '0', '1', '0', 2574, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(977, 'Deck Chair', 'summer_chair*5', 's', 1, 1, 1, '0', '1', '0', 2575, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(978, 'Deck Chair', 'summer_chair*6', 's', 1, 1, 1, '0', '1', '0', 2576, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(979, 'Green Deck Chair', 'summer_chair*7', 's', 1, 1, 1, '0', '1', '0', 2577, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(980, 'Yellow Deck Chair', 'summer_chair*8', 's', 1, 1, 1, '0', '1', '0', 2578, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(981, 'Red Deck Chair', 'summer_chair*9', 's', 1, 1, 1, '0', '1', '0', 2579, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(982, 'Latin Love 1', 'sound_set_36', 's', 1, 1, 0.2, '1', '0', '0', 2583, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(983, 'Dance 6', 'sound_set_35', 's', 1, 1, 0.2, '1', '0', '0', 2595, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(984, 'Rock 5', 'sound_set_34', 's', 1, 1, 0.2, '1', '0', '0', 2570, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(985, 'Rock 3', 'sound_set_33', 's', 1, 1, 0.2, '1', '0', '0', 2564, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(986, 'Instrumental 2', 'sound_set_32', 's', 1, 1, 0.2, '1', '0', '0', 2569, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(987, 'Dance 3', 'sound_set_31', 's', 1, 1, 0.2, '1', '0', '0', 2596, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(988, 'Instrumental 1', 'sound_set_30', 's', 1, 1, 0.2, '1', '0', '0', 2585, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(989, 'Dance 2', 'sound_set_29', 's', 1, 1, 0.2, '1', '0', '0', 2580, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(990, 'Sound Machine Pro', 'sound_machine_pro', 's', 1, 1, 1, '0', '0', '0', 2606, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(991, 'Aqua One Way Gate', 'rare_mnstr', 's', 1, 1, 0.001, '0', '0', '0', 2584, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(992, 'Black HC Gate', 'one_way_door*2', 's', 1, 1, 0.001, '0', '0', '0', 2598, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(993, 'White HC Gate', 'one_way_door*3', 's', 1, 1, 0.001, '0', '0', '0', 2599, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(994, 'Beige One Way Gate', 'one_way_door*4', 's', 1, 1, 0.001, '0', '0', '0', 2600, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(995, 'Pink One Way Gate', 'one_way_door*5', 's', 1, 1, 0.001, '0', '0', '0', 2601, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(996, 'Blue HC Gate', 'one_way_door*6', 's', 1, 1, 0.001, '0', '0', '0', 2602, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(997, 'Green One Way Gate', 'one_way_door*7', 's', 1, 1, 0.001, '0', '0', '0', 2603, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(998, 'Yellow One Way Gate', 'one_way_door*8', 's', 1, 1, 0.001, '0', '0', '0', 2604, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(999, 'Red One Way Gate', 'one_way_door*9', 's', 1, 1, 0.001, '0', '0', '0', 2605, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(1000, 'Executive Rug', 'exe_rug', 's', 3, 3, 0, '1', '0', '1', 2567, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1001, 'Executive Glass Table', 'exe_s_table', 's', 2, 2, 1, '1', '0', '0', 2581, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1002, 'Sound set 37', 'sound_set_37', 's', 1, 1, 0.2, '1', '0', '0', 2565, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1003, 'Blue Summer Pool', 'summer_pool*1', 's', 2, 2, 0, '0', '0', '1', 2591, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1004, 'Red Summer Pool', 'summer_pool*2', 's', 2, 2, 0, '0', '0', '1', 2592, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1005, 'Green Summer Pool', 'summer_pool*3', 's', 2, 2, 0, '0', '0', '1', 2593, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1006, 'Yellow Summer Pool', 'summer_pool*4', 's', 2, 2, 0, '0', '0', '1', 2594, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1007, 'Burn', 'song_disk', 's', 1, 1, 0.1, '1', '0', '0', 2607, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1008, 'Jukebox', 'jukebox*1', 's', 1, 1, 1, '1', '0', '0', 2608, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1009, 'Welcome', 'carpet_soft_tut', 's', 1, 1, 0, '1', '0', '1', 2609, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1010, 'Graveyard Portal', 'sound_set_44', 's', 1, 1, 0.2, '1', '0', '0', 2610, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1011, 'SFX 1', 'sound_set_43', 's', 1, 1, 0.2, '1', '0', '0', 2614, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1012, 'Haunted Mansion', 'sound_set_42', 's', 1, 1, 0.2, '1', '0', '0', 2624, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1013, 'Rock 8', 'sound_set_41', 's', 1, 1, 0.2, '1', '0', '0', 2612, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1014, 'Rock 4', 'sound_set_40', 's', 1, 1, 0.2, '1', '0', '0', 2615, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1015, 'Rock 7', 'sound_set_39', 's', 1, 1, 0.2, '1', '0', '0', 2622, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1016, 'Rock 6', 'sound_set_38', 's', 1, 1, 0.2, '1', '0', '0', 2616, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1017, 'Grunge Chair', 'grunge_chair', 's', 1, 1, 1, '0', '1', '0', 2617, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1018, 'Grunge Mattress', 'grunge_mattress', 's', 3, 1, 1, '0', '1', '0', 2618, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1019, 'Radiator', 'grunge_radiator', 's', 1, 1, 1, '0', '0', '0', 2621, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1020, 'Grunge Bookshelf', 'grunge_shelf', 's', 3, 1, 1, '0', '0', '0', 2619, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1021, 'Road Sign', 'grunge_sign', 's', 1, 1, 1, '0', '0', '0', 2613, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1022, 'Grunge Table', 'grunge_table', 's', 2, 2, 1, '1', '0', '0', 2623, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1023, 'Creepy Crypt', 'habboween_crypt', 's', 1, 3, 1.1, '0', '0', '0', 2611, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(1024, 'Unholy Ground', 'habboween_grass', 's', 2, 2, 0, '0', '0', '1', 2626, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1025, 'Habboween Cauldron', 'hal_cauldron', 's', 1, 1, 1, '0', '0', '0', 2625, '1', '1', '1', '1', '1', 'vendingmachine', 0, '30', ''),
(1026, 'Haunted Grave', 'hal_grave', 's', 1, 1, 1, '0', '0', '0', 2620, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1027, 'Christmas Party', 'sound_set_52', 's', 1, 1, 0.2, '1', '0', '0', 2633, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1028, 'Club 6', 'sound_set_51', 's', 1, 1, 0.2, '1', '0', '0', 2631, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1029, 'Club 5', 'sound_set_50', 's', 1, 1, 0.2, '1', '0', '0', 2632, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1030, 'Club 4', 'sound_set_49', 's', 1, 1, 0.2, '1', '0', '0', 2634, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1031, 'Club 3', 'sound_set_48', 's', 1, 1, 0.2, '1', '0', '0', 2629, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1032, 'Club 2', 'sound_set_47', 's', 1, 1, 0.2, '1', '0', '0', 2627, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1033, 'Club 1', 'sound_set_46', 's', 1, 1, 0.2, '1', '0', '0', 2630, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1034, 'Lost_Beatness', 'sound_set_45', 's', 1, 1, 0.2, '1', '0', '0', 2628, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1035, 'Lantern Bundle 2', 'xmas_icelamp', 's', 1, 1, 1, '1', '0', '0', 2641, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1036, 'Ice Castle Wall', 'xmas_cstl_wall', 's', 2, 1, 1, '0', '0', '0', 2646, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1037, 'Ice Castle Tower', 'xmas_cstl_twr', 's', 1, 1, 1, '0', '0', '0', 2651, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1038, 'Ice Castle Gate', 'xmas_cstl_gate', 's', 2, 1, 0.001, '0', '0', '0', 2636, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1039, 'Snowy Christmas Tree', 'tree7', 's', 1, 1, 1, '0', '0', '0', 2653, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1040, 'Flashy Christmas Tree', 'tree6', 's', 1, 1, 1, '0', '0', '0', 2638, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1041, 'Oh Blinging Tree', 'sound_set_54', 's', 1, 1, 0.2, '1', '0', '0', 2649, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1042, 'Snowy Surprise', 'sound_set_53', 's', 1, 1, 0.2, '1', '0', '0', 2652, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1043, 'postbank Safe', 'safe_silo_pb', 's', 1, 1, 1.3, '1', '0', '0', 2642, '1', '1', '1', '1', '1', 'vendingmachine', 0, '17', ''),
(1044, 'Snowy Maze Gate', 'plant_mazegate_snow', 's', 2, 1, 0.001, '0', '0', '1', 2640, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1045, 'Snowy Maze Bundle 2', 'plant_maze_snow', 's', 2, 1, 1, '0', '0', '1', 2635, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1046, 'Winter Sleigh', 'christmas_sleigh', 's', 2, 2, 1, '0', '0', '0', 2648, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1047, 'Reindeer', 'christmas_reindeer', 's', 1, 2, 1, '0', '0', '0', 2637, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1048, 'Reindeer Droppings', 'christmas_poop', 's', 1, 1, 1, '0', '0', '0', 2654, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1049, 'Executive Bar Desk', 'exe_bardesk', 's', 1, 1, 1, '1', '0', '0', 2643, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1050, 'Executive Sofa Chair', 'exe_chair', 's', 1, 1, 1, '0', '1', '0', 2647, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1051, 'Executive Boss Chair', 'exe_chair2', 's', 1, 1, 1, '0', '1', '0', 2650, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1052, 'Executive Corner Desk', 'exe_corner', 's', 1, 1, 1, '1', '0', '0', 2655, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1053, 'Executive Drinks Tray', 'exe_drinks', 's', 1, 1, 1, '0', '0', '0', 2645, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1054, '3-Seater Sofa', 'exe_sofa', 's', 3, 1, 1, '0', '1', '0', 2639, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1055, 'Take a memo', 'exe_table', 's', 3, 2, 1.1, '0', '0', '0', 2644, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1056, 'RnB Grooves 5', 'sound_set_59', 's', 1, 1, 0.2, '1', '0', '0', 2670, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1057, 'RnB Grooves 4', 'sound_set_58', 's', 1, 1, 0.2, '1', '0', '0', 2656, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1058, 'RnB Grooves 3', 'sound_set_57', 's', 1, 1, 0.2, '1', '0', '0', 2673, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1059, 'RnB Grooves 2', 'sound_set_56', 's', 1, 1, 0.2, '1', '0', '0', 2669, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1060, 'RnB Grooves 1', 'sound_set_55', 's', 1, 1, 0.2, '1', '0', '0', 2671, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1061, 'Lightweight', 'noob_table*1', 's', 2, 2, 1, '1', '0', '0', 2687, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1062, 'Lightweight', 'noob_table*2', 's', 2, 2, 1, '1', '0', '0', 2688, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1063, 'Lightweight', 'noob_table*3', 's', 2, 2, 1, '1', '0', '0', 2689, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1064, 'Lightweight', 'noob_table*4', 's', 2, 2, 1, '1', '0', '0', 2690, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1065, 'Lightweight', 'noob_table*5', 's', 2, 2, 1, '1', '0', '0', 2691, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1066, 'Lightweight', 'noob_table*6', 's', 2, 2, 1, '1', '0', '0', 2692, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1067, 'My first Habbo stool', 'noob_stool*1', 's', 1, 1, 1, '0', '1', '0', 2657, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1068, 'My first Habbo stool', 'noob_stool*2', 's', 1, 1, 1, '0', '1', '0', 2658, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1069, 'My first Habbo stool', 'noob_stool*3', 's', 1, 1, 1, '0', '1', '0', 2659, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1070, 'My first Habbo stool', 'noob_stool*4', 's', 1, 1, 1, '0', '1', '0', 2660, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1071, 'My first Habbo stool', 'noob_stool*5', 's', 1, 1, 1, '0', '1', '0', 2661, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1072, 'My first Habbo stool', 'noob_stool*6', 's', 1, 1, 1, '0', '1', '0', 2662, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1073, 'My first Habbo rug', 'noob_rug*1', 's', 2, 3, 0, '1', '0', '1', 2681, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1074, 'My first Habbo rug', 'noob_rug*2', 's', 2, 3, 0, '1', '0', '1', 2682, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1075, 'My first Habbo rug', 'noob_rug*3', 's', 2, 3, 0, '1', '0', '1', 2683, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1076, 'My first Habbo rug', 'noob_rug*4', 's', 2, 3, 0, '1', '0', '1', 2684, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1077, 'My first Habbo rug', 'noob_rug*5', 's', 2, 3, 0, '1', '0', '1', 2685, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1078, 'My first Habbo rug', 'noob_rug*6', 's', 2, 3, 0, '1', '0', '1', 2686, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1079, 'My first Habbo lamp', 'noob_lamp*1', 's', 1, 1, 1, '0', '0', '0', 2663, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1080, 'My first Habbo lamp', 'noob_lamp*2', 's', 1, 1, 1, '0', '0', '0', 2664, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1081, 'My first Habbo lamp', 'noob_lamp*3', 's', 1, 1, 1, '0', '0', '0', 2665, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1082, 'My first Habbo lamp', 'noob_lamp*4', 's', 1, 1, 1, '0', '0', '0', 2666, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1083, 'My first Habbo lamp', 'noob_lamp*5', 's', 1, 1, 1, '0', '0', '0', 2667, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1084, 'My first Habbo lamp', 'noob_lamp*6', 's', 1, 1, 1, '0', '0', '0', 2668, '0', '0', '1', '0', '1', 'default', 2, '0', ''),
(1085, 'Lightweight', 'noob_chair*1', 's', 1, 1, 1, '0', '1', '0', 2675, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1086, ' practical', 'noob_chair*2', 's', 1, 1, 1, '0', '1', '0', 2676, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1087, ' practical', 'noob_chair*3', 's', 1, 1, 1, '0', '1', '0', 2677, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1088, ' practical', 'noob_chair*4', 's', 1, 1, 1, '0', '1', '0', 2678, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1089, ' practical', 'noob_chair*5', 's', 1, 1, 1, '0', '1', '0', 2679, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1090, 'Power Globe', 'noob_chair*6', 's', 1, 1, 1, '0', '1', '0', 2680, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1091, 'Executive Plant', 'exe_plant', 's', 1, 1, 1, '0', '0', '0', 2674, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1092, 'Grey Share Bear', 'val_teddy*1', 's', 1, 1, 1, '0', '1', '0', 2699, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1093, 'Pink Share Bear', 'val_teddy*2', 's', 1, 1, 1, '0', '1', '0', 2700, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1094, 'Green Share Bear', 'val_teddy*3', 's', 1, 1, 1, '0', '1', '0', 2701, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1095, 'Brown Share Bear', 'val_teddy*4', 's', 1, 1, 1, '0', '1', '0', 2702, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1096, 'Yellow Share Bear', 'val_teddy*5', 's', 1, 1, 1, '0', '1', '0', 2703, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1097, 'Blue Share Bear', 'val_teddy*6', 's', 1, 1, 1, '0', '1', '0', 2704, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1098, 'Love Randomiser', 'val_randomizer', 's', 4, 1, 1.4, '0', '1', '0', 2696, '1', '1', '1', '1', '1', 'loveshuffler', 1, '0', ''),
(1099, 'Heart Shaped Chocs', 'val_choco', 's', 1, 1, 1, '0', '0', '0', 2697, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1100, 'Teleport Door', 'teleport_door', 's', 1, 1, 0.001, '0', '0', '1', 2693, '1', '1', '0', '1', '1', 'teleport', 2, '0', ''),
(1101, 'Latin Love 3', 'sound_set_61', 's', 1, 1, 0.2, '1', '0', '0', 2698, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1102, 'Latin Love 2', 'sound_set_60', 's', 1, 1, 0.2, '1', '0', '0', 2695, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1103, 'Crystal Ball', 'fortune', 's', 1, 1, 1, '0', '0', '0', 2694, '1', '1', '1', '1', '1', 'dice', 1, '0', ''),
(1104, 'Adventure Desk', 'sw_table', 's', 1, 2, 1, '0', '0', '0', 2713, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1105, 'Raven', 'sw_raven', 's', 1, 1, 1, '0', '0', '0', 2711, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1106, 'Ye Olde Chest', 'sw_chest', 's', 1, 2, 1, '0', '0', '0', 2709, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1107, 'Sand Castle Wall', 'sand_cstl_wall', 's', 2, 1, 1, '0', '0', '0', 2710, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1108, 'Sand Castle Tower', 'sand_cstl_twr', 's', 1, 1, 1, '0', '0', '0', 2705, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1109, 'Sand Castle Gate', 'sand_cstl_gate', 's', 2, 1, 0.001, '0', '0', '0', 2712, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1110, 'Candle Box', 'grunge_candle', 's', 1, 1, 1, '0', '0', '0', 2708, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1111, 'Bench', 'grunge_bench', 's', 3, 1, 1, '0', '1', '0', 2707, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1112, 'Flaming Barrel', 'grunge_barrel', 's', 1, 1, 1, '0', '0', '0', 2706, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1113, 'Moon Lamp', 'rclr_lamp', 's', 1, 1, 1, '0', '0', '0', 2733, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1115, 'Bubble trophy', 'a0 prizetrophy8_g', 's', 1, 1, 1, '0', '0', '0', 2426, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1116, 'nouvelle_trax', 'nouvelle_trax', 's', 1, 1, 1, '0', '0', '0', 2736, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1117, 'Bubble Juice Floor', 'md_rug', 's', 4, 4, 0, '1', '0', '1', 2727, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1118, 'Sushi Kohada', 'jp_tray6', 's', 1, 1, 1, '0', '0', '0', 2720, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1119, 'Sushi Tamago', 'jp_tray5', 's', 1, 1, 1, '0', '0', '0', 2717, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1120, 'Sushi Uni', 'jp_tray4', 's', 1, 1, 1, '0', '0', '0', 2725, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1121, 'Sushi Ikura', 'jp_tray3', 's', 1, 1, 1, '0', '0', '0', 2726, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1122, 'Sushi Ika', 'jp_tray2', 's', 1, 1, 1, '0', '0', '0', 2724, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1123, 'Sushi Maguro', 'jp_tray1', 's', 1, 1, 1, '0', '0', '0', 2715, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1124, 'Tea Maker', 'arabian_teamk', 's', 1, 1, 1, '0', '0', '0', 2716, '1', '1', '1', '1', '1', 'vendingmachine', 0, '1', ''),
(1125, 'Ornamental Urn', 'arabian_snake', 's', 1, 1, 1, '0', '0', '0', 2732, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1126, 'Berber Kilim Rug', 'arabian_rug', 's', 3, 5, 0, '1', '0', '1', 2719, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1127, 'Green Blossom Pillow', 'arabian_pllw', 's', 1, 1, 0.8, '0', '1', '0', 2722, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1128, 'Soft wooden screen', 'arabian_divdr', 's', 1, 2, 1, '0', '0', '0', 2730, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1129, 'Exotic', 'arabian_chair', 's', 1, 1, 1.2, '0', '1', '0', 2721, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1130, 'Amanjena Table', 'arabian_bigtb', 's', 3, 2, 0.8, '1', '0', '0', 2731, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1131, 'Hexagonal Tea Table', 'arabian_tetbl', 's', 1, 1, 1, '1', '0', '0', 2714, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1132, 'Mint Tea Tray', 'arabian_tray1', 's', 1, 1, 1, '0', '0', '0', 2734, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1133, 'Candle Tray', 'arabian_tray2', 's', 1, 1, 1, '0', '0', '0', 2735, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1134, 'Sweets Tray', 'arabian_tray3', 's', 1, 1, 1, '0', '0', '0', 2723, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1135, 'Sweet', 'arabian_tray4', 's', 1, 1, 1, '0', '0', '0', 2728, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1136, 'Alhambra Trax 3', 'sound_set_64', 's', 1, 1, 0.2, '1', '0', '0', 2738, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1137, 'Alhambra Trax 2', 'sound_set_63', 's', 1, 1, 0.2, '1', '0', '0', 2740, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1138, 'Alhambra Trax 1', 'sound_set_62', 's', 1, 1, 0.2, '1', '0', '0', 2741, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1139, 'Jukebox Pacha TV', 'jukebox_ptv*1', 's', 1, 1, 1, '0', '0', '0', 2739, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1140, 'Calippo icecream machine', 'calippo', 's', 1, 1, 1, '0', '0', '0', 2737, '1', '1', '1', '1', '1', 'vendingmachine', 0, '4', ''),
(1141, 'traxsilver', 'traxsilver', 's', 1, 1, 1, '1', '0', '0', 2744, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1142, 'traxgold', 'traxgold', 's', 1, 1, 1, '1', '0', '0', 2742, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1143, 'traxbronze', 'traxbronze', 's', 1, 1, 1, '1', '0', '0', 2743, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1144, 'bench_puffet', 'bench_puffet', 's', 2, 1, 1, '0', '1', '0', 2745, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1145, 'Gold Bar (China)', 'CFC_500_goldbar', 's', 1, 1, 0.4, '1', '0', '0', 2764, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1146, 'Sack of Credits (China)', 'CFC_200_moneybag', 's', 1, 1, 1, '1', '0', '0', 2770, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1148, 'Gold Coin (China)', 'CFC_100_coin_gold', 's', 1, 1, 0.2, '1', '0', '0', 2796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1149, 'Silver Coin (China)', 'CFC_50_coin_silver', 's', 1, 1, 0.2, '1', '0', '0', 2772, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1150, 'Chabu Dai', 'jp_table', 's', 2, 2, 1, '0', '0', '0', 2749, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1151, 'Shishi Odishi', 'jp_rare', 's', 2, 2, 1, '0', '0', '0', 2750, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1152, 'Katana Green', 'jp_katana3', 's', 1, 1, 1, '0', '0', '0', 2748, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1153, 'Katana Blue', 'jp_katana2', 's', 1, 1, 1, '0', '0', '0', 2747, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1154, 'HC Katana Red', 'jp_katana1', 's', 1, 1, 1, '0', '0', '0', 2751, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1156, 'Tiki Waterfall', 'tiki_waterfall', 's', 3, 2, 1, '0', '0', '0', 2757, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1157, 'Tiki Pig Tray', 'tiki_tray4', 's', 1, 1, 1, '0', '0', '0', 2765, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1158, 'Tiki Fish Tray', 'tiki_tray3', 's', 1, 1, 1, '0', '0', '0', 2753, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1159, 'Tiki Pineapple Plate', 'tiki_tray2', 's', 1, 1, 1, '0', '0', '0', 2768, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1160, 'Tiki Fruit Tray', 'tiki_tray1', 's', 1, 1, 1, '0', '0', '0', 2755, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1161, 'Empty Tray', 'tiki_tray0', 's', 1, 1, 1, '0', '0', '0', 2792, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1162, 'Toucan', 'tiki_toucan', 's', 1, 1, 1, '0', '0', '0', 2756, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1163, 'Beach Torch', 'tiki_torch', 's', 1, 1, 1, '0', '0', '0', 2773, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1164, 'Tribal Statue', 'tiki_statue', 's', 1, 1, 1, '0', '0', '0', 2782, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1165, 'Island Sand Patch', 'tiki_sand', 's', 2, 2, 0, '1', '0', '1', 2798, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1166, 'Tiki Parasol', 'tiki_parasol', 's', 1, 1, 1, '0', '0', '0', 2769, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1167, 'Jungle Patch', 'tiki_junglerug', 's', 2, 2, 0, '1', '0', '1', 2781, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1168, 'Tiki Bar Corner', 'tiki_corner', 's', 1, 1, 1, '1', '0', '0', 2794, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1169, 'Butterflies', 'tiki_bflies', 's', 1, 1, 1, '0', '0', '0', 2785, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1170, 'Tiki Bar Stool', 'tiki_bench', 's', 1, 1, 1.3, '0', '1', '0', 2784, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1171, 'Tiki Bar Desk', 'tiki_bardesk', 's', 1, 1, 1, '1', '0', '0', 2795, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1172, 'tampax_rug', 'tampax_rug', 's', 3, 4, 0, '1', '0', '1', 2754, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1173, 'Sound set 70', 'sound_set_70', 's', 1, 1, 0.2, '1', '0', '0', 2767, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1174, 'Sound set 69', 'sound_set_69', 's', 1, 1, 0.2, '1', '0', '0', 2799, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1175, 'Sound set 68', 'sound_set_68', 's', 1, 1, 0.2, '1', '0', '0', 2793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1176, 'Sound set 67', 'sound_set_67', 's', 1, 1, 0.2, '1', '0', '0', 2771, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1177, 'Sound set 66', 'sound_set_66', 's', 1, 1, 0.2, '1', '0', '0', 2752, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1178, 'Sound set 65', 'sound_set_65', 's', 1, 1, 0.2, '1', '0', '0', 2766, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1185, 'Lucky Bamboo', 'noob_plant', 's', 1, 1, 1, '0', '0', '0', 2783, '0', '1', '1', '0', '1', 'default', 1, '0', ''),
(1197, 'Japanese Teamaker', 'jp_teamaker', 's', 1, 1, 1, '0', '0', '0', 2774, '1', '1', '1', '1', '1', 'vendingmachine', 0, '28', ''),
(1198, 'September 2008', 'svnr_uk', 's', 1, 1, 1, '0', '0', '0', 2838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1199, 'August 2008', 'svnr_nl', 's', 1, 2, 1, '0', '1', '0', 2825, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1200, 'July 2008', 'svnr_it', 's', 2, 1, 1, '0', '1', '0', 2813, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1201, 'October 2008', 'svnr_de', 's', 1, 1, 1, '0', '0', '0', 2801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1202, 'November 2008', 'svnr_aus', 's', 1, 1, 1, '0', '0', '0', 2836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1203, 'Accompaniments', 'diner_tray_7', 's', 1, 1, 1, '0', '0', '0', 2840, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1204, 'Vanilla', 'diner_tray_6', 's', 1, 1, 1, '0', '0', '0', 2826, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1205, 'Bacon and Eggs', 'diner_tray_5', 's', 1, 1, 1, '0', '0', '0', 2815, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1206, 'Pancakes', 'diner_tray_4', 's', 1, 1, 1, '0', '0', '0', 2800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1207, 'Spaghetti Meatballs', 'diner_tray_3', 's', 1, 1, 1, '0', '0', '0', 2841, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1208, 'Steak and Mash', 'diner_tray_2', 's', 1, 1, 1, '0', '0', '0', 2802, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1209, 'Burger and Chips', 'diner_tray_1', 's', 1, 1, 1, '0', '0', '0', 2839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1210, 'Had your fill', 'diner_tray_0', 's', 1, 1, 0.1, '1', '0', '0', 2837, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1211, 'Aqua Diner Sofa 2', 'diner_sofa_2*1', 's', 1, 1, 1, '0', '1', '0', 2804, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1212, 'Pink Diner Sofa 2', 'diner_sofa_2*2', 's', 1, 1, 1, '0', '1', '0', 2805, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1213, 'Black Diner Sofa 2', 'diner_sofa_2*3', 's', 1, 1, 1, '0', '1', '0', 2806, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1214, 'White Diner Sofa 2', 'diner_sofa_2*4', 's', 1, 1, 1, '0', '1', '0', 2807, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1215, 'Latte Diner Sofa 2', 'diner_sofa_2*5', 's', 1, 1, 1, '0', '1', '0', 2808, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1216, 'Blue Diner Sofa 2', 'diner_sofa_2*6', 's', 1, 1, 1, '0', '1', '0', 2809, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1217, 'Green Diner Sofa 2', 'diner_sofa_2*7', 's', 1, 1, 1, '0', '1', '0', 2810, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1218, 'Yellow Diner Sofa 2', 'diner_sofa_2*8', 's', 1, 1, 1, '0', '1', '0', 2811, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1219, 'Red Diner Sofa 2', 'diner_sofa_2*9', 's', 1, 1, 1, '0', '1', '0', 2812, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1220, 'Diner Shaker', 'diner_shaker', 's', 1, 1, 1, '0', '0', '0', 2814, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1221, 'Diner Floor', 'diner_rug', 's', 2, 2, 0, '1', '0', '1', 2803, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1222, 'Aqua Gumball Machine', 'diner_gumvendor*1', 's', 1, 1, 1, '0', '0', '0', 2827, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1223, 'Pink Gumball Machine', 'diner_gumvendor*2', 's', 1, 1, 1, '0', '0', '0', 2828, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1224, 'Black Gumball Machine', 'diner_gumvendor*3', 's', 1, 1, 1, '0', '0', '0', 2829, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1225, 'White Gumball Machine', 'diner_gumvendor*4', 's', 1, 1, 1, '0', '0', '0', 2830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1226, 'Latte Gumball Machine', 'diner_gumvendor*5', 's', 1, 1, 1, '0', '0', '0', 2831, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1227, 'Blue Gumball Machine', 'diner_gumvendor*6', 's', 1, 1, 1, '0', '0', '0', 2832, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture_old` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1228, 'Green Gumball Machine', 'diner_gumvendor*7', 's', 1, 1, 1, '0', '0', '0', 2833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1229, 'Yellow Gumball Machine', 'diner_gumvendor*8', 's', 1, 1, 1, '0', '0', '0', 2834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1230, 'Red Gumball Machine', 'diner_gumvendor*9', 's', 1, 1, 1, '0', '0', '0', 2835, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1231, 'Aqua Diner Till', 'diner_cashreg*1', 's', 1, 1, 1, '0', '0', '0', 2816, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1232, 'Pink Diner Till', 'diner_cashreg*2', 's', 1, 1, 1, '0', '0', '0', 2817, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1233, 'Black Diner Till', 'diner_cashreg*3', 's', 1, 1, 1, '0', '0', '0', 2818, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1234, 'White Diner Till', 'diner_cashreg*4', 's', 1, 1, 1, '0', '0', '0', 2819, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1235, 'Latte Diner Till', 'diner_cashreg*5', 's', 1, 1, 1, '0', '0', '0', 2820, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1236, 'Blue Diner Till', 'diner_cashreg*6', 's', 1, 1, 1, '0', '0', '0', 2821, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1237, 'Green Diner Till', 'diner_cashreg*7', 's', 1, 1, 1, '0', '0', '0', 2822, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1238, 'Yellow Diner Till', 'diner_cashreg*8', 's', 1, 1, 1, '0', '0', '0', 2823, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1239, 'Red Diner Till', 'diner_cashreg*9', 's', 1, 1, 1, '0', '0', '0', 2824, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1240, 'Aqua Diner Table', 'diner_table_2*1', 's', 3, 2, 1, '1', '0', '0', 2879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1241, 'Pink Diner Table', 'diner_table_2*2', 's', 3, 2, 1, '1', '0', '0', 2880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1242, 'Black Diner Table', 'diner_table_2*3', 's', 3, 2, 1, '1', '0', '0', 2881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1243, 'White Diner Table', 'diner_table_2*4', 's', 3, 2, 1, '1', '0', '0', 2882, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1244, 'Latte Diner Table', 'diner_table_2*5', 's', 3, 2, 1, '1', '0', '0', 2883, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1245, 'Blue Diner Table', 'diner_table_2*6', 's', 3, 2, 1, '1', '0', '0', 2884, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1246, 'Green Diner Table', 'diner_table_2*7', 's', 3, 2, 1, '1', '0', '0', 2885, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1247, 'Yellow Diner Table', 'diner_table_2*8', 's', 3, 2, 1, '1', '0', '0', 2886, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1248, 'Red Diner Table', 'diner_table_2*9', 's', 3, 2, 1, '1', '0', '0', 2887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1249, 'Aqua Diner Booth Table', 'diner_table_1*1', 's', 2, 2, 1, '1', '0', '0', 2897, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1250, 'Pink Diner Booth Table', 'diner_table_1*2', 's', 2, 2, 1, '1', '0', '0', 2898, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1251, 'Black Diner Booth Table', 'diner_table_1*3', 's', 2, 2, 1, '1', '0', '0', 2899, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1252, 'White Diner Booth Table', 'diner_table_1*4', 's', 2, 2, 1, '1', '0', '0', 2900, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1253, 'Latte Diner Booth Table', 'diner_table_1*5', 's', 2, 2, 1, '1', '0', '0', 2901, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1254, 'Blue Diner Booth Table', 'diner_table_1*6', 's', 2, 2, 1, '1', '0', '0', 2902, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1255, 'Green Diner Booth Table', 'diner_table_1*7', 's', 2, 2, 1, '1', '0', '0', 2903, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1256, 'Yellow Diner Booth Table', 'diner_table_1*8', 's', 2, 2, 1, '1', '0', '0', 2904, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1257, 'Red Diner Booth Table', 'diner_table_1*9', 's', 2, 2, 1, '1', '0', '0', 2905, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1258, 'Aqua Diner Sofa 1', 'diner_sofa_1*1', 's', 1, 1, 1, '0', '1', '0', 2888, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1259, 'Pink Diner Sofa 1', 'diner_sofa_1*2', 's', 1, 1, 1, '0', '1', '0', 2889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1260, 'Black Diner Sofa 1', 'diner_sofa_1*3', 's', 1, 1, 1, '0', '1', '0', 2890, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1261, 'White Diner Sofa 1', 'diner_sofa_1*4', 's', 1, 1, 1, '0', '1', '0', 2891, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1262, 'Latte Diner Sofa 1', 'diner_sofa_1*5', 's', 1, 1, 1, '0', '1', '0', 2892, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1263, 'Blue Diner Sofa 1', 'diner_sofa_1*6', 's', 1, 1, 1, '0', '1', '0', 2893, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1264, 'Green Diner Sofa 1', 'diner_sofa_1*7', 's', 1, 1, 1, '0', '1', '0', 2894, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1265, 'Yellow Diner Sofa 1', 'diner_sofa_1*8', 's', 1, 1, 1, '0', '1', '0', 2895, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1266, 'Red Diner Sofa 1', 'diner_sofa_1*9', 's', 1, 1, 1, '0', '1', '0', 2896, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1267, 'Aqua Diner Stool', 'diner_chair*1', 's', 1, 1, 1.4, '0', '1', '0', 2861, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1268, 'Pink Diner Stool', 'diner_chair*2', 's', 1, 1, 1.4, '0', '1', '0', 2862, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1269, 'Black Diner Stool', 'diner_chair*3', 's', 1, 1, 1.4, '0', '1', '0', 2863, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1270, 'White Diner Stool', 'diner_chair*4', 's', 1, 1, 1.4, '0', '1', '0', 2864, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1271, 'Latte Diner Stool', 'diner_chair*5', 's', 1, 1, 1.4, '0', '1', '0', 2865, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1272, 'Blue Diner Stool', 'diner_chair*6', 's', 1, 1, 1.4, '0', '1', '0', 2866, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1273, 'Green Diner Stool', 'diner_chair*7', 's', 1, 1, 1.4, '0', '1', '0', 2867, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1274, 'Yellow Diner Stool', 'diner_chair*8', 's', 1, 1, 1.4, '0', '1', '0', 2868, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1275, 'Red Diner Stool', 'diner_chair*9', 's', 1, 1, 1.4, '0', '1', '0', 2869, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1276, 'Aqua Diner Gate', 'diner_bardesk_gate*1', 's', 1, 1, 0.001, '0', '0', '0', 2842, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1277, 'Pink Diner Gate', 'diner_bardesk_gate*2', 's', 1, 1, 0.001, '0', '0', '0', 2843, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1278, 'Black Diner Gate', 'diner_bardesk_gate*3', 's', 1, 1, 0.001, '0', '0', '0', 2844, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1279, 'White Diner Gate', 'diner_bardesk_gate*4', 's', 1, 1, 0.001, '0', '0', '0', 2845, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1280, 'Latte Diner Gate', 'diner_bardesk_gate*5', 's', 1, 1, 0.001, '0', '0', '0', 2846, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1281, 'Blue Diner Gate', 'diner_bardesk_gate*6', 's', 1, 1, 0.001, '0', '0', '0', 2847, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1282, 'Green Diner Gate', 'diner_bardesk_gate*7', 's', 1, 1, 0.001, '0', '0', '0', 2848, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1283, 'Yellow Diner Gate', 'diner_bardesk_gate*8', 's', 1, 1, 0.001, '0', '0', '0', 2849, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1284, 'Red Diner Gate', 'diner_bardesk_gate*9', 's', 1, 1, 0.001, '0', '0', '0', 2850, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1285, 'Aqua Diner Corner', 'diner_bardesk_corner*1', 's', 1, 1, 1, '1', '0', '0', 2870, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1286, 'Pink Diner Corner', 'diner_bardesk_corner*2', 's', 1, 1, 1, '1', '0', '0', 2871, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1287, 'Black Diner Corner', 'diner_bardesk_corner*3', 's', 1, 1, 1, '1', '0', '0', 2872, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1288, 'Latte Diner Corner', 'diner_bardesk_corner*4', 's', 1, 1, 1, '1', '0', '0', 2873, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1289, 'Blue Diner Corner', 'diner_bardesk_corner*6', 's', 1, 1, 1, '1', '0', '0', 2875, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1290, 'Green Diner Corner', 'diner_bardesk_corner*7', 's', 1, 1, 1, '1', '0', '0', 2876, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1291, 'Yellow Diner Corner', 'diner_bardesk_corner*8', 's', 1, 1, 1, '1', '0', '0', 2877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1292, 'Red Diner Corner', 'diner_bardesk_corner*9', 's', 1, 1, 1, '1', '0', '0', 2878, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1293, 'Aqua Diner Bar', 'diner_bardesk*1', 's', 1, 1, 1, '1', '0', '0', 2851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1294, 'Pink Diner Bar', 'diner_bardesk*2', 's', 1, 1, 1, '1', '0', '0', 2852, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1295, 'Black Diner Bar', 'diner_bardesk*3', 's', 1, 1, 1, '1', '0', '0', 2853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1296, 'White Diner Bar', 'diner_bardesk*4', 's', 1, 1, 1, '1', '0', '0', 2854, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1297, 'Latte Diner Bar', 'diner_bardesk*5', 's', 1, 1, 1, '1', '0', '0', 2855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1298, 'Blue Diner Bar', 'diner_bardesk*6', 's', 1, 1, 1, '1', '0', '0', 2856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1299, 'Green Diner Bar', 'diner_bardesk*7', 's', 1, 1, 1, '1', '0', '0', 2857, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1300, 'Yellow Diner Bar', 'diner_bardesk*8', 's', 1, 1, 1, '1', '0', '0', 2858, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1301, 'Red Diner Bar', 'diner_bardesk*9', 's', 1, 1, 1, '1', '0', '0', 2859, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1302, 'ads_dave_cns', 'ads_dave_cns', 's', 1, 1, 1, '0', '0', '0', 2860, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1303, 'easy_carpet name', 'easy_carpet', 's', 4, 4, 0, '1', '0', '1', 2911, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1304, 'easy_bowl2', 'easy_bowl2', 's', 1, 1, 1, '1', '0', '0', 2907, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1305, 'Greek Corner', 'greek_corner', 's', 1, 1, 1, '0', '0', '0', 2910, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1306, 'Enter mortal', 'greek_gate', 's', 2, 1, 0.001, '0', '0', '0', 2908, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1307, 'Greek Pillars', 'greek_pillars', 's', 2, 1, 1, '0', '0', '0', 2909, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1308, 'Greek Seat', 'greek_seat', 's', 1, 1, 0.5, '0', '1', '0', 2906, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1309, 'Greek trophy', 'a0 greektrophy_g', 's', 1, 1, 1, '0', '0', '0', 2622, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1310, 'Greek trophy', 'a0 greektrophy_s', 's', 1, 1, 1, '0', '0', '0', 2623, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1311, 'Greek trophy', 'a0 greektrophy_b', 's', 1, 1, 1, '0', '0', '0', 2624, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1312, 'greek_block', 'greek_block', 's', 2, 1, 0.8, '0', '1', '0', 2915, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1313, 'Glass Table', 'hcc_table', 's', 1, 2, 1, '0', '0', '0', 2923, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1314, 'Bookshelf', 'hcc_shelf', 's', 1, 2, 1, '0', '0', '0', 2917, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1315, 'Low Back Sofa', 'hcc_sofa', 's', 2, 1, 1.2, '0', '1', '0', 2921, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1316, 'Cool look', 'hcc_minibar', 's', 1, 1, 1, '0', '0', '0', 2924, '1', '1', '1', '1', '1', 'vendingmachine', 0, '24', ''),
(1317, 'Trendy Stool', 'hcc_chair', 's', 1, 1, 1, '0', '1', '0', 2919, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1318, 'Crime scene', 'det_divider', 's', 2, 1, 1, '0', '0', '0', 2918, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1319, 'netari_carpet', 'netari_carpet', 's', 3, 5, 0, '1', '0', '1', 2916, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1320, 'Chalk Outline', 'det_body', 's', 2, 3, 0, '0', '0', '1', 2922, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1321, 'Antique Stool', 'hcc_stool', 's', 1, 1, 1.2, '0', '1', '0', 2920, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1322, 'Reclining Chair', 'hcc_sofachair', 's', 1, 1, 1.2, '0', '1', '0', 2925, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1323, 'Glass Corner', 'hcc_crnr', 's', 1, 1, 1, '0', '0', '0', 2926, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1324, 'Glass Divider', 'hcc_dvdr', 's', 2, 1, 1, '0', '0', '0', 2927, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1325, 'sob_carpet', 'sob_carpet', 's', 3, 5, 0, '1', '0', '1', 2928, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1326, 'My Hump', 'igor_seat', 's', 1, 1, 1, '0', '1', '0', 2929, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1327, 'The Brain', 'ads_igorbrain', 's', 1, 1, 1, '0', '0', '0', 2936, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1328, 'Igor Switch', 'ads_igorswitch', 's', 1, 1, 1, '0', '0', '0', 2934, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1329, 'ads_711', 'ads_711*1', 's', 1, 1, 1, '0', '0', '0', 2930, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1330, 'ads_711', 'ads_711*2', 's', 1, 1, 1, '0', '0', '0', 2931, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1331, 'ads_711', 'ads_711*3', 's', 1, 1, 1, '0', '0', '0', 2932, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1332, 'ads_711', 'ads_711*4', 's', 1, 1, 1, '0', '0', '0', 2933, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1333, 'Igor Ray Gun', 'ads_igorraygun', 's', 1, 2, 1, '0', '0', '0', 2935, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1334, 'Blood Sink', 'hween08_sink', 's', 1, 1, 1, '0', '0', '0', 2944, '1', '1', '1', '1', '1', 'vendingmachine', 0, '29', ''),
(1335, 'Hospital Curtain (blood)', 'hween08_curtain', 's', 3, 1, 1, '0', '0', '0', 2942, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1336, 'Blood Bath', 'hween08_bath', 's', 1, 2, 1, '0', '1', '0', 2948, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1337, 'Life Support (blood)', 'hween08_defibs', 's', 1, 1, 1, '0', '0', '0', 2938, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1338, 'Body Bag', 'hween08_bbag', 's', 1, 3, 1.3, '0', '0', '0', 2943, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1339, 'Hospital Curtain (ooze)', 'hween08_curtain2', 's', 3, 1, 1, '0', '0', '0', 2949, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1340, 'Life Support (ooze)', 'hween08_defibs2', 's', 1, 1, 1, '0', '0', '0', 2939, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1341, 'Hospital Bed (blood)', 'hween08_bed', 's', 1, 3, 2, '0', '0', '0', 2945, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1342, 'Ooze Sink', 'hween08_sink2', 's', 1, 1, 1, '0', '0', '0', 2940, '1', '1', '1', '1', '1', 'vendingmachine', 0, '30', ''),
(1343, 'Hospital Bed (ooze)', 'hween08_bed2', 's', 1, 3, 1, '0', '0', '0', 2937, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(1344, 'Ooze Bath', 'hween08_bath2', 's', 1, 2, 1, '0', '1', '0', 2947, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1345, 'Manhole', 'hween08_manhole', 's', 1, 1, 1, '0', '0', '0', 2946, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1346, ' poke', 'hween08_trll', 's', 1, 1, 1, '0', '0', '0', 2941, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1347, 'Glass High Bar Table', 'party_table', 's', 1, 1, 1, '1', '0', '0', 2956, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1348, 'Spotlight', 'party_discol', 's', 1, 1, 1, '0', '0', '0', 2963, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1349, 'Stage Block Large', 'party_block2', 's', 2, 2, 0.7, '1', '0', '1', 2950, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1350, 'Bar Corner', 'party_barcorn', 's', 1, 1, 1, '1', '0', '0', 2957, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1351, 'High Class Bar Stool', 'party_chair', 's', 1, 1, 1.3, '0', '1', '0', 2960, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1352, 'Small Stage', 'party_block', 's', 1, 1, 0.9, '1', '0', '1', 2959, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1353, 'Dance Floor Laser', 'party_ravel', 's', 1, 1, 1, '0', '0', '0', 2965, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1354, 'Despite being made a lava', 'party_tube_lava', 's', 1, 1, 1, '0', '0', '0', 2966, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1355, 'Club Tray', 'party_tray', 's', 1, 1, 1, '0', '0', '0', 2955, '1', '1', '1', '1', '1', 'vendingmachine', 0, '31', ''),
(1356, 'Scratch it', 'party_djtable', 's', 1, 2, 1, '0', '0', '0', 2954, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1357, 'Disco Floor', 'party_floor', 's', 2, 2, 0, '1', '0', '1', 2958, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1358, 'Glitter Ball', 'party_ball', 's', 1, 1, 0, '0', '0', '1', 2964, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1359, 'Bubbles Machine', 'party_tube_bubble', 's', 1, 1, 1, '0', '0', '0', 2951, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1360, ' MC', 'party_mic', 's', 1, 1, 1, '0', '0', '0', 2953, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1361, 'Dance Floor Beamer', 'party_beamer', 's', 1, 1, 1, '0', '0', '0', 2961, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(1362, 'Bar Centre', 'party_bardesk', 's', 1, 1, 1, '1', '0', '0', 2962, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1363, 'Club seat', 'party_seat', 's', 1, 1, 1.1, '0', '1', '0', 2952, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1364, 'Snow Seat', 'xmas08_snowpl', 's', 1, 1, 1, '0', '1', '1', 3005, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1365, 'Emperor Penguin', 'penguin_basic', 's', 1, 1, 1, '0', '0', '0', 2977, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1366, 'Arctic Penguin Trophy', 'xmas08_trph1', 's', 1, 1, 1, '0', '0', '0', 2972, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1367, 'Musketeer Penguin', 'penguin_musketeer', 's', 1, 1, 1, '0', '0', '0', 2995, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1368, 'Icy table', 'xmas08_table', 's', 2, 2, 1, '1', '0', '0', 3009, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1369, 'Hot Tub', 'xmas08_hottub', 's', 2, 2, 1, '0', '0', '0', 2986, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1370, 'Luchador Penguin', 'penguin_wrestler', 's', 1, 1, 1, '0', '0', '0', 2990, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1371, 'Blow it up', 'fx_explosion', 's', 1, 1, 1, '0', '0', '0', 3011, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(1372, 'Robot Penguin', 'penguin_robot', 's', 1, 1, 1, '0', '0', '0', 2969, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1373, 'Icy Christmas Tree', 'xmas08_icetree', 's', 1, 1, 1, '0', '0', '0', 2967, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1374, 'Camp fire', 'campfire', 's', 1, 1, 1, '1', '0', '0', 2974, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1375, 'Ice', 'xmas08_icerug', 's', 2, 2, 0, '1', '0', '1', 3002, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1376, 'Executive Penguin', 'penguin_suit', 's', 1, 1, 1, '0', '0', '0', 3008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1377, 'December 2008', 'svnr_fi', 's', 1, 1, 1, '0', '0', '0', 2991, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1378, 'Snow Storm', 'xmas_snow', 's', 2, 2, 0, '1', '0', '1', 2982, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1379, 'Hockey Penguin', 'penguin_icehockey', 's', 1, 1, 1, '0', '0', '0', 2988, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1380, 'Pilot Penguin', 'penguin_pilot', 's', 1, 1, 1, '0', '0', '0', 3007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1381, 'Ballerina Penguin', 'penguin_ballet', 's', 1, 1, 1, '0', '0', '0', 2996, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1382, 'Arctic SFX', 'sound_set_71', 's', 1, 1, 0.2, '1', '0', '0', 3000, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1383, 'Boxer Penguin', 'penguin_boxer', 's', 1, 1, 1, '0', '0', '0', 2979, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1384, 'Fluorescent Penguin', 'penguin_glow', 's', 1, 1, 1, '0', '0', '0', 2993, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1385, 'Summer Penguin', 'penguin_swim', 's', 1, 1, 1, '0', '0', '0', 2984, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1386, 'Sumo Penguin', 'penguin_sumo', 's', 1, 1, 1, '0', '0', '0', 2994, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1387, 'Bubbles', 'xmas08_geysir', 's', 2, 2, 1, '0', '0', '0', 2985, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1388, 'Clown Penguin', 'penguin_clown', 's', 1, 1, 1, '0', '0', '0', 2989, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1389, 'Infected Penguin', 'penguin_infected', 's', 1, 1, 1, '0', '0', '0', 2983, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1390, 'Firestarter', 'fx_flare', 's', 1, 1, 1, '1', '0', '0', 3013, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(1391, 'Snowball Lantern Pile', 'xmas08_lantern', 's', 1, 1, 1, '0', '0', '0', 2968, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1392, 'Ice chair', 'xmas08_chair', 's', 1, 1, 1, '0', '1', '0', 3001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1393, 'Superhero Penguin', 'penguin_super', 's', 1, 1, 1, '0', '0', '0', 2998, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1394, 'Icy Teleport', 'xmas08_telep', 's', 1, 1, 0.001, '0', '0', '0', 2978, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1395, 'Cube Tree', 'xmas08_cubetree', 's', 1, 1, 1, '0', '0', '0', 3006, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1396, 'Disco Penguin', 'penguin_rock', 's', 1, 1, 1, '0', '0', '0', 3010, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1397, 'Ice divider', 'xmas08_dvdr1', 's', 2, 1, 1, '0', '0', '0', 2992, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1398, 'Ice Fish Hole', 'xmas08_hole', 's', 1, 1, 1, '0', '0', '0', 2980, '1', '1', '1', '1', '1', 'vendingmachine', 0, '34', ''),
(1399, 'XC Penguin', 'penguin_ski', 's', 1, 1, 1, '0', '0', '0', 2981, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1400, 'Skater Penguin', 'penguin_skater', 's', 1, 1, 1, '0', '0', '0', 2973, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1401, 'Icy Divider Corner', 'xmas08_dvdr2', 's', 1, 1, 1, '0', '0', '0', 2970, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1402, 'Christmas Penguin', 'penguin_elf', 's', 1, 1, 1, '0', '0', '0', 2971, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1403, 'Bunny Penguin', 'penguin_bunny', 's', 1, 1, 1, '0', '0', '0', 2975, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1404, 'Ninja Penguin', 'penguin_ninja', 's', 1, 1, 1, '0', '0', '0', 2976, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1405, 'Magic Penguin', 'penguin_magician', 's', 1, 1, 1, '0', '0', '0', 2997, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1406, 'Beautiful Penguin', 'penguin_hunchback', 's', 1, 1, 1, '0', '0', '0', 3003, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1407, 'Cowboy Penguin', 'penguin_cowboy', 's', 1, 1, 1, '0', '0', '0', 2987, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1408, 'Punk Penguin', 'penguin_punk', 's', 1, 1, 1, '0', '0', '0', 3004, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1409, 'Pirate Penguin', 'penguin_pirate', 's', 1, 1, 1, '0', '0', '0', 2999, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1410, 'ads_ob_pillow name', 'ads_ob_pillow', 's', 1, 1, 1, '0', '1', '0', 3018, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1411, 'Leviathon', 'lostc_merdragon', 's', 1, 3, 1, '0', '0', '0', 3016, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1412, 'Idea Agency Desk', 'ads_cldesk', 's', 2, 2, 1, '0', '0', '0', 3017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1413, 'Eco Friendly Penguin', 'xmas08_trph2', 's', 1, 1, 1, '0', '0', '0', 3015, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1414, 'Whatever your Idea', 'ads_cltele', 's', 1, 1, 0.001, '0', '0', '0', 3014, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1415, 'Childline Rug', 'ads_clfloor', 's', 3, 5, 0, '1', '0', '1', 3019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1417, 'Mall tele-door', 'ads_mall_tele', 's', 1, 1, 0.001, '1', '0', '1', 3020, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1418, 'Moongate', 'china_moongt', 's', 1, 3, 0.001, '0', '0', '1', 3024, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1419, 'Lotus Pool', 'bolly_lotus_pool', 's', 2, 2, 0, '0', '0', '0', 3022, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1420, 'Ox Statue', 'china_ox', 's', 1, 1, 1, '0', '0', '0', 3025, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1422, 'Petal Flurry', 'bolly_petals', 's', 2, 2, 0, '1', '0', '1', 3026, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1423, 'Palm Tree', 'bolly_tree', 's', 1, 1, 1, '0', '0', '0', 3042, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1424, 'Swing low', 'bolly_swing', 's', 2, 1, 1.5, '0', '1', '0', 3037, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1425, 'Star Pillow', 'bolly_pillow', 's', 1, 1, 0.8, '0', '1', '0', 3030, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1426, 'Bollywood Corner', 'bolly_corner', 's', 1, 1, 1, '1', '0', '0', 3031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1427, 'Elephant MiniBar', 'bolly_phant', 's', 1, 1, 1, '0', '0', '0', 3033, '1', '1', '1', '1', '1', 'vendingmachine', 0, '35', ''),
(1428, 'Monkey Lamp', 'bolly_monkey_lamp', 's', 1, 1, 1, '0', '0', '0', 3036, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1429, 'Green Curtain', 'bolly_drapeb', 's', 3, 1, 0.001, '0', '0', '0', 3040, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1430, 'Planet of Love', 'planet_of_love', 's', 1, 1, 1, '1', '0', '0', 3044, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1431, 'Chandelier', 'bolly_lamp', 's', 1, 1, 1, '0', '0', '0', 3041, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1432, 'Bollywood Desk', 'bolly_desk', 's', 2, 1, 1, '1', '0', '0', 3034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1433, 'Vase of Flowers', 'bolly_vase', 's', 1, 1, 1, '0', '0', '0', 3043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1434, 'Standard Tile', 'bolly_tile2', 's', 2, 2, 0, '1', '0', '1', 3027, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1435, 'Large Ornamental Table', 'bolly_table', 's', 2, 2, 1, '1', '0', '0', 3035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1436, 'Yellow Curtain', 'bolly_drapec', 's', 3, 1, 0.001, '0', '0', '0', 3032, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1437, 'Extravagant Fountain', 'bolly_fountain', 's', 2, 2, 1, '0', '0', '0', 3029, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1439, 'Ornamental Tile', 'bolly_tile1', 's', 2, 2, 0, '1', '0', '1', 3028, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1440, 'Pink Curtain', 'bolly_drapea', 's', 3, 1, 0.001, '0', '0', '0', 3038, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1441, 'ads_idol_floor1 name', 'ads_idol_floor1', 's', 2, 2, 0, '1', '0', '1', 3045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1442, 'Inventor''s Desk', 'ads_igor_dsk', 's', 2, 1, 1, '0', '0', '0', 3049, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1443, 'ads_idol_desk', 'ads_idol_desk', 's', 1, 4, 1, '0', '0', '0', 3050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1444, 'ads_idol_ch', 'ads_idol_ch', 's', 1, 1, 1.2, '0', '1', '0', 3051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1445, 'Glass Flask', 'ads_igor_flask', 's', 1, 1, 1, '0', '0', '0', 3046, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1446, 'ads_idol_drape name', 'ads_idol_drape', 's', 3, 1, 0.001, '0', '0', '0', 3048, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1447, 'ads_idol_floor2 name', 'ads_idol_floor2', 's', 2, 2, 0, '1', '0', '1', 3047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1448, 'Kraken', 'lostc_octopus', 's', 1, 2, 1, '0', '0', '0', 3052, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1449, 'Marble Floor Tile', 'lc_tile1', 's', 2, 2, 0, '1', '0', '1', 3076, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1450, 'Small Jellyfish Lamp', 'lc_medusa2', 's', 1, 1, 1, '0', '0', '0', 3073, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1451, 'Sally Lightfoot', 'lc_crab2', 's', 1, 1, 1, '0', '0', '0', 3068, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1452, 'March Collectable 2009', 'lostc_teleport', 's', 1, 1, 0.001, '0', '0', '1', 3071, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1453, 'ads_idol_piano name', 'ads_idol_piano', 's', 2, 2, 1, '0', '0', '0', 3058, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1454, 'Large Coral Divider', 'lc_coral_divider_hi', 's', 2, 1, 1, '0', '0', '0', 3078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1455, 'ads_711shelf name', 'ads_711shelf', 's', 1, 2, 1, '0', '0', '0', 3066, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1456, 'Water Tube Corner', 'lc_tubes_corners', 's', 1, 1, 1, '0', '0', '0', 3072, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1457, 'Captain''s Table', 'lc_table', 's', 2, 2, 1, '1', '0', '0', 3067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1458, 'Cobbled Stones', 'lc_tile2', 's', 2, 2, 0, '1', '0', '1', 3069, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1459, 'Anemone', 'lc_anemone', 's', 1, 1, 1, '0', '0', '0', 3074, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1460, 'Small Coral Divider', 'lc_coral_divider_low', 's', 2, 1, 1, '0', '0', '0', 3077, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1461, 'Ocean Window Rug', 'lc_glass_floor', 's', 2, 3, 0, '1', '0', '1', 3060, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1462, 'Large Jellyfish Lamp', 'lc_medusa1', 's', 1, 1, 1, '0', '0', '0', 3064, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1463, 'Crab Patch', 'lc_crab1', 's', 2, 2, 1, '0', '0', '0', 3062, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1464, 'ads_idol_jukebox name', 'ads_idol_jukebox*1', 's', 1, 1, 1, '0', '0', '0', 3059, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1465, 'ads_idol_pchair name', 'ads_idol_pchair', 's', 1, 1, 1, '0', '1', '0', 3056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1466, 'Water Tube Straight', 'lc_tubes_straight', 's', 1, 1, 1, '0', '0', '0', 3065, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1467, 'ads_idol_audChr name', 'ads_idol_audChr', 's', 1, 1, 1, '0', '1', '0', 3057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1468, 'ads_idol_trax name', 'ads_idol_trax', 's', 1, 1, 1, '0', '0', '0', 3055, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1469, 'ads_idol_tele', 'ads_idol_tele', 's', 1, 1, 0.001, '0', '0', '1', 3053, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1470, 'Wooden Corner', 'lc_corner', 's', 1, 1, 1, '1', '0', '0', 3075, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1471, 'Wooden Stool', 'lc_stool', 's', 1, 1, 1, '0', '1', '0', 3063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1472, 'No rusty nails', 'lc_chair', 's', 1, 1, 1, '0', '1', '0', 3061, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1473, 'Wooden Bar Desk', 'lc_desk', 's', 2, 1, 1, '1', '0', '0', 3070, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1474, 'ads_idol_mic name', 'ads_idol_mic', 's', 1, 1, 1, '0', '0', '0', 3054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1475, 'ads_idol_hotspot name', 'ads_idol_hotspot', 's', 1, 1, 0.2, '0', '0', '1', 3080, '1', '1', '1', '1', '1', 'default', 103, '0', ''),
(1476, 'ads_idol_clRack name', 'ads_idol_clRack', 's', 3, 1, 1, '0', '0', '0', 3079, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1477, 'ads_idol_voting_ch name', 'ads_idol_voting_ch', 's', 1, 1, 1.2, '0', '1', '0', 3081, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1478, 'Ecotron prize', 'ecotron_box', 's', 1, 1, 1, '1', '0', '0', 3095, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1479, 'Eco Light 2', 'eco_light2', 's', 1, 1, 1, '1', '0', '0', 3082, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1480, 'Eco Stool 3', 'eco_chair3', 's', 1, 1, 1, '0', '1', '0', 3094, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1481, 'Eco Coffee Table 3', 'eco_table3', 's', 2, 2, 1, '1', '0', '0', 3086, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1482, 'Eco Lamp 2', 'eco_lamp2', 's', 1, 1, 1, '1', '0', '0', 3092, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1483, 'Eco Armchair 3', 'eco_sofa3', 's', 1, 1, 1, '0', '1', '0', 3088, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1484, 'Eco Coffee Table 2', 'eco_table2', 's', 2, 2, 1, '1', '0', '0', 3089, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1485, 'Fruit Bowl 2', 'eco_fruits2', 's', 1, 1, 1, '1', '0', '0', 3102, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1486, 'Eco Armchair 1', 'eco_sofa1', 's', 1, 1, 1, '0', '1', '0', 3096, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1487, 'Fruit Bowl 3', 'eco_fruits3', 's', 1, 1, 1, '1', '0', '0', 3104, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1488, 'Eco Light 1', 'eco_light1', 's', 1, 1, 1, '1', '0', '0', 3098, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1489, 'Actually', 'eco_tree1', 's', 1, 1, 1, '0', '0', '0', 3093, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1490, 'Potted Cactus 2', 'eco_cactus2', 's', 1, 1, 1, '1', '0', '0', 3105, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1491, 'Talk To FRANK Brain Lamp', 'ads_frankb', 's', 1, 1, 1, '0', '0', '0', 3111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1492, 'Road Signs', 'bump_signs', 's', 1, 1, 1, '0', '0', '0', 3090, '1', '1', '1', '0', '1', 'default', 7, '0', ''),
(1493, 'Potted Cactus 1', 'eco_cactus1', 's', 1, 1, 1, '1', '0', '0', 3083, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1494, 'Eco Stool 2', 'eco_chair2', 's', 1, 1, 1, '0', '1', '0', 3106, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1495, 'Potted Cactus 3', 'eco_cactus3', 's', 1, 1, 1, '1', '0', '0', 3085, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1496, 'Bumper Tyres', 'bump_tires', 's', 1, 1, 0.8, '1', '0', '0', 3101, '1', '1', '1', '0', '1', 'default', 3, '0', ''),
(1497, 'Traffic Lights', 'bump_lights', 's', 1, 1, 1, '0', '0', '0', 3103, '1', '1', '1', '0', '1', 'default', 3, '0', ''),
(1498, 'Eco Lamp 3', 'eco_lamp3', 's', 1, 1, 1, '1', '0', '0', 3091, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1499, 'Eco Coffee Table 1', 'eco_table1', 's', 2, 2, 1, '1', '0', '0', 3099, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1500, 'Eco Stool 1', 'eco_chair1', 's', 1, 1, 1, '0', '1', '0', 3084, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1501, 'Eco Armchair 2', 'eco_sofa2', 's', 1, 1, 1, '0', '1', '0', 3100, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1502, 'Road', 'bump_road', 's', 2, 2, 0, '1', '0', '1', 3110, '1', '1', '1', '0', '1', 'default', 4, '0', ''),
(1503, 'Fruit Bowl 1', 'eco_fruits1', 's', 1, 1, 1, '1', '0', '0', 3107, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1504, 'Eco Lamp 1', 'eco_lamp1', 's', 1, 1, 1, '1', '0', '0', 3097, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1505, 'Eco Light 3', 'eco_light3', 's', 1, 1, 1, '1', '0', '0', 3108, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1506, 'Pear Tree', 'eco_tree2', 's', 1, 1, 1, '0', '0', '0', 3109, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1507, 'Totem Leg', 'totem_leg', 's', 1, 1, 1.2, '1', '0', '0', 3113, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(1508, 'ads_grefusa_cactus name', 'ads_grefusa_cactus', 's', 1, 1, 1, '0', '0', '0', 3112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1509, 'ads_idol_tube name', 'ads_idol_tube', 's', 1, 1, 1, '0', '0', '0', 3126, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1510, 'Executive Light', 'exe_light', 's', 1, 1, 0, '1', '0', '1', 3122, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1511, 'ads_idol_cork name', 'ads_idol_cork', 's', 3, 1, 1, '0', '0', '0', 3120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1512, 'Idea Agency Jukebox', 'ads_cl_jukeb', 's', 1, 1, 1, '0', '0', '0', 3127, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1513, 'Grass patch', 'env_grass', 's', 2, 2, 0, '1', '0', '1', 3129, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1514, 'Forest Trunk Seat', 'env_tree3', 's', 1, 1, 1, '0', '0', '0', 3125, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1515, 'Eco Hedgerow', 'env_bushes', 's', 1, 2, 1, '0', '0', '0', 3115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1516, 'Eco Hedgerows Gate', 'env_bushes_gate', 's', 1, 2, 0.001, '0', '0', '0', 3128, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1517, 'Executive Gate', 'exe_gate', 's', 1, 1, 0.001, '0', '0', '0', 3119, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1518, 'ads_idol_newsDsk name', 'ads_idol_newsDsk', 's', 2, 2, 1, '0', '0', '0', 3116, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1519, 'Forest Tree Chair', 'env_tree1', 's', 1, 1, 1, '0', '1', '0', 3117, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1520, 'Forest Tree Americana', 'env_tree2', 's', 1, 1, 1, '0', '1', '0', 3123, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1521, 'Cubist Light', 'exe_cubelight', 's', 1, 1, 1, '0', '0', '0', 3121, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1522, 'The Four Seasons Tree', 'env_tree4', 's', 2, 2, 1, '0', '0', '0', 3118, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1523, 'Sphere Lamp', 'exe_artlamp', 's', 1, 1, 1, '0', '0', '0', 3114, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1524, 'ads_idol_ichair name', 'ads_idol_ichair', 's', 1, 1, 1.4, '0', '1', '0', 3124, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1525, 'Wedding Cake', 'tray_cake', 's', 1, 1, 1, '0', '0', '0', 3133, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1526, 'ads_reebok_block2', 'ads_reebok_block2', 's', 2, 2, 0.8, '1', '0', '1', 3132, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1527, 'ads_malaco_rug_name', 'ads_malaco_rug', 's', 3, 3, 0, '1', '0', '1', 3135, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1528, 'Champagne Bucket', 'tray_champagne', 's', 1, 1, 1, '0', '0', '0', 3134, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1529, 'Champagne Tower', 'tray_glasstower', 's', 1, 1, 1, '0', '0', '0', 3130, '1', '1', '1', '1', '1', 'vendingmachine', 0, '40', ''),
(1530, 'ads_malaco_gu', 'ads_malaco_gu', 's', 1, 1, 1, '0', '0', '0', 3131, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1531, 'Idea Agency Super Cake', 'ads_clcake', 's', 1, 1, 1, '0', '0', '0', 3139, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1532, 'Idea Agency Sofa', 'ads_cl_sofa', 's', 2, 1, 1, '0', '1', '0', 3137, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1533, 'Function Table', 'ads_idol_tblCloth', 's', 2, 2, 1, '1', '0', '0', 3136, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1534, 'ads_idol_carpet name', 'ads_idol_carpet', 's', 2, 7, 0, '0', '0', '1', 3140, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1535, 'Function Lamp', 'ads_idol_lamp', 's', 1, 1, 0, '1', '0', '1', 3138, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1536, 'Rain Shower', 'country_rain', 's', 1, 1, 0, '1', '0', '1', 3153, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1537, 'Scarecrow', 'country_scarecrow', 's', 1, 1, 1, '0', '0', '0', 3160, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1538, 'Porta-House', 'env_telep', 's', 1, 1, 0.001, '0', '0', '0', 3161, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1539, 'Crop Field', 'country_soil', 's', 2, 2, 0, '1', '0', '1', 3145, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1540, 'Field Grass', 'country_grass', 's', 2, 2, 0, '1', '0', '1', 3162, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1541, 'The Golden Tablet', 'ads_goldtabl', 's', 1, 1, 1, '0', '0', '0', 3151, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1542, 'Witch Mushroom', 'eco_mush1', 's', 1, 1, 1, '1', '0', '0', 3142, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1543, 'Tractor', 'country_trctr', 's', 2, 2, 1, '0', '0', '0', 3147, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1544, 'Stone Wall', 'country_fnc2', 's', 2, 1, 1, '0', '0', '0', 3141, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1545, 'Stick Fence', 'country_fnc1', 's', 2, 1, 1, '0', '0', '0', 3154, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1546, 'Wishing Well', 'country_well', 's', 1, 1, 1, '0', '0', '0', 3149, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1547, 'Fairy Mushroom', 'eco_mush2', 's', 1, 1, 1, '1', '0', '0', 3155, '0', '1', '1', '1', '1', 'default', 1, '0', ''),
(1548, 'Rainbow', 'country_rbw', 's', 1, 1, 1, '0', '0', '0', 3143, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1549, 'Golden Wheat', 'country_wheat', 's', 2, 2, 1, '0', '0', '0', 3163, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1550, 'Farm Gate', 'country_gate', 's', 2, 1, 0.001, '0', '0', '0', 3150, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1551, 'Country Trax', 'sound_set_72', 's', 1, 1, 0.2, '1', '0', '0', 3144, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1552, 'Wooden Stage', 'country_stage', 's', 2, 2, 1, '1', '0', '1', 3148, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1553, 'ads_calip_cola_1 name', 'ads_calip_cola*1', 's', 1, 1, 1, '0', '0', '0', 3156, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1554, 'ads_calip_cola_2 name', 'ads_calip_cola*2', 's', 1, 1, 1, '0', '0', '0', 3157, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1555, 'ads_calip_cola_3 name', 'ads_calip_cola*3', 's', 1, 1, 1, '0', '0', '0', 3158, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1556, 'ads_calip_cola_4 name', 'ads_calip_cola*4', 's', 1, 1, 1, '0', '0', '0', 3159, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1557, 'Log Bench', 'country_log', 's', 2, 1, 1, '0', '1', '0', 3146, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1558, 'Stone Pile', 'country_fnc3', 's', 1, 1, 1, '0', '0', '0', 3152, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1559, 'Wooden Patio Tile', 'country_patio', 's', 1, 1, 1, '0', '0', '0', 3166, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1560, 'Country Ditch Corner', 'country_corner', 's', 1, 1, 1, '0', '0', '0', 3164, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1561, 'Country Ditch', 'country_ditch', 's', 1, 2, 0.001, '0', '0', '0', 3165, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1562, 'ads_calip_chair name', 'ads_calip_chair', 's', 1, 1, 1, '0', '1', '0', 3168, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1563, 'ads_idol_trophy name', 'ads_idol_trophy', 's', 1, 1, 1, '0', '0', '0', 3169, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1564, 'Totem Spirit Head', 'totem_head', 's', 1, 1, 1.7, '1', '0', '0', 3167, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1565, 'ads_calip_pool name', 'ads_calip_pool', 's', 2, 2, 0, '0', '0', '1', 3182, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1566, 'laptopdesk name', 'laptopdesk', 's', 2, 2, 1, '0', '0', '0', 3173, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1567, 'Skull', 'LT_skull', 's', 1, 1, 1, '0', '0', '0', 3189, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1568, 'Large Tribal Block', 'lt_stage2', 's', 2, 2, 0.9, '0', '0', '1', 3175, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1569, 'Lava Corner', 'lt_lavac', 's', 1, 1, 1, '0', '0', '0', 3180, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1570, 'Tribal Gate', 'lt_gate', 's', 2, 1, 0.001, '0', '0', '0', 3172, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1571, 'Planet of Eternity', 'saturn', 's', 1, 1, 1, '1', '0', '0', 3181, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1572, 'ads_calip_tele name', 'ads_calip_tele', 's', 1, 1, 0.001, '0', '0', '0', 3190, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1573, 'Stone Statue', 'lt_statue', 's', 1, 1, 1, '0', '0', '0', 3185, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1574, 'Tarantula', 'lt_spider', 's', 1, 1, 1, '0', '0', '0', 3178, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1575, 'Tribal Stone Wall', 'lt_stone2', 's', 2, 1, 1, '1', '0', '0', 3177, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1576, 'Tribal Seat', 'LT_throne', 's', 1, 1, 1.5, '0', '1', '0', 3171, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1577, 'audChr name', 'audChr', 's', 1, 1, 1, '0', '1', '0', 3179, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1578, 'Moss Patch', 'lt_patch', 's', 2, 2, 0, '1', '0', '1', 3188, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1579, 'Lava Ditch', 'lt_lava', 's', 1, 2, 1, '0', '0', '0', 3176, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1580, 'Small Tribal Torch', 'LT_pillar2', 's', 1, 1, 1, '0', '0', '0', 3170, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1581, 'Ant Hill', 'lt_bughill', 's', 1, 1, 1, '0', '0', '0', 3174, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1582, 'noticeboard name', 'noticeboard', 's', 3, 1, 1, '0', '0', '0', 3186, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1583, 'clrack name', 'clrack', 's', 3, 1, 0, '1', '0', '0', 3184, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1584, 'Large Tribal Torch', 'LT_pillar', 's', 1, 1, 1, '0', '0', '0', 3187, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1585, 'ads_calip_parasol name', 'lt_stage1', 's', 1, 1, 0.9, '0', '0', '1', 3183, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1586, 'transparent_floor name', 'transparent_floor', 's', 2, 2, 0, '1', '0', '1', 3199, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1587, 'ads_calip_lava name', 'ads_calip_lava', 's', 1, 1, 1, '0', '0', '0', 3197, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1588, 'Tribal Stone Corner', 'lt_stone1', 's', 1, 1, 1, '1', '0', '0', 3196, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1589, 'ads_calip_fan', 'ads_calip_fan', 's', 1, 1, 1, '0', '0', '0', 3198, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1590, 'voting_ch name', 'voting_ch', 's', 1, 1, 1.3, '0', '1', '0', 3201, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1591, 'Quick Coffee Stop', 'ads_mall_coffeem', 's', 1, 1, 1, '0', '0', '0', 3202, '1', '1', '1', '1', '1', 'vendingmachine', 0, '41', ''),
(1592, 'Totem Planet', 'totem_planet', 's', 1, 1, 1, '0', '0', '0', 3200, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1593, 'Don''t worry', 'SF_reactor', 's', 1, 1, 1, '1', '0', '0', 3212, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1594, 'Pack all you want', 'SF_crate_2', 's', 2, 1, 1, '1', '0', '0', 3204, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1595, 'Space Crew Chair', 'SF_chair_blue', 's', 1, 1, 1.2, '0', '1', '0', 3207, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1596, 'Cryogenic Bed', 'sf_pod', 's', 1, 3, 1.36, '0', '0', '0', 3219, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(1597, 'Command Console', 'SF_panel1', 's', 1, 1, 1, '0', '0', '0', 3217, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1598, 'Starship Table', 'SF_table', 's', 2, 2, 1, '1', '0', '0', 3220, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1599, 'Welcome aboard', 'SF_chair_green', 's', 1, 1, 1.2, '0', '1', '0', 3215, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1600, 'Small Crate', 'SF_crate_1', 's', 1, 1, 1, '1', '0', '0', 3205, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1601, 'Alien Lifeform', 'SF_alien', 's', 1, 1, 1, '0', '0', '0', 3210, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1602, 'Engineering Console', 'SF_panel2', 's', 2, 1, 1, '0', '0', '0', 3218, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1603, 'Display Gate', 'sf_gate', 's', 2, 1, 0.001, '0', '0', '0', 3221, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1604, 'Navigation Panel', 'SF_panel3', 's', 1, 1, 1, '0', '0', '0', 3208, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1605, 'Starship Floor 2', 'SF_floor_2', 's', 2, 2, 0, '1', '0', '1', 3211, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1606, 'Sci Fi Lamp', 'SF_lamp', 's', 1, 1, 1, '0', '0', '0', 3224, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1607, 'Captain''s Chair', 'SF_chair_red', 's', 1, 1, 1.2, '0', '1', '0', 3223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1608, 'Transparent Floor', 'sf_floor', 's', 2, 4, 0, '1', '0', '1', 3213, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1609, 'Starship Roof', 'sf_roof', 's', 2, 4, 0, '1', '0', '1', 3203, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1610, 'Light Pole', 'sf_stick', 's', 1, 1, 1, '0', '0', '0', 3206, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1611, 'Starship Floor 1', 'SF_floor_1', 's', 2, 2, 0, '1', '0', '1', 3222, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1612, ' sweets', 'ads_mall_kiosk', 's', 1, 2, 1, '0', '0', '0', 3216, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1613, 'Futuristic Teleport', 'sf_tele', 's', 1, 1, 0.001, '0', '0', '0', 3214, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1614, 'Sci Fi Roller', 'sf_roller', 's', 1, 1, 0.5, '1', '0', '1', 3209, '1', '1', '1', '1', '1', 'roller', 1, '0', ''),
(1615, 'Hot Trophy', 'prizetrophy_hot', 's', 1, 1, 1, '0', '0', '0', 3229, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1616, 'Pink Inflatable Raft', 'summer_raft1', 's', 1, 1, 1, '0', '1', '0', 3228, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1617, 'Cool Trophy', 'prizetrophy_cool', 's', 1, 1, 1, '0', '0', '0', 3225, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(1618, 'Blue Inflatable Raft', 'summer_raft2', 's', 1, 1, 1, '0', '1', '0', 3227, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1619, 'ads_elisa_gnome name', 'ads_elisa_gnome', 's', 1, 1, 1, '0', '0', '0', 3226, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1620, 'Summer Cool Box', 'summer_icebox', 's', 1, 1, 1, '0', '0', '0', 3231, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1621, 'ads_oc_soda', 'ads_oc_soda', 's', 1, 1, 1, '0', '0', '0', 3230, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1622, 'Mars Patch', 'marsrug', 's', 2, 2, 0, '1', '0', '1', 3232, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1623, 'White Candle', 'rela_candle1', 's', 1, 1, 1, '0', '0', '0', 3238, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1625, 'Red Candles', 'rela_candles2', 's', 1, 1, 1, '0', '0', '0', 3245, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1626, 'Stones', 'rela_stone', 's', 1, 1, 0.5, '0', '0', '1', 3233, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1627, 'Wicker Chair', 'rela_hchair', 's', 1, 1, 1.3, '0', '1', '0', 3247, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1628, 'Red Candle', 'rela_candle2', 's', 1, 1, 1, '0', '0', '0', 3244, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1629, 'ads_711', 'ads_711*5', 's', 1, 1, 1, '0', '0', '0', 3241, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', '');
INSERT INTO `furniture_old` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(1630, 'ads_711', 'ads_711*6', 's', 1, 1, 1, '0', '0', '0', 3242, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1631, 'ads_711', 'ads_711*7', 's', 1, 1, 1, '0', '0', '0', 3243, '1', '1', '1', '1', '1', 'vendingmachine', 0, '19', ''),
(1632, 'Purple Candle', 'rela_candle3', 's', 1, 1, 1, '0', '0', '0', 3235, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1633, 'Asteroid', 'pix_asteroid', 's', 1, 1, 1, '1', '0', '0', 3237, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1634, 'Bushy Houseplant', 'rela_plant', 's', 1, 1, 1, '0', '0', '0', 3246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1635, 'White Candles', 'rela_candles1', 's', 1, 1, 1, '0', '0', '0', 3234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1636, 'Purple Candles', 'rela_candles3', 's', 1, 1, 1, '0', '0', '0', 3236, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1637, 'Orchid', 'rela_orchid', 's', 1, 1, 1, '0', '0', '0', 3239, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1638, 'Rocks', 'rela_rock', 's', 1, 1, 0.8, '0', '1', '0', 3248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1639, 'ktchn_stove name', 'ktchn_stove', 's', 2, 1, 1, '0', '0', '0', 3256, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1640, 'ktchn_light name', 'ktchn_light', 's', 2, 1, 0, '1', '0', '1', 3258, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1641, 'ktchn_plates name', 'ktchn_plates', 's', 1, 1, 1, '0', '0', '0', 3263, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1642, 'ktchn_countr_1 name', 'ktchn_countr_1', 's', 1, 1, 1, '1', '0', '0', 3261, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1643, 'ktchn_pots name', 'ktchn_pots', 's', 2, 1, 0, '1', '0', '1', 3252, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(1644, 'ktchn_cornr name', 'ktchn_cornr', 's', 1, 1, 1, '0', '0', '0', 3257, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1645, 'ktchn_desk name', 'ktchn_desk', 's', 2, 1, 1, '1', '0', '0', 3260, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1646, 'ktchn_trash name', 'ktchn_trash', 's', 1, 1, 1, '0', '0', '0', 3264, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1647, 'ktchn_countr_2 name', 'ktchn_countr_2', 's', 2, 1, 1, '1', '0', '0', 3253, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1648, 'ktchn_bBlock name', 'ktchn_bBlock', 's', 1, 1, 1, '0', '0', '0', 3255, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1649, 'ktchn_dvdr name', 'ktchn_dvdr', 's', 2, 1, 1, '0', '0', '0', 3259, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1650, 'ktchn_inspctr name', 'ktchn_inspctr', 's', 1, 1, 1, '1', '0', '0', 3250, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1651, 'ktchn_fridge name', 'ktchn_fridge', 's', 1, 1, 1, '1', '0', '0', 3249, '1', '1', '1', '1', '1', 'vendingmachine', 0, '3,36,37,38', ''),
(1652, 'ads_1800tele', 'ads_1800tele', 's', 1, 1, 0.001, '0', '0', '0', 3251, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(1653, 'ktchn_sink name', 'ktchn_sink', 's', 2, 1, 1, '0', '0', '0', 3262, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1654, 'ktchn_gate name', 'ktchn_gate', 's', 2, 1, 0.001, '0', '0', '0', 3254, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(1655, 'Pad of stickies', 'post.it', 'i', 0, 0, 1, '0', '0', '0', 1, '0', '0', '1', '0', '1', 'postit', 1, '0', ''),
(1656, 'Heart Stickies', 'post.it.vd', 'i', 0, 0, 1, '0', '0', '0', 2, '0', '0', '1', '0', '1', 'postit', 1, '0', ''),
(1665, 'Gothic Ectoplasm Fountain', 'gothicfountain', 'i', 0, 0, 1, '0', '0', '0', 4002, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1666, 'Retro Wall Lamp', 'hc_wall_lamp', 'i', 0, 0, 1, '0', '0', '0', 4003, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1667, 'Industrial Turbine', 'industrialfan', 'i', 0, 0, 1, '0', '0', '0', 4004, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1668, 'Gothic Torch', 'torch', 'i', 0, 0, 1, '0', '0', '0', 4005, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1669, 'Heart Light', 'val_heart', 'i', 0, 0, 1, '0', '0', '0', 4006, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1670, 'Mirror', 'wallmirror', 'i', 0, 0, 1, '0', '0', '0', 4007, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1671, 'Ninja Stars', 'jp_ninjastars', 'i', 0, 0, 1, '0', '0', '0', 4008, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1672, 'Habbowood Mirror', 'habw_mirror', 'i', 0, 0, 1, '0', '0', '0', 4009, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1673, 'So you gotta ask yourself', 'habbowheel', 'i', 0, 0, 1, '0', '0', '0', 4010, '1', '1', '1', '1', '1', 'habbowheel', 1, '0', ''),
(1674, 'Skull Guitar', 'guitar_skull', 'i', 0, 0, 1, '0', '0', '0', 4011, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1675, 'V Guitar', 'guitar_v', 'i', 0, 0, 1, '0', '0', '0', 4012, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1676, 'Christmas Lights', 'xmas_light', 'i', 0, 0, 1, '0', '0', '0', 4015, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1677, 'Anchor', 'hrella_poster_3', 'i', 0, 0, 1, '0', '0', '0', 4016, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1678, 'Life Buoy', 'hrella_poster_2', 'i', 0, 0, 1, '0', '0', '0', 4013, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1679, 'Porthole', 'hrella_poster_1', 'i', 0, 0, 1, '0', '0', '0', 4014, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1680, 'Swords', 'sw_swords', 'i', 0, 0, 1, '0', '0', '0', 4017, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1681, 'Mysterious Necklace', 'sw_stone', 'i', 0, 0, 1, '0', '0', '0', 4018, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1682, 'Ventilation Duct', 'sw_hole', 'i', 0, 0, 1, '0', '0', '0', 4019, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1683, 'Mood Light', 'roomdimmer', 'i', 0, 0, 1, '0', '0', '0', 4027, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1684, 'Bubble Juice Can', 'md_logo_wall', 'i', 0, 0, 1, '0', '0', '0', 4023, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1685, 'Kakejiku Hokusai', 'jp_sheet3', 'i', 0, 0, 1, '0', '0', '0', 4021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1686, 'Kakejiku Ninjya', 'jp_sheet2', 'i', 0, 0, 1, '0', '0', '0', 4026, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1687, 'Kakejiku Ziritsu', 'jp_sheet1', 'i', 0, 0, 1, '0', '0', '0', 4024, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1688, 'Ancestral Scimitars', 'arabian_swords', 'i', 0, 0, 1, '0', '0', '0', 4020, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1689, 'Arabian Window Frame', 'arabian_wndw', 'i', 0, 0, 1, '0', '0', '0', 4022, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1690, 'Jungle Wallplant', 'tiki_wallplnt', 'i', 0, 0, 1, '0', '0', '0', 4030, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(1691, 'Surfboard', 'tiki_surfboard', 'i', 0, 0, 1, '0', '0', '0', 4028, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(1692, 'tampax_wall', 'tampax_wall', 'i', 0, 0, 1, '0', '0', '0', 4029, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1693, 'Single Window', 'window_single_default', 'i', 0, 0, 1, '0', '0', '0', 4031, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1694, 'Double Window', 'window_double_default', 'i', 0, 0, 1, '0', '0', '0', 4032, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1695, 'Window', 'noob_window_double', 'i', 0, 0, 1, '0', '0', '0', 4033, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(1696, 'Bay Window', 'window_triple', 'i', 0, 0, 1, '0', '0', '0', 4045, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1697, 'Glass Square Window', 'window_square', 'i', 0, 0, 1, '0', '0', '0', 4036, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1698, 'Large Romantic Window', 'window_romantic_wide', 'i', 0, 0, 1, '0', '0', '0', 4041, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1699, 'Small Romantic Window', 'window_romantic_narrow', 'i', 0, 0, 1, '0', '0', '0', 4037, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1700, 'Grunge Window', 'window_grunge', 'i', 0, 0, 1, '0', '0', '0', 4044, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1701, 'Golden Window', 'window_golden', 'i', 0, 0, 1, '0', '0', '0', 4035, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1702, 'Large Oriental Window', 'window_chinese_wide', 'i', 0, 0, 1, '0', '0', '0', 4034, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1703, 'Small Oriental Window', 'window_chinese_narrow', 'i', 0, 0, 1, '0', '0', '0', 4038, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1704, 'Basic Window', 'window_basic', 'i', 0, 0, 1, '0', '0', '0', 4042, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1705, 'Large 70s Window', 'window_70s_wide', 'i', 0, 0, 1, '0', '0', '0', 4039, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1706, 'Small 70s Window', 'window_70s_narrow', 'i', 0, 0, 1, '0', '0', '0', 4040, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1707, 'Sunny Delight', 'ads_sunnyd', 'i', 0, 0, 1, '0', '0', '0', 4043, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1708, 'Good grub', 'window_diner2', 'i', 0, 0, 1, '0', '0', '0', 4046, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1709, 'Large Diner Window', 'window_diner', 'i', 0, 0, 1, '0', '0', '0', 4049, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1710, 'Diner Side Table', 'diner_walltable', 'i', 0, 0, 1, '0', '0', '0', 4048, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1711, 'ads_dave_wall', 'ads_dave_wall', 'i', 0, 0, 1, '0', '0', '0', 4047, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1712, 'Window', 'window_hole', 'i', 0, 0, 1, '0', '0', '0', 4052, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1713, 'easy_poster', 'easy_poster', 'i', 0, 0, 1, '0', '0', '0', 4051, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1714, 'ads_nokia_logo name', 'ads_nokia_logo', 'i', 0, 0, 1, '0', '0', '0', 4050, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1715, 'ads_nokia_phone name', 'ads_nokia_phone', 'i', 0, 0, 1, '0', '0', '0', 4053, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1717, 'Skyscraper Window', 'window_skyscraper', 'i', 0, 0, 1, '0', '0', '0', 4054, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1718, 'netari_poster', 'netari_poster', 'i', 0, 0, 1, '0', '0', '0', 4057, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1719, 'Bullet Hole', 'det_bhole', 'i', 0, 0, 1, '0', '0', '0', 4056, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1720, 'Red V Guitar', 'ads_campguitar', 'i', 0, 0, 1, '0', '0', '0', 4058, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1721, 'Nuclear Radiation Sign', 'hween08_rad', 'i', 0, 0, 1, '0', '0', '0', 4059, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1722, 'Broken Window (small)', 'hween08_wndwb', 'i', 0, 0, 1, '0', '0', '0', 4061, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1723, 'Broken Window (large)', 'hween08_wndw', 'i', 0, 0, 1, '0', '0', '0', 4062, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1724, 'Biohazard Sign', 'hween08_bio', 'i', 0, 0, 1, '0', '0', '0', 4063, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1725, 'X-Ray Light Box', 'hw_08_xray', 'i', 0, 0, 1, '0', '0', '0', 4060, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1726, 'Red Gothic Fountain', 'gothicfountain2', 'i', 0, 0, 1, '0', '0', '0', 4065, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1728, 'TBD Central Musical TV', 'ads_cmusic', 'i', 0, 0, 1, '0', '0', '0', 4067, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1729, 'Stand up or sitting down', 'party_wc_boy', 'i', 0, 0, 1, '0', '0', '0', 4070, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1730, 'Big Wall Lights', 'party_led', 'i', 0, 0, 1, '0', '0', '0', 4066, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1731, 'Neon Heart Light', 'party_neon5', 'i', 0, 0, 1, '0', '0', '0', 4074, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(1732, 'Neon Right Arrows', 'party_neon1', 'i', 0, 0, 1, '0', '0', '0', 4069, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1733, 'Neon Left Arrows', 'party_neon2', 'i', 0, 0, 1, '0', '0', '0', 4073, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1734, 'Girls Toilets', 'party_wc_girl', 'i', 0, 0, 1, '0', '0', '0', 4068, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1735, 'Neon Pink Flamingo', 'party_neon3', 'i', 0, 0, 1, '0', '0', '0', 4075, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1736, 'Bar Shelf', 'party_shelf', 'i', 0, 0, 1, '0', '0', '0', 4071, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1737, 'Neon Skull Light', 'party_neon4', 'i', 0, 0, 1, '0', '0', '0', 4072, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1738, 'Snowy Posters', 'xmas08_wallpaper', 'i', 0, 0, 1, '0', '0', '0', 4077, '0', '0', '1', '1', '1', 'roomeffect', 1, '0', ''),
(1739, 'Icy Wall', 'xmas08_icewall', 'i', 0, 0, 1, '0', '0', '0', 4076, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1741, 'Idea Agency Plasma 1', 'ads_clwall1', 'i', 0, 0, 1, '0', '0', '0', 4082, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1742, 'Idea Agency Plasma 2', 'ads_clwall2', 'i', 0, 0, 1, '0', '0', '0', 4078, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1743, 'Idea Agency Plasma 3', 'ads_clwall3', 'i', 0, 0, 1, '0', '0', '0', 4079, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1744, 'ads_ob_wall', 'ads_ob_wall', 'i', 0, 0, 1, '0', '0', '0', 4081, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1745, 'Mall Window', 'ads_mall_window', 'i', 0, 0, 1, '0', '0', '0', 4083, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1746, 'Dragon Poster', 'china_pstr2', 'i', 0, 0, 1, '0', '0', '0', 4085, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1747, 'Chinese Wall Lamp', 'china_light', 'i', 0, 0, 1, '0', '0', '0', 4086, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1748, 'Ox Poster', 'china_pstr1', 'i', 0, 0, 1, '0', '0', '0', 4084, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1749, 'Bolly Window', 'bolly_wdw_wd', 'i', 0, 0, 1, '0', '0', '0', 4087, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1750, 'Monster Plan Poster', 'ads_igor_wall', 'i', 0, 0, 1, '0', '0', '0', 4090, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1751, 'Evil Bone', 'ads_igorevilb', 'i', 0, 0, 1, '0', '0', '0', 4089, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1752, 'ads_idol_wall name', 'ads_idol_wall', 'i', 0, 0, 1, '0', '0', '0', 4088, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1753, 'Mall Furni Showroom', 'ads_mall_winfur', 'i', 0, 0, 1, '0', '0', '0', 4092, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1754, 'Mall Pet Shop Window', 'ads_mall_winpet', 'i', 0, 0, 1, '0', '0', '0', 4091, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1755, 'Rock Wall', 'lc_wall1', 'i', 0, 0, 1, '0', '0', '0', 4095, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1756, 'Aquarium Window', 'lc_window2', 'i', 0, 0, 1, '0', '0', '0', 4096, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1757, 'Wooden Window', 'lc_window1', 'i', 0, 0, 1, '0', '0', '0', 4094, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1758, 'American Idol TV', 'ads_idol_tv', 'i', 0, 0, 1, '0', '0', '0', 4093, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1759, 'Coral Wall', 'lc_wall2', 'i', 0, 0, 1, '0', '0', '0', 4097, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1760, 'ads_idol_mirror name', 'ads_idol_mirror', 'i', 0, 0, 1, '0', '0', '0', 4099, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1761, 'Mall Cinema Window', 'ads_mall_wincin', 'i', 0, 0, 1, '0', '0', '0', 4098, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1762, 'Strum', 'ads_mall_winmus', 'i', 0, 0, 1, '0', '0', '0', 4101, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1763, 'Mall Beauty Salon', 'ads_mall_winbea', 'i', 0, 0, 1, '0', '0', '0', 4100, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1764, 'Eco Curtain 1', 'eco_curtains1', 'i', 0, 0, 1, '0', '0', '0', 4105, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1765, 'Mall Idea Agency Window', 'ads_mall_winchi', 'i', 0, 0, 1, '0', '0', '0', 4103, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1766, 'Eco Curtain 3', 'eco_curtains3', 'i', 0, 0, 1, '0', '0', '0', 4104, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1767, 'Eco Curtain 2', 'eco_curtains2', 'i', 0, 0, 1, '0', '0', '0', 4102, '0', '1', '1', '1', '1', 'default', 2, '0', ''),
(1768, 'Mall Ice Cream Parlour Window', 'ads_mall_winice', 'i', 0, 0, 1, '0', '0', '0', 4109, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1769, 'Whatever your sporting dibble', 'ads_mall_winspo', 'i', 0, 0, 1, '0', '0', '0', 4106, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1770, 'ads_idol_logo name', 'ads_idol_logo', 'i', 0, 0, 1, '0', '0', '0', 4108, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1771, 'World Map', 'exe_map', 'i', 0, 0, 1, '0', '0', '0', 4110, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1772, 'Wall Fall', 'exe_wfall', 'i', 0, 0, 1, '0', '0', '0', 4107, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1773, 'ads_lin_wh_c name', 'ads_lin_wh_c', 'i', 0, 0, 1, '0', '0', '0', 4115, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1774, 'ads_malaco_tv name', 'ads_malaco_tv', 'i', 0, 0, 1, '0', '0', '0', 4113, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1775, 'ads_puffet_tv name', 'ads_puffet_tv', 'i', 0, 0, 1, '0', '0', '0', 4111, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1776, 'ads_reebok_tv name', 'ads_reebok_tv', 'i', 0, 0, 1, '0', '0', '0', 4112, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1777, 'Forest Wall Poster', 'country_forestwall', 'i', 0, 0, 1, '0', '0', '0', 4114, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1778, 'Marble Fireplace', 'country_fp', 'i', 0, 0, 1, '0', '0', '0', 4117, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1779, 'Farmhouse Wall', 'country_wall', 'i', 0, 0, 1, '0', '0', '0', 4118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1780, 'Ye Olde Lantern', 'country_lantern', 'i', 0, 0, 1, '0', '0', '0', 4116, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1781, 'Norwegian Flag', 'flag_norway', 'i', 0, 0, 1, '0', '0', '0', 4119, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1782, 'Diner Poster', 'diner_poster', 'i', 0, 0, 1, '0', '0', '0', 4120, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1783, '', 'lt_jngl_wall', 'i', 0, 0, 1, '0', '0', '0', 4121, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1784, 'ads_mirror name', 'ads_mirror', 'i', 0, 0, 1, '0', '0', '0', 4122, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1785, 'lt_wall', 'lt_wall', 'i', 0, 0, 1, '0', '0', '0', 4123, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1787, 'Starship Window', 'sf_window', 'i', 0, 0, 1, '0', '0', '0', 4224, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1788, 'Starship Wall', 'sf_wall2', 'i', 0, 0, 1, '0', '0', '0', 4228, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(1789, 'ads_wwe_poster name', 'ads_wwe_poster', 'i', 0, 0, 1, '0', '0', '0', 4226, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1790, 'Fly me to the moon', 'ads_mall_wintra', 'i', 0, 0, 1, '0', '0', '0', 4225, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1791, 'Starship Corner', 'sf_wall3', 'i', 0, 0, 1, '0', '0', '0', 4223, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1793, 'ads_veet name', 'ads_veet', 'i', 0, 0, 1, '0', '0', '0', 4222, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1794, 'Wall Tiles', 'rela_wall', 'i', 0, 0, 1, '0', '0', '0', 4232, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(1795, 'flag_belgium', 'flag_belgium', 'i', 0, 0, 1, '0', '0', '0', 4229, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1796, 'Porko Flag', 'Porko Flag', 'i', 0, 0, 1, '0', '0', '0', 4249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1797, 'ads_mall_wingar', 'ads_mall_wingar', 'i', 0, 0, 1, '0', '0', '0', 4230, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1798, 'ktchn_wall name', 'ktchn_wall', 'i', 0, 0, 1, '0', '0', '0', 4235, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1799, 'ads_mall_winclo', 'ads_mall_winclo', 'i', 0, 0, 1, '0', '0', '0', 4236, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(1800, 'ktchn_oven name', 'ktchn_oven', 'i', 0, 0, 1, '0', '0', '0', 4234, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(1801, 'ktchn_knives name', 'ktchn_knives', 'i', 0, 0, 1, '0', '0', '0', 4233, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(1802, 'Mood Controller (Large)', 'dimmer_fuse6', 'i', 0, 0, 1, '0', '0', '0', 4240, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1803, 'Mood Switch (Large)', 'dimmer_swtch', 'i', 0, 0, 1, '0', '0', '0', 4237, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1804, 'Mood Controller (Small)', 'dimmer_fuse2', 'i', 0, 0, 1, '0', '0', '0', 4239, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(1805, 'Mood Switch (Small)', 'dimmer_buttn', 'i', 0, 0, 1, '0', '0', '0', 4238, '1', '1', '1', '1', '1', 'dimmer', 1, '0', ''),
(10278, 'hosptl_bbag name', 'hosptl_bbag', 's', 1, 3, 1, '0', '0', '0', 3591, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(10279, 'hosptl_bed', 'hosptl_bed', 's', 1, 3, 1, '0', '0', '0', 3590, '1', '1', '1', '1', '1', 'bed', 2, '0', ''),
(10280, 'hosptl_cab1', 'hosptl_cab1', 's', 1, 1, 1, '0', '0', '0', 3586, '1', '1', '1', '1', '1', 'vendingmachine', 2, '35', ''),
(10281, 'hosptl_cab2', 'hosptl_cab2', 's', 2, 1, 1, '0', '0', '0', 3608, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10282, 'hosptl_curtain', 'hosptl_curtain', 's', 3, 1, 1, '0', '0', '0', 3588, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(10283, 'hosptl_defibs', 'hosptl_defibs', 's', 1, 1, 1, '0', '0', '0', 3606, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10284, 'hosptl_light', 'hosptl_light', 's', 1, 1, 1, '0', '0', '0', 3610, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10285, 'hosptl_seat', 'hosptl_seat', 's', 1, 2, 1, '0', '1', '0', 3611, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10286, 'hosptl_skele', 'hosptl_skele', 's', 1, 1, 1, '0', '0', '0', 3604, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10287, 'hosptl_xray', 'hosptl_xray', 'i', 0, 0, 0, '0', '0', '0', 4339, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10289, 'easel_0', 'easel_0', 's', 1, 1, 1, '0', '0', '0', 3582, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10290, 'easel_1', 'easel_1', 's', 1, 1, 1, '0', '0', '0', 3594, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10291, 'easel_2', 'easel_2', 's', 1, 1, 1, '0', '0', '0', 3603, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10292, 'easel_3', 'easel_3', 's', 1, 1, 1, '1', '0', '0', 3596, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(10293, 'easel_4', 'easel_4', 's', 1, 1, 1, '0', '0', '0', 3600, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(10294, 'easel_2', 'easel_2', 's', 1, 1, 1, '0', '0', '0', 3603, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(10350, 'african_bones', 'african_bones', 's', 1, 1, 1, '0', '0', '0', 3609, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10351, 'african_fence', 'african_fence', 's', 1, 2, 1, '0', '0', '0', 3579, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10352, 'african_patch', 'african_patch', 's', 2, 2, 1, '0', '0', '1', 3602, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10353, 'african_stage', 'african_stage', 's', 2, 2, 1, '1', '0', '1', 3607, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10354, 'african_tree1', 'african_tree1', 's', 1, 1, 1, '0', '0', '0', 3584, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(10355, 'african_tree2', 'african_tree2', 's', 1, 1, 1, '0', '0', '0', 3605, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10357, 'ktchn10_cabnt', 'ktchn10_cabnt', 'i', 0, 0, 0, '0', '0', '0', 4338, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10358, 'ktchn10_pot', 'ktchn10_pot', 's', 1, 1, 1, '0', '0', '0', 3580, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10359, 'ktchn10_sink', 'ktchn10_sink', 's', 2, 1, 1, '0', '0', '0', 3612, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(10360, 'ktchn10_stove', 'ktchn10_stove', 's', 2, 1, 1, '0', '0', '0', 3581, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19877, '', 'avatar_effect9', 'e', 1, 1, 1, '0', '0', '0', 9, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19878, '', 'avatar_effect6', 'e', 1, 1, 1, '0', '0', '0', 6, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19879, '', 'avatar_effect16', 'e', 1, 1, 1, '0', '0', '0', 16, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19880, '', 'avatar_effect2', 'e', 1, 1, 1, '0', '0', '0', 2, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19881, '', 'avatar_effect14', 'e', 1, 1, 1, '0', '0', '0', 14, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19882, '', 'avatar_effect15', 'e', 1, 1, 1, '0', '0', '0', 15, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19883, '', 'avatar_effect3', 'e', 1, 1, 1, '0', '0', '0', 3, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19884, '', 'avatar_effect17', 'e', 1, 1, 1, '0', '0', '0', 17, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19885, '', 'avatar_effect18', 'e', 1, 1, 1, '0', '0', '0', 18, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19886, '', 'avatar_effect1', 'e', 1, 1, 1, '0', '0', '0', 1, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19887, '', 'avatar_effect4', 'e', 1, 1, 1, '0', '0', '0', 4, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19888, '', 'avatar_effect5', 'e', 1, 1, 1, '0', '0', '0', 5, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19889, '', 'avatar_effect7', 'e', 1, 1, 1, '0', '0', '0', 7, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19890, '', 'avatar_effect8', 'e', 1, 1, 1, '0', '0', '0', 8, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19891, '', 'avatar_effect10', 'e', 1, 1, 1, '0', '0', '0', 10, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19892, '', 'avatar_effect12', 'e', 1, 1, 1, '0', '0', '0', 12, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19893, '', 'avatar_effect13', 'e', 1, 1, 1, '0', '0', '0', 13, '0', '0', '1', '0', '0', 'default', 1, '0', ''),
(19894, '', 'a2 l', 'i', 1, 1, 1, '0', '0', '0', 3002, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19895, '', 'a2 t', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19896, '', 'wallpaper 1', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19926, '', 'landscape 1', 'i', 1, 1, 1, '0', '0', '0', 4054, '0', '0', '1', '1', '0', 'roomeffect', 1, '0', ''),
(19938, '', 'hween09_floor', 's', 2, 2, 0, '1', '0', '1', 3288, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(19939, '', 'hween09_jar', 's', 1, 1, 1, '0', '0', '0', 3287, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19940, 'City Bench (Clean)', 'urban_bench_plain', 's', 2, 1, 1, '0', '1', '0', 3284, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19941, '', 'hween09_organ', 's', 2, 1, 1, '0', '0', '0', 3282, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19942, '', 'byesw_hand', 's', 1, 1, 1.35, '0', '0', '0', 3291, '0', '1', '1', '1', '1', '', 1, '0', ''),
(19943, '', 'byesw_hotel', 's', 1, 1, 1, '0', '0', '0', 3289, '0', '1', '1', '1', '1', 'default', 6, '0', ''),
(19944, '', 'hween09_table', 's', 1, 3, 1, '0', '0', '0', 3286, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19945, '', 'hween09_chair', 's', 1, 1, 1, '0', '1', '0', 3295, '0', '0', '1', '1', '1', 'default', 1, '0', ''),
(19946, '', 'hween09_mirror', 's', 1, 1, 1, '0', '1', '0', 3293, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19947, 'Trap Door', 'hween09_hatch', 's', 2, 2, 0.001, '0', '0', '1', 3285, '0', '0', '1', '1', '1', 'gate', 2, '0', ''),
(19948, '', 'hween09_ghost', 's', 1, 1, 1, '0', '0', '0', 3290, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19949, '', 'hween09_tv', 's', 2, 1, 1, '0', '0', '0', 3292, '0', '0', '1', '1', '1', 'default', 3, '0', ''),
(19950, '', 'hween09_chandelier', 's', 1, 1, 1, '0', '0', '1', 3294, '0', '0', '1', '1', '1', 'default', 3, '0', ''),
(19951, '', 'hween09_crnr1', 'i', 0, 0, 1, '0', '0', '0', 4247, '0', '0', '1', '1', '1', 'default', 4, '0', ''),
(19952, '', 'hween09_paint', 'i', 0, 0, 1, '0', '0', '0', 4263, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19953, '', 'hween09_treewall', 'i', 0, 0, 1, '0', '0', '0', 4269, '0', '0', '1', '1', '1', 'default', 2, '0', ''),
(19954, '', 'hween09_wall1', 'i', 0, 0, 1, '0', '0', '0', 4257, '0', '0', '1', '1', '1', 'default', 4, '0', ''),
(19955, '', 'hween09_stonewall', 'i', 0, 0, 1, '0', '0', '0', 4259, '0', '0', '1', '1', '1', 'default', 5, '0', ''),
(19956, '', 'hween09_win', 'i', 0, 0, 1, '0', '0', '0', 4271, '0', '0', '1', '1', '1', 'default', 10, '0', ''),
(19957, '', 'avatar_effect22', 'e', 1, 1, 1, '0', '0', '0', 22, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19958, '', 'avatar_effect19', 'e', 1, 1, 1, '0', '0', '0', 19, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19959, '', 'avatar_effect20', 'e', 1, 1, 1, '0', '0', '0', 20, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19960, '', 'avatar_effect21', 'e', 1, 1, 1, '0', '0', '0', 21, '0', '0', '1', '0', '1', 'default', 1, '0', ''),
(19971, 'Snowman Middle', 'xm09_man_b', 's', 1, 1, 0.8, '1', '0', '0', 3328, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(19972, 'Snowman Head', 'xm09_man_c', 's', 1, 1, 1, '0', '0', '0', 3329, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(19973, 'Christmas Table', 'xm09_table', 's', 2, 6, 1, '1', '0', '0', 3335, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19974, '6-Seater Bench', 'xm09_bench', 's', 6, 1, 1, '0', '1', '0', 3340, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19976, 'Snowy Fir Trees', 'xm09_firwall', 'i', 0, 0, 1, '0', '0', '0', 4307, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19977, 'Snowy Forest', 'xm09_forestwall', 'i', 0, 0, 1, '0', '0', '0', 4308, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19978, 'Lodge Wall', 'xm09_lodgewall', 'i', 0, 0, 1, '1', '0', '0', 4311, '0', '1', '1', '1', '1', 'default', 8, '0', ''),
(19979, 'Gold Heart Bauble', 'xm09_bauble_25', 'i', 0, 0, 1, '1', '0', '0', 4286, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19980, 'Silver Heart Bauble', 'xm09_bauble_26', 'i', 0, 0, 1, '1', '0', '0', 4306, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19981, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1, '1', '0', '0', 4279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19982, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1, '1', '0', '0', 4279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19983, 'Blue Heart Bauble', 'xm09_bauble_23', 'i', 0, 0, 1, '1', '0', '0', 4292, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19984, 'Green Heart Bauble', 'xm09_bauble_24', 'i', 0, 0, 1, '1', '0', '0', 4278, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19985, 'Candy Cane', 'xm09_candyCane', 's', 1, 1, 1, '0', '0', '0', 3314, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(19986, 'Big Stocking', 'xm09_stocking', 'i', 0, 0, 1, '1', '0', '0', 4280, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19989, 'Snowman Base', 'xm09_man_a', 's', 1, 1, 1, '1', '0', '0', 3330, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(19994, 'Fountain', 'ads_twi_fountn', 's', 2, 2, 1, '0', '0', '0', 3301, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19995, 'Clock Tower wall', 'ads_twi_dvdr2', 's', 2, 1, 1, '0', '0', '0', 3302, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19996, 'Standing Rose Bouquet', 'ads_twi_roses', 's', 1, 1, 1, '0', '0', '0', 3304, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19997, 'Cake on Table with Presents', 'ads_twi_table', 's', 2, 2, 1, '0', '0', '0', 3297, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(19998, 'Volturi Royal Chair', 'ads_twi_chair', 's', 1, 1, 1, '0', '1', '0', 3300, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(19999, 'Half wall', 'ads_twi_dvdr1', 's', 2, 1, 1, '0', '0', '0', 3303, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20000, 'Broken Piano', 'ads_twi_piano', 's', 2, 2, 1, '0', '0', '0', 3299, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20001, 'ads_twi_tower name', 'ads_twi_tower', 's', 1, 1, 1, '0', '0', '0', 3298, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20002, 'Toolbox', 'ads_twi_toolbx', 's', 1, 1, 1, '0', '0', '0', 3296, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20003, 'Mist', 'ads_twi_mist', 's', 1, 1, 0, '1', '0', '1', 3308, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20006, 'Mesh Corner', 'urban_fence_corner', 's', 1, 1, 1, '1', '0', '0', 3275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20007, 'Taxi Sofa', 'urban_carsofa', 's', 2, 1, 1, '0', '1', '0', 3268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20008, 'City Bench (Dirty)', 'urban_bench', 's', 2, 1, 1, '0', '1', '0', 3269, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20010, 'Pavement Slab', 'urban_sidewalk', 's', 2, 2, 0.2, '1', '0', '1', 3274, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(20011, 'Water Hydrant', 'urban_wpost', 's', 1, 1, 1, '0', '0', '0', 3272, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20012, 'Mesh Fencing', 'urban_fence', 's', 1, 2, 1, '0', '0', '0', 3267, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20013, 'Garbage Bin', 'urban_bin', 's', 1, 1, 1, '0', '0', '0', 3266, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20014, 'Concrete Block', 'urban_blocker', 's', 1, 1, 1, '0', '0', '0', 3270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20015, 'Basketball Pole', 'urban_bsktbll', 's', 1, 1, 1, '0', '0', '0', 3271, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20016, 'Street Lamp', 'urban_lamp', 's', 1, 1, 1, '1', '0', '0', 3265, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20018, 'Street Wall', 'urban_wall', 'i', 0, 0, 1, '1', '0', '0', 4244, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20021, 'Giant Heart', 'heart', 's', 1, 1, 1, '0', '0', '0', 227, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20022, 'Champion trophy', 'a0 prizetrophy6_b', 's', 1, 1, 1, '0', '0', '0', 1510, '1', '1', '1', '1', '0', 'trophy', 1, '0', ''),
(20024, 'Square Dining Table', 'table_plasto_square*9', 's', 1, 1, 1, '1', '0', '0', 118, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20025, 'Terracotta Pillar', 'pillar*6', 's', 1, 1, 1, '0', '0', '0', 1609, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20026, 'Urban Iced Bookcase', 'shelves_norja*4', 's', 1, 1, 1, '0', '0', '0', 1795, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20027, 'Black Mode Double Bed', 'bed_polyfon*2', 's', 2, 3, 1.8, '0', '0', '0', 1895, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20028, 'Blue Iced Angle', 'divider_nor5*6', 's', 1, 1, 1, '0', '0', '0', 1995, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20029, 'Valentine''s Cauldron', 'val_cauldron', 's', 1, 1, 1, '0', '0', '0', 2103, '1', '1', '1', '1', '1', 'vendingmachine', 0, '25', ''),
(20030, 'Aqua Pura Module 5', 'pura_mdl5*1', 's', 1, 1, 1, '0', '1', '0', 2509, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20031, 'Aqua One Way Gate', 'one_way_door*1', 's', 1, 1, 0.001, '0', '0', '0', 2597, '1', '1', '1', '1', '1', 'onewaygate', 2, '0', ''),
(20032, 'Power Globe', 'exe_globe', 's', 1, 1, 1, '0', '0', '0', 2672, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20034, 'Latte Diner Corner', 'diner_bardesk_corner*5', 's', 1, 1, 1, '1', '0', '0', 2874, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20035, 'Bubbles', 'fx_bubble', 's', 1, 1, 1, '1', '0', '0', 3012, '0', '0', '1', '0', '1', 'rentals', 2, '0', ''),
(20036, 'Safety Cone', 'bump_tottero', 's', 1, 1, 1, '0', '0', '0', 3087, '1', '1', '1', '0', '1', 'default', 1, '0', ''),
(20037, 'ads_calip_parasol name', 'ads_calip_parasol', 's', 1, 1, 1, '0', '0', '0', 3195, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20041, '2010 Poster', 'year2010', 'i', 0, 0, 1, '1', '0', '0', 4313, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20042, 'Party Lantern', 'party_lantern', 's', 1, 1, 0, '1', '0', '1', 3327, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20043, 'Party Lights', 'party_lights', 'i', 0, 0, 1, '0', '0', '0', 4310, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20045, 'arabian_tile', 'arabian_tile', 's', 2, 2, 0, '1', '0', '1', 3312, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20046, 'Executive Teleport', 'exe_elevator', 's', 1, 1, 0.001, '0', '0', '0', 3305, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(20047, 'Soothing Stick', 'rela_stick', 's', 1, 1, 1, '0', '0', '0', 3240, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20048, 'Mall Lift', 'ads_mall_elevator', 's', 1, 1, 0.001, '0', '0', '0', 3306, '1', '1', '0', '1', '1', 'teleport', 1, '0', ''),
(20050, 'Flatscreen TV', 'xm09_infotv', 'i', 0, 0, 1, '1', '0', '0', 4309, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20051, 'Twilight Trophy', 'ads_twi_trophy', 's', 1, 1, 1, '1', '0', '0', 3311, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(20052, 'Volturi Crest', 'ads_twi_crest', 'i', 0, 0, 1, '1', '0', '0', 4275, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20053, 'Painting', 'ads_twi_paint', 'i', 0, 0, 1, '1', '0', '0', 4272, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20054, 'Window with Candles', 'ads_twi_windw', 'i', 0, 0, 1, '1', '0', '0', 4277, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20055, 'Truck and Motorcycles', 'ads_twi_bwall2', 'i', 0, 0, 1, '1', '0', '0', 4276, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20056, 'Dream Catcher', 'ads_twi_dreamc', 'i', 0, 0, 1, '1', '0', '0', 4273, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20057, 'Barn Wall', 'ads_twi_bwall1', 'i', 0, 0, 1, '1', '0', '0', 4274, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20059, 'Arabian Wall', 'arabian_wall', 'i', 0, 0, 1, '1', '0', '0', 4287, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20060, 'DEAL_HC_1', 'DEAL_HC_1', 'h', 0, 0, 0, '0', '0', '0', 0, '0', '0', '1', '0', '0', 'default', 0, '0', ''),
(20063, 'Hot Choc Machine', 'xm09_cocoa', 's', 1, 1, 1, '1', '0', '0', 3337, '1', '1', '1', '1', '1', 'vendingmachine', 0, '10', ''),
(20064, 'Astro-Bar', 'sf_mbar', 's', 1, 1, 1, '1', '0', '0', 3273, '1', '1', '1', '1', '1', 'vendingmachine', 0, '44', ''),
(20066, 'Dead Tree', 'tree2', 's', 1, 1, 1, '0', '0', '0', 2104, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20067, 'Green Hatch', 'divider_poly3*7', 's', 1, 1, 0.001, '0', '0', '0', 1930, '1', '1', '1', '1', '1', 'gate', 1, '0', ''),
(20068, 'Idea Agency Lava Lamp', 'ads_cllava2', 's', 1, 1, 1, '0', '0', '0', 3021, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20071, 'ads_gsArcade_2 name', 'ads_gsArcade_2', 's', 1, 1, 1, '1', '0', '0', 3278, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20072, 'ads_gsArcade_1 name', 'ads_gsArcade_1', 's', 1, 1, 1, '1', '0', '0', 3277, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20073, 'ads_idol_l_carpet name', 'ads_idol_l_carpet', 's', 2, 7, 0, '1', '0', '0', 3276, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20074, 'Silver MTV EMA Trophy', 'ads_mtvtrophy_silver', 's', 1, 1, 1, '0', '0', '0', 3281, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20075, 'ads_spang_sleep', 'ads_spang_sleep', 's', 1, 3, 0.8, '1', '0', '0', 3280, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20076, 'Gold MTV EMA Trophy', 'ads_mtvtrophy_gold', 's', 1, 1, 1, '0', '0', '0', 3279, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20077, 'ktchn_hlthNut name', 'ktchn_hlthNut', 's', 1, 1, 1, '1', '0', '0', 3307, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20078, 'Chicken', 'petfood8', 's', 1, 1, 1, '1', '0', '0', 3325, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20079, 'nest_plow_reg', 'nest_plow_reg', 's', 1, 1, 1, '1', '0', '0', 3318, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20080, 'Yellow Pet Snuggle', 'nest_snug_yel', 's', 1, 1, 1, '1', '0', '0', 3319, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20081, 'Salmon', 'petfood9', 's', 1, 1, 1, '1', '0', '0', 3322, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20082, 'Leveling Cake', 'petfood10', 's', 1, 1, 1, '1', '0', '0', 3326, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20083, 'Ice Apples', 'petfood7', 's', 1, 1, 1, '1', '0', '0', 3321, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20084, 'Red Apples', 'petfood6', 's', 1, 1, 1, '1', '0', '0', 3323, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20085, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1, '1', '0', '0', 3310, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20086, 'nest_snug_red', 'nest_snug_red', 's', 1, 1, 1, '1', '0', '0', 3317, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20087, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1, '1', '0', '0', 3310, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20088, 'nest_plow_bro', 'nest_plow_bro', 's', 1, 1, 1, '1', '0', '0', 3309, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20089, 'Red Pet Pillow', 'nest_plow_red', 's', 1, 1, 1, '1', '0', '0', 3320, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20090, 'nest_snug_blu', 'nest_snug_blu', 's', 1, 1, 1, '1', '0', '0', 3315, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20091, 'Green Apples', 'petfood5', 's', 1, 1, 1, '1', '0', '0', 3324, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20092, 'Blue Pet Pillow', 'nest_plow_blu', 's', 1, 1, 1, '1', '0', '0', 3316, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20093, 'Giant Bauble', 'xm09_lrgBauble', 's', 1, 1, 1, '1', '0', '0', 3313, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20094, 'nest_dirt', 'nest_dirt', 's', 1, 1, 1, '1', '0', '0', 3331, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20095, 'nest_snug_prp', 'nest_snug_prp', 's', 1, 1, 1, '1', '0', '0', 3332, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20096, 'nest_nest', 'nest_nest', 's', 1, 1, 1, '1', '0', '0', 3334, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20097, 'nest_nails', 'nest_nails', 's', 1, 1, 1, '1', '0', '0', 3336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20098, 'nest_basket', 'nest_basket', 's', 1, 1, 1, '1', '0', '0', 3333, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20099, 'Polar Bear Nest', 'nest_ice', 's', 1, 1, 1, '1', '0', '0', 3339, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20100, 'nest_plow_skl', 'nest_plow_skl', 's', 1, 1, 1, '1', '0', '0', 3341, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20101, 'nest_snug_bla', 'nest_snug_bla', 's', 1, 1, 1, '1', '0', '0', 3338, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20102, 'The Moodi Machine', 'ads_cl_moodi', 's', 1, 1, 1, '1', '0', '0', 3342, '1', '1', '1', '1', '1', 'vendingmachine', 1, '46,47,45', ''),
(20103, 'org_chairpnk', 'org_chairpnk', 's', 1, 1, 1.2, '0', '1', '0', 3354, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20104, 'org_tblpnk', 'org_tblpnk', 's', 1, 1, 1, '1', '0', '0', 3352, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20105, 'org_lampblk', 'org_lampblk', 's', 1, 1, 1.2, '0', '0', '0', 3353, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20106, 'org_lamppnk', 'org_lamppnk', 's', 1, 1, 1.2, '0', '0', '0', 3348, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20107, 'org_table', 'org_table', 's', 2, 2, 1, '1', '0', '0', 3356, '1', '1', '1', '1', '1', '', 2, '0', ''),
(20108, 'china_tiger', 'china_tiger', 's', 1, 1, 1, '1', '0', '0', 3344, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20109, 'xm09_trophy name', 'xm09_trophy', 's', 1, 1, 1, '1', '0', '0', 3351, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20110, 'china_plmTree name', 'china_plmTree', 's', 1, 1, 1, '1', '0', '0', 3355, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20111, 'org_chairblk', 'org_chairblk', 's', 1, 1, 1.2, '0', '1', '0', 3349, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20112, 'org_tblblk', 'org_tblblk', 's', 1, 1, 1, '1', '0', '0', 3347, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20113, 'org_chrblk', 'org_chrblk', 's', 1, 1, 1.2, '0', '1', '0', 3345, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20114, 'china_tigrSeat name', 'china_tigrSeat', 's', 1, 2, 1, '1', '0', '0', 3346, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20115, 'org_chrpnk', 'org_chrpnk', 's', 1, 1, 1.2, '0', '1', '0', 3350, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20116, 'ads_chups name', 'ads_chups', 's', 1, 1, 1, '1', '0', '0', 3367, '1', '1', '1', '1', '1', 'vendingmachine', 1, '48', ''),
(20117, 'bling_fridge', 'bling_fridge', 's', 1, 1, 1, '0', '0', '0', 3366, '1', '1', '1', '1', '1', 'vendingmachine', 0, '50', ''),
(20118, 'petfood12 name', 'petfood12', 's', 1, 1, 1, '1', '0', '0', 3370, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20119, 'ads_droetker_paula name', 'ads_droetker_paula', 's', 1, 1, 1, '1', '0', '0', 3365, '1', '1', '1', '1', '1', 'vendingmachine', 1, '49', ''),
(20120, 'petfood11 name', 'petfood11', 's', 1, 1, 1, '1', '0', '0', 3358, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20121, 'bling_chair_a', 'bling_chair_a', 's', 1, 1, 1, '0', '1', '0', 3368, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20122, 'petfood13 name', 'petfood13', 's', 1, 1, 1, '1', '0', '0', 3359, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20123, 'bling_pool', 'bling_pool', 's', 3, 1, 0.01, '0', '1', '0', 3369, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20124, 'bling_toilet', 'bling_toilet', 's', 1, 1, 1.2, '0', '1', '0', 3362, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20125, 'val09_floor', 'val09_floor', 's', 2, 2, 0, '1', '0', '1', 3363, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20126, 'bling_chair_c', 'bling_chair_c', 's', 1, 1, 1, '0', '1', '0', 3361, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20127, 'bling_chair_b', 'bling_chair_b', 's', 1, 1, 1, '0', '1', '0', 3360, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20128, 'bling_shwr name', 'bling_shwr', 's', 1, 1, 0, '1', '0', '1', 3396, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20129, 'bling_bed name', 'bling_bed', 's', 2, 3, 1.6, '0', '1', '0', 3364, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20130, 'bling_sofa', 'bling_sofa', 's', 2, 1, 1.5, '0', '1', '0', 3371, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20131, 'val09_floor2', 'val09_floor2', 's', 2, 2, 0, '1', '0', '1', 3357, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20132, 'teddy_basic', 'teddy_basic', 's', 1, 1, 1, '1', '0', '0', 3393, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20133, 'teddy_pendergrass', 'teddy_pendergrass', 's', 1, 1, 1, '1', '0', '0', 3384, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20134, 'val_hSeat_1 name', 'val_hSeat*1', 's', 1, 1, 1, '0', '1', '0', 3386, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20135, 'val_hSeat_2 name', 'val_hSeat*2', 's', 1, 1, 1, '0', '1', '0', 3387, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20136, 'val_hSeat_3 name', 'val_hSeat*3', 's', 1, 1, 1, '0', '1', '0', 3388, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20137, 'val_hSeat_4 name', 'val_hSeat*4', 's', 1, 1, 1, '0', '1', '0', 3389, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20138, 'val_hSeat_5 name', 'val_hSeat*5', 's', 1, 1, 1, '0', '1', '0', 3390, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20139, 'val_hSeat_6 name', 'val_hSeat*6', 's', 1, 1, 1, '0', '1', '0', 3391, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20140, 'val_hSeat_7 name', 'val_hSeat*7', 's', 1, 1, 1, '0', '1', '0', 3392, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20141, 'Valentines gift basket', 'val_basket', 's', 1, 1, 1, '1', '0', '0', 3382, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20142, 'teddy_bear', 'teddy_bear', 's', 1, 1, 1, '1', '0', '0', 3385, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20143, 'teddy_pink', 'teddy_pink', 's', 1, 1, 1, '1', '0', '0', 3383, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20144, 'bling_fridge_restricted name', 'bling_fridge_restricted', 's', 1, 1, 1, '0', '0', '0', 3394, '1', '1', '1', '1', '1', 'vendingmachine', 0, '50', ''),
(20145, 'ads_percyrock name', 'ads_percyrock', 's', 2, 2, 1, '1', '0', '0', 3395, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20146, 'Bubble Juice Can', 'md_can', 'i', 0, 0, 1, '1', '0', '0', 4025, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20147, 'ads_idol_l_logo name', 'ads_idol_l_logo', 'i', 0, 0, 1, '1', '0', '0', 4243, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20148, 'Latin American Idol TV', 'ads_idol_l_tv', 'i', 0, 0, 1, '1', '0', '0', 4245, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20149, 'Big MTV', 'ads_mtv_bigtv', 'i', 0, 0, 1, '1', '0', '0', 4241, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20150, 'Small MTV', 'ads_mtv_tv', 'i', 0, 0, 1, '1', '0', '0', 4242, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20151, 'flag_singapore', 'flag_singapore', 'i', 0, 0, 1, '1', '0', '0', 4249, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20152, 'Old Curtain', 'hween09_curt', 'i', 0, 0, 1, '1', '0', '0', 4266, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20153, 'flag_columbia', 'flag_columbia', 'i', 0, 0, 1, '1', '0', '0', 4258, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20154, 'flag_chile', 'flag_chile', 'i', 0, 0, 1, '1', '0', '0', 4256, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20155, 'flag_ecuador', 'flag_ecuador', 'i', 0, 0, 1, '1', '0', '0', 4268, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20156, 'flag_dominicanrepublic', 'flag_dominicanrepublic', 'i', 0, 0, 1, '1', '0', '0', 4265, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20157, 'flag_newzealand', 'flag_newzealand', 'i', 0, 0, 1, '1', '0', '0', 4260, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20158, 'flag_malaysia', 'flag_malaysia', 'i', 0, 0, 1, '1', '0', '0', 4252, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20159, 'Loading Poster', 'byesw_loadscreen', 'i', 0, 0, 1, '1', '0', '0', 4267, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20160, 'flag_venezl', 'flag_venezl', 'i', 0, 0, 1, '1', '0', '0', 4254, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20161, 'flag_algeria', 'flag_algeria', 'i', 0, 0, 1, '1', '0', '0', 4270, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20162, 'flag_tunisia', 'flag_tunisia', 'i', 0, 0, 1, '1', '0', '0', 4248, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20163, 'flag_panama', 'flag_panama', 'i', 0, 0, 1, '1', '0', '0', 4262, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20164, 'flag_mexico', 'flag_mexico', 'i', 0, 0, 1, '1', '0', '0', 4250, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20165, 'flag_argentina', 'flag_argentina', 'i', 0, 0, 1, '1', '0', '0', 4261, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20166, 'flag_philippines', 'flag_philippines', 'i', 0, 0, 1, '1', '0', '0', 4251, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20167, 'flag_greece', 'flag_greece', 'i', 0, 0, 1, '1', '0', '0', 4253, '1', '1', '1', '1', '1', 'default', 1, '0', '');
INSERT INTO `furniture_old` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(20168, 'flag_peru', 'flag_peru', 'i', 0, 0, 1, '1', '0', '0', 4246, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20169, 'flag_morocco', 'flag_morocco', 'i', 0, 0, 1, '1', '0', '0', 4264, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20170, 'flag_turkey', 'flag_turkey', 'i', 0, 0, 1, '1', '0', '0', 4255, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20171, 'Blue Long Bauble', 'xm09_bauble_12', 'i', 0, 0, 1, '1', '0', '0', 4304, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20172, 'Purple Long Bauble', 'xm09_bauble_16', 'i', 0, 0, 1, '1', '0', '0', 4303, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20173, 'Red Long Bauble', 'xm09_bauble_17', 'i', 0, 0, 1, '1', '0', '0', 4281, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20174, 'Silver Long Bauble', 'xm09_bauble_15', 'i', 0, 0, 1, '1', '0', '0', 4301, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20175, 'Silver Round Bauble', 'xm09_bauble_10', 'i', 0, 0, 1, '1', '0', '0', 4293, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20176, 'Gold Round Bauble', 'xm09_bauble_9', 'i', 0, 0, 1, '1', '0', '0', 4294, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20177, 'Green Long Bauble', 'xm09_bauble_18', 'i', 0, 0, 1, '1', '0', '0', 4298, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20178, 'Green Long Bauble', 'xm09_bauble_13', 'i', 0, 0, 1, '1', '0', '0', 4299, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20179, 'Blue Round Bauble', 'xm09_bauble_2', 'i', 0, 0, 1, '1', '0', '0', 4297, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20180, 'Red Round Bauble', 'xm09_bauble_1', 'i', 0, 0, 1, '1', '0', '0', 4300, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20181, 'Red Heart Bauble', 'xm09_bauble_22', 'i', 0, 0, 1, '1', '0', '0', 4302, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20182, 'Green Round Bauble', 'xm09_bauble_3', 'i', 0, 0, 1, '1', '0', '0', 4285, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20183, 'Silver Long Bauble', 'xm09_bauble_21', 'i', 0, 0, 1, '1', '0', '0', 4305, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20184, 'Green Round Bauble', 'xm09_bauble_8', 'i', 0, 0, 1, '1', '0', '0', 4295, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20185, 'Gold Round Bauble', 'xm09_bauble_4', 'i', 0, 0, 1, '1', '0', '0', 4282, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20186, 'Silver Round Bauble', 'xm09_bauble_5', 'i', 0, 0, 1, '1', '0', '0', 4288, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20187, 'Red Long Bauble', 'xm09_bauble_11', 'i', 0, 0, 1, '1', '0', '0', 4289, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20188, 'Gold Long Bauble', 'xm09_bauble_20', 'i', 0, 0, 1, '1', '0', '0', 4296, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20190, 'val_table1 name', 'val_table1', 's', 1, 1, 1, '0', '0', '0', 3397, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20191, 'Gold Long Bauble', 'xm09_bauble_14', 'i', 0, 0, 1, '1', '0', '0', 4290, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20192, 'Blue Round Bauble', 'xm09_bauble_7', 'i', 0, 0, 1, '1', '0', '0', 4291, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20193, 'Red Round Bauble', 'xm09_bauble_6', 'i', 0, 0, 1, '1', '0', '0', 4284, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20194, 'Blue Long Bauble', 'xm09_bauble_19', 'i', 0, 0, 1, '1', '0', '0', 4283, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20195, 'china_pstr3 name', 'china_pstr3', 'i', 0, 0, 1, '1', '0', '0', 4314, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20196, 'ads_tv_jaapuisto name', 'ads_tv_jaapuisto', 'i', 0, 0, 1, '1', '0', '0', 4315, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20197, 'Empire State Building Clock', 'ads_percyw', 'i', 0, 0, 1, '1', '0', '0', 4322, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20198, 'val09_wdrobe_b', 'val09_wdrobe_b', 'i', 0, 0, 1, '1', '0', '0', 4320, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20199, 'val09_wall2', 'val09_wall2', 'i', 0, 0, 1, '1', '0', '0', 4316, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20200, 'bling_sink', 'bling_sink', 'i', 0, 0, 1, '1', '0', '0', 4319, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20201, 'val09_wall1', 'val09_wall1', 'i', 0, 0, 1, '1', '0', '0', 4318, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20202, 'bling_cabinet', 'bling_cabinet', 'i', 0, 0, 1, '1', '0', '0', 4321, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20204, 'val09_wdrobe_g', 'val09_wdrobe_g', 'i', 0, 0, 1, '1', '0', '0', 4317, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20207, 'rare_ironmaiden name', 'rare_ironmaiden', 's', 1, 1, 0.001, '0', '0', '0', 3399, '1', '1', '0', '1', '1', 'teleport', 2, '0', ''),
(20208, 'rare_trex name', 'rare_trex', 's', 3, 7, 1, '0', '0', '0', 3398, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20209, 'beanstalk', 'beanstalk', 's', 1, 1, 1, '1', '0', '0', 3401, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(20210, 'Rare Voodoo Doll', 'rare_vdoll', 's', 1, 1, 1, '0', '0', '0', 3403, '1', '1', '1', '1', '1', '', 10, '0', ''),
(20211, 'rare_mmmth name', 'rare_mmmth', 's', 2, 1, 1, '0', '1', '0', 3402, '1', '1', '1', '1', '1', '', 0, '0', ''),
(20212, 'crystal_patch', 'crystal_patch', 's', 3, 3, 0, '0', '0', '1', 3400, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20213, 'ads_boost_surfb name', 'ads_boost_surfb', 'i', 0, 0, 1, '1', '0', '0', 4323, '1', '1', '1', '1', '1', '', 0, '0', ''),
(20214, 'ads_tlc_wheel name', 'ads_tlc_wheel', 'i', 0, 0, 1, '1', '0', '0', 4324, '1', '1', '1', '1', '1', 'habbowheel', 1, '0', ''),
(20221, 'White moon lupine', 'garden_lupin4', 's', 1, 1, 0.000000001, '0', '0', '0', 3419, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20222, 'Gold rush', 'garden_mursu3', 's', 1, 1, 1, '0', '0', '0', 3408, '1', '1', '1', '1', '1', 'default', 0, '0', ''),
(20223, 'Purple Lupine', 'garden_lupin5', 's', 1, 1, 1, '0', '0', '0', 3411, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20224, 'Violet Blossom', 'garden_seed', 's', 1, 1, 1, '0', '0', '0', 3406, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20225, 'Snapping teleporter', 'garden_flytrap', 's', 1, 1, 0.001, '0', '0', '0', 3420, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(20226, 'Pink pandemic', 'garden_flo3', 's', 1, 1, 0.000000000000001, '1', '0', '1', 3426, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20227, 'Belching pod', 'garden_volcano', 's', 2, 2, 1, '0', '0', '0', 3424, '1', '1', '1', '1', '1', 'alert', 2, '0', ''),
(20228, 'Wonder lamp', 'garden_flolamp', 's', 1, 1, 1, '0', '0', '0', 3415, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20229, 'Red rush', 'garden_mursu2', 's', 1, 1, 1, '0', '0', '0', 3412, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20230, 'Star flower', 'garden_jyrki', 's', 1, 1, 1, '0', '0', '0', 3405, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(20231, 'White rush', 'garden_mursu4', 's', 1, 1, 1, '0', '0', '0', 3414, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20232, 'Garden leaves', 'garden_leaves', 's', 1, 1, 1, '0', '0', '0', 3425, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20233, 'Sky blue lupine', 'garden_lupin2', 's', 1, 1, 1, '0', '0', '0', 3416, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20234, 'Red lupine', 'garden_lupin3', 's', 1, 1, 1, '0', '0', '0', 3407, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20235, 'Pink rush', 'garden_mursu', 's', 1, 1, 1, '0', '0', '0', 3404, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20237, 'Yellow happiness', 'garden_flo2', 's', 1, 1, 0, '1', '0', '1', 3409, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20238, 'Bauhinia orchid tree', 'garden_orchtree', 's', 1, 1, 1, '0', '0', '0', 3413, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20239, 'Orange lupine', 'garden_lupin1', 's', 1, 1, 1, '0', '0', '0', 3421, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20240, 'Weird staring bush', 'garden_staringbush', 's', 1, 3, 1, '0', '0', '0', 3417, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20241, 'ads_grefusa_yum name', 'ads_grefusa_yum', 's', 1, 1, 1, '1', '0', '0', 3423, '1', '1', '1', '1', '1', 'vendingmachine', 1, '51, 52', ''),
(20242, 'Blue passion', 'garden_flo1', 's', 1, 1, 0.00000001, '1', '0', '1', 3418, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20243, 'Duck grass', 'garden_jungle', 's', 1, 1, 1, '1', '0', '0', 3422, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20244, 'merger_chest name', 'merger_chest', 's', 2, 1, 1, '0', '0', '0', 3455, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20245, 'Suave Fireplace', 'hc2_frplc', 's', 1, 2, 1, '0', '0', '0', 3458, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20246, 'Leather Bar Stool', 'hc2_barchair', 's', 1, 1, 1.7, '0', '1', '0', 3439, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20247, 'runway_display name', 'runway_display', 's', 1, 1, 1, '0', '0', '0', 3457, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20248, 'runway_bigchr_5 name', 'runway_bigchr_5', 's', 1, 1, 0.8, '1', '0', '0', 3463, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20249, 'runway_bigchr_4 name', 'runway_bigchr_4', 's', 1, 1, 0.8, '1', '0', '0', 3435, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20250, 'VIP Duvan', 'hc3_dc', 's', 1, 3, 1, '0', '0', '0', 3461, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20252, 'Glass Table', 'hc2_sofatbl', 's', 2, 2, 0.5, '1', '0', '0', 3434, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20253, 'runway_stool name', 'runway_stool', 's', 1, 1, 1.2, '0', '1', '0', 3442, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20254, 'runway_dvdr name', 'runway_dvdr', 's', 2, 1, 1, '0', '0', '0', 3456, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20255, 'runway_block_2 name', 'runway_block_2', 's', 2, 2, 0.8, '1', '0', '1', 3443, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20256, 'runway_bigchr_1 name', 'runway_bigchr_1', 's', 1, 1, 0.8, '0', '1', '0', 3462, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20257, 'Black Lamp', 'hc2_biglamp', 's', 1, 1, 1, '0', '0', '0', 3446, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20258, 'Leather Sofa', 'hc2_sofa', 's', 2, 1, 1, '0', '1', '0', 3452, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20259, 'Trendy Rug', 'hc2_carpet', 's', 3, 5, 0, '1', '0', '1', 3440, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20260, 'runway_block_1 name', 'runway_block_1', 's', 2, 2, 0.8, '1', '0', '1', 3433, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20261, 'runway_bench name', 'runway_bench', 's', 2, 1, 1.4, '0', '1', '0', 3464, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20262, 'runway_chair_2 name', 'runway_chair_2', 's', 1, 1, 1.4, '0', '1', '0', 3429, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20263, 'ads_cheetos name', 'ads_cheetos', 's', 1, 1, 1, '0', '0', '0', 3453, '1', '1', '1', '1', '1', 'vendingmachine', 1, '51, 52', ''),
(20264, 'VIP Coffee Table', 'hc3_table', 's', 2, 2, 0.5, '1', '0', '0', 3466, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20265, 'runway_bigchr_3 name', 'runway_bigchr_3', 's', 1, 1, 0.8, '1', '0', '0', 3454, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20266, 'VIP Stool', 'hc3_stool', 's', 1, 1, 1.7, '0', '1', '0', 3448, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20267, 'VIP Sofa', 'hc3_sofa', 's', 2, 1, 1, '0', '1', '0', 3441, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20268, 'runway_bigchr_2 name', 'runway_bigchr_2', 's', 1, 1, 0.8, '1', '0', '0', 3427, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20269, 'Leather Armchair', 'hc2_armchair', 's', 1, 1, 1, '1', '1', '0', 3436, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20270, 'runway_table_2 name', 'runway_table_2', 's', 2, 1, 1, '0', '0', '0', 3444, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20271, 'runway_table_1 name', 'runway_table_1', 's', 3, 2, 1, '1', '0', '0', 3460, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20272, 'runway_manqn_1 name', 'runway_manqn_1', 's', 1, 1, 1, '0', '0', '0', 3437, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20273, 'Leather Duvan', 'hc2_dvn', 's', 1, 3, 1, '0', '0', '0', 3459, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(20274, 'VIP Light', 'hc3_light', 's', 2, 1, 0, '1', '0', '1', 3465, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20275, 'VIP Shelves', 'hc3_shelf', 's', 3, 1, 1.75, '1', '0', '0', 3438, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20276, 'runway_head name', 'runway_head', 's', 1, 1, 1, '1', '0', '0', 3432, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(20277, 'runway_manqn_2 name', 'runway_manqn_2', 's', 1, 1, 1, '0', '0', '0', 3467, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(20278, 'Black Divider', 'hc2_divider', 's', 1, 3, 1, '0', '0', '0', 3449, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20279, 'Espresso Machine', 'hc2_coffee', 's', 1, 1, 1, '0', '0', '0', 3450, '1', '1', '1', '1', '1', 'vendingmachine', 0, '9,8,14,15,6,10,11,12,17,13', ''),
(20280, 'Service Trolley', 'hc2_cart', 's', 1, 1, 1, '0', '0', '0', 3430, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20281, 'VIP Bar Desk', 'hc3_bard', 's', 2, 1, 1.05, '1', '0', '0', 3445, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20282, 'VIP Lamp', 'hc3_hugelamp', 's', 1, 1, 0, '1', '0', '1', 3447, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20283, 'VIP Divider', 'hc3_divider', 's', 1, 3, 1, '0', '0', '0', 3431, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20284, 'Black Vase', 'hc2_vase', 's', 1, 1, 1, '0', '0', '0', 3428, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20285, 'runway_chair_1 name', 'runway_chair_1', 's', 1, 1, 1.4, '0', '1', '0', 3451, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20286, 'Green been vines', 'garden_wall', 'i', 0, 0, 1, '1', '0', '0', 4325, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20287, 'ads_tv_yle name', 'ads_tv_yle', 'i', 0, 0, 1, '1', '0', '0', 4326, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20288, 'VIP Wall Art', 'hc3_walldeco', 'i', 0, 0, 1, '1', '0', '0', 4329, '1', '1', '1', '1', '1', 'default', 10, '0', ''),
(20289, 'runway_shelf name', 'runway_shelf', 'i', 0, 0, 1, '1', '0', '0', 4327, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(20290, 'ads_nokia_x6 name', 'ads_nokia_x6', 'i', 0, 0, 1, '1', '0', '0', 4330, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20291, 'ads_target_wall name', 'ads_target_wall', 'i', 0, 0, 1, '1', '0', '0', 4332, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20292, 'runway_fabric name', 'runway_fabric', 'i', 0, 0, 1, '1', '0', '0', 4331, '1', '1', '1', '1', '1', 'default', 8, '0', ''),
(20293, 'ads_latrobe_flag name', 'ads_latrobe_flag', 'i', 0, 0, 1, '1', '0', '0', 4328, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20295, 'Camera', 'camera', 's', 1, 1, 1, '0', '0', '0', 263, '1', '1', '1', '1', '1', '', 1, '0', ''),
(20296, 'Holly', 'holly', 'i', 0, 0, 0, '1', '0', '0', 4001, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20319, 'a0 pet5', 'a0 pet5', 's', 1, 1, 0, '0', '0', '0', 2442, '1', '0', '0', '0', '0', 'pet5', 1, '0', ''),
(20320, 'a0 pet4', 'a0 pet4', 's', 1, 1, 0, '0', '0', '0', 2431, '0', '0', '0', '0', '0', 'pet4', 1, '0', ''),
(20321, 'a0 pet3', 'a0 pet3', 's', 1, 1, 0, '0', '0', '0', 2430, '0', '0', '0', '0', '0', 'pet3', 1, '0', ''),
(20322, 'a0 pet2', 'a0 pet2', 's', 1, 1, 0, '0', '0', '0', 2434, '0', '0', '0', '0', '0', 'pet2', 1, '0', ''),
(20323, 'a0 pet1', 'a0 pet1', 's', 1, 1, 0, '0', '0', '0', 2432, '0', '0', '0', '0', '0', 'pet1', 1, '0', ''),
(20324, 'a0 pet0', 'a0 pet0', 's', 1, 1, 0, '0', '0', '0', 2433, '0', '0', '0', '0', '0', 'pet0', 1, '0', ''),
(20335, 'bw_boat name', 'bw_boat', 's', 2, 2, 1, '1', '1', '0', 3527, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20336, 'bw_jaws', 'bw_jaws', 'i', 1, 1, 1, '1', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20337, 'bw_shower', 'bw_shower', 's', 1, 1, 0, '0', '0', '1', 3540, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20338, 'bw_tele', 'bw_tele', 's', 1, 1, 0, '0', '0', '1', 3550, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(20339, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0, '1', '0', '1', 3541, '1', '1', '1', '1', '1', 'pool', 1, '0', ''),
(20340, 'fball_gate name', 'fball_gate', 's', 1, 0, 0.001, '0', '0', '1', 3516, '1', '1', '1', '1', '1', 'fbgate', 1, '0', ''),
(20341, 'fball_counter name', 'fball_counter', 's', 2, 1, 1, '0', '0', '0', 3525, '1', '1', '1', '1', '1', 'scoreboard', 2, '0', ''),
(20342, 'fball_ptch0', 'fball_ptch0', 's', 3, 3, 0, '1', '0', '0', 3520, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20343, 'fball_ptch1', 'fball_ptch1', 's', 3, 3, 0, '1', '0', '0', 3524, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20344, 'fball_ptch2 name', 'fball_ptch2', 's', 3, 3, 0, '1', '0', '0', 3511, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20345, 'fball_ptch3 name', 'fball_ptch3', 's', 3, 3, 0, '1', '0', '0', 3513, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20346, 'fball_ptch4 name', 'fball_ptch4', 's', 3, 3, 0, '1', '0', '0', 3504, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20347, 'fball_ptch5 name', 'fball_ptch5', 's', 3, 3, 0, '1', '0', '0', 3498, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20348, 'fball_ptch6 name', 'fball_ptch6', 's', 3, 3, 0, '1', '0', '0', 3517, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20349, 'fball_ptch7 name', 'fball_ptch7', 's', 3, 3, 0, '1', '0', '0', 3509, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20350, 'fball_ptch8 name', 'fball_ptch8', 's', 3, 3, 0, '1', '0', '0', 3502, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20351, 'fball_score_b', 'fball_score_b', 's', 1, 1, 1, '0', '0', '0', 3496, '1', '1', '1', '1', '1', 'scoreboard', 1, '0', ''),
(20352, 'fball_score_g', 'fball_score_g', 's', 1, 1, 1, '0', '0', '0', 3512, '1', '1', '1', '1', '1', 'scoreboard', 1, '0', ''),
(20353, 'fball_score_r', 'fball_score_r', 's', 1, 1, 1, '0', '0', '0', 3522, '1', '1', '1', '1', '1', 'scoreboard', 1, '0', ''),
(20354, 'fball_score_y', 'fball_score_y', 's', 1, 1, 1, '0', '0', '0', 3506, '1', '1', '1', '1', '1', 'scoreboard', 1, '0', ''),
(20355, 'fball_light name', 'fball_light', 's', 1, 0, 1, '0', '0', '0', 3499, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20356, 'fball_goal_y name', 'fball_goal_y', 's', 3, 0, 1, '0', '0', '0', 3523, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20357, 'fball_goal_r name', 'fball_goal_r', 's', 3, 0, 1, '0', '0', '0', 3514, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20358, 'fball_goal_g', 'fball_goal_g', 's', 3, 0, 1, '0', '0', '0', 3519, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20359, 'fball_goal_b name', 'fball_goal_b', 's', 3, 0, 1, '0', '0', '0', 3515, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20360, 'fball_fnc3 name', 'fball_fnc3', 's', 1, 3, 1, '1', '0', '0', 3495, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20361, 'fball_fnc1 name', 'fball_fnc1', 's', 1, 0, 1, '1', '0', '0', 3501, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20362, 'fball_crnr name', 'fball_crnr', 's', 1, 0, 1, '1', '0', '0', 3503, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20363, 'fball_cote name', 'fball_cote', 's', 3, 1, 1, '0', '0', '0', 3507, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20364, 'fball_bench name', 'fball_bench', 's', 3, 0, 1, '0', '1', '0', 3494, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20365, 'fball_ball5 name', 'fball_ball5', 's', 1, 0, 1, '0', '0', '0', 3518, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20366, 'fball_ball4 name', 'fball_ball4', 's', 1, 0, 1, '0', '0', '0', 3521, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20367, 'fball_ball3 name', 'fball_ball3', 's', 1, 0, 1, '0', '0', '0', 3497, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20368, 'fball_ball2 name', 'fball_ball2', 's', 1, 0, 1, '0', '0', '0', 3510, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(20369, 'fball_ball name', 'fball_ball', 's', 1, 0, 1, '1', '0', '0', 3508, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20370, 'fball_audbench name', 'fball_audbench', 's', 4, 1, 1, '0', '1', '0', 3500, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(20371, 'fball_trophy name', 'fball_trophy', 's', 1, 1, 1, '0', '0', '0', 3505, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(20372, 'party_crate2_1', 'party_crate2_1', 's', 2, 1, 1, '1', '0', '0', 3480, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20373, 'party_crate1_3', 'party_crate1_3', 's', 1, 1, 1, '1', '0', '0', 3481, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20374, 'party_crate1_4', 'party_crate1_4', 's', 1, 1, 1, '1', '0', '0', 3485, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20375, 'party_crate1_1', 'party_crate1_1', 's', 1, 1, 1, '1', '0', '0', 3487, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20376, 'party_crate1_2', 'party_crate1_2', 's', 1, 1, 1, '1', '0', '0', 3489, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20377, 'party_crate2_2', 'party_crate2_2', 's', 2, 1, 1, '1', '0', '0', 3490, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20378, 'party_crate2_3', 'party_crate2_3', 's', 2, 1, 1, '1', '0', '0', 3491, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20379, 'party_crate2_4', 'party_crate2_4', 's', 2, 1, 1, '1', '0', '0', 3492, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20380, 'party_djset', 'pary_djset', 's', 1, 3, 3, '0', '0', '0', 3199, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(20411, 'a0 pet6', 'a0 pet6', 's', 1, 1, 0, '0', '0', '0', 7457, '0', '0', '0', '0', '0', 'pet6', 0, '0', ''),
(20412, 'a0 pet7', 'a0 pet7', 's', 1, 1, 0, '0', '0', '0', 5354, '0', '0', '0', '0', '0', 'pet7', 0, '0', ''),
(25354, 'bw_boat', 'bw_boat', 's', 2, 2, 1, '1', '1', '0', 3527, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25355, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3, '0', '1', '0', 3529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25357, 'bw_sofa', 'bw_sofa', 's', 2, 1, 1, '1', '1', '0', 3533, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(25359, 'bw_fin', 'bw_fin', 's', 1, 1, 1, '1', '0', '0', 3538, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25360, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1, '0', '0', '0', 3539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25361, 'bw_shower', 'bw_shower', 's', 1, 1, 2, '1', '0', '0', 3540, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25362, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0, '1', '0', '0', 3541, '1', '1', '1', '1', '1', 'pool', 1, '0', ''),
(25363, 'bw_croc', 'bw_croc', 's', 1, 3, 1, '1', '1', '0', 3542, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25364, 'bw_sboard', 'bw_sboard', 's', 2, 1, 0, '0', '0', '0', 3543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25365, 'bw_chair', 'bw_chair', 's', 1, 1, 0.8, '1', '1', '1', 3544, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(25366, 'bw_table', 'bw_table', 's', 2, 2, 1, '1', '0', '0', 3545, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25367, 'bw_ball', 'bw_ball', 's', 1, 1, 1, '0', '0', '0', 3547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25368, 'bw_mttrss', 'bw_mttrss', 's', 1, 3, 0.8, '1', '1', '0', 3548, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25369, 'bw_van', 'bw_van', 's', 2, 2, 1, '0', '1', '0', 3549, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(25371, 'bw_fnc_crnr', 'bw_fnc crnr', 's', 1, 2, 1, '1', '0', '0', 3551, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(25372, 'bw_fnc', 'bw_fnc', 's', 2, 1, 1, '1', '0', '0', 3552, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(29901, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3, '0', '1', '1', 3529, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29902, 'bw_sofa', 'bw_sofa', 's', 1, 2, 1, '0', '0', '1', 3533, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29903, 'bw_sboard', 'bw_sboard', 's', 1, 2, 1, '1', '0', '1', 3543, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29904, 'bw_chair', 'bw_chair', 's', 1, 1, 1, '1', '1', '1', 3544, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29905, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1, '0', '0', '0', 3539, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29906, 'bw_table', 'bw_table', 's', 2, 2, 1, '1', '0', '0', 3545, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(29907, 'bw_bball', 'bw_bball', 's', 1, 1, 1, '1', '0', '0', 3547, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29908, 'bw_croc', 'bw_croc', 's', 1, 1, 1, '1', '1', '0', 3542, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29909, 'bw_fnc', 'bw_fnc', 's', 1, 1, 1, '1', '0', '0', 3552, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29910, 'bw_water_1', 'bw_water_1', 's', 2, 2, 0, '1', '0', '1', 3530, '1', '1', '1', '1', '1', 'lowpool', 1, '0', ''),
(29911, 'prison_dvdr2', 'prison_dvdr2', 's', 2, 1, 3, '1', '0', '0', 3532, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(29912, 'prison_gate', 'prison_gate', 's', 1, 1, 0.001, '0', '0', '0', 3526, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(29913, 'prison_dvdr1', 'prison_dvdr1', 's', 1, 1, 3, '1', '0', '0', 3534, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29914, 'prison_stone', 'prison_stone', 's', 1, 1, 1, '0', '0', '0', 3537, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(29915, 'prison_tower', 'prison_tower', 's', 1, 1, 3, '1', '0', '1', 3531, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(29916, 'prison_crnr', 'prison_crnr', 's', 1, 1, 1, '1', '0', '0', 3528, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30000, 'hween10_bat', 'hween10_bat', 's', 1, 1, 1, '0', '0', '0', 3662, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30001, 'hween10_card_1', 'hween10_card_1', 'i', 1, 1, 1, '1', '0', '0', 4346, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30002, 'hween10_card_2', 'hween10_card_2', 'i', 1, 1, 1, '1', '0', '0', 4350, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30003, 'hween10_card_3', 'hween10_card_3', 'i', 1, 1, 1, '1', '0', '0', 4345, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30004, 'hween10_card_4', 'hween10_card_4', 'i', 1, 1, 1, '1', '0', '0', 4347, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30005, 'hween10_card_5', 'hween10_card_5', 'i', 1, 1, 1, '1', '0', '0', 4351, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30006, 'hween10_card_6', 'hween10_card_6', 'i', 1, 1, 1, '1', '0', '0', 4348, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30007, 'hween10_chicken', 'hween10_chicken', 's', 2, 1, 1, '1', '0', '0', 3658, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30008, 'hween10_ffly', 'hween10_ffly', 's', 1, 1, 1, '1', '0', '0', 3657, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30009, 'hween10_fog', 'hween10_fog', 's', 2, 2, 0.0001, '1', '0', '1', 3652, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30010, 'hween10_jar', 'hween10_jar', 's', 1, 1, 1, '1', '0', '0', 3651, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30011, 'hween10_logs', 'hween10_logs', 's', 1, 1, 0.3, '0', '0', '1', 3656, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30012, 'hween10_pond', 'hween10_pond', 's', 2, 2, 0.01, '1', '0', '1', 3650, '1', '1', '1', '1', '1', 'haloweenpool', 1, '0', ''),
(30013, 'hween10_portch', 'hween10_portch', 's', 1, 1, 1, '0', '0', '1', 3661, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(30014, 'hween10_skullpost', 'hween10_skullpost', 's', 1, 1, 1, '1', '0', '0', 3654, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30015, 'hween10_swamp', 'hween10_swamp', 's', 2, 2, 0.01, '1', '0', '0', 3649, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30016, 'hween10_tarot', 'hween10_tarot', 's', 1, 1, 1, '1', '0', '0', 3646, '1', '1', '1', '1', '1', 'dice', 7, '0', ''),
(30017, 'hween10_tele', 'hween10_tele', 's', 1, 1, 0.1, '1', '0', '0', 3659, '1', '1', '1', '1', '1', 'teleport', 2, '0', ''),
(30018, 'hween10_throne', 'hween10_throne', 's', 1, 1, 1.2, '0', '1', '0', 3660, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(30019, 'hween10_tree', 'hween10_tree', 's', 1, 1, 1, '1', '0', '0', 3648, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30020, 'hween10_voodoo1', 'hween10_voodoo1', 's', 1, 1, 1, '1', '0', '0', 3647, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30021, 'hween10_voodoo2', 'hween10_voodoo2', 's', 1, 1, 1, '1', '0', '0', 3653, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30022, 'hween10_voodoo3', 'hween10_voodoo3', 's', 1, 1, 1, '1', '0', '0', 3655, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(30023, 'hween10_wallskull', 'hween10_wallskull', 'i', 1, 1, 1, '1', '0', '0', 4349, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(59919, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0, '0', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(59939, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0, '0', '0', '0', 4336, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77701, 'bling11_block', 'bling11_block', 's', 1, 1, 2, '1', '0', '0', 3801, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77702, 'bling11_dvd', 'bling11_dvd', 's', 1, 2, 1.6, '1', '0', '0', 3793, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77703, 'bling11_dvn', 'bling11_dnv', 's', 1, 3, 1.2, '0', '0', '0', 3798, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(77704, 'bling11_floor', 'bling11_floor', 's', 1, 1, 0.1, '1', '0', '0', 3794, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(77705, 'bling11_pillar', 'bling11_pillar', 's', 1, 1, 3.3, '1', '0', '0', 3802, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77706, 'bling11_plant', 'bling11_plant', 's', 1, 1, 1, '0', '0', '0', 3795, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77707, 'bling11_rug1', 'bling11_rug1', 's', 2, 2, 0.1, '1', '0', '1', 3788, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77708, 'bling11_rug2', 'bling11_rug2', 's', 3, 3, 0.2, '1', '0', '1', 3797, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77709, 'bling11_seat1', 'bling11_seat1', 's', 1, 1, 1, '0', '1', '0', 3800, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77710, 'bling11_seat2', 'bling11_seat2', 's', 1, 1, 1.2, '0', '1', '0', 3799, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(77711, 'bling11_slot', 'bling11_slot', 's', 1, 1, 1, '0', '0', '0', 3786, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77712, 'bling11_sofa', 'bling11_sofa', 's', 3, 1, 0.4, '0', '1', '0', 3790, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77713, 'bling11_statue1', 'bling11_statue1', 's', 1, 1, 1, '0', '0', '0', 3791, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(77714, 'bling11_statue2', 'bling11_statue2', 's', 2, 2, 1, '0', '0', '0', 3785, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77715, 'bling11_tele', 'bling11_tele', 's', 1, 1, 0.1, '0', '0', '0', 3789, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(77716, 'bling11_towels', 'bling11_towels', 's', 1, 1, 1, '0', '0', '0', 3787, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(77717, 'val11_floor', 'val11_floor', 's', 2, 2, 0.1, '1', '0', '1', 3792, '1', '1', '1', '1', '1', 'normalskates', 1, '0', ''),
(77801, 'china_rabbit', 'china_rabbit', 's', 1, 1, 1, '0', '0', '0', 3796, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89900, 'limo_w_front', 'limo_w_front', 's', 2, 1, 1, '0', '0', '0', 3823, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89901, 'limo_w_mid', 'limo_w_mid', 's', 2, 1, 1, '0', '1', '0', 3819, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89902, 'limo_w_mid2', 'limo_w_mid2', 's', 2, 1, 0.3, '0', '0', '1', 3820, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89903, 'limo_w_back', 'limo_w_back', 's', 2, 1, 1, '0', '1', '0', 3822, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89904, 'petfood19', 'petfood19', 's', 1, 1, 0.001, '0', '0', '1', 3821, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89905, 'petfood18', 'petfood18', 's', 1, 1, 0.001, '0', '0', '1', 3816, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89906, 'petfood17', 'petfood17', 's', 1, 1, 0.001, '0', '0', '1', 3817, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89907, 'gothic_st_glass', 'gothic_st_glass', 'i', 1, 1, 1, '0', '0', '0', 4380, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89908, 'gothic_candles', 'gothic_candles', 's', 1, 1, 1, '0', '0', '0', 3825, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89909, 'gothic_bed', 'gothic_bed', 's', 2, 3, 1, '0', '1', '0', 3824, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89910, 'gothic_bowl', 'gothic_bowl', 's', 1, 1, 1, '0', '0', '0', 3828, '1', '1', '1', '1', '1', 'vendingmachine', 1, '62', ''),
(89911, 'gothic_desk', 'gothic_desk', 's', 1, 2, 1, '0', '0', '0', 3826, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89912, 'ads_grefu_trophy', 'ads_grefu_trophy', 's', 1, 1, 1, '0', '0', '0', 3827, '1', '1', '1', '1', '1', 'trophy', 1, '0', ''),
(89914, 'nest_frog', 'nest_frog', 's', 1, 1, 0.1, '0', '0', '1', 3830, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89915, 'pond', 'pond', 's', 1, 1, 0.01, '0', '0', '1', 3831, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89916, 'val11_present', 'val11_present', 's', 1, 1, 1.2, '1', '0', '0', 3832, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89917, 'prizetrophy_cine', 'prizetrophy_cine', 's', 1, 1, 1, '0', '0', '0', 3833, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89918, 'cine_vipsign', 'cine_vipsign', 's', 1, 1, 1, '0', '0', '0', 3834, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89919, 'limo_b_mid3', 'limo_b_mid3', 's', 2, 1, 1, '0', '0', '0', 3835, '1', '1', '1', '1', '1', 'vendingmachine', 1, '50', ''),
(89920, 'limo_b_mid2', 'limo_b_mid2', 's', 2, 1, 0.3, '0', '0', '1', 3836, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89921, 'limo_b_front', 'limo_b_front', 's', 2, 1, 1, '0', '0', '0', 3837, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89922, 'limo_b_mid', 'limo_b_mid', 's', 2, 1, 1.2, '0', '1', '0', 3838, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89923, 'cine_star', 'cine_star', 's', 1, 1, 0.1, '1', '0', '1', 3839, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89924, 'limo_b_back', 'limo_b_back', 's', 2, 1, 1.2, '0', '1', '0', 3840, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89925, 'ads_bigtv_missmix', 'ads_bigtv_missmix', 'i', 1, 1, 1, '0', '0', '0', 4381, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89926, 'cine_curtain', 'cine_curtain', 's', 8, 1, 0.001, '0', '0', '0', 3841, '1', '1', '1', '1', '1', 'gate', 2, '0', ''),
(89927, 'cine_screen', 'cine_screen', 's', 8, 1, 1, '0', '0', '0', 3842, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89928, 'theatre_seat_g', 'theatre_seat_g', 's', 1, 1, 1, '0', '1', '0', 3843, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89929, 'cine_tile', 'cine_tile', 's', 1, 1, 0.1, '0', '0', '1', 3844, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89930, 'cine_bench_b', 'cine_bench_b', 's', 3, 1, 1.1, '0', '1', '0', 3845, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89931, 'theatre_seat_b', 'theatre_seat_b', 's', 1, 1, 1, '0', '1', '0', 3846, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89932, 'cine_roof', 'cine_roof', 's', 3, 3, 0.1, '0', '0', '1', 3847, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89933, 'cine_popcorn', 'cine_popcorn', 's', 1, 1, 1, '0', '0', '0', 3848, '1', '1', '1', '1', '1', 'vendingmachine', 1, '62', ''),
(89934, 'cine_bench', 'cine_bench', 's', 3, 1, 1.1, '0', '1', '0', 3849, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89935, 'cine_bench_g', 'cine_bench_g', 's', 3, 1, 1.1, '0', '1', '0', 3850, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89936, 'cine_ticket_booth', 'cine_ticket_booth', 's', 1, 1, 1, '0', '0', '0', 3851, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89937, 'cine_projector', 'cine_projector', 's', 1, 1, 1, '0', '0', '0', 3852, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89938, 'wf_box', 'wf_box', 's', 1, 1, 1.2, '1', '0', '0', 3853, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89939, 'wf_maze', 'wf_maze', 's', 1, 1, 1, '0', '0', '0', 3854, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89940, 'ads_rangocactus', 'ads_rangocactus', 's', 1, 1, 1, '0', '0', '0', 3855, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89941, 'cine_glass', 'cine_glass', 's', 1, 1, 0.01, '1', '0', '0', 3856, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89942, 'wf_cnd_has_furni_on', 'wf_cnd_has_furni_on', 's', 1, 1, 0.6, '1', '0', '0', 3857, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89943, 'cine_light2', 'cine_light2', 'i', 1, 1, 1, '1', '0', '0', 4382, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89944, 'cine_light1', 'cine_light1', 'i', 1, 1, 1, '1', '0', '0', 4383, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89945, 'cubie_rug_b', 'cubie_rug_b', 's', 2, 3, 0.1, '1', '0', '1', 3860, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89946, 'cubie_lamp_p', 'cubie_lamp_p', 's', 1, 1, 1, '0', '0', '0', 3863, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89947, 'cubie_shelf_3_p', 'cubie_shelf_3_p', 's', 2, 1, 1, '1', '0', '0', 3873, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(89948, 'cubie_shelf_4_b', 'cubie_shelf_4_b', 's', 3, 1, 1, '1', '0', '0', 3882, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89949, 'cubie_shelf_1_b', 'cubie_shelf_1_b', 's', 1, 1, 1, '0', '0', '0', 3875, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89950, 'cubie_shelf_1_p', 'cubie_shelf_1_p', 's', 1, 1, 1, '0', '0', '0', 3874, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89951, 'cubie_chair_p', 'cubie_chair_p', 's', 1, 1, 1.2, '0', '1', '0', 3879, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89952, 'cubie_shelf_4_p', 'cubie_shelf_4_p', 's', 3, 1, 1, '0', '0', '0', 3866, '1', '1', '1', '1', '1', 'default', 6, '0', ''),
(89953, 'cubie_bigtable_p', 'cubie_bigtable_p', 's', 2, 2, 0.5, '1', '0', '1', 3876, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89954, 'cubie_shelf_0_p', 'cubie_shelf_0_p', 's', 1, 1, 0.5, '1', '0', '0', 3884, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89955, 'cubie_beanbag_b', 'cubie_beanbag_b', 's', 1, 1, 1, '0', '1', '0', 3877, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89956, 'cubie_chair_b', 'cubie_chair_b', 's', 1, 1, 1.2, '0', '1', '0', 3859, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89957, 'cubie_bed_b', 'cubie_bed_b', 's', 1, 3, 1.8, '0', '0', '0', 3871, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(89958, 'cubie_bigtable_b', 'cubie_bigtable_b', 's', 2, 2, 0.5, '1', '0', '1', 3861, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89959, 'cubie_stool_b', 'cubie_stool_b', 's', 1, 1, 1.2, '0', '1', '0', 3869, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89960, 'cubie_beanbag_p', 'cubie_beanbag_p', 's', 1, 1, 1, '0', '1', '0', 3862, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89961, 'cubie_shelf_0_b', 'cubie_shelf_0_b', 's', 1, 1, 0.5, '1', '0', '0', 3865, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89962, 'cubie_shelf_2_p', 'cubie_shelf_2_p', 's', 2, 1, 1, '1', '0', '0', 3867, '1', '1', '1', '1', '1', 'default', 17, '0', ''),
(89963, 'cubie_rug_p', 'cubie_rug_p', 's', 2, 3, 0.1, '1', '0', '1', 3870, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89964, 'cubie_sofaseat_b', 'cubie_sofaseat_b', 's', 1, 1, 1, '0', '1', '0', 3881, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89965, 'cubie_table', 'cubie_table', 's', 1, 2, 1, '1', '0', '0', 3880, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89966, 'cubie_sofaseat_p', 'cubie_sofaseat_p', 's', 1, 1, 1, '0', '1', '0', 3864, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89967, 'cubie_bed_p', 'cubie_bed_p', 's', 1, 3, 1.8, '0', '0', '0', 3868, '1', '1', '1', '1', '1', 'bed', 1, '0', ''),
(89968, 'cubie_shelf_3_b', 'cubie_shelf_3_b', 's', 2, 1, 1, '1', '0', '0', 3872, '1', '1', '1', '1', '1', 'default', 9, '0', ''),
(89969, 'cubie_shelf_2_b', 'cubie_shelf_2_b', 's', 2, 1, 1, '1', '0', '0', 3883, '1', '1', '1', '1', '1', 'default', 14, '0', ''),
(89970, 'cubie_lamp_b', 'cubie_lamp_b', 's', 1, 1, 1, '0', '0', '0', 3858, '1', '1', '1', '1', '1', 'default', 4, '0', ''),
(89971, 'cubie_stool_p', 'cubie_stool_p', 's', 1, 1, 1.2, '0', '1', '0', 3878, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89972, 'cubie_wallshelf_b', 'cubie_wallshelf_b', 'i', 1, 1, 1, '1', '0', '0', 4389, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89973, 'cubie_decklight_p', 'cubie_decklight_p', 'i', 1, 1, 1, '1', '0', '0', 4385, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89974, 'cubie_wallshelf_p', 'cubie_wallshelf_p', 'i', 1, 1, 1, '1', '0', '0', 4392, '1', '1', '1', '1', '1', 'default', 7, '0', ''),
(89975, 'cubie_decal_0', 'cubie_decal_0', 'i', 1, 1, 1, '1', '0', '0', 4395, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89976, 'cubie_decal_3', 'cubie_decal_3', 'i', 1, 1, 1, '1', '0', '0', 4391, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89977, 'cubie_decal_1_p', 'cubie_decal_1_p', 'i', 1, 1, 1, '1', '0', '0', 4390, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89978, 'cubie_decklight_b', 'cubie_decklight_b', 'i', 1, 1, 1, '1', '0', '0', 4394, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89979, 'cubie_decal_1_b', 'cubie_decal_1_b', 'i', 1, 1, 1, '1', '0', '0', 4386, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89980, 'cubie_decal_2_b', 'cubie_decal_2_b', 'i', 1, 1, 1, '1', '0', '0', 4387, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89981, 'cubie_decal_3_p', 'cubie_decal_3_p', 'i', 1, 1, 1, '1', '0', '0', 4388, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89982, 'cubie_decal_2_p', 'cubie_decal_2_p', 'i', 1, 1, 1, '1', '0', '0', 4393, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89983, 'cubie_decal_3_b', 'cubie_decal_3_b', 'i', 1, 1, 1, '1', '0', '0', 4384, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89984, 'newbie_present', 'newbie_present', 's', 1, 1, 1, '1', '0', '0', 3885, '1', '1', '1', '1', '1', 'default', 5, '0', ''),
(89985, 'tv_flat', 'tv_flat', 's', 2, 1, 1, '0', '0', '0', 3886, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89986, 'waasa_table2', 'waasa_table2', 's', 2, 1, 1, '1', '0', '0', 3887, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89987, 'computer_flatscreen', 'computer_flatscreen', 's', 1, 1, 1, '0', '0', '0', 3888, '1', '1', '1', '1', '1', 'default', 3, '0', ''),
(89988, 'waasa_chair', 'waasa_chair', 's', 1, 1, 1.2, '0', '1', '0', 3889, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89989, 'waasa_ship2', 'waasa_ship2', 's', 2, 1, 1, '0', '0', '0', 3890, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89990, 'waasa_ship1', 'waasa_ship1', 's', 1, 1, 1, '0', '0', '0', 3891, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89991, 'waasa_bunk_bed', 'waasa_bunk_bed', 's', 3, 1, 1, '1', '0', '0', 3892, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89992, 'computer_laptop', 'computer_laptop', 's', 1, 1, 1, '0', '0', '0', 3893, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89993, 'computer_old', 'computer_old', 's', 1, 1, 1, '0', '0', '0', 3894, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89994, 'waasa_table1', 'waasa_table1', 's', 1, 1, 1, '1', '0', '0', 3895, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89995, 'waasa_desk', 'waasa_desk', 's', 2, 1, 1, '1', '0', '0', 3896, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(89996, 'waasa_wall_shelf2', 'waasa_wall_shelf2', 'i', 1, 1, 1, '1', '0', '0', 4396, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(89997, 'waasa_wall_shelf1', 'waasa_wall_shelf1', 'i', 1, 1, 1, '1', '0', '0', 4397, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95374, 'ads_grefusa_surfb', 'ads_grefusa_surfb', 'i', 0, 0, 0, '0', '0', '0', 4337, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95375, 'ads_pepsi0', 'ads_pepsi0', 's', 1, 1, 3, '0', '0', '0', 3554, '1', '1', '1', '1', '1', 'vendingmachine', 1, '55', ''),
(95376, 'bw_fnc_p', 'bw_fnc_p', 's', 2, 1, 1, '1', '0', '0', 3569, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95377, 'bw_fnc_crnr_g', 'bw_fnc_crnr_g', 's', 1, 2, 1, '1', '0', '0', 3563, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95378, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1, '1', '1', '1', 3561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95379, 'bw_boat_g', 'bw_boat_g', 's', 2, 2, 0.8, '1', '1', '0', 3568, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95380, 'bw_mttrss_g', 'bw_mttrss_g', 's', 1, 3, 0.8, '1', '0', '0', 3558, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95381, 'bw_pool_b2', 'bw_pool_b2', 's', 2, 1, 1, '1', '0', '0', 3565, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95382, 'bw_pool_a2', 'bw_pool_a2', 's', 2, 1, 1, '1', '0', '0', 3564, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95383, 'bw_pool_a3', 'bw_pool_a3', 's', 1, 1, 0, '1', '0', '0', 3556, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95384, 'bw_pool_a1', 'bw_pool_a1', 's', 1, 1, 1, '1', '1', '0', 3577, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95385, 'bw_pool_b1', 'bw_pool_b1', 's', 1, 1, 1, '1', '0', '0', 3560, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95386, 'bw_fnc_crnr_p', 'bw_fnc_crnr_p', 's', 1, 2, 1, '0', '0', '0', 3576, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95387, 'bw_sboard_g', 'bw_sboard_g', 's', 2, 1, 0, '0', '0', '0', 3562, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95388, 'bw_sboard_p', 'bw_sboard_p', 's', 2, 1, 0, '0', '0', '0', 3571, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95389, 'bw_table_g', 'bw_table_g', 's', 2, 2, 1, '1', '0', '0', 3566, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95390, 'bw_table_p', 'bw_table_p', 's', 2, 1, 0, '1', '0', '0', 3578, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95391, 'bw_van_p', 'bw_van_p', 's', 2, 2, 1, '0', '1', '0', 3570, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95392, 'bw_van_g', 'bw_van_g', 's', 2, 2, 1, '0', '1', '0', 3574, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(95393, 'bw_sofa_g', 'bw_sofa_g', 's', 2, 1, 1, '1', '1', '0', 3575, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95394, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1, '1', '1', '0', 3561, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95395, 'bw_fnc_g name', 'bw_fnc_g', 's', 2, 1, 1, '1', '0', '0', 3557, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(95397, 'bw_tele', 'bw_tele', 's', 1, 1, 3, '0', '0', '0', 3550, '1', '1', '1', '1', '1', 'teleport', 1, '0', ''),
(99000, 'qt_xm10_nest', 'qt_xm10_nest', 's', 1, 1, 1, '0', '0', '0', 3742, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99001, 'qt_xm10_icedragon', 'qt_xm10_icedragon', 's', 1, 1, 1, '0', '0', '0', 3746, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99002, 'qt_xm10_stone', 'qt_xm10_stone', 's', 2, 1, 1, '0', '0', '0', 3747, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99003, 'qt_xm10_icetiger', 'qt_xm10_icetiger', 's', 1, 1, 1, '0', '0', '0', 3728, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99004, 'qt_xm10_trex', 'qt_xm10_trex', 's', 3, 7, 1, '0', '0', '0', 3722, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99005, 'qt_xm10_palm_tree', 'qt_xm10_palm_tree', 's', 1, 1, 3, '0', '0', '0', 3720, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99006, 'qt_xm10_bench', 'qt_xm10_bench', 's', 2, 1, 1, '0', '0', '0', 3750, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99007, 'qt_xm10_icelupin', 'qt_xm10_icelupin', 's', 1, 1, 1, '0', '0', '0', 3732, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99008, 'qt_xm10_xmduck', 'qt_xm10_xmduck', 's', 1, 1, 1, '0', '0', '0', 3719, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99009, 'qt_xm10_iceduck', 'qt_xm10_iceduck', 's', 1, 1, 1, '0', '0', '0', 3727, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99010, 'qt_xm10_bauble1', 'qt_xm10_bauble1', 'i', 1, 1, 1, '0', '0', '0', 4365, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99011, 'qt_xm10_bauble2', 'qt_xm10_bauble2', 'i', 1, 1, 1, '0', '0', '0', 4361, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99012, 'qt_xm10_bauble3', 'qt_xm10_bauble3', 'i', 1, 1, 1, '0', '0', '0', 4368, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99013, 'qt_xm10_iceplasto', 'qt_xm10_iceplasto', 's', 1, 1, 1, '0', '1', '0', 3730, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99014, 'qt_xm10_ice_fish', 'qt_xm10_ice_fish', 's', 1, 2, 3, '0', '0', '0', 3748, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99015, 'qt_xm10_gnome', 'qt_xm10_gnome', 's', 1, 2, 1, '0', '0', '0', 3726, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99016, 'qt_xm10_icesilotable', 'qt_xm10_icesilotable', 's', 1, 1, 1, '0', '0', '0', 3743, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99017, 'qt_xm10_iceteddy', 'qt_xm10_iceteddy', 's', 1, 1, 1, '0', '0', '0', 3734, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99018, 'qt_xm10_elephant', 'qt_xm10_elephant', 's', 1, 1, 1, '0', '0', '0', 3724, '1', '1', '1', '1', '1', 'vendingmachine', 2, '0', ''),
(99019, 'qt_xm10_iceclubsofa', 'qt_xm10_iceclubsofa', 's', 2, 1, 1, '0', '1', '0', 3718, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99020, 'es_skating_ice', 'es_skating_ice', 's', 2, 2, 0.01, '0', '0', '1', 3736, '1', '1', '1', '1', '1', 'iceskates', 2, '0', ''),
(99021, 'es_sidewalk', 'es_sidewalk', 's', 2, 2, 0.2, '0', '0', '1', 3716, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99022, 'es_wpost', 'es_wpost', 's', 1, 1, 1, '0', '0', '0', 3725, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99023, 'es_tagging', 'es_tagging', 's', 1, 1, 3, '0', '0', '0', 3741, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99024, 'es_santa', 'es_santa', 's', 1, 1, 1, '0', '0', '0', 3740, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99025, 'es_window', 'es_window', 'i', 1, 1, 1, '0', '0', '0', 4367, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99026, 'es_bench', 'es_bench', 's', 2, 1, 1, '0', '1', '0', 3712, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99027, 'es_fnc_1', 'es_fnc_1', 's', 1, 1, 1, '0', '0', '0', 3729, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99028, 'es_fnc_2', 'es_fnc_2', 's', 1, 1, 1, '0', '0', '0', 3714, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99029, 'es_fnc_crnr', 'es_fnc_crnr', 's', 1, 1, 1, '0', '0', '0', 3721, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99030, 'es_epictree', 'es_epictree', 's', 2, 2, 4, '0', '0', '0', 3723, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99031, 'es_icestar_g', 'es_icestar_g', 's', 1, 1, 6, '0', '0', '0', 3731, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99032, 'es_icestar_r', 'es_icestar_r', 's', 1, 1, 6, '0', '0', '0', 3745, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99033, 'es_icestar_y', 'es_icestar_y', 's', 1, 1, 6, '0', '0', '0', 3749, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99034, 'es_icestar', 'es_icestar', 's', 1, 1, 6, '0', '0', '0', 3713, '1', '1', '1', '1', '1', 'default', 2, '0', '');
INSERT INTO `furniture_old` (`id`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `can_stack`, `can_sit`, `is_walkable`, `sprite_id`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `foot_figure`) VALUES
(99035, 'es_puck', 'es_puck', 's', 1, 1, 1, '0', '0', '0', 3739, '1', '1', '1', '1', '1', '', 2, '0', ''),
(99036, 'es_roaster', 'es_roaster', 's', 1, 1, 2, '0', '0', '0', 3738, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99037, 'es_lmppst', 'es_lmppst', 's', 1, 1, 4, '0', '0', '0', 3735, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99038, 'es_statue', 'es_statue', 's', 1, 1, 1, '0', '0', '0', 3717, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99080, 'es_big3', 'es_big3', 'i', 1, 1, 0.5, '1', '0', '1', 4371, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99081, 'es_big2', 'es_big2', 'i', 1, 1, 0.5, '1', '0', '1', 4372, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99082, 'Freeze Ice Block', 'es_box', 's', 1, 1, 1, '1', '0', '1', 3758, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99083, 'Freese Counter', 'es_counter', 's', 2, 1, 1, '0', '0', '0', 3764, '1', '1', '1', '1', '1', 'scoreboard', 1, '0', ''),
(99084, 'Exit Tile', 'es_exit', 's', 1, 1, 0.1, '1', '0', '1', 3759, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99085, 'Blue Freeze Gate', 'es_gate_b', 's', 1, 1, 1, '0', '0', '1', 3762, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99086, 'Green Freeze Gate', 'es_gate_g', 's', 1, 1, 0, '0', '0', '1', 3761, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99087, 'Red Freeze Gate', 'es_gate_r', 's', 1, 1, 0, '0', '0', '1', 3760, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99088, 'Yellow Freeze Gate', 'es_gate_y', 's', 1, 1, 0, '0', '0', '1', 3763, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99089, 'Yellow Freeze Scoreboard', 'es_score_y', 's', 1, 1, 0, '0', '0', '0', 3767, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99090, 'Red Freeze Scoreboard', 'es_score_r', 's', 1, 1, 0, '0', '0', '0', 3765, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99091, 'Blue Freeze Scoreboard', 'es_score_b', 's', 1, 1, 0, '0', '0', '0', 3756, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99092, 'Green Freeze Scoreboard', 'es_score_g', 's', 1, 1, 0, '0', '0', '0', 3766, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99093, 'Freeze Tile', 'es_tile', 's', 1, 1, 0, '0', '0', '1', 3757, '1', '1', '1', '1', '1', 'default', 1, '0', ''),
(99904, 'year2011_waver_b', 'year2011_waver_b', 's', 1, 1, 3, '0', '0', '0', 3781, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99905, 'year2011_waver_g', 'year2011_waver_g', 's', 1, 1, 3, '0', '0', '0', 3780, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99906, 'year2011_waver_r', 'year2011_waver_r', 's', 1, 1, 3, '0', '0', '0', 3777, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99907, 'year2011_waver_y', 'year2011_waver_y', 's', 1, 1, 3, '0', '0', '0', 3768, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(99908, 'prizetrophy_2011_y', 'prizetrophy_2011_y', 's', 1, 1, 3, '0', '0', '0', 3771, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99909, 'prizetrophy_2011_b', 'prizetrophy_2011_b', 's', 1, 1, 3, '0', '0', '0', 3773, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99910, 'prizetrophy_2011_r', 'prizetrophy_2011_r', 's', 1, 1, 3, '0', '0', '0', 3770, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99911, 'prizetrophy_2011_p', 'prizetrophy_2011_p', 's', 1, 1, 3, '0', '0', '0', 3775, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99912, 'prizetrophy_2011_g', 'prizetrophy_2011_g', 's', 1, 1, 3, '0', '0', '0', 3778, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99913, 'prizetrophy_2011_w', 'prizetrophy_2011_w', 's', 1, 1, 3, '0', '0', '0', 3769, '1', '1', '1', '1', '1', 'trophy', 2, '0', ''),
(99914, 'year2011', 'year2011', 'i', 1, 1, 1, '0', '0', '0', 4373, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568401, 'exe_copier', 'exe_copier', 's', 1, 1, 1, '0', '0', '0', 3704, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568402, 'exe_glassdvdr', 'exe_glassdvdr', 's', 1, 1, 1, '0', '0', '0', 3706, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568403, 'exe_wrkdesk', 'exe_wrkdesk', 's', 1, 1, 1, '0', '0', '0', 3705, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568404, 'exe_seccam', 'exe_seccam', 's', 1, 1, 1, '0', '0', '1', 3707, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568405, 'exe_sensor', 'exe_sensor', 'i', 1, 1, 1, '0', '0', '0', 4356, '1', '1', '1', '1', '1', 'default', 2, '0', ''),
(3568406, 'wallpaper_single_101', 'wallpaper_single_101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568407, 'wallpaper_single_102', 'wallpaper_single_102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568408, 'wallpaper_single_103', 'wallpaper_single_103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568409, 'wallpaper_single_104', 'wallpaper_single_104', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568410, 'wallpaper_single_105', 'wallpaper_single_105', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568411, 'wallpaper_single_106', 'wallpaper_single_106', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568412, 'a0 pet8', 'a0 pet8', 's', 1, 1, 1, '1', '0', '0', 6489, '1', '1', '1', '1', '1', 'pet8', 1, '0', ''),
(3568413, 'a0 pet11', 'a0 pet11', 's', 1, 1, 1, '1', '0', '0', 6490, '1', '1', '1', '1', '1', 'pet11', 1, '0', ''),
(3568414, 'wallpaper_single_109', 'wallpaper_single_109', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568415, 'wallpaper_single_110', 'wallpaper_single_110', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568416, 'wallpaper_single_111', 'wallpaper_single_111', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568417, 'wallpaper_single_112', 'wallpaper_single_112', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568418, 'wallpaper_single_113', 'wallpaper_single_113', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568419, 'wallpaper_single_114', 'wallpaper_single_114', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568420, 'wallpaper_single_115', 'wallpaper_single_115', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568421, 'wallpaper_single_201', 'wallpaper_single_201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568422, 'a0 pet10', 'a0 pet10', 's', 0, 0, 0, '0', '0', '0', 1532, '1', '1', '1', '1', '1', 'pet10', 1, '0', ''),
(3568423, 'wallpaper_single_203', 'wallpaper_single_203', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568424, 'wallpaper_single_204', 'wallpaper_single_204', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568425, 'wallpaper_single_205', 'wallpaper_single_205', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568426, 'wallpaper_single_206', 'wallpaper_single_206', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568427, 'wallpaper_single_207', 'wallpaper_single_207', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568428, 'wallpaper_single_208', 'wallpaper_single_208', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568429, 'wallpaper_single_209', 'wallpaper_single_209', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568430, 'wallpaper_single_210', 'wallpaper_single_210', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568431, 'wallpaper_single_211', 'wallpaper_single_211', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568432, 'wallpaper_single_212', 'wallpaper_single_212', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568433, 'wallpaper_single_213', 'wallpaper_single_213', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568434, 'wallpaper_single_214', 'wallpaper_single_214', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568435, 'wallpaper_single_215', 'wallpaper_single_215', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568436, 'wallpaper_single_216', 'wallpaper_single_216', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568437, 'wallpaper_single_217', 'wallpaper_single_217', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568438, 'wallpaper_single_218', 'wallpaper_single_218', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568439, 'wallpaper_single_301', 'wallpaper_single_301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568440, 'wallpaper_single_302', 'wallpaper_single_302', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568441, 'wallpaper_single_303', 'wallpaper_single_303', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568442, 'wallpaper_single_304', 'wallpaper_single_304', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568443, 'wallpaper_single_305', 'wallpaper_single_305', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568444, 'wallpaper_single_306', 'wallpaper_single_306', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568445, 'wallpaper_single_307', 'wallpaper_single_307', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568446, 'wallpaper_single_401', 'wallpaper_single_401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568447, 'wallpaper_single_402', 'wallpaper_single_402', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568448, 'wallpaper_single_403', 'wallpaper_single_403', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568449, 'wallpaper_single_404', 'wallpaper_single_404', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568450, 'wallpaper_single_405', 'wallpaper_single_405', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568451, 'wallpaper_single_406', 'wallpaper_single_406', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568452, 'wallpaper_single_407', 'wallpaper_single_407', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568453, 'wallpaper_single_408', 'wallpaper_single_408', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568454, 'wallpaper_single_501', 'wallpaper_single_501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568455, 'wallpaper_single_502', 'wallpaper_single_502', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568456, 'wallpaper_single_503', 'wallpaper_single_503', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568457, 'wallpaper_single_504', 'wallpaper_single_504', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568458, 'wallpaper_single_505', 'wallpaper_single_505', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568459, 'wallpaper_single_506', 'wallpaper_single_506', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568460, 'wallpaper_single_507', 'wallpaper_single_507', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568461, 'wallpaper_single_508', 'wallpaper_single_508', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568462, 'wallpaper_single_601', 'wallpaper_single_601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568463, 'wallpaper_single_602', 'wallpaper_single_602', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568464, 'wallpaper_single_603', 'wallpaper_single_603', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568465, 'wallpaper_single_604', 'wallpaper_single_604', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568466, 'wallpaper_single_605', 'wallpaper_single_605', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568467, 'wallpaper_single_606', 'wallpaper_single_606', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568468, 'wallpaper_single_607', 'wallpaper_single_607', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568469, 'wallpaper_single_608', 'wallpaper_single_608', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568470, 'wallpaper_single_609', 'wallpaper_single_609', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568471, 'wallpaper_single_610', 'wallpaper_single_610', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568472, 'wallpaper_single_701', 'wallpaper_single_701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568473, 'wallpaper_single_702', 'wallpaper_single_702', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568474, 'wallpaper_single_703', 'wallpaper_single_703', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568475, 'wallpaper_single_704', 'wallpaper_single_704', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568476, 'wallpaper_single_705', 'wallpaper_single_705', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568477, 'wallpaper_single_706', 'wallpaper_single_706', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568478, 'wallpaper_single_707', 'wallpaper_single_707', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568479, 'wallpaper_single_708', 'wallpaper_single_708', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568480, 'wallpaper_single_709', 'wallpaper_single_709', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568481, 'wallpaper_single_710', 'wallpaper_single_710', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568482, 'wallpaper_single_801', 'wallpaper_single_801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568483, 'wallpaper_single_802', 'wallpaper_single_802', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568484, 'wallpaper_single_803', 'wallpaper_single_803', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568485, 'wallpaper_single_804', 'wallpaper_single_804', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568486, 'wallpaper_single_805', 'wallpaper_single_805', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568487, 'wallpaper_single_806', 'wallpaper_single_806', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568488, 'wallpaper_single_807', 'wallpaper_single_807', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568489, 'wallpaper_single_808', 'wallpaper_single_808', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568490, 'wallpaper_single_809', 'wallpaper_single_809', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568491, 'wallpaper_single_810', 'wallpaper_single_810', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568492, 'wallpaper_single_901', 'wallpaper_single_901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568493, 'wallpaper_single_902', 'wallpaper_single_902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568494, 'wallpaper_single_903', 'wallpaper_single_903', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568495, 'wallpaper_single_904', 'wallpaper_single_904', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568496, 'wallpaper_single_905', 'wallpaper_single_905', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568497, 'wallpaper_single_906', 'wallpaper_single_906', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568498, 'wallpaper_single_907', 'wallpaper_single_907', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568499, 'wallpaper_single_908', 'wallpaper_single_908', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568500, 'wallpaper_single_1001', 'wallpaper_single_1001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568501, 'wallpaper_single_1002', 'wallpaper_single_1002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568502, 'wallpaper_single_1003', 'wallpaper_single_1003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568503, 'wallpaper_single_1004', 'wallpaper_single_1004', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568504, 'wallpaper_single_1005', 'wallpaper_single_1005', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568505, 'wallpaper_single_1006', 'wallpaper_single_1006', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568506, 'wallpaper_single_1007', 'wallpaper_single_1007', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568507, 'wallpaper_single_1101', 'wallpaper_single_1101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568508, 'wallpaper_single_1201', 'wallpaper_single_1201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568509, 'wallpaper_single_1301', 'wallpaper_single_1301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568510, 'wallpaper_single_1401', 'wallpaper_single_1401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568511, 'wallpaper_single_1501', 'wallpaper_single_1501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568512, 'wallpaper_single_1601', 'wallpaper_single_1601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568513, 'wallpaper_single_1701', 'wallpaper_single_1701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568514, 'wallpaper_single_1801', 'wallpaper_single_1801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568515, 'wallpaper_single_1901', 'wallpaper_single_1901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568516, 'wallpaper_single_1902', 'wallpaper_single_1902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568517, 'wallpaper_single_2001', 'wallpaper_single_2001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568518, 'wallpaper_single_2002', 'wallpaper_single_2002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568519, 'wallpaper_single_2003', 'wallpaper_single_2003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568520, 'wallpaper_single_2101', 'wallpaper_single_2101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568521, 'wallpaper_single_2102', 'wallpaper_single_2102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568522, 'wallpaper_single_2103', 'wallpaper_single_2103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568523, 'wallpaper_single_2201', 'wallpaper_single_2201', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568524, 'wallpaper_single_2202', 'wallpaper_single_2202', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568525, 'wallpaper_single_2203', 'wallpaper_single_2203', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568526, 'wallpaper_single_2204', 'wallpaper_single_2204', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568527, 'wallpaper_single_2205', 'wallpaper_single_2205', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568528, 'wallpaper_single_2206', 'wallpaper_single_2206', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568529, 'wallpaper_single_2301', 'wallpaper_single_2301', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568530, 'wallpaper_single_2302', 'wallpaper_single_2302', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568531, 'wallpaper_single_2303', 'wallpaper_single_2303', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568532, 'wallpaper_single_2304', 'wallpaper_single_2304', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568533, 'wallpaper_single_2401', 'wallpaper_single_2401', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568534, 'wallpaper_single_2402', 'wallpaper_single_2402', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568535, 'wallpaper_single_2403', 'wallpaper_single_2403', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568536, 'wallpaper_single_2501', 'wallpaper_single_2501', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568537, 'wallpaper_single_2502', 'wallpaper_single_2502', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568538, 'wallpaper_single_2503', 'wallpaper_single_2503', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568539, 'wallpaper_single_2504', 'wallpaper_single_2504', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568540, 'wallpaper_single_2601', 'wallpaper_single_2601', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568541, 'wallpaper_single_2602', 'wallpaper_single_2602', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568542, 'wallpaper_single_2603', 'wallpaper_single_2603', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568543, 'wallpaper_single_2604', 'wallpaper_single_2604', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568544, 'wallpaper_single_2701', 'wallpaper_single_2701', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568545, 'wallpaper_single_2702', 'wallpaper_single_2702', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568546, 'wallpaper_single_2703', 'wallpaper_single_2703', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568547, 'wallpaper_single_2704', 'wallpaper_single_2704', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568548, 'wallpaper_single_2801', 'wallpaper_single_2801', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568549, 'wallpaper_single_2802', 'wallpaper_single_2802', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568550, 'wallpaper_single_2803', 'wallpaper_single_2803', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568551, 'wallpaper_single_2804', 'wallpaper_single_2804', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568552, 'wallpaper_single_2901', 'wallpaper_single_2901', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568553, 'wallpaper_single_2902', 'wallpaper_single_2902', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568554, 'wallpaper_single_2903', 'wallpaper_single_2903', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568555, 'wallpaper_single_2904', 'wallpaper_single_2904', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568556, 'wallpaper_single_3001', 'wallpaper_single_3001', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568557, 'wallpaper_single_3002', 'wallpaper_single_3002', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568558, 'wallpaper_single_3003', 'wallpaper_single_3003', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568559, 'wallpaper_single_3004', 'wallpaper_single_3004', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568560, 'wallpaper_single_3101', 'wallpaper_single_3101', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568561, 'wallpaper_single_3102', 'wallpaper_single_3102', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568562, 'wallpaper_single_3103', 'wallpaper_single_3103', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568563, 'wallpaper_single_3104', 'wallpaper_single_3104', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568564, 'wallpaper_single_3105', 'wallpaper_single_3105', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568565, 'wallpaper_single_3106', 'wallpaper_single_3106', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568566, 'floor_single_101', 'floor_single_101', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568567, 'floor_single_102', 'floor_single_102', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568568, 'floor_single_103', 'floor_single_103', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568569, 'floor_single_104', 'floor_single_104', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568570, 'floor_single_105', 'floor_single_105', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568571, 'floor_single_106', 'floor_single_106', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568572, 'floor_single_107', 'floor_single_107', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568573, 'floor_single_108', 'floor_single_108', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568574, 'floor_single_109', 'floor_single_109', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568575, 'floor_single_110', 'floor_single_110', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568576, 'floor_single_111', 'floor_single_111', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568577, 'floor_single_201', 'floor_single_201', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568578, 'floor_single_202', 'floor_single_202', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568579, 'floor_single_203', 'floor_single_203', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568580, 'floor_single_204', 'floor_single_204', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568581, 'floor_single_205', 'floor_single_205', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568582, 'floor_single_206', 'floor_single_206', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568583, 'floor_single_207', 'floor_single_207', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568584, 'floor_single_208', 'floor_single_208', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568585, 'floor_single_209', 'floor_single_209', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568586, 'floor_single_210', 'floor_single_210', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568587, 'floor_single_211', 'floor_single_211', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568588, 'floor_single_212', 'floor_single_212', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568589, 'floor_single_301', 'floor_single_301', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568590, 'floor_single_302', 'floor_single_302', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568591, 'floor_single_303', 'floor_single_303', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568592, 'floor_single_304', 'floor_single_304', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568593, 'floor_single_305', 'floor_single_305', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568594, 'floor_single_306', 'floor_single_306', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568595, 'floor_single_307', 'floor_single_307', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568596, 'floor_single_401', 'floor_single_401', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568597, 'floor_single_402', 'floor_single_402', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568598, 'floor_single_403', 'floor_single_403', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568599, 'floor_single_404', 'floor_single_404', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568600, 'floor_single_405', 'floor_single_405', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568601, 'floor_single_406', 'floor_single_406', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568602, 'floor_single_407', 'floor_single_407', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568603, 'floor_single_408', 'floor_single_408', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568604, 'floor_single_409', 'floor_single_409', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568605, 'floor_single_501', 'floor_single_501', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568606, 'floor_single_502', 'floor_single_502', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568607, 'floor_single_503', 'floor_single_503', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568608, 'floor_single_504', 'floor_single_504', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568609, 'floor_single_505', 'floor_single_505', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568610, 'floor_single_506', 'floor_single_506', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568611, 'floor_single_507', 'floor_single_507', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568612, 'floor_single_601', 'floor_single_601', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568613, 'floor_single_602', 'floor_single_602', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568614, 'floor_single_603', 'floor_single_603', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568615, 'floor_single_604', 'floor_single_604', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568616, 'floor_single_605', 'floor_single_605', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568617, 'floor_single_606', 'floor_single_606', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568618, 'floor_single_607', 'floor_single_607', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568619, 'floor_single_608', 'floor_single_608', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568620, 'floor_single_609', 'floor_single_609', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568621, 'floor_single_610', 'floor_single_610', 'i', 1, 1, 1, '0', '0', '0', 2001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568622, 'landscape_single_1.1', 'landscape_single_1.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568623, 'landscape_single_1.2', 'landscape_single_1.2', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568624, 'landscape_single_1.3', 'landscape_single_1.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568625, 'landscape_single_1.4', 'landscape_single_1.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568626, 'landscape_single_1.5', 'landscape_single_1.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568627, 'landscape_single_1.6', 'landscape_single_1.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568628, 'landscape_single_1.7', 'landscape_single_1.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568629, 'landscape_single_1.8', 'landscape_single_1.8', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568630, 'landscape_single_1.9', 'landscape_single_1.9', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568631, 'landscape_single_1.10', 'landscape_single_1.10', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568632, 'landscape_single_1.11', 'landscape_single_1.11', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568633, 'landscape_single_2.1', 'landscape_single_2.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568634, 'landscape_single_2.3', 'landscape_single_2.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568635, 'landscape_single_2.4', 'landscape_single_2.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568636, 'landscape_single_2.5', 'landscape_single_2.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568637, 'landscape_single_2.6', 'landscape_single_2.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568638, 'landscape_single_2.7', 'landscape_single_2.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568639, 'landscape_single_3.1', 'landscape_single_3.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568640, 'landscape_single_3.3', 'landscape_single_3.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568641, 'landscape_single_3.4', 'landscape_single_3.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568642, 'landscape_single_3.5', 'landscape_single_3.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568643, 'landscape_single_3.6', 'landscape_single_3.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568644, 'landscape_single_3.7', 'landscape_single_3.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568645, 'landscape_single_4.1', 'landscape_single_4.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568646, 'landscape_single_4.3', 'landscape_single_4.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568647, 'landscape_single_4.4', 'landscape_single_4.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568648, 'landscape_single_4.5', 'landscape_single_4.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568649, 'landscape_single_4.6', 'landscape_single_4.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568650, 'landscape_single_4.7', 'landscape_single_4.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568651, 'landscape_single_5.1', 'landscape_single_5.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568652, 'landscape_single_5.3', 'landscape_single_5.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568653, 'landscape_single_5.4', 'landscape_single_5.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568654, 'landscape_single_5.5', 'landscape_single_5.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568655, 'landscape_single_5.6', 'landscape_single_5.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568656, 'landscape_single_5.7', 'landscape_single_5.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568657, 'landscape_single_6.1', 'landscape_single_6.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568658, 'landscape_single_6.3', 'landscape_single_6.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568659, 'landscape_single_6.4', 'landscape_single_6.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568660, 'landscape_single_6.5', 'landscape_single_6.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568661, 'landscape_single_6.6', 'landscape_single_6.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568662, 'landscape_single_6.7', 'landscape_single_6.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568663, 'landscape_single_7.1', 'landscape_single_7.1', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568664, 'landscape_single_7.3', 'landscape_single_7.3', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568665, 'landscape_single_7.4', 'landscape_single_7.4', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568666, 'landscape_single_7.5', 'landscape_single_7.5', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568667, 'landscape_single_7.6', 'landscape_single_7.6', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568668, 'landscape_single_7.7', 'landscape_single_7.7', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(3568669, 'landscape_single_7.12', 'landscape_single_7.12', 'i', 1, 1, 1, '0', '0', '0', 4055, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568412, 'wallpaper_single_107', 'wallpaper_single_107', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568413, 'wallpaper_single_108', 'wallpaper_single_108', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', ''),
(4568422, 'wallpaper_single_202', 'wallpaper_single_202', 'i', 1, 1, 1, '0', '0', '0', 3001, '0', '0', '0', '0', '0', 'default', 1, '0', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `furniture_translated`
--

CREATE TABLE IF NOT EXISTS `furniture_translated` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `public_name` text NOT NULL COMMENT 'temp only',
  `item_name` varchar(100) NOT NULL,
  `type` enum('s','i','e','h') NOT NULL DEFAULT 's',
  `width` int(11) NOT NULL DEFAULT '1',
  `length` int(11) NOT NULL DEFAULT '1',
  `stack_height` double NOT NULL DEFAULT '1',
  `can_stack` enum('0','1') NOT NULL DEFAULT '1',
  `can_sit` enum('0','1') NOT NULL DEFAULT '0',
  `is_walkable` enum('0','1') NOT NULL DEFAULT '0',
  `sprite_id` int(11) NOT NULL,
  `allow_recycle` enum('0','1') NOT NULL DEFAULT '1',
  `allow_trade` enum('0','1') NOT NULL DEFAULT '1',
  `allow_marketplace_sell` enum('0','1') NOT NULL DEFAULT '1',
  `allow_gift` enum('0','1') NOT NULL DEFAULT '1',
  `allow_inventory_stack` enum('0','1') NOT NULL DEFAULT '1',
  `interaction_type` enum('default','gate','postit','roomeffect','dimmer','trophy','bed','scoreboard','vendingmachine','alert','onewaygate','loveshuffler','habbowheel','dice','bottle','teleport','rentals','pet','pool','roller','fbgate','lowpool','haloweenpool','normalskates','iceskates','pet0','pet1','pet2','pet3','pet4','pet5','pet6','pet7','pet8','pet9','pet10','pet11','pet12','football','footballgoalred','footballgoalblue','footballgoalyellow','footballgoalgreen','footballcountered','footballcountergreen','footballcounterblue','footballcounteryellow','banzaigateblue','banzaigatered','banzaigateyellow','banzaigategreen','banzaifloor','banzaiscoreblue','banzaiscorered','banzaiscoreyellow','banzaiscoregreen','banzaicounter','banzaitele','banzaipuck','banzaipyramid','freezetimer','freezeexit','freezeredcounter','freezebluecounter','freezeyellowcounter','freezegreencounter','freezeyellowgate','freezeredgate','freezegreengate','freezebluegate','freezetileblock','freezetile','musicdisc','triggertimer','triggerroomenter','triggergameend','triggergamestart','triggerrepeater','triggeronusersay','triggerscoreachieved','triggerstatechanged','triggerwalkonfurni','triggerwalkofffurni','actiongivescore','actionposreset','actionmoverotate','actionresettimer','actionshowmessage','actionteleportto','actiontogglestate','conditionfurnishaveusers','conditionstatepos','conditiontimelessthan','conditiontimemorethan','conditiontriggeronfurni','arrowplate','preassureplate','ringplate','colortile','colorwheel','floorswitch1','floorswitch2','firegate','glassfoor','specialrandom','specialunseen','wire','wireCenter','wireCorner','wireSplitter','wireStandard','pet13','pet14','pet15') NOT NULL DEFAULT 'default',
  `interaction_modes_count` int(11) NOT NULL DEFAULT '1',
  `vending_ids` varchar(100) NOT NULL DEFAULT '0',
  `foot_figure` char(2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `fuserights`
--

CREATE TABLE IF NOT EXISTS `fuserights` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rank` int(11) unsigned NOT NULL,
  `fuse` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `rank` (`rank`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=26 ;

--
-- Volcado de datos para la tabla `fuserights`
--

INSERT INTO `fuserights` (`id`, `rank`, `fuse`) VALUES
(1, 1, 'fuse_room_queue_default'),
(2, 1, 'fuse_buy_credits'),
(3, 1, 'fuse_login'),
(4, 1, 'default'),
(5, 1, 'fuse_trade'),
(6, 3, 'fuse_mod'),
(7, 6, 'fuse_admin'),
(8, 7, 'fuse_sysadmin'),
(9, 4, 'fuse_enter_any_room'),
(10, 1, 'fuse_club_dances'),
(11, 3, 'fuse_housekeeping_login'),
(12, 6, 'fuse_chatlogs'),
(13, 3, 'fuse_alert'),
(14, 4, 'fuse_kick'),
(15, 4, 'fuse_ban'),
(16, 7, 'fuse_housekeeping_catalog'),
(17, 4, 'fuse_housekeeping_moderation'),
(18, 6, 'fuse_housekeeping_sitemanagement'),
(19, 4, 'fuse_any_room_rights'),
(20, 6, 'fuse_ignore_maintenance'),
(21, 4, 'fuse_mute'),
(22, 4, 'fuse_roomkick'),
(23, 4, 'fuse_roomalert'),
(24, 3, 'fuse_enter_full_rooms'),
(25, 1, 'fuse_hide_room_walls');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `fuserights_subs`
--

CREATE TABLE IF NOT EXISTS `fuserights_subs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sub` varchar(120) NOT NULL,
  `fuse` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `sub` (`sub`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14 ;

--
-- Volcado de datos para la tabla `fuserights_subs`
--

INSERT INTO `fuserights_subs` (`id`, `sub`, `fuse`) VALUES
(1, 'habbo_club', 'fuse_use_club_dance'),
(2, 'habbo_club', 'fuse_extended_buddylist'),
(3, 'habbo_club', 'fuse_furni_chooser'),
(4, 'habbo_club', 'fuse_priority_access'),
(5, 'habbo_club', 'fuse_use_club_catalog'),
(6, 'habbo_club', 'fuse_habbo_chooser'),
(7, 'habbo_club', 'fuse_use_club_outfits'),
(8, 'habbo_club', 'fuse_room_queue_club'),
(9, 'habbo_club', 'fuse_use_special_room_layouts'),
(10, 'habbo_club', 'fuse_use_club_badge'),
(11, 'habbo_club', 'fuse_use_wardrobe'),
(12, 'habbo_club', 'fuse_use_vip_outfits'),
(13, 'habbo_club', 'fuse_use_vip_room_layouts');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `groups_details`
--

CREATE TABLE IF NOT EXISTS `groups_details` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) COLLATE latin1_general_ci NOT NULL,
  `description` varchar(200) COLLATE latin1_general_ci NOT NULL,
  `ownerid` int(10) NOT NULL,
  `roomid` int(10) NOT NULL,
  `created` varchar(50) COLLATE latin1_general_ci NOT NULL,
  `badge` text COLLATE latin1_general_ci NOT NULL,
  `type` int(1) NOT NULL DEFAULT '0',
  `recommended` int(1) NOT NULL DEFAULT '0',
  `views` int(15) NOT NULL,
  `pane` smallint(1) NOT NULL DEFAULT '0',
  `topics` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `groups_memberships`
--

CREATE TABLE IF NOT EXISTS `groups_memberships` (
  `userid` int(10) NOT NULL,
  `groupid` int(10) NOT NULL,
  `member_rank` enum('3','2','1') COLLATE latin1_general_ci NOT NULL DEFAULT '3',
  `is_current` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '0',
  `is_pending` enum('0','1') COLLATE latin1_general_ci NOT NULL DEFAULT '0',
  KEY `userid` (`userid`),
  KEY `groupid` (`groupid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `help_subjects`
--

CREATE TABLE IF NOT EXISTS `help_subjects` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `caption` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;

--
-- Volcado de datos para la tabla `help_subjects`
--

INSERT INTO `help_subjects` (`id`, `caption`) VALUES
(1, 'Nablo- General'),
(2, 'Credits, Pixels and Achievements'),
(3, 'Catalogue and Furniture'),
(4, 'Rooms'),
(5, 'Infobus');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `help_topics`
--

CREATE TABLE IF NOT EXISTS `help_topics` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `subject` int(11) unsigned NOT NULL DEFAULT '1',
  `title` varchar(50) NOT NULL,
  `body` text NOT NULL,
  `known_issue` enum('0','1','2') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14 ;

--
-- Volcado de datos para la tabla `help_topics`
--

INSERT INTO `help_topics` (`id`, `subject`, `title`, `body`, `known_issue`) VALUES
(1, 1, 'What is Nablo?', 'Habbo.VG is a Retro which was created by Thierry, Relic and T09. This is a kind of server which does not STEAL your password.. they will be encrypted by a HASH MD5.', '2'),
(2, 1, 'Missing/broken features', 'Any kinda missing or broken features please contact T09 to have this fix.. but then if it''s really urgent, please try to have a friend that was close contact with us!', '2'),
(3, 2, 'How do I get Credits?', 'You can receive credits in a multitude of ways:\r\n\r\n* Every 3 hours you''ll get credits\r\n* Events hosted by Seniors Admins\r\n* Games hosted by other players of VG\r\n* Promotions by Hotel Management', '1'),
(4, 2, 'How do I get Pixels?', 'You automatically receive pixels every now and then. You can exchange these for effects, special pixel offers, and credits. You also receive pixels by completing achievements.', '1'),
(5, 2, 'What are achievements and how do I get them?', 'Earning Achievements will be given out by Hotel Management when you are the winner or most respected player of Habbo.VG', '1'),
(6, 2, 'Are all achievements available on Habbo?', 'We have not yet added all achievements. The ones that are available can be seen under the ''Achievements'' tab in your inventory.', '0'),
(7, 1, 'Staff on Nablo', 'Habbo.VG Staffs are picked by Various and Hex.\r\nThe Staffs will be maintained by the Senior Administrator & Administrators keeping track of the Moderators what they do like abuses.\r\n\r\nAny Staff that are caught abusing please contact Various by E-MAIL.\r\nVarious''s Support: ryan@obbahhost.com', '2'),
(8, 3, 'I have a suggestion for new furniture!', 'We do NOT accept any requests for custom furniture or anything along those lines, we only use furniture that is available on the official hotels. If you have suggestions for new furniture, try contacting Habbo. They might like your idea!', '0'),
(9, 3, 'Why is this piece of furniture missing?', 'We may have not added all furniture yet or we may have purposely decided not to put it up for sale. Please do not contact us about this - we are constantly adding new furniture.', '1'),
(10, 5, 'Where is the Infobus?', 'The infobus is currently available in the navigator, although bugged.', '1'),
(11, 3, 'Stacking-related issues', 'The stacking system is a sensitive and complicated mechanism that still requires some work. There is generally no need to report any problems regarding stacking to us, as we are aware of problems relating to it.\r\n\r\nIf there are problems with stacking relating to a specific piece of furniture, then please submit a suggestion or bug report on our UserVoice forum.', '1'),
(12, 1, 'Support Tickets & User Reports', 'We would just like to urge that the ticket system you will find in this help tool and when reporting users is only intended for SERIOUS requests. Yes, it works, and there is no need to test it. Any requests that are offensive, spam, or in anyway inappropriate may result in a ban.\r\n\r\nAlso, when submitting a help request, please keep in mind that it must be in English.', '2');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `hk_board`
--

CREATE TABLE IF NOT EXISTS `hk_board` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `content` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Volcado de datos para la tabla `hk_board`
--

INSERT INTO `hk_board` (`id`, `content`) VALUES
(1, '[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD\r\n[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD\r\n[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD\r\n[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD\r\n[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD\r\n[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD\r\n[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD\r\n[Hotel Manager DonG: USE http://habbo.vg/manage/index.php?_cmd=forum] << USE THIS INSTEAD');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `homes`
--

CREATE TABLE IF NOT EXISTS `homes` (
  `home_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `link_type` enum('user','group') NOT NULL DEFAULT 'user',
  `link_id` int(10) unsigned NOT NULL,
  `allow_display` enum('0','1') NOT NULL DEFAULT '1',
  `bgimage` varchar(120) NOT NULL DEFAULT 'b_bg_colour_01',
  PRIMARY KEY (`home_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `homes_catalog`
--

CREATE TABLE IF NOT EXISTS `homes_catalog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL,
  `type` varchar(1) NOT NULL,
  `data` text NOT NULL,
  `price` int(11) NOT NULL,
  `amount` int(11) NOT NULL DEFAULT '1',
  `category` int(11) NOT NULL,
  `sorted` enum('1','0') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1294 ;

--
-- Volcado de datos para la tabla `homes_catalog`
--

INSERT INTO `homes_catalog` (`id`, `name`, `type`, `data`, `price`, `amount`, `category`, `sorted`) VALUES
(1, 'sticker_arrow_down', '1', 'sticker_arrow_down', 3, 1, 37, '1'),
(2, 'sticker_arrow_left', '1', 'sticker_arrow_left', 3, 1, 37, '1'),
(3, 'sticker_arrow_up', '1', 'sticker_arrow_up', 3, 1, 37, '1'),
(4, 'sticker_arrow_right', '1', 'sticker_arrow_right', 3, 1, 37, '1'),
(5, 'finger_push', '1', 'finger_push', 3, 1, 37, '1'),
(6, 'sticker_pointing_hand_1', '1', 'sticker_pointing_hand_1', 3, 1, 37, '1'),
(7, 'sticker_pointing_hand_2', '1', 'sticker_pointing_hand_2', 3, 1, 37, '1'),
(8, 'sticker_pointing_hand_3', '1', 'sticker_pointing_hand_3', 3, 1, 37, '1'),
(9, 'sticker_pointing_hand_4', '1', 'sticker_pointing_hand_4', 3, 1, 37, '1'),
(10, 'gorillahand1', '1', 'gorillahand1', 3, 1, 32, '1'),
(11, 'gorillahand2', '1', 'gorillahand2', 3, 1, 32, '1'),
(12, 'lightbulb', '1', 'lightbulb', 3, 1, 32, '1'),
(13, 'redlamp', '1', 'redlamp', 3, 1, 32, '1'),
(14, 'blingblingstars', '1', 'blingblingstars', 3, 1, 25, '1'),
(15, 'blinghearts', '1', 'blinghearts', 3, 1, 25, '1'),
(16, 'sticker_heartbeat', '1', 'sticker_heartbeat', 3, 1, 29, '1'),
(17, 'sticker_bobbaskull', '1', 'sticker_bobbaskull', 3, 1, 32, '1'),
(18, 'chain_vertical', '1', 'chain_vertical', 3, 1, 22, '1'),
(19, 'chain_horizontal', '1', 'chain_horizontal', 3, 1, 22, '1'),
(20, 'nail2', '1', 'nail2', 3, 1, 32, '1'),
(21, 'nail3', '1', 'nail3', 3, 1, 32, '1'),
(22, 'i_love_bobba', '1', 'i_love_bobba', 3, 1, 32, '1'),
(23, 'chewed_bubblegum', '1', 'chewed_bubblegum', 3, 1, 32, '1'),
(24, 'bullet1', '1', 'bullet1', 3, 1, 32, '1'),
(25, 'spill1', '1', 'spill1', 3, 1, 32, '1'),
(26, 'spill2', '1', 'spill2', 3, 1, 32, '1'),
(27, 'spill3', '1', 'spill3', 3, 1, 32, '1'),
(28, 'sticker_coffee_stain', '1', 'sticker_coffee_stain', 3, 1, 32, '1'),
(29, 'sticker_hole', '1', 'sticker_hole', 3, 1, 32, '1'),
(30, 'sticker_flames', '1', 'sticker_flames', 3, 1, 25, '1'),
(31, 'paper_clip_1', '1', 'paper_clip_1', 3, 1, 32, '1'),
(32, 'paper_clip_2', '1', 'paper_clip_2', 3, 1, 32, '1'),
(33, 'paper_clip_3', '1', 'paper_clip_3', 3, 1, 32, '1'),
(34, 'needle_1', '1', 'needle_1', 3, 1, 32, '1'),
(35, 'needle_2', '1', 'needle_2', 3, 1, 32, '1'),
(36, 'needle_3', '1', 'needle_3', 3, 1, 32, '1'),
(37, 'needle_4', '1', 'needle_4', 3, 1, 32, '1'),
(38, 'needle_5', '1', 'needle_5', 3, 1, 32, '1'),
(39, 'highlighter_1', '1', 'highlighter_1', 3, 1, 32, '1'),
(40, 'highlighter_mark5', '1', 'highlighter_mark5', 3, 1, 32, '1'),
(41, 'highlighter_mark6', '1', 'highlighter_mark6', 3, 1, 32, '1'),
(42, 'highlighter_mark4b', '1', 'highlighter_mark4b', 3, 1, 32, '1'),
(43, 'highlighter_2', '1', 'highlighter_2', 3, 1, 32, '1'),
(44, 'highlighter_mark1', '1', 'highlighter_mark1', 3, 1, 32, '1'),
(45, 'highlighter_mark2', '1', 'highlighter_mark2', 3, 1, 32, '1'),
(46, 'highlighter_mark3', '1', 'highlighter_mark3', 3, 1, 32, '1'),
(47, 'ruler_horizontal', '1', 'ruler_horizontal', 3, 1, 22, '1'),
(48, 'ruler_vertical', '1', 'ruler_vertical', 3, 1, 22, '1'),
(49, 'plaster', '1', 'plaster', 3, 1, 32, '1'),
(50, 'plaster2', '1', 'plaster2', 3, 1, 32, '1'),
(51, 'sticker_cactus_anim', '1', 'sticker_cactus_anim', 3, 1, 32, '1'),
(52, 'sticker_spaceduck', '1', 'sticker_spaceduck', 3, 1, 24, '1'),
(53, 'sticker_moonpig', '1', 'sticker_moonpig', 3, 1, 32, '1'),
(54, 'sticker_catinabox', '1', 'sticker_catinabox', 3, 1, 32, '1'),
(55, 'sticker_croco', '1', 'sticker_croco', 3, 1, 24, '1'),
(56, 'bear', '1', 'bear', 3, 1, 32, '1'),
(57, 'swimming_fish', '1', 'swimming_fish', 3, 1, 32, '1'),
(58, 'fish', '1', 'fish', 3, 1, 32, '1'),
(59, 'parrot', '1', 'parrot', 3, 1, 32, '1'),
(60, 'battle1', '1', 'battle1', 3, 1, 30, '1'),
(61, 'battle3', '1', 'battle3', 3, 1, 32, '1'),
(62, 'sticker_sleeping_habbo', '1', 'sticker_sleeping_habbo', 3, 1, 32, '1'),
(63, 'sticker_clown_anim', '1', 'sticker_clown_anim', 3, 1, 24, '1'),
(64, 'sticker_boxer', '1', 'sticker_boxer', 3, 1, 24, '1'),
(65, 'scubacapsule_anim', '1', 'scubacapsule_anim', 3, 1, 35, '1'),
(66, 'sticker_gurubeard_gray', '1', 'sticker_gurubeard_gray', 3, 1, 35, '1'),
(67, 'sticker_gurubeard_brown', '1', 'sticker_gurubeard_brown', 3, 1, 35, '1'),
(68, 'sticker_glasses_supernerd', '1', 'sticker_glasses_supernerd', 3, 1, 35, '1'),
(69, 'sticker_glasses_elton', '1', 'sticker_glasses_elton', 3, 1, 35, '1'),
(70, 'sticker_eyes_blue', '1', 'sticker_eyes_blue', 3, 1, 35, '1'),
(71, 'sticker_eye_anim', '1', 'sticker_eye_anim', 3, 1, 35, '1'),
(72, 'sticker_eye_evil_anim', '1', 'sticker_eye_evil_anim', 3, 1, 35, '1'),
(73, 'burger', '1', 'burger', 3, 1, 32, '1'),
(74, 'juice', '1', 'juice', 3, 1, 32, '1'),
(75, 'i_love_coffee', '1', 'i_love_coffee', 3, 1, 32, '1'),
(76, 'sticker_coffee_steam_blue', '1', 'sticker_coffee_steam_blue', 3, 1, 32, '1'),
(77, 'sticker_coffee_steam_grey', '1', 'sticker_coffee_steam_grey', 3, 1, 32, '1'),
(78, 'cassette1', '1', 'cassette1', 3, 1, 23, '1'),
(79, 'cassette2', '1', 'cassette2', 3, 1, 23, '1'),
(80, 'cassette3', '1', 'cassette3', 3, 1, 23, '1'),
(81, 'cassette4', '1', 'cassette4', 3, 1, 23, '1'),
(82, 'sticker_effect_bam', '1', 'sticker_effect_bam', 3, 1, 25, '1'),
(83, 'sticker_effect_burp', '1', 'sticker_effect_burp', 3, 1, 25, '1'),
(84, 'sticker_effect_woosh', '1', 'sticker_effect_woosh', 3, 1, 25, '1'),
(85, 'sticker_effect_zap', '1', 'sticker_effect_zap', 3, 1, 25, '1'),
(86, 'sticker_effect_whoosh2', '1', 'sticker_effect_whoosh2', 3, 1, 25, '1'),
(87, 'sticker_flower1', '1', 'sticker_flower1', 3, 1, 34, '1'),
(88, 'sticker_flower_big_yellow', '1', 'sticker_flower_big_yellow', 3, 1, 32, '1'),
(89, 'sticker_flower_pink', '1', 'sticker_flower_pink', 3, 1, 32, '1'),
(90, 'vine', '1', 'vine', 3, 1, 22, '1'),
(91, 'vine2', '1', 'vine2', 3, 1, 22, '1'),
(92, 'leafs1', '1', 'leafs1', 3, 1, 22, '1'),
(93, 'leafs2', '1', 'leafs2', 3, 1, 22, '1'),
(94, 'wunderfrank', '1', 'wunderfrank', 3, 1, 30, '1'),
(95, 'sticker_submarine', '1', 'sticker_submarine', 3, 1, 32, '1'),
(96, 'football', '1', 'football', 3, 1, 32, '1'),
(97, 'sticker_zipper_h_bobba_lock', '1', 'sticker_zipper_h_bobba_lock', 3, 1, 22, '1'),
(98, 'sticker_zipper_h_end', '1', 'sticker_zipper_h_end', 3, 1, 22, '1'),
(99, 'sticker_zipper_h_normal_lock', '1', 'sticker_zipper_h_normal_lock', 3, 1, 22, '1'),
(100, 'sticker_zipper_h_tile', '1', 'sticker_zipper_h_tile', 3, 1, 22, '1'),
(101, 'sticker_zipper_v_tile', '1', 'sticker_zipper_v_tile', 3, 1, 22, '1'),
(102, 'sticker_zipper_v_bobba_lock', '1', 'sticker_zipper_v_bobba_lock', 3, 1, 22, '1'),
(103, 'sticker_zipper_v_end', '1', 'sticker_zipper_v_end', 3, 1, 22, '1'),
(104, 'sticker_zipper_v_normal_lock', '1', 'sticker_zipper_v_normal_lock', 3, 1, 22, '1'),
(105, 'bling_a', '1', 'bling_a', 3, 1, 7, '1'),
(106, 'bling_b', '1', 'bling_b', 3, 1, 7, '1'),
(107, 'bling_c', '1', 'bling_c', 3, 1, 7, '1'),
(108, 'bling_d', '1', 'bling_d', 3, 1, 7, '1'),
(109, 'bling_e', '1', 'bling_e', 3, 1, 7, '1'),
(110, 'bling_f', '1', 'bling_f', 3, 1, 7, '1'),
(111, 'bling_g', '1', 'bling_g', 3, 1, 7, '1'),
(112, 'bling_h', '1', 'bling_h', 3, 1, 7, '1'),
(113, 'bling_i', '1', 'bling_i', 3, 1, 7, '1'),
(114, 'bling_j', '1', 'bling_j', 3, 1, 7, '1'),
(115, 'bling_k', '1', 'bling_k', 3, 1, 7, '1'),
(116, 'bling_l', '1', 'bling_l', 3, 1, 7, '1'),
(117, 'bling_m', '1', 'bling_m', 3, 1, 7, '1'),
(118, 'bling_n', '1', 'bling_n', 3, 1, 7, '1'),
(119, 'bling_o', '1', 'bling_o', 3, 1, 7, '1'),
(120, 'bling_p', '1', 'bling_p', 3, 1, 7, '1'),
(121, 'bling_q', '1', 'bling_q', 3, 1, 7, '1'),
(122, 'bling_r', '1', 'bling_r', 3, 1, 7, '1'),
(123, 'bling_s', '1', 'bling_s', 3, 1, 7, '1'),
(124, 'bling_t', '1', 'bling_t', 3, 1, 7, '1'),
(125, 'bling_u', '1', 'bling_u', 3, 1, 7, '1'),
(126, 'bling_v', '1', 'bling_v', 3, 1, 7, '1'),
(127, 'bling_w', '1', 'bling_w', 3, 1, 7, '1'),
(128, 'bling_x', '1', 'bling_x', 3, 1, 7, '1'),
(129, 'bling_y', '1', 'bling_y', 3, 1, 7, '1'),
(130, 'bling_z', '1', 'bling_z', 3, 1, 7, '1'),
(131, 'bling_underscore', '1', 'bling_underscore', 3, 1, 7, '1'),
(132, 'bling_line', '1', 'bling_line', 3, 1, 7, '1'),
(133, 'bling_exclamation', '1', 'bling_exclamation', 3, 1, 7, '1'),
(134, 'bling_question', '1', 'bling_question', 3, 1, 7, '1'),
(135, 'bling_star', '1', 'bling_star', 3, 1, 7, '1'),
(136, 'bling_dot', '1', 'bling_dot', 3, 1, 7, '1'),
(137, 'bling_comma', '1', 'bling_comma', 3, 1, 7, '1'),
(139, 'angelwings_anim', '1', 'angelwings_anim', 3, 1, 35, '1'),
(140, 'xmas_box_green', '1', 'xmas_box_green', 3, 1, 29, '1'),
(141, 'xmas_box_lime', '1', 'xmas_box_lime', 3, 1, 29, '1'),
(142, 'xmas_box_orange', '1', 'xmas_box_orange', 3, 1, 29, '1'),
(143, 'xmas_box_red', '1', 'xmas_box_red', 3, 1, 29, '1'),
(144, 'xmas_box_suit_blue', '1', 'xmas_box_suit_blue', 3, 1, 37, '1'),
(145, 'xmas_box_suit_orange', '1', 'xmas_box_suit_orange', 3, 1, 35, '1'),
(146, 'xmas_box_suit_pink', '1', 'xmas_box_suit_pink', 3, 1, 35, '1'),
(147, 'xmas_box_violet', '1', 'xmas_box_violet', 3, 1, 29, '1'),
(148, 'xmas_boxs', '1', 'xmas_boxs', 3, 1, 29, '1'),
(149, 'xmas_cat_animated', '1', 'xmas_cat_animated', 3, 1, 29, '1'),
(150, 'xmas_dogi_animated', '1', 'xmas_dogi_animated', 3, 1, 29, '1'),
(151, 'xmas_gift_strap_corner_l', '1', 'xmas_gift_strap_corner_l', 3, 1, 29, '1'),
(152, 'xmas_gift_strap_corner_l_bundle', '1', 'xmas_gift_strap_corner_l_bundle', 3, 1, 29, '1'),
(153, 'xmas_gift_strap_corner_r', '1', 'xmas_gift_strap_corner_r', 3, 1, 29, '1'),
(154, 'xmas_gift_strap_h', '1', 'xmas_gift_strap_h', 3, 1, 29, '1'),
(155, 'xmas_gift_strap_v', '1', 'xmas_gift_strap_v', 3, 1, 29, '1'),
(156, 'xmas_gift_afro', '1', 'xmas_gift_afro', 3, 1, 35, '1'),
(157, 'xmas_icicles', '1', 'xmas_icicles', 3, 1, 22, '1'),
(158, 'xmas_snowlantern_anim', '1', 'xmas_snowlantern_anim', 3, 1, 29, '1'),
(159, 'xmas_tree_costume', '1', 'xmas_tree_costume', 3, 1, 29, '1'),
(160, 'xmas_xtree_sticker', '1', 'xmas_xtree_sticker', 3, 1, 29, '1'),
(161, 'xmaslights_anim', '1', 'xmaslights_anim', 3, 1, 29, '1'),
(162, 'xmas_dograindeer_sticker', '1', 'xmas_dograindeer_sticker', 3, 1, 29, '1'),
(163, 'xmas_hc_ribbon', '1', 'xmas_hc_ribbon', 3, 1, 29, '1'),
(164, 'hc_hat', '1', 'hc_hat', 3, 1, 35, '1'),
(165, 'xmas_rastasanta', '1', 'xmas_rastasanta', 3, 1, 24, '1'),
(167, 'xmas_box_suit_mint3', '1', 'xmas_box_suit_mint3', 3, 1, 35, '1'),
(168, 'xmas_box_suit_mint', '1', 'xmas_box_suit_mint', 3, 1, 35, '1'),
(169, 'xmas_box_darkred4', '1', 'xmas_box_darkred4', 3, 1, 29, '1'),
(170, 'xmas_tree01_animated', '1', 'xmas_tree01_animated', 3, 1, 29, '1'),
(171, 'newyear_2007_anim', '1', 'newyear_2007_anim', 3, 1, 29, '1'),
(172, 'cny_dragon_body_l', '1', 'cny_dragon_body_l', 3, 1, 29, '1'),
(173, 'cny_dragon_body_r', '1', 'cny_dragon_body_r', 3, 1, 29, '1'),
(174, 'cny_dragon_head_l', '1', 'cny_dragon_head_l', 3, 1, 29, '1'),
(175, 'cny_dragon_head_r', '1', 'cny_dragon_head_r', 3, 1, 29, '1'),
(176, 'cny_hypnodragon_anim', '1', 'cny_hypnodragon_anim', 3, 1, 24, '1'),
(177, 'cny_kungfu_dude', '1', 'cny_kungfu_dude', 3, 1, 24, '1'),
(178, 'cny_kungfu_girl', '1', 'cny_kungfu_girl', 3, 1, 24, '1'),
(179, 'sticker_dreamer', '1', 'sticker_dreamer', 3, 1, 30, '1'),
(180, 'sticker_lonewolf', '1', 'sticker_lonewolf', 3, 1, 30, '1'),
(181, 'sticker_mamasboy', '1', 'sticker_mamasboy', 3, 1, 30, '1'),
(182, 'sticker_prankster', '1', 'sticker_prankster', 3, 1, 30, '1'),
(183, 'sticker_romantic', '1', 'sticker_romantic', 3, 1, 30, '1'),
(184, 'val_cupido_anim', '1', 'val_cupido_anim', 3, 1, 29, '1'),
(185, 'val_lovedice', '1', 'val_lovedice', 3, 1, 29, '1'),
(186, 'val_sticker_barbwire_horis', '1', 'val_sticker_barbwire_horis', 3, 1, 22, '1'),
(187, 'val_sticker_barbwire_vert', '1', 'val_sticker_barbwire_vert', 3, 1, 22, '1'),
(188, 'val_sticker_croco', '1', 'val_sticker_croco', 3, 1, 29, '1'),
(189, 'val_sticker_cupid_arrow', '1', 'val_sticker_cupid_arrow', 3, 1, 29, '1'),
(190, 'val_sticker_love_costume', '1', 'val_sticker_love_costume', 3, 1, 29, '1'),
(191, 'val_sticker_rosewire_corner', '1', 'val_sticker_rosewire_corner', 3, 1, 22, '1'),
(192, 'val_sticker_rosewire_horis', '1', 'val_sticker_rosewire_horis', 3, 1, 22, '1'),
(193, 'val_sticker_rosewire_vert', '1', 'val_sticker_rosewire_vert', 3, 1, 22, '1'),
(194, 'val_sticker_skull360', '1', 'val_sticker_skull360', 3, 1, 32, '1'),
(195, 'val_sticker_skull360_circle', '1', 'val_sticker_skull360_circle', 3, 1, 32, '1'),
(196, 'val_sticker_storm_costume', '1', 'val_sticker_storm_costume', 3, 1, 32, '1'),
(197, 'val_sticker_voodoo_suit', '1', 'val_sticker_voodoo_suit', 3, 1, 35, '1'),
(198, 'val_lovecostume3', '1', 'val_lovecostume3', 3, 1, 29, '1'),
(199, 'easter_bird', '1', 'easter_bird', 3, 1, 29, '1'),
(200, 'easter_birdsuit', '1', 'easter_birdsuit', 3, 1, 35, '1'),
(201, 'easter_broomstick_001', '1', 'easter_broomstick_001', 3, 1, 32, '1'),
(202, 'easter_bunnymoped', '1', 'easter_bunnymoped', 3, 1, 35, '1'),
(203, 'easter_carrot_rocket', '1', 'easter_carrot_rocket', 3, 1, 32, '1'),
(204, 'easter_eggs_horizontal', '1', 'easter_eggs_horizontal', 3, 1, 29, '1'),
(205, 'easter_eggs_vertical_001', '1', 'easter_eggs_vertical_001', 3, 1, 29, '1'),
(206, 'easter_pointyhat', '1', 'easter_pointyhat', 3, 1, 35, '1'),
(207, 'easter_rabbit_in_hole', '1', 'easter_rabbit_in_hole', 3, 1, 32, '1'),
(208, 'easteregg_costume', '1', 'easteregg_costume', 3, 1, 29, '1'),
(209, 'grass', '1', 'grass', 3, 1, 34, '1'),
(210, 'ukonly_disarno_homes', '1', 'ukonly_disarno_homes', 3, 1, 30, '1'),
(213, 'uk_childline_sticker', '1', 'uk_childline_sticker', 3, 1, 28, '1'),
(214, 'uk_pixel_maze_sticker', '1', 'uk_pixel_maze_sticker', 3, 1, 30, '1'),
(215, 'sticker_chauves_souris', '1', 'sticker_chauves_souris', 3, 1, 29, '1'),
(216, 'trax_8_bit', '1', 'trax_8_bit', 3, 1, 23, '1'),
(217, 'trax_disco', '1', 'trax_disco', 3, 1, 23, '1'),
(225, 'trax_sfx', '1', 'trax_sfx', 3, 1, 23, '1'),
(226, 'trax_rock', '1', 'trax_rock', 3, 1, 23, '1'),
(227, 'trax_electro', '1', 'trax_electro', 3, 1, 23, '1'),
(228, 'trax_ambient', '1', 'trax_ambient', 3, 1, 23, '1'),
(229, 'trax_heavy', '1', 'trax_heavy', 3, 1, 23, '1'),
(230, 'trax_latin', '1', 'trax_latin', 3, 1, 23, '1'),
(231, 'trax_bling2', '1', 'trax_bling2', 3, 1, 23, '1'),
(233, 'evil_giant_bunny', '1', 'evil_giant_bunny', 3, 1, 32, '1'),
(250, 'xmas_snowcone_costume', '1', 'xmas_snowcone_costume', 3, 1, 29, '1'),
(251, 'a', '1', 'a', 3, 1, 7, '1'),
(252, 'a_with_circle', '1', 'a_with_circle', 3, 1, 7, '1'),
(253, 'a_with_dots', '1', 'a_with_dots', 3, 1, 7, '1'),
(254, 'acsent1', '1', 'acsent1', 3, 1, 7, '1'),
(255, 'acsent2', '1', 'acsent2', 3, 1, 7, '1'),
(256, 'b', '1', 'b', 3, 1, 7, '1'),
(258, 'b_2', '1', 'b_2', 3, 1, 7, '1'),
(259, 'bootsitjalapaset_red', '1', 'bootsitjalapaset_red', 3, 1, 35, '1'),
(260, 'c', '1', 'c', 3, 1, 7, '1'),
(261, 'd', '1', 'd', 3, 1, 7, '1'),
(262, 'dot', '1', 'dot', 3, 1, 7, '1'),
(263, 'e', '1', 'e', 3, 1, 7, '1'),
(264, 'extra_ss_duck_left', '1', 'extra_ss_duck_left', 3, 1, 32, '1'),
(265, 'extra_ss_duck_right', '1', 'extra_ss_duck_right', 3, 1, 32, '1'),
(266, 'extra_ss_snowball', '1', 'extra_ss_snowball', 3, 1, 32, '1'),
(267, 'eyeleft', '1', 'eyeleft', 3, 1, 32, '1'),
(268, 'eyeright', '1', 'eyeright', 3, 1, 32, '1'),
(269, 'f', '1', 'f', 3, 1, 7, '1'),
(272, 'fi_golden_snake', '1', 'fi_golden_snake', 3, 1, 32, '1'),
(273, 'fi_mino', '1', 'fi_mino', 3, 1, 24, '1'),
(274, 'g', '1', 'g', 3, 1, 7, '1'),
(275, 'gothic_draculacape', '1', 'gothic_draculacape', 3, 1, 35, '1'),
(276, 'h', '1', 'h', 3, 1, 7, '1'),
(277, 'i', '1', 'i', 3, 1, 7, '1'),
(278, 'icecube_big', '1', 'icecube_big', 3, 1, 29, '1'),
(279, 'icecube_small', '1', 'icecube_small', 3, 1, 29, '1'),
(280, 'j', '1', 'j', 3, 1, 7, '1'),
(281, 'k', '1', 'k', 3, 1, 7, '1'),
(282, 'l', '1', 'l', 3, 1, 7, '1'),
(285, 'lapanen_blue', '1', 'lapanen_blue', 3, 1, 29, '1'),
(287, 'lapanen_purple', '1', 'lapanen_purple', 3, 1, 29, '1'),
(288, 'lapanen_red', '1', 'lapanen_red', 3, 1, 29, '1'),
(290, 'lapanen_yellow', '1', 'lapanen_yellow', 3, 1, 29, '1'),
(291, 'm', '1', 'm', 3, 1, 7, '1'),
(292, 'n', '1', 'n', 3, 1, 7, '1'),
(293, 'nl_coinguy_animated', '1', 'nl_coinguy_animated', 3, 1, 32, '1'),
(294, 'nl_cupido', '1', 'nl_cupido', 3, 1, 29, '1'),
(295, 'nl_downtown_costume', '1', 'nl_downtown_costume', 3, 1, 35, '1'),
(296, 'nl_firecracker', '1', 'nl_firecracker', 3, 1, 29, '1'),
(297, 'nl_football_guest', '1', 'nl_football_guest', 3, 1, 24, '1'),
(298, 'nl_limo', '1', 'nl_limo', 3, 1, 32, '1'),
(299, 'nl_wanted_costume', '1', 'nl_wanted_costume', 3, 1, 35, '1'),
(300, 'o', '1', 'o', 3, 1, 7, '1'),
(301, 'o_with_dots', '1', 'o_with_dots', 3, 1, 7, '1'),
(302, 'p', '1', 'p', 3, 1, 7, '1'),
(303, 'q', '1', 'q', 3, 1, 7, '1'),
(304, 'r', '1', 'r', 3, 1, 7, '1'),
(305, 's', '1', 's', 3, 1, 7, '1'),
(306, 'skeletor_001', '1', 'skeletor_001', 3, 1, 24, '1'),
(307, 'skull', '1', 'skull', 3, 1, 32, '1'),
(308, 'skull2', '1', 'skull2', 3, 1, 32, '1'),
(309, 'snowball_bumpy', '1', 'snowball_bumpy', 3, 1, 32, '1'),
(310, 'snowball_smooth', '1', 'snowball_smooth', 3, 1, 32, '1'),
(311, 'ss_bootsitjalapaset_blue', '1', 'ss_bootsitjalapaset_blue', 3, 1, 35, '1'),
(312, 'ss_bootsitjalapaset_red', '1', 'ss_bootsitjalapaset_red', 3, 1, 35, '1'),
(313, 'ss_costume_blue', '1', 'ss_costume_blue', 3, 1, 35, '1'),
(314, 'ss_costume_red', '1', 'ss_costume_red', 3, 1, 35, '1'),
(315, 'ss_hits_by_snowball', '1', 'ss_hits_by_snowball', 3, 1, 35, '1'),
(316, 'ss_snowballmachine', '1', 'ss_snowballmachine', 3, 1, 32, '1'),
(317, 'ss_snowflake1_001', '1', 'ss_snowflake1_001', 3, 1, 29, '1'),
(319, 'ss_snowflake2', '1', 'ss_snowflake2', 3, 1, 29, '1'),
(320, 'ss_snowman', '1', 'ss_snowman', 3, 1, 35, '1'),
(321, 'ss_snowqueen', '1', 'ss_snowqueen', 3, 1, 35, '1'),
(322, 'ss_snowtree', '1', 'ss_snowtree', 3, 1, 32, '1'),
(323, 'star', '1', 'star', 3, 1, 7, '1'),
(324, 'sticker_eraser', '1', 'sticker_eraser', 3, 1, 32, '1'),
(325, 'sticker_gentleman', '1', 'sticker_gentleman', 3, 1, 24, '1'),
(326, 'sticker_mineur', '1', 'sticker_mineur', 3, 1, 24, '1'),
(327, 'sticker_pencil', '1', 'sticker_pencil', 3, 1, 32, '1'),
(328, 'sticker_pencil_2', '1', 'sticker_pencil_2', 3, 1, 32, '1'),
(329, 't', '1', 't', 3, 1, 7, '1'),
(330, 'trax_bling', '1', 'trax_bling', 3, 1, 23, '1'),
(331, 'trax_reggae', '1', 'trax_reggae', 3, 1, 23, '1'),
(332, 'u', '1', 'u', 3, 1, 7, '1'),
(333, 'underscore', '1', 'underscore', 3, 1, 7, '1'),
(334, 'v', '1', 'v', 3, 1, 7, '1'),
(335, 'val_cupido_anim2', '1', 'val_cupido_anim2', 3, 1, 29, '1'),
(336, 'w', '1', 'w', 3, 1, 7, '1'),
(337, 'wormhand', '1', 'wormhand', 3, 1, 32, '1'),
(338, 'x', '1', 'x', 3, 1, 7, '1'),
(340, 'xmas_skater_costume', '1', 'xmas_skater_costume', 3, 1, 35, '1'),
(341, 'xmas_strap_horiz_gold', '1', 'xmas_strap_horiz_gold', 3, 1, 29, '1'),
(342, 'xmas_strap_horiz_silve', '1', 'xmas_strap_horiz_silve', 3, 1, 29, '1'),
(343, 'xmas_strap_vertical_gold', '1', 'xmas_strap_vertical_gold', 3, 1, 22, '1'),
(344, 'xmas_strap_vertical_silver', '1', 'xmas_strap_vertical_silver', 3, 1, 26, '1'),
(345, 'y', '1', 'y', 3, 1, 7, '1'),
(346, 'z', '1', 'z', 3, 1, 7, '1'),
(348, 'zombiepupu', '1', 'zombiepupu', 3, 1, 32, '1'),
(349, 'diamond_reward', '1', 'diamond_reward', 3, 1, 32, '1'),
(350, 'nz_tiki', '1', 'nz_tiki', 3, 1, 30, '1'),
(351, 'jp_godzilla', '1', 'jp_godzilla', 3, 1, 32, '1'),
(352, 'jp_sushi', '1', 'jp_sushi', 3, 1, 30, '1'),
(354, 'spotlight_sticker_2', '1', 'spotlight_sticker_2', 3, 1, 30, '1'),
(355, 'spotlight_sticker', '1', 'spotlight_sticker', 3, 1, 30, '1'),
(356, 'anim_king', '1', 'anim_king', 3, 1, 24, '1'),
(357, 'filmstrip_corner_botleft', '1', 'filmstrip_corner_botleft', 3, 1, 30, '1'),
(358, 'filmstrip_corner_botright', '1', 'filmstrip_corner_botright', 3, 1, 30, '1'),
(359, 'filmstrip_corner_topleft', '1', 'filmstrip_corner_topleft', 3, 1, 30, '1'),
(360, 'filmstrip_corner_topright', '1', 'filmstrip_corner_topright', 3, 1, 30, '1'),
(361, 'filmstrip_horiz', '1', 'filmstrip_horiz', 3, 1, 30, '1'),
(362, 'filmstrip_vert', '1', 'filmstrip_vert', 3, 1, 30, '1'),
(363, 'hw_3d_glasses', '1', 'hw_3d_glasses', 3, 1, 35, '1'),
(364, 'hw_actionstar', '1', 'hw_actionstar', 3, 1, 24, '1'),
(365, 'hw_bigcamera', '1', 'hw_bigcamera', 3, 1, 30, '1'),
(366, 'hw_bouncers', '1', 'hw_bouncers', 3, 1, 24, '1'),
(367, 'hw_camera_l', '1', 'hw_camera_l', 3, 1, 30, '1'),
(368, 'hw_camera_r', '1', 'hw_camera_r', 3, 1, 30, '1'),
(369, 'hw_carpet_corner_down', '1', 'hw_carpet_corner_down', 3, 1, 29, '1'),
(370, 'hw_carpet_corner_up', '1', 'hw_carpet_corner_up', 3, 1, 30, '1'),
(371, 'hw_carpet_end_ldown', '1', 'hw_carpet_end_ldown', 3, 1, 30, '1'),
(372, 'hw_carpet_end_lup', '1', 'hw_carpet_end_lup', 3, 1, 30, '1'),
(373, 'hw_carpet_end_rdown', '1', 'hw_carpet_end_rdown', 3, 1, 30, '1'),
(374, 'hw_carpet_end_rup', '1', 'hw_carpet_end_rup', 3, 1, 30, '1'),
(375, 'hw_carpet_l', '1', 'hw_carpet_l', 3, 1, 30, '1'),
(376, 'hw_carpet_r', '1', 'hw_carpet_r', 3, 1, 30, '1'),
(377, 'hw_hairspray', '1', 'hw_hairspray', 3, 1, 24, '1'),
(378, 'hw_hippie', '1', 'hw_hippie', 3, 1, 24, '1'),
(379, 'hw_hitcher', '1', 'hw_hitcher', 3, 1, 24, '1'),
(380, 'hw_inmate', '1', 'hw_inmate', 3, 1, 24, '1'),
(381, 'hw_kenny_burger', '1', 'hw_kenny_burger', 3, 1, 24, '1'),
(382, 'hw_kenny_fight', '1', 'hw_kenny_fight', 3, 1, 23, '1'),
(383, 'hw_kenny_shock', '1', 'hw_kenny_shock', 3, 1, 24, '1'),
(384, 'hw_logoanim', '1', 'hw_logoanim', 3, 1, 30, '1'),
(385, 'hw_mega_afro', '1', 'hw_mega_afro', 3, 1, 35, '1'),
(386, 'hw_shades', '1', 'hw_shades', 3, 1, 35, '1'),
(387, 'hw_speedobunny', '1', 'hw_speedobunny', 3, 1, 24, '1'),
(388, 'limo_back', '1', 'limo_back', 3, 1, 30, '1'),
(389, 'limo_doorpiece', '1', 'limo_doorpiece', 3, 1, 30, '1'),
(390, 'limo_front', '1', 'limo_front', 3, 1, 30, '1'),
(391, 'limo_windowpiece', '1', 'limo_windowpiece', 3, 1, 30, '1'),
(392, 'money_o', '1', 'money_o', 3, 1, 32, '1'),
(393, 'money_stash', '1', 'money_stash', 3, 1, 32, '1'),
(394, 'money_v', '1', 'money_v', 3, 1, 32, '1'),
(395, 'spotlight_sticker2_001', '1', 'spotlight_sticker2_001', 3, 1, 30, '1'),
(396, 'spotlight_sticker_002', '1', 'spotlight_sticker_002', 3, 1, 30, '1'),
(397, 'grunge_polaroid_1', '1', 'grunge_polaroid_1', 3, 1, 30, '1'),
(398, 'grunge_polaroid_2', '1', 'grunge_polaroid_2', 3, 1, 30, '1'),
(399, 'grunge_polaroid_3', '1', 'grunge_polaroid_3', 3, 1, 30, '1'),
(400, 'grunge_polaroid_4', '1', 'grunge_polaroid_4', 3, 1, 30, '1'),
(401, 'grunge_polaroid_5', '1', 'grunge_polaroid_5', 3, 1, 30, '1'),
(402, 'fantasticfourlogo', '1', 'fantasticfourlogo', 3, 1, 28, '1'),
(403, 'bullybuster', '1', 'bullybuster', 3, 1, 32, '1'),
(404, 'lovebed', '1', 'lovebed', 3, 1, 29, '1'),
(406, 'banksbobby', '1', 'banksbobby', 3, 1, 30, '1'),
(407, 'bankscan', '1', 'bankscan', 3, 1, 30, '1'),
(408, 'banksdoor', '1', 'banksdoor', 3, 1, 30, '1'),
(409, 'banksheater', '1', 'banksheater', 3, 1, 30, '1'),
(410, 'horizontalink', '1', 'horizontalink', 3, 1, 28, '1'),
(411, 'verticalink', '1', 'verticalink', 3, 1, 32, '1'),
(412, 'britishlegion', '1', 'britishlegion', 3, 1, 29, '1'),
(413, 'teensbear', '1', 'teensbear', 3, 1, 29, '1'),
(414, 'teensberg', '1', 'teensberg', 3, 1, 32, '1'),
(417, 'kir_stamp1', '1', 'kir_stamp1', 3, 1, 30, '1'),
(418, 'kir_stamp2', '1', 'kir_stamp2', 3, 1, 30, '1'),
(419, 'kir_stamp3', '1', 'kir_stamp3', 3, 1, 30, '1'),
(420, 'kir_stamp4', '1', 'kir_stamp4', 3, 1, 30, '1'),
(421, 'kir_stamp5', '1', 'kir_stamp5', 3, 1, 30, '1'),
(422, 'kir_sticker', '1', 'kir_sticker', 3, 1, 30, '1'),
(423, 'hw_amp_big', '1', 'hw_amp_big', 3, 1, 23, '1'),
(424, 'hw_amp_small', '1', 'hw_amp_small', 3, 1, 23, '1'),
(425, 'hw_drummer_boy', '1', 'hw_drummer_boy', 3, 1, 35, '1'),
(426, 'hw_keyboards', '1', 'hw_keyboards', 3, 1, 23, '1'),
(427, 'hw_guitarplayer_white', '1', 'hw_guitarplayer_white', 3, 1, 23, '1'),
(429, 'edito_logo', '1', 'edito_logo', 3, 1, 30, '1'),
(430, 'xmas_smilla_snowboard', '1', 'xmas_smilla_snowboard', 3, 1, 29, '1'),
(431, 'kir_stamp6_003', '1', 'kir_stamp6_003', 3, 1, 30, '1'),
(432, 'xmassticker_anim_3000', '1', 'xmassticker_anim_3000', 3, 1, 29, '1'),
(433, 'orca_ideal_home', '1', 'orca_ideal_home', 3, 1, 30, '1'),
(434, 'xmas_jeff_donkey_reindeer_sticker', '1', 'xmas_jeff_donkey_reindeer_sticker', 3, 1, 24, '1'),
(435, 'bartender_costume', '1', 'bartender_costume', 3, 1, 35, '1'),
(436, 'crew_male_costume', '1', 'crew_male_costume', 3, 1, 35, '1'),
(437, 'femalecaptain_costume', '1', 'femalecaptain_costume', 3, 1, 35, '1'),
(438, 'malecaptain_costume', '1', 'malecaptain_costume', 3, 1, 35, '1'),
(439, 'stewardess_costume', '1', 'stewardess_costume', 3, 1, 35, '1'),
(440, 'valcaptain', '1', 'valcaptain', 3, 1, 24, '1'),
(441, 'valstewardess', '1', 'valstewardess', 3, 1, 24, '1'),
(442, 'valsteward', '1', 'valsteward', 3, 1, 24, '1'),
(443, 'valentertainer', '1', 'valentertainer', 3, 1, 24, '1'),
(444, 'rasta', '1', 'rasta', 3, 1, 24, '1'),
(445, 'missj', '1', 'missj', 3, 1, 24, '1'),
(446, 'valentine_welcome_sticker', '1', 'valentine_welcome_sticker', 3, 1, 29, '1'),
(447, 'habborella_logo', '1', 'habborella_logo', 3, 1, 30, '1'),
(448, 'tall_ship', '1', 'tall_ship', 3, 1, 32, '1'),
(449, 'leapday', '1', 'leapday', 3, 1, 29, '1'),
(450, 'patsday_kissme', '1', 'patsday_kissme', 3, 1, 29, '1'),
(451, 'patsday_potogold', '1', 'patsday_potogold', 3, 1, 29, '1'),
(452, 'patsday_shamrock', '1', 'patsday_shamrock', 3, 1, 29, '1'),
(453, 'patsday_shamborderv', '1', 'patsday_shamborderv', 3, 1, 22, '1'),
(454, 'patsday_shamborderh', '1', 'patsday_shamborderh', 3, 1, 22, '1'),
(455, 'patsday_claddagh', '1', 'patsday_claddagh', 3, 1, 29, '1'),
(456, 'sticker_themepark_003', '1', 'sticker_themepark_003', 3, 1, 30, '1'),
(457, 'sticker_themepark_002', '1', 'sticker_themepark_002', 3, 1, 30, '1'),
(458, '27224_sticker_themepark_001', '1', '27224_sticker_themepark_001', 3, 1, 30, '1'),
(459, 'cheese_badgesticker', '1', 'cheese_badgesticker', 3, 1, 32, '1'),
(460, 'geniefirehead', '1', 'geniefirehead', 3, 1, 35, '1'),
(461, 'bg_groupinfo', '1', 'bg_groupinfo', 3, 1, 32, '1'),
(462, 'bg_stickie', '1', 'bg_stickie', 3, 1, 32, '1'),
(463, 'wood_a', '1', 'wood_a', 3, 1, 7, '1'),
(464, 'wood_acircle', '1', 'wood_acircle', 3, 1, 7, '1'),
(465, 'wood_acsent', '1', 'wood_acsent', 3, 1, 7, '1'),
(466, 'wood_acsent2', '1', 'wood_acsent2', 3, 1, 7, '1'),
(467, 'wood_adots', '1', 'wood_adots', 3, 1, 7, '1'),
(468, 'wood_b', '1', 'wood_b', 3, 1, 7, '1'),
(469, 'wood_c', '1', 'wood_c', 3, 1, 7, '1'),
(470, 'wood_comma', '1', 'wood_comma', 3, 1, 7, '1'),
(471, 'wood_d', '1', 'wood_d', 3, 1, 7, '1'),
(472, 'wood_dot', '1', 'wood_dot', 3, 1, 7, '1'),
(473, 'wood_e', '1', 'wood_e', 3, 1, 7, '1'),
(474, 'wood_exclamation', '1', 'wood_exclamation', 3, 1, 7, '1'),
(475, 'wood_f', '1', 'wood_f', 3, 1, 7, '1'),
(476, 'wood_g', '1', 'wood_g', 3, 1, 7, '1'),
(477, 'wood_h', '1', 'wood_h', 3, 1, 7, '1'),
(478, 'wood_i', '1', 'wood_i', 3, 1, 7, '1'),
(479, 'wood_j', '1', 'wood_j', 3, 1, 7, '1'),
(480, 'wood_k', '1', 'wood_k', 3, 1, 7, '1'),
(481, 'wood_l', '1', 'wood_l', 3, 1, 7, '1'),
(482, 'wood_m', '1', 'wood_m', 3, 1, 7, '1'),
(483, 'wood_n', '1', 'wood_n', 3, 1, 7, '1'),
(484, 'wood_o', '1', 'wood_o', 3, 1, 7, '1'),
(485, 'wood_odots', '1', 'wood_odots', 3, 1, 7, '1'),
(486, 'wood_p', '1', 'wood_p', 3, 1, 7, '1'),
(487, 'wood_q', '1', 'wood_q', 3, 1, 7, '1'),
(488, 'wood_question', '1', 'wood_question', 3, 1, 7, '1'),
(489, 'wood_r', '1', 'wood_r', 3, 1, 7, '1'),
(490, 'wood_s', '1', 'wood_s', 3, 1, 7, '1'),
(491, 'wood_t', '1', 'wood_t', 3, 1, 7, '1'),
(492, 'wood_u', '1', 'wood_u', 3, 1, 7, '1'),
(493, 'wood_undermark', '1', 'wood_undermark', 3, 1, 7, '1'),
(494, 'wood_v', '1', 'wood_v', 3, 1, 7, '1'),
(495, 'wood_w', '1', 'wood_w', 3, 1, 7, '1'),
(496, 'wood_x', '1', 'wood_x', 3, 1, 7, '1'),
(497, 'wood_y', '1', 'wood_y', 3, 1, 7, '1'),
(498, 'wood_z', '1', 'wood_z', 3, 1, 7, '1'),
(499, 'uk_habbo_x_sticker', '1', 'uk_habbo_x_sticker', 3, 1, 30, '1'),
(500, 'habbo_x_home_sticker', '1', 'habbo_x_home_sticker', 3, 1, 30, '1'),
(501, 'habbolympics_teamsticker', '1', 'habbolympics_teamsticker', 3, 1, 30, '1'),
(502, 'orca_ideal_home_001', '1', 'orca_ideal_home_001', 3, 1, 32, '1'),
(503, 'warchild', '1', 'warchild', 3, 1, 28, '1'),
(504, 'pirates_captain', '1', 'pirates_captain', 3, 1, 24, '1'),
(505, 'pirates_dude02', '1', 'pirates_dude02', 3, 1, 24, '1'),
(506, 'hockeyref', '1', 'hockeyref', 3, 1, 24, '1'),
(507, 'hbb_sticker_01', '1', 'hbb_sticker_01', 3, 1, 28, '1'),
(508, 'hbb_sticker_02', '1', 'hbb_sticker_02', 3, 1, 28, '1'),
(509, 'hbb_sticker_03', '1', 'hbb_sticker_03', 3, 1, 28, '1'),
(510, 'sticker_olym_carson', '1', 'sticker_olym_carson', 3, 1, 24, '1'),
(511, 'sticker_olym_cresthawk', '1', 'sticker_olym_cresthawk', 3, 1, 24, '1'),
(512, 'sticker_olym_inari', '1', 'sticker_olym_inari', 3, 1, 24, '1'),
(513, 'sticker_olym_jandelee', '1', 'sticker_olym_jandelee', 3, 1, 24, '1'),
(514, 'sticker_olym_loderse', '1', 'sticker_olym_loderse', 3, 1, 24, '1'),
(515, 'sticker_olym_moiraine', '1', 'sticker_olym_moiraine', 3, 1, 24, '1'),
(516, 'sticker_olym_nme', '1', 'sticker_olym_nme', 3, 1, 24, '1'),
(517, 'sticker_olym_smoothcriminal', '1', 'sticker_olym_smoothcriminal', 3, 1, 24, '1'),
(518, 'sticker_olym_squib', '1', 'sticker_olym_squib', 3, 1, 24, '1'),
(519, 'flameskull', '1', 'flameskull', 3, 1, 32, '1'),
(520, 'cn_teleskull', '1', 'cn_teleskull', 3, 1, 30, '1'),
(521, 'anim_brasero', '1', 'anim_brasero', 3, 1, 32, '1'),
(522, 'sticker_fireworkboom1', '1', 'sticker_fireworkboom1', 3, 1, 25, '1'),
(523, 'sticker_fireworkboom2', '1', 'sticker_fireworkboom2', 3, 1, 25, '1'),
(524, 'sticker_fireworkboom3', '1', 'sticker_fireworkboom3', 3, 1, 25, '1'),
(525, 'sticker_fireworkboom4', '1', 'sticker_fireworkboom4', 3, 1, 25, '1'),
(526, 'atw_week_1_england', '1', 'atw_week_1_england', 3, 1, 31, '1'),
(527, 'atw_week_1_wales', '1', 'atw_week_1_wales', 3, 1, 31, '1'),
(528, 'atw_week_1_rep_ireland', '1', 'atw_week_1_rep_ireland', 3, 1, 31, '1'),
(529, 'atw_week_1_n_ireland', '1', 'atw_week_1_n_ireland', 3, 1, 31, '1'),
(530, 'atw_week_1_scotland', '1', 'atw_week_1_scotland', 3, 1, 31, '1'),
(531, 'atw_week_1_netherlands', '1', 'atw_week_1_netherlands', 3, 1, 31, '1'),
(532, 'atw_week_1_belgium', '1', 'atw_week_1_belgium', 3, 1, 31, '1'),
(533, 'atw_week_1_denmark', '1', 'atw_week_1_denmark', 3, 1, 31, '1'),
(534, 'atw_week_1_kazakhstan', '1', 'atw_week_1_kazakhstan', 3, 1, 31, '1'),
(535, 'atw_week_1_india', '1', 'atw_week_1_india', 3, 1, 31, '1'),
(536, 'atw_week_1_thailand', '1', 'atw_week_1_thailand', 3, 1, 31, '1'),
(537, 'atw_week_1_mongolia', '1', 'atw_week_1_mongolia', 3, 1, 31, '1'),
(538, 'atw_week_1_usa', '1', 'atw_week_1_usa', 3, 1, 31, '1'),
(539, 'atw_week_1_mexico', '1', 'atw_week_1_mexico', 3, 1, 31, '1'),
(540, 'atw_week_1_greenland', '1', 'atw_week_1_greenland', 3, 1, 31, '1'),
(541, 'atw_week_1_morocco', '1', 'atw_week_1_morocco', 3, 1, 31, '1'),
(542, 'atw_week_1_algeria', '1', 'atw_week_1_algeria', 3, 1, 31, '1'),
(543, 'atw_week_1_israel', '1', 'atw_week_1_israel', 3, 1, 31, '1'),
(544, 'atw_week_1_egypt', '1', 'atw_week_1_egypt', 3, 1, 31, '1'),
(545, 'atw_week_1_france', '1', 'atw_week_1_france', 3, 1, 31, '1'),
(546, 'atw_week_2_norway', '1', 'atw_week_2_norway', 3, 1, 31, '1'),
(547, 'atw_week_2_italy', '1', 'atw_week_2_italy', 3, 1, 31, '1'),
(548, 'atw_week_2_portugal', '1', 'atw_week_2_portugal', 3, 1, 31, '1'),
(549, 'atw_week_2_germany', '1', 'atw_week_2_germany', 3, 1, 31, '1'),
(550, 'atw_week_2_vietnam', '1', 'atw_week_2_vietnam', 3, 1, 31, '1'),
(551, 'atw_week_2_cambodia', '1', 'atw_week_2_cambodia', 3, 1, 31, '1'),
(552, 'atw_week_2_china', '1', 'atw_week_2_china', 3, 1, 31, '1'),
(553, 'atw_week_2_south_korea', '1', 'atw_week_2_south_korea', 3, 1, 31, '1'),
(554, 'atw_week_2_canada', '1', 'atw_week_2_canada', 3, 1, 31, '1'),
(555, 'atw_week_2_belize', '1', 'atw_week_2_belize', 3, 1, 31, '1'),
(556, 'atw_week_2_cuba', '1', 'atw_week_2_cuba', 3, 1, 31, '1'),
(557, 'atw_week_2_jamaica', '1', 'atw_week_2_jamaica', 3, 1, 31, '1'),
(558, 'atw_week_2_cameroon', '1', 'atw_week_2_cameroon', 3, 1, 31, '1'),
(559, 'atw_week_2_nigeria', '1', 'atw_week_2_nigeria', 3, 1, 31, '1'),
(560, 'atw_week_2_saudi_arabia', '1', 'atw_week_2_saudi_arabia', 3, 1, 31, '1'),
(561, 'atw_week_2_iraq', '1', 'atw_week_2_iraq', 3, 1, 31, '1'),
(562, 'atw_week_3_sweden', '1', 'atw_week_3_sweden', 3, 1, 31, '1'),
(563, 'atw_week_3_finland', '1', 'atw_week_3_finland', 3, 1, 30, '1'),
(564, 'atw_week_3_spain', '1', 'atw_week_3_spain', 3, 1, 31, '1'),
(565, 'atw_week_3_czech_republic', '1', 'atw_week_3_czech_republic', 3, 1, 31, '1'),
(566, 'atw_week_3_taiwan', '1', 'atw_week_3_taiwan', 3, 1, 31, '1'),
(567, 'atw_week_3_malaysia', '1', 'atw_week_3_malaysia', 3, 1, 31, '1'),
(568, 'atw_week_3_japan', '1', 'atw_week_3_japan', 3, 1, 31, '1'),
(569, 'atw_week_3_honduras', '1', 'atw_week_3_honduras', 3, 1, 31, '1'),
(570, 'atw_week_3_costa_rica', '1', 'atw_week_3_costa_rica', 3, 1, 31, '1'),
(571, 'atw_week_3_panama', '1', 'atw_week_3_panama', 3, 1, 31, '1'),
(572, 'atw_week_3_bahamas', '1', 'atw_week_3_bahamas', 3, 1, 31, '1'),
(573, 'atw_week_3_congo', '1', 'atw_week_3_congo', 3, 1, 31, '1'),
(574, 'atw_week_3_uae', '1', 'atw_week_3_uae', 3, 1, 31, '1'),
(575, 'atw_week_3_ethiopia', '1', 'atw_week_3_ethiopia', 3, 1, 31, '1'),
(576, 'atw_week_3_kuwait', '1', 'atw_week_3_kuwait', 3, 1, 31, '1'),
(577, 'atw_week_4_switzerland', '1', 'atw_week_4_switzerland', 3, 1, 31, '1'),
(578, 'atw_week_4_estonia', '1', 'atw_week_4_estonia', 3, 1, 31, '1'),
(579, 'atw_week_4_poland', '1', 'atw_week_4_poland', 3, 1, 31, '1'),
(580, 'atw_week_4_greece', '1', 'atw_week_4_greece', 3, 1, 31, '1'),
(581, 'atw_week_4_indonesia', '1', 'atw_week_4_indonesia', 3, 1, 31, '1'),
(582, 'atw_week_4_philippines', '1', 'atw_week_4_philippines', 3, 1, 31, '1'),
(583, 'atw_week_4_papua_new_guinea', '1', 'atw_week_4_papua_new_guinea', 3, 1, 31, '1'),
(584, 'colombia', '1', 'colombia', 3, 1, 31, '1'),
(585, 'atw_week_4_venezuela', '1', 'atw_week_4_venezuela', 3, 1, 31, '1'),
(586, 'atw_week_4_ecuador', '1', 'atw_week_4_ecuador', 3, 1, 31, '1'),
(587, 'atw_week_4_peru', '1', 'atw_week_4_peru', 3, 1, 31, '1'),
(588, 'atw_week_4_kenya', '1', 'atw_week_4_kenya', 3, 1, 31, '1'),
(589, 'atw_week_4_angola', '1', 'atw_week_4_angola', 3, 1, 31, '1'),
(590, 'atw_week_4_turkmenistan', '1', 'atw_week_4_turkmenistan', 3, 1, 31, '1'),
(591, 'atw_week_4_iran', '1', 'atw_week_4_iran', 3, 1, 31, '1'),
(592, 'atw_week_5_slovakia', '1', 'atw_week_5_slovakia', 3, 1, 31, '1'),
(593, 'atw_week_5_belarus', '1', 'atw_week_5_belarus', 3, 1, 31, '1'),
(594, 'atw_week_5_ukraine', '1', 'atw_week_5_ukraine', 3, 1, 31, '1'),
(595, 'atw_week_5_turkey', '1', 'atw_week_5_turkey', 3, 1, 31, '1'),
(596, 'atw_week_5_australia', '1', 'atw_week_5_australia', 3, 1, 31, '1'),
(597, 'atw_week_5_samoa', '1', 'atw_week_5_samoa', 3, 1, 31, '1'),
(598, 'atw_week_5_paraguay', '1', 'atw_week_5_paraguay', 3, 1, 31, '1'),
(599, 'atw_week_5_bolivia', '1', 'atw_week_5_bolivia', 3, 1, 31, '1'),
(600, 'atw_week_5_brazil', '1', 'atw_week_5_brazil', 3, 1, 31, '1'),
(601, 'atw_week_5_afghanistan', '1', 'atw_week_5_afghanistan', 3, 1, 31, '1'),
(602, 'atw_week_5_pakistan', '1', 'atw_week_5_pakistan', 3, 1, 31, '1'),
(603, 'atw_week_5_tanzania', '1', 'atw_week_5_tanzania', 3, 1, 31, '1'),
(604, 'green_neon_0', '1', 'green_neon_0', 3, 1, 7, '1'),
(605, 'green_neon_1', '1', 'green_neon_1', 3, 1, 7, '1'),
(606, 'green_neon_2', '1', 'green_neon_2', 3, 1, 7, '1'),
(607, 'green_neon_3', '1', 'green_neon_3', 3, 1, 7, '1'),
(608, 'green_neon_4', '1', 'green_neon_4', 3, 1, 7, '1'),
(609, 'green_neon_5', '1', 'green_neon_5', 3, 1, 7, '1'),
(610, 'green_neon_6', '1', 'green_neon_6', 3, 1, 7, '1'),
(611, 'green_neon_7', '1', 'green_neon_7', 3, 1, 7, '1'),
(612, 'green_neon_8', '1', 'green_neon_8', 3, 1, 7, '1'),
(613, 'green_neon_9', '1', 'green_neon_9', 3, 1, 7, '1'),
(614, 'green_neon_a', '1', 'green_neon_a', 3, 1, 7, '1'),
(615, 'green_neon_b', '1', 'green_neon_b', 3, 1, 7, '1'),
(616, 'green_neon_c', '1', 'green_neon_c', 3, 1, 7, '1'),
(617, 'green_neon_d', '1', 'green_neon_d', 3, 1, 7, '1'),
(618, 'green_neon_e', '1', 'green_neon_e', 3, 1, 7, '1'),
(619, 'green_neon_f', '1', 'green_neon_f', 3, 1, 7, '1'),
(620, 'green_neon_g', '1', 'green_neon_g', 3, 1, 7, '1'),
(621, 'green_neon_h', '1', 'green_neon_h', 3, 1, 7, '1'),
(622, 'green_neon_i', '1', 'green_neon_i', 3, 1, 7, '1'),
(623, 'green_neon_j', '1', 'green_neon_j', 3, 1, 7, '1'),
(624, 'green_neon_k', '1', 'green_neon_k', 3, 1, 7, '1'),
(625, 'green_neon_l', '1', 'green_neon_l', 3, 1, 7, '1'),
(626, 'green_neon_m', '1', 'green_neon_m', 3, 1, 7, '1'),
(627, 'green_neon_n', '1', 'green_neon_n', 3, 1, 7, '1'),
(628, 'green_neon_o', '1', 'green_neon_o', 3, 1, 7, '1'),
(629, 'green_neon_p', '1', 'green_neon_p', 3, 1, 7, '1'),
(630, 'green_neon_q', '1', 'green_neon_q', 3, 1, 7, '1'),
(631, 'green_neon_r', '1', 'green_neon_r', 3, 1, 7, '1'),
(632, 'green_neon_s', '1', 'green_neon_s', 3, 1, 7, '1'),
(633, 'green_neon_t', '1', 'green_neon_t', 3, 1, 7, '1'),
(634, 'green_neon_u', '1', 'green_neon_u', 3, 1, 7, '1'),
(635, 'green_neon_v', '1', 'green_neon_v', 3, 1, 7, '1'),
(636, 'green_neon_w', '1', 'green_neon_w', 3, 1, 7, '1'),
(637, 'green_neon_x', '1', 'green_neon_x', 3, 1, 7, '1'),
(638, 'green_neon_y', '1', 'green_neon_y', 3, 1, 7, '1'),
(639, 'green_neon_z', '1', 'green_neon_z', 3, 1, 7, '1'),
(640, 'neon_blue_0', '1', 'neon_blue_0', 3, 1, 7, '1'),
(641, 'neon_blue_1', '1', 'neon_blue_1', 3, 1, 7, '1'),
(642, 'neon_blue_2', '1', 'neon_blue_2', 3, 1, 7, '1'),
(643, 'neon_blue_3', '1', 'neon_blue_3', 3, 1, 7, '1'),
(644, 'neon_blue_4', '1', 'neon_blue_4', 3, 1, 7, '1'),
(645, 'neon_blue_5', '1', 'neon_blue_5', 3, 1, 7, '1'),
(646, 'neon_blue_6', '1', 'neon_blue_6', 3, 1, 7, '1'),
(647, 'neon_blue_7', '1', 'neon_blue_7', 3, 1, 7, '1'),
(648, 'neon_blue_8', '1', 'neon_blue_8', 3, 1, 7, '1'),
(649, 'neon_blue_9', '1', 'neon_blue_9', 3, 1, 7, '1'),
(650, 'neon_blue_a', '1', 'neon_blue_a', 3, 1, 7, '1'),
(651, 'neon_blue_b', '1', 'neon_blue_b', 3, 1, 7, '1'),
(652, 'neon_blue_c', '1', 'neon_blue_c', 3, 1, 7, '1'),
(653, 'neon_blue_d', '1', 'neon_blue_d', 3, 1, 7, '1'),
(654, 'neon_blue_e', '1', 'neon_blue_e', 3, 1, 7, '1'),
(655, 'neon_blue_f', '1', 'neon_blue_f', 3, 1, 7, '1'),
(656, 'neon_blue_g', '1', 'neon_blue_g', 3, 1, 7, '1'),
(657, 'neon_blue_h', '1', 'neon_blue_h', 3, 1, 7, '1'),
(658, 'neon_blue_i', '1', 'neon_blue_i', 3, 1, 7, '1'),
(659, 'neon_blue_j', '1', 'neon_blue_j', 3, 1, 7, '1'),
(660, 'neon_blue_k', '1', 'neon_blue_k', 3, 1, 7, '1'),
(661, 'neon_blue_l', '1', 'neon_blue_l', 3, 1, 7, '1'),
(662, 'neon_blue_m', '1', 'neon_blue_m', 3, 1, 7, '1'),
(663, 'neon_blue_n', '1', 'neon_blue_n', 3, 1, 7, '1'),
(664, 'neon_blue_o', '1', 'neon_blue_o', 3, 1, 7, '1'),
(665, 'neon_blue_p', '1', 'neon_blue_p', 3, 1, 7, '1'),
(666, 'neon_blue_q', '1', 'neon_blue_q', 3, 1, 7, '1'),
(667, 'neon_blue_r', '1', 'neon_blue_r', 3, 1, 7, '1'),
(668, 'neon_blue_s', '1', 'neon_blue_s', 3, 1, 7, '1'),
(669, 'neon_blue_t', '1', 'neon_blue_t', 3, 1, 7, '1'),
(670, 'neon_blue_u', '1', 'neon_blue_u', 3, 1, 7, '1'),
(671, 'neon_blue_v', '1', 'neon_blue_v', 3, 1, 7, '1'),
(672, 'neon_blue_w', '1', 'neon_blue_w', 3, 1, 7, '1'),
(673, 'neon_blue_x', '1', 'neon_blue_x', 3, 1, 7, '1'),
(674, 'neon_blue_y', '1', 'neon_blue_y', 3, 1, 7, '1'),
(675, 'neon_blue_z', '1', 'neon_blue_z', 3, 1, 7, '1'),
(676, 'neon_pink_0', '1', 'neon_pink_0', 3, 1, 7, '1'),
(677, 'neon_pink_1', '1', 'neon_pink_1', 3, 1, 7, '1'),
(678, 'neon_pink_2', '1', 'neon_pink_2', 3, 1, 7, '1'),
(679, 'neon_pink_3', '1', 'neon_pink_3', 3, 1, 7, '1'),
(680, 'neon_pink_4', '1', 'neon_pink_4', 3, 1, 7, '1'),
(681, 'neon_pink_5', '1', 'neon_pink_5', 3, 1, 7, '1'),
(682, 'neon_pink_6', '1', 'neon_pink_6', 3, 1, 7, '1'),
(683, 'neon_pink_7', '1', 'neon_pink_7', 3, 1, 7, '1'),
(684, 'neon_pink_8', '1', 'neon_pink_8', 3, 1, 7, '1'),
(685, 'neon_pink_9', '1', 'neon_pink_9', 3, 1, 7, '1'),
(686, 'neon_pink_a', '1', 'neon_pink_a', 3, 1, 7, '1'),
(687, 'neon_pink_b', '1', 'neon_pink_b', 3, 1, 7, '1'),
(688, 'neon_pink_c', '1', 'neon_pink_c', 3, 1, 7, '1'),
(689, 'neon_pink_d', '1', 'neon_pink_d', 3, 1, 7, '1'),
(690, 'neon_pink_e', '1', 'neon_pink_e', 3, 1, 7, '1'),
(691, 'neon_pink_f', '1', 'neon_pink_f', 3, 1, 7, '1'),
(692, 'neon_pink_g', '1', 'neon_pink_g', 3, 1, 7, '1'),
(693, 'neon_pink_h', '1', 'neon_pink_h', 3, 1, 7, '1'),
(694, 'neon_pink_i', '1', 'neon_pink_i', 3, 1, 7, '1'),
(695, 'neon_pink_j', '1', 'neon_pink_j', 3, 1, 7, '1'),
(696, 'neon_pink_k', '1', 'neon_pink_k', 3, 1, 7, '1'),
(697, 'neon_pink_l', '1', 'neon_pink_l', 3, 1, 7, '1'),
(698, 'neon_pink_m', '1', 'neon_pink_m', 3, 1, 7, '1'),
(699, 'neon_pink_n', '1', 'neon_pink_n', 3, 1, 7, '1'),
(700, 'neon_pink_o', '1', 'neon_pink_o', 3, 1, 7, '1'),
(701, 'neon_pink_p', '1', 'neon_pink_p', 3, 1, 7, '1'),
(702, 'neon_pink_q', '1', 'neon_pink_q', 3, 1, 7, '1'),
(703, 'neon_pink_r', '1', 'neon_pink_r', 3, 1, 7, '1'),
(704, 'neon_pink_s', '1', 'neon_pink_s', 3, 1, 7, '1'),
(705, 'neon_pink_t', '1', 'neon_pink_t', 3, 1, 7, '1'),
(706, 'neon_pink_u', '1', 'neon_pink_u', 3, 1, 7, '1'),
(707, 'neon_pink_v', '1', 'neon_pink_v', 3, 1, 7, '1'),
(708, 'neon_pink_w', '1', 'neon_pink_w', 3, 1, 7, '1'),
(709, 'neon_pink_x', '1', 'neon_pink_x', 3, 1, 7, '1'),
(710, 'neon_pink_y', '1', 'neon_pink_y', 3, 1, 7, '1'),
(711, 'neon_pink_z', '1', 'neon_pink_z', 3, 1, 7, '1'),
(712, 'locoroco_sticker_125x100', '1', 'locoroco_sticker_125x100', 3, 1, 28, '1'),
(713, 'atw_week_5_namibia', '1', 'atw_week_5_namibia', 3, 1, 31, '1'),
(714, 'atw_week_5_solomon-islands', '1', 'atw_week_5_solomon-islands', 3, 1, 31, '1'),
(715, 'atw_week_5_solomon_islands', '1', 'atw_week_5_solomon_islands', 3, 1, 31, '1'),
(716, 'atw_week_6_russia', '1', 'atw_week_6_russia', 3, 1, 31, '1'),
(717, 'atw_week_6_uruguay', '1', 'atw_week_6_uruguay', 3, 1, 31, '1'),
(718, 'atw_week_6_chile', '1', 'atw_week_6_chile', 3, 1, 31, '1'),
(719, 'atw_week_6_argentina', '1', 'atw_week_6_argentina', 3, 1, 31, '1'),
(720, 'atw_week_6_latvia', '1', 'atw_week_6_latvia', 3, 1, 31, '1'),
(721, 'atw_week_6_bulgaria', '1', 'atw_week_6_bulgaria', 3, 1, 31, '1'),
(722, 'atw_week_6_romania', '1', 'atw_week_6_romania', 3, 1, 31, '1'),
(723, 'atw_week_6_hungary', '1', 'atw_week_6_hungary', 3, 1, 31, '1'),
(724, 'atw_week_6_fiji', '1', 'atw_week_6_fiji', 3, 1, 31, '1'),
(725, 'atw_week_6_tonga', '1', 'atw_week_6_tonga', 3, 1, 31, '1'),
(726, 'atw_week_6_new_zealand', '1', 'atw_week_6_new_zealand', 3, 1, 31, '1'),
(727, 'atw_week_6_south_africa', '1', 'atw_week_6_south_africa', 3, 1, 31, '1'),
(728, 'atw_week_6_madagascar', '1', 'atw_week_6_madagascar', 3, 1, 31, '1'),
(729, 'atw_week_6_botswana', '1', 'atw_week_6_botswana', 3, 1, 31, '1'),
(730, 'atw_week_6_oman', '1', 'atw_week_6_oman', 3, 1, 31, '1'),
(731, 'knifescrime_sticker_01', '1', 'knifescrime_sticker_01', 3, 1, 24, '1'),
(732, 'childline_habbo_stickers_generic_gold', '1', 'childline_habbo_stickers_generic_gold', 3, 1, 28, '1'),
(733, 'childline_habbo_stickers_generic_green', '1', 'childline_habbo_stickers_generic_green', 3, 1, 28, '1'),
(734, 'st_day1', '1', 'st_day1', 3, 1, 30, '1'),
(735, 'st_day2', '1', 'st_day2', 3, 1, 30, '1'),
(736, 'st_day3', '1', 'st_day3', 3, 1, 30, '1'),
(737, 'st_day4', '1', 'st_day4', 3, 1, 30, '1'),
(738, 'st_day5', '1', 'st_day5', 3, 1, 36, '1'),
(739, '8th_birthday_sticker_01', '1', '8th_birthday_sticker_01', 3, 1, 30, '1'),
(740, '8th_birthday_sticker_02', '1', '8th_birthday_sticker_02', 3, 1, 30, '1'),
(741, '8th_birthday_sticker_03', '1', '8th_birthday_sticker_03', 3, 1, 30, '1'),
(742, '8th_birthday_sticker_04', '1', '8th_birthday_sticker_04', 3, 1, 30, '1'),
(743, '8th_birthday_sticker_05', '1', '8th_birthday_sticker_05', 3, 1, 30, '1'),
(744, 'childline_habbo_stickers_production_gold', '1', 'childline_habbo_stickers_production_gold', 3, 1, 28, '1'),
(745, 'childline_habbo_stickers_production_green', '1', 'childline_habbo_stickers_production_green', 3, 1, 28, '1'),
(746, 'h4d_sticker_02', '1', 'h4d_sticker_02', 3, 1, 28, '1'),
(747, 'h4d_sticker_04', '1', 'h4d_sticker_04', 3, 1, 28, '1'),
(748, 'h4d_sticker_01', '1', 'h4d_sticker_01', 3, 1, 28, '1'),
(749, 'habwrecked_sticker_01_190x180', '1', 'habwrecked_sticker_01_190x180', 3, 1, 30, '1'),
(750, 'habwrecked_sticker_02_190x180', '1', 'habwrecked_sticker_02_190x180', 3, 1, 30, '1'),
(751, 'knifescrime_sticker_02', '1', 'knifescrime_sticker_02', 3, 1, 28, '1'),
(752, 'bluestarfish', '1', 'bluestarfish', 3, 1, 32, '1'),
(753, 'redstarfish', '1', 'redstarfish', 3, 1, 32, '1'),
(754, 'yellowstarfish', '1', 'yellowstarfish', 3, 1, 32, '1'),
(755, 'seagull_01', '1', 'seagull_01', 3, 1, 32, '1'),
(756, 'seagull_02', '1', 'seagull_02', 3, 1, 32, '1'),
(757, 'island', '1', 'island', 3, 1, 30, '1'),
(758, 'edito_fisherman_bait', '1', 'edito_fisherman_bait', 3, 1, 35, '1'),
(759, 'shell', '1', 'shell', 3, 1, 32, '1'),
(760, 'au_lifesaver', '1', 'au_lifesaver', 3, 1, 24, '1'),
(761, 'sunflower', '1', 'sunflower', 3, 1, 32, '1'),
(762, 'clothesline', '1', 'clothesline', 3, 1, 32, '1'),
(763, 'summer_rowingboat', '1', 'summer_rowingboat', 3, 1, 35, '1'),
(764, 'summer_cloud2', '1', 'summer_cloud2', 3, 1, 32, '1'),
(765, 'summer_cloud3', '1', 'summer_cloud3', 3, 1, 32, '1'),
(766, 'summer_cloud1', '1', 'summer_cloud1', 3, 1, 32, '1'),
(767, 'summer_swim_trunk', '1', 'summer_swim_trunk', 3, 1, 35, '1'),
(768, 'sticker_woodboard', '1', 'sticker_woodboard', 3, 1, 32, '1'),
(769, 'sticker_volcano', '1', 'sticker_volcano', 3, 1, 32, '1'),
(770, 'circus_sticker_tragafuegos', '1', 'circus_sticker_tragafuegos', 3, 1, 24, '1'),
(771, 'habwrecked_sticker_04_150x180', '1', 'habwrecked_sticker_04_150x180', 3, 1, 30, '1'),
(772, 'habwrecked_sticker_07_70x95', '1', 'habwrecked_sticker_07_70x95', 3, 1, 32, '1'),
(773, 'habwrecked_sticker_05_180x125', '1', 'habwrecked_sticker_05_180x125', 3, 1, 30, '1'),
(774, 'habwrecked_sticker_06_90x70', '1', 'habwrecked_sticker_06_90x70', 3, 1, 32, '1'),
(775, 'habwrecked_sticker_09_45x90', '1', 'habwrecked_sticker_09_45x90', 3, 1, 35, '1'),
(776, 'habwrecked_sticker_12_60x92', '1', 'habwrecked_sticker_12_60x92', 3, 1, 24, '1'),
(777, 'habwrecked_sticker_10_45x90', '1', 'habwrecked_sticker_10_45x90', 3, 1, 35, '1'),
(778, 'habwrecked_sticker_11_45x90', '1', 'habwrecked_sticker_11_45x90', 3, 1, 35, '1'),
(779, 'habwrecked_sticker_08_45x90', '1', 'habwrecked_sticker_08_45x90', 3, 1, 35, '1'),
(780, 'streaker', '1', 'streaker', 3, 1, 24, '1'),
(781, 'childline_habbo_stickers_accman_gold', '1', 'childline_habbo_stickers_accman_gold', 3, 1, 28, '1'),
(782, 'childline_habbo_stickers_accman_green', '1', 'childline_habbo_stickers_accman_green', 3, 1, 28, '1'),
(783, 'stick_stickukmyspace1', '1', 'stick_stickukmyspace1', 3, 1, 28, '1'),
(784, 'bionicle_sticker_01', '1', 'bionicle_sticker_01', 3, 1, 28, '1'),
(785, 'bionicle_sticker_02', '1', 'bionicle_sticker_02', 3, 1, 24, '1'),
(786, 'bionicle_sticker_03', '1', 'bionicle_sticker_03', 3, 1, 28, '1'),
(787, 'pixie_habbo_sticker_04', '1', 'pixie_habbo_sticker_04', 3, 1, 28, '1'),
(788, 'pixie_habbo_sticker_02', '1', 'pixie_habbo_sticker_02', 3, 1, 28, '1'),
(789, 'pixie_habbo_sticker_01', '1', 'pixie_habbo_sticker_01', 3, 1, 28, '1'),
(790, 'pixie_habbo_sticker_03', '1', 'pixie_habbo_sticker_03', 3, 1, 28, '1'),
(791, 'habprentice_sticker_01', '1', 'habprentice_sticker_01', 3, 1, 30, '1'),
(792, 'habprentice_sticker_02', '1', 'habprentice_sticker_02', 3, 1, 24, '1'),
(793, 'habprentice_sticker_03', '1', 'habprentice_sticker_03', 3, 1, 30, '1'),
(794, 'sticker_earth_hour', '1', 'sticker_earth_hour', 3, 1, 28, '1'),
(795, 'childline_habbo_stickers_creative_gold', '1', 'childline_habbo_stickers_creative_gold', 3, 1, 28, '1'),
(796, 'childline_habbo_stickers_creative_blue', '1', 'childline_habbo_stickers_creative_blue', 3, 1, 28, '1'),
(797, 'stick_easter_char2', '1', 'stick_easter_char2', 3, 1, 24, '1'),
(798, 'stick_easter_char1', '1', 'stick_easter_char1', 3, 1, 24, '1'),
(799, 'stick_easter_tree4', '1', 'stick_easter_tree4', 3, 1, 34, '1'),
(800, 'stick_easter_tree3', '1', 'stick_easter_tree3', 3, 1, 34, '1'),
(801, 'stick_easter_tree2', '1', 'stick_easter_tree2', 3, 1, 34, '1'),
(802, 'stick_easter_tree1', '1', 'stick_easter_tree1', 3, 1, 34, '1'),
(803, 'stick_easter_char8', '1', 'stick_easter_char8', 3, 1, 24, '1'),
(804, 'stick_easter_char7', '1', 'stick_easter_char7', 3, 1, 24, '1'),
(805, 'stick_easter_char6', '1', 'stick_easter_char6', 3, 1, 24, '1'),
(807, 'stick_easter_char4', '1', 'stick_easter_char4', 3, 1, 24, '1'),
(808, 'iovetree', '1', 'iovetree', 3, 1, 34, '1'),
(809, 'easter_tree_1', '1', 'easter_tree_1', 3, 1, 34, '1'),
(810, 'easter_tree_2', '1', 'easter_tree_2', 3, 1, 34, '1'),
(811, 'easter_tree_3', '1', 'easter_tree_3', 3, 1, 34, '1'),
(812, 'easter_tree_4', '1', 'easter_tree_4', 3, 1, 34, '1'),
(813, 'green_leaf_lower_left', '1', 'green_leaf_lower_left', 3, 1, 32, '1'),
(814, 'green_leaf_lower_right', '1', 'green_leaf_lower_right', 3, 1, 32, '1'),
(815, 'green_leaf_top_left', '1', 'green_leaf_top_left', 3, 1, 32, '1'),
(817, 'light_green_leaf_lower_left', '1', 'light_green_leaf_lower_left', 3, 1, 32, '1'),
(818, 'light_green_leaf_lower_right', '1', 'light_green_leaf_lower_right', 3, 1, 32, '1'),
(819, 'light_green_leaf_top_left', '1', 'light_green_leaf_top_left', 3, 1, 32, '1'),
(820, 'light_green_leaf_top_right', '1', 'light_green_leaf_top_right', 3, 1, 32, '1'),
(821, 'love_the_earth_avatar_tree', '1', 'love_the_earth_avatar_tree', 3, 1, 34, '1'),
(822, 'stick_easter_char3', '1', 'stick_easter_char3', 3, 1, 24, '1'),
(823, 'childline_habbo_stickers_proman_green_002', '1', 'childline_habbo_stickers_proman_green_002', 3, 1, 28, '1'),
(824, 'childline_habbo_stickers_proman_gold', '1', 'childline_habbo_stickers_proman_gold', 3, 1, 28, '1'),
(825, 'sticker_skidsr', '1', 'sticker_skidsr', 3, 1, 32, '1'),
(826, 'sticker_checkeredflagl', '1', 'sticker_checkeredflagl', 3, 1, 32, '1'),
(827, 'sticker_rcdriverf', '1', 'sticker_rcdriverf', 3, 1, 35, '1'),
(828, 'sticker_skidsl', '1', 'sticker_skidsl', 3, 1, 32, '1'),
(829, 'sticker_checkeredflagr', '1', 'sticker_checkeredflagr', 3, 1, 32, '1'),
(830, 'sticker_rcdriverm1', '1', 'sticker_rcdriverm1', 3, 1, 35, '1'),
(831, 'blue_diner_a', '1', 'blue_diner_a', 3, 1, 7, '1'),
(832, 'blue_diner_a_umlaut', '1', 'blue_diner_a_umlaut', 3, 1, 7, '1'),
(833, 'blue_diner_ae', '1', 'blue_diner_ae', 3, 1, 7, '1'),
(834, 'blue_diner_b', '1', 'blue_diner_b', 3, 1, 7, '1'),
(835, 'blue_diner_c', '1', 'blue_diner_c', 3, 1, 7, '1'),
(836, 'blue_diner_c_cedilla', '1', 'blue_diner_c_cedilla', 3, 1, 7, '1'),
(837, 'blue_diner_d', '1', 'blue_diner_d', 3, 1, 7, '1'),
(838, 'blue_diner_e', '1', 'blue_diner_e', 3, 1, 7, '1'),
(839, 'blue_diner_e_acc', '1', 'blue_diner_e_acc', 3, 1, 7, '1'),
(840, 'blue_diner_e_acc_grave', '1', 'blue_diner_e_acc_grave', 3, 1, 7, '1'),
(841, 'blue_diner_eight', '1', 'blue_diner_eight', 3, 1, 7, '1'),
(842, 'blue_diner_exclamation', '1', 'blue_diner_exclamation', 3, 1, 7, '1'),
(843, 'blue_diner_f', '1', 'blue_diner_f', 3, 1, 7, '1'),
(844, 'blue_diner_five', '1', 'blue_diner_five', 3, 1, 7, '1'),
(845, 'blue_diner_four', '1', 'blue_diner_four', 3, 1, 7, '1'),
(846, 'blue_diner_g', '1', 'blue_diner_g', 3, 1, 7, '1'),
(847, 'blue_diner_h', '1', 'blue_diner_h', 3, 1, 7, '1'),
(848, 'blue_diner_i', '1', 'blue_diner_i', 3, 1, 7, '1'),
(849, 'blue_diner_j', '1', 'blue_diner_j', 3, 1, 7, '1'),
(850, 'blue_diner_k', '1', 'blue_diner_k', 3, 1, 7, '1'),
(851, 'blue_diner_l', '1', 'blue_diner_l', 3, 1, 7, '1'),
(852, 'blue_diner_m', '1', 'blue_diner_m', 3, 1, 7, '1'),
(853, 'blue_diner_n', '1', 'blue_diner_n', 3, 1, 7, '1'),
(854, 'blue_diner_nine', '1', 'blue_diner_nine', 3, 1, 7, '1');
INSERT INTO `homes_catalog` (`id`, `name`, `type`, `data`, `price`, `amount`, `category`, `sorted`) VALUES
(855, 'blue_diner_o', '1', 'blue_diner_o', 3, 1, 7, '1'),
(856, 'blue_diner_o_accute', '1', 'blue_diner_o_accute', 3, 1, 7, '1'),
(857, 'blue_diner_o_cc_grave', '1', 'blue_diner_o_cc_grave', 3, 1, 7, '1'),
(858, 'blue_diner_o_umlaut', '1', 'blue_diner_o_umlaut', 3, 1, 7, '1'),
(859, 'blue_diner_one', '1', 'blue_diner_one', 3, 1, 7, '1'),
(860, 'blue_diner_p', '1', 'blue_diner_p', 3, 1, 7, '1'),
(861, 'blue_diner_q', '1', 'blue_diner_q', 3, 1, 7, '1'),
(862, 'blue_diner_question', '1', 'blue_diner_question', 3, 1, 7, '1'),
(863, 'blue_diner_r', '1', 'blue_diner_r', 3, 1, 7, '1'),
(864, 'blue_diner_s', '1', 'blue_diner_s', 3, 1, 7, '1'),
(865, 'blue_diner_seven', '1', 'blue_diner_seven', 3, 1, 7, '1'),
(866, 'blue_diner_six', '1', 'blue_diner_six', 3, 1, 7, '1'),
(867, 'blue_diner_t', '1', 'blue_diner_t', 3, 1, 7, '1'),
(868, 'blue_diner_three', '1', 'blue_diner_three', 3, 1, 7, '1'),
(869, 'blue_diner_two', '1', 'blue_diner_two', 3, 1, 7, '1'),
(870, 'blue_diner_u', '1', 'blue_diner_u', 3, 1, 7, '1'),
(871, 'blue_diner_u_acc', '1', 'blue_diner_u_acc', 3, 1, 7, '1'),
(872, 'blue_diner_u_acc_grave', '1', 'blue_diner_u_acc_grave', 3, 1, 7, '1'),
(873, 'blue_diner_u_umlaut', '1', 'blue_diner_u_umlaut', 3, 1, 7, '1'),
(874, 'blue_diner_upsidedown', '1', 'blue_diner_upsidedown', 3, 1, 7, '1'),
(875, 'blue_diner_v', '1', 'blue_diner_v', 3, 1, 7, '1'),
(876, 'blue_diner_w', '1', 'blue_diner_w', 3, 1, 7, '1'),
(877, 'blue_diner_x', '1', 'blue_diner_x', 3, 1, 7, '1'),
(878, 'blue_diner_y', '1', 'blue_diner_y', 3, 1, 7, '1'),
(879, 'blue_diner_z', '1', 'blue_diner_z', 3, 1, 7, '1'),
(880, 'blue_diner_zero', '1', 'blue_diner_zero', 3, 1, 7, '1'),
(881, 'groupofhabbos', '1', 'groupofhabbos', 3, 1, 30, '1'),
(883, 'cint_logo', '1', 'cint_logo', 3, 1, 28, '1'),
(884, 'sticker_mall_3', '1', 'sticker_mall_3', 3, 1, 30, '1'),
(885, 'sticker_mall_4', '1', 'sticker_mall_4', 3, 1, 30, '1'),
(886, 'sticker_newcow', '1', 'sticker_newcow', 3, 1, 24, '1'),
(887, 'sticker_country_donkey', '1', 'sticker_country_donkey', 3, 1, 24, '1'),
(888, 'stick_country_sheep1', '1', 'stick_country_sheep1', 3, 1, 32, '1'),
(889, 'stick_country_sheep2', '1', 'stick_country_sheep2', 3, 1, 32, '1'),
(890, 'stick_country_horse', '1', 'stick_country_horse', 3, 1, 24, '1'),
(891, 'stick_country_pig', '1', 'stick_country_pig', 3, 1, 32, '1'),
(892, 'stick_country_cow', '1', 'stick_country_cow', 3, 1, 24, '1'),
(893, 'stick_country_cow2', '1', 'stick_country_cow2', 3, 1, 24, '1'),
(894, 'childline_habbo_stickers_planner_gold', '1', 'childline_habbo_stickers_planner_gold', 3, 1, 28, '1'),
(895, 'childline_habbo_stickers_planner_blue', '1', 'childline_habbo_stickers_planner_blue', 3, 1, 28, '1'),
(896, 'ukbigbrothersticker', '1', 'ukbigbrothersticker', 3, 1, 30, '1'),
(897, 'drsticker', '1', 'drsticker', 3, 1, 28, '1'),
(898, 'arm_sticker_1_001', '1', 'arm_sticker_1_001', 3, 1, 28, '1'),
(899, 'arm_sticker_2_001', '1', 'arm_sticker_2_001', 3, 1, 28, '1'),
(900, 'stick_uk_starshine', '1', 'stick_uk_starshine', 3, 1, 25, '1'),
(901, 'stick_hween09_keyboardhands', '1', 'stick_hween09_keyboardhands', 3, 1, 32, '1'),
(902, 'stick_hween09_exclamation', '1', 'stick_hween09_exclamation', 3, 1, 32, '1'),
(903, 'stick_hween09_alien', '1', 'stick_hween09_alien', 3, 1, 32, '1'),
(904, 'stick_hween09_cctv', '1', 'stick_hween09_cctv', 3, 1, 32, '1'),
(905, 'stick_hween09_infobox', '1', 'stick_hween09_infobox', 3, 1, 30, '1'),
(906, 'stick_hween09_videocam2', '1', 'stick_hween09_videocam2', 3, 1, 30, '1'),
(908, 'stick_hween09_newsofhabbo', '1', 'stick_hween09_newsofhabbo', 3, 1, 28, '1'),
(909, 'stick_howufeelin_face', '1', 'stick_howufeelin_face', 3, 1, 28, '1'),
(910, 'childline_01', '1', 'childline_01', 3, 1, 28, '1'),
(911, 'childline_02', '1', 'childline_02', 3, 1, 28, '1'),
(912, 'moodi_01', '1', 'moodi_01', 3, 1, 28, '1'),
(913, 'moodi_02', '1', 'moodi_02', 3, 1, 28, '1'),
(914, 'moodi_03', '1', 'moodi_03', 3, 1, 28, '1'),
(915, 'moodi_04', '1', 'moodi_04', 3, 1, 28, '1'),
(916, 'moodi_05', '1', 'moodi_05', 3, 1, 28, '1'),
(917, 'moodi_06', '1', 'moodi_06', 3, 1, 28, '1'),
(918, 'moodi_07', '1', 'moodi_07', 3, 1, 28, '1'),
(919, 'moodi_08', '1', 'moodi_08', 3, 1, 28, '1'),
(920, 'moodi_09', '1', 'moodi_09', 3, 1, 28, '1'),
(921, 'moodi_10', '1', 'moodi_10', 3, 1, 28, '1'),
(922, 'moodi_11', '1', 'moodi_11', 3, 1, 28, '1'),
(923, 'moodi_12', '1', 'moodi_12', 3, 1, 28, '1'),
(924, 'moodi_13', '1', 'moodi_13', 3, 1, 28, '1'),
(925, 'moodi_14', '1', 'moodi_14', 3, 1, 28, '1'),
(926, 'moodi_15', '1', 'moodi_15', 3, 1, 28, '1'),
(927, 'uk_maze_09_champion_sticker', '1', 'uk_maze_09_champion_sticker', 3, 1, 30, '1'),
(928, 'uk_bullyproof_sticker_01', '1', 'uk_bullyproof_sticker_01', 3, 1, 28, '1'),
(929, 'xmas2009_bauble', '1', 'xmas2009_bauble', 3, 1, 29, '1'),
(930, 'xmas2009_bubbledrink', '1', 'xmas2009_bubbledrink', 3, 1, 32, '1'),
(931, 'xmas2009_cakes', '1', 'xmas2009_cakes', 3, 1, 29, '1'),
(932, 'xmas2009_elfbadge', '1', 'xmas2009_elfbadge', 3, 1, 32, '1'),
(933, 'xmas2009_reindeerpin', '1', 'xmas2009_reindeerpin', 3, 1, 29, '1'),
(934, 'xmas2009_snowshake', '1', 'xmas2009_snowshake', 3, 1, 29, '1'),
(935, 'stick_pj_ares', '1', 'stick_pj_ares', 3, 1, 28, '1'),
(936, 'stick_pj_cyclops', '1', 'stick_pj_cyclops', 3, 1, 28, '1'),
(937, 'stick_pj_hephaestus', '1', 'stick_pj_hephaestus', 3, 1, 28, '1'),
(938, 'stick_pj_hermes', '1', 'stick_pj_hermes', 3, 1, 24, '1'),
(939, 'stick_pj_poseidon', '1', 'stick_pj_poseidon', 3, 1, 28, '1'),
(940, 'stick_pj_zeus', '1', 'stick_pj_zeus', 3, 1, 28, '1'),
(941, 'sticker_yir', '1', 'sticker_yir', 3, 1, 28, '1'),
(942, 'circus_sticker_payaso', '1', 'circus_sticker_payaso', 3, 1, 24, '1'),
(943, 'sticker_tlc', '1', 'sticker_tlc', 3, 1, 28, '1'),
(944, 'sticker_fire', '1', 'sticker_fire', 3, 1, 24, '1'),
(945, 'stick_habbolympics_gold', '1', 'stick_habbolympics_gold', 3, 1, 30, '1'),
(946, 'stick_habbolympics_silver', '1', 'stick_habbolympics_silver', 3, 1, 30, '1'),
(947, 'stick_habbolympics_bronze', '1', 'stick_habbolympics_bronze', 3, 1, 30, '1'),
(948, 'sticker_loudmouth', '1', 'sticker_loudmouth', 3, 1, 28, '1'),
(949, 'sticker_cryboy', '1', 'sticker_cryboy', 3, 1, 28, '1'),
(950, 'sticker_clown', '1', 'sticker_clown', 3, 1, 28, '1'),
(951, 'uk_fairytales_bookcase', '1', 'uk_fairytales_bookcase', 3, 1, 32, '1'),
(952, 'uk_fairytales_book_01', '1', 'uk_fairytales_book_01', 3, 1, 30, '1'),
(953, 'uk_fairytales_sticker_01', '1', 'uk_fairytales_sticker_01', 3, 1, 30, '1'),
(954, 'hw_uk_fairytales_sticker_02', '1', 'hw_uk_fairytales_sticker_02', 3, 1, 30, '1'),
(955, 'hw_uk_fairytales_sticker_03', '1', 'hw_uk_fairytales_sticker_03', 3, 1, 32, '1'),
(956, 'uk_fairytales_book_02', '1', 'uk_fairytales_book_02', 3, 1, 30, '1'),
(957, 'uk_fairytales_book_03', '1', 'uk_fairytales_book_03', 3, 1, 30, '1'),
(958, 'hw_stpat2010_kiss1', '1', 'hw_stpat2010_kiss1', 3, 1, 29, '1'),
(959, 'hw_stpat2010_kiss2', '1', 'hw_stpat2010_kiss2', 3, 1, 29, '1'),
(960, 'hw_stpat2010_stpatdrink', '1', 'hw_stpat2010_stpatdrink', 3, 1, 29, '1'),
(961, 'hw_stpat2010_pantsf', '1', 'hw_stpat2010_pantsf', 3, 1, 35, '1'),
(962, 'hw_stpat2010_pantsm', '1', 'hw_stpat2010_pantsm', 3, 1, 29, '1'),
(963, 'hw_stpat2010_tshirtf', '1', 'hw_stpat2010_tshirtf', 3, 1, 29, '1'),
(964, 'hw_stpat2010_tshirtm', '1', 'hw_stpat2010_tshirtm', 3, 1, 29, '1'),
(965, 'hw_stpat2010_hat', '1', 'hw_stpat2010_hat', 3, 1, 29, '1'),
(966, 'hw_stpat2010_bighat', '1', 'hw_stpat2010_bighat', 3, 1, 29, '1'),
(967, 'hw_stpat2010_lepricornoutfit', '1', 'hw_stpat2010_lepricornoutfit', 3, 1, 29, '1'),
(968, 'hw_stpat2010_femalelepricorn', '1', 'hw_stpat2010_femalelepricorn', 3, 1, 35, '1'),
(969, 'hw_stpat2010_cider', '1', 'hw_stpat2010_cider', 3, 1, 32, '1'),
(970, 'hw_stpat2010_border1', '1', 'hw_stpat2010_border1', 3, 1, 22, '1'),
(971, 'hw_stpat2010_border2', '1', 'hw_stpat2010_border2', 3, 1, 22, '1'),
(972, 'hw_stpat2010_potofgold', '1', 'hw_stpat2010_potofgold', 3, 1, 29, '1'),
(973, 'hw_stpat2010_shamrock', '1', 'hw_stpat2010_shamrock', 3, 1, 29, '1'),
(974, 'uk_fairytales_book_04', '1', 'uk_fairytales_book_04', 3, 1, 30, '1'),
(975, 'uk_fairytales_book_05', '1', 'uk_fairytales_book_05', 3, 1, 30, '1'),
(976, 'uk_fairytales_book_06', '1', 'uk_fairytales_book_06', 3, 1, 30, '1'),
(977, 'uk_fairytales_book_07', '1', 'uk_fairytales_book_07', 3, 1, 30, '1'),
(978, 'uk_fairytales_book_08', '1', 'uk_fairytales_book_08', 3, 1, 30, '1'),
(979, 'uk_fairytales_book_09', '1', 'uk_fairytales_book_09', 3, 1, 30, '1'),
(980, 'uk_fairytales_book_10', '1', 'uk_fairytales_book_10', 3, 1, 30, '1'),
(981, 'uk_fairytales_sticker_04', '1', 'uk_fairytales_sticker_04', 3, 1, 29, '1'),
(982, 'uk_fairytales_sticker_05', '1', 'uk_fairytales_sticker_05', 3, 1, 30, '1'),
(983, 'uk_fairytales_sticker_06', '1', 'uk_fairytales_sticker_06', 3, 1, 30, '1'),
(984, 'uk_fairytales_sticker_07', '1', 'uk_fairytales_sticker_07', 3, 1, 30, '1'),
(985, 'uk_fairytales_sticker_08', '1', 'uk_fairytales_sticker_08', 3, 1, 30, '1'),
(986, 'uk_fairytales_sticker_09', '1', 'uk_fairytales_sticker_09', 3, 1, 30, '1'),
(987, 'uk_fairytales_sticker_10', '1', 'uk_fairytales_sticker_10', 3, 1, 30, '1'),
(988, 'hw_uk_marchon_sticker_01', '1', 'hw_uk_marchon_sticker_01', 3, 1, 28, '1'),
(989, 'hw_uk_marchon_sticker_02', '1', 'hw_uk_marchon_sticker_02', 3, 1, 30, '1'),
(991, 'bg_colour_01', '4', 'bg_colour_01', 3, 1, 5, '1'),
(992, 'bg_colour_08', '4', 'bg_colour_08', 3, 1, 5, '1'),
(993, 'bg_colour_12', '4', 'bg_colour_12', 3, 1, 5, '1'),
(994, 'bg_colour_16', '4', 'bg_colour_16', 3, 1, 5, '1'),
(995, 'bg_denim', '4', 'bg_denim', 3, 1, 33, '1'),
(996, 'bg_lace', '4', 'bg_lace', 3, 1, 33, '1'),
(997, 'bg_stitched', '4', 'bg_stitched', 3, 1, 33, '1'),
(998, 'bg_wood', '4', 'bg_wood', 3, 1, 33, '1'),
(999, 'bg_cork', '4', 'bg_cork', 3, 1, 33, '1'),
(1000, 'bg_stone', '4', 'bg_stone', 3, 1, 33, '1'),
(1001, 'bg_pattern_bricks', '4', 'bg_pattern_bricks', 3, 1, 33, '1'),
(1002, 'bg_ruled_paper', '4', 'bg_ruled_paper', 3, 1, 33, '1'),
(1003, 'bg_grass', '4', 'bg_grass', 3, 1, 5, '1'),
(1004, 'bg_hotel', '4', 'bg_hotel', 3, 1, 36, '1'),
(1005, 'bg_bubble', '4', 'bg_bubble', 3, 1, 33, '1'),
(1006, 'bg_pattern_bobbaskulls1', '4', 'bg_pattern_bobbaskulls1', 3, 1, 33, '1'),
(1007, 'bg_pattern_space', '4', 'bg_pattern_space', 3, 1, 33, '1'),
(1008, 'bg_image_submarine', '4', 'bg_image_submarine', 3, 1, 33, '1'),
(1009, 'bg_metal2', '4', 'bg_metal2', 3, 1, 33, '1'),
(1010, 'bg_broken_glass', '4', 'bg_broken_glass', 3, 1, 33, '1'),
(1011, 'bg_pattern_clouds', '4', 'bg_pattern_clouds', 3, 1, 33, '1'),
(1012, 'bg_comic2', '4', 'bg_comic2', 3, 1, 33, '1'),
(1013, 'bg_pattern_floral_01', '4', 'bg_pattern_floral_01', 3, 1, 33, '1'),
(1014, 'bg_pattern_floral_02', '4', 'bg_pattern_floral_02', 3, 1, 33, '1'),
(1015, 'bg_pattern_floral_03', '4', 'bg_pattern_floral_03', 3, 1, 33, '1'),
(1016, 'bg_pattern_bulb', '4', 'bg_pattern_bulb', 3, 1, 33, '1'),
(1017, 'bg_pattern_cars', '4', 'bg_pattern_cars', 3, 1, 33, '1'),
(1018, 'bg_pattern_carpants', '4', 'bg_pattern_carpants', 3, 1, 33, '1'),
(1019, 'bg_pattern_plasto', '4', 'bg_pattern_plasto', 3, 1, 33, '1'),
(1020, 'bg_pattern_tinyroom', '4', 'bg_pattern_tinyroom', 3, 1, 33, '1'),
(1021, 'bg_pattern_hearts', '4', 'bg_pattern_hearts', 3, 1, 33, '1'),
(1022, 'bg_pattern_abstract1', '4', 'bg_pattern_abstract1', 3, 1, 33, '1'),
(1023, 'bg_bathroom_tile', '4', 'bg_bathroom_tile', 3, 1, 33, '1'),
(1024, 'bg_pattern_fish', '4', 'bg_pattern_fish', 3, 1, 33, '1'),
(1025, 'bg_pattern_deepred', '4', 'bg_pattern_deepred', 3, 1, 33, '1'),
(1026, 'bg_colour_02', '4', 'bg_colour_02', 3, 1, 5, '1'),
(1027, 'bg_colour_03', '4', 'bg_colour_03', 3, 1, 5, '1'),
(1028, 'bg_colour_04', '4', 'bg_colour_04', 3, 1, 5, '1'),
(1029, 'bg_colour_05', '4', 'bg_colour_05', 3, 1, 5, '1'),
(1030, 'bg_colour_06', '4', 'bg_colour_06', 3, 1, 5, '1'),
(1031, 'bg_colour_07', '4', 'bg_colour_07', 3, 1, 5, '1'),
(1032, 'bg_colour_09', '4', 'bg_colour_09', 3, 1, 5, '1'),
(1033, 'bg_colour_10', '4', 'bg_colour_10', 3, 1, 5, '1'),
(1034, 'bg_colour_11', '4', 'bg_colour_11', 3, 1, 5, '1'),
(1035, 'bg_colour_13', '4', 'bg_colour_13', 3, 1, 5, '1'),
(1036, 'bg_colour_14', '4', 'bg_colour_14', 3, 1, 5, '1'),
(1037, 'bg_colour_15', '4', 'bg_colour_15', 3, 1, 5, '1'),
(1038, 'bg_colour_17', '4', 'bg_colour_17', 3, 1, 5, '1'),
(1039, 'bg_tonga', '4', 'bg_tonga', 3, 1, 33, '1'),
(1040, 'xmas_bgpattern_starsky', '4', 'xmas_bgpattern_starsky', 3, 1, 36, '1'),
(1041, 'xmas_gifts_bg', '4', 'xmas_gifts_bg', 3, 1, 26, '1'),
(1046, 'newyear_bg_fireworks', '4', 'newyear_bg_fireworks', 3, 1, 33, '1'),
(1047, 'vale_rose_bg', '4', 'vale_rose_bg', 3, 1, 33, '1'),
(1048, 'vale_skull_bg', '4', 'vale_skull_bg', 3, 1, 33, '1'),
(1049, 'hc_bg_machine', '4', 'hc_bg_machine', 3, 1, 33, '1'),
(1050, 'hc_bg_pillow', '4', 'hc_bg_pillow', 3, 1, 33, '1'),
(1051, 'hc_bg_royal', '4', 'hc_bg_royal', 3, 1, 33, '1'),
(1052, 'easter_eggs_wallpaper', '4', 'easter_eggs_wallpaper', 3, 1, 26, '1'),
(1055, 'newyear_bg_fireworks2', '4', 'newyear_bg_fireworks2', 3, 1, 36, '1'),
(1056, 'nl_green_bg', '4', 'nl_green_bg', 3, 1, 33, '1'),
(1057, 'val_bgpattern_love', '4', 'val_bgpattern_love', 3, 1, 33, '1'),
(1058, 'val_bgpattern_skull', '4', 'val_bgpattern_skull', 3, 1, 33, '1'),
(1059, 'bg_bobbaheart', '4', 'bg_bobbaheart', 3, 1, 33, '1'),
(1060, 'bg_rain', '4', 'bg_rain', 3, 1, 33, '1'),
(1061, 'tutorial_bg', '4', 'tutorial_bg', 3, 1, 36, '1'),
(1062, 'habbo_group_tutorial_bg', '4', 'habbo_group_tutorial_bg', 3, 1, 36, '1'),
(1063, 'fantasticfour', '4', 'fantasticfour', 3, 1, 27, '1'),
(1064, 'silversurfer', '4', 'silversurfer', 3, 1, 27, '1'),
(1065, 'fantastic4', '4', 'fantastic4', 3, 1, 27, '1'),
(1066, 'silversurfer2', '4', 'silversurfer2', 3, 1, 27, '1'),
(1067, 'fantastic42', '4', 'fantastic42', 3, 1, 27, '1'),
(1068, 'fan43', '4', 'fan43', 3, 1, 27, '1'),
(1069, 'silversurfer3', '4', 'silversurfer3', 3, 1, 27, '1'),
(1070, 'grungewall', '4', 'grungewall', 3, 1, 33, '1'),
(1072, 'bg_infobus_blue', '4', 'bg_infobus_blue', 3, 1, 36, '1'),
(1073, 'bg_infobus_white', '4', 'bg_infobus_white', 3, 1, 36, '1'),
(1074, 'bg_infobus_yellow', '4', 'bg_infobus_yellow', 3, 1, 36, '1'),
(1075, 'bg_lido_flat', '4', 'bg_lido_flat', 3, 1, 36, '1'),
(1076, 'bg_lidoo', '4', 'bg_lidoo', 3, 1, 36, '1'),
(1077, 'bg_vip', '4', 'bg_vip', 3, 1, 36, '1'),
(1079, 'habbogroup', '4', 'habbogroup', 3, 1, 36, '1'),
(1080, 'snowstorm_bg', '4', 'snowstorm_bg', 3, 1, 36, '1'),
(1081, 'makeover', '4', 'makeover', 3, 1, 33, '1'),
(1291, 'HabboHotel Logo', '1', 'sticker_Habbo_logo', 10, 1, 38, '1'),
(1083, 'kerrang2', '4', 'kerrang2', 3, 1, 5, '1'),
(1084, 'bg_kerrang2', '4', 'bg_kerrang2', 3, 1, 27, '1'),
(1085, 'christmas2007bg_001', '4', 'christmas2007bg_001', 3, 1, 26, '1'),
(1086, 'habbox', '4', 'habbox', 3, 1, 36, '1'),
(1087, 'sttriniansblackboard', '4', 'sttriniansblackboard', 3, 1, 27, '1'),
(1089, 'orca', '4', 'orca', 3, 1, 36, '1'),
(1090, 'penelope', '4', 'penelope', 3, 1, 27, '1'),
(1091, 'habborella_sea_bg', '4', 'habborella_sea_bg', 3, 1, 36, '1'),
(1093, 'random_habbos', '4', 'random_habbos', 3, 1, 36, '1'),
(1094, 'welcoming_party', '4', 'welcoming_party', 3, 1, 36, '1'),
(1096, 'bg_unofficial_fansites', '4', 'bg_unofficial_fansites', 3, 1, 36, '1'),
(1097, 'themepark_bg_02', '4', 'themepark_bg_02', 3, 1, 36, '1'),
(1098, 'themepark_bg_01', '4', 'themepark_bg_01', 3, 1, 36, '1'),
(1099, 'bg_serpentine_darkblue', '4', 'bg_serpentine_darkblue', 3, 1, 32, '1'),
(1100, 'bg_serpntine_darkred', '4', 'bg_serpntine_darkred', 3, 1, 33, '1'),
(1101, 'bg_serpentine_1', '4', 'bg_serpentine_1', 3, 1, 33, '1'),
(1102, 'bg_serpentine_2', '4', 'bg_serpentine_2', 3, 1, 33, '1'),
(1103, 'alhambragroup', '4', 'alhambragroup', 3, 1, 36, '1'),
(1104, 'shabboline', '4', 'shabboline', 3, 1, 36, '1'),
(1105, 'habbo_toolbar', '4', 'habbo_toolbar', 3, 1, 33, '1'),
(1106, 'madball_2008_bg_001', '4', 'madball_2008_bg_001', 3, 1, 36, '1'),
(1107, 'jp_prom_bg', '4', 'jp_prom_bg', 3, 1, 36, '1'),
(1108, 'habbo_social_game_001_opt', '4', 'habbo_social_game_001_opt', 3, 1, 36, '1'),
(1109, 'habbo_social_game_002', '4', 'habbo_social_game_002', 3, 1, 36, '1'),
(1110, 'hundredmillion_bg', '4', 'hundredmillion_bg', 3, 1, 36, '1'),
(1111, 'meet_dave_groupbg_02', '4', 'meet_dave_groupbg_02', 3, 1, 27, '1'),
(1112, 'meet_dave_groupbg_01', '4', 'meet_dave_groupbg_01', 3, 1, 27, '1'),
(1113, 'guidesgroup_bg', '4', 'guidesgroup_bg', 3, 1, 36, '1'),
(1114, 'grouppage_snowbattle2', '4', 'grouppage_snowbattle2', 3, 1, 36, '1'),
(1115, 'top_gamers_bg_64', '4', 'top_gamers_bg_64', 3, 1, 36, '1'),
(1116, 'summer_bg_optimal', '4', 'summer_bg_optimal', 3, 1, 36, '1'),
(1117, '10kbc_habbo_grouppage_bg_3b', '4', '10kbc_habbo_grouppage_bg_3b', 3, 1, 27, '1'),
(1118, '10kbc_habbo_grouppage_bg_2b', '4', '10kbc_habbo_grouppage_bg_2b', 3, 1, 27, '1'),
(1119, 'landing_page_comp', '4', 'landing_page_comp', 3, 1, 27, '1'),
(1120, '27419_appart732_scene', '4', '27419_appart732_scene', 3, 1, 36, '1'),
(1121, 'myspy_group', '4', 'myspy_group', 3, 1, 27, '1'),
(1122, 'habbolympics_bg_final', '4', 'habbolympics_bg_final', 3, 1, 36, '1'),
(1125, 'cw_group_1', '4', 'cw_group_1', 3, 1, 27, '1'),
(1126, 'cw_group_2', '4', 'cw_group_2', 3, 1, 27, '1'),
(1127, 'cw_poster', '4', 'cw_poster', 3, 1, 27, '1'),
(1128, 'wallpaper_dinerus', '4', 'wallpaper_dinerus', 3, 1, 36, '1'),
(1129, 'hairspray_sm_group', '4', 'hairspray_sm_group', 3, 1, 27, '1'),
(1130, 'reoc_billing_group', '4', 'reoc_billing_group', 3, 1, 36, '1'),
(1131, 'camp_rock_group', '4', 'camp_rock_group', 3, 1, 27, '1'),
(1134, 'arm_habbo_grouppage3', '4', 'arm_habbo_grouppage3', 3, 1, 37, '1'),
(1135, 'usob_grouppag_1e', '4', 'usob_grouppag_1e', 3, 1, 36, '1'),
(1136, 'kingcorp_928x1360', '4', 'kingcorp_928x1360', 3, 1, 36, '1'),
(1139, 'achievement_web_bg', '4', 'achievement_web_bg', 3, 1, 36, '1'),
(1140, 'peacegroup', '4', 'peacegroup', 3, 1, 36, '1'),
(1141, 'igor_2_group_928x1360', '4', 'igor_2_group_928x1360', 3, 1, 27, '1'),
(1292, 'Welcome to Habbo!', '1', 'sticker_Habbo_welcome', 5, 1, 38, '1'),
(1143, 'hw_day2', '4', 'hw_day2', 3, 1, 36, '1'),
(1144, 'hw_day3', '4', 'hw_day3', 3, 1, 27, '1'),
(1145, 'hw_day4', '4', 'hw_day4', 3, 1, 36, '1'),
(1146, 'hw_day5', '4', 'hw_day5', 3, 1, 36, '1'),
(1147, 'hw_day6', '4', 'hw_day6', 3, 1, 36, '1'),
(1148, 'insiders_habbo', '4', 'insiders_habbo', 3, 1, 27, '1'),
(1149, 'atw_group_world', '4', 'atw_group_world', 3, 1, 27, '1'),
(1150, 'atw_group_far_east_aus', '4', 'atw_group_far_east_aus', 3, 1, 36, '1'),
(1151, 'atw_group_europe', '4', 'atw_group_europe', 3, 1, 36, '1'),
(1152, 'atw_group_america', '4', 'atw_group_america', 3, 1, 36, '1'),
(1153, 'atw_group_africa', '4', 'atw_group_africa', 3, 1, 5, '1'),
(1155, 'neon_gp_subpage_bg_v1', '4', 'neon_gp_subpage_bg_v1', 3, 1, 36, '1'),
(1156, 'neon_subpage2', '4', 'neon_subpage2', 3, 1, 36, '1'),
(1157, 'locoroco_group_928x1360_2', '4', 'locoroco_group_928x1360_2', 3, 1, 27, '1'),
(1159, 'sonic_unl_habbo_grouppg4', '4', 'sonic_unl_habbo_grouppg4', 3, 1, 27, '1'),
(1161, 'sonic_unl_habbo_group', '4', 'sonic_unl_habbo_group', 3, 1, 27, '1'),
(1162, 'xmas08_gpbg', '4', 'xmas08_gpbg', 3, 1, 36, '1'),
(1164, 'uk_cw_habbo_group_page_100k', '4', 'uk_cw_habbo_group_page_100k', 3, 1, 27, '1'),
(1166, 'childline_habbo_grouppg', '4', 'childline_habbo_grouppg', 3, 1, 27, '1'),
(1167, 'knifescrime_group', '4', 'knifescrime_group', 3, 1, 27, '1'),
(1168, 'h4d_habbo_background_group_02', '4', 'h4d_habbo_background_group_02', 3, 1, 33, '1'),
(1169, 'gameshow_group_928x1360', '4', 'gameshow_group_928x1360', 3, 1, 36, '1'),
(1170, 'bg_nobobba', '4', 'bg_nobobba', 3, 1, 27, '1'),
(1172, 'harajuku_group_07_b', '4', 'harajuku_group_07_b', 3, 1, 27, '1'),
(1173, 'harajuku_group_06_b', '4', 'harajuku_group_06_b', 3, 1, 27, '1'),
(1174, 'harajuku_group_05_b', '4', 'harajuku_group_05_b', 3, 1, 27, '1'),
(1175, 'harajuku_group_04_b', '4', 'harajuku_group_04_b', 3, 1, 27, '1'),
(1176, 'harajuku_group_03_b', '4', 'harajuku_group_03_b', 3, 1, 27, '1'),
(1177, 'harajuku_group_02_b', '4', 'harajuku_group_02_b', 3, 1, 27, '1'),
(1178, 'uk_h4d_bg', '4', 'uk_h4d_bg', 3, 1, 27, '1'),
(1179, 'bg_shalimar_grouptheatre', '4', 'bg_shalimar_grouptheatre', 3, 1, 36, '1'),
(1180, 'gp_sha', '4', 'gp_sha', 3, 1, 36, '1'),
(1181, 'habwrecked_group_01_928x1360', '4', 'habwrecked_group_01_928x1360', 3, 1, 36, '1'),
(1182, 'habwrecked_group_02_928x1360', '4', 'habwrecked_group_02_928x1360', 3, 1, 36, '1'),
(1183, 'habwrecked_group_03_928x1360', '4', 'habwrecked_group_03_928x1360', 3, 1, 36, '1'),
(1184, 'vip_group', '4', 'vip_group', 3, 1, 36, '1'),
(1185, 'bg_newsletter_03', '4', 'bg_newsletter_03', 3, 1, 36, '1'),
(1186, 'uk_office_928x1360', '4', 'uk_office_928x1360', 3, 1, 36, '1'),
(1187, 'bg_elliot_minor_back', '4', 'bg_elliot_minor_back', 3, 1, 27, '1'),
(1188, 'bg_habbouk_frank_11924', '4', 'bg_habbouk_frank_11924', 3, 1, 27, '1'),
(1189, 'bg_lostc_oceanfloor', '4', 'bg_lostc_oceanfloor', 3, 1, 36, '1'),
(1191, 'bg_earth_hour', '4', 'bg_earth_hour', 3, 1, 27, '1'),
(1192, 'habprentice_background_01', '4', 'habprentice_background_01', 3, 1, 36, '1'),
(1193, 'habprentice_background_02', '4', 'habprentice_background_02', 3, 1, 36, '1'),
(1194, 'bionicle_group_01', '4', 'bionicle_group_01', 3, 1, 27, '1'),
(1195, 'bionicle_group_04', '4', 'bionicle_group_04', 3, 1, 27, '1'),
(1197, 'bionicle_group_07', '4', 'bionicle_group_07', 3, 1, 27, '1'),
(1198, 'bionicle_group_05', '4', 'bionicle_group_05', 3, 1, 27, '1'),
(1199, 'bionicle_group_02', '4', 'bionicle_group_02', 3, 1, 27, '1'),
(1200, 'bionicle_group_06', '4', 'bionicle_group_06', 3, 1, 27, '1'),
(1202, 'pixie_background', '4', 'pixie_background', 3, 1, 27, '1'),
(1203, 'bionicle_group_03', '4', 'bionicle_group_03', 3, 1, 27, '1'),
(1204, 'uk_buzz_group_928x1360', '4', 'uk_buzz_group_928x1360', 3, 1, 27, '1'),
(1205, 'uk_group_page_17_again', '4', 'uk_group_page_17_again', 3, 1, 27, '1'),
(1206, 'uk_wtmi_group_928x1360', '4', 'uk_wtmi_group_928x1360', 3, 1, 27, '1'),
(1207, 'uk_wtmi_group_c', '4', 'uk_wtmi_group_c', 3, 1, 27, '1'),
(1208, 'habbo_mall_background', '4', 'habbo_mall_background', 3, 1, 36, '1'),
(1209, 'uk_skellig_bg', '4', 'uk_skellig_bg', 3, 1, 27, '1'),
(1211, 'bg_easter_1', '4', 'bg_easter_1', 3, 1, 36, '1'),
(1212, 'bg_easter_2', '4', 'bg_easter_2', 3, 1, 36, '1'),
(1213, 'bg_easter_3', '4', 'bg_easter_3', 3, 1, 36, '1'),
(1214, 'bg_easter_4', '4', 'bg_easter_4', 3, 1, 36, '1'),
(1215, 'bg_easter_5', '4', 'bg_easter_5', 3, 1, 37, '1'),
(1216, 'uk_equigg_bg', '4', 'uk_equigg_bg', 3, 1, 27, '1'),
(1217, 'uk_natm2_group_928x1360', '4', 'uk_natm2_group_928x1360', 3, 1, 27, '1'),
(1218, 'grouppage_country', '4', 'grouppage_country', 3, 1, 36, '1'),
(1219, 'uk_habboway_group_928x1360', '4', 'uk_habboway_group_928x1360', 3, 1, 36, '1'),
(1220, 'uk_parentsguide_group_928x1360', '4', 'uk_parentsguide_group_928x1360', 3, 1, 36, '1'),
(1221, 'uk_safetytips_group_928x1360', '4', 'uk_safetytips_group_928x1360', 3, 1, 36, '1'),
(1222, 'uk_natm2_group_main_928x1360', '4', 'uk_natm2_group_main_928x1360', 3, 1, 27, '1'),
(1223, 'uk_country_village_group', '4', 'uk_country_village_group', 3, 1, 36, '1'),
(1224, 'beta_group_bg2', '4', 'beta_group_bg2', 3, 1, 36, '1'),
(1225, 'uk_charliechic_group_928x1360', '4', 'uk_charliechic_group_928x1360', 3, 1, 27, '1'),
(1226, 'bg_ltribe_jungle', '4', 'bg_ltribe_jungle', 3, 1, 36, '1'),
(1227, 'uk_iceage3_group_928x1360', '4', 'uk_iceage3_group_928x1360', 3, 1, 27, '1'),
(1228, 'uk_supersuper_group_med', '4', 'uk_supersuper_group_med', 3, 1, 27, '1'),
(1229, 'uk_supersuper_group_large', '4', 'uk_supersuper_group_large', 3, 1, 27, '1'),
(1230, 'ia3_uk_english_platform_habbo_928x1360_static', '4', 'ia3_uk_english_platform_habbo_928x1360_static', 3, 1, 27, '1'),
(1231, 'openbeta_bg', '4', 'openbeta_bg', 3, 1, 36, '1'),
(1232, 'bg_generic_stars_2', '4', 'bg_generic_stars_2', 3, 1, 33, '1'),
(1233, 'groupbg_scifi2', '4', 'groupbg_scifi2', 3, 1, 36, '1'),
(1234, 'group_nspcc2_928x136', '4', 'group_nspcc2_928x136', 3, 1, 27, '1'),
(1235, 'bg_dating_parklife', '4', 'bg_dating_parklife', 3, 1, 36, '1'),
(1236, 'bg_hotcool_summer', '4', 'bg_hotcool_summer', 3, 1, 5, '1'),
(1237, 'calvinharris_group_928x1360', '4', 'calvinharris_group_928x1360', 3, 1, 27, '1'),
(1238, 'uk_september_group_02_928x1360', '4', 'uk_september_group_02_928x1360', 3, 1, 27, '1'),
(1239, 'uk1_mall_cop_group_928x1360', '4', 'uk1_mall_cop_group_928x1360', 3, 1, 27, '1'),
(1240, 'uk_muzutv_group_928x1360', '4', 'uk_muzutv_group_928x1360', 3, 1, 27, '1'),
(1241, 'uk_paramore_group_928x1360', '4', 'uk_paramore_group_928x1360', 3, 1, 27, '1'),
(1242, 'groupbg_hpv', '4', 'groupbg_hpv', 3, 1, 27, '1'),
(1243, 'uk_julianperretta_group', '4', 'uk_julianperretta_group', 3, 1, 27, '1'),
(1244, 'uk_bootyluv_group', '4', 'uk_bootyluv_group', 3, 1, 27, '1'),
(1246, 'bg_relax', '4', 'bg_relax', 3, 1, 36, '1'),
(1247, 'uk_cloudy_group_01_1', '4', 'uk_cloudy_group_01_1', 3, 1, 27, '1'),
(1248, 'uk_skulduggery_group', '4', 'uk_skulduggery_group', 3, 1, 27, '1'),
(1249, 'kitchensurvivor_bg_v2', '4', 'kitchensurvivor_bg_v2', 3, 1, 36, '1'),
(1250, 'uk_basshunter_group_928x1360', '4', 'uk_basshunter_group_928x1360', 3, 1, 27, '1'),
(1251, 'uk_theveronicas_group_928x1360', '4', 'uk_theveronicas_group_928x1360', 3, 1, 27, '1'),
(1293, 'Stickie notes', '3', 'stickienote', 10, 5, 4, '1'),
(1253, 'bg_ema09', '4', 'bg_ema09', 3, 1, 27, '1'),
(1255, 'bg_hween09_newsofhabbo2', '4', 'bg_hween09_newsofhabbo2', 3, 1, 27, '1'),
(1257, 'bg_howufeelin_happyface', '4', 'bg_howufeelin_happyface', 3, 1, 27, '1'),
(1258, 'bg_nspcc_parkscene', '4', 'bg_nspcc_parkscene', 3, 1, 27, '1'),
(1259, 'bg_twilight_week2_002', '4', 'bg_twilight_week2_002', 3, 1, 27, '1'),
(1260, 'bg_iceage_03', '4', 'bg_iceage_03', 3, 1, 27, '1'),
(1262, 'bg_twilight_week4_002', '4', 'bg_twilight_week4_002', 3, 1, 27, '1'),
(1263, 'bg_xmas09_wall', '4', 'bg_xmas09_wall', 3, 1, 26, '1'),
(1264, 'xmas2009_bg_snowing', '4', 'xmas2009_bg_snowing', 3, 1, 26, '1'),
(1265, 'xmas2009_bg_xmasfun2', '4', 'xmas2009_bg_xmasfun2', 3, 1, 26, '1'),
(1266, 'xmas2009_bg_xmasfun', '4', 'xmas2009_bg_xmasfun', 3, 1, 26, '1'),
(1267, 'bg_alvinandchipmunks', '4', 'bg_alvinandchipmunks', 3, 1, 27, '1'),
(1268, 'bg_st2', '4', 'bg_st2', 3, 1, 27, '1'),
(1269, 'bg_0800_final', '4', 'bg_0800_final', 3, 1, 27, '1'),
(1270, 'bg_pj', '4', 'bg_pj', 3, 1, 27, '1'),
(1271, 'hw_hotelhappenings_bg_v1', '4', 'hw_hotelhappenings_bg_v1', 3, 1, 36, '1'),
(1272, 'bg_fire', '4', 'bg_fire', 3, 1, 36, '1'),
(1273, 'bg_pj_001', '4', 'bg_pj_001', 3, 1, 27, '1'),
(1274, 'bg_safety_appart732', '4', 'bg_safety_appart732', 3, 1, 36, '1'),
(1276, 'gp_yir', '4', 'gp_yir', 3, 1, 27, '1'),
(1277, 'bg_aita', '4', 'bg_aita', 3, 1, 27, '1'),
(1278, 'bg__offifansite', '4', 'bg__offifansite', 3, 1, 36, '1'),
(1279, 'heartbreak_hotel', '4', 'heartbreak_hotel', 3, 1, 36, '1'),
(1280, 'gp_mandf', '4', 'gp_mandf', 3, 1, 27, '1'),
(1281, 'bg_winterolympics_2010', '4', 'bg_winterolympics_2010', 3, 1, 36, '1'),
(1282, 'bg_tlc_blank', '4', 'bg_tlc_blank', 3, 1, 27, '1'),
(1283, 'gp_int_sec', '4', 'gp_int_sec', 3, 1, 27, '1'),
(1284, 'mb_groupbg_3_stickys', '4', 'mb_groupbg_3_stickys', 3, 1, 36, '1'),
(1285, 'bg_httyd_tease', '4', 'bg_httyd_tease', 3, 1, 27, '1'),
(1286, 'hw_uk_habwrecked10_teaser', '4', 'hw_uk_habwrecked10_teaser', 3, 1, 36, '1'),
(1287, 'bg_httyd_tease_02', '4', 'bg_httyd_tease_02', 3, 1, 27, '1'),
(1288, 'hw_uk_habwrecked10_launch', '4', 'hw_uk_habwrecked10_launch', 3, 1, 36, '1'),
(1289, 'bg_httyd_main_02', '4', 'bg_httyd_main_02', 3, 1, 27, '1'),
(1290, 'bg_alvin_dvd', '4', 'bg_alvin_dvd', 3, 1, 27, '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `homes_categories`
--

CREATE TABLE IF NOT EXISTS `homes_categories` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `type` varchar(120) NOT NULL DEFAULT 'stickers',
  `caption` varchar(120) NOT NULL DEFAULT 'undefined',
  `fuse_requirement` varchar(120) NOT NULL DEFAULT '',
  `order_num` int(11) NOT NULL DEFAULT '1',
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=39 ;

--
-- Volcado de datos para la tabla `homes_categories`
--

INSERT INTO `homes_categories` (`id`, `parent_id`, `type`, `caption`, `fuse_requirement`, `order_num`, `enabled`) VALUES
(1, 0, 'stickers', 'Stickers', '', 1, '1'),
(2, 0, 'backgrounds', 'Backgrounds', '', 2, '1'),
(3, 0, 'stickie_notes', 'Notes', '', 3, '1'),
(4, 3, 'stickie_notes', 'Stickie Notes', '', 1, '1'),
(5, 2, 'backgrounds', 'General', '', 9001, '1'),
(26, 2, 'backgrounds', 'Holidays', '', 9004, '1'),
(7, 1, 'stickers', 'Letters', '', 11, '1'),
(22, 1, 'stickers', 'Borders', '', 12, '1'),
(25, 1, 'stickers', 'Effects', '', 13, '1'),
(23, 1, 'stickers', 'Music', '', 9, '1'),
(24, 1, 'stickers', 'Characters', '', 8, '1'),
(27, 2, 'backgrounds', 'Campaigns', '', 9005, '1'),
(28, 1, 'stickers', 'Campaigns', '', 7, '1'),
(29, 1, 'stickers', 'Holidays', '', 6, '1'),
(30, 1, 'stickers', 'Habbo', '', 5, '1'),
(31, 1, 'stickers', 'Countries', '', 4, '1'),
(32, 1, 'stickers', 'Other', '', 14, '1'),
(33, 2, 'backgrounds', 'Patterns', '', 9003, '1'),
(34, 1, 'stickers', 'Environment', '', 3, '1'),
(35, 1, 'stickers', 'Costumes', '', 2, '1'),
(36, 2, 'backgrounds', 'Habbo', '', 9002, '1'),
(37, 1, 'stickers', 'Arrows & Pointers', '', 1, '1'),
(38, 1, 'stickers', 'Habbo', '', 0, '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `homes_inventory`
--

CREATE TABLE IF NOT EXISTS `homes_inventory` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `type` varchar(32) NOT NULL,
  `data` varchar(250) NOT NULL,
  `amount` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `homes_items`
--

CREATE TABLE IF NOT EXISTS `homes_items` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `home_id` int(10) unsigned NOT NULL,
  `type` enum('sticker','widget','stickie') NOT NULL DEFAULT 'sticker',
  `x` int(11) NOT NULL DEFAULT '0',
  `y` int(11) NOT NULL DEFAULT '0',
  `z` int(11) NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `skin` text NOT NULL,
  `owner_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`) USING BTREE,
  KEY `x` (`x`) USING BTREE,
  KEY `y` (`y`) USING BTREE,
  KEY `z` (`z`) USING BTREE,
  KEY `home_id` (`home_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `ipn_requests`
--

CREATE TABLE IF NOT EXISTS `ipn_requests` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` text NOT NULL,
  `ip` text NOT NULL,
  `status` enum('0','1','2','3','4','5','6') NOT NULL DEFAULT '0' COMMENT '0 = Error, 1 = OK, 2 = Forced, 3 = Auth failure, 4 = UID not found, 5 = Forced, 6 = Data failure',
  `request_data` text NOT NULL,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `balance_diff` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `ip_cache`
--

CREATE TABLE IF NOT EXISTS `ip_cache` (
  `ip` varchar(16) NOT NULL,
  `country` varchar(75) NOT NULL DEFAULT 'UNKNOWN',
  `isSafe` enum('false','true') DEFAULT 'true',
  PRIMARY KEY (`ip`),
  UNIQUE KEY `ip` (`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ROW_FORMAT=FIXED;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `irc_sessions`
--

CREATE TABLE IF NOT EXISTS `irc_sessions` (
  `irc_username` varchar(50) NOT NULL,
  `vg_username` varchar(50) NOT NULL,
  `rank` int(1) NOT NULL,
  PRIMARY KEY (`irc_username`,`vg_username`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `irc_sessions`
--

INSERT INTO `irc_sessions` (`irc_username`, `vg_username`, `rank`) VALUES
('(dante)', 'Dante', 0),
('1337', 'CameronScotto', 0),
('Apple', 'Apple', 0),
('Aytar', 'Kwendozz', 0),
('bendiksa', 'bendiksa21', 0),
('Elliott', 'Elliott', 0),
('EverydayShufflin', 'EverydayShufflin', 0),
('Gunner716', 'JustinXD', 0),
('Hello', 'OxygenBunny', 0),
('Ian2458', 'Ian2458', 0),
('Jackson', 'Mango', 0),
('Jizz', 'Lemar', 0),
('Lee', 'ZAPBOY', 0),
('PaperJam', 'PaperJam', 0),
('PEjump', 'PEjump', 0),
('sdef', 'Awesome', 0),
('TayTayTiara', 'Tiara', 0),
('Timmy', 'EnriqueIglesias', 0),
('TRiLLE', 'DANISHGAY', 0),
('Vergeten', 'Vergeten', 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `irc_users`
--

CREATE TABLE IF NOT EXISTS `irc_users` (
  `id` int(10) NOT NULL,
  `username` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `irc_users`
--

INSERT INTO `irc_users` (`id`, `username`) VALUES
(0, 'martinmine'),
(2, 'Zombie'),
(3, 'cmsweb'),
(4, 'Various');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items`
--

CREATE TABLE IF NOT EXISTS `items` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `base_id` smallint(5) unsigned DEFAULT NULL,
  PRIMARY KEY (`item_id`),
  UNIQUE KEY `id_UNIQUE` (`item_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=107 ;

--
-- Volcado de datos para la tabla `items`
--

INSERT INTO `items` (`item_id`, `base_id`) VALUES
(6, 981),
(7, 410),
(8, 981),
(9, 410),
(10, 2746),
(11, 2753),
(12, 2767),
(13, 2760),
(14, 2778),
(15, 175),
(16, 2794),
(17, 2794),
(18, 1527),
(19, 175),
(20, 175),
(21, 2784),
(22, 320),
(23, 320),
(24, 2804),
(25, 2803),
(26, 1515),
(27, 2796),
(28, 175),
(29, 175),
(30, 320),
(31, 320),
(32, 2774),
(33, 2774),
(34, 2735),
(35, 2787),
(36, 2735),
(37, 2787),
(38, 175),
(39, 175),
(40, 750),
(41, 410),
(42, 410),
(43, 410),
(44, 410),
(45, 963),
(46, 320),
(47, 320),
(48, 320),
(49, 960),
(50, 981),
(51, 410),
(52, 410),
(53, 410),
(54, 410),
(55, 410),
(56, 700),
(57, 2804),
(58, 2804),
(59, 2749),
(60, 2748),
(61, 2747),
(62, 2744),
(63, 2738),
(64, 2751),
(65, 2751),
(66, 2751),
(67, 2751),
(68, 2751),
(69, 2751),
(70, 2751),
(71, 2751),
(72, 2751),
(73, 2751),
(74, 2741),
(75, 2744),
(76, 320),
(77, 320),
(78, 320),
(79, 2804),
(80, 320),
(81, 320),
(82, 2140),
(83, 2742),
(84, 2742),
(85, 2751),
(86, 1713),
(87, 2730),
(88, 2730),
(89, 2730),
(90, 2730),
(91, 2730),
(92, 2730),
(93, 2730),
(94, 2730),
(95, 2730),
(96, 2742),
(97, 2745),
(98, 1704),
(99, 1472),
(100, 2742),
(101, 2751),
(102, 2751),
(103, 2742),
(104, 1452),
(105, 414),
(106, 269);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_base`
--

CREATE TABLE IF NOT EXISTS `items_base` (
  `item_id` smallint(6) unsigned NOT NULL AUTO_INCREMENT,
  `sprite_id` int(11) NOT NULL,
  `public_name` varchar(255) NOT NULL,
  `item_name` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `width` int(11) NOT NULL,
  `length` int(11) NOT NULL,
  `height` double(3,2) NOT NULL,
  `allow_stack` tinyint(1) NOT NULL,
  `allow_walk` tinyint(1) NOT NULL,
  `allow_sit` tinyint(1) NOT NULL,
  `allow_recycle` tinyint(1) NOT NULL,
  `allow_trade` tinyint(1) NOT NULL,
  `allow_marketplace_sell` tinyint(1) NOT NULL,
  `allow_gift` tinyint(1) NOT NULL,
  `allow_inventory_stack` tinyint(1) NOT NULL,
  `interaction_type` varchar(50) NOT NULL,
  `cycle_count` int(2) NOT NULL,
  `vending_ids` varchar(20) NOT NULL,
  PRIMARY KEY (`item_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2805 ;

--
-- Volcado de datos para la tabla `items_base`
--

INSERT INTO `items_base` (`item_id`, `sprite_id`, `public_name`, `item_name`, `type`, `width`, `length`, `height`, `allow_stack`, `allow_walk`, `allow_sit`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `cycle_count`, `vending_ids`) VALUES
(1, 13, 'Bookcase', 'shelves_norja', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2, 14, 'Bookcase', 'shelves_polyfon', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(3, 15, 'Bookcase', 'shelves_silo', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(4, 17, 'Small Coffee Table', 'table_polyfon_small', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(5, 18, 'Dining Chair', 'chair_polyfon', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(6, 20, 'Coffee Table', 'table_norja_med', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(7, 21, 'Coffee Table', 'table_silo_med', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(8, 22, 'Occasional Table', 'table_plasto_4leg', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(9, 23, 'Round Dining Table', 'table_plasto_round', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(10, 24, 'Square Dining Table', 'table_plasto_bigsquare', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(11, 25, 'Shelf', 'stand_polyfon_z', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(12, 26, 'Dining Chair', 'chair_silo', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(13, 28, 'Cushioned', 'sofa_silo', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(14, 29, 'Bench', 'couch_norja', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(15, 30, 'Chair', 'chair_norja', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(16, 31, 'Large Coffee Table', 'table_polyfon_med', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(17, 32, 'Doormat', 'doormat_love', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(18, 33, 'Doormat', 'doormat_plain', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(19, 34, 'Armchair', 'sofachair_polyfon', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(20, 35, 'Two-seater Sofa', 'sofa_polyfon', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(21, 36, 'Large', 'sofachair_silo', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(22, 38, 'Plastic Pod Chair', 'chair_plasty', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(23, 39, 'Chair', 'chair_plasto', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(24, 40, 'Occasional Table', 'table_plasto_square', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(25, 41, 'Double Bed', 'bed_polyfon', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(26, 42, 'Single Bed', 'bed_polyfon_one', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(27, 43, 'Plain Single Bed', 'bed_trad_one', 's', 2, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(28, 44, 'Plain Double Bed', 'bed_trad', 's', 2, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(29, 45, 'Single Bed', 'bed_silo_one', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(30, 46, 'Double Bed', 'bed_silo_two', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(31, 47, 'Occasional Table', 'table_silo_small', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(32, 48, 'Double Bed', 'bed_armas_two', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(33, 49, 'bed_budget_one', 'bed_budget_one', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(34, 50, 'Comfortable', 'bed_budget', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(35, 51, 'Bookcase', 'shelves_armas', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(36, 52, 'Bench', 'bench_armas', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(37, 53, 'Dining Table', 'table_armas', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(38, 54, 'Occasional Table', 'small_table_armas', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(39, 55, 'Stool', 'small_chair_armas', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(40, 56, 'Authentic', 'fireplace_armas', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(41, 57, 'Table Lamp', 'lamp_armas', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(42, 58, 'Single Bed', 'bed_armas_one', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(43, 59, 'Floor rug', 'carpet_standard', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(44, 60, 'Hand-Woven Rug', 'carpet_armas', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(45, 61, 'Faux-Fur Bear Rug', 'carpet_polar', 's', 2, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(46, 62, 'Fireplace', 'fireplace_polyfon', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(47, 63, 'Square Dining Table', 'table_plasto_4leg*1', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(48, 64, 'Square Dining Table', 'table_plasto_bigsquare*1', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(49, 65, 'Round Dining Table', 'table_plasto_round*1', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(50, 66, 'Occasional Table', 'table_plasto_square*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(51, 67, 'Chair', 'chair_plasto*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(52, 68, 'Floor Rug', 'carpet_standard*1', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(53, 69, 'Doormat', 'doormat_plain*1', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(54, 70, 'Occasional Table', 'table_plasto_4leg*2', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(55, 71, 'Square Dining Table', 'table_plasto_bigsquare*2', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(56, 72, 'Round Dining Table', 'table_plasto_round*2', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(57, 73, 'Round Dining Table', 'table_plasto_square*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(58, 74, 'Chair', 'chair_plasto*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(59, 75, 'Doormat', 'doormat_plain*2', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(60, 76, 'Floor Rug', 'carpet_standard*2', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(61, 77, 'Round Dining Table', 'table_plasto_4leg*3', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(62, 78, 'Square Dining Table', 'table_plasto_bigsquare*3', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(63, 79, 'Round Dining Table', 'table_plasto_round*3', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(64, 80, 'Square Dining Table', 'table_plasto_square*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(65, 81, 'Chair', 'chair_plasto*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(66, 82, 'Floor Rug', 'carpet_standard*3', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(67, 83, 'Doormat', 'doormat_plain*3', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(68, 84, 'Square Dining Table', 'table_plasto_4leg*4', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(69, 87, 'Square Dining Table', 'table_plasto_square*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(70, 88, 'Chair', 'chair_plasto*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(71, 89, 'Floor Rug', 'carpet_standard*4', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(72, 90, 'Doormat', 'doormat_plain*4', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(73, 91, 'Doormat', 'doormat_plain*6', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(74, 93, 'Doormat', 'doormat_plain*5', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(75, 94, 'Floor Rug', 'carpet_standard*5', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(76, 95, 'Occasional Table', 'table_plasto_4leg*5', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(77, 96, 'Square Dining Table', 'table_plasto_bigsquare*5', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(78, 97, 'Round Dining Table', 'table_plasto_round*5', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(79, 98, 'Square Dining Table', 'table_plasto_square*5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(80, 99, 'Chair', 'chair_plasto*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(81, 100, 'Occasional table Table', 'table_plasto_4leg*6', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(82, 101, 'Square Dining Table', 'table_plasto_bigsquare*6', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(83, 102, 'Round Dining Table', 'table_plasto_round*6', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(84, 103, 'Square Dining Table', 'table_plasto_square*6', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(85, 104, 'Chair', 'chair_plasto*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(86, 105, 'Occasional table', 'table_plasto_4leg*7', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(87, 106, 'Square Dining Table', 'table_plasto_bigsquare*7', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(88, 107, 'Round Dining Table', 'table_plasto_round*7', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(89, 108, 'Square Dining Table', 'table_plasto_square*7', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(90, 109, 'Chair', 'chair_plasto*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(91, 110, 'Occasional Table', 'table_plasto_4leg*8', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(92, 111, 'Square Dining Table', 'table_plasto_bigsquare*8', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(93, 112, 'Round Dining Table', 'table_plasto_round*8', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(94, 113, 'Square Dining Table', 'table_plasto_square*8', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(95, 114, 'Chair', 'chair_plasto*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(96, 115, 'Occasional Table', 'table_plasto_4leg*9', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(97, 116, 'Square Dining Table', 'table_plasto_bigsquare*9', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(98, 117, 'Square Dining Table', 'table_plasto_round*9', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(99, 119, 'Chair', 'chair_plasto*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(100, 120, 'Floor Rug', 'carpet_standard*6', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(101, 121, 'Plastic Pod Chair', 'chair_plasty*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(102, 122, 'Pizza Box', 'pizza', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(103, 123, 'Empty Cans', 'drinks', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(104, 124, 'Plastic Pod Chair', 'chair_plasty*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(105, 125, 'Plastic Pod Chair', 'chair_plasty*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(106, 126, 'Plastic Pod Chair', 'chair_plasty*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(107, 127, 'Mini-Bar', 'bar_polyfon', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '6,5,2,1'),
(108, 128, 'Aloe Vera', 'plant_cruddy', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(109, 129, 'Empty Spinning Bottle', 'bottle', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bottle', 0, '0'),
(110, 130, 'Bar/desk', 'bardesk_polyfon', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(111, 131, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(112, 133, 'Barrel Minibar', 'bar_armas', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '6,2,1'),
(113, 134, 'Bardesk', 'bartable_armas', 's', 1, 3, 1.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(114, 135, 'Barrel Stool', 'bar_chair_armas', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(115, 136, 'Soft Wool Rug', 'carpet_soft', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(116, 137, 'Soft Wool Rug', 'carpet_soft*1', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(117, 138, 'Soft Wool Rug', 'carpet_soft*2', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(118, 139, 'Soft Wool Rug', 'carpet_soft*3', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(119, 140, 'Soft Wool Rug', 'carpet_soft*4', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(120, 141, 'Soft Wool Rug', 'carpet_soft*5', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(121, 143, 'Soft Wool Rug', 'carpet_soft*6', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(122, 144, 'Portable TV', 'red_tv', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(123, 145, 'Large TV', 'wood_tv', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(124, 146, 'Pink Faux-Fur Bear Rug', 'carpet_polar*1', 's', 2, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(125, 147, 'Plastic Pod Chair', 'chair_plasty*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(126, 148, 'Blue Bear Rug', 'carpet_polar*2', 's', 2, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(127, 149, 'Yellow Bear Rug', 'carpet_polar*3', 's', 2, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(128, 150, 'Green Bear Rug', 'carpet_polar*4', 's', 2, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(129, 151, 'Plastic Pod Chair', 'chair_plasty*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(130, 152, 'Large Coffee Table', 'table_polyfon', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(131, 153, 'Large Dining Table', 'smooth_table_polyfon', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(132, 154, 'Armchair', 'sofachair_polyfon_girl', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(133, 155, 'Single Bed', 'bed_polyfon_girl_one', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(134, 156, 'Double Bed', 'bed_polyfon_girl', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(135, 157, 'Two-seater Sofa', 'sofa_polyfon_girl', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(136, 158, 'Plain Single Bed', 'bed_budgetb_one', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(137, 159, 'Plain Double Bed', 'bed_budgetb', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(138, 160, 'Pineapple Plant', 'plant_pineapple', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(139, 161, 'Fruit Tree', 'plant_fruittree', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(140, 162, 'Small Cactus', 'plant_small_cactus', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(141, 163, 'Bonsai Tree', 'plant_bonsai', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(142, 164, 'Mature Cactus', 'plant_big_cactus', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(143, 165, 'Yukka Plant', 'plant_yukka', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(144, 166, 'Floor Rug', 'carpet_standard*7', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(145, 167, 'Floor Rug', 'carpet_standard*8', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(146, 168, 'Floor Rug', 'carpet_standard*9', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(147, 169, 'Floor Rug', 'carpet_standard*10', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(148, 170, 'Floor Rug', 'carpet_standard*11', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(149, 171, 'Cut Sunflower', 'plant_sunflower', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(150, 172, 'Cut Roses', 'plant_rose', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(151, 173, 'Digital TV', 'tv_luxus', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(152, 174, 'Bubble Bath', 'bath', 's', 1, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(153, 177, 'Sink', 'sink', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '100'),
(154, 178, 'Loo Seat', 'toilet', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(155, 179, 'Rubber Duck', 'duck', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(156, 180, 'Floor Tiles', 'tile', 's', 4, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(157, 181, 'Loo Seat', 'toilet_red', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(158, 182, 'Loo Seat', 'toilet_yell', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(159, 183, 'Floor Tiles', 'tile_red', 's', 4, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(160, 184, 'Floor Tiles', 'tile_yell', 's', 4, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(161, 187, 'Gift', 'present_gen', 's', 1, 1, 1.00, 1, 0, 0, 1, 0, 1, 1, 1, 'default', 1, '0'),
(162, 188, 'Gift', 'present_gen1', 's', 1, 1, 1.00, 1, 0, 0, 1, 0, 1, 1, 1, 'default', 1, '0'),
(163, 189, 'Gift', 'present_gen2', 's', 1, 1, 1.00, 1, 0, 0, 1, 0, 1, 1, 1, 'default', 1, '0'),
(164, 190, 'Gift', 'present_gen3', 's', 1, 1, 1.00, 1, 0, 0, 1, 0, 1, 1, 1, 'default', 1, '0'),
(165, 191, 'Gift', 'present_gen4', 's', 1, 1, 1.00, 1, 0, 0, 1, 0, 1, 1, 1, 'default', 1, '0'),
(166, 192, 'Gift', 'present_gen5', 's', 1, 1, 1.00, 1, 0, 0, 1, 0, 1, 1, 1, 'default', 1, '0'),
(167, 193, 'Gift', 'present_gen6', 's', 1, 1, 1.00, 1, 0, 0, 1, 0, 1, 1, 1, 'default', 1, '0'),
(168, 195, 'A Pura Minibar', 'bar_basic', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '6,2,5,1'),
(169, 196, 'Pura Shelves', 'shelves_basic', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(170, 197, 'iced sofachair', 'soft_sofachair_norja', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(171, 198, 'iced sofa', 'soft_sofa_norja', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(172, 199, 'Pura Lamp', 'lamp_basic', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(173, 200, 'Lodge Candle', 'lamp2_armas', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(174, 201, 'Pura Refridgerator', 'fridge', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '3,5,6,2'),
(175, 202, 'Telephone Box', 'door', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(176, 204, 'Wardrobe', 'doorB', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(177, 205, 'Portaloo', 'doorC', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(178, 206, 'Pumpkin Lamp', 'pumpkin', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(179, 207, 'Skull Candle Holder', 'skullcandle', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(180, 208, 'Blood', 'deadduck', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(181, 209, 'Dead Duck 2', 'deadduck2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(182, 210, 'Dead Duck 3', 'deadduck3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(183, 211, 'Menorah', 'menorah', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(184, 212, 'Christmas Pudding', 'pudding', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(185, 213, 'Joint of Ham', 'ham', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(186, 214, 'Roast Turkey', 'turkey', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(187, 215, 'Christmas Rubber Duck', 'xmasduck', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(188, 216, 'Gingerbread House', 'house', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(189, 217, 'Electric Candles', 'triplecandle', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(190, 218, 'Christmas Tree 1', 'tree3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(191, 219, 'Christmas Tree 2', 'tree4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(192, 220, 'Christmas Tree 3', 'tree5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(193, 223, 'Eaten Ham', 'ham2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(194, 224, 'White Candle Plate', 'wcandleset', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(195, 225, 'Red Candle Plate', 'rcandleset', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(196, 226, 'Giant Heart', 'statue', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(197, 228, 'Valentine''s Duck', 'valeduck', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(198, 229, 'Heart Sofa', 'heartsofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(199, 230, 'Throne', 'throne', 's', 1, 1, 1.00, 0, 0, 1, 0, 1, 1, 1, 1, 'default', 1, '0'),
(200, 231, 'Russian Samovar', 'samovar', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'vendingmachine', 0, '1'),
(201, 232, 'Vase of Flowers', 'giftflowers', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(202, 233, 'Cake', 'habbocake', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(203, 234, 'Holopod', 'hologram', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(204, 235, 'Wannabe bunny', 'easterduck', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(205, 236, 'Squidgy Bunny', 'bunny', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(206, 237, 'Basket Of Eggs', 'basket', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(207, 238, 'Pop-up Egg', 'birdie', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(208, 239, 'Holo-dice', 'edice', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dice', 1, '0'),
(209, 267, 'Club sofa', 'club_sofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(210, 241, 'Gold Trophy', 'a0 prize1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(211, 242, 'Silver Trophy', 'a0 prize2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(212, 243, 'Bronze Trophy', 'a0 prize3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(213, 244, 'Hatch (Lockable)', 'divider_poly3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(214, 245, 'Corner plinth', 'divider_arm1', 's', 1, 1, 1.40, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(215, 246, 'Room divider', 'divider_arm2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(216, 247, 'Knock', 'divider_arm3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(217, 248, 'Looks squishy', 'divider_nor1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(218, 249, 'Corner Shelf', 'divider_silo1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(219, 250, 'Strong', 'divider_nor2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(220, 251, 'Screen', 'divider_silo2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(221, 252, 'Door (Lockable)', 'divider_nor3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(222, 253, 'Gate (lockable)', 'divider_silo3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(223, 254, 'Typewriter', 'typingmachine', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(224, 260, 'Dragon Egg', 'spyro', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(225, 261, 'Holo-girl', 'redhologram', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(226, 264, 'Poinsetta', 'joulutahti', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(227, 265, 'Pink Hyacinth', 'hyacinth1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(228, 266, 'Blue Hyacinth', 'hyacinth2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(229, 268, 'Chair', 'chair_plasto*10', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(230, 269, 'Chair', 'chair_plasto*11', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(231, 270, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*12', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(232, 271, 'Corner Cabinet/Desk', 'bardeskcorner_polyfon*13', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(233, 273, 'Chair', 'chair_plasto*12', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(234, 274, 'Chair', 'chair_plasto*13', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(235, 275, 'HC chair', 'chair_plasto*14', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(236, 276, 'HC table', 'table_plasto_4leg*14', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(237, 277, 'Mochamaster', 'mocchamaster', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '9,8,14,15,6,10,11,12'),
(238, 278, 'Basketball Court', 'carpet_legocourt', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(239, 279, 'Team Bench', 'bench_lego', 's', 4, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(240, 280, 'Basketball Trophy', 'legotrophy', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 2, '0'),
(241, 283, 'Holiday Romance', 'valentinescreen', 's', 2, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(242, 284, 'Dicemaster', 'edicehc', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dice', 1, '0'),
(243, 285, 'Petal Patch', 'rare_daffodil_rug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(244, 286, 'Blue Amber Lamp', 'rare_beehive_bulb', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(245, 287, 'Throne Sofa', 'hcsohva', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(246, 288, 'Tubmaster', 'hcamme', 's', 1, 2, 0.60, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(247, 290, 'Golden Elephant', 'rare_elephant_statue', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(248, 291, 'Bird Bath (red)', 'rare_fountain', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(249, 292, 'Speaker''s Corner', 'rare_stand', 's', 1, 1, 1.70, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(250, 293, 'Snow Globe', 'rare_globe', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(251, 294, 'Hammock', 'rare_hammock', 's', 1, 3, 1.57, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(252, 295, 'Silver Elephant', 'rare_elephant_statue*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(253, 296, 'Bronze Elephant', 'rare_elephant_statue*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(254, 297, 'Bird Bath (grey)', 'rare_fountain*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(255, 298, 'Bird Bath (green)', 'rare_fountain*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(256, 299, 'Bird Bath (blue)', 'rare_fountain*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(257, 300, 'Red Amber Lamp', 'rare_beehive_bulb*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(258, 301, 'Yellow Amber Lamp', 'rare_beehive_bulb*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(259, 302, 'Lappland Greetings', 'rare_xmas_screen', 's', 2, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(260, 303, 'Yellow Parasol', 'rare_parasol*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(261, 304, 'Orange Parasol', 'rare_parasol*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(262, 305, 'Violet Parasol', 'rare_parasol*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(263, 1758, 'Dead tree', 'tree1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(264, 3312, 'arabian_tile', 'arabian_tile', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(265, 2102, 'White Candle', 'wcandle', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(266, 2121, 'Red Candle', 'rcandle', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(267, 428, 'Gingerbread House', 'house2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(268, 449, 'Habbo Turntable', 'djesko_turntable', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(269, 457, 'Habbo Cola Machine', 'md_limukaappi', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(270, 1484, 'Occasional Table', 'table_plasto_4leg*10', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(271, 1486, 'Occasional Table', 'table_plasto_4leg*15', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(272, 1487, 'Occasional Table', 'table_plasto_bigsquare*14', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(273, 1488, 'Occasional Table', 'table_plasto_bigsquare*15', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(274, 1489, 'Occasional Table', 'table_plasto_round*14', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(275, 1490, 'Occasional Table', 'table_plasto_round*15', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(276, 1491, 'Occasional Table', 'table_plasto_square*14', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(277, 1492, 'Occasional Table', 'table_plasto_square*15', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(278, 1495, 'Chair', 'chair_plasto*15', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(279, 1496, 'Plastic Pod Chair', 'chair_plasty*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(280, 1497, 'Plastic Pod Chair', 'chair_plasty*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(281, 1498, 'Plastic Pod Chair', 'chair_plasty*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(282, 1499, 'Plastic Pod Chair', 'chair_plasty*10', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(283, 1500, 'Plastic Pod Chair', 'chair_plasty*11', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(284, 1501, 'Chair', 'chair_plasto*16', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(285, 1502, 'Occasional Table', 'table_plasto_4leg*16', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(286, 1503, 'Scoreboard', 'hockey_score', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'scoreboard', 100, '0'),
(287, 1504, 'Lert', 'hockey_light', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'alert', 2, '0'),
(288, 1505, 'Imperial Teleport', 'doorD', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(289, 1506, 'Duck trophy', 'a0 prizetrophy2_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(290, 1507, 'Globe trophy', 'a0 prizetrophy3_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(291, 1508, 'Fish trophy', 'a0 prizetrophy4_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(292, 1509, 'Champion trophy', 'a0 prizetrophy5_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(293, 1512, 'Classic trophy', 'prizetrophy*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(294, 1512, 'Duck trophy', 'a0 prizetrophy2_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(295, 1513, 'Globe trophy', 'a0 prizetrophy3_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(296, 1514, 'Fish trophy', 'a0 prizetrophy4_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(297, 1515, 'Duo trophy', 'a0 prizetrophy5_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(298, 1516, 'Champion trophy', 'a0 prizetrophy6_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(299, 1519, 'Classic trophy', 'prizetrophy*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(300, 1518, 'Duck trophy', 'a0 prizetrophy2_s', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(301, 1519, 'Globe trophy', 'a0 prizetrophy3_s', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(302, 1520, 'Fish trophy', 'a0 prizetrophy4_s', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(303, 1521, 'Duo trophy', 'a0 prizetrophy5_s', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(304, 1522, 'Champion trophy', 'a0 prizetrophy6_s', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(305, 1526, 'Classic trophy', 'prizetrophy*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(306, 289, 'Green Parasol', 'rare_parasol*0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(307, 1529, 'Oil Lamp', 'hc_lmp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(308, 1528, 'Nordic Table', 'hc_tbl', 's', 1, 3, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(309, 1527, 'Majestic Chair', 'hc_chr', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(310, 1530, 'Study Desk', 'hc_dsk', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(311, 1531, 'Night', 'nest', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(312, 1532, 'Bones Mega Multipack', 'petfood1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(313, 1533, 'Sardines Mega Multipack', 'petfood2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(314, 1534, 'Cabbage Mega Multipack', 'petfood3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(315, 1535, 'Blue Water Bowl', 'waterbowl*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(316, 1536, 'Brown Water Bowl', 'waterbowl*5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(317, 1537, 'Green Water Bowl', 'waterbowl*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(318, 1538, 'Red Water Bowl', 'waterbowl*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(319, 1539, 'Yellow Water Bowl', 'waterbowl*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(320, 1540, 'Rubber Ball', 'toy1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(321, 1541, 'Rubber Ball', 'toy1*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(322, 1542, 'Rubber Ball', 'toy1*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(323, 1543, 'Rubber Ball', 'toy1*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(324, 1544, 'Rubber Ball', 'toy1*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(325, 1545, 'Marzipan Man', 'goodie1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(326, 1546, 'Marzipan Man', 'goodie1*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(327, 1547, 'Marzipan Man', 'goodie1*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(328, 1548, 'Chocolate Mouse', 'goodie2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(329, 1547, 'Bronze Habbo trophy', 'a0 prizetrophy7_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(330, 1548, 'Gold Habbo trophy', 'a0 prizetrophy7_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(331, 1549, 'Silver Habbo trophy', 'a0 prizetrophy7_s', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(332, 1549, 'Red Laser Door', 'scifiport*0', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(333, 1550, 'Violet Sci-Fi Port', 'scifiport*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(334, 1551, 'Purple Sci-Fi Port', 'scifiport*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(335, 1552, 'Aqua Laser Gate', 'scifiport*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(336, 1553, 'White Sci-Fi Port', 'scifiport*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(337, 1554, 'Security Fence', 'scifiport*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(338, 1555, 'Pink Sci-Fi Port', 'scifiport*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(339, 1556, 'Jade Sci-Fi Port', 'scifiport*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(340, 1557, 'Blue Laser Gate', 'scifiport*2', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(341, 1558, 'Gold Laser Gate', 'scifiport*1', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(342, 1559, 'Neptune Smoke Machine', 'scifirocket*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(343, 1560, 'From a space far', 'scifirocket*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(344, 1561, 'Jupiter Smoke Machine', 'scifirocket*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(345, 1562, 'Mercury Smoke Machine', 'scifirocket*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(346, 1563, 'Uranus Smoke Machine', 'scifirocket*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(347, 1564, 'Venus Smoke Machine', 'scifirocket*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(348, 1565, 'Endor Smoke Machine', 'scifirocket*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(349, 1566, 'Earth Smoke Machine', 'scifirocket*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(350, 1567, 'Saturn Smoke Machine', 'scifirocket*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(351, 1568, 'Mars Smoke Machine', 'scifirocket*0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(352, 1569, 'Violet Starship Door', 'scifidoor*10', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(353, 1570, 'It''s blue', 'scifidoor*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(354, 1571, 'Purple Spaceship Door', 'scifidoor*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(355, 1572, 'Aqua Spaceship Door', 'scifidoor*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(356, 1573, 'Black Monolith', 'scifidoor*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(357, 1574, 'White Spaceship Door', 'scifidoor*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(358, 1575, 'Emerald Spaceship Door', 'scifidoor*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(359, 1576, 'Lightblue Spaceship Door', 'scifidoor*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(360, 1577, 'Yellow Spaceship Door', 'scifidoor*2', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(361, 1578, 'Pink Spaceship Door', 'scifidoor*1', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(362, 1579, 'Puffy', 'pillow*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(363, 1580, 'Puffy', 'pillow*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(364, 1581, 'White Lace Pillow', 'pillow*0', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(365, 1582, 'Puffy', 'pillow*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(366, 1583, 'Puffy', 'pillow*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(367, 1584, 'Purple Velvet Pillow', 'pillow*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(368, 1585, 'Puffy', 'pillow*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(369, 1586, 'Puffy', 'pillow*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(370, 1587, 'Puffy', 'pillow*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(371, 1588, 'Puffy', 'pillow*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(372, 1589, 'Pink marquee', 'marquee*1', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(373, 1590, 'Red Dragon Marquee', 'marquee*2', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(374, 1591, 'Purple Marquee', 'marquee*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(375, 1592, 'White Marquee', 'marquee*10', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(376, 1593, 'Ultramarine Marquee', 'marquee*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(377, 1594, 'Green Marquee', 'marquee*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(378, 1595, 'Graphite Marquee', 'marquee*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(379, 1596, 'Yellow Marquee', 'marquee*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(380, 1597, 'Blue Marquee', 'marquee*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(381, 1598, 'Aqua Marquee', 'marquee*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(382, 1599, 'Pink Oriental screen', 'wooden_screen*1', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(383, 1600, 'RosewoodScreen', 'wooden_screen*2', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(384, 1601, 'Purple Oriental Screen', 'wooden_screen*7', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(385, 1602, 'White Oriental Screen', 'wooden_screen*0', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(386, 1603, 'Night Blue Oriental Screen', 'wooden_screen*8', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(387, 1604, 'Gray Oriental Screen', 'wooden_screen*5', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(388, 1605, 'Green Oriental Screen', 'wooden_screen*9', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(389, 1606, 'Golden Oriental Screen', 'wooden_screen*4', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(390, 1607, 'Blue Oriental Screen', 'wooden_screen*6', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(391, 1608, 'Terracotta Pillar', 'wooden_screen*3', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(392, 1610, 'Pink Marble Pillar', 'pillar*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(393, 1611, 'Rock Pillar', 'pillar*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(394, 1612, 'Classy architect', 'pillar*0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(395, 1613, 'Roman Pillar', 'pillar*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(396, 1614, 'Nordic Pillar', 'pillar*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(397, 1615, 'Pagan Pillar', 'pillar*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(398, 1616, 'Dark Ages Pillar', 'pillar*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(399, 1617, 'Atlantean Pillar', 'pillar*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(400, 1618, 'blue pillar', 'pillar*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(401, 1619, 'Serpent of Doom', 'rare_dragonlamp*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(402, 1620, 'Fire Dragon Lamp', 'rare_dragonlamp*0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(403, 1621, 'Elf Green Dragon Lamp', 'rare_dragonlamp*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(404, 1622, 'Jade Dragon Lamp', 'rare_dragonlamp*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(405, 1623, 'Bronze Dragon Lamp', 'rare_dragonlamp*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(406, 1624, 'Purple Dragon Lamp', 'rare_dragonlamp*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(407, 1625, 'Sky Dragon Lamp', 'rare_dragonlamp*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(408, 1626, 'Gold Dragon Lamp', 'rare_dragonlamp*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(409, 1627, 'Sea Dragon Lamp', 'rare_dragonlamp*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(410, 1628, 'Silver Dragon Lamp', 'rare_dragonlamp*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(411, 1629, 'Blueberry Ice Cream Machine', 'rare_icecream*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(412, 1630, 'Chocolate Ice Cream Machine', 'rare_icecream*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(413, 1631, 'Peppermint Ice Cream Machine', 'rare_icecream*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(414, 1632, 'Pistachio Ice Cream Machine', 'rare_icecream*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(415, 1633, 'Toffee Ice Cream Machine', 'rare_icecream*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(416, 1634, 'Bubblegum Ice Cream Machine', 'rare_icecream*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(417, 1635, 'Blackcurrant Ice Cream Machine', 'rare_icecream*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(418, 1636, 'Cherry Ice Cream Machine', 'rare_icecream*0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(419, 1637, 'Strawberry Ice Cream Machine', 'rare_icecream*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(420, 1638, 'Vanilla Ice Cream Machine', 'rare_icecream*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(421, 1639, 'Brown Powered Fan', 'rare_fan*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(422, 1640, 'Ochre Powered Fan', 'rare_fan*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(423, 1641, 'Fucsia Powered Fan', 'rare_fan*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(424, 1642, 'Purple Dragon Skin Fan', 'rare_fan*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(425, 1643, 'Festive Fan', 'rare_fan*0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(426, 1644, 'SUPERLOVE Fan', 'rare_fan*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(427, 1645, 'Yellow Powered Fan', 'rare_fan*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(428, 1646, 'Birthday Fan', 'rare_fan*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(429, 1647, 'Stylish', 'rare_fan*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(430, 1648, 'Green Powered Fan', 'rare_fan*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(431, 1649, 'Ice Habbo Roller', 'queue_tile1*3', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(432, 1650, 'Blue Habbo Roller', 'queue_tile1*6', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(433, 1651, 'Gold Habbo Roller', 'queue_tile1*4', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(434, 1652, 'Green Habbo Roller', 'queue_tile1*9', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(435, 1653, 'Navy Habbo Roller', 'queue_tile1*8', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(436, 1654, 'Knight Roller', 'queue_tile1*5', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(437, 1655, 'Purple Habbo Roller', 'queue_tile1*7', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(438, 1656, 'Red Habbo Roller', 'queue_tile1*2', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(439, 1657, 'Pink Habbo Roller', 'queue_tile1*1', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(440, 1658, 'White Quest Roller', 'queue_tile1*0', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(441, 3278, 'ads_gsArcade_2 name', 'ads_gsArcade_2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(442, 1738, 'Snow Rug', 'rare_snowrug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(443, 1741, 'Lantern', 'cn_lamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(444, 1742, 'Chinese Sofa', 'cn_sofa', 's', 3, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(445, 1745, 'Sport track straight', 'sporttrack1*1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(446, 1747, 'Sport track straight grass', 'sporttrack1*3', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(447, 1748, 'Sport track straight asphalt', 'sporttrack1*2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(448, 1750, 'Sport corner tartan', 'sporttrack2*1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(449, 1751, 'Sport corner asphalt', 'sporttrack2*2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(450, 1752, 'Sport corner grass', 'sporttrack2*3', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(451, 1754, 'Sport goal tartan', 'sporttrack3*1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(452, 1755, 'Sport goal asphalt', 'sporttrack3*2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(453, 1756, 'Sport goal grass', 'sporttrack3*3', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(454, 1757, 'Football Lamp', 'footylamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(455, 1759, 'Bar Stool', 'barchair_silo', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(456, 1760, 'Habbos', 'divider_nor4*4', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(457, 1761, 'Classic Traffic Light', 'traffic_light*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(458, 1762, 'Blue Traffic Light', 'traffic_light*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(459, 1763, 'Purple Traffic Light', 'traffic_light*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(460, 1764, 'Yellow Traffic Light', 'traffic_light*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(461, 1765, 'Red Traffic Light', 'traffic_light*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(462, 1766, 'Blue Inflatable Chair', 'rubberchair*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(463, 1767, 'Pink Inflatable Chair', 'rubberchair*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(464, 1768, 'Orange Inflatable Chair', 'rubberchair*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(465, 1769, 'Ocean Inflatable Chair', 'rubberchair*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(466, 1770, 'Lime Inflatable Chair', 'rubberchair*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(467, 1771, 'Violet Inflatable Chair', 'rubberchair*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(468, 1772, 'Yellow Maze Barrier', 'barrier*1', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(469, 1773, 'No trespassing', 'barrier*2', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(470, 1774, 'No trespassing', 'barrier*3', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(471, 1775, 'White Inflatable Chair', 'rubberchair*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(472, 1776, 'Black Inflatable Chair', 'rubberchair*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(473, 1777, 'Black Iced Table', 'table_norja_med*2', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0');
INSERT INTO `items_base` (`item_id`, `sprite_id`, `public_name`, `item_name`, `type`, `width`, `length`, `height`, `allow_stack`, `allow_walk`, `allow_sit`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `cycle_count`, `vending_ids`) VALUES
(474, 1778, 'White Iced Table', 'table_norja_med*3', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(475, 1779, 'Urban Iced Coffee Table', 'table_norja_med*4', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(476, 1780, 'Large Coffee Table Pink', 'table_norja_med*5', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(477, 1781, 'Large Coffee Table Blue', 'table_norja_med*6', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(478, 1782, 'Rural Iced Coffee Table', 'table_norja_med*7', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(479, 1783, 'Large Coffee Table Yellow', 'table_norja_med*8', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(480, 1784, 'Large Coffee Table Red', 'table_norja_med*9', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(481, 1785, 'Black Iced Bench', 'couch_norja*2', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(482, 1786, 'White Iced Bench', 'couch_norja*3', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(483, 1787, 'Urban Iced Bench', 'couch_norja*4', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(484, 1788, 'Pink Bench', 'couch_norja*5', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(485, 1789, 'Blue Bench', 'couch_norja*6', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(486, 1790, 'Rural Iced Bench', 'couch_norja*7', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(487, 1791, 'Yellow Bench', 'couch_norja*8', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(488, 1792, 'Red Bench', 'couch_norja*9', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(489, 1793, 'Black Iced Bookcase', 'shelves_norja*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(490, 1794, 'Urban Iced Bookcase', 'shelves_norja*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(491, 1796, 'Pink Bookcase', 'shelves_norja*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(492, 1797, 'Blue Bookcase', 'shelves_norja*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(493, 1798, 'Rural Iced Bookcase', 'shelves_norja*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(494, 1799, 'Yellow Bookcase', 'shelves_norja*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(495, 1800, 'Red Bookcase', 'shelves_norja*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(496, 1801, 'Black Iced Chair', 'chair_norja*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(497, 1802, 'White Iced Chair', 'chair_norja*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(498, 1803, 'Urban Iced Chair', 'chair_norja*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(499, 1804, 'Pink Chair', 'chair_norja*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(500, 1805, 'Blue Chair', 'chair_norja*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(501, 1806, 'Rural Chair', 'chair_norja*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(502, 1807, 'Yellow Chair', 'chair_norja*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(503, 1808, 'Red Chair', 'chair_norja*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(504, 1809, 'Black Iced Corner', 'divider_nor1*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(505, 1810, 'Looks squishy', 'divider_nor1*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(506, 1811, 'Urban Iced Corner', 'divider_nor1*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(507, 1812, 'Pink Ice corner', 'divider_nor1*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(508, 1813, 'Blue Ice corner', 'divider_nor1*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(509, 1814, 'Rural Iced Corner', 'divider_nor1*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(510, 1815, 'Yellow Ice corner', 'divider_nor1*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(511, 1816, 'Red Ice corner', 'divider_nor1*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(512, 1817, 'Black Iced Sofa', 'soft_sofa_norja*2', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(513, 1818, 'Pristine white', 'soft_sofa_norja*3', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(514, 1819, 'Urban Iced Sofa', 'soft_sofa_norja*4', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(515, 1820, 'Pink Iced Sofa', 'soft_sofa_norja*5', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(516, 1821, 'Blue Iced Sofa', 'soft_sofa_norja*6', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(517, 1822, 'Rural Iced Sofa', 'soft_sofa_norja*7', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(518, 1823, 'Yellow Iced Sofa', 'soft_sofa_norja*8', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(519, 1824, 'Red Iced Sofa', 'soft_sofa_norja*9', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(520, 1825, 'Black Iced Sofachair', 'soft_sofachair_norja*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(521, 1826, 'White Iced Sofachair', 'soft_sofachair_norja*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(522, 1827, 'Urban Iced Sofachair', 'soft_sofachair_norja*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(523, 1828, 'Pink Iced Sofachair', 'soft_sofachair_norja*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(524, 1829, 'Blue Iced Sofachair', 'soft_sofachair_norja*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(525, 1830, 'Rural Iced Sofachair', 'soft_sofachair_norja*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(526, 1831, 'Yellow Iced Sofachair', 'soft_sofachair_norja*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(527, 1832, 'Red Iced Sofachair', 'soft_sofachair_norja*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(528, 1833, 'Large', 'sofachair_silo*2', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(529, 1834, 'Large', 'sofachair_silo*3', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(530, 1835, 'Beige Area Armchair', 'sofachair_silo*4', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(531, 1836, 'Pink Area Armchair', 'sofachair_silo*5', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(532, 1837, 'Blue Area Armchair', 'sofachair_silo*6', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(533, 1838, 'Green Area Armchair', 'sofachair_silo*7', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(534, 1839, 'Large', 'sofachair_silo*8', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(535, 1840, 'Red Area Armchair', 'sofachair_silo*9', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(536, 1841, 'Black Occasional Table', 'table_silo_small*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(537, 1842, 'White Occasional Table', 'table_silo_small*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(538, 1843, 'Beige Area Occasional Table', 'table_silo_small*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(539, 1844, 'Pink Area Occasional Table', 'table_silo_small*5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(540, 1845, 'Blue Area Occasional Table', 'table_silo_small*6', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(541, 1846, 'Green Area Occasional Table', 'table_silo_small*7', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(542, 1847, 'Yellow Occasional Table', 'table_silo_small*8', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(543, 1848, 'Red Area Occasional Table', 'table_silo_small*9', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(544, 1849, 'Black Corner Shelf', 'divider_silo1*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(545, 1850, 'White Corner Shelf', 'divider_silo1*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(546, 1851, 'Beige Area Corner Shelf', 'divider_silo1*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(547, 1852, 'Pink Area Corner Shelf', 'divider_silo1*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(548, 1853, 'Blue Area Corner Shelf', 'divider_silo1*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(549, 1854, 'Green Area Corner Shelf', 'divider_silo1*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(550, 1855, 'Yellow Corner Shelf', 'divider_silo1*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(551, 1856, 'Red Area Corner Shelf', 'divider_silo1*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(552, 1857, 'Black Area Gate', 'divider_silo3*2', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(553, 1858, 'White Area Gate', 'divider_silo3*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(554, 1859, 'Beige Area Gate', 'divider_silo3*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(555, 1860, 'Pink Area Gate', 'divider_silo3*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(556, 1861, 'Blue Area Gate', 'divider_silo3*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(557, 1862, 'Green Area Gate', 'divider_silo3*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(558, 1863, 'Yellow Area Gate', 'divider_silo3*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(559, 1864, 'Red Area Gate', 'divider_silo3*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(560, 1865, 'Black Coffee Table', 'table_silo_med*2', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(561, 1866, 'White Coffee Table', 'table_silo_med*3', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(562, 1867, 'Beige Area Coffee Table', 'table_silo_med*4', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(563, 1868, 'Pink Area Coffee Table', 'table_silo_med*5', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(564, 1869, 'Blue Area Coffee Table', 'table_silo_med*6', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(565, 1870, 'Green Area Coffee Table', 'table_silo_med*7', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(566, 1871, 'Yellow Coffee Table', 'table_silo_med*8', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(567, 1872, 'Red Area Coffee Table', 'table_silo_med*9', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(568, 1873, 'Cushioned', 'sofa_silo*2', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(569, 1874, 'Cushioned', 'sofa_silo*3', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(570, 1875, 'Beige Area Sofa', 'sofa_silo*4', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(571, 1876, 'Pink Area Sofa', 'sofa_silo*5', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(572, 1877, 'Blue Area Sofa', 'sofa_silo*6', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(573, 1878, 'Green Area Sofa', 'sofa_silo*7', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(574, 1879, 'Cushioned', 'sofa_silo*8', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(575, 1880, 'Red Area Sofa', 'sofa_silo*9', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(576, 1881, 'Black Mode Armchair', 'sofachair_polyfon*2', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(577, 1882, 'White Armchair', 'sofachair_polyfon*3', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(578, 1883, 'Beige Mode Armchair', 'sofachair_polyfon*4', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(579, 1884, 'Blue Mode Armchair', 'sofachair_polyfon*6', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(580, 1885, 'Green Armchair', 'sofachair_polyfon*7', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(581, 1886, 'Yellow Mode Armchair', 'sofachair_polyfon*8', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(582, 1887, 'Red Armchair', 'sofachair_polyfon*9', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(583, 1888, 'Black Mode Sofa', 'sofa_polyfon*2', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(584, 1889, 'White Two-seater Sofa', 'sofa_polyfon*3', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(585, 1890, 'Beige Mode Sofa', 'sofa_polyfon*4', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(586, 1891, 'Blue Mode Sofa', 'sofa_polyfon*6', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(587, 1892, 'Green Two-seater Sofa', 'sofa_polyfon*7', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(588, 1893, 'Yellow Mode Sofa', 'sofa_polyfon*8', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(589, 1894, 'Black Mode Double Bed', 'sofa_polyfon*9', 's', 2, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(590, 1896, 'White Double Bed', 'bed_polyfon*3', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(591, 1897, 'Beige Mode Double Bed', 'bed_polyfon*4', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(592, 1898, 'Blue Mode Double Bed', 'bed_polyfon*6', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(593, 1899, 'Green Double Bed', 'bed_polyfon*7', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(594, 1900, 'Yellow Mode Double Bed', 'bed_polyfon*8', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(595, 1901, 'Red Double Bed', 'bed_polyfon*9', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(596, 1902, 'Black Mode Single Bed', 'bed_polyfon_one*2', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(597, 1903, 'White Single Bed', 'bed_polyfon_one*3', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(598, 1904, 'Beige Mode Single Bed', 'bed_polyfon_one*4', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(599, 1905, 'Blue Mode Single Bed', 'bed_polyfon_one*6', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(600, 1906, 'Green Single Bed', 'bed_polyfon_one*7', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(601, 1907, 'Yellow Mode Single Bed', 'bed_polyfon_one*8', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(602, 1908, 'Red Single Bed', 'bed_polyfon_one*9', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(603, 1909, 'Black Mode Bardesk', 'bardesk_polyfon*2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(604, 1910, 'White Bardesk', 'bardesk_polyfon*3', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(605, 1911, 'Beige Mode Bardesk', 'bardesk_polyfon*4', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(606, 1912, 'Candy Bar', 'bardesk_polyfon*5', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(607, 1913, 'Blue Mode Bardesk', 'bardesk_polyfon*6', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(608, 1914, 'Green Bardesk', 'bardesk_polyfon*7', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(609, 1915, 'Yellow Mode Bardesk', 'bardesk_polyfon*8', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(610, 1916, 'Red Bardesk', 'bardesk_polyfon*9', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(611, 1917, 'Black Mode Bardesk Corner', 'bardeskcorner_polyfon*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(612, 1918, 'White Corner Desk', 'bardeskcorner_polyfon*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(613, 1919, 'Beige Mode Bardesk Corner', 'bardeskcorner_polyfon*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(614, 1920, 'Candy Corner', 'bardeskcorner_polyfon*5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(615, 1921, 'Blue Mode Bardesk Corner', 'bardeskcorner_polyfon*6', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(616, 1922, 'Green Corner Desk', 'bardeskcorner_polyfon*7', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(617, 1923, 'Yellow Mode Bardesk Corner', 'bardeskcorner_polyfon*8', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(618, 1924, 'Red Corner Desk', 'bardeskcorner_polyfon*9', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(619, 1925, 'Black Mode Bardesk Gate', 'divider_poly3*2', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(620, 1926, 'White Hatch', 'divider_poly3*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(621, 1927, 'Beige Mode Bardesk Gate', 'divider_poly3*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(622, 1928, 'Candy Hatch (Lockable)', 'divider_poly3*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(623, 1929, 'Blue Mode Bardesk Gate', 'divider_poly3*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(624, 3276, 'ads_idol_l_carpet name', 'ads_idol_l_carpet', 's', 2, 7, 0.00, 1, 0, 0, 1, 1, 1, 1, 1, '', 1, '0'),
(625, 1931, 'Yellow Mode Bardesk Gate', 'divider_poly3*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(626, 1932, 'Red Hatch', 'divider_poly3*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(627, 1933, 'Black Dining Chair', 'chair_silo*2', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(628, 1934, 'White Dining Chair', 'chair_silo*3', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(629, 1935, 'Beige Silo Dining Chair', 'chair_silo*4', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(630, 1936, 'Pink Silo Dining Chair', 'chair_silo*5', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(631, 1937, 'Blue Area Dining Chair', 'chair_silo*6', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(632, 1938, 'Green Area Dining Chair', 'chair_silo*7', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(633, 1939, 'Yellow Dining Chair', 'chair_silo*8', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(634, 1940, 'Red Area Dining Chair', 'chair_silo*9', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(635, 1941, 'No way through', 'divider_nor3*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(636, 1942, 'White Iced Gate', 'divider_nor3*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(637, 1943, 'Urban Iced Gate', 'divider_nor3*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(638, 1944, 'Pink Iced gate', 'divider_nor3*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(639, 1945, 'Blue Iced gate', 'divider_nor3*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(640, 1946, 'Rural Iced gate', 'divider_nor3*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(641, 1947, 'Yellow Iced gate', 'divider_nor3*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(642, 1948, 'Red Iced gate', 'divider_nor3*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(643, 1949, 'Black Iced Bar-Desk', 'divider_nor2*2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(644, 1950, 'Strong', 'divider_nor2*3', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(645, 1951, 'Urban Iced Bar', 'divider_nor2*4', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(646, 1952, 'Pink Iced bar desk', 'divider_nor2*5', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(647, 1953, 'Blue Iced  bar desk', 'divider_nor2*6', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(648, 1954, 'Rural Iced Bar', 'divider_nor2*7', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(649, 1955, 'Yellow Iced  bar desk', 'divider_nor2*8', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(650, 1956, 'Red Iced  bar desk', 'divider_nor2*9', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(651, 1957, 'Area Quest Desk', 'silo_studydesk', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(652, 1958, 'White Solarium', 'solarium_norja', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(653, 1959, 'Black Solarium', 'solarium_norja*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(654, 1960, 'Beige Solarium', 'solarium_norja*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(655, 1961, 'Urban Solarium', 'solarium_norja*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(656, 1962, 'Pink Solarium', 'solarium_norja*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(657, 1963, 'Blue Solarium', 'solarium_norja*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(658, 1964, 'Rural Solarium', 'solarium_norja*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(659, 1965, 'Yellow Solarium', 'solarium_norja*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(660, 1966, 'Red Solarium', 'solarium_norja*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(661, 1967, 'Tropical Beach Rug', 'sandrug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(662, 1968, 'Moon Patch', 'rare_moonrug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(663, 1969, 'Chinese Lacquer Chair', 'chair_china', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(664, 1970, 'Chinese Lacquer Table', 'china_table', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(665, 1971, 'Red Sleeping Bag', 'sleepingbag*1', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(666, 1972, 'Lime Sleeping Bag', 'sleepingbag*2', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(667, 1973, 'Ocean Sleeping Bag', 'sleepingbag*3', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(668, 1974, 'Safety Sleeping Bag', 'sleepingbag*4', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(669, 1975, 'Safe Minibar', 'safe_silo', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(670, 1976, 'Orange Sleeping Bag', 'sleepingbag*7', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(671, 1977, 'eXceptional Sleeping Bag', 'sleepingbag*9', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(672, 1978, 'Graphite Sleeping Bag', 'sleepingbag*5', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(673, 1979, 'Khaki Sleeping Bag', 'sleepingbag*10', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(674, 1980, 'Purple Sleeping Bag', 'sleepingbag*6', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(675, 1981, 'Golden Sleeping Bag', 'sleepingbag*8', 's', 1, 3, 0.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(676, 1982, 'Chinese Bookshelf', 'china_shelve', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(677, 1983, 'White Traffic Light', 'traffic_light*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(678, 1984, 'Habbos', 'divider_nor4*2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(679, 1985, 'Habbos', 'divider_nor4*3', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(680, 1986, 'Habbos', 'divider_nor4*5', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(681, 1987, 'Habbos', 'divider_nor4*6', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(682, 1988, 'Habbos', 'divider_nor4*7', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(683, 1989, 'Habbos', 'divider_nor4*8', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(684, 1990, 'Habbos', 'divider_nor4*9', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(685, 1991, 'Black Iced Angle', 'divider_nor5*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(686, 1992, 'White Iced Angle', 'divider_nor5*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(687, 1993, 'Urban Iced Angle', 'divider_nor5*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(688, 1994, 'Blue Iced Angle', 'divider_nor5*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(689, 1996, 'Rural Iced Angle', 'divider_nor5*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(690, 1997, 'Yellow Iced Angle', 'divider_nor5*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(691, 1998, 'Red Iced Angle', 'divider_nor5*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(692, 1999, 'Plain Iced Angle', 'divider_nor5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(693, 2000, 'Habbos', 'divider_nor4', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(694, 2001, 'Dragon Screen', 'wall_china', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(695, 2002, 'Firm', 'corner_china', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(696, 2003, 'Black Bar Stool', 'barchair_silo*2', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(697, 2004, 'White Bar Stool', 'barchair_silo*3', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(698, 2005, 'Beige Bar Stool', 'barchair_silo*4', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(699, 2006, 'Pink Bar Stool', 'barchair_silo*5', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(700, 2007, 'Blue Bar Stool', 'barchair_silo*6', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(701, 2008, 'Green Bar Stool', 'barchair_silo*7', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(702, 2009, 'Yellow Bar Stool', 'barchair_silo*8', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(703, 2010, 'Red Bar Stool', 'barchair_silo*9', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(704, 2011, 'Black Safe Minibar', 'safe_silo*2', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(705, 2012, 'White Safe Minibar', 'safe_silo*3', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(706, 2013, 'Beige Safe Minibar', 'safe_silo*4', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(707, 2014, 'Pink Safe Minibar', 'safe_silo*5', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(708, 2015, 'Blue Safe Minibar', 'safe_silo*6', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(709, 2016, 'Green Safe Minibar', 'safe_silo*7', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(710, 2017, 'Yellow Safe Minibar', 'safe_silo*8', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(711, 2018, 'Red Safe Minibar', 'safe_silo*9', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(712, 2019, 'Glass shelf', 'glass_shelf', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(713, 2020, 'Glass chair', 'glass_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(714, 2021, 'Glass stool', 'glass_stool', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(715, 2022, 'Glass sofa', 'glass_sofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(716, 2023, 'Glass table', 'glass_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(717, 2024, 'Glass table', 'glass_table*2', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(718, 2025, 'White Glass Table', 'glass_table*3', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(719, 2026, 'Glass table', 'glass_table*4', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(720, 2027, 'Candy Glass Table', 'glass_table*5', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(721, 2028, 'Blue Glass Table', 'glass_table*6', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(722, 2029, 'Green Glass Table', 'glass_table*7', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(723, 2030, 'Yellow Glass Table', 'glass_table*8', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(724, 2031, 'Glass table', 'glass_table*9', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(725, 2032, 'Glass chair', 'glass_chair*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(726, 2033, 'Glass chair', 'glass_chair*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(727, 2034, 'Glass chair', 'glass_chair*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(728, 2035, 'Candy Glass Chair', 'glass_chair*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(729, 2036, 'Blue Glass Chair', 'glass_chair*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(730, 2037, 'Green Glass Chair', 'glass_chair*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(731, 2038, 'Yellow Glass Chair', 'glass_chair*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(732, 2039, 'Glass chair', 'glass_chair*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(733, 2040, 'Glass sofa', 'glass_sofa*2', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(734, 2041, 'White Glass Sofa', 'glass_sofa*3', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(735, 2042, 'Glass sofa', 'glass_sofa*4', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(736, 2043, 'Candy Glass Sofa', 'glass_sofa*5', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(737, 2044, 'Blue Glass Sofa', 'glass_sofa*6', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(738, 2045, 'Green Glass Sofa', 'glass_sofa*7', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(739, 2046, 'Yellow Glass Sofa', 'glass_sofa*8', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(740, 2047, 'Glass sofa', 'glass_sofa*9', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(741, 2048, 'Glass stool', 'glass_stool*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(742, 2050, 'Glass stool', 'glass_stool*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(743, 2051, 'Candy Glass Stool', 'glass_stool*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(744, 2052, 'Blue Glass Stool', 'glass_stool*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(745, 2053, 'Green Glass Stool', 'glass_stool*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(746, 2054, 'Yellow Glass Stool', 'glass_stool*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(747, 2056, 'White Glass Stool', 'glass_stool*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(748, 2057, 'Glass stool', 'glass_stool*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(749, 2063, 'Gold Coin', 'CF_10_coin_gold', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(750, 2064, 'Bronze Coin', 'CF_1_coin_bronze', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(751, 2065, 'Sack of Credits', 'CF_20_moneybag', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(752, 2066, 'Gold Bar', 'CF_50_goldbar', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(753, 2067, 'Silver Coin', 'CF_5_coin_silver', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(754, 2068, 'Persian Carpet', 'hc_crpt', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(755, 2069, 'Forget plasma', 'hc_tv', 's', 2, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(756, 2070, 'Gothic Portcullis', 'gothgate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(757, 2071, 'Gothic Candelabra', 'gothiccandelabra', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(758, 2072, 'Gothic Railing', 'gothrailing', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(759, 2073, 'Gothic table', 'goth_table', 's', 1, 5, 1.70, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(760, 2074, 'Medieval Bookcase', 'hc_bkshlf', 's', 1, 4, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(761, 2075, 'Electric Butler', 'hc_btlr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '24'),
(762, 2076, 'Antique Drapery', 'hc_crtn', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(763, 2077, 'The Grammophon', 'hc_djset', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(764, 2078, 'Heavy Duty Fireplace', 'hc_frplc', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(765, 2079, 'Victorian Street Light', 'hc_lmpst', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(766, 2080, 'Weird Science Machine', 'hc_machine', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(767, 2081, 'HC Rollers Set', 'hc_rllr', 's', 1, 1, 0.50, 0, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(768, 2082, 'X-Ray Divider', 'hc_rntgn', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(769, 2083, 'Drinks Trolley', 'hc_trll', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(770, 2084, 'Gothic Chair Pink', 'gothic_chair*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(771, 2085, 'Gothic Sofa Pink', 'gothic_sofa*1', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(772, 2086, 'Gothic Stool Pink', 'gothic_stool*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(773, 2087, 'Golden Gothic Chair', 'gothic_chair*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(774, 2088, 'Golden Gothic Sofa', 'gothic_sofa*2', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(775, 2089, 'Golden Gothic Stool', 'gothic_stool*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(776, 2090, 'Red Gothic Chair', 'gothic_chair*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(777, 2091, 'Red Gothic Sofa', 'gothic_sofa*3', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(778, 2092, 'Red Gothic Stool', 'gothic_stool*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(779, 2093, 'Black Gothic Chair', 'gothic_chair*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(780, 2094, 'Black Gothic Sofa', 'gothic_sofa*4', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(781, 2095, 'Black Gothic Stool', 'gothic_stool*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(782, 2096, 'Green Gothic Chair', 'gothic_chair*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(783, 2097, 'Green Gothic Sofa', 'gothic_sofa*5', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(784, 2098, 'Green Gothic Stool', 'gothic_stool*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(785, 2099, 'Gothic Chair Blue', 'gothic_chair*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(786, 2100, 'Gothic Sofa Blue', 'gothic_sofa*6', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(787, 2101, 'Valentine''s Cauldron', 'gothic_stool*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(788, 2105, 'Sound Machine', 'sound_machine', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(789, 2106, 'Turquoise Romantique Piano Chair', 'romantique_pianochair*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(790, 2107, 'Onyx Piano Stool', 'romantique_pianochair*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(791, 2108, 'Lime Romantique Piano Chair', 'romantique_pianochair*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(792, 2109, 'Amber Piano Stool', 'romantique_pianochair*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(793, 2110, 'Rose Quartz Piano Stool', 'romantique_pianochair*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(794, 2111, 'Turquoise Romantique Divan', 'romantique_divan*3', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(795, 2112, 'Onyx Chaise-Longue', 'romantique_divan*5', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(796, 2113, 'Emerald Chaise-Longue', 'romantique_divan*2', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(797, 2114, 'Amber Chaise-Longue', 'romantique_divan*4', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(798, 2115, 'Rose Quartz Chaise-Longue', 'romantique_divan*1', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(799, 2116, 'Turquoise Romantique Chair', 'romantique_chair*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(800, 2117, 'Onyx Chair', 'romantique_chair*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(801, 2118, 'Lime Romantique Chair', 'romantique_chair*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(802, 2119, 'Amber Chair', 'romantique_chair*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(803, 2120, 'Rose Quartz Chair', 'romantique_chair*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(804, 2123, 'Yellow Valentine Rose', 'plant_valentinerose*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(805, 2124, 'Purple Valentine''s Rose', 'plant_valentinerose*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(806, 2125, 'White Valentine''s Rose', 'plant_valentinerose*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(807, 2126, 'Pink Valentine''s Rose', 'plant_valentinerose*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(808, 2127, 'Red Valentine''s Rose', 'plant_valentinerose*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(809, 2128, 'Maze Shrubbery Gate', 'plant_mazegate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(810, 2129, 'Maze Shrubbery', 'plant_maze', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(811, 2130, 'Bulrush', 'plant_bulrush', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(812, 2131, 'T-Bones Mega Multipack', 'petfood4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(813, 2132, 'Red carpet', 'carpet_valentine', 's', 2, 7, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(814, 2133, 'Cobbled Path', 'gothic_carpet', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(815, 2134, 'Dungeon Floor', 'gothic_carpet2', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(816, 2135, '', 'gothic_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(817, 2136, '', 'gothic_sofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(818, 2137, '', 'gothic_stool', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(819, 2138, 'Pink Grand Piano', 'grand_piano*3', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(820, 2139, 'Onyx Grand Piano', 'grand_piano*5', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(821, 2140, 'Black Grand Piano', 'grand_piano*2', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(822, 2141, 'Amber Grand Piano', 'grand_piano*4', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(823, 2142, 'Turquoise Grand Piano', 'grand_piano*1', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(824, 2143, 'Deluxe Theatre Chair', 'theatre_seat', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 6, '0'),
(825, 2144, 'Treats Tray', 'romantique_tray2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(826, 2145, 'Breakfast Tray', 'romantique_tray1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(827, 2146, 'Turquoise Tray Table', 'romantique_smalltabl*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(828, 2147, 'Onyx Tray Table', 'romantique_smalltabl*5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(829, 2148, 'Lime Tray Table', 'romantique_smalltabl*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(830, 2149, 'Amber Tray Table', 'romantique_smalltabl*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(831, 2150, 'Rose Quartz Tray Table', 'romantique_smalltabl*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(832, 2151, 'Dressing Table', 'romantique_mirrortabl', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(833, 2152, 'Turquoise Screen', 'romantique_divider*3', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(834, 2153, 'Green Screen', 'romantique_divider*2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(835, 2154, 'Amber Screen', 'romantique_divider*4', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(836, 2155, 'Rose Quartz Screen', 'romantique_divider*1', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(837, 2156, 'Large Tatami Mat', 'jp_tatami2', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(838, 2157, 'Small Tatami Mat', 'jp_tatami', 's', 2, 2, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(839, 2158, 'Director''s Chair', 'habbowood_chair', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(840, 2159, 'Bamboo Forest', 'jp_bamboo', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(841, 2160, 'Irori', 'jp_irori', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(842, 2161, 'Pillow Chair', 'jp_pillow', 's', 1, 1, 0.80, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(843, 2162, 'Habbo Sounds 1', 'sound_set_1', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(844, 2163, 'Habbo Sounds 3', 'sound_set_2', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(845, 2608, 'Jukebox', 'jukebox*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(846, 2609, 'Welcome', 'carpet_soft_tut', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(847, 2610, 'Graveyard Portal', 'sound_set_44', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(848, 2614, 'SFX 1', 'sound_set_43', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(849, 2624, 'Haunted Mansion', 'sound_set_42', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(850, 2612, 'Rock 8', 'sound_set_41', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(851, 2615, 'Rock 4', 'sound_set_40', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(852, 2622, 'Rock 7', 'sound_set_39', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(853, 2616, 'Rock 6', 'sound_set_38', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(854, 2617, 'Grunge Chair', 'grunge_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(855, 2618, 'Grunge Mattress', 'grunge_mattress', 's', 3, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(856, 2621, 'Radiator', 'grunge_radiator', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(857, 2619, 'Grunge Bookshelf', 'grunge_shelf', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(858, 2613, 'Road Sign', 'grunge_sign', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(859, 2623, 'Grunge Table', 'grunge_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(860, 2611, 'Creepy Crypt', 'habboween_crypt', 's', 1, 3, 1.10, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 2, '0'),
(861, 2626, 'Unholy Ground', 'habboween_grass', 's', 2, 2, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(862, 2625, 'Habboween Cauldron', 'hal_cauldron', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '30'),
(863, 2620, 'Haunted Grave', 'hal_grave', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(864, 2633, 'Christmas Party', 'sound_set_52', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(865, 2631, 'Club 6', 'sound_set_51', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(866, 2632, 'Club 5', 'sound_set_50', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(867, 2634, 'Club 4', 'sound_set_49', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(868, 2629, 'Club 3', 'sound_set_48', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(869, 2627, 'Club 2', 'sound_set_47', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(870, 2630, 'Club 1', 'sound_set_46', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(871, 2628, 'Lost_Beatness', 'sound_set_45', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(872, 2641, 'Lantern Bundle 2', 'xmas_icelamp', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(873, 2646, 'Ice Castle Wall', 'xmas_cstl_wall', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(874, 2651, 'Ice Castle Tower', 'xmas_cstl_twr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(875, 2636, 'Ice Castle Gate', 'xmas_cstl_gate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(876, 2653, 'Snowy Christmas Tree', 'tree7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(877, 2638, 'Flashy Christmas Tree', 'tree6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(878, 2649, 'Oh Blinging Tree', 'sound_set_54', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(879, 2652, 'Snowy Surprise', 'sound_set_53', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(880, 2642, 'postbank Safe', 'safe_silo_pb', 's', 1, 1, 1.30, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '17'),
(881, 2640, 'Snowy Maze Gate', 'plant_mazegate_snow', 's', 2, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(882, 2635, 'Snowy Maze Bundle 2', 'plant_maze_snow', 's', 2, 1, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(883, 2648, 'Winter Sleigh', 'christmas_sleigh', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(884, 2637, 'Reindeer', 'christmas_reindeer', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(885, 2654, 'Reindeer Droppings', 'christmas_poop', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(886, 2643, 'Executive Bar Desk', 'exe_bardesk', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(887, 2647, 'Executive Sofa Chair', 'exe_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(888, 2650, 'Executive Boss Chair', 'exe_chair2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(889, 2655, 'Executive Corner Desk', 'exe_corner', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(890, 2645, 'Executive Drinks Tray', 'exe_drinks', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(891, 2639, '3-Seater Sofa', 'exe_sofa', 's', 3, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(892, 2644, 'Take a memo', 'exe_table', 's', 3, 2, 1.10, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(893, 2670, 'RnB Grooves 5', 'sound_set_59', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(894, 2656, 'RnB Grooves 4', 'sound_set_58', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(895, 2673, 'RnB Grooves 3', 'sound_set_57', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(896, 2669, 'RnB Grooves 2', 'sound_set_56', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(897, 2671, 'RnB Grooves 1', 'sound_set_55', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(898, 2687, 'Lightweight', 'noob_table*1', 's', 2, 2, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(899, 2688, 'Lightweight', 'noob_table*2', 's', 2, 2, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(900, 2689, 'Lightweight', 'noob_table*3', 's', 2, 2, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(901, 2690, 'Lightweight', 'noob_table*4', 's', 2, 2, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(902, 2691, 'Lightweight', 'noob_table*5', 's', 2, 2, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(903, 2692, 'Lightweight', 'noob_table*6', 's', 2, 2, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(904, 2657, 'My first Habbo stool', 'noob_stool*1', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(905, 2658, 'My first Habbo stool', 'noob_stool*2', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(906, 2659, 'My first Habbo stool', 'noob_stool*3', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(907, 2660, 'My first Habbo stool', 'noob_stool*4', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(908, 2661, 'My first Habbo stool', 'noob_stool*5', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(909, 2662, 'My first Habbo stool', 'noob_stool*6', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(910, 2681, 'My first Habbo rug', 'noob_rug*1', 's', 2, 3, 0.00, 1, 1, 0, 0, 1, 1, 0, 1, 'default', 1, '0'),
(911, 2682, 'My first Habbo rug', 'noob_rug*2', 's', 2, 3, 0.00, 1, 1, 0, 0, 1, 1, 0, 1, 'default', 1, '0'),
(912, 2683, 'My first Habbo rug', 'noob_rug*3', 's', 2, 3, 0.00, 1, 1, 0, 0, 1, 1, 0, 1, 'default', 1, '0'),
(913, 2684, 'My first Habbo rug', 'noob_rug*4', 's', 2, 3, 0.00, 1, 1, 0, 0, 1, 1, 0, 1, 'default', 1, '0'),
(914, 2685, 'My first Habbo rug', 'noob_rug*5', 's', 2, 3, 0.00, 1, 1, 0, 0, 1, 1, 0, 1, 'default', 1, '0'),
(915, 2686, 'My first Habbo rug', 'noob_rug*6', 's', 2, 3, 0.00, 1, 1, 0, 0, 1, 1, 0, 1, 'default', 1, '0'),
(916, 2663, 'My first Habbo lamp', 'noob_lamp*1', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 2, '0'),
(917, 2664, 'My first Habbo lamp', 'noob_lamp*2', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 2, '0'),
(918, 2665, 'My first Habbo lamp', 'noob_lamp*3', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 2, '0'),
(919, 2666, 'My first Habbo lamp', 'noob_lamp*4', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 2, '0'),
(920, 2667, 'My first Habbo lamp', 'noob_lamp*5', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 2, '0'),
(921, 2668, 'My first Habbo lamp', 'noob_lamp*6', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 2, '0'),
(922, 2675, 'Lightweight', 'noob_chair*1', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(923, 2676, ' practical', 'noob_chair*2', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(924, 2677, ' practical', 'noob_chair*3', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(925, 2678, ' practical', 'noob_chair*4', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(926, 2679, ' practical', 'noob_chair*5', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(927, 2680, 'Power Globe', 'noob_chair*6', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 0, 1, 'default', 1, '0'),
(928, 2674, 'Executive Plant', 'exe_plant', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(929, 2699, 'Grey Share Bear', 'val_teddy*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(930, 2700, 'Pink Share Bear', 'val_teddy*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0');
INSERT INTO `items_base` (`item_id`, `sprite_id`, `public_name`, `item_name`, `type`, `width`, `length`, `height`, `allow_stack`, `allow_walk`, `allow_sit`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `cycle_count`, `vending_ids`) VALUES
(931, 2701, 'Green Share Bear', 'val_teddy*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(932, 2702, 'Brown Share Bear', 'val_teddy*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(933, 2703, 'Yellow Share Bear', 'val_teddy*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(934, 2704, 'Blue Share Bear', 'val_teddy*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(935, 2696, 'Love Randomiser', 'val_randomizer', 's', 4, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'loveshuffler', 1, '0'),
(936, 2697, 'Heart Shaped Chocs', 'val_choco', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(937, 2693, 'Teleport Door', 'teleport_door', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 0, 1, 1, 'teleport', 2, '0'),
(938, 2698, 'Latin Love 3', 'sound_set_61', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(939, 2695, 'Latin Love 2', 'sound_set_60', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(940, 2694, 'Crystal Ball', 'fortune', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dice', 1, '0'),
(941, 2713, 'Adventure Desk', 'sw_table', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(942, 2711, 'Raven', 'sw_raven', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(943, 2709, 'Ye Olde Chest', 'sw_chest', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(944, 2710, 'Sand Castle Wall', 'sand_cstl_wall', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(945, 2705, 'Sand Castle Tower', 'sand_cstl_twr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(946, 2712, 'Sand Castle Gate', 'sand_cstl_gate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(947, 2708, 'Candle Box', 'grunge_candle', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(948, 2707, 'Bench', 'grunge_bench', 's', 3, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(949, 2706, 'Flaming Barrel', 'grunge_barrel', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(950, 2733, 'Moon Lamp', 'rclr_lamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(951, 2426, 'Bubble trophy', 'a0 prizetrophy8_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(952, 2736, 'nouvelle_trax', 'nouvelle_trax', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(953, 2727, 'Bubble Juice Floor', 'md_rug', 's', 4, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(954, 2720, 'Sushi Kohada', 'jp_tray6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(955, 2717, 'Sushi Tamago', 'jp_tray5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(956, 2725, 'Sushi Uni', 'jp_tray4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(957, 2726, 'Sushi Ikura', 'jp_tray3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(958, 2724, 'Sushi Ika', 'jp_tray2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(959, 2715, 'Sushi Maguro', 'jp_tray1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(960, 2716, 'Tea Maker', 'arabian_teamk', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '1'),
(961, 2732, 'Ornamental Urn', 'arabian_snake', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(962, 2719, 'Berber Kilim Rug', 'arabian_rug', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(963, 2722, 'Green Blossom Pillow', 'arabian_pllw', 's', 1, 1, 0.80, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(964, 2730, 'Soft wooden screen', 'arabian_divdr', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(965, 2721, 'Exotic', 'arabian_chair', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(966, 2731, 'Amanjena Table', 'arabian_bigtb', 's', 3, 2, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(967, 2714, 'Hexagonal Tea Table', 'arabian_tetbl', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(968, 2734, 'Mint Tea Tray', 'arabian_tray1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(969, 2735, 'Candle Tray', 'arabian_tray2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(970, 2723, 'Sweets Tray', 'arabian_tray3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(971, 2728, 'Sweet', 'arabian_tray4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(972, 2738, 'Alhambra Trax 3', 'sound_set_64', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(973, 2740, 'Alhambra Trax 2', 'sound_set_63', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(974, 2741, 'Alhambra Trax 1', 'sound_set_62', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(975, 2739, 'Jukebox Pacha TV', 'jukebox_ptv*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(976, 2737, 'Calippo icecream machine', 'calippo', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(977, 2744, 'traxsilver', 'traxsilver', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(978, 2742, 'traxgold', 'traxgold', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(979, 2743, 'traxbronze', 'traxbronze', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(980, 2745, 'bench_puffet', 'bench_puffet', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(981, 2764, 'Gold Bar (China)', 'CFC_500_goldbar', 's', 1, 1, 0.40, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(982, 2770, 'Sack of Credits (China)', 'CFC_200_moneybag', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(983, 3275, 'Mesh Corner', 'urban_fence_corner', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(984, 2796, 'Gold Coin (China)', 'CFC_100_coin_gold', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(985, 2772, 'Silver Coin (China)', 'CFC_50_coin_silver', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(986, 2749, 'Chabu Dai', 'jp_table', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(987, 2750, 'Shishi Odishi', 'jp_rare', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(988, 2748, 'Katana Green', 'jp_katana3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(989, 2747, 'Katana Blue', 'jp_katana2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(990, 2751, 'HC Katana Red', 'jp_katana1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(991, 2757, 'Tiki Waterfall', 'tiki_waterfall', 's', 3, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(992, 2765, 'Tiki Pig Tray', 'tiki_tray4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(993, 2753, 'Tiki Fish Tray', 'tiki_tray3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(994, 2768, 'Tiki Pineapple Plate', 'tiki_tray2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(995, 2755, 'Tiki Fruit Tray', 'tiki_tray1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(996, 2792, 'Empty Tray', 'tiki_tray0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(997, 2756, 'Toucan', 'tiki_toucan', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(998, 2773, 'Beach Torch', 'tiki_torch', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(999, 2782, 'Tribal Statue', 'tiki_statue', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1000, 2798, 'Island Sand Patch', 'tiki_sand', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1001, 2769, 'Tiki Parasol', 'tiki_parasol', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1002, 2781, 'Jungle Patch', 'tiki_junglerug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1003, 2794, 'Tiki Bar Corner', 'tiki_corner', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1004, 2785, 'Butterflies', 'tiki_bflies', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1005, 2784, 'Tiki Bar Stool', 'tiki_bench', 's', 1, 1, 1.30, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1006, 2795, 'Tiki Bar Desk', 'tiki_bardesk', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1007, 2754, 'tampax_rug', 'tampax_rug', 's', 3, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1008, 2767, 'Sound set 70', 'sound_set_70', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1009, 2799, 'Sound set 69', 'sound_set_69', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1010, 2793, 'Sound set 68', 'sound_set_68', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1011, 2771, 'Sound set 67', 'sound_set_67', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1012, 2752, 'Sound set 66', 'sound_set_66', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1013, 2766, 'Sound set 65', 'sound_set_65', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1014, 118, 'Square Dining Table', 'table_plasto_square*9', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1015, 227, 'Giant Heart', 'heart', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1016, 3265, 'Street Lamp', 'urban_lamp', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1017, 2783, 'Lucky Bamboo', 'noob_plant', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 0, 1, 'default', 1, '0'),
(1018, 4244, 'Street Wall', 'urban_wall', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1019, 1510, 'Champion trophy', 'a0 prizetrophy6_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(1020, 2774, 'Japanese Teamaker', 'jp_teamaker', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '28'),
(1021, 2838, 'September 2008', 'svnr_uk', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1022, 2825, 'August 2008', 'svnr_nl', 's', 1, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1023, 2813, 'July 2008', 'svnr_it', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1024, 2801, 'October 2008', 'svnr_de', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1025, 2836, 'November 2008', 'svnr_aus', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1026, 2840, 'Accompaniments', 'diner_tray_7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1027, 2826, 'Vanilla', 'diner_tray_6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1028, 2815, 'Bacon and Eggs', 'diner_tray_5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1029, 2800, 'Pancakes', 'diner_tray_4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1030, 2841, 'Spaghetti Meatballs', 'diner_tray_3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1031, 2802, 'Steak and Mash', 'diner_tray_2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1032, 2839, 'Burger and Chips', 'diner_tray_1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1033, 2837, 'Had your fill', 'diner_tray_0', 's', 1, 1, 0.10, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1034, 2804, 'Aqua Diner Sofa 2', 'diner_sofa_2*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1035, 2805, 'Pink Diner Sofa 2', 'diner_sofa_2*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1036, 2806, 'Black Diner Sofa 2', 'diner_sofa_2*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1037, 2807, 'White Diner Sofa 2', 'diner_sofa_2*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1038, 2808, 'Latte Diner Sofa 2', 'diner_sofa_2*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1039, 2809, 'Blue Diner Sofa 2', 'diner_sofa_2*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1040, 2810, 'Green Diner Sofa 2', 'diner_sofa_2*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1041, 2811, 'Yellow Diner Sofa 2', 'diner_sofa_2*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1042, 2812, 'Red Diner Sofa 2', 'diner_sofa_2*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1043, 2814, 'Diner Shaker', 'diner_shaker', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1044, 2803, 'Diner Floor', 'diner_rug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1045, 2827, 'Aqua Gumball Machine', 'diner_gumvendor*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1046, 2828, 'Pink Gumball Machine', 'diner_gumvendor*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1047, 2829, 'Black Gumball Machine', 'diner_gumvendor*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1048, 2830, 'White Gumball Machine', 'diner_gumvendor*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1049, 2831, 'Latte Gumball Machine', 'diner_gumvendor*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1050, 2832, 'Blue Gumball Machine', 'diner_gumvendor*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1051, 2833, 'Green Gumball Machine', 'diner_gumvendor*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1052, 2834, 'Yellow Gumball Machine', 'diner_gumvendor*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1053, 2835, 'Red Gumball Machine', 'diner_gumvendor*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1054, 2816, 'Aqua Diner Till', 'diner_cashreg*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1055, 2817, 'Pink Diner Till', 'diner_cashreg*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1056, 2818, 'Black Diner Till', 'diner_cashreg*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1057, 2819, 'White Diner Till', 'diner_cashreg*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1058, 2820, 'Latte Diner Till', 'diner_cashreg*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1059, 2821, 'Blue Diner Till', 'diner_cashreg*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1060, 2822, 'Green Diner Till', 'diner_cashreg*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1061, 2823, 'Yellow Diner Till', 'diner_cashreg*8', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1062, 2824, 'Red Diner Till', 'diner_cashreg*9', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1063, 2879, 'Aqua Diner Table', 'diner_table_2*1', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1064, 2880, 'Pink Diner Table', 'diner_table_2*2', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1065, 2881, 'Black Diner Table', 'diner_table_2*3', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1066, 2882, 'White Diner Table', 'diner_table_2*4', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1067, 2883, 'Latte Diner Table', 'diner_table_2*5', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1068, 2884, 'Blue Diner Table', 'diner_table_2*6', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1069, 2885, 'Green Diner Table', 'diner_table_2*7', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1070, 2886, 'Yellow Diner Table', 'diner_table_2*8', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1071, 2887, 'Red Diner Table', 'diner_table_2*9', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1072, 2897, 'Aqua Diner Booth Table', 'diner_table_1*1', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1073, 2898, 'Pink Diner Booth Table', 'diner_table_1*2', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1074, 2899, 'Black Diner Booth Table', 'diner_table_1*3', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1075, 2900, 'White Diner Booth Table', 'diner_table_1*4', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1076, 2901, 'Latte Diner Booth Table', 'diner_table_1*5', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1077, 2902, 'Blue Diner Booth Table', 'diner_table_1*6', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1078, 2903, 'Green Diner Booth Table', 'diner_table_1*7', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1079, 2904, 'Yellow Diner Booth Table', 'diner_table_1*8', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1080, 2905, 'Red Diner Booth Table', 'diner_table_1*9', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1081, 2888, 'Aqua Diner Sofa 1', 'diner_sofa_1*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1082, 2889, 'Pink Diner Sofa 1', 'diner_sofa_1*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1083, 2890, 'Black Diner Sofa 1', 'diner_sofa_1*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1084, 2891, 'White Diner Sofa 1', 'diner_sofa_1*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1085, 2892, 'Latte Diner Sofa 1', 'diner_sofa_1*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1086, 2893, 'Blue Diner Sofa 1', 'diner_sofa_1*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1087, 2894, 'Green Diner Sofa 1', 'diner_sofa_1*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1088, 2895, 'Yellow Diner Sofa 1', 'diner_sofa_1*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1089, 2896, 'Red Diner Sofa 1', 'diner_sofa_1*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1090, 2861, 'Aqua Diner Stool', 'diner_chair*1', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1091, 2862, 'Pink Diner Stool', 'diner_chair*2', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1092, 2863, 'Black Diner Stool', 'diner_chair*3', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1093, 2864, 'White Diner Stool', 'diner_chair*4', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1094, 2865, 'Latte Diner Stool', 'diner_chair*5', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1095, 2866, 'Blue Diner Stool', 'diner_chair*6', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1096, 2867, 'Green Diner Stool', 'diner_chair*7', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1097, 2868, 'Yellow Diner Stool', 'diner_chair*8', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1098, 2869, 'Red Diner Stool', 'diner_chair*9', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1099, 2842, 'Aqua Diner Gate', 'diner_bardesk_gate*1', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1100, 2843, 'Pink Diner Gate', 'diner_bardesk_gate*2', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1101, 2844, 'Black Diner Gate', 'diner_bardesk_gate*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1102, 2845, 'White Diner Gate', 'diner_bardesk_gate*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1103, 2846, 'Latte Diner Gate', 'diner_bardesk_gate*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1104, 2847, 'Blue Diner Gate', 'diner_bardesk_gate*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1105, 2848, 'Green Diner Gate', 'diner_bardesk_gate*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1106, 2849, 'Yellow Diner Gate', 'diner_bardesk_gate*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1107, 2850, 'Red Diner Gate', 'diner_bardesk_gate*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1108, 2870, 'Aqua Diner Corner', 'diner_bardesk_corner*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1109, 2871, 'Pink Diner Corner', 'diner_bardesk_corner*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1110, 2872, 'Black Diner Corner', 'diner_bardesk_corner*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1111, 2873, 'Latte Diner Corner', 'diner_bardesk_corner*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1112, 2875, 'Blue Diner Corner', 'diner_bardesk_corner*6', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1113, 2876, 'Green Diner Corner', 'diner_bardesk_corner*7', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1114, 2877, 'Yellow Diner Corner', 'diner_bardesk_corner*8', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1115, 2878, 'Red Diner Corner', 'diner_bardesk_corner*9', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1116, 2851, 'Aqua Diner Bar', 'diner_bardesk*1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1117, 2852, 'Pink Diner Bar', 'diner_bardesk*2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1118, 2853, 'Black Diner Bar', 'diner_bardesk*3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1119, 2854, 'White Diner Bar', 'diner_bardesk*4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1120, 2855, 'Latte Diner Bar', 'diner_bardesk*5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1121, 2856, 'Blue Diner Bar', 'diner_bardesk*6', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1122, 2857, 'Green Diner Bar', 'diner_bardesk*7', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1123, 2858, 'Yellow Diner Bar', 'diner_bardesk*8', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1124, 2859, 'Red Diner Bar', 'diner_bardesk*9', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1125, 2860, 'ads_dave_cns', 'ads_dave_cns', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1126, 2911, 'easy_carpet name', 'easy_carpet', 's', 4, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1127, 2907, 'easy_bowl2', 'easy_bowl2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1128, 2910, 'Greek Corner', 'greek_corner', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1129, 2908, 'Enter mortal', 'greek_gate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1130, 2909, 'Greek Pillars', 'greek_pillars', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1131, 2906, 'Greek Seat', 'greek_seat', 's', 1, 1, 0.50, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1132, 2622, 'Greek trophy', 'a0 greektrophy_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(1133, 2623, 'Greek trophy', 'a0 greektrophy_s', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(1134, 2624, 'Greek trophy', 'a0 greektrophy_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(1135, 2915, 'greek_block', 'greek_block', 's', 2, 1, 0.80, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1136, 2923, 'Glass Table', 'hcc_table', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1137, 2917, 'Bookshelf', 'hcc_shelf', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1138, 2921, 'Low Back Sofa', 'hcc_sofa', 's', 2, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1139, 2924, 'Cool look', 'hcc_minibar', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '24'),
(1140, 2919, 'Trendy Stool', 'hcc_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1141, 2918, 'Crime scene', 'det_divider', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1142, 2916, 'netari_carpet', 'netari_carpet', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1143, 2922, 'Chalk Outline', 'det_body', 's', 2, 3, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1144, 2920, 'Antique Stool', 'hcc_stool', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1145, 2925, 'Reclining Chair', 'hcc_sofachair', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1146, 2926, 'Glass Corner', 'hcc_crnr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1147, 2927, 'Glass Divider', 'hcc_dvdr', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1148, 2928, 'sob_carpet', 'sob_carpet', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1149, 2929, 'My Hump', 'igor_seat', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1150, 2936, 'The Brain', 'ads_igorbrain', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1151, 2934, 'Igor Switch', 'ads_igorswitch', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1152, 2930, 'ads_711', 'ads_711*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1153, 2931, 'ads_711', 'ads_711*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1154, 2932, 'ads_711', 'ads_711*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1155, 2933, 'ads_711', 'ads_711*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1156, 2935, 'Igor Ray Gun', 'ads_igorraygun', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1157, 2944, 'Blood Sink', 'hween08_sink', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '29'),
(1158, 2942, 'Hospital Curtain (blood)', 'hween08_curtain', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1159, 2948, 'Blood Bath', 'hween08_bath', 's', 1, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1160, 2938, 'Life Support (blood)', 'hween08_defibs', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1161, 2943, 'Body Bag', 'hween08_bbag', 's', 1, 3, 1.30, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(1162, 2949, 'Hospital Curtain (ooze)', 'hween08_curtain2', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1163, 2939, 'Life Support (ooze)', 'hween08_defibs2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1164, 2945, 'Hospital Bed (blood)', 'hween08_bed', 's', 1, 3, 2.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(1165, 2940, 'Ooze Sink', 'hween08_sink2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '30'),
(1166, 2937, 'Hospital Bed (ooze)', 'hween08_bed2', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(1167, 2947, 'Ooze Bath', 'hween08_bath2', 's', 1, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1168, 2946, 'Manhole', 'hween08_manhole', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1169, 2941, ' poke', 'hween08_trll', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1170, 2956, 'Glass High Bar Table', 'party_table', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1171, 2963, 'Spotlight', 'party_discol', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1172, 2950, 'Stage Block Large', 'party_block2', 's', 2, 2, 0.70, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1173, 2957, 'Bar Corner', 'party_barcorn', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1174, 2960, 'High Class Bar Stool', 'party_chair', 's', 1, 1, 1.30, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1175, 2959, 'Small Stage', 'party_block', 's', 1, 1, 0.90, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1176, 2965, 'Dance Floor Laser', 'party_ravel', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1177, 2966, 'Despite being made a lava', 'party_tube_lava', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1178, 2955, 'Club Tray', 'party_tray', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '31'),
(1179, 2954, 'Scratch it', 'party_djtable', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1180, 2958, 'Disco Floor', 'party_floor', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1181, 2964, 'Glitter Ball', 'party_ball', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1182, 2951, 'Bubbles Machine', 'party_tube_bubble', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1183, 2953, ' MC', 'party_mic', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1184, 2961, 'Dance Floor Beamer', 'party_beamer', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 7, '0'),
(1185, 2962, 'Bar Centre', 'party_bardesk', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1186, 2952, 'Club seat', 'party_seat', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1187, 3005, 'Snow Seat', 'xmas08_snowpl', 's', 1, 1, 1.00, 0, 1, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1188, 2977, 'Emperor Penguin', 'penguin_basic', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1189, 2972, 'Arctic Penguin Trophy', 'xmas08_trph1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1190, 2995, 'Musketeer Penguin', 'penguin_musketeer', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1191, 3009, 'Icy table', 'xmas08_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1192, 2986, 'Hot Tub', 'xmas08_hottub', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1193, 2990, 'Luchador Penguin', 'penguin_wrestler', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1194, 3011, 'Blow it up', 'fx_explosion', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'rentals', 2, '0'),
(1195, 2969, 'Robot Penguin', 'penguin_robot', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1196, 2967, 'Icy Christmas Tree', 'xmas08_icetree', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1197, 2974, 'Camp fire', 'campfire', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1198, 3002, 'Ice', 'xmas08_icerug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1199, 3008, 'Executive Penguin', 'penguin_suit', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1200, 2991, 'December 2008', 'svnr_fi', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1201, 2982, 'Snow Storm', 'xmas_snow', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1202, 2988, 'Hockey Penguin', 'penguin_icehockey', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1203, 3007, 'Pilot Penguin', 'penguin_pilot', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1204, 2996, 'Ballerina Penguin', 'penguin_ballet', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1205, 3000, 'Arctic SFX', 'sound_set_71', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1206, 2979, 'Boxer Penguin', 'penguin_boxer', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1207, 2993, 'Fluorescent Penguin', 'penguin_glow', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1208, 2984, 'Summer Penguin', 'penguin_swim', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1209, 2994, 'Sumo Penguin', 'penguin_sumo', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1210, 2985, 'Bubbles', 'xmas08_geysir', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1211, 2989, 'Clown Penguin', 'penguin_clown', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1212, 2983, 'Infected Penguin', 'penguin_infected', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1213, 3013, 'Firestarter', 'fx_flare', 's', 1, 1, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'rentals', 2, '0'),
(1214, 2968, 'Snowball Lantern Pile', 'xmas08_lantern', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1215, 3001, 'Ice chair', 'xmas08_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1216, 2998, 'Superhero Penguin', 'penguin_super', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1217, 2978, 'Icy Teleport', 'xmas08_telep', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1218, 3006, 'Cube Tree', 'xmas08_cubetree', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1219, 3010, 'Disco Penguin', 'penguin_rock', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1220, 2992, 'Ice divider', 'xmas08_dvdr1', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1221, 2980, 'Ice Fish Hole', 'xmas08_hole', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '34'),
(1222, 2981, 'XC Penguin', 'penguin_ski', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1223, 2973, 'Skater Penguin', 'penguin_skater', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1224, 2970, 'Icy Divider Corner', 'xmas08_dvdr2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1225, 2971, 'Christmas Penguin', 'penguin_elf', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1226, 2975, 'Bunny Penguin', 'penguin_bunny', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1227, 2976, 'Ninja Penguin', 'penguin_ninja', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1228, 2997, 'Magic Penguin', 'penguin_magician', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1229, 3003, 'Beautiful Penguin', 'penguin_hunchback', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1230, 2987, 'Cowboy Penguin', 'penguin_cowboy', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1231, 3004, 'Punk Penguin', 'penguin_punk', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1232, 2999, 'Pirate Penguin', 'penguin_pirate', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1233, 3018, 'ads_ob_pillow name', 'ads_ob_pillow', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1234, 3016, 'Leviathon', 'lostc_merdragon', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1235, 3017, 'Idea Agency Desk', 'ads_cldesk', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1236, 3015, 'Eco Friendly Penguin', 'xmas08_trph2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1237, 3014, 'Whatever your Idea', 'ads_cltele', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1238, 3019, 'Childline Rug', 'ads_clfloor', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1239, 3020, 'Mall tele-door', 'ads_mall_tele', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1240, 3024, 'Moongate', 'china_moongt', 's', 1, 3, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1241, 3022, 'Lotus Pool', 'bolly_lotus_pool', 's', 2, 2, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1242, 3025, 'Ox Statue', 'china_ox', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1243, 3026, 'Petal Flurry', 'bolly_petals', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1244, 3042, 'Palm Tree', 'bolly_tree', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1245, 3037, 'Swing low', 'bolly_swing', 's', 2, 1, 1.50, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1246, 3030, 'Star Pillow', 'bolly_pillow', 's', 1, 1, 0.80, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1247, 3031, 'Bollywood Corner', 'bolly_corner', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1248, 3033, 'Elephant MiniBar', 'bolly_phant', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '35'),
(1249, 3036, 'Monkey Lamp', 'bolly_monkey_lamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1250, 3040, 'Green Curtain', 'bolly_drapeb', 's', 3, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1251, 3044, 'Planet of Love', 'planet_of_love', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1252, 3041, 'Chandelier', 'bolly_lamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1253, 3034, 'Bollywood Desk', 'bolly_desk', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1254, 3043, 'Vase of Flowers', 'bolly_vase', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1255, 3027, 'Standard Tile', 'bolly_tile2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1256, 3035, 'Large Ornamental Table', 'bolly_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1257, 3032, 'Yellow Curtain', 'bolly_drapec', 's', 3, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1258, 3029, 'Extravagant Fountain', 'bolly_fountain', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1259, 3305, 'Executive Teleport', 'exe_elevator', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1260, 3028, 'Ornamental Tile', 'bolly_tile1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1261, 3038, 'Pink Curtain', 'bolly_drapea', 's', 3, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1262, 3045, 'ads_idol_floor1 name', 'ads_idol_floor1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1263, 3049, 'Inventor''s Desk', 'ads_igor_dsk', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1264, 3050, 'ads_idol_desk', 'ads_idol_desk', 's', 1, 4, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1265, 3051, 'ads_idol_ch', 'ads_idol_ch', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1266, 3046, 'Glass Flask', 'ads_igor_flask', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1267, 3048, 'ads_idol_drape name', 'ads_idol_drape', 's', 3, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1268, 3047, 'ads_idol_floor2 name', 'ads_idol_floor2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1269, 3052, 'Kraken', 'lostc_octopus', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1270, 3076, 'Marble Floor Tile', 'lc_tile1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1271, 3073, 'Small Jellyfish Lamp', 'lc_medusa2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1272, 3068, 'Sally Lightfoot', 'lc_crab2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1273, 3071, 'March Collectable 2009', 'lostc_teleport', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1274, 3058, 'ads_idol_piano name', 'ads_idol_piano', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1275, 3078, 'Large Coral Divider', 'lc_coral_divider_hi', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1276, 3066, 'ads_711shelf name', 'ads_711shelf', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1277, 3072, 'Water Tube Corner', 'lc_tubes_corners', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1278, 3067, 'Captain''s Table', 'lc_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1279, 3069, 'Cobbled Stones', 'lc_tile2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1280, 3074, 'Anemone', 'lc_anemone', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1281, 3077, 'Small Coral Divider', 'lc_coral_divider_low', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1282, 3060, 'Ocean Window Rug', 'lc_glass_floor', 's', 2, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1283, 3064, 'Large Jellyfish Lamp', 'lc_medusa1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1284, 3062, 'Crab Patch', 'lc_crab1', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1285, 3059, 'ads_idol_jukebox name', 'ads_idol_jukebox*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1286, 3056, 'ads_idol_pchair name', 'ads_idol_pchair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1287, 3065, 'Water Tube Straight', 'lc_tubes_straight', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1288, 3057, 'ads_idol_audChr name', 'ads_idol_audChr', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1289, 3055, 'ads_idol_trax name', 'ads_idol_trax', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1290, 3053, 'ads_idol_tele', 'ads_idol_tele', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1291, 3075, 'Wooden Corner', 'lc_corner', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1292, 3063, 'Wooden Stool', 'lc_stool', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1293, 3061, 'No rusty nails', 'lc_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1294, 3070, 'Wooden Bar Desk', 'lc_desk', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1295, 3054, 'ads_idol_mic name', 'ads_idol_mic', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1296, 3080, 'ads_idol_hotspot name', 'ads_idol_hotspot', 's', 1, 1, 0.20, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 103, '0'),
(1297, 3079, 'ads_idol_clRack name', 'ads_idol_clRack', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1298, 3081, 'ads_idol_voting_ch name', 'ads_idol_voting_ch', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1299, 3095, 'Ecotron prize', 'ecotron_box', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1300, 3082, 'Eco Light 2', 'eco_light2', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1301, 3094, 'Eco Stool 3', 'eco_chair3', 's', 1, 1, 1.00, 0, 0, 1, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1302, 3086, 'Eco Coffee Table 3', 'eco_table3', 's', 2, 2, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1303, 3092, 'Eco Lamp 2', 'eco_lamp2', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1304, 3088, 'Eco Armchair 3', 'eco_sofa3', 's', 1, 1, 1.00, 0, 0, 1, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1305, 3089, 'Eco Coffee Table 2', 'eco_table2', 's', 2, 2, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1306, 3102, 'Fruit Bowl 2', 'eco_fruits2', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1307, 3096, 'Eco Armchair 1', 'eco_sofa1', 's', 1, 1, 1.00, 0, 0, 1, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1308, 3104, 'Fruit Bowl 3', 'eco_fruits3', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1309, 3098, 'Eco Light 1', 'eco_light1', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1310, 3093, 'Actually', 'eco_tree1', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1311, 3105, 'Potted Cactus 2', 'eco_cactus2', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1312, 3111, 'Talk To FRANK Brain Lamp', 'ads_frankb', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1313, 3090, 'Road Signs', 'bump_signs', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 0, 1, 'default', 7, '0'),
(1314, 3083, 'Potted Cactus 1', 'eco_cactus1', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1315, 3106, 'Eco Stool 2', 'eco_chair2', 's', 1, 1, 1.00, 0, 0, 1, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1316, 3085, 'Potted Cactus 3', 'eco_cactus3', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1317, 3101, 'Bumper Tyres', 'bump_tires', 's', 1, 1, 0.80, 1, 0, 0, 1, 1, 1, 0, 1, 'default', 3, '0'),
(1318, 3103, 'Traffic Lights', 'bump_lights', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 0, 1, 'default', 3, '0'),
(1319, 3091, 'Eco Lamp 3', 'eco_lamp3', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1320, 3099, 'Eco Coffee Table 1', 'eco_table1', 's', 2, 2, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1321, 3084, 'Eco Stool 1', 'eco_chair1', 's', 1, 1, 1.00, 0, 0, 1, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1322, 3100, 'Eco Armchair 2', 'eco_sofa2', 's', 1, 1, 1.00, 0, 0, 1, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1323, 3110, 'Road', 'bump_road', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 0, 1, 'default', 4, '0'),
(1324, 3107, 'Fruit Bowl 1', 'eco_fruits1', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1325, 3097, 'Eco Lamp 1', 'eco_lamp1', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1326, 3108, 'Eco Light 3', 'eco_light3', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1327, 3109, 'Pear Tree', 'eco_tree2', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1328, 3113, 'Totem Leg', 'totem_leg', 's', 1, 1, 1.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 9, '0'),
(1329, 3112, 'ads_grefusa_cactus name', 'ads_grefusa_cactus', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1330, 3126, 'ads_idol_tube name', 'ads_idol_tube', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1331, 3122, 'Executive Light', 'exe_light', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1332, 3120, 'ads_idol_cork name', 'ads_idol_cork', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1333, 3127, 'Idea Agency Jukebox', 'ads_cl_jukeb', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1334, 3129, 'Grass patch', 'env_grass', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1335, 3125, 'Forest Trunk Seat', 'env_tree3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1336, 3115, 'Eco Hedgerow', 'env_bushes', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1337, 3128, 'Eco Hedgerows Gate', 'env_bushes_gate', 's', 1, 2, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1338, 3119, 'Executive Gate', 'exe_gate', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1339, 3116, 'ads_idol_newsDsk name', 'ads_idol_newsDsk', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1340, 3117, 'Forest Tree Chair', 'env_tree1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1341, 3123, 'Forest Tree Americana', 'env_tree2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1342, 3121, 'Cubist Light', 'exe_cubelight', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1343, 3118, 'The Four Seasons Tree', 'env_tree4', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1344, 3114, 'Sphere Lamp', 'exe_artlamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1345, 3124, 'ads_idol_ichair name', 'ads_idol_ichair', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1346, 3133, 'Wedding Cake', 'tray_cake', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1347, 3132, 'ads_reebok_block2', 'ads_reebok_block2', 's', 2, 2, 0.80, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1348, 3135, 'ads_malaco_rug_name', 'ads_malaco_rug', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1349, 3134, 'Champagne Bucket', 'tray_champagne', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1350, 3130, 'Champagne Tower', 'tray_glasstower', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '40'),
(1351, 3131, 'ads_malaco_gu', 'ads_malaco_gu', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1352, 3139, 'Idea Agency Super Cake', 'ads_clcake', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1353, 3137, 'Idea Agency Sofa', 'ads_cl_sofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1354, 3136, 'Function Table', 'ads_idol_tblCloth', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1355, 3140, 'ads_idol_carpet name', 'ads_idol_carpet', 's', 2, 7, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1356, 3138, 'Function Lamp', 'ads_idol_lamp', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1357, 3153, 'Rain Shower', 'country_rain', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1358, 3160, 'Scarecrow', 'country_scarecrow', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1359, 3161, 'Porta-House', 'env_telep', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1360, 3145, 'Crop Field', 'country_soil', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1361, 3162, 'Field Grass', 'country_grass', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1362, 3151, 'The Golden Tablet', 'ads_goldtabl', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1363, 3142, 'Witch Mushroom', 'eco_mush1', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1364, 3147, 'Tractor', 'country_trctr', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1365, 3141, 'Stone Wall', 'country_fnc2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1366, 3154, 'Stick Fence', 'country_fnc1', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1367, 3149, 'Wishing Well', 'country_well', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1368, 3155, 'Fairy Mushroom', 'eco_mush2', 's', 1, 1, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 1, '0'),
(1369, 3143, 'Rainbow', 'country_rbw', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1370, 3163, 'Golden Wheat', 'country_wheat', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1371, 3150, 'Farm Gate', 'country_gate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1372, 3144, 'Country Trax', 'sound_set_72', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1373, 3148, 'Wooden Stage', 'country_stage', 's', 2, 2, 1.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1374, 3156, 'ads_calip_cola_1 name', 'ads_calip_cola*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1375, 3157, 'ads_calip_cola_2 name', 'ads_calip_cola*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1376, 3158, 'ads_calip_cola_3 name', 'ads_calip_cola*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1377, 3159, 'ads_calip_cola_4 name', 'ads_calip_cola*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1378, 3146, 'Log Bench', 'country_log', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1379, 3152, 'Stone Pile', 'country_fnc3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1380, 3166, 'Wooden Patio Tile', 'country_patio', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1381, 3164, 'Country Ditch Corner', 'country_corner', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1382, 3165, 'Country Ditch', 'country_ditch', 's', 1, 2, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1383, 3168, 'ads_calip_chair name', 'ads_calip_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1384, 3169, 'ads_idol_trophy name', 'ads_idol_trophy', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(1385, 3167, 'Totem Spirit Head', 'totem_head', 's', 1, 1, 1.70, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1386, 3182, 'ads_calip_pool name', 'ads_calip_pool', 's', 2, 2, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1387, 3173, 'laptopdesk name', 'laptopdesk', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1388, 3189, 'Skull', 'LT_skull', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1389, 3175, 'Large Tribal Block', 'lt_stage2', 's', 2, 2, 0.90, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1390, 3180, 'Lava Corner', 'lt_lavac', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1391, 3172, 'Tribal Gate', 'lt_gate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1392, 3181, 'Planet of Eternity', 'saturn', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1393, 3190, 'ads_calip_tele name', 'ads_calip_tele', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1394, 3185, 'Stone Statue', 'lt_statue', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0');
INSERT INTO `items_base` (`item_id`, `sprite_id`, `public_name`, `item_name`, `type`, `width`, `length`, `height`, `allow_stack`, `allow_walk`, `allow_sit`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `cycle_count`, `vending_ids`) VALUES
(1395, 3178, 'Tarantula', 'lt_spider', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1396, 3177, 'Tribal Stone Wall', 'lt_stone2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1397, 3171, 'Tribal Seat', 'LT_throne', 's', 1, 1, 1.50, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1398, 3179, 'audChr name', 'audChr', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1399, 3188, 'Moss Patch', 'lt_patch', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1400, 3176, 'Lava Ditch', 'lt_lava', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1401, 3170, 'Small Tribal Torch', 'LT_pillar2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1402, 3174, 'Ant Hill', 'lt_bughill', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1403, 3186, 'noticeboard name', 'noticeboard', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1404, 3184, 'clrack name', 'clrack', 's', 3, 1, 0.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1405, 3187, 'Large Tribal Torch', 'LT_pillar', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1406, 3183, 'ads_calip_parasol name', 'lt_stage1', 's', 1, 1, 0.90, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1407, 3199, 'transparent_floor name', 'transparent_floor', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1408, 3197, 'ads_calip_lava name', 'ads_calip_lava', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1409, 3196, 'Tribal Stone Corner', 'lt_stone1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1410, 3198, 'ads_calip_fan', 'ads_calip_fan', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1411, 3201, 'voting_ch name', 'voting_ch', 's', 1, 1, 1.30, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1412, 3202, 'Quick Coffee Stop', 'ads_mall_coffeem', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '41'),
(1413, 3200, 'Totem Planet', 'totem_planet', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1414, 3212, 'Don''t worry', 'SF_reactor', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1415, 3204, 'Pack all you want', 'SF_crate_2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1416, 3207, 'Space Crew Chair', 'SF_chair_blue', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1417, 3219, 'Cryogenic Bed', 'sf_pod', 's', 1, 3, 1.36, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 2, '0'),
(1418, 3217, 'Command Console', 'SF_panel1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1419, 3220, 'Starship Table', 'SF_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1420, 3215, 'Welcome aboard', 'SF_chair_green', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1421, 3205, 'Small Crate', 'SF_crate_1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1422, 3210, 'Alien Lifeform', 'SF_alien', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1423, 3218, 'Engineering Console', 'SF_panel2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1424, 3221, 'Display Gate', 'sf_gate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1425, 3208, 'Navigation Panel', 'SF_panel3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1426, 3211, 'Starship Floor 2', 'SF_floor_2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1427, 3224, 'Sci Fi Lamp', 'SF_lamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1428, 3223, 'Captain''s Chair', 'SF_chair_red', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1429, 3213, 'Transparent Floor', 'sf_floor', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1430, 3203, 'Starship Roof', 'sf_roof', 's', 2, 4, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1431, 3206, 'Light Pole', 'sf_stick', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1432, 3222, 'Starship Floor 1', 'SF_floor_1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1433, 3216, ' sweets', 'ads_mall_kiosk', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1434, 3214, 'Futuristic Teleport', 'sf_tele', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1435, 3209, 'Sci Fi Roller', 'sf_roller', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'roller', 1, '0'),
(1436, 3229, 'Hot Trophy', 'prizetrophy_hot', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(1437, 3228, 'Pink Inflatable Raft', 'summer_raft1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1438, 3225, 'Cool Trophy', 'prizetrophy_cool', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 0, 'trophy', 1, '0'),
(1439, 3227, 'Blue Inflatable Raft', 'summer_raft2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1440, 3226, 'ads_elisa_gnome name', 'ads_elisa_gnome', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1441, 3231, 'Summer Cool Box', 'summer_icebox', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1442, 3230, 'ads_oc_soda', 'ads_oc_soda', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1443, 3232, 'Mars Patch', 'marsrug', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1444, 3238, 'White Candle', 'rela_candle1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1445, 2104, 'Dead Tree', 'tree2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1446, 3245, 'Red Candles', 'rela_candles2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1447, 3233, 'Stones', 'rela_stone', 's', 1, 1, 0.50, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1448, 3247, 'Wicker Chair', 'rela_hchair', 's', 1, 1, 1.30, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1449, 3244, 'Red Candle', 'rela_candle2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1450, 3241, 'ads_711', 'ads_711*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1451, 3242, 'ads_711', 'ads_711*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1452, 3243, 'ads_711', 'ads_711*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '19'),
(1453, 3235, 'Purple Candle', 'rela_candle3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1454, 3237, 'Asteroid', 'pix_asteroid', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1455, 3246, 'Bushy Houseplant', 'rela_plant', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1456, 3234, 'White Candles', 'rela_candles1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1457, 3236, 'Purple Candles', 'rela_candles3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1458, 3239, 'Orchid', 'rela_orchid', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1459, 3248, 'Rocks', 'rela_rock', 's', 1, 1, 0.80, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1460, 3256, 'ktchn_stove name', 'ktchn_stove', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1461, 3258, 'ktchn_light name', 'ktchn_light', 's', 2, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1462, 3263, 'ktchn_plates name', 'ktchn_plates', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1463, 3261, 'ktchn_countr_1 name', 'ktchn_countr_1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1464, 3252, 'ktchn_pots name', 'ktchn_pots', 's', 2, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1465, 3257, 'ktchn_cornr name', 'ktchn_cornr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1466, 3260, 'ktchn_desk name', 'ktchn_desk', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1467, 3264, 'ktchn_trash name', 'ktchn_trash', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1468, 3253, 'ktchn_countr_2 name', 'ktchn_countr_2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1469, 3255, 'ktchn_bBlock name', 'ktchn_bBlock', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1470, 3259, 'ktchn_dvdr name', 'ktchn_dvdr', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1471, 3250, 'ktchn_inspctr name', 'ktchn_inspctr', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1472, 3249, 'ktchn_fridge name', 'ktchn_fridge', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '3,36,37,38'),
(1473, 3251, 'ads_1800tele', 'ads_1800tele', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1474, 3262, 'ktchn_sink name', 'ktchn_sink', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1475, 3254, 'ktchn_gate name', 'ktchn_gate', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1476, 1, 'Pad of stickies', 'post.it', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'postit', 1, '0'),
(1477, 2, 'Heart Stickies', 'post.it.vd', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'postit', 1, '0'),
(1478, 1930, 'Green Hatch', 'divider_poly3*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 1, '0'),
(1479, 3021, 'Idea Agency Lava Lamp', 'ads_cllava2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1480, 4002, 'Gothic Ectoplasm Fountain', 'gothicfountain', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1481, 4003, 'Retro Wall Lamp', 'hc_wall_lamp', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1482, 4004, 'Industrial Turbine', 'industrialfan', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1483, 4005, 'Gothic Torch', 'torch', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1484, 4006, 'Heart Light', 'val_heart', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1485, 4007, 'Mirror', 'wallmirror', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1486, 4008, 'Ninja Stars', 'jp_ninjastars', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1487, 4009, 'Habbowood Mirror', 'habw_mirror', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1488, 4010, 'So you gotta ask yourself', 'habbowheel', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'habbowheel', 1, '0'),
(1489, 4011, 'Skull Guitar', 'guitar_skull', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1490, 4012, 'V Guitar', 'guitar_v', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1491, 4015, 'Christmas Lights', 'xmas_light', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1492, 4016, 'Anchor', 'hrella_poster_3', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1493, 4013, 'Life Buoy', 'hrella_poster_2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1494, 4014, 'Porthole', 'hrella_poster_1', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1495, 4017, 'Swords', 'sw_swords', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1496, 4018, 'Mysterious Necklace', 'sw_stone', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1497, 4019, 'Ventilation Duct', 'sw_hole', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1498, 4027, 'Mood Light', 'roomdimmer', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dimmer', 1, '0'),
(1499, 4023, 'Bubble Juice Can', 'md_logo_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1500, 4021, 'Kakejiku Hokusai', 'jp_sheet3', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1501, 4026, 'Kakejiku Ninjya', 'jp_sheet2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1502, 4024, 'Kakejiku Ziritsu', 'jp_sheet1', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1503, 4020, 'Ancestral Scimitars', 'arabian_swords', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1504, 4022, 'Arabian Window Frame', 'arabian_wndw', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1505, 4030, 'Jungle Wallplant', 'tiki_wallplnt', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 1, '0'),
(1506, 4028, 'Surfboard', 'tiki_surfboard', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 9, '0'),
(1507, 4029, 'tampax_wall', 'tampax_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1508, 4031, 'Single Window', 'window_single_default', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1509, 4032, 'Double Window', 'window_double_default', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1510, 4033, 'Window', 'noob_window_double', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(1511, 4045, 'Bay Window', 'window_triple', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1512, 4036, 'Glass Square Window', 'window_square', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1513, 4041, 'Large Romantic Window', 'window_romantic_wide', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1514, 4037, 'Small Romantic Window', 'window_romantic_narrow', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1515, 4044, 'Grunge Window', 'window_grunge', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1516, 4035, 'Golden Window', 'window_golden', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1517, 4034, 'Large Oriental Window', 'window_chinese_wide', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1518, 4038, 'Small Oriental Window', 'window_chinese_narrow', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1519, 4042, 'Basic Window', 'window_basic', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1520, 4039, 'Large 70s Window', 'window_70s_wide', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1521, 4040, 'Small 70s Window', 'window_70s_narrow', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1522, 4043, 'Sunny Delight', 'ads_sunnyd', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1523, 4046, 'Good grub', 'window_diner2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1524, 4049, 'Large Diner Window', 'window_diner', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1525, 4048, 'Diner Side Table', 'diner_walltable', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1526, 4047, 'ads_dave_wall', 'ads_dave_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1527, 4052, 'Window', 'window_hole', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1528, 4051, 'easy_poster', 'easy_poster', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1529, 4050, 'ads_nokia_logo name', 'ads_nokia_logo', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1530, 4053, 'ads_nokia_phone name', 'ads_nokia_phone', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1531, 4054, 'Skyscraper Window', 'window_skyscraper', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1532, 4057, 'netari_poster', 'netari_poster', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1533, 4056, 'Bullet Hole', 'det_bhole', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1534, 4058, 'Red V Guitar', 'ads_campguitar', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1535, 4059, 'Nuclear Radiation Sign', 'hween08_rad', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1536, 4061, 'Broken Window (small)', 'hween08_wndwb', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1537, 4062, 'Broken Window (large)', 'hween08_wndw', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1538, 4063, 'Biohazard Sign', 'hween08_bio', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1539, 4060, 'X-Ray Light Box', 'hw_08_xray', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1540, 4065, 'Red Gothic Fountain', 'gothicfountain2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1541, 4275, 'Volturi Crest', 'ads_twi_crest', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1542, 4067, 'TBD Central Musical TV', 'ads_cmusic', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1543, 4070, 'Stand up or sitting down', 'party_wc_boy', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1544, 4066, 'Big Wall Lights', 'party_led', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1545, 4074, 'Neon Heart Light', 'party_neon5', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1546, 4069, 'Neon Right Arrows', 'party_neon1', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1547, 4073, 'Neon Left Arrows', 'party_neon2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1548, 4068, 'Girls Toilets', 'party_wc_girl', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1549, 4075, 'Neon Pink Flamingo', 'party_neon3', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1550, 4071, 'Bar Shelf', 'party_shelf', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1551, 4072, 'Neon Skull Light', 'party_neon4', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1552, 4077, 'Snowy Posters', 'xmas08_wallpaper', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'roomeffect', 1, '0'),
(1553, 4076, 'Icy Wall', 'xmas08_icewall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1554, 4082, 'Idea Agency Plasma 1', 'ads_clwall1', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1555, 4078, 'Idea Agency Plasma 2', 'ads_clwall2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1556, 4079, 'Idea Agency Plasma 3', 'ads_clwall3', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1557, 4081, 'ads_ob_wall', 'ads_ob_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1558, 4083, 'Mall Window', 'ads_mall_window', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1559, 4085, 'Dragon Poster', 'china_pstr2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1560, 4086, 'Chinese Wall Lamp', 'china_light', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1561, 4084, 'Ox Poster', 'china_pstr1', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1562, 4087, 'Bolly Window', 'bolly_wdw_wd', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1563, 4090, 'Monster Plan Poster', 'ads_igor_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1564, 4089, 'Evil Bone', 'ads_igorevilb', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1565, 4088, 'ads_idol_wall name', 'ads_idol_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1566, 4092, 'Mall Furni Showroom', 'ads_mall_winfur', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1567, 4091, 'Mall Pet Shop Window', 'ads_mall_winpet', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1568, 4095, 'Rock Wall', 'lc_wall1', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1569, 4096, 'Aquarium Window', 'lc_window2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1570, 4094, 'Wooden Window', 'lc_window1', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1571, 4093, 'American Idol TV', 'ads_idol_tv', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1572, 4097, 'Coral Wall', 'lc_wall2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1573, 4099, 'ads_idol_mirror name', 'ads_idol_mirror', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1574, 4098, 'Mall Cinema Window', 'ads_mall_wincin', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1575, 4101, 'Strum', 'ads_mall_winmus', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1576, 4100, 'Mall Beauty Salon', 'ads_mall_winbea', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1577, 4105, 'Eco Curtain 1', 'eco_curtains1', 'i', 0, 0, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1578, 4103, 'Mall Idea Agency Window', 'ads_mall_winchi', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1579, 4104, 'Eco Curtain 3', 'eco_curtains3', 'i', 0, 0, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1580, 4102, 'Eco Curtain 2', 'eco_curtains2', 'i', 0, 0, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 2, '0'),
(1581, 4109, 'Mall Ice Cream Parlour Window', 'ads_mall_winice', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1582, 4106, 'Whatever your sporting dibble', 'ads_mall_winspo', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1583, 4108, 'ads_idol_logo name', 'ads_idol_logo', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1584, 4110, 'World Map', 'exe_map', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1585, 4107, 'Wall Fall', 'exe_wfall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1586, 4115, 'ads_lin_wh_c name', 'ads_lin_wh_c', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1587, 4113, 'ads_malaco_tv name', 'ads_malaco_tv', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1588, 4111, 'ads_puffet_tv name', 'ads_puffet_tv', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1589, 4112, 'ads_reebok_tv name', 'ads_reebok_tv', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1590, 4114, 'Forest Wall Poster', 'country_forestwall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1591, 4117, 'Marble Fireplace', 'country_fp', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1592, 4118, 'Farmhouse Wall', 'country_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1593, 4116, 'Ye Olde Lantern', 'country_lantern', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1594, 4119, 'Norwegian Flag', 'flag_norway', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1595, 4120, 'Diner Poster', 'diner_poster', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1596, 4121, '', 'lt_jngl_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1597, 4122, 'ads_mirror name', 'ads_mirror', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1598, 4123, 'lt_wall', 'lt_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1599, 4224, 'Starship Window', 'sf_window', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1600, 4228, 'Starship Wall', 'sf_wall2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1601, 4226, 'ads_wwe_poster name', 'ads_wwe_poster', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1602, 4225, 'Fly me to the moon', 'ads_mall_wintra', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1603, 4223, 'Starship Corner', 'sf_wall3', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1604, 4222, 'ads_veet name', 'ads_veet', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1605, 4232, 'Wall Tiles', 'rela_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(1606, 4229, 'flag_belgium', 'flag_belgium', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1607, 4249, 'Porko Flag', 'Porko Flag', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1608, 4230, 'ads_mall_wingar', 'ads_mall_wingar', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1609, 4235, 'ktchn_wall name', 'ktchn_wall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1610, 4236, 'ads_mall_winclo', 'ads_mall_winclo', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1611, 4234, 'ktchn_oven name', 'ktchn_oven', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1612, 4233, 'ktchn_knives name', 'ktchn_knives', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1613, 4240, 'Mood Controller (Large)', 'dimmer_fuse6', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dimmer', 1, '0'),
(1614, 4237, 'Mood Switch (Large)', 'dimmer_swtch', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dimmer', 1, '0'),
(1615, 4239, 'Mood Controller (Small)', 'dimmer_fuse2', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dimmer', 1, '0'),
(1616, 4238, 'Mood Switch (Small)', 'dimmer_buttn', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'dimmer', 1, '0'),
(1617, 9, '', 'avatar_effect9', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1618, 6, '', 'avatar_effect6', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1619, 16, '', 'avatar_effect16', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1620, 2, '', 'avatar_effect2', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1621, 14, '', 'avatar_effect14', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1622, 15, '', 'avatar_effect15', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1623, 3, '', 'avatar_effect3', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1624, 17, '', 'avatar_effect17', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1625, 18, '', 'avatar_effect18', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1626, 1, '', 'avatar_effect1', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1627, 4, '', 'avatar_effect4', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1628, 5, '', 'avatar_effect5', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1629, 7, '', 'avatar_effect7', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1630, 8, '', 'avatar_effect8', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1631, 10, '', 'avatar_effect10', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1632, 12, '', 'avatar_effect12', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1633, 13, '', 'avatar_effect13', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 1, '0'),
(1634, 3002, '', 'a2 l', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 0, 'roomeffect', 1, '0'),
(1635, 3001, '', 'a2 t', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 0, 'roomeffect', 1, '0'),
(1636, 3001, '', 'wallpaper 1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 0, 'roomeffect', 1, '0'),
(1637, 4055, '', 'landscape 1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 0, 'roomeffect', 1, '0'),
(1638, 3288, '', 'hween09_floor', 's', 2, 2, 0.00, 1, 1, 0, 0, 0, 1, 1, 1, 'default', 1, '0'),
(1639, 3287, '', 'hween09_jar', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 2, '0'),
(1640, 3284, 'City Bench (Clean)', 'urban_bench_plain', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1641, 3282, '', 'hween09_organ', 's', 2, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 2, '0'),
(1642, 3291, '', 'byesw_hand', 's', 1, 1, 1.35, 0, 0, 0, 0, 1, 1, 1, 1, '', 1, '0'),
(1643, 3289, '', 'byesw_hotel', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'default', 6, '0'),
(1644, 3286, '', 'hween09_table', 's', 1, 3, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 2, '0'),
(1645, 3295, '', 'hween09_chair', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 1, 1, 'default', 1, '0'),
(1646, 3293, '', 'hween09_mirror', 's', 1, 1, 1.00, 0, 0, 1, 0, 0, 1, 1, 1, 'default', 2, '0'),
(1647, 3285, 'Trap Door', 'hween09_hatch', 's', 2, 2, 0.00, 0, 1, 0, 0, 0, 1, 1, 1, 'gate', 2, '0'),
(1648, 3290, '', 'hween09_ghost', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 2, '0'),
(1649, 3292, '', 'hween09_tv', 's', 2, 1, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 3, '0'),
(1650, 3294, '', 'hween09_chandelier', 's', 1, 1, 1.00, 0, 1, 0, 0, 0, 1, 1, 1, 'default', 3, '0'),
(1651, 4247, '', 'hween09_crnr1', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 4, '0'),
(1652, 4263, '', 'hween09_paint', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 2, '0'),
(1653, 4269, '', 'hween09_treewall', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 2, '0'),
(1654, 4257, '', 'hween09_wall1', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 4, '0'),
(1655, 4259, '', 'hween09_stonewall', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 5, '0'),
(1656, 4271, '', 'hween09_win', 'i', 0, 0, 1.00, 0, 0, 0, 0, 0, 1, 1, 1, 'default', 10, '0'),
(1657, 22, '', 'avatar_effect22', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(1658, 19, '', 'avatar_effect19', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(1659, 20, '', 'avatar_effect20', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(1660, 21, '', 'avatar_effect21', 'e', 1, 1, 1.00, 0, 0, 0, 0, 0, 1, 0, 1, 'default', 1, '0'),
(1661, 3330, 'Snowman Base', 'xm09_man_a', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1662, 3328, 'Snowman Middle', 'xm09_man_b', 's', 1, 1, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 9, '0'),
(1663, 3329, 'Snowman Head', 'xm09_man_c', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 8, '0'),
(1664, 3335, 'Christmas Table', 'xm09_table', 's', 2, 6, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1665, 3340, '6-Seater Bench', 'xm09_bench', 's', 6, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1666, 4307, 'Snowy Fir Trees', 'xm09_firwall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1667, 4308, 'Snowy Forest', 'xm09_forestwall', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1668, 4311, 'Lodge Wall', 'xm09_lodgewall', 'i', 0, 0, 1.00, 1, 0, 0, 0, 1, 1, 1, 1, 'default', 8, '0'),
(1669, 4286, 'Gold Heart Bauble', 'xm09_bauble_25', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1670, 4306, 'Silver Heart Bauble', 'xm09_bauble_26', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1671, 4279, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1672, 4279, 'Pink Heart Bauble', 'xm09_bauble_27', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1673, 4292, 'Blue Heart Bauble', 'xm09_bauble_23', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1674, 4278, 'Green Heart Bauble', 'xm09_bauble_24', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1675, 3314, 'Candy Cane', 'xm09_candyCane', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1676, 4280, 'Big Stocking', 'xm09_stocking', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1677, 3301, 'Fountain', 'ads_twi_fountn', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1678, 3302, 'Clock Tower wall', 'ads_twi_dvdr2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1679, 3304, 'Standing Rose Bouquet', 'ads_twi_roses', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1680, 3297, 'Cake on Table with Presents', 'ads_twi_table', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1681, 3300, 'Volturi Royal Chair', 'ads_twi_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1682, 3303, 'Half wall', 'ads_twi_dvdr1', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1683, 3299, 'Broken Piano', 'ads_twi_piano', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1684, 3298, 'ads_twi_tower name', 'ads_twi_tower', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1685, 3296, 'Toolbox', 'ads_twi_toolbx', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1686, 3308, 'Mist', 'ads_twi_mist', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1687, 3272, 'Water Hydrant', 'urban_wpost', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1688, 3274, 'Pavement Slab', 'urban_sidewalk', 's', 2, 2, 0.20, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1689, 3269, 'City Bench (Dirty)', 'urban_bench', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1690, 3268, 'Taxi Sofa', 'urban_carsofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1691, 3270, 'Concrete Block', 'urban_blocker', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1692, 3266, 'Garbage Bin', 'urban_bin', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1693, 3267, 'Mesh Fencing', 'urban_fence', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1694, 3271, 'Basketball Pole', 'urban_bsktbll', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1695, 1609, 'Terracotta Pillar', 'pillar*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1696, 1795, 'Urban Iced Bookcase', 'shelves_norja*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1697, 1895, 'Black Mode Double Bed', 'bed_polyfon*2', 's', 2, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(1698, 1995, 'Blue Iced Angle', 'divider_nor5*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1699, 2103, 'Valentine''s Cauldron', 'val_cauldron', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '25'),
(1700, 2509, 'Aqua Pura Module 5', 'pura_mdl5*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1701, 2597, 'Aqua One Way Gate', 'one_way_door*1', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(1702, 2672, 'Power Globe', 'exe_globe', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1703, 2874, 'Latte Diner Corner', 'diner_bardesk_corner*5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1704, 3012, 'Bubbles', 'fx_bubble', 's', 1, 1, 1.00, 1, 0, 0, 0, 0, 1, 0, 1, 'rentals', 2, '0'),
(1705, 3087, 'Safety Cone', 'bump_tottero', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 0, 1, 'default', 1, '0'),
(1706, 3195, 'ads_calip_parasol name', 'ads_calip_parasol', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1707, 4313, '2010 Poster', 'year2010', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1708, 3327, 'Party Lantern', 'party_lantern', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1709, 4310, 'Party Lights', 'party_lights', 'i', 0, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1710, 3240, 'Soothing Stick', 'rela_stick', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1711, 3306, 'Mall Lift', 'ads_mall_elevator', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 1, '0'),
(1712, 4309, 'Flatscreen TV', 'xm09_infotv', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1713, 3311, 'Twilight Trophy', 'ads_twi_trophy', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'trophy', 1, '0'),
(1714, 4272, 'Painting', 'ads_twi_paint', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1715, 4277, 'Window with Candles', 'ads_twi_windw', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1716, 4276, 'Truck and Motorcycles', 'ads_twi_bwall2', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1717, 4273, 'Dream Catcher', 'ads_twi_dreamc', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1718, 4274, 'Barn Wall', 'ads_twi_bwall1', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1719, 4287, 'Arabian Wall', 'arabian_wall', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, '', 2, '0'),
(1720, 0, 'DEAL_HC_1', 'DEAL_HC_1', 'h', 0, 0, 0.00, 0, 0, 0, 0, 0, 1, 0, 0, 'default', 0, '0'),
(1721, 3277, 'ads_gsArcade_1 name', 'ads_gsArcade_1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1722, 3337, 'Hot Choc Machine', 'xm09_cocoa', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '10'),
(1723, 3273, 'Astro-Bar', 'sf_mbar', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '44'),
(1724, 3281, 'Silver MTV EMA Trophy', 'ads_mtvtrophy_silver', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1725, 3280, 'ads_spang_sleep', 'ads_spang_sleep', 's', 1, 3, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(1726, 3279, 'Gold MTV EMA Trophy', 'ads_mtvtrophy_gold', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1727, 3307, 'ktchn_hlthNut name', 'ktchn_hlthNut', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1728, 3325, 'Chicken', 'petfood8', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1729, 3318, 'nest_plow_reg', 'nest_plow_reg', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1730, 3319, 'Yellow Pet Snuggle', 'nest_snug_yel', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1731, 3322, 'Salmon', 'petfood9', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1732, 3326, 'Leveling Cake', 'petfood10', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1733, 3321, 'Ice Apples', 'petfood7', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1734, 3323, 'Red Apples', 'petfood6', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1735, 3310, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1736, 3317, 'nest_snug_red', 'nest_snug_red', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1737, 3310, 'Green Pet Snuggle', 'nest_snug_grn', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1738, 3309, 'nest_plow_bro', 'nest_plow_bro', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1739, 3320, 'Red Pet Pillow', 'nest_plow_red', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1740, 3315, 'nest_snug_blu', 'nest_snug_blu', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1741, 3324, 'Green Apples', 'petfood5', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1742, 3316, 'Blue Pet Pillow', 'nest_plow_blu', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1743, 3313, 'Giant Bauble', 'xm09_lrgBauble', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1744, 3331, 'nest_dirt', 'nest_dirt', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1745, 3332, 'nest_snug_prp', 'nest_snug_prp', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1746, 3334, 'nest_nest', 'nest_nest', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1747, 3336, 'nest_nails', 'nest_nails', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1748, 3333, 'nest_basket', 'nest_basket', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1749, 3339, 'Polar Bear Nest', 'nest_ice', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1750, 3341, 'nest_plow_skl', 'nest_plow_skl', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1751, 3338, 'nest_snug_bla', 'nest_snug_bla', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1752, 3342, 'The Moodi Machine', 'ads_cl_moodi', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '46,47,45'),
(1753, 3354, 'org_chairpnk', 'org_chairpnk', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 0, '0'),
(1754, 3352, 'org_tblpnk', 'org_tblpnk', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1755, 3353, 'org_lampblk', 'org_lampblk', 's', 1, 1, 1.20, 0, 0, 0, 1, 1, 1, 1, 1, '', 2, '0'),
(1756, 3348, 'org_lamppnk', 'org_lamppnk', 's', 1, 1, 1.20, 0, 0, 0, 1, 1, 1, 1, 1, '', 2, '0'),
(1757, 3356, 'org_table', 'org_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, '', 2, '0'),
(1758, 3344, 'china_tiger', 'china_tiger', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1759, 3351, 'xm09_trophy name', 'xm09_trophy', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1760, 3355, 'china_plmTree name', 'china_plmTree', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1761, 3349, 'org_chairblk', 'org_chairblk', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 0, '0'),
(1762, 3347, 'org_tblblk', 'org_tblblk', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1763, 3345, 'org_chrblk', 'org_chrblk', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 0, '0'),
(1764, 3346, 'china_tigrSeat name', 'china_tigrSeat', 's', 1, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1765, 3350, 'org_chrpnk', 'org_chrpnk', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 0, '0'),
(1766, 3367, 'ads_chups name', 'ads_chups', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '48'),
(1767, 3366, 'bling_fridge', 'bling_fridge', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '50'),
(1768, 3370, 'petfood12 name', 'petfood12', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1769, 3365, 'ads_droetker_paula name', 'ads_droetker_paula', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '49'),
(1770, 3358, 'petfood11 name', 'petfood11', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1771, 3368, 'bling_chair_a', 'bling_chair_a', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1772, 3359, 'petfood13 name', 'petfood13', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1773, 3369, 'bling_pool', 'bling_pool', 's', 3, 1, 0.01, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1774, 3362, 'bling_toilet', 'bling_toilet', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 0, '0'),
(1775, 3363, 'val09_floor', 'val09_floor', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(1776, 3361, 'bling_chair_c', 'bling_chair_c', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1777, 3360, 'bling_chair_b', 'bling_chair_b', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1778, 3396, 'bling_shwr name', 'bling_shwr', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1779, 3364, 'bling_bed name', 'bling_bed', 's', 2, 3, 1.60, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1780, 3371, 'bling_sofa', 'bling_sofa', 's', 2, 1, 1.50, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1781, 3357, 'val09_floor2', 'val09_floor2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(1782, 3393, 'teddy_basic', 'teddy_basic', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1783, 3384, 'teddy_pendergrass', 'teddy_pendergrass', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1784, 3386, 'val_hSeat_1 name', 'val_hSeat*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1785, 3387, 'val_hSeat_2 name', 'val_hSeat*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1786, 3388, 'val_hSeat_3 name', 'val_hSeat*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1787, 3389, 'val_hSeat_4 name', 'val_hSeat*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1788, 3390, 'val_hSeat_5 name', 'val_hSeat*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1789, 3391, 'val_hSeat_6 name', 'val_hSeat*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1790, 3392, 'val_hSeat_7 name', 'val_hSeat*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1791, 3382, 'Valentines gift basket', 'val_basket', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1792, 3385, 'teddy_bear', 'teddy_bear', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1793, 3383, 'teddy_pink', 'teddy_pink', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1794, 3394, 'bling_fridge_restricted name', 'bling_fridge_restricted', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '50'),
(1795, 3395, 'ads_percyrock name', 'ads_percyrock', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1796, 4025, 'Bubble Juice Can', 'md_can', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1797, 4243, 'ads_idol_l_logo name', 'ads_idol_l_logo', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1798, 4245, 'Latin American Idol TV', 'ads_idol_l_tv', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1799, 4241, 'Big MTV', 'ads_mtv_bigtv', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1800, 4242, 'Small MTV', 'ads_mtv_tv', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1801, 4249, 'flag_singapore', 'flag_singapore', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1802, 4266, 'Old Curtain', 'hween09_curt', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1803, 4258, 'flag_columbia', 'flag_columbia', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1804, 4256, 'flag_chile', 'flag_chile', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1805, 4268, 'flag_ecuador', 'flag_ecuador', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1806, 4265, 'flag_dominicanrepublic', 'flag_dominicanrepublic', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1807, 4260, 'flag_newzealand', 'flag_newzealand', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1808, 4252, 'flag_malaysia', 'flag_malaysia', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1809, 4267, 'Loading Poster', 'byesw_loadscreen', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1810, 4254, 'flag_venezl', 'flag_venezl', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1811, 4270, 'flag_algeria', 'flag_algeria', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1812, 4248, 'flag_tunisia', 'flag_tunisia', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1813, 4262, 'flag_panama', 'flag_panama', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1814, 4250, 'flag_mexico', 'flag_mexico', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1815, 4261, 'flag_argentina', 'flag_argentina', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1816, 4251, 'flag_philippines', 'flag_philippines', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1817, 4253, 'flag_greece', 'flag_greece', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1818, 4246, 'flag_peru', 'flag_peru', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1819, 4264, 'flag_morocco', 'flag_morocco', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1820, 4255, 'flag_turkey', 'flag_turkey', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1821, 4304, 'Blue Long Bauble', 'xm09_bauble_12', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1822, 4303, 'Purple Long Bauble', 'xm09_bauble_16', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1823, 4281, 'Red Long Bauble', 'xm09_bauble_17', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1824, 4301, 'Silver Long Bauble', 'xm09_bauble_15', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1825, 4293, 'Silver Round Bauble', 'xm09_bauble_10', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1826, 4294, 'Gold Round Bauble', 'xm09_bauble_9', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1827, 4298, 'Green Long Bauble', 'xm09_bauble_18', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1828, 4299, 'Green Long Bauble', 'xm09_bauble_13', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1829, 4297, 'Blue Round Bauble', 'xm09_bauble_2', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1830, 4300, 'Red Round Bauble', 'xm09_bauble_1', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1831, 4302, 'Red Heart Bauble', 'xm09_bauble_22', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1832, 4285, 'Green Round Bauble', 'xm09_bauble_3', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1833, 4305, 'Silver Long Bauble', 'xm09_bauble_21', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1834, 4295, 'Green Round Bauble', 'xm09_bauble_8', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1835, 4282, 'Gold Round Bauble', 'xm09_bauble_4', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1836, 4288, 'Silver Round Bauble', 'xm09_bauble_5', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1837, 4289, 'Red Long Bauble', 'xm09_bauble_11', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1838, 4296, 'Gold Long Bauble', 'xm09_bauble_20', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1839, 3397, 'val_table1 name', 'val_table1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 0, '0'),
(1840, 4290, 'Gold Long Bauble', 'xm09_bauble_14', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1841, 4291, 'Blue Round Bauble', 'xm09_bauble_7', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1842, 4284, 'Red Round Bauble', 'xm09_bauble_6', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1843, 4283, 'Blue Long Bauble', 'xm09_bauble_19', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1844, 4314, 'china_pstr3 name', 'china_pstr3', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1845, 4315, 'ads_tv_jaapuisto name', 'ads_tv_jaapuisto', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1846, 4322, 'Empire State Building Clock', 'ads_percyw', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1847, 4320, 'val09_wdrobe_b', 'val09_wdrobe_b', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1848, 4316, 'val09_wall2', 'val09_wall2', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1849, 4319, 'bling_sink', 'bling_sink', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1850, 4318, 'val09_wall1', 'val09_wall1', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1851, 4321, 'bling_cabinet', 'bling_cabinet', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1852, 4317, 'val09_wdrobe_g', 'val09_wdrobe_g', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1853, 3399, 'rare_ironmaiden name', 'rare_ironmaiden', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 0, 1, 1, 'teleport', 2, '0'),
(1854, 3398, 'rare_trex name', 'rare_trex', 's', 3, 7, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1855, 3401, 'beanstalk', 'beanstalk', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(1856, 3403, 'Rare Voodoo Doll', 'rare_vdoll', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, '', 10, '0'),
(1857, 3402, 'rare_mmmth name', 'rare_mmmth', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, '', 0, '0'),
(1858, 3400, 'crystal_patch', 'crystal_patch', 's', 3, 3, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1859, 4323, 'ads_boost_surfb name', 'ads_boost_surfb', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, '', 0, '0'),
(1860, 4324, 'ads_tlc_wheel name', 'ads_tlc_wheel', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'habbowheel', 1, '0'),
(1861, 2442, 'a0 pet5', 'a0 pet5', 's', 1, 1, 0.00, 0, 0, 0, 1, 0, 0, 0, 0, 'pet5', 1, '0'),
(1862, 3419, 'White moon lupine', 'garden_lupin4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1863, 3408, 'Gold rush', 'garden_mursu3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 0, '0'),
(1864, 3411, 'Purple Lupine', 'garden_lupin5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1865, 3406, 'Violet Blossom', 'garden_seed', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1866, 3420, 'Snapping teleporter', 'garden_flytrap', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'teleport', 1, '0');
INSERT INTO `items_base` (`item_id`, `sprite_id`, `public_name`, `item_name`, `type`, `width`, `length`, `height`, `allow_stack`, `allow_walk`, `allow_sit`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `cycle_count`, `vending_ids`) VALUES
(1867, 3426, 'Pink pandemic', 'garden_flo3', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1868, 3424, 'Belching pod', 'garden_volcano', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'alert', 2, '0'),
(1869, 3415, 'Wonder lamp', 'garden_flolamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1870, 3412, 'Red rush', 'garden_mursu2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1871, 3405, 'Star flower', 'garden_jyrki', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 8, '0'),
(1872, 3414, 'White rush', 'garden_mursu4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1873, 3425, 'Garden leaves', 'garden_leaves', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1874, 3416, 'Sky blue lupine', 'garden_lupin2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1875, 3407, 'Red lupine', 'garden_lupin3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1876, 3404, 'Pink rush', 'garden_mursu', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1877, 3413, 'Bauhinia orchid tree', 'garden_orchtree', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1878, 3409, 'Yellow happiness', 'garden_flo2', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1879, 3421, 'Orange lupine', 'garden_lupin1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1880, 3417, 'Weird staring bush', 'garden_staringbush', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1881, 3423, 'ads_grefusa_yum name', 'ads_grefusa_yum', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '51, 52'),
(1882, 3418, 'Blue passion', 'garden_flo1', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1883, 3422, 'Duck grass', 'garden_jungle', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, '', 1, '0'),
(1884, 3455, 'merger_chest name', 'merger_chest', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1885, 3458, 'Suave Fireplace', 'hc2_frplc', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1886, 3439, 'Leather Bar Stool', 'hc2_barchair', 's', 1, 1, 1.70, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1887, 3457, 'runway_display name', 'runway_display', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1888, 3463, 'runway_bigchr_5 name', 'runway_bigchr_5', 's', 1, 1, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1889, 3435, 'runway_bigchr_4 name', 'runway_bigchr_4', 's', 1, 1, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1890, 3461, 'VIP Duvan', 'hc3_dc', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(1891, 3434, 'Glass Table', 'hc2_sofatbl', 's', 2, 2, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1892, 3442, 'runway_stool name', 'runway_stool', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1893, 3456, 'runway_dvdr name', 'runway_dvdr', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1894, 3443, 'runway_block_2 name', 'runway_block_2', 's', 2, 2, 0.80, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1895, 3462, 'runway_bigchr_1 name', 'runway_bigchr_1', 's', 1, 1, 0.80, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1896, 3446, 'Black Lamp', 'hc2_biglamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1897, 3452, 'Leather Sofa', 'hc2_sofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1898, 3440, 'Trendy Rug', 'hc2_carpet', 's', 3, 5, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1899, 3433, 'runway_block_1 name', 'runway_block_1', 's', 2, 2, 0.80, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1900, 3464, 'runway_bench name', 'runway_bench', 's', 2, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1901, 3429, 'runway_chair_2 name', 'runway_chair_2', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1902, 3453, 'ads_cheetos name', 'ads_cheetos', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '51, 52'),
(1903, 3466, 'VIP Coffee Table', 'hc3_table', 's', 2, 2, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1904, 3454, 'runway_bigchr_3 name', 'runway_bigchr_3', 's', 1, 1, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1905, 3448, 'VIP Stool', 'hc3_stool', 's', 1, 1, 1.70, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1906, 3441, 'VIP Sofa', 'hc3_sofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1907, 3427, 'runway_bigchr_2 name', 'runway_bigchr_2', 's', 1, 1, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1908, 3436, 'Leather Armchair', 'hc2_armchair', 's', 1, 1, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1909, 3444, 'runway_table_2 name', 'runway_table_2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1910, 3460, 'runway_table_1 name', 'runway_table_1', 's', 3, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1911, 3437, 'runway_manqn_1 name', 'runway_manqn_1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1912, 3459, 'Leather Duvan', 'hc2_dvn', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(1913, 3465, 'VIP Light', 'hc3_light', 's', 2, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1914, 3438, 'VIP Shelves', 'hc3_shelf', 's', 3, 1, 1.75, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1915, 3432, 'runway_head name', 'runway_head', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 7, '0'),
(1916, 3467, 'runway_manqn_2 name', 'runway_manqn_2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(1917, 3449, 'Black Divider', 'hc2_divider', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1918, 3450, 'Espresso Machine', 'hc2_coffee', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '9,8,14,15,6,10,11,12'),
(1919, 3430, 'Service Trolley', 'hc2_cart', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1920, 3445, 'VIP Bar Desk', 'hc3_bard', 's', 2, 1, 1.05, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1921, 3447, 'VIP Lamp', 'hc3_hugelamp', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1922, 3431, 'VIP Divider', 'hc3_divider', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1923, 3428, 'Black Vase', 'hc2_vase', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1924, 3451, 'runway_chair_1 name', 'runway_chair_1', 's', 1, 1, 1.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1925, 4325, 'Green been vines', 'garden_wall', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(1926, 4326, 'ads_tv_yle name', 'ads_tv_yle', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1927, 4329, 'VIP Wall Art', 'hc3_walldeco', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 10, '0'),
(1928, 4327, 'runway_shelf name', 'runway_shelf', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(1929, 4330, 'ads_nokia_x6 name', 'ads_nokia_x6', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1930, 4332, 'ads_target_wall name', 'ads_target_wall', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1931, 4331, 'runway_fabric name', 'runway_fabric', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 8, '0'),
(1932, 4328, 'ads_latrobe_flag name', 'ads_latrobe_flag', 'i', 0, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, '', 1, '0'),
(1933, 263, 'Camera', 'camera', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, '', 1, '0'),
(1934, 4001, 'Holly', 'holly', 'i', 0, 0, 0.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1935, 2164, 'Electronic 1', 'sound_set_3', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1936, 2165, 'Ambient 1', 'sound_set_4', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1937, 2166, 'Ambient 4', 'sound_set_5', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1938, 2167, 'Ambient 3', 'sound_set_6', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1939, 2168, 'SFX 5', 'sound_set_7', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1940, 2169, 'Ambient 2', 'sound_set_8', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1941, 2170, 'Electronic 2', 'sound_set_9', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1942, 2171, 'Traxmachine', 'sound_machine*1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1943, 2519, 'Habbowood Spotlight', 'spotlight', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(1944, 2543, 'Ocean Traxmachine', 'sound_machine*2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1945, 2544, 'Green Traxmachine', 'sound_machine*3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1946, 2545, 'For Funky', 'sound_machine*4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1947, 2546, 'Brown Traxmachine', 'sound_machine*5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1948, 2547, 'Purple Traxmachine', 'sound_machine*6', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1949, 2548, 'Red Traxmachine', 'sound_machine*7', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1950, 2551, 'Crystal Lamp', 'rom_lamp', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1951, 2459, 'Polar Sofa', 'rclr_sofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1952, 2458, 'Water Garden', 'rclr_garden', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(1953, 2562, 'Palm Chair', 'rclr_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1954, 2496, 'Rock 2', 'sound_set_28', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1955, 2549, 'Groove 2', 'sound_set_27', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1956, 2508, 'Groove 1', 'sound_set_26', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1957, 2470, 'Actually', 'sound_set_25', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1958, 2492, 'It''s all about the Pentiums', 'sound_set_24', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1959, 2457, 'SFX 4', 'sound_set_23', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1960, 2521, 'With a hamper full of sounds', 'sound_set_22', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1961, 2494, 'Rock 1', 'sound_set_21', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1962, 2524, 'SFX 2', 'sound_set_20', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1963, 2469, 'Hip Hop Beats 4', 'sound_set_19', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1964, 2497, 'Groove 4', 'sound_set_18', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1965, 2550, 'Groove 3', 'sound_set_17', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1966, 2561, 'Ferry', 'sound_set_16', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1967, 2495, 'RnB Grooves 6', 'sound_set_15', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1968, 2482, 'Hip Hop Beats 2', 'sound_set_14', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1969, 2523, 'Dance 5', 'sound_set_13', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1970, 2493, 'Habbo Sounds 2', 'sound_set_12', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1971, 2563, 'Dance 4', 'sound_set_11', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1972, 2481, 'Hip Hop Beats 1', 'sound_set_10', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1973, 2518, 'Rope Divider', 'rope_divider', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(1974, 2520, 'romantique_clock', 'romantique_clock', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1975, 2507, 'Aqua Pura Module 5', 'rare_icecream_campaign', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 0, '4'),
(1976, 2510, 'Pink Pura Module 5', 'pura_mdl5*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1977, 2511, 'Black Pura Module 5', 'pura_mdl5*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1978, 2512, 'White Pura Module 5', 'pura_mdl5*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1979, 2513, 'beige pura module 5', 'pura_mdl5*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1980, 2514, 'Blue Pura Module 5', 'pura_mdl5*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1981, 2515, 'Green Pura Module 5', 'pura_mdl5*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1982, 2516, 'Yellow Pura Module 5', 'pura_mdl5*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1983, 2517, 'Red Pura Module 5', 'pura_mdl5*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1984, 2472, 'Aqua Pura Module 4', 'pura_mdl4*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1985, 2473, 'Pink Pura Module 4', 'pura_mdl4*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1986, 2474, 'Black Pura Module 4', 'pura_mdl4*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1987, 2475, 'White Pura Module 4', 'pura_mdl4*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1988, 2476, 'beige pura module 4', 'pura_mdl4*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1989, 2477, 'Blue Pura Module 4', 'pura_mdl4*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1990, 2478, 'Green Pura Module 4', 'pura_mdl4*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1991, 2479, 'yellow pura module 4', 'pura_mdl4*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1992, 2480, 'Red Pura Module 4', 'pura_mdl4*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1993, 2534, 'Aqua Pura Module 3', 'pura_mdl3*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1994, 2535, 'Pink Pura Module 3', 'pura_mdl3*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1995, 2536, 'Black Pura Module 3', 'pura_mdl3*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1996, 2537, 'White Pura Module 3', 'pura_mdl3*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1997, 2538, 'beige pura module 3', 'pura_mdl3*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1998, 2539, 'Blue Pura Module 3', 'pura_mdl3*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(1999, 2540, 'Green Pura Module 3', 'pura_mdl3*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2000, 2541, 'yellow pura module 3', 'pura_mdl3*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2001, 2542, 'Red Pura Module 3', 'pura_mdl3*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2002, 2483, 'Aqua Pura Module 2', 'pura_mdl2*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2003, 2484, 'Pink Pura Module 2', 'pura_mdl2*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2004, 2485, 'Black Pura Module 2', 'pura_mdl2*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2005, 2486, 'White Pura Module 2', 'pura_mdl2*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2006, 2487, 'beige pura module 2', 'pura_mdl2*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2007, 2488, 'Blue Pura Module 2', 'pura_mdl2*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2008, 2489, 'Green Pura Module 2', 'pura_mdl2*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2009, 2490, 'yellow pura module 2', 'pura_mdl2*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2010, 2491, 'Red Pura Module 2', 'pura_mdl2*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2011, 2460, 'Aqua Pura Module 1', 'pura_mdl1*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2012, 2461, 'Pink Pura Module 1', 'pura_mdl1*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2013, 2462, 'Black Pura Module 1', 'pura_mdl1*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2014, 2463, 'White Pura Module 1', 'pura_mdl1*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2015, 2464, 'beige pura module 1', 'pura_mdl1*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2016, 2465, 'Blue Pura Module 1', 'pura_mdl1*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2017, 2466, 'Green Pura Module 1', 'pura_mdl1*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2018, 2467, 'yellow pura module 1', 'pura_mdl1*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2019, 2468, 'Red Pura Module 1', 'pura_mdl1*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2020, 2471, 'Japanese Lantern', 'jp_lantern', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2021, 2525, 'chair_basic', 'chair_basic*1', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2022, 2526, 'Pink Pura Egg Chair', 'chair_basic*2', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2023, 2527, 'Black Pura Egg Chair', 'chair_basic*3', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2024, 2528, 'White Pura Egg Chair', 'chair_basic*4', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2025, 2529, 'Beige Pura Egg Chair', 'chair_basic*5', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2026, 2530, 'Blue Pura Egg Chair', 'chair_basic*6', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2027, 2531, 'Green Pura Egg Chair', 'chair_basic*7', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2028, 2532, 'chair_basic', 'chair_basic*8', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2029, 2533, 'Red Pura Egg Chair', 'chair_basic*9', 's', 1, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2030, 2552, '', 'bed_budget*1', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2031, 2553, 'Pink Pura Double Bed', 'bed_budget*2', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2032, 2554, 'Black Pura Double Bed', 'bed_budget*3', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2033, 2555, 'White Pura Double Bed', 'bed_budget*4', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2034, 2556, 'Beige Pura Double Bed', 'bed_budget*5', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2035, 2557, 'Blue Pura Double Bed', 'bed_budget*6', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2036, 2558, 'Green Pura Double Bed', 'bed_budget*7', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2037, 2559, 'Yellow Pura Double Bed', 'bed_budget*8', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2038, 2560, 'Red Pura Double Bed', 'bed_budget*9', 's', 2, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2039, 2498, '', 'bed_budget_one*1', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2040, 2499, 'Pink Pura Bed', 'bed_budget_one*2', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2041, 2500, 'Black Pura Bed', 'bed_budget_one*3', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2042, 2501, 'White Pura Bed', 'bed_budget_one*4', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2043, 2502, 'Beige Pura Bed', 'bed_budget_one*5', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2044, 2503, 'Blue Pura Bed', 'bed_budget_one*6', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2045, 2504, 'Green Pura Bed', 'bed_budget_one*7', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2046, 2505, 'Yellow Pura Bed', 'bed_budget_one*8', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2047, 2506, 'Red Pura Bed', 'bed_budget_one*9', 's', 1, 3, 1.90, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2048, 2522, 'Japanese Drawer', 'jp_drawer', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2049, 2568, 'Star Tile', 'tile_stella', 's', 1, 1, 0.05, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2050, 2566, 'Marble Tile', 'tile_marble', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2051, 2582, 'Red Tile', 'tile_brown', 's', 1, 1, 0.05, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2052, 2587, 'Blue Barbeque Grill', 'summer_grill*1', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2053, 2588, 'Red Barbeque Grill', 'summer_grill*2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2054, 2589, 'Green Barbeque Grill', 'summer_grill*3', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2055, 2590, 'Green Barbeque Grill', 'summer_grill*4', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2056, 2571, 'Aqua Deck Chair', 'summer_chair*1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2057, 2572, 'Pink Deck Chair', 'summer_chair*2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2058, 2573, 'Black Deck Chair', 'summer_chair*3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2059, 2574, 'White Deck Chair', 'summer_chair*4', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2060, 2575, 'Deck Chair', 'summer_chair*5', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2061, 2576, 'Deck Chair', 'summer_chair*6', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2062, 2577, 'Green Deck Chair', 'summer_chair*7', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2063, 2578, 'Yellow Deck Chair', 'summer_chair*8', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2064, 2579, 'Red Deck Chair', 'summer_chair*9', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2065, 2583, 'Latin Love 1', 'sound_set_36', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2066, 2595, 'Dance 6', 'sound_set_35', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2067, 2570, 'Rock 5', 'sound_set_34', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2068, 2564, 'Rock 3', 'sound_set_33', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2069, 2569, 'Instrumental 2', 'sound_set_32', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2070, 2596, 'Dance 3', 'sound_set_31', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2071, 2585, 'Instrumental 1', 'sound_set_30', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2072, 2580, 'Dance 2', 'sound_set_29', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2073, 2606, 'Sound Machine Pro', 'sound_machine_pro', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2074, 2584, 'Aqua One Way Gate', 'rare_mnstr', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(2075, 2598, 'Black HC Gate', 'one_way_door*2', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2076, 2599, 'White HC Gate', 'one_way_door*3', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2077, 2600, 'Beige One Way Gate', 'one_way_door*4', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2078, 2601, 'Pink One Way Gate', 'one_way_door*5', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2079, 2602, 'Blue HC Gate', 'one_way_door*6', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2080, 2603, 'Green One Way Gate', 'one_way_door*7', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2081, 2604, 'Yellow One Way Gate', 'one_way_door*8', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2082, 2605, 'Red One Way Gate', 'one_way_door*9', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'onewaygate', 2, '0'),
(2083, 2567, 'Executive Rug', 'exe_rug', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2084, 2581, 'Executive Glass Table', 'exe_s_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2085, 2565, 'Sound set 37', 'sound_set_37', 's', 1, 1, 0.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2086, 2591, 'Blue Summer Pool', 'summer_pool*1', 's', 2, 2, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2087, 2592, 'Red Summer Pool', 'summer_pool*2', 's', 2, 2, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2088, 2593, 'Green Summer Pool', 'summer_pool*3', 's', 2, 2, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2089, 2594, 'Yellow Summer Pool', 'summer_pool*4', 's', 2, 2, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2090, 2607, 'Burn', 'song_disk', 's', 1, 1, 0.10, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2091, 3527, 'bw_boat name', 'bw_boat', 's', 2, 2, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2092, 4336, 'bw_jaws', 'bw_jaws', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2093, 3540, 'bw_shower', 'bw_shower', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2094, 3550, 'bw_tele', 'bw_tele', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'teleport', 1, '0'),
(2095, 3541, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'pool', 1, '0'),
(2096, 3529, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3.00, 0, 1, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2097, 3533, 'bw_sofa', 'bw_sofa', 's', 1, 2, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2098, 3543, 'bw_sboard', 'bw_sboard', 's', 1, 2, 1.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2099, 3544, 'bw_chair', 'bw_chair', 's', 1, 1, 1.00, 1, 1, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2100, 3539, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2101, 3545, 'bw_table', 'bw_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2102, 3547, 'bw_bball', 'bw_bball', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2103, 3542, 'bw_croc', 'bw_croc', 's', 1, 1, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2104, 3552, 'bw_fnc', 'bw_fnc', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2105, 3530, 'bw_water_1', 'bw_water_1', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'lowpool', 1, '0'),
(2106, 3532, 'prison_dvdr2', 'prison_dvdr2', 's', 2, 1, 3.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2107, 3526, 'prison_gate', 'prison_gate', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(2108, 3534, 'prison_dvdr1', 'prison_dvdr1', 's', 1, 1, 3.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2109, 3537, 'prison_stone', 'prison_stone', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2110, 3531, 'prison_tower', 'prison_tower', 's', 1, 1, 3.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2111, 3528, 'prison_crnr', 'prison_crnr', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2112, 3520, 'fball_ptch0', 'fball_ptch0', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2113, 3524, 'fball_ptch1', 'fball_ptch1', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2114, 3511, 'fball_ptch2 name', 'fball_ptch2', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2115, 3513, 'fball_ptch3 name', 'fball_ptch3', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2116, 3504, 'fball_ptch4 name', 'fball_ptch4', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2117, 3498, 'fball_ptch5 name', 'fball_ptch5', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2118, 3517, 'fball_ptch6 name', 'fball_ptch6', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2119, 3509, 'fball_ptch7 name', 'fball_ptch7', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2120, 3502, 'fball_ptch8 name', 'fball_ptch8', 's', 3, 3, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2121, 3496, 'fball_score_b', 'fball_score_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'footballcounterblue', 1, '0'),
(2122, 3512, 'fball_score_g', 'fball_score_g', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'footballcountergreen', 1, '0'),
(2123, 3522, 'fball_score_r', 'fball_score_r', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'footballcountered', 1, '0'),
(2124, 3506, 'fball_score_y', 'fball_score_y', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'footballcounteryellow', 1, '0'),
(2125, 3525, 'fball_counter name', 'fball_counter', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'scoreboard', 2, '0'),
(2126, 3516, 'fball_gate name', 'fball_gate', 's', 1, 0, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'fbgate', 1, '0'),
(2127, 3499, 'fball_light name', 'fball_light', 's', 1, 0, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2128, 3523, 'fball_goal_y name', 'fball_goal_y', 's', 3, 0, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'footballgoalyellow', 1, '0'),
(2129, 3514, 'fball_goal_r name', 'fball_goal_r', 's', 3, 0, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'footballgoalred', 1, '0'),
(2130, 3519, 'fball_goal_g', 'fball_goal_g', 's', 3, 0, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'footballgoalgreen', 1, '0'),
(2131, 3515, 'fball_goal_b name', 'fball_goal_b', 's', 3, 0, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'footballgoalblue', 1, '0'),
(2132, 3495, 'fball_fnc3 name', 'fball_fnc3', 's', 1, 3, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2133, 3501, 'fball_fnc1 name', 'fball_fnc1', 's', 1, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2134, 3503, 'fball_crnr name', 'fball_crnr', 's', 1, 0, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2135, 3507, 'fball_cote name', 'fball_cote', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2136, 3494, 'fball_bench name', 'fball_bench', 's', 3, 0, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2137, 3518, 'fball_ball5 name', 'fball_ball5', 's', 1, 0, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'football', 1, '0'),
(2138, 3521, 'fball_ball4 name', 'fball_ball4', 's', 1, 0, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'football', 1, '0'),
(2139, 3497, 'fball_ball3 name', 'fball_ball3', 's', 1, 0, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'football', 1, '0'),
(2140, 3510, 'fball_ball2 name', 'fball_ball2', 's', 1, 0, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'football', 1, '0'),
(2141, 3508, 'fball_ball name', 'fball_ball', 's', 1, 0, 1.00, 1, 1, 0, 1, 1, 1, 1, 1, 'football', 2, '0'),
(2142, 3500, 'fball_audbench name', 'fball_audbench', 's', 4, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2143, 3505, 'fball_trophy name', 'fball_trophy', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 1, '0'),
(2144, 3582, 'easel_0', 'easel_0', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2145, 3594, 'easel_1', 'easel_1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2146, 3603, 'easel_2', 'easel_2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2147, 3596, 'easel_3', 'easel_3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(2148, 3600, 'easel_4', 'easel_4', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(2149, 3603, 'easel_2', 'easel_2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(2150, 3480, 'party_crate2_1', 'party_crate2_1', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2151, 3481, 'party_crate1_3', 'party_crate1_3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2152, 3485, 'party_crate1_4', 'party_crate1_4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2153, 3487, 'party_crate1_1', 'party_crate1_1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2154, 3489, 'party_crate1_2', 'party_crate1_2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2155, 3490, 'party_crate2_2', 'party_crate2_2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2156, 3491, 'party_crate2_3', 'party_crate2_3', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2157, 3492, 'party_crate2_4', 'party_crate2_4', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2158, 3199, 'party_djset', 'pary_djset', 's', 1, 3, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2159, 3527, 'bw_boat', 'bw_boat', 's', 2, 2, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2160, 3529, 'bw_lgchair', 'bw_lgchair', 's', 1, 1, 3.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2161, 3533, 'bw_sofa', 'bw_sofa', 's', 2, 1, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2162, 3538, 'bw_fin', 'bw_fin', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2163, 3539, 'bw_ccnuts', 'bw_ccnuts', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2164, 3540, 'bw_shower', 'bw_shower', 's', 1, 1, 2.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2165, 3541, 'bw_water_2', 'bw_water_2', 's', 2, 2, 0.00, 1, 0, 0, 1, 1, 1, 1, 1, 'pool', 1, '0'),
(2166, 3542, 'bw_croc', 'bw_croc', 's', 1, 3, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2167, 3543, 'bw_sboard', 'bw_sboard', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2168, 3544, 'bw_chair', 'bw_chair', 's', 1, 1, 0.80, 1, 1, 1, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2169, 3545, 'bw_table', 'bw_table', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2170, 3547, 'bw_ball', 'bw_ball', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2171, 3548, 'bw_mttrss', 'bw_mttrss', 's', 1, 3, 0.80, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2172, 3549, 'bw_van', 'bw_van', 's', 2, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2173, 3551, 'bw_fnc_crnr', 'bw_fnc crnr', 's', 1, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2174, 3552, 'bw_fnc', 'bw_fnc', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2175, 4336, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2176, 4336, 'Mandibula', 'bw_jaws', 'i', 0, 0, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2177, 3569, 'bw_fnc_p', 'bw_fnc_p', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2178, 3563, 'bw_fnc_crnr_g', 'bw_fnc_crnr_g', 's', 1, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2179, 3561, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1.00, 1, 1, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2180, 3568, 'bw_boat_g', 'bw_boat_g', 's', 2, 2, 0.80, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2181, 3558, 'bw_mttrss_g', 'bw_mttrss_g', 's', 1, 3, 0.80, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2182, 3565, 'bw_pool_b2', 'bw_pool_b2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2183, 3564, 'bw_pool_a2', 'bw_pool_a2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2184, 3556, 'bw_pool_a3', 'bw_pool_a3', 's', 1, 1, 0.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2185, 3577, 'bw_pool_a1', 'bw_pool_a1', 's', 1, 1, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2186, 3554, 'ads_pepsi0', 'ads_pepsi0', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '55'),
(2187, 4337, 'ads_grefusa_surfb', 'ads_grefusa_surfb', 'i', 0, 0, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2188, 3560, 'bw_pool_b1', 'bw_pool_b1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2189, 3576, 'bw_fnc_crnr_p', 'bw_fnc_crnr_p', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2190, 3562, 'bw_sboard_g', 'bw_sboard_g', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2191, 3571, 'bw_sboard_p', 'bw_sboard_p', 's', 2, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2192, 3566, 'bw_table_g', 'bw_table_g', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2193, 3578, 'bw_table_p', 'bw_table_p', 's', 2, 1, 0.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2194, 3570, 'bw_van_p', 'bw_van_p', 's', 2, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2195, 3574, 'bw_van_g', 'bw_van_g', 's', 2, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2196, 3575, 'bw_sofa_g', 'bw_sofa_g', 's', 2, 1, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2197, 3561, 'bw_sofa_p', 'bw_sofa_p', 's', 2, 1, 1.00, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2198, 3557, 'bw_fnc_g name', 'bw_fnc_g', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2199, 3550, 'bw_tele', 'bw_tele', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'teleport', 1, '0'),
(2200, 3605, 'african_tree2', 'african_tree2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2201, 3584, 'african_tree1', 'african_tree1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2202, 3607, 'african_stage', 'african_stage', 's', 2, 2, 1.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2203, 3602, 'african_patch', 'african_patch', 's', 2, 2, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2204, 3579, 'african_fence', 'african_fence', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2205, 3609, 'african_bones', 'african_bones', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2206, 4338, 'ktchn10_cabnt', 'ktchn10_cabnt', 'i', 0, 0, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2207, 3580, 'ktchn10_pot', 'ktchn10_pot', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2208, 3612, 'ktchn10_sink', 'ktchn10_sink', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2209, 3581, 'ktchn10_stove', 'ktchn10_stove', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2210, 3591, 'hosptl_bbag name', 'hosptl_bbag', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 2, '0'),
(2211, 3590, 'hosptl_bed', 'hosptl_bed', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 2, '0'),
(2212, 3586, 'hosptl_cab1', 'hosptl_cab1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 2, '35'),
(2213, 3608, 'hosptl_cab2', 'hosptl_cab2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2214, 3588, 'hosptl_curtain', 'hosptl_curtain', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2215, 3606, 'hosptl_defibs', 'hosptl_defibs', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2216, 3610, 'hosptl_light', 'hosptl_light', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2217, 3611, 'hosptl_seat', 'hosptl_seat', 's', 1, 2, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2218, 3604, 'hosptl_skele', 'hosptl_skele', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2219, 4339, 'hosptl_xray', 'hosptl_xray', 'i', 0, 0, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2220, 3860, 'cubie_rug_b', 'cubie_rug_b', 's', 2, 3, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2221, 3863, 'cubie_lamp_p', 'cubie_lamp_p', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2222, 3873, 'cubie_shelf_3_p', 'cubie_shelf_3_p', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 9, '0'),
(2223, 3882, 'cubie_shelf_4_b', 'cubie_shelf_4_b', 's', 3, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(2224, 3875, 'cubie_shelf_1_b', 'cubie_shelf_1_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 14, '0'),
(2225, 3874, 'cubie_shelf_1_p', 'cubie_shelf_1_p', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 14, '0'),
(2226, 3879, 'cubie_chair_p', 'cubie_chair_p', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2227, 3866, 'cubie_shelf_4_p', 'cubie_shelf_4_p', 's', 3, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 6, '0'),
(2228, 3876, 'cubie_bigtable_p', 'cubie_bigtable_p', 's', 2, 2, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2229, 3884, 'cubie_shelf_0_p', 'cubie_shelf_0_p', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2230, 3877, 'cubie_beanbag_b', 'cubie_beanbag_b', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2231, 3859, 'cubie_chair_b', 'cubie_chair_b', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2232, 3871, 'cubie_bed_b', 'cubie_bed_b', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2233, 3861, 'cubie_bigtable_b', 'cubie_bigtable_b', 's', 2, 2, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2234, 3869, 'cubie_stool_b', 'cubie_stool_b', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2235, 3862, 'cubie_beanbag_p', 'cubie_beanbag_p', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2236, 3865, 'cubie_shelf_0_b', 'cubie_shelf_0_b', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2237, 3867, 'cubie_shelf_2_p', 'cubie_shelf_2_p', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 17, '0'),
(2238, 3870, 'cubie_rug_p', 'cubie_rug_p', 's', 2, 3, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2239, 3881, 'cubie_sofaseat_b', 'cubie_sofaseat_b', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2240, 3880, 'cubie_table', 'cubie_table', 's', 1, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2241, 3864, 'cubie_sofaseat_p', 'cubie_sofaseat_p', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2242, 3868, 'cubie_bed_p', 'cubie_bed_p', 's', 1, 3, 1.80, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2243, 3872, 'cubie_shelf_3_b', 'cubie_shelf_3_b', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 9, '0'),
(2244, 3883, 'cubie_shelf_2_b', 'cubie_shelf_2_b', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 14, '0'),
(2245, 3858, 'cubie_lamp_b', 'cubie_lamp_b', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2246, 3878, 'cubie_stool_p', 'cubie_stool_p', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2247, 4389, 'cubie_wallshelf_b', 'cubie_wallshelf_b', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 7, '0'),
(2248, 4385, 'cubie_decklight_p', 'cubie_decklight_p', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2249, 4392, 'cubie_wallshelf_p', 'cubie_wallshelf_p', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 7, '0'),
(2250, 4395, 'cubie_decal_0', 'cubie_decal_0', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2251, 4391, 'cubie_decal_3', 'cubie_decal_3', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2252, 4390, 'cubie_decal_1_p', 'cubie_decal_1_p', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2253, 4394, 'cubie_decklight_b', 'cubie_decklight_b', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2254, 4386, 'cubie_decal_1_b', 'cubie_decal_1_b', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2255, 4387, 'cubie_decal_2_b', 'cubie_decal_2_b', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2256, 4388, 'cubie_decal_3_p', 'cubie_decal_3_p', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2257, 4393, 'cubie_decal_2_p', 'cubie_decal_2_p', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2258, 4384, 'cubie_decal_3_b', 'cubie_decal_3_b', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2259, 3885, 'newbie_present', 'newbie_present', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(2260, 3886, 'tv_flat', 'tv_flat', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2261, 3887, 'waasa_table2', 'waasa_table2', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2262, 3888, 'computer_flatscreen', 'computer_flatscreen', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2263, 3889, 'waasa_chair', 'waasa_chair', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2264, 3890, 'waasa_ship2', 'waasa_ship2', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2265, 3891, 'waasa_ship1', 'waasa_ship1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2266, 3892, 'waasa_bunk_bed', 'waasa_bunk_bed', 's', 3, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2267, 3893, 'computer_laptop', 'computer_laptop', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2268, 3894, 'computer_old', 'computer_old', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2269, 3895, 'waasa_table1', 'waasa_table1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2270, 3896, 'waasa_desk', 'waasa_desk', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2271, 4396, 'waasa_wall_shelf2', 'waasa_wall_shelf2', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2272, 4397, 'waasa_wall_shelf1', 'waasa_wall_shelf1', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2273, 3830, 'nest_frog', 'nest_frog', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2274, 3831, 'pond', 'pond', 's', 1, 1, 0.01, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2275, 3832, 'val11_present', 'val11_present', 's', 1, 1, 1.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2276, 3833, 'prizetrophy_cine', 'prizetrophy_cine', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2277, 3834, 'cine_vipsign', 'cine_vipsign', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2278, 3835, 'limo_b_mid3', 'limo_b_mid3', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '50'),
(2279, 3836, 'limo_b_mid2', 'limo_b_mid2', 's', 2, 1, 0.30, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2280, 3837, 'limo_b_front', 'limo_b_front', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2281, 3838, 'limo_b_mid', 'limo_b_mid', 's', 2, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2282, 3839, 'cine_star', 'cine_star', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2283, 3840, 'limo_b_back', 'limo_b_back', 's', 2, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2284, 4381, 'ads_bigtv_missmix', 'ads_bigtv_missmix', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2285, 3841, 'cine_curtain', 'cine_curtain', 's', 8, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'gate', 2, '0'),
(2286, 3842, 'cine_screen', 'cine_screen', 's', 8, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 7, '0'),
(2287, 3843, 'theatre_seat_g', 'theatre_seat_g', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 6, '0'),
(2288, 3844, 'cine_tile', 'cine_tile', 's', 1, 1, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2289, 3845, 'cine_bench_b', 'cine_bench_b', 's', 3, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2290, 3846, 'theatre_seat_b', 'theatre_seat_b', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 6, '0'),
(2291, 3847, 'cine_roof', 'cine_roof', 's', 3, 3, 0.10, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(2292, 3848, 'cine_popcorn', 'cine_popcorn', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '62'),
(2293, 3849, 'cine_bench', 'cine_bench', 's', 3, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2294, 3850, 'cine_bench_g', 'cine_bench_g', 's', 3, 1, 1.10, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2295, 3851, 'cine_ticket_booth', 'cine_ticket_booth', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2296, 3852, 'cine_projector', 'cine_projector', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2297, 4380, 'gothic_st_glass', 'gothic_st_glass', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2298, 3825, 'gothic_candles', 'gothic_candles', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2299, 3824, 'gothic_bed', 'gothic_bed', 's', 2, 3, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2300, 3828, 'gothic_bowl', 'gothic_bowl', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 1, '62'),
(2301, 3826, 'gothic_desk', 'gothic_desk', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 5, '0'),
(2302, 3827, 'ads_grefu_trophy', 'ads_grefu_trophy', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 1, '0'),
(2303, 3801, 'bling11_block', 'bling11_block', 's', 1, 1, 2.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2304, 3793, 'bling11_dvd', 'bling11_dvd', 's', 1, 2, 1.60, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2305, 3798, 'bling11_dvn', 'bling11_dnv', 's', 1, 3, 1.20, 0, 0, 0, 1, 1, 1, 1, 1, 'bed', 1, '0'),
(2306, 3794, 'bling11_floor', 'bling11_floor', 's', 1, 1, 0.10, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 9, '0'),
(2307, 3802, 'bling11_pillar', 'bling11_pillar', 's', 1, 1, 3.30, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2308, 3795, 'bling11_plant', 'bling11_plant', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2309, 3788, 'bling11_rug1', 'bling11_rug1', 's', 2, 2, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2310, 3797, 'bling11_rug2', 'bling11_rug2', 's', 3, 3, 0.20, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2311, 3800, 'bling11_seat1', 'bling11_seat1', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2312, 3799, 'bling11_seat2', 'bling11_seat2', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 5, '0'),
(2313, 3786, 'bling11_slot', 'bling11_slot', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2314, 3790, 'bling11_sofa', 'bling11_sofa', 's', 3, 1, 0.40, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2315, 3791, 'bling11_statue1', 'bling11_statue1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2316, 3785, 'bling11_statue2', 'bling11_statue2', 's', 2, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2317, 3789, 'bling11_tele', 'bling11_tele', 's', 1, 1, 0.10, 0, 0, 0, 1, 1, 1, 1, 1, 'teleport', 1, '0'),
(2318, 3787, 'bling11_towels', 'bling11_towels', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2319, 3792, 'val11_floor', 'val11_floor', 's', 2, 2, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'normalskates', 1, '0'),
(2320, 3796, 'china_rabbit', 'china_rabbit', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2321, 3823, 'limo_w_front', 'limo_w_front', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2322, 3819, 'limo_w_mid', 'limo_w_mid', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2323, 3820, 'limo_w_mid2', 'limo_w_mid2', 's', 2, 1, 0.30, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2324, 3822, 'limo_w_back', 'limo_w_back', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2325, 3821, 'petfood19', 'petfood19', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2326, 3816, 'petfood18', 'petfood18', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2327, 3817, 'petfood17', 'petfood17', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2328, 3662, 'hween10_bat', 'hween10_bat', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2329, 4346, 'hween10_card_1', 'hween10_card_1', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2330, 4350, 'hween10_card_2', 'hween10_card_2', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2331, 4345, 'hween10_card_3', 'hween10_card_3', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2332, 4347, 'hween10_card_4', 'hween10_card_4', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2333, 4351, 'hween10_card_5', 'hween10_card_5', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2334, 4348, 'hween10_card_6', 'hween10_card_6', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2335, 3658, 'hween10_chicken', 'hween10_chicken', 's', 2, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2336, 3657, 'hween10_ffly', 'hween10_ffly', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0');
INSERT INTO `items_base` (`item_id`, `sprite_id`, `public_name`, `item_name`, `type`, `width`, `length`, `height`, `allow_stack`, `allow_walk`, `allow_sit`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `cycle_count`, `vending_ids`) VALUES
(2337, 3652, 'hween10_fog', 'hween10_fog', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2338, 3651, 'hween10_jar', 'hween10_jar', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2339, 3656, 'hween10_logs', 'hween10_logs', 's', 1, 1, 0.30, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2340, 3650, 'hween10_pond', 'hween10_pond', 's', 2, 2, 0.01, 1, 1, 0, 1, 1, 1, 1, 1, 'haloweenpool', 1, '0'),
(2341, 3661, 'hween10_portch', 'hween10_portch', 's', 1, 1, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 7, '0'),
(2342, 3654, 'hween10_skullpost', 'hween10_skullpost', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2343, 3649, 'hween10_swamp', 'hween10_swamp', 's', 2, 2, 0.01, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2344, 3646, 'hween10_tarot', 'hween10_tarot', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'dice', 7, '0'),
(2345, 3659, 'hween10_tele', 'hween10_tele', 's', 1, 1, 0.10, 1, 0, 0, 1, 1, 1, 1, 1, 'teleport', 2, '0'),
(2346, 3660, 'hween10_throne', 'hween10_throne', 's', 1, 1, 1.20, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2347, 3648, 'hween10_tree', 'hween10_tree', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2348, 3647, 'hween10_voodoo1', 'hween10_voodoo1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2349, 3653, 'hween10_voodoo2', 'hween10_voodoo2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2350, 3655, 'hween10_voodoo3', 'hween10_voodoo3', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2351, 4349, 'hween10_wallskull', 'hween10_wallskull', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2352, 3781, 'year2011_waver_b', 'year2011_waver_b', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2353, 3780, 'year2011_waver_g', 'year2011_waver_g', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2354, 3777, 'year2011_waver_r', 'year2011_waver_r', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2355, 3768, 'year2011_waver_y', 'year2011_waver_y', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2356, 3771, 'prizetrophy_2011_y', 'prizetrophy_2011_y', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 2, '0'),
(2357, 3773, 'prizetrophy_2011_b', 'prizetrophy_2011_b', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 2, '0'),
(2358, 3770, 'prizetrophy_2011_r', 'prizetrophy_2011_r', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 2, '0'),
(2359, 3775, 'prizetrophy_2011_p', 'prizetrophy_2011_p', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 2, '0'),
(2360, 3778, 'prizetrophy_2011_g', 'prizetrophy_2011_g', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 2, '0'),
(2361, 3769, 'prizetrophy_2011_w', 'prizetrophy_2011_w', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'trophy', 2, '0'),
(2362, 4373, 'year2011', 'year2011', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2363, 3742, 'qt_xm10_nest', 'qt_xm10_nest', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2364, 3746, 'qt_xm10_icedragon', 'qt_xm10_icedragon', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2365, 3747, 'qt_xm10_stone', 'qt_xm10_stone', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2366, 3728, 'qt_xm10_icetiger', 'qt_xm10_icetiger', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2367, 3722, 'qt_xm10_trex', 'qt_xm10_trex', 's', 3, 7, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2368, 3720, 'qt_xm10_palm_tree', 'qt_xm10_palm_tree', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2369, 3750, 'qt_xm10_bench', 'qt_xm10_bench', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2370, 3732, 'qt_xm10_icelupin', 'qt_xm10_icelupin', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2371, 3719, 'qt_xm10_xmduck', 'qt_xm10_xmduck', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2372, 3727, 'qt_xm10_iceduck', 'qt_xm10_iceduck', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2373, 4365, 'qt_xm10_bauble1', 'qt_xm10_bauble1', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2374, 4361, 'qt_xm10_bauble2', 'qt_xm10_bauble2', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2375, 4368, 'qt_xm10_bauble3', 'qt_xm10_bauble3', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2376, 3730, 'qt_xm10_iceplasto', 'qt_xm10_iceplasto', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2377, 3748, 'qt_xm10_ice_fish', 'qt_xm10_ice_fish', 's', 1, 2, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2378, 3726, 'qt_xm10_gnome', 'qt_xm10_gnome', 's', 1, 2, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2379, 3743, 'qt_xm10_icesilotable', 'qt_xm10_icesilotable', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2380, 3734, 'qt_xm10_iceteddy', 'qt_xm10_iceteddy', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2381, 3724, 'qt_xm10_elephant', 'qt_xm10_elephant', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'vendingmachine', 2, '0'),
(2382, 3718, 'qt_xm10_iceclubsofa', 'qt_xm10_iceclubsofa', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2383, 3736, 'es_skating_ice', 'es_skating_ice', 's', 2, 2, 0.01, 0, 1, 0, 1, 1, 1, 1, 1, 'iceskates', 2, '0'),
(2384, 3716, 'es_sidewalk', 'es_sidewalk', 's', 2, 2, 0.20, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2385, 3725, 'es_wpost', 'es_wpost', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2386, 3741, 'es_tagging', 'es_tagging', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2387, 3740, 'es_santa', 'es_santa', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2388, 4367, 'es_window', 'es_window', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2389, 3712, 'es_bench', 'es_bench', 's', 2, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2390, 3729, 'es_fnc_1', 'es_fnc_1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2391, 3714, 'es_fnc_2', 'es_fnc_2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2392, 3721, 'es_fnc_crnr', 'es_fnc_crnr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2393, 3723, 'es_epictree', 'es_epictree', 's', 2, 2, 4.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2394, 3731, 'es_icestar_g', 'es_icestar_g', 's', 1, 1, 6.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2395, 3745, 'es_icestar_r', 'es_icestar_r', 's', 1, 1, 6.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2396, 3749, 'es_icestar_y', 'es_icestar_y', 's', 1, 1, 6.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2397, 3713, 'es_icestar', 'es_icestar', 's', 1, 1, 6.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2398, 3739, 'es_puck', 'es_puck', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, '', 2, '0'),
(2399, 3738, 'es_roaster', 'es_roaster', 's', 1, 1, 2.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2400, 3735, 'es_lmppst', 'es_lmppst', 's', 1, 1, 4.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2401, 3717, 'es_statue', 'es_statue', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2402, 3704, 'exe_copier', 'exe_copier', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2403, 3706, 'exe_glassdvdr', 'exe_glassdvdr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2404, 3705, 'exe_wrkdesk', 'exe_wrkdesk', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2405, 3707, 'exe_seccam', 'exe_seccam', 's', 1, 1, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2406, 4356, 'exe_sensor', 'exe_sensor', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2407, 4371, 'es_big3', 'es_big3', 'i', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2408, 4372, 'es_big2', 'es_big2', 'i', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2409, 3758, 'Freeze Ice Block', 'es_box', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'freezetileblock', 1, '0'),
(2410, 3764, 'Freese Counter', 'es_counter', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'freezetimer', 1, '0'),
(2411, 3759, 'Exit Tile', 'es_exit', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'freezeexit', 1, '0'),
(2412, 3762, 'Blue Freeze Gate', 'es_gate_b', 's', 1, 1, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'freezebluegate', 1, '0'),
(2413, 3761, 'Green Freeze Gate', 'es_gate_g', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'freezegreengate', 1, '0'),
(2414, 3760, 'Red Freeze Gate', 'es_gate_r', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'freezeredgate', 1, '0'),
(2415, 3763, 'Yellow Freeze Gate', 'es_gate_y', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'freezeyellowgate', 1, '0'),
(2416, 3767, 'Yellow Freeze Scoreboard', 'es_score_y', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'freezeyellowcounter', 1, '0'),
(2417, 3765, 'Red Freeze Scoreboard', 'es_score_r', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'freezeredcounter', 1, '0'),
(2418, 3756, 'Blue Freeze Scoreboard', 'es_score_b', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'freezebluecounter', 1, '0'),
(2419, 3766, 'Green Freeze Scoreboard', 'es_score_g', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'freezegreencounter', 1, '0'),
(2420, 3757, 'Freeze Tile', 'es_tile', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'freezetile', 1, '0'),
(2421, 3853, 'wf_box', 'wf_box', 's', 1, 1, 1.20, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2422, 3854, 'wf_maze', 'wf_maze', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2423, 3855, 'ads_rangocactus', 'ads_rangocactus', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2424, 3856, 'cine_glass', 'cine_glass', 's', 1, 1, 0.01, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2425, 3857, 'wf_cnd_has_furni_on', 'wf_cnd_has_furni_on', 's', 1, 1, 0.60, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2426, 4382, 'cine_light2', 'cine_light2', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2427, 4383, 'cine_light1', 'cine_light1', 'i', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2428, 2431, 'a0 pet4', 'a0 pet4', 's', 1, 1, 0.00, 0, 0, 0, 0, 0, 0, 0, 0, 'pet4', 1, '0'),
(2429, 2430, 'a0 pet3', 'a0 pet3', 's', 1, 1, 0.00, 0, 0, 0, 0, 0, 0, 0, 0, 'pet3', 1, '0'),
(2430, 2434, 'a0 pet2', 'a0 pet2', 's', 1, 1, 0.00, 0, 0, 0, 0, 0, 0, 0, 0, 'pet2', 1, '0'),
(2431, 2432, 'a0 pet1', 'a0 pet1', 's', 1, 1, 0.00, 0, 0, 0, 0, 0, 0, 0, 0, 'pet1', 1, '0'),
(2432, 2433, 'a0 pet0', 'a0 pet0', 's', 1, 1, 0.00, 0, 0, 0, 0, 0, 0, 0, 0, 'pet0', 1, '0'),
(2433, 7457, 'a0 pet6', 'a0 pet6', 's', 1, 1, 0.00, 0, 0, 0, 0, 0, 0, 0, 0, 'pet6', 0, '0'),
(2434, 5354, 'a0 pet7', 'a0 pet7', 's', 1, 1, 0.00, 0, 0, 0, 0, 0, 0, 0, 0, 'pet7', 0, '0'),
(2435, 6489, 'a0 pet8', 'a0 pet8', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'pet8', 1, '0'),
(2436, 6490, 'a0 pet11', 'a0 pet11', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'pet11', 1, '0'),
(2437, 1532, 'a0 pet10', 'a0 pet10', 's', 0, 0, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'pet10', 1, '0'),
(2438, 3001, 'wallpaper_single_101', 'wallpaper_single_101', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2439, 3001, 'wallpaper_single_102', 'wallpaper_single_102', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2440, 3001, 'wallpaper_single_103', 'wallpaper_single_103', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2441, 3001, 'wallpaper_single_104', 'wallpaper_single_104', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2442, 3001, 'wallpaper_single_105', 'wallpaper_single_105', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2443, 3001, 'wallpaper_single_106', 'wallpaper_single_106', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2444, 3001, 'wallpaper_single_107', 'wallpaper_single_107', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2445, 3001, 'wallpaper_single_108', 'wallpaper_single_108', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2446, 3001, 'wallpaper_single_109', 'wallpaper_single_109', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2447, 3001, 'wallpaper_single_110', 'wallpaper_single_110', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2448, 3001, 'wallpaper_single_111', 'wallpaper_single_111', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2449, 3001, 'wallpaper_single_112', 'wallpaper_single_112', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2450, 3001, 'wallpaper_single_113', 'wallpaper_single_113', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2451, 3001, 'wallpaper_single_114', 'wallpaper_single_114', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2452, 3001, 'wallpaper_single_115', 'wallpaper_single_115', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2453, 3001, 'wallpaper_single_201', 'wallpaper_single_201', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2454, 3001, 'wallpaper_single_202', 'wallpaper_single_202', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2455, 3001, 'wallpaper_single_203', 'wallpaper_single_203', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2456, 3001, 'wallpaper_single_204', 'wallpaper_single_204', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2457, 3001, 'wallpaper_single_205', 'wallpaper_single_205', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2458, 3001, 'wallpaper_single_206', 'wallpaper_single_206', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2459, 3001, 'wallpaper_single_207', 'wallpaper_single_207', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2460, 3001, 'wallpaper_single_208', 'wallpaper_single_208', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2461, 3001, 'wallpaper_single_209', 'wallpaper_single_209', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2462, 3001, 'wallpaper_single_210', 'wallpaper_single_210', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2463, 3001, 'wallpaper_single_211', 'wallpaper_single_211', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2464, 3001, 'wallpaper_single_212', 'wallpaper_single_212', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2465, 3001, 'wallpaper_single_213', 'wallpaper_single_213', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2466, 3001, 'wallpaper_single_214', 'wallpaper_single_214', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2467, 3001, 'wallpaper_single_215', 'wallpaper_single_215', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2468, 3001, 'wallpaper_single_216', 'wallpaper_single_216', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2469, 3001, 'wallpaper_single_217', 'wallpaper_single_217', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2470, 3001, 'wallpaper_single_218', 'wallpaper_single_218', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2471, 3001, 'wallpaper_single_301', 'wallpaper_single_301', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2472, 3001, 'wallpaper_single_302', 'wallpaper_single_302', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2473, 3001, 'wallpaper_single_303', 'wallpaper_single_303', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2474, 3001, 'wallpaper_single_304', 'wallpaper_single_304', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2475, 3001, 'wallpaper_single_305', 'wallpaper_single_305', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2476, 3001, 'wallpaper_single_306', 'wallpaper_single_306', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2477, 3001, 'wallpaper_single_307', 'wallpaper_single_307', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2478, 3001, 'wallpaper_single_401', 'wallpaper_single_401', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2479, 3001, 'wallpaper_single_402', 'wallpaper_single_402', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2480, 3001, 'wallpaper_single_403', 'wallpaper_single_403', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2481, 3001, 'wallpaper_single_404', 'wallpaper_single_404', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2482, 3001, 'wallpaper_single_405', 'wallpaper_single_405', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2483, 3001, 'wallpaper_single_406', 'wallpaper_single_406', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2484, 3001, 'wallpaper_single_407', 'wallpaper_single_407', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2485, 3001, 'wallpaper_single_408', 'wallpaper_single_408', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2486, 3001, 'wallpaper_single_501', 'wallpaper_single_501', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2487, 3001, 'wallpaper_single_502', 'wallpaper_single_502', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2488, 3001, 'wallpaper_single_503', 'wallpaper_single_503', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2489, 3001, 'wallpaper_single_504', 'wallpaper_single_504', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2490, 3001, 'wallpaper_single_505', 'wallpaper_single_505', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2491, 3001, 'wallpaper_single_506', 'wallpaper_single_506', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2492, 3001, 'wallpaper_single_507', 'wallpaper_single_507', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2493, 3001, 'wallpaper_single_508', 'wallpaper_single_508', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2494, 3001, 'wallpaper_single_601', 'wallpaper_single_601', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2495, 3001, 'wallpaper_single_602', 'wallpaper_single_602', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2496, 3001, 'wallpaper_single_603', 'wallpaper_single_603', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2497, 3001, 'wallpaper_single_604', 'wallpaper_single_604', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2498, 3001, 'wallpaper_single_605', 'wallpaper_single_605', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2499, 3001, 'wallpaper_single_606', 'wallpaper_single_606', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2500, 3001, 'wallpaper_single_607', 'wallpaper_single_607', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2501, 3001, 'wallpaper_single_608', 'wallpaper_single_608', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2502, 3001, 'wallpaper_single_609', 'wallpaper_single_609', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2503, 3001, 'wallpaper_single_610', 'wallpaper_single_610', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2504, 3001, 'wallpaper_single_701', 'wallpaper_single_701', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2505, 3001, 'wallpaper_single_702', 'wallpaper_single_702', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2506, 3001, 'wallpaper_single_703', 'wallpaper_single_703', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2507, 3001, 'wallpaper_single_704', 'wallpaper_single_704', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2508, 3001, 'wallpaper_single_705', 'wallpaper_single_705', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2509, 3001, 'wallpaper_single_706', 'wallpaper_single_706', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2510, 3001, 'wallpaper_single_707', 'wallpaper_single_707', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2511, 3001, 'wallpaper_single_708', 'wallpaper_single_708', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2512, 3001, 'wallpaper_single_709', 'wallpaper_single_709', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2513, 3001, 'wallpaper_single_710', 'wallpaper_single_710', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2514, 3001, 'wallpaper_single_801', 'wallpaper_single_801', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2515, 3001, 'wallpaper_single_802', 'wallpaper_single_802', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2516, 3001, 'wallpaper_single_803', 'wallpaper_single_803', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2517, 3001, 'wallpaper_single_804', 'wallpaper_single_804', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2518, 3001, 'wallpaper_single_805', 'wallpaper_single_805', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2519, 3001, 'wallpaper_single_806', 'wallpaper_single_806', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2520, 3001, 'wallpaper_single_807', 'wallpaper_single_807', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2521, 3001, 'wallpaper_single_808', 'wallpaper_single_808', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2522, 3001, 'wallpaper_single_809', 'wallpaper_single_809', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2523, 3001, 'wallpaper_single_810', 'wallpaper_single_810', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2524, 3001, 'wallpaper_single_901', 'wallpaper_single_901', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2525, 3001, 'wallpaper_single_902', 'wallpaper_single_902', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2526, 3001, 'wallpaper_single_903', 'wallpaper_single_903', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2527, 3001, 'wallpaper_single_904', 'wallpaper_single_904', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2528, 3001, 'wallpaper_single_905', 'wallpaper_single_905', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2529, 3001, 'wallpaper_single_906', 'wallpaper_single_906', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2530, 3001, 'wallpaper_single_907', 'wallpaper_single_907', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2531, 3001, 'wallpaper_single_908', 'wallpaper_single_908', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2532, 3001, 'wallpaper_single_1001', 'wallpaper_single_1001', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2533, 3001, 'wallpaper_single_1002', 'wallpaper_single_1002', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2534, 3001, 'wallpaper_single_1003', 'wallpaper_single_1003', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2535, 3001, 'wallpaper_single_1004', 'wallpaper_single_1004', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2536, 3001, 'wallpaper_single_1005', 'wallpaper_single_1005', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2537, 3001, 'wallpaper_single_1006', 'wallpaper_single_1006', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2538, 3001, 'wallpaper_single_1007', 'wallpaper_single_1007', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2539, 3001, 'wallpaper_single_1101', 'wallpaper_single_1101', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2540, 3001, 'wallpaper_single_1201', 'wallpaper_single_1201', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2541, 3001, 'wallpaper_single_1301', 'wallpaper_single_1301', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2542, 3001, 'wallpaper_single_1401', 'wallpaper_single_1401', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2543, 3001, 'wallpaper_single_1501', 'wallpaper_single_1501', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2544, 3001, 'wallpaper_single_1601', 'wallpaper_single_1601', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2545, 3001, 'wallpaper_single_1701', 'wallpaper_single_1701', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2546, 3001, 'wallpaper_single_1801', 'wallpaper_single_1801', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2547, 3001, 'wallpaper_single_1901', 'wallpaper_single_1901', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2548, 3001, 'wallpaper_single_1902', 'wallpaper_single_1902', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2549, 3001, 'wallpaper_single_2001', 'wallpaper_single_2001', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2550, 3001, 'wallpaper_single_2002', 'wallpaper_single_2002', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2551, 3001, 'wallpaper_single_2003', 'wallpaper_single_2003', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2552, 3001, 'wallpaper_single_2101', 'wallpaper_single_2101', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2553, 3001, 'wallpaper_single_2102', 'wallpaper_single_2102', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2554, 3001, 'wallpaper_single_2103', 'wallpaper_single_2103', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2555, 3001, 'wallpaper_single_2201', 'wallpaper_single_2201', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2556, 3001, 'wallpaper_single_2202', 'wallpaper_single_2202', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2557, 3001, 'wallpaper_single_2203', 'wallpaper_single_2203', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2558, 3001, 'wallpaper_single_2204', 'wallpaper_single_2204', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2559, 3001, 'wallpaper_single_2205', 'wallpaper_single_2205', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2560, 3001, 'wallpaper_single_2206', 'wallpaper_single_2206', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2561, 3001, 'wallpaper_single_2301', 'wallpaper_single_2301', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2562, 3001, 'wallpaper_single_2302', 'wallpaper_single_2302', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2563, 3001, 'wallpaper_single_2303', 'wallpaper_single_2303', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2564, 3001, 'wallpaper_single_2304', 'wallpaper_single_2304', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2565, 3001, 'wallpaper_single_2401', 'wallpaper_single_2401', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2566, 3001, 'wallpaper_single_2402', 'wallpaper_single_2402', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2567, 3001, 'wallpaper_single_2403', 'wallpaper_single_2403', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2568, 3001, 'wallpaper_single_2501', 'wallpaper_single_2501', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2569, 3001, 'wallpaper_single_2502', 'wallpaper_single_2502', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2570, 3001, 'wallpaper_single_2503', 'wallpaper_single_2503', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2571, 3001, 'wallpaper_single_2504', 'wallpaper_single_2504', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2572, 3001, 'wallpaper_single_2601', 'wallpaper_single_2601', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2573, 3001, 'wallpaper_single_2602', 'wallpaper_single_2602', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2574, 3001, 'wallpaper_single_2603', 'wallpaper_single_2603', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2575, 3001, 'wallpaper_single_2604', 'wallpaper_single_2604', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2576, 3001, 'wallpaper_single_2701', 'wallpaper_single_2701', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2577, 3001, 'wallpaper_single_2702', 'wallpaper_single_2702', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2578, 3001, 'wallpaper_single_2703', 'wallpaper_single_2703', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2579, 3001, 'wallpaper_single_2704', 'wallpaper_single_2704', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2580, 3001, 'wallpaper_single_2801', 'wallpaper_single_2801', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2581, 3001, 'wallpaper_single_2802', 'wallpaper_single_2802', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2582, 3001, 'wallpaper_single_2803', 'wallpaper_single_2803', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2583, 3001, 'wallpaper_single_2804', 'wallpaper_single_2804', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2584, 3001, 'wallpaper_single_2901', 'wallpaper_single_2901', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2585, 3001, 'wallpaper_single_2902', 'wallpaper_single_2902', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2586, 3001, 'wallpaper_single_2903', 'wallpaper_single_2903', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2587, 3001, 'wallpaper_single_2904', 'wallpaper_single_2904', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2588, 3001, 'wallpaper_single_3001', 'wallpaper_single_3001', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2589, 3001, 'wallpaper_single_3002', 'wallpaper_single_3002', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2590, 3001, 'wallpaper_single_3003', 'wallpaper_single_3003', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2591, 3001, 'wallpaper_single_3004', 'wallpaper_single_3004', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2592, 3001, 'wallpaper_single_3101', 'wallpaper_single_3101', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2593, 3001, 'wallpaper_single_3102', 'wallpaper_single_3102', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2594, 3001, 'wallpaper_single_3103', 'wallpaper_single_3103', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2595, 3001, 'wallpaper_single_3104', 'wallpaper_single_3104', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2596, 3001, 'wallpaper_single_3105', 'wallpaper_single_3105', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2597, 3001, 'wallpaper_single_3106', 'wallpaper_single_3106', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2598, 2001, 'floor_single_101', 'floor_single_101', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2599, 2001, 'floor_single_102', 'floor_single_102', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2600, 2001, 'floor_single_103', 'floor_single_103', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2601, 2001, 'floor_single_104', 'floor_single_104', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2602, 2001, 'floor_single_105', 'floor_single_105', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2603, 2001, 'floor_single_106', 'floor_single_106', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2604, 2001, 'floor_single_107', 'floor_single_107', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2605, 2001, 'floor_single_108', 'floor_single_108', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2606, 2001, 'floor_single_109', 'floor_single_109', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2607, 2001, 'floor_single_110', 'floor_single_110', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2608, 2001, 'floor_single_111', 'floor_single_111', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2609, 2001, 'floor_single_201', 'floor_single_201', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2610, 2001, 'floor_single_202', 'floor_single_202', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2611, 2001, 'floor_single_203', 'floor_single_203', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2612, 2001, 'floor_single_204', 'floor_single_204', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2613, 2001, 'floor_single_205', 'floor_single_205', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2614, 2001, 'floor_single_206', 'floor_single_206', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2615, 2001, 'floor_single_207', 'floor_single_207', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2616, 2001, 'floor_single_208', 'floor_single_208', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2617, 2001, 'floor_single_209', 'floor_single_209', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2618, 2001, 'floor_single_210', 'floor_single_210', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2619, 2001, 'floor_single_211', 'floor_single_211', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2620, 2001, 'floor_single_212', 'floor_single_212', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2621, 2001, 'floor_single_301', 'floor_single_301', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2622, 2001, 'floor_single_302', 'floor_single_302', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2623, 2001, 'floor_single_303', 'floor_single_303', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2624, 2001, 'floor_single_304', 'floor_single_304', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2625, 2001, 'floor_single_305', 'floor_single_305', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2626, 2001, 'floor_single_306', 'floor_single_306', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2627, 2001, 'floor_single_307', 'floor_single_307', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2628, 2001, 'floor_single_401', 'floor_single_401', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2629, 2001, 'floor_single_402', 'floor_single_402', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2630, 2001, 'floor_single_403', 'floor_single_403', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2631, 2001, 'floor_single_404', 'floor_single_404', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2632, 2001, 'floor_single_405', 'floor_single_405', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2633, 2001, 'floor_single_406', 'floor_single_406', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2634, 2001, 'floor_single_407', 'floor_single_407', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2635, 2001, 'floor_single_408', 'floor_single_408', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2636, 2001, 'floor_single_409', 'floor_single_409', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2637, 2001, 'floor_single_501', 'floor_single_501', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2638, 2001, 'floor_single_502', 'floor_single_502', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2639, 2001, 'floor_single_503', 'floor_single_503', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2640, 2001, 'floor_single_504', 'floor_single_504', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2641, 2001, 'floor_single_505', 'floor_single_505', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2642, 2001, 'floor_single_506', 'floor_single_506', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2643, 2001, 'floor_single_507', 'floor_single_507', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2644, 2001, 'floor_single_601', 'floor_single_601', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2645, 2001, 'floor_single_602', 'floor_single_602', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2646, 2001, 'floor_single_603', 'floor_single_603', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2647, 2001, 'floor_single_604', 'floor_single_604', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2648, 2001, 'floor_single_605', 'floor_single_605', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2649, 2001, 'floor_single_606', 'floor_single_606', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2650, 2001, 'floor_single_607', 'floor_single_607', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2651, 2001, 'floor_single_608', 'floor_single_608', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2652, 2001, 'floor_single_609', 'floor_single_609', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2653, 2001, 'floor_single_610', 'floor_single_610', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2654, 4055, 'landscape_single_1.1', 'landscape_single_1.1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2655, 4055, 'landscape_single_1.2', 'landscape_single_1.2', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2656, 4055, 'landscape_single_1.3', 'landscape_single_1.3', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2657, 4055, 'landscape_single_1.4', 'landscape_single_1.4', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2658, 4055, 'landscape_single_1.5', 'landscape_single_1.5', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2659, 4055, 'landscape_single_1.6', 'landscape_single_1.6', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2660, 4055, 'landscape_single_1.7', 'landscape_single_1.7', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2661, 4055, 'landscape_single_1.8', 'landscape_single_1.8', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2662, 4055, 'landscape_single_1.9', 'landscape_single_1.9', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2663, 4055, 'landscape_single_1.10', 'landscape_single_1.10', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2664, 4055, 'landscape_single_1.11', 'landscape_single_1.11', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2665, 4055, 'landscape_single_2.1', 'landscape_single_2.1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2666, 4055, 'landscape_single_2.3', 'landscape_single_2.3', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2667, 4055, 'landscape_single_2.4', 'landscape_single_2.4', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2668, 4055, 'landscape_single_2.5', 'landscape_single_2.5', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2669, 4055, 'landscape_single_2.6', 'landscape_single_2.6', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2670, 4055, 'landscape_single_2.7', 'landscape_single_2.7', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2671, 4055, 'landscape_single_3.1', 'landscape_single_3.1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2672, 4055, 'landscape_single_3.3', 'landscape_single_3.3', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2673, 4055, 'landscape_single_3.4', 'landscape_single_3.4', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2674, 4055, 'landscape_single_3.5', 'landscape_single_3.5', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2675, 4055, 'landscape_single_3.6', 'landscape_single_3.6', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2676, 4055, 'landscape_single_3.7', 'landscape_single_3.7', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2677, 4055, 'landscape_single_4.1', 'landscape_single_4.1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2678, 4055, 'landscape_single_4.3', 'landscape_single_4.3', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2679, 4055, 'landscape_single_4.4', 'landscape_single_4.4', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2680, 4055, 'landscape_single_4.5', 'landscape_single_4.5', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2681, 4055, 'landscape_single_4.6', 'landscape_single_4.6', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2682, 4055, 'landscape_single_4.7', 'landscape_single_4.7', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2683, 4055, 'landscape_single_5.1', 'landscape_single_5.1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2684, 4055, 'landscape_single_5.3', 'landscape_single_5.3', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2685, 4055, 'landscape_single_5.4', 'landscape_single_5.4', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2686, 4055, 'landscape_single_5.5', 'landscape_single_5.5', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2687, 4055, 'landscape_single_5.6', 'landscape_single_5.6', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2688, 4055, 'landscape_single_5.7', 'landscape_single_5.7', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2689, 4055, 'landscape_single_6.1', 'landscape_single_6.1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2690, 4055, 'landscape_single_6.3', 'landscape_single_6.3', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2691, 4055, 'landscape_single_6.4', 'landscape_single_6.4', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2692, 4055, 'landscape_single_6.5', 'landscape_single_6.5', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2693, 4055, 'landscape_single_6.6', 'landscape_single_6.6', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2694, 4055, 'landscape_single_6.7', 'landscape_single_6.7', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2695, 4055, 'landscape_single_7.1', 'landscape_single_7.1', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2696, 4055, 'landscape_single_7.3', 'landscape_single_7.3', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2697, 4055, 'landscape_single_7.4', 'landscape_single_7.4', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2698, 4055, 'landscape_single_7.5', 'landscape_single_7.5', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2699, 4055, 'landscape_single_7.6', 'landscape_single_7.6', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2700, 4055, 'landscape_single_7.7', 'landscape_single_7.7', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2701, 4055, 'landscape_single_7.12', 'landscape_single_7.12', 'i', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 0, 'default', 1, '0'),
(2702, 6491, 'a0 pet12', 'a0 pet12', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'pet12', 1, '0'),
(2703, 4342, 'bb_painimies2', 'bb_painimies2', 'i', 1, 1, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2704, 3615, 'bb_score_b', 'bb_score_b', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'banzaiscoreblue', 2, '0'),
(2705, 3616, 'bb_robo', 'bb_robo', 's', 2, 2, 2.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2706, 3617, 'bb_dragon', 'bb_dragon', 's', 3, 1, 2.50, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2707, 3618, 'bb_ducklight', 'bb_ducklight', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 8, '0'),
(2708, 3619, 'bb_caterhead', 'bb_caterhead', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2709, 3620, 'bb_cargobox', 'bb_cargobox', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2710, 3621, 'bb_gate_g', 'bb_gate_g', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'banzaigategreen', 2, '0'),
(2711, 3622, 'bb_crchair3', 'bb_crchair3', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2712, 3623, 'bb_score_g', 'bb_score_g', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'banzaiscoregreen', 1, '0'),
(2713, 3624, 'bb_crchair', 'bb_crchair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2714, 3625, 'bb_crchair2', 'bb_crchair2', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2715, 3626, 'bb_score_y', 'bb_score_y', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'banzaiscoreyellow', 2, '0'),
(2716, 3627, 'bb_knj1', 'bb_knj1', 's', 2, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2717, 3628, 'bb_gate_r', 'bb_gate_r', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'banzaigatered', 2, '0'),
(2718, 3629, 'bb_tddhnd', 'bb_tddhnd', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2719, 3630, 'bb_lightdiv', 'bb_lightdiv', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 8, '0'),
(2720, 3631, 'bb_tddhead', 'bb_tddhead', 's', 2, 2, 2.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2721, 3632, 'bb_pyramid', 'bb_pyramid', 's', 1, 1, 0.00, 1, 0, 0, 1, 1, 1, 1, 1, 'banzaipyramid', 3, '0'),
(2722, 3633, 'bb_patch1', 'bb_patch1', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'banzaifloor', 4, '0'),
(2723, 3634, 'bb_fnc3', 'bb_fnc3', 's', 1, 3, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2724, 3635, 'bb_gate_y', 'bb_gate_y', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'banzaigateyellow', 1, '0'),
(2725, 3637, 'bb_apparatus', 'bb_apparatus', 's', 2, 2, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 8, '0'),
(2726, 3638, 'bb_caterbody', 'bb_caterbody', 's', 1, 1, 1.70, 1, 0, 1, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2727, 3639, 'bb_knj2', 'bb_knj2', 's', 1, 1, 2.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 4, '0'),
(2728, 3640, 'bb_fnc1', 'bb_fnc1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 2, '0'),
(2729, 3641, 'bb_puck', 'bb_puck', 's', 1, 1, 0.60, 1, 0, 0, 1, 1, 1, 1, 1, 'banzaipuck', 3, '0'),
(2730, 3642, 'bb_rnd_tele', 'bb_rnd_tele', 's', 1, 1, 0.30, 0, 1, 0, 1, 1, 1, 1, 1, 'banzaitele', 1, '0'),
(2731, 3643, 'bb_gate_b', 'bb_gate_b', 's', 1, 1, 0.00, 0, 1, 0, 1, 1, 1, 1, 1, 'banzaigateblue', 1, '0'),
(2732, 3644, 'bb_score_r', 'bb_score_r', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'banzaiscorered', 2, '0'),
(2733, 4341, 'bb_painimies1', 'bb_painimies1', 'i', 1, 1, 1.00, 0, 1, 0, 1, 1, 1, 1, 1, 'default', 3, '0'),
(2734, 3614, 'bb_crnr', 'bb_crnr', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2735, 3645, 'bb_counter', 'bb_counter', 's', 1, 4, 0.10, 0, 0, 0, 1, 1, 0, 1, 1, 'banzaicounter', 1, '0'),
(2736, 2607, 'song_disk', 'song_disk', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'musicdisc', 1, '0'),
(2737, 3679, 'wf_trg_at_given_time', 'wf_trg_at_given_time', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggertimer', 4, '0'),
(2738, 3683, 'wf_trg_enter_room', 'wf_trg_enter_room', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggerroomenter', 4, '0'),
(2739, 3680, 'wf_trg_game_ends', 'wf_trg_game_ends', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggergameend', 5, '0'),
(2740, 3702, 'wf_trg_game_starts', 'wf_trg_game_starts', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggergamestart', 5, '0'),
(2741, 3671, 'wf_trg_periodically', 'wf_trg_periodically', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggerrepeater', 4, '0'),
(2742, 3675, 'wf_trg_says_something', 'wf_trg_says_something', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggeronusersay', 4, '0'),
(2743, 3673, 'wf_trg_score_achieved', 'wf_trg_score_achieved', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggerscoreachieved', 4, '0'),
(2744, 3668, 'wf_trg_state_changed', 'wf_trg_state_changed', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggerstatechanged', 4, '0'),
(2745, 3678, 'wf_trg_walks_off_furni', 'wf_trg_walks_off_furni', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggerwalkofffurni', 4, '0'),
(2746, 3703, 'wf_trg_walks_on_furni', 'wf_trg_walks_on_furni', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'triggerwalkonfurni', 4, '0'),
(2747, 3697, 'wf_act_give_score', 'wf_act_give_score', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'actiongivescore', 5, '0'),
(2748, 3700, 'wf_act_match_to_sshot', 'wf_act_match_to_sshot', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'actionposreset', 4, '0'),
(2749, 3663, 'wf_act_move_rotate', 'wf_act_move_rotate', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'actionmoverotate', 4, '0'),
(2750, 3691, 'wf_act_reset_timers', 'wf_act_reset_timers', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'actionresettimer', 4, '0'),
(2751, 3681, 'wf_act_show_message', 'wf_act_show_message', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'actionshowmessage', 4, '0'),
(2752, 3674, 'wf_act_teleport_to', 'wf_act_teleport_to', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'actionteleportto', 1, '0'),
(2753, 3685, 'wf_act_toggle_state', 'wf_act_toggle_state', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'actiontogglestate', 4, '0'),
(2754, 3692, 'wf_cnd_furnis_hv_avtrs', 'wf_cnd_furnis_hv_avtrs', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'conditionfurnishaveusers', 4, '0'),
(2755, 3695, 'wf_cnd_match_snapshot', 'wf_cnd_match_snapshot', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'conditionstatepos', 4, '0'),
(2756, 3682, 'wf_cnd_time_less_than', 'wf_cnd_time_less_than', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'conditiontimelessthan', 4, '0'),
(2757, 3665, 'wf_cnd_time_more_than', 'wf_cnd_time_more_than', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'conditiontimemorethan', 4, '0'),
(2758, 3694, 'wf_cnd_trggrer_on_frn', 'wf_cnd_trggrer_on_frn', 's', 1, 1, 0.50, 1, 0, 0, 1, 1, 1, 1, 1, 'conditiontriggeronfurni', 4, '0'),
(2759, 3693, 'wf_arrowplate', 'wf_arrowplate', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'arrowplate', 4, '0'),
(2760, 3688, 'wf_pressureplate', 'wf_pressureplate', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'preassureplate', 2, '0'),
(2761, 3687, 'wf_ringplate', 'wf_ringplate', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'ringplate', 2, '0'),
(2762, 3666, 'wf_colortile', 'wf_colortile', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'colortile', 10, '0'),
(2763, 3676, 'wf_colorwheel', 'wf_colorwheel', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'colorwheel', 10, '0'),
(2764, 3701, 'wf_floor_switch1', 'wf_floor_switch1', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'floorswitch1', 2, '0'),
(2765, 3667, 'wf_floor_switch2', 'wf_floor_switch2', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'floorswitch2', 5, '0'),
(2766, 3686, 'wf_firegate', 'wf_firegate', 's', 1, 1, 0.00, 1, 1, 0, 1, 1, 1, 1, 1, 'firegate', 2, '0'),
(2767, 3699, 'wf_glassdoor', 'wf_glassdoor', 's', 1, 1, 0.10, 1, 0, 0, 1, 1, 1, 1, 1, 'gate', 1, '0'),
(2768, 3669, 'wf_xtra_random', 'wf_xtra_random', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'specialrandom', 4, '0'),
(2769, 3670, 'wf_xtra_unseen', 'wf_xtra_unseen', 's', 1, 1, 0.50, 1, 1, 0, 1, 1, 1, 1, 1, 'specialunseen', 4, '0');
INSERT INTO `items_base` (`item_id`, `sprite_id`, `public_name`, `item_name`, `type`, `width`, `length`, `height`, `allow_stack`, `allow_walk`, `allow_sit`, `allow_recycle`, `allow_trade`, `allow_marketplace_sell`, `allow_gift`, `allow_inventory_stack`, `interaction_type`, `cycle_count`, `vending_ids`) VALUES
(2770, 3696, 'wf_wire1', 'wf_wire1', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'wireStandard', 2, '0'),
(2771, 3664, 'wf_wire2', 'wf_wire2', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'wireCenter', 2, '0'),
(2772, 3698, 'wf_wire3', 'wf_wire3', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'wireCorner', 2, '0'),
(2773, 3677, 'wf_wire4', 'wf_wire4', 's', 1, 1, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'wireSplitter', 2, '0'),
(2774, 4018, 'qt_sum11_ictrolley', 'qt_sum11_ictrolley', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2775, 4022, 'qt_sum11_platfrm', 'qt_sum11_platfrm', 's', 2, 2, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2776, 4021, 'qt_sum11_shell3', 'qt_sum11_shell3', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2777, 4023, 'qt_sum11_shell2', 'qt_sum11_shell2', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2778, 4025, 'qt_sum11_chair', 'qt_sum11_chair', 's', 1, 1, 1.00, 0, 0, 1, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2779, 4020, 'qt_sum11_shell4', 'qt_sum11_shell4', 's', 1, 1, 1.00, 1, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2780, 4017, 'qt_sum11_shell1', 'qt_sum11_shell1', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2781, 4024, 'qt_sum11_shell5', 'qt_sum11_shell5', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2782, 4019, 'qt_sum11_petfood', 'qt_sum11_petfood', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2783, 4070, 'petfood25', 'petfood25', 's', 1, 1, 0.20, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2784, 4068, 'lm_bananadrink', 'lm_bananadrink', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2785, 4067, 'lm_crystal_skull', 'lm_crystal_skull', 's', 1, 1, 0.20, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2786, 4073, 'lm_jackbox', 'lm_jackbox', 's', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2787, 4075, 'ads_durex_carpet', 'ads_durex_carpet', 's', 2, 3, 0.10, 1, 1, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2788, 4410, 'ads_durex_screen', 'ads_durex_screen', 'i', 1, 1, 1.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2789, 4074, 'ads_durex_vend', 'ads_durex_vend', 's', 1, 1, 3.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2790, 2124013, 'Sand Dragon', 'qt_sum11_dragon', 's', 1, 1, 0.00, 0, 0, 0, 1, 1, 1, 1, 1, 'default', 1, '0'),
(2791, 14, 'HabMoon Aapje', 'a0 pet14', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 1, 'pet14', 1, '0'),
(2792, 14, 'Turtels', 'a0 pet9', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 1, 'pet9', 1, '0'),
(2793, 14, 'Horse', 'a0 pet15', 's', 1, 1, 1.00, 0, 0, 0, 0, 0, 0, 0, 1, 'pet15', 1, '0'),
(2794, 3372, 'present_wrap*1', 'Caja Regalo 1', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2795, 3373, 'present_wrap*10', 'Caja Regalo 10', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2796, 3374, 'present_wrap*2', 'Caja Regalo 2', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2797, 3375, 'present_wrap*3', 'Caja Regalo 3', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2798, 3376, 'present_wrap*4', 'Caja Regalo 4', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2799, 3377, 'present_wrap*5', 'Caja Regalo 5', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2800, 3378, 'present_wrap*6', 'Caja Regalo 6', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2801, 3379, 'present_wrap*7', 'Caja Regalo 7', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2802, 3380, 'present_wrap*8', 'Caja Regalo 8', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2803, 3381, 'present_wrap*9', 'Caja Regalo 9', 's', 0, 1, 1.00, 1, 0, 0, 0, 0, 0, 0, 1, 'gift', 0, ''),
(2804, 4221, 'Horse Saddle', 'horse_saddle', 's', 1, 1, 1.00, 0, 0, 0, 0, 1, 1, 1, 1, 'saddle', 0, '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_base_gifts`
--

CREATE TABLE IF NOT EXISTS `items_base_gifts` (
  `baseid` int(10) unsigned NOT NULL,
  PRIMARY KEY (`baseid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `items_base_gifts`
--

INSERT INTO `items_base_gifts` (`baseid`) VALUES
(161),
(162),
(163),
(164),
(165),
(166),
(167);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_extradata`
--

CREATE TABLE IF NOT EXISTS `items_extradata` (
  `item_id` int(10) unsigned NOT NULL,
  `data` varchar(45) NOT NULL,
  PRIMARY KEY (`item_id`),
  UNIQUE KEY `item_id_UNIQUE` (`item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `items_extradata`
--

INSERT INTO `items_extradata` (`item_id`, `data`) VALUES
(8, ''),
(9, ''),
(12, '0'),
(13, '1'),
(14, ''),
(15, ''),
(16, '70;perra00'),
(17, '70;weee00'),
(19, '0'),
(20, '0'),
(21, ''),
(22, '0'),
(23, '0'),
(25, '70;Desc21'),
(27, '70;Regalinho Itachi00'),
(28, '0'),
(29, '0'),
(30, '0'),
(31, '0'),
(32, ''),
(33, ''),
(34, '60'),
(35, ''),
(36, ''),
(37, ''),
(38, '0'),
(39, '0'),
(40, ''),
(41, ''),
(42, ''),
(43, ''),
(44, ''),
(45, ''),
(46, '0'),
(47, '0'),
(48, '0'),
(49, ''),
(50, ''),
(51, ''),
(52, ''),
(53, ''),
(54, ''),
(55, ''),
(56, ''),
(76, '0'),
(77, '0'),
(78, '0'),
(80, '0'),
(81, '0'),
(86, 'Fakundo	23-7-2012	teeeeeeeeeeeeeeeeeeeeeeeeee'),
(99, '0');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_gifts`
--

CREATE TABLE IF NOT EXISTS `items_gifts` (
  `item_id` int(10) unsigned NOT NULL DEFAULT '0',
  `gift_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`item_id`,`gift_id`),
  UNIQUE KEY `item_id` (`item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_moodlight`
--

CREATE TABLE IF NOT EXISTS `items_moodlight` (
  `item_id` int(10) unsigned NOT NULL,
  `enabled` enum('0','1') NOT NULL DEFAULT '0',
  `current_preset` int(11) NOT NULL,
  `preset_one` text NOT NULL,
  `preset_two` text NOT NULL,
  `preset_three` text NOT NULL,
  PRIMARY KEY (`item_id`),
  KEY `item_id` (`item_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_rooms`
--

CREATE TABLE IF NOT EXISTS `items_rooms` (
  `item_id` int(10) unsigned NOT NULL,
  `room_id` int(10) unsigned NOT NULL,
  `x` decimal(4,2) NOT NULL COMMENT 'Holds data XX,YY for floor items, and width XX,YY for wall items',
  `y` decimal(4,2) NOT NULL COMMENT 'Holds data ZZ,ZZ for floor items (height), and length XX,YY for wall items	',
  `n` tinyint(2) NOT NULL COMMENT '0-6: Regular rotation for floor items, 7: left, 8: right for wall items',
  PRIMARY KEY (`item_id`),
  UNIQUE KEY `item_id_UNIQUE` (`item_id`),
  KEY `room_id` (`room_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `items_rooms`
--

INSERT INTO `items_rooms` (`item_id`, `room_id`, `x`, `y`, `n`) VALUES
(36, 67, 10.05, 0.00, 0),
(87, 84, 4.05, 0.00, 0),
(88, 84, 9.11, 0.00, 0),
(89, 84, 4.13, 0.00, 0),
(90, 84, 9.02, 0.00, 0),
(91, 84, 4.09, 0.00, 0),
(92, 84, 10.08, 0.00, 0),
(93, 84, 7.07, 0.00, 0),
(94, 84, 5.03, 0.00, 0),
(95, 84, 11.04, 0.00, 0),
(97, 82, 6.03, 0.00, 2),
(99, 78, 4.03, 0.00, 2);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_rooms_songs`
--

CREATE TABLE IF NOT EXISTS `items_rooms_songs` (
  `itemid` int(10) unsigned NOT NULL,
  `roomid` int(10) unsigned NOT NULL,
  `songid` int(11) NOT NULL,
  PRIMARY KEY (`itemid`,`roomid`),
  KEY `itemid` (`itemid`),
  KEY `roomid` (`roomid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_tele_links`
--

CREATE TABLE IF NOT EXISTS `items_tele_links` (
  `tele_one_id` int(10) unsigned NOT NULL,
  `tele_two_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`tele_one_id`,`tele_two_id`),
  UNIQUE KEY `tele_one_id` (`tele_one_id`) USING BTREE,
  UNIQUE KEY `tele_two_id` (`tele_two_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `items_tele_links`
--

INSERT INTO `items_tele_links` (`tele_one_id`, `tele_two_id`) VALUES
(19, 20),
(20, 19),
(28, 29),
(29, 28),
(38, 39),
(39, 38);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_translations`
--

CREATE TABLE IF NOT EXISTS `items_translations` (
  `old` int(11) NOT NULL,
  `new` int(11) NOT NULL,
  PRIMARY KEY (`old`,`new`),
  KEY `old` (`old`),
  KEY `new` (`new`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `items_users`
--

CREATE TABLE IF NOT EXISTS `items_users` (
  `item_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`item_id`),
  UNIQUE KEY `item_id_UNIQUE` (`item_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `items_users`
--

INSERT INTO `items_users` (`item_id`, `user_id`) VALUES
(7, 70),
(10, 70),
(11, 70),
(12, 70),
(13, 70),
(18, 70),
(21, 70),
(22, 70),
(23, 70),
(26, 70),
(31, 70),
(32, 70),
(33, 70),
(34, 70),
(35, 70),
(42, 70),
(43, 70),
(44, 70),
(45, 70),
(46, 70),
(47, 70),
(48, 70),
(49, 70),
(50, 70),
(51, 70),
(52, 70),
(53, 70),
(54, 70),
(55, 70),
(56, 70),
(57, 70),
(58, 70),
(59, 70),
(60, 70),
(61, 70),
(62, 70),
(65, 70),
(66, 70),
(67, 70),
(68, 70),
(69, 70),
(70, 70),
(71, 70),
(72, 70),
(73, 70),
(74, 70),
(75, 70),
(76, 70),
(77, 70),
(80, 70),
(83, 70),
(84, 70),
(85, 70),
(9, 71),
(15, 71),
(19, 71),
(20, 71),
(28, 71),
(29, 71),
(38, 71),
(39, 71),
(63, 71),
(64, 71),
(78, 71),
(79, 71),
(81, 71),
(82, 71),
(86, 71),
(96, 71),
(98, 71),
(100, 71),
(101, 71),
(102, 71),
(103, 71),
(104, 71),
(105, 71),
(106, 71);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `item_id_generator`
--

CREATE TABLE IF NOT EXISTS `item_id_generator` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_generator` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `id_generator` (`id_generator`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `messenger_friendships`
--

CREATE TABLE IF NOT EXISTS `messenger_friendships` (
  `sender` int(10) unsigned NOT NULL,
  `receiver` int(10) unsigned NOT NULL,
  PRIMARY KEY (`sender`,`receiver`),
  KEY `i_sender` (`sender`) USING HASH,
  KEY `i_receiver` (`receiver`) USING HASH
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `messenger_friendships`
--

INSERT INTO `messenger_friendships` (`sender`, `receiver`) VALUES
(70, 71);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `messenger_requests`
--

CREATE TABLE IF NOT EXISTS `messenger_requests` (
  `sender` int(10) unsigned NOT NULL,
  `receiver` int(10) unsigned NOT NULL,
  PRIMARY KEY (`sender`,`receiver`),
  KEY `i_sender` (`sender`) USING HASH,
  KEY `i_receiver` (`receiver`) USING HASH
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `moderation_forum_replies`
--

CREATE TABLE IF NOT EXISTS `moderation_forum_replies` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `thread_id` int(10) unsigned NOT NULL,
  `poster` varchar(120) NOT NULL,
  `date` varchar(50) NOT NULL,
  `message` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=27 ;

--
-- Volcado de datos para la tabla `moderation_forum_replies`
--

INSERT INTO `moderation_forum_replies` (`id`, `thread_id`, `poster`, `date`, `message`) VALUES
(8, 6, 'Evo', '7 April 2011 09:00 AM', 'Ryan, Josh, and Myself have been trying to tell the staff list that banning them is totally not fair, because we''re basically banning them for using a different language, banning them for being themselves, this is discrimination... so it''s good to see we''re taking action now, and concluding the bans of the ''marginalised''.'),
(10, 6, 'Zombie', '7 April 2011 07:52 PM', 'Trying to talk to martin to add :permban <username> so it will let us ban by IP in-game.'),
(15, 6, 'Evo', '8 April 2011 08:29 AM', 'That is a very good idea, however, I don''t want to use it on the foreign guys.'),
(16, 6, 'Evo', '8 April 2011 08:31 AM', 'That is a very good idea, however, I don''t want to use it on the foreign guys.'),
(24, 6, 'LeeW', '30 April 2011 06:15 AM', 'tell evo wasnt here during the "wars of the languages" I like that << ....');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `moderation_forum_threads`
--

CREATE TABLE IF NOT EXISTS `moderation_forum_threads` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `poster` varchar(100) NOT NULL,
  `subject` varchar(120) NOT NULL,
  `date` varchar(50) NOT NULL,
  `timestamp` double NOT NULL,
  `message` text NOT NULL,
  `locked` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=18 ;

--
-- Volcado de datos para la tabla `moderation_forum_threads`
--

INSERT INTO `moderation_forum_threads` (`id`, `poster`, `subject`, `date`, `timestamp`, `message`, `locked`) VALUES
(6, 'Zombie', 'Language Bans!', '7 April 2011 06:01 AM', 99999999999, 'Trying to make money for HabboVG, Josh doesn''t want any more members banned for language. Now, the public rooms are allowed to roomkick & roomban members so we can make it seem like it''s an English Only hostel. Just don''t perm ban anyone.\r\nLet''s try to get popular again.', '0'),
(17, 'Jazzica', 'Badge Codes', '28 August 2011 03:10 PM', 1314537014, 'Stuck for badge codes, the all listed here - \r\n\r\nhttp://www.habborator.org/badges/', '0');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `moderation_presets`
--

CREATE TABLE IF NOT EXISTS `moderation_presets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  `type` enum('message','roommessage') NOT NULL DEFAULT 'message',
  `message` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=32 ;

--
-- Volcado de datos para la tabla `moderation_presets`
--

INSERT INTO `moderation_presets` (`id`, `enabled`, `type`, `message`) VALUES
(18, '1', 'message', 'You have scammed, so that will be a two (2) Hour ban. When you come back, please make it stop, or a further timed ban will come. -Staff'),
(19, '1', 'message', 'You have been cyber bullying, you will get a two (2) Hours ban. When you come back, please make it stop. -Staff'),
(20, '1', 'message', 'This specific feature(s)/furniture(s), as you have pointed out are on their way to Habbo.VG, the technical and coding team in Habbo are working on bringing this to Habbo.VG, please wait momentarily, this should take within 1-7 days, or up to a month. - Moderator/Admin on Duty.'),
(22, '1', 'message', 'The Habbo.VG Staff Team is working on this problem. We are sorry for any inconvenience(s) this has caused. Please wait momentarily, - Moderators need to thoroughly deal with this properly. You should see changes being made soon. - Moderator/Staff on Duty.'),
(23, '1', 'message', 'Your Call for Help has been processed and dealt with accordingly to the Habbo.VG Staff Code of Conduct, and the Moderation Team has taken your Call for help into consideration. This Call for Help has been recorded for confidential reasons. If this has not been dealt with to your satisfaction, please email us.'),
(24, '1', 'message', 'You have been giving Personal Info / Phonenumbers / Adresses, so now you get a 2 Hour ban. If you keep doing this, we will ban even longer. -Staff'),
(25, '1', 'message', 'If you have any technical problems, please email us at other.habbo.vg@gmail.com or alternatively contact a Staff online. -Staff'),
(26, '1', 'message', 'The hourly credits are every 3 Hours. You get automatically 3.000c. For mroe Info, go on your Homepage -> Credits. -Staff'),
(28, '1', 'message', 'Your behaviour/actions/language is highly inappropriate, and breaches the Habbo.VG Way, please comply with the Habbo.VG Way that we have distributed. You can view this by going to ''Community'' then, ''Habbo VG Way'', Please make the correct alternations so that punishments are not applied to you. - Hotel Management'),
(29, '1', 'message', 'Your Call for Help does not meet the requirements made to be processed. Please be aware that the Call for Help tool is only used for genuine reasons, and it is preferably not misused. - Habbo.VG Moderation Team'),
(30, '1', 'roommessage', 'Room has been marked as faggot ass licker, & Jacob DON''T CHANGE MY SHIT. -Ryan'),
(31, '0', 'message', 'Newly generated preset - please update');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `moderation_tickets`
--

CREATE TABLE IF NOT EXISTS `moderation_tickets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `score` int(11) NOT NULL,
  `type` int(11) NOT NULL,
  `status` enum('open','picked','resolved','abusive','invalid','deleted') NOT NULL DEFAULT 'open',
  `sender_id` int(10) unsigned NOT NULL,
  `reported_id` int(10) unsigned NOT NULL,
  `moderator_id` int(10) unsigned NOT NULL,
  `message` text NOT NULL,
  `room_id` int(10) unsigned NOT NULL,
  `room_name` varchar(100) NOT NULL,
  `timestamp` double NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `navigator_flatcats`
--

CREATE TABLE IF NOT EXISTS `navigator_flatcats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `caption` varchar(100) NOT NULL,
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  `min_rank` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=16 ;

--
-- Volcado de datos para la tabla `navigator_flatcats`
--

INSERT INTO `navigator_flatcats` (`id`, `caption`, `enabled`, `min_rank`) VALUES
(15, 'No Category', '1', 1),
(1, 'Habbo Staff Rooms Âµ', '1', 4),
(2, 'Competition Category', '0', 1),
(3, 'unused competition category', '0', 1),
(4, 'Themed & RPG Rooms', '1', 1),
(5, 'Restaurant, Bar & Night Club Rooms', '1', 1),
(6, 'Club & Group Rooms', '1', 1),
(7, 'Chat, Chill & Discussion Rooms', '1', 1),
(8, 'Maze & Theme Park Rooms', '1', 1),
(9, 'Trading & Shopping Rooms', '1', 1),
(10, 'Gaming & Race Rooms', '1', 1),
(11, 'Hair Salons & Modelling Rooms', '1', 1),
(12, 'Help Centre, Guide & Service Rooms', '1', 1),
(13, 'School, Daycare & Adoption Rooms', '1', 1),
(14, 'All Other Rooms', '1', 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `navigator_pubcats`
--

CREATE TABLE IF NOT EXISTS `navigator_pubcats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `caption` varchar(100) NOT NULL,
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;

--
-- Volcado de datos para la tabla `navigator_pubcats`
--

INSERT INTO `navigator_pubcats` (`id`, `caption`, `enabled`) VALUES
(1, 'Cafes and Restaurants', '1'),
(2, 'Lounges and Entertainment', '1'),
(3, 'Pubs and Clubs', '1'),
(4, 'Outside Spaces & Swimming Pools', '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `navigator_pubcats_old`
--

CREATE TABLE IF NOT EXISTS `navigator_pubcats_old` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `caption` varchar(100) NOT NULL,
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `navigator_publics_new`
--

CREATE TABLE IF NOT EXISTS `navigator_publics_new` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ordernum` int(11) NOT NULL DEFAULT '1',
  `bannertype` enum('0','1') NOT NULL COMMENT '0 = big, 1 = normal',
  `caption` varchar(100) NOT NULL,
  `description` varchar(5000) NOT NULL DEFAULT '',
  `image` text NOT NULL,
  `image_type` enum('internal','external') NOT NULL DEFAULT 'internal',
  `room_id` int(10) unsigned NOT NULL,
  `category_id` int(11) NOT NULL DEFAULT '0',
  `category_parent_id` int(11) NOT NULL DEFAULT '-1',
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  `recommended` enum('0','1') NOT NULL DEFAULT '0',
  `typeofdata` int(255) NOT NULL DEFAULT '1',
  `tag` varchar(50000) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;

--
-- Volcado de datos para la tabla `navigator_publics_new`
--

INSERT INTO `navigator_publics_new` (`id`, `ordernum`, `bannertype`, `caption`, `description`, `image`, `image_type`, `room_id`, `category_id`, `category_parent_id`, `enabled`, `recommended`, `typeofdata`, `tag`) VALUES
(1, 1, '0', 'Juegos', '', 'officialrooms_hq/gamefolder.gif', 'internal', 0, 0, -1, '1', '0', 4, ''),
(2, 1, '1', 'Sala de Itachi', '¡Únete ahora!', 'officialrooms_hq/nav_es_02.png', 'internal', 64, 1, 1, '1', '0', 2, ''),
(3, 1, '0', 'Espacios Públicos', '', 'officialrooms_hq/official_rooms_nav_img.png', 'internal', 0, 0, -1, '1', '0', 4, ''),
(4, 1, '0', 'El Recibidor', '', 'officialrooms_hq/welcome_lobby.png', 'internal', 57, 3, 3, '1', '0', 3, '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `notes`
--

CREATE TABLE IF NOT EXISTS `notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `content` varchar(500) NOT NULL,
  `date` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=15 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `pets_racesoncatalogue`
--

CREATE TABLE IF NOT EXISTS `pets_racesoncatalogue` (
  `raceid` int(255) DEFAULT NULL,
  `color1` int(255) DEFAULT NULL,
  `color2` int(255) DEFAULT NULL,
  `has1color` enum('1','0') DEFAULT NULL,
  `has2color` enum('1','0') DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `pets_racesoncatalogue`
--

INSERT INTO `pets_racesoncatalogue` (`raceid`, `color1`, `color2`, `has1color`, `has2color`) VALUES
(12, 0, 0, '1', '0'),
(12, 1, 1, '1', '0'),
(12, 2, 2, '1', '0'),
(12, 3, 3, '1', '0'),
(12, 4, 4, '1', '0'),
(12, 5, 5, '1', '0'),
(15, 1, 2, '1', '0'),
(15, 2, 3, '1', '0'),
(15, 3, 4, '1', '0'),
(15, 4, 5, '1', '0'),
(15, 1, 6, '1', '1'),
(15, 2, 7, '1', '1'),
(15, 3, 8, '1', '1'),
(15, 4, 9, '1', '1'),
(15, 1, 10, '1', '1'),
(15, 2, 11, '1', '1'),
(15, 3, 12, '1', '1'),
(15, 4, 13, '1', '1'),
(15, 1, 14, '1', '1'),
(15, 2, 15, '1', '1'),
(15, 3, 16, '1', '1'),
(15, 4, 17, '1', '1'),
(15, 1, 18, '0', '1'),
(15, 2, 19, '0', '1'),
(15, 3, 20, '0', '1'),
(15, 4, 21, '0', '1'),
(15, 1, 22, '0', '1'),
(15, 2, 23, '0', '1'),
(15, 3, 24, '0', '1'),
(15, 4, 25, '0', '1'),
(15, 1, 26, '0', '1'),
(15, 2, 27, '0', '1'),
(15, 3, 28, '0', '1'),
(15, 4, 29, '0', '1'),
(15, 1, 30, '0', '1'),
(15, 2, 31, '0', '1'),
(15, 3, 32, '0', '1'),
(15, 4, 33, '0', '1'),
(15, 1, 34, '0', '1'),
(15, 2, 35, '0', '1'),
(15, 3, 36, '0', '1'),
(15, 4, 37, '0', '1'),
(15, 1, 38, '0', '1'),
(15, 2, 39, '0', '1'),
(15, 3, 40, '0', '1'),
(15, 4, 41, '0', '1'),
(15, 1, 42, '0', '1'),
(15, 2, 43, '0', '1'),
(15, 3, 44, '0', '1'),
(15, 4, 45, '0', '1'),
(15, 1, 46, '0', '1'),
(15, 2, 47, '0', '1'),
(15, 3, 48, '0', '1'),
(15, 4, 49, '0', '1'),
(0, 0, 0, '1', '0'),
(0, 1, 1, '1', '0'),
(0, 2, 2, '1', '0'),
(0, 3, 3, '1', '0'),
(0, 4, 4, '1', '0'),
(0, 5, 5, '1', '0'),
(0, 6, 6, '1', '0'),
(0, 7, 7, '1', '0'),
(0, 8, 8, '1', '0'),
(0, 9, 9, '1', '0'),
(0, 10, 10, '1', '0'),
(0, 11, 11, '1', '0'),
(0, 12, 12, '1', '0'),
(0, 13, 13, '1', '0'),
(0, 14, 14, '1', '0'),
(0, 15, 15, '1', '0'),
(0, 16, 16, '1', '0'),
(0, 17, 17, '1', '0'),
(0, 18, 18, '1', '0'),
(0, 19, 19, '1', '0'),
(0, 20, 20, '1', '0'),
(0, 21, 21, '1', '0'),
(0, 22, 22, '1', '0'),
(0, 23, 23, '1', '0'),
(0, 24, 24, '1', '0'),
(1, 0, 0, '1', '0'),
(1, 1, 1, '1', '0'),
(1, 2, 2, '1', '0'),
(1, 3, 3, '1', '0'),
(1, 4, 4, '1', '0'),
(1, 5, 5, '1', '0'),
(1, 6, 6, '1', '0'),
(1, 7, 7, '1', '0'),
(1, 8, 8, '1', '0'),
(1, 9, 9, '1', '0'),
(1, 10, 10, '1', '0'),
(1, 11, 11, '1', '0'),
(1, 12, 12, '1', '0'),
(1, 13, 13, '1', '0'),
(1, 14, 14, '1', '0'),
(1, 15, 15, '1', '0'),
(1, 16, 16, '1', '0'),
(1, 17, 17, '1', '0'),
(1, 18, 18, '1', '0'),
(1, 19, 19, '1', '0'),
(1, 20, 20, '1', '0'),
(1, 21, 21, '1', '0'),
(1, 22, 22, '1', '0'),
(1, 23, 23, '1', '0'),
(1, 24, 24, '1', '0'),
(10, 0, 0, '1', '0'),
(9, 0, 0, '1', '0'),
(9, 1, 1, '1', '0'),
(9, 2, 2, '1', '0'),
(9, 3, 3, '1', '0'),
(9, 4, 4, '1', '0'),
(9, 5, 5, '1', '0'),
(9, 6, 6, '1', '0'),
(9, 7, 7, '1', '0'),
(9, 8, 8, '1', '0'),
(11, 1, 1, '1', '0'),
(11, 2, 2, '1', '0'),
(11, 3, 3, '1', '0'),
(11, 4, 4, '1', '0'),
(11, 5, 5, '1', '0'),
(11, 6, 6, '1', '0'),
(11, 8, 8, '0', '0'),
(11, 9, 9, '1', '0'),
(11, 10, 10, '1', '0'),
(11, 11, 11, '1', '0'),
(11, 12, 12, '1', '0'),
(11, 13, 13, '1', '0'),
(11, 15, 15, '1', '0'),
(11, 18, 18, '1', '0'),
(8, 0, 0, '1', '0'),
(8, 1, 1, '1', '0'),
(8, 2, 2, '1', '0'),
(8, 3, 3, '1', '0'),
(8, 4, 4, '1', '0'),
(8, 5, 5, '1', '0'),
(8, 6, 6, '1', '0'),
(8, 7, 7, '1', '0'),
(8, 8, 8, '1', '0'),
(8, 9, 9, '1', '0'),
(8, 10, 10, '1', '0'),
(8, 11, 11, '1', '0'),
(8, 14, 14, '1', '0'),
(7, 0, 0, '1', '0'),
(7, 1, 1, '1', '0'),
(7, 2, 2, '1', '0'),
(7, 3, 3, '0', '1'),
(7, 4, 4, '1', '0'),
(7, 5, 5, '1', '0'),
(7, 6, 6, '1', '0'),
(7, 7, 7, '1', '0'),
(7, 0, 0, '1', '0'),
(7, 1, 1, '1', '0'),
(7, 2, 2, '1', '0'),
(7, 3, 3, '0', '1'),
(7, 4, 4, '1', '0'),
(7, 5, 5, '1', '0'),
(7, 6, 6, '1', '0'),
(7, 7, 7, '1', '0'),
(5, 0, 0, '1', '0'),
(5, 1, 1, '1', '0'),
(5, 2, 2, '1', '0'),
(5, 3, 3, '1', '0'),
(5, 5, 5, '1', '0'),
(5, 7, 7, '1', '0'),
(5, 8, 8, '1', '0'),
(3, 0, 0, '1', '0'),
(3, 1, 1, '1', '0'),
(3, 2, 2, '1', '0'),
(3, 3, 3, '1', '0'),
(3, 4, 4, '1', '0'),
(3, 5, 5, '1', '0'),
(3, 6, 6, '1', '0'),
(4, 0, 0, '1', '0'),
(4, 1, 1, '1', '0'),
(4, 2, 2, '1', '0'),
(4, 3, 3, '1', '0'),
(2, 0, 0, '1', '0'),
(2, 1, 1, '1', '0'),
(2, 2, 2, '1', '0'),
(2, 3, 3, '1', '0'),
(2, 4, 4, '1', '0'),
(2, 5, 5, '1', '0'),
(2, 6, 6, '1', '0'),
(2, 7, 7, '1', '0'),
(2, 8, 8, '1', '0'),
(2, 9, 9, '1', '0'),
(2, 10, 10, '1', '0'),
(2, 11, 11, '1', '0'),
(6, 0, 0, '1', '0'),
(6, 1, 1, '1', '0'),
(6, 2, 2, '1', '0'),
(6, 3, 3, '1', '0'),
(6, 4, 4, '1', '0'),
(6, 5, 5, '1', '0'),
(6, 6, 6, '0', '1'),
(6, 7, 7, '0', '1'),
(6, 8, 8, '0', '1'),
(6, 9, 9, '0', '1'),
(6, 10, 10, '0', '1'),
(6, 11, 11, '1', '0'),
(6, 12, 12, '0', '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `quests`
--

CREATE TABLE IF NOT EXISTS `quests` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `category` varchar(32) NOT NULL DEFAULT '',
  `series_number` int(11) NOT NULL DEFAULT '0',
  `goal_type` int(10) NOT NULL DEFAULT '0',
  `goal_data` int(10) unsigned NOT NULL DEFAULT '0',
  `name` varchar(32) NOT NULL DEFAULT '',
  `reward` int(11) NOT NULL DEFAULT '10',
  `data_bit` varchar(2) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=34 ;

--
-- Volcado de datos para la tabla `quests`
--

INSERT INTO `quests` (`id`, `category`, `series_number`, `goal_type`, `goal_data`, `name`, `reward`, `data_bit`) VALUES
(1, 'room_builder', 1, 0, 3, 'MOVEITEM', 10, '_2'),
(2, 'social', 1, 8, 1, 'ENTEROTHERSROOM', 10, '_2'),
(3, 'identity', 1, 14, 1, 'CHANGEFIGURE', 10, '_2'),
(4, 'explore', 1, 17, 1936, 'FINDLIFEGUARDTOWER', 10, '_2'),
(5, 'room_builder', 2, 1, 3, 'ROTATEITEM', 10, ''),
(6, 'room_builder', 3, 2, 1, 'PLACEITEM', 10, ''),
(7, 'room_builder', 4, 3, 1, 'PICKUPITEM', 10, ''),
(8, 'room_builder', 5, 4, 2, 'SWITCHSTATE', 10, ''),
(9, 'room_builder', 6, 5, 1, 'STACKITEM', 10, ''),
(10, 'room_builder', 7, 6, 1, 'PLACEFLOOR', 10, ''),
(11, 'room_builder', 8, 7, 1, 'PLACEWALLPAPER', 10, '_1'),
(12, 'identity', 2, 15, 1, 'CHANGEMOTTO', 10, ''),
(13, 'identity', 3, 16, 1, 'WEARBADGE', 10, ''),
(14, 'social', 2, 9, 1, 'CHATWITHSOMEONE', 10, ''),
(15, 'social', 3, 10, 1, 'REQUESTFRIEND', 10, ''),
(16, 'social', 4, 11, 1, 'GIVERESPECT', 10, ''),
(17, 'social', 5, 12, 1, 'DANCE', 10, ''),
(18, 'social', 6, 13, 1, 'WAVE', 10, ''),
(19, 'explore', 2, 17, 1948, 'SWIM', 10, ''),
(20, 'explore', 3, 17, 1969, 'FINDSURFBOARD', 10, ''),
(21, 'explore', 4, 17, 1956, 'FINDBEETLE', 10, ''),
(22, 'explore', 5, 17, 1369, 'FINDNEONFLOOR', 10, ''),
(23, 'explore', 6, 17, 1375, 'FINDDISCOBALL', 10, ''),
(24, 'explore', 7, 17, 1019, 'FINDJUKEBOX', 10, ''),
(25, 'explore', 8, 17, 2050, 'FINDBBGATE', 10, ''),
(26, 'explore', 9, 17, 2040, 'FINDBBTILE', 10, ''),
(27, 'explore', 10, 17, 2049, 'FINDBBTELEPORT', 10, ''),
(28, 'explore', 11, 17, 2167, 'FINDFREEZEGATE', 10, ''),
(29, 'explore', 12, 17, 2172, 'FINDFREEZESCOREBOARD', 10, ''),
(30, 'explore', 13, 17, 2166, 'FINDFREEZEEXITTILE', 10, ''),
(31, 'explore', 14, 17, 1413, 'ICESKATE', 10, ''),
(32, 'explore', 15, 17, 2148, 'FINDTAGPOLE', 10, ''),
(33, 'explore', 16, 17, 2199, 'ROLLERSKATE', 10, '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `ranks`
--

CREATE TABLE IF NOT EXISTS `ranks` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `prefix` text NOT NULL,
  `suffix` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=9002 ;

--
-- Volcado de datos para la tabla `ranks`
--

INSERT INTO `ranks` (`id`, `name`, `prefix`, `suffix`) VALUES
(1, 'User', '', ''),
(2, 'eXpert', '<b>', '</b>'),
(3, 'Silver Hobba', '<span style="color: #darkgreen;">', '</span>'),
(4, 'Gold Hobba', '<b style="color: #04B404;">', '</b>'),
(5, 'Trial Moderator', '<b style="color: lime">', '</b>'),
(6, 'Moderator', '<b style="color: red;">', '</b>'),
(7, 'Assistent Manager', '<span style="font-weight: bold;color:grey;background: url(http://i.imgur.com/Jnoq2.gif)">', '</span>'),
(8, 'Hotel Managment', '<span style="font-weight: bold;color:grey;background: url(http://i.imgur.com/Jnoq2.gif)">', '</span>');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `rooms`
--

CREATE TABLE IF NOT EXISTS `rooms` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `roomtype` enum('public','private') NOT NULL DEFAULT 'private',
  `caption` varchar(100) NOT NULL DEFAULT 'Room',
  `owner` varchar(75) NOT NULL DEFAULT '',
  `description` varchar(200) NOT NULL,
  `category` int(2) NOT NULL DEFAULT '0',
  `state` enum('open','locked','password') NOT NULL DEFAULT 'open',
  `users_now` int(3) NOT NULL DEFAULT '0',
  `users_max` int(3) NOT NULL DEFAULT '25',
  `model_name` varchar(20) NOT NULL,
  `public_ccts` text NOT NULL,
  `score` int(6) NOT NULL DEFAULT '0',
  `tags` varchar(100) NOT NULL,
  `icon_bg` int(2) NOT NULL DEFAULT '1',
  `icon_fg` int(2) NOT NULL DEFAULT '0',
  `icon_items` varchar(10) NOT NULL DEFAULT '0.0',
  `password` text NOT NULL,
  `wallpaper` varchar(10) NOT NULL DEFAULT '0.0',
  `floor` varchar(10) NOT NULL DEFAULT '0.0',
  `landscape` varchar(10) NOT NULL DEFAULT '0.0',
  `allow_pets` enum('0','1') NOT NULL DEFAULT '1',
  `allow_pets_eat` enum('0','1') NOT NULL DEFAULT '0',
  `allow_walkthrough` enum('0','1') NOT NULL DEFAULT '0',
  `allow_hidewall` enum('1','0') NOT NULL DEFAULT '0',
  `allow_rightsoverride` enum('1','0') NOT NULL DEFAULT '0',
  `floorthickness` int(6) NOT NULL,
  `wallthickness` int(6) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`) USING HASH,
  KEY `owner` (`owner`) USING BTREE,
  KEY `category` (`category`) USING BTREE,
  KEY `caption` (`caption`) USING BTREE,
  KEY `tags` (`tags`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=90 ;

--
-- Volcado de datos para la tabla `rooms`
--

INSERT INTO `rooms` (`id`, `roomtype`, `caption`, `owner`, `description`, `category`, `state`, `users_now`, `users_max`, `model_name`, `public_ccts`, `score`, `tags`, `icon_bg`, `icon_fg`, `icon_items`, `password`, `wallpaper`, `floor`, `landscape`, `allow_pets`, `allow_pets_eat`, `allow_walkthrough`, `allow_hidewall`, `allow_rightsoverride`, `floorthickness`, `wallthickness`) VALUES
(50, 'public', 'Netcafé', '', 'The netcafé', 0, 'open', 0, 50, 'netcafe', 'hh_room_netcafe', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(51, 'public', 'The park', '', 'The park', 0, 'open', 0, 25, 'park_a', 'hh_room_park', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(52, 'private', 'Heaven''s Beach Cafe', '', '', 0, 'open', 0, 25, 'rooftop_2', 'hh_room_rooftop', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(53, 'public', 'Heaven''s Beach Cafe 2', '', '', 0, 'open', 0, 25, 'rooftop_2', 'hh_room_rooftop', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(54, 'public', 'Pizzeria Pepperoni', '', '', 0, 'open', 0, 25, 'pizza', 'hh_room_pizza', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(55, 'public', 'Star lounge', '', '', 0, 'open', 0, 25, 'star_lounge', 'hh_room_starlounge', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(57, 'public', 'El Recibidor', 'HabboLatino', '', 0, 'open', 0, 25, 'model_k2', 'hh_room_nlobby', 0, '', 1, 0, '0.0', '', '0.0', '105', '0.0', '0', '0', '0', '1', '0', 0, 0),
(59, 'public', 'picnic', '', '', 0, 'open', 0, 25, 'picnic', 'hh_room_picnic_dudesons', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(60, 'public', 'Theatredrome', '', '', 0, 'open', 0, 25, 'theater', 'hh_room_theater', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(62, 'public', 'Cinema', '', '', 0, 'open', 0, 25, 'cinema_a', 'hh_room_cinema', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '0', '0', '0', '0', 0, 0),
(64, 'private', '4TITULO CAMBIADO', 'Itachi', 'DESCRIPCION CAMBIADA', 14, 'open', 0, 25, 'model_a', '', 0, 'yovoy1,yovoy2', 1, 0, '0.0', '', '3003', '403', '1.1', '', '', '', '', '0', 1, 0),
(68, 'private', 'TEST', 'Fakundo', '', 15, 'password', 0, 50, 'model_n', '', 0, '', 1, 0, '0.0', '123a123', '0.0', '0.0', '0.0', '0', '', '', '', '0', 0, 0),
(67, 'private', 'fdfd', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '2901', '603', '0.0', '1', '0', '0', '0', '0', 0, 0),
(69, 'private', 'sdfasdfasdfasd', 'Fakundo', '', 9, 'open', 0, 25, 'model_f', '', 0, '', 1, 0, '0.0', '', '3106', '606', '5.4', '', '', '', '', '0', 0, 0),
(70, 'private', 'rqwerqere', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(71, 'private', 'dfafasdf', 'Fakundo', '', 15, 'locked', 0, 10, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '', '', '', '0', 0, 0),
(72, 'private', 'gsdfgsdf', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(73, 'private', 'rwerwe', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(74, 'private', 'gfgfgf', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(75, 'private', 'rqwe', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(76, 'private', 'vcxzvc', 'Fakundo', '', 9, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '', '', '', '0', 1, 1),
(77, 'private', 'twerjtwaje', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(78, 'private', 'vxcvxcgfsdf', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 1, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(79, 'private', 'twertwert', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(80, 'private', 'fsdrwere', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(81, 'private', 'twertwer', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(82, 'private', 'vxcvxc', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(83, 'private', 'vxcvxc', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(84, 'private', 'vxcvrtr', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(85, 'private', 'yertyer', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(86, 'private', 'Hallo world!', 'Itachi', '', 9, 'open', 0, 25, 'model_u', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '', '', '', '', '0', 1, 1),
(87, 'private', 'Home', 'Fakundo', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0),
(88, 'private', 'Â»RicardoÂ»', 'Fakundo', '', 15, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '0', '', '', '', '0', 0, 0),
(89, 'private', '123456', 'Itachi', '', 0, 'open', 0, 25, 'model_a', '', 0, '', 1, 0, '0.0', '', '0.0', '0.0', '0.0', '1', '0', '0', '0', '0', 0, 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_active`
--

CREATE TABLE IF NOT EXISTS `room_active` (
  `roomid` int(10) unsigned NOT NULL,
  `active_users` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`roomid`),
  UNIQUE KEY `roomid` (`roomid`) USING HASH,
  KEY `activeusers` (`active_users`) USING HASH
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_ads`
--

CREATE TABLE IF NOT EXISTS `room_ads` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ad_image` text NOT NULL,
  `ad_image_orig` text NOT NULL,
  `ad_link` text NOT NULL,
  `views` int(11) NOT NULL DEFAULT '0',
  `views_limit` int(11) NOT NULL DEFAULT '0' COMMENT '0 = unlimited',
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;

--
-- Volcado de datos para la tabla `room_ads`
--

INSERT INTO `room_ads` (`id`, `ad_image`, `ad_image_orig`, `ad_link`, `views`, `views_limit`, `enabled`) VALUES
(2, 'http://www.shipmentoffail.com/wp-content/uploads/2010/05/weather.jpg', 'weather.jpg', 'javascript.alert("lol");', 411048, 0, '1'),
(3, 'http://habbo.vg/ads/sam.gif', 'sam.gif', 'http://www.habbo.vg/me', 411179, 0, '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_items`
--

CREATE TABLE IF NOT EXISTS `room_items` (
  `id` int(9) unsigned NOT NULL,
  `room_id` int(9) unsigned NOT NULL,
  `base_item` int(5) unsigned NOT NULL,
  `extra_data` text NOT NULL,
  `x` int(3) NOT NULL,
  `y` int(3) NOT NULL,
  `z` double NOT NULL,
  `rot` int(1) NOT NULL,
  `wall_pos` char(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `room_id` (`room_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ROW_FORMAT=FIXED;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_items_moodlight`
--

CREATE TABLE IF NOT EXISTS `room_items_moodlight` (
  `item_id` int(10) unsigned NOT NULL,
  `enabled` enum('0','1') NOT NULL DEFAULT '0',
  `current_preset` int(11) NOT NULL,
  `preset_one` text NOT NULL,
  `preset_two` text NOT NULL,
  `preset_three` text NOT NULL,
  PRIMARY KEY (`item_id`),
  KEY `item_id` (`item_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_items_songs`
--

CREATE TABLE IF NOT EXISTS `room_items_songs` (
  `item_id` int(10) unsigned NOT NULL,
  `room_id` int(10) unsigned NOT NULL,
  `song_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`item_id`,`room_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_links`
--

CREATE TABLE IF NOT EXISTS `room_links` (
  `roomid` int(9) unsigned NOT NULL,
  `toroomid` int(9) unsigned NOT NULL,
  `fromx` int(2) NOT NULL,
  `fromy` int(2) NOT NULL,
  `tox` int(2) NOT NULL,
  `toy` int(2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `room_links`
--

INSERT INTO `room_links` (`roomid`, `toroomid`, `fromx`, `fromy`, `tox`, `toy`) VALUES
(105235, 1337, 19, 3, 2, 15),
(105235, 1337, 20, 4, 3, 16),
(105235, 1337, 21, 5, 4, 17),
(105235, 1337, 22, 6, 5, 18),
(105235, 1337, 23, 7, 6, 19),
(105235, 1337, 24, 8, 7, 20),
(105235, 1337, 25, 9, 8, 21),
(105235, 1337, 26, 10, 9, 22),
(105235, 1337, 27, 11, 10, 23),
(105235, 1337, 28, 12, 11, 24),
(1337, 105235, 2, 15, 19, 3),
(1337, 105235, 3, 16, 20, 4),
(1337, 105235, 4, 17, 21, 5),
(1337, 105235, 5, 18, 22, 6),
(1337, 105235, 6, 19, 23, 7),
(1337, 105235, 7, 20, 24, 8),
(1337, 105235, 8, 21, 25, 9),
(1337, 105235, 9, 22, 26, 10),
(1337, 105235, 10, 23, 27, 11),
(1337, 105235, 11, 24, 28, 12),
(1337, 105235, 13, 26, 30, 14),
(1337, 105235, 14, 27, 31, 15),
(1337, 105235, 15, 28, 32, 16),
(1337, 105235, 16, 29, 33, 17),
(1337, 105235, 17, 30, 34, 18),
(1337, 105235, 18, 31, 35, 19),
(1337, 105235, 19, 32, 36, 20),
(1337, 105235, 20, 33, 37, 21),
(1337, 105235, 21, 34, 38, 22),
(105235, 1337, 30, 14, 13, 26),
(105235, 1337, 31, 15, 14, 27),
(105235, 1337, 32, 16, 15, 28),
(105235, 1337, 33, 17, 16, 29),
(105235, 1337, 34, 18, 17, 30),
(105235, 1337, 35, 19, 18, 31),
(105235, 1337, 36, 20, 19, 32),
(105235, 1337, 37, 21, 20, 33),
(105235, 1337, 38, 22, 21, 34);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_links_copy`
--

CREATE TABLE IF NOT EXISTS `room_links_copy` (
  `roomid` int(9) unsigned NOT NULL,
  `toroomid` int(9) unsigned NOT NULL,
  `fromx` int(2) NOT NULL,
  `fromy` int(2) NOT NULL,
  `tox` int(2) NOT NULL,
  `toy` int(2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_models`
--

CREATE TABLE IF NOT EXISTS `room_models` (
  `id` varchar(100) NOT NULL,
  `door_x` int(11) NOT NULL,
  `door_y` int(11) NOT NULL,
  `door_z` double NOT NULL,
  `door_dir` int(4) NOT NULL DEFAULT '2',
  `heightmap` text NOT NULL,
  `public_items` text NOT NULL,
  `club_only` enum('0','1') NOT NULL DEFAULT '0',
  `poolmap` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `room_models`
--

INSERT INTO `room_models` (`id`, `door_x`, `door_y`, `door_z`, `door_dir`, `heightmap`, `public_items`, `club_only`, `poolmap`) VALUES
('model_a', 3, 5, 0, 2, 'xxxxxxxxxxxx\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxx00000000\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx', '', '0', ''),
('model_b', 0, 5, 0, 2, 'xxxxxxxxxxxx\r\nxxxxx0000000\r\nxxxxx0000000\r\nxxxxx0000000\r\nxxxxx0000000\r\nx00000000000\r\nx00000000000\r\nx00000000000\r\nx00000000000\r\nx00000000000\r\nx00000000000\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx', '', '0', ''),
('model_c', 4, 7, 0, 2, 'xxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx', '', '0', ''),
('model_d', 4, 7, 0, 2, 'xxxxxxxxxxxx\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxxxxxxxxxxx', '', '0', ''),
('model_e', 1, 5, 0, 2, 'xxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxx0000000000\r\nxx0000000000\r\nxx0000000000\r\nxx0000000000\r\nxx0000000000\r\nxx0000000000\r\nxx0000000000\r\nxx0000000000\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx', '', '0', ''),
('model_f', 2, 5, 0, 2, 'xxxxxxxxxxxx\r\nxxxxxxx0000x\r\nxxxxxxx0000x\r\nxxx00000000x\r\nxxx00000000x\r\nxxx00000000x\r\nxxx00000000x\r\nx0000000000x\r\nx0000000000x\r\nx0000000000x\r\nx0000000000x\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx', '', '0', ''),
('model_i', 0, 10, 0, 2, 'xxxxxxxxxxxxxxxxx\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nx0000000000000000\r\nxxxxxxxxxxxxxxxxx', '', '0', ''),
('model_j', 0, 10, 0, 2, 'xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxx0000000000\r\nxxxxxxxxxxx0000000000\r\nxxxxxxxxxxx0000000000\r\nxxxxxxxxxxx0000000000\r\nxxxxxxxxxxx0000000000\r\nxxxxxxxxxxx0000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx0000000000xxxxxxxxxx\r\nx0000000000xxxxxxxxxx\r\nx0000000000xxxxxxxxxx\r\nx0000000000xxxxxxxxxx\r\nx0000000000xxxxxxxxxx\r\nx0000000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx', '', '0', ''),
('model_k', 0, 13, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxxxxxxxxxxxxxxxxxx', '', '0', ''),
('model_l', 0, 16, 0, 2, 'xxxxxxxxxxxxxxxxxxxxx\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nx00000000xxxx00000000\r\nxxxxxxxxxxxxxxxxxxxxx', '', '0', ''),
('model_m', 0, 15, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nx0000000000000000000000000000\r\nx0000000000000000000000000000\r\nx0000000000000000000000000000\r\nx0000000000000000000000000000\r\nx0000000000000000000000000000\r\nx0000000000000000000000000000\r\nx0000000000000000000000000000\r\nx0000000000000000000000000000\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxx00000000xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '0', ''),
('model_n', 0, 16, 0, 2, 'xxxxxxxxxxxxxxxxxxxxx\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx000000xxxxxxxx000000\r\nx000000x000000x000000\r\nx000000x000000x000000\r\nx000000x000000x000000\r\nx000000x000000x000000\r\nx000000x000000x000000\r\nx000000x000000x000000\r\nx000000xxxxxxxx000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nx00000000000000000000\r\nxxxxxxxxxxxxxxxxxxxxx', '', '0', ''),
('model_g', 1, 7, 1, 2, 'xxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxx00000\r\nxxxxxxx00000\r\nxxxxxxx00000\r\nxx1111000000\r\nxx1111000000\r\nxx1111000000\r\nxx1111000000\r\nxx1111000000\r\nxxxxxxx00000\r\nxxxxxxx00000\r\nxxxxxxx00000\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx', '', '1', ''),
('model_q', 10, 4, 2, 2, 'xxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxx22222222\r\nxxxxxxxxxxx22222222\r\nxxxxxxxxxxx22222222\r\nxxxxxxxxxxx22222222\r\nxxxxxxxxxxx22222222\r\nxxxxxxxxxxx22222222\r\nx222222222222222222\r\nx222222222222222222\r\nx222222222222222222\r\nx222222222222222222\r\nx222222222222222222\r\nx222222222222222222\r\nx2222xxxxxxxxxxxxxx\r\nx2222xxxxxxxxxxxxxx\r\nx2222211111xx000000\r\nx222221111110000000\r\nx222221111110000000\r\nx2222211111xx000000\r\nxx22xxx1111xxxxxxxx\r\nxx11xxx1111xxxxxxxx\r\nx1111xx1111xx000000\r\nx1111xx111110000000\r\nx1111xx111110000000\r\nx1111xx1111xx000000\r\nxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_o', 0, 18, 1, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxx11111111xxxx\r\nxxxxxxxxxxxxx11111111xxxx\r\nxxxxxxxxxxxxx11111111xxxx\r\nxxxxxxxxxxxxx11111111xxxx\r\nxxxxxxxxxxxxx11111111xxxx\r\nxxxxxxxxxxxxx11111111xxxx\r\nxxxxxxxxxxxxx11111111xxxx\r\nxxxxxxxxxxxxx00000000xxxx\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nx111111100000000000000000\r\nx111111100000000000000000\r\nx111111100000000000000000\r\nx111111100000000000000000\r\nx111111100000000000000000\r\nx111111100000000000000000\r\nx111111100000000000000000\r\nx111111100000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_r', 10, 4, 3, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxx33333333333333\r\nxxxxxxxxxxx33333333333333\r\nxxxxxxxxxxx33333333333333\r\nxxxxxxxxxx333333333333333\r\nxxxxxxxxxxx33333333333333\r\nxxxxxxxxxxx33333333333333\r\nxxxxxxx333333333333333333\r\nxxxxxxx333333333333333333\r\nxxxxxxx333333333333333333\r\nxxxxxxx333333333333333333\r\nxxxxxxx333333333333333333\r\nxxxxxxx333333333333333333\r\nx4444433333xxxxxxxxxxxxxx\r\nx4444433333xxxxxxxxxxxxxx\r\nx44444333333222xx000000xx\r\nx44444333333222xx000000xx\r\nxxx44xxxxxxxx22xx000000xx\r\nxxx33xxxxxxxx11xx000000xx\r\nxxx33322222211110000000xx\r\nxxx33322222211110000000xx\r\nxxxxxxxxxxxxxxxxx000000xx\r\nxxxxxxxxxxxxxxxxx000000xx\r\nxxxxxxxxxxxxxxxxx000000xx\r\nxxxxxxxxxxxxxxxxx000000xx\r\nxxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_p', 0, 23, 2, 2, 'xxxxxxxxxxxxxxxxxxx\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx22222222xxxx\r\nxxxxxxx11111111xxxx\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx2222xx11111111xxxx\r\nx2222xx00000000xxxx\r\nx2222xx000000000000\r\nx2222xx000000000000\r\nx2222xx000000000000\r\nx2222xx000000000000\r\n22222xx000000000000\r\nx2222xx000000000000\r\nxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_h', 4, 4, 1, 2, 'xxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxx111111x\r\nxxxxx111111x\r\nxxxxx111111x\r\nxxxxx111111x\r\nxxxxx111111x\r\nxxxxx000000x\r\nxxxxx000000x\r\nxxx00000000x\r\nxxx00000000x\r\nxxx00000000x\r\nxxx00000000x\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx\r\nxxxxxxxxxxxx', '', '1', ''),
('old_skool', 2, 1, 0, 2, 'xx0xxxxxxxxxxxxxx\r\n0000000xxx00000xx\r\n0000000x0000000xx\r\n0000000xxxxxxxxxx\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n00000000000000000\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x\r\n0000000000000000x', 'SLHk49mobiles_chair3QBPAHHHk410mobiles_chair3RBPAHHHk411mobiles_chair3SBPAHHHk412mobiles_chair3PCPAHHHe101mobiles_chair1IRBHPAHe1010mobiles_chair1RBRBHPAHe110mobiles_chair1HSBHJHb111mobiles_table2ISBHHHc112mobiles_table3JSBHHHe113mobiles_chair1KSBHRAHb1110mobiles_table2RBSBHHHc1111mobiles_table3SBSBHHHa121mobiles_table1IPCHHHd122mobiles_table4JPCHHHe129mobiles_chair1QBPCHJHa1210mobiles_table1RBPCHHHd1211mobiles_table4SBPCHHHe1212mobiles_chair1PCPCHRAHe131mobiles_chair1IQCHHHe1311mobiles_chair1SBQCHHHe150mobiles_chair1HSCHPAHe170mobiles_chair1HQDHJHb171mobiles_table2IQDHHHc172mobiles_table3JQDHHHe173mobiles_chair1KQDHRAHa181mobiles_table1IRDHHHd182mobiles_table4JRDHHHe192mobiles_chair1JSDHHHe211mobiles_chair1IQEHPAHb216mobiles_table2RAQEHHHc217mobiles_table3SAQEHHHe2112mobiles_chair1PCQEHPAHe220mobiles_chair1HREHJHb221mobiles_table2IREHHHc222mobiles_table3JREHHHe223mobiles_chair1KREHRAHe225mobiles_chair1QAREHJHa226mobiles_table1RAREHHHd227mobiles_table4SAREHHHe228mobiles_chair1PBREHRAHe2211mobiles_chair1SBREHJHb2212mobiles_table2PCREHHHc2213mobiles_table3QCREHHHe2214mobiles_chair1RCREHRAHa231mobiles_table1ISEHHHd232mobiles_table4JSEHHHa2312mobiles_table1PCSEHHHd2313mobiles_table4QCSEHHHe241mobiles_chair1IPFHHHe247mobiles_chair1SAPFHPAHe2413mobiles_chair1QCPFHH', '0', ''),
('pizza', 5, 27, 1, 2, 'xxxxxxxxx0000000\r\nx11111x1xx000000\r\n11xxxxx111x00000\r\n11x1111111xx0000\r\n11x1111111100000\r\nxxx1111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n1111111111100000\r\n11111111111xxxxx\r\n1111111111xxxxxx\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n1111111111111111\r\n11xx11xx11111111\r\nxxxx11xxxxxxxxxx\r\nxxxx11xxxxxxxxxx', 'QGHa015pizza_plant1SCHHJHe314pizza_sofa1RCKHPAHE315pizza_sofa2SCKHPAHc515pizza_tableSCQAHJHb60pizza_plant2HRAIJHf614pizza_sofa3RCRAHHHF615pizza_sofa4SCRAHHHd81pizza_chairIPBIPAHd82pizza_chairJPBIPAHc102pizza_tableJRBIJHe1014pizza_sofa1RCRBHPAHE1015pizza_sofa2SCRBHPAHd111pizza_chairISBIHHd112pizza_chairJSBIHHc1215pizza_tableSCPCHJHf1314pizza_sofa3RCQCHHHF1315pizza_sofa4SCQCHHHd161pizza_chairIPDIPAHd162pizza_chairJPDIPAHc182pizza_tableJRDIJHd191pizza_chairISDIHHd192pizza_chairJSDIHHd2111pizza_chairSBQEIJHd2114pizza_chairRCQEIRAHd2211pizza_chairSBREIJHc2213pizza_tableQCREIHHd2214pizza_chairRCREIRAHa250pizza_plant1HQFIJHa2515pizza_plant1SCQFIJ', '0', ''),
('pub_a', 15, 25, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx2222222211111xxx\r\nxxxxxxxxx2222222211111xxx\r\nxxxxxxxxx2222222211111xxx\r\nxxxxxxxxx2222222211111xxx\r\nxxxxxxxxx2222222222111xxx\r\nxxxxxxxxx2222222222111xxx\r\nxxxxxxxxx2222222222000xxx\r\nxxxxxxxxx2222222222000xxx\r\nxxxxxxxxx2222222222000xxx\r\nxxxxxxxxx2222222222000xxx\r\nx333333332222222222000xxx\r\nx333333332222222222000xxx\r\nx333333332222222222000xxx\r\nx333333332222222222000xxx\r\nx333333332222222222000xxx\r\nx333332222222222222000xxx\r\nx333332222222222222000xxx\r\nx333332222222222222000xxx\r\nx333332222222222222000xxx\r\nx333333332222222222000xxx\r\nxxxxx31111112222222000xxx\r\nxxxxx31111111000000000xxx\r\nxxxxx31111111000000000xxx\r\nxxxxx31111111000000000xxx\r\nxxxxx31111111000000000xxx\r\nxxxxxxxxxxxxxxx00xxxxxxxx\r\nxxxxxxxxxxxxxxx00xxxxxxxx\r\nxxxxxxxxxxxxxxx00xxxxxxxx\r\nxxxxxxxxxxxxxxx00xxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxx', 'SWHS119pub_sofa2SDIIPAHs120pub_sofaPEIIPAHs121pub_sofaQEIIPAHq211bardesk1SBJJHHc212pub_chairPCJJRAHQ311bardesk2SBKJHHq411bardesk1SBPAJHHc412pub_chairPCPAJRAHQ511bardesk2SBQAJHHf518pub_fenceRDQAJIHq611bardesk1SBRAJHHc612pub_chairPCRAJRAHf618pub_fenceRDRAJHHQ711bardesk2SBSAJHHf718pub_fenceRDSAJHHq811bardesk1SBPBJHHc812pub_chairPCPBJRAHf818pub_fenceRDPBJHHw910bardesk4RBQBJHHW911bardesk3SBQBJHHf918pub_fenceRDQBJHHf1018pub_fenceRDRBJHHC112pub_chair2JSBKPAHC113pub_chair2KSBKPAHC115pub_chair2QASBKPAHC116pub_chair2RASBKPAHf118pub_fencePBSBKIHf1118pub_fenceRDSBJHHf128pub_fencePBPCKHHf1218pub_fenceRDPCJHHf138pub_fencePBQCKHHC139pub_chair2QBQCJJHk1314pub_chair3RCQCJJHT1315pub_table2SCQCJIHk1316pub_chair3PDQCJRAHf1318pub_fenceRDQCJHHf148pub_fencePBRCKJHC149pub_chair2QBRCJJHk1414pub_chair3RCRCJJHT1415pub_table2SCRCJJHk1416pub_chair3PDRCJRAHf1418pub_fenceRDRCJHHt151pub_tableISCKHHf155pub_fenceQASCKIHf1518pub_fenceRDSCJHHS161pub_sofa2IPDKJHf165pub_fenceQAPDKHHf1618pub_fenceRDPDJHHs171pub_sofaIQDKJHf175pub_fenceQAQDKHHk1713pub_chair3QCQDJPAHk1714pub_chair3RCQDJPAHk1715pub_chair3SCQDJPAHk1716pub_chair3PDQDJPAHf1718pub_fenceRDQDJHHs181pub_sofaIRDKJHf185pub_fenceQARDKHHT1813pub_table2QCRDJQAHT1814pub_table2RCRDJRAHT1815pub_table2SCRDJRAHT1816pub_table2PDRDJPAHf1818pub_fenceRDRDJHHs192pub_sofaJSDKHHS193pub_sofa2KSDKHHf195pub_fenceQASDKHHk1913pub_chair3QCSDJHHk1914pub_chair3RCSDJHHk1915pub_chair3SCSDJHHk1916pub_chair3PDSDJHHf1918pub_fenceRDSDJHHf201pub_fenceIPEKQAHf202pub_fenceJPEKRAHf203pub_fenceKPEKRAHf204pub_fencePAPEKRAHf205pub_fenceQAPEKKHf2018pub_fenceRDPEJHHS217pub_sofa2SAQEIPAHs218pub_sofaPBQEIPAHf2112pub_fencePCQEJQAHf2113pub_fenceQCQEJRAHf2114pub_fenceRCQEJRAHf2115pub_fenceSCQEJRAHf2116pub_fencePDQEJRAHf2117pub_fenceQDQEJRAHf2118pub_fenceRDQEJKHS226pub_sofa2RAREIJHt2215pub_tableSCREHHHC2216pub_chair2PDREHPAHC2217pub_chair2QDREHPAHs236pub_sofaRASEIJHT238pub_table2PBSEIIHs246pub_sofaRAPFIJHT248pub_table2PBPFIHHs256pub_sofaRAQFIJHT258pub_table2PBQFIJ', '0', ''),
('newbie_lobby', 2, 11, 0, 2, 'xxxxxxxxxxxxxxxx000000\r\nxxxxx0xxxxxxxxxx000000\r\nxxxxx00000000xxx000000\r\nxxxxx000000000xx000000\r\n0000000000000000000000\r\n0000000000000000000000\r\n0000000000000000000000\r\n0000000000000000000000\r\n0000000000000000000000\r\nxxxxx000000000000000xx\r\nxxxxx000000000000000xx\r\nx0000000000000000000xx\r\nx0000000000000000xxxxx\r\nxxxxxx00000000000xxxxx\r\nxxxxxxx0000000000xxxxx\r\nxxxxxxxx000000000xxxxx\r\nxxxxxxxx000000000xxxxx\r\nxxxxxxxx000000000xxxxx\r\nxxxxxxxx000000000xxxxx\r\nxxxxxxxx000000000xxxxx\r\nxxxxxxxx000000000xxxxx\r\nxxxxxx00000000000xxxxx\r\nxxxxxx00000000000xxxxx\r\nxxxxxx00000000000xxxxx\r\nxxxxxx00000000000xxxxx\r\nxxxxxx00000000000xxxxx\r\nxxxxx000000000000xxxxx\r\nxxxxx000000000000xxxxx', 'SOHa016crl_lampPDHHHHy017crl_sofa2cQDHHPAHw018crl_sofa2bRDHHPAHv019crl_sofa2aSDHHPAHa020crl_lampPEHHHHb116crl_chairPDIHJHa27crl_lampSAJHHHa211crl_lampSBJHHHb216crl_chairPDJHJHc35crl_pillarQAKHHHb37crl_chairSAKHJHu39crl_table1bQBKHHHs311crl_sofa1cSBKHRAHb316crl_chairPDKHJHA319crl_table2bSDKHHHz320crl_table2aPEKHHHa40crl_lampHPAHHHy41crl_sofa2cIPAHPAHw42crl_sofa2bJPAHPAHv43crl_sofa2aKPAHPAHa44crl_lampPAPAHHHt49crl_table1aQBPAHHHr411crl_sofa1bSBPAHRAHh415crl_wall2aSCPAHHHa416crl_lampPDPAHHHb50crl_chairHQAHJHb57crl_chairSAQAHJHq511crl_sofa1aSBQAHRAHA62crl_table2bJRAHHHz63crl_table2aKRAHHHa611crl_lampSBRAHHHb70crl_chairHSAHJHa80crl_lampHPBHHHD81crl_sofa3cIPBHHHC82crl_sofa3bJPBHHHB83crl_sofa3aKPBHHHa84crl_lampPAPBHHHo819crl_barchair2SDPBHHHp820crl_tablebarPEPBHHHo821crl_barchair2QEPBHHHE95crl_pillar2QAQBHHHc99crl_pillarQBQBHHHP158crl_desk1aPBSCHHHO159crl_deskiQBSCHHHN1510crl_deskhRBSCHHHM1610crl_deskgRBPDHHHL1710crl_deskfRBQDHHHK1810crl_deskeRBRDHHHK1910crl_deskeRBSDHHHK2010crl_deskeRBPEHHHK2110crl_deskeRBQEHHHK2210crl_deskeRBREHHHK2310crl_deskeRBSEHHHG247crl_wallbSAPFHHHK2410crl_deskeRBPFHHHF257crl_wallaSAQFHHHH258crl_desk1bPBQFHHHI259crl_desk1cQBQFHHHJ2510crl_desk1dRBQFHHHd2712crl_lamp2PCSFHHHf2713crl_cabinet2QCSFHHHe2714crl_cabinet1RCSFHHHd2715crl_lamp2SCSFHH', '0', ''),
('tearoom', 21, 19, 1, 6, 'xxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxx3333x33333333x\r\n333333xx3333x33333333x\r\n3333333x3333x33333333x\r\n3333333x3333x33333333x\r\n3333333xxxxxx33333333x\r\n333333333333333333333x\r\n333333333333333333333x\r\n333333333333333333333x\r\n333333333333333333333x\r\n33333333222x333333333x\r\n33333333222x333333333x\r\n33333333222x333333333x\r\n33333333222x333333333x\r\n33333333111x333333333x\r\n33333333111x333333333x\r\n33333333111x333333333x\r\nxxxxxxxx111xxxxxxxxxxx\r\n11111111111111111111xx\r\n1111111111111111111111\r\n1111111111111111111111\r\n11111111111111111111xx', 'QIHh113hardwoodsofa1QCIKPAHi114hardwoodsofa2RCIKPAHj115hardwoodsofa3SCIKPAHc116teabambooPDIKHHh118hardwoodsofa1RDIKPAHi119hardwoodsofa2SDIKPAHj120hardwoodsofa3PEIKPAHl313teasmalltable1QCKKHHk315teasmalltable2SCKKHHl318teasmalltable1RDKKHHk320teasmalltable2PEKKHHe62teastoolJRAKPAHe63teastoolKRAKPAHf68chinastoolredPBRAKPAHf69chinastoolredQBRAKPAHf610chinastoolredRBRAKPAHf611chinastoolredSBRAKPAHa82teatable1JPBKHHb83teatable2KPBKHHm92teastool2JQBKHHm93teastool2KQBKHHe916teastoolPDQBKPAHe917teastoolQDQBKPAHa1116teatable1PDSBKHHb1117teatable2QDSBKHHe122teastoolJPCKPAHe123teastoolKPCKPAHm1216teastool2PDPCKHHm1217teastool2QDPCKHHa142teatable1JRCKHHb143teatable2KRCKHHm152teastool2JSCKHHm153teastool2KSCKHHd180teavaseHRDIHHg190chinastoolgreenHSDIJHg200chinastoolgreenHPEIJHd210teavaseHQEIH', '0', ''),
('rooftop', 17, 12, 4, 2, '44xxxxxxxxxxxxxxxxxx\r\n444xxxxxxxxxxx444444\r\n4444xxxxxxxxxx444444\r\n44444xxxx4xxxx444444\r\n444444xxx44xxx444444\r\n44444444444444444444\r\n44444444444444444444\r\n44444444444444444444\r\n44444444xx44xx44xx44\r\n44444444xx44xx44xx44\r\n44444444444444444444\r\n44444444444444444444\r\n44444444444444444444\r\nx444444x444444xx4444\r\nx444444x444444xx333x\r\nx444444x444444xx222x\r\nx444444x444444xx11xx\r\nx444444x444444xxxxxx', 'PKHa10rooftop_minichairHIPAPAHd116rooftop_flatcurbPDIPAPAHe117rooftop_flatcurb2QDIPAPAHc20rooftop_rodtableHJPAHHa21rooftop_minichairIJPARAHa30rooftop_minichairHKPAHHd416rooftop_flatcurbPDPAPAHHe417rooftop_flatcurb2QDPAPAHHa62rooftop_minichairJRAPAPAHa71rooftop_minichairISAPAJHc72rooftop_rodtableJSAPAHHa73rooftop_minichairKSAPARAHa82rooftop_minichairJPBPAHHa90rooftop_minichairHQBPAPAHb100rooftop_emptytableHRBPAHHa110rooftop_minichairHSBPAHHd131rooftop_flatcurbIQCPAJHd136rooftop_flatcurbRAQCPARAHd138rooftop_flatcurbPBQCPAJHd1313rooftop_flatcurbQCQCPARAHf141rooftop_flatcurb3IRCPAJHf146rooftop_flatcurb3RARCPARAHf148rooftop_flatcurb3PBRCPAJHf1413rooftop_flatcurb3QCRCPARAHf151rooftop_flatcurb3ISCPAJHf156rooftop_flatcurb3RASCPARAHf158rooftop_flatcurb3PBSCPAJHf1513rooftop_flatcurb3QCSCPARAHf161rooftop_flatcurb3IPDPAJHf166rooftop_flatcurb3RAPDPARAHf168rooftop_flatcurb3PBPDPAJHf1613rooftop_flatcurb3QCPDPARAHg171rooftop_flatcurb4IQDPAHHf172rooftop_flatcurb3JQDPAHHf173rooftop_flatcurb3KQDPAHHf174rooftop_flatcurb3PAQDPAHHf175rooftop_flatcurb3QAQDPAHHh176rooftop_flatcurb5RAQDPAHHg178rooftop_flatcurb4PBQDPAHHf179rooftop_flatcurb3QBQDPAHHf1710rooftop_flatcurb3RBQDPAHHf1711rooftop_flatcurb3SBQDPAHHf1712rooftop_flatcurb3PCQDPAHHh1713rooftop_flatcurb5QCQDPAH', '0', ''),
('rooftop_2', 4, 9, 0, 2, 'x0000x000\r\nxxxxxx000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\n000000000\r\nxxx000xxx\r\nxxx000xxx', 'RDHk08rooftop_bigchairPBHHPAHl18rooftop_bigtablePBIHHHj20rooftop_sofabHJHPAHi21rooftop_sofaIJHPAHk28rooftop_bigchairPBJHHHk38rooftop_bigchairPBKHPAHl48rooftop_bigtablePBPAHHHj50rooftop_sofabHQAHHHi51rooftop_sofaIQAHHHk58rooftop_bigchairPBQAHHHj60rooftop_sofabHRAHPAHi61rooftop_sofaIRAHPAHj67rooftop_sofabSARAHPAHi68rooftop_sofaPBRAHPAHj90rooftop_sofabHQBHHHi91rooftop_sofaIQBHHHj97rooftop_sofabSAQBHHHi98rooftop_sofaPBQBHH', '0', ''),
('star_lounge', 37, 36, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx2222x4444442222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222x444x32222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222xx4xx22222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx222222222222222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx222222222222222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx222222222222222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx222222222222222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx222222222222222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx222222222222222xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222222222222211111xxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222222222222211111xxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222222222222211111xxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222222222222211111xxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222222222222222111xxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx22222222222222222111xxxxxxxxx\r\nxxxxxxxxxxxxxxxx3333x22222222222222xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx3333x22222222222222xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx3333x22222222221111xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx3333xx2x22222220000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx333333332222222000000xxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx333333332222222x0000000xxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx33333332222222x0000000xxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxx222222000000xxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'PXHk1521star_tableQESCJHHa1522star_sofaRESCJPAHb1523star_sofa2SESCJPAHz1524palmPFSCJHHb1621star_sofa2QEPDJJHQ1632dj1PHPDJHHW1633dj2QHPDJHHE1634dj3RHPDJHHa1721star_sofaQEQDJJHm1728star_microphonePGQDPAHHb1821star_sofa2QERDJJHa1835star_sofaSHRDJRAHa1921star_sofaQESDJJHb1935star_sofa2SHSDJRAHb2021star_sofa2QEPEJJHb2024star_sofa2PFPEJJHa2032star_sofaPHPEJRAHa2035star_sofaSHPEJRAHa2121star_sofaQEQEJJHa2124star_sofaPFQEJJHb2132star_sofa2PHQEJRAHb2135star_sofa2SHQEJRAHc2221star_sofachairQEREJJHk2224star_tablePFREJHHb2225star_sofa2QFREJHHa2226star_sofaRFREJHHb2230star_sofa2RGREJHHa2231star_sofaSGREJHHk2232star_tablePHREJHHk2235star_tableSHREJHHz2321palmQESEJHHa2335star_sofaSHSEJRAHp2422bar10REPFJHHb2435star_sofa2SHPFJRAHa2437star_sofaQIPFIPAHb2438star_sofa2RIPFIPAHa2439star_sofaSIPFIPAHb2440star_sofa2PJPFIPAHo2522bar9REQFJHHb2525star_sofa2QFQFJHHa2526star_sofaRFQFJHHb2530star_sofa2RGQFJHHa2531star_sofaSGQFJHHa2535star_sofaSHQFJRAHb2536star_sofa2PIQFIJHi2622bar8RERFJHHX2625palm1QFRFJHHV2626palm3RFRFJHHC2630palm2RGRFJHHB2631palm4SGRFJHHb2635star_sofa2SHRFJRAHa2636star_sofaPIRFIJHk2639star_tableSIRFIHHk2640star_tablePJRFIHHu2722bar7RESFJHHa2725star_sofaQFSFJPAHb2726star_sofa2RFSFJPAHa2730star_sofaRGSFJPAHb2731star_sofa2SGSFJPAHk2735star_tableSHSFJHHz2736palmPISFIHHk2737star_tableQISFIHHy2822bar6REPGJHHt2922bar5REQGJHHk2925star_tableQFQGJHHk2926star_tableRFQGJHHk3016star_tablePDRGKHHr3022bar4RERGJHHb3116star_sofa2PDSGKJHe3122bar3RESGJHHb3125star_sofa2QFSGJHHa3126star_sofaRFSGJHHa3130star_sofaRGSGJRAHa3216star_sofaPDPHKJHw3222bar2REPHJHHB3225palm4QFPHJHHX3226palm1RFPHJHHb3230star_sofa2RGPHJRAHb3316star_sofa2PDQHKJHq3322bar1REQHJHHa3325star_sofaQFQHJPAHb3326star_sofa2RFQHJPAHa3330star_sofaRGQHJRAHa3416star_sofaPDRHKJHb3430star_sofa2RGRHJRAHV3435palm3SHRHHHHC3436palm2PIRHHHHk3516star_tablePDSHKHHa3530star_sofaRGSHJRAHb3630star_sofa2RGPIJRAHc3725star_sofachairQFQIJHHb3726star_sofa2RFQIJHHa3727star_sofaSFQIJHHb3728star_sofa2PGQIJHHa3729star_sofaQGQIJHHk3730star_tableRGQIJH', '0', ''),
('netcafe', 22, 12, 0, 2, 'xxxxx1111xxxxxxxxxxx1xxxx\r\nxxxxx1111111111111111xxxx\r\nxxxxx1111111111111111xxxx\r\nxxxxx1111111111111111xxxx\r\nxxxxxxxx0000000000000xxxx\r\n111111100000000000000xxxx\r\n111111100000000000000xxxx\r\n111111100000000000000xxxx\r\nxxxx11100000000000000xxxx\r\nx1xx11100000000000000xxxx\r\nx1xx11100000000000000xxxx\r\nx1xx111000000000000000000\r\nx1xx111000000000000000000\r\nxxxx111000000000000000000\r\nxxxx11100000000000000xxxx\r\nxxxx1110000000xx11111xxxx\r\nxxxxx111110000x111111xxxx\r\nxxxxxx111100001111111xxxx\r\nxxxxxx111100001111111xxxx\r\nxxxxxx111100001111111xxxx\r\nxxxxxx111100001111111xxxx\r\nxxxxxx111100001111111xxxx\r\nxxxxxx111100001111111xxxx\r\nxxxxx1111100001111111xxxx', 'RRHi06shift1RAHIPAHj07shift2SAHIPAHm110mRBIIHHl113lQCIIHHk116kPDIIHHk119kSDIIHHh35kukat6QAKIHHg36kukat5RAKIHHc312kukat2PCKIHHb313kukat1QCKIHHc319kukat2SDKIHHb320kukat1PEKIHHi412shift1PCPAHPAHj413shift2QCPAHPAHi419shift1SDPAHPAHj420shift2PEPAHPAHi50shift1HQAIPAHj51shift2IQAIPAHi52shift1JQAIPAHj53shift2KQAIPAHk715kSCSAHJHo716table2PDSAHRAHz717tablecornerQDSAHHHm718mRDSAHRAHl815lSCPBHJHo816table2PDPBHPAHl818lRDPBHRAHm94mPAQBIRAHk99kQBQBHJHp910table3RBQBHRAHz911tablecornerSBQBHHHm912mPCQBHRAHk915kSCQBHJHo916table2PDQBHJHk918kRDQBHRAHk104kPARBIRAHm109mQBRBHJHp1010table3RBRBHPAHm1012mPCRBHRAHm1015mSCRBHJHo1016table2PDRBHHHk1018kRDRBHRAHl114lPASBIRAHl119lQBSBHJHp1110table3RBSBHJHl1112lPCSBHRAHk124kPAPCIRAHl129lQBPCHJHp1210table3RBPCHHHk1212kPCPCHRAHm134mPAQCIRAHc165kukat2QAPDIHHb166kukat1RAPDIHHc167kukat2SAPDIHHb168kukat1PBPDIHHe169kukat3QBPDIHHd1615kukka2SCPDIHHf179kukat4QBQDIHHk186kRARDIRAHe189kukat3QBRDIHHs1820sofabig3PERDIRAHf199kukat4QBSDIHHn1917table1QDSDIPAHz1918tablecornerRDSDIHHr1920sofabig2PESDIRAHn2017table1QDPEIJHr2020sofabig2PEPEIRAHm216mRAQEIRAHn2117table1QDQEIHHq2120sofabig1PEQEIRAHv2316sofalittle3PDSEIHHu2317sofalittle2QDSEIHHt2318sofalittle1RDSEIHHa2320kukkaPESEIH', '0', ''),
('dusty_lounge', 14, 1, 2, 4, 'xxxxxxxxxxxxxx22xxxxxxxxxxxxx\r\nxxxxxxxxxx222x222x2xxxxxxxxxx\r\nxxxxxxx33322222222223xxxxxxx3\r\nxxxxxxx33322222222223xxxxxxx3\r\nxxxxxxx33322222222223x33333x3\r\nxxxxxxx33322222222223x33333x3\r\nxx111xx33322222222223xxxxxxx3\r\nxx111xxx332222222222333333333\r\nxx111xxxx32222222222333333333\r\nxx111xxxxxx222222222333333333\r\nxx111xxxxxxx1111111x333333333\r\nxx111xxxxxxx1111111x222222222\r\nxx111xxxxxx111111111111111111\r\nxx111xxxxxx111111111111111111\r\n11111xxxxxx111111111111111111\r\n11111xxxxxx111111111111111111\r\n11x11xxxxxx111111111111111111\r\n11xxxxxxxxx11111111111111111x\r\nx11xxxxxxxxx1111111x1111111xx\r\nxx11xxxxxxx111111111111111xxx\r\nxxx11xxxxxx11111111111111xxxx\r\nxxxx11111111111111111111xxxxx\r\nxxxxx11111111111111xxxxxxxxxx\r\nxxxxxxxxxxx11111111xxxxxxxxxx\r\nxxxxxxxxxxx11111111xxxxxxxxxx', 'QHHc48greenchair2PBPAKPAHd49greenchair1QBPAKPAHc68greenchair2PBRAKHHd69greenchair1QBRAKHHa620dustylampPERAKJHa628dustylampPGRAKJHc73greenchair2KSAIPAHd74greenchair1PASAIPAHc93greenchair2KQBIHHd94greenchair1PAQBIHHb1021yellowchairQERBKJHb1023yellowchairSERBKRAHb1026yellowchairRFRBKJHb1028yellowchairPGRBKRAHc1211greenchair2SBPCIJHc133greenchair2KQCIPAHd134greenchair1PAQCIPAHd1311greenchair1SBQCIJHa1411dustylampSBRCIJHc153greenchair2KSCIHHd154greenchair1PASCIHHc1511greenchair2SBSCIJHb1524yellowchairPFSCIPAHd1611greenchair1SBPDIJHb1722yellowchairREQDIJHa1724dustylampPFQDIJHb1726yellowchairRFQDIRAHa1911dustylampSBSDIJHb1924yellowchairPFSDIHHc2312greenchair2PCSEIJHc2314greenchair2RCSEIRAHd2412greenchair1PCPFIJHd2414greenchair1RCPFIRA', '0', ''),
('orient', 35, 22, 0, 6, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx1xx000x000xx111x111xxx\r\nxxxxxxxxxxxxxx1xx000x000xxxxxx1111xx\r\nxxxxxxxxxxxxxx1xx000x000x111111111xx\r\nxxxxxxxxxxxxxx1xx000x000x111111111xx\r\nxxx111111111111xx000x000x111111111xx\r\nxxx1xxxxxxxxxxxxx000x000x111111111xx\r\nxxx1x1111111111000000000x111111111xx\r\nxxx1x1111111111000000000xx1111111xxx\r\nxxx1x11xxxxxx11000000000xx1111111100\r\nxxx111xxxxxxx11000000000011111111100\r\nxxx111xxxxxxx11000000000011111111100\r\nxxxxx1xxxxxxx11000000000011111111100\r\nxxxxx11xxxxxx11000000000xx1111111100\r\nxxxxx1111111111000000000xx1111111xxx\r\nxxxxx1111111111xx000x000x111111111xx\r\nxxxxxxxxxxxxxxxxx000x000x111111111xx\r\nxxxxxxxxxxxxxxxxx000x000x111111111xx\r\nxxxxxxxxxxxxxxxxx000x000x111111111xx\r\nxxxxxxxxxxxxxxxxx000x000x111111111xx\r\nxxxxxxxxxxxxxxxxx000x00xx11xxxx111xx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxx11111111xx', 'SOHd1017benchQDRBHJHd1019benchSDRBHRAHd1021benchQERBHJHd1023benchSERBHRAHd1117benchQDSBHJHd1119benchSDSBHRAHd1121benchQESBHJHd1123benchSESBHRAHb1132koc_chairPHSBIPAHd1217benchQDPCHJHd1219benchSDPCHRAHd1221benchQEPCHJHd1223benchSEPCHRAHb1231koc_chairSGPCIJHa1232koc_tablePHPCIHHb1233koc_chairQHPCIRAHd1317benchQDQCHJHd1319benchSDQCHRAHd1321benchQEQCHJHd1323benchSEQCHRAHb1325koc_chairQFQCIPAHb1332koc_chairPHQCIHHd1417benchQDRCHJHd1419benchSDRCHRAHd1421benchQERCHJHd1423benchSERCHRAHa1425koc_tableQFRCIHHb1426koc_chairRFRCIRAHd1517benchQDSCHJHd1519benchSDSCHRAHd1521benchQESCHJHd1523benchSESCHRAHb1525koc_chairQFSCIHHb1529koc_chairQGSCIJHa1530koc_tableRGSCIHHb1531koc_chairSGSCIRAHb1630koc_chairRGPDIHHc2425chairf1QFPFIJHc2433chairf1QHPFIRAHd2517benchQDQFHJHd2519benchSDQFHRAHd2521benchQEQFHJHd2523benchSEQFHRAHc2525chairf1QFQFIJHc2533chairf1QHQFIRAHd2617benchQDRFHJHd2619benchSDRFHRAHd2621benchQERFHJHd2623benchSERFHRAHc2625chairf1QFRFIJHc2633chairf1QHRFIRAHd2717benchQDSFHJHd2719benchSDSFHRAHd2721benchQESFHJHd2723benchSESFHRAHd2817benchQDPGHJHd2819benchSDPGHRAHd2821benchQEPGHJHd2823benchSEPGHRAHd2917benchQDQGHJHd2919benchSDQGHRAHd2921benchQEQGHJHd2923benchSEQG`hFFRA', '0', ''),
('custom_model', 0, 0, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxx\r\nxxxxxxxxxxx000000000000000xxx\r\nxxxxxxxxxx00000000000000000xx\r\nxxxxxxxxxx00000000000000000xx\r\nxxxxxxxxxx00000000000000000xx\r\nxxxxxxxxxx11111111111111111xx\r\nxxxxxxxxxx22222222222222222xx\r\nxxxxxxxxxx22222222222222222xx\r\nxxxxxxxxxx22222222222222222xx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '0', ''),
('theater', 20, 27, 0, 0, 'xxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxx111111111xxxxxxx\r\nxxxxxxx11111111100000xx\r\nxxxx00x11111111100000xx\r\nxxxx00x11111111100000xx\r\n4xxx00x11111111100000xx\r\n4440000xxxxxxxxx00000xx\r\n444000000000000000000xx\r\n4xx000000000000000000xx\r\n4xx0000000000000000000x\r\n44400000000000000000000\r\n44400000000000000000000\r\n44x00000000000000000000\r\n44x11111111111111111000\r\n44x11111111111111111000\r\n33x11111111111111111000\r\n22x11111111111111111000\r\n22x11111111111111111000\r\n22x11111111111111111000\r\n22x11111111111111111000\r\n22x11111111111111111000\r\n22211111111111111111000\r\n22211111111111111111000\r\nxxxxxxxxxxxxxxxxxxxx00x\r\nxxxxxxxxxxxxxxxxxxxx00x', 'QKHm1011micSBRBIHHd112thchair2JSBPAJHd122thchair2JPCPAJHd152thchair2JSCPAJHc156thchair1RASCHHHc157thchair1SASCHHHc158thchair1PBSCHHHc159thchair1QBSCHHHc1510thchair1RBSCHHHc1512thchair1PCSCHHHc1513thchair1QCSCHHHc1514thchair1RCSCHHHc1515thchair1SCSCHHHc1516thchair1PDSCHHHd162thchair2JPDPAJHc206thchair1RAPEIHHc207thchair1SAPEIHHc208thchair1PBPEIHHc209thchair1QBPEIHHc2010thchair1RBPEIHHc2012thchair1PCPEIHHc2013thchair1QCPEIHHc2014thchair1RCPEIHHc2015thchair1SCPEIHHc2016thchair1PDPEIHHc236thchair1RASEIHHc237thchair1SASEIHHc238thchair1PBSEIHHc239thchair1QBSEIHHc2310thchair1RBSEIHHc2312thchair1PCSEIHHc2313thchair1QCSEIHHc2314thchair1RCSEIHHc2315thchair1SCSEIHHc2316thchair1PDSEIHHc266thchair1RARFIHHc267thchair1SARFIHHc268thchair1PBRFIHHc269thchair1QBRFIHHc2610thchair1RBRFIHHc2612thchair1PCRFIHHc2613thchair1QCRFIHHc2614thchair1RCRFIHHc2615thchair1SCRFIHHc2616thchair1PDRFIH', '0', ''),
('picnic', 16, 5, 2, 4, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxx22222xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\n22xxxxxxxxxxxxx22xxxxxxxxxxxxxxxxxxxxx\r\n2222222222222222222x222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222xxx222222222222222222222222\r\n2222222222xx33x22222222222222222222222\r\n222222222xx3333x2222222222222222222222\r\n222222222x333333x222222222222222222222\r\n222222222x333333x222222222222222222222\r\n2222222222x3332x2222222222222222222222\r\n22222222222x33x22222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222222222222222222222222222222222\r\n22222222x22222xxxx22222222222222222222\r\n22222222222222xxxx22222222222222222222\r\n22222222222222xxx22222222222222222x222\r\n2222222222222222222222222222222222x222\r\n2222222222222222222222222222222222x222\r\n2222222222222222222222222222222222x222\r\n2222222222222222222222222222222222x222\r\n22222222222222222222222x2222222222x222\r\n22222222222222222222222x2222222222x222\r\nx2222222222222222222222x222222222xx222\r\n2x222222222222222222222x22222222222222\r\n2x222222222222222222222x22222222222222\r\n22x22222222222222222222x22222222222222\r\n222x2222222222222222222x22222222222222\r\n2222x222222222222222222x22222222222222\r\n22222x22222222222222222x22222222222222\r\n222222x2222222222222222x22222222222222\r\n2222222x222222222222222x22222222222222\r\n22222222x22222222222222x22222222222222\r\n222222222xxxxxxxxxxxxxxx22222222222222\r\n2222222222xxxxxxxxxxxxxx22222222222222', 'PcHh710hedge7RBSAJPAHh711hedge7SBSAJPAHh712hedge7PCSAJPAHh713hedge7QCSAJPAHy714hedge8RCSAJPAHs718hedge2RDSAJPAHh719hedge7SDSAJPAHh720hedge7PESAJPAHh721hedge7QESAJPAHz814hedge9RCPBJPAHz818hedge9RDPBJPAHv93hedge5KQBJPAHz103hedge9KRBJPAHc1112picnic_dummychair1PCSBKPAHc1113picnic_dummychair1QCSBKPAHc1114picnic_dummychair1RCSB`hFFPAHc1310picnic_dummychair1RBQCKJHc1315picnic_dummychair1SCQCKRAHb1321picnic_groundQEQCJPAHb147picnic_groundSARCJPAHc1410picnic_dummychair1RBRCKJHc1415picnic_dummychair1SCRCKRAHb1519picnic_groundSDSCJJHb1523picnic_groundSESCJRAHb165picnic_groundQAPDJJHb169picnic_groundQBPDJRAHL1620picnic_cloth1PEPDJJHL176picnic_cloth1RAQDJJHb1721picnic_groundQEQDJHHb187picnic_groundSARDJHHa190picnic_redbench2HSDJJHA200picnic_redbench1HPEJJHw2011hedge6SBPEJPAHh2012hedge7PCPEJPAHh2013hedge7QCPEJPAHt2014hedge3RCPEJPAHu2017hedge4QDPEJPAHh2018hedge7RDPEJPAHh2019hedge7SDPEJPAHy2020hedge8PEPEJPAHv2111hedge5SBQEJPAHM2112picnic_bench1PCQEJPAHN2113picnic_bench2QCQEJPAHO2114picnic_bench3RCQEJPAHM2117picnic_bench1QDQEJPAHN2118picnic_bench2RDQEJPAHO2119picnic_bench3SDQEJPAHv2120hedge5PEQEJPAHa220picnic_redbench2HREJJHv2211hedge5SBREJPAHv2220hedge5PEREJPAHb2225picnic_groundQFREJPAHA230picnic_redbench1HSEJJHv2311hedge5SBSEJPAHM2312picnic_bench1PCSEJJHM2319picnic_bench1SDSEJRAHv2320hedge5PESEJPAHc246picnic_dummychair1RAPFJPAHd247picnic_dummychair4SAPFJPAHe248picnic_dummychair6PBPFJPAHv2411hedge5SBPFJPAHN2412picnic_bench2PCPFJJHN2419picnic_bench2SDPFJRAHv2420hedge5PEPFJPAHb2423picnic_groundSEPFJJHb2427picnic_groundSFPFJRAHK255picnic_stumpQAQFJJHv2511hedge5SBQFJPAHN2512picnic_bench2PCQFJJHN2519picnic_bench2SDQFJRAHv2520hedge5PEQFJPAHG2524picnic_cloth2PFQFJJHK267picnic_stumpSARFJHHv2611hedge5SBRFJPAHO2612picnic_bench3PCRFJJHH2614picnic_fireplace1RCRFJHHI2616picnic_fireplace2PDRFJJHO2619picnic_bench3SDRFJRAHv2620hedge5PERFJPAHb2625picnic_groundQFRFJHHz2711hedge9SBSFJPAHQ2712picnic_lemonadePCSFJPAHz2720hedge9PESFJPAHE298picnic_firewood2PBQGJHHa300picnic_redbench2HRGJJHD308picnic_firewood1PBRGJHHA310picnic_redbench1HSGJJHD318picnic_firewood1PBSGJHHM3112picnic_bench1PCSGJPAHN3113picnic_bench2QCSGJPAHO3114picnic_bench3RCSGJPAHM3118picnic_bench1RDSGJPAHN3119picnic_bench2SDSGJPAHO3120picnic_bench3PESGJPAHf3127picnic_carrotSFSGJHHf3128picnic_carrotPGSGJHHf3129picnic_carrotQGSGJHHf3130picnic_carrotRGSGJHHf3131picnic_carrotSGSGJHHD328picnic_firewood1PBPHJHHF3212picnic_table2PCPHJJHP3214picnic_tableRCPHJJHF3218picnic_table2RDPHJJHP3220picnic_tablePEPHJJHr333hedge1KQHJPAHD338picnic_firewood1PBQHJHHM3312picnic_bench1PCQHJHHN3313picnic_bench2QCQHJHHO3314picnic_bench3RCQHJHHM3318picnic_bench1RDQHJHHN3319picnic_bench2SDQHJHHO3320picnic_bench3PEQHJHHg3327picnic_cabbageSFQHJHHg3328picnic_cabbagePGQHJHHg3329picnic_cabbageQGQHJHHv343hedge5KRHJPAHD348picnic_firewood1PBRHJHHv353hedge5KSHJPAHD358picnic_firewood1PBSHJHHv363hedge5KPIJPAHD368picnic_firewood1PBPIJHHD378picnic_firewood1PBQIJHHM3712picnic_bench1PCQIJPAHN3713picnic_bench2QCQIJPAHO3714picnic_bench3RCQIJPAHM3718picnic_bench1RDQIJPAHN3719picnic_bench2SDQIJPAHO3720picnic_bench3PEQIJPAHD388picnic_firewood1PBRIJHHF3812picnic_table2PCRIJJHP3814picnic_tableRCRIJJHF3818picnic_table2RDRIJJHP3820picnic_tablePERIJJHJ398picnic_firewood3PBSIJHHM3912picnic_bench1PCSIJHHN3913picnic_bench2QCSIJHHO3914picnic_bench3RCSIJHHM3918picnic_bench1RDSIJHHN3919picnic_bench2SDSIJHHO3920picnic_bench3PESIJH', '0', ''),
('cinema_a', 20, 27, 1, 0, 'xxxxxxx1xx11111111xxxxxx\r\nxxx1111111111111111xxxxx\r\nxxx111xxxx1111111111xxxx\r\nxxxx2xxxxxxxxxxxxxxxxxxx\r\nxx3x3x333311xxxxxxxxxx11\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111111122111\r\nxx3333333311x22222222111\r\nxx3333333311x22222222111\r\nxx3333333311xxxxxxxxx111\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111111111111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\nxx3333333311111xxxx11111\r\n333333332111111xxxx11111\r\n333333332111111111111111\r\n333333332111111111111111\r\n333333332111111111111111\r\nxx3333332111111111111111\r\nxxxxxxxxxxxxxxxxxxx11111\r\nxxxxxxxxxxxxxxxxxxx11111\r\nxxxxxxxxxxxxxxxxxxx11111', 'PUHC42orangeJPAKHHA47loungey_chairSAPAKJHV48loungey_tablebigbPBPAKHHA49loungey_chairQBPAKRAHA52loungey_chairJQAKPAHA57loungey_chairSAQAKJHU58loungey_tablebigaPBQAKHHA59loungey_chairQBQAKRAHB62loungey_tableJRAKHHA72loungey_chairJSAKHHh713theater_chairQCSAIHHh714theater_chairRCSAIHHh715theater_chairSCSAIHHh716theater_chairPDSAIHHh717theater_chairQDSAIHHh718theater_chairRDSAIHHz721stairQESAIHHL89lightpoleQBPBKHHq813pomomaskiQCPBJJHq814pomomaskiRCPBJHHq815pomomaskiSCPBJHHq816pomomaskiPDPBJHHq817pomomaskiQDPBJHHq818pomomaskiRDPBJHHq819pomomaskiSDPBJIHz821stairQEPBIHHC92orangeJQBKHHh913theater_chairQCQBJHHh914theater_chairRCQBJHHh915theater_chairSCQBJHHh916theater_chairPDQBJHHh917theater_chairQDQBJHHh918theater_chairRDQBJHHh919theater_chairSDQBJHHh920theater_chairPEQBJHHz921stairQEQBIHHA102loungey_chairJRBKPAHA109loungey_chairQBRBKPAHB112loungey_tableJSBKHHB119loungey_tableQBSBKHHA122loungey_chairJPCKHHA129loungey_chairQBPCKHHd1217cubicb_chairQDPCIRAHc1219cubico_chairSDPCIJHd1315cubicb_chairSCQCIJHL1319lightpoleSDQCIHHd1320cubicb_chairPEQCIRAHL149lightpoleQBRCKHHA152loungey_chairJSCKPAHd1514cubicb_chairRCSCIPAHc1519cubico_chairSDSCIPAHB162loungey_tableJPDKHHA167loungey_chairSAPDKJHB168loungey_tablePBPDKJHA169loungey_chairQBPDKRAHd1613cubicb_chairQCPDIJHd1614cubicb_chairRCPDIRAHC1619orangeSDPDIHHA172loungey_chairJQDKHHA177loungey_chairSAQDKJHB178loungey_tablePBQDKJHA179loungey_chairQBQDKRAHd1719cubicb_chairSDQDIJHC182orangeJRDKHHd1814cubicb_chairRCRDIPAHK192bardesqueJSDKHHK202bardesqueJPEKIHb203bar_chairKPEKRAHL209lightpoleQBPEKHHd2014cubicb_chairRCPEIHHd2019cubicb_chairSDPEIJHc2020cubico_chairPEPEIRAHK212bardesqueJQEKIHb213bar_chairKQEKRAHd2119cubicb_chairSDQEIHHK222bardesqueJREKIHb223bar_chairKREKRAHL2216lightpolePDREIHHc2218cubico_chairRDREIHHK232bardesqueJSEKIHb233bar_chairKSEKRAHK242bardesqueJPFKIHb243bar_chairKPFKRAHK252bardesqueJQFKJ', '0', ''),
('the_den', 3, 22, 0, 0, '00000000xxxxxxxx\r\n0000000000000000\r\n0000000000000000\r\n000000000000xx00\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\nx000000000000000\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\n0000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nx000000000000000\r\nxxx00xxxxxxxxxxx\r\nxxx00xxxxxxxxxxx\r\nxxx00xxxxxxxxxxx', '', '0', ''),
('model_s', 0, 3, 0, 2, 'xxxxxx\r\nx00000\r\nx00000\r\n000000\r\nx00000\r\nx00000\r\nx00000\r\nx00000', '', '0', ''),
('park_a', 2, 15, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0xxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00xxxxxxxxxxxx\r\nxxxxxxxxxxxxx0x00xxxxxxxxxxx0x000xxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000000000000xxxxxxxxxx\r\nxxxxxxxxxxx000000000000000000000000xxxxxxxxx\r\nxxxxxxxxxxx0000000000000000000000000xxxxxxxx\r\nxxxxxxxxxxx00000000000000000000000000xxxxxxx\r\nxxxxxxxx000000000000000000000000000000xxxxxx\r\nxxxxxxx00000000000000000000000000000000xxxxx\r\nxxxxxxx000000000000000000000000000000000xxxx\r\nxxxxxxx0000000000000000000000000000000000xxx\r\nxxxxxxxxx000000000000000000000000000000000xx\r\n00000000000000000000xx00000000000000000000xx\r\n0000000000000000000xxxx00000000000xxxxxxx0xx\r\n0000000000000000000xxxx00000000000x00000xxxx\r\nxxxxx00x0000000000xxxxx0xxxxxx0000x0000000xx\r\nxxxxx0000000000000xxxxx0xx000x0000x000000xxx\r\nxxxxx0000000000000xxxxx0x000000000x00000xxxx\r\nxxxxx000000x0000000xxxx0x000000000xxx00xxxxx\r\nxxxxxxxx000x0000000xxx00xxx000000x0000xxxxxx\r\nxxxxxxxx000x000000xxxx0x0000000000000xxxxxxx\r\nxxxxxxxx000x000000011100000000000000xxxxxxxx\r\nxxxxxxxx000x00000001110000000000000xxxxxxxxx\r\nxxxxxxxxx00x0000000111x00000000x00xxxxxxxxxx\r\nxxxxxxxxxx0x0000000xxx0000000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx000000xxxx0000000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx000000xxx00xxxxx00xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxx0xx000x00xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxx0x000000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxxxx00000xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxxxx00xxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxx0xxxxxxxxxxxxxxxxxxxx', 'RPHN527parkfence2SFQAHHHN529parkfence2QGQAHHHM619parkfence1SDRAHHHO620parkfence3PERAHPAHO621parkfence3QERAHPAHO622parkfence3RERAHPAHN623parkfence2SERAHPAHO624parkfence3PFRAHPAHO625parkfence3QFRAHPAHO626parkfence3RFRAHPAHM627parkfence1SFRAHJHO629parkfence3QGRAHJHN717parkfence2QDSAHHHO719parkfence3SDSAHJHO723parkfence3SESAHJHO727parkfence3SFSAHJHO729parkfence3QGSAHJHO817parkfence3QDPBHJHO819parkfence3SDPBHJHN821parkfence2QEPBHHHO823parkfence3SEPBHJHN825parkfence2QFPBHHHO827parkfence3SFPBHJHO829parkfence3QGPBHJHL98bench2PBQBHPAHK99benchQBQBHPAHO917parkfence3QDQBHJHN919parkfence2SDQBHRAHO921parkfence3QEQBHJHN923parkfence2SEQBHRAHO925parkfence3QFQBHJHN927parkfence2SFQBHRAHO929parkfence3QGQBHJHO1017parkfence3QDRBHJHO1021parkfence3QERBHJHO1025parkfence3QFRBHJHO1029parkfence3QGRBHJHL117bench2SASBHJHM1117parkfence1QDSBHPAHO1118parkfence3RDSBHPAHO1119parkfence3SDSBHPAHO1120parkfence3PESBHPAHN1121parkfence2QESBHJHO1122parkfence3RESBHPAHO1123parkfence3SESBHPAHO1124parkfence3PFSBHPAHN1125parkfence2QFSBHJHO1126parkfence3RFSBHPAHO1127parkfence3SFSBHPAHO1128parkfence3PGSBHPAHM1129parkfence1QGSBHRAHK127benchSAPCHJHL1635bench2SHPDHJHL1637bench2QIPDHPAHK1638benchRIPDHPAHK1735benchSHQDHJHL1827bench2SFRDHPAHK1828benchPGRDHPAHL1835bench2SHRDHJHL1925bench2QFSDHJHK1935benchSHSDHJHK2025benchQFPEHJHL2925bench2QFQGHPAHK2926benchRFQGHPAHL3023bench2SERGHJHK3123benchSESGHJ@`SGSBMRDPBPA0.0I2Mqueue_tile2JMPGRAH0.0I2Mqueue_tile2SAMPFSAJ0.0I2Mqueue_tile2QBMRFSAPA0.0I2Mqueue_tile2SFMSERBJ0.0I2Mqueue_tile2SCMRFPBPA0.0I2Mqueue_tile2REMPGQBH0.0I2Mqueue_tile2PGMPFRBH0.0I2Mqueue_tile2PCMPEPBH0.0I2Mqueue_tile2QGMRFRBJ0.0I2Mqueue_tile2QDMRDQBPA0.0I2Mqueue_tile2RFMRERBJ0.0I2Mqueue_tile2PFMSDRBJ0.0I2Mqueue_tile2PDMPGPBH0.0I2Mqueue_tile2RGMSFRBJ0.0I2Mqueue_tile2RAMRESAPA0.0I2Mqueue_tile2RBMPGSAH0.0I2Mqueue_tile2SDMREQBPA0.0I2Mqueue_tile2QEMRFQBPA0.0I2Mqueue_tile2RCMPFPBH0.0I2Mqueue_tile2KMRDSAPA0.0I2Mqueue_tile2PAMPESAJ0.0I2Mqueue_tile2PBMQFSAJ0.0I2Mqueue_tile2IMPGQAH0.0I2Mqueue_tile2SEMRDRBJ0.0I2Mqueue_tile2QCMREPBPA0.0I2Mqueue_tile2SGMPGRBH0.0I2Mqueue_tile2QAMQESAJ0.0I2Mqueue_tile2QFMPERBH0.0I2Mqueue_tile2RDMPEQBH0.0I2Mqueue_tile2PEMPFQBH0.0I2Mqueue_tile2', '0', ''),
('park_b', 11, 2, 0, 6, '0000x0000000\r\n0000xx000000\r\n000000000000\r\n00000000000x\r\n000000000000\r\n00x0000x0000', '', '0', ''),
('model_0', 0, 4, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx00000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx00000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx00000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000\r\n000000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000\r\nx00000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000\r\nx00000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000\r\nx00000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx00000000xx00000000xx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', '');
INSERT INTO `room_models` (`id`, `door_x`, `door_y`, `door_z`, `door_dir`, `heightmap`, `public_items`, `club_only`, `poolmap`) VALUES
('model_v', 0, 3, 2, 2, 'xxxxxxxxxxxxxxxxxxxx\r\nx222221111111111111x\r\nx222221111111111111x\r\n2222221111111111111x\r\nx222221111111111111x\r\nx222221111111111111x\r\nx222221111111111111x\r\nxxxxxxxx1111xxxxxxxx\r\nxxxxxxxx0000xxxxxxxx\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx00000000000x000000x\r\nx00000000000x000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nxxxxxxxx00000000000x\r\nx000000x00000000000x\r\nx000000x0000xxxxxxxx\r\nx00000000000x000000x\r\nx00000000000x000000x\r\nx00000000000x000000x\r\nx00000000000x000000x\r\nxxxxxxxx0000x000000x\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_t', 0, 3, 2, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx222222222222222222222222222x\r\nx222222222222222222222222222x\r\n2222222222222222222222222222x\r\nx222222222222222222222222222x\r\nx2222xxxxxx222222xxxxxxx2222x\r\nx2222xxxxxx111111xxxxxxx2222x\r\nx2222xx111111111111111xx2222x\r\nx2222xx111111111111111xx2222x\r\nx2222xx11xxx1111xxxx11xx2222x\r\nx2222xx11xxx0000xxxx11xx2222x\r\nx22222111x00000000xx11xx2222x\r\nx22222111x00000000xx11xx2222x\r\nx22222111x00000000xx11xx2222x\r\nx22222111x00000000xx11xx2222x\r\nx22222111x00000000xx11xx2222x\r\nx22222111x00000000xx11xx2222x\r\nx2222xx11xxxxxxxxxxx11xx2222x\r\nx2222xx11xxxxxxxxxxx11xx2222x\r\nx2222xx111111111111111xx2222x\r\nx2222xx111111111111111xx2222x\r\nx2222xxxxxxxxxxxxxxxxxxx2222x\r\nx2222xxxxxxxxxxxxxxxxxxx2222x\r\nx222222222222222222222222222x\r\nx222222222222222222222222222x\r\nx222222222222222222222222222x\r\nx222222222222222222222222222x\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_x', 0, 12, 0, 2, 'xxxxxxxxxxxxxxxxxxxx\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nxxx00xxx0000xxx00xxx\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\n0000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000x0000x000000x\r\nx000000xxxxxx000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nx000000000000000000x\r\nxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_w', 0, 3, 2, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx2222xx1111111111xx11111111\r\nx2222xx1111111111xx11111111\r\n222222111111111111111111111\r\nx22222111111111111111111111\r\nx22222111111111111111111111\r\nx22222111111111111111111111\r\nx2222xx1111111111xx11111111\r\nx2222xx1111111111xx11111111\r\nx2222xx1111111111xxxx1111xx\r\nx2222xx1111111111xxxx0000xx\r\nxxxxxxx1111111111xx00000000\r\nxxxxxxx1111111111xx00000000\r\nx22222111111111111000000000\r\nx22222111111111111000000000\r\nx22222111111111111000000000\r\nx22222111111111111000000000\r\nx2222xx1111111111xx00000000\r\nx2222xx1111111111xx00000000\r\nx2222xxxx1111xxxxxxxxxxxxxx\r\nx2222xxxx0000xxxxxxxxxxxxxx\r\nx2222x0000000000xxxxxxxxxxx\r\nx2222x0000000000xxxxxxxxxxx\r\nx2222x0000000000xxxxxxxxxxx\r\nx2222x0000000000xxxxxxxxxxx\r\nx2222x0000000000xxxxxxxxxxx\r\nx2222x0000000000xxxxxxxxxxx', '', '1', ''),
('model_z', 0, 9, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\n000000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_u', 0, 17, 1, 2, 'xxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\n11111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nx1111100000000000000000x\r\nxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_y', 0, 3, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx00000000xx0000000000xx0000x\r\nx00000000xx0000000000xx0000x\r\n000000000xx0000000000xx0000x\r\nx00000000xx0000000000xx0000x\r\nx00000000xx0000xx0000xx0000x\r\nx00000000xx0000xx0000xx0000x\r\nx00000000xx0000xx0000000000x\r\nx00000000xx0000xx0000000000x\r\nxxxxx0000xx0000xx0000000000x\r\nxxxxx0000xx0000xx0000000000x\r\nxxxxx0000xx0000xxxxxxxxxxxxx\r\nxxxxx0000xx0000xxxxxxxxxxxxx\r\nx00000000xx0000000000000000x\r\nx00000000xx0000000000000000x\r\nx00000000xx0000000000000000x\r\nx00000000xx0000000000000000x\r\nx0000xxxxxxxxxxxxxxxxxx0000x\r\nx0000xxxxxxxxxxxxxxxxxx0000x\r\nx00000000000000000000000000x\r\nx00000000000000000000000000x\r\nx00000000000000000000000000x\r\nx00000000000000000000000000x\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_oscar', 0, 15, 1, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx11111111xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx11xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111x11111111x00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111x11111111x00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111x11111111x00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111111111111100000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111111111111100000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111x11111111x00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111x11111111x00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx1111111x11111111x00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx11xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_b2g', 0, 0, 0, 2, 'xxxxxxxxxxxxxx\r\nx00000x000000x\r\nx000000000000x\r\nx00000x000000x\r\nx00000x000000x\r\nx00000x000000x\r\nx00000x000000x\r\nxxx0xxx000000x\r\nx000000000000x\r\nx000000000000x\r\nx000000000000x\r\nx000000000000x\r\nx000000000000x\r\nx000000000000x\r\nx000000000000x\r\nx000000000000x\r\nx000000000000x\r\nx00000xx00000x\r\nxxxxxxxxxxxxxx', '', '1', ''),
('model_opening', 0, 23, 2, 2, 'xxxxxxxxxxxxxxxxxxx\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx222222222222\r\nxxxxxxx111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx222221111111111111\r\nx2222xx111111111111\r\nx2222xx000000000000\r\nx2222xx000000000000\r\nx2222xx000000000000\r\nx2222xx000000000000\r\nx2222xx000000000000\r\n22222xx000000000000\r\nx2222xx000000000000\r\nxxxxxxxxxxxxxxxxxxx', '', '1', ''),
('model_cust1', 0, 3, 0, 2, '000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000\r\n000000000000000000000000', '', '0', ''),
('pool_b', 9, 21, 7, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx7xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx777xxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxx8888888x7xxx77777xxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxx8888888x7xxx777777xxxxxxxxx\r\nxxxxxxxxxxxxxxxx88xxxxx77x7x777777777xxxxxxxx\r\nxxxxxxxxxxxxxxxx88x7777777777777777777xxxxxxx\r\nxxxxxxxxxxxxxxxx88x77777777777777777777xxxxxx\r\nxxxxxxxxxxxxxx9988x77777777777777777777xxxxxx\r\nxxxxxxxxxxxxxx9988x7777777777777777777x00xxxx\r\nxxxxxxxxxxxxxx9988x777777777777777777x0000xxx\r\nxxxxxxxxxxxxxx9988x7777777x0000000000000000xx\r\nxxxxxxxxxxxxxx9988x777777x000000000000000000x\r\n7777777777xxxx9988777777x0x0000000000000000xx\r\nx7777777777xxx998877777x000x00000000000000xxx\r\nxx7777777777xx99887777x00000x000000000000xxxx\r\nxxx7777777777x9988777x0000000x0000000000xxxxx\r\nxxxx777777777x777777x00000000x000000000xxxxxx\r\nxxxxx777777777777777000000000x00000000xxxxxxx\r\nxxxxxx77777777777777000000000x0000000xxxxxxxx\r\nxxxxxxx777777x7777770000000000xxxx00xxxxxxxxx\r\nxxxxxxxx77777777777xx0000000000000xxxxxxxxxxx\r\nxxxxxxxxx777777110000x000000000000xxxxxxxxxxx\r\nxxxxxxxxxx7x77x1100000x0000000000xxxxxxxxxxxx\r\nxxxxxxxxxxx777x11000000x00000000xxxxxxxxxxxxx\r\nxxxxxxxxxxxx771110000000x000000xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxx111100000000x0000xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx11100000000x000xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx1100000000x00xxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx110000000x0xxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx110000000xxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxx1100000xxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxx11000xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxx110xxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxx1xxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'QIHu233umbrellaQHJSAHHb318pool_sofa2RDKPBPAHB319pool_sofa1SDKPBPAHb320pool_sofa2PEKPBPAHB321pool_sofa1QEKPBPAHb322pool_sofa2REKPBPAHB323pool_sofa1SEKPBPAHc333pool_chairQHKSAPAHc432pool_chairPHPASAJHt433pool_tableQHPASAHHc434pool_chairRHPASARAHb516pool_sofa2PDQAPBJHc533pool_chairQHQASAHHB616pool_sofa1PDRAPBJHb716pool_sofa2PDSAPBJHc735pool_chairSHSASAPAHf814flower1RCPBQBHHB816pool_sofa1PDPBPBJHu833umbrellaQHPBSAHHc834pool_chairRHPBSAJHt835pool_tableSHPBSAHHc836pool_chairPIPBSARAHb914pool_sofa2RCQBQBJHb916pool_sofa2PDQBPBJHc935pool_chairSHQBSAHHB1014pool_sofa1RCRBQBJHB1016pool_sofa1PDRBPBJHb1114pool_sofa2RCSBQBJHb1116pool_sofa2PDSBPBJHB1214pool_sofa1RCPCQBJHB1216pool_sofa1PDPCPBJHR133flower2bKQCSAJHr134flower2aPAQCSAJHb1314pool_sofa2RCQCQBJHb1316pool_sofa2PDQCPBJHB1414pool_sofa1RCRCQBJHB1416pool_sofa1PDRCPBJ@`RBRBMQEQBH7.0I2Mqueue_tile2SAMQFSAJ7.0I2Mqueue_tile2JMRFRAH7.0I2Mqueue_tile2QAMSESAJ7.0I2Mqueue_tile2IMRFQAH7.0I2Mqueue_tile2QBMQEPBH7.0I2Mqueue_tile2KMQESAJ7.0I2Mqueue_tile2PBMRFSAH7.0I2Mqueue_tile2PAMRESAJ7.0I2Mqueue_tile2RAMPFSAJ7.0I2Mqueue_tile2', '0', '000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000110000\r\n000000000000000000000000000000000000001111000\r\n000000000000000000000000000111111111111111100\r\n000000000000000000000000001111111111111111110\r\n000000000000000000000000010111111111111111100\r\n000000000000000000000000111011111111111111000\r\n000000000000000000000001111101111111111110000\r\n000000000000000000000011111110111111111100000\r\n000000000000000000000111111110111111111000000\r\n000000000000000000001111111110111111110000000\r\n000000000000000000001111111110111111100000000\r\n000000000000000000001111111111000011000000000\r\n000000000000000000000111111111111100000000000\r\n000000000000000111111011111111111100000000000\r\n000000000000000111111101111111111000000000000\r\n000000000000000111111110111111110000000000000\r\n000000000000001111111111011111100000000000000\r\n000000000000011111111111101111000000000000000\r\n000000000000001111111111101110000000000000000\r\n000000000000000111111111101100000000000000000\r\n000000000000000011111111101000000000000000000\r\n000000000000000001111111110000000000000000000\r\n000000000000000000111111100000000000000000000\r\n000000000000000000011111000000000000000000000\r\n000000000000000000001110000000000000000000000\r\n000000000000000000000100000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000\r\n000000000000000000000000000000000000000000000'),
('pool_a', 1, 24, 7, 6, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx7xxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx777xxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx7777777xxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx77777777xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx77777777xxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx777777777xxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx7xxx777777xxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx7x777777777xxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx7xxx77777777xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx7x777777777x7xxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx7xxx7777777777xxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx777777777777xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx77777777777x2111xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx7777777777x221111xxxxxxxxxxx\r\nxxxxxxxxx7777777777777777x2211111xxxxxxxxxx\r\nxxxxxxxxx7777777777777777x22211111xxxxxxxxx\r\nxxxxxxxxx7777777777777777x222211111xxxxxxxx\r\nxxxxxx77777777777777777777x222211111xxxxxxx\r\nxxxxxx7777777xx777777777777x222211111xxxxxx\r\nxxxxxx7777777xx77777777777772222111111xxxxx\r\nxxxxxx777777777777777777777x22221111111xxxx\r\nxx7777777777777777777777x322222211111111xxx\r\n77777777777777777777777x33222222111111111xx\r\n7777777777777777777777x333222222211111111xx\r\nxx7777777777777777777x333322222222111111xxx\r\nxx7777777777777777777333332222222221111xxxx\r\nxx777xxx777777777777733333222222222211xxxxx\r\nxx777x7x77777777777773333322222222222xxxxxx\r\nxx777x7x7777777777777x33332222222222xxxxxxx\r\nxxx77x7x7777777777777xx333222222222xxxxxxxx\r\nxxxx77777777777777777xxx3222222222xxxxxxxxx\r\nxxxxx777777777777777777xx22222222xxxxxxxxxx\r\nxxxxxx777777777777777777x2222222xxxxxxxxxxx\r\nxxxxxxx777777777777777777222222xxxxxxxxxxxx\r\nxxxxxxxx7777777777777777722222xxxxxxxxxxxxx\r\nxxxxxxxxx77777777777777772222xxxxxxxxxxxxxx\r\nxxxxxxxxxx777777777777777222xxxxxxxxxxxxxxx\r\nxxxxxxxxxxx77777777777777x2xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx77777777777777xxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxx777777777777xxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxx7777777777xxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxx77777777xxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxx777777xxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx7777xxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxx77xxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'RKHu418umbrella2RDPASAHHb518pool_2sofa2RDQASAJHB618pool_2sofa1RDRASAJHu207umbrella2SAPESAHHc208pool_chair2PBPESAPAHu2024umbrella2PFPESAHHc2025pool_chair2QFPESAPAHc217pool_chair2SAQESAJHt218pool_table2PBQESAHHc219pool_chair2QBQESARAHc2124pool_chair2PFQESAJHt2125pool_table2QFQESAHHc228pool_chair2PBRESAHHR282flower2bJPGSAHHr292flower2aJQGSAHHL326boxRAPHSAHHf3313flower1QCQHSAHHy3410pool_chairyRBRHSAPAH8358umbrellayPBSHSAHHy359pool_chairyQBSHSAJHQ3510pool_tableyRBSHSAHHy3511pool_chairySBSHSARAH93515umbrellapSCSHSAHH73521umbrellaoQESHSAHHy3610pool_chairyRBPISAHHP3615pool_chairpSCPISAPAHo3621pool_chairoQEPISAPAHo3622pool_chairoREPISAPAHP3714pool_chairpRCQISAJHZ3715pool_tablepSCQISAHHP3716pool_chairpPDQISARAHK3721pool_taboQEQISARAHk3722pool_tabo2REQISARAHP3814pool_chairpRCRISAJHz3815pool_tablep2SCRISAHHP3816pool_chairpPDRISARAHo3821pool_chairoQERISAHHo3822pool_chairoRERISAHHP3915pool_chairpSCSISAHHg4120pool_chairgPEQJSAPAHg4121pool_chairgQEQJSAPAHW4220pool_tablgPERJSARAHw4221pool_tablg2QERJSARAHG4319umbrellagSDSJSAHHg4320pool_chairgPESJSAHHg4321pool_chairgQESJSAH', '0', '0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000001111000000000000\r\n0000000000000000000000000011111100000000000\r\n0000000000000000000000000011111110000000000\r\n0000000000000000000000000011111111000000000\r\n0000000000000000000000000011111111100000000\r\n0000000000000000000000000001111111110000000\r\n0000000000000000000000000000111111111000000\r\n0000000000000000000000000000111111111100000\r\n0000000000000000000000000000111111111110000\r\n0000000000000000000000000111111111111111000\r\n0000000000000000000000001111111111111111100\r\n0000000000000000000000011111111111111111100\r\n0000000000000000000000111111111111111111000\r\n0000000000000000000001111111111111111110000\r\n0000000000000000000001111111111111111100000\r\n0000000000000000000001111111111111111000000\r\n0000000000000000000000111111111111110000000\r\n0000000000000000000000011111111111100000000\r\n0000000000000000000000001111111111000000000\r\n0000000000000000000000000111111110000000000\r\n0000000000000000000000000111111100000000000\r\n0000000000000000000000000111111000000000000\r\n0000000000000000000000000111110000000000000\r\n0000000000000000000000000111100000000000000\r\n0000000000000000000000000111000000000000000\r\n0000000000000000000000000010000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000'),
('model_k2', 0, 13, 0, 2, 'xxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxxxxxxxxxx00000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\n0000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nx000000000000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxx0000000000000000\r\nxxxxxxxxxxxxxxxxxxxxxxxxx', '', '0', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_models_customs`
--

CREATE TABLE IF NOT EXISTS `room_models_customs` (
  `roomid` int(11) NOT NULL,
  `doorx` int(2) NOT NULL,
  `doory` int(2) NOT NULL,
  `height` double NOT NULL,
  `modeldata` text NOT NULL,
  `poolmap` text NOT NULL,
  PRIMARY KEY (`roomid`),
  UNIQUE KEY `roomid` (`roomid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `room_models_customs`
--

INSERT INTO `room_models_customs` (`roomid`, `doorx`, `doory`, `height`, `modeldata`, `poolmap`) VALUES
(1, 0, 10, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000', ''),
(1846, 18, 1, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxx0xxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxx0000000000000xxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', ''),
(2630, 1, 1, 9, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nx9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x9x\r\nx9999999999999999999999999999999999999x\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', ''),
(4109, 32, 20, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxx33333333333xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222xx1111111111111xxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222xx1111111111111xxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222211111111111111xxxxxxxxxxxxxxx\r\nxxxxxx3333333333332222222222222211111111111111xxxxxxxxxxxxxxx\r\nxxxxxx3333333333332222222222222211111111111111xxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222211111111111111xxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222xx1111111111111xxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222xx1111111111111xxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222xx1111111111111xxxxxxxxxxxxxxx\r\nxxxxxx33333333333xx222222222222xx1111111111111xxxxxxxxxxxxxxx\r\nxxxxxxxxx3333xxxxxx222222222222xxxxxx1111xxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxx2222xxxxxx222222222222xxxxxx0000xxxxxxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxx0000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxx2222222222xxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx000000000000xxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', ''),
(6251, 0, 1, 0, 'x00000000000000000000000000000000x\r\n000000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx0000xxxxxxxxx00000xxxxxxxxxx0000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x\r\nx00000000000000000000000000000000x', ''),
(20036, 5, 27, 0, 'x7777777777x\r\nx7777777777x\r\nx7777777777x\r\nx7777777777x\r\nx7777777777x\r\nx7777777777x\r\nx7777777777x\r\nx7777777777x\r\nx7777777777x\r\nx7777777777x\r\nxxxxxxxx777x\r\nxxxxxxxx777x\r\nxxxxxxxx666x\r\nxxxxxxxx666x\r\nxxxxxxxx555x\r\nxxxxxxxx555x\r\nxxxxxxxx444x\r\nxxxxxxxx444x\r\nxxxxxxxx333x\r\nxxxxxxxx333x\r\nxxxxxxxx222x\r\nxxxxxxxx222x\r\nxxxxxxxx111x\r\nxxxxxxxx111x\r\nxxxxxxxx000x\r\nxxxxxx00000x\r\nxxxxxx00000x\r\nxxxxx000000x\r\nxxxxxx00000x\r\nxxxxxx00000x', ''),
(22142, 6, 3, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxx00xxx00000x\r\nxxxxxxxxxxxxxx00000000x0000xx00000x\r\nxxxxxxDxxxxxxx00000000000000000000x\r\nxxxxxxxxxxxxxx00000000x0000xx00000x\r\nxxxxxxxxxxxxxxxxxxxxxxxx00xxx00000x\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', ''),
(26478, 0, 9, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx00000xxxxx00000000000000000000\r\nx00000xxxxx00000000000000000000\r\nx00000xxxxx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\n000000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nx00000000xx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxx00000000000000000000\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', ''),
(32193, 0, 10, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000', ''),
(77716, 0, 10, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\n0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\r\nx000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000', '0'),
(135830, 0, 5, 0, 'xxxxxxxxxxxxxxxxx0000000000000000xxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0xxxxxxxxxx0xxx0xxxxxxxxxxxxxxxxx\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\n000000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xxxxxxxxxxxxxx000000000000000000\r\nx0000000000000xxxxxxxxxxxxxxxxxxxxxxx0000000000000\r\nx0000000000000xxxxxxxxxxxxxxxxxxxxxxx0000000000000\r\nx0000000000000xx0000000000000000000xx0000000000000\r\nx0000000000000xx0000000000000000000xx0000000000000\r\nx0000000000000xx0000000000000000000xx0000000000000\r\nx0xxxxxxxxxxxxxx0000000000000000000xxxxxxxxxxxxxx0\r\nx0xxxxxxxxxxxxxx0000000000000000000xxxxxxxxxxxxxx0\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx000000000000xxx0000000000000000000xxx0000000000x0\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx0x0000000000xxx0000000000000000000xxx000000000000\r\nx0x0000000000xxx0000000000000000000xxx0000000000x0\r\nx0xxxxxxxxxxxxxx0000000000000000000xxxxxxxxxxxxxx0\r\nx0xxxxxxxxxxxxxx0000000000000000000xxxxxxxxxxxxxx0\r\nx000000000000xxx0000000000000000000xx0000000000000\r\nx000000000000xxx0000000000000000000xx0000000000000\r\nx000000000000xxxxxxxxxxxxxxxxxxxxxxxx0000000000000\r\nx000000000000xxxxxxxxxxxxxxxxxxxxxxxx0000000000000\r\nx00000000000000000xxxxxxxxxxxxxx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nx00000000000000000xx0000000000xx000000000000000000\r\nxxxxxxxxxxxxxxxxx0xxx0xxxxxxxxxx0xxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxx0000000000000000xxxxxxxxxxxxxxxxx\r\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', '');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_model_static`
--

CREATE TABLE IF NOT EXISTS `room_model_static` (
  `model` varchar(30) NOT NULL,
  `x` int(3) NOT NULL,
  `y` int(3) NOT NULL,
  `rot` int(3) NOT NULL,
  `content` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `room_model_static`
--

INSERT INTO `room_model_static` (`model`, `x`, `y`, `rot`, `content`) VALUES
('old_skool', 9, 4, 0, ''),
('old_skool', 10, 4, 0, ''),
('old_skool', 11, 4, 0, ''),
('old_skool', 12, 4, 0, ''),
('old_skool', 1, 10, 4, ''),
('old_skool', 10, 10, 4, ''),
('old_skool', 0, 11, 2, ''),
('old_skool', 3, 11, 6, ''),
('old_skool', 9, 12, 2, ''),
('old_skool', 12, 12, 6, ''),
('old_skool', 1, 13, 0, ''),
('old_skool', 11, 13, 0, ''),
('old_skool', 0, 15, 4, ''),
('old_skool', 0, 17, 2, ''),
('old_skool', 3, 17, 6, ''),
('old_skool', 2, 19, 0, ''),
('old_skool', 1, 21, 4, ''),
('old_skool', 12, 21, 4, ''),
('old_skool', 0, 22, 2, ''),
('old_skool', 3, 22, 6, ''),
('old_skool', 5, 22, 2, ''),
('old_skool', 8, 22, 6, ''),
('old_skool', 11, 22, 2, ''),
('old_skool', 14, 22, 6, ''),
('old_skool', 1, 24, 0, ''),
('old_skool', 7, 24, 4, ''),
('old_skool', 13, 24, 0, ''),
('pizza', 14, 3, 4, ''),
('pizza', 15, 3, 4, ''),
('pizza', 14, 6, 0, ''),
('pizza', 15, 6, 0, ''),
('pizza', 1, 8, 4, ''),
('pizza', 2, 8, 4, ''),
('pizza', 14, 10, 4, ''),
('pizza', 15, 10, 4, ''),
('pizza', 1, 11, 0, ''),
('pizza', 2, 11, 0, ''),
('pizza', 14, 13, 0, ''),
('pizza', 15, 13, 0, ''),
('pizza', 1, 16, 4, ''),
('pizza', 2, 16, 4, ''),
('pizza', 1, 19, 0, ''),
('pizza', 2, 19, 0, ''),
('pizza', 11, 21, 2, ''),
('pizza', 14, 21, 6, ''),
('pizza', 11, 22, 2, ''),
('pizza', 14, 22, 6, ''),
('pub_a', 19, 1, 4, ''),
('pub_a', 20, 1, 4, ''),
('pub_a', 21, 1, 4, ''),
('pub_a', 12, 2, 6, ''),
('pub_a', 12, 4, 6, ''),
('pub_a', 12, 6, 6, ''),
('pub_a', 12, 8, 6, ''),
('pub_a', 2, 11, 4, ''),
('pub_a', 3, 11, 4, ''),
('pub_a', 5, 11, 4, ''),
('pub_a', 6, 11, 4, ''),
('pub_a', 9, 13, 2, ''),
('pub_a', 14, 13, 2, ''),
('pub_a', 16, 13, 6, ''),
('pub_a', 9, 14, 2, ''),
('pub_a', 14, 14, 2, ''),
('pub_a', 16, 14, 6, ''),
('pub_a', 1, 16, 2, ''),
('pub_a', 1, 17, 2, ''),
('pub_a', 13, 17, 4, ''),
('pub_a', 14, 17, 4, ''),
('pub_a', 15, 17, 4, ''),
('pub_a', 16, 17, 4, ''),
('pub_a', 1, 18, 2, ''),
('pub_a', 2, 19, 0, ''),
('pub_a', 3, 19, 0, ''),
('pub_a', 13, 19, 0, ''),
('pub_a', 14, 19, 0, ''),
('pub_a', 15, 19, 0, ''),
('pub_a', 16, 19, 0, ''),
('pub_a', 7, 21, 4, ''),
('pub_a', 8, 21, 4, ''),
('pub_a', 6, 22, 2, ''),
('pub_a', 16, 22, 4, ''),
('pub_a', 17, 22, 4, ''),
('pub_a', 6, 23, 2, ''),
('pub_a', 6, 24, 2, ''),
('pub_a', 6, 25, 2, ''),
('newbie_lobby', 17, 0, 4, ''),
('newbie_lobby', 18, 0, 4, ''),
('newbie_lobby', 19, 0, 4, ''),
('newbie_lobby', 16, 1, 2, ''),
('newbie_lobby', 16, 2, 2, ''),
('newbie_lobby', 7, 3, 2, ''),
('newbie_lobby', 11, 3, 6, ''),
('newbie_lobby', 16, 3, 2, ''),
('newbie_lobby', 1, 4, 4, ''),
('newbie_lobby', 2, 4, 4, ''),
('newbie_lobby', 3, 4, 4, ''),
('newbie_lobby', 11, 4, 6, ''),
('newbie_lobby', 0, 5, 2, ''),
('newbie_lobby', 7, 5, 2, ''),
('newbie_lobby', 11, 5, 6, ''),
('newbie_lobby', 0, 7, 2, ''),
('newbie_lobby', 1, 8, 0, ''),
('newbie_lobby', 2, 8, 0, ''),
('newbie_lobby', 3, 8, 0, ''),
('newbie_lobby', 19, 8, 0, ''),
('newbie_lobby', 21, 8, 0, ''),
('tearoom', 13, 1, 4, ''),
('tearoom', 14, 1, 4, ''),
('tearoom', 15, 1, 4, ''),
('tearoom', 18, 1, 4, ''),
('tearoom', 19, 1, 4, ''),
('tearoom', 20, 1, 4, ''),
('tearoom', 2, 6, 4, ''),
('tearoom', 3, 6, 4, ''),
('tearoom', 8, 6, 4, ''),
('tearoom', 9, 6, 4, ''),
('tearoom', 10, 6, 4, ''),
('tearoom', 11, 6, 4, ''),
('tearoom', 2, 9, 0, ''),
('tearoom', 3, 9, 0, ''),
('tearoom', 16, 9, 4, ''),
('tearoom', 17, 9, 4, ''),
('tearoom', 2, 12, 4, ''),
('tearoom', 3, 12, 4, ''),
('tearoom', 16, 12, 0, ''),
('tearoom', 17, 12, 0, ''),
('tearoom', 2, 15, 0, ''),
('tearoom', 3, 15, 0, ''),
('tearoom', 0, 19, 2, ''),
('tearoom', 0, 20, 2, ''),
('rooftop', 0, 1, 4, ''),
('rooftop', 1, 2, 6, ''),
('rooftop', 0, 3, 0, ''),
('rooftop', 2, 6, 4, ''),
('rooftop', 1, 7, 2, ''),
('rooftop', 3, 7, 6, ''),
('rooftop', 2, 8, 0, ''),
('rooftop', 0, 9, 4, ''),
('rooftop', 0, 11, 0, ''),
('rooftop_2', 8, 0, 4, ''),
('rooftop_2', 0, 2, 4, ''),
('rooftop_2', 1, 2, 4, ''),
('rooftop_2', 8, 2, 0, ''),
('rooftop_2', 8, 3, 4, ''),
('rooftop_2', 0, 5, 0, ''),
('rooftop_2', 1, 5, 0, ''),
('rooftop_2', 8, 5, 0, ''),
('rooftop_2', 0, 6, 4, ''),
('rooftop_2', 1, 6, 4, ''),
('rooftop_2', 7, 6, 4, ''),
('rooftop_2', 8, 6, 4, ''),
('rooftop_2', 0, 9, 0, ''),
('rooftop_2', 1, 9, 0, ''),
('rooftop_2', 7, 9, 0, ''),
('rooftop_2', 8, 9, 0, ''),
('star_lounge', 22, 15, 4, ''),
('star_lounge', 23, 15, 4, ''),
('star_lounge', 21, 16, 2, ''),
('star_lounge', 21, 17, 2, ''),
('star_lounge', 21, 18, 2, ''),
('star_lounge', 35, 18, 6, ''),
('star_lounge', 21, 19, 2, ''),
('star_lounge', 35, 19, 6, ''),
('star_lounge', 21, 20, 2, ''),
('star_lounge', 24, 20, 2, ''),
('star_lounge', 32, 20, 6, ''),
('star_lounge', 35, 20, 6, ''),
('star_lounge', 21, 21, 2, ''),
('star_lounge', 24, 21, 2, ''),
('star_lounge', 32, 21, 6, ''),
('star_lounge', 35, 21, 6, ''),
('star_lounge', 21, 22, 2, ''),
('star_lounge', 25, 22, 0, ''),
('star_lounge', 26, 22, 0, ''),
('star_lounge', 30, 22, 0, ''),
('star_lounge', 31, 22, 0, ''),
('star_lounge', 35, 23, 6, ''),
('star_lounge', 35, 24, 6, ''),
('star_lounge', 37, 24, 4, ''),
('star_lounge', 38, 24, 4, ''),
('star_lounge', 39, 24, 4, ''),
('star_lounge', 40, 24, 4, ''),
('star_lounge', 25, 25, 0, ''),
('star_lounge', 26, 25, 0, ''),
('star_lounge', 30, 25, 0, ''),
('star_lounge', 31, 25, 0, ''),
('star_lounge', 35, 25, 6, ''),
('star_lounge', 36, 25, 2, ''),
('star_lounge', 35, 26, 6, ''),
('star_lounge', 36, 26, 2, ''),
('star_lounge', 25, 27, 4, ''),
('star_lounge', 26, 27, 4, ''),
('star_lounge', 30, 27, 4, ''),
('star_lounge', 31, 27, 4, ''),
('star_lounge', 16, 31, 2, ''),
('star_lounge', 25, 31, 0, ''),
('star_lounge', 26, 31, 0, ''),
('star_lounge', 30, 31, 6, ''),
('star_lounge', 16, 32, 2, ''),
('star_lounge', 30, 32, 6, ''),
('star_lounge', 16, 33, 2, ''),
('star_lounge', 25, 33, 4, ''),
('star_lounge', 26, 33, 4, ''),
('star_lounge', 30, 33, 6, ''),
('star_lounge', 16, 34, 2, ''),
('star_lounge', 30, 34, 6, ''),
('star_lounge', 30, 35, 6, ''),
('star_lounge', 30, 36, 6, ''),
('star_lounge', 25, 37, 0, ''),
('star_lounge', 26, 37, 0, ''),
('star_lounge', 27, 37, 0, ''),
('star_lounge', 28, 37, 0, ''),
('star_lounge', 29, 37, 0, ''),
('netcafe', 20, 18, 6, ''),
('netcafe', 20, 19, 6, ''),
('netcafe', 20, 20, 6, ''),
('netcafe', 20, 21, 6, ''),
('netcafe', 16, 23, 0, ''),
('netcafe', 17, 23, 0, ''),
('netcafe', 18, 23, 0, ''),
('dusty_lounge', 8, 4, 4, ''),
('dusty_lounge', 9, 4, 4, ''),
('dusty_lounge', 8, 6, 0, ''),
('dusty_lounge', 9, 6, 0, ''),
('dusty_lounge', 3, 7, 4, ''),
('dusty_lounge', 4, 7, 4, ''),
('dusty_lounge', 3, 9, 0, ''),
('dusty_lounge', 4, 9, 0, ''),
('dusty_lounge', 21, 10, 2, ''),
('dusty_lounge', 23, 10, 6, ''),
('dusty_lounge', 26, 10, 2, ''),
('dusty_lounge', 28, 10, 6, ''),
('dusty_lounge', 11, 12, 2, ''),
('dusty_lounge', 3, 13, 4, ''),
('dusty_lounge', 4, 13, 4, ''),
('dusty_lounge', 11, 13, 2, ''),
('dusty_lounge', 3, 15, 0, ''),
('dusty_lounge', 4, 15, 0, ''),
('dusty_lounge', 11, 15, 2, ''),
('dusty_lounge', 24, 15, 4, ''),
('dusty_lounge', 11, 16, 2, ''),
('dusty_lounge', 22, 17, 2, ''),
('dusty_lounge', 26, 17, 6, ''),
('dusty_lounge', 24, 19, 0, ''),
('dusty_lounge', 12, 23, 2, ''),
('dusty_lounge', 14, 23, 6, ''),
('dusty_lounge', 12, 24, 2, ''),
('dusty_lounge', 14, 24, 6, ''),
('orient', 17, 10, 2, ''),
('orient', 19, 10, 6, ''),
('orient', 21, 10, 2, ''),
('orient', 23, 10, 6, ''),
('orient', 17, 11, 2, ''),
('orient', 19, 11, 6, ''),
('orient', 21, 11, 2, ''),
('orient', 23, 11, 6, ''),
('orient', 32, 11, 4, ''),
('orient', 17, 12, 2, ''),
('orient', 19, 12, 6, ''),
('orient', 21, 12, 2, ''),
('orient', 23, 12, 6, ''),
('orient', 31, 12, 2, ''),
('orient', 33, 12, 6, ''),
('orient', 17, 13, 2, ''),
('orient', 19, 13, 6, ''),
('orient', 21, 13, 2, ''),
('orient', 23, 13, 6, ''),
('orient', 25, 13, 4, ''),
('orient', 32, 13, 0, ''),
('orient', 17, 14, 2, ''),
('orient', 19, 14, 6, ''),
('orient', 21, 14, 2, ''),
('orient', 23, 14, 6, ''),
('orient', 26, 14, 6, ''),
('orient', 17, 15, 2, ''),
('orient', 19, 15, 6, ''),
('orient', 21, 15, 2, ''),
('orient', 23, 15, 6, ''),
('orient', 25, 15, 0, ''),
('orient', 29, 15, 2, ''),
('orient', 31, 15, 6, ''),
('orient', 30, 16, 0, ''),
('orient', 25, 24, 2, ''),
('orient', 33, 24, 6, ''),
('orient', 17, 25, 2, ''),
('orient', 19, 25, 6, ''),
('orient', 21, 25, 2, ''),
('orient', 23, 25, 6, ''),
('orient', 25, 25, 2, ''),
('orient', 33, 25, 6, ''),
('orient', 17, 26, 2, ''),
('orient', 19, 26, 6, ''),
('orient', 21, 26, 2, ''),
('orient', 23, 26, 6, ''),
('orient', 25, 26, 2, ''),
('orient', 33, 26, 6, ''),
('orient', 17, 27, 2, ''),
('orient', 19, 27, 6, ''),
('orient', 21, 27, 2, ''),
('orient', 23, 27, 6, ''),
('orient', 17, 28, 2, ''),
('orient', 19, 28, 6, ''),
('orient', 21, 28, 2, ''),
('orient', 23, 28, 6, ''),
('orient', 17, 29, 2, ''),
('orient', 19, 29, 6, ''),
('orient', 21, 29, 2, ''),
('orient', 23, 29, 6, ''),
('theater', 2, 11, 2, ''),
('theater', 2, 12, 2, ''),
('theater', 2, 15, 2, ''),
('theater', 6, 15, 0, ''),
('theater', 7, 15, 0, ''),
('theater', 8, 15, 0, ''),
('theater', 9, 15, 0, ''),
('theater', 10, 15, 0, ''),
('theater', 12, 15, 0, ''),
('theater', 13, 15, 0, ''),
('theater', 14, 15, 0, ''),
('theater', 15, 15, 0, ''),
('theater', 16, 15, 0, ''),
('theater', 2, 16, 2, ''),
('theater', 6, 20, 0, ''),
('theater', 7, 20, 0, ''),
('theater', 8, 20, 0, ''),
('theater', 9, 20, 0, ''),
('theater', 10, 20, 0, ''),
('theater', 12, 20, 0, ''),
('theater', 13, 20, 0, ''),
('theater', 14, 20, 0, ''),
('theater', 15, 20, 0, ''),
('theater', 16, 20, 0, ''),
('theater', 6, 23, 0, ''),
('theater', 7, 23, 0, ''),
('theater', 8, 23, 0, ''),
('theater', 9, 23, 0, ''),
('theater', 10, 23, 0, ''),
('theater', 12, 23, 0, ''),
('theater', 13, 23, 0, ''),
('theater', 14, 23, 0, ''),
('theater', 15, 23, 0, ''),
('theater', 16, 23, 0, ''),
('theater', 6, 26, 0, ''),
('theater', 7, 26, 0, ''),
('theater', 8, 26, 0, ''),
('theater', 9, 26, 0, ''),
('theater', 10, 26, 0, ''),
('theater', 12, 26, 0, ''),
('theater', 13, 26, 0, ''),
('theater', 14, 26, 0, ''),
('theater', 15, 26, 0, ''),
('theater', 16, 26, 0, ''),
('picnic', 12, 11, 4, ''),
('picnic', 13, 11, 4, ''),
('picnic', 14, 11, 4, ''),
('picnic', 10, 13, 2, ''),
('picnic', 15, 13, 6, ''),
('picnic', 10, 14, 2, ''),
('picnic', 15, 14, 6, ''),
('picnic', 0, 19, 2, ''),
('picnic', 0, 20, 2, ''),
('picnic', 12, 21, 4, ''),
('picnic', 13, 21, 4, ''),
('picnic', 14, 21, 4, ''),
('picnic', 17, 21, 4, ''),
('picnic', 18, 21, 4, ''),
('picnic', 19, 21, 4, ''),
('picnic', 0, 22, 2, ''),
('picnic', 0, 23, 2, ''),
('picnic', 12, 23, 2, ''),
('picnic', 19, 23, 6, ''),
('picnic', 6, 24, 4, ''),
('picnic', 7, 24, 4, ''),
('picnic', 8, 24, 4, ''),
('picnic', 12, 24, 2, ''),
('picnic', 19, 24, 6, ''),
('picnic', 12, 25, 2, ''),
('picnic', 19, 25, 6, ''),
('picnic', 12, 26, 2, ''),
('picnic', 19, 26, 6, ''),
('picnic', 0, 30, 2, ''),
('picnic', 0, 31, 2, ''),
('picnic', 12, 31, 4, ''),
('picnic', 13, 31, 4, ''),
('picnic', 14, 31, 4, ''),
('picnic', 18, 31, 4, ''),
('picnic', 19, 31, 4, ''),
('picnic', 20, 31, 4, ''),
('picnic', 12, 33, 0, ''),
('picnic', 13, 33, 0, ''),
('picnic', 14, 33, 0, ''),
('picnic', 18, 33, 0, ''),
('picnic', 19, 33, 0, ''),
('picnic', 20, 33, 0, ''),
('picnic', 12, 37, 4, ''),
('picnic', 13, 37, 4, ''),
('picnic', 14, 37, 4, ''),
('picnic', 18, 37, 4, ''),
('picnic', 19, 37, 4, ''),
('picnic', 20, 37, 4, ''),
('picnic', 12, 39, 0, ''),
('picnic', 13, 39, 0, ''),
('picnic', 14, 39, 0, ''),
('picnic', 18, 39, 0, ''),
('picnic', 19, 39, 0, ''),
('picnic', 20, 39, 0, ''),
('cinema_a', 7, 4, 2, ''),
('cinema_a', 9, 4, 6, ''),
('cinema_a', 2, 5, 4, ''),
('cinema_a', 7, 5, 2, ''),
('cinema_a', 9, 5, 6, ''),
('cinema_a', 2, 7, 0, ''),
('cinema_a', 13, 7, 0, ''),
('cinema_a', 14, 7, 0, ''),
('cinema_a', 15, 7, 0, ''),
('cinema_a', 16, 7, 0, ''),
('cinema_a', 17, 7, 0, ''),
('cinema_a', 18, 7, 0, ''),
('cinema_a', 13, 9, 0, ''),
('cinema_a', 14, 9, 0, ''),
('cinema_a', 15, 9, 0, ''),
('cinema_a', 16, 9, 0, ''),
('cinema_a', 17, 9, 0, ''),
('cinema_a', 18, 9, 0, ''),
('cinema_a', 19, 9, 0, ''),
('cinema_a', 20, 9, 0, ''),
('cinema_a', 2, 10, 4, ''),
('cinema_a', 9, 10, 4, ''),
('cinema_a', 2, 12, 0, ''),
('cinema_a', 9, 12, 0, ''),
('cinema_a', 17, 12, 6, ''),
('cinema_a', 19, 12, 2, ''),
('cinema_a', 15, 13, 2, ''),
('cinema_a', 20, 13, 6, ''),
('cinema_a', 2, 15, 4, ''),
('cinema_a', 14, 15, 4, ''),
('cinema_a', 19, 15, 4, ''),
('cinema_a', 7, 16, 2, ''),
('cinema_a', 9, 16, 6, ''),
('cinema_a', 13, 16, 2, ''),
('cinema_a', 14, 16, 6, ''),
('cinema_a', 2, 17, 0, ''),
('cinema_a', 7, 17, 2, ''),
('cinema_a', 9, 17, 6, ''),
('cinema_a', 19, 17, 2, ''),
('cinema_a', 14, 18, 4, ''),
('cinema_a', 3, 20, 6, ''),
('cinema_a', 14, 20, 0, ''),
('cinema_a', 19, 20, 2, ''),
('cinema_a', 20, 20, 6, ''),
('cinema_a', 3, 21, 6, ''),
('cinema_a', 19, 21, 0, ''),
('cinema_a', 3, 22, 6, ''),
('cinema_a', 18, 22, 0, ''),
('cinema_a', 3, 23, 6, ''),
('cinema_a', 3, 24, 6, ''),
('park_a', 8, 9, 4, ''),
('park_a', 9, 9, 4, ''),
('park_a', 7, 11, 2, ''),
('park_a', 7, 12, 2, ''),
('park_a', 35, 16, 2, ''),
('park_a', 37, 16, 4, ''),
('park_a', 38, 16, 4, ''),
('park_a', 35, 17, 2, ''),
('park_a', 27, 18, 4, ''),
('park_a', 28, 18, 4, ''),
('park_a', 35, 18, 2, ''),
('park_a', 25, 19, 2, ''),
('park_a', 35, 19, 2, ''),
('park_a', 25, 20, 2, ''),
('park_a', 25, 29, 4, ''),
('park_a', 26, 29, 4, ''),
('park_a', 23, 30, 2, ''),
('park_a', 23, 31, 2, ''),
('pool_a', 18, 5, 2, ''),
('pool_a', 18, 6, 2, ''),
('pool_a', 8, 20, 4, ''),
('pool_a', 25, 20, 4, ''),
('pool_a', 7, 21, 2, ''),
('pool_a', 9, 21, 6, ''),
('pool_a', 24, 21, 2, ''),
('pool_a', 8, 22, 0, ''),
('pool_a', 10, 34, 4, ''),
('pool_a', 9, 35, 2, ''),
('pool_a', 11, 35, 6, ''),
('pool_a', 10, 36, 0, ''),
('pool_a', 15, 36, 4, ''),
('pool_a', 21, 36, 4, ''),
('pool_a', 22, 36, 4, ''),
('pool_a', 14, 37, 2, ''),
('pool_a', 16, 37, 6, ''),
('pool_a', 14, 38, 2, ''),
('pool_a', 16, 38, 6, ''),
('pool_a', 21, 38, 0, ''),
('pool_a', 22, 38, 0, ''),
('pool_a', 15, 39, 0, ''),
('pool_a', 20, 41, 4, ''),
('pool_a', 21, 41, 4, ''),
('pool_a', 20, 43, 0, ''),
('pool_a', 21, 43, 0, ''),
('old_skool', 9, 4, 0, 'mobiles_chair3'),
('old_skool', 10, 4, 0, 'mobiles_chair3'),
('old_skool', 11, 4, 0, 'mobiles_chair3'),
('old_skool', 12, 4, 0, 'mobiles_chair3'),
('old_skool', 1, 10, 4, 'mobiles_chair1'),
('old_skool', 10, 10, 4, 'mobiles_chair1'),
('old_skool', 0, 11, 2, 'mobiles_chair1'),
('old_skool', 1, 11, 0, ''),
('old_skool', 2, 11, 0, ''),
('old_skool', 3, 11, 6, 'mobiles_chair1'),
('old_skool', 10, 11, 0, ''),
('old_skool', 11, 11, 0, ''),
('old_skool', 1, 12, 0, ''),
('old_skool', 2, 12, 0, ''),
('old_skool', 9, 12, 2, 'mobiles_chair1'),
('old_skool', 10, 12, 0, ''),
('old_skool', 11, 12, 0, ''),
('old_skool', 12, 12, 6, 'mobiles_chair1'),
('old_skool', 1, 13, 0, 'mobiles_chair1'),
('old_skool', 11, 13, 0, 'mobiles_chair1'),
('old_skool', 0, 15, 4, 'mobiles_chair1'),
('old_skool', 0, 17, 2, 'mobiles_chair1'),
('old_skool', 1, 17, 0, ''),
('old_skool', 2, 17, 0, ''),
('old_skool', 3, 17, 6, 'mobiles_chair1'),
('old_skool', 1, 18, 0, ''),
('old_skool', 2, 18, 0, ''),
('old_skool', 2, 19, 0, 'mobiles_chair1'),
('old_skool', 1, 21, 4, 'mobiles_chair1'),
('old_skool', 6, 21, 0, ''),
('old_skool', 7, 21, 0, ''),
('old_skool', 12, 21, 4, 'mobiles_chair1'),
('old_skool', 0, 22, 2, 'mobiles_chair1'),
('old_skool', 1, 22, 0, ''),
('old_skool', 2, 22, 0, ''),
('old_skool', 3, 22, 6, 'mobiles_chair1'),
('old_skool', 5, 22, 2, 'mobiles_chair1'),
('old_skool', 6, 22, 0, ''),
('old_skool', 7, 22, 0, ''),
('old_skool', 8, 22, 6, 'mobiles_chair1'),
('old_skool', 11, 22, 2, 'mobiles_chair1'),
('old_skool', 12, 22, 0, ''),
('old_skool', 13, 22, 0, ''),
('old_skool', 14, 22, 6, 'mobiles_chair1'),
('old_skool', 1, 23, 0, ''),
('old_skool', 2, 23, 0, ''),
('old_skool', 12, 23, 0, ''),
('old_skool', 13, 23, 0, ''),
('old_skool', 1, 24, 0, 'mobiles_chair1'),
('old_skool', 7, 24, 4, 'mobiles_chair1'),
('old_skool', 13, 24, 0, 'mobiles_chair1'),
('pizza', 15, 0, 2, ''),
('pizza', 14, 3, 4, 'pizza_sofa1'),
('pizza', 15, 3, 4, 'pizza_sofa2'),
('pizza', 15, 5, 2, ''),
('pizza', 0, 6, 2, ''),
('pizza', 14, 6, 0, 'pizza_sofa3'),
('pizza', 15, 6, 0, 'pizza_sofa4'),
('pizza', 1, 8, 4, 'pizza_chair'),
('pizza', 2, 8, 4, 'pizza_chair'),
('pizza', 2, 10, 2, ''),
('pizza', 14, 10, 4, 'pizza_sofa1'),
('pizza', 15, 10, 4, 'pizza_sofa2'),
('pizza', 1, 11, 0, 'pizza_chair'),
('pizza', 2, 11, 0, 'pizza_chair'),
('pizza', 15, 12, 2, ''),
('pizza', 14, 13, 0, 'pizza_sofa3'),
('pizza', 15, 13, 0, 'pizza_sofa4'),
('pizza', 1, 16, 4, 'pizza_chair'),
('pizza', 2, 16, 4, 'pizza_chair'),
('pizza', 2, 18, 2, ''),
('pizza', 1, 19, 0, 'pizza_chair'),
('pizza', 2, 19, 0, 'pizza_chair'),
('pizza', 11, 21, 2, 'pizza_chair'),
('pizza', 14, 21, 6, 'pizza_chair'),
('pizza', 11, 22, 2, 'pizza_chair'),
('pizza', 13, 22, 0, ''),
('pizza', 14, 22, 6, 'pizza_chair'),
('pizza', 0, 25, 2, ''),
('pizza', 15, 25, 2, ''),
('pub_a', 19, 1, 4, 'pub_sofa2'),
('pub_a', 20, 1, 4, 'pub_sofa'),
('pub_a', 21, 1, 4, 'pub_sofa'),
('pub_a', 11, 2, 0, ''),
('pub_a', 12, 2, 6, 'pub_chair'),
('pub_a', 11, 3, 0, ''),
('pub_a', 11, 4, 0, ''),
('pub_a', 12, 4, 6, 'pub_chair'),
('pub_a', 11, 5, 0, ''),
('pub_a', 18, 5, 1, ''),
('pub_a', 11, 6, 0, ''),
('pub_a', 12, 6, 6, 'pub_chair'),
('pub_a', 18, 6, 0, ''),
('pub_a', 11, 7, 0, ''),
('pub_a', 18, 7, 0, ''),
('pub_a', 11, 8, 0, ''),
('pub_a', 12, 8, 6, 'pub_chair'),
('pub_a', 18, 8, 0, ''),
('pub_a', 10, 9, 0, ''),
('pub_a', 11, 9, 0, ''),
('pub_a', 18, 9, 0, ''),
('pub_a', 18, 10, 0, ''),
('pub_a', 2, 11, 4, 'pub_chair2'),
('pub_a', 3, 11, 4, 'pub_chair2'),
('pub_a', 5, 11, 4, 'pub_chair2'),
('pub_a', 6, 11, 4, 'pub_chair2'),
('pub_a', 8, 11, 1, ''),
('pub_a', 18, 11, 0, ''),
('pub_a', 8, 12, 0, ''),
('pub_a', 18, 12, 0, ''),
('pub_a', 8, 13, 0, ''),
('pub_a', 9, 13, 2, 'pub_chair2'),
('pub_a', 14, 13, 2, 'pub_chair3'),
('pub_a', 15, 13, 1, ''),
('pub_a', 16, 13, 6, 'pub_chair3'),
('pub_a', 18, 13, 0, ''),
('pub_a', 8, 14, 2, ''),
('pub_a', 9, 14, 2, 'pub_chair2'),
('pub_a', 14, 14, 2, 'pub_chair3'),
('pub_a', 15, 14, 2, ''),
('pub_a', 16, 14, 6, 'pub_chair3'),
('pub_a', 18, 14, 0, ''),
('pub_a', 1, 15, 0, ''),
('pub_a', 5, 15, 1, ''),
('pub_a', 18, 15, 0, ''),
('pub_a', 1, 16, 2, 'pub_sofa2'),
('pub_a', 5, 16, 0, ''),
('pub_a', 18, 16, 0, ''),
('pub_a', 1, 17, 2, 'pub_sofa'),
('pub_a', 5, 17, 0, ''),
('pub_a', 13, 17, 4, 'pub_chair3'),
('pub_a', 14, 17, 4, 'pub_chair3'),
('pub_a', 15, 17, 4, 'pub_chair3'),
('pub_a', 16, 17, 4, 'pub_chair3'),
('pub_a', 18, 17, 0, ''),
('pub_a', 1, 18, 2, 'pub_sofa'),
('pub_a', 5, 18, 0, ''),
('pub_a', 13, 18, 5, ''),
('pub_a', 14, 18, 6, ''),
('pub_a', 15, 18, 6, ''),
('pub_a', 16, 18, 4, ''),
('pub_a', 18, 18, 0, ''),
('pub_a', 2, 19, 0, 'pub_sofa'),
('pub_a', 3, 19, 0, 'pub_sofa2'),
('pub_a', 5, 19, 0, ''),
('pub_a', 13, 19, 0, 'pub_chair3'),
('pub_a', 14, 19, 0, 'pub_chair3'),
('pub_a', 15, 19, 0, 'pub_chair3'),
('pub_a', 16, 19, 0, 'pub_chair3'),
('pub_a', 18, 19, 0, ''),
('pub_a', 1, 20, 5, ''),
('pub_a', 2, 20, 6, ''),
('pub_a', 3, 20, 6, ''),
('pub_a', 4, 20, 6, ''),
('pub_a', 5, 20, 3, ''),
('pub_a', 18, 20, 0, ''),
('pub_a', 7, 21, 4, 'pub_sofa2'),
('pub_a', 8, 21, 4, 'pub_sofa'),
('pub_a', 12, 21, 5, ''),
('pub_a', 13, 21, 6, ''),
('pub_a', 14, 21, 6, ''),
('pub_a', 15, 21, 6, ''),
('pub_a', 16, 21, 6, ''),
('pub_a', 17, 21, 6, ''),
('pub_a', 18, 21, 3, ''),
('pub_a', 6, 22, 2, 'pub_sofa2'),
('pub_a', 15, 22, 0, ''),
('pub_a', 16, 22, 4, 'pub_chair2'),
('pub_a', 17, 22, 4, 'pub_chair2'),
('pub_a', 6, 23, 2, 'pub_sofa'),
('pub_a', 8, 23, 1, ''),
('pub_a', 6, 24, 2, 'pub_sofa'),
('pub_a', 8, 24, 0, ''),
('pub_a', 6, 25, 2, 'pub_sofa'),
('pub_a', 8, 25, 2, ''),
('newbie_lobby', 16, 0, 0, ''),
('newbie_lobby', 17, 0, 4, 'crl_sofa2c'),
('newbie_lobby', 18, 0, 4, 'crl_sofa2b'),
('newbie_lobby', 19, 0, 4, 'crl_sofa2a'),
('newbie_lobby', 20, 0, 0, ''),
('newbie_lobby', 16, 1, 2, 'crl_chair'),
('newbie_lobby', 7, 2, 0, ''),
('newbie_lobby', 11, 2, 0, ''),
('newbie_lobby', 16, 2, 2, 'crl_chair'),
('newbie_lobby', 5, 3, 0, ''),
('newbie_lobby', 7, 3, 2, 'crl_chair'),
('newbie_lobby', 9, 3, 0, ''),
('newbie_lobby', 11, 3, 6, 'crl_sofa1c'),
('newbie_lobby', 16, 3, 2, 'crl_chair'),
('newbie_lobby', 19, 3, 0, ''),
('newbie_lobby', 20, 3, 0, ''),
('newbie_lobby', 0, 4, 0, ''),
('newbie_lobby', 1, 4, 4, 'crl_sofa2c'),
('newbie_lobby', 2, 4, 4, 'crl_sofa2b'),
('newbie_lobby', 3, 4, 4, 'crl_sofa2a'),
('newbie_lobby', 4, 4, 0, ''),
('newbie_lobby', 9, 4, 0, ''),
('newbie_lobby', 11, 4, 6, 'crl_sofa1b'),
('newbie_lobby', 15, 4, 0, ''),
('newbie_lobby', 16, 4, 0, ''),
('newbie_lobby', 0, 5, 2, 'crl_chair'),
('newbie_lobby', 7, 5, 2, 'crl_chair'),
('newbie_lobby', 11, 5, 6, 'crl_sofa1a'),
('newbie_lobby', 2, 6, 0, ''),
('newbie_lobby', 3, 6, 0, ''),
('newbie_lobby', 11, 6, 0, ''),
('newbie_lobby', 0, 7, 2, 'crl_chair'),
('newbie_lobby', 0, 8, 0, ''),
('newbie_lobby', 1, 8, 0, 'crl_sofa3c'),
('newbie_lobby', 2, 8, 0, 'crl_sofa3b'),
('newbie_lobby', 3, 8, 0, 'crl_sofa3a'),
('newbie_lobby', 4, 8, 0, ''),
('newbie_lobby', 19, 8, 0, 'crl_barchair2'),
('newbie_lobby', 20, 8, 0, ''),
('newbie_lobby', 21, 8, 0, 'crl_barchair2'),
('newbie_lobby', 5, 9, 0, ''),
('newbie_lobby', 9, 9, 0, ''),
('newbie_lobby', 8, 15, 0, ''),
('newbie_lobby', 9, 15, 0, ''),
('newbie_lobby', 10, 15, 0, ''),
('newbie_lobby', 10, 16, 0, ''),
('newbie_lobby', 10, 17, 0, ''),
('newbie_lobby', 10, 18, 0, ''),
('newbie_lobby', 10, 19, 0, ''),
('newbie_lobby', 10, 20, 0, ''),
('newbie_lobby', 10, 21, 0, ''),
('newbie_lobby', 10, 22, 0, ''),
('newbie_lobby', 10, 23, 0, ''),
('newbie_lobby', 7, 24, 0, ''),
('newbie_lobby', 10, 24, 0, ''),
('newbie_lobby', 7, 25, 0, ''),
('newbie_lobby', 8, 25, 0, ''),
('newbie_lobby', 9, 25, 0, ''),
('newbie_lobby', 10, 25, 0, ''),
('newbie_lobby', 12, 27, 0, ''),
('newbie_lobby', 13, 27, 0, ''),
('newbie_lobby', 14, 27, 0, ''),
('newbie_lobby', 15, 27, 0, ''),
('tearoom', 13, 1, 4, 'hardwoodsofa1'),
('tearoom', 14, 1, 4, 'hardwoodsofa2'),
('tearoom', 15, 1, 4, 'hardwoodsofa3'),
('tearoom', 16, 1, 0, ''),
('tearoom', 18, 1, 4, 'hardwoodsofa1'),
('tearoom', 19, 1, 4, 'hardwoodsofa2'),
('tearoom', 20, 1, 4, 'hardwoodsofa3'),
('tearoom', 13, 3, 0, ''),
('tearoom', 15, 3, 0, ''),
('tearoom', 18, 3, 0, ''),
('tearoom', 20, 3, 0, ''),
('tearoom', 2, 6, 4, 'teastool'),
('tearoom', 3, 6, 4, 'teastool'),
('tearoom', 8, 6, 4, 'chinastoolred'),
('tearoom', 9, 6, 4, 'chinastoolred'),
('tearoom', 10, 6, 4, 'chinastoolred'),
('tearoom', 11, 6, 4, 'chinastoolred'),
('tearoom', 2, 8, 0, ''),
('tearoom', 3, 8, 0, ''),
('tearoom', 2, 9, 0, 'teastool2'),
('tearoom', 3, 9, 0, 'teastool2'),
('tearoom', 16, 9, 4, 'teastool'),
('tearoom', 17, 9, 4, 'teastool'),
('tearoom', 16, 11, 0, ''),
('tearoom', 17, 11, 0, ''),
('tearoom', 2, 12, 4, 'teastool'),
('tearoom', 3, 12, 4, 'teastool'),
('tearoom', 16, 12, 0, 'teastool2'),
('tearoom', 17, 12, 0, 'teastool2'),
('tearoom', 2, 14, 0, ''),
('tearoom', 3, 14, 0, ''),
('tearoom', 2, 15, 0, 'teastool2'),
('tearoom', 3, 15, 0, 'teastool2'),
('tearoom', 0, 18, 0, ''),
('tearoom', 0, 19, 2, 'chinastoolgreen'),
('tearoom', 0, 20, 2, 'chinastoolgreen'),
('tearoom', 0, 21, 0, ''),
('rooftop', 0, 1, 4, 'rooftop_minichair'),
('rooftop', 16, 1, 4, ''),
('rooftop', 17, 1, 4, ''),
('rooftop', 0, 2, 0, ''),
('rooftop', 1, 2, 6, 'rooftop_minichair'),
('rooftop', 0, 3, 0, 'rooftop_minichair'),
('rooftop', 16, 4, 0, ''),
('rooftop', 17, 4, 0, ''),
('rooftop', 2, 6, 4, 'rooftop_minichair'),
('rooftop', 1, 7, 2, 'rooftop_minichair'),
('rooftop', 2, 7, 0, ''),
('rooftop', 3, 7, 6, 'rooftop_minichair'),
('rooftop', 2, 8, 0, 'rooftop_minichair'),
('rooftop', 0, 9, 4, 'rooftop_minichair'),
('rooftop', 0, 10, 0, ''),
('rooftop', 0, 11, 0, 'rooftop_minichair'),
('rooftop', 1, 13, 2, ''),
('rooftop', 6, 13, 6, ''),
('rooftop', 8, 13, 2, ''),
('rooftop', 13, 13, 6, ''),
('rooftop', 1, 14, 2, ''),
('rooftop', 6, 14, 6, ''),
('rooftop', 8, 14, 2, ''),
('rooftop', 13, 14, 6, ''),
('rooftop', 1, 15, 2, ''),
('rooftop', 6, 15, 6, ''),
('rooftop', 8, 15, 2, ''),
('rooftop', 13, 15, 6, ''),
('rooftop', 1, 16, 2, ''),
('rooftop', 6, 16, 6, ''),
('rooftop', 8, 16, 2, ''),
('rooftop', 13, 16, 6, ''),
('rooftop', 1, 17, 0, ''),
('rooftop', 2, 17, 0, ''),
('rooftop', 3, 17, 0, ''),
('rooftop', 4, 17, 0, ''),
('rooftop', 5, 17, 0, ''),
('rooftop', 6, 17, 0, ''),
('rooftop', 8, 17, 0, ''),
('rooftop', 9, 17, 0, ''),
('rooftop', 10, 17, 0, ''),
('rooftop', 11, 17, 0, ''),
('rooftop', 12, 17, 0, ''),
('rooftop', 13, 17, 0, ''),
('rooftop_2', 8, 0, 4, 'rooftop_bigchair'),
('rooftop_2', 8, 1, 0, ''),
('rooftop_2', 0, 2, 4, 'rooftop_sofab'),
('rooftop_2', 1, 2, 4, 'rooftop_sofa'),
('rooftop_2', 8, 2, 0, 'rooftop_bigchair'),
('rooftop_2', 8, 3, 4, 'rooftop_bigchair'),
('rooftop_2', 8, 4, 0, ''),
('rooftop_2', 0, 5, 0, 'rooftop_sofab'),
('rooftop_2', 1, 5, 0, 'rooftop_sofa'),
('rooftop_2', 8, 5, 0, 'rooftop_bigchair'),
('rooftop_2', 0, 6, 4, 'rooftop_sofab'),
('rooftop_2', 1, 6, 4, 'rooftop_sofa'),
('rooftop_2', 7, 6, 4, 'rooftop_sofab'),
('rooftop_2', 8, 6, 4, 'rooftop_sofa'),
('rooftop_2', 0, 9, 0, 'rooftop_sofab'),
('rooftop_2', 1, 9, 0, 'rooftop_sofa'),
('rooftop_2', 7, 9, 0, 'rooftop_sofab'),
('rooftop_2', 8, 9, 0, 'rooftop_sofa'),
('star_lounge', 21, 15, 0, ''),
('star_lounge', 22, 15, 4, 'star_sofa'),
('star_lounge', 23, 15, 4, 'star_sofa2'),
('star_lounge', 24, 15, 0, ''),
('star_lounge', 21, 16, 2, 'star_sofa2'),
('star_lounge', 32, 16, 0, ''),
('star_lounge', 33, 16, 0, ''),
('star_lounge', 34, 16, 0, ''),
('star_lounge', 21, 17, 2, 'star_sofa'),
('star_lounge', 28, 17, 0, ''),
('star_lounge', 21, 18, 2, 'star_sofa2'),
('star_lounge', 35, 18, 6, 'star_sofa'),
('star_lounge', 21, 19, 2, 'star_sofa'),
('star_lounge', 35, 19, 6, 'star_sofa2'),
('star_lounge', 21, 20, 2, 'star_sofa2'),
('star_lounge', 24, 20, 2, 'star_sofa2'),
('star_lounge', 32, 20, 6, 'star_sofa'),
('star_lounge', 35, 20, 6, 'star_sofa'),
('star_lounge', 21, 21, 2, 'star_sofa'),
('star_lounge', 24, 21, 2, 'star_sofa'),
('star_lounge', 32, 21, 6, 'star_sofa2'),
('star_lounge', 35, 21, 6, 'star_sofa2'),
('star_lounge', 21, 22, 2, 'star_sofachair'),
('star_lounge', 24, 22, 0, ''),
('star_lounge', 25, 22, 0, 'star_sofa2'),
('star_lounge', 26, 22, 0, 'star_sofa'),
('star_lounge', 30, 22, 0, 'star_sofa2'),
('star_lounge', 31, 22, 0, 'star_sofa'),
('star_lounge', 32, 22, 0, ''),
('star_lounge', 35, 22, 0, ''),
('star_lounge', 21, 23, 0, ''),
('star_lounge', 35, 23, 6, 'star_sofa'),
('star_lounge', 22, 24, 0, ''),
('star_lounge', 35, 24, 6, 'star_sofa2'),
('star_lounge', 37, 24, 4, 'star_sofa'),
('star_lounge', 38, 24, 4, 'star_sofa2'),
('star_lounge', 39, 24, 4, 'star_sofa'),
('star_lounge', 40, 24, 4, 'star_sofa2'),
('star_lounge', 22, 25, 0, ''),
('star_lounge', 25, 25, 0, 'star_sofa2'),
('star_lounge', 26, 25, 0, 'star_sofa'),
('star_lounge', 30, 25, 0, 'star_sofa2'),
('star_lounge', 31, 25, 0, 'star_sofa'),
('star_lounge', 35, 25, 6, 'star_sofa'),
('star_lounge', 36, 25, 2, 'star_sofa2'),
('star_lounge', 22, 26, 0, ''),
('star_lounge', 25, 26, 0, ''),
('star_lounge', 26, 26, 0, ''),
('star_lounge', 30, 26, 0, ''),
('star_lounge', 31, 26, 0, ''),
('star_lounge', 35, 26, 6, 'star_sofa2'),
('star_lounge', 36, 26, 2, 'star_sofa'),
('star_lounge', 39, 26, 0, ''),
('star_lounge', 40, 26, 0, ''),
('star_lounge', 22, 27, 0, ''),
('star_lounge', 25, 27, 4, 'star_sofa'),
('star_lounge', 26, 27, 4, 'star_sofa2'),
('star_lounge', 30, 27, 4, 'star_sofa'),
('star_lounge', 31, 27, 4, 'star_sofa2'),
('star_lounge', 35, 27, 0, ''),
('star_lounge', 36, 27, 0, ''),
('star_lounge', 37, 27, 0, ''),
('star_lounge', 22, 28, 0, ''),
('star_lounge', 22, 29, 0, ''),
('star_lounge', 25, 29, 0, ''),
('star_lounge', 26, 29, 0, ''),
('star_lounge', 16, 30, 0, ''),
('star_lounge', 22, 30, 0, ''),
('star_lounge', 16, 31, 2, 'star_sofa2'),
('star_lounge', 22, 31, 0, ''),
('star_lounge', 25, 31, 0, 'star_sofa2'),
('star_lounge', 26, 31, 0, 'star_sofa'),
('star_lounge', 30, 31, 6, 'star_sofa'),
('star_lounge', 16, 32, 2, 'star_sofa'),
('star_lounge', 22, 32, 0, ''),
('star_lounge', 25, 32, 0, ''),
('star_lounge', 26, 32, 0, ''),
('star_lounge', 30, 32, 6, 'star_sofa2'),
('star_lounge', 16, 33, 2, 'star_sofa2'),
('star_lounge', 22, 33, 0, ''),
('star_lounge', 25, 33, 4, 'star_sofa'),
('star_lounge', 26, 33, 4, 'star_sofa2'),
('star_lounge', 30, 33, 6, 'star_sofa'),
('star_lounge', 16, 34, 2, 'star_sofa'),
('star_lounge', 30, 34, 6, 'star_sofa2'),
('star_lounge', 35, 34, 0, ''),
('star_lounge', 36, 34, 0, ''),
('star_lounge', 16, 35, 0, ''),
('star_lounge', 30, 35, 6, 'star_sofa'),
('star_lounge', 30, 36, 6, 'star_sofa2'),
('star_lounge', 25, 37, 0, 'star_sofachair'),
('star_lounge', 26, 37, 0, 'star_sofa2'),
('star_lounge', 27, 37, 0, 'star_sofa'),
('star_lounge', 28, 37, 0, 'star_sofa2'),
('star_lounge', 29, 37, 0, 'star_sofa'),
('star_lounge', 30, 37, 0, ''),
('netcafe', 6, 0, 4, ''),
('netcafe', 7, 0, 4, ''),
('netcafe', 10, 1, 0, ''),
('netcafe', 13, 1, 0, ''),
('netcafe', 16, 1, 0, ''),
('netcafe', 19, 1, 0, ''),
('netcafe', 5, 3, 0, ''),
('netcafe', 6, 3, 0, ''),
('netcafe', 12, 3, 0, ''),
('netcafe', 13, 3, 0, ''),
('netcafe', 19, 3, 0, ''),
('netcafe', 20, 3, 0, ''),
('netcafe', 12, 4, 4, ''),
('netcafe', 13, 4, 4, ''),
('netcafe', 19, 4, 4, ''),
('netcafe', 20, 4, 4, ''),
('netcafe', 0, 5, 4, ''),
('netcafe', 1, 5, 4, ''),
('netcafe', 2, 5, 4, ''),
('netcafe', 3, 5, 4, ''),
('netcafe', 15, 7, 2, ''),
('netcafe', 16, 7, 6, ''),
('netcafe', 17, 7, 0, ''),
('netcafe', 18, 7, 6, ''),
('netcafe', 15, 8, 2, ''),
('netcafe', 16, 8, 4, ''),
('netcafe', 18, 8, 6, ''),
('netcafe', 4, 9, 6, ''),
('netcafe', 9, 9, 2, ''),
('netcafe', 10, 9, 6, ''),
('netcafe', 11, 9, 0, ''),
('netcafe', 12, 9, 6, ''),
('netcafe', 15, 9, 2, ''),
('netcafe', 16, 9, 2, ''),
('netcafe', 18, 9, 6, ''),
('netcafe', 4, 10, 6, ''),
('netcafe', 9, 10, 2, ''),
('netcafe', 10, 10, 4, ''),
('netcafe', 12, 10, 6, ''),
('netcafe', 15, 10, 2, ''),
('netcafe', 16, 10, 0, ''),
('netcafe', 18, 10, 6, ''),
('netcafe', 4, 11, 6, ''),
('netcafe', 9, 11, 2, ''),
('netcafe', 10, 11, 2, ''),
('netcafe', 12, 11, 6, ''),
('netcafe', 4, 12, 6, ''),
('netcafe', 9, 12, 2, ''),
('netcafe', 10, 12, 0, ''),
('netcafe', 12, 12, 6, ''),
('netcafe', 4, 13, 6, ''),
('netcafe', 5, 16, 0, ''),
('netcafe', 6, 16, 0, ''),
('netcafe', 7, 16, 0, ''),
('netcafe', 8, 16, 0, ''),
('netcafe', 9, 16, 0, ''),
('netcafe', 15, 16, 0, ''),
('netcafe', 9, 17, 0, ''),
('netcafe', 6, 18, 6, ''),
('netcafe', 9, 18, 0, ''),
('netcafe', 20, 18, 6, 'sofabig3'),
('netcafe', 9, 19, 0, ''),
('netcafe', 17, 19, 4, ''),
('netcafe', 18, 19, 0, ''),
('netcafe', 20, 19, 6, 'sofabig2'),
('netcafe', 17, 20, 2, ''),
('netcafe', 20, 20, 6, 'sofabig2'),
('netcafe', 6, 21, 6, ''),
('netcafe', 17, 21, 0, ''),
('netcafe', 20, 21, 6, 'sofabig1'),
('netcafe', 16, 23, 0, 'sofalittle3'),
('netcafe', 17, 23, 0, 'sofalittle2'),
('netcafe', 18, 23, 0, 'sofalittle1'),
('netcafe', 20, 23, 0, ''),
('dusty_lounge', 8, 4, 4, 'greenchair2'),
('dusty_lounge', 9, 4, 4, 'greenchair1'),
('dusty_lounge', 8, 6, 0, 'greenchair2'),
('dusty_lounge', 9, 6, 0, 'greenchair1'),
('dusty_lounge', 20, 6, 2, ''),
('dusty_lounge', 28, 6, 2, ''),
('dusty_lounge', 3, 7, 4, 'greenchair2'),
('dusty_lounge', 4, 7, 4, 'greenchair1'),
('dusty_lounge', 3, 9, 0, 'greenchair2'),
('dusty_lounge', 4, 9, 0, 'greenchair1'),
('dusty_lounge', 21, 10, 2, 'yellowchair'),
('dusty_lounge', 23, 10, 6, 'yellowchair'),
('dusty_lounge', 26, 10, 2, 'yellowchair'),
('dusty_lounge', 28, 10, 6, 'yellowchair'),
('dusty_lounge', 11, 12, 2, 'greenchair2'),
('dusty_lounge', 3, 13, 4, 'greenchair2'),
('dusty_lounge', 4, 13, 4, 'greenchair1'),
('dusty_lounge', 11, 13, 2, 'greenchair1'),
('dusty_lounge', 11, 14, 2, ''),
('dusty_lounge', 3, 15, 0, 'greenchair2'),
('dusty_lounge', 4, 15, 0, 'greenchair1'),
('dusty_lounge', 11, 15, 2, 'greenchair2'),
('dusty_lounge', 24, 15, 4, 'yellowchair'),
('dusty_lounge', 11, 16, 2, 'greenchair1'),
('dusty_lounge', 22, 17, 2, 'yellowchair'),
('dusty_lounge', 24, 17, 2, ''),
('dusty_lounge', 26, 17, 6, 'yellowchair'),
('dusty_lounge', 11, 19, 2, ''),
('dusty_lounge', 24, 19, 0, 'yellowchair'),
('dusty_lounge', 12, 23, 2, 'greenchair2'),
('dusty_lounge', 14, 23, 6, 'greenchair2'),
('dusty_lounge', 12, 24, 2, 'greenchair1'),
('dusty_lounge', 14, 24, 6, 'greenchair1'),
('orient', 17, 10, 2, 'bench'),
('orient', 19, 10, 6, 'bench'),
('orient', 21, 10, 2, 'bench'),
('orient', 23, 10, 6, 'bench'),
('orient', 17, 11, 2, 'bench'),
('orient', 19, 11, 6, 'bench'),
('orient', 21, 11, 2, 'bench'),
('orient', 23, 11, 6, 'bench'),
('orient', 32, 11, 4, 'koc_chair'),
('orient', 17, 12, 2, 'bench'),
('orient', 19, 12, 6, 'bench'),
('orient', 21, 12, 2, 'bench'),
('orient', 23, 12, 6, 'bench'),
('orient', 31, 12, 2, 'koc_chair'),
('orient', 32, 12, 0, ''),
('orient', 33, 12, 6, 'koc_chair'),
('orient', 17, 13, 2, 'bench'),
('orient', 19, 13, 6, 'bench'),
('orient', 21, 13, 2, 'bench'),
('orient', 23, 13, 6, 'bench'),
('orient', 25, 13, 4, 'koc_chair'),
('orient', 32, 13, 0, 'koc_chair'),
('orient', 17, 14, 2, 'bench'),
('orient', 19, 14, 6, 'bench'),
('orient', 21, 14, 2, 'bench'),
('orient', 23, 14, 6, 'bench'),
('orient', 25, 14, 0, ''),
('orient', 26, 14, 6, 'koc_chair'),
('orient', 17, 15, 2, 'bench'),
('orient', 19, 15, 6, 'bench'),
('orient', 21, 15, 2, 'bench'),
('orient', 23, 15, 6, 'bench'),
('orient', 25, 15, 0, 'koc_chair'),
('orient', 29, 15, 2, 'koc_chair'),
('orient', 30, 15, 0, ''),
('orient', 31, 15, 6, 'koc_chair'),
('orient', 30, 16, 0, 'koc_chair'),
('orient', 25, 24, 2, 'chairf1'),
('orient', 33, 24, 6, 'chairf1'),
('orient', 17, 25, 2, 'bench'),
('orient', 19, 25, 6, 'bench'),
('orient', 21, 25, 2, 'bench'),
('orient', 23, 25, 6, 'bench'),
('orient', 25, 25, 2, 'chairf1'),
('orient', 33, 25, 6, 'chairf1'),
('orient', 17, 26, 2, 'bench'),
('orient', 19, 26, 6, 'bench'),
('orient', 21, 26, 2, 'bench'),
('orient', 23, 26, 6, 'bench'),
('orient', 25, 26, 2, 'chairf1'),
('orient', 33, 26, 6, 'chairf1'),
('orient', 17, 27, 2, 'bench'),
('orient', 19, 27, 6, 'bench'),
('orient', 21, 27, 2, 'bench'),
('orient', 23, 27, 6, 'bench'),
('orient', 17, 28, 2, 'bench'),
('orient', 19, 28, 6, 'bench'),
('orient', 21, 28, 2, 'bench'),
('orient', 23, 28, 6, 'bench'),
('orient', 17, 29, 2, 'bench'),
('orient', 19, 29, 6, 'bench'),
('orient', 21, 29, 2, 'bench'),
('orient', 23, 29, 6, 'bench'),
('theater', 11, 10, 0, ''),
('theater', 2, 11, 2, 'thchair2'),
('theater', 2, 12, 2, 'thchair2'),
('theater', 2, 15, 2, 'thchair2'),
('theater', 6, 15, 0, 'thchair1'),
('theater', 7, 15, 0, 'thchair1'),
('theater', 8, 15, 0, 'thchair1'),
('theater', 9, 15, 0, 'thchair1'),
('theater', 10, 15, 0, 'thchair1'),
('theater', 12, 15, 0, 'thchair1'),
('theater', 13, 15, 0, 'thchair1'),
('theater', 14, 15, 0, 'thchair1'),
('theater', 15, 15, 0, 'thchair1'),
('theater', 16, 15, 0, 'thchair1'),
('theater', 2, 16, 2, 'thchair2'),
('theater', 6, 20, 0, 'thchair1'),
('theater', 7, 20, 0, 'thchair1'),
('theater', 8, 20, 0, 'thchair1'),
('theater', 9, 20, 0, 'thchair1'),
('theater', 10, 20, 0, 'thchair1'),
('theater', 12, 20, 0, 'thchair1'),
('theater', 13, 20, 0, 'thchair1'),
('theater', 14, 20, 0, 'thchair1'),
('theater', 15, 20, 0, 'thchair1'),
('theater', 16, 20, 0, 'thchair1'),
('theater', 6, 23, 0, 'thchair1'),
('theater', 7, 23, 0, 'thchair1'),
('theater', 8, 23, 0, 'thchair1'),
('theater', 9, 23, 0, 'thchair1'),
('theater', 10, 23, 0, 'thchair1'),
('theater', 12, 23, 0, 'thchair1'),
('theater', 13, 23, 0, 'thchair1'),
('theater', 14, 23, 0, 'thchair1'),
('theater', 15, 23, 0, 'thchair1'),
('theater', 16, 23, 0, 'thchair1'),
('theater', 6, 26, 0, 'thchair1'),
('theater', 7, 26, 0, 'thchair1'),
('theater', 8, 26, 0, 'thchair1'),
('theater', 9, 26, 0, 'thchair1'),
('theater', 10, 26, 0, 'thchair1'),
('theater', 12, 26, 0, 'thchair1'),
('theater', 13, 26, 0, 'thchair1'),
('theater', 14, 26, 0, 'thchair1'),
('theater', 15, 26, 0, 'thchair1'),
('theater', 16, 26, 0, 'thchair1'),
('picnic', 10, 7, 4, ''),
('picnic', 11, 7, 4, ''),
('picnic', 12, 7, 4, ''),
('picnic', 13, 7, 4, ''),
('picnic', 14, 7, 4, ''),
('picnic', 18, 7, 4, ''),
('picnic', 19, 7, 4, ''),
('picnic', 20, 7, 4, ''),
('picnic', 21, 7, 4, ''),
('picnic', 14, 8, 4, ''),
('picnic', 18, 8, 4, ''),
('picnic', 3, 9, 4, ''),
('picnic', 3, 10, 4, ''),
('picnic', 12, 11, 4, 'picnic_dummychair1'),
('picnic', 13, 11, 4, 'picnic_dummychair1'),
('picnic', 14, 11, 4, 'picnic_dummychair1'),
('picnic', 10, 13, 2, 'picnic_dummychair1'),
('picnic', 15, 13, 6, 'picnic_dummychair1'),
('picnic', 21, 13, 4, ''),
('picnic', 7, 14, 4, ''),
('picnic', 10, 14, 2, 'picnic_dummychair1'),
('picnic', 15, 14, 6, 'picnic_dummychair1'),
('picnic', 19, 15, 2, ''),
('picnic', 23, 15, 6, ''),
('picnic', 5, 16, 2, ''),
('picnic', 9, 16, 6, ''),
('picnic', 20, 16, 2, ''),
('picnic', 6, 17, 2, ''),
('picnic', 21, 17, 0, ''),
('picnic', 7, 18, 0, ''),
('picnic', 0, 19, 2, 'picnic_redbench2'),
('picnic', 0, 20, 2, 'picnic_redbench1'),
('picnic', 11, 20, 4, ''),
('picnic', 12, 20, 4, ''),
('picnic', 13, 20, 4, ''),
('picnic', 14, 20, 4, ''),
('picnic', 17, 20, 4, ''),
('picnic', 18, 20, 4, ''),
('picnic', 19, 20, 4, ''),
('picnic', 20, 20, 4, ''),
('picnic', 11, 21, 4, ''),
('picnic', 12, 21, 4, 'picnic_bench1'),
('picnic', 13, 21, 4, 'picnic_bench2'),
('picnic', 14, 21, 4, 'picnic_bench3'),
('picnic', 17, 21, 4, 'picnic_bench1'),
('picnic', 18, 21, 4, 'picnic_bench2'),
('picnic', 19, 21, 4, 'picnic_bench3'),
('picnic', 20, 21, 4, ''),
('picnic', 0, 22, 2, 'picnic_redbench2'),
('picnic', 11, 22, 4, ''),
('picnic', 20, 22, 4, ''),
('picnic', 25, 22, 4, ''),
('picnic', 0, 23, 2, 'picnic_redbench1'),
('picnic', 11, 23, 4, ''),
('picnic', 12, 23, 2, 'picnic_bench1'),
('picnic', 19, 23, 6, 'picnic_bench1'),
('picnic', 20, 23, 4, ''),
('picnic', 6, 24, 4, 'picnic_dummychair1'),
('picnic', 7, 24, 4, 'picnic_dummychair4'),
('picnic', 8, 24, 4, 'picnic_dummychair6'),
('picnic', 11, 24, 4, ''),
('picnic', 12, 24, 2, 'picnic_bench2'),
('picnic', 19, 24, 6, 'picnic_bench2'),
('picnic', 20, 24, 4, ''),
('picnic', 23, 24, 2, ''),
('picnic', 27, 24, 6, ''),
('picnic', 5, 25, 2, ''),
('picnic', 11, 25, 4, ''),
('picnic', 12, 25, 2, 'picnic_bench2'),
('picnic', 19, 25, 6, 'picnic_bench2'),
('picnic', 20, 25, 4, ''),
('picnic', 24, 25, 2, ''),
('picnic', 7, 26, 0, ''),
('picnic', 11, 26, 4, ''),
('picnic', 12, 26, 2, 'picnic_bench3'),
('picnic', 14, 26, 0, ''),
('picnic', 16, 26, 2, ''),
('picnic', 19, 26, 6, 'picnic_bench3'),
('picnic', 20, 26, 4, ''),
('picnic', 25, 26, 0, ''),
('picnic', 11, 27, 4, ''),
('picnic', 12, 27, 4, ''),
('picnic', 20, 27, 4, ''),
('picnic', 8, 29, 0, ''),
('picnic', 0, 30, 2, 'picnic_redbench2'),
('picnic', 8, 30, 0, ''),
('picnic', 0, 31, 2, 'picnic_redbench1'),
('picnic', 8, 31, 0, ''),
('picnic', 12, 31, 4, 'picnic_bench1'),
('picnic', 13, 31, 4, 'picnic_bench2'),
('picnic', 14, 31, 4, 'picnic_bench3'),
('picnic', 18, 31, 4, 'picnic_bench1'),
('picnic', 19, 31, 4, 'picnic_bench2'),
('picnic', 20, 31, 4, 'picnic_bench3'),
('picnic', 27, 31, 0, ''),
('picnic', 28, 31, 0, ''),
('picnic', 29, 31, 0, ''),
('picnic', 30, 31, 0, ''),
('picnic', 31, 31, 0, ''),
('picnic', 8, 32, 0, ''),
('picnic', 12, 32, 2, ''),
('picnic', 14, 32, 2, ''),
('picnic', 18, 32, 2, ''),
('picnic', 20, 32, 2, ''),
('picnic', 3, 33, 4, ''),
('picnic', 8, 33, 0, ''),
('picnic', 12, 33, 0, 'picnic_bench1'),
('picnic', 13, 33, 0, 'picnic_bench2'),
('picnic', 14, 33, 0, 'picnic_bench3'),
('picnic', 18, 33, 0, 'picnic_bench1'),
('picnic', 19, 33, 0, 'picnic_bench2'),
('picnic', 20, 33, 0, 'picnic_bench3'),
('picnic', 27, 33, 0, ''),
('picnic', 28, 33, 0, ''),
('picnic', 29, 33, 0, ''),
('picnic', 3, 34, 4, ''),
('picnic', 8, 34, 0, ''),
('picnic', 3, 35, 4, ''),
('picnic', 8, 35, 0, ''),
('picnic', 3, 36, 4, ''),
('picnic', 8, 36, 0, ''),
('picnic', 8, 37, 0, ''),
('picnic', 12, 37, 4, 'picnic_bench1'),
('picnic', 13, 37, 4, 'picnic_bench2'),
('picnic', 14, 37, 4, 'picnic_bench3'),
('picnic', 18, 37, 4, 'picnic_bench1'),
('picnic', 19, 37, 4, 'picnic_bench2'),
('picnic', 20, 37, 4, 'picnic_bench3'),
('picnic', 8, 38, 0, ''),
('picnic', 12, 38, 2, ''),
('picnic', 14, 38, 2, ''),
('picnic', 18, 38, 2, ''),
('picnic', 20, 38, 2, ''),
('picnic', 8, 39, 0, ''),
('picnic', 12, 39, 0, 'picnic_bench1'),
('picnic', 13, 39, 0, 'picnic_bench2'),
('picnic', 14, 39, 0, 'picnic_bench3'),
('picnic', 18, 39, 0, 'picnic_bench1'),
('picnic', 19, 39, 0, 'picnic_bench2'),
('picnic', 20, 39, 0, 'picnic_bench3'),
('cinema_a', 2, 4, 0, ''),
('cinema_a', 7, 4, 2, 'loungey_chair'),
('cinema_a', 8, 4, 0, ''),
('cinema_a', 9, 4, 6, 'loungey_chair'),
('cinema_a', 2, 5, 4, 'loungey_chair'),
('cinema_a', 7, 5, 2, 'loungey_chair'),
('cinema_a', 8, 5, 0, ''),
('cinema_a', 9, 5, 6, 'loungey_chair'),
('cinema_a', 2, 6, 0, ''),
('cinema_a', 2, 7, 0, 'loungey_chair'),
('cinema_a', 13, 7, 0, 'theater_chair'),
('cinema_a', 14, 7, 0, 'theater_chair'),
('cinema_a', 15, 7, 0, 'theater_chair'),
('cinema_a', 16, 7, 0, 'theater_chair'),
('cinema_a', 17, 7, 0, 'theater_chair'),
('cinema_a', 18, 7, 0, 'theater_chair'),
('cinema_a', 21, 7, 0, ''),
('cinema_a', 9, 8, 0, ''),
('cinema_a', 13, 8, 2, ''),
('cinema_a', 14, 8, 0, ''),
('cinema_a', 15, 8, 0, ''),
('cinema_a', 16, 8, 0, ''),
('cinema_a', 17, 8, 0, ''),
('cinema_a', 18, 8, 0, ''),
('cinema_a', 19, 8, 1, ''),
('cinema_a', 21, 8, 0, ''),
('cinema_a', 2, 9, 0, ''),
('cinema_a', 13, 9, 0, 'theater_chair'),
('cinema_a', 14, 9, 0, 'theater_chair'),
('cinema_a', 15, 9, 0, 'theater_chair'),
('cinema_a', 16, 9, 0, 'theater_chair'),
('cinema_a', 17, 9, 0, 'theater_chair'),
('cinema_a', 18, 9, 0, 'theater_chair'),
('cinema_a', 19, 9, 0, 'theater_chair'),
('cinema_a', 20, 9, 0, 'theater_chair'),
('cinema_a', 21, 9, 0, ''),
('cinema_a', 2, 10, 4, 'loungey_chair'),
('cinema_a', 9, 10, 4, 'loungey_chair'),
('cinema_a', 2, 11, 0, ''),
('cinema_a', 9, 11, 0, ''),
('cinema_a', 2, 12, 0, 'loungey_chair'),
('cinema_a', 9, 12, 0, 'loungey_chair'),
('cinema_a', 17, 12, 6, 'cubicb_chair'),
('cinema_a', 19, 12, 2, 'cubico_chair'),
('cinema_a', 15, 13, 2, 'cubicb_chair'),
('cinema_a', 19, 13, 0, ''),
('cinema_a', 20, 13, 6, 'cubicb_chair'),
('cinema_a', 9, 14, 0, ''),
('cinema_a', 2, 15, 4, 'loungey_chair'),
('cinema_a', 14, 15, 4, 'cubicb_chair'),
('cinema_a', 19, 15, 4, 'cubico_chair'),
('cinema_a', 2, 16, 0, ''),
('cinema_a', 7, 16, 2, 'loungey_chair'),
('cinema_a', 8, 16, 2, ''),
('cinema_a', 9, 16, 6, 'loungey_chair'),
('cinema_a', 13, 16, 2, 'cubicb_chair'),
('cinema_a', 14, 16, 6, 'cubicb_chair'),
('cinema_a', 19, 16, 0, ''),
('cinema_a', 2, 17, 0, 'loungey_chair'),
('cinema_a', 7, 17, 2, 'loungey_chair'),
('cinema_a', 8, 17, 2, ''),
('cinema_a', 9, 17, 6, 'loungey_chair'),
('cinema_a', 19, 17, 2, 'cubicb_chair'),
('cinema_a', 2, 18, 0, ''),
('cinema_a', 14, 18, 4, 'cubicb_chair'),
('cinema_a', 2, 19, 0, ''),
('cinema_a', 2, 20, 1, ''),
('cinema_a', 3, 20, 6, 'bar_chair'),
('cinema_a', 9, 20, 0, ''),
('cinema_a', 14, 20, 0, 'cubicb_chair'),
('cinema_a', 19, 20, 2, 'cubicb_chair'),
('cinema_a', 20, 20, 6, 'cubico_chair'),
('cinema_a', 2, 21, 1, ''),
('cinema_a', 3, 21, 6, 'bar_chair'),
('cinema_a', 19, 21, 0, 'cubicb_chair'),
('cinema_a', 2, 22, 1, ''),
('cinema_a', 3, 22, 6, 'bar_chair'),
('cinema_a', 16, 22, 0, ''),
('cinema_a', 18, 22, 0, 'cubico_chair'),
('cinema_a', 2, 23, 1, ''),
('cinema_a', 3, 23, 6, 'bar_chair'),
('cinema_a', 2, 24, 1, ''),
('cinema_a', 3, 24, 6, 'bar_chair'),
('cinema_a', 2, 25, 2, ''),
('park_a', 27, 5, 0, ''),
('park_a', 29, 5, 0, ''),
('park_a', 19, 6, 0, ''),
('park_a', 20, 6, 4, ''),
('park_a', 21, 6, 4, ''),
('park_a', 22, 6, 4, ''),
('park_a', 23, 6, 4, ''),
('park_a', 24, 6, 4, ''),
('park_a', 25, 6, 4, ''),
('park_a', 26, 6, 4, ''),
('park_a', 27, 6, 2, ''),
('park_a', 29, 6, 2, ''),
('park_a', 17, 7, 0, ''),
('park_a', 19, 7, 2, ''),
('park_a', 23, 7, 2, ''),
('park_a', 27, 7, 2, ''),
('park_a', 29, 7, 2, ''),
('park_a', 17, 8, 2, ''),
('park_a', 19, 8, 2, ''),
('park_a', 21, 8, 0, ''),
('park_a', 23, 8, 2, ''),
('park_a', 25, 8, 0, ''),
('park_a', 27, 8, 2, ''),
('park_a', 29, 8, 2, ''),
('park_a', 8, 9, 4, 'bench2'),
('park_a', 9, 9, 4, 'bench'),
('park_a', 17, 9, 2, ''),
('park_a', 19, 9, 6, ''),
('park_a', 21, 9, 2, ''),
('park_a', 23, 9, 6, ''),
('park_a', 25, 9, 2, ''),
('park_a', 27, 9, 6, ''),
('park_a', 29, 9, 2, ''),
('park_a', 17, 10, 2, ''),
('park_a', 21, 10, 2, ''),
('park_a', 25, 10, 2, ''),
('park_a', 29, 10, 2, ''),
('park_a', 7, 11, 2, 'bench2'),
('park_a', 17, 11, 4, ''),
('park_a', 18, 11, 4, ''),
('park_a', 19, 11, 4, ''),
('park_a', 20, 11, 4, ''),
('park_a', 21, 11, 2, ''),
('park_a', 22, 11, 4, ''),
('park_a', 23, 11, 4, ''),
('park_a', 24, 11, 4, ''),
('park_a', 25, 11, 2, ''),
('park_a', 26, 11, 4, ''),
('park_a', 27, 11, 4, ''),
('park_a', 28, 11, 4, ''),
('park_a', 29, 11, 6, ''),
('park_a', 7, 12, 2, 'bench'),
('park_a', 35, 16, 2, 'bench2'),
('park_a', 37, 16, 4, 'bench2'),
('park_a', 38, 16, 4, 'bench'),
('park_a', 35, 17, 2, 'bench'),
('park_a', 27, 18, 4, 'bench2'),
('park_a', 28, 18, 4, 'bench'),
('park_a', 35, 18, 2, 'bench2'),
('park_a', 25, 19, 2, 'bench2'),
('park_a', 35, 19, 2, 'bench'),
('park_a', 25, 20, 2, 'bench'),
('park_a', 25, 29, 4, 'bench2'),
('park_a', 26, 29, 4, 'bench'),
('park_a', 23, 30, 2, 'bench2'),
('park_a', 23, 31, 2, 'bench'),
('pool_a', 18, 4, 0, ''),
('pool_a', 18, 5, 2, 'pool_2sofa2'),
('pool_a', 18, 6, 2, 'pool_2sofa1'),
('pool_a', 7, 20, 0, ''),
('pool_a', 8, 20, 4, 'pool_chair2'),
('pool_a', 24, 20, 0, ''),
('pool_a', 25, 20, 4, 'pool_chair2'),
('pool_a', 7, 21, 2, 'pool_chair2'),
('pool_a', 8, 21, 0, ''),
('pool_a', 9, 21, 6, 'pool_chair2'),
('pool_a', 24, 21, 2, 'pool_chair2'),
('pool_a', 25, 21, 0, ''),
('pool_a', 8, 22, 0, 'pool_chair2'),
('pool_a', 2, 28, 0, ''),
('pool_a', 2, 29, 0, ''),
('pool_a', 6, 32, 0, ''),
('pool_a', 13, 33, 0, ''),
('pool_a', 10, 34, 4, 'pool_chairy'),
('pool_a', 8, 35, 0, ''),
('pool_a', 9, 35, 2, 'pool_chairy'),
('pool_a', 10, 35, 0, ''),
('pool_a', 11, 35, 6, 'pool_chairy'),
('pool_a', 15, 35, 0, ''),
('pool_a', 21, 35, 0, ''),
('pool_a', 10, 36, 0, 'pool_chairy'),
('pool_a', 15, 36, 4, 'pool_chairp'),
('pool_a', 21, 36, 4, 'pool_chairo'),
('pool_a', 22, 36, 4, 'pool_chairo'),
('pool_a', 14, 37, 2, 'pool_chairp'),
('pool_a', 15, 37, 0, ''),
('pool_a', 16, 37, 6, 'pool_chairp'),
('pool_a', 21, 37, 6, ''),
('pool_a', 22, 37, 6, ''),
('pool_a', 14, 38, 2, 'pool_chairp'),
('pool_a', 15, 38, 0, ''),
('pool_a', 16, 38, 6, 'pool_chairp'),
('pool_a', 21, 38, 0, 'pool_chairo'),
('pool_a', 22, 38, 0, 'pool_chairo'),
('pool_a', 15, 39, 0, 'pool_chairp'),
('pool_a', 20, 41, 4, 'pool_chairg'),
('pool_a', 21, 41, 4, 'pool_chairg'),
('pool_a', 20, 42, 6, ''),
('pool_a', 21, 42, 6, ''),
('pool_a', 19, 43, 0, ''),
('pool_a', 20, 43, 0, 'pool_chairg'),
('pool_a', 21, 43, 0, 'pool_chairg'),
('old_skool', 9, 4, 0, 'mobiles_chair3'),
('old_skool', 10, 4, 0, 'mobiles_chair3'),
('old_skool', 11, 4, 0, 'mobiles_chair3'),
('old_skool', 12, 4, 0, 'mobiles_chair3'),
('old_skool', 1, 10, 4, 'mobiles_chair1'),
('old_skool', 10, 10, 4, 'mobiles_chair1'),
('old_skool', 0, 11, 2, 'mobiles_chair1'),
('old_skool', 1, 11, 0, ''),
('old_skool', 2, 11, 0, ''),
('old_skool', 3, 11, 6, 'mobiles_chair1'),
('old_skool', 10, 11, 0, ''),
('old_skool', 11, 11, 0, ''),
('old_skool', 1, 12, 0, ''),
('old_skool', 2, 12, 0, ''),
('old_skool', 9, 12, 2, 'mobiles_chair1'),
('old_skool', 10, 12, 0, ''),
('old_skool', 11, 12, 0, ''),
('old_skool', 12, 12, 6, 'mobiles_chair1'),
('old_skool', 1, 13, 0, 'mobiles_chair1'),
('old_skool', 11, 13, 0, 'mobiles_chair1'),
('old_skool', 0, 15, 4, 'mobiles_chair1'),
('old_skool', 0, 17, 2, 'mobiles_chair1'),
('old_skool', 1, 17, 0, ''),
('old_skool', 2, 17, 0, ''),
('old_skool', 3, 17, 6, 'mobiles_chair1'),
('old_skool', 1, 18, 0, ''),
('old_skool', 2, 18, 0, ''),
('old_skool', 2, 19, 0, 'mobiles_chair1'),
('old_skool', 1, 21, 4, 'mobiles_chair1'),
('old_skool', 6, 21, 0, ''),
('old_skool', 7, 21, 0, ''),
('old_skool', 12, 21, 4, 'mobiles_chair1'),
('old_skool', 0, 22, 2, 'mobiles_chair1'),
('old_skool', 1, 22, 0, ''),
('old_skool', 2, 22, 0, ''),
('old_skool', 3, 22, 6, 'mobiles_chair1'),
('old_skool', 5, 22, 2, 'mobiles_chair1'),
('old_skool', 6, 22, 0, ''),
('old_skool', 7, 22, 0, ''),
('old_skool', 8, 22, 6, 'mobiles_chair1'),
('old_skool', 11, 22, 2, 'mobiles_chair1'),
('old_skool', 12, 22, 0, ''),
('old_skool', 13, 22, 0, ''),
('old_skool', 14, 22, 6, 'mobiles_chair1'),
('old_skool', 1, 23, 0, ''),
('old_skool', 2, 23, 0, ''),
('old_skool', 12, 23, 0, ''),
('old_skool', 13, 23, 0, ''),
('old_skool', 1, 24, 0, 'mobiles_chair1'),
('old_skool', 7, 24, 4, 'mobiles_chair1'),
('old_skool', 13, 24, 0, 'mobiles_chair1'),
('pizza', 15, 0, 2, ''),
('pizza', 14, 3, 4, 'pizza_sofa1'),
('pizza', 15, 3, 4, 'pizza_sofa2'),
('pizza', 15, 5, 2, ''),
('pizza', 0, 6, 2, ''),
('pizza', 14, 6, 0, 'pizza_sofa3'),
('pizza', 15, 6, 0, 'pizza_sofa4'),
('pizza', 1, 8, 4, 'pizza_chair'),
('pizza', 2, 8, 4, 'pizza_chair'),
('pizza', 2, 10, 2, ''),
('pizza', 14, 10, 4, 'pizza_sofa1'),
('pizza', 15, 10, 4, 'pizza_sofa2'),
('pizza', 1, 11, 0, 'pizza_chair'),
('pizza', 2, 11, 0, 'pizza_chair'),
('pizza', 15, 12, 2, ''),
('pizza', 14, 13, 0, 'pizza_sofa3'),
('pizza', 15, 13, 0, 'pizza_sofa4'),
('pizza', 1, 16, 4, 'pizza_chair'),
('pizza', 2, 16, 4, 'pizza_chair'),
('pizza', 2, 18, 2, ''),
('pizza', 1, 19, 0, 'pizza_chair'),
('pizza', 2, 19, 0, 'pizza_chair'),
('pizza', 11, 21, 2, 'pizza_chair'),
('pizza', 14, 21, 6, 'pizza_chair'),
('pizza', 11, 22, 2, 'pizza_chair'),
('pizza', 13, 22, 0, ''),
('pizza', 14, 22, 6, 'pizza_chair'),
('pizza', 0, 25, 2, ''),
('pizza', 15, 25, 2, ''),
('pub_a', 19, 1, 4, 'pub_sofa2'),
('pub_a', 20, 1, 4, 'pub_sofa'),
('pub_a', 21, 1, 4, 'pub_sofa'),
('pub_a', 11, 2, 0, ''),
('pub_a', 12, 2, 6, 'pub_chair'),
('pub_a', 11, 3, 0, ''),
('pub_a', 11, 4, 0, ''),
('pub_a', 12, 4, 6, 'pub_chair'),
('pub_a', 11, 5, 0, ''),
('pub_a', 18, 5, 1, ''),
('pub_a', 11, 6, 0, ''),
('pub_a', 12, 6, 6, 'pub_chair'),
('pub_a', 18, 6, 0, ''),
('pub_a', 11, 7, 0, ''),
('pub_a', 18, 7, 0, ''),
('pub_a', 11, 8, 0, ''),
('pub_a', 12, 8, 6, 'pub_chair'),
('pub_a', 18, 8, 0, ''),
('pub_a', 10, 9, 0, ''),
('pub_a', 11, 9, 0, ''),
('pub_a', 18, 9, 0, ''),
('pub_a', 18, 10, 0, ''),
('pub_a', 2, 11, 4, 'pub_chair2'),
('pub_a', 3, 11, 4, 'pub_chair2'),
('pub_a', 5, 11, 4, 'pub_chair2'),
('pub_a', 6, 11, 4, 'pub_chair2'),
('pub_a', 8, 11, 1, ''),
('pub_a', 18, 11, 0, ''),
('pub_a', 8, 12, 0, ''),
('pub_a', 18, 12, 0, ''),
('pub_a', 8, 13, 0, ''),
('pub_a', 9, 13, 2, 'pub_chair2'),
('pub_a', 14, 13, 2, 'pub_chair3'),
('pub_a', 15, 13, 1, ''),
('pub_a', 16, 13, 6, 'pub_chair3'),
('pub_a', 18, 13, 0, ''),
('pub_a', 8, 14, 2, ''),
('pub_a', 9, 14, 2, 'pub_chair2'),
('pub_a', 14, 14, 2, 'pub_chair3'),
('pub_a', 15, 14, 2, ''),
('pub_a', 16, 14, 6, 'pub_chair3'),
('pub_a', 18, 14, 0, ''),
('pub_a', 1, 15, 0, ''),
('pub_a', 5, 15, 1, ''),
('pub_a', 18, 15, 0, ''),
('pub_a', 1, 16, 2, 'pub_sofa2'),
('pub_a', 5, 16, 0, ''),
('pub_a', 18, 16, 0, ''),
('pub_a', 1, 17, 2, 'pub_sofa'),
('pub_a', 5, 17, 0, ''),
('pub_a', 13, 17, 4, 'pub_chair3'),
('pub_a', 14, 17, 4, 'pub_chair3'),
('pub_a', 15, 17, 4, 'pub_chair3'),
('pub_a', 16, 17, 4, 'pub_chair3'),
('pub_a', 18, 17, 0, ''),
('pub_a', 1, 18, 2, 'pub_sofa'),
('pub_a', 5, 18, 0, ''),
('pub_a', 13, 18, 5, ''),
('pub_a', 14, 18, 6, ''),
('pub_a', 15, 18, 6, ''),
('pub_a', 16, 18, 4, ''),
('pub_a', 18, 18, 0, ''),
('pub_a', 2, 19, 0, 'pub_sofa'),
('pub_a', 3, 19, 0, 'pub_sofa2'),
('pub_a', 5, 19, 0, ''),
('pub_a', 13, 19, 0, 'pub_chair3'),
('pub_a', 14, 19, 0, 'pub_chair3'),
('pub_a', 15, 19, 0, 'pub_chair3'),
('pub_a', 16, 19, 0, 'pub_chair3'),
('pub_a', 18, 19, 0, ''),
('pub_a', 1, 20, 5, ''),
('pub_a', 2, 20, 6, ''),
('pub_a', 3, 20, 6, ''),
('pub_a', 4, 20, 6, ''),
('pub_a', 5, 20, 3, ''),
('pub_a', 18, 20, 0, ''),
('pub_a', 7, 21, 4, 'pub_sofa2'),
('pub_a', 8, 21, 4, 'pub_sofa'),
('pub_a', 12, 21, 5, ''),
('pub_a', 13, 21, 6, ''),
('pub_a', 14, 21, 6, ''),
('pub_a', 15, 21, 6, ''),
('pub_a', 16, 21, 6, ''),
('pub_a', 17, 21, 6, ''),
('pub_a', 18, 21, 3, ''),
('pub_a', 6, 22, 2, 'pub_sofa2'),
('pub_a', 15, 22, 0, ''),
('pub_a', 16, 22, 4, 'pub_chair2'),
('pub_a', 17, 22, 4, 'pub_chair2'),
('pub_a', 6, 23, 2, 'pub_sofa'),
('pub_a', 8, 23, 1, ''),
('pub_a', 6, 24, 2, 'pub_sofa'),
('pub_a', 8, 24, 0, ''),
('pub_a', 6, 25, 2, 'pub_sofa'),
('pub_a', 8, 25, 2, ''),
('newbie_lobby', 16, 0, 0, ''),
('newbie_lobby', 17, 0, 4, 'crl_sofa2c'),
('newbie_lobby', 18, 0, 4, 'crl_sofa2b'),
('newbie_lobby', 19, 0, 4, 'crl_sofa2a'),
('newbie_lobby', 20, 0, 0, ''),
('newbie_lobby', 16, 1, 2, 'crl_chair'),
('newbie_lobby', 7, 2, 0, ''),
('newbie_lobby', 11, 2, 0, ''),
('newbie_lobby', 16, 2, 2, 'crl_chair'),
('newbie_lobby', 5, 3, 0, ''),
('newbie_lobby', 7, 3, 2, 'crl_chair'),
('newbie_lobby', 9, 3, 0, ''),
('newbie_lobby', 11, 3, 6, 'crl_sofa1c'),
('newbie_lobby', 16, 3, 2, 'crl_chair'),
('newbie_lobby', 19, 3, 0, ''),
('newbie_lobby', 20, 3, 0, ''),
('newbie_lobby', 0, 4, 0, ''),
('newbie_lobby', 1, 4, 4, 'crl_sofa2c'),
('newbie_lobby', 2, 4, 4, 'crl_sofa2b'),
('newbie_lobby', 3, 4, 4, 'crl_sofa2a'),
('newbie_lobby', 4, 4, 0, ''),
('newbie_lobby', 9, 4, 0, ''),
('newbie_lobby', 11, 4, 6, 'crl_sofa1b'),
('newbie_lobby', 15, 4, 0, ''),
('newbie_lobby', 16, 4, 0, ''),
('newbie_lobby', 0, 5, 2, 'crl_chair');
INSERT INTO `room_model_static` (`model`, `x`, `y`, `rot`, `content`) VALUES
('newbie_lobby', 7, 5, 2, 'crl_chair'),
('newbie_lobby', 11, 5, 6, 'crl_sofa1a'),
('newbie_lobby', 2, 6, 0, ''),
('newbie_lobby', 3, 6, 0, ''),
('newbie_lobby', 11, 6, 0, ''),
('newbie_lobby', 0, 7, 2, 'crl_chair'),
('newbie_lobby', 0, 8, 0, ''),
('newbie_lobby', 1, 8, 0, 'crl_sofa3c'),
('newbie_lobby', 2, 8, 0, 'crl_sofa3b'),
('newbie_lobby', 3, 8, 0, 'crl_sofa3a'),
('newbie_lobby', 4, 8, 0, ''),
('newbie_lobby', 19, 8, 0, 'crl_barchair2'),
('newbie_lobby', 20, 8, 0, ''),
('newbie_lobby', 21, 8, 0, 'crl_barchair2'),
('newbie_lobby', 5, 9, 0, ''),
('newbie_lobby', 9, 9, 0, ''),
('newbie_lobby', 8, 15, 0, ''),
('newbie_lobby', 9, 15, 0, ''),
('newbie_lobby', 10, 15, 0, ''),
('newbie_lobby', 10, 16, 0, ''),
('newbie_lobby', 10, 17, 0, ''),
('newbie_lobby', 10, 18, 0, ''),
('newbie_lobby', 10, 19, 0, ''),
('newbie_lobby', 10, 20, 0, ''),
('newbie_lobby', 10, 21, 0, ''),
('newbie_lobby', 10, 22, 0, ''),
('newbie_lobby', 10, 23, 0, ''),
('newbie_lobby', 7, 24, 0, ''),
('newbie_lobby', 10, 24, 0, ''),
('newbie_lobby', 7, 25, 0, ''),
('newbie_lobby', 8, 25, 0, ''),
('newbie_lobby', 9, 25, 0, ''),
('newbie_lobby', 10, 25, 0, ''),
('newbie_lobby', 12, 27, 0, ''),
('newbie_lobby', 13, 27, 0, ''),
('newbie_lobby', 14, 27, 0, ''),
('newbie_lobby', 15, 27, 0, ''),
('tearoom', 13, 1, 4, 'hardwoodsofa1'),
('tearoom', 14, 1, 4, 'hardwoodsofa2'),
('tearoom', 15, 1, 4, 'hardwoodsofa3'),
('tearoom', 16, 1, 0, ''),
('tearoom', 18, 1, 4, 'hardwoodsofa1'),
('tearoom', 19, 1, 4, 'hardwoodsofa2'),
('tearoom', 20, 1, 4, 'hardwoodsofa3'),
('tearoom', 13, 3, 0, ''),
('tearoom', 15, 3, 0, ''),
('tearoom', 18, 3, 0, ''),
('tearoom', 20, 3, 0, ''),
('tearoom', 2, 6, 4, 'teastool'),
('tearoom', 3, 6, 4, 'teastool'),
('tearoom', 8, 6, 4, 'chinastoolred'),
('tearoom', 9, 6, 4, 'chinastoolred'),
('tearoom', 10, 6, 4, 'chinastoolred'),
('tearoom', 11, 6, 4, 'chinastoolred'),
('tearoom', 2, 8, 0, ''),
('tearoom', 3, 8, 0, ''),
('tearoom', 2, 9, 0, 'teastool2'),
('tearoom', 3, 9, 0, 'teastool2'),
('tearoom', 16, 9, 4, 'teastool'),
('tearoom', 17, 9, 4, 'teastool'),
('tearoom', 16, 11, 0, ''),
('tearoom', 17, 11, 0, ''),
('tearoom', 2, 12, 4, 'teastool'),
('tearoom', 3, 12, 4, 'teastool'),
('tearoom', 16, 12, 0, 'teastool2'),
('tearoom', 17, 12, 0, 'teastool2'),
('tearoom', 2, 14, 0, ''),
('tearoom', 3, 14, 0, ''),
('tearoom', 2, 15, 0, 'teastool2'),
('tearoom', 3, 15, 0, 'teastool2'),
('tearoom', 0, 18, 0, ''),
('tearoom', 0, 19, 2, 'chinastoolgreen'),
('tearoom', 0, 20, 2, 'chinastoolgreen'),
('tearoom', 0, 21, 0, ''),
('rooftop', 0, 1, 4, 'rooftop_minichair'),
('rooftop', 16, 1, 4, ''),
('rooftop', 17, 1, 4, ''),
('rooftop', 0, 2, 0, ''),
('rooftop', 1, 2, 6, 'rooftop_minichair'),
('rooftop', 0, 3, 0, 'rooftop_minichair'),
('rooftop', 16, 4, 0, ''),
('rooftop', 17, 4, 0, ''),
('rooftop', 2, 6, 4, 'rooftop_minichair'),
('rooftop', 1, 7, 2, 'rooftop_minichair'),
('rooftop', 2, 7, 0, ''),
('rooftop', 3, 7, 6, 'rooftop_minichair'),
('rooftop', 2, 8, 0, 'rooftop_minichair'),
('rooftop', 0, 9, 4, 'rooftop_minichair'),
('rooftop', 0, 10, 0, ''),
('rooftop', 0, 11, 0, 'rooftop_minichair'),
('rooftop', 1, 13, 2, ''),
('rooftop', 6, 13, 6, ''),
('rooftop', 8, 13, 2, ''),
('rooftop', 13, 13, 6, ''),
('rooftop', 1, 14, 2, ''),
('rooftop', 6, 14, 6, ''),
('rooftop', 8, 14, 2, ''),
('rooftop', 13, 14, 6, ''),
('rooftop', 1, 15, 2, ''),
('rooftop', 6, 15, 6, ''),
('rooftop', 8, 15, 2, ''),
('rooftop', 13, 15, 6, ''),
('rooftop', 1, 16, 2, ''),
('rooftop', 6, 16, 6, ''),
('rooftop', 8, 16, 2, ''),
('rooftop', 13, 16, 6, ''),
('rooftop', 1, 17, 0, ''),
('rooftop', 2, 17, 0, ''),
('rooftop', 3, 17, 0, ''),
('rooftop', 4, 17, 0, ''),
('rooftop', 5, 17, 0, ''),
('rooftop', 6, 17, 0, ''),
('rooftop', 8, 17, 0, ''),
('rooftop', 9, 17, 0, ''),
('rooftop', 10, 17, 0, ''),
('rooftop', 11, 17, 0, ''),
('rooftop', 12, 17, 0, ''),
('rooftop', 13, 17, 0, ''),
('rooftop_2', 8, 0, 4, 'rooftop_bigchair'),
('rooftop_2', 8, 1, 0, ''),
('rooftop_2', 0, 2, 4, 'rooftop_sofab'),
('rooftop_2', 1, 2, 4, 'rooftop_sofa'),
('rooftop_2', 8, 2, 0, 'rooftop_bigchair'),
('rooftop_2', 8, 3, 4, 'rooftop_bigchair'),
('rooftop_2', 8, 4, 0, ''),
('rooftop_2', 0, 5, 0, 'rooftop_sofab'),
('rooftop_2', 1, 5, 0, 'rooftop_sofa'),
('rooftop_2', 8, 5, 0, 'rooftop_bigchair'),
('rooftop_2', 0, 6, 4, 'rooftop_sofab'),
('rooftop_2', 1, 6, 4, 'rooftop_sofa'),
('rooftop_2', 7, 6, 4, 'rooftop_sofab'),
('rooftop_2', 8, 6, 4, 'rooftop_sofa'),
('rooftop_2', 0, 9, 0, 'rooftop_sofab'),
('rooftop_2', 1, 9, 0, 'rooftop_sofa'),
('rooftop_2', 7, 9, 0, 'rooftop_sofab'),
('rooftop_2', 8, 9, 0, 'rooftop_sofa'),
('star_lounge', 21, 15, 0, ''),
('star_lounge', 22, 15, 4, 'star_sofa'),
('star_lounge', 23, 15, 4, 'star_sofa2'),
('star_lounge', 24, 15, 0, ''),
('star_lounge', 21, 16, 2, 'star_sofa2'),
('star_lounge', 32, 16, 0, ''),
('star_lounge', 33, 16, 0, ''),
('star_lounge', 34, 16, 0, ''),
('star_lounge', 21, 17, 2, 'star_sofa'),
('star_lounge', 28, 17, 0, ''),
('star_lounge', 21, 18, 2, 'star_sofa2'),
('star_lounge', 35, 18, 6, 'star_sofa'),
('star_lounge', 21, 19, 2, 'star_sofa'),
('star_lounge', 35, 19, 6, 'star_sofa2'),
('star_lounge', 21, 20, 2, 'star_sofa2'),
('star_lounge', 24, 20, 2, 'star_sofa2'),
('star_lounge', 32, 20, 6, 'star_sofa'),
('star_lounge', 35, 20, 6, 'star_sofa'),
('star_lounge', 21, 21, 2, 'star_sofa'),
('star_lounge', 24, 21, 2, 'star_sofa'),
('star_lounge', 32, 21, 6, 'star_sofa2'),
('star_lounge', 35, 21, 6, 'star_sofa2'),
('star_lounge', 21, 22, 2, 'star_sofachair'),
('star_lounge', 24, 22, 0, ''),
('star_lounge', 25, 22, 0, 'star_sofa2'),
('star_lounge', 26, 22, 0, 'star_sofa'),
('star_lounge', 30, 22, 0, 'star_sofa2'),
('star_lounge', 31, 22, 0, 'star_sofa'),
('star_lounge', 32, 22, 0, ''),
('star_lounge', 35, 22, 0, ''),
('star_lounge', 21, 23, 0, ''),
('star_lounge', 35, 23, 6, 'star_sofa'),
('star_lounge', 22, 24, 0, ''),
('star_lounge', 35, 24, 6, 'star_sofa2'),
('star_lounge', 37, 24, 4, 'star_sofa'),
('star_lounge', 38, 24, 4, 'star_sofa2'),
('star_lounge', 39, 24, 4, 'star_sofa'),
('star_lounge', 40, 24, 4, 'star_sofa2'),
('star_lounge', 22, 25, 0, ''),
('star_lounge', 25, 25, 0, 'star_sofa2'),
('star_lounge', 26, 25, 0, 'star_sofa'),
('star_lounge', 30, 25, 0, 'star_sofa2'),
('star_lounge', 31, 25, 0, 'star_sofa'),
('star_lounge', 35, 25, 6, 'star_sofa'),
('star_lounge', 36, 25, 2, 'star_sofa2'),
('star_lounge', 22, 26, 0, ''),
('star_lounge', 25, 26, 0, ''),
('star_lounge', 26, 26, 0, ''),
('star_lounge', 30, 26, 0, ''),
('star_lounge', 31, 26, 0, ''),
('star_lounge', 35, 26, 6, 'star_sofa2'),
('star_lounge', 36, 26, 2, 'star_sofa'),
('star_lounge', 39, 26, 0, ''),
('star_lounge', 40, 26, 0, ''),
('star_lounge', 22, 27, 0, ''),
('star_lounge', 25, 27, 4, 'star_sofa'),
('star_lounge', 26, 27, 4, 'star_sofa2'),
('star_lounge', 30, 27, 4, 'star_sofa'),
('star_lounge', 31, 27, 4, 'star_sofa2'),
('star_lounge', 35, 27, 0, ''),
('star_lounge', 36, 27, 0, ''),
('star_lounge', 37, 27, 0, ''),
('star_lounge', 22, 28, 0, ''),
('star_lounge', 22, 29, 0, ''),
('star_lounge', 25, 29, 0, ''),
('star_lounge', 26, 29, 0, ''),
('star_lounge', 16, 30, 0, ''),
('star_lounge', 22, 30, 0, ''),
('star_lounge', 16, 31, 2, 'star_sofa2'),
('star_lounge', 22, 31, 0, ''),
('star_lounge', 25, 31, 0, 'star_sofa2'),
('star_lounge', 26, 31, 0, 'star_sofa'),
('star_lounge', 30, 31, 6, 'star_sofa'),
('star_lounge', 16, 32, 2, 'star_sofa'),
('star_lounge', 22, 32, 0, ''),
('star_lounge', 25, 32, 0, ''),
('star_lounge', 26, 32, 0, ''),
('star_lounge', 30, 32, 6, 'star_sofa2'),
('star_lounge', 16, 33, 2, 'star_sofa2'),
('star_lounge', 22, 33, 0, ''),
('star_lounge', 25, 33, 4, 'star_sofa'),
('star_lounge', 26, 33, 4, 'star_sofa2'),
('star_lounge', 30, 33, 6, 'star_sofa'),
('star_lounge', 16, 34, 2, 'star_sofa'),
('star_lounge', 30, 34, 6, 'star_sofa2'),
('star_lounge', 35, 34, 0, ''),
('star_lounge', 36, 34, 0, ''),
('star_lounge', 16, 35, 0, ''),
('star_lounge', 30, 35, 6, 'star_sofa'),
('star_lounge', 30, 36, 6, 'star_sofa2'),
('star_lounge', 25, 37, 0, 'star_sofachair'),
('star_lounge', 26, 37, 0, 'star_sofa2'),
('star_lounge', 27, 37, 0, 'star_sofa'),
('star_lounge', 28, 37, 0, 'star_sofa2'),
('star_lounge', 29, 37, 0, 'star_sofa'),
('star_lounge', 30, 37, 0, ''),
('netcafe', 6, 0, 4, ''),
('netcafe', 7, 0, 4, ''),
('netcafe', 10, 1, 0, ''),
('netcafe', 13, 1, 0, ''),
('netcafe', 16, 1, 0, ''),
('netcafe', 19, 1, 0, ''),
('netcafe', 5, 3, 0, ''),
('netcafe', 6, 3, 0, ''),
('netcafe', 12, 3, 0, ''),
('netcafe', 13, 3, 0, ''),
('netcafe', 19, 3, 0, ''),
('netcafe', 20, 3, 0, ''),
('netcafe', 12, 4, 4, ''),
('netcafe', 13, 4, 4, ''),
('netcafe', 19, 4, 4, ''),
('netcafe', 20, 4, 4, ''),
('netcafe', 0, 5, 4, ''),
('netcafe', 1, 5, 4, ''),
('netcafe', 2, 5, 4, ''),
('netcafe', 3, 5, 4, ''),
('netcafe', 15, 7, 2, ''),
('netcafe', 16, 7, 6, ''),
('netcafe', 17, 7, 0, ''),
('netcafe', 18, 7, 6, ''),
('netcafe', 15, 8, 2, ''),
('netcafe', 16, 8, 4, ''),
('netcafe', 18, 8, 6, ''),
('netcafe', 4, 9, 6, ''),
('netcafe', 9, 9, 2, ''),
('netcafe', 10, 9, 6, ''),
('netcafe', 11, 9, 0, ''),
('netcafe', 12, 9, 6, ''),
('netcafe', 15, 9, 2, ''),
('netcafe', 16, 9, 2, ''),
('netcafe', 18, 9, 6, ''),
('netcafe', 4, 10, 6, ''),
('netcafe', 9, 10, 2, ''),
('netcafe', 10, 10, 4, ''),
('netcafe', 12, 10, 6, ''),
('netcafe', 15, 10, 2, ''),
('netcafe', 16, 10, 0, ''),
('netcafe', 18, 10, 6, ''),
('netcafe', 4, 11, 6, ''),
('netcafe', 9, 11, 2, ''),
('netcafe', 10, 11, 2, ''),
('netcafe', 12, 11, 6, ''),
('netcafe', 4, 12, 6, ''),
('netcafe', 9, 12, 2, ''),
('netcafe', 10, 12, 0, ''),
('netcafe', 12, 12, 6, ''),
('netcafe', 4, 13, 6, ''),
('netcafe', 5, 16, 0, ''),
('netcafe', 6, 16, 0, ''),
('netcafe', 7, 16, 0, ''),
('netcafe', 8, 16, 0, ''),
('netcafe', 9, 16, 0, ''),
('netcafe', 15, 16, 0, ''),
('netcafe', 9, 17, 0, ''),
('netcafe', 6, 18, 6, ''),
('netcafe', 9, 18, 0, ''),
('netcafe', 20, 18, 6, 'sofabig3'),
('netcafe', 9, 19, 0, ''),
('netcafe', 17, 19, 4, ''),
('netcafe', 18, 19, 0, ''),
('netcafe', 20, 19, 6, 'sofabig2'),
('netcafe', 17, 20, 2, ''),
('netcafe', 20, 20, 6, 'sofabig2'),
('netcafe', 6, 21, 6, ''),
('netcafe', 17, 21, 0, ''),
('netcafe', 20, 21, 6, 'sofabig1'),
('netcafe', 16, 23, 0, 'sofalittle3'),
('netcafe', 17, 23, 0, 'sofalittle2'),
('netcafe', 18, 23, 0, 'sofalittle1'),
('netcafe', 20, 23, 0, ''),
('dusty_lounge', 8, 4, 4, 'greenchair2'),
('dusty_lounge', 9, 4, 4, 'greenchair1'),
('dusty_lounge', 8, 6, 0, 'greenchair2'),
('dusty_lounge', 9, 6, 0, 'greenchair1'),
('dusty_lounge', 20, 6, 2, ''),
('dusty_lounge', 28, 6, 2, ''),
('dusty_lounge', 3, 7, 4, 'greenchair2'),
('dusty_lounge', 4, 7, 4, 'greenchair1'),
('dusty_lounge', 3, 9, 0, 'greenchair2'),
('dusty_lounge', 4, 9, 0, 'greenchair1'),
('dusty_lounge', 21, 10, 2, 'yellowchair'),
('dusty_lounge', 23, 10, 6, 'yellowchair'),
('dusty_lounge', 26, 10, 2, 'yellowchair'),
('dusty_lounge', 28, 10, 6, 'yellowchair'),
('dusty_lounge', 11, 12, 2, 'greenchair2'),
('dusty_lounge', 3, 13, 4, 'greenchair2'),
('dusty_lounge', 4, 13, 4, 'greenchair1'),
('dusty_lounge', 11, 13, 2, 'greenchair1'),
('dusty_lounge', 11, 14, 2, ''),
('dusty_lounge', 3, 15, 0, 'greenchair2'),
('dusty_lounge', 4, 15, 0, 'greenchair1'),
('dusty_lounge', 11, 15, 2, 'greenchair2'),
('dusty_lounge', 24, 15, 4, 'yellowchair'),
('dusty_lounge', 11, 16, 2, 'greenchair1'),
('dusty_lounge', 22, 17, 2, 'yellowchair'),
('dusty_lounge', 24, 17, 2, ''),
('dusty_lounge', 26, 17, 6, 'yellowchair'),
('dusty_lounge', 11, 19, 2, ''),
('dusty_lounge', 24, 19, 0, 'yellowchair'),
('dusty_lounge', 12, 23, 2, 'greenchair2'),
('dusty_lounge', 14, 23, 6, 'greenchair2'),
('dusty_lounge', 12, 24, 2, 'greenchair1'),
('dusty_lounge', 14, 24, 6, 'greenchair1'),
('orient', 17, 10, 2, 'bench'),
('orient', 19, 10, 6, 'bench'),
('orient', 21, 10, 2, 'bench'),
('orient', 23, 10, 6, 'bench'),
('orient', 17, 11, 2, 'bench'),
('orient', 19, 11, 6, 'bench'),
('orient', 21, 11, 2, 'bench'),
('orient', 23, 11, 6, 'bench'),
('orient', 32, 11, 4, 'koc_chair'),
('orient', 17, 12, 2, 'bench'),
('orient', 19, 12, 6, 'bench'),
('orient', 21, 12, 2, 'bench'),
('orient', 23, 12, 6, 'bench'),
('orient', 31, 12, 2, 'koc_chair'),
('orient', 32, 12, 0, ''),
('orient', 33, 12, 6, 'koc_chair'),
('orient', 17, 13, 2, 'bench'),
('orient', 19, 13, 6, 'bench'),
('orient', 21, 13, 2, 'bench'),
('orient', 23, 13, 6, 'bench'),
('orient', 25, 13, 4, 'koc_chair'),
('orient', 32, 13, 0, 'koc_chair'),
('orient', 17, 14, 2, 'bench'),
('orient', 19, 14, 6, 'bench'),
('orient', 21, 14, 2, 'bench'),
('orient', 23, 14, 6, 'bench'),
('orient', 25, 14, 0, ''),
('orient', 26, 14, 6, 'koc_chair'),
('orient', 17, 15, 2, 'bench'),
('orient', 19, 15, 6, 'bench'),
('orient', 21, 15, 2, 'bench'),
('orient', 23, 15, 6, 'bench'),
('orient', 25, 15, 0, 'koc_chair'),
('orient', 29, 15, 2, 'koc_chair'),
('orient', 30, 15, 0, ''),
('orient', 31, 15, 6, 'koc_chair'),
('orient', 30, 16, 0, 'koc_chair'),
('orient', 25, 24, 2, 'chairf1'),
('orient', 33, 24, 6, 'chairf1'),
('orient', 17, 25, 2, 'bench'),
('orient', 19, 25, 6, 'bench'),
('orient', 21, 25, 2, 'bench'),
('orient', 23, 25, 6, 'bench'),
('orient', 25, 25, 2, 'chairf1'),
('orient', 33, 25, 6, 'chairf1'),
('orient', 17, 26, 2, 'bench'),
('orient', 19, 26, 6, 'bench'),
('orient', 21, 26, 2, 'bench'),
('orient', 23, 26, 6, 'bench'),
('orient', 25, 26, 2, 'chairf1'),
('orient', 33, 26, 6, 'chairf1'),
('orient', 17, 27, 2, 'bench'),
('orient', 19, 27, 6, 'bench'),
('orient', 21, 27, 2, 'bench'),
('orient', 23, 27, 6, 'bench'),
('orient', 17, 28, 2, 'bench'),
('orient', 19, 28, 6, 'bench'),
('orient', 21, 28, 2, 'bench'),
('orient', 23, 28, 6, 'bench'),
('orient', 17, 29, 2, 'bench'),
('orient', 19, 29, 6, 'bench'),
('orient', 21, 29, 2, 'bench'),
('orient', 23, 29, 6, 'bench'),
('theater', 11, 10, 0, ''),
('theater', 2, 11, 2, 'thchair2'),
('theater', 2, 12, 2, 'thchair2'),
('theater', 2, 15, 2, 'thchair2'),
('theater', 6, 15, 0, 'thchair1'),
('theater', 7, 15, 0, 'thchair1'),
('theater', 8, 15, 0, 'thchair1'),
('theater', 9, 15, 0, 'thchair1'),
('theater', 10, 15, 0, 'thchair1'),
('theater', 12, 15, 0, 'thchair1'),
('theater', 13, 15, 0, 'thchair1'),
('theater', 14, 15, 0, 'thchair1'),
('theater', 15, 15, 0, 'thchair1'),
('theater', 16, 15, 0, 'thchair1'),
('theater', 2, 16, 2, 'thchair2'),
('theater', 6, 20, 0, 'thchair1'),
('theater', 7, 20, 0, 'thchair1'),
('theater', 8, 20, 0, 'thchair1'),
('theater', 9, 20, 0, 'thchair1'),
('theater', 10, 20, 0, 'thchair1'),
('theater', 12, 20, 0, 'thchair1'),
('theater', 13, 20, 0, 'thchair1'),
('theater', 14, 20, 0, 'thchair1'),
('theater', 15, 20, 0, 'thchair1'),
('theater', 16, 20, 0, 'thchair1'),
('theater', 6, 23, 0, 'thchair1'),
('theater', 7, 23, 0, 'thchair1'),
('theater', 8, 23, 0, 'thchair1'),
('theater', 9, 23, 0, 'thchair1'),
('theater', 10, 23, 0, 'thchair1'),
('theater', 12, 23, 0, 'thchair1'),
('theater', 13, 23, 0, 'thchair1'),
('theater', 14, 23, 0, 'thchair1'),
('theater', 15, 23, 0, 'thchair1'),
('theater', 16, 23, 0, 'thchair1'),
('theater', 6, 26, 0, 'thchair1'),
('theater', 7, 26, 0, 'thchair1'),
('theater', 8, 26, 0, 'thchair1'),
('theater', 9, 26, 0, 'thchair1'),
('theater', 10, 26, 0, 'thchair1'),
('theater', 12, 26, 0, 'thchair1'),
('theater', 13, 26, 0, 'thchair1'),
('theater', 14, 26, 0, 'thchair1'),
('theater', 15, 26, 0, 'thchair1'),
('theater', 16, 26, 0, 'thchair1'),
('picnic', 10, 7, 4, ''),
('picnic', 11, 7, 4, ''),
('picnic', 12, 7, 4, ''),
('picnic', 13, 7, 4, ''),
('picnic', 14, 7, 4, ''),
('picnic', 18, 7, 4, ''),
('picnic', 19, 7, 4, ''),
('picnic', 20, 7, 4, ''),
('picnic', 21, 7, 4, ''),
('picnic', 14, 8, 4, ''),
('picnic', 18, 8, 4, ''),
('picnic', 3, 9, 4, ''),
('picnic', 3, 10, 4, ''),
('picnic', 12, 11, 4, 'picnic_dummychair1'),
('picnic', 13, 11, 4, 'picnic_dummychair1'),
('picnic', 14, 11, 4, 'picnic_dummychair1'),
('picnic', 10, 13, 2, 'picnic_dummychair1'),
('picnic', 15, 13, 6, 'picnic_dummychair1'),
('picnic', 21, 13, 4, ''),
('picnic', 7, 14, 4, ''),
('picnic', 10, 14, 2, 'picnic_dummychair1'),
('picnic', 15, 14, 6, 'picnic_dummychair1'),
('picnic', 19, 15, 2, ''),
('picnic', 23, 15, 6, ''),
('picnic', 5, 16, 2, ''),
('picnic', 9, 16, 6, ''),
('picnic', 20, 16, 2, ''),
('picnic', 6, 17, 2, ''),
('picnic', 21, 17, 0, ''),
('picnic', 7, 18, 0, ''),
('picnic', 0, 19, 2, 'picnic_redbench2'),
('picnic', 0, 20, 2, 'picnic_redbench1'),
('picnic', 11, 20, 4, ''),
('picnic', 12, 20, 4, ''),
('picnic', 13, 20, 4, ''),
('picnic', 14, 20, 4, ''),
('picnic', 17, 20, 4, ''),
('picnic', 18, 20, 4, ''),
('picnic', 19, 20, 4, ''),
('picnic', 20, 20, 4, ''),
('picnic', 11, 21, 4, ''),
('picnic', 12, 21, 4, 'picnic_bench1'),
('picnic', 13, 21, 4, 'picnic_bench2'),
('picnic', 14, 21, 4, 'picnic_bench3'),
('picnic', 17, 21, 4, 'picnic_bench1'),
('picnic', 18, 21, 4, 'picnic_bench2'),
('picnic', 19, 21, 4, 'picnic_bench3'),
('picnic', 20, 21, 4, ''),
('picnic', 0, 22, 2, 'picnic_redbench2'),
('picnic', 11, 22, 4, ''),
('picnic', 20, 22, 4, ''),
('picnic', 25, 22, 4, ''),
('picnic', 0, 23, 2, 'picnic_redbench1'),
('picnic', 11, 23, 4, ''),
('picnic', 12, 23, 2, 'picnic_bench1'),
('picnic', 19, 23, 6, 'picnic_bench1'),
('picnic', 20, 23, 4, ''),
('picnic', 6, 24, 4, 'picnic_dummychair1'),
('picnic', 7, 24, 4, 'picnic_dummychair4'),
('picnic', 8, 24, 4, 'picnic_dummychair6'),
('picnic', 11, 24, 4, ''),
('picnic', 12, 24, 2, 'picnic_bench2'),
('picnic', 19, 24, 6, 'picnic_bench2'),
('picnic', 20, 24, 4, ''),
('picnic', 23, 24, 2, ''),
('picnic', 27, 24, 6, ''),
('picnic', 5, 25, 2, ''),
('picnic', 11, 25, 4, ''),
('picnic', 12, 25, 2, 'picnic_bench2'),
('picnic', 19, 25, 6, 'picnic_bench2'),
('picnic', 20, 25, 4, ''),
('picnic', 24, 25, 2, ''),
('picnic', 7, 26, 0, ''),
('picnic', 11, 26, 4, ''),
('picnic', 12, 26, 2, 'picnic_bench3'),
('picnic', 14, 26, 0, ''),
('picnic', 16, 26, 2, ''),
('picnic', 19, 26, 6, 'picnic_bench3'),
('picnic', 20, 26, 4, ''),
('picnic', 25, 26, 0, ''),
('picnic', 11, 27, 4, ''),
('picnic', 12, 27, 4, ''),
('picnic', 20, 27, 4, ''),
('picnic', 8, 29, 0, ''),
('picnic', 0, 30, 2, 'picnic_redbench2'),
('picnic', 8, 30, 0, ''),
('picnic', 0, 31, 2, 'picnic_redbench1'),
('picnic', 8, 31, 0, ''),
('picnic', 12, 31, 4, 'picnic_bench1'),
('picnic', 13, 31, 4, 'picnic_bench2'),
('picnic', 14, 31, 4, 'picnic_bench3'),
('picnic', 18, 31, 4, 'picnic_bench1'),
('picnic', 19, 31, 4, 'picnic_bench2'),
('picnic', 20, 31, 4, 'picnic_bench3'),
('picnic', 27, 31, 0, ''),
('picnic', 28, 31, 0, ''),
('picnic', 29, 31, 0, ''),
('picnic', 30, 31, 0, ''),
('picnic', 31, 31, 0, ''),
('picnic', 8, 32, 0, ''),
('picnic', 12, 32, 2, ''),
('picnic', 14, 32, 2, ''),
('picnic', 18, 32, 2, ''),
('picnic', 20, 32, 2, ''),
('picnic', 3, 33, 4, ''),
('picnic', 8, 33, 0, ''),
('picnic', 12, 33, 0, 'picnic_bench1'),
('picnic', 13, 33, 0, 'picnic_bench2'),
('picnic', 14, 33, 0, 'picnic_bench3'),
('picnic', 18, 33, 0, 'picnic_bench1'),
('picnic', 19, 33, 0, 'picnic_bench2'),
('picnic', 20, 33, 0, 'picnic_bench3'),
('picnic', 27, 33, 0, ''),
('picnic', 28, 33, 0, ''),
('picnic', 29, 33, 0, ''),
('picnic', 3, 34, 4, ''),
('picnic', 8, 34, 0, ''),
('picnic', 3, 35, 4, ''),
('picnic', 8, 35, 0, ''),
('picnic', 3, 36, 4, ''),
('picnic', 8, 36, 0, ''),
('picnic', 8, 37, 0, ''),
('picnic', 12, 37, 4, 'picnic_bench1'),
('picnic', 13, 37, 4, 'picnic_bench2'),
('picnic', 14, 37, 4, 'picnic_bench3'),
('picnic', 18, 37, 4, 'picnic_bench1'),
('picnic', 19, 37, 4, 'picnic_bench2'),
('picnic', 20, 37, 4, 'picnic_bench3'),
('picnic', 8, 38, 0, ''),
('picnic', 12, 38, 2, ''),
('picnic', 14, 38, 2, ''),
('picnic', 18, 38, 2, ''),
('picnic', 20, 38, 2, ''),
('picnic', 8, 39, 0, ''),
('picnic', 12, 39, 0, 'picnic_bench1'),
('picnic', 13, 39, 0, 'picnic_bench2'),
('picnic', 14, 39, 0, 'picnic_bench3'),
('picnic', 18, 39, 0, 'picnic_bench1'),
('picnic', 19, 39, 0, 'picnic_bench2'),
('picnic', 20, 39, 0, 'picnic_bench3'),
('cinema_a', 2, 4, 0, ''),
('cinema_a', 7, 4, 2, 'loungey_chair'),
('cinema_a', 8, 4, 0, ''),
('cinema_a', 9, 4, 6, 'loungey_chair'),
('cinema_a', 2, 5, 4, 'loungey_chair'),
('cinema_a', 7, 5, 2, 'loungey_chair'),
('cinema_a', 8, 5, 0, ''),
('cinema_a', 9, 5, 6, 'loungey_chair'),
('cinema_a', 2, 6, 0, ''),
('cinema_a', 2, 7, 0, 'loungey_chair'),
('cinema_a', 13, 7, 0, 'theater_chair'),
('cinema_a', 14, 7, 0, 'theater_chair'),
('cinema_a', 15, 7, 0, 'theater_chair'),
('cinema_a', 16, 7, 0, 'theater_chair'),
('cinema_a', 17, 7, 0, 'theater_chair'),
('cinema_a', 18, 7, 0, 'theater_chair'),
('cinema_a', 21, 7, 0, ''),
('cinema_a', 9, 8, 0, ''),
('cinema_a', 13, 8, 2, ''),
('cinema_a', 14, 8, 0, ''),
('cinema_a', 15, 8, 0, ''),
('cinema_a', 16, 8, 0, ''),
('cinema_a', 17, 8, 0, ''),
('cinema_a', 18, 8, 0, ''),
('cinema_a', 19, 8, 1, ''),
('cinema_a', 21, 8, 0, ''),
('cinema_a', 2, 9, 0, ''),
('cinema_a', 13, 9, 0, 'theater_chair'),
('cinema_a', 14, 9, 0, 'theater_chair'),
('cinema_a', 15, 9, 0, 'theater_chair'),
('cinema_a', 16, 9, 0, 'theater_chair'),
('cinema_a', 17, 9, 0, 'theater_chair'),
('cinema_a', 18, 9, 0, 'theater_chair'),
('cinema_a', 19, 9, 0, 'theater_chair'),
('cinema_a', 20, 9, 0, 'theater_chair'),
('cinema_a', 21, 9, 0, ''),
('cinema_a', 2, 10, 4, 'loungey_chair'),
('cinema_a', 9, 10, 4, 'loungey_chair'),
('cinema_a', 2, 11, 0, ''),
('cinema_a', 9, 11, 0, ''),
('cinema_a', 2, 12, 0, 'loungey_chair'),
('cinema_a', 9, 12, 0, 'loungey_chair'),
('cinema_a', 17, 12, 6, 'cubicb_chair'),
('cinema_a', 19, 12, 2, 'cubico_chair'),
('cinema_a', 15, 13, 2, 'cubicb_chair'),
('cinema_a', 19, 13, 0, ''),
('cinema_a', 20, 13, 6, 'cubicb_chair'),
('cinema_a', 9, 14, 0, ''),
('cinema_a', 2, 15, 4, 'loungey_chair'),
('cinema_a', 14, 15, 4, 'cubicb_chair'),
('cinema_a', 19, 15, 4, 'cubico_chair'),
('cinema_a', 2, 16, 0, ''),
('cinema_a', 7, 16, 2, 'loungey_chair'),
('cinema_a', 8, 16, 2, ''),
('cinema_a', 9, 16, 6, 'loungey_chair'),
('cinema_a', 13, 16, 2, 'cubicb_chair'),
('cinema_a', 14, 16, 6, 'cubicb_chair'),
('cinema_a', 19, 16, 0, ''),
('cinema_a', 2, 17, 0, 'loungey_chair'),
('cinema_a', 7, 17, 2, 'loungey_chair'),
('cinema_a', 8, 17, 2, ''),
('cinema_a', 9, 17, 6, 'loungey_chair'),
('cinema_a', 19, 17, 2, 'cubicb_chair'),
('cinema_a', 2, 18, 0, ''),
('cinema_a', 14, 18, 4, 'cubicb_chair'),
('cinema_a', 2, 19, 0, ''),
('cinema_a', 2, 20, 1, ''),
('cinema_a', 3, 20, 6, 'bar_chair'),
('cinema_a', 9, 20, 0, ''),
('cinema_a', 14, 20, 0, 'cubicb_chair'),
('cinema_a', 19, 20, 2, 'cubicb_chair'),
('cinema_a', 20, 20, 6, 'cubico_chair'),
('cinema_a', 2, 21, 1, ''),
('cinema_a', 3, 21, 6, 'bar_chair'),
('cinema_a', 19, 21, 0, 'cubicb_chair'),
('cinema_a', 2, 22, 1, ''),
('cinema_a', 3, 22, 6, 'bar_chair'),
('cinema_a', 16, 22, 0, ''),
('cinema_a', 18, 22, 0, 'cubico_chair'),
('cinema_a', 2, 23, 1, ''),
('cinema_a', 3, 23, 6, 'bar_chair'),
('cinema_a', 2, 24, 1, ''),
('cinema_a', 3, 24, 6, 'bar_chair'),
('cinema_a', 2, 25, 2, ''),
('park_a', 27, 5, 0, ''),
('park_a', 29, 5, 0, ''),
('park_a', 19, 6, 0, ''),
('park_a', 20, 6, 4, ''),
('park_a', 21, 6, 4, ''),
('park_a', 22, 6, 4, ''),
('park_a', 23, 6, 4, ''),
('park_a', 24, 6, 4, ''),
('park_a', 25, 6, 4, ''),
('park_a', 26, 6, 4, ''),
('park_a', 27, 6, 2, ''),
('park_a', 29, 6, 2, ''),
('park_a', 17, 7, 0, ''),
('park_a', 19, 7, 2, ''),
('park_a', 23, 7, 2, ''),
('park_a', 27, 7, 2, ''),
('park_a', 29, 7, 2, ''),
('park_a', 17, 8, 2, ''),
('park_a', 19, 8, 2, ''),
('park_a', 21, 8, 0, ''),
('park_a', 23, 8, 2, ''),
('park_a', 25, 8, 0, ''),
('park_a', 27, 8, 2, ''),
('park_a', 29, 8, 2, ''),
('park_a', 8, 9, 4, 'bench2'),
('park_a', 9, 9, 4, 'bench'),
('park_a', 17, 9, 2, ''),
('park_a', 19, 9, 6, ''),
('park_a', 21, 9, 2, ''),
('park_a', 23, 9, 6, ''),
('park_a', 25, 9, 2, ''),
('park_a', 27, 9, 6, ''),
('park_a', 29, 9, 2, ''),
('park_a', 17, 10, 2, ''),
('park_a', 21, 10, 2, ''),
('park_a', 25, 10, 2, ''),
('park_a', 29, 10, 2, ''),
('park_a', 7, 11, 2, 'bench2'),
('park_a', 17, 11, 4, ''),
('park_a', 18, 11, 4, ''),
('park_a', 19, 11, 4, ''),
('park_a', 20, 11, 4, ''),
('park_a', 21, 11, 2, ''),
('park_a', 22, 11, 4, ''),
('park_a', 23, 11, 4, ''),
('park_a', 24, 11, 4, ''),
('park_a', 25, 11, 2, ''),
('park_a', 26, 11, 4, ''),
('park_a', 27, 11, 4, ''),
('park_a', 28, 11, 4, ''),
('park_a', 29, 11, 6, ''),
('park_a', 7, 12, 2, 'bench'),
('park_a', 35, 16, 2, 'bench2'),
('park_a', 37, 16, 4, 'bench2'),
('park_a', 38, 16, 4, 'bench'),
('park_a', 35, 17, 2, 'bench'),
('park_a', 27, 18, 4, 'bench2'),
('park_a', 28, 18, 4, 'bench'),
('park_a', 35, 18, 2, 'bench2'),
('park_a', 25, 19, 2, 'bench2'),
('park_a', 35, 19, 2, 'bench'),
('park_a', 25, 20, 2, 'bench'),
('park_a', 25, 29, 4, 'bench2'),
('park_a', 26, 29, 4, 'bench'),
('park_a', 23, 30, 2, 'bench2'),
('park_a', 23, 31, 2, 'bench'),
('pool_a', 18, 4, 0, ''),
('pool_a', 18, 5, 2, 'pool_2sofa2'),
('pool_a', 18, 6, 2, 'pool_2sofa1'),
('pool_a', 7, 20, 0, ''),
('pool_a', 8, 20, 4, 'pool_chair2'),
('pool_a', 24, 20, 0, ''),
('pool_a', 25, 20, 4, 'pool_chair2'),
('pool_a', 7, 21, 2, 'pool_chair2'),
('pool_a', 8, 21, 0, ''),
('pool_a', 9, 21, 6, 'pool_chair2'),
('pool_a', 24, 21, 2, 'pool_chair2'),
('pool_a', 25, 21, 0, ''),
('pool_a', 8, 22, 0, 'pool_chair2'),
('pool_a', 2, 28, 0, ''),
('pool_a', 2, 29, 0, ''),
('pool_a', 6, 32, 0, ''),
('pool_a', 13, 33, 0, ''),
('pool_a', 10, 34, 4, 'pool_chairy'),
('pool_a', 8, 35, 0, ''),
('pool_a', 9, 35, 2, 'pool_chairy'),
('pool_a', 10, 35, 0, ''),
('pool_a', 11, 35, 6, 'pool_chairy'),
('pool_a', 15, 35, 0, ''),
('pool_a', 21, 35, 0, ''),
('pool_a', 10, 36, 0, 'pool_chairy'),
('pool_a', 15, 36, 4, 'pool_chairp'),
('pool_a', 21, 36, 4, 'pool_chairo'),
('pool_a', 22, 36, 4, 'pool_chairo'),
('pool_a', 14, 37, 2, 'pool_chairp'),
('pool_a', 15, 37, 0, ''),
('pool_a', 16, 37, 6, 'pool_chairp'),
('pool_a', 21, 37, 6, ''),
('pool_a', 22, 37, 6, ''),
('pool_a', 14, 38, 2, 'pool_chairp'),
('pool_a', 15, 38, 0, ''),
('pool_a', 16, 38, 6, 'pool_chairp'),
('pool_a', 21, 38, 0, 'pool_chairo'),
('pool_a', 22, 38, 0, 'pool_chairo'),
('pool_a', 15, 39, 0, 'pool_chairp'),
('pool_a', 20, 41, 4, 'pool_chairg'),
('pool_a', 21, 41, 4, 'pool_chairg'),
('pool_a', 20, 42, 6, ''),
('pool_a', 21, 42, 6, ''),
('pool_a', 19, 43, 0, ''),
('pool_a', 20, 43, 0, 'pool_chairg'),
('pool_a', 21, 43, 0, 'pool_chairg'),
('pool_b', 33, 2, 0, ''),
('pool_b', 18, 3, 4, 'pool_sofa2'),
('pool_b', 19, 3, 4, 'pool_sofa1'),
('pool_b', 20, 3, 4, 'pool_sofa2'),
('pool_b', 21, 3, 4, 'pool_sofa1'),
('pool_b', 22, 3, 4, 'pool_sofa2'),
('pool_b', 23, 3, 4, 'pool_sofa1'),
('pool_b', 33, 3, 4, 'pool_chair'),
('pool_b', 32, 4, 2, 'pool_chair'),
('pool_b', 33, 4, 0, ''),
('pool_b', 34, 4, 6, 'pool_chair'),
('pool_b', 16, 5, 2, 'pool_sofa2'),
('pool_b', 33, 5, 0, 'pool_chair'),
('pool_b', 16, 6, 2, 'pool_sofa1'),
('pool_b', 16, 7, 2, 'pool_sofa2'),
('pool_b', 35, 7, 4, 'pool_chair'),
('pool_b', 14, 8, 0, ''),
('pool_b', 16, 8, 2, 'pool_sofa1'),
('pool_b', 33, 8, 0, ''),
('pool_b', 34, 8, 2, 'pool_chair'),
('pool_b', 35, 8, 0, ''),
('pool_b', 36, 8, 6, 'pool_chair'),
('pool_b', 14, 9, 2, 'pool_sofa2'),
('pool_b', 16, 9, 2, 'pool_sofa2'),
('pool_b', 35, 9, 0, 'pool_chair'),
('pool_b', 14, 10, 2, 'pool_sofa1'),
('pool_b', 16, 10, 2, 'pool_sofa1'),
('pool_b', 14, 11, 2, 'pool_sofa2'),
('pool_b', 16, 11, 2, 'pool_sofa2'),
('pool_b', 14, 12, 2, 'pool_sofa1'),
('pool_b', 16, 12, 2, 'pool_sofa1'),
('pool_b', 3, 13, 2, ''),
('pool_b', 4, 13, 2, ''),
('pool_b', 14, 13, 2, 'pool_sofa2'),
('pool_b', 16, 13, 2, 'pool_sofa2'),
('pool_b', 14, 14, 2, 'pool_sofa1'),
('pool_b', 16, 14, 2, 'pool_sofa1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_rights`
--

CREATE TABLE IF NOT EXISTS `room_rights` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `room_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `room_id` (`room_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=27 ;

--
-- Volcado de datos para la tabla `room_rights`
--

INSERT INTO `room_rights` (`id`, `room_id`, `user_id`) VALUES
(26, 64, 71);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `room_swearword_filter`
--

CREATE TABLE IF NOT EXISTS `room_swearword_filter` (
  `word` varchar(200) NOT NULL,
  PRIMARY KEY (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `server_status`
--

CREATE TABLE IF NOT EXISTS `server_status` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `status` enum('0','1','2') NOT NULL DEFAULT '0',
  `users_online` int(11) NOT NULL DEFAULT '0',
  `rooms_loaded` int(11) NOT NULL DEFAULT '0',
  `server_ver` text NOT NULL,
  `stamp` double NOT NULL,
  `minutesuptime` int(11) NOT NULL,
  `userpeak` int(11) NOT NULL DEFAULT '0',
  `bannerdata` varchar(1000) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Volcado de datos para la tabla `server_status`
--

INSERT INTO `server_status` (`id`, `status`, `users_online`, `rooms_loaded`, `server_ver`, `stamp`, `minutesuptime`, `userpeak`) VALUES
(1, '0', 0, 0, 'Butterstorm Emulator r96', 1343756359, 53, 10001);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_app_form`
--

CREATE TABLE IF NOT EXISTS `site_app_form` (
  `id` varchar(24) NOT NULL,
  `caption` varchar(120) NOT NULL,
  `descr` text NOT NULL,
  `field_type` enum('textbox','textarea','checkbox') NOT NULL,
  `required` enum('0','1') NOT NULL DEFAULT '1',
  `order_num` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_app_openings`
--

CREATE TABLE IF NOT EXISTS `site_app_openings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `text_descr` text NOT NULL,
  `text_reqs` text NOT NULL,
  `text_duties` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_config`
--

CREATE TABLE IF NOT EXISTS `site_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `maintenance` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `maintaince` (`maintenance`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Volcado de datos para la tabla `site_config`
--

INSERT INTO `site_config` (`id`, `maintenance`) VALUES
(1, '0');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_cron`
--

CREATE TABLE IF NOT EXISTS `site_cron` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `prio` int(11) NOT NULL DEFAULT '5',
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  `scriptfile` varchar(50) NOT NULL,
  `last_exec` int(11) NOT NULL,
  `exec_every` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_hotcampaigns`
--

CREATE TABLE IF NOT EXISTS `site_hotcampaigns` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL DEFAULT '1',
  `enabled` enum('0','1') NOT NULL DEFAULT '1',
  `image_url` text NOT NULL,
  `caption` text NOT NULL,
  `descr` text NOT NULL,
  `url` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=16 ;

--
-- Volcado de datos para la tabla `site_hotcampaigns`
--

INSERT INTO `site_hotcampaigns` (`id`, `order_id`, `enabled`, `image_url`, `caption`, `descr`, `url`) VALUES
(12, 2, '0', 'http://i.imgur.com/Au8Dr.gif', 'Habbo.GG Staff', 'Need help? Want to know who exactly you need to contact? Go to the list!', '/staff.aspx'),
(13, 1, '1', 'c_images/hot_campaign_images_hq/hot_campaign_button_160x60_AUHotel.gif', 'We are back!', 'We are now back! This will be better, bigger, and more awesome than ANY hotel hotels!', '/client.aspx');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_minimail`
--

CREATE TABLE IF NOT EXISTS `site_minimail` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `sender_id` int(10) unsigned NOT NULL,
  `receiver_id` int(10) unsigned NOT NULL,
  `folder` enum('inbox','sent','trash') NOT NULL DEFAULT 'inbox',
  `is_read` enum('0','1') NOT NULL DEFAULT '0',
  `subject` varchar(120) NOT NULL,
  `date` varchar(120) NOT NULL,
  `isodate` varchar(120) NOT NULL,
  `timestamp` int(11) NOT NULL,
  `body` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2201 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_navi`
--

CREATE TABLE IF NOT EXISTS `site_navi` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `order_id` int(11) NOT NULL,
  `caption` text NOT NULL,
  `class` text NOT NULL,
  `url` text NOT NULL,
  `visibility` enum('0','1','2','3') NOT NULL COMMENT '0 = Never, 1 = Always, 2 = Logged in only, 3 = Guests only',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=39 ;

--
-- Volcado de datos para la tabla `site_navi`
--

INSERT INTO `site_navi` (`id`, `parent_id`, `order_id`, `caption`, `class`, `url`, `visibility`) VALUES
(1, 0, 1, '%habboName%', 'metab', '%www%/me', '2'),
(2, 1, 1, 'Home', '', '/me', '1'),
(5, 0, 2, 'Community', '', '%www%/community', '1'),
(4, 1, 4, 'Account Settings', '', '%www%/profile', '2'),
(6, 0, 3, 'Credits', '', '%www%/credits', '0'),
(7, 5, 1, 'Community', '', '%www%/community', '1'),
(8, 0, 1, 'Register At Habbo', 'tab-register-now', '%www%/register', '3'),
(9, 6, 1, 'Credits', '', '%www%/credits', '1'),
(10, 6, 3, 'Pixels', '', '%www%/credits/pixels', '1'),
(11, 6, 2, 'Habbo Club', '', '%www%/credits/Habboclub', '0'),
(13, 12, 1, 'Shop Home', '', '%www%/vip/shop', '2'),
(14, 1, 2, 'Public Page', '', '%www%/home/%habboName%', '2'),
(15, 1, 4, 'Habbo Club', '', '%www%/credits/Habboclub', '0'),
(16, 5, 3, 'Habbo Staff', '', '%www%/staff', '1'),
(17, 5, 2, 'News', '', '%www%/articles', '1'),
(18, 12, 2, 'Get Points', '', '%www%/vip/getpoints', '2'),
(20, 5, 4, 'Tags', '', '%www%/community/tags', '0'),
(23, 8, 1, 'Register to be awesome ;D', '', '%www%/register', '0'),
(22, 5, 5, 'VG Ways', '', '%www%/articles/category/13', '0'),
(24, 0, 4, 'Habbo Staff', '', '%www%/staff', '0'),
(25, 1, 2, 'Forums', '', '#', '0'),
(27, 26, 1, 'Credits', '', '%www%/tops', '1'),
(28, 1, 5, 'Rares Value', '', '%www%/me/rares', '1'),
(29, 1, 3, 'VG Windowed', '', '/client', '0'),
(30, 5, 4, 'Retired Staffs', '', '%www%/staff/retired', '0'),
(31, 0, 6, 'Staff App', 'tab-register-now', '%www%/apps', '1'),
(33, 0, 11, 'GGForum', 'tab-register-now', 'http://habboforums.info', '0'),
(34, 0, 8, 'Facebook', 'tab-register-now', 'http://facebook.com/habbodotvg', '1'),
(35, 0, 9, 'GGTweet', 'tab-register-now', 'twitter.com', '0'),
(36, 0, 10, 'GGTube', 'tab-register-now', 'youtube.com', '0'),
(37, 1, 3, 'My Page', '', '%www%/home/%habboName%', '0'),
(38, 0, 11, 'CMS (Beta)', 'tab-register-now', 'http://cms.habbo.cm', '1');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_news`
--

CREATE TABLE IF NOT EXISTS `site_news` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `seo_link` varchar(120) NOT NULL DEFAULT 'news-article',
  `title` text NOT NULL,
  `category_id` int(10) unsigned NOT NULL DEFAULT '1',
  `topstory_image` text NOT NULL,
  `body` text NOT NULL,
  `snippet` text NOT NULL,
  `datestr` varchar(50) NOT NULL,
  `timestamp` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `datestr` (`datestr`) USING BTREE
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14 ;

--
-- Volcado de datos para la tabla `site_news`
--

INSERT INTO `site_news` (`id`, `seo_link`, `title`, `category_id`, `topstory_image`, `body`, `snippet`, `datestr`, `timestamp`) VALUES
(9, 'nieuwe-site', 'Nieuwe Site', 12, 'c_images/Top_Story_Images/BeachBunny2.gif', '<p>Hey Nablo''s,</p>\r\n<p>Ja! We hebben eindelijk een nieuw site uiterlijk, deze gemaakt door T09! Het enige wat niet zo leuk is voor jullie is dat alle accounts zijn verwijdert. Dit omdat we een geheel nieuwe database hebben gekregen. Dit is wel beter voor ons, omdat we nu minder laggen etc.</p>\r\n<p>Nablo is nu in top conditie, nog wat laatste aanpassingen en we zijn helemaal klaar! Het enige wat we van jullie vragen is om zoveel mogelijk reclame te maken op andere hotels.</p>\r\n<p>TIPS:</p>\r\n<p>- Maak reclame op drukke hotels</p>\r\n<p>- Maak reclame op MSN</p>\r\n<p>- Maak reclame op Twitter/Facebook/Hyves</p>\r\n<p>- Maak niet een half uur reclame dat is te kort!</p>\r\n<p>Bij de 25 Start ik de Sollicitatie''s !</p>\r\n<p>&nbsp;</p>\r\n<p>Groetjes,</p>\r\n<p>Thierry &amp; T09 &amp; Relic - Hotel Beheer</p>', '<p>Wa is ie mooi!</p>', '28-Jun-2012', 1340992623),
(10, 'test', 'test', 12, 'c_images/Top_Story_Images/28152_topstory_infobus.gif', 'test', 'testr', '29-Jun-2012', 1340985763),
(11, 'test', 'test', 12, 'c_images/Top_Story_Images/28152_topstory_infobus.gif', 'test', 'test', '29-Jun-2012', 1340985769),
(12, 'test', 'test', 12, 'c_images/Top_Story_Images/28152_topstory_infobus.gif', 'test', 'test', '29-Jun-2012', 1340985782),
(13, 'test', 'test', 12, 'c_images/Top_Story_Images/28152_topstory_infobus.gif', 'test', 'testt', '29-Jun-2012', 1340985789);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `site_news_categories`
--

CREATE TABLE IF NOT EXISTS `site_news_categories` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `caption` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14 ;

--
-- Volcado de datos para la tabla `site_news_categories`
--

INSERT INTO `site_news_categories` (`id`, `caption`) VALUES
(12, 'Uncategorized'),
(1, 'Habbo'),
(2, 'Technical'),
(3, 'Updates'),
(4, 'Competitions'),
(5, 'Polls'),
(6, 'Sponsored'),
(7, 'Credits'),
(8, 'Habbo Club'),
(9, 'VIP'),
(10, 'Furni'),
(11, 'Support'),
(13, 'Habbo.VG Way');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `songs`
--

CREATE TABLE IF NOT EXISTS `songs` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL,
  `artist` varchar(32) NOT NULL,
  `song_data` text NOT NULL,
  `length` double NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `stafflog`
--

CREATE TABLE IF NOT EXISTS `stafflog` (
  `id` int(11) NOT NULL,
  `username` varchar(255) DEFAULT NULL,
  `command` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `staff_bios`
--

CREATE TABLE IF NOT EXISTS `staff_bios` (
  `id` int(11) NOT NULL DEFAULT '0',
  `user` varchar(250) DEFAULT NULL,
  `bio` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `staff_bios`
--

INSERT INTO `staff_bios` (`id`, `user`, `bio`) VALUES
(1, 'Various', 'im gay in a box.');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `staff_logs`
--

CREATE TABLE IF NOT EXISTS `staff_logs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `staffuser` varchar(40) NOT NULL,
  `target` varchar(40) NOT NULL,
  `action_type` varchar(40) NOT NULL,
  `description` text,
  `extra_info` text,
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=549 ;

--
-- Volcado de datos para la tabla `staff_logs`
--

INSERT INTO `staff_logs` (`id`, `staffuser`, `target`, `action_type`, `description`, `extra_info`, `time`, `deleted`) VALUES
(1, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-11 00:02:19', 0),
(2, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-11 00:05:02', 0),
(3, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-11 00:07:15', 0),
(4, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-11 00:38:59', 0),
(5, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-11 00:39:05', 0),
(6, 'Itachi', '', 'Chat command', 'Issued chat command :lay', NULL, '2012-07-11 00:39:13', 0),
(7, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-11 00:39:38', 0),
(8, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 102', NULL, '2012-07-13 09:21:56', 0),
(9, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1', NULL, '2012-07-13 09:21:59', 0),
(10, 'Itachi', '', 'Chat command', 'Issued chat command :enable 40', NULL, '2012-07-13 09:32:17', 0),
(11, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 10', NULL, '2012-07-13 09:32:20', 0),
(12, 'Fakundo', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-13 21:54:37', 0),
(13, 'Fakundo', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-13 21:54:39', 0),
(14, 'Fakundo', '', 'Chat command', 'Issued chat command :reload', NULL, '2012-07-13 15:02:58', 0),
(15, 'Fakundo', '', 'Chat command', 'Issued chat command :buyx 30', NULL, '2012-07-13 15:06:06', 0),
(16, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 2', NULL, '2012-07-13 15:28:20', 0),
(17, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 4', NULL, '2012-07-13 15:28:22', 0),
(18, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 99', NULL, '2012-07-13 15:28:24', 0),
(19, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 9', NULL, '2012-07-13 15:28:27', 0),
(20, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 101', NULL, '2012-07-13 15:28:29', 0),
(21, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1025', NULL, '2012-07-13 15:30:41', 0),
(22, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1006', NULL, '2012-07-13 15:31:37', 0),
(23, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1000', NULL, '2012-07-13 15:31:59', 0),
(24, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1001', NULL, '2012-07-13 15:32:02', 0),
(25, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1002', NULL, '2012-07-13 15:32:05', 0),
(26, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1003', NULL, '2012-07-13 15:32:08', 0),
(27, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1004', NULL, '2012-07-13 15:32:11', 0),
(28, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1005', NULL, '2012-07-13 15:32:13', 0),
(29, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1006', NULL, '2012-07-13 15:32:16', 0),
(30, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1007', NULL, '2012-07-13 15:32:19', 0),
(31, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1008', NULL, '2012-07-13 15:32:22', 0),
(32, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1009', NULL, '2012-07-13 15:32:26', 0),
(33, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1010', NULL, '2012-07-13 15:32:28', 0),
(34, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1011', NULL, '2012-07-13 15:32:31', 0),
(35, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1012', NULL, '2012-07-13 15:32:34', 0),
(36, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1013', NULL, '2012-07-13 15:32:37', 0),
(37, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1014', NULL, '2012-07-13 15:32:41', 0),
(38, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1015', NULL, '2012-07-13 15:32:43', 0),
(39, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1016', NULL, '2012-07-13 15:32:46', 0),
(40, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1017', NULL, '2012-07-13 15:32:48', 0),
(41, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1018', NULL, '2012-07-13 15:32:51', 0),
(42, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1019', NULL, '2012-07-13 15:32:54', 0),
(43, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1020', NULL, '2012-07-13 15:32:56', 0),
(44, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1021', NULL, '2012-07-13 15:33:00', 0),
(45, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1022', NULL, '2012-07-13 15:33:04', 0),
(46, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-13 15:33:07', 0),
(47, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-13 15:33:10', 0),
(48, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1025', NULL, '2012-07-13 15:33:13', 0),
(49, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1026', NULL, '2012-07-13 15:33:16', 0),
(50, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1027', NULL, '2012-07-13 15:33:19', 0),
(51, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1028', NULL, '2012-07-13 15:33:22', 0),
(52, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1029', NULL, '2012-07-13 15:33:25', 0),
(53, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1030', NULL, '2012-07-13 15:33:30', 0),
(54, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1029', NULL, '2012-07-13 15:33:33', 0),
(55, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1029', NULL, '2012-07-13 15:37:10', 0),
(56, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1000', NULL, '2012-07-13 16:36:30', 0),
(57, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-13 16:36:34', 0),
(58, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-13 16:36:40', 0),
(59, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-13 16:36:42', 0),
(60, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1025', NULL, '2012-07-13 16:36:47', 0),
(61, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1022', NULL, '2012-07-13 16:36:51', 0),
(62, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1020', NULL, '2012-07-13 16:36:54', 0),
(63, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-13 16:36:57', 0),
(64, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-13 16:37:01', 0),
(65, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1026', NULL, '2012-07-13 16:37:04', 0),
(66, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1027', NULL, '2012-07-13 16:37:08', 0),
(67, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1030', NULL, '2012-07-13 16:37:11', 0),
(68, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1029', NULL, '2012-07-13 16:37:14', 0),
(69, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1000', NULL, '2012-07-13 19:54:27', 0),
(70, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-14 10:21:20', 0),
(71, 'Itachi', '', 'Chat command', 'Issued chat command :enable 1', NULL, '2012-07-14 10:21:33', 0),
(72, 'Itachi', '', 'Chat command', 'Issued chat command :enable 31', NULL, '2012-07-14 10:21:36', 0),
(73, 'Itachi', '', 'Chat command', 'Issued chat command :enable 32', NULL, '2012-07-14 10:21:39', 0),
(74, 'Itachi', '', 'Chat command', 'Issued chat command :enable 33', NULL, '2012-07-14 10:21:44', 0),
(75, 'Itachi', '', 'Chat command', 'Issued chat command :enable 33', NULL, '2012-07-14 10:23:55', 0),
(76, 'Itachi', '', 'Chat command', 'Issued chat command :enable 34', NULL, '2012-07-14 10:24:26', 0),
(77, 'Itachi', '', 'Chat command', 'Issued chat command :enable 34', NULL, '2012-07-14 10:24:40', 0),
(78, 'Itachi', '', 'Chat command', 'Issued chat command :enable 35', NULL, '2012-07-14 10:24:43', 0),
(79, 'Itachi', '', 'Chat command', 'Issued chat command :enable 36', NULL, '2012-07-14 10:24:56', 0),
(80, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-14 19:57:25', 0),
(81, 'Itachi', 'Itachi', 'Badge', 'Badge given to user [ADM]', NULL, '2012-07-14 20:01:02', 0),
(82, 'Itachi', '', 'Chat command', 'Issued chat command :givebadge Itachi ADM', NULL, '2012-07-14 20:01:02', 0),
(83, 'Fakundo', '', 'Chat command', 'Issued chat command :come Itachi', NULL, '2012-07-15 00:38:46', 0),
(84, 'Fakundo', '', 'Chat command', 'Issued chat command :come Itachi', NULL, '2012-07-15 00:39:21', 0),
(85, 'Fakundo', '', 'Chat command', 'Issued chat command :invisible', NULL, '2012-07-15 00:39:31', 0),
(86, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-15 08:19:18', 0),
(87, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1002', NULL, '2012-07-15 08:19:26', 0),
(88, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-15 08:19:35', 0),
(89, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-15 08:19:39', 0),
(90, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1011', NULL, '2012-07-15 08:19:43', 0),
(91, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 100', NULL, '2012-07-15 08:19:54', 0),
(92, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1044', NULL, '2012-07-15 08:19:59', 0),
(93, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1014', NULL, '2012-07-15 08:20:03', 0),
(94, 'Fakundo', '', 'Chat command', 'Issued chat command :dc Itachi', NULL, '2012-07-15 08:22:05', 0),
(95, 'Itachi', '', 'HotelAlert', 'Hotel alert [Hola ]', NULL, '2012-07-15 08:27:26', 0),
(96, 'Itachi', '', 'Chat command', 'Issued chat command :ha Hola', NULL, '2012-07-15 08:27:26', 0),
(97, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Como no? ]', NULL, '2012-07-15 08:27:37', 0),
(98, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Como no?', NULL, '2012-07-15 08:27:37', 0),
(99, 'Itachi', '', 'Staff Message', 'Sent staff message:Hola', NULL, '2012-07-15 08:27:37', 0),
(100, 'Itachi', '', 'Chat command', 'Issued chat command :staffmessage Hola', NULL, '2012-07-15 08:27:37', 0),
(101, 'Fakundo', '', 'Staff Message', 'Sent staff message:Sexo', NULL, '2012-07-15 08:27:46', 0),
(102, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage Sexo', NULL, '2012-07-15 08:27:46', 0),
(103, 'Itachi', 'Fakundo', 'Alert', 'Alerted user with message [LOL]', NULL, '2012-07-15 08:27:47', 0),
(104, 'Itachi', '', 'Chat command', 'Issued chat command :alert Fakundo LOL', NULL, '2012-07-15 08:27:47', 0),
(105, 'Fakundo', '', 'Chat command', 'Issued chat command :hal ajsdja jadsj', NULL, '2012-07-15 08:27:51', 0),
(106, 'Itachi', '', 'Staff Message', 'Sent staff message:Ricardo es Guapo B|', NULL, '2012-07-15 08:27:56', 0),
(107, 'Itachi', '', 'Chat command', 'Issued chat command :staffmessage Ricardo es Guapo B|', NULL, '2012-07-15 08:27:56', 0),
(108, 'Fakundo', '', 'Alert', 'Room alert with message [no falta tanto papin]', NULL, '2012-07-15 08:27:57', 0),
(109, 'Fakundo', '', 'Chat command', 'Issued chat command :Roomalert no falta tanto papin', NULL, '2012-07-15 08:27:57', 0),
(110, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-15 08:29:08', 0),
(111, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1020', NULL, '2012-07-15 08:29:12', 0),
(112, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1022', NULL, '2012-07-15 08:29:31', 0),
(113, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-15 08:29:49', 0),
(114, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem -1', NULL, '2012-07-15 08:30:20', 0),
(115, 'Itachi', '', 'HotelAlert', 'Hotel alert [hOLA ]', NULL, '2012-07-15 08:31:06', 0),
(116, 'Itachi', '', 'Chat command', 'Issued chat command :HA hOLA', NULL, '2012-07-15 08:31:06', 0),
(117, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-15 08:31:09', 0),
(118, 'Itachi', '', 'HotelAlert', 'Hotel alert [elalert hola ]', NULL, '2012-07-15 08:31:22', 0),
(119, 'Itachi', '', 'Chat command', 'Issued chat command :hotelalert hola', NULL, '2012-07-15 08:31:22', 0),
(120, 'Fakundo', '', 'Chat command', 'Issued chat command :userinfo Itachi', NULL, '2012-07-15 08:31:25', 0),
(121, 'Itachi', '', 'Alert', 'Room alert with message [sa]', NULL, '2012-07-15 08:31:26', 0),
(122, 'Itachi', '', 'Chat command', 'Issued chat command :roomalert sa', NULL, '2012-07-15 08:31:26', 0),
(123, 'Itachi', '', 'HotelAlert', 'Hotel alert [hola ]', NULL, '2012-07-15 08:31:41', 0),
(124, 'Itachi', '', 'Chat command', 'Issued chat command :ha hola', NULL, '2012-07-15 08:31:41', 0),
(125, 'Fakundo', '', 'Staff Message', 'Sent staff message:eres gay', NULL, '2012-07-15 08:31:53', 0),
(126, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage eres gay', NULL, '2012-07-15 08:31:53', 0),
(127, 'Itachi', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-15 23:06:39', 0),
(128, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1011', NULL, '2012-07-16 01:15:04', 0),
(129, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-16 01:15:12', 0),
(130, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-16 01:15:21', 0),
(131, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1026', NULL, '2012-07-16 01:15:25', 0),
(132, 'Fakundo', '', 'HotelAlert', 'Hotel alert [se ]', NULL, '2012-07-16 01:15:30', 0),
(133, 'Fakundo', '', 'Chat command', 'Issued chat command :ha se', NULL, '2012-07-16 01:15:30', 0),
(134, 'Fakundo', '', 'Staff Message', 'Sent staff message:Desde ya los molestos staff message :D', NULL, '2012-07-16 01:15:43', 0),
(135, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage Desde ya los molestos staff message :D', NULL, '2012-07-16 01:15:43', 0),
(136, 'Fakundo', '', 'Chat command', 'Issued chat command :come Itachi', NULL, '2012-07-16 01:17:12', 0),
(137, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-16 11:24:57', 0),
(138, 'Fakundo', '', 'HotelAlert', 'Hotel alert [hola ]', NULL, '2012-07-16 11:36:22', 0),
(139, 'Fakundo', '', 'Chat command', 'Issued chat command :ha hola', NULL, '2012-07-16 11:36:22', 0),
(140, 'Fakundo', '', 'Chat command', 'Issued chat command :alert hola', NULL, '2012-07-16 11:36:28', 0),
(141, 'Fakundo', '', 'Chat command', 'Issued chat command :buyx 10', NULL, '2012-07-16 11:37:03', 0),
(142, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-16 11:51:55', 0),
(143, 'Fakundo', '', 'Chat command', 'Issued chat command :come Itachi', NULL, '2012-07-16 11:52:17', 0),
(144, 'Fakundo', '', 'Chat command', 'Issued chat command :come Itachi', NULL, '2012-07-16 11:55:29', 0),
(145, 'Itachi', '', 'HotelAlert', 'Hotel alert [hola ]', NULL, '2012-07-16 11:57:45', 0),
(146, 'Itachi', '', 'Chat command', 'Issued chat command :ha hola', NULL, '2012-07-16 11:57:45', 0),
(147, 'Itachi', '', 'Chat command', 'Issued chat command :reload', NULL, '2012-07-16 11:57:49', 0),
(148, 'Itachi', '', 'Chat command', 'Issued chat command :get Fakundo', NULL, '2012-07-16 12:08:35', 0),
(149, 'Itachi', '', 'Chat command', 'Issued chat command :info', NULL, '2012-07-16 12:12:47', 0),
(150, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-16 12:13:11', 0),
(151, 'Itachi', '', 'Chat command', 'Issued chat command :coins Itachi 44', NULL, '2012-07-16 12:13:40', 0),
(152, 'Itachi', '', 'Chat command', 'Issued chat command :reload', NULL, '2012-07-16 12:14:22', 0),
(153, 'Itachi', '', 'Chat command', 'Issued chat command :enable 50', NULL, '2012-07-16 20:04:17', 0),
(154, 'Itachi', '', 'Chat command', 'Issued chat command :enable 59', NULL, '2012-07-16 20:04:22', 0),
(155, 'Itachi', '', 'Chat command', 'Issued chat command :enable 58', NULL, '2012-07-16 20:04:29', 0),
(156, 'Itachi', '', 'Chat command', 'Issued chat command :enable 57', NULL, '2012-07-16 20:04:33', 0),
(157, 'Itachi', '', 'Chat command', 'Issued chat command :enable 56', NULL, '2012-07-16 20:04:37', 0),
(158, 'Itachi', '', 'Chat command', 'Issued chat command :enable 55', NULL, '2012-07-16 20:04:40', 0),
(159, 'Itachi', '', 'Chat command', 'Issued chat command :enable 54', NULL, '2012-07-16 20:04:42', 0),
(160, 'Itachi', '', 'Chat command', 'Issued chat command :enable 53', NULL, '2012-07-16 20:04:46', 0),
(161, 'Itachi', '', 'Chat command', 'Issued chat command :enable 52', NULL, '2012-07-16 20:04:48', 0),
(162, 'Itachi', '', 'Chat command', 'Issued chat command :enable 51', NULL, '2012-07-16 20:04:51', 0),
(163, 'Itachi', '', 'Chat command', 'Issued chat command :enable 48', NULL, '2012-07-16 20:04:55', 0),
(164, 'Itachi', '', 'Chat command', 'Issued chat command :enable 49', NULL, '2012-07-16 20:04:59', 0),
(165, 'Itachi', '', 'Chat command', 'Issued chat command :enable 47', NULL, '2012-07-16 20:05:02', 0),
(166, 'Itachi', '', 'Chat command', 'Issued chat command :enable 46', NULL, '2012-07-16 20:05:05', 0),
(167, 'Itachi', '', 'Chat command', 'Issued chat command :enable 45', NULL, '2012-07-16 20:05:08', 0),
(168, 'Itachi', '', 'Chat command', 'Issued chat command :enable 44', NULL, '2012-07-16 20:05:10', 0),
(169, 'Itachi', '', 'Chat command', 'Issued chat command :enable 43', NULL, '2012-07-16 20:05:13', 0),
(170, 'Itachi', '', 'Chat command', 'Issued chat command :enable 40', NULL, '2012-07-16 20:05:16', 0),
(171, 'Itachi', '', 'Chat command', 'Issued chat command :enable 39', NULL, '2012-07-16 20:05:18', 0),
(172, 'Itachi', '', 'Chat command', 'Issued chat command :enable 38', NULL, '2012-07-16 20:05:21', 0),
(173, 'Itachi', '', 'Chat command', 'Issued chat command :enable 37', NULL, '2012-07-16 20:05:24', 0),
(174, 'Itachi', '', 'Chat command', 'Issued chat command :enable 36', NULL, '2012-07-16 20:05:26', 0),
(175, 'Itachi', '', 'Chat command', 'Issued chat command :enable 30', NULL, '2012-07-16 20:05:29', 0),
(176, 'Itachi', '', 'Chat command', 'Issued chat command :enable 31', NULL, '2012-07-16 20:05:32', 0),
(177, 'Itachi', '', 'Chat command', 'Issued chat command :enable 29', NULL, '2012-07-16 20:05:36', 0),
(178, 'Itachi', '', 'Chat command', 'Issued chat command :enable 28', NULL, '2012-07-16 20:05:38', 0),
(179, 'Itachi', '', 'Chat command', 'Issued chat command :enable 27', NULL, '2012-07-16 20:05:41', 0),
(180, 'Itachi', '', 'Chat command', 'Issued chat command :enable 26', NULL, '2012-07-16 20:05:43', 0),
(181, 'Itachi', '', 'Chat command', 'Issued chat command :enable 25', NULL, '2012-07-16 20:05:45', 0),
(182, 'Itachi', '', 'Chat command', 'Issued chat command :enable 24', NULL, '2012-07-16 20:05:47', 0),
(183, 'Itachi', '', 'Chat command', 'Issued chat command :enable 23', NULL, '2012-07-16 20:05:49', 0),
(184, 'Itachi', '', 'Chat command', 'Issued chat command :enable 22', NULL, '2012-07-16 20:05:51', 0),
(185, 'Itachi', '', 'Chat command', 'Issued chat command :enable 21', NULL, '2012-07-16 20:05:53', 0),
(186, 'Itachi', '', 'Chat command', 'Issued chat command :enable 52', NULL, '2012-07-16 20:05:57', 0),
(187, 'Itachi', '', 'Chat command', 'Issued chat command :enable 53', NULL, '2012-07-16 20:06:02', 0),
(188, 'Itachi', '', 'Chat command', 'Issued chat command :enable 54', NULL, '2012-07-16 20:06:04', 0),
(189, 'Itachi', '', 'Chat command', 'Issued chat command :enable 55', NULL, '2012-07-16 20:06:06', 0),
(190, 'Itachi', '', 'Chat command', 'Issued chat command :enable 56', NULL, '2012-07-16 20:06:09', 0),
(191, 'Itachi', '', 'Chat command', 'Issued chat command :enable 57', NULL, '2012-07-16 20:06:11', 0),
(192, 'Itachi', '', 'Chat command', 'Issued chat command :enable 58', NULL, '2012-07-16 20:06:14', 0),
(193, 'Itachi', '', 'Chat command', 'Issued chat command :enable 59', NULL, '2012-07-16 20:06:17', 0),
(194, 'Itachi', '', 'Chat command', 'Issued chat command :enable 60', NULL, '2012-07-16 20:06:19', 0),
(195, 'Itachi', '', 'Chat command', 'Issued chat command :enable 61', NULL, '2012-07-16 20:06:21', 0),
(196, 'Itachi', '', 'Chat command', 'Issued chat command :enable 62', NULL, '2012-07-16 20:06:24', 0),
(197, 'Itachi', '', 'Chat command', 'Issued chat command :enable 63', NULL, '2012-07-16 20:06:27', 0),
(198, 'Itachi', '', 'Chat command', 'Issued chat command :enable 64', NULL, '2012-07-16 20:06:30', 0),
(199, 'Itachi', '', 'Chat command', 'Issued chat command :enable 65', NULL, '2012-07-16 20:06:33', 0),
(200, 'Itachi', '', 'Chat command', 'Issued chat command :enable 66', NULL, '2012-07-16 20:06:37', 0),
(201, 'Itachi', '', 'Chat command', 'Issued chat command :enable 67', NULL, '2012-07-16 20:06:41', 0),
(202, 'Itachi', '', 'Chat command', 'Issued chat command :enable 68', NULL, '2012-07-16 20:06:44', 0),
(203, 'Itachi', '', 'Chat command', 'Issued chat command :enable 69', NULL, '2012-07-16 20:06:47', 0),
(204, 'Itachi', '', 'Chat command', 'Issued chat command :enable 70', NULL, '2012-07-16 20:06:49', 0),
(205, 'Itachi', '', 'Chat command', 'Issued chat command :enable 71', NULL, '2012-07-16 20:06:53', 0),
(206, 'Itachi', '', 'Chat command', 'Issued chat command :enable 72', NULL, '2012-07-16 20:06:55', 0),
(207, 'Itachi', '', 'Chat command', 'Issued chat command :enable 73', NULL, '2012-07-16 20:06:57', 0),
(208, 'Itachi', '', 'Chat command', 'Issued chat command :enable 74', NULL, '2012-07-16 20:07:00', 0),
(209, 'Itachi', '', 'Chat command', 'Issued chat command :enable 7', NULL, '2012-07-16 20:07:04', 0),
(210, 'Itachi', '', 'Chat command', 'Issued chat command :enable 9', NULL, '2012-07-16 20:07:07', 0),
(211, 'Itachi', '', 'Chat command', 'Issued chat command :enable 10', NULL, '2012-07-16 20:07:09', 0),
(212, 'Itachi', '', 'Chat command', 'Issued chat command :enable 11', NULL, '2012-07-16 20:07:13', 0),
(213, 'Itachi', '', 'Chat command', 'Issued chat command :enable 12', NULL, '2012-07-16 20:07:15', 0),
(214, 'Itachi', '', 'Chat command', 'Issued chat command :enable 13', NULL, '2012-07-16 20:07:17', 0),
(215, 'Itachi', '', 'Chat command', 'Issued chat command :enable 14', NULL, '2012-07-16 20:07:20', 0),
(216, 'Itachi', '', 'Chat command', 'Issued chat command :enable 14', NULL, '2012-07-16 20:07:22', 0),
(217, 'Itachi', '', 'Chat command', 'Issued chat command :enable 15', NULL, '2012-07-16 20:07:25', 0),
(218, 'Itachi', '', 'Chat command', 'Issued chat command :enable 16', NULL, '2012-07-16 20:07:27', 0),
(219, 'Itachi', '', 'Chat command', 'Issued chat command :enable 17', NULL, '2012-07-16 20:07:29', 0),
(220, 'Itachi', '', 'Chat command', 'Issued chat command :enable 18', NULL, '2012-07-16 20:07:31', 0),
(221, 'Itachi', '', 'Chat command', 'Issued chat command :enable 19', NULL, '2012-07-16 20:07:33', 0),
(222, 'Itachi', '', 'Chat command', 'Issued chat command :enable 20', NULL, '2012-07-16 20:07:35', 0),
(223, 'Itachi', '', 'Chat command', 'Issued chat command :enable 21', NULL, '2012-07-16 20:07:37', 0),
(224, 'Itachi', '', 'Chat command', 'Issued chat command :enable 22', NULL, '2012-07-16 20:07:39', 0),
(225, 'Itachi', '', 'Chat command', 'Issued chat command :enable 23', NULL, '2012-07-16 20:07:42', 0),
(226, 'Itachi', '', 'Chat command', 'Issued chat command :enable 1', NULL, '2012-07-16 20:07:47', 0),
(227, 'Itachi', '', 'Chat command', 'Issued chat command :enable 2', NULL, '2012-07-16 20:07:53', 0),
(228, 'Itachi', '', 'Chat command', 'Issued chat command :enable 3', NULL, '2012-07-16 20:07:56', 0),
(229, 'Itachi', '', 'Chat command', 'Issued chat command :enable 4', NULL, '2012-07-16 20:07:59', 0),
(230, 'Itachi', '', 'Chat command', 'Issued chat command :enable 4', NULL, '2012-07-16 20:08:30', 0),
(231, 'Fakundo', '', 'HotelAlert', 'Hotel alert [hola ]', NULL, '2012-07-16 21:54:18', 0),
(232, 'Fakundo', '', 'Chat command', 'Issued chat command :ha hola', NULL, '2012-07-16 21:54:18', 0),
(233, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-16 21:56:20', 0),
(234, 'Fakundo', '', 'Chat command', 'Issued chat command :come Itachi', NULL, '2012-07-16 22:02:59', 0),
(235, 'Fakundo', '', 'HotelAlert', 'Hotel alert [hola ]', NULL, '2012-07-16 22:37:43', 0),
(236, 'Fakundo', '', 'Chat command', 'Issued chat command :ha hola', NULL, '2012-07-16 22:37:43', 0),
(237, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-17 01:33:26', 0),
(238, 'Fakundo', '', 'Chat command', 'Issued chat command :info', NULL, '2012-07-17 01:35:59', 0),
(239, 'Itachi', '', 'HotelAlert', 'Hotel alert [test ]', NULL, '2012-07-17 01:37:32', 0),
(240, 'Itachi', '', 'Chat command', 'Issued chat command :ha test', NULL, '2012-07-17 01:37:32', 0),
(241, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Mi nombre es Scrillex :D ]', NULL, '2012-07-17 01:38:08', 0),
(242, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Mi nombre es Scrillex :D', NULL, '2012-07-17 01:38:08', 0),
(243, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Ala mierda Esta pocamadre esto ]', NULL, '2012-07-17 01:38:20', 0),
(244, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Ala mierda Esta pocamadre esto', NULL, '2012-07-17 01:38:20', 0),
(245, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Itachi eres el mejor okya xd â€¢ ]', NULL, '2012-07-17 01:39:10', 0),
(246, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Itachi eres el mejor okya xd â€¢', NULL, '2012-07-17 01:39:10', 0),
(247, 'Fakundo', '', 'HotelAlert', 'Hotel alert [no puedo parar en hacer esto xd ]', NULL, '2012-07-17 01:40:28', 0),
(248, 'Fakundo', '', 'Chat command', 'Issued chat command :ha no puedo parar en hacer esto xd', NULL, '2012-07-17 01:40:28', 0),
(249, 'Itachi', '', 'HotelAlert', 'Hotel alert [esque la nueva alerta mola xd ]', NULL, '2012-07-17 01:40:42', 0),
(250, 'Itachi', '', 'Chat command', 'Issued chat command :ha esque la nueva alerta mola xd', NULL, '2012-07-17 01:40:42', 0),
(251, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Si mola mucho lol ]', NULL, '2012-07-17 01:41:24', 0),
(252, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Si mola mucho lol', NULL, '2012-07-17 01:41:24', 0),
(253, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Contesta we xdddddddddd ]', NULL, '2012-07-17 01:46:06', 0),
(254, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Contesta we xdddddddddd', NULL, '2012-07-17 01:46:06', 0),
(255, 'Itachi', 'Fakundo', 'Badge', 'Badge given to user [ADM]', NULL, '2012-07-17 01:48:29', 0),
(256, 'Itachi', '', 'Chat command', 'Issued chat command :givebadge Fakundo ADM', NULL, '2012-07-17 01:48:29', 0),
(257, 'Fakundo', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-17 01:49:53', 0),
(258, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-17 01:50:15', 0),
(259, 'Fakundo', '', 'HotelAlert', 'Hotel alert [xd ]', NULL, '2012-07-17 01:51:08', 0),
(260, 'Fakundo', '', 'Chat command', 'Issued chat command :ha xd', NULL, '2012-07-17 01:51:08', 0),
(261, 'Fakundo', '', 'HotelAlert', 'Hotel alert [hola ]', NULL, '2012-07-17 01:55:26', 0),
(262, 'Fakundo', '', 'Chat command', 'Issued chat command :ha hola', NULL, '2012-07-17 01:55:26', 0),
(263, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-17 02:08:32', 0),
(264, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-17 02:16:44', 0),
(265, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-17 02:16:59', 0),
(266, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-17 02:17:53', 0),
(267, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-17 02:19:28', 0),
(268, 'Fakundo', '', 'Chat command', 'Issued chat command :buyx 10', NULL, '2012-07-17 02:54:15', 0),
(269, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Hola fakundo ]', NULL, '2012-07-17 03:01:45', 0),
(270, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Hola fakundo', NULL, '2012-07-17 03:01:45', 0),
(271, 'Fakundo', '', 'HotelAlert', 'Hotel alert [No mms Esta chingon!!! :DDDDD ]', NULL, '2012-07-17 03:02:24', 0),
(272, 'Fakundo', '', 'Chat command', 'Issued chat command :ha No mms Esta chingon!!! :DDDDD', NULL, '2012-07-17 03:02:24', 0),
(273, 'Itachi', '', 'HotelAlert', 'Hotel alert [Puto de mierda ]', NULL, '2012-07-17 03:02:30', 0),
(274, 'Itachi', '', 'Chat command', 'Issued chat command :ha Puto de mierda', NULL, '2012-07-17 03:02:31', 0),
(275, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Fakundo cara de mierda ]', NULL, '2012-07-17 03:02:39', 0),
(276, 'Fakundo', '', 'Chat command', 'Issued chat command :Ha Fakundo cara de mierda', NULL, '2012-07-17 03:02:39', 0),
(277, 'Itachi', '', 'HotelAlert', 'Hotel alert [Que te den x culo gay ]', NULL, '2012-07-17 03:02:53', 0),
(278, 'Itachi', '', 'Chat command', 'Issued chat command :ha Que te den x culo gay', NULL, '2012-07-17 03:02:53', 0),
(279, 'Fakundo', '', 'HotelAlert', 'Hotel alert [A fakundo le dan x el kulo, y ese no soy yo  ]', NULL, '2012-07-17 03:03:04', 0),
(280, 'Fakundo', '', 'Chat command', 'Issued chat command :ha A fakundo le dan x el kulo, y ese no soy yo ', NULL, '2012-07-17 03:03:04', 0),
(281, 'Itachi', '', 'HotelAlert', 'Hotel alert [peppeeppe ]', NULL, '2012-07-17 03:05:09', 0),
(282, 'Itachi', '', 'Chat command', 'Issued chat command :ha peppeeppe', NULL, '2012-07-17 03:05:09', 0),
(283, 'Itachi', '', 'Chat command', 'Issued chat command :STALK Itachi', NULL, '2012-07-17 03:05:15', 0),
(284, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Papapapapappa pipipipio XD ]', NULL, '2012-07-17 03:05:17', 0),
(285, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Papapapapappa pipipipio XD', NULL, '2012-07-17 03:05:17', 0),
(286, 'Itachi', '', 'HotelAlert', 'Hotel alert [Ola de publicidad, ven! ]', NULL, '2012-07-17 03:05:38', 0),
(287, 'Itachi', '', 'Chat command', 'Issued chat command :ha Ola de publicidad, ven!', NULL, '2012-07-17 03:05:38', 0),
(288, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Hola de publicidad con el hermoso de Ricardo| Ven! :D ]', NULL, '2012-07-17 03:05:59', 0),
(289, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Hola de publicidad con el hermoso de Ricardo| Ven! :D', NULL, '2012-07-17 03:05:59', 0),
(290, 'Fakundo', '', 'Chat command', 'Issued chat command :push Itachi', NULL, '2012-07-17 03:06:42', 0),
(291, 'Fakundo', '', 'Chat command', 'Issued chat command :push Itachi', NULL, '2012-07-17 03:07:06', 0),
(292, 'Fakundo', '', 'Chat command', 'Issued chat command :push Itachi', NULL, '2012-07-17 03:07:11', 0),
(293, 'Itachi', 'Fakundo', 'Disconnect', 'User disconnected by user', NULL, '2012-07-17 03:08:29', 0),
(294, 'Itachi', '', 'Chat command', 'Issued chat command :dc Fakundo', NULL, '2012-07-17 03:08:31', 0),
(295, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-17 03:14:25', 0),
(296, 'Itachi', '', 'Chat command', 'Issued chat command :handitem -1', NULL, '2012-07-17 03:14:55', 0),
(297, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-17 03:15:27', 0),
(298, 'Itachi', '', 'Chat command', 'Issued chat command :come Fakundo', NULL, '2012-07-17 03:16:14', 0),
(299, 'Itachi', '', 'Chat command', 'Issued chat command :kick Fakundo', NULL, '2012-07-17 03:18:36', 0),
(300, 'Itachi', 'Fakundo', 'Disconnect', 'User disconnected by user', NULL, '2012-07-17 03:18:38', 0),
(301, 'Itachi', '', 'Chat command', 'Issued chat command :dc Fakundo', NULL, '2012-07-17 03:18:38', 0),
(302, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-17 03:18:59', 0),
(303, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-17 03:19:10', 0),
(304, 'Itachi', '', 'HotelAlert', 'Hotel alert [HabboLatino Beta <> TEST :D ]', NULL, '2012-07-17 03:19:25', 0),
(305, 'Itachi', '', 'Chat command', 'Issued chat command :ha HabboLatino Beta <> TEST :D', NULL, '2012-07-17 03:19:25', 0),
(306, 'Itachi', '', 'HotelAlert', 'Hotel alert [<> ]', NULL, '2012-07-17 03:19:31', 0),
(307, 'Itachi', '', 'Chat command', 'Issued chat command :ha <>', NULL, '2012-07-17 03:19:31', 0),
(308, 'Itachi', '', 'HotelAlert', 'Hotel alert [<>TEST<> ]', NULL, '2012-07-17 03:19:38', 0),
(309, 'Itachi', '', 'Chat command', 'Issued chat command :HA <>TEST<>', NULL, '2012-07-17 03:19:38', 0),
(310, 'Itachi', '', 'HotelAlert', 'Hotel alert [AHAHAH!AHDSJAFHSJ! ]', NULL, '2012-07-17 03:19:44', 0),
(311, 'Itachi', '', 'Chat command', 'Issued chat command :HA AHAHAH!AHDSJAFHSJ!', NULL, '2012-07-17 03:19:44', 0),
(312, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1014', NULL, '2012-07-17 03:21:43', 0),
(313, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1020', NULL, '2012-07-17 03:21:47', 0),
(314, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-17 03:21:51', 0),
(315, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1026', NULL, '2012-07-17 03:22:02', 0),
(316, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1024', NULL, '2012-07-17 03:22:11', 0),
(317, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1026', NULL, '2012-07-17 03:22:13', 0),
(318, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1031', NULL, '2012-07-17 03:22:18', 0),
(319, 'Itachi', '', 'HotelAlert', 'Hotel alert [Prueba que se siente ser staff di :ha y algo jaja ]', NULL, '2012-07-17 03:22:40', 0),
(320, 'Itachi', '', 'Chat command', 'Issued chat command :ha Prueba que se siente ser staff di :ha y algo jaja', NULL, '2012-07-17 03:22:40', 0),
(321, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1012', NULL, '2012-07-17 03:23:54', 0),
(322, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1008', NULL, '2012-07-17 03:23:58', 0),
(323, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1001', NULL, '2012-07-17 03:24:04', 0),
(324, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1002', NULL, '2012-07-17 03:24:06', 0),
(325, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-17 03:58:40', 0),
(326, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-17 03:59:14', 0),
(327, 'Itachi', '', 'HotelAlert', 'Hotel alert [lol ]', NULL, '2012-07-17 03:59:17', 0),
(328, 'Itachi', '', 'Chat command', 'Issued chat command :ha lol', NULL, '2012-07-17 03:59:17', 0),
(329, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-17 23:44:18', 0),
(330, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-17 23:44:20', 0),
(331, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-17 23:44:23', 0),
(332, 'Itachi', '', 'Chat command', 'Issued chat command :lay', NULL, '2012-07-17 23:44:25', 0),
(333, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-17 23:44:28', 0),
(334, 'Itachi', '', 'Chat command', 'Issued chat command :lay', NULL, '2012-07-17 23:44:29', 0),
(335, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-17 23:44:30', 0),
(336, 'Itachi', '', 'Chat command', 'Issued chat command :lay', NULL, '2012-07-17 23:44:31', 0),
(337, 'Itachi', '', 'Staff Message', 'Sent staff message:lol', NULL, '2012-07-17 23:44:38', 0),
(338, 'Itachi', '', 'Chat command', 'Issued chat command :staffmessage lol', NULL, '2012-07-17 23:44:38', 0),
(339, 'Itachi', '', 'Staff Message', 'Sent staff message:lol', NULL, '2012-07-17 23:44:43', 0),
(340, 'Itachi', '', 'Chat command', 'Issued chat command :staffmessage lol', NULL, '2012-07-17 23:44:43', 0),
(341, 'Itachi', '', 'HotelAlert', 'Hotel alert [OKAA ]', NULL, '2012-07-17 23:44:55', 0),
(342, 'Itachi', '', 'Chat command', 'Issued chat command :ha OKAA', NULL, '2012-07-17 23:44:55', 0),
(343, 'Itachi', 'Itachi', 'Alert', 'Alerted user with message [jeje]', NULL, '2012-07-17 23:45:21', 0),
(344, 'Itachi', '', 'Chat command', 'Issued chat command :alert Itachi jeje', NULL, '2012-07-17 23:45:21', 0),
(345, 'Itachi', '', 'Staff Message', 'Sent staff message:yup', NULL, '2012-07-17 23:48:53', 0),
(346, 'Itachi', '', 'Chat command', 'Issued chat command :Staffmessage yup', NULL, '2012-07-17 23:48:53', 0),
(347, 'Fakundo', '', 'Staff Message', 'Sent staff message:lala', NULL, '2012-07-17 23:51:20', 0),
(348, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage lala', NULL, '2012-07-17 23:51:20', 0),
(349, 'Fakundo', '', 'Staff Message', 'Sent staff message:lala', NULL, '2012-07-17 23:53:12', 0),
(350, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage lala', NULL, '2012-07-17 23:53:12', 0),
(351, 'Fakundo', '', 'Staff Message', 'Sent staff message:lala', NULL, '2012-07-17 23:53:54', 0),
(352, 'Fakundo', '', 'Chat command', 'Issued chat command :Staffmessage lala', NULL, '2012-07-17 23:53:55', 0),
(353, 'Fakundo', '', 'Staff Message', 'Sent staff message:YUP LALA', NULL, '2012-07-17 23:54:01', 0),
(354, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage YUP LALA', NULL, '2012-07-17 23:54:01', 0),
(355, 'Fakundo', '', 'Chat command', 'Issued chat command :hal asfasd fasd', NULL, '2012-07-17 23:54:06', 0),
(356, 'Fakundo', '', 'Chat command', 'Issued chat command :nuevavotacion asdjsjds', NULL, '2012-07-17 23:55:24', 0),
(357, 'Fakundo', '', 'Alert', 'Room alert with message [asdf]', NULL, '2012-07-17 23:55:32', 0),
(358, 'Fakundo', '', 'Chat command', 'Issued chat command :Roomalert asdf', NULL, '2012-07-17 23:55:32', 0),
(359, 'Fakundo', '', 'Chat command', 'Issued chat command :enable -1', NULL, '2012-07-18 00:28:21', 0),
(360, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 10023', NULL, '2012-07-18 00:28:24', 0),
(361, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1021', NULL, '2012-07-18 00:28:29', 0),
(362, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1026', NULL, '2012-07-18 00:28:33', 0),
(363, 'Fakundo', '', 'Chat command', 'Issued chat command :handitem 1027', NULL, '2012-07-18 00:28:35', 0),
(364, 'Fakundo', '', 'Chat command', 'Issued chat command :info', NULL, '2012-07-18 00:30:32', 0),
(365, 'Itachi', '', 'Chat command', 'Issued chat command :Setspeed 45', NULL, '2012-07-18 00:39:39', 0),
(366, 'Itachi', '', 'Chat command', 'Issued chat command :setspeed 1', NULL, '2012-07-18 00:39:44', 0),
(367, 'Itachi', '', 'Chat command', 'Issued chat command :setspeed 0', NULL, '2012-07-18 00:39:47', 0),
(368, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-18 00:41:00', 0),
(369, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-18 02:23:14', 0),
(370, 'Fakundo', '', 'Chat command', 'Issued chat command :coins Fakundo 100', NULL, '2012-07-18 02:23:45', 0),
(371, 'Itachi', '', 'Chat command', 'Issued chat command :empty Itachi', NULL, '2012-07-18 03:47:52', 0),
(372, 'Itachi', '', 'Chat command', 'Issued chat command :empty', NULL, '2012-07-18 03:48:09', 0),
(373, 'Itachi', '', 'HotelAlert', 'Hotel alert [Ven a mi sala, soy Itachi :D ]', NULL, '2012-07-18 03:51:22', 0),
(374, 'Itachi', '', 'Chat command', 'Issued chat command :ha Ven a mi sala, soy Itachi :D', NULL, '2012-07-18 03:51:22', 0),
(375, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1015', NULL, '2012-07-18 03:52:55', 0),
(376, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1023', NULL, '2012-07-18 03:53:09', 0),
(377, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1004', NULL, '2012-07-18 03:53:16', 0),
(378, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1001', NULL, '2012-07-18 03:53:22', 0),
(379, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1002', NULL, '2012-07-18 03:53:27', 0),
(380, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1036', NULL, '2012-07-18 03:53:35', 0),
(381, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1029', NULL, '2012-07-18 03:53:38', 0),
(382, 'Fakundo', '', 'Room Mute', 'Room muted', NULL, '2012-07-18 03:53:58', 0),
(383, 'Fakundo', '', 'Chat command', 'Issued chat command :ROOMMUTE', NULL, '2012-07-18 03:53:58', 0),
(384, 'Fakundo', '', 'Room Mute', 'Room muted', NULL, '2012-07-18 03:54:03', 0),
(385, 'Fakundo', '', 'Chat command', 'Issued chat command :ROOMMUTE', NULL, '2012-07-18 03:54:03', 0),
(386, 'Fakundo', '', 'Alert', 'Room alert with message []', NULL, '2012-07-18 03:54:10', 0),
(387, 'Fakundo', '', 'Chat command', 'Issued chat command :ROOMALERT', NULL, '2012-07-18 03:54:10', 0),
(388, 'Itachi', '', 'Chat command', 'Issued chat command :push', NULL, '2012-07-18 03:54:24', 0),
(389, 'Itachi', '', 'Chat command', 'Issued chat command :push', NULL, '2012-07-18 03:54:25', 0),
(390, 'Itachi', '', 'Chat command', 'Issued chat command :push', NULL, '2012-07-18 03:54:28', 0),
(391, 'Itachi', '', 'Chat command', 'Issued chat command :push', NULL, '2012-07-18 03:54:31', 0),
(392, 'Itachi', '', 'Chat command', 'Issued chat command :Tele', NULL, '2012-07-18 03:54:36', 0),
(393, 'Fakundo', '', 'Chat command', 'Issued chat command :TELE', NULL, '2012-07-18 03:54:38', 0),
(394, 'Itachi', '', 'Chat command', 'Issued chat command :Tele', NULL, '2012-07-18 03:54:40', 0),
(395, 'Itachi', '', 'Alert', 'Room alert with message [no aun]', NULL, '2012-07-18 03:54:42', 0),
(396, 'Itachi', '', 'Chat command', 'Issued chat command :roomalert no aun', NULL, '2012-07-18 03:54:42', 0),
(397, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-18 03:55:21', 0),
(398, 'Itachi', '', 'HotelAlert', 'Hotel alert [Ven de nuevo ]', NULL, '2012-07-18 03:55:24', 0),
(399, 'Itachi', '', 'Chat command', 'Issued chat command :ha Ven de nuevo', NULL, '2012-07-18 03:55:24', 0),
(400, 'Itachi', '', 'Chat command', 'Issued chat command :come Fakundo', NULL, '2012-07-18 03:55:29', 0),
(401, 'Fakundo', '', 'Alert', 'Room alert with message [HOLA:D]', NULL, '2012-07-18 03:55:57', 0),
(402, 'Fakundo', '', 'Chat command', 'Issued chat command :ROOMALERT HOLA:D', NULL, '2012-07-18 03:55:57', 0),
(403, 'Fakundo', '', 'HotelAlert', 'Hotel alert [HOLA ]', NULL, '2012-07-18 03:56:22', 0),
(404, 'Fakundo', '', 'Chat command', 'Issued chat command :HA HOLA', NULL, '2012-07-18 03:56:22', 0),
(405, 'Itachi', '', 'Staff Message', 'Sent staff message:y esto es :staffmessage para todos los staffs lol', NULL, '2012-07-18 03:56:32', 0),
(406, 'Itachi', '', 'Chat command', 'Issued chat command :Staffmessage y esto es :staffmessage para todos los staffs lol', NULL, '2012-07-18 03:56:32', 0),
(407, 'Itachi', '', 'Staff Message', 'Sent staff message:lalal', NULL, '2012-07-18 03:57:21', 0),
(408, 'Itachi', '', 'Chat command', 'Issued chat command :Staffmessage lalal', NULL, '2012-07-18 03:57:21', 0),
(409, 'Fakundo', '', 'Staff Message', 'Sent staff message:HOLA :D', NULL, '2012-07-18 03:57:33', 0),
(410, 'Fakundo', '', 'Chat command', 'Issued chat command :STAFFMESSAGE HOLA :D', NULL, '2012-07-18 03:57:33', 0),
(411, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1002', NULL, '2012-07-18 04:04:32', 0),
(412, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1001', NULL, '2012-07-18 04:04:40', 0),
(413, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1000', NULL, '2012-07-18 04:04:43', 0),
(414, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1029', NULL, '2012-07-18 04:04:48', 0),
(415, 'Itachi', '', 'HotelAlert', 'Hotel alert [Hola, ven a mi sala. ]', NULL, '2012-07-18 04:43:14', 0),
(416, 'Itachi', '', 'Chat command', 'Issued chat command :ha Hola, ven a mi sala.', NULL, '2012-07-18 04:43:14', 0),
(417, 'Itachi', '', 'HotelAlert', 'Hotel alert [ImFaku ]', NULL, '2012-07-18 04:44:55', 0),
(418, 'Itachi', '', 'Chat command', 'Issued chat command :ha ImFaku', NULL, '2012-07-18 04:44:55', 0),
(419, 'Itachi', '', 'HotelAlert', 'Hotel alert [YEAHHHHHHH IM FAKUU WIIII ]', NULL, '2012-07-18 04:45:02', 0),
(420, 'Itachi', '', 'Chat command', 'Issued chat command :ha YEAHHHHHHH IM FAKUU WIIII', NULL, '2012-07-18 04:45:02', 0),
(421, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-18 04:45:56', 0),
(422, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-18 04:55:13', 0),
(423, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Unanse a la beta... tarata! ]', NULL, '2012-07-18 04:55:41', 0),
(424, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Unanse a la beta... tarata!', NULL, '2012-07-18 04:55:41', 0),
(425, 'Itachi', '', 'HotelAlert', 'Hotel alert [salte que debe entrar la ganadora ]', NULL, '2012-07-18 04:57:39', 0),
(426, 'Itachi', '', 'Chat command', 'Issued chat command :ha salte que debe entrar la ganadora', NULL, '2012-07-18 04:57:39', 0),
(427, 'Itachi', 'Fakundo', 'Disconnect', 'User disconnected by user', NULL, '2012-07-18 04:57:44', 0),
(428, 'Itachi', '', 'Chat command', 'Issued chat command :Dc Fakundo', NULL, '2012-07-18 04:57:44', 0),
(429, 'Itachi', '', 'HotelAlert', 'Hotel alert [Ven a mi sala ]', NULL, '2012-07-18 05:04:37', 0),
(430, 'Itachi', '', 'Chat command', 'Issued chat command :ha Ven a mi sala', NULL, '2012-07-18 05:04:37', 0),
(431, 'Itachi', '', 'HotelAlert', 'Hotel alert [ven ]', NULL, '2012-07-18 05:05:18', 0),
(432, 'Itachi', '', 'Chat command', 'Issued chat command :ha ven', NULL, '2012-07-18 05:05:18', 0),
(433, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-18 05:05:31', 0),
(434, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-18 05:13:50', 0),
(435, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-18 05:14:08', 0),
(436, 'Fakundo', '', 'HotelAlert', 'Hotel alert [elalert ]', NULL, '2012-07-18 05:14:31', 0),
(437, 'Fakundo', '', 'Chat command', 'Issued chat command :hotelalert', NULL, '2012-07-18 05:14:31', 0),
(438, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-18 05:14:50', 0),
(439, 'Fakundo', '', 'Staff Message', 'Sent staff message:lol', NULL, '2012-07-18 20:36:17', 0),
(440, 'Fakundo', '', 'Chat command', 'Issued chat command :Staffmessage lol', NULL, '2012-07-18 20:36:17', 0),
(441, 'Fakundo', '', 'Staff Message', 'Sent staff message:mejorado yuppp', NULL, '2012-07-18 20:36:24', 0),
(442, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage mejorado yuppp', NULL, '2012-07-18 20:36:24', 0),
(443, 'Fakundo', '', 'Chat command', 'Issued chat command :empty', NULL, '2012-07-19 04:02:40', 0),
(444, 'Itachi', '', 'Chat command', 'Issued chat command :empty', NULL, '2012-07-19 04:09:59', 0),
(445, 'Fakundo', '', 'Chat command', 'Issued chat command :coins Itahci 1000000', NULL, '2012-07-19 04:10:47', 0),
(446, 'Fakundo', '', 'Chat command', 'Issued chat command :coins Itachi 10000000', NULL, '2012-07-19 04:10:55', 0),
(447, 'Itachi', '', 'Chat command', 'Issued chat command :empty', NULL, '2012-07-19 04:17:58', 0),
(448, 'Itachi', '', 'Chat command', 'Issued chat command :shutdown', NULL, '2012-07-19 04:56:20', 0),
(449, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-19 05:19:19', 0),
(450, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-19 05:19:30', 0),
(451, 'Itachi', '', 'HotelAlert', 'Hotel alert [Ven a la sala de Fakundo lol ]', NULL, '2012-07-19 05:19:35', 0),
(452, 'Itachi', '', 'Chat command', 'Issued chat command :ha Ven a la sala de Fakundo lol', NULL, '2012-07-19 05:19:35', 0),
(453, 'Itachi', '', 'Chat command', 'Issued chat command :come Fakundo', NULL, '2012-07-19 05:19:39', 0),
(454, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1026', NULL, '2012-07-19 05:22:29', 0),
(455, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1030', NULL, '2012-07-19 05:23:11', 0),
(456, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1014', NULL, '2012-07-19 05:23:16', 0),
(457, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1016', NULL, '2012-07-19 05:23:22', 0),
(458, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-19 20:44:54', 0),
(459, 'Itachi', '', 'HotelAlert', 'Hotel alert [Hola Nacho xD ]', NULL, '2012-07-19 20:44:57', 0),
(460, 'Itachi', '', 'Chat command', 'Issued chat command :ha Hola Nacho xD', NULL, '2012-07-19 20:44:57', 0),
(461, 'Fakundo', '', 'HotelAlert', 'Hotel alert [hola ]', NULL, '2012-07-19 20:45:59', 0),
(462, 'Fakundo', '', 'Chat command', 'Issued chat command :ha hola', NULL, '2012-07-19 20:45:59', 0),
(463, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Funciona? ]', NULL, '2012-07-19 20:46:13', 0),
(464, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Funciona?', NULL, '2012-07-19 20:46:13', 0),
(465, 'Itachi', '', 'HotelAlert', 'Hotel alert [puto ]', NULL, '2012-07-19 20:46:43', 0),
(466, 'Itachi', '', 'Chat command', 'Issued chat command :ha puto', NULL, '2012-07-19 20:46:43', 0),
(467, 'Itachi', '', 'Staff Message', 'Sent staff message:ESTO ES STAFFMESSAGE LOL', NULL, '2012-07-19 20:46:50', 0),
(468, 'Itachi', '', 'Chat command', 'Issued chat command :staffmessage ESTO ES STAFFMESSAGE LOL', NULL, '2012-07-19 20:46:50', 0),
(469, 'Itachi', '', 'Alert', 'Room alert with message [puta]', NULL, '2012-07-19 20:46:56', 0),
(470, 'Itachi', '', 'Chat command', 'Issued chat command :roomalert puta', NULL, '2012-07-19 20:46:56', 0),
(471, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-19 20:46:58', 0),
(472, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-19 20:47:18', 0),
(473, 'Fakundo', '', 'HotelAlert', 'Hotel alert [:D ]', NULL, '2012-07-19 21:04:05', 0),
(474, 'Fakundo', '', 'Chat command', 'Issued chat command :ha :D', NULL, '2012-07-19 21:04:05', 0),
(475, 'Itachi', '', 'Chat command', 'Issued chat command :Buyx 400', NULL, '2012-07-20 02:01:35', 0),
(476, 'Itachi', '', 'Chat command', 'Issued chat command :Refreshcata', NULL, '2012-07-20 02:01:48', 0),
(477, 'Itachi', '', 'Chat command', 'Issued chat command :Refreshcata', NULL, '2012-07-20 02:01:56', 0),
(478, 'Itachi', '', 'HotelAlert', 'Hotel alert [Hola :D ]', NULL, '2012-07-20 19:51:50', 0),
(479, 'Itachi', '', 'Chat command', 'Issued chat command :ha Hola :D', NULL, '2012-07-20 19:51:50', 0),
(480, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-20 19:52:10', 0),
(481, 'Itachi', '', 'Chat command', 'Issued chat command :stalk Fakundo', NULL, '2012-07-20 19:52:13', 0),
(482, 'Itachi', '', 'Chat command', 'Issued chat command :stalk Fakundo', NULL, '2012-07-20 19:52:24', 0);
INSERT INTO `staff_logs` (`id`, `staffuser`, `target`, `action_type`, `description`, `extra_info`, `time`, `deleted`) VALUES
(483, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-20 19:52:32', 0),
(484, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-20 20:02:40', 0),
(485, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-20 20:03:46', 0),
(486, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-20 20:05:10', 0),
(487, 'Itachi', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-20 23:48:58', 0),
(488, 'Itachi', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-21 01:00:54', 0),
(489, 'Itachi', '', 'Chat command', 'Issued chat command :enable 11', NULL, '2012-07-21 18:38:56', 0),
(490, 'Fakundo', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-22 03:22:09', 0),
(491, 'Itachi', '', 'Chat command', 'Issued chat command :sit', NULL, '2012-07-22 03:22:24', 0),
(492, 'Itachi', '', 'Chat command', 'Issued chat command :handitem 1000', NULL, '2012-07-22 03:23:43', 0),
(493, 'Itachi', '', 'Chat command', 'Issued chat command :Refreshcata', NULL, '2012-07-22 03:34:41', 0),
(494, 'Fakundo', '', 'Chat command', 'Issued chat command :Refreshcata', NULL, '2012-07-22 03:36:28', 0),
(495, 'Fakundo', '', 'RefreshItems', 'Refreshed items definitions.', NULL, '2012-07-22 03:36:37', 0),
(496, 'Fakundo', '', 'Chat command', 'Issued chat command :refreshitems', NULL, '2012-07-22 03:36:37', 0),
(497, 'Itachi', '', 'Mass Credits', 'Send [20000] credits to everyone in the database', NULL, '2012-07-22 03:43:38', 0),
(498, 'Itachi', '', 'Chat command', 'Issued chat command :globalcredits 20000', NULL, '2012-07-22 03:43:38', 0),
(499, 'Itachi', '', 'Mass Credits', 'Send [200000] credits to everyone online', NULL, '2012-07-22 03:43:41', 0),
(500, 'Itachi', '', 'Chat command', 'Issued chat command :masscredits 200000', NULL, '2012-07-22 03:43:41', 0),
(501, 'Itachi', '', 'Chat command', 'Issued chat command :Tele', NULL, '2012-07-22 03:45:37', 0),
(502, 'Itachi', '', 'Chat command', 'Issued chat command :Tele', NULL, '2012-07-22 03:45:41', 0),
(503, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-22 21:08:50', 0),
(504, 'Itachi', '', 'Chat command', 'Issued chat command :userinfo Fakundo', NULL, '2012-07-22 21:09:50', 0),
(505, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Mola :D ]', NULL, '2012-07-22 21:22:59', 0),
(506, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Mola :D', NULL, '2012-07-22 21:22:59', 0),
(507, 'Itachi', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-23 16:10:16', 0),
(508, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-23 21:22:07', 0),
(509, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Hola :D ]', NULL, '2012-07-23 21:22:57', 0),
(510, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Hola :D', NULL, '2012-07-23 21:22:57', 0),
(511, 'Itachi', '', 'Alert', 'Room alert with message [puto]', NULL, '2012-07-23 21:23:08', 0),
(512, 'Itachi', '', 'Chat command', 'Issued chat command :Roomalert puto', NULL, '2012-07-23 21:23:08', 0),
(513, 'Fakundo', '', 'Alert', 'Room alert with message [hola]', NULL, '2012-07-23 21:23:21', 0),
(514, 'Fakundo', '', 'Chat command', 'Issued chat command :roomalert hola', NULL, '2012-07-23 21:23:21', 0),
(515, 'Itachi', 'Fakundo', 'Alert', 'Alerted user with message [lala]', NULL, '2012-07-23 21:24:49', 0),
(516, 'Itachi', '', 'Chat command', 'Issued chat command :alert Fakundo lala', NULL, '2012-07-23 21:24:49', 0),
(517, 'Itachi', 'Itachi', 'Alert', 'Alerted user with message [lalala]', NULL, '2012-07-23 21:24:52', 0),
(518, 'Itachi', '', 'Chat command', 'Issued chat command :Alert Itachi lalala', NULL, '2012-07-23 21:24:52', 0),
(519, 'Fakundo', 'Itachi', 'Alert', 'Alerted user with message [lala]', NULL, '2012-07-23 21:25:07', 0),
(520, 'Fakundo', '', 'Chat command', 'Issued chat command :alert Itachi lala', NULL, '2012-07-23 21:25:07', 0),
(521, 'Itachi', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-23 23:59:30', 0),
(522, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Test CryptoGlobal xD ]', NULL, '2012-07-26 01:07:52', 0),
(523, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Test CryptoGlobal xD', NULL, '2012-07-26 01:07:52', 0),
(524, 'Fakundo', '', 'HotelAlert', 'Hotel alert [lol ]', NULL, '2012-07-26 01:08:21', 0),
(525, 'Fakundo', '', 'Chat command', 'Issued chat command :ha lol', NULL, '2012-07-26 01:08:21', 0),
(526, 'Fakundo', '', 'HotelAlert', 'Hotel alert [Prueba RC4 ]', NULL, '2012-07-26 21:48:20', 0),
(527, 'Fakundo', '', 'Chat command', 'Issued chat command :ha Prueba RC4', NULL, '2012-07-26 21:48:20', 0),
(528, 'Itachi', '', 'Chat command', 'Issued chat command :copy Fakundo', NULL, '2012-07-29 04:29:18', 0),
(529, 'Itachi', '', 'Chat command', 'Issued chat command :setmax 2', NULL, '2012-07-29 04:30:04', 0),
(530, 'Fakundo', '', 'Staff Message', 'Sent staff message:', NULL, '2012-07-30 03:49:07', 0),
(531, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage', NULL, '2012-07-30 03:49:07', 0),
(532, 'Fakundo', '', 'Staff Message', 'Sent staff message: hola :D', NULL, '2012-07-30 03:49:17', 0),
(533, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage  hola :D', NULL, '2012-07-30 03:49:17', 0),
(534, 'Fakundo', '', 'Staff Message', 'Sent staff message:HOLA', NULL, '2012-07-30 03:49:58', 0),
(535, 'Fakundo', '', 'Chat command', 'Issued chat command :STAFFMESSAGE HOLA', NULL, '2012-07-30 03:49:58', 0),
(536, 'Fakundo', '', 'Chat command', 'Issued chat command :ban fw', NULL, '2012-07-30 04:00:22', 0),
(537, 'Fakundo', '', 'Chat command', 'Issued chat command :ban Andredu', NULL, '2012-07-30 04:00:32', 0),
(538, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-30 04:04:09', 0),
(539, 'Fakundo', '', 'Chat command', 'Issued chat command :invisible', NULL, '2012-07-30 04:05:21', 0),
(540, 'Fakundo', '', 'Chat command', 'Issued chat command :invisible', NULL, '2012-07-30 04:05:27', 0),
(541, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-30 04:06:25', 0),
(542, 'Fakundo', '', 'Chat command', 'Issued chat command :pickall', NULL, '2012-07-30 04:11:19', 0),
(543, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-30 04:12:03', 0),
(544, 'Fakundo', '', 'Alert', 'Room alert with message [hola]', NULL, '2012-07-30 04:12:25', 0),
(545, 'Fakundo', '', 'Chat command', 'Issued chat command :roomalert hola', NULL, '2012-07-30 04:12:25', 0),
(546, 'Fakundo', '', 'Chat command', 'Issued chat command :commands', NULL, '2012-07-30 04:14:07', 0),
(547, 'Fakundo', '', 'Staff Message', 'Sent staff message:hola', NULL, '2012-07-30 04:14:40', 0),
(548, 'Fakundo', '', 'Chat command', 'Issued chat command :staffmessage hola', NULL, '2012-07-30 04:14:40', 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `tele_links`
--

CREATE TABLE IF NOT EXISTS `tele_links` (
  `tele_one_id` int(10) unsigned NOT NULL,
  `tele_two_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`tele_one_id`,`tele_two_id`),
  UNIQUE KEY `tele_one_id` (`tele_one_id`) USING BTREE,
  UNIQUE KEY `tele_two_id` (`tele_two_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `trigger_in_place`
--

CREATE TABLE IF NOT EXISTS `trigger_in_place` (
  `original_trigger` int(11) NOT NULL,
  `triggers_item` int(11) NOT NULL,
  PRIMARY KEY (`original_trigger`,`triggers_item`),
  KEY `triggers_item` (`triggers_item`) USING HASH
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `trigger_in_place`
--

INSERT INTO `trigger_in_place` (`original_trigger`, `triggers_item`) VALUES
(0, 7),
(75, 7),
(0, 12),
(11, 12),
(10, 13),
(6574, 4457),
(7382, 4457),
(7762, 7557),
(7762, 7561);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `trigger_item`
--

CREATE TABLE IF NOT EXISTS `trigger_item` (
  `trigger_id` int(11) NOT NULL,
  `trigger_input` enum('integer','multi_furniture','static_trigger','string') NOT NULL,
  `trigger_data_2` varchar(10) DEFAULT NULL,
  `trigger_data` varchar(100) DEFAULT NULL,
  `all_user_triggerable` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`trigger_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `trigger_item`
--

INSERT INTO `trigger_item` (`trigger_id`, `trigger_input`, `trigger_data_2`, `trigger_data`, `all_user_triggerable`) VALUES
(0, 'integer', '', '0', 0),
(10, 'integer', '', '0', 0),
(11, 'integer', '', '0', 0),
(63, 'integer', '', '', 0),
(64, 'integer', '', 'hola perra', 0),
(65, 'integer', '', 'like a pro *yao', 0),
(66, 'integer', '', 'lol', 0),
(74, 'integer', '', '31', 0),
(75, 'integer', '', '0', 0),
(84, 'string', '', 'puto', 0),
(85, 'integer', '', 'hola', 0),
(6574, 'integer', '', '2', 0),
(7382, 'integer', '', '0', 0),
(7761, 'string', '', 'hola', 0),
(7762, 'integer', '', '2', 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `trigger_rotation`
--

CREATE TABLE IF NOT EXISTS `trigger_rotation` (
  `item_id` int(11) NOT NULL,
  `rotation_status` tinyint(4) NOT NULL,
  `movement_status` tinyint(4) NOT NULL,
  PRIMARY KEY (`item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `uberdown`
--

CREATE TABLE IF NOT EXISTS `uberdown` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `username` char(50) NOT NULL,
  `shit` char(255) NOT NULL,
  PRIMARY KEY (`id`,`username`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=11 ;

--
-- Volcado de datos para la tabla `uberdown`
--

INSERT INTO `uberdown` (`id`, `username`, `shit`) VALUES
(1, 'Various', 'COCKS AND VAGINAS LOL?'),
(2, 'Various', 'test'),
(3, 'Laurent', 'Laurent: I am trying several times to enter the hotel, but i get redirected to the disconnect page. The hotel is online.'),
(4, 'Dash', 'The Server is Down'),
(5, 'Dash', 'Alert from habbo staff client have had some problems'),
(6, 'Laurent', 'Random Shutdown'),
(7, 'Jinx', 'Hotel is down.. ;'),
(8, 'zGrav', 'Server is down >_>'),
(9, 'Laurent', 'Server went down without reason. No idea how it went.'),
(10, 'Stian', 'PROBLEMS UMAD?');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `username` char(50) NOT NULL,
  `real_name` char(100) NOT NULL DEFAULT '',
  `password` char(42) NOT NULL,
  `mail` varchar(50) NOT NULL DEFAULT 'defaultuser@meth0d.org',
  `auth_ticket` varchar(60) NOT NULL,
  `rank` int(1) unsigned NOT NULL DEFAULT '1',
  `credits` int(11) NOT NULL DEFAULT '0',
  `vip_points` int(11) NOT NULL DEFAULT '0',
  `activity_points` int(11) NOT NULL DEFAULT '0',
  `activity_points_lastupdate` double(5,0) NOT NULL DEFAULT '0',
  `look` char(100) NOT NULL DEFAULT 'hr-115-42.hd-190-1.ch-215-62.lg-285-91.sh-290-62',
  `gender` enum('M','F') NOT NULL DEFAULT 'M',
  `motto` char(50) NOT NULL,
  `account_created` char(12) NOT NULL,
  `last_online` varchar(20) NOT NULL,
  `online` enum('0','1') NOT NULL DEFAULT '0',
  `ip_last` char(20) NOT NULL,
  `ip_reg` char(20) NOT NULL,
  `home_room` int(10) unsigned NOT NULL DEFAULT '0',
  `respect` int(11) NOT NULL DEFAULT '0',
  `daily_respect_points` int(1) NOT NULL DEFAULT '3',
  `daily_pet_respect_points` int(1) NOT NULL DEFAULT '3',
  `newbie_status` int(1) NOT NULL DEFAULT '3',
  `is_muted` enum('0','1') NOT NULL DEFAULT '0',
  `mutant_penalty` enum('0','1','2') NOT NULL DEFAULT '0',
  `mutant_penalty_expire` int(11) NOT NULL DEFAULT '0',
  `block_newfriends` enum('0','1') NOT NULL DEFAULT '0',
  `lastdailycredits` char(18) NOT NULL DEFAULT '',
  `points` int(11) NOT NULL DEFAULT '0',
  `block_trade` enum('1','0') NOT NULL DEFAULT '0',
  `crystals` int(11) NOT NULL DEFAULT '0',
  `currentquestid` int(11) unsigned NOT NULL,
  `currentquestprogress` int(11) NOT NULL,
  `achievement_points` int(11) NOT NULL,
  PRIMARY KEY (`username`),
  UNIQUE KEY `id` (`id`) USING HASH,
  UNIQUE KEY `username` (`username`) USING BTREE,
  KEY `ip_last` (`ip_last`) USING BTREE
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=73 ;

--
-- Volcado de datos para la tabla `users`
--

INSERT INTO `users` (`id`, `username`, `real_name`, `password`, `mail`, `auth_ticket`, `rank`, `credits`, `vip_points`, `activity_points`, `activity_points_lastupdate`, `look`, `gender`, `motto`, `account_created`, `last_online`, `online`, `ip_last`, `ip_reg`, `home_room`, `respect`, `daily_respect_points`, `daily_pet_respect_points`, `newbie_status`, `is_muted`, `mutant_penalty`, `mutant_penalty_expire`, `block_newfriends`, `lastdailycredits`, `points`, `block_trade`, `crystals`, `currentquestid`, `currentquestprogress`, `achievement_points`) VALUES
(71, 'Fakundo', 'Mariano', '', 'defaultuser@meth0d.org', 'BetaFakundo', 9, 339854, 0, 32730, 99999, 'sh-907-96.hd-3096-3.he-3082-91.lg-3018-81.ch-660-95.hr-9534-34', 'F', 'jkjkk', '', '7/29/2012 9:17:09 PM', '0', '91.121.241.155', '', 0, 12, 3, 3, 3, '0', '0', 0, '0', '07/30', 0, '0', 0, 0, 0, 40),
(72, 'HabboLatino', '', '', 'defaultuser@meth0d.org', '', 1, 29100, 0, 100, 99999, 'hr-115-42.hd-190-1.ch-215-62.lg-285-91.sh-290-62', 'M', '', '', '7/22/2012 2:17:12 PM', '0', '186.58.7.220', '', 0, 0, 3, 3, 3, '0', '0', 0, '0', '07/22', 0, '0', 0, 0, 0, 0),
(70, 'Itachi', 'Julian', '', 'defaultuser@meth0d.org', 'BetaItachi', 1, 57773819, 0, 49338830, 99999, 'sh-907-96.hd-3096-3.he-3082-91.lg-3018-81.ch-660-95.hr-9534-34', 'F', ':O', '', '7/30/2012 10:10:18 P', '0', '91.121.241.155', '', 0, 8, 3, 0, 3, '0', '0', 0, '0', '07/30', 0, '0', 0, 0, 0, 40);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_achievement`
--

CREATE TABLE IF NOT EXISTS `user_achievement` (
  `userid` int(11) unsigned NOT NULL,
  `group` varchar(255) NOT NULL,
  `level` int(11) NOT NULL,
  `progress` int(11) NOT NULL,
  PRIMARY KEY (`userid`,`group`),
  KEY `id` (`userid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `user_achievement`
--

INSERT INTO `user_achievement` (`userid`, `group`, `level`, `progress`) VALUES
(70, 'ACH_AvatarLooks', 1, 0),
(70, 'ACH_BasicClub', 1, 0),
(70, 'ACH_Motto', 1, 0),
(70, 'ACH_RespectEarned', 2, 1),
(70, 'ACH_RespectGiven', 0, 8),
(71, 'ACH_AvatarLooks', 1, 0),
(71, 'ACH_BasicClub', 1, 1),
(71, 'ACH_Motto', 1, 0),
(71, 'ACH_RespectEarned', 1, 7),
(71, 'ACH_RespectGiven', 0, 12);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_achievements`
--

CREATE TABLE IF NOT EXISTS `user_achievements` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `achievement_id` int(2) unsigned NOT NULL,
  `achievement_level` int(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_badges`
--

CREATE TABLE IF NOT EXISTS `user_badges` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `badge_id` varchar(20) NOT NULL,
  `badge_slot` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE,
  KEY `badge` (`badge_id`) USING BTREE,
  KEY `slot` (`badge_slot`) USING BTREE
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14 ;

--
-- Volcado de datos para la tabla `user_badges`
--

INSERT INTO `user_badges` (`id`, `user_id`, `badge_id`, `badge_slot`) VALUES
(1, 70, 'ACH_Motto1', 0),
(2, 70, 'ACH_AvatarLooks1', 0),
(3, 71, 'ACH_AvatarLooks1', 1),
(4, 70, 'ADM', 1),
(5, 71, 'ACH_Motto1', 0),
(6, 71, 'HC1', 0),
(7, 71, 'ACH_BasicClub1', 0),
(8, 70, 'HC1', 0),
(9, 70, 'ACH_BasicClub1', 0),
(10, 71, 'ADM', 2),
(11, 71, 'ACH_RespectEarned1', 0),
(12, 70, 'ACH_RespectEarned1', 0),
(13, 70, 'ACH_RespectEarned2', 0);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_effects`
--

CREATE TABLE IF NOT EXISTS `user_effects` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `effect_id` int(11) NOT NULL DEFAULT '1',
  `total_duration` int(11) NOT NULL DEFAULT '3600',
  `is_activated` enum('0','1') NOT NULL DEFAULT '0',
  `activated_stamp` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;

--
-- Volcado de datos para la tabla `user_effects`
--

INSERT INTO `user_effects` (`id`, `user_id`, `effect_id`, `total_duration`, `is_activated`, `activated_stamp`) VALUES
(1, 71, 15, 3600, '', 0),
(2, 71, 21, 3600, '', 0),
(3, 70, 18, 3600, '0', 1342929902);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_favorites`
--

CREATE TABLE IF NOT EXISTS `user_favorites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `room_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=7 ;

--
-- Volcado de datos para la tabla `user_favorites`
--

INSERT INTO `user_favorites` (`id`, `user_id`, `room_id`) VALUES
(5, 70, 86),
(6, 70, 78);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_homes`
--

CREATE TABLE IF NOT EXISTS `user_homes` (
  `username` varchar(255) NOT NULL,
  `content` text NOT NULL,
  PRIMARY KEY (`username`),
  UNIQUE KEY `username` (`username`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_ignores`
--

CREATE TABLE IF NOT EXISTS `user_ignores` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `ignore_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_info`
--

CREATE TABLE IF NOT EXISTS `user_info` (
  `user_id` int(11) NOT NULL,
  `bans` int(11) NOT NULL DEFAULT '0',
  `cautions` int(11) NOT NULL DEFAULT '0',
  `reg_timestamp` double NOT NULL DEFAULT '0',
  `login_timestamp` double NOT NULL DEFAULT '0',
  `cfhs` int(11) NOT NULL DEFAULT '0',
  `cfhs_abusive` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `userid` (`user_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_items`
--

CREATE TABLE IF NOT EXISTS `user_items` (
  `id` int(9) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(9) unsigned NOT NULL,
  `base_item` int(5) unsigned NOT NULL,
  `extra_data` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING HASH
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Volcado de datos para la tabla `user_items`
--

INSERT INTO `user_items` (`id`, `user_id`, `base_item`, `extra_data`) VALUES
(1, 1, 1478, 'Saturday, June 30, 2012');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_items_songs`
--

CREATE TABLE IF NOT EXISTS `user_items_songs` (
  `item_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `song_id` int(11) NOT NULL,
  PRIMARY KEY (`item_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_online`
--

CREATE TABLE IF NOT EXISTS `user_online` (
  `userid` int(10) unsigned NOT NULL,
  PRIMARY KEY (`userid`),
  UNIQUE KEY `userid` (`userid`) USING HASH
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `user_online`
--

INSERT INTO `user_online` (`userid`) VALUES
(70);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_pets`
--

CREATE TABLE IF NOT EXISTS `user_pets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `room_id` int(10) unsigned NOT NULL,
  `name` varchar(32) NOT NULL DEFAULT 'Unnamed',
  `race` varchar(3) NOT NULL DEFAULT '000',
  `color` varchar(6) NOT NULL DEFAULT 'FFFFFF',
  `type` int(10) unsigned NOT NULL,
  `expirience` int(11) NOT NULL,
  `energy` int(11) NOT NULL,
  `nutrition` int(11) NOT NULL DEFAULT '100',
  `respect` int(11) NOT NULL DEFAULT '0',
  `createstamp` double NOT NULL DEFAULT '0',
  `x` int(11) NOT NULL DEFAULT '0',
  `y` int(11) NOT NULL DEFAULT '0',
  `z` double NOT NULL DEFAULT '0',
  `have_saddle` int(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE,
  KEY `room_id` (`room_id`) USING BTREE
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 ROW_FORMAT=FIXED AUTO_INCREMENT=13 ;

--
-- Volcado de datos para la tabla `user_pets`
--

INSERT INTO `user_pets` (`id`, `user_id`, `room_id`, `name`, `race`, `color`, `type`, `expirience`, `energy`, `nutrition`, `respect`, `createstamp`, `x`, `y`, `z`, `have_saddle`) VALUES
(1, 70, 0, 'Perra', '0', 'FFFFFF', 6, 0, 100, 100, 0, 1343064409, 0, 0, 0, 0),
(2, 70, 0, 'BABE', '6', 'FFFFFF', 15, 0, 100, 100, 0, 1343066186, 0, 0, 0, 1),
(3, 70, 0, 'Totuguita', '0', 'FFFFFF', 9, 0, 100, 100, 0, 1343077518, 0, 0, 0, 0),
(4, 70, 64, 'Caballito', '2', 'FFFFFF', 15, 50, 100, 100, 0, 1343077541, 0, 0, 0, 1),
(5, 70, 64, 'Pepe', '0', '9ADCFF', 7, 0, 100, 100, 0, 1343080462, 0, 0, 0, 0),
(6, 70, 0, 'SoyRanita', '0', 'FFFFFF', 8, 0, 100, 100, 0, 1343080577, 0, 0, 0, 0),
(7, 70, 0, 'fadsfasdf', '0', 'FF7B3A', 0, 0, 100, 100, 0, 1343080629, 0, 0, 0, 0),
(8, 70, 0, 'fsdafas', '0', 'FFFFFF', 6, 0, 100, 100, 0, 1343089828, 0, 0, 0, 0),
(9, 70, 0, 'fsdafsdf', '0', 'CCCCCC', 7, 0, 100, 100, 0, 1343089836, 0, 0, 0, 0),
(10, 71, 0, 'Caballo', '2', 'FFFFFF', 15, 10, 100, 100, 0, 1343090007, 0, 0, 0, 1),
(11, 70, 0, 'tORTUGUITA', '0', 'FFFFFF', 9, 0, 100, 100, 0, 1343092821, 0, 0, 0, 0),
(12, 71, 73, 'Comerlaaaaaaaaaa', '2', 'FFFFFF', 15, 10, 100, 100, 0, 1343109224, 0, 0, 0, 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_presents`
--

CREATE TABLE IF NOT EXISTS `user_presents` (
  `item_id` int(10) unsigned NOT NULL,
  `base_id` int(10) unsigned NOT NULL,
  `amount` int(11) NOT NULL,
  `extra_data` text NOT NULL,
  PRIMARY KEY (`item_id`),
  KEY `item_id` (`item_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_quests`
--

CREATE TABLE IF NOT EXISTS `user_quests` (
  `user_id` int(10) unsigned NOT NULL,
  `quest_id` int(10) unsigned NOT NULL,
  `progress` int(10) NOT NULL,
  PRIMARY KEY (`user_id`,`quest_id`),
  KEY `userid` (`user_id`) USING HASH,
  KEY `questid` (`quest_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_rankings`
--

CREATE TABLE IF NOT EXISTS `user_rankings` (
  `userid` int(10) NOT NULL,
  `type` varchar(1000) NOT NULL DEFAULT 'competitions',
  `information` varchar(1000) unsigned NOT NULL
  `achievement_id` int(2) unsigned NOT NULL,
  `roomid` int(255) NOT NULL DEFAULT 0,
  `score` int(255) NOT NULL DEFAULT 0
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_roomvisits`
--

CREATE TABLE IF NOT EXISTS `user_roomvisits` (
  `user_id` int(10) unsigned NOT NULL,
  `room_id` int(10) unsigned NOT NULL,
  `entry_timestamp` double NOT NULL,
  `exit_timestamp` double NOT NULL,
  `hour` int(11) NOT NULL,
  `minute` int(11) NOT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE,
  KEY `room_id` (`room_id`) USING BTREE,
  KEY `entry_timestamp` (`entry_timestamp`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_subscriptions`
--

CREATE TABLE IF NOT EXISTS `user_subscriptions` (
  `user_id` int(1) unsigned NOT NULL,
  `subscription_id` char(20) NOT NULL,
  `timestamp_activated` int(1) NOT NULL,
  `timestamp_expire` int(1) NOT NULL,
  PRIMARY KEY (`user_id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `user_subscriptions`
--

INSERT INTO `user_subscriptions` (`user_id`, `subscription_id`, `timestamp_activated`, `timestamp_expire`) VALUES
(70, 'habbo_vip', 1341979617, 1355717217),
(71, 'habbo_vip', 1342216369, 1369000369);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_tags`
--

CREATE TABLE IF NOT EXISTS `user_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `tag` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=10 ;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_tickets`
--

CREATE TABLE IF NOT EXISTS `user_tickets` (
  `userid` int(10) unsigned NOT NULL,
  `sessionticket` varchar(100) NOT NULL,
  `ipaddress` varchar(20) NOT NULL,
  PRIMARY KEY (`sessionticket`,`ipaddress`),
  UNIQUE KEY `index_id` (`userid`) USING HASH
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `user_tickets`
--

INSERT INTO `user_tickets` (`userid`, `sessionticket`, `ipaddress`) VALUES
(70, 'BetaItachi', '91.121.241.155'),
(71, 'BetaFakundo', '186.58.7.220'),
(72, 'BetaHabboLatino', '*');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `user_wardrobe`
--

CREATE TABLE IF NOT EXISTS `user_wardrobe` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `slot_id` int(10) unsigned NOT NULL,
  `look` varchar(120) NOT NULL,
  `gender` enum('F','M') NOT NULL DEFAULT 'M',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=9 ;

--
-- Volcado de datos para la tabla `user_wardrobe`
--

INSERT INTO `user_wardrobe` (`id`, `user_id`, `slot_id`, `look`, `gender`) VALUES
(5, 70, 1, 'hd-180-2.ch-3208-1341-1332.ca-3225-1341-1322.he-3149-1341.lg-3078-1341.hr-3163-1356', 'M'),
(6, 70, 2, 'sh-3206-62.hd-180-2.ch-3208-1341-1332.ca-3225-1341-1322.he-3149-1341.lg-3078-1341.hr-3163-1356', 'M'),
(7, 71, 2, 'sh-907-96.hd-3096-3.ch-660-95.he-3082-91.lg-3018-81.hr-9534-34', 'F'),
(8, 71, 1, 'sh-305-62.hd-180-7.wa-2007-0.ha-1002-70.lg-270-79.ch-215-66.hr-100-0', 'M');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `vip_items`
--

CREATE TABLE IF NOT EXISTS `vip_items` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(120) NOT NULL,
  `name` text NOT NULL,
  `descr` text NOT NULL,
  `price` int(11) NOT NULL DEFAULT '5',
  `image` varchar(120) NOT NULL DEFAULT '',
  `featured` enum('0','1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Volcado de datos para la tabla `vip_items`
--

INSERT INTO `vip_items` (`id`, `type`, `name`, `descr`, `price`, `image`, `featured`) VALUES
(1, 'cr5000', 'Instant credits update - 5000 credits', 'This will set your credits balance to 5000. This is considered a refill only, meaning your credits balance will *not* go above 5000 by purchasing this product.', 5, '%www%/images/money_stash.png', '1');

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
